/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/arrays","vs/base/common/strings","vs/platform/telemetry/common/telemetry","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/node/state","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/parts/ipc/node/ipc.net","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],te=function(G){for(var e=[],E=0,C=G.length;E<C;E++)e[E]=ee[G[E]];return e};define(ee[133],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=e.$5r=e.$4r=e.$3r=void 0;function E(P,f){const l=Math.pow(10,f);return Math.round(P*l)/l}class C{constructor(f,l,m,d=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=E(Math.max(Math.min(1,d),0),3)}static equals(f,l){return f.r===l.r&&f.g===l.g&&f.b===l.b&&f.a===l.a}}e.$3r=C;class r{constructor(f,l,m,d){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.l=E(Math.max(Math.min(1,m),0),3),this.a=E(Math.max(Math.min(1,d),0),3)}static equals(f,l){return f.h===l.h&&f.s===l.s&&f.l===l.l&&f.a===l.a}static fromRGBA(f){const l=f.r/255,m=f.g/255,d=f.b/255,p=f.a,h=Math.max(l,m,d),y=Math.min(l,m,d);let b=0,o=0;const g=(y+h)/2,a=h-y;if(a>0){switch(o=Math.min(g<=.5?a/(2*g):a/(2-2*g),1),h){case l:b=(m-d)/a+(m<d?6:0);break;case m:b=(d-l)/a+2;break;case d:b=(l-m)/a+4;break}b*=60,b=Math.round(b)}return new r(b,o,g,p)}static i(f,l,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?f+(l-f)*6*m:m<1/2?l:m<2/3?f+(l-f)*(2/3-m)*6:f}static toRGBA(f){const l=f.h/360,{s:m,l:d,a:p}=f;let h,y,b;if(m===0)h=y=b=d;else{const o=d<.5?d*(1+m):d+m-d*m,g=2*d-o;h=r.i(g,o,l+1/3),y=r.i(g,o,l),b=r.i(g,o,l-1/3)}return new C(Math.round(h*255),Math.round(y*255),Math.round(b*255),p)}}e.$4r=r;class O{constructor(f,l,m,d){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.v=E(Math.max(Math.min(1,m),0),3),this.a=E(Math.max(Math.min(1,d),0),3)}static equals(f,l){return f.h===l.h&&f.s===l.s&&f.v===l.v&&f.a===l.a}static fromRGBA(f){const l=f.r/255,m=f.g/255,d=f.b/255,p=Math.max(l,m,d),h=Math.min(l,m,d),y=p-h,b=p===0?0:y/p;let o;return y===0?o=0:p===l?o=((m-d)/y%6+6)%6:p===m?o=(d-l)/y+2:o=(l-m)/y+4,new O(Math.round(o*60),b,p,f.a)}static toRGBA(f){const{h:l,s:m,v:d,a:p}=f,h=d*m,y=h*(1-Math.abs(l/60%2-1)),b=d-h;let[o,g,a]=[0,0,0];return l<60?(o=h,g=y):l<120?(o=y,g=h):l<180?(g=h,a=y):l<240?(g=y,a=h):l<300?(o=y,a=h):l<=360&&(o=h,a=y),o=Math.round((o+b)*255),g=Math.round((g+b)*255),a=Math.round((a+b)*255),new C(o,g,a,p)}}e.$5r=O;class A{static fromHex(f){return A.Format.CSS.parseHex(f)||A.red}static equals(f,l){return!f&&!l?!0:!f||!l?!1:f.equals(l)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof C)this.rgba=f;else if(f instanceof r)this.i=f,this.rgba=r.toRGBA(f);else if(f instanceof O)this.j=f,this.rgba=O.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&C.equals(this.rgba,f.rgba)&&r.equals(this.hsla,f.hsla)&&O.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=A.k(this.rgba.r),l=A.k(this.rgba.g),m=A.k(this.rgba.b),d=.2126*f+.7152*l+.0722*m;return E(d,4)}static k(f){const l=f/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(f){const l=this.getRelativeLuminance(),m=f.getRelativeLuminance();return l>m?(l+.05)/(m+.05):(m+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const l=this.getRelativeLuminance(),m=f.getRelativeLuminance();return l>m}isDarkerThan(f){const l=this.getRelativeLuminance(),m=f.getRelativeLuminance();return l<m}lighten(f){return new A(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new A(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:l,g:m,b:d,a:p}=this.rgba;return new A(new C(l,m,d,p*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const l=f.rgba,m=this.rgba.a,d=l.a,p=m+d*(1-m);if(p<1e-6)return A.transparent;const h=this.rgba.r*m/p+l.r*d*(1-m)/p,y=this.rgba.g*m/p+l.g*d*(1-m)/p,b=this.rgba.b*m/p+l.b*d*(1-m)/p;return new A(new C(h,y,b,p))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:l,g:m,b:d,a:p}=this.rgba;return new A(new C(f.rgba.r-p*(f.rgba.r-l),f.rgba.g-p*(f.rgba.g-m),f.rgba.b-p*(f.rgba.b-d),1))}flatten(...f){const l=f.reduceRight((m,d)=>A.o(d,m));return A.o(this,l)}static o(f,l){const m=1-f.rgba.a;return new A(new C(m*l.rgba.r+f.rgba.a*f.rgba.r,m*l.rgba.g+f.rgba.a*f.rgba.g,m*l.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(f,l,m){if(f.isLighterThan(l))return f;m=m||.5;const d=f.getRelativeLuminance(),p=l.getRelativeLuminance();return m=m*(p-d)/p,f.lighten(m)}static getDarkerColor(f,l,m){if(f.isDarkerThan(l))return f;m=m||.5;const d=f.getRelativeLuminance(),p=l.getRelativeLuminance();return m=m*(d-p)/d,f.darken(m)}}e.$6r=A,A.white=new A(new C(255,255,255,1)),A.black=new A(new C(0,0,0,1)),A.red=new A(new C(255,0,0,1)),A.blue=new A(new C(0,0,255,1)),A.green=new A(new C(0,255,0,1)),A.cyan=new A(new C(0,255,255,1)),A.lightgrey=new A(new C(211,211,211,1)),A.transparent=new A(new C(0,0,0,0)),function(P){let f;(function(l){let m;(function(d){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}d.formatRGB=p;function h(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}d.formatRGBA=h;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}d.formatHSL=y;function b(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}d.formatHSLA=b;function o(t){const u=t.toString(16);return u.length!==2?"0"+u:u}function g(t){return`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}`}d.formatHex=g;function a(t,u=!1){return u&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}${o(Math.round(t.rgba.a*255))}`}d.formatHexA=a;function v(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}d.format=v;function k(t){const u=t.length;if(u===0||t.charCodeAt(0)!==35)return null;if(u===7){const s=16*w(t.charCodeAt(1))+w(t.charCodeAt(2)),i=16*w(t.charCodeAt(3))+w(t.charCodeAt(4)),n=16*w(t.charCodeAt(5))+w(t.charCodeAt(6));return new P(new C(s,i,n,1))}if(u===9){const s=16*w(t.charCodeAt(1))+w(t.charCodeAt(2)),i=16*w(t.charCodeAt(3))+w(t.charCodeAt(4)),n=16*w(t.charCodeAt(5))+w(t.charCodeAt(6)),c=16*w(t.charCodeAt(7))+w(t.charCodeAt(8));return new P(new C(s,i,n,c/255))}if(u===4){const s=w(t.charCodeAt(1)),i=w(t.charCodeAt(2)),n=w(t.charCodeAt(3));return new P(new C(16*s+s,16*i+i,16*n+n))}if(u===5){const s=w(t.charCodeAt(1)),i=w(t.charCodeAt(2)),n=w(t.charCodeAt(3)),c=w(t.charCodeAt(4));return new P(new C(16*s+s,16*i+i,16*n+n,(16*c+c)/255))}return null}d.parseHex=k;function w(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=l.CSS||(l.CSS={}))})(f=P.Format||(P.Format={}))}(A||(e.$6r=A={}))}),define(ee[55],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.$Qg=e.$Pg=void 0;function E(A){return(P,f,l)=>{let m=null,d=null;if(typeof l.value=="function"?(m="value",d=l.value):typeof l.get=="function"&&(m="get",d=l.get),!d)throw new Error("not supported");l[m]=A(d,f)}}function C(A,P,f){let l=null,m=null;if(typeof f.value=="function"?(l="value",m=f.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(l="get",m=f.get),!m)throw new Error("not supported");const d=`$memoize$${P}`;f[l]=function(...p){return this.hasOwnProperty(d)||Object.defineProperty(this,d,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,p)}),this[d]}}e.$Pg=C;function r(A,P,f){return E((l,m)=>{const d=`$debounce$${m}`,p=`$debounce$result$${m}`;return function(...h){this[p]||(this[p]=f?f():void 0),clearTimeout(this[d]),P&&(this[p]=P(this[p],...h),h=[this[p]]),this[d]=setTimeout(()=>{l.apply(this,h),this[p]=f?f():void 0},A)}})}e.$Qg=r;function O(A,P,f){return E((l,m)=>{const d=`$throttle$timer$${m}`,p=`$throttle$result$${m}`,h=`$throttle$lastRun$${m}`,y=`$throttle$pending$${m}`;return function(...b){if(this[p]||(this[p]=f?f():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...b)),this[y])return;const o=this[h]+A;o<=Date.now()?(this[h]=Date.now(),l.apply(this,[this[p]]),this[p]=f?f():void 0):(this[y]=!0,this[d]=setTimeout(()=>{this[y]=!1,this[h]=Date.now(),l.apply(this,[this[p]]),this[p]=f?f():void 0},o-Date.now()))}})}e.$Rg=O}),define(ee[13],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.$W=e.setUnexpectedErrorHandler=e.$U=e.$T=void 0;class E{constructor(){this.b=[],this.a=function(u){setTimeout(()=>{throw u.stack?k.isErrorNoTelemetry(u)?new k(u.message+`

`+u.stack):new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.b.push(u),()=>{this.d(u)}}c(u){this.b.forEach(s=>{s(u)})}d(u){this.b.splice(this.b.indexOf(u),1)}setUnexpectedErrorHandler(u){this.a=u}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(u){this.a(u),this.c(u)}onUnexpectedExternalError(u){this.a(u)}}e.$T=E,e.$U=new E;function C(t){e.$U.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=C;function r(t){if(!t||typeof t!="object")return!1;const u=t;return u.code==="EPIPE"&&u.syscall?.toUpperCase()==="WRITE"}e.$W=r;function O(t){l(t)||e.$U.onUnexpectedError(t)}e.$X=O;function A(t){l(t)||e.$U.onUnexpectedExternalError(t)}e.$Y=A;function P(t){if(t instanceof Error){const{name:u,message:s}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:u,message:s,stack:i,noTelemetry:k.isErrorNoTelemetry(t)}}return t}e.$Z=P;const f="Canceled";function l(t){return t instanceof m?!0:t instanceof Error&&t.name===f&&t.message===f}e.$1=l;class m extends Error{constructor(){super(f),this.name=this.message}}e.$2=m;function d(){const t=new Error(f);return t.name=t.message,t}e.$3=d;function p(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.$4=p;function h(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.$5=h;function y(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.$6=y;function b(t){const u=new Error(`${t} has been disposed`);return u.name="DISPOSED",u}e.$7=b;function o(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.$8=o;class g extends Error{constructor(u){super("NotImplemented"),u&&(this.message=u)}}e.$9=g;class a extends Error{constructor(u){super("NotSupported"),u&&(this.message=u)}}e.$0=a;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=v;class k extends Error{constructor(u){super(u),this.name="CodeExpectedError"}static fromError(u){if(u instanceof k)return u;const s=new k;return s.message=u.message,s.stack=u.stack,s}static isErrorNoTelemetry(u){return u.name==="CodeExpectedError"}}e.$_=k;class w extends Error{constructor(u){super(u||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}e.$ab=w}),define(ee[24],te([0,1,13]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.CompareResult=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.top=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=void 0;function C(z,B=0){return z[z.length-(1+B)]}e.$9e=C;function r(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$0e=r;function O(z,B,X=(se,ce)=>se===ce){if(z===B)return!0;if(!z||!B||z.length!==B.length)return!1;for(let se=0,ce=z.length;se<ce;se++)if(!X(z[se],B[se]))return!1;return!0}e.$$e=O;function A(z,B){const X=z.length-1;B<X&&(z[B]=z[X]),z.pop()}e.$_e=A;function P(z,B,X){return f(z.length,se=>X(z[se],B))}e.$af=P;function f(z,B){let X=0,se=z-1;for(;X<=se;){const ce=(X+se)/2|0,ge=B(ce);if(ge<0)X=ce+1;else if(ge>0)se=ce-1;else return ce}return-(X+1)}e.$bf=f;function l(z,B){let X=0,se=z.length;if(se===0)return 0;for(;X<se;){const ce=Math.floor((X+se)/2);B(z[ce])?se=ce:X=ce+1}return X}e.$cf=l;function m(z,B,X){if(z=z|0,z>=B.length)throw new TypeError("invalid index");const se=B[Math.floor(B.length*Math.random())],ce=[],ge=[],Ie=[];for(const Ae of B){const Ce=X(Ae,se);Ce<0?ce.push(Ae):Ce>0?ge.push(Ae):Ie.push(Ae)}return z<ce.length?m(z,ce,X):z<ce.length+Ie.length?Ie[0]:m(z-(ce.length+Ie.length),ge,X)}e.$df=m;function d(z,B){const X=[];let se;for(const ce of z.slice(0).sort(B))!se||B(se[0],ce)!==0?(se=[ce],X.push(se)):se.push(ce);return X}e.$ef=d;function p(z,B,X){const se=[];function ce(Ae,Ce,Le){if(Ce===0&&Le.length===0)return;const ye=se[se.length-1];ye&&ye.start+ye.deleteCount===Ae?(ye.deleteCount+=Ce,ye.toInsert.push(...Le)):se.push({start:Ae,deleteCount:Ce,toInsert:Le})}let ge=0,Ie=0;for(;;){if(ge===z.length){ce(ge,0,B.slice(Ie));break}if(Ie===B.length){ce(ge,z.length-ge,[]);break}const Ae=z[ge],Ce=B[Ie],Le=X(Ae,Ce);Le===0?(ge+=1,Ie+=1):Le<0?(ce(ge,1,[]),ge+=1):Le>0&&(ce(ge,0,[Ce]),Ie+=1)}return se}e.$ff=p;function h(z,B,X){const se=p(z,B,X),ce=[],ge=[];for(const Ie of se)ce.push(...z.slice(Ie.start,Ie.start+Ie.deleteCount)),ge.push(...Ie.toInsert);return{removed:ce,added:ge}}e.$gf=h;function y(z,B,X){if(X===0)return[];const se=z.slice(0,X).sort(B);return o(z,B,se,X,z.length),se}e.top=y;function b(z,B,X,se,ce){return X===0?Promise.resolve([]):new Promise((ge,Ie)=>{(async()=>{const Ae=z.length,Ce=z.slice(0,X).sort(B);for(let Le=X,ye=Math.min(X+se,Ae);Le<Ae;Le=ye,ye=Math.min(ye+se,Ae)){if(Le>X&&await new Promise(we=>setTimeout(we)),ce&&ce.isCancellationRequested)throw new E.$2;o(z,B,Ce,Le,ye)}return Ce})().then(ge,Ie)})}e.$if=b;function o(z,B,X,se,ce){for(const ge=X.length;se<ce;se++){const Ie=z[se];if(B(Ie,X[ge-1])<0){X.pop();const Ae=l(X,Ce=>B(Ie,Ce)<0);X.splice(Ae,0,Ie)}}}function g(z){return z.filter(B=>!!B)}e.$jf=g;function a(z){let B=0;for(let X=0;X<z.length;X++)z[X]&&(z[B]=z[X],B+=1);z.length=B}e.$kf=a;function v(z,B,X){z.splice(X,0,z.splice(B,1)[0])}e.$lf=v;function k(z){return!Array.isArray(z)||z.length===0}e.$mf=k;function w(z){return Array.isArray(z)&&z.length>0}e.$nf=w;function t(z,B=X=>X){const X=new Set;return z.filter(se=>{const ce=B(se);return X.has(ce)?!1:(X.add(ce),!0)})}e.$of=t;function u(z){const B=new Set;return X=>{const se=z(X);return B.has(se)?!1:(B.add(se),!0)}}e.$pf=u;function s(z,B){const X=i(z,B);if(X!==-1)return z[X]}e.$qf=s;function i(z,B){for(let X=z.length-1;X>=0;X--){const se=z[X];if(B(se))return X}return-1}e.$rf=i;function n(z,B){return z.length>0?z[0]:B}e.$sf=n;function c(z,B){return z.length>0?z[z.length-1]:B}e.$tf=c;function $(z,B,X=(se,ce)=>se===ce){let se=0;for(let ce=0,ge=Math.min(z.length,B.length);ce<ge&&X(z[ce],B[ce]);ce++)se++;return se}e.$uf=$;function R(z){return[].concat(...z)}e.$vf=R;function I(z,B){let X=typeof B=="number"?z:0;typeof B=="number"?X=z:(X=0,B=z);const se=[];if(X<=B)for(let ce=X;ce<B;ce++)se.push(ce);else for(let ce=X;ce>B;ce--)se.push(ce);return se}e.$wf=I;function S(z,B,X){return z.reduce((se,ce)=>(se[B(ce)]=X?X(ce):ce,se),Object.create(null))}e.$xf=S;function M(z,B){return z.push(B),()=>j(z,B)}e.$yf=M;function j(z,B){const X=z.indexOf(B);if(X>-1)return z.splice(X,1),B}e.$zf=j;function F(z,B,X){const se=z.slice(0,B),ce=z.slice(B);return se.concat(X,ce)}e.$Af=F;function q(z,B){let X;if(typeof B=="number"){let se=B;X=()=>{const ce=Math.sin(se++)*179426549;return ce-Math.floor(ce)}}else X=Math.random;for(let se=z.length-1;se>0;se-=1){const ce=Math.floor(X()*(se+1)),ge=z[se];z[se]=z[ce],z[ce]=ge}}e.$Bf=q;function re(z,B){const X=z.indexOf(B);X>-1&&(z.splice(X,1),z.unshift(B))}e.$Cf=re;function ie(z,B){const X=z.indexOf(B);X>-1&&(z.splice(X,1),z.push(B))}e.$Df=ie;function ne(z,B){for(const X of B)z.push(X)}e.$Ef=ne;function ue(z,B){return Array.isArray(z)?z.map(B):B(z)}e.$Ff=ue;function le(z){return Array.isArray(z)?z:[z]}e.$Gf=le;function K(z){return z[Math.floor(Math.random()*z.length)]}e.$Hf=K;function Y(z,B){for(const X of z){const se=B(X);if(se!==void 0)return se}}e.$If=Y;function N(z,B,X){const se=T(z,B),ce=z.length,ge=X.length;z.length=ce+ge;for(let Ie=ce-1;Ie>=se;Ie--)z[Ie+ge]=z[Ie];for(let Ie=0;Ie<ge;Ie++)z[Ie+se]=X[Ie]}e.$Jf=N;function W(z,B,X,se){const ce=T(z,B),ge=z.splice(ce,X);return N(z,ce,se),ge}e.$Kf=W;function T(z,B){return B<0?Math.max(B+z.length,0):Math.min(B,z.length)}var J;(function(z){function B(ce){return ce<0}z.isLessThan=B;function X(ce){return ce>0}z.isGreaterThan=X;function se(ce){return ce===0}z.isNeitherLessOrGreaterThan=se,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(J||(e.CompareResult=J={}));function Q(z,B){return(X,se)=>B(z(X),z(se))}e.$Lf=Q;function ae(...z){return(B,X)=>{for(const se of z){const ce=se(B,X);if(!J.isNeitherLessOrGreaterThan(ce))return ce}return J.neitherLessOrGreaterThan}}e.$Mf=ae;const oe=(z,B)=>z-B;e.$Nf=oe;function L(z,B){if(z.length===0)return;let X=z[0];for(let se=1;se<z.length;se++){const ce=z[se];B(ce,X)>0&&(X=ce)}return X}e.$Of=L;function D(z,B){if(z.length===0)return;let X=z[0];for(let se=1;se<z.length;se++){const ce=z[se];B(ce,X)>=0&&(X=ce)}return X}e.$Pf=D;function U(z,B){return L(z,(X,se)=>-B(X,se))}e.$Qf=U;class H{constructor(B){this.f=B,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(B){let X=this.c;for(;X<this.f.length&&B(this.f[X]);)X++;const se=X===this.c?null:this.f.slice(this.c,X);return this.c=X,se}takeFromEndWhile(B){let X=this.d;for(;X>=0&&B(this.f[X]);)X--;const se=X===this.d?null:this.f.slice(X+1,this.d+1);return this.d=X,se}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const B=this.f[this.c];return this.c++,B}removeLast(){const B=this.f[this.d];return this.d--,B}takeCount(B){const X=this.f.slice(this.c,this.c+B);return this.c+=B,X}}e.$Rf=H;class V{constructor(B){this.iterate=B}forEach(B){this.iterate(X=>(B(X),!0))}toArray(){const B=[];return this.iterate(X=>(B.push(X),!0)),B}filter(B){return new V(X=>this.iterate(se=>B(se)?X(se):!0))}map(B){return new V(X=>this.iterate(se=>X(B(se))))}some(B){let X=!1;return this.iterate(se=>(X=B(se),!X)),X}findFirst(B){let X;return this.iterate(se=>B(se)?(X=se,!1):!0),X}findLast(B){let X;return this.iterate(se=>(B(se)&&(X=se),!0)),X}findLastMaxBy(B){let X,se=!0;return this.iterate(ce=>((se||J.isGreaterThan(B(ce,X)))&&(se=!1,X=ce),!0)),X}}e.$Sf=V,V.empty=new V(z=>{})}),define(ee[134],te([0,1,13]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oc=e.$nc=e.$mc=e.$lc=e.ok=void 0;function C(f,l){if(!f)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=C;function r(f,l="Unreachable"){throw new Error(l)}e.$lc=r;function O(f){if(!f)throw new E.$ab("Assertion Failed")}e.$mc=O;function A(f){if(!f()){debugger;f(),(0,E.$X)(new E.$ab("Assertion Failed"))}}e.$nc=A;function P(f,l){let m=0;for(;m<f.length-1;){const d=f[m],p=f[m+1];if(!l(d,p))return!1;m++}return!0}e.$oc=P}),define(ee[49],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function E(C){const r=this;let O=!1,A;return function(){return O||(O=!0,A=C.apply(r,arguments)),A}}e.$bb=E}),define(ee[68],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(C){function r(k){return k&&typeof k=="object"&&typeof k[Symbol.iterator]=="function"}C.is=r;const O=Object.freeze([]);function A(){return O}C.empty=A;function*P(k){yield k}C.single=P;function f(k){return r(k)?k:P(k)}C.wrap=f;function l(k){return k||O}C.from=l;function m(k){return!k||k[Symbol.iterator]().next().done===!0}C.isEmpty=m;function d(k){return k[Symbol.iterator]().next().value}C.first=d;function p(k,w){for(const t of k)if(w(t))return!0;return!1}C.some=p;function h(k,w){for(const t of k)if(w(t))return t}C.find=h;function*y(k,w){for(const t of k)w(t)&&(yield t)}C.filter=y;function*b(k,w){let t=0;for(const u of k)yield w(u,t++)}C.map=b;function*o(...k){for(const w of k)for(const t of w)yield t}C.concat=o;function g(k,w,t){let u=t;for(const s of k)u=w(u,s);return u}C.reduce=g;function*a(k,w,t=k.length){for(w<0&&(w+=k.length),t<0?t+=k.length:t>k.length&&(t=k.length);w<t;w++)yield k[w]}C.slice=a;function v(k,w=Number.POSITIVE_INFINITY){const t=[];if(w===0)return[t,k];const u=k[Symbol.iterator]();for(let s=0;s<w;s++){const i=u.next();if(i.done)return[t,C.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return u}}]}C.consume=v})(E||(e.Iterable=E={}))}),define(ee[45],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(t,u=!1){let s=0;const i=t.length;let n="",c=0,$=16,R=0;function I(ie){let ne=0,ue=0;for(;ne<ie;){const le=t.charCodeAt(s);if(le>=48&&le<=57)ue=ue*16+le-48;else if(le>=65&&le<=70)ue=ue*16+le-65+10;else if(le>=97&&le<=102)ue=ue*16+le-97+10;else break;s++,ne++}return ne<ie&&(ue=-1),ue}function S(ie){s=ie,n="",c=0,$=16,R=0}function M(){const ie=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&l(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&l(t.charCodeAt(s)))for(s++;s<t.length&&l(t.charCodeAt(s));)s++;else return R=3,t.substring(ie,s);let ne=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&l(t.charCodeAt(s))){for(s++;s<t.length&&l(t.charCodeAt(s));)s++;ne=s}else R=3;return t.substring(ie,ne)}function j(){let ie="",ne=s;for(;;){if(s>=i){ie+=t.substring(ne,s),R=2;break}const ue=t.charCodeAt(s);if(ue===34){ie+=t.substring(ne,s),s++;break}if(ue===92){if(ie+=t.substring(ne,s),s++,s>=i){R=2;break}switch(t.charCodeAt(s++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const K=I(4);K>=0?ie+=String.fromCharCode(K):R=4;break}default:R=5}ne=s;continue}if(ue>=0&&ue<=31)if(f(ue)){ie+=t.substring(ne,s),R=2;break}else R=6;s++}return ie}function F(){if(n="",R=0,c=s,s>=i)return c=i,$=17;let ie=t.charCodeAt(s);if(P(ie)){do s++,n+=String.fromCharCode(ie),ie=t.charCodeAt(s);while(P(ie));return $=15}if(f(ie))return s++,n+=String.fromCharCode(ie),ie===13&&t.charCodeAt(s)===10&&(s++,n+=`
`),$=14;switch(ie){case 123:return s++,$=1;case 125:return s++,$=2;case 91:return s++,$=3;case 93:return s++,$=4;case 58:return s++,$=6;case 44:return s++,$=5;case 34:return s++,n=j(),$=10;case 47:{const ne=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!f(t.charCodeAt(s));)s++;return n=t.substring(ne,s),$=12}if(t.charCodeAt(s+1)===42){s+=2;const ue=i-1;let le=!1;for(;s<ue;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,le=!0;break}s++}return le||(s++,R=1),n=t.substring(ne,s),$=13}return n+=String.fromCharCode(ie),s++,$=16}case 45:if(n+=String.fromCharCode(ie),s++,s===i||!l(t.charCodeAt(s)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=M(),$=11;default:for(;s<i&&q(ie);)s++,ie=t.charCodeAt(s);if(c!==s){switch(n=t.substring(c,s),n){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return n+=String.fromCharCode(ie),s++,$=16}}function q(ie){if(P(ie)||f(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ie;do ie=F();while(ie>=12&&ie<=15);return ie}return{setPosition:S,getPosition:()=>s,scan:u?re:F,getToken:()=>$,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>s-c,getTokenError:()=>R}}e.$rm=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var m;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(m||(m={}));function d(t,u){const s=[],i=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function R(I,S,M,j){c.value=I,c.offset=S,c.length=M,c.type=j,c.colonOffset=void 0,n=c}try{v(t,{onObjectBegin:(I,S)=>{if(u<=I)throw i;n=void 0,$=u>I,s.push("")},onObjectProperty:(I,S,M)=>{if(u<S||(R(I,S,M,"property"),s[s.length-1]=I,u<=S+M))throw i},onObjectEnd:(I,S)=>{if(u<=I)throw i;n=void 0,s.pop()},onArrayBegin:(I,S)=>{if(u<=I)throw i;n=void 0,s.push(0)},onArrayEnd:(I,S)=>{if(u<=I)throw i;n=void 0,s.pop()},onLiteralValue:(I,S,M)=>{if(u<S||(R(I,S,M,w(I)),u<=S+M))throw i},onSeparator:(I,S,M)=>{if(u<=S)throw i;if(I===":"&&n&&n.type==="property")n.colonOffset=S,$=!1,n=void 0;else if(I===","){const j=s[s.length-1];typeof j=="number"?s[s.length-1]=j+1:($=!0,s[s.length-1]=""),n=void 0}}})}catch(I){if(I!==i)throw I}return{path:s,previousNode:n,isAtPropertyKey:$,matches:I=>{let S=0;for(let M=0;S<I.length&&M<s.length;M++)if(I[S]===s[M]||I[S]==="*")S++;else if(I[S]!=="**")return!1;return S===I.length}}}e.$sm=d;function p(t,u=[],s=O.DEFAULT){let i=null,n=[];const c=[];function $(I){Array.isArray(n)?n.push(I):i!==null&&(n[i]=I)}return v(t,{onObjectBegin:()=>{const I={};$(I),c.push(n),n=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const I=[];$(I),c.push(n),n=I,i=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:$,onError:(I,S,M)=>{u.push({error:I,offset:S,length:M})}},s),n[0]}e.$tm=p;function h(t,u=[],s=O.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function c(I){return i.children.push(I),I}v(t,{onObjectBegin:I=>{i=c({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,S,M)=>{i=c({type:"property",offset:S,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:S,length:M,parent:i})},onObjectEnd:(I,S)=>{i.length=I+S-i.offset,i=i.parent,n(I+S)},onArrayBegin:(I,S)=>{i=c({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,S)=>{i.length=I+S-i.offset,i=i.parent,n(I+S)},onLiteralValue:(I,S,M)=>{c({type:w(I),offset:S,length:M,parent:i,value:I}),n(S+M)},onSeparator:(I,S,M)=>{i.type==="property"&&(I===":"?i.colonOffset=S:I===","&&n(S))},onError:(I,S,M)=>{u.push({error:I,offset:S,length:M})}},s);const R=i.children[0];return R&&delete R.parent,R}e.$um=h;function y(t,u){if(!t)return;let s=t;for(const i of u)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const c of s.children)if(Array.isArray(c.children)&&c.children[0].value===i){s=c.children[1],n=!0;break}if(!n)return}else{const n=i;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}e.$vm=y;function b(t){if(!t.parent||!t.parent.children)return[];const u=b(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;u.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&u.push(s)}return u}e.$wm=b;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const u=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(u[s.children[0].value]=o(i))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$xm=o;function g(t,u,s=!1){return u>=t.offset&&u<t.offset+t.length||s&&u===t.offset+t.length}e.$ym=g;function a(t,u,s=!1){if(g(t,u,s)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=u;n++){const c=a(i[n],u,s);if(c)return c}return t}}e.$zm=a;function v(t,u,s=O.DEFAULT){const i=A(t,!1);function n(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(Q){return Q?ae=>Q(ae,i.getTokenOffset(),i.getTokenLength()):()=>!0}const $=n(u.onObjectBegin),R=c(u.onObjectProperty),I=n(u.onObjectEnd),S=n(u.onArrayBegin),M=n(u.onArrayEnd),j=c(u.onLiteralValue),F=c(u.onSeparator),q=n(u.onComment),re=c(u.onError),ie=s&&s.disallowComments,ne=s&&s.allowTrailingComma;function ue(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:ie||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(Q){case 12:case 13:ie?le(10):q();break;case 16:le(1);break;case 15:case 14:break;default:return Q}}}function le(Q,ae=[],oe=[]){if(re(Q),ae.length+oe.length>0){let L=i.getToken();for(;L!==17;){if(ae.indexOf(L)!==-1){ue();break}else if(oe.indexOf(L)!==-1)break;L=ue()}}}function K(Q){const ae=i.getTokenValue();return Q?j(ae):R(ae),ue(),!0}function Y(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(le(2),Q=0)}catch{le(2)}j(Q);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return ue(),!0}function N(){return i.getToken()!==10?(le(3,[],[2,5]),!1):(K(!1),i.getToken()===6?(F(":"),ue(),J()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function W(){$(),ue();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||le(4,[],[]),F(","),ue(),i.getToken()===2&&ne)break}else Q&&le(6,[],[]);N()||le(4,[],[2,5]),Q=!0}return I(),i.getToken()!==2?le(7,[2],[]):ue(),!0}function T(){S(),ue();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||le(4,[],[]),F(","),ue(),i.getToken()===4&&ne)break}else Q&&le(6,[],[]);J()||le(4,[],[4,5]),Q=!0}return M(),i.getToken()!==4?le(8,[4],[]):ue(),!0}function J(){switch(i.getToken()){case 3:return T();case 1:return W();case 10:return K(!0);default:return Y()}}return ue(),i.getToken()===17?s.allowEmptyContent?!0:(le(4,[],[]),!1):J()?(i.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}e.$Am=v;function k(t,u){const s=A(t),i=[];let n,c=0,$;do switch($=s.getPosition(),n=s.scan(),n){case 12:case 13:case 17:c!==$&&i.push(t.substring(c,$)),u!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,u)),c=s.getPosition();break}while(n!==17);return i.join("")}e.$Bm=k;function w(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Cm=w}),define(ee[135],te([0,1,45]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=e.$BR=e.$AR=e.$zR=void 0;function C(l,m,d){let p,h,y,b,o;if(m){for(b=m.offset,o=b+m.length,y=b;y>0&&!f(l,y-1);)y--;let $=o;for(;$<l.length&&!f(l,$);)$++;h=l.substring(y,$),p=A(h,d)}else h=l,p=0,y=0,b=0,o=l.length;const g=P(d,l);let a=!1,v=0,k;d.insertSpaces?k=O(" ",d.tabSize||4):k="	";const w=(0,E.$rm)(h,!1);let t=!1;function u(){return g+O(k,p+v)}function s(){let $=w.scan();for(a=!1;$===15||$===14;)a=a||$===14,$=w.scan();return t=$===16||w.getTokenError()!==0,$}const i=[];function n($,R,I){!t&&R<o&&I>b&&l.substring(R,I)!==$&&i.push({offset:R,length:I-R,content:$})}let c=s();if(c!==17){const $=w.getTokenOffset()+y,R=O(k,p);n(R,y,$)}for(;c!==17;){let $=w.getTokenOffset()+w.getTokenLength()+y,R=s(),I="";for(;!a&&(R===12||R===13);){const M=w.getTokenOffset()+y;n(" ",$,M),$=w.getTokenOffset()+w.getTokenLength()+y,I=R===12?u():"",R=s()}if(R===2)c!==1&&(v--,I=u());else if(R===4)c!==3&&(v--,I=u());else{switch(c){case 3:case 1:v++,I=u();break;case 5:case 12:I=u();break;case 13:a?I=u():I=" ";break;case 6:I=" ";break;case 10:if(R===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:R===12||R===13?I=" ":R!==5&&R!==17&&(t=!0);break;case 16:t=!0;break}a&&(R===12||R===13)&&(I=u())}const S=w.getTokenOffset()+y;n(I,$,S),c=R}return i}e.$zR=C;function r(l,m){const d=JSON.stringify(l,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?d.replace(/\r\n|\r|\n/g,m.eol):d}e.$AR=r;function O(l,m){let d="";for(let p=0;p<m;p++)d+=l;return d}function A(l,m){let d=0,p=0;const h=m.tabSize||4;for(;d<l.length;){const y=l.charAt(d);if(y===" ")p++;else if(y==="	")p+=h;else break;d++}return Math.floor(p/h)}function P(l,m){for(let d=0;d<m.length;d++){const p=m.charAt(d);if(p==="\r")return d+1<m.length&&m.charAt(d+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return l&&l.eol||`
`}e.$BR=P;function f(l,m){return`\r
`.indexOf(l.charAt(m))!==-1}e.$CR=f}),define(ee[136],te([0,1,45,135]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HR=e.$GR=e.$FR=e.$ER=e.$DR=void 0;function r(l,m,d){return O(l,m,void 0,d)}e.$DR=r;function O(l,m,d,p,h){const y=m.slice(),b=[],o=(0,E.$um)(l,b);let g,a;for(;y.length>0&&(a=y.pop(),g=(0,E.$vm)(o,y),g===void 0&&d!==void 0);)typeof a=="string"?d={[a]:d}:d=[d];if(g)if(g.type==="object"&&typeof a=="string"&&Array.isArray(g.children)){const v=(0,E.$vm)(g,[a]);if(v!==void 0)if(d===void 0){if(!v.parent)throw new Error("Malformed AST");const k=g.children.indexOf(v.parent);let w,t=v.parent.offset+v.parent.length;if(k>0){const u=g.children[k-1];w=u.offset+u.length}else w=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return A(l,{offset:w,length:t-w,content:""},p)}else return A(l,{offset:v.offset,length:v.length,content:JSON.stringify(d)},p);else{if(d===void 0)return[];const k=`${JSON.stringify(a)}: ${JSON.stringify(d)}`,w=h?h(g.children.map(u=>u.children[0].value)):g.children.length;let t;if(w>0){const u=g.children[w-1];t={offset:u.offset+u.length,length:0,content:","+k}}else g.children.length===0?t={offset:g.offset+1,length:0,content:k}:t={offset:g.offset+1,length:0,content:k+","};return A(l,t,p)}}else if(g.type==="array"&&typeof a=="number"&&Array.isArray(g.children))if(d!==void 0){const v=`${JSON.stringify(d)}`;let k;if(g.children.length===0||a===0)k={offset:g.offset+1,length:0,content:g.children.length===0?v:v+","};else{const w=a===-1||a>g.children.length?g.children.length:a,t=g.children[w-1];k={offset:t.offset+t.length,length:0,content:","+v}}return A(l,k,p)}else{const v=a,k=g.children[v];let w;if(g.children.length===1)w={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===v){const t=g.children[v-1],u=t.offset+t.length,s=g.offset+g.length;w={offset:u,length:s-2-u,content:""}}else w={offset:k.offset,length:g.children[v+1].offset-k.offset,content:""};return A(l,w,p)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${g.type}`);else{if(d===void 0)throw new Error("Can not delete in empty document");return A(l,{offset:o?o.offset:0,length:o?o.length:0,content:JSON.stringify(d)},p)}}e.$ER=O;function A(l,m,d){let p=P(l,m),h=m.offset,y=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;h>0&&!(0,C.$CR)(p,h-1);)h--;for(;y<p.length&&!(0,C.$CR)(p,y);)y++}const b=(0,C.$zR)(p,{offset:h,length:y-h},d);for(let g=b.length-1;g>=0;g--){const a=b[g];p=P(p,a),h=Math.min(h,a.offset),y=Math.max(y,a.offset+a.length),y+=a.content.length-a.length}const o=l.length-(p.length-y)-h;return[{offset:h,length:o,content:p.substring(h,y)}]}e.$FR=A;function P(l,m){return l.substring(0,m.offset)+m.content+l.substring(m.offset+m.length)}e.$GR=P;function f(l,m){const d=m.slice(0).sort((h,y)=>{const b=h.offset-y.offset;return b===0?h.length-y.length:b});let p=l.length;for(let h=d.length-1;h>=0;h--){const y=d[h];if(y.offset+y.length<=p)l=P(l,y);else throw new Error("Overlapping edit");p=y.offset}return l}e.$HR=f}),define(ee[83],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=void 0;class E{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$S=E}),define(ee[2],te([0,1,49,68]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=e.$cb=void 0;const r=!1;let O=null;function A(c){O=c}if(e.$cb=A,r){const c="__is_disposable_tracked__";A(new class{trackDisposable($){const R=new Error("Potentially leaked disposable").stack;setTimeout(()=>{$[c]||console.log(R)},3e3)}setParent($,R){if($&&$!==a.None)try{$[c]=!0}catch{}}markAsDisposed($){if($&&$!==a.None)try{$[c]=!0}catch{}}markAsSingleton($){}})}function P(c){return O?.trackDisposable(c),c}function f(c){O?.markAsDisposed(c)}function l(c,$){O?.setParent(c,$)}function m(c,$){if(O)for(const R of c)O.setParent(R,$)}function d(c){return O?.markAsSingleton(c),c}e.$db=d;function p(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.$eb=p;function h(c){if(C.Iterable.is(c)){const $=[];for(const R of c)if(R)try{R.dispose()}catch(I){$.push(I)}if($.length===1)throw $[0];if($.length>1)throw new AggregateError($,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.$fb=h;function y(c){for(const $ of c)p($)&&$.dispose();return[]}e.$gb=y;function b(...c){const $=o(()=>h(c));return m(c,$),$}e.$hb=b;function o(c){const $=P({dispose:(0,E.$bb)(()=>{f($),c()})});return $}e.$ib=o;class g{constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add($){if(!$)return $;if($===this)throw new Error("Cannot register a disposable on itself!");return l($,this),this.g?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add($),$}}e.$jb=g,g.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this.q=new g,P(this),l(this.q,this)}dispose(){f(this),this.q.dispose()}B($){if($===this)throw new Error("Cannot register a disposable on itself!");return this.q.add($)}}e.$kb=a,a.None=Object.freeze({dispose(){}});class v{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value($){this.b||$===this.a||(this.a?.dispose(),$&&l($,this),this.a=$)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const $=this.a;return this.a=void 0,$&&l($,null),$}}e.$lb=v;class k{constructor($){this.b=$,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$mb=k;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set($){let R=$;return this.unset=()=>R=void 0,this.isset=()=>R!==void 0,this.dispose=()=>{R&&(R(),R=void 0,f(this))},this}}e.$nb=w;class t{constructor(){this.a=new Map}acquire($,...R){let I=this.a.get($);I||(I={counter:0,object:this.b($,...R)},this.a.set($,I));const{object:S}=I,M=(0,E.$bb)(()=>{--I.counter===0&&(this.c($,I.object),this.a.delete($))});return I.counter++,{object:S,dispose:M}}}e.$ob=t;class u{constructor($){this.a=$}async acquire($,...R){const I=this.a.acquire($,...R);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(S){throw I.dispose(),S}}}e.$pb=u;class s{constructor($){this.object=$}dispose(){}}e.$qb=s;function i(c){const $=new g;try{c($)}finally{$.dispose()}}e.$rb=i;class n{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has($){return this.a.has($)}get($){return this.a.get($)}set($,R,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get($)?.dispose(),this.a.set($,R)}deleteAndDispose($){this.a.get($)?.dispose(),this.a.delete($)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$sb=n}),define(ee[101],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jc=void 0;class E{constructor(O){this.element=O,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class C{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let O=this.a;for(;O!==E.Undefined;){const A=O.next;O.prev=E.Undefined,O.next=E.Undefined,O=A}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,A){const P=new E(O);if(this.a===E.Undefined)this.a=P,this.b=P;else if(A){const l=this.b;this.b=P,P.prev=l,l.next=P}else{const l=this.a;this.a=P,P.next=l,l.prev=P}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(P))}}shift(){if(this.a!==E.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==E.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==E.Undefined&&O.next!==E.Undefined){const A=O.prev;A.next=O.next,O.next.prev=A}else O.prev===E.Undefined&&O.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):O.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):O.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==E.Undefined;)yield O.element,O=O.next}}e.$jc=C}),define(ee[35],te([0,1]),function(G,e){"use strict";var E,C,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.Touch=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;function O(b,o,g){let a=b.get(o);return a===void 0&&(a=g,b.set(o,a)),a}e.$gi=O;function A(b){const o=[];return b.forEach((g,a)=>{o.push(`${a} => ${g}`)}),`Map(${b.size}) {${o.join(", ")}}`}e.$hi=A;function P(b){const o=[];return b.forEach(g=>{o.push(g)}),`Set(${b.size}) {${o.join(", ")}}`}e.$ii=P;class f{constructor(o,g){this.uri=o,this.value=g}}class l{constructor(o,g){this[E]="ResourceMap",o instanceof l?(this.b=new Map(o.b),this.c=g??l.a):(this.b=new Map,this.c=o??l.a)}set(o,g){return this.b.set(this.c(o),new f(o,g)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,g){typeof g<"u"&&(o=o.bind(g));for(const[a,v]of this.b)o(v.value,v.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$ji=l,l.a=b=>b.toString();class m{constructor(o,g){this[C]="ResourceSet",!o||typeof o=="function"?this.a=new l(o):(this.a=new l(g),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,g){this.a.forEach((a,v)=>o.call(g,v,v,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$ki=m;var d;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class p{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,g=0){const a=this.a.get(o);if(a)return g!==0&&this.j(a,g),a.value}set(o,g,a=0){let v=this.a.get(o);if(v)v.value=g,a!==0&&this.j(v,a);else{switch(v={key:o,value:g,next:void 0,previous:void 0},a){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(o,v),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const g=this.a.get(o);if(g)return this.a.delete(o),this.i(g),this.d--,g.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,g){const a=this.e;let v=this.b;for(;v;){if(g?o.bind(g)(v.value,v.key,this):o(v.value,v.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const o=this,g=this.e;let a=this.b;const v={[Symbol.iterator](){return v},next(){if(o.e!==g)throw new Error("LinkedMap got modified during iteration.");if(a){const k={value:a.key,done:!1};return a=a.next,k}else return{value:void 0,done:!0}}};return v}values(){const o=this,g=this.e;let a=this.b;const v={[Symbol.iterator](){return v},next(){if(o.e!==g)throw new Error("LinkedMap got modified during iteration.");if(a){const k={value:a.value,done:!1};return a=a.next,k}else return{value:void 0,done:!0}}};return v}entries(){const o=this,g=this.e;let a=this.b;const v={[Symbol.iterator](){return v},next(){if(o.e!==g)throw new Error("LinkedMap got modified during iteration.");if(a){const k={value:[a.key,a.value],done:!1};return a=a.next,k}else return{value:void 0,done:!0}}};return v}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let g=this.b,a=this.size;for(;g&&a>o;)this.a.delete(g.key),g=g.next,a--;this.b=g,this.d=a,g&&(g.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const g=o.next,a=o.previous;if(!g||!a)throw new Error("Invalid list");g.previous=a,a.next=g}o.next=void 0,o.previous=void 0,this.e++}j(o,g){if(!this.b||!this.c)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(o===this.b)return;const a=o.next,v=o.previous;o===this.c?(v.next=void 0,this.c=v):(a.previous=v,v.next=a),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(g===2){if(o===this.c)return;const a=o.next,v=o.previous;o===this.b?(a.previous=void 0,this.b=a):(a.previous=v,v.next=a),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((g,a)=>{o.push([a,g])}),o}fromJSON(o){this.clear();for(const[g,a]of o)this.set(g,a)}}e.$li=p;class h extends p{constructor(o,g=1){super(),this.k=o,this.l=Math.min(Math.max(0,g),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,g=2){return super.get(o,g)}peek(o){return super.get(o,0)}set(o,g){return super.set(o,g,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$mi=h;class y{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let g=this.a.get(o)||0;return g===0?!1:(g--,g===0?this.a.delete(o):this.a.set(o,g),!0)}has(o){return this.a.has(o)}}e.$ni=y}),define(ee[84],te([0,1,35]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=void 0;const C=new E.$mi(1e4);function r(l){return f(l,"NFC",C)}e.$3k=r;const O=new E.$mi(1e4);function A(l){return f(l,"NFD",O)}e.$4k=A;const P=/[^\u0000-\u0080]/;function f(l,m,d){if(!l)return l;const p=d.get(l);if(p)return p;let h;return P.test(l)?h=l.normalize(m):h=l,d.set(l,h),h}e.$5k=function(){const l=/[\u0300-\u036f]/g;return function(m){return A(m).replace(l,"")}}()}),define(ee[137],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.$rl=e.rot=e.$pl=void 0;function E(P,f,l){return Math.min(Math.max(P,f),l)}e.$pl=E;function C(P,f){return(f+P%f)%f}e.rot=C;class r{constructor(){this.a=0}getNext(){return this.a++}}e.$rl=r;class O{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$sl=O;class A{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const l=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$tl=A}),function(){function G(r){const O=[];typeof r=="number"&&O.push("code/timeOrigin",r);function A(f){O.push(f,Date.now())}function P(){const f=[];for(let l=0;l<O.length;l+=2)f.push({name:O[l],startTime:O[l+1]});return f}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(r+A.startTime)});return O}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function E(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=E(C))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var C in E)(typeof exports=="object"?exports:G)[C]=E[C]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function E(C){if(e[C])return e[C].exports;var r=e[C]={i:C,l:!1,exports:{}};return G[C].call(r.exports,r,r.exports,E),r.l=!0,r.exports}return E.m=G,E.c=e,E.d=function(C,r,O){E.o(C,r)||Object.defineProperty(C,r,{enumerable:!0,get:O})},E.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},E.t=function(C,r){if(1&r&&(C=E(C)),8&r||4&r&&typeof C=="object"&&C&&C.__esModule)return C;var O=Object.create(null);if(E.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:C}),2&r&&typeof C!="string")for(var A in C)E.d(O,A,function(P){return C[P]}.bind(null,A));return O},E.n=function(C){var r=C&&C.__esModule?function(){return C.default}:function(){return C};return E.d(r,"a",r),r},E.o=function(C,r){return Object.prototype.hasOwnProperty.call(C,r)},E.p="",E(E.s=0)}([function(G,e,E){(function(C){var r;e=G.exports=oe,r=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],f=e.src=[],l=0,m=l++;f[m]="0|[1-9]\\d*";var d=l++;f[d]="[0-9]+";var p=l++;f[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=l++;f[h]="("+f[m]+")\\.("+f[m]+")\\.("+f[m]+")";var y=l++;f[y]="("+f[d]+")\\.("+f[d]+")\\.("+f[d]+")";var b=l++;f[b]="(?:"+f[m]+"|"+f[p]+")";var o=l++;f[o]="(?:"+f[d]+"|"+f[p]+")";var g=l++;f[g]="(?:-("+f[b]+"(?:\\."+f[b]+")*))";var a=l++;f[a]="(?:-?("+f[o]+"(?:\\."+f[o]+")*))";var v=l++;f[v]="[0-9A-Za-z-]+";var k=l++;f[k]="(?:\\+("+f[v]+"(?:\\."+f[v]+")*))";var w=l++,t="v?"+f[h]+f[g]+"?"+f[k]+"?";f[w]="^"+t+"$";var u="[v=\\s]*"+f[y]+f[a]+"?"+f[k]+"?",s=l++;f[s]="^"+u+"$";var i=l++;f[i]="((?:<|>)?=?)";var n=l++;f[n]=f[d]+"|x|X|\\*";var c=l++;f[c]=f[m]+"|x|X|\\*";var $=l++;f[$]="[v=\\s]*("+f[c]+")(?:\\.("+f[c]+")(?:\\.("+f[c]+")(?:"+f[g]+")?"+f[k]+"?)?)?";var R=l++;f[R]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[a]+")?"+f[k]+"?)?)?";var I=l++;f[I]="^"+f[i]+"\\s*"+f[$]+"$";var S=l++;f[S]="^"+f[i]+"\\s*"+f[R]+"$";var M=l++;f[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=l++;f[j]="(?:~>?)";var F=l++;f[F]="(\\s*)"+f[j]+"\\s+",P[F]=new RegExp(f[F],"g");var q=l++;f[q]="^"+f[j]+f[$]+"$";var re=l++;f[re]="^"+f[j]+f[R]+"$";var ie=l++;f[ie]="(?:\\^)";var ne=l++;f[ne]="(\\s*)"+f[ie]+"\\s+",P[ne]=new RegExp(f[ne],"g");var ue=l++;f[ue]="^"+f[ie]+f[$]+"$";var le=l++;f[le]="^"+f[ie]+f[R]+"$";var K=l++;f[K]="^"+f[i]+"\\s*("+u+")$|^$";var Y=l++;f[Y]="^"+f[i]+"\\s*("+t+")$|^$";var N=l++;f[N]="(\\s*)"+f[i]+"\\s*("+u+"|"+f[$]+")",P[N]=new RegExp(f[N],"g");var W=l++;f[W]="^\\s*("+f[$]+")\\s+-\\s+("+f[$]+")\\s*$";var T=l++;f[T]="^\\s*("+f[R]+")\\s+-\\s+("+f[R]+")\\s*$";var J=l++;f[J]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)r(Q,f[Q]),P[Q]||(P[Q]=new RegExp(f[Q]));function ae(_,he){if(_ instanceof oe)return _;if(typeof _!="string"||_.length>O||!(he?P[s]:P[w]).test(_))return null;try{return new oe(_,he)}catch{return null}}function oe(_,he){if(_ instanceof oe){if(_.loose===he)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof oe))return new oe(_,he);r("SemVer",_,he),this.loose=he;var de=_.trim().match(he?P[s]:P[w]);if(!de)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Re=+Se;if(Re>=0&&Re<A)return Re}return Se}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=ae,e.valid=function(_,he){var de=ae(_,he);return de?de.version:null},e.clean=function(_,he){var de=ae(_.trim().replace(/^[=v]+/,""),he);return de?de.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(_){return r("SemVer.compare",this.version,this.loose,_),_ instanceof oe||(_=new oe(_,this.loose)),this.compareMain(_)||this.comparePre(_)},oe.prototype.compareMain=function(_){return _ instanceof oe||(_=new oe(_,this.loose)),D(this.major,_.major)||D(this.minor,_.minor)||D(this.patch,_.patch)},oe.prototype.comparePre=function(_){if(_ instanceof oe||(_=new oe(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var he=0;do{var de=this.prerelease[he],Se=_.prerelease[he];if(r("prerelease compare",he,de,Se),de===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(de===void 0)return-1;if(de!==Se)return D(de,Se)}while(++he)},oe.prototype.inc=function(_,he){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,he,de,Se){typeof de=="string"&&(Se=de,de=void 0);try{return new oe(_,de).inc(he,Se).version}catch{return null}},e.diff=function(_,he){if(z(_,he))return null;var de=ae(_),Se=ae(he);if(de.prerelease.length||Se.prerelease.length){for(var Re in de)if((Re==="major"||Re==="minor"||Re==="patch")&&de[Re]!==Se[Re])return"pre"+Re;return"prerelease"}for(var Re in de)if((Re==="major"||Re==="minor"||Re==="patch")&&de[Re]!==Se[Re])return Re},e.compareIdentifiers=D;var L=/^[0-9]+$/;function D(_,he){var de=L.test(_),Se=L.test(he);return de&&Se&&(_=+_,he=+he),de&&!Se?-1:Se&&!de?1:_<he?-1:_>he?1:0}function U(_,he,de){return new oe(_,de).compare(new oe(he,de))}function H(_,he,de){return U(_,he,de)>0}function V(_,he,de){return U(_,he,de)<0}function z(_,he,de){return U(_,he,de)===0}function B(_,he,de){return U(_,he,de)!==0}function X(_,he,de){return U(_,he,de)>=0}function se(_,he,de){return U(_,he,de)<=0}function ce(_,he,de,Se){var Re;switch(he){case"===":typeof _=="object"&&(_=_.version),typeof de=="object"&&(de=de.version),Re=_===de;break;case"!==":typeof _=="object"&&(_=_.version),typeof de=="object"&&(de=de.version),Re=_!==de;break;case"":case"=":case"==":Re=z(_,de,Se);break;case"!=":Re=B(_,de,Se);break;case">":Re=H(_,de,Se);break;case">=":Re=X(_,de,Se);break;case"<":Re=V(_,de,Se);break;case"<=":Re=se(_,de,Se);break;default:throw new TypeError("Invalid operator: "+he)}return Re}function ge(_,he){if(_ instanceof ge){if(_.loose===he)return _;_=_.value}if(!(this instanceof ge))return new ge(_,he);r("comparator",_,he),this.loose=he,this.parse(_),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(_,he){return D(he,_)},e.major=function(_,he){return new oe(_,he).major},e.minor=function(_,he){return new oe(_,he).minor},e.patch=function(_,he){return new oe(_,he).patch},e.compare=U,e.compareLoose=function(_,he){return U(_,he,!0)},e.rcompare=function(_,he,de){return U(he,_,de)},e.sort=function(_,he){return _.sort(function(de,Se){return e.compare(de,Se,he)})},e.rsort=function(_,he){return _.sort(function(de,Se){return e.rcompare(de,Se,he)})},e.gt=H,e.lt=V,e.eq=z,e.neq=B,e.gte=X,e.lte=se,e.cmp=ce,e.Comparator=ge;var Ie={};function Ae(_,he){if(_ instanceof Ae)return _.loose===he?_:new Ae(_.raw,he);if(_ instanceof ge)return new Ae(_.value,he);if(!(this instanceof Ae))return new Ae(_,he);if(this.loose=he,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Ce(_){return!_||_.toLowerCase()==="x"||_==="*"}function Le(_,he,de,Se,Re,je,Ue,He,Be,ze,qe,Te,Z){return((he=Ce(de)?"":Ce(Se)?">="+de+".0.0":Ce(Re)?">="+de+"."+Se+".0":">="+he)+" "+(He=Ce(Be)?"":Ce(ze)?"<"+(+Be+1)+".0.0":Ce(qe)?"<"+Be+"."+(+ze+1)+".0":Te?"<="+Be+"."+ze+"."+qe+"-"+Te:"<="+He)).trim()}function ye(_,he){for(var de=0;de<_.length;de++)if(!_[de].test(he))return!1;if(he.prerelease.length){for(de=0;de<_.length;de++)if(r(_[de].semver),_[de].semver!==Ie&&_[de].semver.prerelease.length>0){var Se=_[de].semver;if(Se.major===he.major&&Se.minor===he.minor&&Se.patch===he.patch)return!0}return!1}return!0}function we(_,he,de){try{he=new Ae(he,de)}catch{return!1}return he.test(_)}function ke(_,he,de,Se){var Re,je,Ue,He,Be;switch(_=new oe(_,Se),he=new Ae(he,Se),de){case">":Re=H,je=se,Ue=V,He=">",Be=">=";break;case"<":Re=V,je=X,Ue=H,He="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(_,he,Se))return!1;for(var ze=0;ze<he.set.length;++ze){var qe=he.set[ze],Te=null,Z=null;if(qe.forEach(function(fe){fe.semver===Ie&&(fe=new ge(">=0.0.0")),Te=Te||fe,Z=Z||fe,Re(fe.semver,Te.semver,Se)?Te=fe:Ue(fe.semver,Z.semver,Se)&&(Z=fe)}),Te.operator===He||Te.operator===Be||(!Z.operator||Z.operator===He)&&je(_,Z.semver)||Z.operator===Be&&Ue(_,Z.semver))return!1}return!0}ge.prototype.parse=function(_){var he=this.loose?P[K]:P[Y],de=_.match(he);if(!de)throw new TypeError("Invalid comparator: "+_);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new oe(de[2],this.loose):this.semver=Ie},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(_){return r("Comparator.test",_,this.loose),this.semver===Ie||(typeof _=="string"&&(_=new oe(_,this.loose)),ce(_,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(_,he){if(!(_ instanceof ge))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Ae(_.value,he),we(this.value,de,he);if(_.operator==="")return de=new Ae(this.value,he),we(_.semver,de,he);var Se=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),je=this.semver.version===_.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),He=ce(this.semver,"<",_.semver,he)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),Be=ce(this.semver,">",_.semver,he)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return Se||Re||je&&Ue||He||Be},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(_){var he=this.loose;_=_.trim(),r("range",_,he);var de=he?P[T]:P[W];_=_.replace(de,Le),r("hyphen replace",_),_=_.replace(P[N],"$1$2$3"),r("comparator trim",_,P[N]),_=(_=(_=_.replace(P[F],"$1~")).replace(P[ne],"$1^")).split(/\s+/).join(" ");var Se=he?P[K]:P[Y],Re=_.split(" ").map(function(je){return function(Ue,He){return r("comp",Ue),Ue=function(Be,ze){return Be.trim().split(/\s+/).map(function(qe){return function(Te,Z){r("caret",Te,Z);var fe=Z?P[le]:P[ue];return Te.replace(fe,function($e,me,ve,Oe,Fe){var Ke;return r("caret",Te,$e,me,ve,Oe,Fe),Ce(me)?Ke="":Ce(ve)?Ke=">="+me+".0.0 <"+(+me+1)+".0.0":Ce(Oe)?Ke=me==="0"?">="+me+"."+ve+".0 <"+me+"."+(+ve+1)+".0":">="+me+"."+ve+".0 <"+(+me+1)+".0.0":Fe?(r("replaceCaret pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),Ke=me==="0"?ve==="0"?">="+me+"."+ve+"."+Oe+Fe+" <"+me+"."+ve+"."+(+Oe+1):">="+me+"."+ve+"."+Oe+Fe+" <"+me+"."+(+ve+1)+".0":">="+me+"."+ve+"."+Oe+Fe+" <"+(+me+1)+".0.0"):(r("no pr"),Ke=me==="0"?ve==="0"?">="+me+"."+ve+"."+Oe+" <"+me+"."+ve+"."+(+Oe+1):">="+me+"."+ve+"."+Oe+" <"+me+"."+(+ve+1)+".0":">="+me+"."+ve+"."+Oe+" <"+(+me+1)+".0.0"),r("caret return",Ke),Ke})}(qe,ze)}).join(" ")}(Ue,He),r("caret",Ue),Ue=function(Be,ze){return Be.trim().split(/\s+/).map(function(qe){return function(Te,Z){var fe=Z?P[re]:P[q];return Te.replace(fe,function($e,me,ve,Oe,Fe){var Ke;return r("tilde",Te,$e,me,ve,Oe,Fe),Ce(me)?Ke="":Ce(ve)?Ke=">="+me+".0.0 <"+(+me+1)+".0.0":Ce(Oe)?Ke=">="+me+"."+ve+".0 <"+me+"."+(+ve+1)+".0":Fe?(r("replaceTilde pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),Ke=">="+me+"."+ve+"."+Oe+Fe+" <"+me+"."+(+ve+1)+".0"):Ke=">="+me+"."+ve+"."+Oe+" <"+me+"."+(+ve+1)+".0",r("tilde return",Ke),Ke})}(qe,ze)}).join(" ")}(Ue,He),r("tildes",Ue),Ue=function(Be,ze){return r("replaceXRanges",Be,ze),Be.split(/\s+/).map(function(qe){return function(Te,Z){Te=Te.trim();var fe=Z?P[S]:P[I];return Te.replace(fe,function($e,me,ve,Oe,Fe,Ke){r("xRange",Te,$e,me,ve,Oe,Fe,Ke);var xe=Ce(ve),Je=xe||Ce(Oe),Qe=Je||Ce(Fe);return me==="="&&Qe&&(me=""),xe?$e=me===">"||me==="<"?"<0.0.0":"*":me&&Qe?(Je&&(Oe=0),Qe&&(Fe=0),me===">"?(me=">=",Je?(ve=+ve+1,Oe=0,Fe=0):Qe&&(Oe=+Oe+1,Fe=0)):me==="<="&&(me="<",Je?ve=+ve+1:Oe=+Oe+1),$e=me+ve+"."+Oe+"."+Fe):Je?$e=">="+ve+".0.0 <"+(+ve+1)+".0.0":Qe&&($e=">="+ve+"."+Oe+".0 <"+ve+"."+(+Oe+1)+".0"),r("xRange return",$e),$e})}(qe,ze)}).join(" ")}(Ue,He),r("xrange",Ue),Ue=function(Be,ze){return r("replaceStars",Be,ze),Be.trim().replace(P[J],"")}(Ue,He),r("stars",Ue),Ue}(je,he)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(je){return!!je.match(Se)})),Re=Re.map(function(je){return new ge(je,he)})},Ae.prototype.intersects=function(_,he){if(!(_ instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Se){return _.set.some(function(Re){return Re.every(function(je){return Se.intersects(je,he)})})})})},e.toComparators=function(_,he){return new Ae(_,he).set.map(function(de){return de.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new oe(_,this.loose));for(var he=0;he<this.set.length;he++)if(ye(this.set[he],_))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(_,he,de){var Se=null,Re=null;try{var je=new Ae(he,de)}catch{return null}return _.forEach(function(Ue){je.test(Ue)&&(Se&&Re.compare(Ue)!==-1||(Re=new oe(Se=Ue,de)))}),Se},e.minSatisfying=function(_,he,de){var Se=null,Re=null;try{var je=new Ae(he,de)}catch{return null}return _.forEach(function(Ue){je.test(Ue)&&(Se&&Re.compare(Ue)!==1||(Re=new oe(Se=Ue,de)))}),Se},e.validRange=function(_,he){try{return new Ae(_,he).range||"*"}catch{return null}},e.ltr=function(_,he,de){return ke(_,he,"<",de)},e.gtr=function(_,he,de){return ke(_,he,">",de)},e.outside=ke,e.prerelease=function(_,he){var de=ae(_,he);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(_,he,de){return _=new Ae(_,de),he=new Ae(he,de),_.intersects(he)},e.coerce=function(_){if(_ instanceof oe)return _;if(typeof _!="string")return null;var he=_.match(P[M]);return he==null?null:ae((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,E(1))},function(G,e){var E,C,r=G.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(o){if(E===setTimeout)return setTimeout(o,0);if((E===O||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:O}catch{E=O}try{C=typeof clearTimeout=="function"?clearTimeout:A}catch{C=A}})();var f,l=[],m=!1,d=-1;function p(){m&&f&&(m=!1,f.length?l=f.concat(l):d=-1,l.length&&h())}function h(){if(!m){var o=P(p);m=!0;for(var g=l.length;g;){for(f=l,l=[];++d<g;)f&&f[d].run();d=-1,g=l.length}f=null,m=!1,function(a){if(C===clearTimeout)return clearTimeout(a);if((C===A||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(a);try{C(a)}catch{try{return C.call(null,a)}catch{return C.call(this,a)}}}(o)}}function y(o,g){this.fun=o,this.array=g}function b(){}r.nextTick=function(o){var g=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)g[a-1]=arguments[a];l.push(new y(o,g)),l.length!==1||m||P(h)},y.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=b,r.addListener=b,r.once=b,r.off=b,r.removeListener=b,r.removeAllListeners=b,r.emit=b,r.prependListener=b,r.prependOnceListener=b,r.listeners=function(o){return[]},r.binding=function(o){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(o){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(ee[138],te([0,1]),function(G,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class C{constructor(P,f,l){this.level=P,this.key=f,this.value=l,this.forward=[]}}const r=void 0;class O{constructor(P,f=2**16){this.comparator=P,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new C(this.c,r,r)}get size(){return this.f}clear(){this.e=new C(this.c,r,r)}has(P){return!!O.g(this,P,this.comparator)}get(P){return O.g(this,P,this.comparator)?.value}set(P,f){return O.h(this,P,f,this.comparator)&&(this.f+=1),this}delete(P){const f=O.k(this,P,this.comparator);return f&&(this.f-=1),f}forEach(P,f){let l=this.e.forward[0];for(;l;)P.call(f,l.value,l.key,this),l=l.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",f=this.e.forward[0];for(;f;)P+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return P}static g(P,f,l){let m=P.e;for(let d=P.d-1;d>=0;d--)for(;m.forward[d]&&l(m.forward[d].key,f)<0;)m=m.forward[d];if(m=m.forward[0],m&&l(m.key,f)===0)return m}static h(P,f,l,m){const d=[];let p=P.e;for(let h=P.d-1;h>=0;h--){for(;p.forward[h]&&m(p.forward[h].key,f)<0;)p=p.forward[h];d[h]=p}if(p=p.forward[0],p&&m(p.key,f)===0)return p.value=l,!1;{const h=O.j(P);if(h>P.d){for(let y=P.d;y<h;y++)d[y]=P.e;P.d=h}p=new C(h,f,l);for(let y=0;y<h;y++)p.forward[y]=d[y].forward[y],d[y].forward[y]=p;return!0}}static j(P,f=.5){let l=1;for(;Math.random()<f&&l<P.c;)l+=1;return l}static k(P,f,l){const m=[];let d=P.e;for(let p=P.d-1;p>=0;p--){for(;d.forward[p]&&l(d.forward[p].key,f)<0;)d=d.forward[p];m[p]=d}if(d=d.forward[0],!d||l(d.key,f)!==0)return!1;for(let p=0;p<P.d&&m[p].forward[p]===d;p++)m[p].forward[p]=d.forward[p];for(;P.d>0&&P.e.forward[P.d-1]===r;)P.d-=1;return!0}}e.$0q=O}),define(ee[85],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(O){return new C(O)}constructor(O){this.c=E&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$1c=C}),define(ee[4],te([0,1,13,49,2,101,85]),function(G,e,E,C,r,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.Event=void 0;const P=!1,f=!1;var l;(function(R){R.None=()=>r.$kb.None;function I(z){if(f){const{onDidAddListener:B}=z,X=y.create();let se=0;z.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),X.print()),B?.()}}}function S(z,B){return le(z,()=>{},0,void 0,!0,void 0,B)}R.defer=S;function M(z){return(B,X=null,se)=>{let ce=!1,ge;return ge=z(Ie=>{if(!ce)return ge?ge.dispose():ce=!0,B.call(X,Ie)},null,se),ce&&ge.dispose(),ge}}R.once=M;function j(z,B,X){return ue((se,ce=null,ge)=>z(Ie=>se.call(ce,B(Ie)),null,ge),X)}R.map=j;function F(z,B,X){return ue((se,ce=null,ge)=>z(Ie=>{B(Ie),se.call(ce,Ie)},null,ge),X)}R.forEach=F;function q(z,B,X){return ue((se,ce=null,ge)=>z(Ie=>B(Ie)&&se.call(ce,Ie),null,ge),X)}R.filter=q;function re(z){return z}R.signal=re;function ie(...z){return(B,X=null,se)=>(0,r.$hb)(...z.map(ce=>ce(ge=>B.call(X,ge),null,se)))}R.any=ie;function ne(z,B,X,se){let ce=X;return j(z,ge=>(ce=B(ce,ge),ce),se)}R.reduce=ne;function ue(z,B){let X;const se={onWillAddFirstListener(){X=z(ce.fire,ce)},onDidRemoveLastListener(){X?.dispose()}};B||I(se);const ce=new v(se);return B?.add(ce),ce.event}function le(z,B,X=100,se=!1,ce=!1,ge,Ie){let Ae,Ce,Le,ye=0,we;const ke={leakWarningThreshold:ge,onWillAddFirstListener(){Ae=z(he=>{ye++,Ce=B(Ce,he),se&&!Le&&(_.fire(Ce),Ce=void 0),we=()=>{const de=Ce;Ce=void 0,Le=void 0,(!se||ye>1)&&_.fire(de),ye=0},typeof X=="number"?(clearTimeout(Le),Le=setTimeout(we,X)):Le===void 0&&(Le=0,queueMicrotask(we))})},onWillRemoveListener(){ce&&ye>0&&we?.()},onDidRemoveLastListener(){we=void 0,Ae.dispose()}};Ie||I(ke);const _=new v(ke);return Ie?.add(_),_.event}R.debounce=le;function K(z,B=0,X){return R.debounce(z,(se,ce)=>se?(se.push(ce),se):[ce],B,void 0,!0,void 0,X)}R.accumulate=K;function Y(z,B=(se,ce)=>se===ce,X){let se=!0,ce;return q(z,ge=>{const Ie=se||!B(ge,ce);return se=!1,ce=ge,Ie},X)}R.latch=Y;function N(z,B,X){return[R.filter(z,B,X),R.filter(z,se=>!B(se),X)]}R.split=N;function W(z,B=!1,X=[]){let se=X.slice(),ce=z(Ae=>{se?se.push(Ae):Ie.fire(Ae)});const ge=()=>{se?.forEach(Ae=>Ie.fire(Ae)),se=null},Ie=new v({onWillAddFirstListener(){ce||(ce=z(Ae=>Ie.fire(Ae)))},onDidAddFirstListener(){se&&(B?setTimeout(ge):ge())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return Ie.event}R.buffer=W;class T{constructor(B){this.event=B,this.d=new r.$jb}map(B){return new T(j(this.event,B,this.d))}forEach(B){return new T(F(this.event,B,this.d))}filter(B){return new T(q(this.event,B,this.d))}reduce(B,X){return new T(ne(this.event,B,X,this.d))}latch(){return new T(Y(this.event,void 0,this.d))}debounce(B,X=100,se=!1,ce=!1,ge){return new T(le(this.event,B,X,se,ce,ge,this.d))}on(B,X,se){return this.event(B,X,se)}once(B,X,se){return M(this.event)(B,X,se)}dispose(){this.d.dispose()}}function J(z){return new T(z)}R.chain=J;function Q(z,B,X=se=>se){const se=(...Ae)=>Ie.fire(X(...Ae)),ce=()=>z.on(B,se),ge=()=>z.removeListener(B,se),Ie=new v({onWillAddFirstListener:ce,onDidRemoveLastListener:ge});return Ie.event}R.fromNodeEventEmitter=Q;function ae(z,B,X=se=>se){const se=(...Ae)=>Ie.fire(X(...Ae)),ce=()=>z.addEventListener(B,se),ge=()=>z.removeEventListener(B,se),Ie=new v({onWillAddFirstListener:ce,onDidRemoveLastListener:ge});return Ie.event}R.fromDOMEventEmitter=ae;function oe(z){return new Promise(B=>M(z)(B))}R.toPromise=oe;function L(z,B){return B(void 0),z(X=>B(X))}R.runAndSubscribe=L;function D(z,B){let X=null;function se(ge){X?.dispose(),X=new r.$jb,B(ge,X)}se(void 0);const ce=z(ge=>se(ge));return(0,r.$ib)(()=>{ce.dispose(),X?.dispose()})}R.runAndSubscribeWithStore=D;class U{constructor(B,X){this._observable=B,this.d=0,this.f=!1;const se={onWillAddFirstListener:()=>{B.addObserver(this)},onDidRemoveLastListener:()=>{B.removeObserver(this)}};X||I(se),this.emitter=new v(se),X&&X.add(this.emitter)}beginUpdate(B){this.d++}handlePossibleChange(B){}handleChange(B,X){this.f=!0}endUpdate(B){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function H(z,B){return new U(z,B).emitter.event}R.fromObservable=H;function V(z){return B=>{let X=0,se=!1;const ce={beginUpdate(){X++},endUpdate(){X--,X===0&&(z.reportChanges(),se&&(se=!1,B()))},handlePossibleChange(){},handleChange(){se=!0}};return z.addObserver(ce),{dispose(){z.removeObserver(ce)}}}}R.fromObservableLight=V})(l||(e.Event=l={}));class m{constructor(I){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${I}_${m.d++}`,m.all.add(this)}start(I){this.f=new A.$1c,this.listenerCount=I}stop(){if(this.f){const I=this.f.elapsed();this.durations.push(I),this.elapsedOverall+=I,this.invocationCount+=1,this.f=void 0}}}e.$3c=m,m.all=new Set,m.d=0;let d=-1;function p(R){const I=d;return d=R,{dispose(){d=I}}}e.$4c=p;class h{constructor(I,S=Math.random().toString(18).slice(2,5)){this.threshold=I,this.name=S,this.f=0}dispose(){this.d?.clear()}check(I,S){const M=this.threshold;if(M<=0||S<M)return;this.d||(this.d=new Map);const j=this.d.get(I.value)||0;if(this.d.set(I.value,j+1),this.f-=1,this.f<=0){this.f=M*.5;let F,q=0;for(const[re,ie]of this.d)(!F||q<ie)&&(F=re,q=ie);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${q}):`),console.warn(F)}return()=>{const F=this.d.get(I.value)||0;this.d.set(I.value,F-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(I){this.value=I}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class o{constructor(I){this.value=I,this.id=b++}}const g=2,a=(R,I)=>{if(R instanceof o)I(R);else for(let S=0;S<R.length;S++){const M=R[S];M&&I(M)}};class v{constructor(I){this.u=0,this.d=I,this.f=d>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??d):void 0,this.g=this.d?._profName?new m(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(P){const I=this.q;queueMicrotask(()=>{a(I,S=>S.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(I,S,M)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$kb.None;if(this.j)return r.$kb.None;S&&(I=I.bind(S));const j=new o(I);let F,q;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(j.stack=y.create(),F=this.f.check(j.stack,this.u+1)),P&&(j.stack=q??y.create()),this.q?this.q instanceof o?(this.t??=new w,this.q=[this.q,j]):this.q.push(j):(this.d?.onWillAddFirstListener?.(this),this.q=j,this.d?.onDidAddFirstListener?.(this)),this.u++;const re=(0,r.$ib)(()=>{F?.(),this.v(j)});return M instanceof r.$jb?M.add(re):Array.isArray(M)&&M.push(re),re},this.m}v(I){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const S=this.q,M=S.indexOf(I);if(M===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,S[M]=void 0;const j=this.t.current===this;if(this.u*g<=S.length){let F=0;for(let q=0;q<S.length;q++)S[q]?S[F++]=S[q]:j&&(this.t.end--,F<this.t.i&&this.t.i--);S.length=F}}w(I,S){if(!I)return;const M=this.d?.onListenerError||E.$X;if(!M){I.value(S);return}try{I.value(S)}catch(j){M(j)}}x(I){const S=I.current.q;for(;I.i<I.end;)this.w(S[I.i++],I.value);I.reset()}fire(I){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof o)this.w(this.q,I);else{const S=this.t;S.enqueue(this,I,this.q.length),this.x(S)}this.g?.stop()}hasListeners(){return this.u>0}}e.$5c=v;const k=()=>new w;e.$6c=k;class w{constructor(){this.i=-1,this.end=0}enqueue(I,S,M){this.i=0,this.end=M,this.current=I,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends v{async fireAsync(I,S,M){if(this.q)for(this.h||(this.h=new O.$jc),a(this.q,j=>this.h.push([j.value,I]));this.h.size>0&&!S.isCancellationRequested;){const[j,F]=this.h.shift(),q=[],re={...F,token:S,waitUntil:ie=>{if(Object.isFrozen(q))throw new Error("waitUntil can NOT be called asynchronous");M&&(ie=M(ie,j)),q.push(ie)}};try{j(re)}catch(ie){(0,E.$X)(ie);continue}Object.freeze(q),await Promise.allSettled(q).then(ie=>{for(const ne of ie)ne.status==="rejected"&&(0,E.$X)(ne.reason)})}}}e.$7c=t;class u extends v{get isPaused(){return this.h!==0}constructor(I){super(I),this.h=0,this.s=new O.$jc,this.y=I?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const I=Array.from(this.s);this.s.clear(),super.fire(this.y(I))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(I){this.u&&(this.h!==0?this.s.push(I):super.fire(I))}}e.$8c=u;class s extends u{constructor(I){super(I),this.k=I.delay??100}fire(I){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(I)}}e.$9c=s;class i extends v{constructor(I){super(I),this.h=[],this.k=I?.merge}fire(I){this.hasListeners()&&(this.h.push(I),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(S=>super.fire(S)),this.h=[]}))}}e.$0c=i;class n{constructor(){this.f=!1,this.g=[],this.d=new v({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(I){const S={event:I,listener:null};this.g.push(S),this.f&&this.k(S);const M=()=>{this.f&&this.m(S);const j=this.g.indexOf(S);this.g.splice(j,1)};return(0,r.$ib)((0,C.$bb)(M))}h(){this.f=!0,this.g.forEach(I=>this.k(I))}j(){this.f=!1,this.g.forEach(I=>this.m(I))}k(I){I.listener=I.event(S=>this.d.fire(S))}m(I){I.listener&&I.listener.dispose(),I.listener=null}dispose(){this.d.dispose()}}e.$$c=n;class c{constructor(){this.d=[]}wrapEvent(I){return(S,M,j)=>I(F=>{const q=this.d[this.d.length-1];q?q.push(()=>S.call(M,F)):S.call(M,F)},void 0,j)}bufferEvents(I){const S=[];this.d.push(S);const M=I();return this.d.pop(),S.forEach(j=>j()),M}}e.$_c=c;class ${constructor(){this.d=!1,this.f=l.None,this.g=r.$kb.None,this.h=new v({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(I){this.f=I,this.d&&(this.g.dispose(),this.g=I(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$ad=$}),define(ee[21],te([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=e.CancellationToken=void 0;const C=Object.freeze(function(P,f){const l=setTimeout(P.bind(f),0);return{dispose(){clearTimeout(l)}}});var r;(function(P){function f(l){return l===P.None||l===P.Cancelled||l instanceof O?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}P.isCancellationToken=f,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(r||(e.CancellationToken=r={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new E.$5c),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(f){this.a=void 0,this.b=void 0,this.b=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new O),this.a}cancel(){this.a?this.a instanceof O&&this.a.cancel():this.a=r.Cancelled}dispose(f=!1){f&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof O&&this.a.dispose():this.a=r.None}}e.$bd=A}),define(ee[139],te([0,1,21]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ed=e.$dd=e.$cd=void 0;class C{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new E.$bd,f=this.b(P.token);return this.a={promise:f,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$cd=C;class r{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const f=JSON.stringify(P);return this.b!==f&&(this.b=f,this.a=this.c(P)),this.a}}e.$dd=r;class O{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const f=this.b(P);return this.a.set(P,f),f}}e.$ed=O}),define(ee[61],te([0,1,13,2]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=void 0;function r(k){const w=k;return w?typeof w.read=="function":!1}e.$tb=r;function O(k){const w=k;return w?[w.on,w.pause,w.resume,w.destroy].every(t=>typeof t=="function"):!1}e.$ub=O;function A(k){const w=k;return w?O(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.$vb=A;function P(k,w){return new f(k,w)}e.$wb=P;class f{constructor(w,t){this.e=w,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(t=>t(w))}h(w){this.c.error.length===0?(0,E.$X)(w):this.c.error.slice(0).forEach(t=>t(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,t){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(w,t){if(this.a.destroyed)return;let u;switch(w){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const s=u.indexOf(t);s>=0&&u.splice(s,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(k,w){const t=[];let u;for(;(u=k.read())!==null;)t.push(u);return w(t)}e.$xb=l;function m(k,w,t){const u=[];let s;for(;(s=k.read())!==null&&u.length<t;)u.push(s);return s===null&&u.length>0?w(u):{read:()=>{if(u.length>0)return u.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return k.read()}}}e.$yb=m;function d(k,w){return new Promise((t,u)=>{const s=[];p(k,{onData:i=>{w&&s.push(i)},onError:i=>{w?u(i):t(void 0)},onEnd:()=>{t(w?w(s):void 0)}})})}e.$zb=d;function p(k,w){let t=!1;return k.on("error",u=>{t||w.onError(u)}),k.on("end",()=>{t||w.onEnd()}),k.on("data",u=>{t||w.onData(u)}),(0,C.$ib)(()=>t=!0)}e.$Ab=p;function h(k,w){return new Promise((t,u)=>{const s=new C.$jb,i=[],n=R=>{if(i.push(R),i.length>w)return s.dispose(),k.pause(),t({stream:k,buffer:i,ended:!1})},c=R=>u(R),$=()=>t({stream:k,buffer:i,ended:!0});s.add((0,C.$ib)(()=>k.removeListener("error",c))),k.on("error",c),s.add((0,C.$ib)(()=>k.removeListener("end",$))),k.on("end",$),s.add((0,C.$ib)(()=>k.removeListener("data",n))),k.on("data",n)})}e.$Bb=h;function y(k,w){const t=P(w);return t.end(k),t}e.$Cb=y;function b(){const k=P(()=>{throw new Error("not supported")});return k.end(),k}e.$Db=b;function o(k){let w=!1;return{read:()=>w?null:(w=!0,k)}}e.$Eb=o;function g(k,w,t){const u=P(t);return p(k,{onData:s=>u.write(w.data(s)),onError:s=>u.error(w.error?w.error(s):s),onEnd:()=>u.end()}),u}e.$Fb=g;function a(k,w,t){let u=!1;return{read:()=>{const s=w.read();return u?s:(u=!0,s!==null?t([k,s]):k)}}}e.$Gb=a;function v(k,w,t){let u=!1;const s=P(t);return p(w,{onData:i=>u?s.write(i):(u=!0,s.write(t([k,i]))),onError:i=>s.error(i),onEnd:()=>{u||(u=!0,s.write(k)),s.end()}}),s}e.$Hb=v}),define(ee[17],te([0,1,83,61]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=void 0;const r=typeof Buffer<"u",O=new E.$S(()=>new Uint8Array(256));let A,P;class f{static alloc(S){return r?new f(Buffer.allocUnsafe(S)):new f(new Uint8Array(S))}static wrap(S){return r&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new f(S)}static fromString(S,M){return!(M?.dontUseNodeBuffer||!1)&&r?new f(Buffer.from(S)):(A||(A=new TextEncoder),new f(A.encode(S)))}static fromByteArray(S){const M=f.alloc(S.length);for(let j=0,F=S.length;j<F;j++)M.buffer[j]=S[j];return M}static concat(S,M){if(typeof M>"u"){M=0;for(let q=0,re=S.length;q<re;q++)M+=S[q].byteLength}const j=f.alloc(M);let F=0;for(let q=0,re=S.length;q<re;q++){const ie=S[q];j.set(ie,F),F+=ie.byteLength}return j}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=f.alloc(this.byteLength);return S.set(this),S}toString(){return r?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(S,M){return new f(this.buffer.subarray(S,M))}set(S,M){if(S instanceof f)this.buffer.set(S.buffer,M);else if(S instanceof Uint8Array)this.buffer.set(S,M);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),M);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return d(this.buffer,S)}writeUInt32BE(S,M){p(this.buffer,S,M)}readUInt32LE(S){return h(this.buffer,S)}writeUInt32LE(S,M){y(this.buffer,S,M)}readUInt8(S){return b(this.buffer,S)}writeUInt8(S,M){o(this.buffer,S,M)}indexOf(S){const M=S instanceof f?S.buffer:S,j=M.byteLength,F=this.buffer,q=F.byteLength;if(j===0)return 0;if(j===1)return F.indexOf(M[0]);if(j>q)return-1;const re=O.value;re.fill(M.length);for(let le=0;le<M.length;le++)re[M[le]]=M.length-le-1;let ie=M.length-1,ne=ie,ue=-1;for(;ie<q;)if(F[ie]===M[ne]){if(ne===0){ue=ie;break}ie--,ne--}else ie+=Math.max(M.length-ne,re[F[ie]]),ne=M.length-1;return ue}}e.$Ib=f;function l(I,S){return I[S+0]<<0>>>0|I[S+1]<<8>>>0}e.$Jb=l;function m(I,S,M){I[M+0]=S&255,S=S>>>8,I[M+1]=S&255}e.$Kb=m;function d(I,S){return I[S]*2**24+I[S+1]*2**16+I[S+2]*2**8+I[S+3]}e.$Lb=d;function p(I,S,M){I[M+3]=S,S=S>>>8,I[M+2]=S,S=S>>>8,I[M+1]=S,S=S>>>8,I[M]=S}e.$Mb=p;function h(I,S){return I[S+0]<<0>>>0|I[S+1]<<8>>>0|I[S+2]<<16>>>0|I[S+3]<<24>>>0}e.$Nb=h;function y(I,S,M){I[M+0]=S&255,S=S>>>8,I[M+1]=S&255,S=S>>>8,I[M+2]=S&255,S=S>>>8,I[M+3]=S&255}e.$Ob=y;function b(I,S){return I[S]}e.$Pb=b;function o(I,S,M){I[M]=S}e.$Qb=o;function g(I){return C.$xb(I,S=>f.concat(S))}e.$Rb=g;function a(I){return C.$Eb(I)}e.$Sb=a;function v(I){return C.$zb(I,S=>f.concat(S))}e.$Tb=v;async function k(I){return I.ended?f.concat(I.buffer):f.concat([...I.buffer,await v(I.stream)])}e.$Ub=k;function w(I){return C.$Cb(I,S=>f.concat(S))}e.$Vb=w;function t(I){return C.$Fb(I,{data:S=>typeof S=="string"?f.fromString(S):f.wrap(S)},S=>f.concat(S))}e.$Wb=t;function u(I){return C.$wb(S=>f.concat(S),I)}e.$Xb=u;function s(I,S){return C.$Gb(I,S,M=>f.concat(M))}e.$Yb=s;function i(I,S){return C.$Hb(I,S,M=>f.concat(M))}e.$Zb=i;function n(I){let S=0,M=0,j=0;const F=new Uint8Array(Math.floor(I.length/4*3)),q=ie=>{switch(M){case 3:F[j++]=S|ie,M=0;break;case 2:F[j++]=S|ie>>>2,S=ie<<6,M=3;break;case 1:F[j++]=S|ie>>>4,S=ie<<4,M=2;break;default:S=ie<<2,M=1}};for(let ie=0;ie<I.length;ie++){const ne=I.charCodeAt(ie);if(ne>=65&&ne<=90)q(ne-65);else if(ne>=97&&ne<=122)q(ne-97+26);else if(ne>=48&&ne<=57)q(ne-48+52);else if(ne===43||ne===45)q(62);else if(ne===47||ne===95)q(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${I[ie]}`)}}const re=j;for(;M>0;)q(0);return f.wrap(F).slice(0,re)}e.$1b=n;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",$="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:I},S=!0,M=!1){const j=M?$:c;let F="";const q=I.byteLength%3;let re=0;for(;re<I.byteLength-q;re+=3){const ie=I[re+0],ne=I[re+1],ue=I[re+2];F+=j[ie>>>2],F+=j[(ie<<4|ne>>>4)&63],F+=j[(ne<<2|ue>>>6)&63],F+=j[ue&63]}if(q===1){const ie=I[re+0];F+=j[ie>>>2],F+=j[ie<<4&63],S&&(F+="==")}else if(q===2){const ie=I[re+0],ne=I[re+1];F+=j[ie>>>2],F+=j[(ie<<4|ne>>>4)&63],F+=j[ne<<2&63],S&&(F+="=")}return F}e.$2b=R}),define(ee[25],te([0,1,139,83]),function(G,e,E,C){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.GraphemeBreakType=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=void 0;function O(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}e.$hd=O;const A=/{(\d+)}/g;function P(Z,...fe){return fe.length===0?Z:Z.replace(A,function($e,me){const ve=parseInt(me,10);return isNaN(ve)||ve<0||ve>=fe.length?$e:fe[ve]})}e.$id=P;const f=/{([^}]+)}/g;function l(Z,fe){return Z.replace(f,($e,me)=>fe[me]??$e)}e.$jd=l;function m(Z){return Z.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$kd=m;function d(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$ld=d;function p(Z,fe){let $e=0;const me=fe.charCodeAt(0);for(let ve=Z.length-1;ve>=0;ve--)Z.charCodeAt(ve)===me&&$e++;return $e}e.$md=p;function h(Z,fe,$e="\u2026"){return Z.length<=fe?Z:`${Z.substr(0,fe)}${$e}`}e.$nd=h;function y(Z,fe=" "){const $e=b(Z,fe);return o($e,fe)}e.$od=y;function b(Z,fe){if(!Z||!fe)return Z;const $e=fe.length;if($e===0||Z.length===0)return Z;let me=0;for(;Z.indexOf(fe,me)===me;)me=me+$e;return Z.substring(me)}e.$pd=b;function o(Z,fe){if(!Z||!fe)return Z;const $e=fe.length,me=Z.length;if($e===0||me===0)return Z;let ve=me,Oe=-1;for(;Oe=Z.lastIndexOf(fe,ve-1),!(Oe===-1||Oe+$e!==ve);){if(Oe===0)return"";ve=Oe}return Z.substring(0,ve)}e.$qd=o;function g(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$rd=g;function a(Z){return Z.replace(/\*/g,"")}e.$sd=a;function v(Z,fe,$e={}){if(!Z)throw new Error("Cannot create regex from empty string");fe||(Z=d(Z)),$e.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let me="";return $e.global&&(me+="g"),$e.matchCase||(me+="i"),$e.multiline&&(me+="m"),$e.unicode&&(me+="u"),new RegExp(Z,me)}e.$td=v;function k(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}e.$ud=k;function w(Z){return!!Z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.$vd=w;function t(Z){return(Z.global?"g":"")+(Z.ignoreCase?"i":"")+(Z.multiline?"m":"")+(Z.unicode?"u":"")}e.$wd=t;function u(Z){return Z.split(/\r\n|\r|\n/)}e.$xd=u;function s(Z){for(let fe=0,$e=Z.length;fe<$e;fe++){const me=Z.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.$yd=s;function i(Z,fe=0,$e=Z.length){for(let me=fe;me<$e;me++){const ve=Z.charCodeAt(me);if(ve!==32&&ve!==9)return Z.substring(fe,me)}return Z.substring(fe,$e)}e.$zd=i;function n(Z,fe=Z.length-1){for(let $e=fe;$e>=0;$e--){const me=Z.charCodeAt($e);if(me!==32&&me!==9)return $e}return-1}e.$Ad=n;function c(Z,fe,$e){const me=[];let ve=0;for(const Oe of Z.matchAll(fe)){if(me.push(Z.slice(ve,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");ve=Oe.index+Oe[0].length,me.push($e(Oe[0],...Oe.slice(1),Oe.index,Z,Oe.groups))}return me.push(Z.slice(ve)),Promise.all(me).then(Oe=>Oe.join(""))}e.$Bd=c;function $(Z,fe){return Z<fe?-1:Z>fe?1:0}e.$Cd=$;function R(Z,fe,$e=0,me=Z.length,ve=0,Oe=fe.length){for(;$e<me&&ve<Oe;$e++,ve++){const xe=Z.charCodeAt($e),Je=fe.charCodeAt(ve);if(xe<Je)return-1;if(xe>Je)return 1}const Fe=me-$e,Ke=Oe-ve;return Fe<Ke?-1:Fe>Ke?1:0}e.$Dd=R;function I(Z,fe){return S(Z,fe,0,Z.length,0,fe.length)}e.$Ed=I;function S(Z,fe,$e=0,me=Z.length,ve=0,Oe=fe.length){for(;$e<me&&ve<Oe;$e++,ve++){let xe=Z.charCodeAt($e),Je=fe.charCodeAt(ve);if(xe===Je)continue;if(xe>=128||Je>=128)return R(Z.toLowerCase(),fe.toLowerCase(),$e,me,ve,Oe);j(xe)&&(xe-=32),j(Je)&&(Je-=32);const Qe=xe-Je;if(Qe!==0)return Qe}const Fe=me-$e,Ke=Oe-ve;return Fe<Ke?-1:Fe>Ke?1:0}e.$Fd=S;function M(Z){return Z>=48&&Z<=57}e.$Gd=M;function j(Z){return Z>=97&&Z<=122}e.$Hd=j;function F(Z){return Z>=65&&Z<=90}e.$Id=F;function q(Z,fe){return Z.length===fe.length&&S(Z,fe)===0}e.$Jd=q;function re(Z,fe){const $e=fe.length;return fe.length>Z.length?!1:S(Z,fe,0,$e)===0}e.$Kd=re;function ie(Z,fe){const $e=Math.min(Z.length,fe.length);let me;for(me=0;me<$e;me++)if(Z.charCodeAt(me)!==fe.charCodeAt(me))return me;return $e}e.$Ld=ie;function ne(Z,fe){const $e=Math.min(Z.length,fe.length);let me;const ve=Z.length-1,Oe=fe.length-1;for(me=0;me<$e;me++)if(Z.charCodeAt(ve-me)!==fe.charCodeAt(Oe-me))return me;return $e}e.$Md=ne;function ue(Z){return 55296<=Z&&Z<=56319}e.$Nd=ue;function le(Z){return 56320<=Z&&Z<=57343}e.$Od=le;function K(Z,fe){return(Z-55296<<10)+(fe-56320)+65536}e.$Pd=K;function Y(Z,fe,$e){const me=Z.charCodeAt($e);if(ue(me)&&$e+1<fe){const ve=Z.charCodeAt($e+1);if(le(ve))return K(me,ve)}return me}e.$Qd=Y;function N(Z,fe){const $e=Z.charCodeAt(fe-1);if(le($e)&&fe>1){const me=Z.charCodeAt(fe-2);if(ue(me))return K(me,$e)}return $e}class W{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=N(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=Y(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$Rd=W;class T{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new W(fe,$e)}nextGraphemeLength(){const fe=Re.getInstance(),$e=this.c,me=$e.offset;let ve=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Oe=$e.offset,Fe=fe.getGraphemeBreakType($e.nextCodePoint());if(de(ve,Fe)){$e.setOffset(Oe);break}ve=Fe}return $e.offset-me}prevGraphemeLength(){const fe=Re.getInstance(),$e=this.c,me=$e.offset;let ve=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Oe=$e.offset,Fe=fe.getGraphemeBreakType($e.prevCodePoint());if(de(Fe,ve)){$e.setOffset(Oe);break}ve=Fe}return me-$e.offset}eol(){return this.c.eol()}}e.$Sd=T;function J(Z,fe){return new T(Z,fe).nextGraphemeLength()}e.$Td=J;function Q(Z,fe){return new T(Z,fe).prevGraphemeLength()}e.$Ud=Q;function ae(Z,fe){fe>0&&le(Z.charCodeAt(fe))&&fe--;const $e=fe+J(Z,fe);return[$e-Q(Z,$e),$e]}e.$Vd=ae;function oe(Z){const fe=new T(Z);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}e.$Wd=oe;let L;function D(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(Z){return L||(L=D()),L.test(Z)}e.$Xd=U;const H=/^[\t\n\r\x20-\x7E]*$/;function V(Z){return H.test(Z)}e.$Yd=V,e.$Zd=/[\u2028\u2029]/;function z(Z){return e.$Zd.test(Z)}e.$1d=z;function B(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}e.$2d=B;function X(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}e.$3d=X;function se(Z,fe){if(Z.length<fe)return Z;const $e=/\b/g;let me=0;for(;$e.test(Z)&&!(Z.length-$e.lastIndex<fe);)me=$e.lastIndex,$e.lastIndex+=1;return Z.substring(me).replace(/^\s/,"")}e.$4d=se;const ce=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ge=/\x1b\].*?\x07/g;function Ie(Z){return Z&&(Z=Z.replace(ce,"").replace(ge,"")),Z}e.$5d=Ie,e.$6d=String.fromCharCode(65279);function Ae(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}e.$7d=Ae;function Ce(Z){return Ae(Z)?Z.substr(1):Z}e.$8d=Ce;function Le(Z,fe){if(!Z||!fe||Z.length<fe.length)return!1;const $e=fe.length,me=Z.toLowerCase();let ve=0,Oe=-1;for(;ve<$e;){const Fe=me.indexOf(fe[ve],Oe+1);if(Fe<0)return!1;Oe=Fe,ve++}return!0}e.$9d=Le;function ye(Z,fe=!1){return Z?(fe&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}e.$0d=ye;function we(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}e.$$d=we;function ke(Z,fe=1){if(fe===0)return"";let $e=-1;do $e=Z.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?Z:(Z[$e-1]==="\r"&&$e--,Z.substr(0,$e))}e.$_d=ke;function _(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}e.$ae=_;function he(Z){return Re.getInstance().getGraphemeBreakType(Z)}e.$be=he;function de(Z,fe){return Z===0?fe!==5&&fe!==7:Z===2&&fe===3?!1:Z===4||Z===2||Z===3||fe===4||fe===2||fe===3?!0:!(Z===8&&(fe===8||fe===9||fe===11||fe===12)||(Z===11||Z===9)&&(fe===9||fe===10)||(Z===12||Z===10)&&fe===10||fe===5||fe===13||fe===7||Z===1||Z===13&&fe===14||Z===6&&fe===6)}var Se;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(Se||(e.GraphemeBreakType=Se={}));class Re{static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=je()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const $e=this.d,me=$e.length/3;let ve=1;for(;ve<=me;)if(fe<$e[3*ve])ve=2*ve;else if(fe>$e[3*ve+1])ve=2*ve+1;else return $e[3*ve+2];return 0}}Re.c=null;function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(Z,fe){if(Z===0)return 0;const $e=He(Z,fe);if($e!==void 0)return $e;const me=new W(fe,Z);return me.prevCodePoint(),me.offset}e.$ce=Ue;function He(Z,fe){const $e=new W(fe,Z);let me=$e.prevCodePoint();for(;Be(me)||me===65039||me===8419;){if($e.offset===0)return;me=$e.prevCodePoint()}if(!X(me))return;let ve=$e.offset;return ve>0&&$e.prevCodePoint()===8205&&(ve=$e.offset),ve}function Be(Z){return 127995<=Z&&Z<=127999}var ze;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$de="\xA0";class qe{static getInstance(fe){return qe.d.get(Array.from(fe))}static getLocales(){return qe.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ee=qe,r=qe,qe.c=new C.$S(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.d=new E.$dd(Z=>{function fe(Je){const Qe=new Map;for(let tt=0;tt<Je.length;tt+=2)Qe.set(Je[tt],Je[tt+1]);return Qe}function $e(Je,Qe){const tt=new Map(Je);for(const[ot,ct]of Qe)tt.set(ot,ct);return tt}function me(Je,Qe){if(!Je)return Qe;const tt=new Map;for(const[ot,ct]of Je)Qe.has(ot)&&tt.set(ot,ct);return tt}const ve=r.c.value;let Oe=Z.filter(Je=>!Je.startsWith("_")&&Je in ve);Oe.length===0&&(Oe=["_default"]);let Fe;for(const Je of Oe){const Qe=fe(ve[Je]);Fe=me(Fe,Qe)}const Ke=fe(ve._common),xe=$e(Ke,Fe);return new qe(xe)}),qe.e=new C.$S(()=>Object.keys(qe.c.value).filter(Z=>!Z.startsWith("_")));class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(fe){return Te.e().has(fe)}static get codePoints(){return Te.e()}}e.$fe=Te,Te.d=void 0}),define(ee[56],te([0,1,25]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=void 0;function C(g){return r(g,0)}e.$_h=C;function r(g,a){switch(typeof g){case"object":return g===null?O(349,a):Array.isArray(g)?f(g,a):l(g,a);case"string":return P(g,a);case"boolean":return A(g,a);case"number":return O(g,a);case"undefined":return O(937,a);default:return O(617,a)}}e.$ai=r;function O(g,a){return(a<<5)-a+g|0}e.$bi=O;function A(g,a){return O(g?433:863,a)}function P(g,a){a=O(149417,a);for(let v=0,k=g.length;v<k;v++)a=O(g.charCodeAt(v),a);return a}e.$ci=P;function f(g,a){return a=O(104579,a),g.reduce((v,k)=>r(k,v),a)}function l(g,a){return a=O(181387,a),Object.keys(g).sort().reduce((v,k)=>(v=P(k,v),r(g[k],v)),a)}class m{constructor(){this.g=0}get value(){return this.g}hash(a){return this.g=r(a,this.g),this.g}}e.$di=m;var d;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(d||(d={}));function p(g,a,v=32){const k=v-a,w=~((1<<k)-1);return(g<<a|(w&g)>>>k)>>>0}function h(g,a=0,v=g.byteLength,k=0){for(let w=0;w<v;w++)g[a+w]=k}function y(g,a,v="0"){for(;g.length<a;)g=v+g;return g}function b(g,a=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(v=>v.toString(16).padStart(2,"0")).join(""):y((g>>>0).toString(16),a/4)}e.$ei=b;class o{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(a){const v=a.length;if(v===0)return;const k=this.p;let w=this.r,t=this.u,u,s;for(t!==0?(u=t,s=-1,t=0):(u=a.charCodeAt(0),s=0);;){let i=u;if(E.$Nd(u))if(s+1<v){const n=a.charCodeAt(s+1);E.$Od(n)?(s++,i=E.$Pd(u,n)):i=65533}else{t=u;break}else E.$Od(u)&&(i=65533);if(w=this.w(k,w,i),s++,s<v)u=a.charCodeAt(s);else break}this.r=w,this.u=t}w(a,v,k){return k<128?a[v++]=k:k<2048?(a[v++]=192|(k&1984)>>>6,a[v++]=128|(k&63)>>>0):k<65536?(a[v++]=224|(k&61440)>>>12,a[v++]=128|(k&4032)>>>6,a[v++]=128|(k&63)>>>0):(a[v++]=240|(k&1835008)>>>18,a[v++]=128|(k&258048)>>>12,a[v++]=128|(k&4032)>>>6,a[v++]=128|(k&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const a=8*this.t;this.q.setUint32(56,Math.floor(a/4294967296),!1),this.q.setUint32(60,a%4294967296,!1),this.y()}y(){const a=o.g,v=this.q;for(let $=0;$<64;$+=4)a.setUint32($,v.getUint32($,!1),!1);for(let $=64;$<320;$+=4)a.setUint32($,p(a.getUint32($-12,!1)^a.getUint32($-32,!1)^a.getUint32($-56,!1)^a.getUint32($-64,!1),1),!1);let k=this.h,w=this.l,t=this.m,u=this.n,s=this.o,i,n,c;for(let $=0;$<80;$++)$<20?(i=w&t|~w&u,n=1518500249):$<40?(i=w^t^u,n=1859775393):$<60?(i=w&t|w&u|t&u,n=2400959708):(i=w^t^u,n=3395469782),c=p(k,5)+i+s+n+a.getUint32($*4,!1)&4294967295,s=u,u=t,t=p(w,30),w=k,k=c;this.h=this.h+k&4294967295,this.l=this.l+w&4294967295,this.m=this.m+t&4294967295,this.n=this.n+u&4294967295,this.o=this.o+s&4294967295}}e.$fi=o,o.g=new DataView(new ArrayBuffer(320))}),define(ee[69],te([0,1,25]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(C||(C={})),function(r){const O="error",A="warning",P="warn",f="info",l="ignore";function m(p){return p?E.$Jd(O,p)?r.Error:E.$Jd(A,p)||E.$Jd(P,p)?r.Warning:E.$Jd(f,p)?r.Info:r.Ignore:r.Ignore}r.fromValue=m;function d(p){switch(p){case r.Error:return O;case r.Warning:return A;case r.Info:return f;default:return l}}r.toString=d}(C||(C={})),e.default=C}),define(ee[140],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0,e.$2c=Symbol("MicrotaskDelay")}),define(ee[62],te([0,1,24,25]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;class r{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const y=h.charCodeAt(0),b=this.b.charCodeAt(this.c);return y-b}value(){return this.b[this.c]}}e.$nh=r;class O{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,C.$Dd)(h,this.b,0,h.length,this.c,this.d):(0,C.$Fd)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$oh=O;class A{constructor(h=!0,y=!0){this.f=h,this.g=y}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let y=h.length-1;y>=0;y--,this.c--){const b=this.b.charCodeAt(y);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,C.$Dd)(h,this.b,0,h.length,this.d,this.e):(0,C.$Fd)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ph=A;var P;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(P||(P={}));class f{constructor(h,y){this.f=h,this.g=y,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,C.$Ed)(h,this.c.scheme);if(this.d[this.e]===2)return(0,C.$Ed)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,C.$Cd)(h,this.c.query);if(this.d[this.e]===5)return(0,C.$Cd)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$qh=f;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(m||(m={}));class d{static forUris(h=()=>!1,y=()=>!1){return new d(new f(h,y))}static forPaths(h=!1){return new d(new A(void 0,!h))}static forStrings(){return new d(new r)}static forConfigKeys(){return new d(new O)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,y){if(y){const b=y.slice(0);(0,E.$Bf)(b);for(const o of b)this.set(o,h)}else{const b=h.slice(0);(0,E.$Bf)(b);for(const o of b)this.set(o[0],o[1])}}set(h,y){const b=this.b.reset(h);let o;this.c||(this.c=new l,this.c.segment=b.value());const g=[];for(o=this.c;;){const v=b.cmp(o.segment);if(v>0)o.left||(o.left=new l,o.left.segment=b.value()),g.push([-1,o]),o=o.left;else if(v<0)o.right||(o.right=new l,o.right.segment=b.value()),g.push([1,o]),o=o.right;else if(b.hasNext())b.next(),o.mid||(o.mid=new l,o.mid.segment=b.value()),g.push([0,o]),o=o.mid;else break}const a=o.value;o.value=y,o.key=h;for(let v=g.length-1;v>=0;v--){const k=g[v][1];k.updateHeight();const w=k.balanceFactor();if(w<-1||w>1){const t=g[v][0],u=g[v+1][0];if(t===1&&u===1)g[v][1]=k.rotateLeft();else if(t===-1&&u===-1)g[v][1]=k.rotateRight();else if(t===1&&u===-1)k.right=g[v+1][1]=g[v+1][1].rotateRight(),g[v][1]=k.rotateLeft();else if(t===-1&&u===1)k.left=g[v+1][1]=g[v+1][1].rotateLeft(),g[v][1]=k.rotateRight();else throw new Error;if(v>0)switch(g[v-1][0]){case-1:g[v-1][1].left=g[v][1];break;case 1:g[v-1][1].right=g[v][1];break;case 0:g[v-1][1].mid=g[v][1];break}else this.c=g[0][1]}}return a}get(h){return this.d(h)?.value}d(h){const y=this.b.reset(h);let b=this.c;for(;b;){const o=y.cmp(b.segment);if(o>0)b=b.left;else if(o<0)b=b.right;else if(y.hasNext())y.next(),b=b.mid;else break}return b}has(h){const y=this.d(h);return!(y?.value===void 0&&y?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,y){const b=this.b.reset(h),o=[];let g=this.c;for(;g;){const a=b.cmp(g.segment);if(a>0)o.push([-1,g]),g=g.left;else if(a<0)o.push([1,g]),g=g.right;else if(b.hasNext())b.next(),o.push([0,g]),g=g.mid;else break}if(g){if(y?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const a=this.f(g.right);if(a.key){const{key:v,value:k,segment:w}=a;this.e(a.key,!1),g.key=v,g.value=k,g.segment=w}}else{const a=g.left??g.right;if(o.length>0){const[v,k]=o[o.length-1];switch(v){case-1:k.left=a;break;case 0:k.mid=a;break;case 1:k.right=a;break}}else this.c=a}for(let a=o.length-1;a>=0;a--){const v=o[a][1];v.updateHeight();const k=v.balanceFactor();if(k>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),o[a][1]=v.rotateLeft()):k<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),o[a][1]=v.rotateRight()),a>0)switch(o[a-1][0]){case-1:o[a-1][1].left=o[a][1];break;case 1:o[a-1][1].right=o[a][1];break;case 0:o[a-1][1].mid=o[a][1];break}else this.c=o[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const y=this.b.reset(h);let b=this.c,o;for(;b;){const g=y.cmp(b.segment);if(g>0)b=b.left;else if(g<0)b=b.right;else if(y.hasNext())y.next(),o=b.value||o,b=b.mid;else break}return b&&b.value||o}findSuperstr(h){return this.g(h,!1)}g(h,y){const b=this.b.reset(h);let o=this.c;for(;o;){const g=b.cmp(o.segment);if(g>0)o=o.left;else if(g<0)o=o.right;else if(b.hasNext())b.next(),o=o.mid;else return o.mid?this.h(o.mid):y?o.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[y,b]of this)h(b,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const y=[];return this.j(h,y),y[Symbol.iterator]()}j(h,y){h&&(h.left&&this.j(h.left,y),h.value&&y.push([h.key,h.value]),h.mid&&this.j(h.mid,y),h.right&&this.j(h.right,y))}_isBalanced(){const h=y=>{if(!y)return!0;const b=y.balanceFactor();return b<-1||b>1?!1:h(y.left)&&h(y.right)};return h(this.c)}}e.$rh=d}),define(ee[11],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;function E(u){return typeof u=="string"}e.$ge=E;function C(u){return Array.isArray(u)&&u.every(s=>E(s))}e.$he=C;function r(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.$ie=r;function O(u){const s=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof s}e.$je=O;function A(u){return typeof u=="number"&&!isNaN(u)}e.$ke=A;function P(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.$le=P;function f(u){return u===!0||u===!1}e.$me=f;function l(u){return typeof u>"u"}e.$ne=l;function m(u){return!d(u)}e.$oe=m;function d(u){return l(u)||u===null}e.$pe=d;function p(u,s){if(!u)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$qe=p;function h(u){if(d(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.$re=h;function y(...u){const s=[];for(let i=0;i<u.length;i++){const n=u[i];if(d(n))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);s.push(n)}return s}e.$se=y;const b=Object.prototype.hasOwnProperty;function o(u){if(!r(u))return!1;for(const s in u)if(b.call(u,s))return!1;return!0}e.$te=o;function g(u){return typeof u=="function"}e.$ue=g;function a(...u){return u.length>0&&u.every(g)}e.$ve=a;function v(u,s){const i=Math.min(u.length,s.length);for(let n=0;n<i;n++)k(u[n],s[n])}e.$we=v;function k(u,s){if(E(s)){if(typeof u!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(g(s)){try{if(u instanceof s)return}catch{}if(!d(u)&&u.constructor===s||s.length===1&&s.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$xe=k;function w(u){return u===null?void 0:u}e.$ye=w;function t(u){return typeof u>"u"?null:u}e.$ze=t}),define(ee[70],te([0,1,11]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=void 0;const C=Object.create(null);function r(P,f){if((0,E.$ge)(f)){const l=C[f];if(l===void 0)throw new Error(`${P} references an unknown codicon: ${f}`);f=l}return C[P]=f,{id:P}}function O(){return C}e.$wj=O;function A(){return Object.values(e.$yj)}e.$xj=A,e.$yj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package_:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(ee[37],te([0,1,11]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=void 0;function C(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const a=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([v,k])=>{a[v]=k&&typeof k=="object"?C(k):k}),a}e.$Dm=C;function r(g){if(!g||typeof g!="object")return g;const a=[g];for(;a.length>0;){const v=a.shift();Object.freeze(v);for(const k in v)if(O.call(v,k)){const w=v[k];typeof w=="object"&&!Object.isFrozen(w)&&!(0,E.$je)(w)&&a.push(w)}}return g}e.$Em=r;const O=Object.prototype.hasOwnProperty;function A(g,a){return P(g,a,new Set)}e.$Fm=A;function P(g,a,v){if((0,E.$pe)(g))return g;const k=a(g);if(typeof k<"u")return k;if(Array.isArray(g)){const w=[];for(const t of g)w.push(P(t,a,v));return w}if((0,E.$ie)(g)){if(v.has(g))throw new Error("Cannot clone recursive data-structure");v.add(g);const w={};for(const t in g)O.call(g,t)&&(w[t]=P(g[t],a,v));return v.delete(g),w}return g}function f(g,a,v=!0){return(0,E.$ie)(g)?((0,E.$ie)(a)&&Object.keys(a).forEach(k=>{k in g?v&&((0,E.$ie)(g[k])&&(0,E.$ie)(a[k])?f(g[k],a[k],v):g[k]=a[k]):g[k]=a[k]}),g):a}e.$Gm=f;function l(g,a){if(g===a)return!0;if(g==null||a===null||a===void 0||typeof g!=typeof a||typeof g!="object"||Array.isArray(g)!==Array.isArray(a))return!1;let v,k;if(Array.isArray(g)){if(g.length!==a.length)return!1;for(v=0;v<g.length;v++)if(!l(g[v],a[v]))return!1}else{const w=[];for(k in g)w.push(k);w.sort();const t=[];for(k in a)t.push(k);if(t.sort(),!l(w,t))return!1;for(v=0;v<w.length;v++)if(!l(g[w[v]],a[w[v]]))return!1}return!0}e.$Hm=l;function m(g){const a=new Set;return JSON.stringify(g,(v,k)=>{if((0,E.$ie)(k)||Array.isArray(k)){if(a.has(k))return"[Circular]";a.add(k)}return k})}e.$Im=m;function d(g,a){const v=Object.create(null);return!g||!a||Object.keys(a).forEach(w=>{const t=g[w],u=a[w];l(t,u)||(v[w]=u)}),v}e.$Jm=d;function p(g,a){const v=a.toLowerCase(),k=Object.keys(g).find(w=>w.toLowerCase()===v);return k?g[k]:g[a]}e.$Km=p;function h(g,a){const v=Object.create(null);for(const[k,w]of Object.entries(g))a(k,w)&&(v[k]=w);return v}e.$Lm=h;function y(g){let a=[],v=Object.getPrototypeOf(g);for(;Object.prototype!==v;)a=a.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return a}e.$Mm=y;function b(g){const a=[];for(const v of y(g))typeof g[v]=="function"&&a.push(v);return a}e.$Nm=b;function o(g,a){const v=w=>function(){const t=Array.prototype.slice.call(arguments,0);return a(w,t)},k={};for(const w of g)k[w]=v(w);return k}e.$Om=o}),define(ee[102],te([0,1,70]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$zj=e.ThemeColor=void 0;var C;(function(A){function P(f){return f&&typeof f=="object"&&typeof f.id=="string"}A.isThemeColor=P})(C||(e.ThemeColor=C={}));function r(A){return{id:A}}e.$zj=r;var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function f(a){const v=P.exec(a.id);if(!v)return f(E.$yj.error);const[,k,w]=v,t=["codicon","codicon-"+k];return w&&t.push("codicon-modifier-"+w.substring(1)),t}A.asClassNameArray=f;function l(a){return f(a).join(" ")}A.asClassName=l;function m(a){return"."+f(a).join(".")}A.asCSSSelector=m;function d(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||C.isThemeColor(a.color))}A.isThemeIcon=d;const p=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function h(a){const v=p.exec(a);if(!v)return;const[,k]=v;return{id:k}}A.fromString=h;function y(a){return{id:a}}A.fromId=y;function b(a,v){let k=a.id;const w=k.lastIndexOf("~");return w!==-1&&(k=k.substring(0,w)),v&&(k=`${k}~${v}`),{id:k}}A.modify=b;function o(a){const v=a.id.lastIndexOf("~");if(v!==-1)return a.id.substring(v+1)}A.getModifier=o;function g(a,v){return a.id===v.id&&a.color?.id===v.color?.id}A.isEqual=g})(O||(e.ThemeIcon=O={}))}),define(ee[31],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(r){return E.test(r)}e.$2e=C,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(P){for(let f=0;f<P.length;f++)P[f]=Math.floor(Math.random()*256);return P};const O=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){r(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let f=0,l="";return l+=A[O[f++]],l+=A[O[f++]],l+=A[O[f++]],l+=A[O[f++]],l+="-",l+=A[O[f++]],l+=A[O[f++]],l+="-",l+=A[O[f++]],l+=A[O[f++]],l+="-",l+=A[O[f++]],l+=A[O[f++]],l+="-",l+=A[O[f++]],l+=A[O[f++]],l+=A[O[f++]],l+=A[O[f++]],l+=A[O[f++]],l+=A[O[f++]],l}}()}),define(ee[141],te([0,1,71,42,49]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OR=void 0;async function O(A,P){if(await new Promise((m,d)=>{const p=C.createReadStream(A),h=E.createHash("sha1");p.pipe(h);const y=(0,r.$bb)((b,o)=>{p.removeAllListeners(),h.removeAllListeners(),b?d(b):m(o)});p.once("error",y),p.once("end",y),h.once("error",y),h.once("data",b=>y(void 0,b.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$OR=O}),define(ee[142],te([0,1,27]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(A){const P=A.replace(/\-/g,":").toLowerCase();return!C.has(P)}function O(){const A=(0,E.networkInterfaces)();for(const P in A){const f=A[P];if(f){for(const{mac:l}of f)if(r(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$om=O}),define(ee[86],te([0,1,27,62,31,142]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=void 0,e.$pm=new class{c(l){return this.a||(this.a=C.$rh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(l)}value(){if(this.b===void 0){let l=0,m=0;const d=(0,E.networkInterfaces)();for(const p in d){const h=d[p];if(h)for(const{mac:y,internal:b}of h)b||(m+=1,this.c(y.toUpperCase())&&(l+=1))}this.b=m>0?l/m:0}return this.b}};let A;async function P(l){return A||(A=(async()=>await f(l)||r.$3e())()),A}e.$qm=P;async function f(l){try{const m=await new Promise((p,h)=>{G(["crypto"],p,h)}),d=(0,O.$om)();return m.createHash("sha256").update(d,"utf8").digest("hex")}catch(m){l(m);return}}}),define(ee[103],te([0,1,87]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7e=e.$6e=e.$5e=void 0;function C(P,f,l,m=1){let d=!1;return new Promise(p=>{const h=setTimeout(()=>{if(!d)return d=!0,p(0)},l);r(P,f,m,y=>{if(!d)return d=!0,clearTimeout(h),p(y)})})}e.$5e=C;function r(P,f,l,m){if(f===0)return m(0);const d=new E.Socket;d.once("connect",()=>(A(d),r(P+l,f-1,l,m))),d.once("data",()=>{}),d.once("error",p=>(A(d),p.code!=="ECONNREFUSED"?r(P+l,f-1,l,m):m(P))),d.connect(P,"127.0.0.1")}e.$6e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(P,f,l,m="127.0.0.1"){let d=!1,p,h=1;const y=E.createServer({pauseOnConnect:!0});function b(o,g){d||(d=!0,y.removeAllListeners(),y.close(),p&&clearTimeout(p),g(o))}return new Promise(o=>{p=setTimeout(()=>{b(0,o)},l),y.on("listening",()=>{b(P,o)}),y.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&h<f?(P++,h++,y.listen(P,m)):b(0,o)}),y.on("close",()=>{b(0,o)}),y.listen(P,m)})}e.$7e=O;function A(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(f){console.error(f)}}}),function(){function G(){function e(){return process.uncHostAllowlist}function E(f){const l=new Set;if(Array.isArray(f))for(const m of f)typeof m=="string"&&l.add(m);return Array.from(l)}function C(){const f=e();return f?Array.from(f):[]}function r(f){if(process.platform!=="win32")return;const l=e();if(l)if(typeof f=="string")l.add(f.toLowerCase());else for(const m of E(f))r(m)}function O(f){if(typeof f!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const d of l){if(f.indexOf(d)!==0)continue;const h=f.indexOf("\\",d.length);if(h===-1)continue;const y=f.substring(d.length,h);if(y){m=y;break}}return m}function A(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:C,addUNCHostToAllowlist:r,getUNCHost:O,disableUNCAccessRestrictions:A,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return G()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=G():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ee[143],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RR=e.$QR=void 0,e.$QR="vscode:contextmenu",e.$RR="vscode:onCloseContextMenu"}),define(ee[144],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YR=void 0;class E{constructor(r,O){this.a=r,this.onMessage=O}send(r){try{this.a.send("vscode:message",r.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$YR=E}),define(ee[38],te([0,1,14,13]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SR=void 0;class r{constructor(){this.a=new WeakMap}on(A,P){const f=(l,...m)=>{this.b(A,l)&&P(l,...m)};return this.a.set(P,f),E.ipcMain.on(A,f),this}once(A,P){return E.ipcMain.once(A,(f,...l)=>{this.b(A,f)&&P(f,...l)}),this}handle(A,P){return E.ipcMain.handle(A,(f,...l)=>this.b(A,f)?P(f,...l):Promise.reject(`Invalid channel '${A}' or sender for ipcMain.handle() usage.`)),this}removeHandler(A){return E.ipcMain.removeHandler(A),this}removeListener(A,P){const f=this.a.get(P);return f&&(E.ipcMain.removeListener(A,f),this.a.delete(P)),this}b(A,P){if(!A||!A.startsWith("vscode:"))return(0,C.$X)(`Refused to handle ipcMain event for channel '${A}' because the channel is unknown.`),!1;const f=P.senderFrame,l=f.url;if(!l)return!0;let m="unknown";try{m=new URL(l).host}catch{return(0,C.$X)(`Refused to handle ipcMain event for channel '${A}' because of a malformed URL '${l}'.`),!1}return m!=="vscode-app"?((0,C.$X)(`Refused to handle ipcMain event for channel '${A}' because of a bad origin of '${m}'.`),!1):f.parent!==null?((0,C.$X)(`Refused to handle ipcMain event for channel '${A}' because sender of origin '${m}' is not a main frame.`),!1):!0}}e.$SR=new r}),define(ee[145],te([0,1,14,38,11,143]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TR=void 0;function A(){C.$SR.on(O.$QR,(f,l,m,d,p)=>{const h=P(f,d,m);h.popup({window:(0,r.$ye)(E.BrowserWindow.fromWebContents(f.sender)),x:p?p.x:void 0,y:p?p.y:void 0,positioningItem:p?p.positioningItem:void 0,callback:()=>{h&&f.sender.send(O.$RR,l)}})})}e.$TR=A;function P(f,l,m){const d=new E.Menu;return m.forEach(p=>{let h;p.type==="separator"?h=new E.MenuItem({type:p.type}):Array.isArray(p.submenu)?h=new E.MenuItem({submenu:P(f,l,p.submenu),label:p.label}):h=new E.MenuItem({label:p.label,type:p.type,accelerator:p.accelerator,checked:p.checked,enabled:p.enabled,visible:p.visible,click:(y,b,o)=>f.sender.send(l,p.id,o)}),d.append(h)}),d}}),define(ee[146],te([12,10]),function(G,e){return G.create("vs/base/common/date",e)}),define(ee[147],te([0,1,146]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=void 0;const C=60,r=C*60,O=r*24,A=O*7,P=O*30,f=O*365;function l(d,p,h,y){typeof d!="number"&&(d=d.getTime());const b=Math.round((new Date().getTime()-d)/1e3);if(b<-30)return(0,E.localize)(0,null,l(new Date().getTime()+b*1e3,!1));if(!y&&b<30)return(0,E.localize)(1,null);let o;return b<C?(o=b,p?o===1?h?(0,E.localize)(2,null,o):(0,E.localize)(3,null,o):h?(0,E.localize)(4,null,o):(0,E.localize)(5,null,o):o===1?h?(0,E.localize)(6,null,o):(0,E.localize)(7,null,o):h?(0,E.localize)(8,null,o):(0,E.localize)(9,null,o)):b<r?(o=Math.floor(b/C),p?o===1?h?(0,E.localize)(10,null,o):(0,E.localize)(11,null,o):h?(0,E.localize)(12,null,o):(0,E.localize)(13,null,o):o===1?h?(0,E.localize)(14,null,o):(0,E.localize)(15,null,o):h?(0,E.localize)(16,null,o):(0,E.localize)(17,null,o)):b<O?(o=Math.floor(b/r),p?o===1?h?(0,E.localize)(18,null,o):(0,E.localize)(19,null,o):h?(0,E.localize)(20,null,o):(0,E.localize)(21,null,o):o===1?h?(0,E.localize)(22,null,o):(0,E.localize)(23,null,o):h?(0,E.localize)(24,null,o):(0,E.localize)(25,null,o)):b<A?(o=Math.floor(b/O),p?o===1?(0,E.localize)(26,null,o):(0,E.localize)(27,null,o):o===1?(0,E.localize)(28,null,o):(0,E.localize)(29,null,o)):b<P?(o=Math.floor(b/A),p?o===1?h?(0,E.localize)(30,null,o):(0,E.localize)(31,null,o):h?(0,E.localize)(32,null,o):(0,E.localize)(33,null,o):o===1?h?(0,E.localize)(34,null,o):(0,E.localize)(35,null,o):h?(0,E.localize)(36,null,o):(0,E.localize)(37,null,o)):b<f?(o=Math.floor(b/P),p?o===1?h?(0,E.localize)(38,null,o):(0,E.localize)(39,null,o):h?(0,E.localize)(40,null,o):(0,E.localize)(41,null,o):o===1?h?(0,E.localize)(42,null,o):(0,E.localize)(43,null,o):h?(0,E.localize)(44,null,o):(0,E.localize)(45,null,o)):(o=Math.floor(b/f),p?o===1?h?(0,E.localize)(46,null,o):(0,E.localize)(47,null,o):h?(0,E.localize)(48,null,o):(0,E.localize)(49,null,o):o===1?h?(0,E.localize)(50,null,o):(0,E.localize)(51,null,o):h?(0,E.localize)(52,null,o):(0,E.localize)(53,null,o))}e.$Nl=l;function m(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Ol=m}),define(ee[148],te([12,10]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ee[50],te([0,1,24,11,148]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=e.$9h=void 0;function O(d,p){return p&&(d.stack||d.stacktrace)?r.localize(0,null,P(d),A(d.stack)||A(d.stacktrace)):P(d)}function A(d){return Array.isArray(d)?d.join(`
`):d}function P(d){return d.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?r.localize(1,null,d.message):d.message||r.localize(2,null)}function f(d=null,p=!1){if(!d)return r.localize(3,null);if(Array.isArray(d)){const h=E.$jf(d),y=f(h[0],p);return h.length>1?r.localize(4,null,y,h.length):y}if(C.$ge(d))return d;if(d.detail){const h=d.detail;if(h.error)return O(h.error,p);if(h.exception)return O(h.exception,p)}return d.stack?O(d,p):d.message?d.message:r.localize(5,null)}e.$9h=f;function l(d){const p=d;return p instanceof Error&&Array.isArray(p.actions)}e.$0h=l;function m(d,p){let h;return typeof d=="string"?h=new Error(d):h=d,h.actions=p,h}e.$$h=m}),define(ee[149],te([12,10]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ee[150],te([0,1,149]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=void 0;function C(r){switch(r){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.$0o=C}),define(ee[151],te([12,10]),function(G,e){return G.create("vs/base/common/platform",e)}),define(ee[3],te([0,1,151]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let C=!1,r=!1,O=!1,A=!1,P=!1,f=!1,l=!1,m=!1,d=!1,p=!1,h,y=e.$f,b=e.$f,o,g;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?a=e.$g.vscode.process:typeof process<"u"&&(a=process);const v=typeof a?.versions?.electron=="string",k=v&&a?.type==="renderer";if(typeof navigator=="object"&&!k)g=navigator.userAgent,C=g.indexOf("Windows")>=0,r=g.indexOf("Macintosh")>=0,m=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=g.indexOf("Linux")>=0,p=g?.indexOf("Mobi")>=0,f=!0,h=E.getConfiguredDefaultLocale(E.localize(0,null))||e.$f,y=h,b=navigator.language;else if(typeof a=="object"){C=a.platform==="win32",r=a.platform==="darwin",O=a.platform==="linux",A=O&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,l=v,d=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$f,y=e.$f;const R=a.env.VSCODE_NLS_CONFIG;if(R)try{const I=JSON.parse(R),S=I.availableLanguages["*"];h=I.locale,b=I.osLocale,y=S||e.$f,o=I._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var w;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(w||(e.Platform=w={}));function t(R){switch(R){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let u=0;r?u=1:C?u=3:O&&(u=2),e.$i=C,e.$j=r,e.$k=O,e.$l=A,e.$m=P,e.$n=l,e.$o=f,e.$p=f&&typeof e.$g.importScripts=="function",e.$q=m,e.$r=p,e.$s=d,e.$t=u,e.$u=g,e.$v=y;var s;(function(R){function I(){return e.$v}R.value=I;function S(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}R.isDefaultVariant=S;function M(){return e.$v==="en"}R.isDefault=M})(s||(e.Language=s={})),e.$w=h,e.$x=b,e.$y=o,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const R=[];e.$g.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let M=0,j=R.length;M<j;M++){const F=R[M];if(F.id===S.data.vscodeScheduleAsyncWork){R.splice(M,1),F.callback();return}}});let I=0;return S=>{const M=++I;R.push({id:M,callback:S}),e.$g.postMessage({vscodeScheduleAsyncWork:M},"*")}}return R=>setTimeout(R)})();var i;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=r||m?2:C?1:3;let n=!0,c=!1;function $(){if(!c){c=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,n=new Uint16Array(R.buffer)[0]===(2<<8)+1}return n}e.$C=$,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(ee[36],te([0,1,3]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6b=e.$5b=e.env=e.cwd=void 0;let C;if(typeof E.$g.vscode<"u"&&typeof E.$g.vscode.process<"u"){const r=E.$g.vscode.process;C={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return E.$i?"win32":E.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$5b=C.platform,e.$6b=C.arch}),define(ee[9],te([0,1,36]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ic=e.sep=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=void 0;const C=65,r=97,O=90,A=122,P=46,f=47,l=92,m=58,d=63;class p extends Error{constructor(u,s,i){let n;typeof s=="string"&&s.indexOf("not ")===0?(n="must not be",s=s.replace(/^not /,"")):n="must be";const c=u.indexOf(".")!==-1?"property":"argument";let $=`The "${u}" ${c} ${n} of type ${s}`;$+=`. Received type ${typeof i}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,u){if(t===null||typeof t!="object")throw new p(u,"Object",t)}function y(t,u){if(typeof t!="string")throw new p(u,"string",t)}const b=E.$5b==="win32";function o(t){return t===f||t===l}function g(t){return t===f}function a(t){return t>=C&&t<=O||t>=r&&t<=A}function v(t,u,s,i){let n="",c=0,$=-1,R=0,I=0;for(let S=0;S<=t.length;++S){if(S<t.length)I=t.charCodeAt(S);else{if(i(I))break;I=f}if(i(I)){if(!($===S-1||R===1))if(R===2){if(n.length<2||c!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const M=n.lastIndexOf(s);M===-1?(n="",c=0):(n=n.slice(0,M),c=n.length-1-n.lastIndexOf(s)),$=S,R=0;continue}else if(n.length!==0){n="",c=0,$=S,R=0;continue}}u&&(n+=n.length>0?`${s}..`:"..",c=2)}else n.length>0?n+=`${s}${t.slice($+1,S)}`:n=t.slice($+1,S),c=S-$-1;$=S,R=0}else I===P&&R!==-1?++R:R=-1}return n}function k(t,u){h(u,"pathObject");const s=u.dir||u.root,i=u.base||`${u.name||""}${u.ext||""}`;return s?s===u.root?`${s}${i}`:`${s}${t}${i}`:i}e.$7b={resolve(...t){let u="",s="",i=!1;for(let n=t.length-1;n>=-1;n--){let c;if(n>=0){if(c=t[n],y(c,"path"),c.length===0)continue}else u.length===0?c=E.cwd():(c=E.env[`=${u}`]||E.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==u.toLowerCase()&&c.charCodeAt(2)===l)&&(c=`${u}\\`));const $=c.length;let R=0,I="",S=!1;const M=c.charCodeAt(0);if($===1)o(M)&&(R=1,S=!0);else if(o(M))if(S=!0,o(c.charCodeAt(1))){let j=2,F=j;for(;j<$&&!o(c.charCodeAt(j));)j++;if(j<$&&j!==F){const q=c.slice(F,j);for(F=j;j<$&&o(c.charCodeAt(j));)j++;if(j<$&&j!==F){for(F=j;j<$&&!o(c.charCodeAt(j));)j++;(j===$||j!==F)&&(I=`\\\\${q}\\${c.slice(F,j)}`,R=j)}}}else R=1;else a(M)&&c.charCodeAt(1)===m&&(I=c.slice(0,2),R=2,$>2&&o(c.charCodeAt(2))&&(S=!0,R=3));if(I.length>0)if(u.length>0){if(I.toLowerCase()!==u.toLowerCase())continue}else u=I;if(i){if(u.length>0)break}else if(s=`${c.slice(R)}\\${s}`,i=S,S&&u.length>0)break}return s=v(s,!i,"\\",o),i?`${u}\\${s}`:`${u}${s}`||"."},normalize(t){y(t,"path");const u=t.length;if(u===0)return".";let s=0,i,n=!1;const c=t.charCodeAt(0);if(u===1)return g(c)?"\\":t;if(o(c))if(n=!0,o(t.charCodeAt(1))){let R=2,I=R;for(;R<u&&!o(t.charCodeAt(R));)R++;if(R<u&&R!==I){const S=t.slice(I,R);for(I=R;R<u&&o(t.charCodeAt(R));)R++;if(R<u&&R!==I){for(I=R;R<u&&!o(t.charCodeAt(R));)R++;if(R===u)return`\\\\${S}\\${t.slice(I)}\\`;R!==I&&(i=`\\\\${S}\\${t.slice(I,R)}`,s=R)}}}else s=1;else a(c)&&t.charCodeAt(1)===m&&(i=t.slice(0,2),s=2,u>2&&o(t.charCodeAt(2))&&(n=!0,s=3));let $=s<u?v(t.slice(s),!n,"\\",o):"";return $.length===0&&!n&&($="."),$.length>0&&o(t.charCodeAt(u-1))&&($+="\\"),i===void 0?n?`\\${$}`:$:n?`${i}\\${$}`:`${i}${$}`},isAbsolute(t){y(t,"path");const u=t.length;if(u===0)return!1;const s=t.charCodeAt(0);return o(s)||u>2&&a(s)&&t.charCodeAt(1)===m&&o(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let u,s;for(let c=0;c<t.length;++c){const $=t[c];y($,"path"),$.length>0&&(u===void 0?u=s=$:u+=`\\${$}`)}if(u===void 0)return".";let i=!0,n=0;if(typeof s=="string"&&o(s.charCodeAt(0))){++n;const c=s.length;c>1&&o(s.charCodeAt(1))&&(++n,c>2&&(o(s.charCodeAt(2))?++n:i=!1))}if(i){for(;n<u.length&&o(u.charCodeAt(n));)n++;n>=2&&(u=`\\${u.slice(n)}`)}return e.$7b.normalize(u)},relative(t,u){if(y(t,"from"),y(u,"to"),t===u)return"";const s=e.$7b.resolve(t),i=e.$7b.resolve(u);if(s===i||(t=s.toLowerCase(),u=i.toLowerCase(),t===u))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===l;)n++;let c=t.length;for(;c-1>n&&t.charCodeAt(c-1)===l;)c--;const $=c-n;let R=0;for(;R<u.length&&u.charCodeAt(R)===l;)R++;let I=u.length;for(;I-1>R&&u.charCodeAt(I-1)===l;)I--;const S=I-R,M=$<S?$:S;let j=-1,F=0;for(;F<M;F++){const re=t.charCodeAt(n+F);if(re!==u.charCodeAt(R+F))break;re===l&&(j=F)}if(F!==M){if(j===-1)return i}else{if(S>M){if(u.charCodeAt(R+F)===l)return i.slice(R+F+1);if(F===2)return i.slice(R+F)}$>M&&(t.charCodeAt(n+F)===l?j=F:F===2&&(j=3)),j===-1&&(j=0)}let q="";for(F=n+j+1;F<=c;++F)(F===c||t.charCodeAt(F)===l)&&(q+=q.length===0?"..":"\\..");return R+=j,q.length>0?`${q}${i.slice(R,I)}`:(i.charCodeAt(R)===l&&++R,i.slice(R,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const u=e.$7b.resolve(t);if(u.length<=2)return t;if(u.charCodeAt(0)===l){if(u.charCodeAt(1)===l){const s=u.charCodeAt(2);if(s!==d&&s!==P)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(a(u.charCodeAt(0))&&u.charCodeAt(1)===m&&u.charCodeAt(2)===l)return`\\\\?\\${u}`;return t},dirname(t){y(t,"path");const u=t.length;if(u===0)return".";let s=-1,i=0;const n=t.charCodeAt(0);if(u===1)return o(n)?t:".";if(o(n)){if(s=i=1,o(t.charCodeAt(1))){let R=2,I=R;for(;R<u&&!o(t.charCodeAt(R));)R++;if(R<u&&R!==I){for(I=R;R<u&&o(t.charCodeAt(R));)R++;if(R<u&&R!==I){for(I=R;R<u&&!o(t.charCodeAt(R));)R++;if(R===u)return t;R!==I&&(s=i=R+1)}}}}else a(n)&&t.charCodeAt(1)===m&&(s=u>2&&o(t.charCodeAt(2))?3:2,i=s);let c=-1,$=!0;for(let R=u-1;R>=i;--R)if(o(t.charCodeAt(R))){if(!$){c=R;break}}else $=!1;if(c===-1){if(s===-1)return".";c=s}return t.slice(0,c)},basename(t,u){u!==void 0&&y(u,"ext"),y(t,"path");let s=0,i=-1,n=!0,c;if(t.length>=2&&a(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(s=2),u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let $=u.length-1,R=-1;for(c=t.length-1;c>=s;--c){const I=t.charCodeAt(c);if(o(I)){if(!n){s=c+1;break}}else R===-1&&(n=!1,R=c+1),$>=0&&(I===u.charCodeAt($)?--$===-1&&(i=c):($=-1,i=R))}return s===i?i=R:i===-1&&(i=t.length),t.slice(s,i)}for(c=t.length-1;c>=s;--c)if(o(t.charCodeAt(c))){if(!n){s=c+1;break}}else i===-1&&(n=!1,i=c+1);return i===-1?"":t.slice(s,i)},extname(t){y(t,"path");let u=0,s=-1,i=0,n=-1,c=!0,$=0;t.length>=2&&t.charCodeAt(1)===m&&a(t.charCodeAt(0))&&(u=i=2);for(let R=t.length-1;R>=u;--R){const I=t.charCodeAt(R);if(o(I)){if(!c){i=R+1;break}continue}n===-1&&(c=!1,n=R+1),I===P?s===-1?s=R:$!==1&&($=1):s!==-1&&($=-1)}return s===-1||n===-1||$===0||$===1&&s===n-1&&s===i+1?"":t.slice(s,n)},format:k.bind(null,"\\"),parse(t){y(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const s=t.length;let i=0,n=t.charCodeAt(0);if(s===1)return o(n)?(u.root=u.dir=t,u):(u.base=u.name=t,u);if(o(n)){if(i=1,o(t.charCodeAt(1))){let j=2,F=j;for(;j<s&&!o(t.charCodeAt(j));)j++;if(j<s&&j!==F){for(F=j;j<s&&o(t.charCodeAt(j));)j++;if(j<s&&j!==F){for(F=j;j<s&&!o(t.charCodeAt(j));)j++;j===s?i=j:j!==F&&(i=j+1)}}}}else if(a(n)&&t.charCodeAt(1)===m){if(s<=2)return u.root=u.dir=t,u;if(i=2,o(t.charCodeAt(2))){if(s===3)return u.root=u.dir=t,u;i=3}}i>0&&(u.root=t.slice(0,i));let c=-1,$=i,R=-1,I=!0,S=t.length-1,M=0;for(;S>=i;--S){if(n=t.charCodeAt(S),o(n)){if(!I){$=S+1;break}continue}R===-1&&(I=!1,R=S+1),n===P?c===-1?c=S:M!==1&&(M=1):c!==-1&&(M=-1)}return R!==-1&&(c===-1||M===0||M===1&&c===R-1&&c===$+1?u.base=u.name=t.slice($,R):(u.name=t.slice($,c),u.base=t.slice($,R),u.ext=t.slice(c,R))),$>0&&$!==i?u.dir=t.slice(0,$-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const w=(()=>{if(b){const t=/\\/g;return()=>{const u=E.cwd().replace(t,"/");return u.slice(u.indexOf("/"))}}return()=>E.cwd()})();e.$8b={resolve(...t){let u="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const n=i>=0?t[i]:w();y(n,"path"),n.length!==0&&(u=`${n}/${u}`,s=n.charCodeAt(0)===f)}return u=v(u,!s,"/",g),s?`/${u}`:u.length>0?u:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===f,s=t.charCodeAt(t.length-1)===f;return t=v(t,!u,"/",g),t.length===0?u?"/":s?"./":".":(s&&(t+="/"),u?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let u;for(let s=0;s<t.length;++s){const i=t[s];y(i,"path"),i.length>0&&(u===void 0?u=i:u+=`/${i}`)}return u===void 0?".":e.$8b.normalize(u)},relative(t,u){if(y(t,"from"),y(u,"to"),t===u||(t=e.$8b.resolve(t),u=e.$8b.resolve(u),t===u))return"";const s=1,i=t.length,n=i-s,c=1,$=u.length-c,R=n<$?n:$;let I=-1,S=0;for(;S<R;S++){const j=t.charCodeAt(s+S);if(j!==u.charCodeAt(c+S))break;j===f&&(I=S)}if(S===R)if($>R){if(u.charCodeAt(c+S)===f)return u.slice(c+S+1);if(S===0)return u.slice(c+S)}else n>R&&(t.charCodeAt(s+S)===f?I=S:S===0&&(I=0));let M="";for(S=s+I+1;S<=i;++S)(S===i||t.charCodeAt(S)===f)&&(M+=M.length===0?"..":"/..");return`${M}${u.slice(c+I)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===f;let s=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===f){if(!i){s=n;break}}else i=!1;return s===-1?u?"/":".":u&&s===1?"//":t.slice(0,s)},basename(t,u){u!==void 0&&y(u,"ext"),y(t,"path");let s=0,i=-1,n=!0,c;if(u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let $=u.length-1,R=-1;for(c=t.length-1;c>=0;--c){const I=t.charCodeAt(c);if(I===f){if(!n){s=c+1;break}}else R===-1&&(n=!1,R=c+1),$>=0&&(I===u.charCodeAt($)?--$===-1&&(i=c):($=-1,i=R))}return s===i?i=R:i===-1&&(i=t.length),t.slice(s,i)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===f){if(!n){s=c+1;break}}else i===-1&&(n=!1,i=c+1);return i===-1?"":t.slice(s,i)},extname(t){y(t,"path");let u=-1,s=0,i=-1,n=!0,c=0;for(let $=t.length-1;$>=0;--$){const R=t.charCodeAt($);if(R===f){if(!n){s=$+1;break}continue}i===-1&&(n=!1,i=$+1),R===P?u===-1?u=$:c!==1&&(c=1):u!==-1&&(c=-1)}return u===-1||i===-1||c===0||c===1&&u===i-1&&u===s+1?"":t.slice(u,i)},format:k.bind(null,"/"),parse(t){y(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const s=t.charCodeAt(0)===f;let i;s?(u.root="/",i=1):i=0;let n=-1,c=0,$=-1,R=!0,I=t.length-1,S=0;for(;I>=i;--I){const M=t.charCodeAt(I);if(M===f){if(!R){c=I+1;break}continue}$===-1&&(R=!1,$=I+1),M===P?n===-1?n=I:S!==1&&(S=1):n!==-1&&(S=-1)}if($!==-1){const M=c===0&&s?1:c;n===-1||S===0||S===1&&n===$-1&&n===c+1?u.base=u.name=t.slice(M,$):(u.name=t.slice(M,n),u.base=t.slice(M,$),u.ext=t.slice(n,$))}return c>0?u.dir=t.slice(0,c-1):s&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.$8b.win32=e.$7b.win32=e.$7b,e.$8b.posix=e.$7b.posix=e.$8b,e.$9b=b?e.$7b.normalize:e.$8b.normalize,e.$0b=b?e.$7b.isAbsolute:e.$8b.isAbsolute,e.$$b=b?e.$7b.join:e.$8b.join,e.$_b=b?e.$7b.resolve:e.$8b.resolve,e.$ac=b?e.$7b.relative:e.$8b.relative,e.$bc=b?e.$7b.dirname:e.$8b.dirname,e.$cc=b?e.$7b.basename:e.$8b.basename,e.$dc=b?e.$7b.extname:e.$8b.extname,e.$ec=b?e.$7b.format:e.$8b.format,e.$fc=b?e.$7b.parse:e.$8b.parse,e.$gc=b?e.$7b.toNamespacedPath:e.$8b.toNamespacedPath,e.sep=b?e.$7b.sep:e.$8b.sep,e.$ic=b?e.$7b.delimiter:e.$8b.delimiter}),define(ee[32],te([0,1,9,3,25,11]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function A(c){return c===47||c===92}e.$Ae=A;function P(c){return c.replace(/[\\/]/g,E.$8b.sep)}e.$Be=P;function f(c){return c.indexOf("/")===-1&&(c=P(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.$Ce=f;function l(c,$=E.$8b.sep){if(!c)return"";const R=c.length,I=c.charCodeAt(0);if(A(I)){if(A(c.charCodeAt(1))&&!A(c.charCodeAt(2))){let M=3;const j=M;for(;M<R&&!A(c.charCodeAt(M));M++);if(j!==M&&!A(c.charCodeAt(M+1))){for(M+=1;M<R;M++)if(A(c.charCodeAt(M)))return c.slice(0,M+1).replace(/[\\/]/g,$)}}return $}else if(g(I)&&c.charCodeAt(1)===58)return A(c.charCodeAt(2))?c.slice(0,2)+$:c.slice(0,2);let S=c.indexOf("://");if(S!==-1){for(S+=3;S<R;S++)if(A(c.charCodeAt(S)))return c.slice(0,S+1)}return""}e.$De=l;function m(c){if(!C.$i||!c||c.length<5)return!1;let $=c.charCodeAt(0);if($!==92||($=c.charCodeAt(1),$!==92))return!1;let R=2;const I=R;for(;R<c.length&&($=c.charCodeAt(R),$!==92);R++);return!(I===R||($=c.charCodeAt(R+1),isNaN($)||$===92))}e.$Ee=m;const d=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(c,$=C.$i){const R=$?d:p;return!(!c||c.length===0||/^\s+$/.test(c)||(R.lastIndex=0,R.test(c))||$&&h.test(c)||c==="."||c===".."||$&&c[c.length-1]==="."||$&&c.length!==c.trim().length||c.length>255)}e.$Fe=y;function b(c,$,R){const I=c===$;return!R||I?I:!c||!$?!1:(0,r.$Jd)(c,$)}e.$Ge=b;function o(c,$,R,I=E.sep){if(c===$)return!0;if(!c||!$||$.length>c.length)return!1;if(R){if(!(0,r.$Kd)(c,$))return!1;if($.length===c.length)return!0;let M=$.length;return $.charAt($.length-1)===I&&M--,c.charAt(M)===I}return $.charAt($.length-1)!==I&&($+=I),c.indexOf($)===0}e.$He=o;function g(c){return c>=65&&c<=90||c>=97&&c<=122}e.$Ie=g;function a(c,$){return C.$i&&c.endsWith(":")&&(c+=E.sep),(0,E.$0b)(c)||(c=(0,E.$$b)($,c)),c=(0,E.$9b)(c),C.$i?(c=(0,r.$qd)(c,E.sep),c.endsWith(":")&&(c+=E.sep)):(c=(0,r.$qd)(c,E.sep),c||(c=E.sep)),c}e.$Je=a;function v(c){const $=(0,E.$9b)(c);return C.$i?c.length>3?!1:k($)&&(c.length===2||$.charCodeAt(2)===92):$===E.$8b.sep}e.$Ke=v;function k(c,$=C.$i){return $?g(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.$Le=k;function w(c,$=C.$i){return k(c,$)?c[0]:void 0}e.$Me=w;function t(c,$,R){return $.length>c.length?-1:c===$?0:(R&&(c=c.toLowerCase(),$=$.toLowerCase()),c.indexOf($))}e.$Ne=t;function u(c){const $=c.split(":");let R,I,S;for(const M of $){const j=Number(M);(0,O.$ke)(j)?I===void 0?I=j:S===void 0&&(S=j):R=R?[R,M].join(":"):M}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:I!==void 0?I:void 0,column:S!==void 0?S:I!==void 0?1:void 0}}e.$Oe=u;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(c,$,R=8){let I="";for(let M=0;M<R;M++){let j;M===0&&C.$i&&!$&&(R===3||R===4)?j=i:j=s,I+=j.charAt(Math.floor(Math.random()*j.length))}let S;return $?S=`${$}-${I}`:S=I,c?(0,E.$$b)(c,S):S}e.$Pe=n}),define(ee[72],te([0,1,3]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.TerminateResponseCode=e.Source=void 0;var C;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(C||(e.Source=C={}));var r;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function O(P,...f){const l=f.reduce((p,h)=>(p[h]=!0,p),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!l[p]).forEach(p=>{for(let h=0;h<m.length;h++)if(p.search(m[h])!==-1){delete P[p];break}})}e.$bl=O;function A(P){P&&(delete P.DEBUG,E.$j&&delete P.DYLD_LIBRARY_PATH,E.$k&&delete P.LD_PRELOAD)}e.$cl=A}),define(ee[7],te([0,1,9,3]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,O=/^\//,A=/^\/\//;function P(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!r.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!O.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function l(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==d&&(n=d+n):n=d;break}return n}const m="",d="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(n){return n instanceof h?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,c,$,R,I,S=!1){typeof n=="object"?(this.scheme=n.scheme||m,this.authority=n.authority||m,this.path=n.path||m,this.query=n.query||m,this.fragment=n.fragment||m):(this.scheme=f(n,S),this.authority=c||m,this.path=l(this.scheme,$||m),this.query=R||m,this.fragment=I||m,P(this,S))}get fsPath(){return k(this,!1)}with(n){if(!n)return this;let{scheme:c,authority:$,path:R,query:I,fragment:S}=n;return c===void 0?c=this.scheme:c===null&&(c=m),$===void 0?$=this.authority:$===null&&($=m),R===void 0?R=this.path:R===null&&(R=m),I===void 0?I=this.query:I===null&&(I=m),S===void 0?S=this.fragment:S===null&&(S=m),c===this.scheme&&$===this.authority&&R===this.path&&I===this.query&&S===this.fragment?this:new o(c,$,R,I,S)}static parse(n,c=!1){const $=p.exec(n);return $?new o($[2]||m,s($[4]||m),s($[5]||m),s($[7]||m),s($[9]||m),c):new o(m,m,m,m,m)}static file(n){let c=m;if(C.$i&&(n=n.replace(/\\/g,d)),n[0]===d&&n[1]===d){const $=n.indexOf(d,2);$===-1?(c=n.substring(2),n=d):(c=n.substring(2,$),n=n.substring($)||d)}return new o("file",c,n,m,m)}static from(n,c){return new o(n.scheme,n.authority,n.path,n.query,n.fragment,c)}static joinPath(n,...c){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return C.$i&&n.scheme==="file"?$=h.file(E.$7b.join(k(n,!0),...c)).path:$=E.$8b.join(n.path,...c),n.with({path:$})}toString(n=!1){return w(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof h)return n;{const c=new o(n);return c._formatted=n.external??null,c._fsPath=n._sep===b?n.fsPath??null:null,c}}else return n}}e.URI=h;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$Re=y;const b=C.$i?1:void 0;class o extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(n=!1){return n?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=b),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(i,n,c){let $,R=-1;for(let I=0;I<i.length;I++){const S=i.charCodeAt(I);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||n&&S===47||c&&S===91||c&&S===93||c&&S===58)R!==-1&&($+=encodeURIComponent(i.substring(R,I)),R=-1),$!==void 0&&($+=i.charAt(I));else{$===void 0&&($=i.substr(0,I));const M=g[S];M!==void 0?(R!==-1&&($+=encodeURIComponent(i.substring(R,I)),R=-1),$+=M):R===-1&&(R=I)}}return R!==-1&&($+=encodeURIComponent(i.substring(R))),$!==void 0?$:i}function v(i){let n;for(let c=0;c<i.length;c++){const $=i.charCodeAt(c);$===35||$===63?(n===void 0&&(n=i.substr(0,c)),n+=g[$]):n!==void 0&&(n+=i[c])}return n!==void 0?n:i}function k(i,n){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,C.$i&&(c=c.replace(/\//g,"\\")),c}e.$Se=k;function w(i,n){const c=n?v:a;let $="",{scheme:R,authority:I,path:S,query:M,fragment:j}=i;if(R&&($+=R,$+=":"),(I||R==="file")&&($+=d,$+=d),I){let F=I.indexOf("@");if(F!==-1){const q=I.substr(0,F);I=I.substr(F+1),F=q.lastIndexOf(":"),F===-1?$+=c(q,!1,!1):($+=c(q.substr(0,F),!1,!1),$+=":",$+=c(q.substr(F+1),!1,!0)),$+="@"}I=I.toLowerCase(),F=I.lastIndexOf(":"),F===-1?$+=c(I,!1,!0):($+=c(I.substr(0,F),!1,!0),$+=I.substr(F))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const F=S.charCodeAt(1);F>=65&&F<=90&&(S=`/${String.fromCharCode(F+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const F=S.charCodeAt(0);F>=65&&F<=90&&(S=`${String.fromCharCode(F+32)}:${S.substr(2)}`)}$+=c(S,!0,!1)}return M&&($+="?",$+=c(M,!1,!1)),j&&($+="#",$+=n?j:a(j,!1,!1)),$}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(u)?i.replace(u,n=>t(n)):i}}),define(ee[152],te([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Ap=e.$zp=e.$yp=void 0;function C(l){const m=l;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.$yp=C;function r(l){const m=[];let d;try{const p=JSON.parse(l.arguments),h=p[p.length-1];h&&h.__$stack&&(p.pop(),d=h.__$stack),m.push(...p)}catch{m.push("Unable to log remote console arguments",l.arguments)}return{args:m,stack:d}}e.$zp=r;function O(l){if(typeof l!="string")return O(r(l).stack);const m=l;if(m){const d=A(m),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(p&&p.length===4)return{uri:E.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Ap=O;function A(l){if(!l)return l;const m=l.indexOf(`
`);return m===-1?l:l.substring(0,m)}function P(l,m){const{args:d,stack:p}=r(l),h=typeof d[0]=="string"&&d.length===1;let y=A(p);y&&(y=`(${y.trim()})`);let b=[];if(typeof d[0]=="string"?y&&h?b=[`%c[${m}] %c${d[0]} %c${y}`,f("blue"),f(""),f("grey")]:b=[`%c[${m}] %c${d[0]}`,f("blue"),f(""),...d.slice(1)]:b=[`%c[${m}]%`,f("blue"),...d],y&&!h&&b.push(y),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,b)}e.log=P;function f(l){return`color: ${l}`}}),define(ee[73],te([0,1,17,25,7]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=e.$Tg=e.$Sg=void 0;function O(l){return JSON.stringify(l,P)}e.$Sg=O;function A(l){let m=JSON.parse(l);return m=f(m),m}e.$Tg=A;function P(l,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:(0,C.$wd)(m)}:m}function f(l,m=0){if(!l||m>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return r.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof E.$Ib||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let d=0;d<l.length;++d)l[d]=f(l[d],m+1);else for(const d in l)Object.hasOwnProperty.call(l,d)&&(l[d]=f(l[d],m+1))}return l}e.$Ug=f}),define(ee[15],te([0,1,13,3,7]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var O;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.$Te="vscode-tkn",e.$Ue="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${O.vscodeRemoteResource}`}set(m,d,p){this.a[m]=d,this.b[m]=p}setConnectionToken(m,d){this.c[m]=d}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(o){return E.$X(o),m}const d=m.authority;let p=this.a[d];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const h=this.b[d],y=this.c[d];let b=`path=${encodeURIComponent(m.path)}`;return typeof y=="string"&&(b+=`&${e.$Ue}=${encodeURIComponent(y)}`),r.URI.from({scheme:C.$o?this.d:O.vscodeRemoteResource,authority:`${p}:${h}`,path:this.f,query:b})}}e.$Ve=new A,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(m){const d=this.b(m,G);return this.uriToBrowserUri(d)}uriToBrowserUri(m){return m.scheme===O.vscodeRemote?e.$Ve.rewrite(m):m.scheme===O.file&&(C.$m||C.$p&&C.$g.origin===`${O.vscodeFileResource}://${P.a}`)?m.with({scheme:O.vscodeFileResource,authority:m.authority||P.a,query:null,fragment:null}):m}asFileUri(m){const d=this.b(m,G);return this.uriToFileUri(d)}uriToFileUri(m){return m.scheme===O.vscodeFileResource?m.with({scheme:O.file,authority:m.authority!==P.a?m.authority:null,query:null,fragment:null}):m}b(m,d){return r.URI.isUri(m)?m:r.URI.parse(d.toUrl(m))}}P.a="vscode-app",e.$1e=new P;var f;(function(l){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(m.get("3"));const d="vscode-coi";function p(y){let b;typeof y=="string"?b=new URL(y).searchParams:y instanceof URL?b=y.searchParams:r.URI.isUri(y)&&(b=new URL(y.toString(!0)).searchParams);const o=b?.get(d);if(o)return m.get(o)}l.getHeadersFromQuery=p;function h(y,b,o){if(!globalThis.crossOriginIsolated)return;const g=b&&o?"3":o?"2":"1";y instanceof URLSearchParams?y.set(d,g):y[d]=g}l.addSearchParam=h})(f||(e.COI=f={}))}),define(ee[19],te([0,1,32,15,9,3,25,7]),function(G,e,E,C,r,O,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.DataUri=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function f(h){return(0,P.$Se)(h,!0)}e.$Tf=f;class l{constructor(y){this.a=y}compare(y,b,o=!1){return y===b?0:(0,A.$Cd)(this.getComparisonKey(y,o),this.getComparisonKey(b,o))}isEqual(y,b,o=!1){return y===b?!0:!y||!b?!1:this.getComparisonKey(y,o)===this.getComparisonKey(b,o)}getComparisonKey(y,b=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,b,o=!1){if(y.scheme===b.scheme){if(y.scheme===C.Schemas.file)return E.$He(f(y),f(b),this.a(y))&&y.query===b.query&&(o||y.fragment===b.fragment);if((0,e.$$f)(y.authority,b.authority))return E.$He(y.path,b.path,this.a(y),"/")&&y.query===b.query&&(o||y.fragment===b.fragment)}return!1}joinPath(y,...b){return P.URI.joinPath(y,...b)}basenameOrAuthority(y){return(0,e.$3f)(y)||y.authority}basename(y){return r.$8b.basename(y.path)}extname(y){return r.$8b.extname(y.path)}dirname(y){if(y.path.length===0)return y;let b;return y.scheme===C.Schemas.file?b=P.URI.file(r.$bc(f(y))).path:(b=r.$8b.dirname(y.path),y.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),b="/")),y.with({path:b})}normalizePath(y){if(!y.path.length)return y;let b;return y.scheme===C.Schemas.file?b=P.URI.file(r.$9b(f(y))).path:b=r.$8b.normalize(y.path),y.with({path:b})}relativePath(y,b){if(y.scheme!==b.scheme||!(0,e.$$f)(y.authority,b.authority))return;if(y.scheme===C.Schemas.file){const a=r.$ac(f(y),f(b));return O.$i?E.$Be(a):a}let o=y.path||"/";const g=b.path||"/";if(this.a(y)){let a=0;for(const v=Math.min(o.length,g.length);a<v&&!(o.charCodeAt(a)!==g.charCodeAt(a)&&o.charAt(a).toLowerCase()!==g.charAt(a).toLowerCase());a++);o=g.substr(0,a)+o.substr(a)}return r.$8b.relative(o,g)}resolvePath(y,b){if(y.scheme===C.Schemas.file){const o=P.URI.file(r.$_b(f(y),b));return y.with({authority:o.authority,path:o.path})}return b=E.$Ce(b),y.with({path:r.$8b.resolve(y.path,b)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,b){return y===b||y!==void 0&&b!==void 0&&(0,A.$Jd)(y,b)}hasTrailingPathSeparator(y,b=r.sep){if(y.scheme===C.Schemas.file){const o=f(y);return o.length>E.$De(o).length&&o[o.length-1]===b}else{const o=y.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,b=r.sep){return(0,e.$_f)(y,b)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,b=r.sep){let o=!1;if(y.scheme===C.Schemas.file){const g=f(y);o=g!==void 0&&g.length===E.$De(g).length&&g[g.length-1]===b}else{b="/";const g=y.path;o=g.length===1&&g.charCodeAt(g.length-1)===47}return!o&&!(0,e.$_f)(y,b)?y.with({path:y.path+"/"}):y}}e.$Uf=l,e.$Vf=new l(()=>!1),e.$Wf=new l(h=>h.scheme===C.Schemas.file?!O.$k:!0),e.$Xf=new l(h=>!0),e.$Yf=e.$Vf.isEqual.bind(e.$Vf),e.$Zf=e.$Vf.isEqualOrParent.bind(e.$Vf),e.$1f=e.$Vf.getComparisonKey.bind(e.$Vf),e.$2f=e.$Vf.basenameOrAuthority.bind(e.$Vf),e.$3f=e.$Vf.basename.bind(e.$Vf),e.$4f=e.$Vf.extname.bind(e.$Vf),e.$5f=e.$Vf.dirname.bind(e.$Vf),e.$6f=e.$Vf.joinPath.bind(e.$Vf),e.$7f=e.$Vf.normalizePath.bind(e.$Vf),e.$8f=e.$Vf.relativePath.bind(e.$Vf),e.$9f=e.$Vf.resolvePath.bind(e.$Vf),e.$0f=e.$Vf.isAbsolutePath.bind(e.$Vf),e.$$f=e.$Vf.isEqualAuthority.bind(e.$Vf),e.$_f=e.$Vf.hasTrailingPathSeparator.bind(e.$Vf),e.$ag=e.$Vf.removeTrailingPathSeparator.bind(e.$Vf),e.$bg=e.$Vf.addTrailingPathSeparator.bind(e.$Vf);function m(h,y){const b=[];for(let o=0;o<h.length;o++){const g=y(h[o]);h.some((a,v)=>v===o?!1:(0,e.$Zf)(g,y(a)))||b.push(h[o])}return b}e.$cg=m;var d;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function y(b){const o=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(v=>{const[k,w]=v.split(":");k&&w&&o.set(k,w)});const a=b.path.substring(0,b.path.indexOf(";"));return a&&o.set(h.META_DATA_MIME,a),o}h.parseMetaData=y})(d||(e.DataUri=d={}));function p(h,y,b){if(y){let o=h.path;return o&&o[0]!==r.$8b.sep&&(o=r.$8b.sep+o),h.with({scheme:b,authority:y,path:o})}return h.with({scheme:b})}e.$dg=p}),define(ee[8],te([0,1,21,13,4,2,19,3,140]),function(G,e,E,C,r,O,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Og=e.$Ng=e.$Mg=e.Promises=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=void 0;function l(L){return!!L&&typeof L.then=="function"}e.$eg=l;function m(L){const D=new E.$bd,U=L(D.token),H=new Promise((V,z)=>{const B=D.token.onCancellationRequested(()=>{B.dispose(),D.dispose(),z(new C.$2)});Promise.resolve(U).then(X=>{B.dispose(),D.dispose(),V(X)},X=>{B.dispose(),D.dispose(),z(X)})});return new class{cancel(){D.cancel()}then(V,z){return H.then(V,z)}catch(V){return this.then(void 0,V)}finally(V){return H.finally(V)}}}e.$fg=m;function d(L,D,U){return new Promise((H,V)=>{const z=D.onCancellationRequested(()=>{z.dispose(),H(U)});L.then(H,V).finally(()=>z.dispose())})}e.$gg=d;function p(L,D){return new Promise((U,H)=>{const V=D.onCancellationRequested(()=>{V.dispose(),H(new C.$2)});L.then(U,H).finally(()=>V.dispose())})}e.$hg=p;async function h(L){let D=-1;const U=L.map((H,V)=>H.then(z=>(D=V,z)));try{return await Promise.race(U)}finally{L.forEach((H,V)=>{V!==D&&H.cancel()})}}e.$ig=h;function y(L,D,U){let H;const V=setTimeout(()=>{H?.(void 0),U?.()},D);return Promise.race([L.finally(()=>clearTimeout(V)),new Promise(z=>H=z)])}e.$jg=y;function b(L){return new Promise((D,U)=>{const H=L();l(H)?H.then(D,U):D(H)})}e.$kg=b;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(D){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=D,!this.b){const U=()=>{if(this.b=null,this.f)return;const H=this.queue(this.d);return this.d=null,H};this.b=new Promise(H=>{this.a.then(U,U).then(H)})}return new Promise((U,H)=>{this.b.then(U,H)})}return this.a=D(),new Promise((U,H)=>{this.a.then(V=>{this.a=null,U(V)},V=>{this.a=null,H(V)})})}dispose(){this.f=!0}}e.$lg=o;class g{constructor(){this.a=Promise.resolve(null)}queue(D){return this.a=this.a.then(()=>D(),()=>D())}}e.$mg=g;class a{constructor(){this.a=new Map}queue(D,U){const V=(this.a.get(D)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(D)===V&&this.a.delete(D)});return this.a.set(D,V),V}}e.$ng=a;const v=(L,D)=>{let U=!0;const H=setTimeout(()=>{U=!1,D()},L);return{isTriggered:()=>U,dispose:()=>{clearTimeout(H),U=!1}}},k=L=>{let D=!0;return queueMicrotask(()=>{D&&(D=!1,L())}),{isTriggered:()=>D,dispose:()=>{D=!1}}};class w{constructor(D){this.defaultDelay=D,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(D,U=this.defaultDelay){this.g=D,this.h(),this.b||(this.b=new Promise((V,z)=>{this.d=V,this.f=z}).then(()=>{if(this.b=null,this.d=null,this.g){const V=this.g;return this.g=null,V()}}));const H=()=>{this.a=null,this.d?.(null)};return this.a=U===f.$2c?k(H):v(U,H),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$2),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$og=w;class t{constructor(D){this.a=new w(D),this.b=new o}trigger(D,U){return this.a.trigger(()=>this.b.queue(D),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.$pg=t;class u{constructor(){this.a=!1,this.b=new Promise((D,U)=>{this.d=D})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$qg=u;class s extends u{constructor(D){super(),this.f=setTimeout(()=>this.open(),D)}open(){clearTimeout(this.f),super.open()}}e.$rg=s;function i(L,D){return D?new Promise((U,H)=>{const V=setTimeout(()=>{z.dispose(),U()},L),z=D.onCancellationRequested(()=>{clearTimeout(V),z.dispose(),H(new C.$2)})}):m(U=>i(L,U))}e.$sg=i;function n(L,D=0){const U=setTimeout(L,D);return(0,O.$ib)(()=>clearTimeout(U))}e.$tg=n;function c(L){const D=[];let U=0;const H=L.length;function V(){return U<H?L[U++]():null}function z(B){B!=null&&D.push(B);const X=V();return X?X.then(z):Promise.resolve(D)}return Promise.resolve(null).then(z)}e.$ug=c;function $(L,D=H=>!!H,U=null){let H=0;const V=L.length,z=()=>{if(H>=V)return Promise.resolve(U);const B=L[H++];return Promise.resolve(B()).then(se=>D(se)?Promise.resolve(se):z())};return z()}e.$vg=$;function R(L,D=H=>!!H,U=null){if(L.length===0)return Promise.resolve(U);let H=L.length;const V=()=>{H=-1;for(const z of L)z.cancel?.()};return new Promise((z,B)=>{for(const X of L)X.then(se=>{--H>=0&&D(se)?(V(),z(se)):H===0&&z(U)}).catch(se=>{--H>=0&&(V(),B(se))})})}e.$wg=R;class I{constructor(D){this.a=0,this.d=D,this.f=[],this.b=0,this.g=new r.$5c}get onDrained(){return this.g.event}get size(){return this.a}queue(D){return this.a++,new Promise((U,H)=>{this.f.push({factory:D,c:U,e:H}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const D=this.f.shift();this.b++;const U=D.factory();U.then(D.c,D.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$xg=I;class S extends I{constructor(){super(1)}}e.$yg=S;class M{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const D=new W;return this.b.add(D),D.p}d(){for(const[,D]of this.a)if(D.size>0)return!1;return!0}queueFor(D,U=A.$Vf){const H=U.getComparisonKey(D);let V=this.a.get(H);return V||(V=new S,r.Event.once(V.onDrained)(()=>{V?.dispose(),this.a.delete(H),this.f()}),this.a.set(H,V)),V}f(){this.d()&&this.g()}g(){for(const D of this.b)D.complete();this.b.clear()}dispose(){for(const[,D]of this.a)D.dispose();this.a.clear(),this.g()}}e.$zg=M;class j{constructor(D,U){this.a=-1,typeof D=="function"&&typeof U=="number"&&this.setIfNotSet(D,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(D,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,D()},U)}setIfNotSet(D,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,D()},U))}}e.$Ag=j;class F{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(D,U){this.cancel(),this.a=setInterval(()=>{D()},U)}}e.$Bg=F;class q{constructor(D,U){this.b=-1,this.a=D,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(D=this.d){this.cancel(),this.b=setTimeout(this.f,D)}get delay(){return this.d}set delay(D){this.d=D}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Cg=q;class re{constructor(D,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=D,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(D=this.b){D%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${D}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(D/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dg=re;class ie extends q{constructor(D,U){super(D,U),this.j=[]}work(D){this.j.push(D),this.isScheduled()||this.schedule()}h(){const D=this.j;this.j=[],this.a?.(D)}dispose(){this.j=[],super.dispose()}}e.$Eg=ie;class ne extends O.$kb{constructor(D,U){super(),this.g=D,this.h=U,this.a=[],this.b=this.B(new O.$lb),this.f=!1}get pending(){return this.a.length}work(D){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+D.length>this.g.maxBufferedWork)return!1}else if(this.pending+D.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of D)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fg=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Gg=L=>{(0,P.$A)(()=>{if(D)return;const U=Date.now()+15;L(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let D=!1;return{dispose(){D||(D=!0)}}}:e.$Gg=(L,D)=>{const U=requestIdleCallback(L,typeof D=="number"?{timeout:D}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(U))}}}}();class ue{constructor(D){this.d=!1,this.a=()=>{try{this.f=D()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.$Gg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Hg=ue;async function le(L,D,U){let H;for(let V=0;V<U;V++)try{return await L()}catch(z){H=z,await i(D)}throw H}e.$Ig=le;class K{hasPending(D){return this.a?typeof D=="number"?this.a.taskId===D:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(D,U,H){return this.a={taskId:D,cancel:()=>H?.(),promise:U},U.then(()=>this.d(D),()=>this.d(D)),U}d(D){this.a&&D===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const D=this.b;this.b=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this.b)this.b.run=D;else{let U,H;const V=new Promise((z,B)=>{U=z,H=B});this.b={run:D,promise:V,promiseResolve:U,promiseReject:H}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Jg=K;class Y{constructor(D,U=()=>Date.now()){this.d=D,this.f=U,this.a=0,this.b=0}increment(){const D=this.f();return D-this.a>this.d&&(this.a=D,this.b=0),this.b++,this.b}}e.$Kg=Y;var N;(function(L){L[L.Resolved=0]="Resolved",L[L.Rejected=1]="Rejected"})(N||(N={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((D,U)=>{this.a=D,this.b=U})}complete(D){return new Promise(U=>{this.a(D),this.d={outcome:0,value:D},U()})}error(D){return new Promise(U=>{this.b(D),this.d={outcome:1,value:D},U()})}cancel(){return this.error(new C.$2)}}e.$Lg=W;var T;(function(L){async function D(H){let V;const z=await Promise.all(H.map(B=>B.then(X=>X,X=>{V||(V=X)})));if(typeof V<"u")throw V;return z}L.settled=D;function U(H){return new Promise(async(V,z)=>{try{await H(V,z)}catch(B){z(B)}})}L.withAsyncBody=U})(T||(e.Promises=T={}));var J;(function(L){L[L.Initial=0]="Initial",L[L.DoneOK=1]="DoneOK",L[L.DoneError=2]="DoneError"})(J||(J={}));class Q{static fromArray(D){return new Q(U=>{U.emitMany(D)})}static fromPromise(D){return new Q(async U=>{U.emitMany(await D)})}static fromPromises(D){return new Q(async U=>{await Promise.all(D.map(async H=>U.emitOne(await H)))})}static merge(D){return new Q(async U=>{await Promise.all(D.map(async H=>{for await(const V of H)U.emitOne(V)}))})}constructor(D){this.a=0,this.b=[],this.d=null,this.f=new r.$5c,queueMicrotask(async()=>{const U={emitOne:H=>this.g(H),emitMany:H=>this.h(H),reject:H=>this.k(H)};try{await Promise.resolve(D(U)),this.j()}catch(H){this.k(H)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let D=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(D<this.b.length)return{done:!1,value:this.b[D++]};if(this.a===1)return{done:!0,value:void 0};await r.Event.toPromise(this.f.event)}while(!0)}}}static map(D,U){return new Q(async H=>{for await(const V of D)H.emitOne(U(V))})}map(D){return Q.map(this,D)}static filter(D,U){return new Q(async H=>{for await(const V of D)U(V)&&H.emitOne(V)})}filter(D){return Q.filter(this,D)}static coalesce(D){return Q.filter(D,U=>!!U)}coalesce(){return Q.coalesce(this)}static async toPromise(D){const U=[];for await(const H of D)U.push(H);return U}toPromise(){return Q.toPromise(this)}g(D){this.a===0&&(this.b.push(D),this.f.fire())}h(D){this.a===0&&(this.b=this.b.concat(D),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(D){this.a===0&&(this.a=2,this.d=D,this.f.fire())}}e.$Mg=Q,Q.EMPTY=Q.fromArray([]);class ae extends Q{constructor(D,U){super(U),this.l=D}cancel(){this.l.cancel()}}e.$Ng=ae;function oe(L){const D=new E.$bd,U=L(D.token);return new ae(D,async H=>{const V=D.token.onCancellationRequested(()=>{V.dispose(),D.dispose(),H.reject(new C.$2)});try{for await(const z of U){if(D.token.isCancellationRequested)return;H.emitOne(z)}V.dispose(),D.dispose()}catch(z){V.dispose(),D.dispose(),H.reject(z)}})}e.$Og=oe}),define(ee[104],te([0,1,24,8,32,35,9,3,25]),function(G,e,E,C,r,O,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0;function l(){return Object.create(null)}e.$8i=l,e.$9i="**",e.$0i="/";const m="[/\\\\]",d="[^/\\\\]",p=/\//g;function h(Y,N){switch(Y){case 0:return"";case 1:return`${d}*?`;default:return`(?:${m}|${d}+${m}${N?`|${m}${d}+`:""})*?`}}function y(Y,N){if(!Y)return[];const W=[];let T=!1,J=!1,Q="";for(const ae of Y){switch(ae){case N:if(!T&&!J){W.push(Q),Q="";continue}break;case"{":T=!0;break;case"}":T=!1;break;case"[":J=!0;break;case"]":J=!1;break}Q+=ae}return Q&&W.push(Q),W}e.$$i=y;function b(Y){if(!Y)return"";let N="";const W=y(Y,e.$0i);if(W.every(T=>T===e.$9i))N=".*";else{let T=!1;W.forEach((J,Q)=>{if(J===e.$9i){if(T)return;N+=h(2,Q===W.length-1)}else{let ae=!1,oe="",L=!1,D="";for(const U of J){if(U!=="}"&&ae){oe+=U;continue}if(L&&(U!=="]"||!D)){let H;U==="-"?H=U:(U==="^"||U==="!")&&!D?H="^":U===e.$0i?H="":H=(0,f.$ld)(U),D+=H;continue}switch(U){case"{":ae=!0;continue;case"[":L=!0;continue;case"}":{const V=`(?:${y(oe,",").map(z=>b(z)).join("|")})`;N+=V,ae=!1,oe="";break}case"]":{N+="["+D+"]",L=!1,D="";break}case"?":N+=d;continue;case"*":N+=h(1);continue;default:N+=(0,f.$ld)(U)}}Q<W.length-1&&(W[Q+1]!==e.$9i||Q+2<W.length)&&(N+=m)}T=J===e.$9i})}return N}const o=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$mi(1e4),u=function(){return!1},s=function(){return null};function i(Y,N){if(!Y)return s;let W;typeof Y!="string"?W=Y.pattern:W=Y,W=W.trim();const T=`${W}_${!!N.trimForExclusions}`;let J=t.get(T);if(J)return n(J,Y);let Q;return o.test(W)?J=$(W.substr(4),W):(Q=g.exec(c(W,N)))?J=R(Q[1],W):(N.trimForExclusions?v:a).test(W)?J=I(W,N):(Q=k.exec(c(W,N)))?J=S(Q[1].substr(1),W,!0):(Q=w.exec(c(W,N)))?J=S(Q[1],W,!1):J=M(W),t.set(T,J),n(J,Y)}function n(Y,N){if(typeof N=="string")return Y;const W=function(T,J){return(0,r.$He)(T,N.base,!P.$k)?Y((0,f.$pd)(T.substr(N.base.length),A.sep),J):null};return W.allBasenames=Y.allBasenames,W.allPaths=Y.allPaths,W.basenames=Y.basenames,W.patterns=Y.patterns,W}function c(Y,N){return N.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function $(Y,N){return function(W,T){return typeof W=="string"&&W.endsWith(Y)?N:null}}function R(Y,N){const W=`/${Y}`,T=`\\${Y}`,J=function(ae,oe){return typeof ae!="string"?null:oe?oe===Y?N:null:ae===Y||ae.endsWith(W)||ae.endsWith(T)?N:null},Q=[Y];return J.basenames=Q,J.patterns=[N],J.allBasenames=Q,J}function I(Y,N){const W=le(Y.slice(1,-1).split(",").map(oe=>i(oe,N)).filter(oe=>oe!==s),Y),T=W.length;if(!T)return s;if(T===1)return W[0];const J=function(oe,L){for(let D=0,U=W.length;D<U;D++)if(W[D](oe,L))return Y;return null},Q=W.find(oe=>!!oe.allBasenames);Q&&(J.allBasenames=Q.allBasenames);const ae=W.reduce((oe,L)=>L.allPaths?oe.concat(L.allPaths):oe,[]);return ae.length&&(J.allPaths=ae),J}function S(Y,N,W){const T=A.sep===A.$8b.sep,J=T?Y:Y.replace(p,A.sep),Q=A.sep+J,ae=A.$8b.sep+Y;let oe;return W?oe=function(L,D){return typeof L=="string"&&(L===J||L.endsWith(Q)||!T&&(L===Y||L.endsWith(ae)))?N:null}:oe=function(L,D){return typeof L=="string"&&(L===J||!T&&L===Y)?N:null},oe.allPaths=[(W?"*/":"./")+Y],oe}function M(Y){try{const N=new RegExp(`^${b(Y)}$`);return function(W){return N.lastIndex=0,typeof W=="string"&&N.test(W)?Y:null}}catch{return s}}function j(Y,N,W){return!Y||typeof N!="string"?!1:F(Y)(N,void 0,W)}e.$_i=j;function F(Y,N={}){if(!Y)return u;if(typeof Y=="string"||q(Y)){const W=i(Y,N);if(W===s)return u;const T=function(J,Q){return!!W(J,Q)};return W.allBasenames&&(T.allBasenames=W.allBasenames),W.allPaths&&(T.allPaths=W.allPaths),T}return ne(Y,N)}e.$aj=F;function q(Y){const N=Y;return N?typeof N.base=="string"&&typeof N.pattern=="string":!1}e.$bj=q;function re(Y){return Y.allBasenames||[]}e.$cj=re;function ie(Y){return Y.allPaths||[]}e.$dj=ie;function ne(Y,N){const W=le(Object.getOwnPropertyNames(Y).map(oe=>ue(oe,Y[oe],N)).filter(oe=>oe!==s)),T=W.length;if(!T)return s;if(!W.some(oe=>!!oe.requiresSiblings)){if(T===1)return W[0];const oe=function(U,H){let V;for(let z=0,B=W.length;z<B;z++){const X=W[z](U,H);if(typeof X=="string")return X;(0,C.$eg)(X)&&(V||(V=[]),V.push(X))}return V?(async()=>{for(const z of V){const B=await z;if(typeof B=="string")return B}return null})():null},L=W.find(U=>!!U.allBasenames);L&&(oe.allBasenames=L.allBasenames);const D=W.reduce((U,H)=>H.allPaths?U.concat(H.allPaths):U,[]);return D.length&&(oe.allPaths=D),oe}const J=function(oe,L,D){let U,H;for(let V=0,z=W.length;V<z;V++){const B=W[V];B.requiresSiblings&&D&&(L||(L=(0,A.$cc)(oe)),U||(U=L.substr(0,L.length-(0,A.$dc)(oe).length)));const X=B(oe,L,U,D);if(typeof X=="string")return X;(0,C.$eg)(X)&&(H||(H=[]),H.push(X))}return H?(async()=>{for(const V of H){const z=await V;if(typeof z=="string")return z}return null})():null},Q=W.find(oe=>!!oe.allBasenames);Q&&(J.allBasenames=Q.allBasenames);const ae=W.reduce((oe,L)=>L.allPaths?oe.concat(L.allPaths):oe,[]);return ae.length&&(J.allPaths=ae),J}function ue(Y,N,W){if(N===!1)return s;const T=i(Y,W);if(T===s)return s;if(typeof N=="boolean")return T;if(N){const J=N.when;if(typeof J=="string"){const Q=(ae,oe,L,D)=>{if(!D||!T(ae,oe))return null;const U=J.replace("$(basename)",()=>L),H=D(U);return(0,C.$eg)(H)?H.then(V=>V?Y:null):H?Y:null};return Q.requiresSiblings=!0,Q}}return T}function le(Y,N){const W=Y.filter(oe=>!!oe.basenames);if(W.length<2)return Y;const T=W.reduce((oe,L)=>{const D=L.basenames;return D?oe.concat(D):oe},[]);let J;if(N){J=[];for(let oe=0,L=T.length;oe<L;oe++)J.push(N)}else J=W.reduce((oe,L)=>{const D=L.patterns;return D?oe.concat(D):oe},[]);const Q=function(oe,L){if(typeof oe!="string")return null;if(!L){let U;for(U=oe.length;U>0;U--){const H=oe.charCodeAt(U-1);if(H===47||H===92)break}L=oe.substr(U)}const D=T.indexOf(L);return D!==-1?J[D]:null};Q.basenames=T,Q.patterns=J,Q.allBasenames=T;const ae=Y.filter(oe=>!oe.basenames);return ae.push(Q),ae}function K(Y,N){return(0,E.$$e)(Y,N,(W,T)=>typeof W=="string"&&typeof T=="string"?W===T:typeof W!="string"&&typeof T!="string"?W.base===T.base&&W.pattern===T.pattern:!1)}e.$ej=K}),define(ee[46],te([0,1,24,32,9,3,19,25]),function(G,e,E,C,r,O,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wz=e.$Vz=e.$Uz=e.$Tz=e.$Sz=e.$Rz=e.$Qz=e.$Pz=e.$Oz=e.$Nz=void 0;function f(i,n){const{os:c,tildify:$,relative:R}=n;if(R){const M=l(i,R,c);if(typeof M=="string")return M}let I=i.fsPath;if(c===1&&!O.$i?I=I.replace(/\//g,"\\"):c!==1&&O.$i&&(I=I.replace(/\\/g,"/")),c!==1&&$?.userHome){const M=$.userHome.fsPath;let j;i.scheme!==$.userHome.scheme&&i.path.startsWith(r.$8b.sep)?j=$.userHome.with({path:i.path}).fsPath:j=i.fsPath,I=p(j,M,c)}return(c===1?r.$7b:r.$8b).normalize(m(I,c===1))}e.$Nz=f;function l(i,n,c){const $=c===1?r.$7b:r.$8b,R=c===3?A.$Vf:A.$Xf,I=n.getWorkspace(),S=(0,E.$sf)(I.folders);if(!S)return;i.scheme!==S.uri.scheme&&i.path.startsWith(r.$8b.sep)&&(i=S.uri.with({path:i.path}));const M=n.getWorkspaceFolder(i);if(!M)return;let j;if(R.isEqual(M.uri,i)?j="":j=R.relativePath(M.uri,i)??"",j&&(j=$.normalize(j)),I.folders.length>1&&!n.noPrefix){const F=M.name?M.name:R.basenameOrAuthority(M.uri);j=j?`${F} \u2022 ${j}`:F}return j}function m(i,n=O.$i){return(0,C.$Le)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$Oz=m;let d=Object.create(null);function p(i,n,c=O.OS){if(c===1||!i||!n)return i;let $=d.original===n?d.normalized:void 0;$||($=n,O.$i&&($=(0,C.$Be)($)),$=`${(0,P.$qd)($,r.$8b.sep)}${r.$8b.sep}`,d={original:n,normalized:$});let R=i;return O.$i&&(R=(0,C.$Be)(R)),(c===3?R.startsWith($):(0,P.$Kd)(R,$))?`~/${R.substr($.length)}`:i}e.$Pz=p;function h(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$Qz=h;const y="\u2026",b="\\\\",o="~";function g(i,n=r.sep){const c=new Array(i.length);let $=!1;for(let R=0;R<i.length;R++){const I=i[R];if(I===""){c[R]=`.${n}`;continue}if(!I){c[R]=I;continue}$=!0;let S="",M=I;M.indexOf(b)===0?(S=M.substr(0,M.indexOf(b)+b.length),M=M.substr(M.indexOf(b)+b.length)):M.indexOf(n)===0?(S=M.substr(0,M.indexOf(n)+n.length),M=M.substr(M.indexOf(n)+n.length)):M.indexOf(o)===0&&(S=M.substr(0,M.indexOf(o)+o.length),M=M.substr(M.indexOf(o)+o.length));const j=M.split(n);for(let F=1;$&&F<=j.length;F++)for(let q=j.length-F;$&&q>=0;q--){$=!1;let re=j.slice(q,q+F).join(n);for(let ie=0;!$&&ie<i.length;ie++)if(ie!==R&&i[ie]&&i[ie].indexOf(re)>-1){const ne=q+F===j.length,ue=q>0&&i[ie].indexOf(n)>-1?n+re:re,le=i[ie].endsWith(ue);$=!ne||le}if(!$){let ie="";(j[0].endsWith(":")||S!=="")&&(q===1&&(q=0,F++,re=j[0]+n+re),q>0&&(ie=j[0]+n),ie=S+ie),q>0&&(ie=ie+y+n),ie=ie+re,q+F<j.length&&(ie=ie+n+y),c[R]=ie}}$&&(c[R]=I)}return c}e.$Rz=g;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function v(i,n=Object.create(null)){const c=[];let $=!1,R="";for(const I of i)if(I==="$"||$&&I==="{")R&&c.push({value:R,type:a.TEXT}),R="",$=!0;else if(I==="}"&&$){const S=n[R];if(typeof S=="string")S.length&&c.push({value:S,type:a.VARIABLE});else if(S){const M=c[c.length-1];(!M||M.type!==a.SEPARATOR)&&c.push({value:S.label,type:a.SEPARATOR})}R="",$=!1}else R+=I;return R&&!$&&c.push({value:R,type:a.TEXT}),c.filter((I,S)=>{if(I.type===a.SEPARATOR){const M=c[S-1],j=c[S+1];return[M,j].every(F=>F&&(F.type===a.VARIABLE||F.type===a.TEXT)&&F.value.length>0)}return!0}).map(I=>I.value).join("")}e.$Sz=v;function k(i,n){return O.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.$Tz=k;function w(i,n){return O.$j||n?i.replace(/\(&&\w\)|&&/g,""):O.$i?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$Uz=w;function t(i){return i.replace(/&/g,"&&")}e.$Vz=t;function u(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const c=s(i.substring(0,n));return{name:c.name,parentPath:c.parentPath+i.substring(n)}}}return s(i)}e.$Wz=u;function s(i){const n=i.indexOf("/")!==-1?r.$8b:r.$7b,c=n.basename(i),$=n.dirname(i);return c.length?{name:c,parentPath:$}:{name:$,parentPath:""}}}),define(ee[153],te([0,1,17,7]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=e.$lm=e.$km=e.$jm=void 0;function r(d){return d.toJSON()}class O{constructor(p){this.a=p}transformIncoming(p){const h=this.a.transformIncoming(p);return h===p?p:r(C.URI.from(h))}transformOutgoing(p){const h=this.a.transformOutgoing(p);return h===p?p:r(C.URI.from(h))}transformOutgoingURI(p){const h=this.a.transformOutgoing(p);return h===p?p:C.URI.from(h)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$jm=O,e.$km=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function A(d,p,h){if(!d||h>200)return null;if(typeof d=="object"){if(d instanceof C.URI)return p.transformOutgoing(d);for(const y in d)if(Object.hasOwnProperty.call(d,y)){const b=A(d[y],p,h+1);b!==null&&(d[y]=b)}}return null}function P(d,p){const h=A(d,p,0);return h===null?d:h}e.$lm=P;function f(d,p,h,y){if(!d||y>200)return null;if(typeof d=="object"){if(d.$mid===1)return h?C.URI.revive(p.transformIncoming(d)):p.transformIncoming(d);if(d instanceof E.$Ib)return null;for(const b in d)if(Object.hasOwnProperty.call(d,b)){const o=f(d[b],p,h,y+1);o!==null&&(d[b]=o)}}return null}function l(d,p){const h=f(d,p,!1,0);return h===null?d:h}e.$mm=l;function m(d,p){const h=f(d,p,!0,0);return h===null?d:h}e.$nm=m}),define(ee[22],te([0,1,42,27,154,8,32,84,9,3,19,7]),function(G,e,E,C,r,O,A,P,f,l,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function h(ne,ue=p.UNLINK,le){if((0,A.$Ke)(ne))throw new Error("rimraf - will refuse to recursively delete root");return ue===p.UNLINK?b(ne):y(ne,le)}async function y(ne,ue=(0,A.$Pe)((0,C.tmpdir)())){try{try{await E.promises.rename(ne,ue)}catch(le){return le.code==="ENOENT"?void 0:b(ne)}b(ue).catch(le=>{})}catch(le){if(le.code!=="ENOENT")throw le}}async function b(ne){return(0,r.promisify)(E.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function o(ne){if((0,A.$Ke)(ne))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=o;async function g(ne,ue){return k(await(ue?a(ne):(0,r.promisify)(E.readdir)(ne)))}async function a(ne){try{return await(0,r.promisify)(E.readdir)(ne,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const ue=[],le=await g(ne);for(const K of le){let Y=!1,N=!1,W=!1;try{const T=await e.Promises.lstat((0,f.$$b)(ne,K));Y=T.isFile(),N=T.isDirectory(),W=T.isSymbolicLink()}catch(T){console.warn("[node.js fs] unexpected error from lstat after readdir: ",T)}ue.push({name:K,isFile:()=>Y,isDirectory:()=>N,isSymbolicLink:()=>W})}return ue}function v(ne){return k(E.readdirSync(ne))}e.readdirSync=v;function k(ne){return ne.map(ue=>typeof ue=="string"?l.$j?(0,P.$3k)(ue):ue:(ue.name=l.$j?(0,P.$3k)(ue.name):ue.name,ue))}async function w(ne){const ue=await g(ne),le=[];for(const K of ue)await u.existsDirectory((0,f.$$b)(ne,K))&&le.push(K);return le}function t(ne,ue=1e3){return new Promise(le=>{let K=!1;const Y=setInterval(()=>{K||(K=!0,E.access(ne,N=>{K=!1,N&&(clearInterval(Y),le(void 0))}))},ue)})}e.whenDeleted=t;var u;(function(ne){async function ue(Y){let N;try{if(N=await e.Promises.lstat(Y),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(l.$i&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(T){if(T.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw T}throw W}}ne.stat=ue;async function le(Y){try{const{stat:N,symbolicLink:W}=await ne.stat(Y);return N.isFile()&&W?.dangling!==!0}catch{}return!1}ne.existsFile=le;async function K(Y){try{const{stat:N,symbolicLink:W}=await ne.stat(Y);return N.isDirectory()&&W?.dangling!==!0}catch{}return!1}ne.existsDirectory=K})(u||(e.SymlinkSupport=u={}));const s=new O.$zg;function i(ne,ue,le){return s.queueFor(d.URI.file(ne),m.$Wf).queue(()=>{const K=I(le);return new Promise((Y,N)=>$(ne,ue,K,W=>W?N(W):Y()))})}let n=!0;function c(ne){n=ne}e.configureFlushOnWrite=c;function $(ne,ue,le,K){if(!n)return E.writeFile(ne,ue,{mode:le.mode,flag:le.flag},K);E.open(ne,le.flag,le.mode,(Y,N)=>{if(Y)return K(Y);E.writeFile(N,ue,W=>{if(W)return E.close(N,()=>K(W));E.fdatasync(N,T=>(T&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",T),c(!1)),E.close(N,J=>K(J))))})})}function R(ne,ue,le){const K=I(le);if(!n)return E.writeFileSync(ne,ue,{mode:K.mode,flag:K.flag});const Y=E.openSync(ne,K.flag,K.mode);try{E.writeFileSync(Y,ue);try{E.fdatasyncSync(Y)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),c(!1)}}finally{E.closeSync(Y)}}e.writeFileSync=R;function I(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function S(ne,ue){if(ne!==ue)try{await e.Promises.rename(ne,ue)}catch(le){if(ne.toLowerCase()!==ue.toLowerCase()&&le.code==="EXDEV"||ne.endsWith("."))await M(ne,ue,{preserveSymlinks:!1}),await h(ne,p.MOVE);else throw le}}async function M(ne,ue,le){return F(ne,ue,{root:{source:ne,target:ue},options:le,handledSourcePaths:new Set})}const j=511;async function F(ne,ue,le){if(le.handledSourcePaths.has(ne))return;le.handledSourcePaths.add(ne);const{stat:K,symbolicLink:Y}=await u.stat(ne);if(Y){if(le.options.preserveSymlinks)try{return await ie(ne,ue,le)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(Y.dangling)return}return K.isDirectory()?q(ne,ue,K.mode&j,le):re(ne,ue,K.mode&j)}async function q(ne,ue,le,K){await e.Promises.mkdir(ue,{recursive:!0,mode:le});const Y=await g(ne);for(const N of Y)await F((0,f.$$b)(ne,N),(0,f.$$b)(ue,N),K)}async function re(ne,ue,le){await e.Promises.copyFile(ne,ue),await e.Promises.chmod(ue,le)}async function ie(ne,ue,le){let K=await e.Promises.readlink(ne);(0,A.$He)(K,le.root.source,!l.$k)&&(K=(0,f.$$b)(le.root.target,K.substr(le.root.source.length+1))),await e.Promises.symlink(K,ue)}e.Promises=new class{get access(){return(0,r.promisify)(E.access)}get stat(){return(0,r.promisify)(E.stat)}get lstat(){return(0,r.promisify)(E.lstat)}get utimes(){return(0,r.promisify)(E.utimes)}get read(){return(ne,ue,le,K,Y)=>new Promise((N,W)=>{E.read(ne,ue,le,K,Y,(T,J,Q)=>T?W(T):N({bytesRead:J,buffer:Q}))})}get readFile(){return(0,r.promisify)(E.readFile)}get write(){return(ne,ue,le,K,Y)=>new Promise((N,W)=>{E.write(ne,ue,le,K,Y,(T,J,Q)=>T?W(T):N({bytesWritten:J,buffer:Q}))})}get appendFile(){return(0,r.promisify)(E.appendFile)}get fdatasync(){return(0,r.promisify)(E.fdatasync)}get truncate(){return(0,r.promisify)(E.truncate)}get rename(){return(0,r.promisify)(E.rename)}get copyFile(){return(0,r.promisify)(E.copyFile)}get open(){return(0,r.promisify)(E.open)}get close(){return(0,r.promisify)(E.close)}get symlink(){return(0,r.promisify)(E.symlink)}get readlink(){return(0,r.promisify)(E.readlink)}get chmod(){return(0,r.promisify)(E.chmod)}get mkdir(){return(0,r.promisify)(E.mkdir)}get unlink(){return(0,r.promisify)(E.unlink)}get rmdir(){return(0,r.promisify)(E.rmdir)}get realpath(){return(0,r.promisify)(E.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return w}get writeFile(){return i}get rm(){return h}get move(){return S}get copy(){return M}}}),define(ee[105],te([0,1,42,9,3,25,22]),function(G,e,E,C,r,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=void 0;function P(p){if(r.$k)return p;const h=(0,C.$bc)(p);if(p===h)return p;const y=((0,C.$cc)(p)||p).toLowerCase();try{const o=(0,A.readdirSync)(h).filter(g=>g.toLowerCase()===y);if(o.length===1){const g=P(h);if(g)return(0,C.$$b)(g,o[0])}else if(o.length>1){const g=o.indexOf(y);if(g>=0){const a=P(h);if(a)return(0,C.$$b)(a,o[g])}}}catch{}return null}e.$Fp=P;async function f(p){if(r.$k)return p;const h=(0,C.$bc)(p);if(p===h)return p;const y=((0,C.$cc)(p)||p).toLowerCase();try{const o=(await A.Promises.readdir(h)).filter(g=>g.toLowerCase()===y);if(o.length===1){const g=await f(h);if(g)return(0,C.$$b)(g,o[0])}else if(o.length>1){const g=o.indexOf(y);if(g>=0){const a=await f(h);if(a)return(0,C.$$b)(a,o[g])}}}catch{}return null}e.$Gp=f;async function l(p){try{return await A.Promises.realpath(p)}catch{const y=d(p);return await A.Promises.access(y,E.constants.R_OK),y}}e.$Hp=l;function m(p){try{return E.realpathSync(p)}catch{const y=d(p);return E.accessSync(y,E.constants.R_OK),y}}e.$Ip=m;function d(p){return(0,O.$qd)((0,C.$9b)(p),C.sep)}}),define(ee[106],te([0,1,27,9,22]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=void 0;const O=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var f;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(f||(f={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class d{constructor(w,t,u){this.exePath=w,this.displayName=t,this.a=u}async exists(){return this.a===void 0&&(this.a=await r.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:k=!1}={}){return k?l===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:k=!1,findPreview:w=!1}={}){const t=p({useAlternateBitness:k});if(!t)return null;const u=C.$$b(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(u))return null;let s=-1,i=null;for(const $ of await r.Promises.readdir(u)){let R=-1;if(w){const S=$.indexOf("-");if(S<0)continue;const M=$.substring(0,S);if(!O.test(M)||$.substring(S+1)!=="preview")continue;R=parseInt(M,10)}else{if(!O.test($))continue;R=parseInt($,10)}if(R<=s)continue;const I=C.$$b(u,$,"pwsh.exe");await r.SymlinkSupport.existsFile(I)&&(i=I,s=R)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",c=w?" Preview":"";return new d(i,`PowerShell${c}${n}`,!0)}async function y({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const w=C.$$b(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(w))return null;const{pwshMsixDirRegex:t,pwshMsixName:u}=k?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const s of await r.Promises.readdir(w))if(t.test(s)){const i=C.$$b(w,s,"pwsh.exe");return new d(i,u)}return null}function b(){const k=C.$$b(E.homedir(),".dotnet","tools","pwsh.exe");return new d(k,".NET Core PowerShell Global Tool")}function o(){const k=C.$$b(process.env.windir,l===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new d(k,"Windows PowerShell",!0)}async function*g(){let k=await h();k&&(yield k),k=await h({useAlternateBitness:!0}),k&&(yield k),k=await y(),k&&(yield k),k=b(),k&&(yield k),k=await h({findPreview:!0}),k&&(yield k),k=await y({findPreview:!0}),k&&(yield k),k=await h({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=o(),k&&(yield k)}async function*a(){for await(const k of g())await k.exists()&&(yield k)}e.$_k=a;async function v(){for await(const k of a())return k;return null}e.$al=v}),define(ee[88],te([0,1,9,3,36,72,11,22]),function(G,e,E,C,r,O,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$el=e.$dl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function f(d=r.env){return d.comspec||"cmd.exe"}e.$dl=f;function l(d){let p=[],h=!1;const y=function(b){if(h){p.push(b);return}(!d.send(b,g=>{if(g&&console.error(g),h=!1,p.length>0){const a=p.slice(0);p=[],a.forEach(v=>y(v))}})||C.$i)&&(h=!0)};return{send:y}}e.$el=l;var m;(function(d){async function p(h,y,b){if(E.$0b(h))return h;if(y===void 0&&(y=r.cwd()),E.$bc(h)!=="."||(b===void 0&&A.$ge(r.env.PATH)&&(b=r.env.PATH.split(E.$ic)),b===void 0||b.length===0))return E.$$b(y,h);async function g(a){if(await P.Promises.exists(a)){let v;try{v=await P.Promises.stat(a)}catch(k){k.message.startsWith("EACCES")&&(v=await P.Promises.lstat(a))}return v?!v.isDirectory():!1}return!1}for(const a of b){let v;if(E.$0b(a)?v=E.$$b(a,h):v=E.$$b(y,a,h),await g(v))return v;let k=v+".com";if(await g(k)||(k=v+".exe",await g(k)))return k}return E.$$b(y,h)}d.findExecutable=p})(m||(e.win32=m={}))}),define(ee[107],te([0,1,47,15]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;function r(A){return new Promise((P,f)=>{let l;const m=new Map;function d(h,y,b,o,g){const a=m.get(y);if(h===A||a){const v={name:p(b),cmd:b,pid:h,ppid:y,load:o,mem:g};m.set(h,v),h===A&&(l=v),a&&(a.children||(a.children=[]),a.children.push(v),a.children.length>1&&(a.children=a.children.sort((k,w)=>k.pid-w.pid)))}}function p(h){const y=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,o=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,a=/conhost\.exe.+--headless/i,v=/--type=([a-zA-Z-]+)/;if(o.exec(h))return"electron-crash-reporter";if(g.exec(h))return"winpty-agent";if(a.exec(h))return"conpty-agent";let k=v.exec(h);if(k&&k.length===2)return k[1]==="renderer"?"window":k[1]==="utility"?y.exec(h)?"utility-network-service":"utility-process":k[1]==="extensionHost"?"extension-host":k[1];const w=/[a-zA-Z-]+\.js/g;let t="";do k=w.exec(h),k&&(t+=k+" ");while(k);return t&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${t})`:b.exec(h)?`electron-nodejs (${h})`:h}if(process.platform==="win32"){const h=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,b)=>{G(["@vscode/windows-process-tree"],y,b)}).then(y=>{y.getProcessList(A,b=>{if(!b){f(new Error(`Root process ${A} not found`));return}y.getProcessCpuUsage(b,o=>{const g=new Map;o.forEach(a=>{const v=h(a.commandLine||"");g.set(a.pid,{name:p(v),cmd:v,pid:a.pid,ppid:a.ppid,load:a.cpu||0,mem:a.memory||0})}),l=g.get(A),l?(g.forEach(a=>{const v=g.get(a.ppid);v&&(v.children||(v.children=[]),v.children.push(a))}),g.forEach(a=>{a.children&&(a.children=a.children.sort((v,k)=>v.pid-k.pid))}),P(l)):f(new Error(`Root process ${A} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let h=function(){let y=[l];const b=[];for(;y.length;){const g=y.shift();g&&(b.push(g.pid),g.children&&(y=y.concat(g.children)))}let o=JSON.stringify(C.$1e.asFileUri("vs/base/node/cpuUsage.sh").fsPath);o+=" "+b.join(" "),(0,E.exec)(o,{},(g,a,v)=>{if(g||v)f(g||new Error(v.toString()));else{const k=a.toString().split(`
`);for(let w=0;w<b.length;w++){const t=m.get(b[w]);t.load=parseFloat(k[w])}if(!l){f(new Error(`Root process ${A} not found`));return}P(l)}})};(0,E.exec)("which ps",{},(y,b,o)=>{if(y||o)if(process.platform!=="linux")f(y||new Error(o.toString()));else{const g=JSON.stringify(C.$1e.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(g,{},(a,v,k)=>{a||k?f(a||new Error(k.toString())):(O(v,d),h())})}else{const g=b.toString().trim(),a="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${g} ${a}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,k,w)=>{v||w&&!w.includes("screen size is bogus")?f(v||new Error(w.toString())):(O(k,d),process.platform==="linux"?h():l?P(l):f(new Error(`Root process ${A} not found`)))})}})}})}e.$br=r;function O(A,P){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=A.toString().split(`
`);for(const m of l){const d=f.exec(m.trim());d&&d.length===6&&P(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}}),define(ee[155],te([0,1,27,3,106,88]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=void 0;async function A(d,p){return d===1?C.$i?m():O.$dl(p):f(d,p)}e.$fl=A;let P=null;function f(d,p){if(C.$k&&d===2||C.$j&&d===3)return"/bin/bash";if(!P){let h;if(C.$i)h="/bin/bash";else{if(h=p.SHELL,!h)try{h=(0,E.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}P=h}return P}let l=null;async function m(){return l||(l=(await(0,r.$al)()).exePath),l}});var pe=this&&this.__decorate||function(G,e,E,C){var r=arguments.length,O=r<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,E):C,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(G,e,E,C);else for(var P=G.length-1;P>=0;P--)(A=G[P])&&(O=(r<3?A(O):r>3?A(e,E,O):A(e,E))||O);return r>3&&O&&Object.defineProperty(e,E,O),O};define(ee[43],te([0,1,24,8,17,21,55,13,4,2,73,25,11]),function(G,e,E,C,r,O,A,P,f,l,m,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.ProxyChannel=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.RequestInitiator=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=void 0;var h;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(h||(h={}));function y(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(b||(b={}));function o(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(g||(g={}));function a(N){let W=0;for(let T=0;;T+=7){const J=N.read(1);if(W|=(J.buffer[0]&127)<<T,!(J.buffer[0]&128))return W}}const v=s(0);function k(N,W){if(W===0){N.write(v);return}let T=0;for(let Q=W;Q!==0;Q=Q>>>7)T++;const J=r.$Ib.alloc(T);for(let Q=0;W!==0;Q++)J.buffer[Q]=W&127,W=W>>>7,W>0&&(J.buffer[Q]|=128);N.write(J)}class w{constructor(W){this.b=W,this.a=0}read(W){const T=this.b.slice(this.a,this.a+W);return this.a+=T.byteLength,T}}e.$Vg=w;class t{constructor(){this.a=[]}get buffer(){return r.$Ib.concat(this.a)}write(W){this.a.push(W)}}e.$Wg=t;var u;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object",N[N.Int=6]="Int"})(u||(u={}));function s(N){const W=r.$Ib.alloc(1);return W.writeUInt8(N,0),W}const i={Undefined:s(u.Undefined),String:s(u.String),Buffer:s(u.Buffer),VSBuffer:s(u.VSBuffer),Array:s(u.Array),Object:s(u.Object),Uint:s(u.Int)},n=typeof Buffer<"u";function c(N,W){if(typeof W>"u")N.write(i.Undefined);else if(typeof W=="string"){const T=r.$Ib.fromString(W);N.write(i.String),k(N,T.byteLength),N.write(T)}else if(n&&Buffer.isBuffer(W)){const T=r.$Ib.wrap(W);N.write(i.Buffer),k(N,T.byteLength),N.write(T)}else if(W instanceof r.$Ib)N.write(i.VSBuffer),k(N,W.byteLength),N.write(W);else if(Array.isArray(W)){N.write(i.Array),k(N,W.length);for(const T of W)c(N,T)}else if(typeof W=="number"&&(W|0)===W)N.write(i.Uint),k(N,W);else{const T=r.$Ib.fromString(JSON.stringify(W));N.write(i.Object),k(N,T.byteLength),N.write(T)}}e.$Xg=c;function $(N){switch(N.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return N.read(a(N)).toString();case u.Buffer:return N.read(a(N)).buffer;case u.VSBuffer:return N.read(a(N));case u.Array:{const T=a(N),J=[];for(let Q=0;Q<T;Q++)J.push($(N));return J}case u.Object:return JSON.parse(N.read(a(N)).toString());case u.Int:return a(N)}}e.$Yg=$;class R{constructor(W,T,J=null,Q=1e3){this.h=W,this.j=T,this.k=J,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(W,T){this.b.set(W,T),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const T=this.o([W.type]);this.k?.logOutgoing(T,0,1,o(W.type));return}case 201:case 202:case 204:case 203:{const T=this.o([W.type,W.id],W.data);this.k?.logOutgoing(T,W.id,1,o(W.type),W.data);return}}}o(W,T=void 0){const J=new t;return c(J,W),c(J,T),this.p(J.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const T=new w(W),J=$(T),Q=$(T),ae=J[0];switch(ae){case 100:return this.k?.logIncoming(W.byteLength,J[1],1,`${y(ae)}: ${J[2]}.${J[3]}`,Q),this.s({type:ae,id:J[1],channelName:J[2],name:J[3],arg:Q});case 102:return this.k?.logIncoming(W.byteLength,J[1],1,`${y(ae)}: ${J[2]}.${J[3]}`,Q),this.t({type:ae,id:J[1],channelName:J[2],name:J[3],arg:Q});case 101:return this.k?.logIncoming(W.byteLength,J[1],1,`${y(ae)}`),this.u({type:ae,id:J[1]});case 103:return this.k?.logIncoming(W.byteLength,J[1],1,`${y(ae)}`),this.u({type:ae,id:J[1]})}}s(W){const T=this.b.get(W.channelName);if(!T){this.v(W);return}const J=new O.$bd;let Q;try{Q=T.call(this.j,W.name,W.arg,J.token)}catch(L){Q=Promise.reject(L)}const ae=W.id;Q.then(L=>{this.m({id:ae,data:L,type:201}),this.d.delete(W.id)},L=>{L instanceof Error?this.m({id:ae,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.m({id:ae,data:L,type:203}),this.d.delete(W.id)});const oe=(0,l.$ib)(()=>J.cancel());this.d.set(W.id,oe)}t(W){const T=this.b.get(W.channelName);if(!T){this.v(W);return}const J=W.id,ae=T.listen(this.j,W.name,W.arg)(oe=>this.m({id:J,data:oe,type:204}));this.d.set(W.id,ae)}u(W){const T=this.d.get(W.id);T&&(T.dispose(),this.d.delete(W.id))}v(W){let T=this.g.get(W.channelName);T||(T=[],this.g.set(W.channelName,T));const J=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);T.push({request:W,timeoutTimer:J})}w(W){const T=this.g.get(W);if(T){for(const J of T)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$fb)(this.d.values()),this.d.clear()}}e.$Zg=R;var I;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class S{constructor(W,T=null){this.l=W,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$5c,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=T}getChannel(W){const T=this;return{call(J,Q,ae){return T.a?Promise.reject(new P.$2):T.m(W,J,Q,ae)},listen(J,Q){return T.a?f.Event.None:T.o(W,J,Q)}}}m(W,T,J,Q=O.CancellationToken.None){const ae=this.g++,L={id:ae,type:100,channelName:W,name:T,arg:J};if(Q.isCancellationRequested)return Promise.reject(new P.$2);let D;return new Promise((H,V)=>{if(Q.isCancellationRequested)return V(new P.$2);const z=()=>{const ce=ge=>{switch(ge.type){case 201:this.f.delete(ae),H(ge.data);break;case 202:{this.f.delete(ae);const Ie=new Error(ge.data.message);Ie.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,Ie.name=ge.data.name,V(Ie);break}case 203:this.f.delete(ae),V(ge.data);break}};this.f.set(ae,ce),this.p(L)};let B=null;this.b===g.Idle?z():(B=(0,C.$fg)(ce=>this.u()),B.then(()=>{B=null,z()}));const X=()=>{B?(B.cancel(),B=null):this.p({id:ae,type:101}),V(new P.$2)},se=Q.onCancellationRequested(X);D=(0,l.$hb)((0,l.$ib)(X),se),this.d.add(D)}).finally(()=>{this.d.delete(D)})}o(W,T,J){const Q=this.g++,oe={id:Q,type:102,channelName:W,name:T,arg:J};let L=null;const D=new f.$5c({onWillAddFirstListener:()=>{L=(0,C.$fg)(H=>this.u()),L.then(()=>{L=null,this.d.add(D),this.p(oe)})},onDidRemoveLastListener:()=>{L?(L.cancel(),L=null):(this.d.delete(D),this.p({id:Q,type:103}))}}),U=H=>D.fire(H.data);return this.f.set(Q,U),D.event}p(W){switch(W.type){case 100:case 102:{const T=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(T,W.id,0,`${y(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const T=this.q([W.type,W.id]);this.j?.logOutgoing(T,W.id,0,y(W.type));return}}}q(W,T=void 0){const J=new t;return c(J,W),c(J,T),this.r(J.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const T=new w(W),J=$(T),Q=$(T),ae=J[0];switch(ae){case 200:return this.j?.logIncoming(W.byteLength,0,0,o(ae)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,J[1],0,o(ae),Q),this.t({type:J[0],id:J[1],data:Q})}}t(W){if(W.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$fb)(this.d.values()),this.d.clear()}}e.$1g=S,pe([A.$Pg],S.prototype,"onDidInitializePromise",null);class M{get connections(){const W=[];return this.f.forEach(T=>W.push(T)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new f.$5c,this.onDidAddConnection=this.g.event,this.h=new f.$5c,this.onDidRemoveConnection=this.h.event,W(({protocol:T,onDidClientDisconnect:J})=>{f.Event.once(T.onMessage)(ae=>{const oe=new w(ae),L=$(oe),D=new R(T,L),U=new S(T);this.a.forEach((V,z)=>D.registerChannel(z,V));const H={channelServer:D,channelClient:U,ctx:L};this.f.add(H),this.g.fire(H),J(()=>{D.dispose(),U.dispose(),this.f.delete(H),this.h.fire(H)})})})}getChannel(W,T){const J=this;return{call(Q,ae,oe){let L;if((0,p.$ue)(T)){const U=(0,E.$Hf)(J.connections.filter(T));L=U?Promise.resolve(U):f.Event.toPromise(f.Event.filter(J.onDidAddConnection,T))}else L=T.routeCall(J,Q,ae);const D=L.then(U=>U.channelClient.getChannel(W));return F(D).call(Q,ae,oe)},listen(Q,ae){if((0,p.$ue)(T))return J.j(W,T,Q,ae);const oe=T.routeEvent(J,Q,ae).then(L=>L.channelClient.getChannel(W));return F(oe).listen(Q,ae)}}}j(W,T,J,Q){const ae=this;let oe=new l.$jb;const L=new f.$5c({onWillAddFirstListener:()=>{oe=new l.$jb;const D=new f.$$c,U=new Map,H=z=>{const X=z.channelClient.getChannel(W).listen(J,Q),se=D.add(X);U.set(z,se)},V=z=>{const B=U.get(z);B&&(B.dispose(),U.delete(z))};ae.connections.filter(T).forEach(H),f.Event.filter(ae.onDidAddConnection,T)(H,void 0,oe),ae.onDidRemoveConnection(V,void 0,oe),D.event(L.fire,L,oe),oe.add(D)},onDidRemoveLastListener:()=>{oe.dispose()}});return L.event}registerChannel(W,T){this.a.set(W,T),this.f.forEach(J=>{J.channelServer.registerChannel(W,T)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$2g=M;class j{constructor(W,T,J=null){const Q=new t;c(Q,T),W.send(Q.buffer),this.a=new S(W,J),this.d=new R(W,T,J)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,T){this.d.registerChannel(W,T)}dispose(){this.a.dispose(),this.d.dispose()}}e.$3g=j;function F(N){return{call(W,T,J){return N.then(Q=>Q.call(W,T,J))},listen(W,T){const J=new f.$ad;return N.then(Q=>J.input=Q.listen(W,T)),J.event}}}e.$4g=F;function q(N){let W=!1;return{call(T,J,Q){return W?N.call(T,J,Q):(0,C.$sg)(0).then(()=>W=!0).then(()=>N.call(T,J,Q))},listen(T,J){if(W)return N.listen(T,J);const Q=new f.$ad;return(0,C.$sg)(0).then(()=>W=!0).then(()=>Q.input=N.listen(T,J)),Q.event}}}e.$5g=q;class re{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const T of W.connections)if(await Promise.resolve(this.a(T.ctx)))return Promise.resolve(T);return await f.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$6g=re;var ie;(function(N){function W(ae,oe){const L=ae,D=oe&&oe.disableMarshalling,U=new Map;for(const H in L)J(H)&&U.set(H,f.Event.buffer(L[H],!0));return new class{listen(H,V,z){const B=U.get(V);if(B)return B;if(Q(V)){const X=L[V];if(typeof X=="function")return X.call(L,z)}throw new Error(`Event not found: ${V}`)}call(H,V,z){const B=L[V];if(typeof B=="function"){if(!D&&Array.isArray(z))for(let X=0;X<z.length;X++)z[X]=(0,m.$Ug)(z[X]);return B.apply(L,z)}throw new Error(`Method not found: ${V}`)}}}N.fromService=W;function T(ae,oe){const L=oe&&oe.disableMarshalling;return new Proxy({},{get(D,U){if(typeof U=="string")return oe?.properties?.has(U)?oe.properties.get(U):Q(U)?function(H){return ae.listen(U,H)}:J(U)?ae.listen(U):async function(...H){let V;oe&&!(0,p.$pe)(oe.context)?V=[oe.context,...H]:V=H;const z=await ae.call(U,V);return L?z:(0,m.$Ug)(z)};throw new Error(`Property not found: ${String(U)}`)}})}N.toService=T;function J(ae){return ae[0]==="o"&&ae[1]==="n"&&d.$Id(ae.charCodeAt(2))}function Q(ae){return/^onDynamic/.test(ae)&&d.$Id(ae.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const W=N.toString();if(W!=="[object Object]")return W}return N}function le(N){return Array.isArray(N)?N.map(ue):ue(N)}function K(N,W,T,J,Q,ae,oe){oe=le(oe);const L=ne[Q],D=L[J%L.length];let U=[`%c[${N}]%c[${String(W).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${D}`];/\($/.test(ae)?(U=U.concat(oe),U.push(")")):U.push(oe),console.log.apply(console,U)}class Y{constructor(W,T){this.d=W,this.f=T,this.a=0,this.b=0}logOutgoing(W,T,J,Q,ae){this.b+=W,K(this.d,this.b,W,T,J,Q,ae)}logIncoming(W,T,J,Q,ae){this.a+=W,K(this.f,this.a,W,T,J,Q,ae)}}e.$7g=Y}),define(ee[156],te([0,1,17,4,43]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WR=e.$VR=void 0;class O{constructor(f){this.a=f,this.onMessage=C.Event.fromDOMEventEmitter(this.a,"message",l=>E.$Ib.wrap(l.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$VR=O;class A extends r.$3g{constructor(f,l){const m=new O(f);super(m,l),this.b=m}dispose(){this.b.disconnect()}}e.$WR=A}),define(ee[108],te([0,1,17,4,2,43]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_g=e.$$g=e.$0g=e.$9g=e.ProtocolConstants=e.$8g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let c=0;function $(I,S){if(!n.has(I)){const M=String(++c);n.set(I,M)}return n.get(I)}function R(I,S,M,j){if(!i.enableDiagnostics)return;const F=$(I,S);if(j instanceof E.$Ib||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const q=E.$Ib.alloc(j.byteLength);q.set(j),i.records.push({timestamp:Date.now(),id:F,label:S,type:M,buff:q})}else i.records.push({timestamp:Date.now(),id:F,label:S,type:M,data:j})}i.traceSocketEvent=R})(P||(e.SocketDiagnostics=P={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let l=null;function m(){return l||(l=E.$Ib.alloc(0)),l}class d{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,c){if(n===0)return m();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const S=this.a[0];return c&&(this.a.shift(),this.b-=n),S}if(this.a[0].byteLength>n){const S=this.a[0].slice(0,n);return c&&(this.a[0]=this.a[0].slice(n),this.b-=n),S}const $=E.$Ib.alloc(n);let R=0,I=0;for(;n>0;){const S=this.a[I];if(S.byteLength>n){const M=S.slice(0,n);$.set(M,R),R+=n,c&&(this.a[I]=S.slice(n),this.b-=n),n-=n}else $.set(S,R),R+=S.byteLength,c?(this.a.shift(),this.b-=S.byteLength):I++,n-=S.byteLength}return $}}e.$8g=d;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function h(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class b{constructor(n,c,$,R){this.type=n,this.id=c,this.ack=$,this.data=R,this.writtenTime=0}get size(){return this.data.byteLength}}class o extends r.$kb{constructor(n){super(),this.f=this.B(new C.$5c),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new d,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,R=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new b($,R,I,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=E.$Ib.alloc(13);c.writeUInt8(n.type,0),c.writeUInt32BE(n.id,1),c.writeUInt32BE(n.ack,5),c.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(c,n.data)}g(n,c){const $=this.f===0;return this.d.push(n,c),this.f+=n.byteLength+c.byteLength,$}h(){const n=E.$Ib.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,c){this.g(n,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class a extends r.$kb{constructor(n){super(),this.f=new C.$5c,this.onMessage=this.f.event,this.g=new C.$5c,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new g(this.a)),this.c=this.B(new o(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new b(1,0,0,n))}}e.$9g=a;class v extends O.$3g{static fromSocket(n,c){return new v(new a(n),c)}get onDidDispose(){return this.b.onDidDispose}constructor(n,c,$=null){super(n,c,$),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$0g=v;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.$5c({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$$g=k;class w{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,c=this.a;for(;c;)c=c.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let c=0,$=this.a;for(;$;)n[c++]=$.data,$=$.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const c=new w(n);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class u{static getInstance(){return u.b||(u.b=new u),u.b}constructor(){this.c=[];const n=Date.now();for(let c=0;c<u.a;c++)this.c[c]=n-1e3*c;setInterval(()=>{for(let c=u.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),c=(1+u.a)*1e3;let $=0;for(let R=0;R<u.a;R++)n-this.c[R]<=c&&$++;return 1-$/u.a}hasHighLoad(){return this.d()>=.5}}u.a=10,u.b=null;class s{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new k,this.onControlMessage=this.u.event,this.v=new k,this.onMessage=this.v.event,this.w=new k,this.onDidDispose=this.w.event,this.x=new k,this.onSocketClose=this.x.event,this.y=new k,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??u.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new r.$jb,this.o=n.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new o(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new b(5,0,0,m());this.p.write(n),this.p.flush()}sendPause(){const n=new b(7,0,0,m());this.p.write(n)}sendResume(){const n=new b(8,0,0,m());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,c){this.a=!0,this.r.dispose(),this.r=new r.$jb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new o(this.o)),this.r.add(this.q.onMessage($=>this.z($))),this.r.add(this.o.onClose($=>this.x.fire($))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new b(3,0,this.h,m());this.p.write(n);const c=this.b.toArray();for(let $=0,R=c.length;$<R;$++)this.p.write(c[$]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const c=this.b.peek();if(c&&c.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new b(6,0,0,m())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const c=this.b.toArray();for(let $=0,R=c.length;$<R;$++)this.p.write(c[$]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const c=++this.c;this.h=this.g;const $=new b(1,c,this.h,n);this.b.push($),this.a||(this.p.write($),this.B())}sendControl(n){const c=new b(2,0,0,n);this.p.write(c)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),c=Date.now()-n.writtenTime,$=Date.now()-this.q.lastReadTime,R=Date.now()-this.n;if(c>=2e4&&$>=2e4&&R>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:$});return}const I=Math.max(2e4-c,2e4-$,2e4-R,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new b(3,0,this.h,m());this.p.write(n)}D(){this.h=this.g;const n=new b(9,0,this.h,m());this.p.write(n)}}e.$_g=s}),define(ee[157],te([0,1,38,17,4,2,43,144]),function(G,e,E,C,r,O,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZR=void 0;function f(m,d){const p=r.Event.fromNodeEventEmitter(E.$SR,d,(y,b)=>({event:y,message:b})),h=r.Event.filter(p,({event:y})=>y.sender.id===m);return r.Event.map(h,({message:y})=>y&&C.$Ib.wrap(y))}class l extends A.$2g{static d(){const d=r.Event.fromNodeEventEmitter(E.$SR,"vscode:hello",({sender:p})=>p);return r.Event.map(d,p=>{const h=p.id;l.b.get(h)?.dispose();const b=new r.$5c;l.b.set(h,(0,O.$ib)(()=>b.fire()));const o=f(h,"vscode:message"),g=r.Event.any(r.Event.signal(f(h,"vscode:disconnect")),b.event);return{protocol:new P.$YR(p,o),onDidClientDisconnect:g}})}constructor(){super(l.d())}}e.$ZR=l,l.b=new Map}),define(ee[109],te([0,1,38,4,31,156]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2R=e.$1R=void 0;class A extends O.$WR{constructor(l,m){super({addEventListener:(d,p)=>l.addListener(d,p),removeEventListener:(d,p)=>l.removeListener(d,p),postMessage:d=>l.postMessage(d),start:()=>l.start(),close:()=>l.close()},m)}}e.$1R=A;async function P(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,r.$3e)();f.webContents.send("vscode:createMessageChannel",l);const m=C.Event.fromNodeEventEmitter(E.$SR,"vscode:createMessageChannelResult",(p,h)=>({nonce:h,port:p.ports[0]})),{port:d}=await C.Event.toPromise(C.Event.once(C.Event.filter(m,p=>p.nonce===l)));return d}e.$2R=P}),define(ee[158],te([0,1,47,8,17,21,152,13,4,2,37,88,72,43]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=void 0;class y extends h.$Zg{constructor(g){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",a=>r.$Ib.wrap(Buffer.from(a,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$Cp=y;class b{constructor(g,a){this.i=g,this.j=a,this.c=new Set,this.g=new Map,this.h=new f.$5c,this.onDidProcessExit=this.h.event;const v=a&&a.timeout?a.timeout:6e4;this.b=new C.$og(v),this.d=null,this.f=null}getChannel(g){const a=this;return{call(v,k,w){return a.k(g,v,k,w)},listen(v,k){return a.l(g,v,k)}}}k(g,a,v,k=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(P.$3());this.b.cancel();const w=this.n(g),t=(0,C.$fg)(i=>w.call(a,v,i)),u=k.onCancellationRequested(()=>t.cancel()),s=(0,l.$ib)(()=>t.cancel());return this.c.add(s),t.finally(()=>{u.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,a,v){if(!this.b)return f.Event.None;this.b.cancel();let k;const w=new f.$5c({onWillAddFirstListener:()=>{k=this.n(g).listen(a,v)(w.fire,w),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return w.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],a=Object.create(null);a.env={...(0,m.$Dm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(a.env={...a.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(a.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,p.$cl)(a.env),this.d=(0,E.fork)(this.i,g,a);const v=new f.$5c;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,A.$yp)(n)){(0,A.log)(n,`IPC Library: ${this.j.serverName}`);return}v.fire(r.$Ib.wrap(Buffer.from(n,"base64")))});const w=this.j.useQueue?(0,d.$el)(this.d):this.d,t=n=>this.d&&this.d.connected&&w.send(n.buffer.toString("base64")),u=v.event,s={send:t,onMessage:u};this.f=new h.$1g(s);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,c)=>{process.removeListener("exit",i),this.c.forEach($=>(0,l.$fb)($)),this.c.clear(),n!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:c})})}return this.f}n(g){let a=this.g.get(g);return a||(a=this.m.getChannel(g),this.g.set(g,a)),a}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Dp=b}),define(ee[110],te([0,1,8,4,2,73,11]),function(G,e,E,C,r,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.StorageState=e.$Bo=e.StorageHint=void 0;var P;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function f(p){const h=p;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$Bo=f;var l;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(l||(e.StorageState=l={}));class m extends r.$kb{constructor(h,y=Object.create(null)){super(),this.m=h,this.n=y,this.b=this.B(new C.$8c),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=new E.$pg(m.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(h=>this.r(h)))}r(h){this.b.pause();try{h.changed?.forEach((y,b)=>this.s(b,y)),h.deleted?.forEach(y=>this.s(y,void 0))}finally{this.b.resume()}}s(h,y){if(this.c===l.Closed)return;let b=!1;(0,A.$pe)(y)?b=this.f.delete(h):this.f.get(h)!==y&&(this.f.set(h,y),b=!0),b&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.n.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(h,y){const b=this.f.get(h);return(0,A.$pe)(b)?y:b}getBoolean(h,y){const b=this.get(h);return(0,A.$pe)(b)?y:b==="true"}getNumber(h,y){const b=this.get(h);return(0,A.$pe)(b)?y:parseInt(b,10)}getObject(h,y){const b=this.get(h);return(0,A.$pe)(b)?y:(0,O.$Tg)(b)}async set(h,y,b=!1){if(this.c===l.Closed)return;if((0,A.$pe)(y))return this.delete(h,b);const o=(0,A.$ie)(y)||Array.isArray(y)?(0,O.$Sg)(y):String(y);if(this.f.get(h)!==o)return this.f.set(h,o),this.j.set(h,o),this.h.delete(h),this.b.fire({key:h,external:b}),this.w()}async delete(h,y=!1){if(!(this.c===l.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:y}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=l.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(h).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(h){if(this.u)return this.w(h)}async w(h){return this.g.trigger(()=>this.v(),h)}async whenFlushed(){if(this.u)return new Promise(h=>this.l.push(h))}isInMemory(){return this.n.hint===P.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Co=m,m.a=100;class d{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((y,b)=>this.a.set(b,y)),h.delete?.forEach(y=>this.a.delete(y))}async close(){}}e.$Do=d}),define(ee[159],te([0,1,8,4,35,9,22]),function(G,e,E,C,r,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mS=void 0;class P{get onDidChangeItemsExternal(){return C.Event.None}constructor(m,d=Object.create(null)){this.g=m,this.h=d,this.c=(0,O.$cc)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const m=await this.f,d=new Map;return(await this.s(m,"SELECT * FROM ItemTable")).forEach(h=>d.set(h.key,h.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${d.size} rows`),d}async updateItems(m){const d=await this.f;return this.j(d,m)}j(m,d){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${d.insert?(0,r.$hi)(d.insert):"0"}), delete(${d.delete?(0,r.$ii)(d.delete):"0"})`),this.t(m,()=>{const p=d.insert,h=d.delete;if(p&&p.size>0){const y=[];y.push([]);let b=0;p.forEach((o,g)=>{let a=y[b];a.length>P.b&&(b++,a=[],y.push(a)),a.push(g,o)}),y.forEach(o=>{this.u(m,`INSERT INTO ItemTable VALUES ${new Array(o.length/2).fill("(?,?)").join(",")}`,g=>g.run(o),()=>{const g=[];let a=0;return p.forEach((v,k)=>{g.push(k),a+=v.length}),`Keys: ${g.join(", ")} Length: ${a}`})})}if(h&&h.size){const y=[];y.push([]);let b=0;h.forEach(o=>{let g=y[b];g.length>P.b&&(b++,g=[],y.push(g)),g.push(o)}),y.forEach(o=>{this.u(m,`DELETE FROM ItemTable WHERE key IN (${new Array(o.length).fill("?").join(",")})`,g=>g.run(o),()=>{const g=[];return h.forEach(a=>{g.push(a)}),`Keys: ${g.join(", ")}`})})}})}async close(m){this.d.trace(`[storage ${this.c}] close()`);const d=await this.f;return this.k(d,m)}k(m,d){return new Promise((p,h)=>{m.db.close(y=>(y&&this.o(m,`[storage ${this.c}] close(): ${y}`),this.g===P.IN_MEMORY_PATH?p():!m.isErroneous&&!m.isInMemory?this.l().then(p,b=>(this.d.error(`[storage ${this.c}] backup(): ${b}`),p())):typeof d=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(b=>{const o=()=>this.k(b,void 0);return this.j(b,{insert:d()}).then(()=>o(),g=>(o(),Promise.reject(g)))})).then(p,h):h(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const m=this.m(this.g);return A.Promises.copy(this.g,m,{preserveSymlinks:!1})}m(m){return`${m}.backup`}async checkIntegrity(m){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${m})`);const d=await this.f,p=await this.r(d,m?"PRAGMA integrity_check":"PRAGMA quick_check"),h=m?p.integrity_check:p.quick_check;return d.isErroneous?`${h} (last error: ${d.lastError})`:d.isInMemory?`${h} (in-memory!)`:h}async n(m,d=!0){this.d.trace(`[storage ${this.c}] open(${m}, retryOnBusy: ${d})`);try{return await this.p(m)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&d)return await(0,E.$sg)(P.a),this.n(m,!1);try{await A.Promises.unlink(m);try{await A.Promises.rename(this.m(m),m)}catch{}return await this.p(m)}catch(h){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${h}`),this.p(P.IN_MEMORY_PATH)}}}o(m,d){m.isErroneous=!0,m.lastError=d,this.d.error(d)}p(m){return new Promise((d,p)=>{new Promise((h,y)=>{G(["@vscode/sqlite3"],h,y)}).then(h=>{const y={db:new(this.d.isTracing?h.verbose().Database:h.Database)(m,b=>b?y.db&&b.code!=="SQLITE_CANTOPEN"?y.db.close(()=>p(b)):p(b):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>d(y),o=>y.db.close(()=>p(o)))),isInMemory:m===P.IN_MEMORY_PATH};y.db.on("error",b=>this.o(y,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&y.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},p)})}q(m,d){return new Promise((p,h)=>{m.db.exec(d,y=>y?(this.o(m,`[storage ${this.c}] exec(): ${y}`),h(y)):p())})}r(m,d){return new Promise((p,h)=>{m.db.get(d,(y,b)=>y?(this.o(m,`[storage ${this.c}] get(): ${y}`),h(y)):p(b))})}s(m,d){return new Promise((p,h)=>{m.db.all(d,(y,b)=>y?(this.o(m,`[storage ${this.c}] all(): ${y}`),h(y)):p(b))})}t(m,d){return new Promise((p,h)=>{m.db.serialize(()=>{m.db.run("BEGIN TRANSACTION"),d(),m.db.run("END TRANSACTION",y=>y?(this.o(m,`[storage ${this.c}] transaction(): ${y}`),h(y)):p())})})}u(m,d,p,h){const y=m.db.prepare(d),b=o=>{this.o(m,`[storage ${this.c}] prepare(): ${o} (${d}). Details: ${h()}`)};y.on("error",b),p(y),y.finalize(o=>{o&&b(o),y.removeListener("error",b)})}}e.$mS=P,P.IN_MEMORY_PATH=":memory:",P.a=2e3,P.b=256;class f{constructor(m){m&&typeof m.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.a=m.logTrace),m&&typeof m.logError=="function"&&(this.b=m.logError)}get isTracing(){return!!this.a}trace(m){this.a?.(m)}error(m){this.b?.(m)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[160],te([12,10]),function(G,e){return G.create("vs/code/electron-main/app",e)}),define(ee[161],te([12,10]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[162],te([12,10]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ee[163],te([12,10]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ee[164],te([12,10]),function(G,e){return G.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[165],te([12,10]),function(G,e){return G.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[166],te([12,10]),function(G,e){return G.create("vs/platform/environment/node/argv",e)}),define(ee[167],te([12,10]),function(G,e){return G.create("vs/platform/environment/node/argvHelper",e)}),define(ee[168],te([12,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[169],te([12,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[170],te([12,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[171],te([12,10]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[172],te([12,10]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[173],te([12,10]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ee[174],te([12,10]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ee[175],te([12,10]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ee[176],te([12,10]),function(G,e){return G.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[177],te([12,10]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[178],te([12,10]),function(G,e){return G.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[179],te([12,10]),function(G,e){return G.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[180],te([12,10]),function(G,e){return G.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[181],te([12,10]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ee[182],te([12,10]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ee[183],te([12,10]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[184],te([12,10]),function(G,e){return G.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ee[185],te([12,10]),function(G,e){return G.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ee[186],te([12,10]),function(G,e){return G.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[187],te([12,10]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[188],te([12,10]),function(G,e){return G.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[189],te([12,10]),function(G,e){return G.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[190],te([12,10]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ee[191],te([12,10]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[192],te([12,10]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[193],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b_=e.$a_=void 0;function E(r){return r&&r.hasOwnProperty("folderUri")}e.$a_=E;function C(r){return r&&r.hasOwnProperty("workspace")}e.$b_=C}),define(ee[194],te([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i2b=e.$h2b=e.$g2b=void 0;function C(A){return typeof A?.backupFolder=="string"}e.$g2b=C;function r(A){let P=[];try{Array.isArray(A.workspaces)&&(P=A.workspaces.map(f=>({workspace:{id:f.id,configPath:E.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return P}e.$h2b=r;function O(A){let P=[];try{Array.isArray(A.folders)&&(P=A.folders.map(f=>({folderUri:E.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return P}e.$i2b=O}),define(ee[195],te([0,1,13,163]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.TokenType=void 0;var r;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(r||(e.TokenType=r={}));function O(...l){switch(l.length){case 1:return(0,C.localize)(0,null,l[0]);case 2:return(0,C.localize)(1,null,l[0],l[1]);case 3:return(0,C.localize)(2,null,l[0],l[1],l[2]);default:return}}const A=(0,C.localize)(3,null),P=(0,C.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return m.isTripleEq?"===":"==";case 4:return m.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return m.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return m.lexeme;case 18:return m.lexeme;case 19:return m.lexeme;case 20:return"EOF";default:throw(0,E.$5)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(m){return this.c=m,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const d=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:d})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const d=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:d})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(m){return this.r()||this.c.charCodeAt(this.e)!==m?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(m){this.f.push({type:m,offset:this.d})}l(m){const d=this.d,p=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:p};this.g.push({offset:d,lexeme:p,additionalInfo:m}),this.f.push(h)}n(){this.m.lastIndex=this.d;const m=this.m.exec(this.c);if(m){this.e=this.d+m[0].length;const d=this.c.substring(this.d,this.e),p=f.b.get(d);p?this.k(p):this.f.push({type:17,lexeme:d,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let m=this.e,d=!1,p=!1;for(;;){if(m>=this.c.length){this.e=m,this.l(P);return}const y=this.c.charCodeAt(m);if(d)d=!1;else if(y===47&&!p){m++;break}else y===91?p=!0:y===92?d=!0:y===93&&(p=!1);m++}for(;m<this.c.length&&f.a.has(this.c.charCodeAt(m));)m++;this.e=m;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$oi=f,f.a=new Set(["i","g","s","m","y","u"].map(l=>l.charCodeAt(0))),f.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(ee[196],te([0,1,4,2]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=void 0;class r{constructor(){this.a=new E.$5c,this.b=new E.$5c,this.c=new E.$5c,this.d=new E.$5c}call(P,f,l){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(P,f,l){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$on=r,r.ChannelName="extensionhostdebugservice";class O extends C.$kb{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,f,l){this.b.call("attach",[P,f,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,f){this.b.call("terminate",[P,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,f){return this.b.call("openExtensionDevelopmentHostWindow",[P,f])}}e.$pn=O}),define(ee[197],te([0,1,147,55,15,9,36,19,7]),function(G,e,E,C,r,O,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,O.$bc)(r.$1e.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,O.$$b)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,P.$6f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.$6f)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,E.$Ol)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$$b)(this.userDataPath,"logs",h)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$6f)(f.URI.file((0,O.$$b)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$6f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$6f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$6f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=A.env.VSCODE_PORTABLE;return h?f.URI.file((0,O.$$b)(h,"argv.json")):(0,P.$6f)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,O.$$b)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,O.$_b)(h):(0,O.$9b)((0,O.$$b)(r.$1e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?f.URI.file((0,O.$_b)(h)):f.URI.file((0,O.$$b)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,O.$_b)(h);const y=A.env.VSCODE_EXTENSIONS;if(y)return y;const b=A.env.VSCODE_PORTABLE;return b?(0,O.$$b)(b,"extensions"):(0,P.$6f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(y=>/^[^:/?#]+?:\/\//.test(y)?f.URI.parse(y):f.URI.file((0,O.$9b)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?f.URI.parse(h):f.URI.file((0,O.$9b)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Pl.test(h))}get extensionLogLevel(){const h=[];for(const y of this.args.log||[]){const b=e.$Pl.exec(y);b&&b[1]&&b[2]&&h.push([b[1],b[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,P.$6f)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=A.env.VSCODE_PORTABLE;return h?f.URI.file((0,O.$$b)(h,"policy.json")):(0,P.$6f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,y,b){this.a=h,this.b=y,this.c=b,this.editSessionId=this.args.editSessionId}}e.$Ql=l,pe([C.$Pg],l.prototype,"appRoot",null),pe([C.$Pg],l.prototype,"userHome",null),pe([C.$Pg],l.prototype,"userDataPath",null),pe([C.$Pg],l.prototype,"appSettingsHome",null),pe([C.$Pg],l.prototype,"tmpDir",null),pe([C.$Pg],l.prototype,"cacheHome",null),pe([C.$Pg],l.prototype,"stateResource",null),pe([C.$Pg],l.prototype,"userRoamingDataHome",null),pe([C.$Pg],l.prototype,"userDataSyncHome",null),pe([C.$Pg],l.prototype,"sync",null),pe([C.$Pg],l.prototype,"machineSettingsResource",null),pe([C.$Pg],l.prototype,"workspaceStorageHome",null),pe([C.$Pg],l.prototype,"localHistoryHome",null),pe([C.$Pg],l.prototype,"keyboardLayoutResource",null),pe([C.$Pg],l.prototype,"argvResource",null),pe([C.$Pg],l.prototype,"isExtensionDevelopment",null),pe([C.$Pg],l.prototype,"untitledWorkspacesHome",null),pe([C.$Pg],l.prototype,"builtinExtensionsPath",null),pe([C.$Pg],l.prototype,"extensionsPath",null),pe([C.$Pg],l.prototype,"extensionDevelopmentLocationURI",null),pe([C.$Pg],l.prototype,"extensionDevelopmentKind",null),pe([C.$Pg],l.prototype,"extensionTestsLocationURI",null),pe([C.$Pg],l.prototype,"debugExtensionHost",null),pe([C.$Pg],l.prototype,"logLevel",null),pe([C.$Pg],l.prototype,"extensionLogLevel",null),pe([C.$Pg],l.prototype,"serviceMachineIdResource",null),pe([C.$Pg],l.prototype,"disableTelemetry",null),pe([C.$Pg],l.prototype,"disableWorkspaceTrust",null),pe([C.$Pg],l.prototype,"policyFile",null);function m(p,h){return d(p["inspect-extensions"],p["inspect-brk-extensions"],5870,h,p.debugId,p.extensionEnvironment)}e.$Rl=m;function d(p,h,y,b,o,g){const v=Number(h||p)||(b?null:y),k=v?!!h:!1;let w;if(g)try{w=JSON.parse(g)}catch{}return{port:v,break:k,debugId:o,env:w}}e.$Sl=d}),define(ee[111],te([0,1,306,3,166]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.$il=e.$hl=e.$gl=void 0;const O={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.$gl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(33,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(b,o,g=A){const a=b.find(c=>c.length>0&&c[0]!=="-"),v={},k=["_"],w=[],t={};let u;for(const c in o){const $=o[c];$.type==="subcommand"?c===a&&(u=$):($.alias&&(v[c]=$.alias),$.type==="string"||$.type==="string[]"?(k.push(c),$.deprecates&&k.push(...$.deprecates)):$.type==="boolean"&&(w.push(c),$.deprecates&&w.push(...$.deprecates)),$.global&&(t[c]=$))}if(u&&a){const c=t;for(const S in u.options)c[S]=u.options[S];const $=b.filter(S=>S!==a),R=g.getSubcommandReporter?g.getSubcommandReporter(a):void 0,I=P($,c,R);return{[a]:I,_:[]}}const s=E(b,{string:k,boolean:w,alias:v}),i={},n=s;i._=s._.map(c=>String(c)).filter(c=>c.length>0),delete n._;for(const c in o){const $=o[c];if($.type==="subcommand")continue;$.alias&&delete n[$.alias];let R=n[c];if($.deprecates)for(const I of $.deprecates)n.hasOwnProperty(I)&&(R||(R=n[I],R&&g.onDeprecatedOption(I,$.deprecationMessage||(0,r.localize)(36,null,c))),delete n[I]);if(typeof R<"u"){if($.type==="string[]"){if(Array.isArray(R)||(R=[R]),!$.allowEmptyValue){const I=R.filter(S=>S.length>0);I.length!==R.length&&(g.onEmptyValue(c),R=I.length>0?I:void 0)}}else $.type==="string"&&(Array.isArray(R)?(R=R.pop(),g.onMultipleValues(c,R)):!R&&!$.allowEmptyValue&&(g.onEmptyValue(c),R=void 0));i[c]=R,$.deprecationMessage&&g.onDeprecatedOption(c,$.deprecationMessage)}delete n[c]}for(const c in n)g.onUnknownOption(c);return i}e.$hl=P;function f(b,o){let g="";return o.args&&(Array.isArray(o.args)?g=` <${o.args.join("> <")}>`:g=` <${o.args}>`),o.alias?`-${o.alias} --${b}${g}`:`--${b}${g}`}function l(b,o){const g=[];for(const a in b){const v=b[a],k=f(a,v);g.push([k,v.description])}return m(g,o)}e.$il=l;function m(b,o){const a=b.reduce((w,t)=>Math.max(w,t[0].length),12)+2+1;if(o-a<25)return b.reduce((w,t)=>w.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const v=o-a-1,k=[];for(const w of b){const t=w[0],u=p(w[1],v),s=d(a-t.length-2);k.push("  "+t+s+u[0]);for(let i=1;i<u.length;i++)k.push(d(a)+u[i])}return k}function d(b){return" ".repeat(b)}function p(b,o){const g=[];for(;b.length;){const a=b.length<o?b.length:b.lastIndexOf(" ",o),v=b.slice(0,a).trim();b=b.slice(a),g.push(v)}return g}function h(b,o,g,a,v){const k=process.stdout.isTTY&&process.stdout.columns||80,w=v?.noInputFiles!==!0?`[${(0,r.localize)(37,null)}...]`:"",t=[`${b} ${g}`];t.push(""),t.push(`${(0,r.localize)(38,null)}: ${o} [${(0,r.localize)(39,null)}]${w}`),t.push(""),v?.noPipe!==!0&&(C.$i?t.push((0,r.localize)(40,null,o)):t.push((0,r.localize)(41,null,o)),t.push(""));const u={},s=[];for(const i in a){const n=a[i];if(n.type==="subcommand")n.description&&s.push({command:i,description:n.description});else if(n.description&&n.cat){let c=u[n.cat];c||(u[n.cat]=c={}),c[i]=n}}for(const i in u){const n=i,c=u[n];c&&(t.push(O[n]),t.push(...l(c,k)),t.push(""))}return s.length&&(t.push((0,r.localize)(42,null)),t.push(...m(s.map(i=>[i.command,i.description]),k)),t.push("")),t.join(`
`)}e.$jl=h;function y(b,o){return`${b||(0,r.localize)(43,null)}
${o||(0,r.localize)(44,null)}
${process.arch}`}e.$kl=y}),define(ee[198],te([0,1,87,196,111]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r2b=void 0;class O extends C.$on{constructor(P){super(),this.f=P}call(P,f,l){return f==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(P,f,l)}async g(P,f){const l=(0,r.$hl)(P,r.$gl);l.debugRenderer=f;const m=l.extensionDevelopmentPath;if(!m)return{success:!1};const[d]=await this.f.openExtensionDevelopmentHostWindow(m,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!f)return{success:!0};const p=d.win;if(!p)return{success:!0};const h=p.webContents.debugger;let y=h.isAttached()?1/0:0;const b=(0,E.createServer)(o=>{y++===0&&h.attach();let g=!1;const a=w=>{g||o.write(JSON.stringify(w)+"\0")},v=(w,t,u,s)=>a({method:t,params:u,sessionId:s});p.on("close",()=>{h.removeListener("message",v),o.end(),g=!0}),h.addListener("message",v);let k=Buffer.alloc(0);o.on("data",w=>{k=Buffer.concat([k,w]);for(let t=k.indexOf(0);t!==-1;t=k.indexOf(0)){let u;try{const s=k.slice(0,t).toString("utf8");k=k.slice(t+1),u=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}h.sendCommand(u.method,u.params,u.sessionId).then(s=>a({id:u.id,sessionId:u.sessionId,result:s})).catch(s=>a({id:u.id,sessionId:u.sessionId,error:{code:0,message:s.message}}))}}),o.on("error",w=>{console.error("error on cdp pipe:",w)}),o.on("close",()=>{g=!0,--y===0&&h.detach()})});return await new Promise(o=>b.listen(0,o)),p.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.$r2b=O}),define(ee[63],te([0,1,307,167,111]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ol=e.$nl=e.$ml=e.$ll=void 0;function O(d,p){const h=(v,k)=>{console.warn((0,C.localize)(0,null,v,k))},y=v=>{console.warn((0,C.localize)(1,null,v))},b=(v,k)=>{console.warn((0,C.localize)(2,null,v,k))},o=v=>({onUnknownOption:k=>{v!=="tunnel"&&console.warn((0,C.localize)(3,null,k,v))},onMultipleValues:h,onEmptyValue:y,onDeprecatedOption:b,getSubcommandReporter:v!=="tunnel"?o:void 0}),g={onUnknownOption:v=>{console.warn((0,C.localize)(4,null,v))},onMultipleValues:h,onEmptyValue:y,onDeprecatedOption:b,getSubcommandReporter:o},a=(0,r.$hl)(d,r.$gl,p?g:void 0);return a.goto&&a._.forEach(v=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,C.localize)(5,null))),a}function A(d){const p=d.findIndex(h=>!/^-/.test(h));if(p>-1)return[...d.slice(0,p),...d.slice(p+1)]}function P(d){let[,...p]=d;process.env.VSCODE_DEV&&(p=A(p)||[]);const h=!m(process.env);return O(p,h)}e.$ll=P;function f(d){let[,,...p]=d;return process.env.VSCODE_DEV&&(p=A(p)||[]),O(p,!0)}e.$ml=f;function l(d,...p){const h=d.indexOf("--");return h===-1?d.push(...p):d.splice(h,0,...p),d}e.$nl=l;function m(d){return d.VSCODE_CLI==="1"}e.$ol=m}),function(){"use strict";function G(e,E,C){function r(A,P){const f=O(A,P),l=[f];return e.isAbsolute(f)||l.unshift(C),e.resolve(...l)}function O(A,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,P);const m=A["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(d,"AppData","Roaming")}break;case"darwin":l=e.join(E.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,P)}return{getUserDataPath:r}}if(typeof define=="function")define(ee[199],te([112,27,36]),function(e,E,C){return G(e,E,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=G(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[89],te([0,1,27,197,199]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Tl=void 0;class O extends C.$Ql{constructor(l,m){super(l,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,r.getUserDataPath)(l,m.nameShort)},m)}}e.$Tl=O;function A(f,l){return(0,C.$Sl)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,l,f.extensionEnvironment)}e.$Ul=A;function P(f,l){return(0,C.$Sl)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,l,f.extensionEnvironment)}e.$Vl=P}),define(ee[200],te([0,1,42,27,32]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$43b=void 0;function O(A){const P=(0,r.$Pe)((0,C.tmpdir)());try{return(0,E.writeFileSync)(P,""),A&&console.log(`Marker file for --wait created: ${P}`),P}catch(f){A&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$43b=O}),define(ee[201],te([0,1,11,169]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=void 0;function r(A,P,f){try{O(A,P,f)}catch(l){console.error(l?.message??l)}return A}e.$$o=r;function O(A,P,f){const l=(m,d,p)=>{const h=m[d];if((0,E.$ge)(h)){const y=h,b=y.length;if(b>1&&y[0]==="%"&&y[b-1]==="%"){const o=y.substr(1,b-2);let g=P[o];g===void 0&&f&&(g=f[o]);const a=typeof g=="string"?g:g?.message,v=f?.[o],k=typeof v=="string"?v:v?.message;if(!a){k||console.warn(`[${A.name}]: ${(0,C.localize)(0,null,o)}`);return}if(p&&(d==="title"||d==="category")&&k&&k!==a){const w={value:a,original:k};m[d]=w}else m[d]=a}}else if((0,E.$ie)(h))for(const y in h)h.hasOwnProperty(y)&&(y==="commands"?l(h,y,!0):l(h,y,p));else if(Array.isArray(h))for(let y=0;y<h.length;y++)l(h,y,p)};for(const m in A)A.hasOwnProperty(m)&&l(A,m)}}),define(ee[202],te([0,1,19,69,171,203]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function f(g){return g=g.trim(),g==="*"||A.test(g)}e.$no=f;function l(g){if(!f(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=g.match(A);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.$oo=l;function m(g){if(!g)return null;const a=g.majorBase,v=g.majorMustEqual,k=g.minorBase;let w=g.minorMustEqual;const t=g.patchBase;let u=g.patchMustEqual;g.hasCaret&&(a===0||(w=!1),u=!1);let s=0;if(g.preRelease){const i=P.exec(g.preRelease);if(i){const[,n,c,$]=i;s=Date.UTC(Number(n),Number(c)-1,Number($))}}return{majorBase:a,majorMustEqual:v,minorBase:k,minorMustEqual:w,patchBase:t,patchMustEqual:u,isMinimum:g.hasGreaterEquals,notBefore:s}}e.$po=m;function d(g,a,v){let k;typeof g=="string"?k=m(l(g)):k=g;let w;a instanceof Date?w=a.getTime():typeof a=="string"&&(w=new Date(a).getTime());let t;if(typeof v=="string"?t=m(l(v)):t=v,!k||!t)return!1;const u=k.majorBase,s=k.minorBase,i=k.patchBase;let n=t.majorBase,c=t.minorBase,$=t.patchBase;const R=t.notBefore;let I=t.majorMustEqual,S=t.minorMustEqual,M=t.patchMustEqual;return t.isMinimum?u>n?!0:u<n?!1:s>c?!0:s<c||w&&w<R?!1:i>=$:(u===1&&n===0&&(!I||!S||!M)&&(n=1,c=0,$=0,I=!0,S=!1,M=!1),u<n?!1:u>n?!I:s<c?!1:s>c?!S:i<$?!1:i>$?!M:!(w&&w<R))}e.$qo=d;function p(g,a,v,k,w){const t=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return t.push([C.default.Error,r.localize(0,null)]),t;if(typeof k.name!="string")return t.push([C.default.Error,r.localize(1,null,"name")]),t;if(typeof k.version!="string")return t.push([C.default.Error,r.localize(2,null,"version")]),t;if(!k.engines)return t.push([C.default.Error,r.localize(3,null,"engines")]),t;if(typeof k.engines.vscode!="string")return t.push([C.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof k.extensionDependencies<"u"&&!o(k.extensionDependencies))return t.push([C.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof k.activationEvents<"u"){if(!o(k.activationEvents))return t.push([C.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof k.main>"u"&&typeof k.browser>"u")return t.push([C.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&t.push([C.default.Warning,r.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return t.push([C.default.Error,r.localize(9,null,"main")]),t;{const i=(0,E.$6f)(v,k.main);(0,E.$Zf)(i,v)||t.push([C.default.Warning,r.localize(10,null,i.path,v.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return t.push([C.default.Error,r.localize(11,null,"browser")]),t;{const i=(0,E.$6f)(v,k.browser);(0,E.$Zf)(i,v)||t.push([C.default.Warning,r.localize(12,null,i.path,v.path)])}}if(!O.valid(k.version))return t.push([C.default.Error,r.localize(13,null)]),t;const u=[];if(!h(g,a,k,w,u))for(const i of u)t.push([C.default.Error,i]);return t}e.$ro=p;function h(g,a,v,k,w){return k||typeof v.main>"u"&&typeof v.browser>"u"?!0:b(g,a,v.engines.vscode,w)}e.$so=h;function y(g,a,v){return g==="*"||b(a,v,g)}e.$to=y;function b(g,a,v,k=[]){const w=m(l(v));if(!w)return k.push(r.localize(14,null,v)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return k.push(r.localize(15,null,v)),!1}else if(!w.majorMustEqual)return k.push(r.localize(16,null,v)),!1;return d(g,a,w)?!0:(k.push(r.localize(17,null,g,v)),!1)}function o(g){if(!Array.isArray(g))return!1;for(let a=0,v=g.length;a<v;a++)if(typeof g[a]!="string")return!1;return!0}}),define(ee[204],te([0,1,17,31]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=void 0;async function r(O,A,P){let f=P&&P.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const m=(await A.readFile(O.serviceMachineIdResource)).value.toString();f=(0,C.$2e)(m)?m:null}catch{f=null}if(!f){f=(0,C.$3e)();try{await A.writeFile(O.serviceMachineIdResource,E.$Ib.fromString(f))}catch{}}return P?.store("storage.serviceMachineId",f,-1,1),f}e.$Mo=r}),define(ee[74],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=void 0;class E{constructor(r,O=[],A=!1){this.ctor=r,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.$ih=E}),define(ee[205],te([0,1,74]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.InstantiationType=void 0;const C=[];var r;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function O(P,f,l){f instanceof E.$ih||(f=new E.$ih(f,[],!!l)),C.push([P,f])}e.$8q=O;function A(){return C}e.$9q=A}),define(ee[206],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=void 0;class E{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Op=E;class C{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const P=this.lookupOrInsertNode(O),f=this.lookupOrInsertNode(A);P.outgoing.set(f.key,f),f.incoming.set(P.key,P)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const P of this.a.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let P=this.a.get(A);return P||(P=new E(A,O),this.a.set(A,P)),P}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,P]of this.a)O.push(`${A}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const P=new Set([O]),f=this.c(A,P);if(f)return f}}c(O,A){for(const[P,f]of O.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const l=this.c(f,A);if(l)return l;A.delete(P)}}}e.$Pp=C}),define(ee[6],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e._util=void 0;var E;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(f){return f[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(E||(e._util=E={})),e.$kh=r("instantiationService");function C(A,P,f){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:A,index:f}):(P[E.DI_DEPENDENCIES]=[{id:A,index:f}],P[E.DI_TARGET]=P)}function r(A){if(E.serviceIds.has(A))return E.serviceIds.get(A);const P=function(f,l,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(P,f,m)};return P.toString=()=>A,E.serviceIds.set(A,P),P}e.$lh=r;function O(A){return A}e.$mh=O}),define(ee[64],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j2b=void 0,e.$j2b=(0,E.$lh)("backupMainService")}),define(ee[18],te([0,1,11,7,6]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.ConfigurationTarget=e.$Th=e.$Sh=e.$Rh=void 0,e.$Rh=(0,r.$lh)("configurationService");function O(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof C.URI)}e.$Sh=O;function A(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof C.URI)}e.$Th=A;var P;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function f(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Uh=f;function l(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.$Vh=l;function m(g,a){const v=Object.create(null);for(const k in g)d(v,k,g[k],a);return v}e.$Wh=m;function d(g,a,v,k){const w=a.split("."),t=w.pop();let u=g;for(let s=0;s<w.length;s++){const i=w[s];let n=u[i];switch(typeof n){case"undefined":n=u[i]=Object.create(null);break;case"object":break;default:k(`Ignoring ${a} as ${w.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}u=n}if(typeof u=="object"&&u!==null)try{u[t]=v}catch{k(`Ignoring ${a} as ${w.join(".")} is ${JSON.stringify(u)}`)}else k(`Ignoring ${a} as ${w.join(".")} is ${JSON.stringify(u)}`)}e.$Xh=d;function p(g,a){const v=a.split(".");h(g,v)}e.$Yh=p;function h(g,a){const v=a.shift();if(a.length===0){delete g[v];return}if(Object.keys(g).indexOf(v)!==-1){const k=g[v];typeof k=="object"&&!Array.isArray(k)&&(h(k,a),Object.keys(k).length===0&&delete g[v])}}function y(g,a,v){function k(u,s){let i=u;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const w=a.split("."),t=k(g,w);return typeof t>"u"?v:t}e.$Zh=y;function b(g,a,v){Object.keys(a).forEach(k=>{k!=="__proto__"&&(k in g?E.$ie(g[k])&&E.$ie(a[k])?b(g[k],a[k],v):v&&(g[k]=a[k]):g[k]=a[k])})}e.$1h=b;function o(g){return g.replace(/[\[\]]/g,"")}e.$2h=o}),define(ee[113],te([0,1,3,25,195,6,162,13]),function(G,e,E,C,r,O,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.ContextKeyExprType=e.$pi=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",E.$j),f.set("isLinux",E.$k),f.set("isWindows",E.$i),f.set("isWeb",E.$o),f.set("isMacNative",E.$j&&!E.$o),f.set("isEdge",E.$G),f.set("isFirefox",E.$E),f.set("isChrome",E.$D),f.set("isSafari",E.$F);function l(L,D){if(f.get(L)!==void 0)throw(0,P.$4)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(L,D)}e.$pi=l;const m=Object.prototype.hasOwnProperty;var d;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const p={regexParsingWithErrorRecovery:!0},h=(0,A.localize)(0,null),y=(0,A.localize)(1,null),b=(0,A.localize)(2,null),o=(0,A.localize)(3,null),g=(0,A.localize)(4,null),a=(0,A.localize)(5,null),v=(0,A.localize)(6,null),k=(0,A.localize)(7,null);class w{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=p){this.k=D,this.d=new r.$oi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const H=this.D(),V=H.type===17?a:void 0;throw this.h.push({message:g,offset:H.offset,lexeme:r.$oi.getLexeme(H),additionalInfo:V}),w.c}return U}catch(U){if(U!==w.c)throw U;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(16);){const U=this.o();D.push(U)}return D.length===1?D[0]:t.or(...D)}o(){const D=[this.s()];for(;this.y(15);){const U=this.s();D.push(U)}return D.length===1?D[0]:t.and(...D)}s(){if(this.y(2)){const D=this.D();switch(D.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,o),U?.negate()}case 17:return this.z(),j.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const U=this.l();return this.A(1,o),U}case 17:{const U=D.lexeme;if(this.z(),this.y(9)){const V=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),V.type!==10)throw this.B("REGEX",V);const z=V.lexeme,B=z.lastIndexOf("/"),X=B===z.length-1?void 0:this.w(z.substring(B+1));let se;try{se=new RegExp(z.substring(1,B),X)}catch{throw this.B("REGEX",V)}return ue.create(U,se)}switch(V.type){case 10:case 19:{const z=[V.lexeme];this.z();let B=this.D(),X=0;for(let Ae=0;Ae<V.lexeme.length;Ae++)V.lexeme.charCodeAt(Ae)===40?X++:V.lexeme.charCodeAt(Ae)===41&&X--;for(;!this.E()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:X++;break;case 1:X--;break;case 10:case 18:for(let Ae=0;Ae<B.lexeme.length;Ae++)B.lexeme.charCodeAt(Ae)===40?X++:V.lexeme.charCodeAt(Ae)===41&&X--}if(X<0)break;z.push(r.$oi.getLexeme(B)),this.z(),B=this.D()}const se=z.join(""),ce=se.lastIndexOf("/"),ge=ce===se.length-1?void 0:this.w(se.substring(ce+1));let Ie;try{Ie=new RegExp(se.substring(1,ce),ge)}catch{throw this.B("REGEX",V)}return t.regex(U,Ie)}case 18:{const z=V.lexeme;this.z();let B=null;if(!(0,C.$hd)(z)){const X=z.indexOf("/"),se=z.lastIndexOf("/");if(X!==se&&X>=0){const ce=z.slice(X+1,se),ge=z[se+1]==="i"?"i":"";try{B=new RegExp(ce,ge)}catch{throw this.B("REGEX",V)}}}if(B===null)throw this.B("REGEX",V);return ue.create(U,B)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const V=this.u();return t.notIn(U,V)}switch(this.D().type){case 3:{this.z();const V=this.u();if(this.x().type===18)return t.equals(U,V);switch(V){case"true":return t.has(U);case"false":return t.not(U);default:return t.equals(U,V)}}case 4:{this.z();const V=this.u();if(this.x().type===18)return t.notEquals(U,V);switch(V){case"true":return t.not(U);case"false":return t.has(U);default:return t.notEquals(U,V)}}case 5:return this.z(),ie.create(U,this.u());case 6:return this.z(),ne.create(U,this.u());case 7:return this.z(),q.create(U,this.u());case 8:return this.z(),re.create(U,this.u());case 13:return this.z(),t.in(U,this.u());default:return t.has(U)}}case 20:throw this.h.push({message:v,offset:D.offset,lexeme:"",additionalInfo:k}),w.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case 17:case 18:return this.z(),D.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,U){if(this.C(D))return this.z();throw this.B(U,this.D())}B(D,U,H){const V=(0,A.localize)(8,null,D,r.$oi.getLexeme(U)),z=U.offset,B=r.$oi.getLexeme(U);return this.h.push({message:V,offset:z,lexeme:B,additionalInfo:H}),w.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$qi=w,w.c=new Error;class t{static false(){return n.INSTANCE}static true(){return c.INSTANCE}static has(D){return $.create(D)}static equals(D,U){return R.create(D,U)}static notEquals(D,U){return M.create(D,U)}static regex(D,U){return ue.create(D,U)}static in(D,U){return I.create(D,U)}static notIn(D,U){return S.create(D,U)}static not(D){return j.create(D)}static and(...D){return Y.create(D,null,!0)}static or(...D){return N.create(D,null,!0)}static greater(D,U){return q.create(D,U)}static greaterEquals(D,U){return re.create(D,U)}static smaller(D,U){return ie.create(D,U)}static smallerEquals(D,U){return ne.create(D,U)}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$ri=t,t.c=new w({regexParsingWithErrorRecovery:!1});function u(L){const D=new w({regexParsingWithErrorRecovery:!1});return L.map(U=>(D.parse(U),D.lexingErrors.length>0?D.lexingErrors.map(H=>({errorMessage:H.additionalInfo?(0,A.localize)(9,null,H.additionalInfo):(0,A.localize)(10,null),offset:H.offset,length:H.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(H=>({errorMessage:H.additionalInfo?`${H.message}. ${H.additionalInfo}`:H.message,offset:H.offset,length:H.lexeme.length})):[]))}e.$si=u;function s(L,D){const U=L?L.substituteConstants():void 0,H=D?D.substituteConstants():void 0;return!U&&!H?!0:!U||!H?!1:U.equals(H)}e.$ti=s;function i(L,D){return L.cmp(D)}class n{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return c.INSTANCE}}e.$ui=n,n.INSTANCE=new n;class c{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return n.INSTANCE}}e.$vi=c,c.INSTANCE=new c;class ${static create(D,U=null){const H=f.get(D);return typeof H=="boolean"?H?c.INSTANCE:n.INSTANCE:new $(D,U)}constructor(D,U){this.key=D,this.c=U,this.type=2}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=f.get(this.key);return typeof D=="boolean"?D?c.INSTANCE:n.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$wi=$;class R{static create(D,U,H=null){if(typeof U=="boolean")return U?$.create(D,H):j.create(D,H);const V=f.get(D);return typeof V=="boolean"?U===(V?"true":"false")?c.INSTANCE:n.INSTANCE:new R(D,U,H)}constructor(D,U,H){this.c=D,this.d=U,this.f=H,this.type=4}cmp(D){return D.type!==this.type?this.type-D.type:J(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=f.get(this.c);if(typeof D=="boolean"){const U=D?"true":"false";return this.d===U?c.INSTANCE:n.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$xi=R;class I{static create(D,U){return new I(D,U)}constructor(D,U){this.d=D,this.f=U,this.type=10,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:J(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const U=D.getValue(this.f),H=D.getValue(this.d);return Array.isArray(U)?U.includes(H):typeof H=="string"&&typeof U=="object"&&U!==null?m.call(U,H):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$yi=I;class S{static create(D,U){return new S(D,U)}constructor(D,U){this.d=D,this.f=U,this.type=11,this.c=I.create(D,U)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$zi=S;class M{static create(D,U,H=null){if(typeof U=="boolean")return U?j.create(D,H):$.create(D,H);const V=f.get(D);return typeof V=="boolean"?U===(V?"true":"false")?n.INSTANCE:c.INSTANCE:new M(D,U,H)}constructor(D,U,H){this.c=D,this.d=U,this.f=H,this.type=5}cmp(D){return D.type!==this.type?this.type-D.type:J(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=f.get(this.c);if(typeof D=="boolean"){const U=D?"true":"false";return this.d===U?n.INSTANCE:c.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Ai=M;class j{static create(D,U=null){const H=f.get(D);return typeof H=="boolean"?H?n.INSTANCE:c.INSTANCE:new j(D,U)}constructor(D,U){this.c=D,this.d=U,this.type=3}cmp(D){return D.type!==this.type?this.type-D.type:T(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=f.get(this.c);return typeof D=="boolean"?D?n.INSTANCE:c.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$Bi=j;function F(L,D){if(typeof L=="string"){const U=parseFloat(L);isNaN(U)||(L=U)}return typeof L=="string"||typeof L=="number"?D(L):n.INSTANCE}class q{static create(D,U,H=null){return F(U,V=>new q(D,V,H))}constructor(D,U,H){this.c=D,this.d=U,this.f=H,this.type=12}cmp(D){return D.type!==this.type?this.type-D.type:J(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Ci=q;class re{static create(D,U,H=null){return F(U,V=>new re(D,V,H))}constructor(D,U,H){this.c=D,this.d=U,this.f=H,this.type=13}cmp(D){return D.type!==this.type?this.type-D.type:J(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Di=re;class ie{static create(D,U,H=null){return F(U,V=>new ie(D,V,H))}constructor(D,U,H){this.c=D,this.d=U,this.f=H,this.type=14}cmp(D){return D.type!==this.type?this.type-D.type:J(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Ei=ie;class ne{static create(D,U,H=null){return F(U,V=>new ne(D,V,H))}constructor(D,U,H){this.c=D,this.d=U,this.f=H,this.type=15}cmp(D){return D.type!==this.type?this.type-D.type:J(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Fi=ne;class ue{static create(D,U){return new ue(D,U)}constructor(D,U){this.d=D,this.f=U,this.type=7,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const U=this.f?this.f.source:"",H=D.f?D.f.source:"";return U<H?-1:U>H?1:0}equals(D){if(D.type===this.type){const U=this.f?this.f.source:"",H=D.f?D.f.source:"";return this.d===D.d&&U===H}return!1}substituteConstants(){return this}evaluate(D){const U=D.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=le.create(this)),this.c}}e.$Gi=ue;class le{static create(D){return new le(D)}constructor(D){this.c=D,this.type=8}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new le(this.c.map(D))}negate(){return this.c}}e.$Hi=le;function K(L){let D=null;for(let U=0,H=L.length;U<H;U++){const V=L[U].substituteConstants();if(L[U]!==V&&D===null){D=[];for(let z=0;z<U;z++)D[z]=L[z]}D!==null&&(D[U]=V)}return D===null?L:D}class Y{static create(D,U,H){return Y.d(D,U,H)}constructor(D,U){this.expr=D,this.c=U,this.type=6}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let U=0,H=this.expr.length;U<H;U++){const V=i(this.expr[U],D.expr[U]);if(V!==0)return V}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let U=0,H=this.expr.length;U<H;U++)if(!this.expr[U].equals(D.expr[U]))return!1;return!0}return!1}substituteConstants(){const D=K(this.expr);return D===this.expr?this:Y.create(D,this.c,!1)}evaluate(D){for(let U=0,H=this.expr.length;U<H;U++)if(!this.expr[U].evaluate(D))return!1;return!0}static d(D,U,H){const V=[];let z=!1;for(const B of D)if(B){if(B.type===1){z=!0;continue}if(B.type===0)return n.INSTANCE;if(B.type===6){V.push(...B.expr);continue}V.push(B)}if(V.length===0&&z)return c.INSTANCE;if(V.length!==0){if(V.length===1)return V[0];V.sort(i);for(let B=1;B<V.length;B++)V[B-1].equals(V[B])&&(V.splice(B,1),B--);if(V.length===1)return V[0];for(;V.length>1;){const B=V[V.length-1];if(B.type!==9)break;V.pop();const X=V.pop(),se=V.length===0,ce=N.create(B.expr.map(ge=>Y.create([ge,X],null,H)),null,se);ce&&(V.push(ce),V.sort(i))}if(V.length===1)return V[0];if(H){for(let B=0;B<V.length;B++)for(let X=B+1;X<V.length;X++)if(V[B].negate().equals(V[X]))return n.INSTANCE;if(V.length===1)return V[0]}return new Y(V,U)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const U of this.expr)D.push(...U.keys());return D}map(D){return new Y(this.expr.map(U=>U.map(D)),null)}negate(){if(!this.c){const D=[];for(const U of this.expr)D.push(U.negate());this.c=N.create(D,this,!0)}return this.c}}e.$Ii=Y;class N{static create(D,U,H){return N.d(D,U,H)}constructor(D,U){this.expr=D,this.c=U,this.type=9}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let U=0,H=this.expr.length;U<H;U++){const V=i(this.expr[U],D.expr[U]);if(V!==0)return V}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let U=0,H=this.expr.length;U<H;U++)if(!this.expr[U].equals(D.expr[U]))return!1;return!0}return!1}substituteConstants(){const D=K(this.expr);return D===this.expr?this:N.create(D,this.c,!1)}evaluate(D){for(let U=0,H=this.expr.length;U<H;U++)if(this.expr[U].evaluate(D))return!0;return!1}static d(D,U,H){let V=[],z=!1;if(D){for(let B=0,X=D.length;B<X;B++){const se=D[B];if(se){if(se.type===0){z=!0;continue}if(se.type===1)return c.INSTANCE;if(se.type===9){V=V.concat(se.expr);continue}V.push(se)}}if(V.length===0&&z)return n.INSTANCE;V.sort(i)}if(V.length!==0){if(V.length===1)return V[0];for(let B=1;B<V.length;B++)V[B-1].equals(V[B])&&(V.splice(B,1),B--);if(V.length===1)return V[0];if(H){for(let B=0;B<V.length;B++)for(let X=B+1;X<V.length;X++)if(V[B].negate().equals(V[X]))return c.INSTANCE;if(V.length===1)return V[0]}return new N(V,U)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const U of this.expr)D.push(...U.keys());return D}map(D){return new N(this.expr.map(U=>U.map(D)),null)}negate(){if(!this.c){const D=[];for(const U of this.expr)D.push(U.negate());for(;D.length>1;){const U=D.shift(),H=D.shift(),V=[];for(const z of oe(U))for(const B of oe(H))V.push(Y.create([z,B],null,!1));D.unshift(N.create(V,null,!1))}this.c=N.create(D,this,!0)}return this.c}}e.$Ji=N;class W extends ${static all(){return W.d.values()}constructor(D,U,H){super(D,null),this.f=U,typeof H=="object"?W.d.push({...H,key:D}):H!==!0&&W.d.push({key:D,description:H,type:U!=null?typeof U:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return R.create(this.key,D)}notEqualsTo(D){return M.create(this.key,D)}}e.$Ki=W,W.d=[],e.$Li=(0,O.$lh)("contextKeyService");function T(L,D){return L<D?-1:L>D?1:0}function J(L,D,U,H){return L<U?-1:L>U?1:D<H?-1:D>H?1:0}function Q(L,D){if(L.type===0||D.type===1)return!0;if(L.type===9)return D.type===9?ae(L.expr,D.expr):!1;if(D.type===9){for(const U of D.expr)if(Q(L,U))return!0;return!1}if(L.type===6){if(D.type===6)return ae(D.expr,L.expr);for(const U of L.expr)if(Q(U,D))return!0;return!1}return L.equals(D)}e.$Mi=Q;function ae(L,D){let U=0,H=0;for(;U<L.length&&H<D.length;){const V=L[U].cmp(D[H]);if(V<0)return!1;V===0&&U++,H++}return U===L.length}function oe(L){return L.type===9?L.expr:[L]}}),define(ee[75],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=void 0,e.$in=(0,E.$lh)("credentialsService"),e.$jn=(0,E.$lh)("credentialsMainService");class C{constructor(){this.a={}}async getPassword(O,A){return this.a[O]?.[A]??null}async setPassword(O,A,P){this.a[O]=this.a[O]??{},this.a[O][A]=P}async deletePassword(O,A){return this.a[O]?.[A]?(delete this.a[O][A],Object.keys(this.a[O]).length===0&&delete this.a[O],!0):!1}async findPassword(O){return JSON.stringify(this.a[O])??null}async findCredentials(O){const A=[];for(const P of Object.keys(this.a[O]||{}))A.push({account:P,password:this.a[O][P]});return A}async clear(){this.a={}}}e.$kn=C}),define(ee[90],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.ID=void 0,e.ID="diagnosticsService",e.$1l=(0,E.$lh)(e.ID);function C(O){return!!O.hostName&&!!O.errorMessage}e.$2l=C;class r{async getPerformanceInfo(A,P){return{}}async getSystemInfo(A,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,P){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.$3l=r}),define(ee[91],te([0,1,19,69,164,6,46,3,37]),function(G,e,E,C,r,O,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2z=e.$1z=e.ConfirmResult=e.$Zz=e.$Yz=e.$Xz=void 0,e.$Xz=(0,O.$lh)("dialogService");var l;(function(b){b[b.Confirmation=1]="Confirmation",b[b.Prompt=2]="Prompt",b[b.Input=3]="Input"})(l||(l={}));class m{a(o){return this.d(o,l.Confirmation)}b(o){return this.d(o,l.Prompt)}c(o){return this.d(o,l.Input)}d(o,g){const a=[];switch(g){case l.Confirmation:{const v=o;v.primaryButton?a.push(v.primaryButton):a.push((0,r.localize)(0,null)),v.cancelButton?a.push(v.cancelButton):a.push((0,r.localize)(1,null));break}case l.Prompt:{const v=o;Array.isArray(v.buttons)&&v.buttons.length>0&&a.push(...v.buttons.map(k=>k.label)),v.cancelButton&&(v.cancelButton===!0?a.push((0,r.localize)(2,null)):typeof v.cancelButton=="string"?a.push(v.cancelButton):v.cancelButton.label?a.push(v.cancelButton.label):a.push((0,r.localize)(3,null))),a.length===0&&a.push((0,r.localize)(4,null));break}case l.Input:{const v=o;v.primaryButton?a.push(v.primaryButton):a.push((0,r.localize)(5,null)),v.cancelButton?a.push(v.cancelButton):a.push((0,r.localize)(6,null));break}}return a}e(o){if(typeof o=="string")return o;if(typeof o=="number")return o===C.default.Info?"info":o===C.default.Error?"error":o===C.default.Warning?"warning":"none"}async f(o,g,a){const v=[...o.buttons??[]];return o.cancelButton&&typeof o.cancelButton!="string"&&typeof o.cancelButton!="boolean"&&v.push(o.cancelButton),{result:await v[g]?.run({checkboxChecked:a}),checkboxChecked:a}}}e.$Yz=m,e.$Zz=(0,O.$lh)("fileDialogService");var d;(function(b){b[b.SAVE=0]="SAVE",b[b.DONT_SAVE=1]="DONT_SAVE",b[b.CANCEL=2]="CANCEL"})(d||(e.ConfirmResult=d={}));const p=10;function h(b){const o=[];return o.push(...b.slice(0,p).map(g=>typeof g=="string"?g:(0,E.$3f)(g))),b.length>p&&(b.length-p===1?o.push((0,r.localize)(7,null)):o.push((0,r.localize)(8,null,b.length-p))),o.push(""),o.join(`
`)}e.$1z=h;function y(b,o){const g=(0,f.$Dm)(b);let a=(g.buttons??[]).map(t=>(0,A.$Uz)(t)),v=(b.buttons||[]).map((t,u)=>u),k=0,w=g.cancelId??a.length-1;if(a.length>1){const t=typeof w=="number"?a[w]:void 0;if(P.$k||P.$j){if(typeof t=="string"&&a.length>1&&w!==1){a.splice(w,1),a.splice(1,0,t);const u=v[w];v.splice(w,1),v.splice(1,0,u),w=1}P.$k&&a.length>1&&(a=a.reverse(),v=v.reverse(),k=a.length-1,typeof t=="string"&&(w=k-1))}else if(P.$i&&typeof t=="string"&&a.length>1&&w!==a.length-1){a.splice(w,1),a.push(t);const u=v[w];v.splice(w,1),v.push(u),w=a.length-1}}return g.buttons=a,g.defaultId=k,g.cancelId=w,g.noLink=!0,g.title=g.title||o.nameLong,{options:g,buttonIndeces:v}}e.$2z=y}),define(ee[114],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zob=e.$yob=e.KnownStorageProvider=e.$xob=e.$wob=void 0,e.$wob=(0,E.$lh)("encryptionService"),e.$xob=(0,E.$lh)("encryptionMainService");var C;(function(A){A.unknown="unknown",A.basicText="basic_text",A.gnomeAny="gnome_any",A.gnomeLibsecret="gnome_libsecret",A.gnomeKeyring="gnome_keyring",A.kwallet="kwallet",A.kwallet5="kwallet5",A.kwallet6="kwallet6",A.dplib="dpapi",A.keychainAccess="keychain_access"})(C||(e.KnownStorageProvider=C={}));function r(A){return A==="kwallet"||A==="kwallet5"||A==="kwallet6"}e.$yob=r;function O(A){return A==="gnome_any"||A==="gnome_libsecret"||A==="gnome_keyring"}e.$zob=O}),define(ee[33],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=void 0,e.$sh=(0,E.$lh)("environmentService"),e.$th=(0,E.$mh)(e.$sh)}),define(ee[115],te([0,1,168,6]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ln=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=void 0,e.$zn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$An=new RegExp(e.$zn),e.$Bn="__web_extension",e.$Cn="skipWalkthrough",e.$Dn="extensionsSync";function r(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$En=r;function O(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Fn=O;function A(a,v){switch(a){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Gn=A;function P(a,v){return v==="web"&&!a.includes("web")}e.$Hn=P;function f(a,v,k){return P(v,k)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===k?!0:l(k).includes(a)}e.$In=f;function l(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Jn=l;function m(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.$Kn=m;var d;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(d||(e.SortBy=d={}));var p;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var h;(function(a){a.Install="install",a.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var y;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$Ln=(0,C.$lh)("extensionGalleryService");var b;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var o;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(o||(e.ExtensionSignaturetErrorCode=o={}));class g extends Error{constructor(v,k){super(v),this.code=k,this.name=k}}e.$Mn=g,e.$Nn=(0,C.$lh)("extensionManagementService"),e.$On="extensionsIdentifiers/disabled",e.$Pn="extensionsIdentifiers/enabled",e.$Qn=(0,C.$lh)("IGlobalExtensionEnablementService"),e.$Rn=(0,C.$lh)("IExtensionTipsService"),e.$Sn=(0,E.localize)(0,null),e.$Tn={value:e.$Sn,original:"Extensions"},e.$Un={value:(0,E.localize)(1,null),original:"Preferences"}}),define(ee[207],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hb=void 0,e.$1hb=(0,E.$lh)("extensionUrlTrustService")}),define(ee[208],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L2b=e.$K2b=void 0,e.$K2b=(0,E.$lh)("extensionHostStarter"),e.$L2b="extensionHostStarter"}),define(ee[116],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cUb=e.$bUb=e.$aUb=void 0,e.$aUb=(0,E.$lh)("externalTerminal"),e.$bUb="Terminal.app",e.$cUb=(0,E.$lh)("externalTerminal")}),define(ee[209],te([0,1,47,15,9,3,72,22,88,172,116]),function(G,e,E,C,r,O,A,P,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P2b=e.$O2b=e.$N2b=void 0;const d=l.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends p{openTerminal(k,w){return this.spawnTerminal(E,k,f.$dl(),w)}spawnTerminal(k,w,t,u){const s=w.windowsExec||h.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=r.$cc(s,".exe").toLowerCase();if(i==="cmder")return k.spawn(s,u?[u]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return s.indexOf(" ")>=0&&n.push('""'),n.push(s),i==="wt"&&n.push("-d ."),new Promise((c,$)=>{const R=o(process),I=k.spawn(t,n,{cwd:u,env:R});I.on("error",$),I.on("exit",()=>c())})}runInTerminal(k,w,t,u,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:h.getDefaultTerminalWindows();return new Promise((n,c)=>{const $=`"${w} - ${d}"`,R=`""${t.join('" "')}" & pause"`,I=Object.assign({},o(process),u);Object.keys(I).filter(q=>I[q]===null).forEach(q=>delete I[q]);const S={cwd:w,env:I,windowsVerbatimArguments:!0};let M,j;r.$cc(i,".exe")==="wt"?(M=i,j=["-d",".",h.b,"/c",R]):(M=h.b,j=["/c","start",$,"/wait",i,"/c",R]),E.spawn(M,j,S).on("error",q=>{c(g(q))}),n(void 0)})}static getDefaultTerminalWindows(){if(!h.d){const k=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${k?"Sysnative":"System32"}\\cmd.exe`}return h.d}}e.$N2b=h,h.b="cmd.exe";class y extends p{openTerminal(k,w){return this.spawnTerminal(E,k,w)}runInTerminal(k,w,t,u,s){const i=s.osxExec||m.$bUb;return new Promise((n,c)=>{if(i===m.$bUb||i==="iTerm.app"){const $=i===m.$bUb?"TerminalHelper":"iTermHelper",I=[C.$1e.asFileUri(`vs/workbench/contrib/externalTerminal/node/${$}.scpt`).fsPath,"-t",k||d,"-w",w];for(const j of t)I.push("-a"),I.push(j);if(u){const j=Object.assign({},o(process),u);for(const F in j){const q=j[F];q===null?(I.push("-u"),I.push(F)):(I.push("-e"),I.push(`${F}=${q}`))}}let S="";const M=E.spawn(y.b,I);M.on("error",j=>{c(g(j))}),M.stderr.on("data",j=>{S+=j.toString()}),M.on("exit",j=>{if(j===0)n(void 0);else if(S){const F=S.split(`
`,1);c(new Error(F[0]))}else c(new Error(l.localize(1,null,$,j)))})}else c(new Error(l.localize(2,null,i)))})}spawnTerminal(k,w,t){const u=w.osxExec||m.$bUb;return new Promise((s,i)=>{const n=["-a",u];t&&n.push(t);const c=o(process),$=k.spawn("/usr/bin/open",n,{cwd:t,env:c});$.on("error",i),$.on("exit",()=>s())})}}e.$O2b=y,y.b="/usr/bin/osascript";class b extends p{openTerminal(k,w){return this.spawnTerminal(E,k,w)}runInTerminal(k,w,t,u,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((n,c)=>{const $=[];i.then(R=>{R.indexOf("gnome-terminal")>=0?$.push("-x"):$.push("-e"),$.push("bash"),$.push("-c");const I=`${a(t)}; echo; read -p "${b.b}" -n1;`;$.push(`''${I}''`);const S=Object.assign({},o(process),u);Object.keys(S).filter(q=>S[q]===null).forEach(q=>delete S[q]);const M={cwd:w,env:S};let j="";const F=E.spawn(R,$,M);F.on("error",q=>{c(g(q))}),F.stderr.on("data",q=>{j+=q.toString()}),F.on("exit",q=>{if(q===0)n(void 0);else if(j){const re=j.split(`
`,1);c(new Error(re[0]))}else c(new Error(l.localize(4,null,R,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!b.d)if(!O.$k)b.d=Promise.resolve("xterm");else{const k=await P.Promises.exists("/etc/debian_version");b.d=new Promise(w=>{k?w("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?w("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?w("konsole"):process.env.COLORTERM?w(process.env.COLORTERM):process.env.TERM?w(process.env.TERM):w("xterm")})}return b.d}spawnTerminal(k,w,t){const u=w.linuxExec?Promise.resolve(w.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{u.then(n=>{const c=o(process),$=k.spawn(n,[],{cwd:t,env:c});$.on("error",i),$.on("exit",()=>s())})})}}e.$P2b=b,b.b=l.localize(3,null);function o(v){const k={...v.env};return(0,A.$bl)(k),k}function g(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(l.localize(5,null,v.path)):v}function a(v){let k="";for(const w of v)w.indexOf(" ")>=0?k+='"'+w+'"':k+=w,k+=" ";return k}}),define(ee[16],te([0,1,62,9,25,11,7,174,6,3,15]),function(G,e,E,C,r,O,A,P,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.FileKind=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.FileOperationResult=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.FileChangeType=e.$6j=e.FileOperation=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.FileSystemProviderErrorCode=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Pj=e.$Oj=void 0,e.$Oj=(0,f.$lh)("fileService");function d(T){return T.create===!0}e.$Pj=d;var p;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var h;(function(T){T[T.Readonly=1]="Readonly",T[T.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var y;(function(T){T[T.None=0]="None",T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock",T[T.FileAtomicRead=16384]="FileAtomicRead",T[T.FileAtomicWrite=32768]="FileAtomicWrite",T[T.FileAtomicDelete=65536]="FileAtomicDelete",T[T.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function b(T){return!!(T.capabilities&2)}e.$Qj=b;function o(T){return!!(T.capabilities&8)}e.$Rj=o;function g(T){return!!(T.capabilities&131072)}e.$Sj=g;function a(T){return!!(T.capabilities&4)}e.$Tj=a;function v(T){return!!(T.capabilities&16)}e.$Uj=v;function k(T){return b(T)?!!(T.capabilities&16384):!1}e.$Vj=k;function w(T){return b(T)?!!(T.capabilities&32768):!1}e.$Wj=w;function t(T){return!!(T.capabilities&65536)}e.$Xj=t;function u(T){return!!(T.capabilities&2048)}e.$Yj=u;var s;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsStorageQuota="EntryExceedsStorageQuota",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class i extends Error{static create(J,Q){const ae=new i(J.toString(),Q);return $(ae,Q),ae}constructor(J,Q){super(J),this.code=Q}}e.$Zj=i;function n(T,J){return i.create(T,J)}e.$1j=n;function c(T){return T||n((0,P.localize)(0,null),s.Unknown)}e.$2j=c;function $(T,J){return T.name=J?`${J} (FileSystemError)`:"FileSystemError",T}e.$3j=$;function R(T){if(!T)return s.Unknown;if(T instanceof i)return T.code;const J=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!J)return s.Unknown;switch(J[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$4j=R;function I(T){if(T instanceof re)return T.fileOperationResult;switch(R(T)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$5j=I;var S;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY",T[T.WRITE=4]="WRITE"})(S||(e.FileOperation=S={}));class M{constructor(J,Q,ae){this.resource=J,this.operation=Q,this.target=ae}isOperation(J){return this.operation===J}}e.$6j=M;var j;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class F{constructor(J,Q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ae=new Map;for(const oe of J){const L=ae.get(oe.type);switch(L?L.push([oe.resource,oe]):ae.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,L]of ae)switch(oe){case 1:this.a=E.$rh.forUris(()=>Q),this.a.fill(L);break;case 0:this.b=E.$rh.forUris(()=>Q),this.b.fill(L);break;case 2:this.c=E.$rh.forUris(()=>Q),this.c.fill(L);break}}contains(J,...Q){return this.d(J,{includeChildren:!1},...Q)}affects(J,...Q){return this.d(J,{includeChildren:!0},...Q)}d(J,Q,...ae){if(!J)return!1;const oe=ae.length>0;return!!((!oe||ae.includes(1))&&(this.a?.get(J)||Q.includeChildren&&this.a?.findSuperstr(J))||(!oe||ae.includes(0))&&(this.b?.get(J)||Q.includeChildren&&this.b?.findSuperstr(J))||(!oe||ae.includes(2))&&(this.c?.findSubstr(J)||Q.includeChildren&&this.c?.findSuperstr(J)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$7j=F;function q(T,J,Q){return!T||!J||T===J||J.length>T.length?!1:(J.charAt(J.length-1)!==C.sep&&(J+=C.sep),Q?(0,r.$Kd)(T,J):T.indexOf(J)===0)}e.$8j=q;class re extends Error{constructor(J,Q,ae){super(J),this.fileOperationResult=Q,this.options=ae}}e.$9j=re;class ie extends re{constructor(J,Q,ae,oe){super(J,Q,oe),this.fileOperationResult=Q,this.size=ae}}e.$0j=ie;class ne extends re{constructor(J,Q,ae){super(J,2,ae),this.stat=Q}}e.$$j=ne;var ue;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(e.FileOperationResult=ue={})),e.$_j={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ak={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$bk="files.associations",e.$ck="files.exclude",e.$dk="files.readonlyInclude",e.$ek="files.readonlyExclude",e.$fk="files.readonlyFromPermissions";var le;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.$gk="";function K(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.$hk=K;async function Y(T,J){if(!J.hasProvider(A.URI.from({scheme:T.scheme})))return new Promise(Q=>{const ae=J.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===T.scheme&&oe.added&&(ae.dispose(),Q())})})}e.$ik=Y;class N{static formatSize(J){return(0,O.$ke)(J)||(J=0),J<N.KB?(0,P.localize)(1,null,J.toFixed(0)):J<N.MB?(0,P.localize)(2,null,(J/N.KB).toFixed(2)):J<N.GB?(0,P.localize)(3,null,(J/N.MB).toFixed(2)):J<N.TB?(0,P.localize)(4,null,(J/N.GB).toFixed(2)):(0,P.localize)(5,null,(J/N.TB).toFixed(2))}}e.$jk=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;function W(T){const J=typeof T=="string"||T?.scheme===m.Schemas.vscodeRemote;return typeof T!="string"&&T?.scheme===m.Schemas.file?1024*N.MB:J?10*N.MB:l.$o?50*N.MB:1024*N.MB}e.$kk=W}),define(ee[210],te([0,1,17,50,13,4,2,61,7,31,16]),function(G,e,E,C,r,O,A,P,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=e.$eM=void 0,e.$eM="localFilesystem";class d extends A.$kb{constructor(h,y){super(),this.a=h,this.b=y,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.$5c),this.onDidChangeFile=this.f.event,this.g=this.B(new O.$5c),this.onDidWatchError=this.g.event,this.h=(0,l.$3e)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,y){const{buffer:b}=await this.a.call("readFile",[h,y]);return b}readFileStream(h,y,b){const o=(0,P.$wb)(a=>E.$Ib.concat(a.map(v=>E.$Ib.wrap(v))).buffer),g=this.a.listen("readFileStream",[h,y])(a=>{if(a instanceof E.$Ib)o.write(a.buffer);else{if(a==="end")o.end();else{let v;if(a instanceof Error)v=a;else{const k=a;v=(0,m.$1j)(k.message??(0,C.$9h)(k),k.code??m.FileSystemProviderErrorCode.Unknown)}o.error(v),o.end()}g.dispose()}});return b.onCancellationRequested(()=>{o.error((0,r.$3)()),o.end(),g.dispose()}),o}writeFile(h,y,b){return this.a.call("writeFile",[h,E.$Ib.wrap(y),b])}open(h,y){return this.a.call("open",[h,y])}close(h){return this.a.call("close",[h])}async read(h,y,b,o,g){const[a,v]=await this.a.call("read",[h,y,g]);return b.set(a.buffer.slice(0,v),o),v}write(h,y,b,o,g){return this.a.call("write",[h,y,E.$Ib.wrap(b),o,g])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,y){return this.a.call("delete",[h,y])}rename(h,y,b){return this.a.call("rename",[h,y,b])}copy(h,y,b){return this.a.call("copy",[h,y,b])}cloneFile(h,y){return this.a.call("cloneFile",[h,y])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const y=h;this.f.fire(y.map(b=>({resource:f.URI.revive(b.resource),type:b.type})))}else{const y=h;this.g.fire(y)}}))}watch(h,y){const b=(0,l.$3e)();return this.a.call("watch",[this.h,b,h,y]),(0,A.$ib)(()=>this.a.call("unwatch",[this.h,b]))}}e.$fM=d}),define(ee[117],te([0,1,17,13,175,16]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;async function A(m,d,p,h,y,b){let o;try{await P(m,d,p,h,y,b)}catch(g){o=g}finally{o&&y.errorTransformer&&(o=y.errorTransformer(o)),typeof o<"u"&&p.error(o),p.end()}}e.$np=A;async function P(m,d,p,h,y,b){f(b);const o=await m.open(d,{create:!1});try{f(b);let g=0,a=0,v=y&&typeof y.length=="number"?y.length:void 0,k=E.$Ib.alloc(Math.min(y.bufferSize,typeof v=="number"?v:y.bufferSize)),w=y&&typeof y.position=="number"?y.position:0,t=0;do a=await m.read(o,w,k.buffer,t,k.byteLength-t),w+=a,t+=a,g+=a,typeof v=="number"&&(v-=a),t===k.byteLength&&(await p.write(h(k)),k=E.$Ib.alloc(Math.min(y.bufferSize,typeof v=="number"?v:y.bufferSize)),t=0);while(a>0&&(typeof v!="number"||v>0)&&f(b)&&l(g,y));if(t>0){let u=t;typeof v=="number"&&(u=Math.min(t,v)),p.write(h(k.slice(0,u)))}}catch(g){throw(0,O.$2j)(g)}finally{await m.close(o)}}function f(m){if(m.isCancellationRequested)throw(0,C.$3)();return!0}function l(m,d){if(typeof d?.limits?.size=="number"&&m>d.limits.size)throw(0,O.$1j)((0,r.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ee[76],te([0,1,104,2,9,3,7,16]),function(G,e,E,C,r,O,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=void 0;function f(g){return g.recursive===!0}e.$pp=f;class l extends C.$kb{constructor(a,v,k,w){super(),this.h=a,this.i=v,this.j=k,this.k=w,this.c=this.B(new C.$lb),this.f=void 0,this.g=0}m(){const a=new C.$jb;this.c.value=a,this.b=this.l(a),this.b.setVerboseLogging(this.j),a.add(this.b.onDidChangeFile(v=>this.h(v))),a.add(this.b.onDidLogMessage(v=>this.i(v))),a.add(this.b.onDidError(v=>this.n(v)))}n(a){this.k.restartOnError?this.g<l.a&&this.f?(this.r(`restarting watcher after error: ${a}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${a}`):this.r(a)}p(a){this.g++,this.m(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.j=a,await this.b?.setVerboseLogging(a)}r(a){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${a}`})}s(a){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.$qp=l,l.a=5;class m extends l{constructor(a,v,k){super(a,v,k,{type:"node.js",restartOnError:!1})}}e.$rp=m;class d extends l{constructor(a,v,k){super(a,v,k,{type:"universal",restartOnError:!0})}}e.$sp=d;function p(g){return g.map(a=>({type:a.type,resource:A.URI.file(a.path)}))}e.$tp=p;function h(g){const a=new o;for(const v of g)a.processEvent(v);return a.coalesce()}e.$up=h;function y(g,a){return typeof a=="string"&&!a.startsWith(E.$9i)&&!(0,r.$0b)(a)?{base:g,pattern:a}:a}e.$vp=y;function b(g,a){const v=[];for(const k of a)v.push((0,E.$aj)(y(g,k)));return v}e.$wp=b;class o{constructor(){this.a=new Set,this.b=new Map}c(a){return O.$k?a.path:a.path.toLowerCase()}processEvent(a){const v=this.b.get(this.c(a));let k=!1;if(v){const w=v.type,t=a.type;v.path!==a.path&&(a.type===2||a.type===1)?k=!0:w===1&&t===2?(this.b.delete(this.c(a)),this.a.delete(v)):w===2&&t===1?v.type=0:w===1&&t===0||(v.type=t)}else k=!0;k&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],v=[];return Array.from(this.a).filter(k=>k.type!==2?(a.push(k),!1):!0).sort((k,w)=>k.path.length-w.path.length).filter(k=>v.some(w=>(0,P.$8j)(k.path,w,!O.$k))?!1:(v.push(k.path),!0)).concat(a)}}}),define(ee[211],te([0,1,42,8,21,32,2,84,9,3,105,22,76]),function(G,e,E,C,r,O,A,P,f,l,m,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=void 0;class h extends A.$kb{constructor(o,g,a,v){super(),this.j=o,this.k=g,this.l=a,this.m=v,this.c=this.B(new C.$Fg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},k=>this.k(k))),this.f=this.B(new C.$Eg(k=>this.u(k),h.b)),this.g=(0,p.$wp)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,p.$wp)(this.j.path,this.j.includes):void 0,this.i=new r.$bd,this.ready=this.n()}async n(){try{const o=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const g=await d.Promises.stat(o);this.B(await this.s(o,g.isDirectory()))}catch(o){o.code!=="ENOENT"?this.w(o):this.z(o)}}async r(o){let g=o.path;try{g=await d.Promises.realpath(o.path),o.path===g&&(g=await(0,m.$Gp)(o.path)??o.path),o.path!==g&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${g})`)}catch{}return g}async s(o,g){if(l.$j&&(0,O.$He)(o,"/Volumes/",!0))return this.w(`Refusing to watch ${o} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$kb.None;const a=new r.$bd(this.i.token),v=new A.$jb;try{const k=(0,f.$cc)(o),w=(0,E.watch)(o);v.add((0,A.$ib)(()=>{w.removeAllListeners(),w.close()})),this.z(`Started watching: '${o}'`);const t=new Set;if(g)try{for(const s of await d.Promises.readdir(o))t.add(s)}catch(s){this.w(s)}const u=new Map;v.add((0,A.$ib)(()=>{for(const[,s]of u)s.dispose();u.clear()})),w.on("error",(s,i)=>{this.w(`Failed to watch ${o} for changes using fs.watch() (${s}, ${i})`),this.dispose()}),w.on("change",(s,i)=>{if(a.token.isCancellationRequested)return;this.z(`[raw] ["${s}"] ${i}`);let n="";if(i&&(n=i.toString(),l.$j&&(n=(0,P.$3k)(n))),!(!n||s!=="change"&&s!=="rename"))if(g)if(s==="rename"){u.get(n)?.dispose();const c=setTimeout(async()=>{if(u.delete(n),n===k&&!await d.Promises.exists(o)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const $=await this.v((0,f.$$b)(o,n));if(a.token.isCancellationRequested)return;let R;$?t.has(n)?R=0:(R=1,t.add(n)):(t.delete(n),R=2),this.t({path:(0,f.$$b)(this.j.path,n),type:R})},h.a);u.set(n,(0,A.$ib)(()=>clearTimeout(c)))}else{let c;t.has(n)?c=0:(c=1,t.add(n)),this.t({path:(0,f.$$b)(this.j.path,n),type:c})}else if(s==="rename"||n!==k){const c=setTimeout(async()=>{const $=await d.Promises.exists(o);a.token.isCancellationRequested||($?(this.t({path:this.j.path,type:0},!0),v.add(await this.s(o,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);v.clear(),v.add((0,A.$ib)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(k){await d.Promises.exists(o)&&!a.token.isCancellationRequested&&this.w(`Failed to watch ${o} for changes using fs.watch() (${k.toString()})`)}return(0,A.$ib)(()=>{a.dispose(!0),v.dispose()})}t(o,g=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`),!g&&this.g.some(a=>a(o.path))?this.m&&this.z(` >> ignored (excluded) ${o.path}`):!g&&this.h&&this.h.length>0&&!this.h.some(a=>a(o.path))?this.m&&this.z(` >> ignored (not included) ${o.path}`):this.f.work(o))}u(o){const g=(0,p.$up)(o);if(g.length>0){if(this.m)for(const v of g)this.z(`>> normalized ${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`);this.c.work(g)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(o){if(l.$k)return d.Promises.exists(o);try{const g=(0,f.$cc)(o);return(await d.Promises.readdir((0,f.$bc)(o))).some(v=>v===g)}catch(g){return this.z(g),!1}}setVerboseLogging(o){this.m=o}w(o){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${o}`})}y(o){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${o}`})}z(o){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${o}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Jp=h,h.a=100,h.b=75;async function y(b,o,g,a,v=512){const k=await d.Promises.open(b,"r"),w=Buffer.allocUnsafe(v),t=new r.$bd(a);let u,s=!1;const i={path:b,excludes:[],recursive:!1},n=new h(i,c=>{(async()=>{for(const{type:$}of c)if($===0){if(s)return;s=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:R}=await d.Promises.read(k,w,0,v,null);if(!R||t.token.isCancellationRequested)break;o(w.slice(0,R))}}catch(R){u=new Error(R),t.dispose(!0)}finally{s=!1}}})()});return await n.ready,g(),new Promise((c,$)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await d.Promises.close(k)}catch(R){u=new Error(R)}u?$(u):c()})})}e.$Kp=y}),define(ee[212],te([0,1,4,104,2,3,211]),function(G,e,E,C,r,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;class P extends r.$kb{constructor(){super(...arguments),this.a=this.B(new E.$5c),this.onDidChangeFile=this.a.event,this.b=this.B(new E.$5c),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(l){const m=this.i(l),d=m.filter(h=>{const y=this.c.get(h.path);return y?!(0,C.$ej)(y.request.excludes,h.excludes)||!(0,C.$ej)(y.request.includes,h.includes):!0}),p=Array.from(this.c.values()).filter(({request:h})=>!m.find(y=>y.path===h.path&&(0,C.$ej)(y.excludes,h.excludes)&&(0,C.$ej)(y.includes,h.includes))).map(({request:h})=>h.path);d.length&&this.j(`Request to start watching: ${d.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const h of p)this.h(h);for(const h of d)this.g(h)}g(l){const m=new A.$Jp(l,p=>this.a.fire(p),p=>this.b.fire(p),this.f),d={request:l,instance:m};this.c.set(l.path,d)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const m=this.c.get(l);m&&(this.c.delete(l),m.instance.dispose())}i(l){const m=new Map;for(const d of l){const p=O.$k?d.path:d.path.toLowerCase();m.set(p,d)}return Array.from(m.values())}async setVerboseLogging(l){this.f=l;for(const[,m]of this.c)m.instance.setVerboseLogging(l)}j(l){this.f&&this.b.fire({type:"trace",message:this.k(l)})}k(l,m){return m?`[File Watcher (node.js)] ${l} (path: ${m.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$Lp=P}),define(ee[213],te([0,1,76,212]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class r extends E.$rp{constructor(A,P,f){super(A,P,f),this.m()}l(){return new C.$Lp}}e.$Mp=r}),define(ee[214],te([0,1,15,43,158,76]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;class A extends O.$sp{constructor(f,l,m){super(f,l,m),this.m()}l(f){const l=f.add(new r.$Dp(E.$1e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(l.onDidProcessExit(({code:m,signal:d})=>this.n(`terminated by itself with code ${m}, signal: ${d}`))),C.ProxyChannel.toService((0,C.$5g)(l.getChannel("watcher")))}}e.$Ep=A}),define(ee[92],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=void 0;class E{constructor(...r){this.a=new Map;for(const[O,A]of r)this.set(O,A)}set(r,O){const A=this.a.get(r);return this.a.set(r,O),A}has(r){return this.a.has(r)}get(r){return this.a.get(r)}}e.$jh=E}),define(ee[215],te([0,1,8,13,2,74,206,6,92,101]),function(G,e,E,C,r,O,A,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0;const m=!1;class d extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class p{constructor(o=new f.$jh,g=!1,a,v=m){this.f=o,this.g=g,this.h=a,this.i=v,this.o=new Set,this.f.set(P.$kh,this),this._globalGraph=v?a?._globalGraph??new A.$Pp(k=>k):void 0}createChild(o){return new p(o,this.g,this,this.i)}invokeFunction(o,...g){const a=y.traceInvocation(this.i,o);let v=!1;try{return o({get:w=>{if(v)throw(0,C.$5)("service accessor is only valid during the invocation of its target method");const t=this.m(w,a);if(!t)throw new Error(`[invokeFunction] unknown service '${w}'`);return t}},...g)}finally{v=!0,a.stop()}}createInstance(o,...g){let a,v;return o instanceof O.$ih?(a=y.traceCreation(this.i,o.ctor),v=this.j(o.ctor,o.staticArguments.concat(g),a)):(a=y.traceCreation(this.i,o),v=this.j(o,g,a)),a.stop(),v}j(o,g=[],a){const v=P._util.getServiceDependencies(o).sort((t,u)=>t.index-u.index),k=[];for(const t of v){const u=this.m(t.id,a);u||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),k.push(u)}const w=v.length>0?v[0].index:g.length;if(g.length!==w){console.trace(`[createInstance] First service dependency of ${o.name} at position ${w+1} conflicts with ${g.length} static arguments`);const t=w-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,w)}return Reflect.construct(o,g.concat(k))}k(o,g){if(this.f.get(o)instanceof O.$ih)this.f.set(o,g);else if(this.h)this.h.k(o,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const g=this.f.get(o);return!g&&this.h?this.h.l(o):g}m(o,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const a=this.l(o);return a instanceof O.$ih?this.q(o,a,g.branch(o,!0)):(g.branch(o,!1),a)}q(o,g,a){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,g,a)}finally{this.o.delete(o)}}r(o,g,a){const v=new A.$Pp(t=>t.id.toString());let k=0;const w=[{id:o,desc:g,_trace:a}];for(;w.length;){const t=w.pop();if(v.lookupOrInsertNode(t),k++>1e3)throw new d(v);for(const u of P._util.getServiceDependencies(t.desc.ctor)){const s=this.l(u.id);if(s||this.u(`[createInstance] ${o} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),s instanceof O.$ih){const i={id:u.id,desc:s,_trace:t._trace.branch(u.id,!0)};v.insertEdge(t,i),w.push(i)}}}for(;;){const t=v.roots();if(t.length===0){if(!v.isEmpty())throw new d(v);break}for(const{data:u}of t){if(this.l(u.id)instanceof O.$ih){const i=this.s(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.k(u.id,i)}v.removeNode(u)}}return this.l(o)}s(o,g,a=[],v,k){if(this.f.get(o)instanceof O.$ih)return this.t(o,g,a,v,k);if(this.h)return this.h.s(o,g,a,v,k);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(o,g,a=[],v,k){if(v){const w=new p(void 0,this.g,this,this.i);w.c=String(o);const t=new Map,u=new E.$Hg(()=>{const s=w.j(g,a,k);for(const[i,n]of t){const c=s[i];if(typeof c=="function")for(const $ of n)c.apply(s,$)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,i){if(!u.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let $=t.get(i);return $||($=new l.$jc,t.set(i,$)),(I,S,M)=>{const j=$.push([I,S,M]);return(0,r.$ib)(j)}}if(i in s)return s[i];const n=u.value;let c=n[i];return typeof c!="function"||(c=c.bind(n),s[i]=c),c},set(s,i,n){return u.value[i]=n,!0},getPrototypeOf(s){return g.prototype}})}else return this.j(g,a,k)}u(o,g){if(g&&console.warn(o),this.g)throw new Error(o)}}e.$Qp=p;var h;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(h||(h={}));class y{static traceInvocation(o,g){return o?new y(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(o,g){return o?new y(1,g.name):y.c}constructor(o,g){this.type=o,this.name=g,this.g=Date.now(),this.h=[]}branch(o,g){const a=new y(3,o.toString());return this.h.push([o,g,a]),a}stop(){const o=Date.now()-this.g;y.f+=o;let g=!1;function a(k,w){const t=[],u=new Array(k+1).join("	");for(const[s,i,n]of w.h)if(i&&n){g=!0,t.push(`${u}CREATES -> ${s}`);const c=a(k+1,n);c&&t.push(c)}else t.push(`${u}uses -> ${s}`);return t.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(o>2||g)&&y.all.add(v.join(`
`))}}e.$Rp=y,y.all=new Set,y.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}},y.f=0}),define(ee[216],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypb=e.IssueType=void 0;var C;(function(r){r[r.Bug=0]="Bug",r[r.PerformanceIssue=1]="PerformanceIssue",r[r.FeatureRequest=2]="FeatureRequest"})(C||(e.IssueType=C={})),e.$ypb=(0,E.$lh)("issueService")}),define(ee[5],te([0,1,50,4,56,2,35,3,19,11,7,113,6]),function(G,e,E,C,r,O,A,P,f,l,m,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.log=e.$Qi=e.LogLevel=e.$Pi=e.$Oi=e.$Ni=void 0,e.$Ni=(0,p.$lh)("logService"),e.$Oi=(0,p.$lh)("loggerService");function h(){return new Date().toISOString()}function y(I){return(0,l.$ke)(I)}e.$Pi=y;var b;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$Qi=b.Info;function o(I,S,M){switch(S){case b.Trace:I.trace(M);break;case b.Debug:I.debug(M);break;case b.Info:I.info(M);break;case b.Warning:I.warn(M);break;case b.Error:I.error(M);break;case b.Off:break;default:throw new Error(`Invalid log level ${S}`)}}e.log=o;function g(I,S=!1){let M="";for(let j=0;j<I.length;j++){let F=I[j];if(F instanceof Error&&(F=(0,E.$9h)(F,S)),typeof F=="object")try{F=JSON.stringify(F)}catch{}M+=(j>0?" ":"")+F}return M}class a extends O.$kb{constructor(){super(...arguments),this.b=e.$Qi,this.c=this.B(new C.$5c),this.onDidChangeLogLevel=this.c.event}setLevel(S){this.b!==S&&(this.b=S,this.c.fire(this.b))}getLevel(){return this.b}f(S){return this.b!==b.Off&&this.b<=S}}e.$Si=a;class v extends a{constructor(S){super(),this.h=S}f(S){return this.h||super.f(S)}trace(S,...M){this.f(b.Trace)&&this.g(b.Trace,g([S,...M],!0))}debug(S,...M){this.f(b.Debug)&&this.g(b.Debug,g([S,...M]))}info(S,...M){this.f(b.Info)&&this.g(b.Info,g([S,...M]))}warn(S,...M){this.f(b.Warning)&&this.g(b.Warning,g([S,...M]))}error(S,...M){if(this.f(b.Error))if(S instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=S.stack,this.g(b.Error,g(j))}else this.g(b.Error,g([S,...M]))}flush(){}}e.$Ti=v;class k extends a{constructor(S=e.$Qi){super(),this.setLevel(S),this.g=!P.$i}trace(S,...M){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,S,...M):console.log(`[main ${h()}]`,S,...M))}debug(S,...M){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,S,...M):console.log(`[main ${h()}]`,S,...M))}info(S,...M){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,S,...M):console.log(`[main ${h()}]`,S,...M))}warn(S,...M){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,S,...M):console.warn(`[main ${h()}]`,S,...M))}error(S,...M){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,S,...M):console.error(`[main ${h()}]`,S,...M))}dispose(){}flush(){}}e.$Ui=k;class w extends a{constructor(S=e.$Qi,M=!0){super(),this.g=M,this.setLevel(S)}trace(S,...M){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",S,...M):console.log(S,...M))}debug(S,...M){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",S,...M):console.log(S,...M))}info(S,...M){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",S,...M):console.log(S,...M))}warn(S,...M){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",S,...M):console.log(S,...M))}error(S,...M){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",S,...M):console.error(S,...M))}dispose(){}flush(){}}e.$Vi=w;class t extends a{constructor(S,M=e.$Qi){super(),this.g=S,this.setLevel(M)}trace(S,...M){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(S),...M])}debug(S,...M){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(S),...M])}info(S,...M){this.f(b.Info)&&this.g.log(b.Info,[this.h(S),...M])}warn(S,...M){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(S),...M])}error(S,...M){this.f(b.Error)&&this.g.log(b.Error,[this.h(S),...M])}h(S){return typeof S=="string"?S:(0,E.$9h)(S,this.f(b.Trace))}dispose(){}flush(){}}e.$Wi=t;class u extends a{constructor(S){super(),this.g=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const M of this.g)M.setLevel(S);super.setLevel(S)}trace(S,...M){for(const j of this.g)j.trace(S,...M)}debug(S,...M){for(const j of this.g)j.debug(S,...M)}info(S,...M){for(const j of this.g)j.info(S,...M)}warn(S,...M){for(const j of this.g)j.warn(S,...M)}error(S,...M){for(const j of this.g)j.error(S,...M)}flush(){for(const S of this.g)S.flush()}dispose(){for(const S of this.g)S.dispose()}}e.$Xi=u;class s extends O.$kb{constructor(S,M,j){if(super(),this.h=S,this.j=M,this.b=new A.$ji,this.c=this.B(new C.$5c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$5c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$5c),this.onDidChangeVisibility=this.g.event,j)for(const F of j)this.b.set(F.resource,{logger:void 0,info:F})}k(S){return(0,l.$ge)(S)?[...this.b.values()].find(M=>M.info.id===S):this.b.get(S)}getLogger(S){return this.k(S)?.logger}createLogger(S,M){const j=this.l(S),F=(0,l.$ge)(S)?S:M?.id??(0,r.$_h)(j.toString()).toString(16);let q=this.b.get(j)?.logger;const re=M?.logLevel==="always"?b.Trace:M?.logLevel;q||(q=this.m(j,re??this.getLogLevel(j)??this.h,{...M,id:F}));const ie={logger:q,info:{resource:j,id:F,logLevel:re,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(ie.info),this.b.set(j,ie),q}l(S){return(0,l.$ge)(S)?(0,f.$6f)(this.j,`${S}.log`):S}setLogLevel(S,M){if(m.URI.isUri(S)){const j=S,F=M,q=this.b.get(j);q&&F!==q.info.logLevel&&(q.info.logLevel=F===this.h?void 0:F,q.logger?.setLevel(F),this.b.set(q.info.resource,q),this.f.fire([j,F]))}else{this.h=S;for(const[j,F]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(S,M){const j=this.k(S);j&&M!==!j.info.hidden&&(j.info.hidden=!M,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,M]))}getLogLevel(S){let M;return S&&(M=this.b.get(S)?.info.logLevel),M??this.h}registerLogger(S){const M=this.b.get(S.resource);M?M.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this.b.set(S.resource,{info:S,logger:void 0}),this.c.fire({added:[S],removed:[]}))}deregisterLogger(S){const M=this.b.get(S);M&&(M.logger&&M.logger.dispose(),this.b.delete(S),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const S of this.b.values())yield S.info}getRegisteredLogger(S){return this.b.get(S)?.info}dispose(){this.b.forEach(S=>S.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yi=s;class i{constructor(){this.onDidChangeLogLevel=new C.$5c().event}setLevel(S){}getLevel(){return b.Info}trace(S,...M){}debug(S,...M){}info(S,...M){}warn(S,...M){}error(S,...M){}critical(S,...M){}dispose(){}flush(){}}e.$Zi=i;class n extends i{}e.$1i=n;function c(I){if(I.verbose)return b.Trace;if(typeof I.logLevel=="string"){const S=R(I.logLevel.toLowerCase());if(S!==void 0)return S}return e.$Qi}e.$2i=c;function $(I){switch(I){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.$3i=$;function R(I){switch(I){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$4i=R,e.$5i=new d.$Ki("logLevel",$(b.Info))});var x=this&&this.__param||function(G,e){return function(E,C){e(E,C,G)}};define(ee[217],te([0,1,75,4,2,5,3,8]),function(G,e,E,C,r,O,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0;let f=e.$ln=class ht extends r.$kb{constructor(m){super(),this.h=m,this.c=this.B(new C.$5c),this.onDidChangePassword=this.c.event,this.g=new P.$ng}async getPassword(m,d){this.h.trace("Going to get password from keytar:",m,d);let p;try{p=await this.i()}catch{return null}return await this.g.queue(m+d,()=>this.k(p,m,d))}async k(m,d,p){this.h.trace("Doing get password from keytar:",d,p);const h=await(0,P.$Ig)(()=>m.getPassword(d,p),50,3);if(!h)return this.h.trace("Did not get a password from keytar for account:",p),h;let y,b;try{const o=JSON.parse(h);y=o.content,b=o.hasNextChunk}catch{}if(!y||!b)return this.h.trace("Got password from keytar for account:",p),h;try{let o=1;for(;b;){const g=await(0,P.$Ig)(()=>m.getPassword(d,`${p}-${o}`),50,3),a=JSON.parse(g);y+=a.content,b=a.hasNextChunk,o++}return this.h.trace(`Got ${o}-chunked password from keytar for account:`,p),y}catch(o){return this.h.error(o),h}}async setPassword(m,d,p){this.h.trace("Going to set password using keytar:",m,d);let h;try{h=await this.i()}catch(y){throw this.j?.(y),y}await this.g.queue(m+d,()=>this.l(h,m,d,p)),this.c.fire({service:m,account:d})}async l(m,d,p,h){if(this.h.trace("Doing set password from keytar:",d,p),!A.$i){await(0,P.$Ig)(()=>m.setPassword(d,p,h),50,3),this.h.trace("Set password from keytar for account:",p);return}if(await this.m(m,d,p),h.length<=ht.b){await(0,P.$Ig)(()=>m.setPassword(d,p,h),50,3),this.h.trace("Set password from keytar for account:",p);return}let y=0,b=0,o=!0;for(;o;){const g=h.substring(y,y+ht.b);y+=ht.b,o=h.length-y>0;const a={content:g,hasNextChunk:o};await(0,P.$Ig)(()=>m.setPassword(d,b?`${p}-${b}`:p,JSON.stringify(a)),50,3),b++}this.h.trace(`Set${b?` ${b}-chunked`:""} password from keytar for account:`,p)}async deletePassword(m,d){this.h.trace("Going to delete password using keytar:",m,d);let p;try{p=await this.i()}catch(y){throw this.j?.(y),y}const h=await this.g.queue(m+d,()=>this.m(p,m,d));return h&&this.c.fire({service:m,account:d}),h}async m(m,d,p){this.h.trace("Doing delete password from keytar:",d,p);const h=await m.getPassword(d,p);if(!h)return this.h.trace("Did not get a password to delete from keytar for account:",p),!1;let y,b;try{const g=JSON.parse(h);y=g.content,b=g.hasNextChunk}catch{}let o=0;if(y&&b)try{for(o++;b;){const g=`${p}-${o}`,a=await m.getPassword(d,g);await m.deletePassword(d,g),b=JSON.parse(a).hasNextChunk,o++}}catch(g){this.h.error(g)}return await m.deletePassword(d,p)?(this.h.trace(`Deleted${o?` ${o}-chunked`:""} password from keytar for account:`,p),!0):(this.h.trace(`Keytar failed to delete${o?` ${o}-chunked`:""} password for account:`,p),!1)}async findPassword(m){let d;try{d=await this.i()}catch{return null}return await d.findPassword(m)}async findCredentials(m){let d;try{d=await this.i()}catch{return[]}return await d.findCredentials(m)}clear(){return this.f instanceof E.$kn?this.f.clear():Promise.resolve()}};f.a=2500,f.b=f.a-100,e.$ln=f=pe([x(0,O.$Ni)],f)}),define(ee[218],te([0,1,14,3,5]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I2b=void 0;const O=E.safeStorage;let A=e.$I2b=class{constructor(f,l){this.a=f,this.b=l,E.app.commandLine.getSwitchValue("password-store")==="basic_text"&&O.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.b.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(O.encryptString(f));return this.b.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.b.error(l),l}}async decrypt(f){let l;try{if(l=JSON.parse(f),!l.data)return this.b.trace("[EncryptionMainService] Unable to parse encrypted value. Attempting old decryption."),this.c(f)}catch(d){return this.b.trace("[EncryptionMainService] Unable to parse encrypted value. Attempting old decryption.",d),this.c(f)}const m=Buffer.from(l.data);this.b.trace("[EncryptionMainService] Decrypting value.");try{const d=O.decryptString(m);return this.b.trace("[EncryptionMainService] Decrypted value."),d}catch(d){throw this.b.error(d),d}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(C.$i)return Promise.resolve("dpapi");if(C.$j)return Promise.resolve("keychain_access");if(O.getSelectedStorageBackend)try{const f=O.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.b.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(C.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(C.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}async c(f){let l;try{l=await new Promise((m,d)=>G(["vscode-encrypt"],m,d))}catch{return f}try{return l.decrypt(this.a,f)}catch(m){return this.b.error(m),f}}};e.$I2b=A=pe([x(1,r.$Ni)],A)}),define(ee[219],te([0,1,24,8,13,4,2,9,76,5]),function(G,e,E,C,r,O,A,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;class m extends A.$kb{constructor(p,h){super(),this.a=p,this.b=h,this.c=this.B(new O.$5c),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$5c),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new C.$pg(0)),this.s=[],this.t=this.B(new C.$pg(0))}watch(p,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(p,h):this.u(p,h)}l(p,h){const y={path:this.C(p),excludes:h.excludes,includes:h.includes,recursive:h.recursive},b=(0,E.$yf)(this.j,y);return this.m(),(0,A.$ib)(()=>{b(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,r.$X)(p))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,f.$tp)(h)),h=>this.z(h),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const h of this.j)(0,f.$pp)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const h of this.j)(0,f.$pp)(h)&&p.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(p,h){const y={path:this.C(p),excludes:h.excludes,includes:h.includes,recursive:!1},b=(0,E.$yf)(this.s,y);return this.v(),(0,A.$ib)(()=>{b(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(p=>(0,r.$X)(p))}w(){return this.r||(this.r=this.B(this.y(p=>this.c.fire((0,f.$tp)(p)),p=>this.z(p),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.r.watch(this.s)}z(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}C(p){return(0,P.$9b)(p.fsPath)}}e.$xp=m}),define(ee[220],te([0,1,24,8,17,21,4,56,68,2,62,15,65,19,61,173,16,117,5,13]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;let k=e.$op=class extends l.$kb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new A.$5c),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$5c),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$5c),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new A.$5c),this.onDidRunOperation=this.m.event,this.R=this.B(new A.$5c),this.onDidFilesChange=this.R.event,this.S=this.B(new A.$5c),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new C.$zg)}registerProvider(t,u){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${t}`);const s=new l.$jb;return this.h.set(t,u),this.c.fire({added:!0,scheme:t,provider:u}),s.add(u.onDidChangeFile(i=>this.R.fire(new o.$7j(i,!this.O(u))))),typeof u.onDidWatchError=="function"&&s.add(u.onDidWatchError(i=>this.S.fire(new Error(i)))),s.add(u.onDidChangeCapabilities(()=>this.g.fire({provider:u,scheme:t}))),(0,l.$ib)(()=>{this.c.fire({added:!1,scheme:t,provider:u}),this.h.delete(t),(0,l.$fb)(s)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const u=[];this.f.fire({scheme:t,join(s){u.push(s)}}),!this.h.has(t)&&await C.Promises.settled(u)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,u){const s=this.h.get(t.scheme);return!!(s&&s.capabilities&u)}listCapabilities(){return f.Iterable.map(this.h,([t,u])=>({scheme:t,capabilities:u.capabilities}))}async j(t){if(!(0,h.$0f)(t))throw new o.$9j((0,b.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const u=this.h.get(t.scheme);if(!u){const s=new v.$_;throw s.message=(0,b.localize)(1,null,t.toString()),s}return u}async k(t){const u=await this.j(t);if((0,o.$Tj)(u)||(0,o.$Qj)(u)||(0,o.$Uj)(u))return u;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const u=await this.j(t);if((0,o.$Tj)(u)||(0,o.$Qj)(u))return u;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,u){try{return await this.n(t,u)}catch(s){throw(0,o.$4j)(s)===o.FileSystemProviderErrorCode.FileNotFound?new o.$9j((0,b.localize)(2,null,this.nb(t)),1):(0,o.$2j)(s)}}async n(t,u){const s=await this.j(t),i=this.O(s),n=u?.resolveTo,c=u?.resolveSingleChildDescendants,$=u?.resolveMetadata,R=await s.stat(t);let I;return this.p(s,t,R,void 0,!!$,(S,M)=>(I||(I=m.$rh.forUris(()=>!i),I.set(t,!0),n&&I.fill(!0,n)),I.get(S.resource)||I.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&c?M===1:!1))}async p(t,u,s,i,n,c){const{providerExtUri:$}=this.N(t),R={resource:u,name:$.basename(u),isFile:(s.type&o.FileType.File)!==0,isDirectory:(s.type&o.FileType.Directory)!==0,isSymbolicLink:(s.type&o.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&o.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&o.FilePermission.Locked),etag:(0,o.$hk)({mtime:s.mtime,size:s.size}),children:void 0};if(R.isDirectory&&c(R,i)){try{const I=await t.readdir(u),S=await C.Promises.settled(I.map(async([M,j])=>{try{const F=$.joinPath(u,M),q=n?await t.stat(F):{type:j};return await this.p(t,F,q,I.length,n,c)}catch(F){return this.b.trace(F),null}}));R.children=(0,E.$jf)(S)}catch(I){this.b.trace(I),R.children=[]}return R}return R}async resolveAll(t){return C.Promises.settled(t.map(async u=>{try{return{stat:await this.n(u.resource,u.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const u=await this.j(t),s=await u.stat(t);return this.p(u,t,s,void 0,!0,()=>!1)}async exists(t){const u=await this.j(t);try{return!!await u.stat(t)}catch{return!1}}async canCreateFile(t,u){try{await this.r(t,u)}catch(s){return s}return!0}async r(t,u){if(!u?.overwrite&&await this.exists(t))throw new o.$9j((0,b.localize)(3,null,this.nb(t)),3,u)}async createFile(t,u=r.$Ib.fromString(""),s){await this.r(t,s);const i=await this.writeFile(t,u);return this.m.fire(new o.$6j(t,0,i)),i}async writeFile(t,u,s){const i=this.lb(await this.l(t),t),{providerExtUri:n}=this.N(i);try{await this.s(i,t,s)||await this.P(i,n.dirname(t));let $;if((0,o.$Qj)(i)&&!(u instanceof r.$Ib))if((0,y.$ub)(u)){const R=await(0,y.$Bb)(u,3);R.ended?$=r.$Ib.concat(R.buffer):$=R}else $=(0,y.$yb)(u,R=>r.$Ib.concat(R),3);else $=u;if(!(0,o.$Tj)(i)||(0,o.$Qj)(i)&&$ instanceof r.$Ib)await this.cb(i,t,s,$);else{const R=$ instanceof r.$Ib?(0,r.$Sb)($):$;s?.atomic!==!1&&s?.atomic?.postfix?await this.Y(i,t,(0,h.$6f)((0,h.$5f)(t),`${(0,h.$3f)(t)}${s.atomic.postfix}`),s,R):await this.Z(i,t,s,R)}this.m.fire(new o.$6j(t,4))}catch(c){throw new o.$9j((0,b.localize)(4,null,this.nb(t),(0,o.$2j)(c).toString()),(0,o.$5j)(c),s)}return this.resolve(t,{resolveMetadata:!0})}async s(t,u,s){const i=!!s?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,b.localize)(5,null,this.nb(u)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,b.localize)(6,null,this.nb(u)));if(i)throw new Error((0,b.localize)(7,null,this.nb(u)))}let c;try{c=await t.stat(u)}catch{return}if(c.type&o.FileType.Directory)throw new o.$9j((0,b.localize)(8,null,this.nb(u)),0,s);if(this.mb(u,c),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==o.$gk&&typeof c.mtime=="number"&&typeof c.size=="number"&&s.mtime<c.mtime&&s.etag!==(0,o.$hk)({mtime:s.mtime,size:c.size}))throw new o.$9j((0,b.localize)(9,null),3,s);return c}async readFile(t,u,s){const i=await this.k(t);return u?.atomic?this.t(i,t,u,s):this.u(i,t,u,s)}async t(t,u,s,i){return new Promise((n,c)=>{this.X.queueFor(u,this.N(t).providerExtUri).queue(async()=>{try{const $=await this.u(t,u,s,i);n($)}catch($){c($)}})})}async u(t,u,s,i){const n=await this.v(t,u,{...s,preferUnbuffered:!0},i);return{...n,value:await(0,r.$Tb)(n.value)}}async readFileStream(t,u,s){const i=await this.k(t);return this.v(i,t,u,s)}async v(t,u,s,i){const n=new O.$bd(i),c=this.F(u,s).then(R=>R,R=>{throw n.cancel(),R});let $;try{return typeof s?.etag=="string"&&s.etag!==o.$gk&&await c,s?.atomic&&(0,o.$Vj)(t)||!((0,o.$Tj)(t)||(0,o.$Uj)(t))||(0,o.$Qj)(t)&&s?.preferUnbuffered?$=this.D(t,u,s):(0,o.$Uj)(t)?$=this.z(t,u,n.token,s):$=this.C(t,u,n.token,s),{...await c,value:$}}catch(R){throw $&&await(0,y.$zb)($),this.w(R,u,s)}}w(t,u,s){const i=(0,b.localize)(10,null,this.nb(u),(0,o.$2j)(t).toString());return t instanceof o.$$j?new o.$$j(i,t.stat,s):t instanceof o.$0j?new o.$0j(i,t.fileOperationResult,t.size,t.options):new o.$9j(i,(0,o.$5j)(t),s)}z(t,u,s,i=Object.create(null)){const n=t.readFileStream(u,i,s);return(0,y.$Fb)(n,{data:c=>c instanceof r.$Ib?c:r.$Ib.wrap(c),error:c=>this.w(c,u,i)},c=>r.$Ib.concat(c))}C(t,u,s,i=Object.create(null)){const n=(0,r.$Xb)();return(0,g.$np)(t,u,n,c=>c,{...i,bufferSize:this.a,errorTransformer:c=>this.w(c,u,i)},s),n}D(t,u,s){const i=(0,y.$wb)(n=>r.$Ib.concat(n));return(async()=>{try{let n;s?.atomic&&(0,o.$Vj)(t)?n=await t.readFile(u,{atomic:!0}):n=await t.readFile(u),typeof s?.position=="number"&&(n=n.slice(s.position)),typeof s?.length=="number"&&(n=n.slice(0,s.length)),this.G(u,n.byteLength,s),i.end(r.$Ib.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async F(t,u){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new o.$9j((0,b.localize)(11,null,this.nb(t)),0,u);if(typeof u?.etag=="string"&&u.etag!==o.$gk&&u.etag===s.etag)throw new o.$$j((0,b.localize)(12,null),s,u);return this.G(t,s.size,u),s}G(t,u,s){if(typeof s?.limits?.size=="number"&&u>s.limits.size)throw new o.$0j((0,b.localize)(13,null,this.nb(t)),7,u,s)}async canMove(t,u,s){return this.H(t,u,"move",s)}async canCopy(t,u,s){return this.H(t,u,"copy",s)}async H(t,u,s,i){if(t.toString()!==u.toString())try{const n=s==="move"?this.lb(await this.l(t),t):await this.k(t),c=this.lb(await this.l(u),u);await this.M(n,t,c,u,s,i)}catch(n){return n}return!0}async move(t,u,s){const i=this.lb(await this.l(t),t),n=this.lb(await this.l(u),u),c=await this.I(i,t,n,u,"move",!!s),$=await this.resolve(u,{resolveMetadata:!0});return this.m.fire(new o.$6j(t,c==="move"?2:3,$)),$}async copy(t,u,s){const i=await this.k(t),n=this.lb(await this.l(u),u),c=await this.I(i,t,n,u,"copy",!!s),$=await this.resolve(u,{resolveMetadata:!0});return this.m.fire(new o.$6j(t,c==="copy"?3:2,$)),$}async I(t,u,s,i,n,c){if(u.toString()===i.toString())return n;const{exists:$,isSameResourceWithDifferentPathCase:R}=await this.M(t,u,s,i,n,c);if($&&!R&&c&&await this.del(i,{recursive:!0}),await this.P(s,this.N(s).providerExtUri.dirname(i)),n==="copy"){if(t===s&&(0,o.$Rj)(t))await t.copy(u,i,{overwrite:c});else{const I=await this.resolve(u);I.isDirectory?await this.L(t,I,s,i):await this.J(t,u,s,i)}return n}else return t===s?(await t.rename(u,i,{overwrite:c}),n):(await this.I(t,u,s,i,"copy",c),await this.del(u,{recursive:!0}),"copy")}async J(t,u,s,i){if((0,o.$Tj)(t)&&(0,o.$Tj)(s))return this.eb(t,u,s,i);if((0,o.$Tj)(t)&&(0,o.$Qj)(s))return this.kb(t,u,s,i);if((0,o.$Qj)(t)&&(0,o.$Tj)(s))return this.ib(t,u,s,i);if((0,o.$Qj)(t)&&(0,o.$Qj)(s))return this.gb(t,u,s,i)}async L(t,u,s,i){await s.mkdir(i),Array.isArray(u.children)&&await C.Promises.settled(u.children.map(async n=>{const c=this.N(s).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.L(t,await this.resolve(n.resource),s,c):this.J(t,n.resource,s,c)}))}async M(t,u,s,i,n,c){let $=!1;if(t===s){const{providerExtUri:I,isPathCaseSensitive:S}=this.N(t);if(S||($=I.isEqual(u,i)),$&&n==="copy")throw new Error((0,b.localize)(14,null,this.nb(u),this.nb(i)));if(!$&&I.isEqualOrParent(i,u))throw new Error((0,b.localize)(15,null,this.nb(u),this.nb(i)))}const R=await this.exists(i);if(R&&!$){if(!c)throw new o.$9j((0,b.localize)(16,null,this.nb(u),this.nb(i)),4);if(t===s){const{providerExtUri:I}=this.N(t);if(I.isEqualOrParent(u,i))throw new Error((0,b.localize)(17,null,this.nb(u),this.nb(i)))}}return{exists:R,isSameResourceWithDifferentPathCase:$}}N(t){const u=this.O(t);return{providerExtUri:u?h.$Vf:h.$Xf,isPathCaseSensitive:u}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const u=this.lb(await this.j(t),t);await this.P(u,t);const s=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new o.$6j(t,0,s)),s}async P(t,u){const s=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(u,i.dirname(u));)try{if(!((await t.stat(u)).type&o.FileType.Directory))throw new Error((0,b.localize)(18,null,this.nb(u)));break}catch(n){if((0,o.$4j)(n)!==o.FileSystemProviderErrorCode.FileNotFound)throw n;s.push(i.basename(u)),u=i.dirname(u)}for(let n=s.length-1;n>=0;n--){u=i.joinPath(u,s[n]);try{await t.mkdir(u)}catch(c){if((0,o.$4j)(c)!==o.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(t,u){try{await this.Q(t,u)}catch(s){return s}return!0}async Q(t,u){const s=this.lb(await this.j(t),t),i=!!u?.useTrash;if(i&&!(s.capabilities&4096))throw new Error((0,b.localize)(19,null,this.nb(t)));const n=u?.atomic;if(n&&!(s.capabilities&65536))throw new Error((0,b.localize)(20,null,this.nb(t)));if(i&&n)throw new Error((0,b.localize)(21,null,this.nb(t)));let c;try{c=await s.stat(t)}catch{}if(c)this.mb(t,c);else throw new o.$9j((0,b.localize)(22,null,this.nb(t)),1);if(!!!u?.recursive){const R=await this.resolve(t);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,b.localize)(23,null,this.nb(t)))}return s}async del(t,u){const s=await this.Q(t,u),i=!!u?.useTrash,n=!!u?.recursive,c=u?.atomic??!1;await s.delete(t,{recursive:n,useTrash:i,atomic:c}),this.m.fire(new o.$6j(t,1))}async cloneFile(t,u){const s=await this.j(t),i=this.lb(await this.l(u),u);if(s===i&&this.N(s).providerExtUri.isEqual(t,u))return;if(s===i&&(0,o.$Sj)(s))return s.cloneFile(t,u);await this.P(i,this.N(i).providerExtUri.dirname(u));const n=this.X.queueFor(t,this.N(s).providerExtUri);return s===i&&(0,o.$Rj)(s)?n.queue(()=>s.copy(t,u,{overwrite:!0})):n.queue(()=>this.J(s,t,i,u))}watch(t,u={recursive:!1,excludes:[]}){const s=new l.$jb;let i=!1,n=()=>{i=!0};return s.add((0,l.$ib)(()=>n())),(async()=>{try{const c=await this.W(t,u);i?(0,l.$fb)(c):n=()=>(0,l.$fb)(c)}catch(c){this.b.error(c)}})(),s}async W(t,u){const s=await this.j(t),i=(0,P.$_h)([this.N(s).providerExtUri.getComparisonKey(t),u]);let n=this.U.get(i);return n||(n={count:0,disposable:s.watch(t,u)},this.U.set(i,n)),n.count+=1,(0,l.$ib)(()=>{n&&(n.count--,n.count===0&&((0,l.$fb)(n.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,l.$fb)(t.disposable);this.U.clear()}async Y(t,u,s,i,n){await this.Z(t,s,i,n);try{await t.rename(s,u,{overwrite:!0})}catch(c){try{await t.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}async Z(t,u,s,i){return this.X.queueFor(u,this.N(t).providerExtUri).queue(async()=>{const n=await t.open(u,{create:!0,unlock:s?.unlock??!1});try{(0,y.$ub)(i)||(0,y.$vb)(i)?await this.$(t,n,i):await this.ab(t,n,i)}catch(c){throw(0,o.$2j)(c)}finally{await t.close(n)}})}async $(t,u,s){let i=0,n;if((0,y.$vb)(s)){if(s.buffer.length>0){const c=r.$Ib.concat(s.buffer);await this.bb(t,u,c,c.byteLength,i,0),i+=c.byteLength}if(s.ended)return;n=s.stream}else n=s;return new Promise((c,$)=>{(0,y.$Ab)(n,{onData:async R=>{n.pause();try{await this.bb(t,u,R,R.byteLength,i,0)}catch(I){return $(I)}i+=R.byteLength,setTimeout(()=>n.resume())},onError:R=>$(R),onEnd:()=>c()})})}async ab(t,u,s){let i=0,n;for(;(n=s.read())!==null;)await this.bb(t,u,n,n.byteLength,i,0),i+=n.byteLength}async bb(t,u,s,i,n,c){let $=0;for(;$<i;){const R=await t.write(u,n+$,s.buffer,c+$,i-$);$+=R}}async cb(t,u,s,i){return this.X.queueFor(u,this.N(t).providerExtUri).queue(()=>this.db(t,u,s,i))}async db(t,u,s,i){let n;i instanceof r.$Ib?n=i:(0,y.$ub)(i)?n=await(0,r.$Tb)(i):(0,y.$vb)(i)?n=await(0,r.$Ub)(i):n=(0,r.$Rb)(i),await t.writeFile(u,n.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async eb(t,u,s,i){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.fb(t,u,s,i))}async fb(t,u,s,i){let n,c;try{n=await t.open(u,{create:!1}),c=await s.open(i,{create:!0,unlock:!1});const $=r.$Ib.alloc(this.a);let R=0,I=0,S=0;do S=await t.read(n,R,$.buffer,I,$.byteLength-I),await this.bb(s,c,$,S,R,I),R+=S,I+=S,I===$.byteLength&&(I=0);while(S>0)}catch($){throw(0,o.$2j)($)}finally{await C.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof c=="number"?s.close(c):Promise.resolve()])}}async gb(t,u,s,i){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.hb(t,u,s,i))}async hb(t,u,s,i){return s.writeFile(i,await t.readFile(u),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,u,s,i){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.jb(t,u,s,i))}async jb(t,u,s,i){const n=await s.open(i,{create:!0,unlock:!1});try{const c=await t.readFile(u);await this.bb(s,n,r.$Ib.wrap(c),c.byteLength,0,0)}catch(c){throw(0,o.$2j)(c)}finally{await s.close(n)}}async kb(t,u,s,i){const n=await(0,r.$Tb)(this.C(t,u,O.CancellationToken.None));await this.cb(s,i,void 0,n)}lb(t,u){if(t.capabilities&2048)throw new o.$9j((0,b.localize)(24,null,this.nb(u)),6);return t}mb(t,u){if((u.permissions??0)&o.FilePermission.Readonly)throw new o.$9j((0,b.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===d.Schemas.file?t.fsPath:t.toString(!0)}};e.$op=k=pe([x(0,a.$Ni)],k)}),define(ee[93],te([0,1,42,308,8,35,17,4,32,2,9,3,19,61,22,177,16,117,219,50,214,213]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a,v,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0,(()=>{try{(0,C.gracefulify)(E)}catch(u){console.error(`Error enabling graceful-fs: ${(0,v.$9h)(u)}`)}})();class t extends a.$xp{constructor(s,i){super(s,i),this.onDidChangeCapabilities=P.Event.None,this.I=new O.$ji(n=>p.$Wf.getComparisonKey(n)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,d.$k&&(this.F|=1024)),this.F}async stat(s){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.C(s));return{type:this.H(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:o.FilePermission.Locked}}catch(i){throw this.ab(i)}}async G(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await y.Promises.readdir(this.C(s),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async c=>{try{let $;c.isSymbolicLink()?$=(await this.stat((0,p.$6f)(s,c.name))).type:$=this.H(c),n.push([c.name,$])}catch($){this.a.trace($)}})),n}catch(i){throw this.ab(i)}}H(s,i){let n;return i?.dangling?n=o.FileType.Unknown:s.isFile()?n=o.FileType.File:s.isDirectory()?n=o.FileType.Directory:n=o.FileType.Unknown,i&&(n|=o.FileType.SymbolicLink),n}async J(s){const i=this.C(s);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.I.get(s);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const c=new r.$qg;return this.I.set(s,c),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.$ib)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.I.get(s)===c&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.I.delete(s)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),c.open()})}async readFile(s,i){let n;try{i?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(s)})`),n=await this.J(s));const c=this.C(s);return await y.Promises.readFile(c)}catch(c){throw this.ab(c)}finally{n?.dispose()}}L(s){t.D&&this.a.trace(s)}readFileStream(s,i,n){const c=(0,h.$wb)($=>A.$Ib.concat($.map(R=>A.$Ib.wrap(R))).buffer);return(0,g.$np)(this,s,c,$=>$.buffer,{...i,bufferSize:256*1024},n),c}async writeFile(s,i,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.M(s,(0,p.$6f)((0,p.$5f)(s),`${(0,p.$3f)(s)}${n.atomic.postfix}`),i,n):this.N(s,i,n)}async M(s,i,n,c){await this.N(i,n,c);try{await this.rename(i,s,{overwrite:!0})}catch($){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw $}}async N(s,i,n){let c;try{const $=this.C(s);if(!n.create||!n.overwrite){if(await y.Promises.exists($)){if(!n.overwrite)throw(0,o.$1j)((0,b.localize)(0,null),o.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,o.$1j)((0,b.localize)(1,null),o.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(s,{create:!0,unlock:n.unlock}),await this.write(c,0,i,0,i.byteLength)}catch($){throw await this.bb(s,$)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(s){t.R=s}async open(s,i){const n=this.C(s);let c;(0,o.$Pj)(i)&&(c=await this.J(s));let $;try{if((0,o.$Pj)(i)&&i.unlock)try{const{stat:I}=await y.SymlinkSupport.stat(n);I.mode&128||await y.Promises.chmod(n,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let R;if((0,o.$Pj)(i)){if(d.$i)try{await y.Promises.truncate(n,0),R="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}R||(R="w")}else R="r";$=await y.Promises.open(n,R)}catch(R){throw c?.dispose(),(0,o.$Pj)(i)?await this.bb(s,R):this.ab(R)}if(this.O.set($,0),(0,o.$Pj)(i)&&this.Q.set($,s),c){const R=this.P.get($);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${$} (${n})`),this.P.set($,c),R&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${$} (${n})`),R.dispose())}return $}async close(s){const i=this.P.get(s);try{if(this.O.delete(s),this.Q.delete(s)&&t.R)try{await y.Promises.fdatasync(s)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(s)}catch(n){throw this.ab(n)}finally{i&&(this.P.get(s)===i&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.P.delete(s)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,n,c,$){const R=this.S(s,i);let I=null;try{I=(await y.Promises.read(s,n,c,$,R)).bytesRead}catch(S){throw this.ab(S)}finally{this.U(s,R,I)}return I}S(s,i){return i===this.O.get(s)?null:i}U(s,i,n){const c=this.O.get(s);typeof c=="number"&&(typeof i=="number"||(typeof n=="number"?this.O.set(s,c+n):this.O.delete(s)))}async write(s,i,n,c,$){return(0,r.$Ig)(()=>this.W(s,i,n,c,$),100,3)}async W(s,i,n,c,$){const R=this.S(s,i);let I=null;try{I=(await y.Promises.write(s,n,c,$,R)).bytesWritten}catch(S){throw await this.bb(this.Q.get(s),S)}finally{this.U(s,R,I)}return I}async mkdir(s){try{await y.Promises.mkdir(this.C(s))}catch(i){throw this.ab(i)}}async delete(s,i){try{const n=this.C(s);if(i.recursive){let c;i?.atomic!==!1&&i.atomic.postfix&&(c=(0,m.$$b)((0,m.$bc)(n),`${(0,m.$cc)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,c)}else try{await y.Promises.unlink(n)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let $=!1;try{const{stat:R,symbolicLink:I}=await y.SymlinkSupport.stat(n);$=R.isDirectory()&&!I}catch{}if($)await y.Promises.rmdir(n);else throw c}else throw c}}catch(n){throw this.ab(n)}}async rename(s,i,n){const c=this.C(s),$=this.C(i);if(c!==$)try{await this.X(s,i,"move",n.overwrite),await y.Promises.move(c,$)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,b.localize)(2,null,(0,m.$cc)(c),(0,m.$cc)((0,m.$bc)($)),R.toString()))),this.ab(R)}}async copy(s,i,n){const c=this.C(s),$=this.C(i);if(c!==$)try{await this.X(s,i,"copy",n.overwrite),await y.Promises.copy(c,$,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,b.localize)(3,null,(0,m.$cc)(c),(0,m.$cc)((0,m.$bc)($)),R.toString()))),this.ab(R)}}async X(s,i,n,c){const $=this.C(s),R=this.C(i);let I=!1;if(!!(this.capabilities&1024)||(I=(0,f.$Ge)($,R,!0)),I){if(n==="copy")throw(0,o.$1j)((0,b.localize)(4,null),o.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const M=await this.G(s);if(!M)throw(0,o.$1j)((0,b.localize)(5,null),o.FileSystemProviderErrorCode.FileNotFound);const j=await this.G(i);if(j){if(!c)throw(0,o.$1j)((0,b.localize)(6,null),o.FileSystemProviderErrorCode.FileExists);M.type&o.FileType.File&&j.type&o.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.Y(s,i,!1)}async Y(s,i,n){const c=this.C(s),$=this.C(i),R=!!(this.capabilities&1024);if((0,f.$Ge)(c,$,!R))return;const I=new l.$jb;try{const[S,M]=await Promise.all([this.J(s),this.J(i)]);I.add(S),I.add(M),n&&await y.Promises.mkdir((0,m.$bc)($),{recursive:!0}),await y.Promises.copyFile(c,$)}catch(S){if(S.code==="ENOENT"&&!n)return this.Y(s,i,!0);throw this.ab(S)}finally{I.dispose()}}p(s,i,n){return new k.$Ep(c=>s(c),c=>i(c),n)}y(s,i,n){return new w.$Mp(c=>s(c),c=>i(c),n)}ab(s){if(s instanceof o.$Zj)return s;let i=s,n;switch(s.code){case"ENOENT":n=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=o.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=o.FileSystemProviderErrorCode.Unknown;break;default:n=o.FileSystemProviderErrorCode.Unknown}return(0,o.$1j)(i,n)}async bb(s,i){let n=this.ab(i);if(s&&n.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await y.SymlinkSupport.stat(this.C(s));c.mode&128||(n=(0,o.$1j)(i,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return n}}e.$Np=t,t.D=!1,t.R=!0}),define(ee[221],te([0,1,4,93,2,17,61,21]),function(G,e,E,C,r,O,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=void 0;class f extends r.$kb{constructor(d,p){super(),this.a=d,this.b=p,this.w=new Map,this.y=new Map}call(d,p,h){const y=this.c(d);switch(p){case"stat":return this.g(y,h[0]);case"readdir":return this.h(y,h[0]);case"open":return this.l(y,h[0],h[1]);case"close":return this.m(h[0]);case"read":return this.n(h[0],h[1],h[2]);case"readFile":return this.i(y,h[0],h[1]);case"write":return this.p(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.k(y,h[0],h[1],h[2]);case"rename":return this.t(y,h[0],h[1],h[2]);case"copy":return this.u(y,h[0],h[1],h[2]);case"cloneFile":return this.v(y,h[0],h[1]);case"mkdir":return this.r(y,h[0]);case"delete":return this.s(y,h[0],h[1]);case"watch":return this.C(y,h[0],h[1],h[2],h[3]);case"unwatch":return this.D(h[0],h[1])}throw new Error(`IPC Command ${p} not found`)}listen(d,p,h){const y=this.c(d);switch(p){case"fileChange":return this.z(y,h[0]);case"readFileStream":return this.j(y,h[0],h[1])}throw new Error(`Unknown event ${p}`)}g(d,p){const h=this.f(d,p,!0);return this.a.stat(h)}h(d,p){const h=this.f(d,p);return this.a.readdir(h)}async i(d,p,h){const y=this.f(d,p,!0),b=await this.a.readFile(y,h);return O.$Ib.wrap(b)}j(d,p,h){const y=this.f(d,p,!0),b=new P.$bd,o=new E.$5c({onDidRemoveLastListener:()=>{b.cancel()}}),g=this.a.readFileStream(y,h,b.token);return(0,A.$Ab)(g,{onData:a=>o.fire(O.$Ib.wrap(a)),onError:a=>o.fire(a),onEnd:()=>{o.fire("end"),o.dispose(),b.dispose()}}),o.event}k(d,p,h,y){const b=this.f(d,p);return this.a.writeFile(b,h.buffer,y)}l(d,p,h){const y=this.f(d,p,!0);return this.a.open(y,h)}m(d){return this.a.close(d)}async n(d,p,h){const y=O.$Ib.alloc(h),b=0,o=await this.a.read(d,p,y.buffer,b,h);return[y,o]}p(d,p,h,y,b){return this.a.write(d,p,h.buffer,y,b)}r(d,p){const h=this.f(d,p);return this.a.mkdir(h)}s(d,p,h){const y=this.f(d,p);return this.a.delete(y,h)}t(d,p,h,y){const b=this.f(d,p),o=this.f(d,h);return this.a.rename(b,o,y)}u(d,p,h,y){const b=this.f(d,p),o=this.f(d,h);return this.a.copy(b,o,y)}v(d,p,h){const y=this.f(d,p),b=this.f(d,h);return this.a.cloneFile(y,b)}z(d,p){const h=new E.$5c({onWillAddFirstListener:()=>{this.w.set(p,this.F(d,h))},onDidRemoveLastListener:()=>{(0,r.$fb)(this.w.get(p)),this.w.delete(p)}});return h.event}async C(d,p,h,y,b){const o=this.w.get(p);if(o){const g=this.f(d,y),a=o.watch(h,g,b);this.y.set(p+h,a)}}async D(d,p){const h=d+p,y=this.y.get(h);y&&((0,r.$fb)(y),this.y.delete(h))}dispose(){super.dispose();for(const[,d]of this.y)d.dispose();this.y.clear();for(const[,d]of this.w)d.dispose();this.w.clear()}}e.$hr=f;class l extends r.$kb{constructor(d,p,h,y){super(),this.c=d,this.f=h,this.g=y,this.a=new Map,this.b=this.B(new C.$Np(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(p)}h(d){const p=this.B(new E.$5c);this.B(p.event(h=>{d.fire(h.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type})))})),this.B(this.b.onDidChangeFile(h=>p.fire(h))),this.B(this.b.onDidWatchError(h=>d.fire(h)))}i(d){}j(d){}watch(d,p,h){const y=this.j(this.g);return Array.isArray(y)&&(h.excludes=[...h.excludes,...y]),this.a.set(d,this.b.watch(p,h)),(0,r.$ib)(()=>{(0,r.$fb)(this.a.get(d)),this.a.delete(d)})}dispose(){super.dispose();for(const[,d]of this.a)d.dispose();this.a.clear()}}e.$ir=l}),define(ee[222],te([0,1,14,176,3,7,16,9,221,153]),function(G,e,E,C,r,O,A,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q2b=void 0;class m extends f.$hr{constructor(h,y,b){super(h,y),this.G=b}c(h){return l.$km}f(h,y){return O.URI.revive(y)}async s(h,y,b){if(!b.useTrash)return super.s(h,y,b);const o=this.f(h,y),g=(0,P.$9b)(o.fsPath);try{await E.shell.trashItem(g)}catch{throw(0,A.$1j)(r.$i?(0,C.localize)(0,null,(0,P.$cc)(g)):(0,C.localize)(1,null,(0,P.$cc)(g)),A.FileSystemProviderErrorCode.Unknown)}}F(h,y){return new d(h,y,this.b,this.G)}}e.$Q2b=m;class d extends f.$ir{watch(h,y,b){if(b.recursive)throw(0,A.$1j)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(h,y,b)}}}),define(ee[223],te([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Yb=void 0;class C extends E.$Ti{constructor(O=E.$Qi){super(),this.k=[],this.l=void 0,this.setLevel(O),this.B(this.onDidChangeLogLevel(A=>{this.l?.setLevel(A)}))}set logger(O){this.l=O;for(const{level:A,message:P}of this.k)(0,E.log)(O,A,P);this.k=[]}g(O,A){this.l?(0,E.log)(this.l,O,A):this.getLevel()<=O&&this.k.push({level:O,message:A})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.$2Yb=C}),define(ee[224],te([0,1,7,4,5,2]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=e.$Jq=void 0;class A extends r.$Yi{constructor(d,p,h,y,b){super(p,h,y),this.n=d,this.p=b,this.B(b.listen("onDidChangeLogLevel",d)(o=>{(0,r.$Pi)(o)?super.setLogLevel(o):super.setLogLevel(E.URI.revive(o[0]),o[1])})),this.B(b.listen("onDidChangeVisibility",d)(([o,g])=>super.setVisibility(E.URI.revive(o),g))),this.B(b.listen("onDidChangeLoggers",d)(({added:o,removed:g})=>{for(const a of o)super.registerLogger({...a,resource:E.URI.revive(a.resource)});for(const a of g)super.deregisterLogger(a.resource)}))}createConsoleMainLogger(){return new r.$Wi({log:(d,p)=>{this.p.call("consoleLog",[d,p])}})}registerLogger(d){super.registerLogger(d),this.p.call("registerLogger",[d,this.n])}deregisterLogger(d){super.deregisterLogger(d),this.p.call("deregisterLogger",[d,this.n])}setLogLevel(d,p){super.setLogLevel(d,p),this.p.call("setLogLevel",[d,p])}setVisibility(d,p){super.setVisibility(d,p),this.p.call("setVisibility",[this.l(d),p])}m(d,p,h){return new P(this.p,d,p,h,this.n)}static setLogLevel(d,p,h){return d.call("setLogLevel",[p,h])}}e.$Jq=A;class P extends r.$Ti{constructor(d,p,h,y,b){super(y?.logLevel==="always"),this.m=d,this.n=p,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[p,y,b]).then(()=>{this.r(this.l),this.k=!0})}g(d,p){const h=[[d,p]];this.k?this.r(h):this.l.push(...h)}r(d){this.m.call("log",[this.n,d])}}class f{constructor(d,p){this.a=d,this.b=p}listen(d,p){const h=this.b(d);switch(p){case"onDidChangeLoggers":return C.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(b=>this.c(b,h)),removed:[...y.removed].map(b=>this.c(b,h))}));case"onDidChangeVisibility":return C.Event.map(this.a.onDidChangeVisibility,y=>[h.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return C.Event.map(this.a.onDidChangeLogLevel,y=>(0,r.$Pi)(y)?y:[h.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${p}`)}async call(d,p,h){const y=this.b(d);switch(p){case"setLogLevel":return(0,r.$Pi)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(E.URI.revive(y.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,y)))}throw new Error(`Call not found: ${p}`)}c(d,p){return{...d,resource:p.transformOutgoingURI(d.resource)}}}e.$Kq=f;class l extends O.$kb{constructor(d,p){super(),p.call("setLogLevel",[d.getLogLevel()]),this.B(d.onDidChangeLogLevel(h=>p.call("setLogLevel",[h]))),p.call("getRegisteredLoggers").then(h=>{for(const y of h)d.registerLogger({...y,resource:E.URI.revive(y.resource)})}),this.B(p.listen("onDidChangeVisibility")(([h,y])=>d.setVisibility(E.URI.revive(h),y))),this.B(p.listen("onDidChangeLoggers")(({added:h,removed:y})=>{for(const b of h)d.registerLogger({...b,resource:E.URI.revive(b.resource)});for(const b of y)d.deregisterLogger(b.resource)}))}}e.$Lq=l}),define(ee[225],te([0,1,2,5]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=void 0;class r extends E.$kb{constructor(A,P=[]){super(),this.a=new C.$Xi([A,...P]),this.B(A.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...P){this.a.trace(A,...P)}debug(A,...P){this.a.debug(A,...P)}info(A,...P){this.a.info(A,...P)}warn(A,...P){this.a.warn(A,...P)}error(A,...P){this.a.error(A,...P)}flush(){this.a.flush()}}e.$wM=r}),define(ee[226],te([0,1,35,7,5]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U3b=void 0;class O{constructor(P){this.b=P,this.a=new E.$ji}listen(P,f,l){switch(f){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(P,f,l){switch(f){case"createLogger":this.c(C.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(C.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,r.$Pi)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(C.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(C.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:C.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(C.URI.revive(l[0]))}throw new Error(`Call not found: ${f}`)}c(P,f,l){this.a.set(P,this.b.createLogger(P,f,l))}d(P,f){let l=console.log;switch(P){case r.LogLevel.Error:l=console.error;break;case r.LogLevel.Warning:l=console.warn;break;case r.LogLevel.Info:l=console.info;break}l.call(console,...f)}e(P,f){const l=this.a.get(P);if(!l)throw new Error("Create the logger before logging");for(const[m,d]of f)(0,r.log)(l,m,d)}}e.$U3b=O}),define(ee[227],te([0,1,16,5]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=void 0;var r;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(r||(r={}));async function O(l,m,d,p,h){try{const y=await new Promise((o,g)=>{G(["@vscode/spdlog"],o,g)});y.setFlushOn(r.Trace);const b=await y.createAsyncRotatingLogger(l,m,d,p);return h?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(y){console.error(y)}return null}function A(l,m,d){switch(m){case C.LogLevel.Trace:l.trace(d);break;case C.LogLevel.Debug:l.debug(d);break;case C.LogLevel.Info:l.info(d);break;case C.LogLevel.Warning:l.warn(d);break;case C.LogLevel.Error:l.error(d);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function P(l,m){switch(m){case C.LogLevel.Trace:l.setLevel(r.Trace);break;case C.LogLevel.Debug:l.setLevel(r.Debug);break;case C.LogLevel.Info:l.setLevel(r.Info);break;case C.LogLevel.Warning:l.setLevel(r.Warning);break;case C.LogLevel.Error:l.setLevel(r.Error);break;case C.LogLevel.Off:l.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class f extends C.$Ti{constructor(m,d,p,h,y){super(),this.k=[],this.setLevel(y),this.l=this.n(m,d,p,h),this.B(this.onDidChangeLogLevel(b=>{this.m&&P(this.m,b)}))}async n(m,d,p,h){const y=p?6:1,b=30/y*E.$jk.MB,o=await O(m,d,b,y,h);if(o){this.m=o,P(this.m,this.getLevel());for(const{level:g,message:a}of this.k)A(this.m,g,a);this.k=[]}}g(m,d){this.m?A(this.m,m,d):this.getLevel()<=m&&this.k.push({level:m,message:d})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$lM=f}),define(ee[228],te([0,1,31,5,227]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=void 0;class O extends C.$Yi{m(P,f,l){return new r.$lM((0,E.$3e)(),P.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,f)}}e.$mM=O}),define(ee[66],te([0,1,35,4,6,5,228]),function(G,e,E,C,r,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l3b=e.$k3b=void 0,e.$k3b=(0,r.$mh)(O.$Oi);class P extends A.$mM{constructor(){super(...arguments),this.p=new E.$ji}createLogger(l,m,d){d!==void 0&&this.p.set(this.l(l),d);try{return super.createLogger(l,m)}catch(p){throw this.p.delete(this.l(l)),p}}registerLogger(l,m){m!==void 0&&this.p.set(l.resource,m),super.registerLogger(l)}deregisterLogger(l){this.p.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const m=[];for(const d of super.getRegisteredLoggers())l===this.p.get(d.resource)&&m.push(d);return m}getOnDidChangeLogLevelEvent(l){return C.Event.filter(this.onDidChangeLogLevel,m=>(0,O.$Pi)(m)||this.s(m[0],l))}getOnDidChangeVisibilityEvent(l){return C.Event.filter(this.onDidChangeVisibility,([m])=>this.s(m,l))}getOnDidChangeLoggersEvent(l){return C.Event.filter(C.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(p=>this.s(p.resource,l)),removed:[...m.removed].filter(p=>this.s(p.resource,l))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(l){for(const[m,d]of this.p)d===l&&this.deregisterLogger(m)}s(l,m){const d=this.p.get(l);return d===void 0||d===m}dispose(){super.dispose(),this.p.clear()}}e.$l3b=P}),define(ee[229],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$92b=e.$82b=e.$72b=e.$62b=void 0;function E(A){return A.submenu!==void 0}e.$62b=E;function C(A){return A.id==="vscode.menubar.separator"}e.$72b=C;function r(A){return A.uri!==void 0}e.$82b=r;function O(A){return!E(A)&&!C(A)&&!r(A)}e.$92b=O}),define(ee[39],te([0,1,4,68,2,6]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0,e.$Rm=(0,O.$lh)("policy");class A extends r.$kb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.$5c),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const m=Object.keys(this.f).length;return this.f={...l,...this.f},m!==Object.keys(this.f).length&&await this.i(l),C.Iterable.reduce(this.g.entries(),(d,[p,h])=>({...d,[p]:h}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return C.Iterable.reduce(Object.entries(this.f),(l,[m,d])=>({...l,[m]:{definition:d,value:this.g.get(m)}}),{})}}e.$Sm=A;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Tm=P}),define(ee[230],te([0,1,8,4,68,11,16,5,39]),function(G,e,E,C,r,O,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_3b=void 0;function l(d,p){const h=[];for(const y of new Set(r.Iterable.concat(d.keys(),p.keys())))d.get(y)!==p.get(y)&&h.push(y);return h}let m=e.$_3b=class extends f.$Sm{constructor(p,h,y){super(),this.j=p,this.k=h,this.l=y,this.c=this.B(new E.$pg(500));const b=C.Event.filter(h.onDidFilesChange,o=>o.affects(p));this.B(h.watch(p)),this.B(b(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const p=new Map;try{const h=await this.k.readFile(this.j),y=JSON.parse(h.value.toString());if(!(0,O.$ie)(y))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(y))this.f[b]&&p.set(b,y[b])}catch(h){h.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",h)}return p}async p(){const p=await this.n(),h=l(this.g,p);this.g=p,h.length>0&&this.h.fire(h)}};e.$_3b=m=pe([x(1,A.$Oj),x(2,P.$Ni)],m)}),define(ee[231],te([0,1,4,2,39]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O3b=e.$N3b=void 0;class O{constructor(f){this.b=f,this.a=new C.$jb}listen(f,l){switch(l){case"onDidChange":return E.Event.map(this.b.onDidChange,m=>m.reduce((d,p)=>({...d,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(f,l,m){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$N3b=O;class A extends r.$Sm{constructor(f,l){super(),this.a=l;for(const m in f){const{definition:d,value:p}=f[m];this.f[m]=d,p!==void 0&&this.g.set(m,p)}this.a.listen("onDidChange")(m=>{for(const d in m){const p=m[d];p===null?this.g.delete(d):this.g.set(d,p)}this.h.fire(Object.keys(m))})}async i(f){const l=await this.a.call("updatePolicyDefinitions",f);for(const m in l)this.g.set(m,l[m])}}e.$O3b=A}),define(ee[232],te([0,1,39,8,309,2,5]),function(G,e,E,C,r,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$3b=void 0;let P=e.$$3b=class extends E.$Sm{constructor(l,m){super(),this.j=l,this.k=m,this.a=new C.$lg,this.b=this.B(new O.$lb)}async i(l){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((m,d)=>{try{this.b.value=(0,r.createWatcher)(this.k,l,p=>{this.m(p),m()})}catch(p){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),d(p)}}))}m(l){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const m in l){const d=l[m];d===void 0?this.g.delete(m):this.g.set(m,d)}this.h.fire(Object.keys(l))}};e.$$3b=P=pe([x(0,A.$Ni)],P)}),define(ee[77],te([0,1,3,36]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof E.$g.vscode<"u"&&typeof E.$g.vscode.context<"u"){const O=E.$g.vscode.context.configuration();if(O)r=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,C.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:O.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.80.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(ee[23],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=void 0,e.$6i=(0,E.$lh)("productService"),e.$7i="vscode://schemas/vscode-product"}),define(ee[233],te([0,1,71,5,23]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J2b=void 0;let O=e.$J2b=class{constructor(P,f){this.b=P,this.c=f,this.a=new Map}async isExtensionUrlTrusted(P,f){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const l=/^(.*)#([^#]+)$/.exec(f);if(!l)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,m,d]=l;let p=this.a.get(P);if(!p){if(p=this.b.trustedExtensionUrlPublicKeys[P],!p||p.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.a.set(P,[...p])}const h=Buffer.from(decodeURIComponent(d),"base64");if(h.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const y=h.slice(0,6),b=h.readUIntBE(0,6),o=Date.now()-b;if(o<0||o>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const g=h.slice(6),a=E.createVerify("SHA256");a.write(y),a.write(Buffer.from(m)),a.end();for(let v=0;v<p.length;v++){let k=p[v];if(k!==null){if(typeof k=="string")try{k=E.createPublicKey({key:Buffer.from(k,"base64"),format:"der",type:"spki"}),p[v]=k}catch(w){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${v+1} for ${P}:`,w),p[v]=null;continue}if(a.verify(k,g))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};e.$J2b=O=pe([x(0,r.$6i),x(1,C.$Ni)],O)}),define(ee[234],te([0,1,8,5]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V2b=void 0;let r=e.$V2b=class{constructor(A,P,f){this.a=A,this.b=P,this.c=f}async inspect(A){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.$sg)(A);const f=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};e.$V2b=r=pe([x(2,C.$Ni)],r)}),define(ee[78],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y2b=void 0,e.$Y2b=(0,E.$lh)("protocolMainService")}),define(ee[44],te([0,1,134,11]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=void 0;class r{constructor(){this.a=new Map}add(A,P){E.ok(C.$ge(A)),E.ok(C.$ie(P)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,P)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Pm=new r}),define(ee[235],te([0,1,4,44]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0,e.$Qm={JSONContribution:"base.contributions.json"};function r(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class O{constructor(){this.b=new E.$5c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,l){this.a[r(f)]=l,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const A=new O;C.$Pm.add(e.$Qm.JSONContribution,A)}),define(ee[57],te([0,1,24,4,11,161,18,235,44]),function(G,e,E,C,r,O,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.ConfigurationScope=e.$Um=e.EditPresentationTypes=void 0;var l;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$Um={Configuration:"base.contributions.configuration"};var m;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.$Vm={properties:{},patternProperties:{}},e.$Wm={properties:{},patternProperties:{}},e.$Xm={properties:{},patternProperties:{}},e.$Ym={properties:{},patternProperties:{}},e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m="vscode://schemas/settings/resourceLanguage",e.$3m="vscode://schemas/settings/configurationDefaults";const d=f.$Pm.as(P.$Qm.JSONContribution);class p{constructor(){this.h=new Set,this.i=new C.$5c,this.onDidSchemaChange=this.i.event,this.j=new C.$5c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},d.registerSchema(e.$2m,this.g),this.v()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const s=new Set;this.n(t,u,s),d.registerSchema(e.$2m,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const u=new Set;this.o(t,u),d.registerSchema(e.$2m,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:t,remove:u}){const s=new Set;this.o(u,s),this.n(t,!1,s),d.registerSchema(e.$2m,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const u=new Set;this.k(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(t,u){const s=[];for(const{overrides:i,source:n}of t)for(const c in i)if(u.add(c),e.$5m.test(c)){const $=this.a.get(c),R=$?.valuesSources??new Map;if(n)for(const j of Object.keys(i[c]))R.set(j,n);const I={...$?.value||{},...i[c]};this.a.set(c,{source:n,value:I,valuesSources:R});const S=(0,A.$2h)(c),M={type:"object",default:I,description:O.localize(1,null,S),$ref:e.$2m,defaultDefaultValue:I,source:r.$ge(n)?void 0:n,defaultValueSource:n};s.push(...b(c)),this.d[c]=M,this.b.properties[c]=M}else{this.a.set(c,{value:i[c],source:n});const $=this.d[c];$&&(this.w(c,$),this.r(c,$))}this.m(s)}deregisterDefaultConfigurations(t){const u=new Set;this.l(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(t,u){for(const{overrides:s,source:i}of t)for(const n in s){const c=this.a.get(n),$=r.$ge(i)?i:i?.id,R=r.$ge(c?.source)?c?.source:c?.source?.id;if($===R)if(u.add(n),this.a.delete(n),e.$5m.test(n))delete this.d[n],delete this.b.properties[n];else{const I=this.d[n];I&&(this.w(n,I),this.r(n,I))}}this.u()}deltaConfiguration(t){let u=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),u=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),u=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const u of t)this.h.add(u);this.u()}n(t,u,s){t.forEach(i=>{this.p(i,u,i.extensionInfo,i.restrictedProperties,void 0,s),this.c.push(i),this.q(i)})}o(t,u){const s=i=>{if(i.properties)for(const n in i.properties){u.add(n);const c=this.d[n];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>s(n))};for(const i of t){s(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,u=!0,s,i,n=3,c){n=r.$pe(t.scope)?n:t.scope;const $=t.properties;if($)for(const I in $){const S=$[I];if(u&&v(I,S)){delete $[I];continue}if(S.source=s,S.defaultDefaultValue=$[I].default,this.w(I,S),e.$5m.test(I)?S.scope=void 0:(S.scope=r.$pe(S.scope)?n:S.scope,S.restricted=r.$pe(S.restricted)?!!i?.includes(I):S.restricted),$[I].hasOwnProperty("included")&&!$[I].included){this.f[I]=$[I],delete $[I];continue}else this.d[I]=$[I],$[I].policy?.name&&this.e.set($[I].policy.name,I);!$[I].deprecationMessage&&$[I].markdownDeprecationMessage&&($[I].deprecationMessage=$[I].markdownDeprecationMessage),c.add(I)}const R=t.allOf;if(R)for(const I of R)this.p(I,u,s,i,n,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const u=s=>{const i=s.properties;if(i)for(const c in i)this.r(c,i[c]);s.allOf?.forEach(u)};u(t)}r(t,u){switch(e.$Vm.properties[t]=u,u.scope){case 1:e.$Wm.properties[t]=u;break;case 2:e.$Xm.properties[t]=u;break;case 6:e.$Ym.properties[t]=u;break;case 3:e.$Zm.properties[t]=u;break;case 4:e.$1m.properties[t]=u;break;case 5:e.$1m.properties[t]=u,this.g.properties[t]=u;break}}s(t,u){switch(delete e.$Vm.properties[t],u.scope){case 1:delete e.$Wm.properties[t];break;case 2:delete e.$Xm.properties[t];break;case 6:delete e.$Ym.properties[t];break;case 3:delete e.$Zm.properties[t];break;case 4:case 5:delete e.$1m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const u=`[${t}]`,s={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$2m};this.w(u,s),e.$Vm.properties[u]=s,e.$Wm.properties[u]=s,e.$Xm.properties[u]=s,e.$Ym.properties[u]=s,e.$Zm.properties[u]=s,e.$1m.properties[u]=s}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$2m};e.$Vm.patternProperties[e.$4m]=t,e.$Wm.patternProperties[e.$4m]=t,e.$Xm.patternProperties[e.$4m]=t,e.$Ym.patternProperties[e.$4m]=t,e.$Zm.patternProperties[e.$4m]=t,e.$1m.patternProperties[e.$4m]=t,this.i.fire()}w(t,u){const s=this.a.get(t);let i=s?.value,n=s?.source;r.$ne(i)&&(i=u.defaultDefaultValue,n=void 0),r.$ne(i)&&(i=g(u.type)),u.default=i,u.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",y=new RegExp(h,"g");e.$4m=`^(${h})+$`,e.$5m=new RegExp(e.$4m);function b(w){const t=[];if(e.$5m.test(w)){let u=y.exec(w);for(;u?.length;){const s=u[1].trim();s&&t.push(s),u=y.exec(w)}}return(0,E.$of)(t)}e.$6m=b;function o(w){return w.reduce((t,u)=>`${t}[${u}]`,"")}e.$7m=o;function g(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$8m=g;const a=new p;f.$Pm.add(e.$Um.Configuration,a);function v(w,t){return w.trim()?e.$5m.test(w)?O.localize(7,null,w):a.getConfigurationProperties()[w]!==void 0?O.localize(8,null,w):t.policy?.name&&a.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,w,t.policy?.name,a.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}e.$9m=v;function k(){const w=[],t=a.getConfigurationProperties();for(const u of Object.keys(t))w.push([u,t[u].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.$0m=k}),define(ee[118],te([0,1,24,4,45,2,35,37,11,7,18,57,44]),function(G,e,E,C,r,O,A,P,f,l,m,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=void 0;function h(u){return Object.isFrozen(u)?u:P.$Em(u)}class y{constructor(s={},i=[],n=[],c){this.b=s,this.c=i,this.d=n,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof y)return i;const n=new b("");return n.parseRaw(i),n.configurationModel});this.f=s.reduce((i,n)=>n===i?n:i.merge(n),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,m.$Zh)(this.contents,s):this.contents}inspect(s,i){const n=this.rawConfiguration.getValue(s),c=i?this.rawConfiguration.getOverrideValue(s,i):void 0,$=i?this.rawConfiguration.override(i).getValue(s):n;return{value:n,override:c,merged:$}}getOverrideValue(s,i){const n=this.i(i);return n?s?(0,m.$Zh)(n,s):n:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const n of this.overrides)n.identifiers.includes(s)&&i.push(...n.keys);return E.$of(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return E.$of(s)}override(s){let i=this.a.get(s);return i||(i=this.g(s),this.a.set(s,i)),i}merge(...s){const i=P.$Dm(this.contents),n=P.$Dm(this.overrides),c=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const R of s)if($.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.h(i,R.contents);for(const I of R.overrides){const[S]=n.filter(M=>E.$$e(M.identifiers,I.identifiers));S?(this.h(S.contents,I.contents),S.keys.push(...I.keys),S.keys=E.$of(S.keys)):n.push(P.$Dm(I))}for(const I of R.keys)c.indexOf(I)===-1&&c.push(I)}return new y(i,c,n,$.every(R=>R instanceof y)?void 0:$)}g(s){const i=this.i(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const c of E.$of([...Object.keys(this.contents),...Object.keys(i)])){let $=this.contents[c];const R=i[c];R&&(typeof $=="object"&&typeof R=="object"?($=P.$Dm($),this.h($,R)):$=R),n[c]=$}return new y(n,this.keys,this.overrides)}h(s,i){for(const n of Object.keys(i)){if(n in s&&f.$ie(s[n])&&f.$ie(i[n])){this.h(s[n],i[n]);continue}s[n]=P.$Dm(i[n])}}i(s){let i=null,n=null;const c=$=>{$&&(n?this.h(n,$):n=P.$Dm($))};for(const $ of this.overrides)E.$$e($.identifiers,[s])?i=$.contents:$.identifiers.includes(s)&&c($.contents);return c(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.j(s,i,!0)}setValue(s,i){this.j(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,m.$Yh)(this.contents,s),d.$5m.test(s)&&this.overrides.splice(this.overrides.findIndex(n=>E.$$e(n.identifiers,(0,d.$6m)(s))),1))}j(s,i,n){(0,m.$Xh)(this.contents,s,i,c=>console.error(c)),n=n||this.keys.indexOf(s)===-1,n&&this.keys.push(s),d.$5m.test(s)&&this.overrides.push({identifiers:(0,d.$6m)(s),keys:Object.keys(this.contents[s]),contents:(0,m.$Wh)(this.contents[s],c=>console.error(c))})}}e.$$m=y;class b{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,i){if(!f.$pe(s)){const n=this.g(s);this.parseRaw(n,i)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,i){this.a=s;const{contents:n,keys:c,overrides:$,restricted:R,hasExcludedProperties:I}=this.h(s,i);this.b=new y(n,c,$,I?[s]:void 0),this.c=R||[]}g(s){let i={},n=null,c=[];const $=[],R=[];function I(M){Array.isArray(c)?c.push(M):n!==null&&(c[n]=M)}const S={onObjectBegin:()=>{const M={};I(M),$.push(c),c=M,n=null},onObjectProperty:M=>{n=M},onObjectEnd:()=>{c=$.pop()},onArrayBegin:()=>{const M=[];I(M),$.push(c),c=M,n=null},onArrayEnd:()=>{c=$.pop()},onLiteralValue:I,onError:(M,j,F)=>{R.push({error:M,offset:j,length:F})}};if(s)try{r.$Am(s,S),i=c[0]||{}}catch(M){console.error(`Error while parsing settings file ${this.f}: ${M}`),this.d=[M]}return i}h(s,i){const n=p.$Pm.as(d.$Um.Configuration).getConfigurationProperties(),c=this.i(s,n,!0,i);s=c.raw;const $=(0,m.$Wh)(s,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),R=Object.keys(s),I=this.j(s,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:$,keys:R,overrides:I,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(s,i,n,c){let $=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:$};const R={},I=[];for(const S in s)if(d.$5m.test(S)&&n){const M=this.i(s[S],i,!1,c);R[S]=M.raw,$=$||M.hasExcludedProperties,I.push(...M.restricted)}else{const M=i[S],j=M?typeof M.scope<"u"?M.scope:3:void 0;M?.restricted&&I.push(S),(j===void 0||c.scopes===void 0||c.scopes.includes(j))&&!(c.skipRestricted&&M?.restricted)?R[S]=s[S]:$=!0}return{raw:R,restricted:I,hasExcludedProperties:$}}j(s,i){const n=[];for(const c of Object.keys(s))if(d.$5m.test(c)){const $={};for(const R in s[c])$[R]=s[c][R];n.push({identifiers:(0,d.$6m)(c),keys:Object.keys($),contents:(0,m.$Wh)($,i)})}return n}}e.$_m=b;class o extends O.$kb{constructor(s,i,n,c){super(),this.f=s,this.g=i,this.h=c,this.c=this.B(new C.$5c),this.onDidChange=this.c.event,this.a=new b(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(n.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(C.Event.any(C.Event.filter(this.h.onDidFilesChange,$=>$.contains(this.f)),C.Event.filter(this.h.onDidRunOperation,$=>($.isOperation(0)||$.isOperation(3)||$.isOperation(1)||$.isOperation(4))&&n.isEqual($.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new y}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$an=o;class g{constructor(s,i,n,c,$,R,I,S,M,j,F,q,re){this.a=s,this.b=i,this.c=n,this.overrideIdentifiers=c,this.d=$,this.f=R,this.g=I,this.h=S,this.i=M,this.j=j,this.k=F,this.l=q,this.m=re}get value(){return h(this.c)}n(s,i,n){const c=s.inspect(i,n);return{get value(){return h(c.value)},get override(){return h(c.override)},get merged(){return h(c.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(s,i,n,c,$=new y,R=new y,I=new A.$ji,S=new y,M=new A.$ji){this.c=s,this.d=i,this.f=n,this.g=c,this.h=$,this.i=R,this.j=I,this.l=S,this.m=M,this.a=null,this.b=new A.$ji,this.n=null}getValue(s,i,n){return this.q(s,i,n).getValue(s)}updateValue(s,i,n={}){let c;n.resource?(c=this.m.get(n.resource),c||(c=new y,this.m.set(n.resource,c))):c=this.l,i===void 0?c.removeValue(s):c.setValue(s,i),n.resource||(this.a=null)}inspect(s,i,n){const c=this.q(s,i,n),$=this.u(i.resource,n),R=i.resource?this.m.get(i.resource)||this.l:this.l,I=new Set;for(const S of c.overrides)for(const M of S.identifiers)c.getOverrideValue(s,M)!==void 0&&I.add(M);return new g(s,i,c.getValue(s),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,$||void 0,R)}keys(s){const i=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,i){this.j.set(s,i),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const n=[];if(!i){const{added:c,updated:$,removed:R}=w(this.c,s);i=[...c,...$,...R]}for(const c of i)for(const $ of(0,d.$6m)(c)){const R=this.c.getKeysForOverrideIdentifier($),I=s.getKeysForOverrideIdentifier($),S=[...I.filter(M=>R.indexOf(M)===-1),...R.filter(M=>I.indexOf(M)===-1),...R.filter(M=>!P.$Hm(this.c.override($).getValue(M),s.override($).getValue(M)))];n.push([$,S])}return this.updateDefaultConfiguration(s),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:n,removed:c}=w(this.d,s),$=[...i,...n,...c];return $.length&&this.updatePolicyConfiguration(s),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:n,removed:c,overrides:$}=w(this.applicationConfiguration,s),R=[...i,...n,...c];return R.length&&this.updateApplicationConfiguration(s),{keys:R,overrides:$}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:n,removed:c,overrides:$}=w(this.localUserConfiguration,s),R=[...i,...n,...c];return R.length&&this.updateLocalUserConfiguration(s),{keys:R,overrides:$}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:n,removed:c,overrides:$}=w(this.remoteUserConfiguration,s),R=[...i,...n,...c];return R.length&&this.updateRemoteUserConfiguration(s),{keys:R,overrides:$}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:n,removed:c,overrides:$}=w(this.workspaceConfiguration,s),R=[...i,...n,...c];return R.length&&this.updateWorkspaceConfiguration(s),{keys:R,overrides:$}}compareAndUpdateFolderConfiguration(s,i){const n=this.p.get(s),{added:c,updated:$,removed:R,overrides:I}=w(n,i),S=[...c,...$,...R];return(S.length||!n)&&this.updateFolderConfiguration(s,i),{keys:S,overrides:I}}compareAndDeleteFolderConfiguration(s){const i=this.p.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:n,updated:c,removed:$,overrides:R}=w(i,void 0);return{keys:[...n,...c,...$],overrides:R}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,i,n){let c=this.r(i,n);return i.overrideIdentifier&&(c=c.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(c=c.merge(this.d)),c}r({resource:s},i){let n=this.s();if(i&&s){const c=i.getFolder(s);c&&(n=this.t(c.uri)||n);const $=this.m.get(s);$&&(n=n.merge($))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let i=this.b.get(s);if(!i){const n=this.s(),c=this.j.get(s);c?(i=n.merge(c),this.b.set(s,i)):i=n}return i}u(s,i){if(i&&s){const n=i.getFolder(s);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,i)=>{const{contents:n,overrides:c,keys:$}=this.j.get(i);return s.push([i,{contents:n,overrides:c,keys:$}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this.i.keys.forEach(i=>s.add(i)),this.j.forEach(i=>i.keys.forEach(n=>s.add(n))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>s.add(n))),[...s.values()]}w(s){const i=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(s).forEach(c=>i.add(c))),[...i.values()]}static parse(s){const i=this.x(s.defaults),n=this.x(s.policy),c=this.x(s.application),$=this.x(s.user),R=this.x(s.workspace),I=s.folders.reduce((S,M)=>(S.set(l.URI.revive(M[0]),this.x(M[1])),S),new A.$ji);return new a(i,n,c,$,new y,R,I,new y,new A.$ji)}static x(s){return new y(s.contents,s.keys,s.overrides)}}e.$bn=a;function v(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const s=new Set,i=new Map;for(const c of u)c.keys.forEach($=>s.add($)),c.overrides.forEach(([$,R])=>{const I=(0,A.$gi)(i,$,new Set);R.forEach(S=>I.add(S))});const n=[];return i.forEach((c,$)=>n.push([$,[...c.values()]])),{keys:[...s.values()],overrides:n}}e.$cn=v;class k{constructor(s,i,n,c){this.change=s,this.f=i,this.g=n,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const $ of s.keys)this.affectedKeys.add($);for(const[,$]of s.overrides)for(const R of $)this.affectedKeys.add(R);this.d=this.a;for(const $ of this.affectedKeys)this.d+=$+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(s,i){const n=this.a+s,c=this.d.indexOf(n);if(c<0)return!1;const $=c+n.length;if($>=this.d.length)return!1;const R=this.d.charCodeAt($);if(R!==this.b&&R!==this.c)return!1;if(i){const I=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.f?.workspace):void 0,S=this.g.getValue(s,i,this.h);return!P.$Hm(I,S)}return!0}}e.$dn=k;function w(u,s){const{added:i,removed:n,updated:c}=t(s?.rawConfiguration,u?.rawConfiguration),$=[],R=u?.getAllOverrideIdentifiers()||[],I=s?.getAllOverrideIdentifiers()||[];if(s){const S=I.filter(M=>!R.includes(M));for(const M of S)$.push([M,s.getKeysForOverrideIdentifier(M)])}if(u){const S=R.filter(M=>!I.includes(M));for(const M of S)$.push([M,u.getKeysForOverrideIdentifier(M)])}if(s&&u){for(const S of R)if(I.includes(S)){const M=t({contents:u.getOverrideValue(void 0,S)||{},keys:u.getKeysForOverrideIdentifier(S)},{contents:s.getOverrideValue(void 0,S)||{},keys:s.getKeysForOverrideIdentifier(S)});$.push([S,[...M.added,...M.removed,...M.updated]])}}return{added:i,removed:n,updated:c,overrides:$}}function t(u,s){const i=u?s?u.keys.filter($=>s.keys.indexOf($)===-1):[...u.keys]:[],n=s?u?s.keys.filter($=>u.keys.indexOf($)===-1):[...s.keys]:[],c=[];if(u&&s){for(const $ of s.keys)if(u.keys.indexOf($)!==-1){const R=(0,m.$Zh)(s.contents,$),I=(0,m.$Zh)(u.contents,$);P.$Hm(R,I)||c.push($)}}return{added:i,removed:n,updated:c}}}),define(ee[236],te([0,1,24,4,2,37,11,118,57,5,39,44]),function(G,e,E,C,r,O,A,P,f,l,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=void 0;class p extends r.$kb{constructor(){super(...arguments),this.a=this.B(new C.$5c),this.onDidChangeConfiguration=this.a.event,this.b=new P.$$m}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(d.$Pm.as(f.$Um.Configuration).onDidUpdateConfiguration(({properties:o,defaultsOverrides:g})=>this.c(Array.from(o),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(o,g){this.h(o,d.$Pm.as(f.$Um.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:o})}f(){return{}}g(){this.b=new P.$$m;const o=d.$Pm.as(f.$Um.Configuration).getConfigurationProperties();this.h(Object.keys(o),o)}h(o,g){const a=this.f();for(const v of o){const k=a[v],w=g[v];k!==void 0?this.b.addValue(v,k):w?this.b.addValue(v,w.default):this.b.removeValue(v)}}}e.$en=p;class h{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=new P.$$m}async initialize(){return this.configurationModel}}e.$fn=h;let y=e.$gn=class extends r.$kb{get configurationModel(){return this.b}constructor(o,g,a){super(),this.c=o,this.f=g,this.g=a,this.a=this.B(new C.$5c),this.onDidChangeConfiguration=this.a.event,this.b=new P.$$m}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(o=>this.i(o))),this.B(this.c.onDidChangeConfiguration(async({properties:o})=>this.j(await this.h(o),!0))),this.b}async h(o){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",o);const g={},a=[],v=d.$Pm.as(f.$Um.Configuration).getConfigurationProperties();for(const k of o){const w=v[k];if(!w){a.push(k);continue}if(w.policy){if(w.type!=="string"&&w.type!=="number"){this.g.warn(`Policy ${w.policy.name} has unsupported type ${w.type}`);continue}a.push(k),g[w.policy.name]={type:w.type}}}return(0,A.$te)(g)||await this.f.updatePolicyDefinitions(g),a}i(o){this.g.trace("PolicyConfiguration#onDidChangePolicies",o);const g=d.$Pm.as(f.$Um.Configuration).getPolicyConfigurations(),a=(0,E.$jf)(o.map(v=>g.get(v)));this.j(a,!0)}j(o,g){this.g.trace("PolicyConfiguration#update",o);const a=d.$Pm.as(f.$Um.Configuration).getConfigurationProperties(),v=[],k=this.b.isEmpty();for(const w of o){const t=a[w]?.policy?.name;if(t){const u=this.f.getPolicyValue(t);(k?u!==void 0:!(0,O.$Hm)(this.b.getValue(w),u))&&v.push([w,u])}else this.b.getValue(w)!==void 0&&v.push([w,void 0])}if(v.length){this.g.trace("PolicyConfiguration#changed",v);const w=this.b;this.b=new P.$$m;for(const t of w.keys)this.b.setValue(t,w.getValue(t));for(const[t,u]of v)u===void 0?this.b.removeValue(t):this.b.setValue(t,u);g&&this.a.fire(this.b)}}};e.$gn=y=pe([x(1,m.$Rm),x(2,l.$Ni)],y)}),define(ee[237],te([0,1,8,4,2,19,18,118,236,39]),function(G,e,E,C,r,O,A,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0;class m extends r.$kb{constructor(p,h,y,b){super(),this.i=p,this.h=this.B(new C.$5c),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$en),this.c=y instanceof l.$Tm?new f.$fn:this.B(new f.$gn(this.b,y,b)),this.f=this.B(new P.$an(this.i,void 0,O.$Wf,h)),this.a=new P.$bn(this.b.configurationModel,this.c.configurationModel,new P.$$m,new P.$$m),this.g=this.B(new E.$Cg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:o,properties:g})=>this.k(o,g))),this.B(this.c.onDidChangeConfiguration(o=>this.l(o))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,h,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$bn(p,h,new P.$$m,y)}getConfigurationData(){return this.a.toData()}getValue(p,h){const y=typeof p=="string"?p:void 0,b=(0,A.$Sh)(p)?p:(0,A.$Sh)(h)?h:{};return this.a.getValue(y,b,void 0)}updateValue(p,h,y,b){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const h=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(y,h,2)}k(p,h){const y=this.a.toData(),b=this.a.compareAndUpdateDefaultConfiguration(p,h);this.m(b,y,7)}l(p){const h=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(p);this.m(y,h,7)}m(p,h,y){const b=new P.$dn(p,{data:h},this.a);b.source=y,b.sourceConfig=this.n(y),this.h.fire(b)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$hn=m}),define(ee[238],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$23b=e.$13b=e.$Z3b=void 0,e.$Z3b="request",e.$13b="remoteResourceHandler";class E{async routeCall(r,O,A){if(O!==e.$Z3b)throw new Error(`Call not found: ${O}`);const P=A[0];if(P?.authority){const f=r.connections.find(l=>l.ctx===P.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(r,O){throw new Error(`Event not found: ${O}`)}}e.$23b=E}),define(ee[239],te([0,1,13,6]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=e.RemoteAuthorityResolverErrorCode=e.$uk=e.$tk=e.RemoteConnectionType=e.$sk=void 0,e.$sk=(0,C.$lh)("remoteAuthorityResolverService");var r;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class O{constructor(d){this.id=d,this.type=1}toString(){return`Managed(${this.id})`}}e.$tk=O;class A{constructor(d,p){this.host=d,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$uk=A;var P;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class f extends E.$_{static isNotAvailable(d){return d instanceof f&&d._code===P.NotAvailable}static isTemporarilyNotAvailable(d){return d instanceof f&&d._code===P.TemporarilyNotAvailable}static isNoResolverFound(d){return d instanceof f&&d._code===P.NoResolverFound}static isHandled(d){return d instanceof f&&d.isHandled}constructor(d,p=P.Unknown,h){super(d),this._message=d,this._code=p,this._detail=h,this.isHandled=p===P.NotAvailable&&h===!0,Object.setPrototypeOf(this,f.prototype)}}e.$vk=f;function l(m){const d=m.indexOf("+");return d===-1?m:m.substring(0,d)}e.$wk=l}),define(ee[58],te([0,1,15]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=void 0;function C(l){return l.scheme===E.Schemas.vscodeRemote?l.authority:void 0}e.$xk=C;function r(l){if(!l)return;const m=l.indexOf("+");return m<0?l:l.substr(0,m)}e.$yk=r;function O(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$zk=O;function A(l){const{host:m,port:d}=f(l);if(typeof d>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:d}}e.$Ak=A;function P(l,m){let{host:d,port:p}=f(l);return typeof p>"u"&&(p=m),{host:d,port:p}}e.$Bk=P;function f(l){const m=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const d=l.match(/^(\[[0-9a-z:]+\])$/);if(d)return{host:d[1],port:void 0};const p=l.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:l,port:void 0}}}),define(ee[119],te([0,1,25,6,58]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.TargetPlatform=e.ExtensionType=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=void 0,e.$xl="extensions.user.cache",e.$yl="extensions.builtin.cache",e.$zl="undefined_publisher",e.$Al=["ui","workspace","web"];function O(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$Bl=O,e.$Cl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(A||(e.ExtensionType=A={}));var P;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class f{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,g){if(typeof o>"u"||o===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof o=="string"||typeof g=="string"){const a=typeof o=="string"?o:o.value,v=typeof g=="string"?g:g.value;return E.$Jd(a,v)}return o._lower===g._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Dl=f;class l{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const g of o)this.add(g)}add(o){this.c.add(f.toKey(o))}delete(o){return this.c.delete(f.toKey(o))}has(o){return this.c.has(f.toKey(o))}}e.$El=l;class m{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(f.toKey(o))}get(o){return this.c.get(f.toKey(o))}has(o){return this.c.has(f.toKey(o))}set(o,g){this.c.set(f.toKey(o),g)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fl=m;function d(b){return p(b)}e.$Gl=d;function p(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.$Hl=p;function h(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.$Il=h;function y(b,o){if(o){const g=`onResolveRemoteAuthority:${(0,r.$yk)(o)}`;return!!b.activationEvents?.includes(g)}return!1}e.$Jl=y,e.$Kl=(0,C.$lh)("IBuiltinExtensionsScannerService")}),define(ee[240],te([0,1,8,17,21,13,4,2,65,85,31,108,239,58]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.PersistentConnectionEventType=e.$Ik=e.$Hk=e.$Gk=e.ConnectionType=void 0;const y=30*1e3;var b;(function(L){L[L.Management=1]="Management",L[L.ExtensionHost=2]="ExtensionHost",L[L.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function o(L){switch(L){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(L){const D=new r.$bd;return setTimeout(()=>D.cancel(),L),D.token}function a(L,D){if(L.isCancellationRequested||D.isCancellationRequested)return r.CancellationToken.Cancelled;const U=new r.$bd;return L.onCancellationRequested(()=>U.cancel()),D.onCancellationRequested(()=>U.cancel()),U.token}class v{get didTimeout(){return this.c==="timedout"}constructor(D){this.c="pending",this.d=new P.$jb,this.promise=new Promise((U,H)=>{this.f=U,this.g=H}),D.isCancellationRequested?this.h():this.d.add(D.onCancellationRequested(()=>this.h()))}registerDisposable(D){this.c==="pending"?this.d.add(D):D.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const D=new Error("Time limit reached");return D.code="ETIMEDOUT",D.syscall="connect",D}resolve(D){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(D))}reject(D){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(D))}}function k(L,D){const U=new v(D);return U.registerDisposable(L.onControlMessage(H=>{const V=JSON.parse(H.toString()),z=W(V);z?U.reject(z):U.resolve(V)})),U.promise}function w(L,D,U,H,V,z,B,X){const se=new v(X),ce=l.$1c.create(!1);return L.info(`Creating a socket (${B})...`),f.mark(`code/willCreateSocket/${z}`),D.connect(U,H,V,B).then(ge=>{se.didTimeout?(f.mark(`code/didCreateSocketError/${z}`),L.info(`Creating a socket (${B}) finished after ${ce.elapsed()} ms, but this is too late and has timed out already.`),ge?.dispose()):(f.mark(`code/didCreateSocketOK/${z}`),L.info(`Creating a socket (${B}) was successful after ${ce.elapsed()} ms.`),se.resolve(ge))},ge=>{f.mark(`code/didCreateSocketError/${z}`),L.info(`Creating a socket (${B}) returned an error after ${ce.elapsed()} ms.`),L.error(ge),se.reject(ge)}),se.promise}function t(L,D){const U=new v(D);return L.then(H=>{U.didTimeout||U.resolve(H)},H=>{U.didTimeout||U.reject(H)}),U.promise}async function u(L,D,U,H){const V=ae(L,D);L.logService.trace(`${V} 1/6. invoking socketFactory.connect().`);let z;try{z=await w(L.logService,L.remoteSocketFactoryService,L.connectTo,(0,h.$zk)(L),`reconnectionToken=${L.reconnectionToken}&reconnection=${L.reconnectionProtocol?"true":"false"}`,o(D),`renderer-${o(D)}-${L.reconnectionToken}`,H)}catch(ge){throw L.logService.error(`${V} socketFactory.connect() failed or timed out. Error:`),L.logService.error(ge),ge}L.logService.trace(`${V} 2/6. socketFactory.connect() was successful.`);let B,X;L.reconnectionProtocol?(L.reconnectionProtocol.beginAcceptReconnection(z,null),B=L.reconnectionProtocol,X=!1):(B=new d.$_g({socket:z}),X=!0),L.logService.trace(`${V} 3/6. sending AuthRequest control message.`);const se=await t(L.signService.createNewMessage((0,m.$3e)()),H),ce={type:"auth",auth:L.connectionToken||"00000000000000000000",data:se.data};B.sendControl(C.$Ib.fromString(JSON.stringify(ce)));try{const ge=await k(B,a(H,g(1e4)));if(ge.type!=="sign"||typeof ge.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(L.logService.trace(`${V} 4/6. received SignRequest control message.`),!await t(L.signService.validate(se,ge.signedData),H)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const Ae=await t(L.signService.sign(ge.data),H),Ce={type:"connectionType",commit:L.commit,signedData:Ae,desiredConnectionType:D};return U&&(Ce.args=U),L.logService.trace(`${V} 5/6. sending ConnectionTypeRequest control message.`),B.sendControl(C.$Ib.fromString(JSON.stringify(Ce))),{protocol:B,ownsProtocol:X}}catch(ge){throw ge&&ge.code==="ETIMEDOUT"&&(L.logService.error(`${V} the handshake timed out. Error:`),L.logService.error(ge)),ge&&ge.code==="VSCODE_CONNECTION_ERROR"&&(L.logService.error(`${V} received error control message when negotiating connection. Error:`),L.logService.error(ge)),X&&N(B),ge}}async function s(L,D,U,H){const V=Date.now(),z=ae(L,D),{protocol:B,ownsProtocol:X}=await u(L,D,U,H),se=new v(H);return se.registerDisposable(B.onControlMessage(ce=>{const ge=JSON.parse(ce.toString()),Ie=W(ge);Ie?(L.logService.error(`${z} received error control message when negotiating connection. Error:`),L.logService.error(Ie),X&&N(B),se.reject(Ie)):(L.reconnectionProtocol?.endAcceptReconnection(),L.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${oe(V)}!`),se.resolve({protocol:B,firstMessage:ge}))})),se.promise}async function i(L,D){const{protocol:U}=await s(L,1,void 0,D);return{protocol:U}}async function n(L,D,U){const{protocol:H,firstMessage:V}=await s(L,2,D,U),z=V&&V.debugPort;return{protocol:H,debugPort:z}}async function c(L,D,U){const H=Date.now(),V=ae(L,3),{protocol:z}=await u(L,3,D,U);return L.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${oe(H)}!`),z}async function $(L,D,U){const{connectTo:H,connectionToken:V}=await L.addressProvider.getAddress();return{commit:L.commit,quality:L.quality,connectTo:H,connectionToken:V,reconnectionToken:D,reconnectionProtocol:U,remoteSocketFactoryService:L.remoteSocketFactoryService,signService:L.signService,logService:L.logService}}async function R(L,D,U){return S(L,async H=>{const{protocol:V}=await i(H,r.CancellationToken.None);return new K(L,D,U,H.reconnectionToken,V)})}e.$Gk=R;async function I(L,D){return S(L,async U=>{const{protocol:H,debugPort:V}=await n(U,D,r.CancellationToken.None);return new Y(L,D,U.reconnectionToken,H,V)})}e.$Hk=I;async function S(L,D){for(let H=1;;H++)try{const V=(0,m.$3e)(),z=await $(L,V,null);return await D(z)}catch(V){if(H<5)L.logService.error(`[remote-connection][attempt ${H}] An error occurred in initial connection! Will retry... Error:`),L.logService.error(V);else throw L.logService.error(`[remote-connection][attempt ${H}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),L.logService.error(V),le.triggerPermanentFailure(0,0,p.$vk.isHandled(V)),V}}async function M(L,D,U){const H=await $(L,(0,m.$3e)(),null);return await c(H,{host:D,port:U},r.CancellationToken.None)}e.$Ik=M;function j(L){return(0,E.$fg)(D=>new Promise((U,H)=>{const V=setTimeout(U,L*1e3);D.onCancellationRequested(()=>{clearTimeout(V),U()})}))}var F;(function(L){L[L.ConnectionLost=0]="ConnectionLost",L[L.ReconnectionWait=1]="ReconnectionWait",L[L.ReconnectionRunning=2]="ReconnectionRunning",L[L.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",L[L.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class q{constructor(D,U){this.reconnectionToken=D,this.millisSinceLastIncomingData=U,this.type=0}}e.$Jk=q;class re{constructor(D,U,H,V){this.reconnectionToken=D,this.millisSinceLastIncomingData=U,this.durationSeconds=H,this.c=V,this.type=1}skipWait(){this.c.cancel()}}e.$Kk=re;class ie{constructor(D,U,H){this.reconnectionToken=D,this.millisSinceLastIncomingData=U,this.attempt=H,this.type=2}}e.$Lk=ie;class ne{constructor(D,U,H){this.reconnectionToken=D,this.millisSinceLastIncomingData=U,this.attempt=H,this.type=4}}e.$Mk=ne;class ue{constructor(D,U,H,V){this.reconnectionToken=D,this.millisSinceLastIncomingData=U,this.attempt=H,this.handled=V,this.type=3}}e.$Nk=ue;class le extends P.$kb{static triggerPermanentFailure(D,U,H){this._permanentFailure=!0,this.f=D,this.g=U,this.h=H,this.i.forEach(V=>V.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(D=>D.s())}static debugPauseSocketWriting(){this.i.forEach(D=>D.w())}get k(){return this.c||le._permanentFailure}constructor(D,U,H,V,z){super(),this.n=D,this.p=U,this.reconnectionToken=H,this.protocol=V,this.r=z,this.j=this.B(new A.$5c),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new ne(this.reconnectionToken,0,0)),this.B(V.onSocketClose(B=>{const X=Q(this.n,this.reconnectionToken,!0);B?B.type===0?(this.p.logService.info(`${X} received socket close event (hadError: ${B.hadError}).`),B.error&&this.p.logService.error(B.error)):(this.p.logService.info(`${X} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this.p.logService.error(B.event)):this.p.logService.info(`${X} received socket close event.`),this.s()})),this.B(V.onSocketTimeout(B=>{const X=Q(this.n,this.reconnectionToken,!0);this.p.logService.info(`${X} received socket timeout event (unacknowledgedMsgCount: ${B.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${B.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${B.timeSinceLastReceivedSomeData}).`),this.s()})),le.i.push(this),this.B((0,P.$ib)(()=>{const B=le.i.indexOf(this);B>=0&&le.i.splice(B,1)})),this.k&&this.v(le.f,le.g,le.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const D=Q(this.n,this.reconnectionToken,!0);this.p.logService.info(`${D} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let H=-1;do{H++;const V=H<U.length?U[H]:U[U.length-1];try{if(V>0){const B=j(V);this.j.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V,B)),this.p.logService.info(`${D} waiting for ${V} seconds before reconnecting...`);try{await B}catch{}}if(this.k){this.p.logService.error(`${D} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1)),this.p.logService.info(`${D} resolving connection...`);const z=await $(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${D} connecting to ${z.connectTo}...`),await this.y(z,g(y)),this.p.logService.info(`${D} reconnected!`),this.j.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${D} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(H>360){this.p.logService.error(`${D} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(p.$vk.isTemporarilyNotAvailable(z)){this.p.logService.info(`${D} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.p.logService.info(`${D} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(z);continue}if((0,O.$1)(z)){this.p.logService.info(`${D} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(z);continue}if(z instanceof p.$vk){this.p.logService.error(`${D} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),H+1,p.$vk.isHandled(z));break}this.p.logService.error(`${D} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}}while(!this.k&&!this.m)}u(D,U,H){this.r?le.triggerPermanentFailure(D,U,H):this.v(D,U,H)}v(D,U,H){this.j.fire(new ue(this.reconnectionToken,D,U,H)),N(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.$Ok=le,le._permanentFailure=!1,le.f=0,le.g=0,le.h=!1,le.i=[];class K extends le{constructor(D,U,H,V,z){super(1,D,V,z,!0),this.client=this.B(new d.$0g(z,{remoteAuthority:U,clientId:H},D.ipcLogger))}async y(D,U){await i(D,U)}}e.$Pk=K;class Y extends le{constructor(D,U,H,V,z){super(2,D,H,V,!1),this.z=U,this.debugPort=z}async y(D,U){await n(D,this.z,U)}}e.$Qk=Y;function N(L){try{L.acceptDisconnect();const D=L.getSocket();L.dispose(),D.dispose()}catch(D){(0,O.$X)(D)}}function W(L){if(L&&L.type==="error"){const D=new Error(`Connection error: ${L.reason}`);return D.code="VSCODE_CONNECTION_ERROR",D}return null}function T(L,D){for(;L.length<D;)L+=" ";return L}function J(L,D){return`[remote-connection][${T(o(L),13)}][${D.substr(0,5)}\u2026]`}function Q(L,D,U){return`${J(L,D)}[${U?"reconnect":"initial"}]`}function ae(L,D){return`${Q(D,L.reconnectionToken,!!L.reconnectionProtocol)}[${L.connectTo}]`}function oe(L){return`${Date.now()-L} ms`}}),define(ee[241],te([0,1,2,6]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.$Ck=void 0,e.$Ck=(0,C.$lh)("remoteSocketFactoryService");class r{constructor(){this.a={}}register(A,P){return this.a[A]??=[],this.a[A].push(P),(0,E.$ib)(()=>{const f=this.a[A]?.indexOf(P);typeof f=="number"&&f>=0&&this.a[A]?.splice(f,1)})}b(A){return(this.a[A.type]||[]).find(f=>f.supports(A))}connect(A,P,f,l){const m=this.b(A);if(!m)throw new Error(`No socket factory found for ${A}`);return m.connect(A,P,f,l)}}e.$Dk=r}),define(ee[242],te([0,1,27,47,42,112]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U2b=void 0;let A;async function P(h=!1){return(A===void 0||h)&&(A=f()),A}e.$U2b=P;async function f(){const h=l();if(h===void 0)return!1;if(h>=22e3){const y=d();if(y)return new Promise(b=>{C.execFile(y,["--status"],o=>b(!o))})}else{const y=p();if(y)try{if((await r.promises.stat(y)).isFile())return!0}catch{}}return!1}function l(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(h)return parseInt(h[3])}function m(h){const y=process.env.SystemRoot;if(y){const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return O.join(y,b?"Sysnative":"System32",h)}}function d(){return m("wsl.exe")}function p(){return m("lxss\\LxssManager.dll")}}),define(ee[51],te([0,1,17,13,2,181,57,6,5,44]),function(G,e,E,C,r,O,A,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=void 0,e.$uo=(0,P.$lh)("requestService");class m{constructor(w){this.b=w}toJSON(){if(!this.a){const w=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?w[t]="*****":w[t]=this.b[t];this.a=w}return this.a}}class d extends r.$kb{constructor(w){super(),this.b=0,this.a=w.createLogger("network",{name:(0,O.localize)(0,null),when:f.$5i.isEqualTo((0,f.$3i)(f.LogLevel.Trace)).serialize()})}async c(w,t,u){const s=`${w} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new m(t.headers??{}));try{const i=await u();return this.a.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${s} - error`,t.type,(0,C.$8)(i)),i}}}e.$vo=d;function p(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}e.$wo=p;function h(k){return k.res.statusCode===204}async function y(k){return h(k)?null:(await(0,E.$Tb)(k.stream)).toString()}e.$xo=y;async function b(k){if(!p(k))throw new Error("Server returned "+k.res.statusCode);return y(k)}e.$yo=b;async function o(k){if(!p(k))throw new Error("Server returned "+k.res.statusCode);if(h(k))return null;const t=(await(0,E.$Tb)(k.stream)).toString();try{return JSON.parse(t)}catch(u){throw u.message+=`:
`+t,u}}e.$zo=o;function g(k){v(k)}e.$Ao=g;let a;function v(k){const w=l.$Pm.as(A.$Um.Configuration),t=a;a={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(5,null),(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null)],default:"override",description:(0,O.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(10,null),restricted:!0}}},w.updateConfigurations({add:[a],remove:t?[t]:[]})}v(1)}),define(ee[243],te([0,1,17,21]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=void 0;class r{constructor(P){this.a=P}listen(P,f){throw new Error("Invalid listen")}call(P,f,l,m=C.CancellationToken.None){switch(f){case"request":return this.a.request(l[0],m).then(async({res:d,stream:p})=>{const h=await(0,E.$Tb)(p);return[{statusCode:d.statusCode,headers:d.headers},h]});case"resolveProxy":return this.a.resolveProxy(l[0])}throw new Error("Invalid call")}}e.$wq=r;class O{constructor(P){this.a=P}async request(P,f){const[l,m]=await this.a.call("request",[P],f);return{res:l,stream:(0,E.$Vb)(m)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.$xq=O}),define(ee[244],te([0,1,245,11]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=void 0;function r(A,P){return A.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:A.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function O(A,P,f={}){const l=(0,E.parse)(A),m=f.proxyUrl||r(l,P);if(!m)return null;const d=(0,E.parse)(m);if(!/^https?:$/.test(d.protocol||""))return null;const p={host:d.hostname||"",port:d.port||(d.protocol==="https"?"443":"80"),auth:d.auth,rejectUnauthorized:(0,C.$me)(f.strictSSL)?f.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((h,y)=>{G(["http-proxy-agent"],h,y)}))(p):new(await new Promise((h,y)=>{G(["https-proxy-agent"],h,y)}))(p)}e.$yq=O}),define(ee[94],te([0,1,47,9,182,21,50,13,3,31,155,63,8,137]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=void 0;let y;async function b(g,a,v,k){return v["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$i?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,d.$ol)(k)&&!v["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,d.$ol)(k)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=p.Promises.withAsyncBody(async(w,t)=>{const u=new O.$bd;let s=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,h.$pl)(i,1,120)*1e3);const n=setTimeout(()=>{u.dispose(!0),t(new Error((0,r.localize)(0,null)))},s);try{w(await o(a,u.token))}catch(c){!(0,P.$1)(c)&&!u.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,A.$9h)(c)))):w({})}finally{clearTimeout(n),u.dispose()}})),y)}e.$ul=b;async function o(g,a){const v=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",v);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",k);const w=(0,l.$3e)().replace(/-/g,"").substr(0,12),t=new RegExp(w+"({.*})"+w),u={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",u);const s=await(0,m.$fl)(f.OS,u);return g.trace("getUnixShellEnvironment#shell",s),new Promise((i,n)=>{if(a.isCancellationRequested)return n(new P.$2);const c=(0,C.$cc)(s);let $,R;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?($=`& '${process.execPath}' ${I} -p '''${w}'' + JSON.stringify(process.env) + ''${w}'''`,R=["-Login","-Command"]):c==="nu"?($=`^'${process.execPath}' ${I} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,R=["-i","-l","-c"]):($=`'${process.execPath}' ${I} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,c==="tcsh"||c==="csh"?R=["-ic"]:R=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),$);const S=(0,E.spawn)(s,[...R,$],{detached:!0,stdio:["ignore","pipe","pipe"],env:u});a.onCancellationRequested(()=>(S.kill(),n(new P.$2))),S.on("error",F=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,A.$9h)(F)),n(F)});const M=[];S.stdout.on("data",F=>M.push(F));const j=[];S.stderr.on("data",F=>j.push(F)),S.on("close",(F,q)=>{const re=Buffer.concat(M).toString("utf8");g.trace("getUnixShellEnvironment#raw",re);const ie=Buffer.concat(j).toString("utf8");if(ie.trim()&&g.trace("getUnixShellEnvironment#stderr",ie),F||q)return n(new Error((0,r.localize)(2,null,F,q)));const ne=t.exec(re),ue=ne?ne[1]:"{}";try{const le=JSON.parse(ue);v?le.ELECTRON_RUN_AS_NODE=v:delete le.ELECTRON_RUN_AS_NODE,k?le.ELECTRON_NO_ATTACH_CONSOLE=k:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",le),i(le)}catch(le){g.error("getUnixShellEnvironment#errorCaught",(0,A.$9h)(le)),n(le)}})})}}),define(ee[246],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pYb=void 0;class E{constructor(){this.b=new Map}async createNewMessage(r){try{const O=await this.c();if(O){const A=String(E.a++);return this.b.set(A,O),{id:A,data:O.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,O){if(!r.id)return!0;const A=this.b.get(r.id);if(!A)return!1;this.b.delete(r.id);try{return A.validate(O)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(r){try{return await this.d(r)}catch{}return r}}e.$pYb=E,E.a=1}),define(ee[95],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=void 0,e.$Ek="signService",e.$Fk=(0,E.$lh)(e.$Ek)}),define(ee[247],te([0,1,246]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$03b=void 0;class C extends E.$pYb{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(A=>new A.signer().sign(O))}h(){return new Promise((O,A)=>G(["vsda"],O,A))}}e.$03b=C}),define(ee[34],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$nM=void 0,e.$nM=(0,E.$lh)("stateReadService"),e.$oM=(0,E.$lh)("stateService")}),define(ee[120],te([0,1,8,17,11,33,16,5]),function(G,e,E,C,r,O,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=e.$pM=e.SaveStrategy=void 0;var f;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(f||(e.SaveStrategy=f={}));class l{constructor(h,y,b,o){this.f=h,this.g=b,this.h=o,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=y===0?void 0:new E.$pg(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(h){h.fileOperationResult!==1&&this.g.error(h)}}getItem(h,y){const b=this.a[h];return(0,r.$pe)(b)?y:b}setItem(h,y){this.setItems([{key:h,data:y}])}setItems(h){let y=!1;for(const{key:b,data:o}of h)this.a[b]!==o&&((0,r.$pe)(o)?(0,r.$ne)(this.a[b])||(this.a[b]=void 0,y=!0):(this.a[b]=o,y=!0));y&&this.j()}removeItem(h){(0,r.$ne)(this.a[h])||(this.a[h]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const h=JSON.stringify(this.a,null,4);if(h!==this.b)try{await this.h.writeFile(this.f,C.$Ib.fromString(h),{atomic:{postfix:".vsctmp"}}),this.b=h}catch(y){this.g.error(y)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.$pM=l;let m=e.$qM=class{constructor(h,y,b,o){this.a=new l(y.stateResource,h,b,o)}async init(){await this.a.init()}getItem(h,y){return this.a.getItem(h,y)}};e.$qM=m=pe([x(1,O.$sh),x(2,P.$Ni),x(3,A.$Oj)],m);class d extends m{setItem(h,y){this.a.setItem(h,y)}setItems(h){this.a.setItems(h)}removeItem(h){this.a.removeItem(h)}close(){return this.a.close()}}e.$rM=d}),define(ee[121],te([0,1,3,36,31]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=void 0;function O(f){if(E.$t===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function A(f,l,m,d,p,h,y,b){const o=Object.create(null);o["common.machineId"]=h,o.sessionID=(0,r.$3e)()+Date.now(),o.commitHash=d,o.version=p,o["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,E.$h)(E.$t),o["common.nodePlatform"]=C.$5b,o["common.nodeArch"]=m,o["common.product"]=b||"desktop",y&&(o["common.msftInternal"]=y);let g=0;const a=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),E.$l&&(o["common.snap"]="true");const v=O(l);return v&&(o["common.platformDetail"]=v),o}e.$Vn=A;function P(f){const l=C.env.USERDNSDOMAIN;if(!l)return!1;const m=l.toLowerCase();return f.some(d=>m===d)}e.$Wn=P}),define(ee[26],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0,e.$Rk=(0,E.$lh)("telemetryService"),e.$Sk=(0,E.$lh)("customEndpointTelemetryService"),e.$Tk="telemetry.currentSessionDate",e.$Uk="telemetry.firstSessionDate",e.$Vk="telemetry.lastSessionDate",e.$Wk="telemetry.machineId",e.$Xk="telemetry",e.$Yk="telemetry.telemetryLevel",e.$Zk="telemetry.enableCrashReporter",e.$1k="telemetry.enableTelemetry";var C;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var r;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(ee[248],te([0,1,27,8,45,15,9,3,7,86,22,107,90,16,23,26]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=e.$cr=void 0;const o=new Map;async function g(t,u){const s=`${t}::${u.join(":")}`,i=o.get(s);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,$=new Map,R=2e4;function I(M,j,F,q){const re=j.substring(M.length+1);return C.Promises.withAsyncBody(async ie=>{let ne;try{ne=await m.Promises.readdir(j,{withFileTypes:!0})}catch{ie();return}if(q.count>=R){q.count+=ne.length,q.maxReached=!0,ie();return}let ue=ne.length;if(ue===0){ie();return}let le=ne;q.count+ne.length>R&&(q.maxReached=!0,ue=R-q.count,le=ne.slice(0,ue)),q.count+=ne.length;for(const K of le)if(K.isDirectory()){if(F.includes(K.name)||await I(M,(0,A.$$b)(j,K.name),F,q),--ue===0){ie();return}}else{const Y=K.name.lastIndexOf(".");if(Y>=0){const N=K.name.substring(Y+1);N&&c.set(N,(c.get(N)??0)+1)}for(const N of n)N.relativePathPattern?.test(re)!==!1&&N.filePattern.test(K.name)&&$.set(N.tag,($.get(N.tag)??0)+1);if(--ue===0){ie();return}}})}const S=C.Promises.withAsyncBody(async M=>{const j={count:0,maxReached:!1};await I(t,t,u,j);const F=await k(t);M({configFiles:a($),fileTypes:a(c),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:F})});return o.set(s,S),S}e.$cr=g;function a(t){return Array.from(t.entries(),([u,s])=>({name:u,count:s})).sort((u,s)=>s.count-u.count)}function v(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/h.$jk.GB).toFixed(2)}GB (${(E.freemem()/h.$jk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.$pm.value()*100)}%`},u=E.cpus();return u&&u.length>0&&(t.cpus=`${u[0].model} (${u.length} x ${u[0].speed})`),t}e.$dr=v;async function k(t){try{const u=new Map,s=(0,A.$$b)(t,".vscode","launch.json"),i=await m.Promises.readFile(s),n=[],c=(0,r.$tm)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${s}`),[];if((0,r.$Cm)(c)==="object"&&c.configurations)for(const $ of c.configurations){const R=$.type;R&&(u.has(R)?u.set(R,u.get(R)+1):u.set(R,1))}return a(u)}catch{return[]}}e.$er=k;let w=e.$fr=class{constructor(u,s){this.c=u,this.d=s}f(u){const s=[];return s.push(`OS Version:       ${u.os}`),s.push(`CPUs:             ${u.cpus}`),s.push(`Memory (System):  ${u.memory}`),s.push(`VM:               ${u.vmHint}`),s.join(`
`)}g(u){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const i=E.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(E.totalmem()/h.$jk.GB).toFixed(2)}GB (${(E.freemem()/h.$jk.GB).toFixed(2)}GB free)`),P.$i||s.push(`Load (avg):       ${E.loadavg().map(n=>Math.round(n)).join(", ")}`),s.push(`VM:               ${Math.round(l.$pm.value()*100)}%`),s.push(`Screen Reader:    ${u.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${u.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(u.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(u,s){return Promise.all([(0,d.$br)(u.mainPID),this.k(u)]).then(async i=>{let[n,c]=i,$=this.m(u,n);return s.forEach(R=>{if((0,p.$2l)(R))$+=`
${R.errorMessage}`,c+=`
${R.errorMessage}`;else if($+=`

Remote: ${R.hostName}`,R.processes&&($+=`
${this.m(u,R.processes)}`),R.workspaceMetadata){c+=`
|  Remote: ${R.hostName}`;for(const I of Object.keys(R.workspaceMetadata)){const S=R.workspaceMetadata[I];let M=`${S.fileCount} files`;S.maxFilesReached&&(M=`more than ${M}`),c+=`|    Folder (${I}): ${M}`,c+=this.h(S)}}}),{processInfo:$,workspaceInfo:c}})}async getSystemInfo(u,s){const{memory:i,vmHint:n,os:c,cpus:$}=v(),R={os:c,memory:i,cpus:$,vmHint:n,processArgs:`${u.mainArguments.join(" ")}`,gpuStatus:u.gpuFeatureStatus,screenReader:`${u.screenReader?"yes":"no"}`,remoteData:s};return P.$i||(R.load=`${E.loadavg().map(I=>Math.round(I)).join(", ")}`),P.$k&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(u,s){const i=[];return(0,d.$br)(u.mainPID).then(async n=>(i.push(""),i.push(this.g(u)),i.push(""),i.push(this.m(u,n)),u.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(u))),s.forEach(c=>{if((0,p.$2l)(c))i.push(`
${c.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${c.hostName}`),i.push(this.f(c.machineInfo)),c.processes&&i.push(this.m(u,c.processes)),c.workspaceMetadata)for(const $ of Object.keys(c.workspaceMetadata)){const R=c.workspaceMetadata[$];let I=`${R.fileCount} files`;R.maxFilesReached&&(I=`more than ${I}`),i.push(`Folder (${$}): ${I}`),i.push(this.h(R))}}),i.push(""),i.push(""),i.join(`
`)))}h(u){const s=[];let n=0;const c=(S,M)=>{const j=` ${S}(${M})`;n+j.length>60?(s.push($),$="|                 ",n=$.length):n+=j.length,$+=j};let $="|      File types:";const R=10,I=u.fileTypes.length>R?R:u.fileTypes.length;for(let S=0;S<I;S++){const M=u.fileTypes[S];c(M.name,M.count)}if(s.push($),u.configFiles.length>=0&&($="|      Conf files:",n=0,u.configFiles.forEach(S=>{c(S.name,S.count)}),s.push($)),u.launchConfigFiles.length>0){let S="|      Launch Configs:";u.launchConfigFiles.forEach(M=>{const j=M.count>1?` ${M.name}(${M.count})`:` ${M.name}`;S+=j}),s.push(S)}return s.join(`
`)}j(u){const s=Math.max(...Object.keys(u).map(i=>i.length));return Object.keys(u).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${u[i]}`).join(`
                  `)}k(u){const s=[],i=[];return u.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(s.push(`|  Window (${n.title})`),n.folderURIs.forEach(c=>{const $=f.URI.revive(c);if($.scheme===O.Schemas.file){const R=$.fsPath;i.push(g(R,["node_modules",".git"]).then(I=>{let S=`${I.fileCount} files`;I.maxFilesReached&&(S=`more than ${S}`),s.push(`|    Folder (${(0,A.$cc)(R)}): ${S}`),s.push(this.h(I))}).catch(I=>{s.push(`|      Error: Unable to collect workspace stats for folder ${R} (${I.toString()})`)}))}else s.push(`|    Folder (${$.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>s.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(u,s){const i=new Map;u.windows.forEach(c=>i.set(c.pid,`window [${c.id}] (${c.title})`)),u.pidToNames.forEach(({pid:c,name:$})=>i.set(c,$));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),s&&this.n(u.mainPID,i,n,s,0),n.join(`
`)}n(u,s,i,n,c){const $=c===0;let R;$?R=n.pid===u?`${this.d.applicationName} main`:"remote agent":s.has(n.pid)?R=s.get(n.pid):R=`${"  ".repeat(c)} ${n.name}`;const I=process.platform==="win32"?n.mem:E.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(I/h.$jk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(n.children)&&n.children.forEach(S=>this.n(u,s,i,S,c+1))}async getWorkspaceFileExtensions(u){const s=new Set;for(const{uri:i}of u.folders){const n=f.URI.revive(i);if(n.scheme!==O.Schemas.file)continue;const c=n.fsPath;try{(await g(c,["node_modules",".git"])).fileTypes.forEach(R=>s.add(R.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(u){for(const{uri:s}of u.folders){const i=f.URI.revive(s);if(i.scheme!==O.Schemas.file)continue;const n=i.fsPath;try{const c=await g(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":u.telemetryId,rendererSessionId:u.rendererSessionId}),c.fileTypes.forEach($=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:u.rendererSessionId,type:$.name,count:$.count})}),c.launchConfigFiles.forEach($=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:u.rendererSessionId,type:$.name,count:$.count})}),c.configFiles.forEach($=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:u.rendererSessionId,type:$.name,count:$.count})})}catch{}}}};e.$fr=w=pe([x(0,b.$Rk),x(1,y.$6i)],w)}),define(ee[249],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p3b=e.$o3b=void 0;class E{constructor(O){this.b=O}listen(O,A){throw new Error(`Event not found: ${A}`)}call(O,A,{eventName:P,data:f}){return this.b.forEach(l=>l.log(P,f)),Promise.resolve(null)}}e.$o3b=E;class C{constructor(O){this.b=O}log(O,A){return this.b.call("log",{eventName:O,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$p3b=C}),define(ee[52],te([0,1,37,11,4,18,58,121,26]),function(G,e,E,C,r,O,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$Xn=l;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Yn=m,e.$Zn=new m;class d{async publicLog(n,c,$){}async publicLogError(n,c,$){}}e.$1n=d,e.$2n="telemetry",e.$3n="extensionTelemetryLog",e.$4n={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,n){return r.Event.debounce(n.onDidChangeConfiguration,($,R)=>{const I=$?new Set([...$.affectedKeys,...R.affectedKeys]):R.affectedKeys;return{...R,affectedKeys:I}},1e3,!0)($=>{$.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,O.$Uh)($.source),configurationKeys:Array.from($.affectedKeys)})})}e.$5n=p;function h(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry||n.extensionTestsLocationURI)}e.$6n=h;function y(i,n){return!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$7n=y;function b(i){const n=i.getValue(f.$Yk),c=i.getValue(f.$Zk);if(i.getValue(f.$1k)===!1||c===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$8n=b;function o(i){const n={},c={},$={};v(i,$);for(let R in $){R=R.length>150?R.substr(R.length-149):R;const I=$[R];typeof I=="number"?c[R]=I:typeof I=="boolean"?c[R]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${R} has been trimmed to 8192, the original length is ${I.length}`),n[R]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(n[R]=I)}return{properties:n,measurements:c}}e.$9n=o;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(i){if(!i)return"none";const n=(0,A.$yk)(i);return g.has(n)?n:"other"}e.$0n=a;function v(i,n,c=0,$){if(i)for(const R of Object.getOwnPropertyNames(i)){const I=i[R],S=$?$+R:R;Array.isArray(I)?n[S]=(0,E.$Im)(I):I instanceof Date?n[S]=I.toISOString():(0,C.$ie)(I)?c<2?v(I,n,c+1,S+"."):n[S]=(0,E.$Im)(I):n[S]=I}}function k(i,n){const c=i.msftInternalDomains||[],$=n.getValue("telemetry.internalTesting");return(0,P.$Wn)(c)||$}e.$$n=k;function w(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$_n=w;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let c=i;const $=[];for(const M of n)for(;;){const j=M.exec(i);if(!j)break;$.push([j.index,M.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(c="";;){const M=I.exec(i);if(!M)break;const j=$.some(([F,q])=>M.index<q&&F<I.lastIndex);!R.test(M[0])&&!j&&(c+=i.substring(S,M.index)+"<REDACTED: user-file-path>",S=I.lastIndex)}return S<i.length&&(c+=i.substr(S)),c}function u(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of n)if(c.regex.test(i))return`<REDACTED: ${c.label}>`;return i}function s(i,n){return(0,E.$Fm)(i,c=>{if(c instanceof l||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let $=c.replaceAll("%20"," ");$=t($,n);for(const R of n)$=$.replace(R,"");return $=u($),$}})}e.$ao=s}),define(ee[122],te([0,1,25,115,119,3,7,13,36,52]),function(G,e,E,C,r,O,A,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0;function m(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,E.$Ed)(s.id,i.id)===0}e.$bo=m;const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const n=i.manifest?i.manifest.version:i.version,c=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,n,c)}static parse(i){const n=d.exec(i);return n&&n[1]&&n[2]?new p({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,c="undefined"){this.version=n,this.targetPlatform=c,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?m(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$co=p;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(s){const i=h.exec(s);return i&&i[1]?[o(i[1]),i[2]]:[o(s),void 0]}e.$do=y;function b(s,i){return`${s}.${i}`}e.$eo=b;function o(s){return s.toLowerCase()}e.$fo=o;function g(s,i){return o(b(s??r.$zl,i))}e.$go=g;function a(s,i){const n=[],c=$=>{for(const R of n)if(R.some(I=>m(i(I),i($))))return R;return null};for(const $ of s){const R=c($);R?R.push($):n.push([$])}return n}e.$ho=a;function v(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$io=v;function k(s){return{id:new l.$Xn(s.identifier.id),name:new l.$Xn(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$jo=k,e.$ko=new r.$Dl("pprice.better-merge");function w(s,i){const n=[],c=i.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const $=c.shift();if($&&n.every(R=>!m(R.identifier,{id:$}))){const R=s.filter(I=>m(I.identifier,{id:$}));R.length===1&&(n.push(R[0]),c.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$lo=w;async function t(s,i){if(!O.$k)return!1;let n;try{n=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch($){i.debug("Error while getting the os-release file.",(0,P.$8)($))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(s,i){const n=await t(s,i),c=(0,C.$Gn)(n?"alpine":O.$t,f.$6b);return i.debug("ComputeTargetPlatform:",c),c}e.$mo=u}),define(ee[250],te([0,1,204,52]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=void 0;async function r(O,A,P,f,l,m,d){const p={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${A.nameShort})`};if((0,C.$6n)(A,P)&&(0,C.$8n)(f)===3){const h=await(0,E.$Mo)(P,l,m);p["X-Market-User-Id"]=h,p["VSCode-SessionId"]=d.machineId||h}return p}e.$No=r}),define(ee[251],te([0,1,2,37,3,25,183,18,57,77,23,44,26,52]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;let y=e.$Bq=class{constructor(g,a,v){this.k=a,this.l=v,this.d={},this.i=new E.$jb,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,O.$ld)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$ld)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration(p.$Yk)||k.affectsConfiguration(p.$1k)||k.affectsConfiguration(p.$Zk))&&this.m()}))}setExperimentProperty(g,a){this.d[g]=a}m(){let g=(0,h.$8n)(this.k);const a=this.l.enabledTelemetryLevels;if(a){this.h=this.sendErrorTelemetry?a.error:!1;const v=a.usage?3:a.error?2:0;g=Math.min(g,v)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,a,v){this.g<a||(v=(0,C.$Gm)(v,this.d),v=(0,h.$ao)(v,this.j),v=(0,C.$Gm)(v,this.c),this.b.forEach(k=>k.log(g,v)))}publicLog(g,a){this.n(g,3,a)}publicLog2(g,a){this.publicLog(g,a)}publicLogError(g,a){this.h&&this.n(g,2,a)}publicLogError2(g,a){this.publicLogError(g,a)}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$Bq=y=pe([x(1,P.$Rh),x(2,m.$6i)],y);function b(){const o=(0,A.localize)(0,null,l.default.nameLong),g=l.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),a=r.$o?"":(0,A.localize)(3,null),v=(0,A.localize)(4,null),k=(0,A.localize)(5,null),w=(0,A.localize)(6,null),t=(0,A.localize)(7,null),u=`
|       | ${v} | ${k} | ${w} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,A.localize)(8,null);return`
${o} ${g} ${a}

&nbsp;

${t}
${u}

&nbsp;

${s}
`}d.$Pm.as(f.$Um.Configuration).registerConfiguration({id:p.$Xk,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[p.$Yk]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),d.$Pm.as(f.$Um.Configuration).registerConfiguration({id:p.$Xk,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[p.$1k]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,A.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,A.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${p.$Yk}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[252],te([0,1,3,86,26]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S3b=void 0;async function O(A,P){let f=A.getItem(r.$Wk);return(typeof f!="string"||E.$j&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,C.$qm)(P.error.bind(P))),f}e.$S3b=O}),define(ee[253],te([0,1,26,252]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T3b=void 0;async function r(O,A){const P=await(0,C.$S3b)(O,A);return O.setItem(E.$Wk,P),P}e.$T3b=r}),define(ee[123],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var E;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(E||(e.EnvironmentVariableMutatorType=E={}))}),define(ee[254],te([0,1,3,123]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;const r=new Map([[C.EnvironmentVariableMutatorType.Append,"APPEND"],[C.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[C.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class O{constructor(m){this.collections=m,this.a=new Map,this.b=new Map,m.forEach((d,p)=>{this.d(d,p);const h=d.map.entries();let y=h.next();for(;!y.done;){const b=y.value[1],o=y.value[0];let g=this.a.get(o);if(g||(g=[],this.a.set(o,g)),g.length>0&&g[0].type===C.EnvironmentVariableMutatorType.Replace){y=h.next();continue}const a={extensionIdentifier:p,value:b.value,type:b.type,scope:b.scope,variable:b.variable,options:b.options};a.scope||delete a.scope,g.unshift(a),y=h.next()}})}async applyToProcessEnvironment(m,d,p){let h;E.$i&&(h={},Object.keys(m).forEach(y=>h[y.toLowerCase()]=y));for(const[y,b]of this.getVariableMap(d)){const o=E.$i&&h[y.toLowerCase()]||y;for(const g of b){const a=p?await p(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case C.EnvironmentVariableMutatorType.Append:m[o]=(m[o]||"")+a;break;case C.EnvironmentVariableMutatorType.Prepend:m[o]=a+(m[o]||"");break;case C.EnvironmentVariableMutatorType.Replace:m[o]=a;break}if(g.options?.applyAtShellIntegration??!1){const v=`VSCODE_ENV_${r.get(g.type)}`;m[v]=(m[v]?m[v]+":":"")+y+"="+this.c(a)}}}}c(m){return m.replaceAll(":","\\x3a")}diff(m,d){const p=new Map,h=new Map,y=new Map;if(m.getVariableMap(d).forEach((b,o)=>{const g=this.getVariableMap(d).get(o),a=P(b,g);a&&p.set(o,a)}),this.getVariableMap(d).forEach((b,o)=>{const g=m.getVariableMap(d).get(o),a=P(b,g);a&&y.set(o,a)}),this.getVariableMap(d).forEach((b,o)=>{const g=m.getVariableMap(d).get(o),a=f(b,g);a&&h.set(o,a)}),!(p.size===0&&h.size===0&&y.size===0))return{added:p,changed:h,removed:y}}getVariableMap(m){const d=new Map;return this.a.forEach((p,h)=>{const y=p.filter(b=>A(b,m));y.length>0&&d.set(y[0].variable,y)}),d}getDescriptionMap(m){const d=new Map;return this.b.forEach((p,h)=>{const y=p.filter(b=>A(b,m,!0));y.length>0&&d.set(y[0].extensionIdentifier,y[0].description)}),d}d(m,d){if(!m.descriptionMap)return;const p=m.descriptionMap.entries();let h=p.next();for(;!h.done;){const y=h.value[1],b=h.value[0];let o=this.b.get(b);o||(o=[],this.b.set(b,o));const g={extensionIdentifier:d,scope:y.scope,description:y.description};g.scope||delete g.scope,o.push(g),h=p.next()}}}e.$2q=O;function A(l,m,d=!1){return l.scope?!!(l.scope.workspaceFolder&&m?.workspaceFolder&&l.scope.workspaceFolder.index===m.workspaceFolder.index):d?m===l.scope:!0}function P(l,m){if(!m)return l;const d=new Set;m.forEach(h=>d.add(h.extensionIdentifier));const p=[];return l.forEach(h=>{d.has(h.extensionIdentifier)||p.push(h)}),p.length===0?void 0:p}function f(l,m){if(!m)return;const d=new Map;m.forEach(h=>d.set(h.extensionIdentifier,h));const p=[];return l.forEach(h=>{const y=d.get(h.extensionIdentifier);y&&(h.type!==y.type||h.value!==y.value||h.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&p.push(y)}),p.length===0?void 0:p}}),define(ee[255],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=void 0;function E(f){return[...f.entries()]}e.$Vq=E;function C(f){return f?[...f.entries()]:[]}e.$Wq=C;function r(f){return new Map(f)}e.$Xq=r;function O(f){return new Map(f??[])}e.$Yq=O;function A(f){return Array.from(f.entries()).map(l=>[l[0],E(l[1].map),C(l[1].descriptionMap)])}e.$Zq=A;function P(f){return new Map(f.map(l=>[l[0],{map:r(l[1]),descriptionMap:O(l[2])}]))}e.$1q=P}),define(ee[256],te([0,1,8,21,4,2,5]),function(G,e,E,C,r,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;let P=e.$Mq=class extends O.$kb{constructor(l,m){super(),this.h=m,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new r.$5c),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l}createRequest(l){return new Promise((m,d)=>{const p=++this.a;this.c.set(p,m),this.g.fire({requestId:p,...l});const h=new C.$bd;(0,E.$sg)(this.b,h.token).then(()=>d(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,O.$ib)(()=>h.cancel())])})}acceptReply(l,m){const d=this.c.get(l);d?(this.c.delete(l),(0,O.$fb)(this.f.get(l)||[]),this.f.delete(l),d(m)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$Mq=P=pe([x(1,A.$Ni)],P)}),define(ee[124],te([0,1,6,113,44]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.$Fq=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Eq=void 0,e.$Eq=new C.$Ki("terminalTabFocusMode",!1,!0);var O;(function(w){w.DefaultProfile="terminal.integrated.defaultProfile.",w.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(w){w.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",w.AutomationProfileLinux="terminal.integrated.automationProfile.linux",w.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",w.AutomationProfileWindows="terminal.integrated.automationProfile.windows",w.ProfilesWindows="terminal.integrated.profiles.windows",w.ProfilesMacOs="terminal.integrated.profiles.osx",w.ProfilesLinux="terminal.integrated.profiles.linux",w.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",w.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",w.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",w.UseWslProfiles="terminal.integrated.useWslProfiles",w.TabsDefaultColor="terminal.integrated.tabs.defaultColor",w.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",w.TabsEnabled="terminal.integrated.tabs.enabled",w.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",w.TabsHideCondition="terminal.integrated.tabs.hideCondition",w.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",w.TabsShowActions="terminal.integrated.tabs.showActions",w.TabsLocation="terminal.integrated.tabs.location",w.TabsFocusMode="terminal.integrated.tabs.focusMode",w.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",w.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",w.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",w.CopyOnSelection="terminal.integrated.copyOnSelection",w.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",w.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",w.FontFamily="terminal.integrated.fontFamily",w.FontSize="terminal.integrated.fontSize",w.LetterSpacing="terminal.integrated.letterSpacing",w.LineHeight="terminal.integrated.lineHeight",w.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",w.TabStopWidth="terminal.integrated.tabStopWidth",w.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",w.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",w.BellDuration="terminal.integrated.bellDuration",w.FontWeight="terminal.integrated.fontWeight",w.FontWeightBold="terminal.integrated.fontWeightBold",w.CursorBlinking="terminal.integrated.cursorBlinking",w.CursorStyle="terminal.integrated.cursorStyle",w.CursorWidth="terminal.integrated.cursorWidth",w.Scrollback="terminal.integrated.scrollback",w.DetectLocale="terminal.integrated.detectLocale",w.DefaultLocation="terminal.integrated.defaultLocation",w.GpuAcceleration="terminal.integrated.gpuAcceleration",w.TerminalTitleSeparator="terminal.integrated.tabs.separator",w.TerminalTitle="terminal.integrated.tabs.title",w.TerminalDescription="terminal.integrated.tabs.description",w.RightClickBehavior="terminal.integrated.rightClickBehavior",w.Cwd="terminal.integrated.cwd",w.ConfirmOnExit="terminal.integrated.confirmOnExit",w.ConfirmOnKill="terminal.integrated.confirmOnKill",w.EnableBell="terminal.integrated.enableBell",w.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",w.AllowChords="terminal.integrated.allowChords",w.AllowMnemonics="terminal.integrated.allowMnemonics",w.TabFocusMode="terminal.integrated.tabFocusMode",w.EnvMacOs="terminal.integrated.env.osx",w.EnvLinux="terminal.integrated.env.linux",w.EnvWindows="terminal.integrated.env.windows",w.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",w.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",w.ShowExitAlert="terminal.integrated.showExitAlert",w.SplitCwd="terminal.integrated.splitCwd",w.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",w.WordSeparators="terminal.integrated.wordSeparators",w.EnableFileLinks="terminal.integrated.enableFileLinks",w.UnicodeVersion="terminal.integrated.unicodeVersion",w.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",w.LocalEchoEnabled="terminal.integrated.localEchoEnabled",w.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",w.LocalEchoStyle="terminal.integrated.localEchoStyle",w.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",w.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",w.CustomGlyphs="terminal.integrated.customGlyphs",w.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",w.InheritEnv="terminal.integrated.inheritEnv",w.ShowLinkHover="terminal.integrated.showLinkHover",w.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",w.AutoReplies="terminal.integrated.autoReplies",w.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",w.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",w.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",w.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",w.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",w.EnableImages="terminal.integrated.enableImages",w.SmoothScrolling="terminal.integrated.smoothScrolling",w.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",w.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay"})(A||(e.TerminalSettingId=A={}));var P;(function(w){w.PowerShell="pwsh",w.Bash="bash",w.Fish="fish",w.Sh="sh",w.Csh="csh",w.Ksh="ksh",w.Zsh="zsh"})(P||(e.PosixShellType=P={}));var f;(function(w){w.CommandPrompt="cmd",w.PowerShell="pwsh",w.Wsl="wsl",w.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var l;(function(w){w[w.Api=0]="Api",w[w.Process=1]="Process",w[w.Sequence=2]="Sequence",w[w.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var m;(function(w){w.LocalPty="localPty",w.PtyHost="ptyHost",w.PtyHostWindow="ptyHostWindow",w.Logger="logger",w.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={})),e.$Fq=(0,E.$lh)("ptyService");var d;(function(w){w.Cwd="cwd",w.InitialCwd="initialCwd",w.FixedDimensions="fixedDimensions",w.Title="title",w.ShellType="shellType",w.HasChildProcesses="hasChildProcesses",w.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",w.OverrideDimensions="overrideDimensions",w.FailedShellIntegrationActivation="failedShellIntegrationActivation",w.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(d||(e.ProcessPropertyType=d={}));var p;(function(w){w[w.BeatInterval=5e3]="BeatInterval",w[w.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",w[w.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",w[w.SecondWaitMultiplier=1]="SecondWaitMultiplier",w[w.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var h;(function(w){w[w.Panel=1]="Panel",w[w.Editor=2]="Editor"})(h||(e.TerminalLocation=h={}));var y;(function(w){w.TerminalView="view",w.Editor="editor"})(y||(e.TerminalLocationString=y={}));var b;(function(w){w[w.GraceTime=6e4]="GraceTime",w[w.ShortGraceTime=6e3]="ShortGraceTime"})(b||(e.LocalReconnectConstants=b={}));var o;(function(w){w[w.HighWatermarkChars=1e5]="HighWatermarkChars",w[w.LowWatermarkChars=5e3]="LowWatermarkChars",w[w.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var g;(function(w){w.GitBash="Git Bash",w.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var a;(function(w){w[w.Off=0]="Off",w[w.FinalTerm=1]="FinalTerm",w[w.VSCode=2]="VSCode"})(a||(e.ShellIntegrationStatus=a={}));var v;(function(w){w[w.Unknown=0]="Unknown",w[w.Shutdown=1]="Shutdown",w[w.Process=2]="Process",w[w.User=3]="User",w[w.Extension=4]="Extension"})(v||(e.TerminalExitReason=v={})),e.$Gq={Backend:"workbench.contributions.terminal.processBackend"};class k{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const u=this.b(t.remoteAuthority);if(this.a.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this.a.set(u,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}r.$Pm.add(e.$Gq.Backend,new k),e.$Hq=(0,E.$lh)("localPtyService"),e.$Iq=(0,E.$lh)("terminalLogService")}),define(ee[257],te([0,1,70,7,185,102]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=e.$Oq=e.$Nq=void 0;function A(p,h){const y=[{name:null,description:(0,r.localize)(0,null)}];return y.push(...p.map(b=>({name:b.profileName,description:P(b)}))),h&&y.push(...h.map(b=>({name:b.title,description:f(b)}))),{values:y.map(b=>b.name),markdownDescriptions:y.map(b=>b.description)}}e.$Nq=A;function P(p){let h=`$(${O.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:E.$yj.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?h+=`
- args: "${p.args}"`:h+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(h+=`
- overrideName: ${p.overrideName}`),p.color&&(h+=`
- color: ${p.color}`),p.env&&(h+=`
- env: ${JSON.stringify(p.env)}`),h}function f(p){return`$(${O.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:E.$yj.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function l(p,h){if(!p&&!h)return!0;if(typeof p=="string"&&typeof h=="string")return p===h;if(Array.isArray(p)&&Array.isArray(h)){if(p.length!==h.length)return!1;for(let y=0;y<p.length;y++)if(p[y]!==h[y])return!1;return!0}return!1}e.$Oq=l;function m(p,h){if(!p&&!h)return!0;if(!p||!h)return!1;if(O.ThemeIcon.isThemeIcon(p)&&O.ThemeIcon.isThemeIcon(h))return p.id===h.id&&p.color===h.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof h=="object"&&"light"in h&&"dark"in h){const y=p,b=h;if((C.URI.isUri(y.light)||d(y.light))&&(C.URI.isUri(y.dark)||d(y.dark))&&(C.URI.isUri(b.light)||d(b.light))&&(C.URI.isUri(b.dark)||d(b.dark)))return y.light.path===b.light.path&&y.dark.path===b.dark.path}if(C.URI.isUri(p)&&C.URI.isUri(h)||d(p)||d(h)){const y=p,b=h;return y.path===b.path&&y.scheme===b.scheme}return!1}e.$Pq=m;function d(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$Qq=d}),define(ee[258],te([0,1,70,3,184,57,44,257]),function(G,e,E,C,r,O,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=e.$Rq=void 0,e.$Rq={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Sq={type:"string",enum:Array.from((0,E.$xj)(),o=>o.id),markdownEnumDescriptions:Array.from((0,E.$xj)(),o=>`$(${o.id})`)};const f={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.$Sq},color:{description:(0,r.localize)(3,null),...e.$Rq},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},m={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function d(o){const g=o===2?"linux":o===1?"osx":"windows";return(0,r.localize)(7,null,(0,C.$h)(o),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:d(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:d(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:d(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,r.localize)(26,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){A.$Pm.as(O.$Um.Configuration).registerConfiguration(p),b()}e.$Tq=h;let y;function b(o,g){const a=A.$Pm.as(O.$Um.Configuration);let v;o&&(v=(0,P.$Nq)(o?.profiles,g));const k=y;y={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:o?.os===3?v?.values:void 0,markdownEnumDescriptions:o?.os===3?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:o?.os===2?v?.values:void 0,markdownEnumDescriptions:o?.os===2?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:o?.os===1?v?.values:void 0,markdownEnumDescriptions:o?.os===1?v?.markdownDescriptions:void 0}}},a.updateConfigurations({add:[y],remove:k?[k]:[]})}e.$Uq=b}),define(ee[259],te([0,1,27,15,37,9,3,36,25,11,22,123,255,254]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$3q=y;async function b(i,n,c,$=P.env,R=m.Promises.exists){if(O.$0b(i))return await R(i)?i:void 0;if(n===void 0&&(n=P.cwd()),O.$bc(i)!=="."){const j=O.$$b(n,i);return await R(j)?j:void 0}const S=(0,r.$Km)($,"PATH");if(c===void 0&&(0,l.$ge)(S)&&(c=S.split(O.$ic)),c===void 0||c.length===0){const j=O.$$b(n,i);return await R(j)?j:void 0}for(const j of c){let F;if(O.$0b(j)?F=O.$$b(j,i):F=O.$$b(n,j,i),await R(F))return F;if(A.$i){let q=F+".com";if(await R(q)||(q=F+".exe",await R(q)))return q}}const M=O.$$b(n,i);return await R(M)?M:void 0}e.$4q=b;function o(i,n,c,$,R){const I=A.$i&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||I)return;const S=i.args,M=P.$5b==="win32"?O.$cc(i.executable).toLowerCase():O.$cc(i.executable),j=O.$bc(C.$1e.asFileUri("").fsPath);let F;const q={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(q.VSCODE_NONCE=n.shellIntegration.nonce),A.$i){if(M==="pwsh.exe"||M==="powershell.exe")return!S||u(S)?F=v.get(a.WindowsPwsh):t(S)&&(F=v.get(a.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,f.$id)(F[F.length-1],j,""),{newArgs:F,envMixin:q}):void 0;$.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(M){case"bash":return!S||S.length===0?F=v.get(a.Bash):s(S)&&(q.VSCODE_SHELL_LOGIN="1",g(n,q),F=v.get(a.Bash)),F?(F=[...F],F[F.length-1]=(0,f.$id)(F[F.length-1],j),{newArgs:F,envMixin:q}):void 0;case"fish":{const re=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ie=O.$$b(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return q.XDG_DATA_DIRS=`${re}:${ie}`,g(n,q),{newArgs:void 0,envMixin:q}}case"pwsh":return!S||u(S)?F=v.get(a.Pwsh):t(S)&&(F=v.get(a.PwshLogin)),F?(F=[...F],F[F.length-1]=(0,f.$id)(F[F.length-1],j,""),{newArgs:F,envMixin:q}):void 0;case"zsh":{if(!S||S.length===0?F=v.get(a.Zsh):s(S)?(F=v.get(a.ZshLogin),g(n,q)):(S===v.get(a.Zsh)||S===v.get(a.ZshLogin))&&(F=S),!F)return;F=[...F],F[F.length-1]=(0,f.$id)(F[F.length-1],j);let re;try{re=E.userInfo().username}catch{re="unknown"}const ie=O.$$b(E.tmpdir(),`${re}-${R.applicationName}-zsh`);q.ZDOTDIR=ie;const ne=c?.ZDOTDIR??E.homedir()??"~";q.USER_ZDOTDIR=ne;const ue=[];return ue.push({source:O.$$b(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.$$b(ie,".zshrc")}),ue.push({source:O.$$b(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.$$b(ie,".zprofile")}),ue.push({source:O.$$b(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.$$b(ie,".zshenv")}),ue.push({source:O.$$b(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.$$b(ie,".zlogin")}),{newArgs:F,envMixin:q,filesToCopy:ue}}}$.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$5q=o;function g(i,n){if(A.$j&&i.environmentVariableCollections){const c=(0,p.$1q)(i.environmentVariableCollections),R=new h.$2q(c).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),I=[];if(R)for(const S of R)S.type===d.EnvironmentVariableMutatorType.Prepend&&I.push(S.value);I.length>0&&(n.VSCODE_PATH_PREFIX=I.join(""))}}var a;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(a||(a={}));const v=new Map;v.set(a.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(a.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(a.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),v.set(a.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),v.set(a.Zsh,["-i"]),v.set(a.ZshLogin,["-il"]),v.set(a.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],w=["-nol","-nologo"];function t(i){return typeof i=="string"?k.includes(i.toLowerCase()):i.length===1&&k.includes(i[0].toLowerCase())||i.length===2&&(k.includes(i[0].toLowerCase())||k.includes(i[1].toLowerCase()))&&(w.includes(i[0].toLowerCase())||w.includes(i[1].toLowerCase()))}function u(i){return typeof i=="string"?w.includes(i.toLowerCase()):i.length===0||i?.length===1&&w.includes(i[0].toLowerCase())}function s(i){return i==="string"&&k.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&k.includes(i[0].toLowerCase())}}),define(ee[260],te([0,1,47,70,9,3,11,22,106,259,112]),function(G,e,E,C,r,O,A,P,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;let d,p=!0;function h(n,c,$,R,I=process.env,S,M,j,F){return S=S||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},O.$i?y($,S,I,M,R.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:R.getValue("terminal.integrated.profiles.windows"),typeof c=="string"?c:R.getValue("terminal.integrated.defaultProfile.windows"),F,j):u(S,M,$,n&&typeof n=="object"?{...n}:R.getValue(O.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof c=="string"?c:R.getValue(O.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,j,I)}e.$6q=h;async function y(n,c,$,R,I,S,M,j,F){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let ie=!1;(0,l.$3q)()>=16299&&(ie=!0),await a(j);const ne=new Map;if(n){ne.set("PowerShell",{source:"PowerShell",icon:C.$yj.terminalPowershell,isAutoDetected:!0}),ne.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.$yj.terminalPowershell,isAutoDetected:!0}),ne.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ne.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:C.$yj.terminalCmd,isAutoDetected:!0}),ne.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ne.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:C.$yj.terminalBash,isAutoDetected:!0});const le=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ne.set("Cmder",{path:`${re}\\cmd.exe`,args:["/K",le],requiresPath:process.env.CMDER_ROOT?le:{path:le,isUnsafe:!0},isAutoDetected:!0})}s(S,ne);const ue=await b(ne.entries(),M,c,$,R,F);if(n||I)try{const le=await w(`${re}\\${ie?"wsl":"bash"}.exe`,M);for(const K of le)(!S||!(K.profileName in S))&&ue.push(K)}catch{p&&(R?.info("WSL is not installed, so could not detect WSL profiles"),p=!1)}return ue}async function b(n,c,$,R=process.env,I,S){const M=[];for(const[j,F]of n)M.push(o(j,F,c,$,R,I,S));return(await Promise.all(M)).filter(j=>!!j)}async function o(n,c,$,R,I=process.env,S,M){if(c===null)return;let j,F,q;if("source"in c&&!("path"in c)){const ue=d?.get(c.source);if(!ue)return;j=ue.paths,F=c.args||ue.args,c.icon?q=g(c.icon):ue.icon&&(q=ue.icon)}else j=Array.isArray(c.path)?c.path:[c.path],F=O.$i||Array.isArray(c.args)?c.args:void 0,q=g(c.icon);let re;if(M){const ue=j.map(K=>typeof K=="string"?K:K.path),le=await M(ue);re=new Array(j.length);for(let K=0;K<j.length;K++)typeof j[K]=="string"?re[K]=le[K]:re[K]={path:le[K],isUnsafe:!0}}else re=j.slice();let ie;if(c.requiresPath){let ue;if((0,A.$ge)(c.requiresPath)?ue=c.requiresPath:(ue=c.requiresPath.path,c.requiresPath.isUnsafe&&(ie=ue)),!await R.existsFile(ue))return}const ne=await i(n,$,re,R,I,F,c.env,c.overrideName,c.isAutoDetected,ie);if(!ne){S?.debug("Terminal profile not validated",n,j);return}return ne.isAutoDetected=c.isAutoDetected,ne.icon=q,ne.color=c.color,ne}function g(n){return typeof n=="string"?{id:n}:n}async function a(n){if(d&&!n)return;const[c,$]=await Promise.all([v(),n||k()]);d=new Map,d.set("Git Bash",{profileName:"Git Bash",paths:c,args:["--login","-i"]}),d.set("PowerShell",{profileName:"PowerShell",paths:$,icon:C.$yj.terminalPowershell})}async function v(){const n=new Set,c=await(0,l.$4q)("git.exe");if(c){const I=(0,m.dirname)(c);n.add((0,m.resolve)(I,"../.."))}function $(I,S){S&&I.add(S)}$(n,process.env.ProgramW6432),$(n,process.env.ProgramFiles),$(n,process.env["ProgramFiles(X86)"]),$(n,`${process.env.LocalAppData}\\Program`);const R=[];for(const I of n)R.push(`${I}\\Git\\bin\\bash.exe`,`${I}\\Git\\usr\\bin\\bash.exe`,`${I}\\usr\\bin\\bash.exe`);return R.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),R}async function k(){const n=[];for await(const c of(0,f.$_k)())n.push(c.exePath);return n}async function w(n,c){const $=[],R=await new Promise((M,j)=>{E.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,q)=>{if(F)return j("Problem occurred when getting wsl distros");M(q)})});if(!R)return[];const I=new RegExp(/[\r?\n]/),S=R.split(I).filter(M=>M.trim().length>0&&M!=="");for(const M of S){if(M===""||M.startsWith("docker-desktop"))continue;const j=`${M} (WSL)`,F={profileName:j,path:n,args:["-d",`${M}`],isDefault:j===c,icon:t(M),isAutoDetected:!1};$.push(F)}return $}function t(n){return n.includes("Ubuntu")?C.$yj.terminalUbuntu:n.includes("Debian")?C.$yj.terminalDebian:C.$yj.terminalLinux}async function u(n,c,$,R,I,S,M,j){const F=new Map;if($){const q=(await n.readFile("/etc/shells")).toString(),re=(S||q.split(`
`)).map(ne=>{const ue=ne.indexOf("#");return ue===-1?ne:ne.substring(0,ue)}).filter(ne=>ne.trim().length>0),ie=new Map;for(const ne of re){let ue=(0,r.$cc)(ne),le=ie.get(ue)||0;le++,le>1&&(ue=`${ue} (${le})`),ie.set(ue,le),F.set(ue,{path:ne,isAutoDetected:!0})}}return s(R,F),await b(F.entries(),I,n,j,c,M)}function s(n,c){if(n)for(const[$,R]of Object.entries(n))R===null||typeof R!="object"||!("path"in R)&&!("source"in R)?c.delete($):(R.icon=R.icon||c.get($)?.icon,c.set($,R))}async function i(n,c,$,R,I,S,M,j,F,q){if($.length===0)return Promise.resolve(void 0);const re=$.shift();if(re==="")return i(n,c,$,R,I,S,M,j,F);const ie=typeof re!="string"&&re.isUnsafe,ne=typeof re=="string"?re:re.path,ue={profileName:n,path:ne,args:S,env:M,overrideName:j,isAutoDetected:F,isDefault:n===c,isUnsafePath:ie,requiresUnsafePath:q};if((0,r.$cc)(ne)===ne){const K=I.PATH?I.PATH.split(r.$ic):void 0,Y=await(0,l.$4q)(ne,void 0,K,void 0,R.existsFile);return Y?(ue.path=Y,ue.isFromPath=!0,ue):i(n,c,$,R,I,S)}return await R.existsFile((0,r.$9b)(ne))?ue:i(n,c,$,R,I,S,M,j,F)}}),define(ee[261],te([0,1,4,2,3,43,18,5,224,94,256,124,258,260]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;var y;(function(g){g[g.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let b=0,o=e.$7q=class extends C.$kb{get c(){return this.g(),this.a}get f(){return this.g(),this.b}g(){this.a||([this.a,this.b]=this.O())}constructor(a,v,k,w){super(),this.G=a,this.H=v,this.I=k,this.J=w,this.i=!1,this.j=0,this.k=!0,this.l=!1,this.p=this.B(new E.$5c),this.onPtyHostExit=this.p.event,this.r=this.B(new E.$5c),this.onPtyHostStart=this.r.event,this.s=this.B(new E.$5c),this.onPtyHostUnresponsive=this.s.event,this.t=this.B(new E.$5c),this.onPtyHostResponsive=this.t.event,this.u=this.B(new E.$5c),this.onPtyHostRequestResolveVariables=this.u.event,this.v=this.B(new E.$5c),this.onProcessData=this.v.event,this.w=this.B(new E.$5c),this.onProcessReady=this.w.event,this.y=this.B(new E.$5c),this.onProcessReplay=this.y.event,this.z=this.B(new E.$5c),this.onProcessOrphanQuestion=this.z.event,this.C=this.B(new E.$5c),this.onDidRequestDetach=this.C.event,this.D=this.B(new E.$5c),this.onDidChangeProperty=this.D.event,this.F=this.B(new E.$5c),this.onProcessExit=this.F.event,(0,p.$Tq)(),this.B((0,C.$ib)(()=>this.P())),this.h=this.B(new m.$Mq(void 0,this.I)),this.h.onCreateRequest(this.u.fire,this.u),this.G.onBeforeWindowConnection?E.Event.once(this.G.onBeforeWindowConnection)(()=>this.g()):this.g(),this.G.onWillShutdown?.(()=>this.i=!0)}get L(){return this.H.getValue("terminal.integrated.ignoreProcessNames")}async M(){return this.f.refreshIgnoreProcessNames?.(this.L)}async N(){if(r.$i)return process.env;try{return await(0,l.$ul)(this.H,this.I,{_:[]},process.env)}catch(a){return this.I.error("ptyHost was unable to resolve shell environment",a),{}}}O(){const a=this.G.start(b),v=a.client;this.r.fire(),O.ProxyChannel.toService(v.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.Q()),this.Q(!0),this.B(a.onDidProcessExit(t=>{this.p.fire(t.code),!this.i&&!this.l&&(this.j<=y.MaxRestarts?(this.I.error(`ptyHost terminated unexpectedly with code ${t.code}`),this.j++,this.restartPtyHost()):this.I.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const w=O.ProxyChannel.toService(v.getChannel(d.TerminalIpcChannels.PtyHost));return this.B(w.onProcessData(t=>this.v.fire(t))),this.B(w.onProcessReady(t=>this.w.fire(t))),this.B(w.onProcessExit(t=>this.F.fire(t))),this.B(w.onDidChangeProperty(t=>this.D.fire(t))),this.B(w.onProcessReplay(t=>this.y.fire(t))),this.B(w.onProcessOrphanQuestion(t=>this.z.fire(t))),this.B(w.onDidRequestDetach(t=>this.C.fire(t))),this.B(new f.$Lq(this.J,v.getChannel(d.TerminalIpcChannels.Logger))),this.a=a,this.b=w,this.B(this.H.onDidChangeConfiguration(async t=>{t.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.M()})),this.M(),[a,w]}dispose(){this.l=!0,super.dispose()}async createProcess(a,v,k,w,t,u,s,i,n,c,$){const R=setTimeout(()=>this.U(),d.HeartbeatConstants.CreateProcessTimeout),I=await this.f.createProcess(a,v,k,w,t,u,s,i,n,c,$);return clearTimeout(R),b=Math.max(b,I),I}updateTitle(a,v,k){return this.f.updateTitle(a,v,k)}updateIcon(a,v,k,w){return this.f.updateIcon(a,v,k,w)}attachToProcess(a){return this.f.attachToProcess(a)}detachFromProcess(a,v){return this.f.detachFromProcess(a,v)}listProcesses(){return this.f.listProcesses()}getPerformanceMarks(){return this.f.getPerformanceMarks()}reduceConnectionGraceTime(){return this.f.reduceConnectionGraceTime()}start(a){return this.f.start(a)}shutdown(a,v){return this.f.shutdown(a,v)}input(a,v){return this.f.input(a,v)}processBinary(a,v){return this.f.processBinary(a,v)}resize(a,v,k){return this.f.resize(a,v,k)}clearBuffer(a){return this.f.clearBuffer(a)}acknowledgeDataEvent(a,v){return this.f.acknowledgeDataEvent(a,v)}setUnicodeVersion(a,v){return this.f.setUnicodeVersion(a,v)}getInitialCwd(a){return this.f.getInitialCwd(a)}getCwd(a){return this.f.getCwd(a)}getLatency(a){return this.f.getLatency(a)}orphanQuestionReply(a){return this.f.orphanQuestionReply(a)}installAutoReply(a,v){return this.f.installAutoReply(a,v)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(a){return this.f.uninstallAutoReply(a)}getDefaultSystemShell(a){return this.f.getDefaultSystemShell(a)}async getProfiles(a,v,k,w=!1){const t=await this.N();return(0,h.$6q)(v,k,w,this.H,t,void 0,this.I,this.X.bind(this,a))}getEnvironment(){return this.f.getEnvironment()}getWslPath(a,v){return this.f.getWslPath(a,v)}getRevivedPtyNewId(a){return this.f.getRevivedPtyNewId(a)}setTerminalLayoutInfo(a){return this.f.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this.f.getTerminalLayoutInfo(a)}async requestDetachInstance(a,v){return this.f.requestDetachInstance(a,v)}async acceptDetachInstanceReply(a,v){return this.f.acceptDetachInstanceReply(a,v)}async freePortKillProcess(a){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(a)}async serializeTerminalState(a){return this.f.serializeTerminalState(a)}async reviveTerminalProcesses(a,v){return this.f.reviveTerminalProcesses(a,v)}async refreshProperty(a,v){return this.f.refreshProperty(a,v)}async updateProperty(a,v,k){return this.f.updateProperty(a,v,k)}async restartPtyHost(){this.P(),this.k=!0,this.O()}P(){this.f.shutdownAll?.(),this.c.store.dispose()}Q(a){this.W(),this.m=setTimeout(()=>this.R(),a?d.HeartbeatConstants.ConnectingBeatInterval:d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this.k||(this.k=!0,this.t.fire())}R(){this.I.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.m=void 0,this.n=setTimeout(()=>this.S(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}S(){this.I.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.n=void 0,this.k&&(this.k=!1,this.s.fire())}U(){this.W(),this.I.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.k&&(this.k=!1,this.s.fire())}W(){this.m&&(clearTimeout(this.m),this.m=void 0),this.n&&(clearTimeout(this.n),this.n=void 0)}X(a,v){return this.h.createRequest({workspaceId:a,originalText:v})}async acceptPtyHostResolvedVariables(a,v){this.h.acceptReply(a,v)}};e.$7q=o=pe([x(1,A.$Rh),x(2,P.$Ni),x(3,P.$Oi)],o)}),define(ee[79],te([0,1,14,4,2,3,18,6,34]),function(G,e,E,C,r,O,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T2b=e.$S2b=void 0;const l="#FFFFFF",m="#1E1E1E",d="#000000",p="#FFFFFF",h="theme",y="themeBackground",b="windowSplash";e.$S2b=(0,P.$lh)("themeMainService");let o=e.$T2b=class extends r.$kb{constructor(a,v){super(),this.b=a,this.c=v,this.a=this.B(new C.$5c),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(O.$i){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(O.$j){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(O.$k&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const a=this.getColorScheme();if(a.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return a.dark?d:p;let v=this.b.getItem(y,null);if(!v)switch(this.b.getItem(h,"vs-dark").split(" ")[0]){case"vs":v=l;break;case"hc-black":v=d;break;case"hc-light":v=p;break;default:v=m}return O.$j&&v.toUpperCase()===m&&(v="#171717"),v}saveWindowSplash(a,v){this.b.setItems([{key:h,data:v.baseTheme},{key:y,data:v.colorInfo.background},{key:b,data:v}]),typeof a=="number"&&this.f(a,v)}f(a,v){for(const k of E.BrowserWindow.getAllWindows())if(k.id===a){k.setBackgroundColor(v.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(b)}};e.$T2b=o=pe([x(0,f.$oM),x(1,A.$Rh)],o)}),define(ee[125],te([0,1,4,18,6,5]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dz=e.$Cz=e.$Bz=e.$Az=e.$zz=e.$yz=e.$xz=e.$wz=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$vz=e.$uz=void 0,e.$uz=(0,r.$lh)("tunnelService"),e.$vz=(0,r.$lh)("sharedTunnelsService");var A;(function(b){b.Http="http",b.Https="https"})(A||(e.TunnelProtocol=A={}));var P;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(P||(e.TunnelPrivacyId=P={}));var f;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function l(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(o)return{address:o[1],port:+o[2]}}e.$wz=l,e.$xz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(b){return e.$xz.indexOf(b)>=0}e.$yz=m,e.$zz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function d(b){return e.$zz.indexOf(b)>=0}e.$Az=d;function p(b,o,g,a){if(g===1)return!1;if(g===2&&d(o)){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(v?.length===4&&parseInt(v[1])>=18)return!1}return b<1024}e.$Bz=p;class h{constructor(o,g,a){this.remoteAddress=o,this.localAddress=g,this.b=a,this.a=new E.$5c,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Cz=h;let y=e.$Dz=class{constructor(o,g){this.i=o,this.j=g,this.a=new E.$5c,this.onTunnelOpened=this.a.event,this.b=new E.$5c,this.onTunnelClosed=this.b.event,this.c=new E.$5c,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],g=Array.from(this.d.values());for(const a of g){const v=Array.from(a.values());for(const k of v){const w=await k.value;w&&o.push(w)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:g}of o.values())await g.then(a=>a?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,g,a,v,k){this.o(o,g,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:g,localAddress:a,privacy:v,protocol:k,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,g){(d(o)||m(o))&&(o=e.$xz[0]);const a=this.q(o,g);if(a)return++a.refcount,a.value}openTunnel(o,g,a,v,k,w=!1,t,u){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${a} on local port ${k}.`),!o)return;if(g||(g="localhost"),v||(v=this.k),this.e&&this.h.has(a)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(o,g,a,v,k,w,t,u);return s?s.then(i=>{if(!i){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(g,a);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.m(i);return(i.tunnelRemoteHost!==g||i.tunnelRemotePort!==a)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),t&&i.privacy!==t&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(n),n}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const g=this.d.get(o.tunnelRemoteHost);if(g){const a=g.get(o.tunnelRemotePort);a&&(a.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,a))}}}}async n(o,g,a){if(a.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${g}.`);const v=a.value.then(async k=>{k&&(await k.dispose(!0),this.b.fire({host:k.tunnelRemoteHost,port:k.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(g),v}}async closeTunnel(o,g){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${g} `);const a=this.d.get(o);if(a&&a.has(g)){const v=a.get(g);v.refcount=0,await this.n(o,g,v)}}o(o,g,a){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(g,{refcount:1,value:a})}async p(o,g){const a=this.d.get(o);if(a){const v=a.get(g);(v?await v.value:void 0)||a.delete(g),a.size===0&&this.d.delete(o)}}q(o,g){const a=[o];m(o)?(a.push(...e.$xz),a.push(...e.$zz)):d(o)&&a.push(...e.$zz);const v=a.map(k=>this.d.get(k));for(const k of v){const w=k?.get(g);if(w)return w}}canTunnel(o){return!!l(o)}s(o,g,a,v,k,w,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${a} on local port ${v}.`);const u=a;this.h.add(u);const s=v===void 0?a:v,i={elevationRequired:k?this.isPortPrivileged(s):!1},n={remoteAddress:{host:g,port:a},localAddressPort:v,privacy:w,public:w?w!==P.Private:void 0,protocol:t},c=o.forwardPort(n,i);return c?(this.o(g,a,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(u)})):this.h.delete(u),c}};e.$Dz=y=pe([x(0,O.$Ni),x(1,C.$Rh)],y)}),define(ee[262],te([0,1,87,27,103,8,2,18,5,23,240,125,95,3,241]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$83b=e.$73b=e.$63b=void 0;async function b(k,w,t,u,s){let i;for(let n=3;n&&(i?.dispose(),i=await new o(k,w,t,u,s).waitForReady(),!(s&&r.$6e[s]||!r.$6e[i.tunnelLocalPort]));n--);return i}class o extends A.$kb{constructor(w,t,u,s,i){super(),this.j=t,this.k=i,this.privacy=d.TunnelPrivacyId.Private,this.i=new Map,this.a=w,this.b=E.createServer(),this.c=new O.$qg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=n=>this.l(n),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const w=this.k??this.tunnelRemotePort,t=(0,d.$Az)(this.j)?"0.0.0.0":"127.0.0.1";let u=await(0,r.$7e)(w,2,1e3,t),s=null;return this.b.listen(u,this.j),await this.c.wait(),s=this.b.address(),s||(u=0,this.b.listen(u,this.j),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async l(w){w.pause();const t=(0,d.$yz)(this.tunnelRemoteHost)||(0,d.$Az)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,m.$Ik)(this.a,t,this.tunnelRemotePort),s=u.getSocket().socket,i=u.readEntireBuffer();u.dispose(),i.byteLength>0&&w.write(i.buffer),w.on("end",()=>{w.localAddress&&this.i.delete(w.localAddress),s.end()}),w.on("close",()=>s.end()),w.on("error",()=>{w.localAddress&&this.i.delete(w.localAddress),s.destroy()}),s.on("end",()=>w.end()),s.on("close",()=>w.end()),s.on("error",()=>{w.destroy()}),w.pipe(s),s.pipe(w),w.localAddress&&this.i.set(w.localAddress,()=>{w.end(),s.end()})}}let g=e.$63b=class extends d.$Dz{constructor(w,t,u,s,i){super(t,i),this.t=w,this.u=u,this.v=s}isPortPrivileged(w){return(0,d.$Bz)(w,this.k,h.OS,C.release())}r(w,t,u,s,i,n,c,$){const R=this.q(t,u);if(R)return++R.refcount,R.value;if(this.e)return this.s(this.e,t,u,i,n,c,$);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${u} on local port ${i}.`);const I={commit:this.v.commit,quality:this.v.quality,addressProvider:w,remoteSocketFactoryService:this.t,signService:this.u,logService:this.i,ipcLogger:null},S=b(I,s,t,u,i);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,u,S),S}}};e.$63b=g=pe([x(0,y.$Ck),x(1,f.$Ni),x(2,p.$Fk),x(3,l.$6i),x(4,P.$Rh)],g);let a=e.$73b=class extends g{constructor(w,t,u,s,i){super(w,t,u,s,i)}};e.$73b=a=pe([x(0,y.$Ck),x(1,f.$Ni),x(2,p.$Fk),x(3,l.$6i),x(4,P.$Rh)],a);let v=e.$83b=class extends A.$kb{constructor(w,t,u,s,i){super(),this.b=w,this.c=t,this.f=u,this.g=s,this.h=i,this.a=new Map}async openTunnel(w,t,u,s,i,n,c,$,R){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${s} on local port ${n}.`),!this.a.has(w)){const I=new a(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(w,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(w))})}return this.a.get(w).openTunnel(t,u,s,i,n,c,$,R)}};e.$83b=v=pe([x(0,y.$Ck),x(1,f.$Ni),x(2,l.$6i),x(3,p.$Fk),x(4,P.$Rh)],v)}),define(ee[48],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chb=e.$bhb=e.UpdateType=e.StateType=void 0;var C;(function(O){O.Uninitialized="uninitialized",O.Idle="idle",O.CheckingForUpdates="checking for updates",O.AvailableForDownload="available for download",O.Downloading="downloading",O.Downloaded="downloaded",O.Updating="updating",O.Ready="ready"})(C||(e.StateType=C={}));var r;(function(O){O[O.Setup=0]="Setup",O[O.Archive=1]="Archive",O[O.Snap=2]="Snap"})(r||(e.UpdateType=r={})),e.$bhb={Uninitialized:{type:"uninitialized"},Idle:(O,A)=>({type:"idle",updateType:O,error:A}),CheckingForUpdates:O=>({type:"checking for updates",explicit:O}),AvailableForDownload:O=>({type:"available for download",update:O}),Downloading:O=>({type:"downloading",update:O}),Downloaded:O=>({type:"downloaded",update:O}),Updating:O=>({type:"updating",update:O}),Ready:O=>({type:"ready",update:O})},e.$chb=(0,E.$lh)("updateService")}),define(ee[263],te([0,1,3,186,57,44]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),O.$Pm.as(r.$Um.Configuration).registerConfiguration({id:"update",order:15,title:(0,C.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,C.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,C.localize)(2,null),(0,C.localize)(3,null),(0,C.localize)(4,null),(0,C.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,C.localize)(6,null),deprecationMessage:(0,C.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,C.localize)(8,null),description:(0,C.localize)(9,null),included:E.$i&&!E.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,C.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[264],te([0,1,4,48]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r3b=e.$q3b=void 0;class r{constructor(P){this.a=P}listen(P,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(P,f,l){switch(f){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${f}`)}}e.$q3b=r;class O{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new E.$5c,this.onStateChange=this.a.event,this.b=C.$bhb.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$r3b=O}),define(ee[40],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=void 0,e.$lk=(0,E.$lh)("IUriIdentityService")}),define(ee[265],te([0,1,40,205,16,19,138,4,2]),function(G,e,E,C,r,O,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class l{constructor(p){this.uri=p,this.time=l._clock++}touch(){return this.time=l._clock++,this}}l._clock=0;let m=e.$$q=class{constructor(p){this.g=p,this.c=new f.$jb,this.f=2**16;const h=new Map,y=b=>{let o=h.get(b.scheme);return o===void 0&&(o=p.hasProvider(b)&&!this.g.hasCapability(b,1024),h.set(b.scheme,o)),o};this.c.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(b=>{h.delete(b.scheme)})),this.extUri=new O.$Uf(y),this.d=new A.$0q((b,o)=>this.extUri.compare(b,o,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,O.$7f)(p));const h=this.d.get(p);return h?h.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new l(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((y,b)=>y[1].time<b[1].time?1:y[1].time>b[1].time?-1:0);l._clock=0,this.d.clear();const h=this.f*.5;for(let y=0;y<h;y++)this.d.set(p[y][0],p[y][1].touch())}};e.$$q=m=pe([x(0,r.$Oj)],m),(0,C.$8q)(E.$lk,m,1)}),define(ee[126],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhb=void 0,e.$Zhb=(0,E.$lh)("urlService")}),define(ee[266],te([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A3b=e.$z3b=e.$y3b=void 0;class C{constructor(P){this.a=P}listen(P,f){throw new Error(`Event not found: ${f}`)}call(P,f,l){switch(f){case"handleURL":return this.a.handleURL(E.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${f}`)}}e.$y3b=C;class r{constructor(P){this.a=P}handleURL(P,f){return this.a.call("handleURL",[P.toJSON(),f])}}e.$z3b=r;class O{constructor(P,f){this.a=P,this.b=f}async routeCall(P,f,l,m){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(l)&&l.length>0){const d=E.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",d.toString(!0)),d.query){const p=/\bwindowId=(\d+)/.exec(d.query);if(p){const h=p[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${h}"`,d.toString(!0));const y=new RegExp(`window:${h}`),b=P.connections.find(o=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",o.ctx),y.test(o.ctx)));if(b)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",d.toString(!0)),b;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",d.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",d.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,f,l,m)}routeEvent(P,f){throw new Error(`Event not found: ${f}`)}}e.$A3b=O}),define(ee[267],te([0,1,8,2,7,23]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oob=e.$nob=void 0;class A extends C.$kb{constructor(){super(...arguments),this.a=new Set}open(l,m){const d=[...this.a.values()];return(0,E.$vg)(d.map(p=>()=>p.handleURL(l,m)),void 0,!1).then(p=>p||!1)}registerHandler(l){return this.a.add(l),(0,C.$ib)(()=>this.a.delete(l))}}e.$nob=A;let P=e.$oob=class extends A{constructor(l){super(),this.b=l}create(l){let{authority:m,path:d,query:p,fragment:h}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&d&&d.indexOf("/")!==0&&(d=`/${d}`),r.URI.from({scheme:this.b.urlProtocol,authority:m,path:d,query:p,fragment:h})}};e.$oob=P=pe([x(0,O.$6i)],P)}),define(ee[268],te([0,1,14,8,4,2,3,7]),function(G,e,E,C,r,O,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B3b=void 0;class f{constructor(m,d,p,h,y,b){if(this.f=d,this.g=b,this.a=[],this.b=0,this.c=O.$kb.None,this.d=new O.$jb,m&&(b.trace("ElectronURLListener initialUrisToHandle:",m.map(a=>a.originalUrl)),this.a=m),A.$i){const a=h.isBuilt?[]:[`"${h.appRoot}"`];a.push("--open-url","--"),E.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,a)}const o=r.Event.map(r.Event.fromNodeEventEmitter(E.app,"open-url",(a,v)=>({event:a,url:v})),({event:a,url:v})=>(a.preventDefault(),v));this.d.add(o(a=>{const v=this.h(a);v&&this.f.open(v,{originalUrl:a})})),p.getWindows().filter(a=>a.isReady).length>0?(b.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(b.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),r.Event.once(p.onDidSignalReadyWindow)(this.i,this,this.d))}h(m){try{return P.URI.parse(m)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const d of this.a)await this.f.open(d.uri,{originalUrl:d.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",d.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",d.originalUrl),m.push(d));m.length!==0&&(this.a=m,this.c=(0,C.$tg)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.$B3b=f}),define(ee[269],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V3b=void 0,e.$V3b="utilityProcessWorker"}),define(ee[270],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C3b=void 0,e.$C3b=(0,E.$lh)("webviewManagerService")}),define(ee[271],te([0,1,14,2,15,7]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D3b=void 0;class A extends C.$kb{constructor(){super();const f=this.b.bind(this);E.protocol.registerFileProtocol(r.Schemas.vscodeWebview,f)}b(f,l){try{const m=O.URI.parse(f.url),d=A.a.get(m.path);if(typeof d=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${d}`,h=r.$1e.asFileUri(p);return l({path:h.fsPath,headers:{...r.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$D3b=A,A.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[80],te([0,1,3]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hD=e.$gD=e.$fD=e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=void 0,e.$aD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(m){return!!m.workspaceUri}e.$bD=C;function r(m){return!!m.folderUri}e.$cD=r;function O(m){return!!m.fileUri}e.$dD=O;function A(m){const d=P(m),p=m.getValue("window.menuBarVisibility");return p==="default"||d==="native"&&p==="compact"||E.$j&&E.$m?"classic":p}e.$eD=A;function P(m){if(E.$o)return"custom";const d=m.getValue("window");if(d){if(E.$j&&d.nativeTabs===!0||E.$j&&d.nativeFullScreen===!1)return"native";const y=d.titleBarStyle;if(y==="native"||y==="custom")return y}return E.$k?"native":"custom"}e.$fD=P;function f(m){if(!E.$i||E.$o||P(m)==="native")return!1;const d=m.getValue("window.experimental.windowControlsOverlay.enabled");return typeof d=="boolean"?d:!0}e.$gD=f;function l(m=0){return Math.pow(1.2,m)}e.$hD=l}),define(ee[127],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$d2b=e.UnloadReason=e.LoadReason=void 0;var E;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(E||(e.LoadReason=E={}));var C;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(C||(e.UnloadReason=C={}));const r=function(P=1){return{width:1024,height:768,mode:P}};e.$d2b=r;var O;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(O||(e.WindowMode=O={}));var A;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(A||(e.WindowError=A={}))}),define(ee[29],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.$e2b=void 0,e.$e2b=(0,E.$lh)("windowsMainService");var C;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(C||(e.OpenContext=C={}))}),define(ee[272],te([0,1,14,21,4,56,2,31,75,114,5,23,29]),function(G,e,E,C,r,O,A,P,f,l,m,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f2b=void 0;var h;(function(b){b[b.Initial=1]="Initial",b[b.StoredCredentialsUsed=2]="StoredCredentialsUsed",b[b.LoginDialogShown=3]="LoginDialogShown"})(h||(h={}));let y=e.$f2b=class extends A.$kb{constructor(o,g,a,v,k){super(),this.g=o,this.h=g,this.i=a,this.j=v,this.k=k,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=h.Initial,this.f=void 0,this.l()}l(){const o=r.Event.fromNodeEventEmitter(E.app,"login",(g,a,v,k,w)=>({event:g,webContents:a,req:v,authInfo:k,callback:w}));this.B(o(this.m,this))}async m({event:o,authInfo:g,req:a,callback:v}){if(!g.isProxy)return;if(!this.b&&this.c===h.LoginDialogShown&&a.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}o.preventDefault();let k;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),k=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(g);try{k=await this.b}finally{this.b=void 0}}v(k?.username,k?.password)}async n(o){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const g=await this.p(o);if(g)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),g;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(o){this.g.trace("auth#doResolveProxyCredentials - enter",o);const g=String((0,O.$_h)({scheme:o.scheme,host:o.host,port:o.port}));let a,v;try{const u=await this.i.getPassword(this.a,g);if(u){const s=JSON.parse(await this.j.decrypt(u));a=s.username,v=s.password}}catch(u){this.g.error(u)}if(this.c!==h.StoredCredentialsUsed&&typeof a=="string"&&typeof v=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=h.StoredCredentialsUsed,{username:a,password:v};const k=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!k){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${k.id} to handle proxy login`);const w={authInfo:o,username:this.f?.username??a,password:this.f?.password??v,replyChannel:`vscode:proxyAuthResponse:${(0,P.$3e)()}`};k.sendWhenReady("vscode:openProxyAuthenticationDialog",C.CancellationToken.None,w),this.c=h.LoginDialogShown;const t=await new Promise(u=>{const s=async(i,n,c)=>{if(n===w.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${k.id}`),k.win?.webContents.off("ipc-message",s),c){const $={username:c.username,password:c.password};try{if(c.remember){const R=await this.j.encrypt(JSON.stringify($));await this.i.setPassword(this.a,g,R)}else await this.i.deletePassword(this.a,g)}catch(R){this.g.error(R)}u({username:$.username,password:$.password})}else u(void 0)};k.win?.webContents.on("ipc-message",s)});return this.f=t,t}};e.$f2b=y=pe([x(0,m.$Ni),x(1,p.$e2b),x(2,f.$jn),x(3,l.$xob),x(4,d.$6i)],y)}),define(ee[273],te([0,1,75,5,33,23,29,217]),function(G,e,E,C,r,O,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M3b=void 0;let f=e.$M3b=class extends P.$ln{constructor(m,d,p,h){super(m),this.n=d,this.p=p,this.r=h,this.j=y=>{this.r.sendToFocused("vscode:showCredentialsError",y.message??y)}}async getSecretStoragePrefix(){return Promise.resolve(this.p.urlProtocol)}async i(){if(this.f)return this.f;if(this.n.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.$kn,this.f;const m=await new Promise((d,p)=>{G(["keytar"],d,p)});return await m.findCredentials("test-keytar-loads"),this.f=m,this.f}};e.$M3b=f=pe([x(0,C.$Ni),x(1,r.$th),x(2,O.$6i),x(3,A.$e2b)],f)}),define(ee[274],te([0,1,14,24,3,7,22,18,63,6,5,126,29]),function(G,e,E,C,r,O,A,P,f,l,m,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$52b=e.$42b=e.ID=void 0,e.ID="launchMainService",e.$42b=(0,l.$lh)(e.ID);let h=e.$52b=class{constructor(b,o,g,a){this.a=b,this.b=o,this.c=g,this.d=a}async start(b,o){this.a.trace("Received data from other instance: ",b,o),r.$j&&E.app.focus({steal:!0});const g=this.e(b);if(g.length){let a=Promise.resolve();if(this.b.getWindowCount()===0){const v=(0,C.$sf)(await this.b.openEmptyWindow({context:4}));v&&(a=v.ready())}a.then(()=>{for(const{uri:v,originalUrl:k}of g)this.c.open(v,{originalUrl:k})})}else return this.f(b,o)}e(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,C.$jf)(b._urls.map(o=>{try{return{uri:O.URI.parse(o),originalUrl:o}}catch{return null}})):[]}async f(b,o){const g=(0,f.$ol)(o)?0:4;let a=[];const v=b.wait&&b.waitMarkerFilePath?O.URI.file(b.waitMarkerFilePath):void 0,k=b.remote||void 0,w={context:g,cli:b,userEnv:o,waitMarkerFileURI:v,remoteAuthority:k,forceProfile:b.profile,forceTempProfile:b["profile-temp"]};if(b.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,w);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let t=!1;if(b["new-window"]||b["unity-launch"]||w.forceProfile||w.forceTempProfile)t=!0;else if(b["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!r.$j}if(t)a=await this.b.open({...w,forceNewWindow:!0,forceEmpty:!0});else{const u=this.b.getLastActiveWindow();u?(this.b.openExistingWindow(u,w),a=[u]):a=await this.b.open({...w,forceEmpty:!0})}}else a=await this.b.open({...w,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if(v&&a.length===1&&a[0])return Promise.race([a[0].whenClosedOrLoaded,(0,A.whenDeleted)(v.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$52b=h=pe([x(0,m.$Ni),x(1,p.$e2b),x(2,d.$Zhb),x(3,P.$Rh)],h)}),define(ee[275],te([0,1,14,4,2,271,29]),function(G,e,E,C,r,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E3b=void 0;let P=e.$E3b=class extends r.$kb{constructor(l){super(),this.b=l,this.a=this.B(new C.$5c),this.onFoundInFrame=this.a.event,this.B(new O.$D3b)}async setIgnoreMenuShortcuts(l,m){let d;if(typeof l.windowId=="number"){const{windowId:p}=l,h=this.b.getWindowById(p);if(!h?.win)throw new Error(`Invalid windowId: ${p}`);d=h.win.webContents}else{const{webContentsId:p}=l;if(d=E.webContents.fromId(p),!d)throw new Error(`Invalid webContentsId: ${p}`)}d.isDestroyed()||d.setIgnoreMenuShortcuts(m)}async findInFrame(l,m,d,p){const y=this.c(l,m);if(typeof y.findInFrame=="function"){y.findInFrame(d,{findNext:p.findNext,forward:p.forward});const b=(o,g)=>{g.finalUpdate&&(this.a.fire(g),y.removeListener("found-in-frame",b))};y.on("found-in-frame",b)}}async stopFindInFrame(l,m,d){const h=this.c(l,m);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(d.keepSelection?"keepSelection":"clearSelection")}c(l,m){const d=this.b.getWindowById(l.windowId);if(!d?.win)throw new Error(`Invalid windowId: ${l}`);const p=d.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===m);if(!p)throw new Error(`Unknown frame: ${m}`);return p}};e.$E3b=P=pe([x(0,A.$e2b)],P)}),define(ee[276],te([0,1,8,4,2]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K3b=void 0;class O extends r.$kb{constructor({onDidOpenWindow:P,onDidFocusWindow:f,getActiveWindowId:l}){super(),this.a=this.B(new r.$jb),C.Event.latch(C.Event.any(P,f))(this.f,this,this.a),this.b=(0,E.$fg)(()=>l()),(async()=>{try{const d=await this.b;this.c=typeof this.c=="number"?this.c:d}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$K3b=O}),define(ee[30],te([0,1,190,9,62,19,7,6,15]),function(G,e,E,C,r,O,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.WorkbenchState=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$uh=(0,P.$lh)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.$vh=l;function m(i){return typeof i?.id=="string"&&!l(i)&&!p(i)}e.$wh=m,e.$xh={id:"ext-dev"},e.$yh={id:"empty-window"};function d(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,C.$cc)(i)}:n?e.$xh:e.$yh;const c=i;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.$zh=d;function p(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.$Ah=p;function h(i){const n=i;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const c=i;if(c?.configPath)return{id:c.id,configPath:A.URI.revive(c.configPath)};if(i?.id)return{id:i.id}}e.$Bh=h;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Ch=b;function o(i){const n=i;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Dh=o;class g{constructor(n,c,$,R,I){this.h=n,this.j=$,this.k=R,this.l=I,this.c=r.$rh.forUris(this.l,()=>!0),this.folders=c}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=r.$rh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Eh=g;class a{constructor(n,c){this.raw=c,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,O.$6f)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Fh=a;function v(i){return new a({uri:i,index:0,name:(0,O.$2f)(i)},{uri:i.toString()})}e.$Gh=v,e.$Hh="code-workspace",e.$Ih=`.${e.$Hh}`,e.$Jh=[{name:(0,E.localize)(0,null),extensions:[e.$Hh]}],e.$Kh="workspace.json";function k(i,n){return O.$Wf.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$Lh=k;function w(i){let n;return A.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.$Mh=w,e.$Nh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Nh}e.$Oh=t;function u(i,n){return!k(i,n)&&!w(i)}e.$Ph=u;function s(i){return(typeof i=="string"?(0,C.$dc)(i):(0,O.$4f)(i))===e.$Ih}e.$Qh=s}),define(ee[59],te([0,1,14,8,56,46,2,84,3,11,22,165,91,6,5,23,30]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t2b=e.$s2b=void 0,e.$s2b=(0,h.$lh)("dialogMainService");let g=e.$t2b=class{constructor(v,k){this.d=v,this.e=k,this.a=new Map,this.b=new Map,this.c=new C.$yg}pickFileFolder(v,k){return this.f({...v,pickFolders:!0,pickFiles:!0,title:(0,d.localize)(0,null)},k)}pickFolder(v,k){return this.f({...v,pickFolders:!0,title:(0,d.localize)(1,null)},k)}pickFile(v,k){return this.f({...v,pickFiles:!0,title:(0,d.localize)(2,null)},k)}pickWorkspace(v,k){const w=(0,d.localize)(3,null),t=(0,O.$Uz)((0,d.localize)(4,null)),u=o.$Jh;return this.f({...v,pickFiles:!0,title:w,filters:u,buttonLabel:t},k)}async f(v,k){const w={title:v.title,buttonLabel:v.buttonLabel,filters:v.filters,defaultPath:v.defaultPath};(typeof v.pickFiles=="boolean"||typeof v.pickFolders=="boolean")&&(w.properties=void 0,v.pickFiles&&v.pickFolders&&(w.properties=["multiSelections","openDirectory","openFile","createDirectory"])),w.properties||(w.properties=["multiSelections",v.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$j&&w.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(w,(0,l.$ye)(k||E.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(v){if(v){let k=this.b.get(v.id);return k||(k=new C.$yg,this.b.set(v.id,k)),k}else return this.c}showMessageBox(v,k){return this.g(k).queue(async()=>{const{options:w,buttonIndeces:t}=(0,p.$2z)(v,this.e);let u;return k?u=await E.dialog.showMessageBox(k,w):u=await E.dialog.showMessageBox(w),{response:t[u.response],checkboxChecked:u.checkboxChecked}})}async showSaveDialog(v,k){const w=this.j(v,k);if(!w)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(k).queue(async()=>{let t;return k?t=await E.dialog.showSaveDialog(k,v):t=await E.dialog.showSaveDialog(v),t.filePath=this.h(t.filePath),t})}finally{(0,A.$fb)(w)}}h(v){return v&&f.$j&&(v=(0,P.$3k)(v)),v}i(v){return v.map(k=>this.h(k))}async showOpenDialog(v,k){v.defaultPath&&(await m.Promises.exists(v.defaultPath)||(v.defaultPath=void 0));const w=this.j(v,k);if(!w)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(k).queue(async()=>{let t;return k?t=await E.dialog.showOpenDialog(k,v):t=await E.dialog.showOpenDialog(v),t.filePaths=this.i(t.filePaths),t})}finally{(0,A.$fb)(w)}}j(v,k){if(!k)return A.$kb.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",v);let w=this.a.get(k.id);w||(w=new Set,this.a.set(k.id,w));const t=(0,r.$_h)(v);if(!w.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",v),w.add(t),(0,A.$ib)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",v),w?.delete(t),w?.size===0&&this.a.delete(k.id)})}};e.$t2b=g=pe([x(0,y.$Ni),x(1,b.$6i)],g)}),define(ee[277],te([0,1,4,2,73,30]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n3b=void 0;class A extends C.$kb{constructor(f,l){super(),this.f=f,this.g=l,this.b=this.B(new E.$5c),this.c=new Map,this.h(l.applicationStorage,this.b)}h(f,l){this.B(E.Event.debounce(f.onDidChangeStorage,(m,d)=>(m?m.push(d):m=[d],m),A.a)(m=>{m.length&&l.fire(this.i(m,f))}))}i(f,l){const m=new Map,d=new Set;return f.forEach(p=>{const h=l.get(p.key);typeof h=="string"?m.set(p.key,h):d.add(p.key)}),{changed:Array.from(m.entries()),deleted:Array.from(d.values())}}listen(f,l,m){switch(l){case"onDidChangeStorage":{const d=m.profile?(0,r.$Ug)(m.profile):void 0;if(!d)return this.b.event;let p=this.c.get(d.id);return p||(p=this.B(new E.$5c),this.h(this.g.profileStorage(d),p),this.c.set(d.id,p)),p.event}}throw new Error(`Event not found: ${l}`)}async call(f,l,m){const d=m.profile?(0,r.$Ug)(m.profile):void 0,p=(0,O.$Bh)(m.workspace),h=await this.j(d,p);switch(l){case"getItems":return Array.from(h.items.entries());case"updateItems":{const y=m;if(y.insert)for(const[b,o]of y.insert)h.set(b,o);y.delete?.forEach(b=>h.delete(b));break}case"isUsed":{const y=m.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${l}`)}}async j(f,l){let m;l?m=this.g.workspaceStorage(l):f?m=this.g.profileStorage(f):m=this.g.applicationStorage;try{await m.init()}catch(d){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":f?"profile":"application"} storage due to ${d}`)}return m}}e.$n3b=A,A.a=100}),define(ee[41],te([0,1,56,4,2,19,7,187,33,16,6,5,30,35,40,8,31,25,11]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=void 0;function v(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&A.URI.isUri(i.location)&&A.URI.isUri(i.globalStorageHome)&&A.URI.isUri(i.settingsResource)&&A.URI.isUri(i.keybindingsResource)&&A.URI.isUri(i.tasksResource)&&A.URI.isUri(i.snippetsHome)&&A.URI.isUri(i.extensionsResource))}e.$mk=v,e.$nk=(0,m.$lh)("IUserDataProfilesService");function k(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:A.URI.revive(s.location).with({scheme:i}),globalStorageHome:A.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:A.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:A.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:A.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:A.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:A.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:A.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$ok=k;function w(s,i,n,c,$){return{id:s,name:i,location:n,isDefault:!1,shortName:$?.shortName,globalStorageHome:(0,O.$6f)(n,"globalStorage"),settingsResource:(0,O.$6f)(n,"settings.json"),keybindingsResource:(0,O.$6f)(n,"keybindings.json"),tasksResource:(0,O.$6f)(n,"tasks.json"),snippetsHome:(0,O.$6f)(n,"snippets"),extensionsResource:(0,O.$6f)(n,"extensions.json"),cacheHome:(0,O.$6f)(c,s),useDefaultFlags:$?.useDefaultFlags,isTransient:$?.transient}}e.$pk=w;let t=e.$qk=class extends r.$kb{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,n,c,$){super(),this.n=i,this.r=n,this.s=c,this.t=$,this.f=!0,this.h=this.B(new C.$5c),this.onDidChangeProfiles=this.h.event,this.i=this.B(new C.$5c),this.onWillCreateProfile=this.i.event,this.j=this.B(new C.$5c),this.onWillRemoveProfile=this.j.event,this.k=this.B(new C.$5c),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new h.$ji,emptyWindows:new Map},this.profilesHome=(0,O.$6f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,O.$6f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=[];if(this.f)try{for(const R of this.J()){if(!R.name||!(0,a.$ge)(R.name)||!R.location){this.t.warn("Skipping the invalid stored profile",R.location||R.name);continue}i.push(w((0,O.$3f)(R.location),R.name,R.location,this.g,{shortName:R.shortName,useDefaultFlags:R.useDefaultFlags}))}}catch(R){this.t.error(R)}const n=new h.$ji,c=new Map,$=this.w();if(i.unshift({...$,extensionsResource:this.O()??$.extensionsResource,isDefault:!0}),i.length)try{const R=this.M();if(R.workspaces)for(const[I,S]of Object.entries(R.workspaces)){const M=A.URI.parse(I),j=i.find(F=>F.id===S);j&&n.set(M,j)}if(R.emptyWindows)for(const[I,S]of Object.entries(R.emptyWindows)){const M=i.find(j=>j.id===S);M&&c.set(I,M)}}catch(R){this.t.error(R)}this.u={profiles:i,workspaces:n,emptyWindows:c}}return this.u}w(){return w("__default__profile__",(0,P.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(i){const n="Temp",c=new RegExp(`${(0,g.$ld)(n)}\\s(\\d+)`);let $=0;for(const I of this.profiles){const S=c.exec(I.name),M=S?parseInt(S[1]):0;$=M>$?M:$}const R=`${n} ${$+1}`;return this.createProfile((0,E.$_h)((0,o.$3e)()).toString(16),R,{transient:!0},i)}async createNamedProfile(i,n,c){return this.createProfile((0,E.$_h)((0,o.$3e)()).toString(16),i,n,c)}async createProfile(i,n,c,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.y(i,n,c);return $&&await this.setProfileForWorkspace($,R),R}async y(i,n,c){if(!(0,a.$ge)(n)||!n)throw new Error("Name of the profile is mandatory and must be of type `string`");let $=this.l.get(n);return $||($=(async()=>{try{const R=this.profiles.find(M=>M.name===n||M.id===i);if(R)return R;const I=w(i,n,(0,O.$6f)(this.profilesHome,i),this.g,c);await this.r.createFolder(I.location);const S=[];return this.i.fire({profile:I,join(M){S.push(M)}}),await b.Promises.settled(S),this.D([I],[],[]),I}finally{this.l.delete(n)}})(),this.l.set(n,$)),$}async updateProfile(i,n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find($=>$.id===i.id);if(!c)throw new Error(`Profile '${i.name}' does not exist`);return c=w(c.id,n.name??c.name,c.location,this.g,{shortName:n.shortName??c.shortName,transient:n.transient??c.isTransient,useDefaultFlags:n.useDefaultFlags??c.useDefaultFlags}),this.D([],[],[c]),c}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const n=this.profiles.find($=>$.id===i.id);if(!n)throw new Error(`Profile '${i.name}' does not exist`);const c=[];this.j.fire({profile:n,join($){c.push($)}});try{await Promise.allSettled(c)}catch($){this.t.error($)}for(const $ of[...this.v.emptyWindows.keys()])n.id===this.v.emptyWindows.get($)?.id&&this.v.emptyWindows.delete($);for(const $ of[...this.v.workspaces.keys()])n.id===this.v.workspaces.get($)?.id&&this.v.workspaces.delete($);this.H(),this.D([],[n],[]);try{await this.r.del(n.cacheHome,{recursive:!0})}catch($){(0,l.$5j)($)!==1&&this.t.error($)}}async setProfileForWorkspace(i,n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find($=>$.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);this.G(i,c)}unsetWorkspace(i,n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,n)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(n=>n.isDirectory&&this.profiles.every(c=>!this.s.extUri.isEqual(c.location,n.resource))).map(n=>this.r.del(n.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(n=>!this.C(n));await Promise.allSettled(i.map(n=>this.removeProfile(n)))}getProfileForWorkspace(i){const n=this.z(i);return A.URI.isUri(n)?this.m.workspaces.get(n)??this.v.workspaces.get(n):this.m.emptyWindows.get(n)??this.v.emptyWindows.get(n)}z(i){return(0,p.$vh)(i)?i.uri:(0,p.$Ah)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(n=>this.s.extUri.isEqual(n.location,i.location))||[...this.m.workspaces.values()].some(n=>this.s.extUri.isEqual(n.location,i.location))||[...this.v.emptyWindows.values()].some(n=>this.s.extUri.isEqual(n.location,i.location))||[...this.v.workspaces.values()].some(n=>this.s.extUri.isEqual(n.location,i.location)))}D(i,n,c){const $=[...this.profiles,...i],R=[];this.m.profiles=[];for(let I of $)I.isDefault||n.some(S=>I.id===S.id)||(I=c.find(S=>I.id===S.id)??I,I.isTransient?this.m.profiles.push(I):R.push({location:I.location,name:I.name,shortName:I.shortName,useDefaultFlags:I.useDefaultFlags}));this.L(R),this.u=void 0,this.F(i,n,c)}F(i,n,c){this.h.fire({added:i,removed:n,updated:c,all:this.profiles})}G(i,n,c){c=n?.isTransient?!0:c,c||this.G(i,void 0,!0);const $=this.z(i),R=c?this.m:this.v;A.URI.isUri($)?(R.workspaces.delete($),n&&R.workspaces.set($,n)):(R.emptyWindows.delete($),n&&R.emptyWindows.set($,n)),c||this.H()}H(){const i={};for(const[c,$]of this.v.workspaces.entries())i[c.toString()]=$.id;const n={};for(const[c,$]of this.v.emptyWindows.entries())n[c.toString()]=$.id;this.N({workspaces:i,emptyWindows:n}),this.u=void 0}I(i){const n={},c=this.w();if(i.workspaces)for(const[R,I]of Object.entries(i.workspaces)){const S=A.URI.parse(I);n[R]=this.s.extUri.isEqual(S,c.location)?c.id:this.s.extUri.basename(S)}const $={};if(i.emptyWindows)for(const[R,I]of Object.entries(i.emptyWindows)){const S=A.URI.parse(I);$[R]=this.s.extUri.isEqual(S,c.location)?c.id:this.s.extUri.basename(S)}return{workspaces:n,emptyWindows:$}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",e.$qk=t=pe([x(0,f.$sh),x(1,l.$Oj),x(2,y.$lk),x(3,d.$Ni)],t);class u extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.$rk=u}),define(ee[81],te([0,1,8,17,2,4,35,7,115,122,16,6,5,41,40,11,13,26]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.ExtensionsProfileScanningErrorCode=void 0;var a;(function(u){u.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",u.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(a||(e.ExtensionsProfileScanningErrorCode=a={}));class v extends Error{constructor(s,i){super(s),this.code=i}}e.$7o=v,e.$8o=(0,d.$lh)("IExtensionsProfileScannerService");let k=e.$9o=class extends r.$kb{constructor(s,i,n,c,$,R){super(),this.i=s,this.j=i,this.k=n,this.l=c,this.m=$,this.n=R,this.b=this.B(new O.$5c),this.onAddExtensions=this.b.event,this.c=this.B(new O.$5c),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$5c),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$5c),this.onDidRemoveExtensions=this.g.event,this.h=new A.$ji}scanProfileExtensions(s,i){return this.p(s,void 0,i)}async addExtensionsToProfile(s,i){const n=[],c=[];try{return await this.p(i,$=>{const R=[];for(const I of $)s.some(([S])=>(0,l.$bo)(S.identifier,I.identifier)&&S.manifest.version!==I.version)?n.push(I):R.push(I);for(const[I,S]of s)if(!R.some(M=>(0,l.$bo)(M.identifier,I.identifier)&&M.version===I.manifest.version)){const M={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:S};c.push(M),R.push(M)}return c.length&&this.b.fire({extensions:c,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),R}),c.length&&this.c.fire({extensions:c,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),c}catch($){throw c.length&&this.c.fire({extensions:c,error:$,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:$,profileLocation:i}),$}}async updateMetadata(s,i){const n=[];return await this.p(i,c=>{const $=[];for(const R of c){const I=s.find(([S])=>(0,l.$bo)(S.identifier,R.identifier)&&S.manifest.version===R.version);I&&(R.metadata={...R.metadata,...I[1]},n.push(R)),$.push(R)}return $}),n}async removeExtensionFromProfile(s,i){const n=[];this.f.fire({extensions:n,profileLocation:i});try{await this.p(i,c=>{const $=[];for(const R of c)(0,l.$bo)(R.identifier,s.identifier)?n.push(R):$.push(R);return n.length&&this.f.fire({extensions:n,profileLocation:i}),$}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(c){throw n.length&&this.g.fire({extensions:n,error:c,profileLocation:i}),c}}async p(s,i,n){return this.w(s).queue(async()=>{let c=[],$;try{const R=await this.j.readFile(s);$=JSON.parse(R.value.toString().trim()||"[]")}catch(R){if((0,m.$5j)(R)!==1)throw R;if(this.l.extUri.isEqual(s,this.k.defaultProfile.extensionsResource)&&($=await this.v()),!$&&n?.bailOutWhenFileNotFound)throw new v((0,o.$8)(R),"ERROR_PROFILE_NOT_FOUND")}if($){Array.isArray($)||this.r(s);let R=!1;for(const I of $){w(I)||this.r(s);let S;if((0,b.$ge)(I.relativeLocation)&&I.relativeLocation)S=this.t(I.relativeLocation);else if((0,b.$ge)(I.location))S=this.t(I.location),R=!0,I.relativeLocation=I.location,I.location=S.toJSON();else{S=P.URI.revive(I.location);const M=this.s(S);M&&(R=!0,I.relativeLocation=M)}c.push({identifier:I.identifier,location:S,version:I.version,metadata:I.metadata})}R&&await this.j.writeFile(s,C.$Ib.fromString(JSON.stringify($)))}if(i){c=i(c);const R=c.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.s(I.location),metadata:I.metadata}));await this.j.writeFile(s,C.$Ib.fromString(JSON.stringify(R)))}return c})}r(s){const i=new v(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(s){return this.l.extUri.isEqual(this.l.extUri.dirname(s),this.i)?this.l.extUri.basename(s):void 0}t(s){return this.l.extUri.joinPath(this.i,s)}async v(){return this.u||(this.u=(async()=>{const s=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let n;try{n=(await this.j.readFile(s)).value.toString()}catch($){if((0,m.$5j)($)===1)return;throw $}this.n.info("Migrating extensions from old default profile location",s.toString());let c;try{const $=JSON.parse(n);Array.isArray($)&&$.every(R=>w(R))?c=$:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",$)}catch($){this.n.error($)}if(c)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,C.$Ib.fromString(JSON.stringify(c)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",s.toString(),this.k.defaultProfile.extensionsResource.toString())}catch($){if((0,m.$5j)($)===3)this.n.info("Migration from old default profile location to new location is done by another window",s.toString(),this.k.defaultProfile.extensionsResource.toString());else throw $}try{await this.j.del(s)}catch($){(0,m.$5j)($)!==1&&this.n.error($)}try{await this.j.del(i)}catch($){(0,m.$5j)($)!==1&&this.n.error($)}return c})()),this.u}w(s){let i=this.h.get(s);return i||(i=new E.$yg,this.h.set(s,i)),i}};e.$9o=k=pe([x(1,m.$Oj),x(2,h.$nk),x(3,y.$lk),x(4,g.$Rk),x(5,p.$Ni)],k);function w(u){return(0,b.$ie)(u)&&(0,f.$Kn)(u.identifier)&&(t(u.location)||(0,b.$ge)(u.location)&&u.location)&&((0,b.$ne)(u.relativeLocation)||(0,b.$ge)(u.relativeLocation))&&u.version&&(0,b.$ge)(u.version)}function t(u){return u?(0,b.$ge)(u.path)&&(0,b.$ge)(u.scheme):!1}}),define(ee[128],te([0,1,24,8,37,17,13,45,150,2,15,9,3,19,203,69,11,7,170,33,122,119,202,16,6,5,23,4,73,81,41,40,201]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a,v,k,w,t,u,s,i,n,c,$,R,I,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.Translations=void 0;var j;(function(le){function K(Y,N){if(Y===N)return!0;const W=Object.keys(Y),T=new Set;for(const J of Object.keys(N))T.add(J);if(W.length!==T.size)return!1;for(const J of W){if(Y[J]!==N[J])return!1;T.delete(J)}return T.size===0}le.equals=K})(j||(e.Translations=j={})),e.$_o=(0,s.$lh)("IExtensionsScannerService");let F=e.$ap=class extends l.$kb{constructor(K,Y,N,W,T,J,Q,ae,oe,L,D,U){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=Y,this.l=N,this.m=W,this.n=T,this.r=J,this.s=Q,this.t=ae,this.u=oe,this.v=L,this.w=D,this.y=U,this.g=this.B(new c.$5c),this.onDidChangeCache=this.g.event,this.h=(0,h.$6f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(ie,this.m,this.h)),this.j=this.B(this.y.createInstance(ie,this.m,this.h)),this.k=this.B(this.y.createInstance(re,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,k.$mo)(this.s,this.t)),this.z}async scanAllExtensions(K,Y,N){const[W,T]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(Y)]),J=N?await this.scanExtensionsUnderDevelopment(K,[...W,...T]):[];return this.G(W,T,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const Y=[];Y.push(this.H(!!K.useCache,K.language)),Y.push(this.I(K.language,!!K.checkControlFile));const[N,W]=await Promise.all(Y);return this.F([...N,...W],0,K,!1)}async scanUserExtensions(K){const Y=K.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",Y);const N=this.w.extUri.isEqual(K.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.L(Y,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,N),T=K.useCache&&!W.devMode&&W.excludeObsolete?this.j:this.k;let J;try{J=await T.scanExtensions(W)}catch(Q){if(Q instanceof R.$7o&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),J=await T.scanExtensions(W);else throw Q}return J=await this.F(J,1,K,!0),this.t.trace("Scanned user extensions:",J.length),J}async scanExtensionsUnderDevelopment(K,Y){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const N=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(W=>W.scheme===m.Schemas.file).map(async W=>{const T=await this.L(W,!1,1,!0,K.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(T)).map(Q=>(Q.type=Y.find(ae=>(0,k.$bo)(ae.identifier,Q.identifier))?.type??Q.type,this.k.validate(Q,T)))}))).flat();return this.F(N,"development",K,!0)}return[]}async scanExistingExtension(K,Y,N){const W=await this.L(K,!1,Y,!0,N.language,!0,void 0),T=await this.k.scanExtension(W);return!T||!N.includeInvalid&&!T.isValid?null:T}async scanOneOrMultipleExtensions(K,Y,N){const W=await this.L(K,!1,Y,!0,N.language,!0,void 0),T=await this.k.scanOneOrMultipleExtensions(W);return this.F(T,Y,N,!0)}async scanMetadata(K){const Y=(0,h.$6f)(K,"package.json"),N=(await this.s.readFile(Y)).value.toString();return JSON.parse(N).__metadata}async updateMetadata(K,Y){const N=(0,h.$6f)(K,"package.json"),W=(await this.s.readFile(N)).value.toString(),T=JSON.parse(W);Y.isMachineScoped=Y.isMachineScoped||void 0,Y.isBuiltin=Y.isBuiltin||void 0,T.__metadata={...T.__metadata,...Y},await this.s.writeFile((0,h.$6f)(K,"package.json"),O.$Ib.fromString(JSON.stringify(T,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof R.$7o&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw K}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.r.addExtensionsToProfile(K.map(Y=>[Y,Y.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,O.$Ib.fromString(JSON.stringify([])))}catch(Y){(0,u.$5j)(Y)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$8)(Y))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.t.error(K)}finally{this.C=void 0}})()),this.C}async F(K,Y,N,W){return N.includeAllVersions||(K=this.G(Y===0?K:void 0,Y===1?K:void 0,Y==="development"?K:void 0,await this.getTargetPlatform(),W)),N.includeInvalid||(K=K.filter(T=>T.isValid)),K.sort((T,J)=>{const Q=d.$cc(T.location.fsPath),ae=d.$cc(J.location.fsPath);return Q<ae?-1:Q>ae?1:0})}G(K,Y,N,W,T){const J=(ae,oe,L)=>{if(ae.isValid&&!oe.isValid)return!1;if(ae.isValid===oe.isValid){if(T&&y.gt(ae.manifest.version,oe.manifest.version))return this.t.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(y.eq(ae.manifest.version,oe.manifest.version)){if(ae.type===0)return this.t.debug(`Skipping extension ${oe.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===W)return this.t.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return L?this.t.warn(`Overwriting user extension ${ae.location.path} with ${oe.location.path}.`):this.t.debug(`Overwriting user extension ${ae.location.path} with ${oe.location.path}.`),!0},Q=new w.$Fl;return K?.forEach(ae=>{const oe=Q.get(ae.identifier.id);(!oe||J(oe,ae,!1))&&Q.set(ae.identifier.id,ae)}),Y?.forEach(ae=>{const oe=Q.get(ae.identifier.id);if(!oe&&K&&ae.type===0){this.t.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!oe||J(oe,ae,!1))&&Q.set(ae.identifier.id,ae)}),N?.forEach(ae=>{const oe=Q.get(ae.identifier.id);(!oe||J(oe,ae,!0))&&Q.set(ae.identifier.id,ae),Q.set(ae.identifier.id,ae)}),[...Q.values()]}async H(K,Y){this.t.trace("Started scanning system extensions");const N=await this.L(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),T=await(K&&!N.devMode?this.i:this.k).scanExtensions(N);return this.t.trace("Scanned system extensions:",T.length),T}async I(K,Y){const N=this.u.isBuilt?[]:this.v.builtInExtensions;if(!N?.length)return[];this.t.trace("Started scanning dev system extensions");const W=Y?await this.J():{},T=[],J=g.URI.file(d.$9b(d.$$b(m.$1e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of N){const oe=W[ae.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":T.push((0,h.$6f)(J,ae.name));break;default:T.push(g.URI.file(oe));break}}const Q=await Promise.all(T.map(async ae=>this.k.scanExtension(await this.L(ae,!1,0,!0,K,!0,void 0))));return this.t.trace("Scanned dev system extensions:",Q.length),(0,E.$jf)(Q)}async J(){try{const K=await this.s.readFile(this.l);return JSON.parse(K.value.toString())}catch{return{}}}async L(K,Y,N,W,T,J,Q){const ae=await this.f(T??p.$v),oe=await this.M(K),L=Y&&!this.w.extUri.isEqual(K,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,D=L?await this.M(L):void 0;return new q(K,oe,L,D,Y,Q,N,W,J,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,T,ae)}async M(K){try{const Y=await this.s.stat(K);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.$ap=F=pe([x(4,I.$nk),x(5,R.$8o),x(6,u.$Oj),x(7,i.$Ni),x(8,v.$sh),x(9,n.$6i),x(10,S.$lk),x(11,s.$kh)],F);class q{constructor(K,Y,N,W,T,J,Q,ae,oe,L,D,U,H,V,z){this.location=K,this.mtime=Y,this.applicationExtensionslocation=N,this.applicationExtensionslocationMtime=W,this.profile=T,this.profileScanOptions=J,this.type=Q,this.excludeObsolete=ae,this.validate=oe,this.productVersion=L,this.productDate=D,this.productCommit=U,this.devMode=H,this.language=V,this.translations=z}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,Y){return(0,h.$Yf)(K.location,Y.location)&&K.mtime===Y.mtime&&(0,h.$Yf)(K.applicationExtensionslocation,Y.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&K.profile===Y.profile&&r.$Hm(K.profileScanOptions,Y.profileScanOptions)&&K.type===Y.type&&K.excludeObsolete===Y.excludeObsolete&&K.validate===Y.validate&&K.productVersion===Y.productVersion&&K.productDate===Y.productDate&&K.productCommit===Y.productCommit&&K.devMode===Y.devMode&&K.language===Y.language&&j.equals(K.translations,Y.translations)}}e.$bp=q;let re=class extends l.$kb{constructor(K,Y,N,W,T){super(),this.f=K,this.g=Y,this.h=N,this.i=W,this.j=T}async scanExtensions(K){const Y=K.profile?await this.l(K):await this.k(K);let N={};if(K.excludeObsolete&&K.type===1)try{const W=(await this.i.readFile(this.f)).value.toString();N=JSON.parse(W)}catch{}return(0,o.$te)(N)?Y:Y.filter(W=>!N[k.$co.create(W).toString()])}async k(K){const Y=await this.i.resolve(K.location);if(!Y.children?.length)return[];const N=await Promise.all(Y.children.map(async W=>{if(!W.isDirectory||K.type===1&&(0,h.$3f)(W.resource).indexOf(".")===0)return null;const T=new q(W.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(T)}));return(0,E.$jf)(N).sort((W,T)=>W.location.path<T.location.path?-1:1)}async l(K){let Y=await this.m(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){Y=Y.filter(W=>!W.metadata?.isApplicationScoped);const N=await this.m(K.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,K);Y.push(...N)}return Y}async m(K,Y,N){const W=await this.g.scanProfileExtensions(K,N.profileScanOptions);if(!W.length)return[];const T=await Promise.all(W.map(async J=>{if(Y(J)){const Q=new q(J.location,N.mtime,N.applicationExtensionslocation,N.applicationExtensionslocationMtime,N.profile,N.profileScanOptions,N.type,N.excludeObsolete,N.validate,N.productVersion,N.productDate,N.productCommit,N.devMode,N.language,N.translations);return this.scanExtension(Q,J.metadata)}return null}));return(0,E.$jf)(T)}async scanOneOrMultipleExtensions(K){try{if(await this.i.exists((0,h.$6f)(K.location,"package.json"))){const Y=await this.scanExtension(K);return Y?[Y]:[]}else return await this.scanExtensions(K)}catch(Y){return this.j.error(`Error scanning extensions at ${K.location.path}:`,(0,A.$8)(Y)),[]}}async scanExtension(K,Y){try{let N=await this.scanExtensionManifest(K.location);if(N){N.publisher||(N.publisher=w.$zl),Y=Y??N.__metadata,delete N.__metadata;const W=(0,k.$go)(N.publisher,N.name),T=Y?.id?{id:W,uuid:Y.id}:{id:W},J=Y?.isSystem?0:K.type,Q=J===0||!!Y?.isBuiltin;N=await this.n(K.location,N,q.createNlsConfiguration(K));const ae={type:J,identifier:T,manifest:N,location:K.location,isBuiltin:Q,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return K.validate?this.validate(ae,K):ae}}catch(N){K.type!==0&&this.j.error(N)}return null}validate(K,Y){let N=!0;const W=(0,t.$ro)(Y.productVersion,Y.productDate,Y.location,K.manifest,K.isBuiltin);for(const[T,J]of W)T===b.default.Error&&(N=!1,this.j.error(this.u(Y.location,J)));return K.isValid=N,K.validations=W,K}async scanExtensionManifest(K){const Y=(0,h.$6f)(K,"package.json");let N;try{N=(await this.i.readFile(Y)).value.toString()}catch(T){return(0,u.$5j)(T)!==1&&this.j.error(this.u(K,(0,a.localize)(0,null,Y.path,T.message))),null}let W;try{W=JSON.parse(N)}catch{const J=[];(0,P.$tm)(N,J);for(const Q of J)this.j.error(this.u(K,(0,a.localize)(1,null,Y.path,Q.offset,Q.length,(0,f.$0o)(Q.error))));return null}return(0,P.$Cm)(W)!=="object"?(this.j.error(this.u(K,(0,a.localize)(2,null,Y.path))),null):W}async n(K,Y,N){const W=await this.r(K,Y,N);if(W)try{const T=[],J=await this.s(W.default,T);if(T.length>0)return T.forEach(ae=>{this.j.error(this.u(K,(0,a.localize)(3,null,W.default?.path,(0,f.$0o)(ae.error))))}),Y;if((0,P.$Cm)(W)!=="object")return this.j.error(this.u(K,(0,a.localize)(4,null,W.default?.path))),Y;const Q=W.values||Object.create(null);return(0,M.$$o)(Y,Q,J)}catch{}return Y}async r(K,Y,N){const W=(0,h.$6f)(K,"package.nls.json"),T=(oe,L)=>{L.forEach(D=>{this.j.error(this.u(K,(0,a.localize)(5,null,oe?.path,(0,f.$0o)(D.error))))})},J=oe=>{this.j.error(this.u(K,(0,a.localize)(6,null,oe?.path)))},Q=`${Y.publisher}.${Y.name}`,ae=N.translations[Q];if(ae)try{const oe=g.URI.file(ae),L=(await this.i.readFile(oe)).value.toString(),D=[],U=(0,P.$tm)(L,D);return D.length>0?(T(oe,D),{values:void 0,default:W}):(0,P.$Cm)(U)!=="object"?(J(oe),{values:void 0,default:W}):{values:U.contents?U.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.i.exists(W))return;let L;try{L=await this.t(K,N)}catch{return}if(!L.localized)return{values:void 0,default:L.original};try{const D=(await this.i.readFile(L.localized)).value.toString(),U=[],H=(0,P.$tm)(D,U);return U.length>0?(T(L.localized,U),{values:void 0,default:L.original}):(0,P.$Cm)(H)!=="object"?(J(L.localized),{values:void 0,default:L.original}):{values:H,default:L.original}}catch{return{values:void 0,default:L.original}}}}async s(K,Y){if(K)try{const N=(await this.i.readFile(K)).value.toString();return(0,P.$tm)(N,Y)}catch{}}t(K,Y){return new Promise((N,W)=>{const T=J=>{const Q=(0,h.$6f)(K,`package.nls.${J}.json`);this.i.exists(Q).then(ae=>{ae&&N({localized:Q,original:(0,h.$6f)(K,"package.nls.json")});const oe=J.lastIndexOf("-");oe===-1?N({localized:(0,h.$6f)(K,"package.nls.json"),original:null}):(J=J.substring(0,oe),T(J))})};if(Y.devMode||Y.pseudo||!Y.language)return N({localized:(0,h.$6f)(K,"package.nls.json"),original:null});T(Y.language)})}u(K,Y){return`[${K.path}]: ${Y}`}};re=pe([x(1,R.$8o),x(2,S.$lk),x(3,u.$Oj),x(4,i.$Ni)],re);let ie=class extends re{constructor(K,Y,N,W,T,J,Q){super(Y,W,T,J,Q),this.z=K,this.C=N,this.w=this.B(new C.$pg(3e3)),this.y=this.B(new c.$5c),this.onDidChangeCache=this.y.event}async scanExtensions(K){const Y=this.H(K),N=await this.D(Y);if(this.v=K,N&&N.input&&q.equals(N.input,this.v))return this.j.debug("Using cached extensions scan result",K.location.toString()),this.w.trigger(()=>this.G()),N.result.map(T=>(T.location=g.URI.revive(T.location),T));const W=await super.scanExtensions(K);return await this.F(Y,{input:K,result:W}),W}async D(K){try{const Y=await this.i.readFile(K),N=JSON.parse(Y.value.toString());return{result:N.result,input:(0,$.$Ug)(N.input)}}catch(Y){this.j.debug("Error while reading the extension cache file:",K.path,(0,A.$8)(Y))}return null}async F(K,Y){try{await this.i.writeFile(K,O.$Ib.fromString(JSON.stringify(Y)))}catch(N){this.j.debug("Error while writing the extension cache file:",K.path,(0,A.$8)(N))}}async G(){if(!this.v)return;const K=this.H(this.v),Y=await this.D(K);if(!Y)return;const N=Y.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!r.$Hm(W,N))try{this.j.info("Invalidating Cache",N,W),await this.i.del(K),this.y.fire()}catch(T){this.j.error(T)}}H(K){const Y=this.I(K);return this.h.extUri.joinPath(Y.cacheHome,K.type===0?w.$yl:w.$xl)}I(K){return K.type===0?this.C.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.z.extensionsResource)?this.z:this.C.profiles.find(Y=>this.h.extUri.isEqual(K.location,Y.extensionsResource))??this.z:this.C.defaultProfile}};ie=pe([x(2,I.$nk),x(3,R.$8o),x(4,S.$lk),x(5,u.$Oj),x(6,i.$Ni)],ie);function ne(le,K){const Y=(0,k.$eo)(le.manifest.publisher,le.manifest.name);return{id:Y,identifier:new w.$Dl(Y),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:K,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}e.$cp=ne;class ue extends F{constructor(K,Y,N,W,T,J,Q,ae,oe,L,D,U){super(K,Y,(0,h.$6f)(N,".vscode-oss-dev","extensions","control.json"),W,T,J,Q,ae,oe,L,D,U),this.N=(async()=>{if(p.$y)try{const H=await this.s.readFile(g.URI.file(p.$y));return JSON.parse(H.value.toString())}catch{}return Object.create(null)})()}f(K){return this.N}}e.$dp=ue}),define(ee[278],te([0,1,5,41,40,26,81,16,33,7]),function(G,e,E,C,r,O,A,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=void 0;let m=e.$vM=class extends A.$9o{constructor(p,h,y,b,o,g){super(l.URI.file(p.extensionsPath),h,y,b,o,g)}};e.$vM=m=pe([x(0,f.$th),x(1,P.$Oj),x(2,C.$nk),x(3,r.$lk),x(4,O.$Rk),x(5,E.$Ni)],m)}),define(ee[279],te([0,1,7,33,81,128,16,6,5,23,40,41]),function(G,e,E,C,r,O,A,P,f,l,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P3b=void 0;let p=e.$P3b=class extends O.$dp{constructor(y,b,o,g,a,v,k,w){super(E.URI.file(a.builtinExtensionsPath),E.URI.file(a.extensionsPath),a.userHome,y.defaultProfile,y,b,o,g,a,v,k,w)}};e.$P3b=p=pe([x(0,d.$nk),x(1,r.$8o),x(2,A.$Oj),x(3,f.$Ni),x(4,C.$th),x(5,l.$6i),x(6,m.$lk),x(7,P.$kh)],p)}),define(ee[280],te([0,1,14,2,15,9,3,62,7,31,38,33,5,41]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$53b=void 0;let y=e.$53b=class extends C.$kb{constructor(o,g,a){super(),this.c=o,this.f=a,this.a=P.$rh.forPaths(!A.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(o.appRoot),this.addValidFileRoot(o.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(o.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:o}=E.session;o.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(g,a)=>this.i(g,a)),o.protocol.interceptFileProtocol(r.Schemas.file,(g,a)=>this.h(g,a)),this.B((0,C.$ib)(()=>{o.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),o.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(o){const g=(0,O.$9b)(o);return this.a.get(g)?C.$kb.None:(this.a.set(g,!0),(0,C.$ib)(()=>this.a.delete(g)))}h(o,g){const a=f.URI.parse(o.url);return this.f.error(`Refused to load resource ${a.fsPath} from ${r.Schemas.file}: protocol (original URL: ${o.url})`),g({error:-3})}i(o,g){const a=this.j(o);let v;return this.c.crossOriginIsolated&&((0,O.$cc)(a)==="workbench.html"||(0,O.$cc)(a)==="workbench-dev.html"?v=r.COI.CoopAndCoep:v=r.COI.getHeadersFromQuery(o.url)),this.a.findSubstr(a)?g({path:a,headers:v}):this.b.has((0,O.$dc)(a).toLowerCase())?g({path:a}):(this.f.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${a} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${o.url})`),g({error:-3}))}j(o){const g=f.URI.parse(o.url),a=r.$1e.uriToFileUri(g);return(0,O.$9b)(a.fsPath)}createIPCObjectUrl(){let o;const g=f.URI.from({scheme:"vscode",path:(0,l.$3e)()}),a=g.toString(),v=async()=>o;return m.$SR.handle(a,v),this.f.trace(`IPC Object URL: Registered new channel ${a}.`),{resource:g,update:k=>o=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${a}.`),m.$SR.removeHandler(a)}}}};e.$53b=y=pe([x(0,d.$th),x(1,h.$nk),x(2,p.$Ni)],y)}),define(ee[96],te([0,1,8,4,2,65,11,110,6,41]),function(G,e,E,C,r,O,A,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Go=e.$Fo=e.$Eo=void 0,e.$Eo="__$__isNewStorageMarker",e.$Fo="__$__targetStorageMarker",e.$Go=(0,f.$lh)("storageService");var m;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var d;(function(a){a[a.APPLICATION=-1]="APPLICATION",a[a.PROFILE=0]="PROFILE",a[a.WORKSPACE=1]="WORKSPACE"})(d||(e.StorageScope=d={}));var p;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function h(a){const v=a.get(e.$Fo);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}e.$Ho=h;class y extends r.$kb{constructor(v={flushInterval:y.a}){super(),this.j=v,this.b=this.B(new C.$8c),this.onDidChangeValue=this.b.event,this.c=this.B(new C.$8c),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$5c),this.onWillSaveState=this.f.event,this.h=this.B(new E.$Cg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new r.$lb),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.$Gg)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,r.$fb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.J()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(v,k){const{key:w,external:t}=k;if(w===e.$Fo){switch(v){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:v})}else this.b.fire({scope:v,key:w,target:this.F(v)[w],external:t})}r(v){this.f.fire({reason:v})}get(v,k,w){return this.L(k)?.get(v,w)}getBoolean(v,k,w){return this.L(k)?.getBoolean(v,w)}getNumber(v,k,w){return this.L(k)?.getNumber(v,w)}getObject(v,k,w){return this.L(k)?.getObject(v,w)}storeAll(v,k){this.t(()=>{for(const w of v)this.store(w.key,w.value,w.scope,w.target,k)})}store(v,k,w,t,u=!1){if((0,A.$pe)(k)){this.remove(v,w,u);return}this.t(()=>{this.u(v,w,t),this.L(w)?.set(v,k,u)})}remove(v,k,w=!1){this.t(()=>{this.u(v,k,void 0),this.L(k)?.delete(v,w)})}t(v){this.b.pause(),this.c.pause();try{v()}finally{this.b.resume(),this.c.resume()}}keys(v,k){const w=[],t=this.F(v);for(const u of Object.keys(t))t[u]===k&&w.push(u);return w}u(v,k,w,t=!1){const u=this.F(k);typeof w=="number"?u[v]!==w&&(u[v]=w,this.L(k)?.set(e.$Fo,JSON.stringify(u),t)):typeof u[v]=="number"&&(delete u[v],this.L(k)?.set(e.$Fo,JSON.stringify(u),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(v){switch(v){case-1:return this.D;case 0:return this.z;default:return this.w}}G(v){const k=this.L(v);return k?h(k):Object.create(null)}isNew(v){return this.getBoolean(e.$Eo,v)===!0}async flush(v=m.NONE){this.f.fire({reason:v});const k=this.L(-1),w=this.L(0),t=this.L(1);switch(v){case m.NONE:await E.Promises.settled([k?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await E.Promises.settled([k?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.L(-1)?.items??new Map,k=this.L(0)?.items??new Map,w=this.L(1)?.items??new Map;return g(v,k,w,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(v,k){return this.r(m.NONE),(0,l.$mk)(v)?this.N(v,k):this.O(v,k)}H(v,k){return!(v.id===k.id||b(k)&&b(v))}I(v,k,w){this.t(()=>{const t=new Set;for(const[u,s]of v)t.add(u),k.get(u)!==s&&this.n(w,{key:u,external:!0});for(const[u]of k.items)t.has(u)||this.n(w,{key:u,external:!0})})}}e.$Io=y,y.a=60*1e3;function b(a){return a.isDefault||!!a.useDefaultFlags?.uiState}e.$Jo=b;class o extends y{constructor(){super(),this.p=this.B(new P.$Co(new P.$Do,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.$Co(new P.$Do,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.$Co(new P.$Do,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(v=>this.n(1,v))),this.B(this.P.onDidChangeStorage(v=>this.n(0,v))),this.B(this.p.onDidChangeStorage(v=>this.n(-1,v)))}L(v){switch(v){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(v){return!1}}e.$Ko=o;async function g(a,v,k,w,t,u){const s=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,n=new Map;a.forEach((j,F)=>{i.set(F,j),n.set(F,s(j))});const c=new Map,$=new Map;v.forEach((j,F)=>{c.set(F,j),$.set(F,s(j))});const R=new Map,I=new Map;k.forEach((j,F)=>{R.set(F,j),I.set(F,s(j))}),console.group(w!==t?`Storage: Application (path: ${w})`:`Storage: Application & Profile (path: ${w}, default profile)`);const S=[];if(i.forEach((j,F)=>{S.push({key:F,value:j})}),console.table(S),console.groupEnd(),console.log(n),w!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];c.forEach((F,q)=>{j.push({key:q,value:F})}),console.table(j),console.groupEnd(),console.log($)}console.group(`Storage: Workspace (path: ${u})`);const M=[];R.forEach((j,F)=>{M.push({key:F,value:j})}),console.table(M),console.groupEnd(),console.log(I)}e.$Lo=g}),define(ee[281],te([0,1,24,8,4,2,9,85,7,22,110,159,5,96,26,30]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a3b=e.$_2b=e.$$2b=e.$02b=void 0;class o extends O.$kb{get storage(){return this.f}constructor(u,s){super(),this.j=u,this.k=s,this.b=this.B(new r.$5c),this.onDidChangeStorage=this.b.event,this.c=this.B(new r.$5c),this.onDidCloseStorage=this.c.event,this.f=new m.$Co(new m.$Do,{hint:m.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new C.$Lg,this.whenInit=this.h.p,this.i=m.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===m.StorageState.None)try{const u=await this.n();this.f.dispose(),this.f=u,this.B(u.onDidChangeStorage(i=>this.b.fire(i))),await this.m(u);const s=u.getBoolean(h.$Eo);s===void 0?u.set(h.$Eo,!0):s&&u.set(h.$Eo,!1)}catch(u){this.j.error(`[storage main] initialize(): Unable to init storage due to ${u}`)}finally{this.i=m.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===p.LogLevel.Trace?u=>this.j.trace(u):void 0,logError:u=>this.j.error(u)}}m(u){return u.init()}get items(){return this.f.items}get(u,s){return this.f.get(u,s)}set(u,s){return this.f.set(u,s)}delete(u){return this.f.delete(u)}async close(){const u=new P.$1c(!1);await this.s(),u.stop(),u.elapsed()>o.a&&await this.r(u),this.c.fire()}async r(u){if(this.path)try{const s=(0,E.top)(Array.from(this.f.items.entries()).map(([n,c])=>({key:n,length:c.length})),(n,c)=>c.length-n.length,5).map(n=>`${n.key}:${n.length}`).join(", "),i=(await this.k.stat(f.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${u.elapsed()}ms, DB size: ${i}b, Large Keys: ${s}`)}catch(s){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",s)}}async s(){this.g&&await this.g,this.i=m.StorageState.Closed,await this.f.close()}}o.a=2e3;class g extends o{get path(){if(!this.v.useInMemoryStorage)return(0,A.$$b)(this.u.globalStorageHome.fsPath,g.t)}constructor(u,s,i,n){super(i,n),this.u=u,this.v=s}async n(){return new m.$Co(new d.$mS(this.path??d.$mS.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:m.StorageHint.STORAGE_IN_MEMORY})}}g.t="state.vscdb";class a extends g{constructor(u,s,i,n){super(u,s,i,n)}}e.$02b=a;class v extends g{constructor(u,s,i,n){super(s.defaultProfile,u,i,n)}async m(u){await super.m(u),this.z(u)}z(u){u.get(y.$Uk,void 0)===void 0&&u.set(y.$Uk,new Date().toUTCString());const i=u.get(y.$Tk,void 0),n=new Date().toUTCString();u.set(y.$Vk,typeof i>"u"?null:i),u.set(y.$Tk,n)}}e.$$2b=v;class k extends o{get path(){if(!this.w.useInMemoryStorage)return(0,A.$$b)(this.y.workspaceStorageHome.fsPath,this.v.id,k.t)}constructor(u,s,i,n,c){super(i,c),this.v=u,this.w=s,this.y=n}async n(){const{storageFilePath:u,wasCreated:s}=await this.C();return new m.$Co(new d.$mS(u,{logging:this.l()}),{hint:this.w.useInMemoryStorage?m.StorageHint.STORAGE_IN_MEMORY:s?m.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:d.$mS.IN_MEMORY_PATH,wasCreated:!0};const u=(0,A.$$b)(this.y.workspaceStorageHome.fsPath,this.v.id),s=(0,A.$$b)(u,k.t);return await l.Promises.exists(u)?{storageFilePath:s,wasCreated:!1}:(await l.Promises.mkdir(u,{recursive:!0}),this.D(u),{storageFilePath:s,wasCreated:!0})}async D(u){let s;if((0,b.$vh)(this.v)?s={folder:this.v.uri.toString()}:(0,b.$Ah)(this.v)&&(s={workspace:this.v.configPath.toString()}),s)try{const i=(0,A.$$b)(u,k.u);await l.Promises.exists(i)||await l.Promises.writeFile(i,JSON.stringify(s,void 0,2))}catch(i){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${i}`)}}}e.$_2b=k,k.t="state.vscdb",k.u="workspace.json";class w extends o{get path(){}async n(){return new m.$Co(new m.$Do,{hint:m.StorageHint.STORAGE_IN_MEMORY})}}e.$a3b=w}),define(ee[282],te([0,1,4,2,96]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R3b=void 0;class O extends C.$kb{constructor(P,f,l){super(),this.b=P,this.c=f,this.f=l;const m=this.B(new C.$lb);this.a=this.B(new E.$5c({onWillAddFirstListener:()=>m.value=this.g(),onDidRemoveLastListener:()=>m.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new C.$jb;return P.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,l)=>(f?f.push(l.key):f=[l.key],f),100)(f=>this.h(f))),P.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(f,l)=>{f||(f=new Map);let m=f.get(l.profile.id);return m||f.set(l.profile.id,m={profile:l.profile,keys:[],storage:l.storage}),m.keys.push(l.key),f},100)(f=>this.i(f))),P}h(P){const f=P.includes(r.$Fo)?[this.c.defaultProfile]:[],l=[];if(P=P.filter(m=>m!==r.$Fo),P.length){const m=(0,r.$Ho)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:P.map(d=>({key:d,scope:0,target:m[d]}))})}this.j(f,l)}i(P){const f=[],l=new Map;for(const[m,d]of P.entries()){d.keys.includes(r.$Fo)&&f.push(d.profile);const p=d.keys.filter(h=>h!==r.$Fo);if(p.length){const h=(0,r.$Ho)(d.storage.storage);l.set(m,{profile:d.profile,changes:p.map(y=>({key:y,scope:0,target:h[y]}))})}}this.j(f,[...l.values()])}j(P,f){(P.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:P})}listen(P,f,l){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(P,f){throw new Error(`Call not found: ${f}`)}}e.$R3b=O}),define(ee[283],te([0,1,7,33,16,5,34,40,41,11,120]),function(G,e,E,C,r,O,A,P,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.$sM=void 0;let d=e.$sM=class ft extends f.$qk{constructor(b,o,g,a,v){super(g,a,o,v),this.P=b,this.Q=g}J(){return this.P.getItem(ft.b,[]).map(o=>({...o,location:(0,l.$ge)(o.location)?this.s.extUri.joinPath(this.profilesHome,o.location):E.URI.revive(o.location)}))}M(){const b=this.P.getItem(ft.c,{});return this.P.getItem(ft.a,!1)?b:this.I(b)}O(){return this.s.extUri.joinPath(E.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};d.a="profileAssociationsMigration",e.$sM=d=pe([x(0,A.$nM),x(1,P.$lk),x(2,C.$th),x(3,r.$Oj),x(4,O.$Ni)],d);let p=e.$tM=class rt extends d{constructor(b,o,g,a,v){super(b,o,g,a,v),this.W=b}L(b){b.length?this.W.setItem(rt.b,b.map(o=>({...o,location:this.s.extUri.basename(o.location)}))):this.W.removeItem(rt.b)}J(){const b=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(b),this.W.setItem("userDataProfilesMigration",!0)),b}N(b){b.emptyWindows||b.workspaces?this.W.setItem(rt.c,b):this.W.removeItem(rt.c)}M(){const b="workspaceAndProfileInfo",o=this.W.getItem(b,void 0);if(o){this.W.removeItem(b);const a=o.reduce((v,{workspace:k,profile:w})=>(v[E.URI.revive(k).toString()]=E.URI.revive(w).toString(),v),{});this.W.setItem(rt.c,{workspaces:a})}const g=super.M();return this.W.getItem(rt.a,!1)||(this.N(g),this.W.setItem(rt.a,!0)),g}};e.$tM=p=pe([x(0,A.$oM),x(1,P.$lk),x(2,C.$th),x(3,r.$Oj),x(4,O.$Ni)],p);let h=e.$uM=class extends p{constructor(b,o,g,a){super(new m.$rM(0,o,a,g),b,o,g,a)}async init(){return await this.W.init(),super.init()}};e.$uM=h=pe([x(0,P.$lk),x(1,C.$th),x(2,r.$Oj),x(3,O.$Ni)],h)}),define(ee[53],te([0,1,33,16,6,5,40,41,283,34]),function(G,e,E,C,r,O,A,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v2b=e.$u2b=void 0,e.$u2b=(0,r.$mh)(P.$nk);let m=e.$v2b=class extends f.$tM{constructor(p,h,y,b,o){super(p,h,y,b,o)}getAssociatedEmptyWindows(){const p=[];for(const h of this.v.emptyWindows.keys())p.push({id:h});return p}};e.$v2b=m=pe([x(0,l.$oM),x(1,A.$lk),x(2,E.$th),x(3,C.$Oj),x(4,O.$Ni)],m)}),define(ee[129],te([0,1,19,7,30]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y2b=e.$x2b=e.$w2b=void 0;async function O(f,l,m){for(const p of f){const h=p.openedWorkspace;if((0,r.$Ah)(h)){const y=await m(h);if(y){if(y.folders.some(b=>E.$Wf.isEqualOrParent(l,b.uri)))return p}else if(E.$Wf.isEqualOrParent(l,h.configPath))return p}}const d=f.filter(p=>(0,r.$vh)(p.openedWorkspace)&&E.$Wf.isEqualOrParent(l,p.openedWorkspace.uri));if(d.length)return d.sort((p,h)=>-(p.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.$w2b=O;function A(f,l){for(const m of f)if((0,r.$Ah)(m.openedWorkspace)&&E.$Wf.isEqual(m.openedWorkspace.configPath,l)||(0,r.$vh)(m.openedWorkspace)&&E.$Wf.isEqual(m.openedWorkspace.uri,l))return m}e.$x2b=A;function P(f,l){const m=d=>l.some(p=>E.$Wf.isEqual(C.URI.file(p),C.URI.file(d)));for(const d of f)if(d.config?.extensionDevelopmentPath?.some(p=>m(p)))return d}e.$y2b=P}),define(ee[97],te([0,1,32,45,136,46,15,9,3,19,7,6,58,30]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_=e.$k_=e.$j_=e.$i_=e.$h_=e.$g_=e.$f_=e.$e_=e.$d_=e.$c_=void 0,e.$c_=(0,d.$lh)("workspacesService");function y(I){return I.hasOwnProperty("workspace")}e.$d_=y;function b(I){return I.hasOwnProperty("folderUri")}e.$e_=b;function o(I){return I.hasOwnProperty("fileUri")}e.$f_=o;function g(I){return a(I)||v(I)}e.$g_=g;function a(I){const S=I;return typeof S?.path=="string"&&(!S.name||typeof S.name=="string")}function v(I){const S=I;return typeof S?.uri=="string"&&(!S.name||typeof S.name=="string")}function k(I,S,M,j,F){if(I.scheme!==j.scheme)return{name:M,uri:I.toString(!0)};let q=S?void 0:F.relativePath(j,I);if(q!==void 0)q.length===0?q=".":f.$i&&(q=w(q));else if(I.scheme===A.Schemas.file)q=I.fsPath,f.$i&&(q=w(q));else if(F.isEqualAuthority(I.authority,j.authority))q=I.path;else return{name:M,uri:I.toString(!0)};return{name:M,path:q}}e.$h_=k;function w(I){return I=(0,O.$Oz)(I),(0,E.$Ee)(I)||(I=(0,E.$Be)(I)),I}function t(I,S,M){const j=[],F=new Set,q=M.dirname(S);for(const re of I){let ie;if(a(re))re.path&&(ie=M.resolvePath(q,re.path));else if(v(re))try{ie=m.URI.parse(re.uri),ie.path[0]!==P.$8b.sep&&(ie=ie.with({path:P.$8b.sep+ie.path}))}catch(ne){console.warn(ne)}if(ie){const ne=M.getComparisonKey(ie);if(!F.has(ne)){F.add(ne);const ue=re.name||M.basenameOrAuthority(ie);j.push(new h.$Fh({uri:ie,name:ue,index:j.length},re))}}}return j}e.$i_=t;function u(I,S,M,j,F){const q=s(S,I),re=F.dirname(S),ie=F.dirname(j),ne=[];for(const Y of q.folders){const N=a(Y)?F.resolvePath(re,Y.path):m.URI.parse(Y.uri);let W;M?W=!1:W=!a(Y)||(0,P.$0b)(Y.path),ne.push(k(N,W,Y.name,ie,F))}const ue={insertSpaces:!1,tabSize:4,eol:f.$k||f.$j?`
`:`\r
`},le=r.$ER(I,["folders"],ne,ue);let K=r.$HR(I,le);return(0,l.$$f)(q.remoteAuthority,(0,p.$xk)(j))&&(K=r.$HR(K,r.$DR(K,["remoteAuthority"],ue))),K}e.$j_=u;function s(I,S){const M=C.$tm(S);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter(j=>g(j));else throw new Error(`${I} looks like an invalid workspace file.`);return M}function i(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function n(I){return typeof I.folderUri=="string"}function c(I){return typeof I.fileUri=="string"}function $(I,S){const M={workspaces:[],files:[]};if(I){const j=function(q,re){for(let ie=0;ie<q.length;ie++)try{re(q[ie],ie)}catch(ne){S.warn(`Error restoring recent entry ${JSON.stringify(q[ie])}: ${ne.toString()}. Skip entry.`)}},F=I;Array.isArray(F.entries)&&j(F.entries,q=>{const re=q.label,ie=q.remoteAuthority;i(q)?M.workspaces.push({label:re,remoteAuthority:ie,workspace:{id:q.workspace.id,configPath:m.URI.parse(q.workspace.configPath)}}):n(q)?M.workspaces.push({label:re,remoteAuthority:ie,folderUri:m.URI.parse(q.folderUri)}):c(q)&&M.files.push({label:re,remoteAuthority:ie,fileUri:m.URI.parse(q.fileUri)})})}return M}e.$k_=$;function R(I){const S={entries:[]};for(const M of I.workspaces)b(M)?S.entries.push({folderUri:M.folderUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority}):S.entries.push({workspace:{id:M.workspace.id,configPath:M.workspace.configPath.toString()},label:M.label,remoteAuthority:M.remoteAuthority});for(const M of I.files)S.entries.push({fileUri:M.fileUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority});return S}e.$l_=R}),define(ee[98],te([0,1,71,15,3,19]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p2b=e.$o2b=e.$n2b=e.$m2b=void 0,e.$m2b=128/4;function A(l){function m(){let d=l.scheme===C.Schemas.file?(0,O.$Tf)(l):l.toString();return r.$k||(d=d.toLowerCase()),(0,E.createHash)("md5").update(d).digest("hex")}return{id:m(),configPath:l}}e.$n2b=A;function P(l,m){function d(){if(l.scheme!==C.Schemas.file)return(0,E.createHash)("md5").update(l.toString()).digest("hex");if(!m)return;let h;return r.$k?h=m.ino:r.$j?h=m.birthtime.getTime():r.$i&&(typeof m.birthtimeMs=="number"?h=Math.floor(m.birthtimeMs):h=m.birthtime.getTime()),(0,E.createHash)("md5").update(l.fsPath).update(h?String(h):"").digest("hex")}const p=d();if(typeof p=="string")return{id:p,uri:l}}e.$o2b=P;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$p2b=f}),define(ee[130],te([0,1,71,87,27,284,17,13,4,2,9,3,31,43,108]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0;class b{traceSocketEvent(S,M){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,M)}constructor(S,M=""){this.f=!0,this.debugLabel=M,this.socket=S,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,P.$X)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const M=j=>{this.traceSocketEvent("read",j),S(A.$Ib.wrap(j))};return this.socket.on("data",M),{dispose:()=>this.socket.off("data",M)}}onClose(S){const M=j=>{S({type:0,hadError:j,error:void 0})};return this.socket.on("close",M),{dispose:()=>this.socket.off("close",M)}}onEnd(S){const M=()=>{S()};return this.socket.on("end",M),{dispose:()=>this.socket.off("end",M)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",S),this.socket.write(S.buffer,M=>{if(M){if(M.code==="EPIPE")return;(0,P.$X)(M)}})}catch(M){if(M.code==="EPIPE")return;(0,P.$X)(M)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((S,M)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),S();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),S()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$ah=b;var o;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(o||(o={}));var g;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(g||(g={}));class a extends l.$kb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,M){this.socket.traceSocketEvent(S,M)}constructor(S,M,j,F){super(),this.f=this.B(new f.$5c),this.g=this.B(new f.$5c),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=S,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:M,inflateBytesLength:j?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new v(this,M,j,F,this.f,(q,re)=>this.k(q,re))),this.B(this.a.onError(q=>{console.error(q),(0,P.$X)(q),this.g.fire({type:0,hadError:!0,error:q})})),this.b=new y.$8g,this.B(this.socket.onData(q=>this.l(q))),this.B(this.socket.onClose(async q=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(q)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let M=0;for(;M<S.byteLength;)this.a.writeMessage(S.slice(M,Math.min(M+262144,S.byteLength))),M+=262144}k(S,M){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",S);let j=2;S.byteLength<126?j+=0:S.byteLength<2**16?j+=2:j+=8;const F=A.$Ib.alloc(j);if(M?F.writeUInt8(194,0):F.writeUInt8(130,0),S.byteLength<126)F.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){F.writeUInt8(126,1);let q=1;F.writeUInt8(S.byteLength>>>8&255,++q),F.writeUInt8(S.byteLength>>>0&255,++q)}else{F.writeUInt8(127,1);let q=1;F.writeUInt8(0,++q),F.writeUInt8(0,++q),F.writeUInt8(0,++q),F.writeUInt8(0,++q),F.writeUInt8(S.byteLength>>>24&255,++q),F.writeUInt8(S.byteLength>>>16&255,++q),F.writeUInt8(S.byteLength>>>8&255,++q),F.writeUInt8(S.byteLength>>>0&255,++q)}this.socket.write(A.$Ib.concat([F,S]))}end(){this.h=!0,this.socket.end()}l(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const M=this.b.peek(this.j.readLen),j=M.readUInt8(0),F=(j&128)>>>7,q=(j&64)>>>6,re=M.readUInt8(1),ie=(re&128)>>>7,ne=re&127;this.j.state=2,this.j.readLen=2+(ie?4:0)+(ne===126?2:0)+(ne===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!q),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const M=this.b.read(this.j.readLen),j=M.readUInt8(1),F=(j&128)>>>7;let q=j&127,re=1;q===126?q=M.readUInt8(++re)*2**8+M.readUInt8(++re):q===127&&(q=M.readUInt8(++re)*0+M.readUInt8(++re)*0+M.readUInt8(++re)*0+M.readUInt8(++re)*0+M.readUInt8(++re)*2**24+M.readUInt8(++re)*2**16+M.readUInt8(++re)*2**8+M.readUInt8(++re));let ie=0;F&&(ie=M.readUInt8(++re)*2**24+M.readUInt8(++re)*2**16+M.readUInt8(++re)*2**8+M.readUInt8(++re)),this.j.state=3,this.j.readLen=q,this.j.mask=ie,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const M=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",M),t(M,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",M),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(M,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$bh=a;class v extends l.$kb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$Ib.alloc(0)}constructor(S,M,j,F,q,re){super(),this.l=S,this.m=q,this.n=re,this.a=this.B(new f.$5c),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$5c),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new f.$5c),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,M?(this.b=this.B(new k(this.l,F,j,{windowBits:15})),this.f=this.B(new w(this.l,{windowBits:15})),this.B(this.b.onError(ie=>this.a.fire(ie))),this.B(this.f.onError(ie=>this.a.fire(ie)))):(this.b=null,this.f=null)}writeMessage(S){this.g.push(S),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const S=this.g.shift();if(this.f){const M=await this.s(this.f,S);this.n(M,!0)}else this.n(S,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(S,M){return new Promise((j,F)=>{S.write(M),S.flush(q=>j(q))})}acceptFrame(S,M,j){this.h.push({data:S,isCompressed:M,isLastFrameOfMessage:j}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const M=await this.w(this.b,S.data,S.isLastFrameOfMessage);this.m.fire(M)}else this.m.fire(S.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(S,M,j){return new Promise((F,q)=>{S.write(M),j&&S.write(A.$Ib.fromByteArray([0,0,255,255])),S.flush(re=>F(re))})}}class k extends l.$kb{get recordedInflateBytes(){return this.j?A.$Ib.concat(this.f):A.$Ib.alloc(0)}constructor(S,M,j,F){super(),this.h=S,this.j=M,this.a=this.B(new f.$5c),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(F),this.b.on("error",q=>{this.h.traceSocketEvent("zlibInflateError",{message:q?.message,code:q?.code}),this.a.fire(q)}),this.b.on("data",q=>{this.h.traceSocketEvent("zlibInflateData",q),this.g.push(A.$Ib.wrap(q))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent("zlibInflateWrite",S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const M=A.$Ib.concat(this.g);this.g.length=0,S(M)})}}class w extends l.$kb{constructor(S,M){super(),this.g=S,this.a=this.B(new f.$5c),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(A.$Ib.wrap(j))})}write(S){this.g.traceSocketEvent("zlibDeflateWrite",S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let M=A.$Ib.concat(this.f);this.f.length=0,M=M.slice(0,M.byteLength-4),S(M)})}}function t(I,S){if(S===0)return;const M=I.byteLength>>>2;for(let ne=0;ne<M;ne++){const ue=I.readUInt32BE(ne*4);I.writeUInt32BE(ue^S,ne*4)}const j=M*4,F=I.byteLength-j,q=S>>>24&255,re=S>>>16&255,ie=S>>>8&255;F>=1&&I.writeUInt8(I.readUInt8(j)^q,j),F>=2&&I.writeUInt8(I.readUInt8(j+1)^re,j+1),F>=3&&I.writeUInt8(I.readUInt8(j+2)^ie,j+2)}e.$ch=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function s(){const I=(0,p.$3e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const S=process.platform!=="darwin"&&e.$ch?e.$ch:(0,r.tmpdir)(),M=(0,m.$$b)(S,`vscode-ipc-${I}.sock`);return n(M),M}e.$dh=s;function i(I,S,M){const j=(0,E.createHash)("md5").update(I).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${M}-${S}-sock`;const F=M.substr(0,4),q=S.substr(0,6),re=j.substr(0,8);let ie;return process.platform!=="darwin"&&e.$ch&&!process.env.VSCODE_PORTABLE?ie=(0,m.$$b)(e.$ch,`vscode-${re}-${F}-${q}.sock`):ie=(0,m.$$b)(I,`${F}-${q}.sock`),n(ie),ie}e.$eh=i;function n(I){const S=u[d.$t];typeof S=="number"&&I.length>=S&&console.warn(`WARNING: IPC handle "${I}" is longer than ${S} chars, try a shorter --user-data-dir`)}class c extends h.$2g{static b(S){const M=f.Event.fromNodeEventEmitter(S,"connection");return f.Event.map(M,j=>({protocol:new y.$9g(new b(j,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(j,"close"))}))}constructor(S){super(c.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$fh=c;function $(I){return new Promise((S,M)=>{const j=(0,C.createServer)();j.on("error",M),j.listen(I,()=>{j.removeListener("error",M),S(new c(j))})})}e.$gh=$;function R(I,S){return new Promise((M,j)=>{const F=(0,C.createConnection)(I,()=>{F.removeListener("error",j),M(y.$0g.fromSocket(new b(F,`ipc-client${S}`),S))});F.once("error",j)})}e.$hh=R}),define(ee[28],te([0,1,55,9,3,130,33,89,6]),function(G,e,E,C,r,O,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l2b=e.$k2b=void 0,e.$k2b=(0,f.$mh)(A.$sh);class l extends P.$Tl{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,C.$$b)(this.userDataPath,"clp")}get backupHome(){return(0,C.$$b)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,O.$eh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,C.$$b)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(r.$k){for(const d in process.env)if(d.endsWith("_VSCODE_SNAP_ORIG")){const p=d.slice(0,-17);if(this.d[p])continue;process.env[p]&&(this.d[p]=process.env[p]),process.env[d]?process.env[p]=process.env[d]:delete process.env[p]}}}restoreSnapExportedVariables(){if(r.$k)for(const d in this.d)process.env[d]=this.d[d],delete this.d[d]}}e.$l2b=l,pe([E.$Pg],l.prototype,"cachedLanguagesPath",null),pe([E.$Pg],l.prototype,"backupHome",null),pe([E.$Pg],l.prototype,"mainIPCHandle",null),pe([E.$Pg],l.prototype,"mainLockfile",null),pe([E.$Pg],l.prototype,"disableUpdates",null),pe([E.$Pg],l.prototype,"disableKeytar",null),pe([E.$Pg],l.prototype,"crossOriginIsolated",null),pe([E.$Pg],l.prototype,"codeCachePath",null),pe([E.$Pg],l.prototype,"useCodeCache",null)}),define(ee[285],te([0,1,71,32,15,9,3,19,22,194,18,28,34,16,5,193,30,98]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q2b=void 0;let a=e.$q2b=class pt{constructor(k,w,t,u){this.j=k,this.k=w,this.l=t,this.m=u,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$Wf,this.i={isEqual:(s,i)=>(0,C.$Ge)(s,i,!A.$k)}}async initialize(){const k=this.m.getItem(pt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(k.emptyWindows),this.d=await this.u((0,l.$h2b)(k)),this.e=await this.v((0,l.$i2b)(k)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==h.$ak.OFF}q(){return this.s()===h.$ak.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||h.$ak.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(k,w){this.d.some(u=>k.workspace.id===u.workspace.id)||(this.d.push(k),this.C());const t=(0,O.$$b)(this.c,k.workspace.id);return w?this.t(t,w).then(()=>t):t}async t(k,w){if(await f.Promises.exists(k)&&await this.z(k),await f.Promises.exists(w))try{await f.Promises.rename(w,k)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(k){return this.e.some(w=>this.h.isEqual(k.folderUri,w.folderUri))||(this.e.push(k),this.C()),(0,O.$$b)(this.c,this.D(k))}registerEmptyWindowBackup(k){return this.g.some(w=>!!w.backupFolder&&this.i.isEqual(w.backupFolder,k.backupFolder))||(this.g.push(k),this.C()),(0,O.$$b)(this.c,k.backupFolder)}async u(k){if(!Array.isArray(k))return[];const w=new Set,t=[];for(const u of k){const s=u.workspace;if(!(0,o.$Ah)(s))return[];if(!w.has(s.id)){w.add(s.id);const i=(0,O.$$b)(this.c,s.id);await this.B(i)?s.configPath.scheme!==r.Schemas.file||await f.Promises.exists(s.configPath.fsPath)?t.push(u):await this.z(i):await this.x(i)}}return t}async v(k){if(!Array.isArray(k))return[];const w=[],t=new Set;for(const u of k){const s=u.folderUri,i=this.h.getComparisonKey(s);if(!t.has(i)){t.add(i);const n=(0,O.$$b)(this.c,this.D(u));await this.B(n)?s.scheme!==r.Schemas.file||await f.Promises.exists(s.fsPath)?w.push(u):await this.z(n):await this.x(n)}}return w}async w(k){if(!Array.isArray(k))return[];const w=[],t=new Set;for(const u of k){const s=u.backupFolder;if(typeof s!="string")return[];if(!t.has(s)){t.add(s);const i=(0,O.$$b)(this.c,s);await this.B(i)?w.push(u):await this.x(i)}}return w}async x(k){try{await f.Promises.rm(k,f.RimRafMode.MOVE)}catch(w){this.l.error(`Backup: Could not delete stale backup: ${w.toString()}`)}}y(){let k=(0,g.$p2b)();for(;this.g.some(w=>!!w.backupFolder&&this.i.isEqual(w.backupFolder,k.id));)k=(0,g.$p2b)();return{backupFolder:k.id}}async z(k){const w=this.y(),t=(0,O.$$b)(this.c,w.backupFolder);try{await f.Promises.rename(k,t)}catch(u){return this.l.error(`Backup: Could not rename backup folder: ${u.toString()}`),!1}return this.g.push(w),!0}async getDirtyWorkspaces(){const k=[];for(const w of this.d)await this.A(w)&&k.push(w);for(const w of this.e)await this.A(w)&&k.push(w);return k}A(k){let w;return(0,l.$g2b)(k)?w=(0,O.$$b)(this.c,k.backupFolder):(0,b.$a_)(k)?w=(0,O.$$b)(this.c,this.D(k)):w=(0,O.$$b)(this.c,k.workspace.id),this.B(w)}async B(k){try{const w=await f.Promises.readdir(k);for(const t of w)try{if((await f.Promises.readdir((0,O.$$b)(k,t))).length>0)return!0}catch{}}catch{}return!1}C(){const k={workspaces:this.d.map(({workspace:w,remoteAuthority:t})=>{const u={id:w.id,configURIPath:w.configPath.toString()};return t&&(u.remoteAuthority=t),u}),folders:this.e.map(({folderUri:w,remoteAuthority:t})=>{const u={folderUri:w.toString()};return t&&(u.remoteAuthority=t),u}),emptyWindows:this.g.map(({backupFolder:w,remoteAuthority:t})=>{const u={backupFolder:w};return t&&(u.remoteAuthority=t),u})};this.m.setItem(pt.a,k)}D(k){const w=k.folderUri;let t;return w.scheme===r.Schemas.file?t=A.$k?w.fsPath:w.fsPath.toLowerCase():t=w.toString().toLowerCase(),(0,E.createHash)("md5").update(t).digest("hex")}};a.a="backupWorkspaces",e.$q2b=a=pe([x(0,d.$k2b),x(1,m.$Rh),x(2,y.$Ni),x(3,p.$oM)],a)}),define(ee[20],te([0,1,14,38,8,4,2,3,36,11,6,5,34,28]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C2b=e.LifecycleMainPhase=e.ShutdownReason=e.$B2b=void 0,e.$B2b=(0,m.$lh)("lifecycleMainService");var y;(function(g){g[g.QUIT=1]="QUIT",g[g.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var b;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen",g[g.Eventually=4]="Eventually"})(b||(e.LifecycleMainPhase=b={}));let o=e.$C2b=class dt extends A.$kb{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(a,v,k){super(),this.v=a,this.w=v,this.y=k,this.c=this.B(new O.$5c),this.onBeforeShutdown=this.c.event,this.f=this.B(new O.$5c),this.onWillShutdown=this.f.event,this.g=this.B(new O.$5c),this.onWillLoadWindow=this.g.event,this.h=this.B(new O.$5c),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(dt.b),this.j&&this.w.removeItem(dt.b)}C(){const a=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$j&&this.n===0&&this.D(1))};E.app.addListener("before-quit",a);const v=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!P.$j)&&E.app.quit()};E.app.addListener("window-all-closed",v),E.app.once("will-quit",k=>{this.L("Lifecycle#app.on(will-quit) - begin"),k.preventDefault(),this.D(1).finally(()=>{this.L("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.H(!1),E.app.removeListener("before-quit",a),E.app.removeListener("window-all-closed",v),this.L("Lifecycle#app.on(will-quit) - calling app.quit()"),E.app.quit()})})}D(a){if(this.s)return this.s;const v=this.v;this.L("Lifecycle#onWillShutdown.fire()");const k=[];return this.f.fire({reason:a,join(w,t){v.trace(`Lifecycle#onWillShutdown - begin '${w}'`),k.push(t.finally(()=>{v.trace(`Lifecycle#onWillShutdown - end '${w}'`)}))}}),this.s=(async()=>{try{await r.Promises.settled(k)}catch(w){this.v.error(w)}try{await this.w.close()}catch(w){this.v.error(w)}})(),this.s}set phase(a){if(a<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===a)return;this.L(`lifecycle (main): phase changed (value: ${a})`),this.k=a;const v=this.u.get(this.k);v&&(v.open(),this.u.delete(this.k))}async when(a){if(a<=this.k)return;let v=this.u.get(a);v||(v=new r.$qg,this.u.set(a,v)),await v.wait()}registerWindow(a){const v=new A.$jb;this.n++,v.add(a.onWillLoad(w=>this.g.fire({window:a,workspace:w.workspace,reason:w.reason})));const k=(0,l.$re)(a.win);k.on("close",w=>{const t=a.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${a.id}`),w.preventDefault(),this.unload(a,1).then(u=>{if(u){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(a),a.close()})}),k.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${a.id}`),this.n--,v.dispose(),this.n===0&&(!P.$j||this.i)&&this.D(1)})}async reload(a,v){await this.unload(a,3)||a.reload(v)}unload(a,v){const k=this.t.get(a.id);if(k)return k;const w=this.F(a,v).finally(()=>{this.t.delete(a.id)});return this.t.set(a.id,w),w}async F(a,v){if(!a.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${a.id}`);const k=this.i?2:v,w=await this.I(a,k);return w?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${a.id})`),this.G(w)):(await this.J(a,k),!1)}G(a){return a?(this.H(!0),this.i=!1,!0):!1}H(a){this.r&&(this.r(a),this.r=void 0,this.p=void 0)}I(a,v){return new Promise(k=>{const w=this.m++,t=`vscode:ok${w}`,u=`vscode:cancel${w}`;C.$SR.once(t,()=>{k(!1)}),C.$SR.once(u,()=>{k(!0)}),a.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:u,reason:v})})}J(a,v){return new Promise(k=>{const t=`vscode:reply${this.m++}`;C.$SR.once(t,()=>k()),a.send("vscode:onWillUnload",{replyChannel:t,reason:v})})}quit(a){return this.L(`Lifecycle#quit() - begin (willRestart: ${a})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(a&&this.w.setItem(dt.b,!0),this.p=new Promise(v=>{this.r=v,this.L("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}L(a){this.y.args["enable-smoke-test-driver"]?this.v.info(a):this.v.trace(a)}async relaunch(a){this.L("Lifecycle#relaunch()");const v=process.argv.slice(1);if(a?.addArgs&&v.push(...a.addArgs),a?.removeArgs)for(const t of a.removeArgs){const u=v.indexOf(t);u>=0&&v.splice(u,1)}const k=()=>{try{if(P.$i){const t=(0,f.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:v})};E.app.once("quit",k),await this.quit(!0)&&E.app.removeListener("quit",k)}async kill(a){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,r.$sg)(1e3),(async()=>{for(const v of E.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let k;v.webContents&&!v.webContents.isDestroyed()?k=new Promise(w=>v.once("closed",w)):k=Promise.resolve(),v.destroy(),await k}})()]),E.app.exit(a)}};o.b="lifecycle.quitAndRestart",e.$C2b=o=pe([x(0,d.$Ni),x(1,p.$oM),x(2,h.$k2b)],o)}),define(ee[286],te([0,1,3,4,2,6,20]),function(G,e,E,C,r,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$22b=e.$12b=void 0,e.$12b=(0,O.$lh)("keyboardLayoutMainService");let P=e.$22b=class extends r.$kb{constructor(m){super(),this.a=this.B(new C.$5c),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,m.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const m=await new Promise((d,p)=>{G(["native-keymap"],d,p)});this.c=f(m),E.$s||m.onDidChangeKeyboardLayout(()=>{this.c=f(m),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$22b=P=pe([x(0,A.$B2b)],P);function f(l){const m=l.getKeyMap(),d=l.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:d}}}),define(ee[287],te([0,1,245,8,17,13,11,18,33,94,5,51,244,284]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0;let y=e.$zq=class extends d.$vo{constructor(a,v,k,w){super(w),this.j=a,this.k=v,this.l=k,this.m(),this.B(a.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const a=this.j.getValue("http");this.f=a?.proxy,this.g=!!a?.proxyStrictSSL,this.h=a?.proxyAuthorization}async request(a,v){const{f:k,g:w}=this;let t;try{t=await(0,l.$ul)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,O.$8)(i)))}const u={...process.env,...t},s=a.agent?a.agent:await(0,p.$yq)(a.url||"",u,{proxyUrl:k,strictSSL:w});return a.agent=s,a.strictSSL=w,this.h&&(a.headers={...a.headers||{},"Proxy-Authorization":this.h}),this.c(a.isChromiumNetwork?"electron":"node",a,()=>o(a,v))}async resolveProxy(a){}};e.$zq=y=pe([x(0,P.$Rh),x(1,f.$th),x(2,m.$Ni),x(3,m.$Oi)],y);async function b(g){return((0,E.parse)(g.url).protocol==="https:"?await new Promise((k,w)=>{G(["https"],k,w)}):await new Promise((k,w)=>{G(["http"],k,w)})).request}async function o(g,a){return C.Promises.withAsyncBody(async(v,k)=>{const w=(0,E.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await b(g),u={hostname:w.hostname,port:w.port?parseInt(w.port):w.protocol==="https:"?443:80,protocol:w.protocol,path:w.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,A.$me)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(u.auth=g.user+":"+g.password);const s=t(u,i=>{const n=(0,A.$ke)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)o({...g,url:i.headers.location,followRedirects:n-1},a).then(v,k);else{let c=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(c=i.pipe((0,h.createGunzip)())),v({res:i,stream:(0,r.$Wb)(c)})}});s.on("error",k),g.timeout&&s.setTimeout(g.timeout),g.isChromiumNetwork&&s.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&s.write(g.data),s.end(),a.onCancellationRequested(()=>{s.abort(),k(new O.$2)})})}e.$Aq=o}),define(ee[288],te([0,1,14,287]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$93b=void 0;function r(A){return E.net.request}class O extends C.$zq{request(P,f){return super.request({...P||{},getRawRequest:r,isChromiumNetwork:!0},f)}}e.$93b=O}),define(ee[99],te([0,1,7,49,4,2,33,16,6,20,5,96,281,41,53,40]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e3b=e.$d3b=e.$c3b=e.$b3b=void 0,e.$b3b=(0,f.$lh)("storageMainService");let o=e.$c3b=class extends O.$kb{constructor(v,k,w,t,u,s){super(),this.c=v,this.f=k,this.g=w,this.h=t,this.i=u,this.j=s,this.a=void 0,this.b=this.B(new r.$5c),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(v=>{v.window.profile&&this.profileStorage(v.window.profile).init(),v.workspace&&this.workspaceStorage(v.workspace).init()})),this.B(this.h.onWillShutdown(v=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=v.reason,v.join("applicationStorage",this.applicationStorage.close());for(const[,k]of this.n)v.join("profileStorage",k.close());for(const[,k]of this.r)v.join("workspaceStorage",k.close())})),this.B(this.g.onWillCreateProfile(v=>{v.join((async()=>{await this.i.exists(v.profile.globalStorageHome)||await this.i.createFolder(v.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(v=>{const k=this.n.get(v.profile.id);k&&v.join(k.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const v=new p.$$2b(this.k(),this.g,this.c,this.i);return(0,C.$bb)(v.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),v}profileStorage(v){if((0,d.$Jo)(v))return this.applicationStorage;let k=this.n.get(v.id);if(!k){this.c.trace(`StorageMainService: creating profile storage (${v.name})`),k=this.p(v),this.n.set(v.id,k);const w=this.B(k.onDidChangeStorage(t=>this.b.fire({...t,storage:k,profile:v})));(0,C.$bb)(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${v.name})`),this.n.delete(v.id),w.dispose()})}return k}p(v){return this.a===2?new p.$a3b(this.c,this.i):new p.$02b(v,this.k(),this.c,this.i)}workspaceStorage(v){let k=this.r.get(v.id);return k||(this.c.trace(`StorageMainService: creating workspace storage (${v.id})`),k=this.s(v),this.r.set(v.id,k),(0,C.$bb)(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${v.id})`),this.r.delete(v.id)})),k}s(v){return this.a===2?new p.$a3b(this.c,this.i):new p.$_2b(v,this.k(),this.c,this.f,this.i)}isUsed(v){const k=E.URI.file(v);for(const w of[this.applicationStorage,...this.n.values(),...this.r.values()])if(w.path&&this.j.extUri.isEqualOrParent(E.URI.file(w.path),k))return!0;return!1}};e.$c3b=o=pe([x(0,m.$Ni),x(1,A.$sh),x(2,y.$u2b),x(3,l.$B2b),x(4,P.$Oj),x(5,b.$lk)],o),e.$d3b=(0,f.$lh)("applicationStorageMainService");let g=e.$e3b=class extends d.$Io{constructor(v,k){super(),this.p=v,this.s=k,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(v){if(v===-1)return this.s.applicationStorage.storage}M(v){if(v===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$e3b=g=pe([x(0,h.$nk),x(1,e.$b3b)],g)}),define(ee[100],te([0,1,8,21,4,18,28,20,5,23,51,48]),function(G,e,E,C,r,O,A,P,f,l,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t3b=e.$s3b=void 0;function p(y,b,o){return`${o.updateUrl}/api/update/${y}/${b}/${o.commit}`}e.$s3b=p;let h=e.$t3b=class{get state(){return this.b}d(b){this.j.info("update#setState",b.type),this.b=b,this.c.fire(b)}constructor(b,o,g,a,v,k){this.f=b,this.g=o,this.h=g,this.i=a,this.j=v,this.k=k,this.b=d.$bhb.Uninitialized,this.c=new r.$5c,this.onStateChange=this.c.event,b.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.g.getValue("update.mode"),o=this.m(b);if(!o){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(o),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(d.$bhb.Idle(this.q())),b==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(b){return b==="none"?void 0:this.k.quality}n(b=60*60*1e3){return(0,E.$sg)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(b){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(b)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(b){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},C.CancellationToken.None)).res.statusCode===204}catch(o){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(o);return}}async _applySpecificUpdate(b){}q(){return 1}r(){}};e.$t3b=h=pe([x(0,P.$B2b),x(1,O.$Rh),x(2,A.$k2b),x(3,m.$uo),x(4,f.$Ni),x(5,l.$6i)],h)}),define(ee[289],te([0,1,14,55,4,2,18,28,20,5,23,51,26,48,100]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u3b=void 0;let b=e.$u3b=class extends y.$t3b{get v(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"error",(g,a)=>a)}get w(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(g,a,v)=>({url:a,version:v,productVersion:v}))}get y(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(g,a,v,k)=>({releaseNotes:a,version:v,productVersion:v,date:k}))}constructor(g,a,v,k,w,t,u){super(g,a,k,w,t,u),this.z=v,this.u=new O.$jb}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(g){this.j.error("UpdateService error:",g);const a=this.state.type==="checking for updates"&&this.state.explicit?g:void 0;this.d(h.$bhb.Idle(1,a))}s(g){let a;this.k.darwinUniversalAssetId?a=this.k.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const v=(0,y.$s3b)(a,g,this.k);try{E.autoUpdater.setFeedURL({url:v})}catch(k){this.j.error("Failed to set update feed URL",k);return}return v}t(g){this.d(h.$bhb.CheckingForUpdates(g)),E.autoUpdater.checkForUpdates()}E(g){this.state.type==="checking for updates"&&this.d(h.$bhb.Downloading(g))}F(g){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:g.version}),this.d(h.$bhb.Ready(g)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(h.$bhb.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};pe([C.$Pg],b.prototype,"v",null),pe([C.$Pg],b.prototype,"w",null),pe([C.$Pg],b.prototype,"x",null),pe([C.$Pg],b.prototype,"y",null),e.$u3b=b=pe([x(0,f.$B2b),x(1,A.$Rh),x(2,p.$Rk),x(3,P.$k2b),x(4,d.$uo),x(5,l.$Ni),x(6,m.$6i)],b)}),define(ee[290],te([0,1,47,42,8,4,9,28,20,5,26,48]),function(G,e,E,C,r,O,A,P,f,l,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w3b=void 0;let p=class{get state(){return this.a}d(b){this.g.info("update#setState",b.type),this.a=b,this.b.fire(b)}constructor(b,o,g){if(this.f=b,this.g=g,this.a=d.$bhb.Uninitialized,this.b=new O.$5c,this.onStateChange=this.b.event,o.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(d.$bhb.Idle(this.k())),this.h(30*1e3).then(void 0,a=>this.g.error(a))}h(b=60*60*1e3){return(0,r.$sg)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(b){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(b)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(b){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(b){}};p=pe([x(0,f.$B2b),x(1,P.$k2b),x(2,l.$Ni)],p);let h=e.$w3b=class extends p{constructor(b,o,g,a,v,k){super(g,a,v),this.o=b,this.p=o,this.q=k;const w=(0,C.watch)(A.$bc(this.o)),t=O.Event.fromNodeEventEmitter(w,"change",(n,c)=>c),u=O.Event.filter(t,n=>n==="current"),i=O.Event.debounce(u,(n,c)=>c,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{i.dispose(),w.close()})}m(){this.d(d.$bhb.CheckingForUpdates(!1)),this.u().then(b=>{b?this.d(d.$bhb.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$bhb.Idle(2)))},b=>{this.g.error(b),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$bhb.Idle(2,b.message||b))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+A.$cc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const b=await new Promise((g,a)=>(0,C.realpath)(`${A.$bc(this.o)}/current`,(v,k)=>v?a(v):g(k))),o=A.$cc(b);return this.p!==o}isLatestVersion(){return this.u().then(void 0,b=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$w3b=h=pe([x(2,f.$B2b),x(3,P.$k2b),x(4,l.$Ni),x(5,m.$Rk)],h)}),define(ee[291],te([0,1,2,20,53,30,8,29]),function(G,e,E,C,r,O,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q3b=void 0;let f=e.$Q3b=class extends E.$kb{constructor(m,d,p){super(),this.a=d,this.b=p,this.B(m.onWillLoadWindow(h=>{h.reason===2&&this.c(h.window)})),this.B(m.onBeforeCloseWindow(h=>this.c(h))),this.B(new A.$Cg(()=>this.g(),30*1e3)).schedule()}async c(m){const d=this.f(m),p=this.a.getProfileForWorkspace(d);p?.isTransient&&(this.a.unsetWorkspace(d,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f(m){return m.openedWorkspace??(0,O.$zh)(m.backupPath,m.isExtensionDevelopmentHost)}g(){const m=this.a.getAssociatedEmptyWindows();if(m.length===0)return;const d=this.b.getWindows().map(p=>this.f(p));for(const p of m)d.some(h=>h.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$Q3b=f=pe([x(0,C.$B2b),x(1,r.$u2b),x(2,P.$e2b)],f)}),define(ee[60],te([0,1,14,2,4,5,310,8,15,29,69,26,20,72,37,3,131]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E2b=e.$D2b=void 0;function g(k){return typeof k.responseWindowId=="number"}let a=e.$D2b=class ut extends C.$kb{static getAll(){return Array.from(ut.b.values())}constructor(w,t,u){super(),this.n=w,this.p=t,this.r=u,this.c=String(++ut.a),this.f=this.B(new r.$5c),this.onStdout=this.f.event,this.g=this.B(new r.$5c),this.onStderr=this.g.event,this.h=this.B(new r.$5c),this.onMessage=this.h.event,this.i=this.B(new r.$5c),this.onExit=this.i.event,this.j=this.B(new r.$5c),this.onCrash=this.j.event,this.k=void 0,this.l=void 0,this.m=void 0}s(w,t){let u;switch(this.m?.correlationId?u=`[UtilityProcess id: ${this.m?.correlationId}, type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${w}`:u=`[UtilityProcess type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${w}`,t){case m.default.Error:this.n.error(u);break;case m.default.Warning:this.n.warn(u);break;case m.default.Info:this.n.trace(u);break}}t(){return this.k?(this.s("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(w){const t=this.u(w);return t&&w.payload&&this.postMessage(w.payload),t}u(w){if(!this.t())return!1;this.m=w;const t=`${this.m.type}-${this.c}`,u=f.$1e.asFileUri("bootstrap-fork.js").fsPath,s=this.m.args??[],i=this.m.execArgv??[],n=this.m.allowLoadingUnsignedLibraries,c=this.m.forceAllocationsToV8Sandbox,$="pipe",R=this.v(w);return this.s("creating new...",m.default.Info),this.k=E.utilityProcess.fork(u,s,{serviceName:t,env:R,execArgv:i,allowLoadingUnsignedLibraries:n,forceAllocationsToV8Sandbox:c,stdio:$}),this.w(this.k,this.m,t),!0}v(w){const t=w.env?{...w.env}:{...(0,y.$Dm)(process.env)};t.VSCODE_AMD_ENTRYPOINT=w.entryPoint,typeof w.parentLifecycleBound=="number"&&(t.VSCODE_PARENT_PID=String(w.parentLifecycleBound)),t.VSCODE_CRASH_REPORTER_PROCESS_TYPE=w.type,b.$i&&((0,o.isUNCAccessRestrictionsDisabled)()?t.NODE_DISABLE_UNC_ACCESS_CHECKS="1":t.NODE_UNC_HOST_ALLOWLIST=(0,o.getUNCHostAllowlist)().join("\\")),(0,h.$cl)(t);for(const u of Object.keys(t))t[u]=String(t[u]);return t}w(w,t,u){if(w.stdout){const s=new A.StringDecoder("utf-8");this.B(r.Event.fromNodeEventEmitter(w.stdout,"data")(i=>this.f.fire(typeof i=="string"?i:s.write(i))))}if(w.stderr){const s=new A.StringDecoder("utf-8");this.B(r.Event.fromNodeEventEmitter(w.stderr,"data")(i=>this.g.fire(typeof i=="string"?i:s.write(i))))}this.B(r.Event.fromNodeEventEmitter(w,"message")(s=>this.h.fire(s))),this.B(r.Event.fromNodeEventEmitter(w,"spawn")(()=>{this.l=w.pid,typeof w.pid=="number"&&ut.b.set(w.pid,{pid:w.pid,name:g(t)?`${t.type} [${t.responseWindowId}]`:t.type}),this.s("successfully created",m.default.Info)})),this.B(r.Event.fromNodeEventEmitter(w,"exit")(s=>{this.s(`received exit event with code ${s}`,m.default.Info),this.i.fire({pid:this.l,code:s,signal:"unknown"}),this.y()})),this.B(r.Event.fromNodeEventEmitter(E.app,"child-process-gone",(s,i)=>({event:s,details:i}))(({details:s})=>{s.type==="Utility"&&s.name===u&&(this.s(`crashed with code ${s.exitCode} and reason '${s.reason}'`,m.default.Error),this.p.publicLog2("utilityprocesscrash",{type:t.type,reason:s.reason,code:s.exitCode}),this.j.fire({pid:this.l,code:s.exitCode,reason:s.reason}),this.y())}))}once(w,t){const u=this.B(this.h.event(s=>{s===w&&(u.dispose(),t())}))}postMessage(w,t){this.k&&this.k.postMessage(w,t)}connect(w){const{port1:t,port2:u}=new E.MessageChannelMain;return this.postMessage(w,[u]),t}enableInspectPort(){if(!this.k||typeof this.l!="number")return!1;this.s("enabling inspect port",m.default.Info);const w=process;return typeof w._debugProcess=="function"?(w._debugProcess(this.l),!0):!1}kill(){if(!this.k)return;this.s("attempting to kill the process...",m.default.Info),this.k.kill()?(this.s("successfully killed the process",m.default.Info),this.y()):this.s("unable to kill the process",m.default.Warning)}y(){typeof this.l=="number"&&ut.b.delete(this.l),this.k=void 0}async waitForExit(w){this.k&&(this.s("waiting to exit...",m.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,P.$sg)(w)]),this.k&&(this.s(`did not exit within ${w}ms, will kill it now...`,m.default.Info),this.kill()))}};a.a=0,a.b=new Map,e.$D2b=a=pe([x(0,O.$Ni),x(1,d.$Rk),x(2,p.$B2b)],a);let v=e.$E2b=class extends a{constructor(w,t,u,s){super(w,u,s),this.z=t}start(w){const t=this.z.getWindowById(w.responseWindowId);if(!t?.win||t.win.isDestroyed()||t.win.webContents.isDestroyed())return this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.u(w))return!1;this.C(t.win,w);const s=this.connect(w.payload);return t.win.webContents.postMessage(w.responseChannel,w.responseNonce,[s]),!0}C(w,t){t.windowLifecycleBound&&(this.B(r.Event.filter(this.r.onWillLoadWindow,u=>u.window.win===w)(()=>this.kill())),this.B(r.Event.fromNodeEventEmitter(w,"closed")(()=>this.kill())))}};e.$E2b=v=pe([x(0,O.$Ni),x(1,l.$e2b),x(2,d.$Rk),x(3,p.$B2b)],v)}),define(ee[292],te([0,1,13,5,20,8,60,29,26]),function(G,e,E,C,r,O,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M2b=void 0;let l=e.$M2b=class Dt{constructor(d,p,h,y){this.d=d,this.f=p,this.g=h,this.h=y,this.b=new Map,this.c=!1,this.f.onWillShutdown(b=>{this.c=!0,b.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(d){const p=this.b.get(d);if(!p)throw new Error("Unknown extension host!");return p}onDynamicStdout(d){return this.i(d).onStdout}onDynamicStderr(d){return this.i(d).onStderr}onDynamicMessage(d){return this.i(d).onMessage}onDynamicExit(d){return this.i(d).onExit}async createExtensionHost(){if(this.c)throw(0,E.$3)();const d=String(++Dt.a),p=new A.$E2b(this.d,this.g,this.h,this.f);return this.b.set(d,p),p.onExit(({pid:h,code:y,signal:b})=>{this.d.info(`Extension host with pid ${h} exited with code: ${y}, signal: ${b}.`),setTimeout(()=>{p.dispose(),this.b.delete(d)})}),{id:d}}async start(d,p){if(this.c)throw(0,E.$3)();this.i(d).start({...p,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:p.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:d})}async enableInspectPort(d){if(this.c)throw(0,E.$3)();const p=this.b.get(d);return p?p.enableInspectPort():!1}async kill(d){if(this.c)throw(0,E.$3)();const p=this.b.get(d);p&&p.kill()}async _killAllNow(){for(const[,d]of this.b)d.kill()}async _waitForAllExit(d){const p=[];for(const[,h]of this.b)p.push(h.waitForExit(d));return O.Promises.settled(p).then(()=>{})}};l.a=0,e.$M2b=l=pe([x(0,C.$Ni),x(1,r.$B2b),x(2,P.$e2b),x(3,f.$Rk)],l)}),define(ee[293],te([0,1,38,8,2,28,20,5,41,39,66,60,52,89,11]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m3b=void 0;let b=e.$m3b=class extends r.$kb{constructor(g,a,v,k,w,t,u){super(),this.c=g,this.f=a,this.g=v,this.h=k,this.i=w,this.j=t,this.k=u,this.a=new C.$qg,this.b=void 0,this.r=void 0,this.s=void 0,this.l()}l(){E.$SR.on("vscode:createSharedProcessMessageChannel",(g,a)=>this.m(g,a)),this.B(this.h.onWillShutdown(()=>this.n()))}async m(g,a){this.i.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const v=await this.connect();if(g.sender.isDestroyed())return v.close();g.sender.postMessage("vscode:createSharedProcessMessageChannelResult",a,[v])}n(){this.i.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage("vscode:electron-main->shared-process=exit"),this.b=void 0}whenReady(){return this.r||(this.r=(async()=>{await this.t;const g=new C.$Lg;this.b?this.b.once("vscode:shared-process->electron-main=init-done",()=>g.complete()):E.$SR.once("vscode:shared-process->electron-main=init-done",()=>g.complete()),await g.p,this.i.trace("[SharedProcess] Overall ready")})()),this.r}get t(){return this.s||(this.s=(async()=>{await this.a.wait(),this.u();const g=new C.$Lg;this.b?this.b.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()):E.$SR.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()),await g.p,this.i.trace("[SharedProcess] IPC ready")})()),this.s}u(){this.b=this.B(new d.$D2b(this.i,p.$Zn,this.h));const g=(0,h.$Vl)(this.f.args,this.f.isBuilt);let a;g.port&&(a=["--nolazy"],g.break?a.push(`--inspect-brk=${g.port}`):a.push(`--inspect=${g.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.v(),execArgv:a})}v(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.j.getLogLevel(),loggers:this.j.getRegisteredLoggers(),policiesData:this.k.serialize()}}async connect(){return await this.t,(0,y.$re)(this.b).connect()}};e.$m3b=b=pe([x(1,O.$k2b),x(2,f.$nk),x(3,A.$B2b),x(4,P.$Ni),x(5,m.$k3b),x(6,l.$Rm)],b)}),define(ee[294],te([0,1,28,89,20,5,52,60,109,38,2,4,37,18]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y3b=void 0;let y=e.$Y3b=class{constructor(o,g,a,v,k){this.d=o,this.f=g,this.g=a,this.h=v,this.i=k,this.a=void 0,this.b=new d.$5c,this.onBeforeWindowConnection=this.b.event,this.c=new d.$5c,this.onWillShutdown=this.c.event,this.h.onWillShutdown(()=>this.c.fire()),l.$SR.on("vscode:createPtyHostMessageChannel",(w,t)=>this.k(w,t))}start(o){this.a=new P.$D2b(this.i,A.$Zn,this.h);const g=(0,C.$Ul)(this.g.args,this.g.isBuilt),a=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:a,args:["--logsPath",this.g.logsHome.fsPath],env:this.j(o)});const v=this.a.connect(),k=new f.$1R(v,"ptyHost"),w=new m.$jb;return w.add(k),w.add(this.a),w.add((0,m.$ib)(()=>{l.$SR.removeHandler("vscode:createPtyHostMessageChannel"),this.a=void 0})),{client:k,store:w,onDidProcessExit:this.a.onExit}}j(o){this.g.unsetSnapExportedVariables();const g={...(0,p.$Dm)(process.env),VSCODE_LAST_PTY_ID:String(o),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.d.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.d.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.d.scrollback)},a=this.f.getValue("terminal.integrated.developer.ptyHost.latency");a&&typeof a=="number"&&(g.VSCODE_LATENCY=String(a));const v=this.f.getValue("terminal.integrated.developer.ptyHost.startupDelay");return v&&typeof v=="number"&&(g.VSCODE_STARTUP_DELAY=String(v)),this.g.restoreSnapExportedVariables(),g}k(o,g){this.b.fire();const a=this.a.connect();if(o.sender.isDestroyed()){a.close();return}o.sender.postMessage("vscode:createPtyHostMessageChannelResult",g,[a])}};e.$Y3b=y=pe([x(1,h.$Rh),x(2,E.$k2b),x(3,r.$B2b),x(4,O.$Ni)],y)}),define(ee[295],te([0,1,2,6,5,29,60,26,56,4,8,20]),function(G,e,E,C,r,O,A,P,f,l,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X3b=e.$W3b=void 0,e.$W3b=(0,C.$lh)("utilityProcessWorker");let p=e.$X3b=class extends E.$kb{constructor(b,o,g,a){super(),this.b=b,this.c=o,this.f=g,this.g=a,this.a=new Map}async createWorker(b){const o=`window: ${b.reply.windowId}, moduleId: ${b.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${o})`);const g=this.h(b);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${o})`),this.disposeWorker(b));const a=new h(this.b,this.c,this.f,this.g,b);if(!a.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,a);const v=new m.$Lg;return l.Event.once(a.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete(g),v.complete({reason:k})}),v.p}h(b){return(0,f.$_h)({moduleId:b.process.moduleId,windowId:b.reply.windowId})}async disposeWorker(b){const o=this.h(b),g=this.a.get(o);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${b.reply.windowId}, moduleId: ${b.process.moduleId})`),g.kill(),this.a.delete(o))}};e.$X3b=p=pe([x(0,r.$Ni),x(1,O.$e2b),x(2,P.$Rk),x(3,d.$B2b)],p);let h=class extends E.$kb{constructor(b,o,g,a,v){super(),this.c=b,this.f=o,this.g=g,this.h=a,this.i=v,this.a=this.B(new l.$5c),this.onDidTerminate=this.a.event,this.b=new A.$E2b(this.c,this.f,this.g,this.h),this.j()}j(){this.B(this.b.onExit(b=>this.a.fire({code:b.code,signal:b.signal}))),this.B(this.b.onCrash(b=>this.a.fire({code:b.code,signal:"ECRASH"})))}spawn(){const o=this.f.getWindowById(this.i.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.i.process.type,entryPoint:this.i.process.moduleId,parentLifecycleBound:o,windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce})}kill(){this.b.kill()}};h=pe([x(0,r.$Ni),x(1,O.$e2b),x(2,P.$Rk),x(3,d.$B2b)],h)}),define(ee[296],te([0,1,14,2,3,19,7,18,20,5,34,29,127,30]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I3b=e.$H3b=e.$G3b=void 0;let y=e.$G3b=class yt extends C.$kb{get state(){return this.b}constructor(k,w,t,u,s){super(),this.g=k,this.h=w,this.i=t,this.j=u,this.k=s,this.b=b(this.h.getItem(yt.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(k=>this.p(k)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(k=>{k.newCount-k.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(k=>this.p(k))}m(){this.f=!0,this.n()}n(){const k=new Set,w={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!w.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(i=>!i.isExtensionDevelopmentHost)),s&&(w.lastActiveWindow=this.r(s),w.lastActiveWindow.uiState.mode===3&&k.add(w.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);t&&(w.lastPluginDevelopmentHostWindow=this.r(t),w.lastPluginDevelopmentHostWindow.uiState.mode===3&&(k.has(w.lastPluginDevelopmentHostWindow.uiState.display)?r.$j&&!t.win?.isSimpleFullScreen()&&(w.lastPluginDevelopmentHostWindow.uiState.mode=1):k.add(w.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(w.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const i=this.r(s);return i.uiState.mode===3&&(k.has(i.uiState.display)?r.$j&&i.windowId!==w.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(i.uiState.mode=1):k.add(i.uiState.display)),i}));const u=g(w);this.h.setItem(yt.a,u),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",u)}p(k){if(this.i.quitRequested)return;const w=this.r(k);k.isExtensionDevelopmentHost&&!k.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=w:!k.isExtensionDevelopmentHost&&k.openedWorkspace&&this.b.openedWindows.forEach(t=>{const u=(0,h.$Ah)(k.openedWorkspace)&&t.workspace?.id===k.openedWorkspace.id,s=(0,h.$vh)(k.openedWorkspace)&&t.folderUri&&O.$Wf.isEqual(t.folderUri,k.openedWorkspace.uri);(u||s)&&(t.uiState=w.uiState)}),this.g.getWindowCount()===1&&(this.c=w)}r(k){return{windowId:k.id,workspace:(0,h.$Ah)(k.openedWorkspace)?k.openedWorkspace:void 0,folderUri:(0,h.$vh)(k.openedWorkspace)?k.openedWorkspace.uri:void 0,backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.serializeWindowState()}}getNewWindowState(k){const w=this.s(k),t=this.k.getValue("window");if(w.mode===3){let u;w.hasDefaultState?u=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):u=!!(this.i.wasRestarted||t?.restoreFullscreen),u||(w.mode=1)}return w}s(k){const w=this.g.getLastActiveWindow();if(!k.extensionTestsPath){if(k.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=k.workspace;if((0,h.$Ah)(c)){const R=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===c.id).map(I=>I.uiState);if(R.length)return R[0]}if((0,h.$vh)(c)){const R=this.state.openedWindows.filter(I=>I.folderUri&&O.$Wf.isEqual(I.folderUri,c.uri)).map(I=>I.uiState);if(R.length)return R[0]}else if(k.backupPath){const R=this.state.openedWindows.filter(I=>I.backupPath===k.backupPath).map(I=>I.uiState);if(R.length)return R[0]}const $=this.c||this.state.lastActiveWindow;if(!w&&$)return $.uiState}let t;const u=E.screen.getAllDisplays();if(u.length===1)t=u[0];else{if(r.$j){const c=E.screen.getCursorScreenPoint();t=E.screen.getDisplayNearestPoint(c)}!t&&w&&(t=E.screen.getDisplayMatching(w.getBounds())),t||(t=E.screen.getPrimaryDisplay()||u[0])}let s=(0,p.$d2b)();s.x=Math.round(t.bounds.x+t.bounds.width/2-s.width/2),s.y=Math.round(t.bounds.y+t.bounds.height/2-s.height/2);const i=this.k.getValue("window");let n=!0;if(i?.newWindowDimensions){if(i.newWindowDimensions==="maximized")s.mode=0,n=!1;else if(i.newWindowDimensions==="fullscreen")s.mode=3,n=!1;else if((i.newWindowDimensions==="inherit"||i.newWindowDimensions==="offset")&&w){const c=w.serializeWindowState();c.mode===3?s.mode=3:s=c,n=s.mode!==3&&i.newWindowDimensions==="offset"}}return n&&(s=this.t(s)),s.hasDefaultState=!0,s}t(k){if(this.g.getWindows().length===0)return k;k.x=typeof k.x=="number"?k.x:0,k.y=typeof k.y=="number"?k.y:0;const w=this.g.getWindows().map(t=>t.getBounds());for(;w.some(t=>t.x===k.x||t.y===k.y);)k.x+=30,k.y+=30;return k}};y.a="windowsState",e.$G3b=y=pe([x(0,d.$e2b),x(1,m.$oM),x(2,f.$B2b),x(3,l.$Ni),x(4,P.$Rh)],y);function b(v){const k={openedWindows:[]},w=v||{openedWindows:[]};return w.lastActiveWindow&&(k.lastActiveWindow=o(w.lastActiveWindow)),w.lastPluginDevelopmentHostWindow&&(k.lastPluginDevelopmentHostWindow=o(w.lastPluginDevelopmentHostWindow)),Array.isArray(w.openedWindows)&&(k.openedWindows=w.openedWindows.map(t=>o(t))),k}e.$H3b=b;function o(v){const k={uiState:v.uiState};return v.backupPath&&(k.backupPath=v.backupPath),v.remoteAuthority&&(k.remoteAuthority=v.remoteAuthority),v.folder&&(k.folderUri=A.URI.parse(v.folder)),v.workspaceIdentifier&&(k.workspace={id:v.workspaceIdentifier.id,configPath:A.URI.parse(v.workspaceIdentifier.configURIPath)}),k}function g(v){return{lastActiveWindow:v.lastActiveWindow&&a(v.lastActiveWindow),lastPluginDevelopmentHostWindow:v.lastPluginDevelopmentHostWindow&&a(v.lastPluginDevelopmentHostWindow),openedWindows:v.openedWindows.map(k=>a(k))}}e.$I3b=g;function a(v){return{workspaceIdentifier:v.workspace&&{id:v.workspace.id,configURIPath:v.workspace.configPath.toString()},folder:v.folderUri&&v.folderUri.toString(),backupPath:v.backupPath,remoteAuthority:v.remoteAuthority,uiState:v.uiState}}}),define(ee[54],te([0,1,14,4,45,2,15,9,19,11,22,192,64,59,28,6,5,53,129,30,97,98]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a,v,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A2b=e.$z2b=void 0,e.$z2b=(0,b.$lh)("workspacesManagementMainService");let t=e.$A2b=class extends O.$kb{constructor(s,i,n,c,$){super(),this.g=s,this.h=i,this.i=n,this.j=c,this.k=$,this.a=this.B(new C.$5c),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new C.$5c),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const s=(await m.Promises.readdir(this.c.fsPath)).map(i=>(0,f.$6f)(this.c,i,v.$Kh));for(const i of s){const n=(0,w.$n2b)(i),c=await this.resolveLocalWorkspace(i);c?this.f.push({workspace:n,remoteAuthority:c.remoteAuthority}):await this.deleteUntitledWorkspace(n)}}catch(s){s.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${s}).`)}}resolveLocalWorkspace(s){return this.l(s,i=>m.Promises.readFile(i,"utf8"))}l(s,i){if(this.m(s)&&s.scheme===A.Schemas.file)try{const n=i(s.fsPath);return n instanceof Promise?n.then(c=>this.n(s,c),c=>{}):this.n(s,n)}catch{return}}m(s){return(0,v.$Lh)(s,this.g)||(0,v.$Qh)(s)}n(s,i){try{const n=this.p(s,i),c=(0,w.$n2b)(s);return{id:c.id,configPath:c.configPath,folders:(0,k.$i_)(n.folders,c.configPath,f.$Wf),remoteAuthority:n.remoteAuthority,transient:n.transient}}catch(n){this.h.warn(n.toString())}}p(s,i){const n=(0,r.$tm)(i);if(n&&Array.isArray(n.folders))n.folders=n.folders.filter(c=>(0,k.$g_)(c));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return n}async createUntitledWorkspace(s,i){const{workspace:n,storedWorkspace:c}=this.r(s,i),$=n.configPath.fsPath;return await m.Promises.mkdir((0,P.$bc)($),{recursive:!0}),await m.Promises.writeFile($,JSON.stringify(c,null,"	")),this.f.push({workspace:n,remoteAuthority:i}),n}r(s=[],i){const n=(Date.now()+Math.round(Math.random()*1e3)).toString(),c=(0,f.$6f)(this.c,n),$=(0,f.$6f)(c,v.$Kh),R=[];for(const I of s)R.push((0,k.$h_)(I.uri,!0,I.name,c,f.$Wf));return{workspace:(0,w.$n2b)($),storedWorkspace:{folders:R,remoteAuthority:i}}}async getWorkspaceIdentifier(s){return(0,w.$n2b)(s)}isUntitledWorkspace(s){return(0,v.$Lh)(s.configPath,this.g)}async deleteUntitledWorkspace(s){this.isUntitledWorkspace(s)&&(await this.s(s),this.i.isEnabled()&&this.i.unsetWorkspace(s),this.a.fire(s))}async s(s){const i=(0,f.$Tf)(s.configPath);try{await m.Promises.rm((0,P.$bc)(i));const n=(0,P.$$b)(this.g.workspaceStorageHome.fsPath,s.id);await m.Promises.exists(n)&&await m.Promises.writeFile((0,P.$$b)(n,"obsolete"),""),this.f=this.f.filter(c=>c.workspace.id!==s.id)}catch(n){this.h.warn(`Unable to delete untitled workspace ${i} (${n}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(s,i,n){if(!s||!s.win||!s.isReady||!await this.t(s,i,n))return;const $=await this.u(s,(0,w.$n2b)(n));if($)return this.b.fire({window:s,workspace:$.workspace}),$}async t(s,i,n){return n?(0,v.$Ah)(s.openedWorkspace)&&f.$Wf.isEqual(s.openedWorkspace.configPath,n)?!1:(0,a.$x2b)(i,n)?(await this.k.showMessageBox({type:"info",buttons:[(0,d.localize)(0,null)],message:(0,d.localize)(1,null,(0,f.$3f)(n)),detail:(0,d.localize)(2,null)},(0,l.$ye)(E.BrowserWindow.getFocusedWindow())),!1):!0:!0}async u(s,i){if(!s.config)return;s.focus();let n;return s.config.extensionDevelopmentPath||(s.config.backupPath?n=await this.j.registerWorkspaceBackup({workspace:i,remoteAuthority:s.remoteAuthority},s.config.backupPath):n=this.j.registerWorkspaceBackup({workspace:i,remoteAuthority:s.remoteAuthority})),(0,v.$Ah)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=i,s.config.backupPath=n,{workspace:i,backupPath:n}}};e.$A2b=t=pe([x(0,y.$k2b),x(1,o.$Ni),x(2,g.$u2b),x(3,p.$j2b),x(4,h.$s2b)],t)}),define(ee[132],te([0,1,14,38,21,6,29,30,54,11,5,60]),function(G,e,E,C,r,O,A,P,f,l,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H2b=e.$G2b=e.ID=void 0,e.ID="diagnosticsMainService",e.$G2b=(0,O.$lh)(e.ID);let p=e.$H2b=class{constructor(y,b,o){this.a=y,this.b=b,this.c=o}async getRemoteDiagnostics(y){const b=this.a.getWindows();return(await Promise.all(b.map(async g=>{const a=g.remoteAuthority;if(!a)return;const v=`vscode:getDiagnosticInfoResponse${g.id}`,k={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(w=>{g.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:v,args:k}),C.$SR.once(v,(t,u)=>{u||w({hostName:a,errorMessage:`Unable to resolve connection to '${a}'.`}),w(u)}),setTimeout(()=>{w({hostName:a,errorMessage:`Connection to '${a}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const o of E.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(o.id);g?y.push(await this.d(g)):y.push(this.e(o))}const b=[];for(const{pid:o,name:g}of d.$D2b.getAll())b.push({pid:o,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:b,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(y){const b=await this.f(y),o=(0,l.$re)(y.win);return this.e(o,b,y.remoteAuthority)}e(y,b=[],o){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:b,remoteAuthority:o}}async f(y){const b=[],o=y.openedWorkspace;if((0,P.$vh)(o))b.push(o.uri);else if((0,P.$Ah)(o)){const g=await this.b.resolveLocalWorkspace(o.configPath);g&&g.folders.forEach(v=>{b.push(v.uri)})}return b}};e.$H2b=p=pe([x(0,A.$e2b),x(1,f.$z2b),x(2,m.$Ni)],p)}),define(ee[67],te([0,1,47,14,27,154,55,4,2,15,9,3,7,105,86,22,103,180,59,28,6,20,5,23,79,29,30,54,17,242,234]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a,v,k,w,t,u,s,i,n,c,$,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X2b=e.$W2b=void 0,e.$W2b=(0,k.$lh)("nativeHostMainService");let S=e.$X2b=class extends f.$kb{constructor(j,F,q,re,ie,ne,ue,le){super(),this.a=j,this.b=F,this.c=q,this.f=re,this.g=ie,this.h=ne,this.i=ue,this.j=le,this.onDidOpenWindow=P.Event.map(this.a.onDidOpenWindow,K=>K.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:K,x:Y,y:N})=>({windowId:K.id,x:Y,y:N})),({windowId:K})=>!!this.a.getWindowById(K)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(C.app,"browser-window-maximize",(K,Y)=>Y.id),K=>!!this.a.getWindowById(K)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(C.app,"browser-window-unmaximize",(K,Y)=>Y.id),K=>!!this.a.getWindowById(K)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(K,Y)=>Y.id),K=>!!this.a.getWindowById(K)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),K=>!!K),K=>K.id),P.Event.filter(P.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(K,Y)=>Y.id),K=>!!this.a.getWindowById(K))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(C.powerMonitor,"resume"),this.onDidChangeColorScheme=this.i.onDidChangeColorScheme,this.k=this.B(new P.$5c),this.onDidChangePassword=this.k.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(C.screen,"display-metrics-changed",(K,Y,N)=>N),K=>!(Array.isArray(K)&&K.length===1&&K[0]==="workArea")),P.Event.fromNodeEventEmitter(C.screen,"display-added"),P.Event.fromNodeEventEmitter(C.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace??(0,n.$zh)(F.backupPath,F.isExtensionDevelopmentHost),title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(j){return this.a.getWindowCount()}async getActiveWindowId(j){const F=C.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(F)return F.id}openWindow(j,F,q){return Array.isArray(F)?this.l(j,F,q):this.m(j,F)}async l(j,F,q=Object.create(null)){F.length>0&&await this.a.open({context:5,contextWindowId:j,urisToOpen:F,cli:this.f.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,mergeMode:q.mergeMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0,forceProfile:q.forceProfile,forceTempProfile:q.forceTempProfile})}async m(j,F){await this.a.openEmptyWindow({context:5,contextWindowId:j},F)}async toggleFullScreen(j){this.t(j)?.toggleFullScreen()}async handleTitleDoubleClick(j){this.t(j)?.handleTitleDoubleClick()}async isMaximized(j){const F=this.t(j);return F?.win?F.win.isMaximized():!1}async maximizeWindow(j){const F=this.t(j);F?.win&&F.win.maximize()}async unmaximizeWindow(j){const F=this.t(j);F?.win&&F.win.unmaximize()}async minimizeWindow(j){const F=this.t(j);F?.win&&F.win.minimize()}async updateWindowControls(j,F){const q=this.t(j);q&&q.updateWindowControls(F)}async focusWindow(j,F){F&&typeof F.windowId=="number"&&(j=F.windowId),this.t(j)?.focus({force:F?.force??!1})}async setMinimumSize(j,F,q){const re=this.t(j);if(re?.win){const[ie,ne]=re.win.getSize(),[ue,le]=re.win.getMinimumSize(),[K,Y]=[F??ue,q??le],[N,W]=[Math.max(ie,K),Math.max(ne,Y)];(ue!==K||le!==Y)&&re.win.setMinimumSize(K,Y),(ie!==N||ne!==W)&&re.win.setSize(N,W)}}async saveWindowSplash(j,F){this.i.saveWindowSplash(j,F)}async installShellCommand(j){const{source:F,target:q}=await this.n();try{const{symbolicLink:re}=await b.SymlinkSupport.stat(F);if(re&&!re.dangling){const ie=await(0,h.$Hp)(F);if(q===ie)return}await b.Promises.unlink(F)}catch(re){if(re.code!=="ENOENT")throw re}try{await b.Promises.symlink(q,F)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:ie}=await this.showMessageBox(j,{type:"info",message:(0,g.localize)(0,null,this.h.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(ie===0)try{const ne=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${F}'\\" with administrator privileges"`;await(0,O.promisify)(E.exec)(ne)}catch{throw new Error((0,g.localize)(3,null,F))}}}async uninstallShellCommand(j){const{source:F}=await this.n();try{await b.Promises.unlink(F)}catch(q){switch(q.code){case"EACCES":{const{response:re}=await this.showMessageBox(j,{type:"info",message:(0,g.localize)(4,null,this.h.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(re===0)try{const ie=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,O.promisify)(E.exec)(ie)}catch{throw new Error((0,g.localize)(7,null,F))}break}case"ENOENT":break;default:throw q}}}async n(){const j=(0,m.$_b)(this.f.appRoot,"bin","code"),F=`/usr/local/bin/${this.h.applicationName}`;if(!await b.Promises.exists(j))throw new Error((0,g.localize)(8,null,j));return{source:F,target:j}}async showMessageBox(j,F){return this.b.showMessageBox(F,this.p(j))}async showSaveDialog(j,F){return this.b.showSaveDialog(F,this.p(j))}async showOpenDialog(j,F){return this.b.showOpenDialog(F,this.p(j))}p(j){const F=this.t(j);if(F?.win)return F.win}async pickFileFolderAndOpen(j,F){const q=await this.b.pickFileFolder(F);q&&await this.r(await Promise.all(q.map(async re=>await b.SymlinkSupport.existsDirectory(re)?{folderUri:p.URI.file(re)}:{fileUri:p.URI.file(re)})),F,j)}async pickFolderAndOpen(j,F){const q=await this.b.pickFolder(F);q&&await this.r(q.map(re=>({folderUri:p.URI.file(re)})),F,j)}async pickFileAndOpen(j,F){const q=await this.b.pickFile(F);q&&await this.r(q.map(re=>({fileUri:p.URI.file(re)})),F,j)}async pickWorkspaceAndOpen(j,F){const q=await this.b.pickWorkspace(F);q&&await this.r(q.map(re=>({workspaceUri:p.URI.file(re)})),F,j)}async r(j,F,q){await this.a.open({context:3,contextWindowId:q,cli:this.f.args,urisToOpen:j,forceNewWindow:F.forceNewWindow})}async showItemInFolder(j,F){C.shell.showItemInFolder(F)}async setRepresentedFilename(j,F){this.t(j)?.setRepresentedFilename(F)}async setDocumentEdited(j,F){this.t(j)?.setDocumentEdited(F)}async openExternal(j,F){return this.f.unsetSnapExportedVariables(),C.shell.openExternal(F),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(j,F){return C.shell.trashItem(F)}async isAdmin(){let j;return d.$i?j=(await new Promise((F,q)=>{G(["native-is-elevated"],F,q)}))():j=process.getuid()===0,j}async writeElevated(j,F,q,re){const ie=await new Promise((ne,ue)=>{G(["@vscode/sudo-prompt"],ne,ue)});return new Promise((ne,ue)=>{const le=[`"${this.s}"`];re?.unlock&&le.push("--file-chmod"),le.push("--file-write",`"${F.fsPath}"`,`"${q.fsPath}"`);const K={name:this.h.nameLong.replace("-",""),icns:d.$j&&this.f.isBuilt?(0,m.$$b)((0,m.$bc)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};ie.exec(le.join(" "),K,(Y,N,W)=>{N&&this.g.trace(`[sudo-prompt] received stdout: ${N}`),W&&this.g.trace(`[sudo-prompt] received stderr: ${W}`),Y?ue(Y):ne(void 0)})})}async isRunningUnderARM64Translation(){return d.$k||d.$i?!1:C.app.runningUnderARM64Translation}get s(){return d.$i?this.f.isBuilt?(0,m.$$b)((0,m.$bc)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,m.$$b)(this.f.appRoot,"scripts","code-cli.bat"):d.$k?this.f.isBuilt?(0,m.$$b)((0,m.$bc)(process.execPath),"bin",`${this.h.applicationName}`):(0,m.$$b)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,m.$$b)(this.f.appRoot,"bin","code"):(0,m.$$b)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return y.$pm.value()}async getOSColorScheme(){return this.i.getColorScheme()}async hasWSLFeatureInstalled(){return d.$i&&(0,R.$U2b)()}async killProcess(j,F,q){process.kill(F,q)}async readClipboardText(j,F){return C.clipboard.readText(F)}async writeClipboardText(j,F,q){return C.clipboard.writeText(F,q)}async readClipboardFindText(j){return C.clipboard.readFindText()}async writeClipboardFindText(j,F){return C.clipboard.writeFindText(F)}async writeClipboardBuffer(j,F,q,re){return C.clipboard.writeBuffer(F,Buffer.from(q.buffer),re)}async readClipboardBuffer(j,F){return $.$Ib.wrap(C.clipboard.readBuffer(F))}async hasClipboard(j,F,q){return C.clipboard.has(F,q)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){C.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){C.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){C.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){C.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){C.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(j,F){this.t(j)?.updateTouchBar(F)}async notifyReady(j){this.t(j)?.setReady()}async relaunch(j,F){return this.c.relaunch(F)}async reload(j,F){const q=this.t(j);if(q){if((0,n.$Ah)(q.openedWorkspace)){const re=q.openedWorkspace.configPath;if(re.scheme===l.Schemas.file&&(await this.j.resolveLocalWorkspace(re))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.c.reload(q,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(j){this.closeWindowById(j,j)}async closeWindowById(j,F){const q=this.t(F);if(q?.win)return q.win.close()}async quit(j){const F=this.a.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&F.win?F.win.close():this.c.quit()}async exit(j,F){await this.c.kill(F)}async resolveProxy(j,F){return this.t(j)?.win?.webContents?.session?.resolveProxy(F)}findFreePort(j,F,q,re,ie=1){return(0,o.$5e)(F,q,re,ie)}async openDevTools(j,F){const q=this.t(j);q?.win&&q.win.webContents.openDevTools(F)}async toggleDevTools(j){const F=this.t(j);F?.win&&F.win.webContents.toggleDevTools()}async sendInputEvent(j,F){const q=this.t(j);q?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&q.win.webContents.sendInputEvent(F)}async profileRenderer(j,F,q){const re=this.t(j);if(!re||!re.win)throw new Error;return await new I.$V2b(re.win,F,this.g).inspect(q)}async windowsGetStringRegKey(j,F,q,re){if(!d.$i)return;const ie=await new Promise((ne,ue)=>{G(["@vscode/windows-registry"],ne,ue)});try{return ie.GetStringRegKey(F,q,re)}catch{return}}t(j){if(typeof j=="number")return this.a.getWindowById(j)}};pe([A.$Pg],S.prototype,"s",null),e.$X2b=S=pe([x(0,i.$e2b),x(1,a.$s2b),x(2,w.$B2b),x(3,v.$k2b),x(4,t.$Ni),x(5,u.$6i),x(6,s.$S2b),x(7,c.$z2b)],S)}),define(ee[297],te([0,1,14,38,27,2,15,3,107,178,90,132,59,28,5,67,77,23,78,80,32,11,34,60,21,7,29,8]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a,v,k,w,t,u,s,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z2b=void 0;const $="issue.processExplorerWindowState";let R=e.$Z2b=class At{constructor(M,j,F,q,re,ie,ne,ue,le,K,Y){this.g=M,this.h=j,this.i=F,this.j=q,this.k=re,this.l=ie,this.m=ne,this.n=ue,this.o=le,this.p=K,this.q=Y,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){C.$SR.on("vscode:listProcesses",async M=>{const j=[];try{j.push({name:(0,l.localize)(0,null),rootProcess:await(0,f.$br)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(q=>{(0,m.$2l)(q)?j.push({name:q.hostName,rootProcess:q}):q.processes&&j.push({name:q.hostName,rootProcess:q.processes})})}catch(F){this.i.error(`Listing processes failed: ${F}`)}this.t(M,"vscode:listProcessesResponse",j)}),C.$SR.on("vscode:workbenchCommand",(M,j)=>{const{id:F,from:q,args:re}=j;let ie;switch(q){case"processExplorer":ie=this.f;break;default:throw new Error(`Unexpected command source: ${q}`)}ie?.webContents.send("vscode:runAction",{id:F,from:q,args:re})}),C.$SR.on("vscode:closeProcessExplorer",M=>{this.d?.close()}),C.$SR.on("vscode:pidToNameRequest",async M=>{const j=await this.k.getMainDiagnostics(),F=[];for(const q of j.windows)F.push([q.pid,`window [${q.id}] (${q.title})`]);for(const{pid:q,name:re}of u.$D2b.getAll())F.push([q,re]);this.t(M,"vscode:pidToNameResponse",F)})}async openReporter(M){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const j=new O.$jb,F=j.add(this.n.createIPCObjectUrl()),q=this.v(this.c,700,800);this.b=this.u(q,F,{backgroundColor:M.styles.backgroundColor,title:(0,l.localize)(1,null),zoomLevel:M.zoomLevel,alwaysOnTop:!1},"issue-reporter"),F.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:M,disableExtensions:!!this.h.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:o.default}),this.b.loadURL(A.$1e.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(M){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const j=new O.$jb,F=j.add(this.n.createIPCObjectUrl()),q=this.p.getItem($,void 0),re=I(q)?q:this.v(this.f,800,500);this.d=this.u(re,F,{backgroundColor:M.styles.backgroundColor,title:(0,l.localize)(2,null),zoomLevel:M.zoomLevel,alwaysOnTop:!0},"process-explorer"),F.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:M,product:o.default}),this.d.loadURL(A.$1e.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const ie=()=>{if(!this.d)return;const ne=this.d.getSize(),ue=this.d.getPosition();if(!ne||!ue)return;const le={width:ne[0],height:ne[1],x:ue[0],y:ue[1]};this.p.setItem($,le)};this.d.on("moved",ie),this.d.on("resized",ie)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const M=await E.contentTracing.stopRecording(`${(0,k.$Pe)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,l.localize)(3,null),detail:(0,l.localize)(4,null,M),buttons:[(0,l.localize)(5,null)]},(0,w.$ye)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,M)}async getSystemStatus(){const[M,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(M,j)}async $getSystemInfo(){const[M,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(M,j)}async $getPerformanceInfo(){try{const[M,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(M,j)}catch(M){throw this.i.warn("issueService#getPerformanceInfo ",M.message),M}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(M){this.i.error(M)}}async $showConfirmCloseDialog(){if(this.b){const{response:M}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(6,null),buttons:[(0,l.localize)(7,null),(0,l.localize)(8,null)]},this.b);M===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:M}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(9,null),buttons:[(0,l.localize)(10,null),(0,l.localize)(11,null)]},this.b);return M===0}return!1}async $getIssueReporterUri(M){if(!this.c)throw new Error("Issue reporter window not available");const j=this.q.getWindowById(this.c.id);if(!j)throw new Error("Window not found");const F=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return c.Promises.withAsyncBody(async(q,re)=>{const ie=new s.$bd;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",ie.token,{replyChannel:F,extensionId:M}),C.$SR.once(F,(ne,ue)=>{q(i.URI.parse(ue))});try{await(0,c.$sg)(5e3),ie.cancel(),re(new Error("Timed out waiting for issue reporter URI"))}finally{C.$SR.removeHandler(F)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(M){M.isMinimized()&&M.restore(),M.focus()}t(M,j,...F){M.sender.isDestroyed()||M.sender.send(j,...F)}u(M,j,F,q){const re=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:M.width,height:M.height,minWidth:300,minHeight:200,x:M.x,y:M.y,title:F.title,backgroundColor:F.backgroundColor||At.a,webPreferences:{preload:A.$1e.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,v.$hD)(F.zoomLevel),sandbox:!0},alwaysOnTop:F.alwaysOnTop,experimentalDarkMode:!0});return re.setMenuBarVisibility(!1),re}v(M,j,F){let q;const re=E.screen.getAllDisplays();if(re.length===1)q=re[0];else{if(P.$j){const ue=E.screen.getCursorScreenPoint();q=E.screen.getDisplayNearestPoint(ue)}!q&&M&&(q=E.screen.getDisplayMatching(M.getBounds())),q||(q=E.screen.getPrimaryDisplay()||re[0])}const ie=q.bounds,ne={width:j,height:F,x:ie.x+ie.width/2-j/2,y:ie.y+ie.height/2-F/2};return ie.width>0&&ie.height>0&&(ne.x<ie.x&&(ne.x=ie.x),ne.y<ie.y&&(ne.y=ie.y),ne.x>ie.x+ie.width&&(ne.x=ie.x),ne.y>ie.y+ie.height&&(ne.y=ie.y),ne.width>ie.width&&(ne.width=ie.width),ne.height>ie.height&&(ne.height=ie.height)),ne}};R.a="#1E1E1E",e.$Z2b=R=pe([x(1,h.$k2b),x(2,y.$Ni),x(3,m.$1l),x(4,d.$G2b),x(5,p.$s2b),x(6,b.$W2b),x(7,a.$Y2b),x(8,g.$6i),x(9,t.$oM),x(10,n.$e2b)],R);function I(S){return typeof S!="object"||S===null?!1:"x"in S&&"y"in S&&"width"in S&&"height"in S}}),define(ee[298],te([0,1,21,18,28,20,5,67,23,51,26,48,100]),function(G,e,E,C,r,O,A,P,f,l,m,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v3b=void 0;let h=e.$v3b=class extends p.$t3b{constructor(b,o,g,a,v,k,w,t){super(b,o,a,v,k,t),this.e=g,this.u=w}s(b){return(0,p.$s3b)(`linux-${process.arch}`,b,this.k)}t(b){this.a&&(this.d(d.$bhb.CheckingForUpdates(b)),this.i.request({url:this.a},E.CancellationToken.None).then(l.$zo).then(o=>{!o||!o.url||!o.version||!o.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!b}),this.d(d.$bhb.Idle(1))):this.d(d.$bhb.AvailableForDownload(o))}).then(void 0,o=>{this.j.error(o),this.e.publicLog2("update:notAvailable",{explicit:!!b});const g=b?o.message||o:void 0;this.d(d.$bhb.Idle(1,g))}))}async o(b){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):b.update.url&&this.u.openExternal(void 0,b.update.url),this.d(d.$bhb.Idle(1))}};e.$v3b=h=pe([x(0,O.$B2b),x(1,C.$Rh),x(2,m.$Rk),x(3,r.$k2b),x(4,l.$uo),x(5,A.$Ni),x(6,P.$W2b),x(7,f.$6i)],h)}),define(ee[299],te([0,1,47,42,27,8,21,55,9,7,141,22,18,28,16,20,5,67,23,51,26,48,100]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a,v,k,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x3b=void 0;async function u(c,$=1e3){for(;!c();)await(0,O.$sg)($)}let s;function i(){return typeof s>"u"&&(s=C.existsSync(f.$$b(f.$bc(process.execPath),"unins000.exe"))?0:1),s}let n=e.$x3b=class extends t.$t3b{get cachePath(){const $=f.$$b((0,r.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return d.Promises.mkdir($,{recursive:!0}).then(()=>$)}constructor($,R,I,S,M,j,F,q,re){super($,R,S,M,j,re),this.u=I,this.v=F,this.w=q}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s($){let R="win32";return process.arch!=="ia32"&&(R+=`-${process.arch}`),i()===1?R+="-archive":this.k.target==="user"&&(R+="-user"),(0,t.$s3b)(R,$,this.k)}t($){this.a&&(this.d(w.$bhb.CheckingForUpdates($)),this.i.request({url:this.a},A.CancellationToken.None).then(v.$zo).then(R=>{const I=i();return!R||!R.url||!R.version||!R.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!$}),this.d(w.$bhb.Idle(I)),Promise.resolve(null)):I===1?(this.d(w.$bhb.AvailableForDownload(R)),Promise.resolve(null)):(this.d(w.$bhb.Downloading(R)),this.C(R.version).then(()=>this.B(R.version).then(S=>d.Promises.exists(S).then(M=>{if(M)return Promise.resolve(S);const j=R.url,F=R.hash,q=`${S}.tmp`;return this.i.request({url:j},A.CancellationToken.None).then(re=>this.v.writeFile(l.URI.file(q),re.stream)).then(F?()=>(0,m.$OR)(q,R.hash):()=>{}).then(()=>d.Promises.rename(q,S)).then(()=>S)})).then(S=>{const M=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:S},M&&R.supportsFastUpdate?this.k.target==="user"?this.p():this.d(w.$bhb.Downloaded(R)):this.d(w.$bhb.Ready(R))})))}).then(void 0,R=>{this.j.error(R),this.u.publicLog2("update:notAvailable",{explicit:!!$});const I=$?R.message||R:void 0;this.d(w.$bhb.Idle(i(),I))}))}async o($){$.update.url&&this.w.openExternal(void 0,$.update.url),this.d(w.$bhb.Idle(i()))}async B($){const R=await this.cachePath;return f.$$b(R,`CodeSetup-${this.k.quality}-${$}.exe`)}async C($=null){const R=$?j=>!new RegExp(`${this.k.quality}-${$}\\.exe$`).test(j):()=>!0,I=await this.cachePath,M=(await d.Promises.readdir(I)).filter(R).map(async j=>{try{await d.Promises.unlink(f.$$b(I,j))}catch{}});await Promise.all(M)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const $=this.state.update;this.d(w.$bhb.Updating($));const R=await this.cachePath;this.e.updateFilePath=f.$$b(R,`CodeSetup-${this.k.quality}-${$.version}.flag`),await d.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(w.$bhb.Idle(i()))});const S=`${this.k.win32MutexName}-ready`,M=await new Promise((j,F)=>{G(["@vscode/windows-mutex"],j,F)});u(()=>M.isActive(S)).then(()=>this.d(w.$bhb.Ready($)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?C.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return i()}async _applySpecificUpdate($){if(this.state.type!=="idle")return;const R=this.g.getValue("update.enableWindowsBackgroundUpdates"),I={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!R};this.d(w.$bhb.Downloading(I)),this.e={packagePath:$},R?this.k.target==="user"?this.p():this.d(w.$bhb.Downloaded(I)):this.d(w.$bhb.Ready(I))}};pe([P.$Pg],n.prototype,"cachePath",null),e.$x3b=n=pe([x(0,b.$B2b),x(1,p.$Rh),x(2,k.$Rk),x(3,h.$k2b),x(4,v.$uo),x(5,o.$Ni),x(6,y.$Oj),x(7,g.$W2b),x(8,a.$6i)],n)}),define(ee[300],te([0,1,14,8,21,50,4,2,15,9,65,3,7,188,64,18,59,28,63,16,20,5,23,78,250,99,26,102,79,80,29,30,54,127,133,39,34,53,66,24]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a,v,k,w,t,u,s,i,n,c,$,R,I,S,M,j,F,q,re,ie,ne,ue){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F3b=void 0;var le;(function(Y){Y[Y.NONE=0]="NONE",Y[Y.NAVIGATING=1]="NAVIGATING",Y[Y.READY=2]="READY"})(le||(le={}));let K=e.$F3b=class vt extends P.$kb{get id(){return this.j}get win(){return this.k}get lastFocusTime(){return this.l}get backupPath(){return this.m?.backupPath}get openedWorkspace(){return this.m?.workspace}get profile(){if(!this.config)return;const N=this.O.profiles.find(W=>W.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&N?N:this.O.getProfileForWorkspace(this.config.workspace??(0,S.$zh)(this.backupPath,this.isExtensionDevelopmentHost))??this.O.defaultProfile}get remoteAuthority(){return this.m?.remoteAuthority}get config(){return this.m}get isExtensionDevelopmentHost(){return!!this.m?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.m?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.m?.debugId}constructor(N,W,T,J,Q,ae,oe,L,D,U,H,V,z,B,X,se,ce,ge,Ie,Ae){super(),this.J=W,this.L=T,this.M=J,this.N=Q,this.O=ae,this.P=oe,this.Q=L,this.R=D,this.S=U,this.U=H,this.W=V,this.X=z,this.Y=B,this.Z=X,this.$=se,this.ab=ce,this.bb=ge,this.db=Ie,this.eb=Ae,this.b=this.B(new A.$5c),this.onWillLoad=this.b.event,this.c=this.B(new A.$5c),this.onDidSignalReady=this.c.event,this.f=this.B(new A.$5c),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new A.$5c),this.onDidClose=this.g.event,this.h=this.B(new A.$5c),this.onDidDestroy=this.h.event,this.l=-1,this.s=void 0,this.t=void 0,this.w=!1,this.z=[],this.C=[],this.D=void 0,this.F=void 0,this.G=this.B(this.bb.createIPCObjectUrl()),this.I=!1,this.fb=0;{const[Ce,Le]=this.pb(N.state);this.n=Ce,this.J.trace("window#ctor: using window state",Ce);const ye=this.n.mode===0||this.n.mode===3,we=this.S.getValue("window"),ke={width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y,backgroundColor:this.U.getBackgroundColor(),minWidth:R.$aD.WIDTH,minHeight:R.$aD.HEIGHT,show:!ye,title:this.ab.nameLong,webPreferences:{preload:f.$1e.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.G.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,R.$hD)(we?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};d.$k?ke.icon=(0,l.$$b)(this.M.appRoot,"resources/linux/code.png"):d.$i&&!this.M.isBuilt&&(ke.icon=(0,l.$$b)(this.M.appRoot,"resources/win32/code_150x150.png")),d.$j&&!this.wb()&&(ke.fullscreenable=!1),d.$j&&(ke.acceptFirstMouse=!0,we?.clickThroughInactive===!1&&(ke.acceptFirstMouse=!1));const _=d.$j&&we?.nativeTabs===!0;_&&(ke.tabbingIdentifier=this.ab.nameShort);const he=(0,R.$fD)(this.S)==="custom";if(he&&(ke.titleBarStyle="hidden",d.$j||(ke.frame=!1),(0,R.$gD)(this.S))){const de=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Se=F.$6r.fromHex(de).isDarker()?"#FFFFFF":"#000000";ke.titleBarOverlay={height:29,color:de,symbolColor:Se},this.w=!0}if((0,m.mark)("code/willCreateCodeBrowserWindow"),this.k=new E.BrowserWindow(ke),(0,m.mark)("code/didCreateCodeBrowserWindow"),this.j=this.k.id,d.$j&&he&&this.k.setSheetOffset(22),he&&(d.$i&&(0,R.$gD)(this.S)||d.$j)){const de=this.eb.getItem(vt.a);de&&this.updateWindowControls({height:de})}d.$i&&he&&this.k.hookWindowMessage(278,()=>{const[Se,Re]=this.k.getPosition(),je=E.screen.getCursorScreenPoint(),Ue=je.x-Se,He=je.y-Re;return(()=>!(Ue>30&&He>=0&&He<=Math.max(this.k.getBounds().height*.15,35)))()||(this.k.setEnabled(!1),this.k.setEnabled(!0),this.f.fire({x:Ue,y:He})),0}),(d.$j||d.$i)&&Le&&(!_||E.BrowserWindow.getAllWindows().length===1)&&[this.n.width,this.n.height,this.n.x,this.n.y].every(de=>typeof de=="number")&&this.k.setBounds({width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y}),ye&&((0,m.mark)("code/willMaximizeCodeWindow"),this.k.maximize(),this.n.mode===3&&this.sb(!0),this.k.show(),(0,m.mark)("code/didMaximizeCodeWindow")),this.l=Date.now()}this.M.args["open-devtools"]===!0&&this.k.webContents.openDevTools(),this.mb(),this.Ab(),this.gb()}setRepresentedFilename(N){d.$j?this.k.setRepresentedFilename(N):this.u=N}getRepresentedFilename(){return d.$j?this.k.getRepresentedFilename():this.u}setDocumentEdited(N){d.$j&&this.k.setDocumentEdited(N),this.v=N}isDocumentEdited(){return d.$j?this.k.isDocumentEdited():!!this.v}focus(N){d.$j&&N?.force&&E.app.focus({steal:!0}),this.k&&(this.k.isMinimized()&&this.k.restore(),this.k.focus())}setReady(){for(this.J.trace(`window#load: window reported ready (id: ${this.j})`),this.fb=2;this.z.length;)this.z.pop()(this);this.c.fire()}ready(){return new Promise(N=>{if(this.isReady)return N(this);this.z.push(N)})}get isReady(){return this.fb===2}get whenClosedOrLoaded(){return new Promise(N=>{function W(){T.dispose(),J.dispose(),N()}const T=this.onDidClose(()=>W()),J=this.onWillLoad(()=>W())})}gb(){this.k.on("unresponsive",()=>this.jb(1)),this.k.webContents.on("render-process-gone",(W,T)=>this.jb(2,{...T})),this.k.webContents.on("did-fail-load",(W,T,J)=>this.jb(3,{reason:J,exitCode:T})),this.k.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this.k.on("closed",()=>{this.g.fire(),this.dispose()}),this.k.webContents.on("did-finish-load",()=>{this.H&&(this.m=this.H,this.H=void 0)}),this.k.on("focus",()=>{this.l=Date.now()}),this.k.on("maximize",W=>{this.m&&(this.m.maximized=!0),E.app.emit("browser-window-maximize",W,this.k)}),this.k.on("unmaximize",W=>{this.m&&(this.m.maximized=!1),E.app.emit("browser-window-unmaximize",W,this.k)}),this.k.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.k.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.B(this.S.onDidChangeConfiguration(W=>this.mb(W))),this.B(this.W.onDidDeleteUntitledWorkspace(W=>this.lb(W)));const N=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.k.webContents.session.webRequest.onBeforeSendHeaders({urls:N},async(W,T)=>{const J=await this.ib();T({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,J)})})}ib(){return this.hb||(this.hb=(0,s.$No)(this.ab.version,this.ab,this.M,this.S,this.P,this.Q,this.Y)),this.hb}async jb(N,W){switch(N){case 2:this.J.error(`CodeWindow: renderer process gone (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.J.error("CodeWindow: detected unresponsive");break;case 3:this.J.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:N,reason:W?.reason,code:W?.exitCode}),N){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.$.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.kb(!1,!1),this.$.quit();return}if(N===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.k&&this.k.webContents&&this.k.webContents.isDevToolsOpened())return;const{response:T,checkboxChecked:J}=await this.Z.showMessageBox({type:"warning",buttons:[(0,h.localize)(0,null),(0,h.localize)(1,null),(0,h.localize)(2,null)],message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null),checkboxLabel:this.m?.workspace?(0,h.localize)(5,null):void 0},this.k);if(T!==2){const Q=T===0;await this.kb(Q,J)}}else if(N===2){let T;W?T=(0,h.localize)(7,null,W.reason,W.exitCode??"<unknown>"):T=(0,h.localize)(6,null);const{response:J,checkboxChecked:Q}=await this.Z.showMessageBox({type:"warning",buttons:[this.m?.workspace?(0,h.localize)(8,null):(0,h.localize)(9,null),(0,h.localize)(10,null)],message:T,detail:this.m?.workspace?(0,h.localize)(11,null):(0,h.localize)(12,null),checkboxLabel:this.m?.workspace?(0,h.localize)(13,null):void 0},this.k),ae=J===0;await this.kb(ae,Q)}break}}async kb(N,W){const T=this.m?.workspace;if(W&&T)try{const J=this.R.workspaceStorage(T);await J.init(),J.delete("memento/workbench.parts.editor"),await J.close()}catch(J){this.J.error(J)}if(this.h.fire(),this.k?.destroy(),N&&this.m){let J,Q;(0,S.$vh)(T)?J={folderUri:T.uri}:(0,S.$Ah)(T)?J={workspaceUri:T.configPath}:Q=!0,(0,ue.$sf)(await this.db.open({context:5,userEnv:this.m.userEnv,cli:{...this.M.args,_:[]},urisToOpen:J?[J]:void 0,forceEmpty:Q,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}lb(N){this.m?.workspace?.id===N.id&&(this.m.workspace=void 0)}mb(N){if(!N||N.affectsConfiguration("window.menuBarVisibility")){const W=this.xb();W!==this.r&&(this.r=W,this.yb(W))}if(!N||N.affectsConfiguration("http.proxy")){let W=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;W?.endsWith("/")&&(W=W.substr(0,W.length-1));const T=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((W||"").indexOf("@")===-1&&(W!==this.D||T!==this.F)){this.D=W,this.F=T;const J=W||"",Q=T?`${T},<local>`:"<local>";this.J.trace(`Setting proxy to '${J}', bypassing '${Q}'`),this.k.webContents.session.setProxy({proxyRules:J,proxyBypassRules:Q,pacScript:""})}}}addTabbedWindow(N){d.$j&&N.win&&this.k.addTabbedWindow(N.win)}load(N,W=Object.create(null)){this.J.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!W.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.k.setTitle(this.ab.nameLong)),this.nb(N,W),this.fb===0?this.m=N:this.H=N,this.fb=1,this.k.loadURL(f.$1e.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const T=this.I;this.I=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new C.$Cg(()=>{this.k&&!this.k.isVisible()&&!this.k.isMinimized()&&(this.k.show(),this.focus({force:!0}),this.k.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:N.workspace,reason:W.isReload?3:T?2:1})}nb(N,W){const T=(this.m??this.H)?.userEnv;if(T){const J=(0,a.$ol)(T)&&!(0,a.$ol)(N.userEnv),Q=this.isExtensionDevelopmentHost;(J||Q)&&(N.userEnv={...T,...N.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(N.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(N["disable-extensions"]=W.disableExtensions),N.fullscreen=this.isFullScreen,N.maximized=this.k.isMaximized(),N.partsSplash=this.U.getWindowSplash(),(0,m.mark)("code/willOpenNewWindow"),N.perfMarks=(0,m.getMarks)(),this.G.update(N)}async reload(N){const W=Object.assign({},this.m);W.workspace=await this.ob(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&N&&(W.verbose=N.verbose,W.debugId=N.debugId,W.extensionEnvironment=N.extensionEnvironment,W["inspect-extensions"]=N["inspect-extensions"],W["inspect-brk-extensions"]=N["inspect-brk-extensions"],W["extensions-dir"]=N["extensions-dir"]),W.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),W.isInitialStartup=!1,W.policiesData=this.N.serialize(),W.continueOn=this.M.continueOn,W.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile,home:this.O.profilesHome},W.logLevel=this.L.getLogLevel(),W.loggers={window:this.L.getRegisteredLoggers(this.id),global:this.L.getRegisteredLoggers()},this.load(W,{isReload:!0,disableExtensions:N?.["disable-extensions"]})}async ob(N){if((0,S.$Ah)(N.workspace)){const W=N.workspace.configPath;if(W.scheme===f.Schemas.file&&!await this.P.exists(W))return}else if((0,S.$vh)(N.workspace)){const W=N.workspace.uri;if(W.scheme===f.Schemas.file&&!await this.P.exists(W))return}return N.workspace}serializeWindowState(){if(!this.k)return(0,j.$d2b)();if(this.isFullScreen){let T;try{T=E.screen.getDisplayMatching(this.getBounds())}catch{}const J=(0,j.$d2b)();return{mode:3,display:T?T.id:void 0,width:this.n.width||J.width,height:this.n.height||J.height,x:this.n.x||0,y:this.n.y||0}}const N=Object.create(null);let W;if(!d.$j&&this.k.isMaximized()?W=0:W=1,W===0?N.mode=0:N.mode=1,W===1||W===0){let T;W===1?T=this.getBounds():T=this.k.getNormalBounds(),N.x=T.x,N.y=T.y,N.width=T.width,N.height=T.height}return N}updateWindowControls(N){if(N.height&&this.eb.setItem(vt.a,N.height),d.$i&&this.w)this.k.setTitleBarOverlay({color:N.backgroundColor?.trim()===""?void 0:N.backgroundColor,symbolColor:N.foregroundColor?.trim()===""?void 0:N.foregroundColor,height:N.height?N.height-1:void 0});else if(d.$j&&N.height!==void 0){const W=(N.height-15)/2;this.k.setTrafficLightPosition({x:W,y:W})}}pb(N){(0,m.mark)("code/willRestoreCodeWindowState");let W=!1;if(N)try{const T=E.screen.getAllDisplays();W=T.length>1,N=this.qb(N,T)}catch(T){this.J.warn(`Unexpected error validating window state: ${T}
${T.stack}`)}return(0,m.mark)("code/didRestoreCodeWindowState"),[N||(0,j.$d2b)(),W]}qb(N,W){if(this.J.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,N),typeof N.x!="number"||typeof N.y!="number"||typeof N.width!="number"||typeof N.height!="number"){this.J.trace("window#validateWindowState: unexpected type of state values");return}if(N.width<=0||N.height<=0){this.J.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const Q=this.rb(W[0]);if(Q){let ae=function(){!N||typeof N.x!="number"||typeof N.y!="number"||!Q||(N.x<Q.x&&(N.x=Q.x),N.y<Q.y&&(N.y=Q.y))};this.J.trace("window#validateWindowState: 1 monitor working area",Q),ae(),N.width>Q.width&&(N.width=Q.width),N.height>Q.height&&(N.height=Q.height),N.x>Q.x+Q.width-128&&(N.x=Q.x+Q.width-N.width),N.y>Q.y+Q.height-128&&(N.y=Q.y+Q.height-N.height),ae()}return N}if(N.display&&N.mode===3){const Q=W.find(ae=>ae.id===N.display);if(Q&&typeof Q.bounds?.x=="number"&&typeof Q.bounds?.y=="number"){this.J.trace("window#validateWindowState: restoring fullscreen to previous display");const ae=(0,j.$d2b)(3);return ae.x=Q.bounds.x,ae.y=Q.bounds.y,ae}}let T,J;try{T=E.screen.getDisplayMatching({x:N.x,y:N.y,width:N.width,height:N.height}),J=this.rb(T)}catch{}if(T&&J&&N.x+N.width>J.x&&N.y+N.height>J.y&&N.x<J.x+J.width&&N.y<J.y+J.height)return this.J.trace("window#validateWindowState: multi-monitor working area",J),N}rb(N){if(N.workArea.width>0&&N.workArea.height>0)return N.workArea;if(N.bounds.width>0&&N.bounds.height>0)return N.bounds}getBounds(){const[N,W]=this.k.getPosition(),[T,J]=this.k.getSize();return{x:N,y:W,width:T,height:J}}toggleFullScreen(){this.sb(!this.isFullScreen)}sb(N){this.wb()?this.tb(N):this.vb(N),this.sendWhenReady(N?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.r&&this.yb(this.r,!1)}get isFullScreen(){return d.$j&&typeof this.s=="boolean"?this.s:this.k.isFullScreen()||this.k.isSimpleFullScreen()}tb(N){this.k.isSimpleFullScreen()&&this.k.setSimpleFullScreen(!1),this.ub(N)}ub(N){d.$j&&(this.s=N,this.t=new C.$Lg,Promise.race([this.t.p,(0,C.$sg)(1e3)]).finally(()=>this.s=void 0)),this.k.setFullScreen(N)}vb(N){this.k.isFullScreen()&&this.ub(!1),this.k.setSimpleFullScreen(N),this.k.webContents.focus()}wb(){const N=this.S.getValue("window");return!N||typeof N.nativeFullScreen!="boolean"||N.nativeTabs?!0:N.nativeFullScreen!==!1}isMinimized(){return this.k.isMinimized()}xb(){let N=(0,R.$eD)(this.S);return["visible","toggle","hidden"].indexOf(N)<0&&(N="classic"),N}yb(N,W=!0){d.$j||(N==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,h.localize)(14,null)),N==="hidden"?setTimeout(()=>{this.zb(N)}):this.zb(N))}zb(N){const W=this.isFullScreen;switch(N){case"classic":this.k.setMenuBarVisibility(!W),this.k.autoHideMenuBar=W;break;case"visible":this.k.setMenuBarVisibility(!0),this.k.autoHideMenuBar=!1;break;case"toggle":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!0;break;case"hidden":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.$j)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.k.minimize();break;case"None":break;case"Maximize":default:this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}else this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}close(){this.k?.close()}sendWhenReady(N,W,...T){this.isReady?this.send(N,...T):this.ready().then(()=>{W.isCancellationRequested||this.send(N,...T)})}send(N,...W){if(this.k){if(this.k.isDestroyed()||this.k.webContents.isDestroyed()){this.J.warn(`Sending IPC message to channel '${N}' for window that is destroyed`);return}try{this.k.webContents.send(N,...W)}catch(T){this.J.warn(`Error sending IPC message to channel '${N}' of window ${this.j}: ${(0,O.$9h)(T)}`)}}}updateTouchBar(N){d.$j&&this.C.forEach((W,T)=>{const J=N[T];W.segments=this.Cb(J)})}Ab(){if(d.$j){for(let N=0;N<10;N++){const W=this.Bb();this.C.push(W)}this.k.setTouchBar(new E.TouchBar({items:this.C}))}}Bb(N=[]){const W=this.Cb(N),T=new E.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:J=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:T.segments[J].id,from:"touchbar"})}});return T}Cb(N=[]){return N.map(T=>{let J;T.icon&&!c.ThemeIcon.isThemeIcon(T.icon)&&T.icon?.dark?.scheme===f.Schemas.file&&(J=E.nativeImage.createFromPath(p.URI.revive(T.icon.dark).fsPath),J.isEmpty()&&(J=void 0));let Q;return typeof T.title=="string"?Q=T.title:Q=T.title.value,{id:T.id,label:J?void 0:Q,icon:J}})}dispose(){super.dispose(),this.L.deregisterLoggers(this.id),this.k=null}};K.a="windowControlHeight",e.$F3b=K=pe([x(1,w.$Ni),x(2,ne.$k3b),x(3,g.$k2b),x(4,q.$Rm),x(5,ie.$u2b),x(6,v.$Oj),x(7,i.$d3b),x(8,i.$b3b),x(9,b.$Rh),x(10,$.$S2b),x(11,M.$z2b),x(12,y.$j2b),x(13,n.$Rk),x(14,o.$s2b),x(15,k.$B2b),x(16,t.$6i),x(17,u.$Y2b),x(18,I.$e2b),x(19,re.$oM)],K)}),define(ee[82],te([0,1,14,24,8,4,46,2,15,3,19,7,22,191,6,20,5,99,97,30,54,35]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a,v,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g3b=e.$f3b=void 0,e.$f3b=(0,y.$lh)("workspacesHistoryMainService");let t=e.$g3b=class nt extends P.$kb{constructor(s,i,n,c){super(),this.f=s,this.g=i,this.h=n,this.j=c,this.c=this.B(new O.$5c),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new r.$pg(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}async addRecentlyOpened(s){let i=[],n=[];for(const $ of s)if((0,a.$d_)($))!this.g.isUntitledWorkspace($.workspace)&&!this.r(i,$.workspace)&&i.push($);else if((0,a.$e_)($))this.s(i,$.folderUri)||i.push($);else{const R=this.t(n,$.fileUri),I=$.fileUri.scheme===f.Schemas.file&&nt.y.indexOf((0,m.$3f)($.fileUri))>=0;!R&&!I&&(n.push($),l.$i&&$.fileUri.scheme===f.Schemas.file&&E.app.addRecentDocument($.fileUri.fsPath))}const c=await this.l({workspaces:i,files:n});i=c.workspaces,n=c.files,i.length>nt.a&&(i.length=nt.a),n.length>nt.a&&(n.length=nt.a),await this.n({workspaces:i,files:n}),this.c.fire(),l.$j&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(s){const i=R=>{const I=this.p(R);for(const S of s)if(m.$Wf.isEqual(S,I))return!1;return!0},n=await this.getRecentlyOpened(),c=n.workspaces.filter(i),$=n.files.filter(i);(c.length!==n.workspaces.length||$.length!==n.files.length)&&(await this.n({files:$,workspaces:c}),this.c.fire(),l.$j&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(s){const i=new w.$ji($=>m.$Wf.getComparisonKey($));if(s?.workspaces)for(const $ of s.workspaces)i.set(this.p($),$);const n=new w.$ji($=>m.$Wf.getComparisonKey($));if(s?.files)for(const $ of s.files)n.set(this.p($),$);const c=await this.m();for(const $ of c.workspaces){const R=i.get(this.p($));R?R.label=R.label??$.label:i.set(this.p($),$)}for(const $ of c.files){const R=n.get(this.p($));R?R.label=R.label??$.label:n.set(this.p($),$)}return{workspaces:[...i.values()],files:[...n.values()]}}async m(){await this.j.whenReady;let s;const i=this.j.get(nt.b,-1);if(typeof i=="string")try{s=JSON.parse(i)}catch(n){this.f.error("Unexpected error parsing opened paths list",n)}return(0,a.$k_)(s,this.f)}async n(s){await this.j.whenReady,this.j.store(nt.b,JSON.stringify((0,a.$l_)(s)),-1,1)}p(s){return(0,a.$e_)(s)?s.folderUri:(0,a.$f_)(s)?s.fileUri:s.workspace.configPath}r(s,i){return!!s.find(n=>(0,a.$d_)(n)&&n.workspace.id===i.id)}s(s,i){return!!s.find(n=>(0,a.$e_)(n)&&m.$Wf.isEqual(n.folderUri,i))}t(s,i){return!!s.find(n=>m.$Wf.isEqual(n.fileUri,i))}async C(){l.$i&&(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!l.$i)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const $ of E.app.getJumpListSettings().removedItems){const R=$.args;if(R){const I=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(R);I&&i.push(d.URI.parse(I[2]))}}await this.removeRecentlyOpened(i);let n=!1;const c=(0,C.$jf)((await this.getRecentlyOpened()).workspaces.slice(0,nt.w).map($=>{const R=(0,a.$d_)($)?$.workspace:$.folderUri,{title:I,description:S}=this.F(R,$.label);let M;return d.URI.isUri(R)?M=`--folder-uri "${R.toString()}"`:(n=!0,M=`--file-uri "${R.configPath.toString()}"`),{type:"task",title:I.substr(0,255),description:S.substr(0,255),program:process.execPath,args:M,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&s.push({type:"custom",name:n?(0,h.localize)(2,null):(0,h.localize)(3,null),items:c})}s.push({type:"recent"});try{const i=E.app.setJumpList(s);i&&i!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.f.warn("updateWindowsJumpList#setJumpList",i)}}F(s,i){if(i)return{title:(0,A.$Wz)(i).name,description:i};if(d.URI.isUri(s))return{title:(0,m.$3f)(s),description:this.G(s)};if(this.g.isUntitledWorkspace(s))return{title:(0,h.localize)(4,null),description:""};let n=(0,m.$3f)(s.configPath);return n.endsWith(v.$Hh)&&(n=n.substr(0,n.length-v.$Hh.length-1)),{title:(0,h.localize)(5,null,n),description:this.G(s.configPath)}}G(s){return s.scheme==="file"?(0,A.$Oz)(s.fsPath):s.toString()}async H(){if(!l.$j)return;E.app.clearRecentDocuments();const s=await this.getRecentlyOpened(),i=[];let n=0;for(let $=0;$<s.workspaces.length&&n<nt.u;$++){const R=this.p(s.workspaces[$]);if(R.scheme===f.Schemas.file){const I=(0,m.$Tf)(R);await p.Promises.exists(I)&&(i.push(I),n++)}}const c=[];for(let $=0;$<s.files.length&&n<nt.v;$++){const R=this.p(s.files[$]);if(R.scheme===f.Schemas.file){const I=(0,m.$Tf)(R);if(nt.y.includes((0,m.$3f)(R))||i.includes(I))continue;await p.Promises.exists(I)&&(c.push(I),n++)}}c.reverse().forEach($=>E.app.addRecentDocument($)),i.reverse().forEach($=>E.app.addRecentDocument($))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.u=7,t.v=10,t.w=7,t.y=["COMMIT_EDITMSG","MERGE_MSG"],e.$g3b=t=pe([x(0,o.$Ni),x(1,k.$z2b),x(2,b.$B2b),x(3,g.$d3b)],t)}),define(ee[301],te([0,1,14,8,21,46,3,7,179,18,28,20,5,229,67,23,34,26,48,80,29,82]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a,v,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h3b=void 0;const t="menu";let u=e.$h3b=class kt{constructor(n,c,$,R,I,S,M,j,F,q,re){this.n=n,this.o=c,this.p=$,this.q=R,this.r=I,this.s=S,this.t=M,this.u=j,this.v=F,this.w=q,this.x=re,this.m=Object.create(null),this.g=new C.$Cg(()=>this.E(),0),this.h=new C.$Cg(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.$j||(0,v.$fD)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const n=this.t.getItem(kt.a);n&&(n.menus&&(this.k=n.menus),n.keybindings&&(this.l=n.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(S,M,j)=>this.p.openEmptyWindow({context:2,contextWindowId:M?.id}),this.m["workbench.action.newWindow"]=(S,M,j)=>this.p.openEmptyWindow({context:2,contextWindowId:M?.id}),this.m["workbench.action.files.openFileFolder"]=(S,M,j)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(j),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(S,M,j)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(j),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(S,M,j)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(j),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const n=this.x.twitterUrl;n&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(n,"openTwitterUrl"));const c=this.x.requestFeatureUrl;c&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(c,"openUserVoiceUrl"));const $=this.x.reportIssueUrl;$&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z($,"openReportIssues"));const R=this.x.licenseUrl;R&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.$v){const S=R.indexOf("?")>0?"&":"?";this.Z(`${R}${S}lang=${A.$v}`,"openLicenseUrl")}else this.Z(R,"openLicenseUrl")});const I=this.x.privacyStatementUrl;I&&R&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(I,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(n=>this.F(n)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const n=this.o.getValue("window.enableMenuBarMnemonics");return typeof n!="boolean"?!0:n}get C(){if(!A.$j)return!1;const n=this.o.getValue("window.nativeTabs");return typeof n!="boolean"?!1:n}updateMenu(n,c){this.k=n.menus,this.l=n.keybindings,this.t.setItem(kt.a,n),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(n){A.$j&&(n.oldCount===0&&n.newCount>0||n.oldCount>0&&n.newCount===0)&&(this.d=n.newCount===0,this.D())}G(){A.$j&&(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const n=E.Menu.getApplicationMenu();if(n&&this.j.push(n),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(A.$j?new E.Menu:null);return}const c=new E.Menu;let $;if(A.$j){const I=new E.Menu;$=new E.MenuItem({label:this.x.nameShort,submenu:I}),this.I(I),c.append($)}if(A.$j&&!this.c){this.c=!0;const I=new E.Menu;I.append(new E.MenuItem({label:this.ab(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(I)}if(this.K("File")){const I=new E.Menu,S=new E.MenuItem({label:this.ab(f.localize(1,null)),submenu:I});this.M(I,"File"),c.append(S)}if(this.K("Edit")){const I=new E.Menu,S=new E.MenuItem({label:this.ab(f.localize(2,null)),submenu:I});this.M(I,"Edit"),c.append(S)}if(this.K("Selection")){const I=new E.Menu,S=new E.MenuItem({label:this.ab(f.localize(3,null)),submenu:I});this.M(I,"Selection"),c.append(S)}if(this.K("View")){const I=new E.Menu,S=new E.MenuItem({label:this.ab(f.localize(4,null)),submenu:I});this.M(I,"View"),c.append(S)}if(this.K("Go")){const I=new E.Menu,S=new E.MenuItem({label:this.ab(f.localize(5,null)),submenu:I});this.M(I,"Go"),c.append(S)}if(this.K("Run")){const I=new E.Menu,S=new E.MenuItem({label:this.ab(f.localize(6,null)),submenu:I});this.M(I,"Run"),c.append(S)}if(this.K("Terminal")){const I=new E.Menu,S=new E.MenuItem({label:this.ab(f.localize(7,null)),submenu:I});this.M(I,"Terminal"),c.append(S)}let R;if(this.K("Window")){const I=new E.Menu;R=new E.MenuItem({label:this.ab(f.localize(8,null)),submenu:I,role:"window"}),this.S(I)}if(R&&c.append(R),this.K("Help")){const I=new E.Menu,S=new E.MenuItem({label:this.ab(f.localize(9,null)),submenu:I,role:"help"});this.M(I,"Help"),c.append(S)}c.items&&c.items.length>0?E.Menu.setApplicationMenu(c):E.Menu.setApplicationMenu(null),this.h.schedule()}I(n){const c=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),$=this.T();let R;if(this.K("Preferences")){const ie=new E.Menu;this.M(ie,"Preferences"),R=new E.MenuItem({label:this.ab(f.localize(11,null)),submenu:ie})}const I=new E.Menu,S=new E.MenuItem({label:f.localize(12,null),role:"services",submenu:I}),M=new E.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),j=new E.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),F=new E.MenuItem({label:f.localize(15,null),role:"unhide"}),q=new E.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(ie,ne,ue)=>{const le=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||E.BrowserWindow.getFocusedWindow()||le?.isMinimized())&&await this.J(ue)&&this.w.quit(void 0)}})),re=[c];re.push(...$),R&&re.push(s(),R),re.push(s(),S,s(),M,j,F,s(),q),re.forEach(ie=>n.append(ie))}async J(n){if(this.p.getWindowCount()===0)return!0;const c=this.o.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.Q(n)){const{response:$}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return $===0}return!0}K(n){if(!A.$j&&(0,v.$fD)(this.o)==="custom")return!1;switch(n){case"File":case"Help":if(A.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[n];case"Window":if(A.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[n]}}L(n,c){c.forEach($=>{if((0,h.$72b)($))n.append(s());else if((0,h.$62b)($)){const R=new E.Menu,I=new E.MenuItem({label:this.ab($.label),submenu:R});this.L(R,$.submenu.items),n.append(I)}else(0,h.$82b)($)?n.append(this.O($)):(0,h.$92b)($)&&($.id==="workbench.action.showAboutDialog"&&this.N(n),A.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[$.id]?n.append(new E.MenuItem(this.Y($.id,{label:this.ab($.label),click:this.m[$.id]}))):n.append(this.U($.label,$.id,!1,$.checked)):n.append(this.U($.label,$.id,$.enabled!==!1,!!$.checked)):n.append(this.U($.label,$.id,$.enabled!==!1,!!$.checked)))})}M(n,c){this.k&&this.k[c]&&this.L(n,this.k[c].items)}N(n){const c=this.T();c.length&&(c.forEach($=>n.append($)),n.append(s()))}O(n){const c=P.URI.revive(n.uri),$=n.id,R=$==="openRecentFile"?{fileUri:c}:$==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new E.MenuItem(this.Y($,{label:n.label,click:async(I,S,M)=>{const j=this.P(M);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[R],forceNewWindow:j,gotoLineMode:!1,remoteAuthority:n.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([c])}},!1))}P(n){return!!(n&&(!A.$j&&(n.ctrlKey||n.shiftKey)||A.$j&&(n.metaKey||n.altKey)))}Q(n){return!!(n.triggeredByAccelerator||n.altKey||n.ctrlKey||n.metaKey||n.shiftKey)}R(n,c,$){const R={label:this.ab(n),role:$,enabled:!0};return new E.MenuItem(this.X(c,R))}S(n){const c=new E.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),$=new E.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),R=new E.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),I=this.U(f.localize(23,null),"workbench.action.switchWindow"),S=[];this.C&&(S.push(s()),S.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),S.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),S.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),S.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),S.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,$,s(),I,...S,s(),R].forEach(M=>n.append(M))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.ab(f.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.ab(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.ab(f.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.ab(f.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(n,c,$,R){const I=this.ab(n),S=typeof c=="function"?c:(re,ie,ne)=>{const ue=re?re.userSettingsLabel:null;let le=c;Array.isArray(c)&&(le=this.P(ne)?c[1]:c[0]),ue&&ne.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ue}):this.W({type:"commandId",commandId:le})},M=typeof $=="boolean"?$:this.p.getWindowCount()>0,j=typeof R=="boolean"?R:!1,F={label:I,click:S,enabled:M};j&&(F.type="checkbox",F.checked=j);let q;return typeof c=="string"?q=c:Array.isArray(c)&&(q=c[0]),A.$j&&(q==="editor.action.clipboardCutAction"?F.role="cut":q==="editor.action.clipboardCopyAction"?F.role="copy":q==="editor.action.clipboardPasteAction"&&(F.role="paste"),q==="undo"?F.click=this.V(S,{inDevTools:re=>re.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):q==="redo"?F.click=this.V(S,{inDevTools:re=>re.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):q==="editor.action.selectAll"&&(F.click=this.V(S,{inDevTools:re=>re.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(q,F))}V(n,c){return($,R,I)=>{const S=E.BrowserWindow.getFocusedWindow();if(!S)return c.inNoWindow();if(S.webContents.isDevToolsFocused()&&S.webContents.devToolsWebContents)return c.inDevTools(S.webContents.devToolsWebContents);n($,R||S,I)}}W(n){let c=E.BrowserWindow.getFocusedWindow();if(!c){const R=this.p.getLastActiveWindow();R?.isMinimized()&&(c=R.win)}const $=c?this.p.getWindowById(c.id):void 0;if($){if(this.v.trace("menubar#runActionInRenderer",n),A.$j&&!this.q.isBuilt&&!$.isReady&&(n.type==="commandId"&&n.commandId==="workbench.action.toggleDevTools"||n.type!=="commandId"&&n.userSettingsLabel==="alt+cmd+i"))return;if(n.type==="commandId"){const R={id:n.commandId,from:"menu"};$.sendWhenReady("vscode:runAction",r.CancellationToken.None,R)}else{const R={userSettingsLabel:n.userSettingsLabel};$.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,R)}}else this.v.trace("menubar#runActionInRenderer: no active window found",n)}X(n,c){const $=typeof n=="string"?this.l[n]:void 0;if($?.label){if($.isNative!==!1)c.accelerator=$.label,c.userSettingsLabel=$.userSettingsLabel;else if(typeof c.label=="string"){const R=c.label.indexOf("[");R>=0?c.label=`${c.label.substr(0,R)} [${$.label}]`:c.label=`${c.label} [${$.label}]`}}else c.accelerator=void 0;return c}Y(n,c,$=!c.accelerator){$&&(c=this.X(n,c));const R=c.click;return c.click=(I,S,M)=>{this.$(n),R?.(I,S,M)},c}Z(n,c){this.w.openExternal(void 0,n),this.$(c)}$(n){this.r.publicLog2("workbenchActionExecuted",{id:n,from:t})}ab(n){return(0,O.$Tz)(n,!this.B)}};u.a="lastKnownMenubarData",e.$h3b=u=pe([x(0,a.$chb),x(1,l.$Rh),x(2,k.$e2b),x(3,m.$k2b),x(4,g.$Rk),x(5,w.$f3b),x(6,o.$oM),x(7,d.$B2b),x(8,p.$Ni),x(9,y.$W2b),x(10,b.$6i)],u);function s(){return new E.MenuItem({type:"separator"})}}),define(ee[302],te([0,1,6,20,5,301]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j3b=e.$i3b=void 0,e.$i3b=(0,E.$lh)("menubarMainService");let A=e.$j3b=class{constructor(f,l,m){this.b=f,this.c=l,this.d=m,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(O.$h3b)}async updateMenubar(f,l){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(l,f)}};e.$j3b=A=pe([x(0,E.$kh),x(1,C.$B2b),x(2,r.$Ni)],A)}),define(ee[303],te([0,1,14,22,131,27,24,21,4,32,49,46,2,15,9,65,3,36,19,11,7,189,64,18,59,28,16,6,20,5,77,78,58,34,80,300,129,296,30,98,82,54,79,39,53,66]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a,v,k,w,t,u,s,i,n,c,$,R,I,S,M,j,F,q,re,ie,ne,ue,le,K,Y,N,W,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J3b=void 0;function J(oe){return(0,ne.$Ah)(oe?.workspace)}function Q(oe){return(0,ne.$vh)(oe?.workspace)}let ae=e.$J3b=class at extends p.$kb{constructor(L,D,U,H,V,z,B,X,se,ce,ge,Ie,Ae,Ce,Le,ye,we,ke){super(),this.k=L,this.l=D,this.m=U,this.n=H,this.r=V,this.s=z,this.t=B,this.u=X,this.v=se,this.w=ce,this.z=ge,this.C=Ie,this.D=Ae,this.F=Ce,this.G=Le,this.H=ye,this.I=we,this.J=ke,this.b=this.B(new f.$5c),this.onDidOpenWindow=this.b.event,this.c=this.B(new f.$5c),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new f.$5c),this.onDidDestroyWindow=this.f.event,this.g=this.B(new f.$5c),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new f.$5c),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ie.$G3b(this,this.r,this.v,this.m,this.z)),this.L()}L(){this.B(this.D.onDidEnterWorkspace(L=>this.c.fire(L.window))),this.B(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const D=new p.$jb;if(D.add(f.Event.any(L.onDidClose,L.onDidDestroy)(()=>D.dispose())),L.config.extensionDevelopmentPath)for(const U of L.config.extensionDevelopmentPath)D.add(this.I.addValidFileRoot(U));L.config.extensionTestsPath&&D.add(this.I.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,D){const U=this.t.args,H=D?.remoteAuthority||void 0,V=!0,z=D?.forceReuseWindow,B=!z;return this.open({...L,cli:U,forceEmpty:V,forceNewWindow:B,forceReuseWindow:z,remoteAuthority:H})}openExistingWindow(L,D){L.focus(),this.M(D,[L])}async open(L){this.m.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const D=[],U=[],H=[],V=[],z=[];let B,X=0;const se=await this.S(L);this.m.trace("windowsManager#open pathsToOpen",se);for(const Ce of se)Q(Ce)?L.addMode?D.push(Ce):U.push(Ce):J(Ce)?H.push(Ce):Ce.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ce.remoteAuthority}),B.filesToOpenOrCreate.push(Ce)):Ce.backupPath?z.push({backupFolder:(0,y.$cc)(Ce.backupPath),remoteAuthority:Ce.remoteAuthority}):X++;L.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),L.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&L.waitMarkerFileURI&&(B.filesToWait={paths:(0,A.$jf)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(V.push(...this.D.getUntitledWorkspaces()),H.push(...V),z.push(...this.w.getEmptyWindowBackups())):z.length=0;const{windows:ce,filesOpenedInWindow:ge}=await this.N(L,H,U,z,X,B,D);if(this.m.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${H.length}, foldersToOpen: ${U.length}, emptyToRestore: ${z.length}, emptyToOpen: ${X})`),ce.length>1)if(ge)ge.focus();else{const Ce=this.j.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Le=!0,ye=!0;if(Ce){const we=ce.filter(ke=>this.j.state.lastActiveWindow&&ke.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Le=!1,ye=!1)}if(Le)for(let we=ce.length-1;we>=0;we--){const ke=ce[we];if(!(ke.openedWorkspace&&V.some(_=>ke.openedWorkspace&&_.workspace.id===ke.openedWorkspace.id)||ke.backupPath&&z.some(_=>ke.backupPath&&_.backupFolder===(0,y.$cc)(ke.backupPath)))){ke.focus(),ye=!1;break}}ye&&ce[ce.length-1].focus()}const Ie=B&&B.filesToDiff.length>0,Ae=B&&B.filesToMerge.length>0;if(!ce.some(Ce=>Ce.isExtensionDevelopmentHost)&&!Ie&&!Ae&&!L.noRecentEntry){const Ce=[];for(const Le of se)J(Le)&&!Le.transient?Ce.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):Q(Le)?Ce.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Ce.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.C.addRecentlyOpened(Ce)}return this.M(L,ce),ce}M(L,D){const U=L.waitMarkerFileURI;L.context===0&&U&&D.length===1&&D[0]&&(async()=>{await D[0].whenClosedOrLoaded;try{await this.H.del(U)}catch{}})()}async N(L,D,U,H,V,z,B){const X=[];let se;function ce(we,ke){X.push(we),ke&&(se=we,z=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:Ie}=this.fb(L);if(!L.initialStartup&&B.length>0){const we=B[0].remoteAuthority,ke=this.kb(we);ke&&ce(this.P(ke,B.map(_=>_.workspace.uri)))}const Ae=U.length+D.length+H.length;if(z&&Ae===0){const we=z.filesToOpenOrCreate[0]||z.filesToDiff[0]||z.filesToMerge[3],ke=this.getWindows().filter(he=>z&&(0,a.$$f)(he.remoteAuthority,z.remoteAuthority));let _;we?.fileUri&&!Ie&&((L.context===4||L.context===0||L.context===1)&&(_=await(0,re.$w2b)(ke,we.fileUri,async he=>he.configPath.scheme===h.Schemas.file?this.D.resolveLocalWorkspace(he.configPath):void 0)),_||(_=this.lb(ke))),_?(0,ne.$Ah)(_.openedWorkspace)?D.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):(0,ne.$vh)(_.openedWorkspace)?U.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):ce(this.O(L,_,z),!0):ce(await this.gb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile}),!0)}const Ce=(0,A.$of)(D,we=>we.workspace.id);if(Ce.length>0){const we=(0,A.$jf)(Ce.map(ke=>(0,re.$x2b)(this.getWindows(),ke.workspace.configPath)));if(we.length>0){const ke=we[0],_=(0,a.$$f)(z?.remoteAuthority,ke.remoteAuthority)?z:void 0;ce(this.O(L,ke,_),!!_),ge=!0}for(const ke of Ce){if(we.some(de=>de.openedWorkspace&&de.openedWorkspace.id===ke.workspace.id))continue;const _=ke.remoteAuthority,he=(0,a.$$f)(z?.remoteAuthority,_)?z:void 0;ce(await this.R(L,ke,ge,he),!!he),ge=!0}}const Le=(0,A.$of)(U,we=>a.$Wf.getComparisonKey(we.workspace.uri));if(Le.length>0){const we=(0,A.$jf)(Le.map(ke=>(0,re.$x2b)(this.getWindows(),ke.workspace.uri)));if(we.length>0){const ke=we[0],_=(0,a.$$f)(z?.remoteAuthority,ke.remoteAuthority)?z:void 0;ce(this.O(L,ke,_),!!_),ge=!0}for(const ke of Le){if(we.some(de=>(0,ne.$vh)(de.openedWorkspace)&&a.$Wf.isEqual(de.openedWorkspace.uri,ke.workspace.uri)))continue;const _=ke.remoteAuthority,he=(0,a.$$f)(z?.remoteAuthority,_)?z:void 0;ce(await this.R(L,ke,ge,he),!!he),ge=!0}}const ye=(0,A.$of)(H,we=>we.backupFolder);if(ye.length>0)for(const we of ye){const ke=we.remoteAuthority,_=(0,a.$$f)(z?.remoteAuthority,ke)?z:void 0;ce(await this.Q(L,!0,ke,_,we),!!_),ge=!0}if(X.length===0||z){z&&!V&&V++;const we=z?z.remoteAuthority:L.remoteAuthority;for(let ke=0;ke<V;ke++)ce(await this.Q(L,ge,we,z),!!z),ge=!0}return{windows:(0,A.$of)(X),filesOpenedInWindow:se}}O(L,D,U){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:U}),D.focus();const H={filesToOpenOrCreate:U?.filesToOpenOrCreate,filesToDiff:U?.filesToDiff,filesToMerge:U?.filesToMerge,filesToWait:U?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return D.sendWhenReady("vscode:openFiles",P.CancellationToken.None,H),D}P(L,D){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:D}),L.focus();const U={foldersToAdd:D};return L.sendWhenReady("vscode:addFolders",P.CancellationToken.None,U),L}Q(L,D,U,H,V){this.m.trace("windowsManager#doOpenEmpty",{restore:!!V,remoteAuthority:U,filesToOpen:H,forceNewWindow:D});let z;return!D&&typeof L.contextWindowId=="number"&&(z=this.getWindowById(L.contextWindowId)),this.gb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:U,forceNewWindow:D,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:H,windowToUse:z,emptyWindowBackupInfo:V,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}R(L,D,U,H,V){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:D,filesToOpen:H}),!U&&!V&&typeof L.contextWindowId=="number"&&(V=this.getWindowById(L.contextWindowId)),this.gb({workspace:D.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:D.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:H,windowToUse:V,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}async S(L){let D,U=!1,H=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(D=await this.U(L),U=!0):L.forceEmpty?D=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(D=await this.W(L.cli),D.length===0&&D.push(Object.create(null)),U=!0):(D=await this.Y(),D.length===0&&D.push(Object.create(null)),H=!0),!L.addMode&&U){const V=D.filter(z=>Q(z));if(V.length>1){const z=V[0].remoteAuthority;if(V.every(B=>(0,a.$$f)(B.remoteAuthority,z))){const B=await this.D.createUntitledWorkspace(V.map(X=>({uri:X.workspace.uri})));D.push({workspace:B,remoteAuthority:z}),D=D.filter(X=>!Q(X))}}}if(L.initialStartup&&!H&&this.z.getValue("window")?.restoreWindows==="preserve"){const V=await this.Y();D.unshift(...V.filter(z=>J(z)||Q(z)||z.backupPath))}return D}async U(L){const D={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},U=await Promise.all((0,A.$jf)(L.urisToOpen||[]).map(async H=>{const V=await this.$(H,D);if(V)return V.label=H.label,V;const z=this.bb(H);this.G.showMessageBox({type:"info",buttons:[(0,w.localize)(0,null)],message:z.scheme===h.Schemas.file?(0,w.localize)(1,null):(0,w.localize)(2,null),detail:z.scheme===h.Schemas.file?(0,w.localize)(3,null,(0,d.$Nz)(z,{os:o.OS,tildify:this.t})):(0,w.localize)(4,null,z.toString(!0))},(0,v.$ye)(E.BrowserWindow.getFocusedWindow()))}));return(0,A.$jf)(U)}async W(L){const D=[],U={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},H=L["folder-uri"];if(H){const B=await Promise.all(H.map(X=>{const se=this.X(X);if(se)return this.$({folderUri:se},U)}));D.push(...(0,A.$jf)(B))}const V=L["file-uri"];if(V){const B=await Promise.all(V.map(X=>{const se=this.X(X);if(se)return this.$((0,ne.$Qh)(X)?{workspaceUri:se}:{fileUri:se},U)}));D.push(...(0,A.$jf)(B))}const z=await Promise.all(L._.map(B=>U.remoteAuthority?this.eb(B,U):this.cb(B,U)));return D.push(...(0,A.$jf)(z)),D}X(L){try{const D=k.URI.parse(L);if(!D.scheme){this.m.error(`Invalid URI input string, scheme missing: ${L}`);return}return D.path?D:D.with({path:"/"})}catch(D){this.m.error(`Invalid URI input string: ${L}, ${D.message}`)}}async Y(){const L=this.Z();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const D=[];L!=="one"&&D.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&D.push(this.j.state.lastActiveWindow);const U=await Promise.all(D.map(async H=>{if(H.workspace){const V=await this.$({workspaceUri:H.workspace.configPath},{remoteAuthority:H.remoteAuthority,rejectTransientWorkspaces:!0});if(J(V))return V}else if(H.folderUri){const V=await this.$({folderUri:H.folderUri},{remoteAuthority:H.remoteAuthority});if(Q(V))return V}else if(L!=="folders"&&H.backupPath)return{backupPath:H.backupPath,remoteAuthority:H.remoteAuthority}}));return(0,A.$jf)(U)}}}Z(){let L;return this.v.wasRestarted?L="all":(L=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async $(L,D=Object.create(null)){const U=this.bb(L);return U.scheme===h.Schemas.file?((0,F.$dD)(L)&&(D={...D,forceOpenWorkspaceAsFile:!0}),this.cb(U.fsPath,D)):this.ab(L,D)}ab(L,D){let U=this.bb(L);const H=(0,M.$xk)(U)||D.remoteAuthority;if(U=(0,a.$ag)((0,a.$7f)(U)),(0,F.$dD)(L)){if(D.gotoLineMode){const{path:V,line:z,column:B}=(0,l.$Oe)(U.path);return{fileUri:U.with({path:V}),options:{selection:z?{startLineNumber:z,startColumn:B||1}:void 0},remoteAuthority:H}}return{fileUri:U,remoteAuthority:H}}else if((0,F.$bD)(L))return{workspace:(0,ue.$n2b)(U),remoteAuthority:H};return{workspace:(0,ue.$o2b)(U),remoteAuthority:H}}bb(L){return(0,F.$bD)(L)?L.workspaceUri:(0,F.$cD)(L)?L.folderUri:L.fileUri}async cb(L,D,U){let H,V;D.gotoLineMode&&({path:L,line:H,column:V}=(0,l.$Oe)(L)),L=(0,l.$Je)((0,y.$9b)(L),(0,g.cwd)());try{const z=await C.Promises.stat(L);if(z.isFile()){if(!D.forceOpenWorkspaceAsFile){const B=await this.D.resolveLocalWorkspace(k.URI.file(L));if(B)return B.transient&&D.rejectTransientWorkspaces?void 0:{workspace:{id:B.id,configPath:B.configPath},type:n.FileType.File,exists:!0,remoteAuthority:B.remoteAuthority,transient:B.transient}}return{fileUri:k.URI.file(L),type:n.FileType.File,exists:!0,options:{selection:H?{startLineNumber:H,startColumn:V||1}:void 0}}}else{if(z.isDirectory())return{workspace:(0,ue.$o2b)(k.URI.file(L),z),type:n.FileType.Directory,exists:!0};if(!o.$i&&L==="/dev/null")return{fileUri:k.URI.file(L),type:n.FileType.File,exists:!0}}}catch(z){if(z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!U)return this.db(L,D);const B=k.URI.file(L);if(this.C.removeRecentlyOpened([B]),D.ignoreFileNotFound)return{fileUri:B,type:n.FileType.File,exists:!1}}}async db(L,D){const U=k.URI.file(L),{response:H,checkboxChecked:V}=await this.G.showMessageBox({type:"warning",buttons:[(0,w.localize)(5,null),(0,w.localize)(6,null),(0,w.localize)(7,null)],message:(0,w.localize)(8,null,U.authority),detail:(0,w.localize)(9,null,(0,d.$Nz)(U,{os:o.OS,tildify:this.t})),checkboxLabel:(0,w.localize)(10,null,U.authority),cancelId:1});if(H===0)return(0,r.addUNCHostToAllowlist)(U.authority),V&&this.B(f.Event.once(this.onDidOpenWindow)(z=>{z.sendWhenReady("vscode:configureAllowedUNCHost",P.CancellationToken.None,U.authority)})),this.cb(L,D,!0);if(H===2)return E.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.db(L,D)}eb(L,D){const U=L.charCodeAt(0),H=D.remoteAuthority;let V,z;D.gotoLineMode&&({path:L,line:V,column:z}=(0,l.$Oe)(L)),U!==47&&((0,l.$Ie)(U)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,l.$Be)(L)),L=`/${L}`);const B=k.URI.from({scheme:h.Schemas.vscodeRemote,authority:H,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,ne.$Qh)(L))return D.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:V?{startLineNumber:V,startColumn:z||1}:void 0},remoteAuthority:D.remoteAuthority}:{workspace:(0,ue.$n2b)(B),remoteAuthority:H};if(D.gotoLineMode||y.$8b.basename(L).indexOf(".")!==-1)return{fileUri:B,options:{selection:V?{startLineNumber:V,startColumn:z||1}:void 0},remoteAuthority:H}}return{workspace:(0,ue.$o2b)(B),remoteAuthority:H}}fb(L){const D=this.z.getValue("window"),U=D?.openFoldersInNewWindow||"default",H=D?.openFilesInNewWindow||"off";let V=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(U==="on"||U==="off")&&(V=U==="on");let z=!1;return L.forceNewWindow||L.forceReuseWindow?z=!!L.forceNewWindow&&!L.forceReuseWindow:(o.$j?L.context===1&&(z=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!L.cli.extensionDevelopmentPath&&(H==="on"||H==="off")&&(z=H==="on")),{openFolderInNewWindow:!!V,openFilesInNewWindow:z}}async openExtensionDevelopmentHostWindow(L,D){const U=(0,re.$y2b)(this.getWindows(),L);if(U)return this.v.reload(U,D.cli),U.focus(),[U];let H=D.cli["folder-uri"]||[],V=D.cli["file-uri"]||[],z=D.cli._;if(!z.length&&!H.length&&!V.length&&!D.cli.extensionTestsPath){const se=this.j.state.lastPluginDevelopmentHostWindow,ce=se?.workspace??se?.folderUri;ce&&(k.URI.isUri(ce)?ce.scheme===h.Schemas.file?z=[ce.fsPath]:H=[ce.toString()]:ce.configPath.scheme===h.Schemas.file?z=[(0,a.$Tf)(ce.configPath)]:V=[ce.configPath.toString()])}let B=D.remoteAuthority;for(const se of L)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=k.URI.parse(se),ge=(0,M.$xk)(ce);ge&&(B?(0,a.$$f)(ge,B)||this.m.error("more than one extension development path authority"):B=ge)}z=z.filter(se=>{const ce=k.URI.file(se);return(0,re.$x2b)(this.getWindows(),ce)?!1:(0,a.$$f)((0,M.$xk)(ce),B)}),H=H.filter(se=>{const ce=this.X(se);return ce&&(0,re.$x2b)(this.getWindows(),ce)?!1:ce?(0,a.$$f)((0,M.$xk)(ce),B):!1}),V=V.filter(se=>{const ce=this.X(se);return ce&&(0,re.$x2b)(this.getWindows(),ce)?!1:ce?(0,a.$$f)((0,M.$xk)(ce),B):!1}),D.cli._=z,D.cli["folder-uri"]=H,D.cli["file-uri"]=V;const X={context:D.context,cli:D.cli,forceNewWindow:!0,forceEmpty:!z.length&&!H.length&&!V.length,userEnv:D.userEnv,noRecentEntry:!0,waitMarkerFileURI:D.waitMarkerFileURI,remoteAuthority:B,forceProfile:D.forceProfile,forceTempProfile:D.forceTempProfile};return this.open(X)}async gb(L){const D=this.z.getValue("window"),U=this.getLastActiveWindow(),H=U?.profile??this.u.defaultProfile;let V;!L.forceNewWindow&&!L.forceNewTabbedWindow&&(V=L.windowToUse||U,V&&V.focus());const z={...this.t.args,...L.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,y.$$b)(this.t.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.u.profilesHome,all:this.u.profiles,profile:H},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.l,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsHome.fsPath,product:I.default,isInitialStartup:L.initialStartup,perfMarks:(0,b.getMarks)(),os:{release:(0,O.release)(),hostname:(0,O.hostname)()},zoomLevel:typeof D?.zoomLevel=="number"?D.zoomLevel:void 0,autoDetectHighContrast:D?.autoDetectHighContrast??!0,autoDetectColorScheme:D?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if(V){const B=V.config;!z.extensionDevelopmentPath&&B?.extensionDevelopmentPath&&(z.extensionDevelopmentPath=B.extensionDevelopmentPath,z.extensionDevelopmentKind=B.extensionDevelopmentKind,z["enable-proposed-api"]=B["enable-proposed-api"],z.verbose=B.verbose,z["inspect-extensions"]=B["inspect-extensions"],z["inspect-brk-extensions"]=B["inspect-brk-extensions"],z.debugId=B.debugId,z.extensionEnvironment=B.extensionEnvironment,z["extensions-dir"]=B["extensions-dir"],z["disable-extensions"]=B["disable-extensions"]),z.loggers={global:z.loggers.global,window:B?.loggers.window??z.loggers.window}}else{const B=this.j.getNewWindowState(z);(0,b.mark)("code/willCreateCodeWindow");const X=V=this.F.createInstance(q.$F3b,{state:B,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});(0,b.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(X),at.a.push(X),this.b.fire(X),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.$bb)(X.onDidSignalReady)(()=>this.c.fire(X)),(0,m.$bb)(X.onDidClose)(()=>this.jb(X)),(0,m.$bb)(X.onDidDestroy)(()=>this.f.fire(X)),X.onDidTriggerSystemContextMenu(({x:ce,y:ge})=>this.h.fire({window:X,x:ce,y:ge}));const se=(0,v.$re)(X.win?.webContents);se.removeAllListeners("devtools-reload-page"),se.on("devtools-reload-page",()=>this.v.reload(X)),this.v.registerWindow(X)}return z.windowId=V.id,V.isReady?this.v.unload(V,4).then(async B=>{B||await this.hb(V,z,L,H)}):await this.hb(V,z,L,H),V}async hb(L,D,U,H){if(D.extensionDevelopmentPath||((0,ne.$Ah)(D.workspace)?D.backupPath=this.w.registerWorkspaceBackup({workspace:D.workspace,remoteAuthority:D.remoteAuthority}):(0,ne.$vh)(D.workspace)?D.backupPath=this.w.registerFolderBackup({folderUri:D.workspace.uri,remoteAuthority:D.remoteAuthority}):D.backupPath=this.w.registerEmptyWindowBackup({backupFolder:U.emptyWindowBackupInfo?.backupFolder??(0,ue.$p2b)().id,remoteAuthority:D.remoteAuthority})),this.u.isEnabled()){const V=D.workspace??(0,ne.$zh)(D.backupPath,!1),z=this.ib(U,V,H),B=z instanceof Promise?await z:z;D.profiles.profile=B,D.extensionDevelopmentPath||await this.u.setProfileForWorkspace(V,B)}L.load(D)}ib(L,D,U){return L.forceProfile?this.u.profiles.find(H=>H.name===L.forceProfile)??this.u.createNamedProfile(L.forceProfile):L.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(D)??U}jb(L){const D=at.a.indexOf(L);at.a.splice(D,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=E.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(L){return this.lb(this.getWindows().filter(D=>(0,a.$$f)(D.remoteAuthority,L)))}lb(L){const D=Math.max.apply(Math,L.map(U=>U.lastFocusTime));return L.find(U=>U.lastFocusTime===D)}sendToFocused(L,...D){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,P.CancellationToken.None,...D)}sendToAll(L,D,U){for(const H of this.getWindows())U&&U.indexOf(H.id)>=0||H.sendWhenReady(L,P.CancellationToken.None,D)}getWindows(){return at.a}getWindowCount(){return at.a.length}getWindowById(L){const D=this.getWindows().filter(U=>U.id===L);return(0,A.$sf)(D)}getWindowByWebContents(L){const D=E.BrowserWindow.fromWebContents(L);if(D)return this.getWindowById(D.id)}};ae.a=[],e.$J3b=ae=pe([x(2,R.$Ni),x(3,T.$k3b),x(4,j.$oM),x(5,N.$Rm),x(6,i.$k2b),x(7,W.$u2b),x(8,$.$B2b),x(9,t.$j2b),x(10,u.$Rh),x(11,le.$f3b),x(12,K.$z2b),x(13,c.$kh),x(14,s.$s2b),x(15,n.$Oj),x(16,S.$Y2b),x(17,Y.$S2b)],ae)}),define(ee[304],te([0,1,64,29,82,54]),function(G,e,E,C,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L3b=void 0;let A=e.$L3b=class{constructor(f,l,m,d){this.a=f,this.b=l,this.c=m,this.d=d,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,l){const m=this.b.getWindowById(f);if(m)return this.a.enterWorkspace(m,this.b.getWindows(),l)}createUntitledWorkspace(f,l,m){return this.a.createUntitledWorkspace(l,m)}deleteUntitledWorkspace(f,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(f,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(f,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$L3b=A=pe([x(0,O.$z2b),x(1,C.$e2b),x(2,r.$f3b),x(3,E.$j2b)],A)}),define(ee[305],te([0,1,14,131,38,27,17,50,13,32,49,45,46,2,15,9,3,11,7,31,145,43,157,109,272,160,64,285,18,75,198,90,132,59,114,218,28,63,94,207,233,208,292,116,209,210,16,222,93,74,6,92,216,297,286,274,20,5,302,67,23,58,293,95,34,277,99,121,26,249,251,52,48,264,289,298,290,299,126,266,267,268,270,275,29,303,276,30,97,82,304,54,273,39,231,53,243,51,81,128,279,291,282,8,253,278,226,66,91,295,269,24,124,294,261,238,83]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a,v,k,w,t,u,s,i,n,c,$,R,I,S,M,j,F,q,re,ie,ne,ue,le,K,Y,N,W,T,J,Q,ae,oe,L,D,U,H,V,z,B,X,se,ce,ge,Ie,Ae,Ce,Le,ye,we,ke,_,he,de,Se,Re,je,Ue,He,Be,ze,qe,Te,Z,fe,$e,me,ve,Oe,Fe,Ke,xe,Je,Qe,tt,ot,ct,Ct,gt,Ot,Mt,Lt,jt,Ut,Nt,Ft,$t,Wt,Tt,zt,Bt,qt,mt,Ht,Et,bt,Vt,Gt,wt,Jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$33b=void 0;let Pt=e.$33b=class extends h.$kb{constructor(Pe,Ee,be,Me,De,We,Xe,Ze,Ne,Ve,Ge,Ye){super(),this.c=Pe,this.f=Ee,this.g=be,this.h=Me,this.i=De,this.j=We,this.k=Xe,this.l=Ze,this.m=Ne,this.n=Ve,this.p=Ge,this.s=Ye,this.t(),this.u()}t(){const Pe=Ne=>Ne?.startsWith(`${y.Schemas.vscodeWebview}://`),Ee=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Ne,Ve,Ge,Ye)=>Pe(Ye.requestingUrl)?Ge(Ee.has(Ve)):Ge(!1)),E.session.defaultSession.setPermissionCheckHandler((Ne,Ve,Ge,Ye)=>Pe(Ye.requestingUrl)?Ee.has(Ve):!1);const be=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),Me=Ne=>{for(let Ve=Ne;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},De=Ne=>Ne.resourceType==="xhr"||Me(Ne.frame),We=Ne=>{const Ve=Ne.frame;if(!Ve||!this.a)return!1;const Ge=E.BrowserWindow.getAllWindows();for(const Ye of Ge)if(Ve.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Xe=(Ne,Ve)=>{if(Ne.path!=="/index.html")return!0;const Ge=Ve.frame;if(!Ge||!this.a)return!1;for(const Ye of this.a.getWindows())if(Ye.win&&Ge.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Ne,Ve)=>{const Ge=a.URI.parse(Ne.url);return Ge.scheme===y.Schemas.vscodeWebview&&!Xe(Ge,Ne)?(this.h.error("Blocked vscode-webview request",Ne.url),Ve({cancel:!0})):Ge.scheme===y.Schemas.vscodeFileResource&&!We(Ne)?(this.h.error("Blocked vscode-file request",Ne.url),Ve({cancel:!0})):Ge.path.endsWith(".svg")&&!be.has(Ge.scheme)?Ve({cancel:!De(Ne)}):Ve({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Ne,Ve)=>{const Ge=Ne.responseHeaders,Ye=Ge["content-type"]||Ge["Content-Type"];if(Ye&&Array.isArray(Ye)){const _e=a.URI.parse(Ne.url);if(_e.path.endsWith(".svg")&&be.has(_e.scheme))return Ge["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Ge});if(!_e.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ye.some(st=>st.toLowerCase().includes("image/svg")))return Ve({cancel:!De(Ne)})}return Ve({cancel:!1})});const Ze=E.session.defaultSession;typeof Ze.setCodeCachePath=="function"&&this.j.codeCachePath&&Ze.setCodeCachePath((0,b.$$b)(this.j.codeCachePath,"chrome")),o.$i&&(this.l.getValue("security.restrictUNCAccess")===!1?(0,C.disableUNCAccessRestrictions)():(0,C.addUNCHostToAllowlist)(this.l.getValue("security.allowedUNCHosts")))}u(){(0,f.setUnexpectedErrorHandler)(be=>this.w(be)),process.on("uncaughtException",be=>(0,f.$X)(be)),process.on("unhandledRejection",be=>(0,f.$X)(be)),this.k.onWillShutdown(()=>this.dispose()),(0,k.$TR)(),E.app.on("accessibility-support-changed",(be,Me)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Me)}),E.app.on("activate",async(be,Me)=>{this.h.trace("app#activate"),Me||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(be,Me)=>{Me.on("will-navigate",De=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),Me.setWindowOpenHandler(({url:De})=>(this.b?.openExternal(void 0,De),{action:"deny"}))});let Pe=[],Ee;E.app.on("open-file",(be,Me)=>{this.h.trace("app#open-file: ",Me),be.preventDefault(),Pe.push((0,Ke.$Qh)(Me)?{workspaceUri:a.URI.file(Me)}:{fileUri:a.URI.file(Me)}),Ee!==void 0&&(clearTimeout(Ee),Ee=void 0),Ee=setTimeout(async()=>{await this.a?.open({context:1,cli:this.j.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ee=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),r.$SR.handle("vscode:fetchShellEnv",be=>{const Me=this.a?.getWindowByWebContents(be.sender);let De,We;return Me?.config?(De=Me.config,We={...process.env,...Me.config.userEnv}):(De=this.j.args,We=process.env),this.O(De,We,!1)}),r.$SR.handle("vscode:writeNlsFile",(be,Me,De)=>{const We=this.v([Me]);if(!We||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.n.writeFile(We,A.$Ib.fromString(De))}),r.$SR.handle("vscode:readNlsFile",async(be,...Me)=>{const De=this.v(Me);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.n.readFile(De)).value.toString()}),r.$SR.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),r.$SR.on("vscode:openDevTools",be=>be.sender.openDevTools()),r.$SR.on("vscode:reloadWindow",be=>be.sender.reload())}v(Pe){let Ee;for(const be of Pe)typeof be=="string"&&(typeof Ee!="string"?Ee=be:Ee=(0,b.$$b)(Ee,be));if(!(typeof Ee!="string"||!(0,b.$0b)(Ee)||!(0,l.$He)(Ee,this.j.cachedLanguagesPath,!o.$k)))return a.URI.file(Ee)}w(Pe){if(Pe){const Ee={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ee))}this.h.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.h.error(Pe.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.j.appRoot}`),this.h.debug("args:",this.j.args);const Pe=this.p.win32AppUserModelId;o.$i&&Pe&&E.app.setAppUserModelId(Pe);try{o.$j&&this.l.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const Ee=new t.$ZR;this.k.onWillShutdown(Ne=>{Ne.reason===2&&Ee.dispose()}),this.h.trace("Resolving machine identifier...");const be=await(0,Wt.$T3b)(this.m,this.h);this.h.trace(`Resolved machine identifier: ${be}`);const{sharedProcessReady:Me,sharedProcessClient:De}=this.H(be),We=await this.I(be,Me);this.B(We.createInstance(s.$f2b)),this.B(We.createInstance(Nt.$Q3b)),We.invokeFunction(Ne=>this.J(Ne,Ee,De));const Xe=We.invokeFunction(Ne=>this.y(Ne,Ee));this.z(Ee),this.k.phase=2,await We.invokeFunction(Ne=>this.L(Ne,Xe)),this.k.phase=3,this.M(),this.B(new $t.$Cg(()=>{this.B((0,$t.$Gg)(()=>this.k.phase=4,2500))},2500)).schedule()}y(Pe,Ee){const be=this.a=Pe.get(ve.$e2b),Me=Pe.get(qe.$Zhb),De=this.b=Pe.get(ce.$W2b),We=this;Me.registerHandler({async handleURL(Ye,_e){return We.G(be,Me,Ye,_e)}});const Xe=this.B(new Fe.$K3b({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Ze=new w.$6g(Ye=>Xe.getActiveClientId().then(_e=>Ye===_e)),Ne=new Te.$A3b(Ze,this.h),Ve=Ee.getChannel("urlHandler",Ne);Me.registerHandler(new Te.$z3b(Ve));const Ge=this.C();return this.B(new fe.$B3b(Ge?.urls,Me,be,this.j,this.p,this.h)),Ge}z(Pe){const Ee=()=>({statusCode:404,data:"Not found"}),be=new Jt.$S(()=>Pe.getChannel(wt.$13b,new wt.$23b));E.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(Me,De)=>{const We=a.URI.parse(Me.url);if(!We.authority.startsWith("window:"))return De(Ee());be.value.call(wt.$Z3b,[We]).then(Xe=>De({...Xe,data:Buffer.from(Xe.body,"base64")}),Xe=>{this.h.warn("error dispatching remote resource call",Xe),De({statusCode:500,data:String(Xe)})})})}C(){const Pe=this.j.args["open-url"]?this.j.args._urls||[]:[];Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Pe);const Ee=global.getOpenUrls()||[];if(Ee.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ee),Pe.length+Ee.length===0)return;const be=[];return{urls:[...Pe,...Ee].map(De=>{try{return{uri:a.URI.parse(De),originalUrl:De}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",De);return}}).filter(De=>{if(!De)return!1;if(this.D(De.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",De.uri.toString(!0)),!1;const We=this.F(De.uri);return We?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",De.uri.toString(!0),We),be.push(We),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",De.uri.toString(!0)),!0)}),openables:be}}D(Pe){if(Pe.authority===y.Schemas.file&&o.$i){const{options:Ee,buttonIndeces:be}=(0,qt.$2z)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,p.$Nz)(Pe,{os:o.OS,tildify:this.j}),this.p.nameShort),detail:(0,i.localize)(3,null)},this.p);if(be[E.dialog.showMessageBoxSync(Ee)]===1)return!0}return!1}F(Pe){if(Pe.path){if(Pe.authority===y.Schemas.file){const Ee=a.URI.file(Pe.fsPath);return(0,Ke.$Qh)(Ee)?{workspaceUri:Ee}:{fileUri:Ee}}else if(Pe.authority===y.Schemas.vscodeRemote){const Ee=Pe.path.indexOf(b.$8b.sep,1);if(Ee!==-1){const be=Pe.path.substring(1,Ee),Me=Pe.path.substring(Ee),De=a.URI.from({scheme:y.Schemas.vscodeRemote,authority:be,path:Me,query:Pe.query,fragment:Pe.fragment});return(0,Ke.$Qh)(Me)?{workspaceUri:De}:/:[\d]+$/.test(Me)?{fileUri:De}:{folderUri:De}}}}}async G(Pe,Ee,be,Me){if(this.h.trace("app#handleProtocolUrl():",be.toString(!0),Me),be.scheme===this.p.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:a.URI.parse(be.query).path,query:""})),this.D(be))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0;let De=!1;const We=new URLSearchParams(be.query);We.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),We.delete("windowId"),be=be.with({query:We.toString()}),De=!0):o.$j&&Pe.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),De=!0);const Xe=We.get("continueOn");Xe!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),We.delete("continueOn"),be=be.with({query:We.toString()}),this.j.continueOn=Xe??void 0);const Ze=this.F(be);return Ze?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Ze,be.toString(!0)),(0,Et.$sf)(await Pe.open({context:5,cli:{...this.j.args},urisToOpen:[Ze],forceNewWindow:De,gotoLineMode:!0}))?.focus(),!0):De?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0)),await(0,Et.$sf)(await Pe.open({context:5,cli:{...this.j.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ie.$xk)(be)}))?.ready(),Ee.open(be,Me)):(this.h.trace("app#handleProtocolUrl(): not handled",be.toString(!0),Me),!1)}H(Pe){const Ee=this.B(this.g.createInstance(Ae.$m3b,Pe)),be=(async()=>{this.h.trace("Main->SharedProcess#connect");const De=await Ee.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new u.$1R(De,"main")})();return{sharedProcessReady:(async()=>(await Ee.whenReady(),be))(),sharedProcessClient:be}}async I(Pe,Ee){const be=new D.$jh;switch(process.platform){case"win32":be.set(Re.$chb,new oe.$ih(ze.$x3b));break;case"linux":o.$l?be.set(Re.$chb,new oe.$ih(Be.$w3b,[process.env.SNAP,process.env.SNAP_REVISION])):be.set(Re.$chb,new oe.$ih(He.$v3b));break;case"darwin":be.set(Re.$chb,new oe.$ih(Ue.$u3b));break}be.set(ve.$e2b,new oe.$ih(Oe.$J3b,[Pe,this.f],!1));const Me=new j.$t2b(this.h,this.p);be.set(j.$s2b,Me),be.set(z.$42b,new oe.$ih(z.$52b,void 0,!1)),be.set(M.$G2b,new oe.$ih(M.$H2b,void 0,!1)),be.set(S.$1l,w.ProxyChannel.toService((0,w.$4g)(Ee.then(Ne=>Ne.getChannel("diagnostics"))))),be.set(U.$ypb,new oe.$ih(H.$Z2b,[this.f])),be.set(F.$xob,new oe.$ih(q.$I2b,[Pe])),be.set(V.$12b,new oe.$ih(V.$22b)),be.set(ce.$W2b,new oe.$ih(ce.$X2b,void 0,!1)),be.set(R.$jn,new oe.$ih(ot.$M3b)),be.set($e.$C3b,new oe.$ih(me.$E3b)),be.set(se.$i3b,new oe.$ih(se.$j3b)),be.set(ue.$1hb,new oe.$ih(le.$J2b)),be.set(K.$K2b,new oe.$ih(Y.$M2b)),be.set(we.$b3b,new oe.$ih(we.$c3b)),be.set(we.$d3b,new oe.$ih(we.$e3b));const De=new Vt.$Y3b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.l.getValue("terminal.integrated.persistentSessionScrollback")??100},this.l,this.j,this.k,this.h),We=new Gt.$7q(De,this.l,this.h,this.i);be.set(bt.$Hq,We),o.$i?be.set(N.$cUb,new oe.$ih(W.$N2b)):o.$j?be.set(N.$cUb,new oe.$ih(W.$O2b)):o.$k&&be.set(N.$cUb,new oe.$ih(W.$P2b));const Xe=new c.$q2b(this.j,this.l,this.h,this.m);be.set(n.$j2b,Xe);const Ze=new tt.$A2b(this.j,this.h,this.s,Xe,Me);if(be.set(tt.$z2b,Ze),be.set(xe.$c_,new oe.$ih(Qe.$L3b,void 0,!1)),be.set(Je.$f3b,new oe.$ih(Je.$g3b,void 0,!1)),be.set(qe.$Zhb,new oe.$ih(Z.$oob,void 0,!1)),(0,Se.$6n)(this.p,this.j)){const Ne=(0,Se.$$n)(this.p,this.l),Ve=(0,w.$4g)(Ee.then(it=>it.getChannel("telemetryAppender"))),Ge=new he.$p3b(Ve),Ye=(0,ke.$Vn)((0,O.release)(),(0,O.hostname)(),process.arch,this.p.commit,this.p.version,Pe,Ne),_e=(0,Se.$_n)(this.j),st={appenders:[Ge],commonProperties:Ye,piiPaths:_e,sendErrorTelemetry:!0};be.set(_.$Rk,new oe.$ih(de.$Bq,[st],!1))}else be.set(_.$Rk,Se.$Zn);return be.set(Lt.$8o,new oe.$ih(Tt.$vM,void 0,!0)),be.set(jt.$_o,new oe.$ih(Ut.$P3b,void 0,!0)),be.set(mt.$W3b,new oe.$ih(mt.$X3b,void 0,!0)),await $t.Promises.settled([Xe.initialize(),Ze.initialize()]),this.g.createChild(be)}J(Pe,Ee,be){const Me=w.ProxyChannel.fromService(Pe.get(z.$42b),{disableMarshalling:!0});this.c.registerChannel("launch",Me);const De=w.ProxyChannel.fromService(Pe.get(M.$G2b),{disableMarshalling:!0});this.c.registerChannel("diagnostics",De);const We=new Ct.$N3b(Pe.get(ct.$Rm));Ee.registerChannel("policy",We),be.then(et=>et.registerChannel("policy",We));const Xe=this.n.getProvider(y.Schemas.file);(0,g.$qe)(Xe instanceof ae.$Np);const Ze=new Q.$Q2b(Xe,this.h,this.j);Ee.registerChannel(T.$eM,Ze),be.then(et=>et.registerChannel(T.$eM,Ze));const Ne=w.ProxyChannel.fromService(Pe.get(gt.$u2b));Ee.registerChannel("userDataProfiles",Ne),be.then(et=>et.registerChannel("userDataProfiles",Ne));const Ve=new Ot.$wq(Pe.get(Mt.$uo));be.then(et=>et.registerChannel("request",Ve));const Ge=new je.$q3b(Pe.get(Re.$chb));Ee.registerChannel("update",Ge);const Ye=w.ProxyChannel.fromService(Pe.get(U.$ypb));Ee.registerChannel("issue",Ye);const _e=w.ProxyChannel.fromService(Pe.get(F.$xob));Ee.registerChannel("encryption",_e);const st=w.ProxyChannel.fromService(Pe.get(R.$jn));Ee.registerChannel("credentials",st);const it=w.ProxyChannel.fromService(Pe.get(Ce.$Fk));Ee.registerChannel("sign",it);const lt=w.ProxyChannel.fromService(Pe.get(V.$12b));Ee.registerChannel("keyboardLayout",lt),this.b=Pe.get(ce.$W2b);const St=w.ProxyChannel.fromService(this.b);Ee.registerChannel("nativeHost",St),be.then(et=>et.registerChannel("nativeHost",St));const Kt=w.ProxyChannel.fromService(Pe.get(xe.$c_));Ee.registerChannel("workspaces",Kt);const Xt=w.ProxyChannel.fromService(Pe.get(se.$i3b));Ee.registerChannel("menubar",Xt);const Yt=w.ProxyChannel.fromService(Pe.get(qe.$Zhb));Ee.registerChannel("url",Yt);const Qt=w.ProxyChannel.fromService(Pe.get(ue.$1hb));Ee.registerChannel("extensionUrlTrust",Qt);const Zt=w.ProxyChannel.fromService(Pe.get($e.$C3b));Ee.registerChannel("webview",Zt);const It=this.B(new ye.$n3b(this.h,Pe.get(we.$b3b)));Ee.registerChannel("storage",It),be.then(et=>et.registerChannel("storage",It));const xt=this.B(new Ft.$R3b(Pe.get(we.$b3b),Pe.get(gt.$u2b),this.h));be.then(et=>et.registerChannel("profileStorageListener",xt));const _t=w.ProxyChannel.fromService(Pe.get(bt.$Hq));Ee.registerChannel(bt.TerminalIpcChannels.LocalPty,_t);const ei=w.ProxyChannel.fromService(Pe.get(N.$cUb));Ee.registerChannel("externalTerminal",ei);const Rt=new zt.$U3b(Pe.get(Bt.$k3b));Ee.registerChannel("logger",Rt),be.then(et=>et.registerChannel("logger",Rt));const ti=new I.$r2b(Pe.get(ve.$e2b));Ee.registerChannel("extensionhostdebugservice",ti);const ii=w.ProxyChannel.fromService(Pe.get(K.$K2b));Ee.registerChannel(K.$L2b,ii);const ni=w.ProxyChannel.fromService(Pe.get(mt.$W3b));Ee.registerChannel(Ht.$V3b,ni)}async L(Pe,Ee){const be=this.a=Pe.get(ve.$e2b),Me=(0,ie.$ol)(process.env)?0:4,De=this.j.args;if(Ee){if(Ee.openables.length>0)return be.open({context:Me,cli:De,urisToOpen:Ee.openables,gotoLineMode:!0,initialStartup:!0});if(Ee.urls.length>0)for(const it of Ee.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),be.open({context:Me,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const We=global.macOpenFiles,Xe=De._.length,Ze=!!De["folder-uri"],Ne=!!De["file-uri"],Ve=De["skip-add-to-recently-opened"]===!0,Ge=De.wait&&De.waitMarkerFilePath?a.URI.file(De.waitMarkerFilePath):void 0,Ye=De.remote||void 0,_e=De.profile,st=De["profile-temp"];if(!Xe&&!Ze&&!Ne){if(De["new-window"]||_e||st)return be.open({context:Me,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:Ge,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:st});if(We.length)return be.open({context:1,cli:De,urisToOpen:We.map(it=>(0,Ke.$Qh)(it)?{workspaceUri:a.URI.file(it)}:{fileUri:a.URI.file(it)}),noRecentEntry:Ve,waitMarkerFileURI:Ge,initialStartup:!0})}return be.open({context:Me,cli:De,forceNewWindow:De["new-window"]||!Xe&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:Ve,waitMarkerFileURI:Ge,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:st})}M(){this.N(),E.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Pe,Ee)=>{Ee({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.O(this.j.args,process.env,!0),this.P(),o.$j&&E.app.runningUnderARM64Translation&&this.a?.sendToFocused("vscode:showTranslatedBuildWarning")}async N(){const Pe=this.p.win32MutexName;if(o.$i&&Pe)try{const Ee=await new Promise((Me,De)=>{G(["@vscode/windows-mutex"],Me,De)}),be=new Ee.Mutex(Pe);(0,m.$bb)(this.k.onWillShutdown)(()=>be.release())}catch(Ee){this.h.error(Ee)}}async O(Pe,Ee,be){try{return await(0,ne.$ul)(this.l,this.h,Pe,Ee)}catch(Me){const De=(0,P.$9h)(Me);be?this.a?.sendToFocused("vscode:showResolveShellEnvError",De):this.h.error(De)}return{}}async P(){try{const Ee=(await this.n.readFile(this.j.argvResource)).value.toString(),be=JSON.parse((0,d.$Bm)(Ee)),De=(0,Se.$8n)(this.l)>=1;if(be["enable-crash-reporter"]===void 0){const We=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.$3e)()}"`,"}"],Xe=Ee.substring(0,Ee.length-2).concat(`,
`,We.join(`
`));await this.n.writeFile(this.j.argvResource,A.$Ib.fromString(Xe))}else{const We=Ee.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);We!==Ee&&await this.n.writeFile(this.j.argvResource,A.$Ib.fromString(We))}}catch(Pe){this.h.error(Pe)}}};e.$33b=Pt=pe([x(2,L.$kh),x(3,X.$Ni),x(4,X.$Oi),x(5,re.$k2b),x(6,B.$B2b),x(7,$.$Rh),x(8,Le.$oM),x(9,J.$Oj),x(10,ge.$6i),x(11,gt.$u2b)],Pt)}),define(ee[311],te([0,1,14,42,7,24,8,50,13,32,49,46,15,9,65,3,36,25,22,43,130,305,10,18,237,248,28,63,200,16,220,93,74,215,92,20,223,5,77,23,78,280,125,262,51,288,95,247,34,52,79,53,39,232,230,2,40,265,66,225,91,120,263]),function(G,e,E,C,r,O,A,P,f,l,m,d,p,h,y,b,o,g,a,v,k,w,t,u,s,i,n,c,$,R,I,S,M,j,F,q,re,ie,ne,ue,le,K,Y,N,W,T,J,Q,ae,oe,L,D,U,H,V,z,B,X,se,ce,ge,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ae{main(){try{this.a()}catch(ye){console.error(ye.message),E.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(je=>console.error(je));const[ye,we,ke,_,he,de,Se,Re]=this.b();try{try{await this.d(ke,Re,_,he,Se)}catch(je){throw this.f(ke,Se,je),je}await ye.invokeFunction(async je=>{const Ue=je.get(ie.$Ni),He=je.get(q.$B2b),Be=je.get(R.$Oj),ze=je.get(ie.$Oi),qe=await this.e(Ue,ke,He,ye,Se,!0);return a.Promises.writeFile(ke.mainLockfile,String(process.pid)).catch(Te=>{Ue.warn(`app#startup(): Error writing main lockfile: ${Te.stack}`)}),de.logger=ze.createLogger("main",{name:(0,t.localize)(0,null)}),(0,m.$bb)(He.onWillShutdown)(Te=>{Be.dispose(),_.dispose(),Te.join("instanceLockfile",a.Promises.unlink(ke.mainLockfile).catch(()=>{}))}),ye.createInstance(w.$33b,qe,we).startup()})}catch(je){ye.invokeFunction(this.i,je)}}b(){const ye=new F.$jh,we=new z.$jb;process.once("exit",()=>we.dispose());const ke={_serviceBrand:void 0,...ne.default};ye.set(ue.$6i,ke);const _=new n.$l2b(this.j(),ke),he=this.c(_);ye.set(n.$k2b,_);const de=new se.$l3b((0,ie.$2i)(_),_.logsHome);ye.set(se.$k3b,de);const Se=new re.$2Yb(de.getLogLevel()),Re=we.add(new ce.$wM(Se,[new ie.$Ui(de.getLogLevel())]));ye.set(ie.$Ni,Re);const je=new I.$op(Re);ye.set(R.$Oj,je);const Ue=new S.$Np(Re);je.registerProvider(p.Schemas.file,Ue);const He=new X.$$q(je);ye.set(B.$lk,He);const Be=new Ie.$rM(1,_,Re,je);ye.set(ae.$nM,Be),ye.set(ae.$oM,Be);const ze=new D.$v2b(Be,He,_,je,Re);ye.set(D.$u2b,ze);const qe=b.$i&&ke.win32RegValueName?we.add(new H.$$3b(Re,ke.win32RegValueName)):_.policyFile?we.add(new V.$_3b(_.policyFile,je,Re)):new U.$Tm;ye.set(U.$Rm,qe);const Te=new s.$hn(ze.defaultProfile.settingsResource,je,qe,Re);return ye.set(u.$Rh,Te),ye.set(q.$B2b,new M.$ih(q.$C2b,void 0,!1)),ye.set(W.$uo,new M.$ih(T.$93b,void 0,!0)),ye.set(L.$S2b,new M.$ih(L.$T2b)),ye.set(J.$Fk,new M.$ih(Q.$03b,void 0,!1)),ye.set(Y.$uz,new M.$ih(N.$73b)),ye.set(le.$Y2b,new K.$53b(_,ze,Re)),[new j.$Qp(ye,!0),he,_,Te,Be,Se,ke,ze]}c(ye){const we={VSCODE_IPC_HOOK:ye.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ke=>{const _=process.env[ke];typeof _=="string"&&(we[ke]=_)}),Object.assign(process.env,we),we}async d(ye,we,ke,_,he){await A.Promises.settled([Promise.all([ye.extensionsPath,ye.codeCachePath,ye.logsHome.fsPath,we.defaultProfile.globalStorageHome.fsPath,ye.workspaceStorageHome.fsPath,ye.localHistoryHome.fsPath,ye.backupHome].map(de=>de?a.Promises.mkdir(de,{recursive:!0}):void 0)),_.init(),ke.initialize()]),we.init()}async e(ye,we,ke,_,he,de){let Se;try{(0,y.mark)("code/willStartMainServer"),Se=await(0,k.$gh)(we.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,m.$bb)(ke.onWillShutdown)(()=>Se.dispose())}catch(Re){if(Re.code!=="EADDRINUSE")throw this.f(we,he,Re),Re;let je;try{je=await(0,k.$hh)(we.mainIPCHandle,"main")}catch(ze){if(!de||b.$i||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.g((0,t.localize)(1,null,he.nameShort),(0,t.localize)(2,null),he),ze;try{(0,C.unlinkSync)(we.mainIPCHandle)}catch(qe){throw ye.warn("Could not delete obsolete instance handle",qe),qe}return this.e(ye,we,ke,_,he,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ze=`Running extension tests from the command line is currently only supported if no other instance of ${he.nameShort} is running.`;throw ye.error(ze),je.dispose(),new Error(ze)}let Ue;!we.args.wait&&!we.args.status&&(Ue=setTimeout(()=>{this.g((0,t.localize)(3,null,he.nameShort),(0,t.localize)(4,null),he)},1e4));const He=v.ProxyChannel.toService(je.getChannel("launch"),{disableMarshalling:!0}),Be=v.ProxyChannel.toService(je.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return _.invokeFunction(async()=>{const ze=new i.$fr(oe.$Zn,he),qe=await Be.getMainDiagnostics(),Te=await Be.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Z=await ze.getDiagnostics(qe,Te);throw console.log(Z),new f.$$});throw b.$i&&await this.h(He,ye),ye.trace("Sending env to running instance..."),await He.start(we.args,process.env),je.dispose(),Ue&&clearTimeout(Ue),new f.$$("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,t.localize)(5,null,he.nameShort)),new f.$$("Terminating...");return process.env.VSCODE_PID=String(process.pid),Se}f(ye,we,ke){if(ke.code==="EACCES"||ke.code==="EPERM"){const _=(0,O.$jf)([ye.userDataPath,ye.extensionsPath,k.$ch]).map(he=>(0,d.$Nz)(r.URI.file(he),{os:b.OS,tildify:ye}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,P.$9h)(ke),_.join(`
`)),we)}}g(ye,we,ke){E.dialog.showMessageBoxSync((0,ge.$2z)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ye,detail:we},ke).options)}async h(ye,we){if(b.$i){const ke=await ye.getMainProcessId();we.trace("Sending some foreground love to the running instance:",ke);try{(await new Promise((_,he)=>{G(["windows-foreground-love"],_,he)})).allowSetForegroundWindow(ke)}catch(_){we.error(_)}}}i(ye,we){const ke=ye.get(ie.$Ni),_=ye.get(q.$B2b);let he=0;we&&(we.isExpected?we.message&&ke.trace(we.message):(he=1,we.stack?ke.error(we.stack):ke.error(`Startup error: ${we.toString()}`))),_.kill(he)}j(){const ye=this.k((0,c.$ll)(process.argv));if(ye.wait&&!ye.waitMarkerFilePath){const we=(0,$.$43b)(ye.verbose);we&&((0,c.$nl)(process.argv,"--waitMarkerFilePath",we),ye.waitMarkerFilePath=we)}return ye}k(ye){if(ye["open-url"]&&(ye._urls=ye._,ye._=[]),!ye.remote){const we=this.l(ye._,ye.goto);ye._=we}return ye}l(ye,we){const ke=(0,o.cwd)(),_=ye.map(Se=>{let Re=String(Se),je;we&&(je=(0,l.$Oe)(Re),Re=je.path),Re&&(Re=this.m(ke,Re));const Ue=(0,l.$Je)(Re,ke),He=(0,h.$cc)(Ue);return He&&!(0,l.$Fe)(He)?null:we&&je?(je.path=Ue,this.n(je)):Ue}),he=b.$i||b.$j,de=(0,O.$of)(_,Se=>Se&&he?Se.toLowerCase():Se||"");return(0,O.$jf)(de)}m(ye,we){return b.$i&&(we=(0,g.$qd)(we,'"')),we=(0,g.$od)((0,g.$od)(we," "),"	"),b.$i&&(we=(0,h.$_b)(ye,we),we=(0,g.$qd)(we,".")),we}n(ye){const we=[ye.path];return typeof ye.line=="number"&&we.push(String(ye.line)),typeof ye.column=="number"&&we.push(String(ye.column)),we.join(":")}}new Ae().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/660393deaaa6d1996740ff4880f1bad43768c814/core/vs/code/electron-main/main.js.map
