/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/strings","vs/base/common/uuid","vs/base/common/objects","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/hash","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],se=function(G){for(var e=[],N=0,D=G.length;N<D;N++)e[N]=ne[G[N]];return e};define(ne[51],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.$Qg=e.$Pg=void 0;function N(L){return(E,u,l)=>{let P=null,S=null;if(typeof l.value=="function"?(P="value",S=l.value):typeof l.get=="function"&&(P="get",S=l.get),!S)throw new Error("not supported");l[P]=L(S,u)}}function D(L,E,u){let l=null,P=null;if(typeof u.value=="function"?(l="value",P=u.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(l="get",P=u.get),!P)throw new Error("not supported");const S=`$memoize$${E}`;u[l]=function(...p){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,p)}),this[S]}}e.$Pg=D;function O(L,E,u){return N((l,P)=>{const S=`$debounce$${P}`,p=`$debounce$result$${P}`;return function(...m){this[p]||(this[p]=u?u():void 0),clearTimeout(this[S]),E&&(this[p]=E(this[p],...m),m=[this[p]]),this[S]=setTimeout(()=>{l.apply(this,m),this[p]=u?u():void 0},L)}})}e.$Qg=O;function A(L,E,u){return N((l,P)=>{const S=`$throttle$timer$${P}`,p=`$throttle$result$${P}`,m=`$throttle$lastRun$${P}`,j=`$throttle$pending$${P}`;return function(...v){if(this[p]||(this[p]=u?u():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),E&&(this[p]=E(this[p],...v)),this[j])return;const d=this[m]+L;d<=Date.now()?(this[m]=Date.now(),l.apply(this,[this[p]]),this[p]=u?u():void 0):(this[j]=!0,this[S]=setTimeout(()=>{this[j]=!1,this[m]=Date.now(),l.apply(this,[this[p]]),this[p]=u?u():void 0},d-Date.now()))}})}e.$Rg=A}),define(ne[70],se([0,1,9]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oc=e.$nc=e.$mc=e.$lc=e.ok=void 0;function D(u,l){if(!u)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=D;function O(u,l="Unreachable"){throw new Error(l)}e.$lc=O;function A(u){if(!u)throw new N.$ab("Assertion Failed")}e.$mc=A;function L(u){if(!u()){debugger;u(),(0,N.$X)(new N.$ab("Assertion Failed"))}}e.$nc=L;function E(u,l){let P=0;for(;P<u.length-1;){const S=u[P],p=u[P+1];if(!l(S,p))return!1;P++}return!0}e.$oc=E}),define(ne[52],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var N;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(N||(e.ScanError=N={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var O;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(O||(e.ParseErrorCode=O={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function L(t,o=!1){let n=0;const i=t.length;let s="",a=0,c=16,I=0;function w(x){let ce=0,le=0;for(;ce<x;){const oe=t.charCodeAt(n);if(oe>=48&&oe<=57)le=le*16+oe-48;else if(oe>=65&&oe<=70)le=le*16+oe-65+10;else if(oe>=97&&oe<=102)le=le*16+oe-97+10;else break;n++,ce++}return ce<x&&(le=-1),le}function $(x){n=x,s="",a=0,c=16,I=0}function M(){const x=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&l(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&l(t.charCodeAt(n)))for(n++;n<t.length&&l(t.charCodeAt(n));)n++;else return I=3,t.substring(x,n);let ce=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&l(t.charCodeAt(n))){for(n++;n<t.length&&l(t.charCodeAt(n));)n++;ce=n}else I=3;return t.substring(x,ce)}function Q(){let x="",ce=n;for(;;){if(n>=i){x+=t.substring(ce,n),I=2;break}const le=t.charCodeAt(n);if(le===34){x+=t.substring(ce,n),n++;break}if(le===92){if(x+=t.substring(ce,n),n++,n>=i){I=2;break}switch(t.charCodeAt(n++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const V=w(4);V>=0?x+=String.fromCharCode(V):I=4;break}default:I=5}ce=n;continue}if(le>=0&&le<=31)if(u(le)){x+=t.substring(ce,n),I=2;break}else I=6;n++}return x}function J(){if(s="",I=0,a=n,n>=i)return a=i,c=17;let x=t.charCodeAt(n);if(E(x)){do n++,s+=String.fromCharCode(x),x=t.charCodeAt(n);while(E(x));return c=15}if(u(x))return n++,s+=String.fromCharCode(x),x===13&&t.charCodeAt(n)===10&&(n++,s+=`
`),c=14;switch(x){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,s=Q(),c=10;case 47:{const ce=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<i&&!u(t.charCodeAt(n));)n++;return s=t.substring(ce,n),c=12}if(t.charCodeAt(n+1)===42){n+=2;const le=i-1;let oe=!1;for(;n<le;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,oe=!0;break}n++}return oe||(n++,I=1),s=t.substring(ce,n),c=13}return s+=String.fromCharCode(x),n++,c=16}case 45:if(s+=String.fromCharCode(x),n++,n===i||!l(t.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=M(),c=11;default:for(;n<i&&ie(x);)n++,x=t.charCodeAt(n);if(a!==n){switch(s=t.substring(a,n),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(x),n++,c=16}}function ie(x){if(E(x)||u(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let x;do x=J();while(x>=12&&x<=15);return x}return{setPosition:$,getPosition:()=>n,scan:o?ue:J,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>I}}e.$rm=L;function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function S(t,o){const n=[],i=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function I(w,$,M,Q){a.value=w,a.offset=$,a.length=M,a.type=Q,a.colonOffset=void 0,s=a}try{b(t,{onObjectBegin:(w,$)=>{if(o<=w)throw i;s=void 0,c=o>w,n.push("")},onObjectProperty:(w,$,M)=>{if(o<$||(I(w,$,M,"property"),n[n.length-1]=w,o<=$+M))throw i},onObjectEnd:(w,$)=>{if(o<=w)throw i;s=void 0,n.pop()},onArrayBegin:(w,$)=>{if(o<=w)throw i;s=void 0,n.push(0)},onArrayEnd:(w,$)=>{if(o<=w)throw i;s=void 0,n.pop()},onLiteralValue:(w,$,M)=>{if(o<$||(I(w,$,M,y(w)),o<=$+M))throw i},onSeparator:(w,$,M)=>{if(o<=$)throw i;if(w===":"&&s&&s.type==="property")s.colonOffset=$,c=!1,s=void 0;else if(w===","){const Q=n[n.length-1];typeof Q=="number"?n[n.length-1]=Q+1:(c=!0,n[n.length-1]=""),s=void 0}}})}catch(w){if(w!==i)throw w}return{path:n,previousNode:s,isAtPropertyKey:c,matches:w=>{let $=0;for(let M=0;$<w.length&&M<n.length;M++)if(w[$]===n[M]||w[$]==="*")$++;else if(w[$]!=="**")return!1;return $===w.length}}}e.$sm=S;function p(t,o=[],n=A.DEFAULT){let i=null,s=[];const a=[];function c(w){Array.isArray(s)?s.push(w):i!==null&&(s[i]=w)}return b(t,{onObjectBegin:()=>{const w={};c(w),a.push(s),s=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const w=[];c(w),a.push(s),s=w,i=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:c,onError:(w,$,M)=>{o.push({error:w,offset:$,length:M})}},n),s[0]}e.$tm=p;function m(t,o=[],n=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function a(w){return i.children.push(w),w}b(t,{onObjectBegin:w=>{i=a({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,$,M)=>{i=a({type:"property",offset:$,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:$,length:M,parent:i})},onObjectEnd:(w,$)=>{i.length=w+$-i.offset,i=i.parent,s(w+$)},onArrayBegin:(w,$)=>{i=a({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,$)=>{i.length=w+$-i.offset,i=i.parent,s(w+$)},onLiteralValue:(w,$,M)=>{a({type:y(w),offset:$,length:M,parent:i,value:w}),s($+M)},onSeparator:(w,$,M)=>{i.type==="property"&&(w===":"?i.colonOffset=$:w===","&&s($))},onError:(w,$,M)=>{o.push({error:w,offset:$,length:M})}},n);const I=i.children[0];return I&&delete I.parent,I}e.$um=m;function j(t,o){if(!t)return;let n=t;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===i){n=a.children[1],s=!0;break}if(!s)return}else{const s=i;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.$vm=j;function v(t){if(!t.parent||!t.parent.children)return[];const o=v(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}e.$wm=v;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const o=Object.create(null);for(const n of t.children){const i=n.children[1];i&&(o[n.children[0].value]=d(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$xm=d;function f(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}e.$ym=f;function h(t,o,n=!1){if(f(t,o,n)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=o;s++){const a=h(i[s],o,n);if(a)return a}return t}}e.$zm=h;function b(t,o,n=A.DEFAULT){const i=L(t,!1);function s(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(Y){return Y?z=>Y(z,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=s(o.onObjectBegin),I=a(o.onObjectProperty),w=s(o.onObjectEnd),$=s(o.onArrayBegin),M=s(o.onArrayEnd),Q=a(o.onLiteralValue),J=a(o.onSeparator),ie=s(o.onComment),ue=a(o.onError),x=n&&n.disallowComments,ce=n&&n.allowTrailingComma;function le(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:x||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(Y){case 12:case 13:x?oe(10):ie();break;case 16:oe(1);break;case 15:case 14:break;default:return Y}}}function oe(Y,z=[],C=[]){if(ue(Y),z.length+C.length>0){let R=i.getToken();for(;R!==17;){if(z.indexOf(R)!==-1){le();break}else if(C.indexOf(R)!==-1)break;R=le()}}}function V(Y){const z=i.getTokenValue();return Y?Q(z):I(z),le(),!0}function H(){switch(i.getToken()){case 11:{let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(oe(2),Y=0)}catch{oe(2)}Q(Y);break}case 7:Q(null);break;case 8:Q(!0);break;case 9:Q(!1);break;default:return!1}return le(),!0}function F(){return i.getToken()!==10?(oe(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(J(":"),le(),X()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function U(){c(),le();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||oe(4,[],[]),J(","),le(),i.getToken()===2&&ce)break}else Y&&oe(6,[],[]);F()||oe(4,[],[2,5]),Y=!0}return w(),i.getToken()!==2?oe(7,[2],[]):le(),!0}function W(){$(),le();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||oe(4,[],[]),J(","),le(),i.getToken()===4&&ce)break}else Y&&oe(6,[],[]);X()||oe(4,[],[4,5]),Y=!0}return M(),i.getToken()!==4?oe(8,[4],[]):le(),!0}function X(){switch(i.getToken()){case 3:return W();case 1:return U();case 10:return V(!0);default:return H()}}return le(),i.getToken()===17?n.allowEmptyContent?!0:(oe(4,[],[]),!1):X()?(i.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.$Am=b;function g(t,o){const n=L(t),i=[];let s,a=0,c;do switch(c=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:a!==c&&i.push(t.substring(a,c)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),a=n.getPosition();break}while(s!==17);return i.join("")}e.$Bm=g;function y(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Cm=y}),define(ne[71],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.$rl=e.rot=e.$pl=void 0;function N(E,u,l){return Math.min(Math.max(E,u),l)}e.$pl=N;function D(E,u){return(u+E%u)%u}e.rot=D;class O{constructor(){this.a=0}getNext(){return this.a++}}e.$rl=O;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$sl=A;class L{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const l=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$tl=L}),function(){function G(O){const A=[];typeof O=="number"&&A.push("code/timeOrigin",O);function L(u){A.push(u,Date.now())}function E(){const u=[];for(let l=0;l<A.length;l+=2)u.push({name:A[l],startTime:A[l+1]});return u}return{mark:L,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const L of performance.getEntriesByType("mark"))A.push({name:L.name,startTime:Math.round(O+L.startTime)});return A}};if(typeof process=="object"){const O=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function N(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=N(D))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var N=e();for(var D in N)(typeof exports=="object"?exports:G)[D]=N[D]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function N(D){if(e[D])return e[D].exports;var O=e[D]={i:D,l:!1,exports:{}};return G[D].call(O.exports,O,O.exports,N),O.l=!0,O.exports}return N.m=G,N.c=e,N.d=function(D,O,A){N.o(D,O)||Object.defineProperty(D,O,{enumerable:!0,get:A})},N.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},N.t=function(D,O){if(1&O&&(D=N(D)),8&O||4&O&&typeof D=="object"&&D&&D.__esModule)return D;var A=Object.create(null);if(N.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:D}),2&O&&typeof D!="string")for(var L in D)N.d(A,L,function(E){return D[E]}.bind(null,L));return A},N.n=function(D){var O=D&&D.__esModule?function(){return D.default}:function(){return D};return N.d(O,"a",O),O},N.o=function(D,O){return Object.prototype.hasOwnProperty.call(D,O)},N.p="",N(N.s=0)}([function(G,e,N){(function(D){var O;e=G.exports=C,O=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],u=e.src=[],l=0,P=l++;u[P]="0|[1-9]\\d*";var S=l++;u[S]="[0-9]+";var p=l++;u[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=l++;u[m]="("+u[P]+")\\.("+u[P]+")\\.("+u[P]+")";var j=l++;u[j]="("+u[S]+")\\.("+u[S]+")\\.("+u[S]+")";var v=l++;u[v]="(?:"+u[P]+"|"+u[p]+")";var d=l++;u[d]="(?:"+u[S]+"|"+u[p]+")";var f=l++;u[f]="(?:-("+u[v]+"(?:\\."+u[v]+")*))";var h=l++;u[h]="(?:-?("+u[d]+"(?:\\."+u[d]+")*))";var b=l++;u[b]="[0-9A-Za-z-]+";var g=l++;u[g]="(?:\\+("+u[b]+"(?:\\."+u[b]+")*))";var y=l++,t="v?"+u[m]+u[f]+"?"+u[g]+"?";u[y]="^"+t+"$";var o="[v=\\s]*"+u[j]+u[h]+"?"+u[g]+"?",n=l++;u[n]="^"+o+"$";var i=l++;u[i]="((?:<|>)?=?)";var s=l++;u[s]=u[S]+"|x|X|\\*";var a=l++;u[a]=u[P]+"|x|X|\\*";var c=l++;u[c]="[v=\\s]*("+u[a]+")(?:\\.("+u[a]+")(?:\\.("+u[a]+")(?:"+u[f]+")?"+u[g]+"?)?)?";var I=l++;u[I]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[h]+")?"+u[g]+"?)?)?";var w=l++;u[w]="^"+u[i]+"\\s*"+u[c]+"$";var $=l++;u[$]="^"+u[i]+"\\s*"+u[I]+"$";var M=l++;u[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Q=l++;u[Q]="(?:~>?)";var J=l++;u[J]="(\\s*)"+u[Q]+"\\s+",E[J]=new RegExp(u[J],"g");var ie=l++;u[ie]="^"+u[Q]+u[c]+"$";var ue=l++;u[ue]="^"+u[Q]+u[I]+"$";var x=l++;u[x]="(?:\\^)";var ce=l++;u[ce]="(\\s*)"+u[x]+"\\s+",E[ce]=new RegExp(u[ce],"g");var le=l++;u[le]="^"+u[x]+u[c]+"$";var oe=l++;u[oe]="^"+u[x]+u[I]+"$";var V=l++;u[V]="^"+u[i]+"\\s*("+o+")$|^$";var H=l++;u[H]="^"+u[i]+"\\s*("+t+")$|^$";var F=l++;u[F]="(\\s*)"+u[i]+"\\s*("+o+"|"+u[c]+")",E[F]=new RegExp(u[F],"g");var U=l++;u[U]="^\\s*("+u[c]+")\\s+-\\s+("+u[c]+")\\s*$";var W=l++;u[W]="^\\s*("+u[I]+")\\s+-\\s+("+u[I]+")\\s*$";var X=l++;u[X]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)O(Y,u[Y]),E[Y]||(E[Y]=new RegExp(u[Y]));function z(q,K){if(q instanceof C)return q;if(typeof q!="string"||q.length>A||!(K?E[n]:E[y]).test(q))return null;try{return new C(q,K)}catch{return null}}function C(q,K){if(q instanceof C){if(q.loose===K)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof C))return new C(q,K);O("SemVer",q,K),this.loose=K;var ee=q.trim().match(K?E[n]:E[y]);if(!ee)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var we=+ge;if(we>=0&&we<L)return we}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=z,e.valid=function(q,K){var ee=z(q,K);return ee?ee.version:null},e.clean=function(q,K){var ee=z(q.trim().replace(/^[=v]+/,""),K);return ee?ee.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(q){return O("SemVer.compare",this.version,this.loose,q),q instanceof C||(q=new C(q,this.loose)),this.compareMain(q)||this.comparePre(q)},C.prototype.compareMain=function(q){return q instanceof C||(q=new C(q,this.loose)),r(this.major,q.major)||r(this.minor,q.minor)||r(this.patch,q.patch)},C.prototype.comparePre=function(q){if(q instanceof C||(q=new C(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var K=0;do{var ee=this.prerelease[K],ge=q.prerelease[K];if(O("prerelease compare",K,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return r(ee,ge)}while(++K)},C.prototype.inc=function(q,K){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,K,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new C(q,ee).inc(K,ge).version}catch{return null}},e.diff=function(q,K){if(Z(q,K))return null;var ee=z(q),ge=z(K);if(ee.prerelease.length||ge.prerelease.length){for(var we in ee)if((we==="major"||we==="minor"||we==="patch")&&ee[we]!==ge[we])return"pre"+we;return"prerelease"}for(var we in ee)if((we==="major"||we==="minor"||we==="patch")&&ee[we]!==ge[we])return we},e.compareIdentifiers=r;var R=/^[0-9]+$/;function r(q,K){var ee=R.test(q),ge=R.test(K);return ee&&ge&&(q=+q,K=+K),ee&&!ge?-1:ge&&!ee?1:q<K?-1:q>K?1:0}function k(q,K,ee){return new C(q,ee).compare(new C(K,ee))}function T(q,K,ee){return k(q,K,ee)>0}function B(q,K,ee){return k(q,K,ee)<0}function Z(q,K,ee){return k(q,K,ee)===0}function _(q,K,ee){return k(q,K,ee)!==0}function re(q,K,ee){return k(q,K,ee)>=0}function de(q,K,ee){return k(q,K,ee)<=0}function $e(q,K,ee,ge){var we;switch(K){case"===":typeof q=="object"&&(q=q.version),typeof ee=="object"&&(ee=ee.version),we=q===ee;break;case"!==":typeof q=="object"&&(q=q.version),typeof ee=="object"&&(ee=ee.version),we=q!==ee;break;case"":case"=":case"==":we=Z(q,ee,ge);break;case"!=":we=_(q,ee,ge);break;case">":we=T(q,ee,ge);break;case">=":we=re(q,ee,ge);break;case"<":we=B(q,ee,ge);break;case"<=":we=de(q,ee,ge);break;default:throw new TypeError("Invalid operator: "+K)}return we}function he(q,K){if(q instanceof he){if(q.loose===K)return q;q=q.value}if(!(this instanceof he))return new he(q,K);O("comparator",q,K),this.loose=K,this.parse(q),this.semver===me?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(q,K){return r(K,q)},e.major=function(q,K){return new C(q,K).major},e.minor=function(q,K){return new C(q,K).minor},e.patch=function(q,K){return new C(q,K).patch},e.compare=k,e.compareLoose=function(q,K){return k(q,K,!0)},e.rcompare=function(q,K,ee){return k(K,q,ee)},e.sort=function(q,K){return q.sort(function(ee,ge){return e.compare(ee,ge,K)})},e.rsort=function(q,K){return q.sort(function(ee,ge){return e.rcompare(ee,ge,K)})},e.gt=T,e.lt=B,e.eq=Z,e.neq=_,e.gte=re,e.lte=de,e.cmp=$e,e.Comparator=he;var me={};function ae(q,K){if(q instanceof ae)return q.loose===K?q:new ae(q.raw,K);if(q instanceof he)return new ae(q.value,K);if(!(this instanceof ae))return new ae(q,K);if(this.loose=K,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function fe(q){return!q||q.toLowerCase()==="x"||q==="*"}function be(q,K,ee,ge,we,Re,Ee,De,Ie,je,ze,ke,Ne){return((K=fe(ee)?"":fe(ge)?">="+ee+".0.0":fe(we)?">="+ee+"."+ge+".0":">="+K)+" "+(De=fe(Ie)?"":fe(je)?"<"+(+Ie+1)+".0.0":fe(ze)?"<"+Ie+"."+(+je+1)+".0":ke?"<="+Ie+"."+je+"."+ze+"-"+ke:"<="+De)).trim()}function Se(q,K){for(var ee=0;ee<q.length;ee++)if(!q[ee].test(K))return!1;if(K.prerelease.length){for(ee=0;ee<q.length;ee++)if(O(q[ee].semver),q[ee].semver!==me&&q[ee].semver.prerelease.length>0){var ge=q[ee].semver;if(ge.major===K.major&&ge.minor===K.minor&&ge.patch===K.patch)return!0}return!1}return!0}function Le(q,K,ee){try{K=new ae(K,ee)}catch{return!1}return K.test(q)}function Ue(q,K,ee,ge){var we,Re,Ee,De,Ie;switch(q=new C(q,ge),K=new ae(K,ge),ee){case">":we=T,Re=de,Ee=B,De=">",Ie=">=";break;case"<":we=B,Re=re,Ee=T,De="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(q,K,ge))return!1;for(var je=0;je<K.set.length;++je){var ze=K.set[je],ke=null,Ne=null;if(ze.forEach(function(Me){Me.semver===me&&(Me=new he(">=0.0.0")),ke=ke||Me,Ne=Ne||Me,we(Me.semver,ke.semver,ge)?ke=Me:Ee(Me.semver,Ne.semver,ge)&&(Ne=Me)}),ke.operator===De||ke.operator===Ie||(!Ne.operator||Ne.operator===De)&&Re(q,Ne.semver)||Ne.operator===Ie&&Ee(q,Ne.semver))return!1}return!0}he.prototype.parse=function(q){var K=this.loose?E[V]:E[H],ee=q.match(K);if(!ee)throw new TypeError("Invalid comparator: "+q);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new C(ee[2],this.loose):this.semver=me},he.prototype.toString=function(){return this.value},he.prototype.test=function(q){return O("Comparator.test",q,this.loose),this.semver===me||(typeof q=="string"&&(q=new C(q,this.loose)),$e(q,this.operator,this.semver,this.loose))},he.prototype.intersects=function(q,K){if(!(q instanceof he))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new ae(q.value,K),Le(this.value,ee,K);if(q.operator==="")return ee=new ae(this.value,K),Le(q.semver,ee,K);var ge=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Re=this.semver.version===q.semver.version,Ee=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),De=$e(this.semver,"<",q.semver,K)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Ie=$e(this.semver,">",q.semver,K)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return ge||we||Re&&Ee||De||Ie},e.Range=ae,ae.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},ae.prototype.toString=function(){return this.range},ae.prototype.parseRange=function(q){var K=this.loose;q=q.trim(),O("range",q,K);var ee=K?E[W]:E[U];q=q.replace(ee,be),O("hyphen replace",q),q=q.replace(E[F],"$1$2$3"),O("comparator trim",q,E[F]),q=(q=(q=q.replace(E[J],"$1~")).replace(E[ce],"$1^")).split(/\s+/).join(" ");var ge=K?E[V]:E[H],we=q.split(" ").map(function(Re){return function(Ee,De){return O("comp",Ee),Ee=function(Ie,je){return Ie.trim().split(/\s+/).map(function(ze){return function(ke,Ne){O("caret",ke,Ne);var Me=Ne?E[oe]:E[le];return ke.replace(Me,function(Te,ye,ve,Pe,Oe){var Ae;return O("caret",ke,Te,ye,ve,Pe,Oe),fe(ye)?Ae="":fe(ve)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":fe(Pe)?Ae=ye==="0"?">="+ye+"."+ve+".0 <"+ye+"."+(+ve+1)+".0":">="+ye+"."+ve+".0 <"+(+ye+1)+".0.0":Oe?(O("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ae=ye==="0"?ve==="0"?">="+ye+"."+ve+"."+Pe+Oe+" <"+ye+"."+ve+"."+(+Pe+1):">="+ye+"."+ve+"."+Pe+Oe+" <"+ye+"."+(+ve+1)+".0":">="+ye+"."+ve+"."+Pe+Oe+" <"+(+ye+1)+".0.0"):(O("no pr"),Ae=ye==="0"?ve==="0"?">="+ye+"."+ve+"."+Pe+" <"+ye+"."+ve+"."+(+Pe+1):">="+ye+"."+ve+"."+Pe+" <"+ye+"."+(+ve+1)+".0":">="+ye+"."+ve+"."+Pe+" <"+(+ye+1)+".0.0"),O("caret return",Ae),Ae})}(ze,je)}).join(" ")}(Ee,De),O("caret",Ee),Ee=function(Ie,je){return Ie.trim().split(/\s+/).map(function(ze){return function(ke,Ne){var Me=Ne?E[ue]:E[ie];return ke.replace(Me,function(Te,ye,ve,Pe,Oe){var Ae;return O("tilde",ke,Te,ye,ve,Pe,Oe),fe(ye)?Ae="":fe(ve)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":fe(Pe)?Ae=">="+ye+"."+ve+".0 <"+ye+"."+(+ve+1)+".0":Oe?(O("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ae=">="+ye+"."+ve+"."+Pe+Oe+" <"+ye+"."+(+ve+1)+".0"):Ae=">="+ye+"."+ve+"."+Pe+" <"+ye+"."+(+ve+1)+".0",O("tilde return",Ae),Ae})}(ze,je)}).join(" ")}(Ee,De),O("tildes",Ee),Ee=function(Ie,je){return O("replaceXRanges",Ie,je),Ie.split(/\s+/).map(function(ze){return function(ke,Ne){ke=ke.trim();var Me=Ne?E[$]:E[w];return ke.replace(Me,function(Te,ye,ve,Pe,Oe,Ae){O("xRange",ke,Te,ye,ve,Pe,Oe,Ae);var We=fe(ve),Fe=We||fe(Pe),Be=Fe||fe(Oe);return ye==="="&&Be&&(ye=""),We?Te=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Be?(Fe&&(Pe=0),Be&&(Oe=0),ye===">"?(ye=">=",Fe?(ve=+ve+1,Pe=0,Oe=0):Be&&(Pe=+Pe+1,Oe=0)):ye==="<="&&(ye="<",Fe?ve=+ve+1:Pe=+Pe+1),Te=ye+ve+"."+Pe+"."+Oe):Fe?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Be&&(Te=">="+ve+"."+Pe+".0 <"+ve+"."+(+Pe+1)+".0"),O("xRange return",Te),Te})}(ze,je)}).join(" ")}(Ee,De),O("xrange",Ee),Ee=function(Ie,je){return O("replaceStars",Ie,je),Ie.trim().replace(E[X],"")}(Ee,De),O("stars",Ee),Ee}(Re,K)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Re){return!!Re.match(ge)})),we=we.map(function(Re){return new he(Re,K)})},ae.prototype.intersects=function(q,K){if(!(q instanceof ae))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return q.set.some(function(we){return we.every(function(Re){return ge.intersects(Re,K)})})})})},e.toComparators=function(q,K){return new ae(q,K).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},ae.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new C(q,this.loose));for(var K=0;K<this.set.length;K++)if(Se(this.set[K],q))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(q,K,ee){var ge=null,we=null;try{var Re=new ae(K,ee)}catch{return null}return q.forEach(function(Ee){Re.test(Ee)&&(ge&&we.compare(Ee)!==-1||(we=new C(ge=Ee,ee)))}),ge},e.minSatisfying=function(q,K,ee){var ge=null,we=null;try{var Re=new ae(K,ee)}catch{return null}return q.forEach(function(Ee){Re.test(Ee)&&(ge&&we.compare(Ee)!==1||(we=new C(ge=Ee,ee)))}),ge},e.validRange=function(q,K){try{return new ae(q,K).range||"*"}catch{return null}},e.ltr=function(q,K,ee){return Ue(q,K,"<",ee)},e.gtr=function(q,K,ee){return Ue(q,K,">",ee)},e.outside=Ue,e.prerelease=function(q,K){var ee=z(q,K);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(q,K,ee){return q=new ae(q,ee),K=new ae(K,ee),q.intersects(K)},e.coerce=function(q){if(q instanceof C)return q;if(typeof q!="string")return null;var K=q.match(E[M]);return K==null?null:z((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,N(1))},function(G,e){var N,D,O=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function E(d){if(N===setTimeout)return setTimeout(d,0);if((N===A||!N)&&setTimeout)return N=setTimeout,setTimeout(d,0);try{return N(d,0)}catch{try{return N.call(null,d,0)}catch{return N.call(this,d,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:A}catch{N=A}try{D=typeof clearTimeout=="function"?clearTimeout:L}catch{D=L}})();var u,l=[],P=!1,S=-1;function p(){P&&u&&(P=!1,u.length?l=u.concat(l):S=-1,l.length&&m())}function m(){if(!P){var d=E(p);P=!0;for(var f=l.length;f;){for(u=l,l=[];++S<f;)u&&u[S].run();S=-1,f=l.length}u=null,P=!1,function(h){if(D===clearTimeout)return clearTimeout(h);if((D===L||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(h);try{D(h)}catch{try{return D.call(null,h)}catch{return D.call(this,h)}}}(d)}}function j(d,f){this.fun=d,this.array=f}function v(){}O.nextTick=function(d){var f=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)f[h-1]=arguments[h];l.push(new j(d,f)),l.length!==1||P||E(m)},j.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=v,O.addListener=v,O.once=v,O.off=v,O.removeListener=v,O.removeAllListeners=v,O.emit=v,O.prependListener=v,O.prependOnceListener=v,O.listeners=function(d){return[]},O.binding=function(d){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function(d){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(ne[72],se([0,1]),function(G,e){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class D{constructor(E,u,l){this.level=E,this.key=u,this.value=l,this.forward=[]}}const O=void 0;class A{constructor(E,u=2**16){this.comparator=E,this[N]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,O,O)}get size(){return this.f}clear(){this.e=new D(this.c,O,O)}has(E){return!!A.g(this,E,this.comparator)}get(E){return A.g(this,E,this.comparator)?.value}set(E,u){return A.h(this,E,u,this.comparator)&&(this.f+=1),this}delete(E){const u=A.k(this,E,this.comparator);return u&&(this.f-=1),u}forEach(E,u){let l=this.e.forward[0];for(;l;)E.call(u,l.value,l.key,this),l=l.forward[0]}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",u=this.e.forward[0];for(;u;)E+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return E}static g(E,u,l){let P=E.e;for(let S=E.d-1;S>=0;S--)for(;P.forward[S]&&l(P.forward[S].key,u)<0;)P=P.forward[S];if(P=P.forward[0],P&&l(P.key,u)===0)return P}static h(E,u,l,P){const S=[];let p=E.e;for(let m=E.d-1;m>=0;m--){for(;p.forward[m]&&P(p.forward[m].key,u)<0;)p=p.forward[m];S[m]=p}if(p=p.forward[0],p&&P(p.key,u)===0)return p.value=l,!1;{const m=A.j(E);if(m>E.d){for(let j=E.d;j<m;j++)S[j]=E.e;E.d=m}p=new D(m,u,l);for(let j=0;j<m;j++)p.forward[j]=S[j].forward[j],S[j].forward[j]=p;return!0}}static j(E,u=.5){let l=1;for(;Math.random()<u&&l<E.c;)l+=1;return l}static k(E,u,l){const P=[];let S=E.e;for(let p=E.d-1;p>=0;p--){for(;S.forward[p]&&l(S.forward[p].key,u)<0;)S=S.forward[p];P[p]=S}if(S=S.forward[0],!S||l(S.key,u)!==0)return!1;for(let p=0;p<E.d&&P[p].forward[p]===S;p++)P[p].forward[p]=S.forward[p];for(;E.d>0&&E.e.forward[E.d-1]===O;)E.d-=1;return!0}}e.$0q=A}),define(ne[44],se([0,1,9,2]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=void 0;function O(g){const y=g;return y?typeof y.read=="function":!1}e.$tb=O;function A(g){const y=g;return y?[y.on,y.pause,y.resume,y.destroy].every(t=>typeof t=="function"):!1}e.$ub=A;function L(g){const y=g;return y?A(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.$vb=L;function E(g,y){return new u(g,y)}e.$wb=E;class u{constructor(y,t){this.e=y,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(y){if(!this.a.destroyed){if(this.a.flowing)this.g(y);else if(this.b.data.push(y),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(y){this.a.destroyed||(this.a.flowing?this.h(y):this.b.error.push(y))}end(y){this.a.destroyed||(typeof y<"u"&&this.write(y),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(y){this.c.data.slice(0).forEach(t=>t(y))}h(y){this.c.error.length===0?(0,N.$X)(y):this.c.error.slice(0).forEach(t=>t(y))}i(){this.c.end.slice(0).forEach(y=>y())}on(y,t){if(!this.a.destroyed)switch(y){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(y,t){if(this.a.destroyed)return;let o;switch(y){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(t);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const y=this.e(this.b.data);this.g(y),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const y of this.b.error)this.h(y);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(g,y){const t=[];let o;for(;(o=g.read())!==null;)t.push(o);return y(t)}e.$xb=l;function P(g,y,t){const o=[];let n;for(;(n=g.read())!==null&&o.length<t;)o.push(n);return n===null&&o.length>0?y(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return g.read()}}}e.$yb=P;function S(g,y){return new Promise((t,o)=>{const n=[];p(g,{onData:i=>{y&&n.push(i)},onError:i=>{y?o(i):t(void 0)},onEnd:()=>{t(y?y(n):void 0)}})})}e.$zb=S;function p(g,y){let t=!1;return g.on("error",o=>{t||y.onError(o)}),g.on("end",()=>{t||y.onEnd()}),g.on("data",o=>{t||y.onData(o)}),(0,D.$ib)(()=>t=!0)}e.$Ab=p;function m(g,y){return new Promise((t,o)=>{const n=new D.$jb,i=[],s=I=>{if(i.push(I),i.length>y)return n.dispose(),g.pause(),t({stream:g,buffer:i,ended:!1})},a=I=>o(I),c=()=>t({stream:g,buffer:i,ended:!0});n.add((0,D.$ib)(()=>g.removeListener("error",a))),g.on("error",a),n.add((0,D.$ib)(()=>g.removeListener("end",c))),g.on("end",c),n.add((0,D.$ib)(()=>g.removeListener("data",s))),g.on("data",s)})}e.$Bb=m;function j(g,y){const t=E(y);return t.end(g),t}e.$Cb=j;function v(){const g=E(()=>{throw new Error("not supported")});return g.end(),g}e.$Db=v;function d(g){let y=!1;return{read:()=>y?null:(y=!0,g)}}e.$Eb=d;function f(g,y,t){const o=E(t);return p(g,{onData:n=>o.write(y.data(n)),onError:n=>o.error(y.error?y.error(n):n),onEnd:()=>o.end()}),o}e.$Fb=f;function h(g,y,t){let o=!1;return{read:()=>{const n=y.read();return o?n:(o=!0,n!==null?t([g,n]):g)}}}e.$Gb=h;function b(g,y,t){let o=!1;const n=E(t);return p(y,{onData:i=>o?n.write(i):(o=!0,n.write(t([g,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(g)),n.end()}}),n}e.$Hb=b}),define(ne[14],se([0,1,161,44]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=void 0;const O=typeof Buffer<"u",A=new N.$S(()=>new Uint8Array(256));let L,E;class u{static alloc($){return O?new u(Buffer.allocUnsafe($)):new u(new Uint8Array($))}static wrap($){return O&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new u($)}static fromString($,M){return!(M?.dontUseNodeBuffer||!1)&&O?new u(Buffer.from($)):(L||(L=new TextEncoder),new u(L.encode($)))}static fromByteArray($){const M=u.alloc($.length);for(let Q=0,J=$.length;Q<J;Q++)M.buffer[Q]=$[Q];return M}static concat($,M){if(typeof M>"u"){M=0;for(let ie=0,ue=$.length;ie<ue;ie++)M+=$[ie].byteLength}const Q=u.alloc(M);let J=0;for(let ie=0,ue=$.length;ie<ue;ie++){const x=$[ie];Q.set(x,J),J+=x.byteLength}return Q}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=u.alloc(this.byteLength);return $.set(this),$}toString(){return O?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice($,M){return new u(this.buffer.subarray($,M))}set($,M){if($ instanceof u)this.buffer.set($.buffer,M);else if($ instanceof Uint8Array)this.buffer.set($,M);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),M);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return S(this.buffer,$)}writeUInt32BE($,M){p(this.buffer,$,M)}readUInt32LE($){return m(this.buffer,$)}writeUInt32LE($,M){j(this.buffer,$,M)}readUInt8($){return v(this.buffer,$)}writeUInt8($,M){d(this.buffer,$,M)}indexOf($){const M=$ instanceof u?$.buffer:$,Q=M.byteLength,J=this.buffer,ie=J.byteLength;if(Q===0)return 0;if(Q===1)return J.indexOf(M[0]);if(Q>ie)return-1;const ue=A.value;ue.fill(M.length);for(let oe=0;oe<M.length;oe++)ue[M[oe]]=M.length-oe-1;let x=M.length-1,ce=x,le=-1;for(;x<ie;)if(J[x]===M[ce]){if(ce===0){le=x;break}x--,ce--}else x+=Math.max(M.length-ce,ue[J[x]]),ce=M.length-1;return le}}e.$Ib=u;function l(w,$){return w[$+0]<<0>>>0|w[$+1]<<8>>>0}e.$Jb=l;function P(w,$,M){w[M+0]=$&255,$=$>>>8,w[M+1]=$&255}e.$Kb=P;function S(w,$){return w[$]*2**24+w[$+1]*2**16+w[$+2]*2**8+w[$+3]}e.$Lb=S;function p(w,$,M){w[M+3]=$,$=$>>>8,w[M+2]=$,$=$>>>8,w[M+1]=$,$=$>>>8,w[M]=$}e.$Mb=p;function m(w,$){return w[$+0]<<0>>>0|w[$+1]<<8>>>0|w[$+2]<<16>>>0|w[$+3]<<24>>>0}e.$Nb=m;function j(w,$,M){w[M+0]=$&255,$=$>>>8,w[M+1]=$&255,$=$>>>8,w[M+2]=$&255,$=$>>>8,w[M+3]=$&255}e.$Ob=j;function v(w,$){return w[$]}e.$Pb=v;function d(w,$,M){w[M]=$}e.$Qb=d;function f(w){return D.$xb(w,$=>u.concat($))}e.$Rb=f;function h(w){return D.$Eb(w)}e.$Sb=h;function b(w){return D.$zb(w,$=>u.concat($))}e.$Tb=b;async function g(w){return w.ended?u.concat(w.buffer):u.concat([...w.buffer,await b(w.stream)])}e.$Ub=g;function y(w){return D.$Cb(w,$=>u.concat($))}e.$Vb=y;function t(w){return D.$Fb(w,{data:$=>typeof $=="string"?u.fromString($):u.wrap($)},$=>u.concat($))}e.$Wb=t;function o(w){return D.$wb($=>u.concat($),w)}e.$Xb=o;function n(w,$){return D.$Gb(w,$,M=>u.concat(M))}e.$Yb=n;function i(w,$){return D.$Hb(w,$,M=>u.concat(M))}e.$Zb=i;function s(w){let $=0,M=0,Q=0;const J=new Uint8Array(Math.floor(w.length/4*3)),ie=x=>{switch(M){case 3:J[Q++]=$|x,M=0;break;case 2:J[Q++]=$|x>>>2,$=x<<6,M=3;break;case 1:J[Q++]=$|x>>>4,$=x<<4,M=2;break;default:$=x<<2,M=1}};for(let x=0;x<w.length;x++){const ce=w.charCodeAt(x);if(ce>=65&&ce<=90)ie(ce-65);else if(ce>=97&&ce<=122)ie(ce-97+26);else if(ce>=48&&ce<=57)ie(ce-48+52);else if(ce===43||ce===45)ie(62);else if(ce===47||ce===95)ie(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${w[x]}`)}}const ue=Q;for(;M>0;)ie(0);return u.wrap(J).slice(0,ue)}e.$1b=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:w},$=!0,M=!1){const Q=M?c:a;let J="";const ie=w.byteLength%3;let ue=0;for(;ue<w.byteLength-ie;ue+=3){const x=w[ue+0],ce=w[ue+1],le=w[ue+2];J+=Q[x>>>2],J+=Q[(x<<4|ce>>>4)&63],J+=Q[(ce<<2|le>>>6)&63],J+=Q[le&63]}if(ie===1){const x=w[ue+0];J+=Q[x>>>2],J+=Q[x<<4&63],$&&(J+="==")}else if(ie===2){const x=w[ue+0],ce=w[ue+1];J+=Q[x>>>2],J+=Q[(x<<4|ce>>>4)&63],J+=Q[ce<<2&63],$&&(J+="=")}return J}e.$2b=I}),define(ne[45],se([0,1,28]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=void 0;function D(f){return O(f,0)}e.$_h=D;function O(f,h){switch(typeof f){case"object":return f===null?A(349,h):Array.isArray(f)?u(f,h):l(f,h);case"string":return E(f,h);case"boolean":return L(f,h);case"number":return A(f,h);case"undefined":return A(937,h);default:return A(617,h)}}e.$ai=O;function A(f,h){return(h<<5)-h+f|0}e.$bi=A;function L(f,h){return A(f?433:863,h)}function E(f,h){h=A(149417,h);for(let b=0,g=f.length;b<g;b++)h=A(f.charCodeAt(b),h);return h}e.$ci=E;function u(f,h){return h=A(104579,h),f.reduce((b,g)=>O(g,b),h)}function l(f,h){return h=A(181387,h),Object.keys(f).sort().reduce((b,g)=>(b=E(g,b),O(f[g],b)),h)}class P{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=O(h,this.g),this.g}}e.$di=P;var S;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function p(f,h,b=32){const g=b-h,y=~((1<<g)-1);return(f<<h|(y&f)>>>g)>>>0}function m(f,h=0,b=f.byteLength,g=0){for(let y=0;y<b;y++)f[h+y]=g}function j(f,h,b="0"){for(;f.length<h;)f=b+f;return f}function v(f,h=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(b=>b.toString(16).padStart(2,"0")).join(""):j((f>>>0).toString(16),h/4)}e.$ei=v;class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const b=h.length;if(b===0)return;const g=this.p;let y=this.r,t=this.u,o,n;for(t!==0?(o=t,n=-1,t=0):(o=h.charCodeAt(0),n=0);;){let i=o;if(N.$Nd(o))if(n+1<b){const s=h.charCodeAt(n+1);N.$Od(s)?(n++,i=N.$Pd(o,s)):i=65533}else{t=o;break}else N.$Od(o)&&(i=65533);if(y=this.w(g,y,i),n++,n<b)o=h.charCodeAt(n);else break}this.r=y,this.u=t}w(h,b,g){return g<128?h[b++]=g:g<2048?(h[b++]=192|(g&1984)>>>6,h[b++]=128|(g&63)>>>0):g<65536?(h[b++]=224|(g&61440)>>>12,h[b++]=128|(g&4032)>>>6,h[b++]=128|(g&63)>>>0):(h[b++]=240|(g&1835008)>>>18,h[b++]=128|(g&258048)>>>12,h[b++]=128|(g&4032)>>>6,h[b++]=128|(g&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=d.g,b=this.q;for(let c=0;c<64;c+=4)h.setUint32(c,b.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)h.setUint32(c,p(h.getUint32(c-12,!1)^h.getUint32(c-32,!1)^h.getUint32(c-56,!1)^h.getUint32(c-64,!1),1),!1);let g=this.h,y=this.l,t=this.m,o=this.n,n=this.o,i,s,a;for(let c=0;c<80;c++)c<20?(i=y&t|~y&o,s=1518500249):c<40?(i=y^t^o,s=1859775393):c<60?(i=y&t|y&o|t&o,s=2400959708):(i=y^t^o,s=3395469782),a=p(g,5)+i+n+s+h.getUint32(c*4,!1)&4294967295,n=o,o=t,t=p(y,30),y=g,g=a;this.h=this.h+g&4294967295,this.l=this.l+y&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$fi=d,d.g=new DataView(new ArrayBuffer(320))}),define(ne[53],se([0,1,28]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(O){O[O.Ignore=0]="Ignore",O[O.Info=1]="Info",O[O.Warning=2]="Warning",O[O.Error=3]="Error"})(D||(D={})),function(O){const A="error",L="warning",E="warn",u="info",l="ignore";function P(p){return p?N.$Jd(A,p)?O.Error:N.$Jd(L,p)||N.$Jd(E,p)?O.Warning:N.$Jd(u,p)?O.Info:O.Ignore:O.Ignore}O.fromValue=P;function S(p){switch(p){case O.Error:return A;case O.Warning:return L;case O.Info:return u;default:return l}}O.toString=S}(D||(D={})),e.default=D}),define(ne[30],se([0,1,3]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=void 0;function D(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const h=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([b,g])=>{h[b]=g&&typeof g=="object"?D(g):g}),h}e.$Dm=D;function O(f){if(!f||typeof f!="object")return f;const h=[f];for(;h.length>0;){const b=h.shift();Object.freeze(b);for(const g in b)if(A.call(b,g)){const y=b[g];typeof y=="object"&&!Object.isFrozen(y)&&!(0,N.$je)(y)&&h.push(y)}}return f}e.$Em=O;const A=Object.prototype.hasOwnProperty;function L(f,h){return E(f,h,new Set)}e.$Fm=L;function E(f,h,b){if((0,N.$pe)(f))return f;const g=h(f);if(typeof g<"u")return g;if(Array.isArray(f)){const y=[];for(const t of f)y.push(E(t,h,b));return y}if((0,N.$ie)(f)){if(b.has(f))throw new Error("Cannot clone recursive data-structure");b.add(f);const y={};for(const t in f)A.call(f,t)&&(y[t]=E(f[t],h,b));return b.delete(f),y}return f}function u(f,h,b=!0){return(0,N.$ie)(f)?((0,N.$ie)(h)&&Object.keys(h).forEach(g=>{g in f?b&&((0,N.$ie)(f[g])&&(0,N.$ie)(h[g])?u(f[g],h[g],b):f[g]=h[g]):f[g]=h[g]}),f):h}e.$Gm=u;function l(f,h){if(f===h)return!0;if(f==null||h===null||h===void 0||typeof f!=typeof h||typeof f!="object"||Array.isArray(f)!==Array.isArray(h))return!1;let b,g;if(Array.isArray(f)){if(f.length!==h.length)return!1;for(b=0;b<f.length;b++)if(!l(f[b],h[b]))return!1}else{const y=[];for(g in f)y.push(g);y.sort();const t=[];for(g in h)t.push(g);if(t.sort(),!l(y,t))return!1;for(b=0;b<y.length;b++)if(!l(f[y[b]],h[y[b]]))return!1}return!0}e.$Hm=l;function P(f){const h=new Set;return JSON.stringify(f,(b,g)=>{if((0,N.$ie)(g)||Array.isArray(g)){if(h.has(g))return"[Circular]";h.add(g)}return g})}e.$Im=P;function S(f,h){const b=Object.create(null);return!f||!h||Object.keys(h).forEach(y=>{const t=f[y],o=h[y];l(t,o)||(b[y]=o)}),b}e.$Jm=S;function p(f,h){const b=h.toLowerCase(),g=Object.keys(f).find(y=>y.toLowerCase()===b);return g?f[g]:f[h]}e.$Km=p;function m(f,h){const b=Object.create(null);for(const[g,y]of Object.entries(f))h(g,y)&&(b[g]=y);return b}e.$Lm=m;function j(f){let h=[],b=Object.getPrototypeOf(f);for(;Object.prototype!==b;)h=h.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return h}e.$Mm=j;function v(f){const h=[];for(const b of j(f))typeof f[b]=="function"&&h.push(b);return h}e.$Nm=v;function d(f,h){const b=y=>function(){const t=Array.prototype.slice.call(arguments,0);return h(y,t)},g={};for(const y of f)g[y]=b(y);return g}e.$Om=d}),define(ne[29],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const N=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(O){return N.test(O)}e.$2e=D,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(E){for(let u=0;u<E.length;u++)E[u]=Math.floor(Math.random()*256);return E};const A=new Uint8Array(16),L=[];for(let E=0;E<256;E++)L.push(E.toString(16).padStart(2,"0"));return function(){O(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,l="";return l+=L[A[u++]],l+=L[A[u++]],l+=L[A[u++]],l+=L[A[u++]],l+="-",l+=L[A[u++]],l+=L[A[u++]],l+="-",l+=L[A[u++]],l+=L[A[u++]],l+="-",l+=L[A[u++]],l+=L[A[u++]],l+="-",l+=L[A[u++]],l+=L[A[u++]],l+=L[A[u++]],l+=L[A[u++]],l+=L[A[u++]],l+=L[A[u++]],l}}()}),define(ne[73],se([0,1,32]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function O(L){const E=L.replace(/\-/g,":").toLowerCase();return!D.has(E)}function A(){const L=(0,N.networkInterfaces)();for(const E in L){const u=L[E];if(u){for(const{mac:l}of u)if(O(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$om=A}),define(ne[74],se([0,1,32,54,29,73]),function(G,e,N,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=void 0,e.$pm=new class{c(l){return this.a||(this.a=D.$rh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(l)}value(){if(this.b===void 0){let l=0,P=0;const S=(0,N.networkInterfaces)();for(const p in S){const m=S[p];if(m)for(const{mac:j,internal:v}of m)v||(P+=1,this.c(j.toUpperCase())&&(l+=1))}this.b=P>0?l/P:0}return this.b}};let L;async function E(l){return L||(L=(async()=>await u(l)||O.$3e())()),L}e.$qm=E;async function u(l){try{const P=await new Promise((p,m)=>{G(["crypto"],p,m)}),S=(0,A.$om)();return P.createHash("sha256").update(S,"utf8").digest("hex")}catch(P){l(P);return}}}),define(ne[75],se([7,4]),function(G,e){return G.create("vs/base/common/date",e)}),define(ne[76],se([0,1,75]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=void 0;const D=60,O=D*60,A=O*24,L=A*7,E=A*30,u=A*365;function l(S,p,m,j){typeof S!="number"&&(S=S.getTime());const v=Math.round((new Date().getTime()-S)/1e3);if(v<-30)return(0,N.localize)(0,null,l(new Date().getTime()+v*1e3,!1));if(!j&&v<30)return(0,N.localize)(1,null);let d;return v<D?(d=v,p?d===1?m?(0,N.localize)(2,null,d):(0,N.localize)(3,null,d):m?(0,N.localize)(4,null,d):(0,N.localize)(5,null,d):d===1?m?(0,N.localize)(6,null,d):(0,N.localize)(7,null,d):m?(0,N.localize)(8,null,d):(0,N.localize)(9,null,d)):v<O?(d=Math.floor(v/D),p?d===1?m?(0,N.localize)(10,null,d):(0,N.localize)(11,null,d):m?(0,N.localize)(12,null,d):(0,N.localize)(13,null,d):d===1?m?(0,N.localize)(14,null,d):(0,N.localize)(15,null,d):m?(0,N.localize)(16,null,d):(0,N.localize)(17,null,d)):v<A?(d=Math.floor(v/O),p?d===1?m?(0,N.localize)(18,null,d):(0,N.localize)(19,null,d):m?(0,N.localize)(20,null,d):(0,N.localize)(21,null,d):d===1?m?(0,N.localize)(22,null,d):(0,N.localize)(23,null,d):m?(0,N.localize)(24,null,d):(0,N.localize)(25,null,d)):v<L?(d=Math.floor(v/A),p?d===1?(0,N.localize)(26,null,d):(0,N.localize)(27,null,d):d===1?(0,N.localize)(28,null,d):(0,N.localize)(29,null,d)):v<E?(d=Math.floor(v/L),p?d===1?m?(0,N.localize)(30,null,d):(0,N.localize)(31,null,d):m?(0,N.localize)(32,null,d):(0,N.localize)(33,null,d):d===1?m?(0,N.localize)(34,null,d):(0,N.localize)(35,null,d):m?(0,N.localize)(36,null,d):(0,N.localize)(37,null,d)):v<u?(d=Math.floor(v/E),p?d===1?m?(0,N.localize)(38,null,d):(0,N.localize)(39,null,d):m?(0,N.localize)(40,null,d):(0,N.localize)(41,null,d):d===1?m?(0,N.localize)(42,null,d):(0,N.localize)(43,null,d):m?(0,N.localize)(44,null,d):(0,N.localize)(45,null,d)):(d=Math.floor(v/u),p?d===1?m?(0,N.localize)(46,null,d):(0,N.localize)(47,null,d):m?(0,N.localize)(48,null,d):(0,N.localize)(49,null,d):d===1?m?(0,N.localize)(50,null,d):(0,N.localize)(51,null,d):m?(0,N.localize)(52,null,d):(0,N.localize)(53,null,d))}e.$Nl=l;function P(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Ol=P}),define(ne[77],se([7,4]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ne[33],se([0,1,19,3,77]),function(G,e,N,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=e.$9h=void 0;function A(S,p){return p&&(S.stack||S.stacktrace)?O.localize(0,null,E(S),L(S.stack)||L(S.stacktrace)):E(S)}function L(S){return Array.isArray(S)?S.join(`
`):S}function E(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?O.localize(1,null,S.message):S.message||O.localize(2,null)}function u(S=null,p=!1){if(!S)return O.localize(3,null);if(Array.isArray(S)){const m=N.$jf(S),j=u(m[0],p);return m.length>1?O.localize(4,null,j,m.length):j}if(D.$ge(S))return S;if(S.detail){const m=S.detail;if(m.error)return A(m.error,p);if(m.exception)return A(m.exception,p)}return S.stack?A(S,p):S.message?S.message:O.localize(5,null)}e.$9h=u;function l(S){const p=S;return p instanceof Error&&Array.isArray(p.actions)}e.$0h=l;function P(S,p){let m;return typeof S=="string"?m=new Error(S):m=S,m.actions=p,m}e.$$h=P}),define(ne[78],se([7,4]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ne[79],se([0,1,78]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=void 0;function D(O){switch(O){case 1:return(0,N.localize)(0,null);case 2:return(0,N.localize)(1,null);case 3:return(0,N.localize)(2,null);case 4:return(0,N.localize)(3,null);case 5:return(0,N.localize)(4,null);case 6:return(0,N.localize)(5,null);case 7:return(0,N.localize)(6,null);case 8:return(0,N.localize)(7,null);case 9:return(0,N.localize)(8,null);default:return""}}e.$0o=D}),define(ne[55],se([0,1,12]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.TerminateResponseCode=e.Source=void 0;var D;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(D||(e.Source=D={}));var O;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(O||(e.TerminateResponseCode=O={}));function A(E,...u){const l=u.reduce((p,m)=>(p[m]=!0,p),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(p=>!l[p]).forEach(p=>{for(let m=0;m<P.length;m++)if(p.search(P[m])!==-1){delete E[p];break}})}e.$bl=A;function L(E){E&&(delete E.DEBUG,N.$j&&delete E.DYLD_LIBRARY_PATH,N.$k&&delete E.LD_PRELOAD)}e.$cl=L}),define(ne[80],se([0,1,11]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Ap=e.$zp=e.$yp=void 0;function D(l){const P=l;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$yp=D;function O(l){const P=[];let S;try{const p=JSON.parse(l.arguments),m=p[p.length-1];m&&m.__$stack&&(p.pop(),S=m.__$stack),P.push(...p)}catch{P.push("Unable to log remote console arguments",l.arguments)}return{args:P,stack:S}}e.$zp=O;function A(l){if(typeof l!="string")return A(O(l).stack);const P=l;if(P){const S=L(P),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(p&&p.length===4)return{uri:N.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Ap=A;function L(l){if(!l)return l;const P=l.indexOf(`
`);return P===-1?l:l.substring(0,P)}function E(l,P){const{args:S,stack:p}=O(l),m=typeof S[0]=="string"&&S.length===1;let j=L(p);j&&(j=`(${j.trim()})`);let v=[];if(typeof S[0]=="string"?j&&m?v=[`%c[${P}] %c${S[0]} %c${j}`,u("blue"),u(""),u("grey")]:v=[`%c[${P}] %c${S[0]}`,u("blue"),u(""),...S.slice(1)]:v=[`%c[${P}]%`,u("blue"),...S],j&&!m&&v.push(j),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,v)}e.log=E;function u(l){return`color: ${l}`}}),define(ne[46],se([0,1,14,28,11]),function(G,e,N,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=e.$Tg=e.$Sg=void 0;function A(l){return JSON.stringify(l,E)}e.$Sg=A;function L(l){let P=JSON.parse(l);return P=u(P),P}e.$Tg=L;function E(l,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,D.$wd)(P)}:P}function u(l,P=0){if(!l||P>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return O.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof N.$Ib||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let S=0;S<l.length;++S)l[S]=u(l[S],P+1);else for(const S in l)Object.hasOwnProperty.call(l,S)&&(l[S]=u(l[S],P+1))}return l}e.$Ug=u}),define(ne[81],se([0,1,32,15,22]),function(G,e,N,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=void 0;const A=/^\d+$/,L=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var u;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(u||(u={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class S{constructor(y,t,o){this.exePath=y,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await O.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:g=!1}={}){return g?l===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:g=!1,findPreview:y=!1}={}){const t=p({useAlternateBitness:g});if(!t)return null;const o=D.$$b(t,"PowerShell");if(!await O.SymlinkSupport.existsDirectory(o))return null;let n=-1,i=null;for(const c of await O.Promises.readdir(o)){let I=-1;if(y){const $=c.indexOf("-");if($<0)continue;const M=c.substring(0,$);if(!A.test(M)||c.substring($+1)!=="preview")continue;I=parseInt(M,10)}else{if(!A.test(c))continue;I=parseInt(c,10)}if(I<=n)continue;const w=D.$$b(o,c,"pwsh.exe");await O.SymlinkSupport.existsFile(w)&&(i=w,n=I)}if(!i)return null;const s=t.includes("x86")?" (x86)":"",a=y?" Preview":"";return new S(i,`PowerShell${a}${s}`,!0)}async function j({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const y=D.$$b(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await O.SymlinkSupport.existsDirectory(y))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=g?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const n of await O.Promises.readdir(y))if(t.test(n)){const i=D.$$b(y,n,"pwsh.exe");return new S(i,o)}return null}function v(){const g=D.$$b(N.homedir(),".dotnet","tools","pwsh.exe");return new S(g,".NET Core PowerShell Global Tool")}function d(){const g=D.$$b(process.env.windir,l===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(g,"Windows PowerShell",!0)}async function*f(){let g=await m();g&&(yield g),g=await m({useAlternateBitness:!0}),g&&(yield g),g=await j(),g&&(yield g),g=v(),g&&(yield g),g=await m({findPreview:!0}),g&&(yield g),g=await j({findPreview:!0}),g&&(yield g),g=await m({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=d(),g&&(yield g)}async function*h(){for await(const g of f())await g.exists()&&(yield g)}e.$_k=h;async function b(){for await(const g of h())return g;return null}e.$al=b}),define(ne[56],se([0,1,15,12,34,55,3,22]),function(G,e,N,D,O,A,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$el=e.$dl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(S=O.env){return S.comspec||"cmd.exe"}e.$dl=u;function l(S){let p=[],m=!1;const j=function(v){if(m){p.push(v);return}(!S.send(v,f=>{if(f&&console.error(f),m=!1,p.length>0){const h=p.slice(0);p=[],h.forEach(b=>j(b))}})||D.$i)&&(m=!0)};return{send:j}}e.$el=l;var P;(function(S){async function p(m,j,v){if(N.$0b(m))return m;if(j===void 0&&(j=O.cwd()),N.$bc(m)!=="."||(v===void 0&&L.$ge(O.env.PATH)&&(v=O.env.PATH.split(N.$ic)),v===void 0||v.length===0))return N.$$b(j,m);async function f(h){if(await E.Promises.exists(h)){let b;try{b=await E.Promises.stat(h)}catch(g){g.message.startsWith("EACCES")&&(b=await E.Promises.lstat(h))}return b?!b.isDirectory():!1}return!1}for(const h of v){let b;if(N.$0b(h)?b=N.$$b(h,m):b=N.$$b(j,h,m),await f(b))return b;let g=b+".com";if(await f(g)||(g=b+".exe",await f(g)))return g}return N.$$b(j,m)}S.findExecutable=p})(P||(e.win32=P={}))}),define(ne[82],se([0,1,32,12,81,56]),function(G,e,N,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=void 0;async function L(S,p){return S===1?D.$i?P():A.$dl(p):u(S,p)}e.$fl=L;let E=null;function u(S,p){if(D.$k&&S===2||D.$j&&S===3)return"/bin/bash";if(!E){let m;if(D.$i)m="/bin/bash";else{if(m=p.SHELL,!m)try{m=(0,N.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}E=m}return E}let l=null;async function P(){return l||(l=(await(0,O.$al)()).exePath),l}});var pe=this&&this.__decorate||function(G,e,N,D){var O=arguments.length,A=O<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,N):D,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,N,D);else for(var E=G.length-1;E>=0;E--)(L=G[E])&&(A=(O<3?L(A):O>3?L(e,N,A):L(e,N))||A);return O>3&&A&&Object.defineProperty(e,N,A),A};define(ne[57],se([0,1,19,8,14,23,51,9,5,2,46,28,3]),function(G,e,N,D,O,A,L,E,u,l,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.ProxyChannel=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.RequestInitiator=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=void 0;var m;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(m||(m={}));function j(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(v||(v={}));function d(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(f||(f={}));function h(F){let U=0;for(let W=0;;W+=7){const X=F.read(1);if(U|=(X.buffer[0]&127)<<W,!(X.buffer[0]&128))return U}}const b=n(0);function g(F,U){if(U===0){F.write(b);return}let W=0;for(let Y=U;Y!==0;Y=Y>>>7)W++;const X=O.$Ib.alloc(W);for(let Y=0;U!==0;Y++)X.buffer[Y]=U&127,U=U>>>7,U>0&&(X.buffer[Y]|=128);F.write(X)}class y{constructor(U){this.b=U,this.a=0}read(U){const W=this.b.slice(this.a,this.a+U);return this.a+=W.byteLength,W}}e.$Vg=y;class t{constructor(){this.a=[]}get buffer(){return O.$Ib.concat(this.a)}write(U){this.a.push(U)}}e.$Wg=t;var o;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object",F[F.Int=6]="Int"})(o||(o={}));function n(F){const U=O.$Ib.alloc(1);return U.writeUInt8(F,0),U}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},s=typeof Buffer<"u";function a(F,U){if(typeof U>"u")F.write(i.Undefined);else if(typeof U=="string"){const W=O.$Ib.fromString(U);F.write(i.String),g(F,W.byteLength),F.write(W)}else if(s&&Buffer.isBuffer(U)){const W=O.$Ib.wrap(U);F.write(i.Buffer),g(F,W.byteLength),F.write(W)}else if(U instanceof O.$Ib)F.write(i.VSBuffer),g(F,U.byteLength),F.write(U);else if(Array.isArray(U)){F.write(i.Array),g(F,U.length);for(const W of U)a(F,W)}else if(typeof U=="number"&&(U|0)===U)F.write(i.Uint),g(F,U);else{const W=O.$Ib.fromString(JSON.stringify(U));F.write(i.Object),g(F,W.byteLength),F.write(W)}}e.$Xg=a;function c(F){switch(F.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return F.read(h(F)).toString();case o.Buffer:return F.read(h(F)).buffer;case o.VSBuffer:return F.read(h(F));case o.Array:{const W=h(F),X=[];for(let Y=0;Y<W;Y++)X.push(c(F));return X}case o.Object:return JSON.parse(F.read(h(F)).toString());case o.Int:return h(F)}}e.$Yg=c;class I{constructor(U,W,X=null,Y=1e3){this.h=U,this.j=W,this.k=X,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(z=>this.q(z)),this.m({type:200})}registerChannel(U,W){this.b.set(U,W),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const W=this.o([U.type]);this.k?.logOutgoing(W,0,1,d(U.type));return}case 201:case 202:case 204:case 203:{const W=this.o([U.type,U.id],U.data);this.k?.logOutgoing(W,U.id,1,d(U.type),U.data);return}}}o(U,W=void 0){const X=new t;return a(X,U),a(X,W),this.p(X.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const W=new y(U),X=c(W),Y=c(W),z=X[0];switch(z){case 100:return this.k?.logIncoming(U.byteLength,X[1],1,`${j(z)}: ${X[2]}.${X[3]}`,Y),this.s({type:z,id:X[1],channelName:X[2],name:X[3],arg:Y});case 102:return this.k?.logIncoming(U.byteLength,X[1],1,`${j(z)}: ${X[2]}.${X[3]}`,Y),this.t({type:z,id:X[1],channelName:X[2],name:X[3],arg:Y});case 101:return this.k?.logIncoming(U.byteLength,X[1],1,`${j(z)}`),this.u({type:z,id:X[1]});case 103:return this.k?.logIncoming(U.byteLength,X[1],1,`${j(z)}`),this.u({type:z,id:X[1]})}}s(U){const W=this.b.get(U.channelName);if(!W){this.v(U);return}const X=new A.$bd;let Y;try{Y=W.call(this.j,U.name,U.arg,X.token)}catch(R){Y=Promise.reject(R)}const z=U.id;Y.then(R=>{this.m({id:z,data:R,type:201}),this.d.delete(U.id)},R=>{R instanceof Error?this.m({id:z,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.m({id:z,data:R,type:203}),this.d.delete(U.id)});const C=(0,l.$ib)(()=>X.cancel());this.d.set(U.id,C)}t(U){const W=this.b.get(U.channelName);if(!W){this.v(U);return}const X=U.id,z=W.listen(this.j,U.name,U.arg)(C=>this.m({id:X,data:C,type:204}));this.d.set(U.id,z)}u(U){const W=this.d.get(U.id);W&&(W.dispose(),this.d.delete(U.id))}v(U){let W=this.g.get(U.channelName);W||(W=[],this.g.set(U.channelName,W));const X=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:U,timeoutTimer:X})}w(U){const W=this.g.get(U);if(W){for(const X of W)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$fb)(this.d.values()),this.d.clear()}}e.$Zg=I;var w;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class ${constructor(U,W=null){this.l=U,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$5c,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=W}getChannel(U){const W=this;return{call(X,Y,z){return W.a?Promise.reject(new E.$2):W.m(U,X,Y,z)},listen(X,Y){return W.a?u.Event.None:W.o(U,X,Y)}}}m(U,W,X,Y=A.CancellationToken.None){const z=this.g++,R={id:z,type:100,channelName:U,name:W,arg:X};if(Y.isCancellationRequested)return Promise.reject(new E.$2);let r;return new Promise((T,B)=>{if(Y.isCancellationRequested)return B(new E.$2);const Z=()=>{const $e=he=>{switch(he.type){case 201:this.f.delete(z),T(he.data);break;case 202:{this.f.delete(z);const me=new Error(he.data.message);me.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,me.name=he.data.name,B(me);break}case 203:this.f.delete(z),B(he.data);break}};this.f.set(z,$e),this.p(R)};let _=null;this.b===f.Idle?Z():(_=(0,D.$fg)($e=>this.u()),_.then(()=>{_=null,Z()}));const re=()=>{_?(_.cancel(),_=null):this.p({id:z,type:101}),B(new E.$2)},de=Y.onCancellationRequested(re);r=(0,l.$hb)((0,l.$ib)(re),de),this.d.add(r)}).finally(()=>{this.d.delete(r)})}o(U,W,X){const Y=this.g++,C={id:Y,type:102,channelName:U,name:W,arg:X};let R=null;const r=new u.$5c({onWillAddFirstListener:()=>{R=(0,D.$fg)(T=>this.u()),R.then(()=>{R=null,this.d.add(r),this.p(C)})},onDidRemoveLastListener:()=>{R?(R.cancel(),R=null):(this.d.delete(r),this.p({id:Y,type:103}))}}),k=T=>r.fire(T.data);return this.f.set(Y,k),r.event}p(U){switch(U.type){case 100:case 102:{const W=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(W,U.id,0,`${j(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const W=this.q([U.type,U.id]);this.j?.logOutgoing(W,U.id,0,j(U.type));return}}}q(U,W=void 0){const X=new t;return a(X,U),a(X,W),this.r(X.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const W=new y(U),X=c(W),Y=c(W),z=X[0];switch(z){case 200:return this.j?.logIncoming(U.byteLength,0,0,d(z)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,X[1],0,d(z),Y),this.t({type:X[0],id:X[1],data:Y})}}t(U){if(U.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$fb)(this.d.values()),this.d.clear()}}e.$1g=$,pe([L.$Pg],$.prototype,"onDidInitializePromise",null);class M{get connections(){const U=[];return this.f.forEach(W=>U.push(W)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new u.$5c,this.onDidAddConnection=this.g.event,this.h=new u.$5c,this.onDidRemoveConnection=this.h.event,U(({protocol:W,onDidClientDisconnect:X})=>{u.Event.once(W.onMessage)(z=>{const C=new y(z),R=c(C),r=new I(W,R),k=new $(W);this.a.forEach((B,Z)=>r.registerChannel(Z,B));const T={channelServer:r,channelClient:k,ctx:R};this.f.add(T),this.g.fire(T),X(()=>{r.dispose(),k.dispose(),this.f.delete(T),this.h.fire(T)})})})}getChannel(U,W){const X=this;return{call(Y,z,C){let R;if((0,p.$ue)(W)){const k=(0,N.$Hf)(X.connections.filter(W));R=k?Promise.resolve(k):u.Event.toPromise(u.Event.filter(X.onDidAddConnection,W))}else R=W.routeCall(X,Y,z);const r=R.then(k=>k.channelClient.getChannel(U));return J(r).call(Y,z,C)},listen(Y,z){if((0,p.$ue)(W))return X.j(U,W,Y,z);const C=W.routeEvent(X,Y,z).then(R=>R.channelClient.getChannel(U));return J(C).listen(Y,z)}}}j(U,W,X,Y){const z=this;let C=new l.$jb;const R=new u.$5c({onWillAddFirstListener:()=>{C=new l.$jb;const r=new u.$$c,k=new Map,T=Z=>{const re=Z.channelClient.getChannel(U).listen(X,Y),de=r.add(re);k.set(Z,de)},B=Z=>{const _=k.get(Z);_&&(_.dispose(),k.delete(Z))};z.connections.filter(W).forEach(T),u.Event.filter(z.onDidAddConnection,W)(T,void 0,C),z.onDidRemoveConnection(B,void 0,C),r.event(R.fire,R,C),C.add(r)},onDidRemoveLastListener:()=>{C.dispose()}});return R.event}registerChannel(U,W){this.a.set(U,W),this.f.forEach(X=>{X.channelServer.registerChannel(U,W)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$2g=M;class Q{constructor(U,W,X=null){const Y=new t;a(Y,W),U.send(Y.buffer),this.a=new $(U,X),this.d=new I(U,W,X)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,W){this.d.registerChannel(U,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$3g=Q;function J(F){return{call(U,W,X){return F.then(Y=>Y.call(U,W,X))},listen(U,W){const X=new u.$ad;return F.then(Y=>X.input=Y.listen(U,W)),X.event}}}e.$4g=J;function ie(F){let U=!1;return{call(W,X,Y){return U?F.call(W,X,Y):(0,D.$sg)(0).then(()=>U=!0).then(()=>F.call(W,X,Y))},listen(W,X){if(U)return F.listen(W,X);const Y=new u.$ad;return(0,D.$sg)(0).then(()=>U=!0).then(()=>Y.input=F.listen(W,X)),Y.event}}}e.$5g=ie;class ue{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const W of U.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await u.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$6g=ue;var x;(function(F){function U(z,C){const R=z,r=C&&C.disableMarshalling,k=new Map;for(const T in R)X(T)&&k.set(T,u.Event.buffer(R[T],!0));return new class{listen(T,B,Z){const _=k.get(B);if(_)return _;if(Y(B)){const re=R[B];if(typeof re=="function")return re.call(R,Z)}throw new Error(`Event not found: ${B}`)}call(T,B,Z){const _=R[B];if(typeof _=="function"){if(!r&&Array.isArray(Z))for(let re=0;re<Z.length;re++)Z[re]=(0,P.$Ug)(Z[re]);return _.apply(R,Z)}throw new Error(`Method not found: ${B}`)}}}F.fromService=U;function W(z,C){const R=C&&C.disableMarshalling;return new Proxy({},{get(r,k){if(typeof k=="string")return C?.properties?.has(k)?C.properties.get(k):Y(k)?function(T){return z.listen(k,T)}:X(k)?z.listen(k):async function(...T){let B;C&&!(0,p.$pe)(C.context)?B=[C.context,...T]:B=T;const Z=await z.call(k,B);return R?Z:(0,P.$Ug)(Z)};throw new Error(`Property not found: ${String(k)}`)}})}F.toService=W;function X(z){return z[0]==="o"&&z[1]==="n"&&S.$Id(z.charCodeAt(2))}function Y(z){return/^onDynamic/.test(z)&&S.$Id(z.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const U=F.toString();if(U!=="[object Object]")return U}return F}function oe(F){return Array.isArray(F)?F.map(le):le(F)}function V(F,U,W,X,Y,z,C){C=oe(C);const R=ce[Y],r=R[X%R.length];let k=[`%c[${F}]%c[${String(U).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${r}`];/\($/.test(z)?(k=k.concat(C),k.push(")")):k.push(C),console.log.apply(console,k)}class H{constructor(U,W){this.d=U,this.f=W,this.a=0,this.b=0}logOutgoing(U,W,X,Y,z){this.b+=U,V(this.d,this.b,U,W,X,Y,z)}logIncoming(U,W,X,Y,z){this.a+=U,V(this.f,this.a,U,W,X,Y,z)}}e.$7g=H}),define(ne[83],se([0,1,58,8,14,23,80,9,5,2,30,56,55,57]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=void 0;class j extends m.$Zg{constructor(f){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",h=>O.$Ib.wrap(Buffer.from(h,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$Cp=j;class v{constructor(f,h){this.i=f,this.j=h,this.c=new Set,this.g=new Map,this.h=new u.$5c,this.onDidProcessExit=this.h.event;const b=h&&h.timeout?h.timeout:6e4;this.b=new D.$og(b),this.d=null,this.f=null}getChannel(f){const h=this;return{call(b,g,y){return h.k(f,b,g,y)},listen(b,g){return h.l(f,b,g)}}}k(f,h,b,g=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(E.$3());this.b.cancel();const y=this.n(f),t=(0,D.$fg)(i=>y.call(h,b,i)),o=g.onCancellationRequested(()=>t.cancel()),n=(0,l.$ib)(()=>t.cancel());return this.c.add(n),t.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,h,b){if(!this.b)return u.Event.None;this.b.cancel();let g;const y=new u.$5c({onWillAddFirstListener:()=>{g=this.n(f).listen(h,b)(y.fire,y),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return y.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,P.$Dm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,p.$cl)(h.env),this.d=(0,N.fork)(this.i,f,h);const b=new u.$5c;u.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,L.$yp)(s)){(0,L.log)(s,`IPC Library: ${this.j.serverName}`);return}b.fire(O.$Ib.wrap(Buffer.from(s,"base64")))});const y=this.j.useQueue?(0,S.$el)(this.d):this.d,t=s=>this.d&&this.d.connected&&y.send(s.buffer.toString("base64")),o=b.event,n={send:t,onMessage:o};this.f=new m.$1g(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,a)=>{process.removeListener("exit",i),this.c.forEach(c=>(0,l.$fb)(c)),this.c.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:a})})}return this.f}n(f){let h=this.g.get(f);return h||(h=this.m.getChannel(f),this.g.set(f,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Dp=v}),define(ne[84],se([0,1,8,5,2,46,3]),function(G,e,N,D,O,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.StorageState=e.$Bo=e.StorageHint=void 0;var E;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function u(p){const m=p;return m?.changed instanceof Map||m?.deleted instanceof Set}e.$Bo=u;var l;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(l||(e.StorageState=l={}));class P extends O.$kb{constructor(m,j=Object.create(null)){super(),this.m=m,this.n=j,this.b=this.B(new D.$8c),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=new N.$pg(P.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(m=>this.r(m)))}r(m){this.b.pause();try{m.changed?.forEach((j,v)=>this.s(v,j)),m.deleted?.forEach(j=>this.s(j,void 0))}finally{this.b.resume()}}s(m,j){if(this.c===l.Closed)return;let v=!1;(0,L.$pe)(j)?v=this.f.delete(m):this.f.get(m)!==j&&(this.f.set(m,j),v=!0),v&&this.b.fire({key:m,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.n.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(m,j){const v=this.f.get(m);return(0,L.$pe)(v)?j:v}getBoolean(m,j){const v=this.get(m);return(0,L.$pe)(v)?j:v==="true"}getNumber(m,j){const v=this.get(m);return(0,L.$pe)(v)?j:parseInt(v,10)}getObject(m,j){const v=this.get(m);return(0,L.$pe)(v)?j:(0,A.$Tg)(v)}async set(m,j,v=!1){if(this.c===l.Closed)return;if((0,L.$pe)(j))return this.delete(m,v);const d=(0,L.$ie)(j)||Array.isArray(j)?(0,A.$Sg)(j):String(j);if(this.f.get(m)!==d)return this.f.set(m,d),this.j.set(m,d),this.h.delete(m),this.b.fire({key:m,external:v}),this.w()}async delete(m,j=!1){if(!(this.c===l.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire({key:m,external:j}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=l.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(m).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(m){if(this.u)return this.w(m)}async w(m){return this.g.trigger(()=>this.v(),m)}async whenFlushed(){if(this.u)return new Promise(m=>this.l.push(m))}isInMemory(){return this.n.hint===E.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Co=P,P.a=100;class S{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((j,v)=>this.a.set(v,j)),m.delete?.forEach(j=>this.a.delete(j))}async close(){}}e.$Do=S}),define(ne[85],se([7,4]),function(G,e){return G.create("vs/base/node/zip",e)}),define(ne[86],se([7,4]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[87],se([7,4]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[88],se([7,4]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ne[89],se([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[90],se([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[91],se([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[92],se([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[93],se([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[94],se([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[95],se([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[96],se([7,4]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[97],se([7,4]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ne[98],se([7,4]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ne[99],se([7,4]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[100],se([7,4]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[101],se([7,4]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ne[102],se([7,4]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ne[103],se([7,4]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[104],se([7,4]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[105],se([7,4]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ne[106],se([0,1,9,88]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.TokenType=void 0;var O;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...l){switch(l.length){case 1:return(0,D.localize)(0,null,l[0]);case 2:return(0,D.localize)(1,null,l[0],l[1]);case 3:return(0,D.localize)(2,null,l[0],l[1],l[2]);default:return}}const L=(0,D.localize)(3,null),E=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,N.$5)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const S=this.d,p=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:p};this.g.push({offset:S,lexeme:p,additionalInfo:P}),this.f.push(m)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const S=this.c.substring(this.d,this.e),p=u.b.get(S);p?this.k(p):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,S=!1,p=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(E);return}const j=this.c.charCodeAt(P);if(S)S=!1;else if(j===47&&!p){P++;break}else j===91?p=!0:j===92?S=!0:j===93&&(p=!1);P++}for(;P<this.c.length&&u.a.has(this.c.charCodeAt(P));)P++;this.e=P;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$oi=u,u.a=new Set(["i","g","s","m","y","u"].map(l=>l.charCodeAt(0))),u.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(ne[107],se([0,1,76,51,16,15,34,17,11]),function(G,e,N,D,O,A,L,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,A.$bc)(O.$1e.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$$b)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,E.$6f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,E.$6f)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,N.$Ol)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$$b)(this.userDataPath,"logs",m)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$6f)(u.URI.file((0,A.$$b)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$6f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$6f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$6f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=L.env.VSCODE_PORTABLE;return m?u.URI.file((0,A.$$b)(m,"argv.json")):(0,E.$6f)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$$b)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,A.$_b)(m):(0,A.$9b)((0,A.$$b)(O.$1e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?u.URI.file((0,A.$_b)(m)):u.URI.file((0,A.$$b)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,A.$_b)(m);const j=L.env.VSCODE_EXTENSIONS;if(j)return j;const v=L.env.VSCODE_PORTABLE;return v?(0,A.$$b)(v,"extensions"):(0,E.$6f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(j=>/^[^:/?#]+?:\/\//.test(j)?u.URI.parse(j):u.URI.file((0,A.$9b)(j)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?u.URI.parse(m):u.URI.file((0,A.$9b)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.$Pl.test(m))}get extensionLogLevel(){const m=[];for(const j of this.args.log||[]){const v=e.$Pl.exec(j);v&&v[1]&&v[2]&&m.push([v[1],v[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,E.$6f)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=L.env.VSCODE_PORTABLE;return m?u.URI.file((0,A.$$b)(m,"policy.json")):(0,E.$6f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,j,v){this.a=m,this.b=j,this.c=v,this.editSessionId=this.args.editSessionId}}e.$Ql=l,pe([D.$Pg],l.prototype,"appRoot",null),pe([D.$Pg],l.prototype,"userHome",null),pe([D.$Pg],l.prototype,"userDataPath",null),pe([D.$Pg],l.prototype,"appSettingsHome",null),pe([D.$Pg],l.prototype,"tmpDir",null),pe([D.$Pg],l.prototype,"cacheHome",null),pe([D.$Pg],l.prototype,"stateResource",null),pe([D.$Pg],l.prototype,"userRoamingDataHome",null),pe([D.$Pg],l.prototype,"userDataSyncHome",null),pe([D.$Pg],l.prototype,"sync",null),pe([D.$Pg],l.prototype,"machineSettingsResource",null),pe([D.$Pg],l.prototype,"workspaceStorageHome",null),pe([D.$Pg],l.prototype,"localHistoryHome",null),pe([D.$Pg],l.prototype,"keyboardLayoutResource",null),pe([D.$Pg],l.prototype,"argvResource",null),pe([D.$Pg],l.prototype,"isExtensionDevelopment",null),pe([D.$Pg],l.prototype,"untitledWorkspacesHome",null),pe([D.$Pg],l.prototype,"builtinExtensionsPath",null),pe([D.$Pg],l.prototype,"extensionsPath",null),pe([D.$Pg],l.prototype,"extensionDevelopmentLocationURI",null),pe([D.$Pg],l.prototype,"extensionDevelopmentKind",null),pe([D.$Pg],l.prototype,"extensionTestsLocationURI",null),pe([D.$Pg],l.prototype,"debugExtensionHost",null),pe([D.$Pg],l.prototype,"logLevel",null),pe([D.$Pg],l.prototype,"extensionLogLevel",null),pe([D.$Pg],l.prototype,"serviceMachineIdResource",null),pe([D.$Pg],l.prototype,"disableTelemetry",null),pe([D.$Pg],l.prototype,"disableWorkspaceTrust",null),pe([D.$Pg],l.prototype,"policyFile",null);function P(p,m){return S(p["inspect-extensions"],p["inspect-brk-extensions"],5870,m,p.debugId,p.extensionEnvironment)}e.$Rl=P;function S(p,m,j,v,d,f){const b=Number(m||p)||(v?null:j),g=b?!!m:!1;let y;if(f)try{y=JSON.parse(f)}catch{}return{port:b,break:g,debugId:d,env:y}}e.$Sl=S}),function(){"use strict";function G(e,N,D){function O(L,E){const u=A(L,E),l=[u];return e.isAbsolute(u)||l.unshift(D),e.resolve(...l)}function A(L,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,E);const P=L["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(S,"AppData","Roaming")}break;case"darwin":l=e.join(N.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(N.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,E)}return{getUserDataPath:O}}if(typeof define=="function")define(ne[108],se([162,32,34]),function(e,N,D){return G(e,N,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),N=require("os");module.exports=G(e,N,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[109],se([0,1,32,107,108]),function(G,e,N,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Tl=void 0;class A extends D.$Ql{constructor(l,P){super(l,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,O.getUserDataPath)(l,P.nameShort)},P)}}e.$Tl=A;function L(u,l){return(0,D.$Sl)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,l,u.extensionEnvironment)}e.$Ul=L;function E(u,l){return(0,D.$Sl)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,l,u.extensionEnvironment)}e.$Vl=E}),define(ne[110],se([0,1,3,92]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=void 0;function O(L,E,u){try{A(L,E,u)}catch(l){console.error(l?.message??l)}return L}e.$$o=O;function A(L,E,u){const l=(P,S,p)=>{const m=P[S];if((0,N.$ge)(m)){const j=m,v=j.length;if(v>1&&j[0]==="%"&&j[v-1]==="%"){const d=j.substr(1,v-2);let f=E[d];f===void 0&&u&&(f=u[d]);const h=typeof f=="string"?f:f?.message,b=u?.[d],g=typeof b=="string"?b:b?.message;if(!h){g||console.warn(`[${L.name}]: ${(0,D.localize)(0,null,d)}`);return}if(p&&(S==="title"||S==="category")&&g&&g!==h){const y={value:h,original:g};P[S]=y}else P[S]=h}}else if((0,N.$ie)(m))for(const j in m)m.hasOwnProperty(j)&&(j==="commands"?l(m,j,!0):l(m,j,p));else if(Array.isArray(m))for(let j=0;j<m.length;j++)l(m,j,p)};for(const P in L)L.hasOwnProperty(P)&&l(L,P)}}),define(ne[47],se([0,1,17,53,96,41]),function(G,e,N,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function u(f){return f=f.trim(),f==="*"||L.test(f)}e.$no=u;function l(f){if(!u(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=f.match(L);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$oo=l;function P(f){if(!f)return null;const h=f.majorBase,b=f.majorMustEqual,g=f.minorBase;let y=f.minorMustEqual;const t=f.patchBase;let o=f.patchMustEqual;f.hasCaret&&(h===0||(y=!1),o=!1);let n=0;if(f.preRelease){const i=E.exec(f.preRelease);if(i){const[,s,a,c]=i;n=Date.UTC(Number(s),Number(a)-1,Number(c))}}return{majorBase:h,majorMustEqual:b,minorBase:g,minorMustEqual:y,patchBase:t,patchMustEqual:o,isMinimum:f.hasGreaterEquals,notBefore:n}}e.$po=P;function S(f,h,b){let g;typeof f=="string"?g=P(l(f)):g=f;let y;h instanceof Date?y=h.getTime():typeof h=="string"&&(y=new Date(h).getTime());let t;if(typeof b=="string"?t=P(l(b)):t=b,!g||!t)return!1;const o=g.majorBase,n=g.minorBase,i=g.patchBase;let s=t.majorBase,a=t.minorBase,c=t.patchBase;const I=t.notBefore;let w=t.majorMustEqual,$=t.minorMustEqual,M=t.patchMustEqual;return t.isMinimum?o>s?!0:o<s?!1:n>a?!0:n<a||y&&y<I?!1:i>=c:(o===1&&s===0&&(!w||!$||!M)&&(s=1,a=0,c=0,w=!0,$=!1,M=!1),o<s?!1:o>s?!w:n<a?!1:n>a?!$:i<c?!1:i>c?!M:!(y&&y<I))}e.$qo=S;function p(f,h,b,g,y){const t=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return t.push([D.default.Error,O.localize(0,null)]),t;if(typeof g.name!="string")return t.push([D.default.Error,O.localize(1,null,"name")]),t;if(typeof g.version!="string")return t.push([D.default.Error,O.localize(2,null,"version")]),t;if(!g.engines)return t.push([D.default.Error,O.localize(3,null,"engines")]),t;if(typeof g.engines.vscode!="string")return t.push([D.default.Error,O.localize(4,null,"engines.vscode")]),t;if(typeof g.extensionDependencies<"u"&&!d(g.extensionDependencies))return t.push([D.default.Error,O.localize(5,null,"extensionDependencies")]),t;if(typeof g.activationEvents<"u"){if(!d(g.activationEvents))return t.push([D.default.Error,O.localize(6,null,"activationEvents")]),t;if(typeof g.main>"u"&&typeof g.browser>"u")return t.push([D.default.Error,O.localize(7,null,"activationEvents","main","browser")]),t}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&t.push([D.default.Warning,O.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return t.push([D.default.Error,O.localize(9,null,"main")]),t;{const i=(0,N.$6f)(b,g.main);(0,N.$Zf)(i,b)||t.push([D.default.Warning,O.localize(10,null,i.path,b.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return t.push([D.default.Error,O.localize(11,null,"browser")]),t;{const i=(0,N.$6f)(b,g.browser);(0,N.$Zf)(i,b)||t.push([D.default.Warning,O.localize(12,null,i.path,b.path)])}}if(!A.valid(g.version))return t.push([D.default.Error,O.localize(13,null)]),t;const o=[];if(!m(f,h,g,y,o))for(const i of o)t.push([D.default.Error,i]);return t}e.$ro=p;function m(f,h,b,g,y){return g||typeof b.main>"u"&&typeof b.browser>"u"?!0:v(f,h,b.engines.vscode,y)}e.$so=m;function j(f,h,b){return f==="*"||v(h,b,f)}e.$to=j;function v(f,h,b,g=[]){const y=P(l(b));if(!y)return g.push(O.localize(14,null,b)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return g.push(O.localize(15,null,b)),!1}else if(!y.majorMustEqual)return g.push(O.localize(16,null,b)),!1;return S(f,h,y)?!0:(g.push(O.localize(17,null,f,b)),!1)}function d(f){if(!Array.isArray(f))return!1;for(let h=0,b=f.length;h<b;h++)if(typeof f[h]!="string")return!1;return!0}}),define(ne[111],se([0,1,14,29]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=void 0;async function O(A,L,E){let u=E&&E.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const P=(await L.readFile(A.serviceMachineIdResource)).value.toString();u=(0,D.$2e)(P)?P:null}catch{u=null}if(!u){u=(0,D.$3e)();try{await L.writeFile(A.serviceMachineIdResource,N.$Ib.fromString(u))}catch{}}return E?.store("storage.serviceMachineId",u,-1,1),u}e.$Mo=O}),define(ne[48],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=void 0;class N{constructor(O,A=[],L=!1){this.ctor=O,this.staticArguments=A,this.supportsDelayedInstantiation=L}}e.$ih=N}),define(ne[112],se([0,1,48]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.InstantiationType=void 0;const D=[];var O;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(O||(e.InstantiationType=O={}));function A(E,u,l){u instanceof N.$ih||(u=new N.$ih(u,[],!!l)),D.push([E,u])}e.$8q=A;function L(){return D}e.$9q=L}),define(ne[113],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=void 0;class N{constructor(A,L){this.key=A,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$Op=N;class D{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const L of this.a.values())L.outgoing.size===0&&A.push(L);return A}insertEdge(A,L){const E=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(L);E.outgoing.set(u.key,u),u.incoming.set(E.key,E)}removeNode(A){const L=this.b(A);this.a.delete(L);for(const E of this.a.values())E.outgoing.delete(L),E.incoming.delete(L)}lookupOrInsertNode(A){const L=this.b(A);let E=this.a.get(L);return E||(E=new N(L,A),this.a.set(L,E)),E}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[L,E]of this.a)A.push(`${L}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,L]of this.a){const E=new Set([A]),u=this.c(L,E);if(u)return u}}c(A,L){for(const[E,u]of A.outgoing){if(L.has(E))return[...L,E].join(" -> ");L.add(E);const l=this.c(u,L);if(l)return l;L.delete(E)}}}e.$Pp=D}),define(ne[24],se([0,1,3,11,10]),function(G,e,N,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.ConfigurationTarget=e.$Th=e.$Sh=e.$Rh=void 0,e.$Rh=(0,O.$lh)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof D.URI)}e.$Sh=A;function L(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof D.URI)}e.$Th=L;var E;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function u(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Uh=u;function l(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}e.$Vh=l;function P(f,h){const b=Object.create(null);for(const g in f)S(b,g,f[g],h);return b}e.$Wh=P;function S(f,h,b,g){const y=h.split("."),t=y.pop();let o=f;for(let n=0;n<y.length;n++){const i=y[n];let s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${h} as ${y.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[t]=b}catch{g(`Ignoring ${h} as ${y.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${h} as ${y.join(".")} is ${JSON.stringify(o)}`)}e.$Xh=S;function p(f,h){const b=h.split(".");m(f,b)}e.$Yh=p;function m(f,h){const b=h.shift();if(h.length===0){delete f[b];return}if(Object.keys(f).indexOf(b)!==-1){const g=f[b];typeof g=="object"&&!Array.isArray(g)&&(m(g,h),Object.keys(g).length===0&&delete f[b])}}function j(f,h,b){function g(o,n){let i=o;for(const s of n){if(typeof i!="object"||i===null)return;i=i[s]}return i}const y=h.split("."),t=g(f,y);return typeof t>"u"?b:t}e.$Zh=j;function v(f,h,b){Object.keys(h).forEach(g=>{g!=="__proto__"&&(g in f?N.$ie(f[g])&&N.$ie(h[g])?v(f[g],h[g],b):b&&(f[g]=h[g]):f[g]=h[g])})}e.$1h=v;function d(f){return f.replace(/[\[\]]/g,"")}e.$2h=d}),define(ne[114],se([0,1,12,28,106,10,87,9]),function(G,e,N,D,O,A,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.ContextKeyExprType=e.$pi=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",N.$j),u.set("isLinux",N.$k),u.set("isWindows",N.$i),u.set("isWeb",N.$o),u.set("isMacNative",N.$j&&!N.$o),u.set("isEdge",N.$G),u.set("isFirefox",N.$E),u.set("isChrome",N.$D),u.set("isSafari",N.$F);function l(R,r){if(u.get(R)!==void 0)throw(0,E.$4)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(R,r)}e.$pi=l;const P=Object.prototype.hasOwnProperty;var S;(function(R){R[R.False=0]="False",R[R.True=1]="True",R[R.Defined=2]="Defined",R[R.Not=3]="Not",R[R.Equals=4]="Equals",R[R.NotEquals=5]="NotEquals",R[R.And=6]="And",R[R.Regex=7]="Regex",R[R.NotRegex=8]="NotRegex",R[R.Or=9]="Or",R[R.In=10]="In",R[R.NotIn=11]="NotIn",R[R.Greater=12]="Greater",R[R.GreaterEquals=13]="GreaterEquals",R[R.Smaller=14]="Smaller",R[R.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const p={regexParsingWithErrorRecovery:!0},m=(0,L.localize)(0,null),j=(0,L.localize)(1,null),v=(0,L.localize)(2,null),d=(0,L.localize)(3,null),f=(0,L.localize)(4,null),h=(0,L.localize)(5,null),b=(0,L.localize)(6,null),g=(0,L.localize)(7,null);class y{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(r=p){this.k=r,this.d=new O.$oi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(r){if(r===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:j});return}this.f=this.d.reset(r).scan(),this.g=0,this.h=[];try{const k=this.l();if(!this.E()){const T=this.D(),B=T.type===17?h:void 0;throw this.h.push({message:f,offset:T.offset,lexeme:O.$oi.getLexeme(T),additionalInfo:B}),y.c}return k}catch(k){if(k!==y.c)throw k;return}}l(){return this.m()}m(){const r=[this.o()];for(;this.y(16);){const k=this.o();r.push(k)}return r.length===1?r[0]:t.or(...r)}o(){const r=[this.s()];for(;this.y(15);){const k=this.s();r.push(k)}return r.length===1?r[0]:t.and(...r)}s(){if(this.y(2)){const r=this.D();switch(r.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const k=this.l();return this.A(1,d),k?.negate()}case 17:return this.z(),Q.create(r.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",r)}}return this.t()}t(){const r=this.D();switch(r.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const k=this.l();return this.A(1,d),k}case 17:{const k=r.lexeme;if(this.z(),this.y(9)){const B=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),B.type!==10)throw this.B("REGEX",B);const Z=B.lexeme,_=Z.lastIndexOf("/"),re=_===Z.length-1?void 0:this.w(Z.substring(_+1));let de;try{de=new RegExp(Z.substring(1,_),re)}catch{throw this.B("REGEX",B)}return le.create(k,de)}switch(B.type){case 10:case 19:{const Z=[B.lexeme];this.z();let _=this.D(),re=0;for(let ae=0;ae<B.lexeme.length;ae++)B.lexeme.charCodeAt(ae)===40?re++:B.lexeme.charCodeAt(ae)===41&&re--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let ae=0;ae<_.lexeme.length;ae++)_.lexeme.charCodeAt(ae)===40?re++:B.lexeme.charCodeAt(ae)===41&&re--}if(re<0)break;Z.push(O.$oi.getLexeme(_)),this.z(),_=this.D()}const de=Z.join(""),$e=de.lastIndexOf("/"),he=$e===de.length-1?void 0:this.w(de.substring($e+1));let me;try{me=new RegExp(de.substring(1,$e),he)}catch{throw this.B("REGEX",B)}return t.regex(k,me)}case 18:{const Z=B.lexeme;this.z();let _=null;if(!(0,D.$hd)(Z)){const re=Z.indexOf("/"),de=Z.lastIndexOf("/");if(re!==de&&re>=0){const $e=Z.slice(re+1,de),he=Z[de+1]==="i"?"i":"";try{_=new RegExp($e,he)}catch{throw this.B("REGEX",B)}}}if(_===null)throw this.B("REGEX",B);return le.create(k,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const B=this.u();return t.notIn(k,B)}switch(this.D().type){case 3:{this.z();const B=this.u();if(this.x().type===18)return t.equals(k,B);switch(B){case"true":return t.has(k);case"false":return t.not(k);default:return t.equals(k,B)}}case 4:{this.z();const B=this.u();if(this.x().type===18)return t.notEquals(k,B);switch(B){case"true":return t.not(k);case"false":return t.has(k);default:return t.notEquals(k,B)}}case 5:return this.z(),x.create(k,this.u());case 6:return this.z(),ce.create(k,this.u());case 7:return this.z(),ie.create(k,this.u());case 8:return this.z(),ue.create(k,this.u());case 13:return this.z(),t.in(k,this.u());default:return t.has(k)}}case 20:throw this.h.push({message:b,offset:r.offset,lexeme:"",additionalInfo:g}),y.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const r=this.D();switch(r.type){case 17:case 18:return this.z(),r.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(r){return r.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(r){return this.C(r)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(r,k){if(this.C(r))return this.z();throw this.B(k,this.D())}B(r,k,T){const B=(0,L.localize)(8,null,r,O.$oi.getLexeme(k)),Z=k.offset,_=O.$oi.getLexeme(k);return this.h.push({message:B,offset:Z,lexeme:_,additionalInfo:T}),y.c}C(r){return this.D().type===r}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$qi=y,y.c=new Error;class t{static false(){return s.INSTANCE}static true(){return a.INSTANCE}static has(r){return c.create(r)}static equals(r,k){return I.create(r,k)}static notEquals(r,k){return M.create(r,k)}static regex(r,k){return le.create(r,k)}static in(r,k){return w.create(r,k)}static notIn(r,k){return $.create(r,k)}static not(r){return Q.create(r)}static and(...r){return H.create(r,null,!0)}static or(...r){return F.create(r,null,!0)}static greater(r,k){return ie.create(r,k)}static greaterEquals(r,k){return ue.create(r,k)}static smaller(r,k){return x.create(r,k)}static smallerEquals(r,k){return ce.create(r,k)}static deserialize(r){return r==null?void 0:this.c.parse(r)}}e.$ri=t,t.c=new y({regexParsingWithErrorRecovery:!1});function o(R){const r=new y({regexParsingWithErrorRecovery:!1});return R.map(k=>(r.parse(k),r.lexingErrors.length>0?r.lexingErrors.map(T=>({errorMessage:T.additionalInfo?(0,L.localize)(9,null,T.additionalInfo):(0,L.localize)(10,null),offset:T.offset,length:T.lexeme.length})):r.parsingErrors.length>0?r.parsingErrors.map(T=>({errorMessage:T.additionalInfo?`${T.message}. ${T.additionalInfo}`:T.message,offset:T.offset,length:T.lexeme.length})):[]))}e.$si=o;function n(R,r){const k=R?R.substituteConstants():void 0,T=r?r.substituteConstants():void 0;return!k&&!T?!0:!k||!T?!1:k.equals(T)}e.$ti=n;function i(R,r){return R.cmp(r)}class s{constructor(){this.type=0}cmp(r){return this.type-r.type}equals(r){return r.type===this.type}substituteConstants(){return this}evaluate(r){return!1}serialize(){return"false"}keys(){return[]}map(r){return this}negate(){return a.INSTANCE}}e.$ui=s,s.INSTANCE=new s;class a{constructor(){this.type=1}cmp(r){return this.type-r.type}equals(r){return r.type===this.type}substituteConstants(){return this}evaluate(r){return!0}serialize(){return"true"}keys(){return[]}map(r){return this}negate(){return s.INSTANCE}}e.$vi=a,a.INSTANCE=new a;class c{static create(r,k=null){const T=u.get(r);return typeof T=="boolean"?T?a.INSTANCE:s.INSTANCE:new c(r,k)}constructor(r,k){this.key=r,this.c=k,this.type=2}cmp(r){return r.type!==this.type?this.type-r.type:W(this.key,r.key)}equals(r){return r.type===this.type?this.key===r.key:!1}substituteConstants(){const r=u.get(this.key);return typeof r=="boolean"?r?a.INSTANCE:s.INSTANCE:this}evaluate(r){return!!r.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(r){return r.mapDefined(this.key)}negate(){return this.c||(this.c=Q.create(this.key,this)),this.c}}e.$wi=c;class I{static create(r,k,T=null){if(typeof k=="boolean")return k?c.create(r,T):Q.create(r,T);const B=u.get(r);return typeof B=="boolean"?k===(B?"true":"false")?a.INSTANCE:s.INSTANCE:new I(r,k,T)}constructor(r,k,T){this.c=r,this.d=k,this.f=T,this.type=4}cmp(r){return r.type!==this.type?this.type-r.type:X(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){const r=u.get(this.c);if(typeof r=="boolean"){const k=r?"true":"false";return this.d===k?a.INSTANCE:s.INSTANCE}return this}evaluate(r){return r.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(r){return r.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$xi=I;class w{static create(r,k){return new w(r,k)}constructor(r,k){this.d=r,this.f=k,this.type=10,this.c=null}cmp(r){return r.type!==this.type?this.type-r.type:X(this.d,this.f,r.d,r.f)}equals(r){return r.type===this.type?this.d===r.d&&this.f===r.f:!1}substituteConstants(){return this}evaluate(r){const k=r.getValue(this.f),T=r.getValue(this.d);return Array.isArray(k)?k.includes(T):typeof T=="string"&&typeof k=="object"&&k!==null?P.call(k,T):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(r){return r.mapIn(this.d,this.f)}negate(){return this.c||(this.c=$.create(this.d,this.f)),this.c}}e.$yi=w;class ${static create(r,k){return new $(r,k)}constructor(r,k){this.d=r,this.f=k,this.type=11,this.c=w.create(r,k)}cmp(r){return r.type!==this.type?this.type-r.type:this.c.cmp(r.c)}equals(r){return r.type===this.type?this.c.equals(r.c):!1}substituteConstants(){return this}evaluate(r){return!this.c.evaluate(r)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(r){return r.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$zi=$;class M{static create(r,k,T=null){if(typeof k=="boolean")return k?Q.create(r,T):c.create(r,T);const B=u.get(r);return typeof B=="boolean"?k===(B?"true":"false")?s.INSTANCE:a.INSTANCE:new M(r,k,T)}constructor(r,k,T){this.c=r,this.d=k,this.f=T,this.type=5}cmp(r){return r.type!==this.type?this.type-r.type:X(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){const r=u.get(this.c);if(typeof r=="boolean"){const k=r?"true":"false";return this.d===k?s.INSTANCE:a.INSTANCE}return this}evaluate(r){return r.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(r){return r.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ai=M;class Q{static create(r,k=null){const T=u.get(r);return typeof T=="boolean"?T?s.INSTANCE:a.INSTANCE:new Q(r,k)}constructor(r,k){this.c=r,this.d=k,this.type=3}cmp(r){return r.type!==this.type?this.type-r.type:W(this.c,r.c)}equals(r){return r.type===this.type?this.c===r.c:!1}substituteConstants(){const r=u.get(this.c);return typeof r=="boolean"?r?s.INSTANCE:a.INSTANCE:this}evaluate(r){return!r.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(r){return r.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.$Bi=Q;function J(R,r){if(typeof R=="string"){const k=parseFloat(R);isNaN(k)||(R=k)}return typeof R=="string"||typeof R=="number"?r(R):s.INSTANCE}class ie{static create(r,k,T=null){return J(k,B=>new ie(r,B,T))}constructor(r,k,T){this.c=r,this.d=k,this.f=T,this.type=12}cmp(r){return r.type!==this.type?this.type-r.type:X(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){return this}evaluate(r){return typeof this.d=="string"?!1:parseFloat(r.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(r){return r.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Ci=ie;class ue{static create(r,k,T=null){return J(k,B=>new ue(r,B,T))}constructor(r,k,T){this.c=r,this.d=k,this.f=T,this.type=13}cmp(r){return r.type!==this.type?this.type-r.type:X(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){return this}evaluate(r){return typeof this.d=="string"?!1:parseFloat(r.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(r){return r.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Di=ue;class x{static create(r,k,T=null){return J(k,B=>new x(r,B,T))}constructor(r,k,T){this.c=r,this.d=k,this.f=T,this.type=14}cmp(r){return r.type!==this.type?this.type-r.type:X(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){return this}evaluate(r){return typeof this.d=="string"?!1:parseFloat(r.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(r){return r.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Ei=x;class ce{static create(r,k,T=null){return J(k,B=>new ce(r,B,T))}constructor(r,k,T){this.c=r,this.d=k,this.f=T,this.type=15}cmp(r){return r.type!==this.type?this.type-r.type:X(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){return this}evaluate(r){return typeof this.d=="string"?!1:parseFloat(r.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(r){return r.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Fi=ce;class le{static create(r,k){return new le(r,k)}constructor(r,k){this.d=r,this.f=k,this.type=7,this.c=null}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.d<r.d)return-1;if(this.d>r.d)return 1;const k=this.f?this.f.source:"",T=r.f?r.f.source:"";return k<T?-1:k>T?1:0}equals(r){if(r.type===this.type){const k=this.f?this.f.source:"",T=r.f?r.f.source:"";return this.d===r.d&&k===T}return!1}substituteConstants(){return this}evaluate(r){const k=r.getValue(this.d);return this.f?this.f.test(k):!1}serialize(){const r=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${r}`}keys(){return[this.d]}map(r){return r.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=oe.create(this)),this.c}}e.$Gi=le;class oe{static create(r){return new oe(r)}constructor(r){this.c=r,this.type=8}cmp(r){return r.type!==this.type?this.type-r.type:this.c.cmp(r.c)}equals(r){return r.type===this.type?this.c.equals(r.c):!1}substituteConstants(){return this}evaluate(r){return!this.c.evaluate(r)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(r){return new oe(this.c.map(r))}negate(){return this.c}}e.$Hi=oe;function V(R){let r=null;for(let k=0,T=R.length;k<T;k++){const B=R[k].substituteConstants();if(R[k]!==B&&r===null){r=[];for(let Z=0;Z<k;Z++)r[Z]=R[Z]}r!==null&&(r[k]=B)}return r===null?R:r}class H{static create(r,k,T){return H.d(r,k,T)}constructor(r,k){this.expr=r,this.c=k,this.type=6}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.expr.length<r.expr.length)return-1;if(this.expr.length>r.expr.length)return 1;for(let k=0,T=this.expr.length;k<T;k++){const B=i(this.expr[k],r.expr[k]);if(B!==0)return B}return 0}equals(r){if(r.type===this.type){if(this.expr.length!==r.expr.length)return!1;for(let k=0,T=this.expr.length;k<T;k++)if(!this.expr[k].equals(r.expr[k]))return!1;return!0}return!1}substituteConstants(){const r=V(this.expr);return r===this.expr?this:H.create(r,this.c,!1)}evaluate(r){for(let k=0,T=this.expr.length;k<T;k++)if(!this.expr[k].evaluate(r))return!1;return!0}static d(r,k,T){const B=[];let Z=!1;for(const _ of r)if(_){if(_.type===1){Z=!0;continue}if(_.type===0)return s.INSTANCE;if(_.type===6){B.push(..._.expr);continue}B.push(_)}if(B.length===0&&Z)return a.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(i);for(let _=1;_<B.length;_++)B[_-1].equals(B[_])&&(B.splice(_,1),_--);if(B.length===1)return B[0];for(;B.length>1;){const _=B[B.length-1];if(_.type!==9)break;B.pop();const re=B.pop(),de=B.length===0,$e=F.create(_.expr.map(he=>H.create([he,re],null,T)),null,de);$e&&(B.push($e),B.sort(i))}if(B.length===1)return B[0];if(T){for(let _=0;_<B.length;_++)for(let re=_+1;re<B.length;re++)if(B[_].negate().equals(B[re]))return s.INSTANCE;if(B.length===1)return B[0]}return new H(B,k)}}serialize(){return this.expr.map(r=>r.serialize()).join(" && ")}keys(){const r=[];for(const k of this.expr)r.push(...k.keys());return r}map(r){return new H(this.expr.map(k=>k.map(r)),null)}negate(){if(!this.c){const r=[];for(const k of this.expr)r.push(k.negate());this.c=F.create(r,this,!0)}return this.c}}e.$Ii=H;class F{static create(r,k,T){return F.d(r,k,T)}constructor(r,k){this.expr=r,this.c=k,this.type=9}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.expr.length<r.expr.length)return-1;if(this.expr.length>r.expr.length)return 1;for(let k=0,T=this.expr.length;k<T;k++){const B=i(this.expr[k],r.expr[k]);if(B!==0)return B}return 0}equals(r){if(r.type===this.type){if(this.expr.length!==r.expr.length)return!1;for(let k=0,T=this.expr.length;k<T;k++)if(!this.expr[k].equals(r.expr[k]))return!1;return!0}return!1}substituteConstants(){const r=V(this.expr);return r===this.expr?this:F.create(r,this.c,!1)}evaluate(r){for(let k=0,T=this.expr.length;k<T;k++)if(this.expr[k].evaluate(r))return!0;return!1}static d(r,k,T){let B=[],Z=!1;if(r){for(let _=0,re=r.length;_<re;_++){const de=r[_];if(de){if(de.type===0){Z=!0;continue}if(de.type===1)return a.INSTANCE;if(de.type===9){B=B.concat(de.expr);continue}B.push(de)}}if(B.length===0&&Z)return s.INSTANCE;B.sort(i)}if(B.length!==0){if(B.length===1)return B[0];for(let _=1;_<B.length;_++)B[_-1].equals(B[_])&&(B.splice(_,1),_--);if(B.length===1)return B[0];if(T){for(let _=0;_<B.length;_++)for(let re=_+1;re<B.length;re++)if(B[_].negate().equals(B[re]))return a.INSTANCE;if(B.length===1)return B[0]}return new F(B,k)}}serialize(){return this.expr.map(r=>r.serialize()).join(" || ")}keys(){const r=[];for(const k of this.expr)r.push(...k.keys());return r}map(r){return new F(this.expr.map(k=>k.map(r)),null)}negate(){if(!this.c){const r=[];for(const k of this.expr)r.push(k.negate());for(;r.length>1;){const k=r.shift(),T=r.shift(),B=[];for(const Z of C(k))for(const _ of C(T))B.push(H.create([Z,_],null,!1));r.unshift(F.create(B,null,!1))}this.c=F.create(r,this,!0)}return this.c}}e.$Ji=F;class U extends c{static all(){return U.d.values()}constructor(r,k,T){super(r,null),this.f=k,typeof T=="object"?U.d.push({...T,key:r}):T!==!0&&U.d.push({key:r,description:T,type:k!=null?typeof k:void 0})}bindTo(r){return r.createKey(this.key,this.f)}getValue(r){return r.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(r){return I.create(this.key,r)}notEqualsTo(r){return M.create(this.key,r)}}e.$Ki=U,U.d=[],e.$Li=(0,A.$lh)("contextKeyService");function W(R,r){return R<r?-1:R>r?1:0}function X(R,r,k,T){return R<k?-1:R>k?1:r<T?-1:r>T?1:0}function Y(R,r){if(R.type===0||r.type===1)return!0;if(R.type===9)return r.type===9?z(R.expr,r.expr):!1;if(r.type===9){for(const k of r.expr)if(Y(R,k))return!0;return!1}if(R.type===6){if(r.type===6)return z(r.expr,R.expr);for(const k of R.expr)if(Y(k,r))return!0;return!1}return R.equals(r)}e.$Mi=Y;function z(R,r){let k=0,T=0;for(;k<R.length&&T<r.length;){const B=R[k].cmp(r[T]);if(B<0)return!1;B===0&&k++,T++}return k===R.length}function C(R){return R.type===9?R.expr:[R]}}),define(ne[59],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0,e.$qn=(0,N.$lh)("downloadService")}),define(ne[18],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=void 0,e.$sh=(0,N.$lh)("environmentService"),e.$th=(0,N.$mh)(e.$sh)}),define(ne[20],se([0,1,90,10]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ln=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=void 0,e.$zn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$An=new RegExp(e.$zn),e.$Bn="__web_extension",e.$Cn="skipWalkthrough",e.$Dn="extensionsSync";function O(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$En=O;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Fn=A;function L(h,b){switch(h){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Gn=L;function E(h,b){return b==="web"&&!h.includes("web")}e.$Hn=E;function u(h,b,g){return E(b,g)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===g?!0:l(g).includes(h)}e.$In=u;function l(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Jn=l;function P(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$Kn=P;var S;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var p;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var m;(function(h){h.Install="install",h.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var j;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(j||(e.InstallOperation=j={})),e.$Ln=(0,D.$lh)("extensionGalleryService");var v;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var d;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(d||(e.ExtensionSignaturetErrorCode=d={}));class f extends Error{constructor(b,g){super(b),this.code=g,this.name=g}}e.$Mn=f,e.$Nn=(0,D.$lh)("extensionManagementService"),e.$On="extensionsIdentifiers/disabled",e.$Pn="extensionsIdentifiers/enabled",e.$Qn=(0,D.$lh)("IGlobalExtensionEnablementService"),e.$Rn=(0,D.$lh)("IExtensionTipsService"),e.$Sn=(0,N.localize)(0,null),e.$Tn={value:e.$Sn,original:"Extensions"},e.$Un={value:(0,N.localize)(1,null),original:"Preferences"}}),define(ne[60],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=void 0,e.$Ro=(0,N.$lh)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((A,L)=>G(["node-vsce-sign"],async E=>A(E),L))),this.a}async verify(A,L,E){let u;try{u=await this.b()}catch{return!1}return u.verify(A,L,E)}}e.$So=D}),define(ne[61],se([0,1,14,9,98,13]),function(G,e,N,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;async function L(P,S,p,m,j,v){let d;try{await E(P,S,p,m,j,v)}catch(f){d=f}finally{d&&j.errorTransformer&&(d=j.errorTransformer(d)),typeof d<"u"&&p.error(d),p.end()}}e.$np=L;async function E(P,S,p,m,j,v){u(v);const d=await P.open(S,{create:!1});try{u(v);let f=0,h=0,b=j&&typeof j.length=="number"?j.length:void 0,g=N.$Ib.alloc(Math.min(j.bufferSize,typeof b=="number"?b:j.bufferSize)),y=j&&typeof j.position=="number"?j.position:0,t=0;do h=await P.read(d,y,g.buffer,t,g.byteLength-t),y+=h,t+=h,f+=h,typeof b=="number"&&(b-=h),t===g.byteLength&&(await p.write(m(g)),g=N.$Ib.alloc(Math.min(j.bufferSize,typeof b=="number"?b:j.bufferSize)),t=0);while(h>0&&(typeof b!="number"||b>0)&&u(v)&&l(f,j));if(t>0){let o=t;typeof b=="number"&&(o=Math.min(t,b)),p.write(m(g.slice(0,o)))}}catch(f){throw(0,A.$2j)(f)}finally{await P.close(d)}}function u(P){if(P.isCancellationRequested)throw(0,D.$3)();return!0}function l(P,S){if(typeof S?.limits?.size=="number"&&P>S.limits.size)throw(0,A.$1j)((0,O.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[115],se([0,1,5,163,2,12,164]),function(G,e,N,D,O,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;class E extends O.$kb{constructor(){super(...arguments),this.a=this.B(new N.$5c),this.onDidChangeFile=this.a.event,this.b=this.B(new N.$5c),this.onDidLogMessage=this.b.event,this.onDidError=N.Event.None,this.c=new Map,this.f=!1}async watch(l){const P=this.i(l),S=P.filter(m=>{const j=this.c.get(m.path);return j?!(0,D.$ej)(j.request.excludes,m.excludes)||!(0,D.$ej)(j.request.includes,m.includes):!0}),p=Array.from(this.c.values()).filter(({request:m})=>!P.find(j=>j.path===m.path&&(0,D.$ej)(j.excludes,m.excludes)&&(0,D.$ej)(j.includes,m.includes))).map(({request:m})=>m.path);S.length&&this.j(`Request to start watching: ${S.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const m of p)this.h(m);for(const m of S)this.g(m)}g(l){const P=new L.$Jp(l,p=>this.a.fire(p),p=>this.b.fire(p),this.f),S={request:l,instance:P};this.c.set(l.path,S)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const P=this.c.get(l);P&&(this.c.delete(l),P.instance.dispose())}i(l){const P=new Map;for(const S of l){const p=A.$k?S.path:S.path.toLowerCase();P.set(p,S)}return Array.from(P.values())}async setVerboseLogging(l){this.f=l;for(const[,P]of this.c)P.instance.setVerboseLogging(l)}j(l){this.f&&this.b.fire({type:"trace",message:this.k(l)})}k(l,P){return P?`[File Watcher (node.js)] ${l} (path: ${P.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$Lp=E}),define(ne[116],se([0,1,62,115]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class O extends N.$rp{constructor(L,E,u){super(L,E,u),this.m()}l(){return new D.$Lp}}e.$Mp=O}),define(ne[117],se([0,1,16,57,83,62]),function(G,e,N,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;class L extends A.$sp{constructor(u,l,P){super(u,l,P),this.m()}l(u){const l=u.add(new O.$Dp(N.$1e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(l.onDidProcessExit(({code:P,signal:S})=>this.n(`terminated by itself with code ${P}, signal: ${S}`))),D.ProxyChannel.toService((0,D.$5g)(l.getChannel("watcher")))}}e.$Ep=L}),define(ne[63],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=void 0;class N{constructor(...O){this.a=new Map;for(const[A,L]of O)this.set(A,L)}set(O,A){const L=this.a.get(O);return this.a.set(O,A),L}has(O){return this.a.has(O)}get(O){return this.a.get(O)}}e.$jh=N}),define(ne[118],se([0,1,8,9,2,48,113,10,63,165]),function(G,e,N,D,O,A,L,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0;const P=!1;class S extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class p{constructor(d=new u.$jh,f=!1,h,b=P){this.f=d,this.g=f,this.h=h,this.i=b,this.o=new Set,this.f.set(E.$kh,this),this._globalGraph=b?h?._globalGraph??new L.$Pp(g=>g):void 0}createChild(d){return new p(d,this.g,this,this.i)}invokeFunction(d,...f){const h=j.traceInvocation(this.i,d);let b=!1;try{return d({get:y=>{if(b)throw(0,D.$5)("service accessor is only valid during the invocation of its target method");const t=this.m(y,h);if(!t)throw new Error(`[invokeFunction] unknown service '${y}'`);return t}},...f)}finally{b=!0,h.stop()}}createInstance(d,...f){let h,b;return d instanceof A.$ih?(h=j.traceCreation(this.i,d.ctor),b=this.j(d.ctor,d.staticArguments.concat(f),h)):(h=j.traceCreation(this.i,d),b=this.j(d,f,h)),h.stop(),b}j(d,f=[],h){const b=E._util.getServiceDependencies(d).sort((t,o)=>t.index-o.index),g=[];for(const t of b){const o=this.m(t.id,h);o||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),g.push(o)}const y=b.length>0?b[0].index:f.length;if(f.length!==y){console.trace(`[createInstance] First service dependency of ${d.name} at position ${y+1} conflicts with ${f.length} static arguments`);const t=y-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,y)}return Reflect.construct(d,f.concat(g))}k(d,f){if(this.f.get(d)instanceof A.$ih)this.f.set(d,f);else if(this.h)this.h.k(d,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const f=this.f.get(d);return!f&&this.h?this.h.l(d):f}m(d,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const h=this.l(d);return h instanceof A.$ih?this.q(d,h,f.branch(d,!0)):(f.branch(d,!1),h)}q(d,f,h){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,f,h)}finally{this.o.delete(d)}}r(d,f,h){const b=new L.$Pp(t=>t.id.toString());let g=0;const y=[{id:d,desc:f,_trace:h}];for(;y.length;){const t=y.pop();if(b.lookupOrInsertNode(t),g++>1e3)throw new S(b);for(const o of E._util.getServiceDependencies(t.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${d} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),n instanceof A.$ih){const i={id:o.id,desc:n,_trace:t._trace.branch(o.id,!0)};b.insertEdge(t,i),y.push(i)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new S(b);break}for(const{data:o}of t){if(this.l(o.id)instanceof A.$ih){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}b.removeNode(o)}}return this.l(d)}s(d,f,h=[],b,g){if(this.f.get(d)instanceof A.$ih)return this.t(d,f,h,b,g);if(this.h)return this.h.s(d,f,h,b,g);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(d,f,h=[],b,g){if(b){const y=new p(void 0,this.g,this,this.i);y.c=String(d);const t=new Map,o=new N.$Hg(()=>{const n=y.j(f,h,g);for(const[i,s]of t){const a=n[i];if(typeof a=="function")for(const c of s)a.apply(n,c)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let c=t.get(i);return c||(c=new l.$jc,t.set(i,c)),(w,$,M)=>{const Q=c.push([w,$,M]);return(0,O.$ib)(Q)}}if(i in n)return n[i];const s=o.value;let a=s[i];return typeof a!="function"||(a=a.bind(s),n[i]=a),a},set(n,i,s){return o.value[i]=s,!0},getPrototypeOf(n){return f.prototype}})}else return this.j(f,h,g)}u(d,f){if(f&&console.warn(d),this.g)throw new Error(d)}}e.$Qp=p;var m;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(m||(m={}));class j{static traceInvocation(d,f){return d?new j(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):j.c}static traceCreation(d,f){return d?new j(1,f.name):j.c}constructor(d,f){this.type=d,this.name=f,this.g=Date.now(),this.h=[]}branch(d,f){const h=new j(3,d.toString());return this.h.push([d,f,h]),h}stop(){const d=Date.now()-this.g;j.f+=d;let f=!1;function h(g,y){const t=[],o=new Array(g+1).join("	");for(const[n,i,s]of y.h)if(i&&s){f=!0,t.push(`${o}CREATES -> ${n}`);const a=h(g+1,s);a&&t.push(a)}else t.push(`${o}uses -> ${n}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${j.f.toFixed(2)}ms)`];(d>2||f)&&j.all.add(b.join(`
`))}}e.$Rp=j,j.all=new Set,j.c=new class extends j{constructor(){super(0,null)}stop(){}branch(){return this}},j.f=0});var te=this&&this.__param||function(G,e){return function(N,D){e(N,D,G)}};define(ne[64],se([0,1,23,2,12,100,20,10]),function(G,e,N,D,O,A,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=e.$sq=void 0;function u(P){return P.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.$sq=u,e.$tq=(0,E.$lh)("languagePackService");let l=e.$uq=class extends D.$kb{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new N.$bd;setTimeout(()=>S.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const j=p.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some(d=>d.startsWith("lp-"))).map(v=>{const d=v.properties.localizedLanguages?.[0],f=u(v);return{...this.f(f,d,v),extensionId:v.identifier.id,galleryExtension:v}});return j.push(this.f("en","English")),j}f(S,p,m){const j=p??S;let v;if(j!==S&&(v=`(${S})`),S.toLowerCase()===O.$v.toLowerCase()&&(v??="",v+=(0,A.localize)(0,null)),m?.installCount){v??="";const d=m.installCount;let f;d>1e6?f=`${Math.floor(d/1e5)/10}M`:d>1e3?f=`${Math.floor(d/1e3)}K`:f=String(d),v+=` $(cloud-download) ${f}`}return{id:S,label:j,description:v}}};e.$uq=l=pe([te(0,L.$Ln)],l)}),define(ne[6],se([0,1,33,5,45,2,35,12,17,3,11,114,10]),function(G,e,N,D,O,A,L,E,u,l,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.log=e.$Qi=e.LogLevel=e.$Pi=e.$Oi=e.$Ni=void 0,e.$Ni=(0,p.$lh)("logService"),e.$Oi=(0,p.$lh)("loggerService");function m(){return new Date().toISOString()}function j(w){return(0,l.$ke)(w)}e.$Pi=j;var v;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$Qi=v.Info;function d(w,$,M){switch($){case v.Trace:w.trace(M);break;case v.Debug:w.debug(M);break;case v.Info:w.info(M);break;case v.Warning:w.warn(M);break;case v.Error:w.error(M);break;case v.Off:break;default:throw new Error(`Invalid log level ${$}`)}}e.log=d;function f(w,$=!1){let M="";for(let Q=0;Q<w.length;Q++){let J=w[Q];if(J instanceof Error&&(J=(0,N.$9h)(J,$)),typeof J=="object")try{J=JSON.stringify(J)}catch{}M+=(Q>0?" ":"")+J}return M}class h extends A.$kb{constructor(){super(...arguments),this.b=e.$Qi,this.c=this.B(new D.$5c),this.onDidChangeLogLevel=this.c.event}setLevel($){this.b!==$&&(this.b=$,this.c.fire(this.b))}getLevel(){return this.b}f($){return this.b!==v.Off&&this.b<=$}}e.$Si=h;class b extends h{constructor($){super(),this.h=$}f($){return this.h||super.f($)}trace($,...M){this.f(v.Trace)&&this.g(v.Trace,f([$,...M],!0))}debug($,...M){this.f(v.Debug)&&this.g(v.Debug,f([$,...M]))}info($,...M){this.f(v.Info)&&this.g(v.Info,f([$,...M]))}warn($,...M){this.f(v.Warning)&&this.g(v.Warning,f([$,...M]))}error($,...M){if(this.f(v.Error))if($ instanceof Error){const Q=Array.prototype.slice.call(arguments);Q[0]=$.stack,this.g(v.Error,f(Q))}else this.g(v.Error,f([$,...M]))}flush(){}}e.$Ti=b;class g extends h{constructor($=e.$Qi){super(),this.setLevel($),this.g=!E.$i}trace($,...M){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,$,...M):console.log(`[main ${m()}]`,$,...M))}debug($,...M){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,$,...M):console.log(`[main ${m()}]`,$,...M))}info($,...M){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,$,...M):console.log(`[main ${m()}]`,$,...M))}warn($,...M){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,$,...M):console.warn(`[main ${m()}]`,$,...M))}error($,...M){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,$,...M):console.error(`[main ${m()}]`,$,...M))}dispose(){}flush(){}}e.$Ui=g;class y extends h{constructor($=e.$Qi,M=!0){super(),this.g=M,this.setLevel($)}trace($,...M){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",$,...M):console.log($,...M))}debug($,...M){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",$,...M):console.log($,...M))}info($,...M){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",$,...M):console.log($,...M))}warn($,...M){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",$,...M):console.log($,...M))}error($,...M){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",$,...M):console.error($,...M))}dispose(){}flush(){}}e.$Vi=y;class t extends h{constructor($,M=e.$Qi){super(),this.g=$,this.setLevel(M)}trace($,...M){this.f(v.Trace)&&this.g.log(v.Trace,[this.h($),...M])}debug($,...M){this.f(v.Debug)&&this.g.log(v.Debug,[this.h($),...M])}info($,...M){this.f(v.Info)&&this.g.log(v.Info,[this.h($),...M])}warn($,...M){this.f(v.Warning)&&this.g.log(v.Warning,[this.h($),...M])}error($,...M){this.f(v.Error)&&this.g.log(v.Error,[this.h($),...M])}h($){return typeof $=="string"?$:(0,N.$9h)($,this.f(v.Trace))}dispose(){}flush(){}}e.$Wi=t;class o extends h{constructor($){super(),this.g=$,$.length&&this.setLevel($[0].getLevel())}setLevel($){for(const M of this.g)M.setLevel($);super.setLevel($)}trace($,...M){for(const Q of this.g)Q.trace($,...M)}debug($,...M){for(const Q of this.g)Q.debug($,...M)}info($,...M){for(const Q of this.g)Q.info($,...M)}warn($,...M){for(const Q of this.g)Q.warn($,...M)}error($,...M){for(const Q of this.g)Q.error($,...M)}flush(){for(const $ of this.g)$.flush()}dispose(){for(const $ of this.g)$.dispose()}}e.$Xi=o;class n extends A.$kb{constructor($,M,Q){if(super(),this.h=$,this.j=M,this.b=new L.$ji,this.c=this.B(new D.$5c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$5c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$5c),this.onDidChangeVisibility=this.g.event,Q)for(const J of Q)this.b.set(J.resource,{logger:void 0,info:J})}k($){return(0,l.$ge)($)?[...this.b.values()].find(M=>M.info.id===$):this.b.get($)}getLogger($){return this.k($)?.logger}createLogger($,M){const Q=this.l($),J=(0,l.$ge)($)?$:M?.id??(0,O.$_h)(Q.toString()).toString(16);let ie=this.b.get(Q)?.logger;const ue=M?.logLevel==="always"?v.Trace:M?.logLevel;ie||(ie=this.m(Q,ue??this.getLogLevel(Q)??this.h,{...M,id:J}));const x={logger:ie,info:{resource:Q,id:J,logLevel:ue,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(x.info),this.b.set(Q,x),ie}l($){return(0,l.$ge)($)?(0,u.$6f)(this.j,`${$}.log`):$}setLogLevel($,M){if(P.URI.isUri($)){const Q=$,J=M,ie=this.b.get(Q);ie&&J!==ie.info.logLevel&&(ie.info.logLevel=J===this.h?void 0:J,ie.logger?.setLevel(J),this.b.set(ie.info.resource,ie),this.f.fire([Q,J]))}else{this.h=$;for(const[Q,J]of this.b.entries())this.b.get(Q)?.info.logLevel===void 0&&J.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility($,M){const Q=this.k($);Q&&M!==!Q.info.hidden&&(Q.info.hidden=!M,this.b.set(Q.info.resource,Q),this.g.fire([Q.info.resource,M]))}getLogLevel($){let M;return $&&(M=this.b.get($)?.info.logLevel),M??this.h}registerLogger($){const M=this.b.get($.resource);M?M.info.hidden!==$.hidden&&this.setVisibility($.resource,!$.hidden):(this.b.set($.resource,{info:$,logger:void 0}),this.c.fire({added:[$],removed:[]}))}deregisterLogger($){const M=this.b.get($);M&&(M.logger&&M.logger.dispose(),this.b.delete($),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const $ of this.b.values())yield $.info}getRegisteredLogger($){return this.b.get($)?.info}dispose(){this.b.forEach($=>$.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yi=n;class i{constructor(){this.onDidChangeLogLevel=new D.$5c().event}setLevel($){}getLevel(){return v.Info}trace($,...M){}debug($,...M){}info($,...M){}warn($,...M){}error($,...M){}critical($,...M){}dispose(){}flush(){}}e.$Zi=i;class s extends i{}e.$1i=s;function a(w){if(w.verbose)return v.Trace;if(typeof w.logLevel=="string"){const $=I(w.logLevel.toLowerCase());if($!==void 0)return $}return e.$Qi}e.$2i=a;function c(w){switch(w){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$3i=c;function I(w){switch(w){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$4i=I,e.$5i=new S.$Ki("logLevel",c(v.Info))}),define(ne[119],se([0,1,19,8,9,5,2,15,62,6]),function(G,e,N,D,O,A,L,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;class P extends L.$kb{constructor(p,m){super(),this.a=p,this.b=m,this.c=this.B(new A.$5c),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$5c),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new D.$pg(0)),this.s=[],this.t=this.B(new D.$pg(0))}watch(p,m){return m.recursive||this.b?.watcher?.forceUniversal?this.l(p,m):this.u(p,m)}l(p,m){const j={path:this.C(p),excludes:m.excludes,includes:m.includes,recursive:m.recursive},v=(0,N.$yf)(this.j,j);return this.m(),(0,L.$ib)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,O.$X)(p))}n(){this.h||(this.h=this.B(this.p(m=>this.c.fire((0,u.$tp)(m)),m=>this.z(m),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const m of this.j)(0,u.$pp)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const m of this.j)(0,u.$pp)(m)&&p.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(p,m){const j={path:this.C(p),excludes:m.excludes,includes:m.includes,recursive:!1},v=(0,N.$yf)(this.s,j);return this.v(),(0,L.$ib)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(p=>(0,O.$X)(p))}w(){return this.r||(this.r=this.B(this.y(p=>this.c.fire((0,u.$tp)(p)),p=>this.z(p),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.r.watch(this.s)}z(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}C(p){return(0,E.$9b)(p.fsPath)}}e.$xp=P}),define(ne[120],se([0,1,19,8,14,23,5,45,65,2,54,16,121,17,44,97,13,61,6,9]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m,j,v,d,f,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;let g=e.$op=class extends l.$kb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new L.$5c),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$5c),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$5c),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new L.$5c),this.onDidRunOperation=this.m.event,this.R=this.B(new L.$5c),this.onDidFilesChange=this.R.event,this.S=this.B(new L.$5c),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new D.$zg)}registerProvider(t,o){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${t}`);const n=new l.$jb;return this.h.set(t,o),this.c.fire({added:!0,scheme:t,provider:o}),n.add(o.onDidChangeFile(i=>this.R.fire(new d.$7j(i,!this.O(o))))),typeof o.onDidWatchError=="function"&&n.add(o.onDidWatchError(i=>this.S.fire(new Error(i)))),n.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:t}))),(0,l.$ib)(()=>{this.c.fire({added:!1,scheme:t,provider:o}),this.h.delete(t),(0,l.$fb)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const o=[];this.f.fire({scheme:t,join(n){o.push(n)}}),!this.h.has(t)&&await D.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,o){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return u.Iterable.map(this.h,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async j(t){if(!(0,m.$0f)(t))throw new d.$9j((0,v.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const o=this.h.get(t.scheme);if(!o){const n=new b.$_;throw n.message=(0,v.localize)(1,null,t.toString()),n}return o}async k(t){const o=await this.j(t);if((0,d.$Tj)(o)||(0,d.$Qj)(o)||(0,d.$Uj)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const o=await this.j(t);if((0,d.$Tj)(o)||(0,d.$Qj)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.n(t,o)}catch(n){throw(0,d.$4j)(n)===d.FileSystemProviderErrorCode.FileNotFound?new d.$9j((0,v.localize)(2,null,this.nb(t)),1):(0,d.$2j)(n)}}async n(t,o){const n=await this.j(t),i=this.O(n),s=o?.resolveTo,a=o?.resolveSingleChildDescendants,c=o?.resolveMetadata,I=await n.stat(t);let w;return this.p(n,t,I,void 0,!!c,($,M)=>(w||(w=P.$rh.forUris(()=>!i),w.set(t,!0),s&&w.fill(!0,s)),w.get($.resource)||w.findSuperstr($.resource.with({query:null,fragment:null}))?!0:$.isDirectory&&a?M===1:!1))}async p(t,o,n,i,s,a){const{providerExtUri:c}=this.N(t),I={resource:o,name:c.basename(o),isFile:(n.type&d.FileType.File)!==0,isDirectory:(n.type&d.FileType.Directory)!==0,isSymbolicLink:(n.type&d.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&d.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((n.permissions??0)&d.FilePermission.Locked),etag:(0,d.$hk)({mtime:n.mtime,size:n.size}),children:void 0};if(I.isDirectory&&a(I,i)){try{const w=await t.readdir(o),$=await D.Promises.settled(w.map(async([M,Q])=>{try{const J=c.joinPath(o,M),ie=s?await t.stat(J):{type:Q};return await this.p(t,J,ie,w.length,s,a)}catch(J){return this.b.trace(J),null}}));I.children=(0,N.$jf)($)}catch(w){this.b.trace(w),I.children=[]}return I}return I}async resolveAll(t){return D.Promises.settled(t.map(async o=>{try{return{stat:await this.n(o.resource,o.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.j(t),n=await o.stat(t);return this.p(o,t,n,void 0,!0,()=>!1)}async exists(t){const o=await this.j(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.r(t,o)}catch(n){return n}return!0}async r(t,o){if(!o?.overwrite&&await this.exists(t))throw new d.$9j((0,v.localize)(3,null,this.nb(t)),3,o)}async createFile(t,o=O.$Ib.fromString(""),n){await this.r(t,n);const i=await this.writeFile(t,o);return this.m.fire(new d.$6j(t,0,i)),i}async writeFile(t,o,n){const i=this.lb(await this.l(t),t),{providerExtUri:s}=this.N(i);try{await this.s(i,t,n)||await this.P(i,s.dirname(t));let c;if((0,d.$Qj)(i)&&!(o instanceof O.$Ib))if((0,j.$ub)(o)){const I=await(0,j.$Bb)(o,3);I.ended?c=O.$Ib.concat(I.buffer):c=I}else c=(0,j.$yb)(o,I=>O.$Ib.concat(I),3);else c=o;if(!(0,d.$Tj)(i)||(0,d.$Qj)(i)&&c instanceof O.$Ib)await this.cb(i,t,n,c);else{const I=c instanceof O.$Ib?(0,O.$Sb)(c):c;n?.atomic!==!1&&n?.atomic?.postfix?await this.Y(i,t,(0,m.$6f)((0,m.$5f)(t),`${(0,m.$3f)(t)}${n.atomic.postfix}`),n,I):await this.Z(i,t,n,I)}this.m.fire(new d.$6j(t,4))}catch(a){throw new d.$9j((0,v.localize)(4,null,this.nb(t),(0,d.$2j)(a).toString()),(0,d.$5j)(a),n)}return this.resolve(t,{resolveMetadata:!0})}async s(t,o,n){const i=!!n?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,v.localize)(5,null,this.nb(o)));if(!!n?.atomic){if(!(t.capabilities&32768))throw new Error((0,v.localize)(6,null,this.nb(o)));if(i)throw new Error((0,v.localize)(7,null,this.nb(o)))}let a;try{a=await t.stat(o)}catch{return}if(a.type&d.FileType.Directory)throw new d.$9j((0,v.localize)(8,null,this.nb(o)),0,n);if(this.mb(o,a),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==d.$gk&&typeof a.mtime=="number"&&typeof a.size=="number"&&n.mtime<a.mtime&&n.etag!==(0,d.$hk)({mtime:n.mtime,size:a.size}))throw new d.$9j((0,v.localize)(9,null),3,n);return a}async readFile(t,o,n){const i=await this.k(t);return o?.atomic?this.t(i,t,o,n):this.u(i,t,o,n)}async t(t,o,n,i){return new Promise((s,a)=>{this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{try{const c=await this.u(t,o,n,i);s(c)}catch(c){a(c)}})})}async u(t,o,n,i){const s=await this.v(t,o,{...n,preferUnbuffered:!0},i);return{...s,value:await(0,O.$Tb)(s.value)}}async readFileStream(t,o,n){const i=await this.k(t);return this.v(i,t,o,n)}async v(t,o,n,i){const s=new A.$bd(i),a=this.F(o,n).then(I=>I,I=>{throw s.cancel(),I});let c;try{return typeof n?.etag=="string"&&n.etag!==d.$gk&&await a,n?.atomic&&(0,d.$Vj)(t)||!((0,d.$Tj)(t)||(0,d.$Uj)(t))||(0,d.$Qj)(t)&&n?.preferUnbuffered?c=this.D(t,o,n):(0,d.$Uj)(t)?c=this.z(t,o,s.token,n):c=this.C(t,o,s.token,n),{...await a,value:c}}catch(I){throw c&&await(0,j.$zb)(c),this.w(I,o,n)}}w(t,o,n){const i=(0,v.localize)(10,null,this.nb(o),(0,d.$2j)(t).toString());return t instanceof d.$$j?new d.$$j(i,t.stat,n):t instanceof d.$0j?new d.$0j(i,t.fileOperationResult,t.size,t.options):new d.$9j(i,(0,d.$5j)(t),n)}z(t,o,n,i=Object.create(null)){const s=t.readFileStream(o,i,n);return(0,j.$Fb)(s,{data:a=>a instanceof O.$Ib?a:O.$Ib.wrap(a),error:a=>this.w(a,o,i)},a=>O.$Ib.concat(a))}C(t,o,n,i=Object.create(null)){const s=(0,O.$Xb)();return(0,f.$np)(t,o,s,a=>a,{...i,bufferSize:this.a,errorTransformer:a=>this.w(a,o,i)},n),s}D(t,o,n){const i=(0,j.$wb)(s=>O.$Ib.concat(s));return(async()=>{try{let s;n?.atomic&&(0,d.$Vj)(t)?s=await t.readFile(o,{atomic:!0}):s=await t.readFile(o),typeof n?.position=="number"&&(s=s.slice(n.position)),typeof n?.length=="number"&&(s=s.slice(0,n.length)),this.G(o,s.byteLength,n),i.end(O.$Ib.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async F(t,o){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new d.$9j((0,v.localize)(11,null,this.nb(t)),0,o);if(typeof o?.etag=="string"&&o.etag!==d.$gk&&o.etag===n.etag)throw new d.$$j((0,v.localize)(12,null),n,o);return this.G(t,n.size,o),n}G(t,o,n){if(typeof n?.limits?.size=="number"&&o>n.limits.size)throw new d.$0j((0,v.localize)(13,null,this.nb(t)),7,o,n)}async canMove(t,o,n){return this.H(t,o,"move",n)}async canCopy(t,o,n){return this.H(t,o,"copy",n)}async H(t,o,n,i){if(t.toString()!==o.toString())try{const s=n==="move"?this.lb(await this.l(t),t):await this.k(t),a=this.lb(await this.l(o),o);await this.M(s,t,a,o,n,i)}catch(s){return s}return!0}async move(t,o,n){const i=this.lb(await this.l(t),t),s=this.lb(await this.l(o),o),a=await this.I(i,t,s,o,"move",!!n),c=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new d.$6j(t,a==="move"?2:3,c)),c}async copy(t,o,n){const i=await this.k(t),s=this.lb(await this.l(o),o),a=await this.I(i,t,s,o,"copy",!!n),c=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new d.$6j(t,a==="copy"?3:2,c)),c}async I(t,o,n,i,s,a){if(o.toString()===i.toString())return s;const{exists:c,isSameResourceWithDifferentPathCase:I}=await this.M(t,o,n,i,s,a);if(c&&!I&&a&&await this.del(i,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(i)),s==="copy"){if(t===n&&(0,d.$Rj)(t))await t.copy(o,i,{overwrite:a});else{const w=await this.resolve(o);w.isDirectory?await this.L(t,w,n,i):await this.J(t,o,n,i)}return s}else return t===n?(await t.rename(o,i,{overwrite:a}),s):(await this.I(t,o,n,i,"copy",a),await this.del(o,{recursive:!0}),"copy")}async J(t,o,n,i){if((0,d.$Tj)(t)&&(0,d.$Tj)(n))return this.eb(t,o,n,i);if((0,d.$Tj)(t)&&(0,d.$Qj)(n))return this.kb(t,o,n,i);if((0,d.$Qj)(t)&&(0,d.$Tj)(n))return this.ib(t,o,n,i);if((0,d.$Qj)(t)&&(0,d.$Qj)(n))return this.gb(t,o,n,i)}async L(t,o,n,i){await n.mkdir(i),Array.isArray(o.children)&&await D.Promises.settled(o.children.map(async s=>{const a=this.N(n).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.L(t,await this.resolve(s.resource),n,a):this.J(t,s.resource,n,a)}))}async M(t,o,n,i,s,a){let c=!1;if(t===n){const{providerExtUri:w,isPathCaseSensitive:$}=this.N(t);if($||(c=w.isEqual(o,i)),c&&s==="copy")throw new Error((0,v.localize)(14,null,this.nb(o),this.nb(i)));if(!c&&w.isEqualOrParent(i,o))throw new Error((0,v.localize)(15,null,this.nb(o),this.nb(i)))}const I=await this.exists(i);if(I&&!c){if(!a)throw new d.$9j((0,v.localize)(16,null,this.nb(o),this.nb(i)),4);if(t===n){const{providerExtUri:w}=this.N(t);if(w.isEqualOrParent(o,i))throw new Error((0,v.localize)(17,null,this.nb(o),this.nb(i)))}}return{exists:I,isSameResourceWithDifferentPathCase:c}}N(t){const o=this.O(t);return{providerExtUri:o?m.$Vf:m.$Xf,isPathCaseSensitive:o}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const o=this.lb(await this.j(t),t);await this.P(o,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new d.$6j(t,0,n)),n}async P(t,o){const n=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(o,i.dirname(o));)try{if(!((await t.stat(o)).type&d.FileType.Directory))throw new Error((0,v.localize)(18,null,this.nb(o)));break}catch(s){if((0,d.$4j)(s)!==d.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(i.basename(o)),o=i.dirname(o)}for(let s=n.length-1;s>=0;s--){o=i.joinPath(o,n[s]);try{await t.mkdir(o)}catch(a){if((0,d.$4j)(a)!==d.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,o){try{await this.Q(t,o)}catch(n){return n}return!0}async Q(t,o){const n=this.lb(await this.j(t),t),i=!!o?.useTrash;if(i&&!(n.capabilities&4096))throw new Error((0,v.localize)(19,null,this.nb(t)));const s=o?.atomic;if(s&&!(n.capabilities&65536))throw new Error((0,v.localize)(20,null,this.nb(t)));if(i&&s)throw new Error((0,v.localize)(21,null,this.nb(t)));let a;try{a=await n.stat(t)}catch{}if(a)this.mb(t,a);else throw new d.$9j((0,v.localize)(22,null,this.nb(t)),1);if(!!!o?.recursive){const I=await this.resolve(t);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,v.localize)(23,null,this.nb(t)))}return n}async del(t,o){const n=await this.Q(t,o),i=!!o?.useTrash,s=!!o?.recursive,a=o?.atomic??!1;await n.delete(t,{recursive:s,useTrash:i,atomic:a}),this.m.fire(new d.$6j(t,1))}async cloneFile(t,o){const n=await this.j(t),i=this.lb(await this.l(o),o);if(n===i&&this.N(n).providerExtUri.isEqual(t,o))return;if(n===i&&(0,d.$Sj)(n))return n.cloneFile(t,o);await this.P(i,this.N(i).providerExtUri.dirname(o));const s=this.X.queueFor(t,this.N(n).providerExtUri);return n===i&&(0,d.$Rj)(n)?s.queue(()=>n.copy(t,o,{overwrite:!0})):s.queue(()=>this.J(n,t,i,o))}watch(t,o={recursive:!1,excludes:[]}){const n=new l.$jb;let i=!1,s=()=>{i=!0};return n.add((0,l.$ib)(()=>s())),(async()=>{try{const a=await this.W(t,o);i?(0,l.$fb)(a):s=()=>(0,l.$fb)(a)}catch(a){this.b.error(a)}})(),n}async W(t,o){const n=await this.j(t),i=(0,E.$_h)([this.N(n).providerExtUri.getComparisonKey(t),o]);let s=this.U.get(i);return s||(s={count:0,disposable:n.watch(t,o)},this.U.set(i,s)),s.count+=1,(0,l.$ib)(()=>{s&&(s.count--,s.count===0&&((0,l.$fb)(s.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,l.$fb)(t.disposable);this.U.clear()}async Y(t,o,n,i,s){await this.Z(t,n,i,s);try{await t.rename(n,o,{overwrite:!0})}catch(a){try{await t.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async Z(t,o,n,i){return this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{const s=await t.open(o,{create:!0,unlock:n?.unlock??!1});try{(0,j.$ub)(i)||(0,j.$vb)(i)?await this.$(t,s,i):await this.ab(t,s,i)}catch(a){throw(0,d.$2j)(a)}finally{await t.close(s)}})}async $(t,o,n){let i=0,s;if((0,j.$vb)(n)){if(n.buffer.length>0){const a=O.$Ib.concat(n.buffer);await this.bb(t,o,a,a.byteLength,i,0),i+=a.byteLength}if(n.ended)return;s=n.stream}else s=n;return new Promise((a,c)=>{(0,j.$Ab)(s,{onData:async I=>{s.pause();try{await this.bb(t,o,I,I.byteLength,i,0)}catch(w){return c(w)}i+=I.byteLength,setTimeout(()=>s.resume())},onError:I=>c(I),onEnd:()=>a()})})}async ab(t,o,n){let i=0,s;for(;(s=n.read())!==null;)await this.bb(t,o,s,s.byteLength,i,0),i+=s.byteLength}async bb(t,o,n,i,s,a){let c=0;for(;c<i;){const I=await t.write(o,s+c,n.buffer,a+c,i-c);c+=I}}async cb(t,o,n,i){return this.X.queueFor(o,this.N(t).providerExtUri).queue(()=>this.db(t,o,n,i))}async db(t,o,n,i){let s;i instanceof O.$Ib?s=i:(0,j.$ub)(i)?s=await(0,O.$Tb)(i):(0,j.$vb)(i)?s=await(0,O.$Ub)(i):s=(0,O.$Rb)(i),await t.writeFile(o,s.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async eb(t,o,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.fb(t,o,n,i))}async fb(t,o,n,i){let s,a;try{s=await t.open(o,{create:!1}),a=await n.open(i,{create:!0,unlock:!1});const c=O.$Ib.alloc(this.a);let I=0,w=0,$=0;do $=await t.read(s,I,c.buffer,w,c.byteLength-w),await this.bb(n,a,c,$,I,w),I+=$,w+=$,w===c.byteLength&&(w=0);while($>0)}catch(c){throw(0,d.$2j)(c)}finally{await D.Promises.settled([typeof s=="number"?t.close(s):Promise.resolve(),typeof a=="number"?n.close(a):Promise.resolve()])}}async gb(t,o,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.hb(t,o,n,i))}async hb(t,o,n,i){return n.writeFile(i,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,o,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.jb(t,o,n,i))}async jb(t,o,n,i){const s=await n.open(i,{create:!0,unlock:!1});try{const a=await t.readFile(o);await this.bb(n,s,O.$Ib.wrap(a),a.byteLength,0,0)}catch(a){throw(0,d.$2j)(a)}finally{await n.close(s)}}async kb(t,o,n,i){const s=await(0,O.$Tb)(this.C(t,o,A.CancellationToken.None));await this.cb(n,i,void 0,s)}lb(t,o){if(t.capabilities&2048)throw new d.$9j((0,v.localize)(24,null,this.nb(o)),6);return t}mb(t,o){if((o.permissions??0)&d.FilePermission.Readonly)throw new d.$9j((0,v.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===S.Schemas.file?t.fsPath:t.toString(!0)}};e.$op=g=pe([te(0,h.$Ni)],g)}),define(ne[122],se([0,1,123,166,8,35,14,5,167,2,15,12,17,44,22,99,13,61,119,33,117,116]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m,j,v,d,f,h,b,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0,(()=>{try{(0,D.gracefulify)(N)}catch(o){console.error(`Error enabling graceful-fs: ${(0,b.$9h)(o)}`)}})();class t extends h.$xp{constructor(n,i){super(n,i),this.onDidChangeCapabilities=E.Event.None,this.I=new A.$ji(s=>p.$Wf.getComparisonKey(s)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,S.$k&&(this.F|=1024)),this.F}async stat(n){try{const{stat:i,symbolicLink:s}=await j.SymlinkSupport.stat(this.C(n));return{type:this.H(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.ab(i)}}async G(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await j.Promises.readdir(this.C(n),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async a=>{try{let c;a.isSymbolicLink()?c=(await this.stat((0,p.$6f)(n,a.name))).type:c=this.H(a),s.push([a.name,c])}catch(c){this.a.trace(c)}})),s}catch(i){throw this.ab(i)}}H(n,i){let s;return i?.dangling?s=d.FileType.Unknown:n.isFile()?s=d.FileType.File:n.isDirectory()?s=d.FileType.Directory:s=d.FileType.Unknown,i&&(s|=d.FileType.SymbolicLink),s}async J(n){const i=this.C(n);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.I.get(n);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const a=new O.$qg;return this.I.set(n,a),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.$ib)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.I.get(n)===a&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.I.delete(n)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(n,i){let s;try{i?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),s=await this.J(n));const a=this.C(n);return await j.Promises.readFile(a)}catch(a){throw this.ab(a)}finally{s?.dispose()}}L(n){t.D&&this.a.trace(n)}readFileStream(n,i,s){const a=(0,m.$wb)(c=>L.$Ib.concat(c.map(I=>L.$Ib.wrap(I))).buffer);return(0,f.$np)(this,n,a,c=>c.buffer,{...i,bufferSize:256*1024},s),a}async writeFile(n,i,s){return s?.atomic!==!1&&s?.atomic?.postfix?this.M(n,(0,p.$6f)((0,p.$5f)(n),`${(0,p.$3f)(n)}${s.atomic.postfix}`),i,s):this.N(n,i,s)}async M(n,i,s,a){await this.N(i,s,a);try{await this.rename(i,n,{overwrite:!0})}catch(c){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}async N(n,i,s){let a;try{const c=this.C(n);if(!s.create||!s.overwrite){if(await j.Promises.exists(c)){if(!s.overwrite)throw(0,d.$1j)((0,v.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,d.$1j)((0,v.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(c){throw await this.bb(n,c)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(n){t.R=n}async open(n,i){const s=this.C(n);let a;(0,d.$Pj)(i)&&(a=await this.J(n));let c;try{if((0,d.$Pj)(i)&&i.unlock)try{const{stat:w}=await j.SymlinkSupport.stat(s);w.mode&128||await j.Promises.chmod(s,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let I;if((0,d.$Pj)(i)){if(S.$i)try{await j.Promises.truncate(s,0),I="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}I||(I="w")}else I="r";c=await j.Promises.open(s,I)}catch(I){throw a?.dispose(),(0,d.$Pj)(i)?await this.bb(n,I):this.ab(I)}if(this.O.set(c,0),(0,d.$Pj)(i)&&this.Q.set(c,n),a){const I=this.P.get(c);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${s})`),this.P.set(c,a),I&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${s})`),I.dispose())}return c}async close(n){const i=this.P.get(n);try{if(this.O.delete(n),this.Q.delete(n)&&t.R)try{await j.Promises.fdatasync(n)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await j.Promises.close(n)}catch(s){throw this.ab(s)}finally{i&&(this.P.get(n)===i&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.P.delete(n)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,s,a,c){const I=this.S(n,i);let w=null;try{w=(await j.Promises.read(n,s,a,c,I)).bytesRead}catch($){throw this.ab($)}finally{this.U(n,I,w)}return w}S(n,i){return i===this.O.get(n)?null:i}U(n,i,s){const a=this.O.get(n);typeof a=="number"&&(typeof i=="number"||(typeof s=="number"?this.O.set(n,a+s):this.O.delete(n)))}async write(n,i,s,a,c){return(0,O.$Ig)(()=>this.W(n,i,s,a,c),100,3)}async W(n,i,s,a,c){const I=this.S(n,i);let w=null;try{w=(await j.Promises.write(n,s,a,c,I)).bytesWritten}catch($){throw await this.bb(this.Q.get(n),$)}finally{this.U(n,I,w)}return w}async mkdir(n){try{await j.Promises.mkdir(this.C(n))}catch(i){throw this.ab(i)}}async delete(n,i){try{const s=this.C(n);if(i.recursive){let a;i?.atomic!==!1&&i.atomic.postfix&&(a=(0,P.$$b)((0,P.$bc)(s),`${(0,P.$cc)(s)}${i.atomic.postfix}`)),await j.Promises.rm(s,j.RimRafMode.MOVE,a)}else try{await j.Promises.unlink(s)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let c=!1;try{const{stat:I,symbolicLink:w}=await j.SymlinkSupport.stat(s);c=I.isDirectory()&&!w}catch{}if(c)await j.Promises.rmdir(s);else throw a}else throw a}}catch(s){throw this.ab(s)}}async rename(n,i,s){const a=this.C(n),c=this.C(i);if(a!==c)try{await this.X(n,i,"move",s.overwrite),await j.Promises.move(a,c)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,v.localize)(2,null,(0,P.$cc)(a),(0,P.$cc)((0,P.$bc)(c)),I.toString()))),this.ab(I)}}async copy(n,i,s){const a=this.C(n),c=this.C(i);if(a!==c)try{await this.X(n,i,"copy",s.overwrite),await j.Promises.copy(a,c,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,v.localize)(3,null,(0,P.$cc)(a),(0,P.$cc)((0,P.$bc)(c)),I.toString()))),this.ab(I)}}async X(n,i,s,a){const c=this.C(n),I=this.C(i);let w=!1;if(!!(this.capabilities&1024)||(w=(0,u.$Ge)(c,I,!0)),w){if(s==="copy")throw(0,d.$1j)((0,v.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const M=await this.G(n);if(!M)throw(0,d.$1j)((0,v.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const Q=await this.G(i);if(Q){if(!a)throw(0,d.$1j)((0,v.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);M.type&d.FileType.File&&Q.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.Y(n,i,!1)}async Y(n,i,s){const a=this.C(n),c=this.C(i),I=!!(this.capabilities&1024);if((0,u.$Ge)(a,c,!I))return;const w=new l.$jb;try{const[$,M]=await Promise.all([this.J(n),this.J(i)]);w.add($),w.add(M),s&&await j.Promises.mkdir((0,P.$bc)(c),{recursive:!0}),await j.Promises.copyFile(a,c)}catch($){if($.code==="ENOENT"&&!s)return this.Y(n,i,!0);throw this.ab($)}finally{w.dispose()}}p(n,i,s){return new g.$Ep(a=>n(a),a=>i(a),s)}y(n,i,s){return new y.$Mp(a=>n(a),a=>i(a),s)}ab(n){if(n instanceof d.$Zj)return n;let i=n,s;switch(n.code){case"ENOENT":s=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=d.FileSystemProviderErrorCode.Unknown;break;default:s=d.FileSystemProviderErrorCode.Unknown}return(0,d.$1j)(i,s)}async bb(n,i){let s=this.ab(i);if(n&&s.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await j.SymlinkSupport.stat(this.C(n));a.mode&128||(s=(0,d.$1j)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return s}}e.$Np=t,t.D=!1,t.R=!0}),define(ne[124],se([0,1,2,6]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=void 0;class O extends N.$kb{constructor(L,E=[]){super(),this.a=new D.$Xi([L,...E]),this.B(L.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...E){this.a.trace(L,...E)}debug(L,...E){this.a.debug(L,...E)}info(L,...E){this.a.info(L,...E)}warn(L,...E){this.a.warn(L,...E)}error(L,...E){this.a.error(L,...E)}flush(){this.a.flush()}}e.$wM=O}),define(ne[125],se([0,1,13,6]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=void 0;var O;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(O||(O={}));async function A(l,P,S,p,m){try{const j=await new Promise((d,f)=>{G(["@vscode/spdlog"],d,f)});j.setFlushOn(O.Trace);const v=await j.createAsyncRotatingLogger(l,P,S,p);return m?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(j){console.error(j)}return null}function L(l,P,S){switch(P){case D.LogLevel.Trace:l.trace(S);break;case D.LogLevel.Debug:l.debug(S);break;case D.LogLevel.Info:l.info(S);break;case D.LogLevel.Warning:l.warn(S);break;case D.LogLevel.Error:l.error(S);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function E(l,P){switch(P){case D.LogLevel.Trace:l.setLevel(O.Trace);break;case D.LogLevel.Debug:l.setLevel(O.Debug);break;case D.LogLevel.Info:l.setLevel(O.Info);break;case D.LogLevel.Warning:l.setLevel(O.Warning);break;case D.LogLevel.Error:l.setLevel(O.Error);break;case D.LogLevel.Off:l.setLevel(O.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class u extends D.$Ti{constructor(P,S,p,m,j){super(),this.k=[],this.setLevel(j),this.l=this.n(P,S,p,m),this.B(this.onDidChangeLogLevel(v=>{this.m&&E(this.m,v)}))}async n(P,S,p,m){const j=p?6:1,v=30/j*N.$jk.MB,d=await A(P,S,v,j,m);if(d){this.m=d,E(this.m,this.getLevel());for(const{level:f,message:h}of this.k)L(this.m,f,h);this.k=[]}}g(P,S){this.m?L(this.m,P,S):this.getLevel()<=P&&this.k.push({level:P,message:S})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$lM=u}),define(ne[126],se([0,1,29,6,125]),function(G,e,N,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=void 0;class A extends D.$Yi{m(E,u,l){return new O.$lM((0,N.$3e)(),E.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,u)}}e.$mM=A}),define(ne[38],se([0,1,5,65,2,10]),function(G,e,N,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0,e.$Rm=(0,A.$lh)("policy");class L extends O.$kb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new N.$5c),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const P=Object.keys(this.f).length;return this.f={...l,...this.f},P!==Object.keys(this.f).length&&await this.i(l),D.Iterable.reduce(this.g.entries(),(S,[p,m])=>({...S,[p]:m}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(l,[P,S])=>({...l,[P]:{definition:S,value:this.g.get(P)}}),{})}}e.$Sm=L;class E{constructor(){this.onDidChange=N.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Tm=E}),define(ne[127],se([0,1,8,5,65,3,13,6,38]),function(G,e,N,D,O,A,L,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_3b=void 0;function l(S,p){const m=[];for(const j of new Set(O.Iterable.concat(S.keys(),p.keys())))S.get(j)!==p.get(j)&&m.push(j);return m}let P=e.$_3b=class extends u.$Sm{constructor(p,m,j){super(),this.j=p,this.k=m,this.l=j,this.c=this.B(new N.$pg(500));const v=D.Event.filter(m.onDidFilesChange,d=>d.affects(p));this.B(m.watch(p)),this.B(v(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const p=new Map;try{const m=await this.k.readFile(this.j),j=JSON.parse(m.value.toString());if(!(0,A.$ie)(j))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(j))this.f[v]&&p.set(v,j[v])}catch(m){m.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",m)}return p}async p(){const p=await this.n(),m=l(this.g,p);this.g=p,m.length>0&&this.h.fire(m)}};e.$_3b=P=pe([te(1,L.$Oj),te(2,E.$Ni)],P)}),define(ne[128],se([0,1,38,8,168,2,6]),function(G,e,N,D,O,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$3b=void 0;let E=e.$$3b=class extends N.$Sm{constructor(l,P){super(),this.j=l,this.k=P,this.a=new D.$lg,this.b=this.B(new A.$lb)}async i(l){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((P,S)=>{try{this.b.value=(0,O.createWatcher)(this.k,l,p=>{this.m(p),P()})}catch(p){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),S(p)}}))}m(l){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const P in l){const S=l[P];S===void 0?this.g.delete(P):this.g.set(P,S)}this.h.fire(Object.keys(l))}};e.$$3b=E=pe([te(0,L.$Ni)],E)}),define(ne[31],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=void 0,e.$6i=(0,N.$lh)("productService"),e.$7i="vscode://schemas/vscode-product"}),define(ne[36],se([0,1,70,3]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=void 0;class O{constructor(){this.a=new Map}add(L,E){N.ok(D.$ge(L)),N.ok(D.$ie(E)),N.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,E)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$Pm=new O}),define(ne[129],se([0,1,5,36]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0,e.$Qm={JSONContribution:"base.contributions.json"};function O(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class A{constructor(){this.b=new N.$5c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,l){this.a[O(u)]=l,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const L=new A;D.$Pm.add(e.$Qm.JSONContribution,L)}),define(ne[42],se([0,1,19,5,3,86,24,129,36]),function(G,e,N,D,O,A,L,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.ConfigurationScope=e.$Um=e.EditPresentationTypes=void 0;var l;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$Um={Configuration:"base.contributions.configuration"};var P;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$Vm={properties:{},patternProperties:{}},e.$Wm={properties:{},patternProperties:{}},e.$Xm={properties:{},patternProperties:{}},e.$Ym={properties:{},patternProperties:{}},e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m="vscode://schemas/settings/resourceLanguage",e.$3m="vscode://schemas/settings/configurationDefaults";const S=u.$Pm.as(E.$Qm.JSONContribution);class p{constructor(){this.h=new Set,this.i=new D.$5c,this.onDidSchemaChange=this.i.event,this.j=new D.$5c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$2m,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const n=new Set;this.n(t,o,n),S.registerSchema(e.$2m,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const o=new Set;this.o(t,o),S.registerSchema(e.$2m,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const n=new Set;this.o(o,n),this.n(t,!1,n),S.registerSchema(e.$2m,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const n=[];for(const{overrides:i,source:s}of t)for(const a in i)if(o.add(a),e.$5m.test(a)){const c=this.a.get(a),I=c?.valuesSources??new Map;if(s)for(const Q of Object.keys(i[a]))I.set(Q,s);const w={...c?.value||{},...i[a]};this.a.set(a,{source:s,value:w,valuesSources:I});const $=(0,L.$2h)(a),M={type:"object",default:w,description:A.localize(1,null,$),$ref:e.$2m,defaultDefaultValue:w,source:O.$ge(s)?void 0:s,defaultValueSource:s};n.push(...v(a)),this.d[a]=M,this.b.properties[a]=M}else{this.a.set(a,{value:i[a],source:s});const c=this.d[a];c&&(this.w(a,c),this.r(a,c))}this.m(n)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:n,source:i}of t)for(const s in n){const a=this.a.get(s),c=O.$ge(i)?i:i?.id,I=O.$ge(a?.source)?a?.source:a?.source?.id;if(c===I)if(o.add(s),this.a.delete(s),e.$5m.test(s))delete this.d[s],delete this.b.properties[s];else{const w=this.d[s];w&&(this.w(s,w),this.r(s,w))}}this.u()}deltaConfiguration(t){let o=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,n){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(t,o){const n=i=>{if(i.properties)for(const s in i.properties){o.add(s);const a=this.d[s];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>n(s))};for(const i of t){n(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(t,o=!0,n,i,s=3,a){s=O.$pe(t.scope)?s:t.scope;const c=t.properties;if(c)for(const w in c){const $=c[w];if(o&&b(w,$)){delete c[w];continue}if($.source=n,$.defaultDefaultValue=c[w].default,this.w(w,$),e.$5m.test(w)?$.scope=void 0:($.scope=O.$pe($.scope)?s:$.scope,$.restricted=O.$pe($.restricted)?!!i?.includes(w):$.restricted),c[w].hasOwnProperty("included")&&!c[w].included){this.f[w]=c[w],delete c[w];continue}else this.d[w]=c[w],c[w].policy?.name&&this.e.set(c[w].policy.name,w);!c[w].deprecationMessage&&c[w].markdownDeprecationMessage&&(c[w].deprecationMessage=c[w].markdownDeprecationMessage),a.add(w)}const I=t.allOf;if(I)for(const w of I)this.p(w,o,n,i,s,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=n=>{const i=n.properties;if(i)for(const a in i)this.r(a,i[a]);n.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$Vm.properties[t]=o,o.scope){case 1:e.$Wm.properties[t]=o;break;case 2:e.$Xm.properties[t]=o;break;case 6:e.$Ym.properties[t]=o;break;case 3:e.$Zm.properties[t]=o;break;case 4:e.$1m.properties[t]=o;break;case 5:e.$1m.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$Vm.properties[t],o.scope){case 1:delete e.$Wm.properties[t];break;case 2:delete e.$Xm.properties[t];break;case 6:delete e.$Ym.properties[t];break;case 3:delete e.$Zm.properties[t];break;case 4:case 5:delete e.$1m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$2m};this.w(o,n),e.$Vm.properties[o]=n,e.$Wm.properties[o]=n,e.$Xm.properties[o]=n,e.$Ym.properties[o]=n,e.$Zm.properties[o]=n,e.$1m.properties[o]=n}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$2m};e.$Vm.patternProperties[e.$4m]=t,e.$Wm.patternProperties[e.$4m]=t,e.$Xm.patternProperties[e.$4m]=t,e.$Ym.patternProperties[e.$4m]=t,e.$Zm.patternProperties[e.$4m]=t,e.$1m.patternProperties[e.$4m]=t,this.i.fire()}w(t,o){const n=this.a.get(t);let i=n?.value,s=n?.source;O.$ne(i)&&(i=o.defaultDefaultValue,s=void 0),O.$ne(i)&&(i=f(o.type)),o.default=i,o.defaultValueSource=s}}const m="\\[([^\\]]+)\\]",j=new RegExp(m,"g");e.$4m=`^(${m})+$`,e.$5m=new RegExp(e.$4m);function v(y){const t=[];if(e.$5m.test(y)){let o=j.exec(y);for(;o?.length;){const n=o[1].trim();n&&t.push(n),o=j.exec(y)}}return(0,N.$of)(t)}e.$6m=v;function d(y){return y.reduce((t,o)=>`${t}[${o}]`,"")}e.$7m=d;function f(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$8m=f;const h=new p;u.$Pm.add(e.$Um.Configuration,h);function b(y,t){return y.trim()?e.$5m.test(y)?A.localize(7,null,y):h.getConfigurationProperties()[y]!==void 0?A.localize(8,null,y):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,y,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$9m=b;function g(){const y=[],t=h.getConfigurationProperties();for(const o of Object.keys(t))y.push([o,t[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.$0m=g}),define(ne[66],se([0,1,19,5,52,2,35,30,3,11,24,42,36]),function(G,e,N,D,O,A,L,E,u,l,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=void 0;function m(o){return Object.isFrozen(o)?o:E.$Em(o)}class j{constructor(n={},i=[],s=[],a){this.b=n,this.c=i,this.d=s,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof j)return i;const s=new v("");return s.parseRaw(i),s.configurationModel});this.f=n.reduce((i,s)=>s===i?s:i.merge(s),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.$Zh)(this.contents,n):this.contents}inspect(n,i){const s=this.rawConfiguration.getValue(n),a=i?this.rawConfiguration.getOverrideValue(n,i):void 0,c=i?this.rawConfiguration.override(i).getValue(n):s;return{value:s,override:a,merged:c}}getOverrideValue(n,i){const s=this.i(i);return s?n?(0,P.$Zh)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const s of this.overrides)s.identifiers.includes(n)&&i.push(...s.keys);return N.$of(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return N.$of(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=E.$Dm(this.contents),s=E.$Dm(this.overrides),a=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const I of n)if(c.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(i,I.contents);for(const w of I.overrides){const[$]=s.filter(M=>N.$$e(M.identifiers,w.identifiers));$?(this.h($.contents,w.contents),$.keys.push(...w.keys),$.keys=N.$of($.keys)):s.push(E.$Dm(w))}for(const w of I.keys)a.indexOf(w)===-1&&a.push(w)}return new j(i,a,s,c.every(I=>I instanceof j)?void 0:c)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const a of N.$of([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[a];const I=i[a];I&&(typeof c=="object"&&typeof I=="object"?(c=E.$Dm(c),this.h(c,I)):c=I),s[a]=c}return new j(s,this.keys,this.overrides)}h(n,i){for(const s of Object.keys(i)){if(s in n&&u.$ie(n[s])&&u.$ie(i[s])){this.h(n[s],i[s]);continue}n[s]=E.$Dm(i[s])}}i(n){let i=null,s=null;const a=c=>{c&&(s?this.h(s,c):s=E.$Dm(c))};for(const c of this.overrides)N.$$e(c.identifiers,[n])?i=c.contents:c.identifiers.includes(n)&&a(c.contents);return a(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,P.$Yh)(this.contents,n),S.$5m.test(n)&&this.overrides.splice(this.overrides.findIndex(s=>N.$$e(s.identifiers,(0,S.$6m)(n))),1))}j(n,i,s){(0,P.$Xh)(this.contents,n,i,a=>console.error(a)),s=s||this.keys.indexOf(n)===-1,s&&this.keys.push(n),S.$5m.test(n)&&this.overrides.push({identifiers:(0,S.$6m)(n),keys:Object.keys(this.contents[n]),contents:(0,P.$Wh)(this.contents[n],a=>console.error(a))})}}e.$$m=j;class v{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new j}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!u.$pe(n)){const s=this.g(n);this.parseRaw(s,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:s,keys:a,overrides:c,restricted:I,hasExcludedProperties:w}=this.h(n,i);this.b=new j(s,a,c,w?[n]:void 0),this.c=I||[]}g(n){let i={},s=null,a=[];const c=[],I=[];function w(M){Array.isArray(a)?a.push(M):s!==null&&(a[s]=M)}const $={onObjectBegin:()=>{const M={};w(M),c.push(a),a=M,s=null},onObjectProperty:M=>{s=M},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const M=[];w(M),c.push(a),a=M,s=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:w,onError:(M,Q,J)=>{I.push({error:M,offset:Q,length:J})}};if(n)try{O.$Am(n,$),i=a[0]||{}}catch(M){console.error(`Error while parsing settings file ${this.f}: ${M}`),this.d=[M]}return i}h(n,i){const s=p.$Pm.as(S.$Um.Configuration).getConfigurationProperties(),a=this.i(n,s,!0,i);n=a.raw;const c=(0,P.$Wh)(n,$=>console.error(`Conflict in settings file ${this.f}: ${$}`)),I=Object.keys(n),w=this.j(n,$=>console.error(`Conflict in settings file ${this.f}: ${$}`));return{contents:c,keys:I,overrides:w,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(n,i,s,a){let c=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:c};const I={},w=[];for(const $ in n)if(S.$5m.test($)&&s){const M=this.i(n[$],i,!1,a);I[$]=M.raw,c=c||M.hasExcludedProperties,w.push(...M.restricted)}else{const M=i[$],Q=M?typeof M.scope<"u"?M.scope:3:void 0;M?.restricted&&w.push($),(Q===void 0||a.scopes===void 0||a.scopes.includes(Q))&&!(a.skipRestricted&&M?.restricted)?I[$]=n[$]:c=!0}return{raw:I,restricted:w,hasExcludedProperties:c}}j(n,i){const s=[];for(const a of Object.keys(n))if(S.$5m.test(a)){const c={};for(const I in n[a])c[I]=n[a][I];s.push({identifiers:(0,S.$6m)(a),keys:Object.keys(c),contents:(0,P.$Wh)(c,i)})}return s}}e.$_m=v;class d extends A.$kb{constructor(n,i,s,a){super(),this.f=n,this.g=i,this.h=a,this.c=this.B(new D.$5c),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(D.Event.any(D.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),D.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&s.isEqual(c.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new j}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$an=d;class f{constructor(n,i,s,a,c,I,w,$,M,Q,J,ie,ue){this.a=n,this.b=i,this.c=s,this.overrideIdentifiers=a,this.d=c,this.f=I,this.g=w,this.h=$,this.i=M,this.j=Q,this.k=J,this.l=ie,this.m=ue}get value(){return m(this.c)}n(n,i,s){const a=n.inspect(i,s);return{get value(){return m(a.value)},get override(){return m(a.override)},get merged(){return m(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(n,i,s,a,c=new j,I=new j,w=new L.$ji,$=new j,M=new L.$ji){this.c=n,this.d=i,this.f=s,this.g=a,this.h=c,this.i=I,this.j=w,this.l=$,this.m=M,this.a=null,this.b=new L.$ji,this.n=null}getValue(n,i,s){return this.q(n,i,s).getValue(n)}updateValue(n,i,s={}){let a;s.resource?(a=this.m.get(s.resource),a||(a=new j,this.m.set(s.resource,a))):a=this.l,i===void 0?a.removeValue(n):a.setValue(n,i),s.resource||(this.a=null)}inspect(n,i,s){const a=this.q(n,i,s),c=this.u(i.resource,s),I=i.resource?this.m.get(i.resource)||this.l:this.l,w=new Set;for(const $ of a.overrides)for(const M of $.identifiers)a.getOverrideValue(n,M)!==void 0&&w.add(M);return new f(n,i,a.getValue(n),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,c||void 0,I)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const s=[];if(!i){const{added:a,updated:c,removed:I}=y(this.c,n);i=[...a,...c,...I]}for(const a of i)for(const c of(0,S.$6m)(a)){const I=this.c.getKeysForOverrideIdentifier(c),w=n.getKeysForOverrideIdentifier(c),$=[...w.filter(M=>I.indexOf(M)===-1),...I.filter(M=>w.indexOf(M)===-1),...I.filter(M=>!E.$Hm(this.c.override(c).getValue(M),n.override(c).getValue(M)))];s.push([c,$])}return this.updateDefaultConfiguration(n),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:s,removed:a}=y(this.d,n),c=[...i,...s,...a];return c.length&&this.updatePolicyConfiguration(n),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:s,removed:a,overrides:c}=y(this.applicationConfiguration,n),I=[...i,...s,...a];return I.length&&this.updateApplicationConfiguration(n),{keys:I,overrides:c}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:s,removed:a,overrides:c}=y(this.localUserConfiguration,n),I=[...i,...s,...a];return I.length&&this.updateLocalUserConfiguration(n),{keys:I,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:s,removed:a,overrides:c}=y(this.remoteUserConfiguration,n),I=[...i,...s,...a];return I.length&&this.updateRemoteUserConfiguration(n),{keys:I,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:s,removed:a,overrides:c}=y(this.workspaceConfiguration,n),I=[...i,...s,...a];return I.length&&this.updateWorkspaceConfiguration(n),{keys:I,overrides:c}}compareAndUpdateFolderConfiguration(n,i){const s=this.p.get(n),{added:a,updated:c,removed:I,overrides:w}=y(s,i),$=[...a,...c,...I];return($.length||!s)&&this.updateFolderConfiguration(n,i),{keys:$,overrides:w}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:a,removed:c,overrides:I}=y(i,void 0);return{keys:[...s,...a,...c],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,s){let a=this.r(i,s);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(a=a.merge(this.d)),a}r({resource:n},i){let s=this.s();if(i&&n){const a=i.getFolder(n);a&&(s=this.t(a.uri)||s);const c=this.m.get(n);c&&(s=s.merge(c))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const s=this.s(),a=this.j.get(n);a?(i=s.merge(a),this.b.set(n,i)):i=s}return i}u(n,i){if(i&&n){const s=i.getFolder(n);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:s,overrides:a,keys:c}=this.j.get(i);return n.push([i,{contents:s,overrides:a,keys:c}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(s=>n.add(s))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>i.add(s)),this.i.getKeysForOverrideIdentifier(n).forEach(s=>i.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(a=>i.add(a))),[...i.values()]}static parse(n){const i=this.x(n.defaults),s=this.x(n.policy),a=this.x(n.application),c=this.x(n.user),I=this.x(n.workspace),w=n.folders.reduce(($,M)=>($.set(l.URI.revive(M[0]),this.x(M[1])),$),new L.$ji);return new h(i,s,a,c,new j,I,w,new j,new L.$ji)}static x(n){return new j(n.contents,n.keys,n.overrides)}}e.$bn=h;function b(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,i=new Map;for(const a of o)a.keys.forEach(c=>n.add(c)),a.overrides.forEach(([c,I])=>{const w=(0,L.$gi)(i,c,new Set);I.forEach($=>w.add($))});const s=[];return i.forEach((a,c)=>s.push([c,[...a.values()]])),{keys:[...n.values()],overrides:s}}e.$cn=b;class g{constructor(n,i,s,a){this.change=n,this.f=i,this.g=s,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of n.keys)this.affectedKeys.add(c);for(const[,c]of n.overrides)for(const I of c)this.affectedKeys.add(I);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(n,i){const s=this.a+n,a=this.d.indexOf(s);if(a<0)return!1;const c=a+s.length;if(c>=this.d.length)return!1;const I=this.d.charCodeAt(c);if(I!==this.b&&I!==this.c)return!1;if(i){const w=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,$=this.g.getValue(n,i,this.h);return!E.$Hm(w,$)}return!0}}e.$dn=g;function y(o,n){const{added:i,removed:s,updated:a}=t(n?.rawConfiguration,o?.rawConfiguration),c=[],I=o?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const $=w.filter(M=>!I.includes(M));for(const M of $)c.push([M,n.getKeysForOverrideIdentifier(M)])}if(o){const $=I.filter(M=>!w.includes(M));for(const M of $)c.push([M,o.getKeysForOverrideIdentifier(M)])}if(n&&o){for(const $ of I)if(w.includes($)){const M=t({contents:o.getOverrideValue(void 0,$)||{},keys:o.getKeysForOverrideIdentifier($)},{contents:n.getOverrideValue(void 0,$)||{},keys:n.getKeysForOverrideIdentifier($)});c.push([$,[...M.added,...M.removed,...M.updated]])}}return{added:i,removed:s,updated:a,overrides:c}}function t(o,n){const i=o?n?o.keys.filter(c=>n.keys.indexOf(c)===-1):[...o.keys]:[],s=n?o?n.keys.filter(c=>o.keys.indexOf(c)===-1):[...n.keys]:[],a=[];if(o&&n){for(const c of n.keys)if(o.keys.indexOf(c)!==-1){const I=(0,P.$Zh)(n.contents,c),w=(0,P.$Zh)(o.contents,c);E.$Hm(I,w)||a.push(c)}}return{added:i,removed:s,updated:a}}}),define(ne[130],se([0,1,19,5,2,30,3,66,42,6,38,36]),function(G,e,N,D,O,A,L,E,u,l,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=void 0;class p extends O.$kb{constructor(){super(...arguments),this.a=this.B(new D.$5c),this.onDidChangeConfiguration=this.a.event,this.b=new E.$$m}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.$Pm.as(u.$Um.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:f})=>this.c(Array.from(d),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(d,f){this.h(d,S.$Pm.as(u.$Um.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}g(){this.b=new E.$$m;const d=S.$Pm.as(u.$Um.Configuration).getConfigurationProperties();this.h(Object.keys(d),d)}h(d,f){const h=this.f();for(const b of d){const g=h[b],y=f[b];g!==void 0?this.b.addValue(b,g):y?this.b.addValue(b,y.default):this.b.removeValue(b)}}}e.$en=p;class m{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new E.$$m}async initialize(){return this.configurationModel}}e.$fn=m;let j=e.$gn=class extends O.$kb{get configurationModel(){return this.b}constructor(d,f,h){super(),this.c=d,this.f=f,this.g=h,this.a=this.B(new D.$5c),this.onDidChangeConfiguration=this.a.event,this.b=new E.$$m}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.i(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.j(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const f={},h=[],b=S.$Pm.as(u.$Um.Configuration).getConfigurationProperties();for(const g of d){const y=b[g];if(!y){h.push(g);continue}if(y.policy){if(y.type!=="string"&&y.type!=="number"){this.g.warn(`Policy ${y.policy.name} has unsupported type ${y.type}`);continue}h.push(g),f[y.policy.name]={type:y.type}}}return(0,L.$te)(f)||await this.f.updatePolicyDefinitions(f),h}i(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const f=S.$Pm.as(u.$Um.Configuration).getPolicyConfigurations(),h=(0,N.$jf)(d.map(b=>f.get(b)));this.j(h,!0)}j(d,f){this.g.trace("PolicyConfiguration#update",d);const h=S.$Pm.as(u.$Um.Configuration).getConfigurationProperties(),b=[],g=this.b.isEmpty();for(const y of d){const t=h[y]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(g?o!==void 0:!(0,A.$Hm)(this.b.getValue(y),o))&&b.push([y,o])}else this.b.getValue(y)!==void 0&&b.push([y,void 0])}if(b.length){this.g.trace("PolicyConfiguration#changed",b);const y=this.b;this.b=new E.$$m;for(const t of y.keys)this.b.setValue(t,y.getValue(t));for(const[t,o]of b)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);f&&this.a.fire(this.b)}}};e.$gn=j=pe([te(1,P.$Rm),te(2,l.$Ni)],j)}),define(ne[131],se([0,1,8,5,2,17,24,66,130,38]),function(G,e,N,D,O,A,L,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0;class P extends O.$kb{constructor(p,m,j,v){super(),this.i=p,this.h=this.B(new D.$5c),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$en),this.c=j instanceof l.$Tm?new u.$fn:this.B(new u.$gn(this.b,j,v)),this.f=this.B(new E.$an(this.i,void 0,A.$Wf,m)),this.a=new E.$bn(this.b.configurationModel,this.c.configurationModel,new E.$$m,new E.$$m),this.g=this.B(new N.$Cg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:d,properties:f})=>this.k(d,f))),this.B(this.c.onDidChangeConfiguration(d=>this.l(d))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,m,j]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new E.$bn(p,m,new E.$$m,j)}getConfigurationData(){return this.a.toData()}getValue(p,m){const j=typeof p=="string"?p:void 0,v=(0,L.$Sh)(p)?p:(0,L.$Sh)(m)?m:{};return this.a.getValue(j,v,void 0)}updateValue(p,m,j,v){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const m=this.a.toData(),j=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(j,m,2)}k(p,m){const j=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(p,m);this.m(v,j,7)}l(p){const m=this.a.toData(),j=this.a.compareAndUpdatePolicyConfiguration(p);this.m(j,m,7)}m(p,m,j){const v=new E.$dn(p,{data:m},this.a);v.source=j,v.sourceConfig=this.n(j),this.h.fire(v)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$hn=P}),define(ne[67],se([0,1,16]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=void 0;function D(l){return l.scheme===N.Schemas.vscodeRemote?l.authority:void 0}e.$xk=D;function O(l){if(!l)return;const P=l.indexOf("+");return P<0?l:l.substr(0,P)}e.$yk=O;function A(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$zk=A;function L(l){const{host:P,port:S}=u(l);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:S}}e.$Ak=L;function E(l,P){let{host:S,port:p}=u(l);return typeof p>"u"&&(p=P),{host:S,port:p}}e.$Bk=E;function u(l){const P=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const S=l.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const p=l.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:l,port:void 0}}}),define(ne[37],se([0,1,28,10,67]),function(G,e,N,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.TargetPlatform=e.ExtensionType=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=void 0,e.$xl="extensions.user.cache",e.$yl="extensions.builtin.cache",e.$zl="undefined_publisher",e.$Al=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Bl=A,e.$Cl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(L||(e.ExtensionType=L={}));var E;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class u{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,f){if(typeof d>"u"||d===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof d=="string"||typeof f=="string"){const h=typeof d=="string"?d:d.value,b=typeof f=="string"?f:f.value;return N.$Jd(h,b)}return d._lower===f._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Dl=u;class l{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const f of d)this.add(f)}add(d){this.c.add(u.toKey(d))}delete(d){return this.c.delete(u.toKey(d))}has(d){return this.c.has(u.toKey(d))}}e.$El=l;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(u.toKey(d))}get(d){return this.c.get(u.toKey(d))}has(d){return this.c.has(u.toKey(d))}set(d,f){this.c.set(u.toKey(d),f)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fl=P;function S(v){return p(v)}e.$Gl=S;function p(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$Hl=p;function m(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$Il=m;function j(v,d){if(d){const f=`onResolveRemoteAuthority:${(0,O.$yk)(d)}`;return!!v.activationEvents?.includes(f)}return!1}e.$Jl=j,e.$Kl=(0,D.$lh)("IBuiltinExtensionsScannerService")}),define(ne[132],se([0,1,2,37,13]),function(G,e,N,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=void 0;class A extends N.$kb{constructor(E,u,l,P,S){super(),this.a=E,this.b=u,this.c=l,this.f=S,this.B(P.onDidInstallExtensions(p=>this.g(p))),this.B(P.onDidUninstallExtension(p=>this.h(p)))}g(E){for(const u of E)u.local&&this.invalidate(u.profileLocation)}h(E){E.error||this.invalidate(E.profileLocation)}async invalidate(E){if(E)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,E)&&await this.i(u);else await this.i(this.a.defaultProfile)}async i(E){try{await this.b.del(this.c.extUri.joinPath(E.cacheHome,D.$xl))}catch(u){(0,O.$5j)(u)!==1&&this.f.error(u)}}}e.$hp=A}),define(ne[43],se([0,1,14,9,2,101,42,10,6,36]),function(G,e,N,D,O,A,L,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=void 0,e.$uo=(0,E.$lh)("requestService");class P{constructor(y){this.b=y}toJSON(){if(!this.a){const y=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?y[t]="*****":y[t]=this.b[t];this.a=y}return this.a}}class S extends O.$kb{constructor(y){super(),this.b=0,this.a=y.createLogger("network",{name:(0,A.localize)(0,null),when:u.$5i.isEqualTo((0,u.$3i)(u.LogLevel.Trace)).serialize()})}async c(y,t,o){const n=`${y} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new P(t.headers??{}));try{const i=await o();return this.a.trace(`${n} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,t.type,(0,D.$8)(i)),i}}}e.$vo=S;function p(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.$wo=p;function m(g){return g.res.statusCode===204}async function j(g){return m(g)?null:(await(0,N.$Tb)(g.stream)).toString()}e.$xo=j;async function v(g){if(!p(g))throw new Error("Server returned "+g.res.statusCode);return j(g)}e.$yo=v;async function d(g){if(!p(g))throw new Error("Server returned "+g.res.statusCode);if(m(g))return null;const t=(await(0,N.$Tb)(g.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$zo=d;function f(g){b(g)}e.$Ao=f;let h;function b(g){const y=l.$Pm.as(L.$Um.Configuration),t=h;h={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(5,null),(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null)],default:"override",description:(0,A.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(10,null),restricted:!0}}},y.updateConfigurations({add:[h],remove:t?[t]:[]})}b(1)}),define(ne[133],se([0,1,23,16,13,43]),function(G,e,N,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=void 0;let L=e.$LM=class{constructor(u,l){this.a=u,this.b=l}async download(u,l,P=N.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,l);return}const S={type:"GET",url:u.toString(!0)},p=await this.a.request(S,P);if(p.res.statusCode===200)await this.b.writeFile(l,p.stream);else{const m=await(0,A.$yo)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${m}`)}}};e.$LM=L=pe([te(0,A.$uo),te(1,O.$Oj)],L)}),define(ne[134],se([0,1,135,3]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=void 0;function O(L,E){return L.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:L.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function A(L,E,u={}){const l=(0,N.parse)(L),P=u.proxyUrl||O(l,E);if(!P)return null;const S=(0,N.parse)(P);if(!/^https?:$/.test(S.protocol||""))return null;const p={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,D.$me)(u.strictSSL)?u.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((m,j)=>{G(["http-proxy-agent"],m,j)}))(p):new(await new Promise((m,j)=>{G(["https-proxy-agent"],m,j)}))(p)}e.$yq=A}),define(ne[136],se([0,1,58,15,102,23,33,9,12,29,82,169,8,71]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=void 0;let j;async function v(f,h,b,g){return b["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.$ol)(g)&&!b["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.$ol)(g)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),j||(j=p.Promises.withAsyncBody(async(y,t)=>{const o=new A.$bd;let n=1e4;const i=f.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(n=(0,m.$pl)(i,1,120)*1e3);const s=setTimeout(()=>{o.dispose(!0),t(new Error((0,O.localize)(0,null)))},n);try{y(await d(h,o.token))}catch(a){!(0,E.$1)(a)&&!o.token.isCancellationRequested?t(new Error((0,O.localize)(1,null,(0,L.$9h)(a)))):y({})}finally{clearTimeout(s),o.dispose()}})),j)}e.$ul=v;async function d(f,h){const b=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",b);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",g);const y=(0,l.$3e)().replace(/-/g,"").substr(0,12),t=new RegExp(y+"({.*})"+y),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",o);const n=await(0,P.$fl)(u.OS,o);return f.trace("getUnixShellEnvironment#shell",n),new Promise((i,s)=>{if(h.isCancellationRequested)return s(new E.$2);const a=(0,D.$cc)(n);let c,I;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' ${w} -p '''${y}'' + JSON.stringify(process.env) + ''${y}'''`,I=["-Login","-Command"]):a==="nu"?(c=`^'${process.execPath}' ${w} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,I=["-i","-l","-c"]):(c=`'${process.execPath}' ${w} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,a==="tcsh"||a==="csh"?I=["-ic"]:I=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),c);const $=(0,N.spawn)(n,[...I,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});h.onCancellationRequested(()=>($.kill(),s(new E.$2))),$.on("error",J=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,L.$9h)(J)),s(J)});const M=[];$.stdout.on("data",J=>M.push(J));const Q=[];$.stderr.on("data",J=>Q.push(J)),$.on("close",(J,ie)=>{const ue=Buffer.concat(M).toString("utf8");f.trace("getUnixShellEnvironment#raw",ue);const x=Buffer.concat(Q).toString("utf8");if(x.trim()&&f.trace("getUnixShellEnvironment#stderr",x),J||ie)return s(new Error((0,O.localize)(2,null,J,ie)));const ce=t.exec(ue),le=ce?ce[1]:"{}";try{const oe=JSON.parse(le);b?oe.ELECTRON_RUN_AS_NODE=b:delete oe.ELECTRON_RUN_AS_NODE,g?oe.ELECTRON_NO_ATTACH_CONSOLE=g:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",oe),i(oe)}catch(oe){f.error("getUnixShellEnvironment#errorCaught",(0,L.$9h)(oe)),s(oe)}})})}}),define(ne[137],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$nM=void 0,e.$nM=(0,N.$lh)("stateReadService"),e.$oM=(0,N.$lh)("stateService")}),define(ne[68],se([0,1,8,14,3,18,13,6]),function(G,e,N,D,O,A,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=e.$pM=e.SaveStrategy=void 0;var u;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class l{constructor(m,j,v,d){this.f=m,this.g=v,this.h=d,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=j===0?void 0:new N.$pg(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.g.error(m)}}getItem(m,j){const v=this.a[m];return(0,O.$pe)(v)?j:v}setItem(m,j){this.setItems([{key:m,data:j}])}setItems(m){let j=!1;for(const{key:v,data:d}of m)this.a[v]!==d&&((0,O.$pe)(d)?(0,O.$ne)(this.a[v])||(this.a[v]=void 0,j=!0):(this.a[v]=d,j=!0));j&&this.j()}removeItem(m){(0,O.$ne)(this.a[m])||(this.a[m]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.h.writeFile(this.f,D.$Ib.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(j){this.g.error(j)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.$pM=l;let P=e.$qM=class{constructor(m,j,v,d){this.a=new l(j.stateResource,m,v,d)}async init(){await this.a.init()}getItem(m,j){return this.a.getItem(m,j)}};e.$qM=P=pe([te(1,A.$sh),te(2,E.$Ni),te(3,L.$Oj)],P);class S extends P{setItem(m,j){this.a.setItem(m,j)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.$rM=S}),define(ne[69],se([0,1,12,34,29]),function(G,e,N,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=void 0;function A(u){if(N.$t===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function L(u,l,P,S,p,m,j,v){const d=Object.create(null);d["common.machineId"]=m,d.sessionID=(0,O.$3e)()+Date.now(),d.commitHash=S,d.version=p,d["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,N.$h)(N.$t),d["common.nodePlatform"]=D.$5b,d["common.nodeArch"]=P,d["common.product"]=v||"desktop",j&&(d["common.msftInternal"]=j);let f=0;const h=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),N.$l&&(d["common.snap"]="true");const b=A(l);return b&&(d["common.platformDetail"]=b),d}e.$Vn=L;function E(u){const l=D.env.USERDNSDOMAIN;if(!l)return!1;const P=l.toLowerCase();return u.some(S=>P===S)}e.$Wn=E}),define(ne[25],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0,e.$Rk=(0,N.$lh)("telemetryService"),e.$Sk=(0,N.$lh)("customEndpointTelemetryService"),e.$Tk="telemetry.currentSessionDate",e.$Uk="telemetry.firstSessionDate",e.$Vk="telemetry.lastSessionDate",e.$Wk="telemetry.machineId",e.$Xk="telemetry",e.$Yk="telemetry.telemetryLevel",e.$Zk="telemetry.enableCrashReporter",e.$1k="telemetry.enableTelemetry";var D;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var O;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(O||(e.TelemetryConfiguration=O={}))}),define(ne[39],se([0,1,30,3,5,24,67,69,25]),function(G,e,N,D,O,A,L,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0;class l{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$Xn=l;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Yn=P,e.$Zn=new P;class S{async publicLog(s,a,c){}async publicLogError(s,a,c){}}e.$1n=S,e.$2n="telemetry",e.$3n="extensionTelemetryLog",e.$4n={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,s){return O.Event.debounce(s.onDidChangeConfiguration,(c,I)=>{const w=c?new Set([...c.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:w}},1e3,!0)(c=>{c.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.$Uh)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.$5n=p;function m(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry||s.extensionTestsLocationURI)}e.$6n=m;function j(i,s){return!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$7n=j;function v(i){const s=i.getValue(u.$Yk),a=i.getValue(u.$Zk);if(i.getValue(u.$1k)===!1||a===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$8n=v;function d(i){const s={},a={},c={};b(i,c);for(let I in c){I=I.length>150?I.substr(I.length-149):I;const w=c[I];typeof w=="number"?a[I]=w:typeof w=="boolean"?a[I]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${w.length}`),s[I]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(s[I]=w)}return{properties:s,measurements:a}}e.$9n=d;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const s=(0,L.$yk)(i);return f.has(s)?s:"other"}e.$0n=h;function b(i,s,a=0,c){if(i)for(const I of Object.getOwnPropertyNames(i)){const w=i[I],$=c?c+I:I;Array.isArray(w)?s[$]=(0,N.$Im)(w):w instanceof Date?s[$]=w.toISOString():(0,D.$ie)(w)?a<2?b(w,s,a+1,$+"."):s[$]=(0,N.$Im)(w):s[$]=w}}function g(i,s){const a=i.msftInternalDomains||[],c=s.getValue("telemetry.internalTesting");return(0,E.$Wn)(a)||c}e.$$n=g;function y(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$_n=y;function t(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const c=[];for(const M of s)for(;;){const Q=M.exec(i);if(!Q)break;c.push([Q.index,M.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(a="";;){const M=w.exec(i);if(!M)break;const Q=c.some(([J,ie])=>M.index<ie&&J<w.lastIndex);!I.test(M[0])&&!Q&&(a+=i.substring($,M.index)+"<REDACTED: user-file-path>",$=w.lastIndex)}return $<i.length&&(a+=i.substr($)),a}function o(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of s)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function n(i,s){return(0,N.$Fm)(i,a=>{if(a instanceof l||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let c=a.replaceAll("%20"," ");c=t(c,s);for(const I of s)c=c.replace(I,"");return c=o(c),c}})}e.$ao=n}),define(ne[26],se([0,1,28,20,37,12,11,9,34,39]),function(G,e,N,D,O,A,L,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0;function P(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,N.$Ed)(n.id,i.id)===0}e.$bo=P;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const s=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,s,a)}static parse(i){const s=S.exec(i);return s&&s[1]&&s[2]?new p({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$co=p;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function j(n){const i=m.exec(n);return i&&i[1]?[d(i[1]),i[2]]:[d(n),void 0]}e.$do=j;function v(n,i){return`${n}.${i}`}e.$eo=v;function d(n){return n.toLowerCase()}e.$fo=d;function f(n,i){return d(v(n??O.$zl,i))}e.$go=f;function h(n,i){const s=[],a=c=>{for(const I of s)if(I.some(w=>P(i(w),i(c))))return I;return null};for(const c of n){const I=a(c);I?I.push(c):s.push([c])}return s}e.$ho=h;function b(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$io=b;function g(n){return{id:new l.$Xn(n.identifier.id),name:new l.$Xn(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$jo=g,e.$ko=new O.$Dl("pprice.better-merge");function y(n,i){const s=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const c=a.shift();if(c&&s.every(I=>!P(I.identifier,{id:c}))){const I=n.filter(w=>P(w.identifier,{id:c}));I.length===1&&(s.push(I[0]),a.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$lo=y;async function t(n,i){if(!A.$k)return!1;let s;try{s=(await n.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,E.$8)(c))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,i){const s=await t(n,i),a=(0,D.$Gn)(s?"alpine":A.$t,u.$6b);return i.debug("ComputeTargetPlatform:",a),a}e.$mo=o}),define(ne[138],se([0,1,23,9,16,17,41,11,91,20,26,37]),function(G,e,N,D,O,A,L,E,u,l,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=void 0;const p=d=>(0,u.localize)(0,null,d),m=(0,u.localize)(1,null,"ms-dotnettools.csharp");function j(d,f){return f?`${d.publisher}.${d.name}@${d.version}`:`${d.publisher}.${d.name}`}let v=e.$To=class{constructor(f,h,b){this.a=f,this.b=h,this.d=b}get f(){}async listExtensions(f,h,b){let g=await this.b.getInstalled(1,b);const y=S.$Cl.map(o=>o.toLowerCase());if(h&&h!==""){if(y.indexOf(h.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}g=g.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.a.info("Possible Categories: "),y.forEach(o=>{this.a.info(o)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),g=g.sort((o,n)=>o.identifier.id.localeCompare(n.identifier.id));let t;for(const o of g)t!==o.identifier.id&&(t=o.identifier.id,this.a.info(j(o.manifest,f)))}async installExtensions(f,h,b,g){const y=[];try{const t=[];f.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const o=[];let n=[];const i=(a,c,I)=>{n.push({id:a,version:c!=="prerelease"?c:void 0,installOptions:{...b,isBuiltin:I,installPreReleaseVersion:c==="prerelease"||b.installPreReleaseVersion}})};for(const a of f)if(a instanceof E.URI)o.push({vsix:a,installOptions:b});else{const[c,I]=(0,P.$do)(a);i(c,I,!1)}for(const a of h)if(a instanceof E.URI)o.push({vsix:a,installOptions:{...b,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,I]=(0,P.$do)(a);i(c,I,!0)}const s=await this.b.getInstalled(1,b.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:a,installOptions:c})=>{try{const I=await this.g(a,c,g,s);I&&t.push(I)}catch(I){this.a.error(I),y.push(a.toString())}})),n.length&&(n=n.filter(({id:a,version:c})=>{const I=s.find(w=>(0,P.$bo)(w.identifier,{id:a}));if(I){if(!g&&(!c||c==="prerelease"&&I.preRelease))return this.a.info((0,u.localize)(5,null,a,I.manifest.version,a)),!1;if(c&&I.manifest.version===c)return this.a.info((0,u.localize)(6,null,`${a}@${c}`)),!1}return!0}),n.length)){const a=await this.h(n);await Promise.all(n.map(async c=>{const I=a.get(c.id.toLowerCase());if(I)try{const w=await this.j(c,I,s);w&&t.push(w)}catch(w){this.a.error(w.message||w.stack||w),y.push(c.id)}else this.a.error(`${p(c.version?`${c.id}@${c.version}`:c.id)}
${m}`),y.push(c.id)}))}}catch(t){throw this.a.error((0,u.localize)(7,null,(0,D.$8)(t))),t}if(y.length)throw new Error((0,u.localize)(8,null,y.join(", ")))}async g(f,h,b,g){const y=await this.b.getManifest(f);if(!y)throw new Error("Invalid vsix");if(await this.l(y,b,h.profileLocation,g))try{return await this.b.install(f,h),this.a.info((0,u.localize)(9,null,(0,A.$3f)(f))),y}catch(o){if((0,D.$1)(o))return this.a.info((0,u.localize)(10,null,(0,A.$3f)(f))),null;throw o}return null}async h(f){const h=new Map,b=f.some(t=>t.installOptions.installPreReleaseVersion),g=await this.b.getTargetPlatform(),y=[];for(const t of f)l.$An.test(t.id)&&y.push({...t,preRelease:b});if(y.length){const t=await this.d.getExtensions(y,{targetPlatform:g},N.CancellationToken.None);for(const o of t)h.set(o.identifier.id.toLowerCase(),o)}return h}async j({id:f,version:h,installOptions:b},g,y){const t=await this.d.getManifest(g,N.CancellationToken.None);if(t&&!this.k(t))return null;const o=y.find(n=>(0,P.$bo)(n.identifier,g.identifier));if(o){if(g.version===o.manifest.version)return this.a.info((0,u.localize)(11,null,h?`${f}@${h}`:f)),null;this.a.info((0,u.localize)(12,null,f,g.version))}try{b.isBuiltin?this.a.info(h?(0,u.localize)(13,null,f,h):(0,u.localize)(14,null,f)):this.a.info(h?(0,u.localize)(15,null,f,h):(0,u.localize)(16,null,f));const n=await this.b.installFromGallery(g,{...b,installGivenVersion:!!h});return this.a.info((0,u.localize)(17,null,f,n.manifest.version)),t}catch(n){if((0,D.$1)(n))return this.a.info((0,u.localize)(18,null,f)),null;throw n}}k(f){return!0}async l(f,h,b,g){if(!h){const y={id:(0,P.$go)(f.publisher,f.name)},t=g.find(o=>(0,P.$bo)(y,o.identifier)&&(0,L.gt)(o.manifest.version,f.version));if(t)return this.a.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,f.version)),!1}return this.k(f)}async uninstallExtensions(f,h,b){const g=async t=>{if(t instanceof E.URI){const o=await this.b.getManifest(t);return j(o)}return t},y=[];for(const t of f){const o=await g(t),i=(await this.b.getInstalled(void 0,b)).filter(s=>(0,P.$bo)(s.identifier,{id:o}));if(!i.length)throw new Error(`${this.m(o)}
${m}`);if(i.some(s=>s.type===0)){this.a.info((0,u.localize)(20,null,o));return}if(!h&&i.some(s=>s.isBuiltin)){this.a.info((0,u.localize)(21,null,o));return}this.a.info((0,u.localize)(22,null,o));for(const s of i)await this.b.uninstall(s,{profileLocation:b}),y.push(s);this.f?this.a.info((0,u.localize)(23,null,o,this.f)):this.a.info((0,u.localize)(24,null,o))}}async locateExtension(f){const h=await this.b.getInstalled();f.forEach(b=>{h.forEach(g=>{if(g.identifier.id===b&&g.location.scheme===O.Schemas.file){this.a.info(g.location.fsPath);return}})})}m(f){return this.f?(0,u.localize)(25,null,f,this.f):(0,u.localize)(26,null,f)}};e.$To=v=pe([te(1,l.$Nn),te(2,l.$Ln)],v)}),define(ne[139],se([0,1,5,2,35,26,37]),function(G,e,N,D,O,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=void 0;class E extends D.$kb{constructor(l,P,S,p,m,j,v){super(),this.f=l,this.g=P,this.h=S,this.i=p,this.j=m,this.k=j,this.l=v,this.a=this.B(new N.$5c),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$sb),this.m().then(null,d=>v.error(d))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles),this.n(),await this.z()}n(){this.B(this.h.onDidChangeProfiles(l=>this.p(l.added))),this.B(this.i.onAddExtensions(l=>this.r(l))),this.B(this.i.onDidAddExtensions(l=>this.s(l))),this.B(this.i.onRemoveExtensions(l=>this.t(l))),this.B(this.i.onDidRemoveExtensions(l=>this.u(l))),this.B(this.k.onDidFilesChange(l=>this.v(l)))}async p(l){try{l.length&&await Promise.all(l.map(P=>(this.c.set(P.id,(0,D.$hb)(this.k.watch(this.j.extUri.dirname(P.extensionsResource)),this.k.watch(P.extensionsResource))),this.y(P.extensionsResource))))}catch(P){throw this.l.error(P),P}}async r(l){for(const P of l.extensions)this.C(this.F(P.identifier,P.version),l.profileLocation)}async s(l){for(const P of l.extensions){const S=this.F(P.identifier,P.version);l.error?this.D(S,l.profileLocation):this.C(S,l.profileLocation)}}async t(l){for(const P of l.extensions)this.D(this.F(P.identifier,P.version),l.profileLocation)}async u(l){const P=[],S=[];for(const p of l.extensions){const m=this.F(p.identifier,p.version);l.error?this.C(m,l.profileLocation):(this.D(m,l.profileLocation),this.b.has(m)||(this.l.debug("Extension is removed from all profiles",p.identifier.id,p.version),S.push(this.f.scanInstalledExtensionAtLocation(p.location).then(j=>{j?P.push(j):this.l.info("Extension not found at the location",p.location.toString())},j=>this.l.error(j)))))}try{await Promise.all(S),P.length&&await this.z(P)}catch(p){this.l.error(p)}}v(l){for(const P of this.h.profiles)l.contains(P.extensionsResource,0,1)&&this.w(P.extensionsResource)}async w(l){const P=[],S=[],p=await this.i.scanProfileExtensions(l),m=new Set,j=new Set;for(const[v,d]of this.b)d.has(l)&&j.add(v);for(const v of p){const d=this.F(v.identifier,v.version);m.add(d),j.has(d)||(P.push(v.identifier),this.C(d,l))}for(const v of j)if(!m.has(v)){const d=this.G(v);d&&(S.push(d.identifier),this.D(v,l))}(P.length||S.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:l}:void 0,removed:S.length?{extensions:S,profileLocation:l}:void 0})}async y(l){const P=await this.i.scanProfileExtensions(l);for(const S of P)this.C(this.F(S.identifier,S.version),l)}async z(l){l||(l=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.F(S.identifier,S.manifest.version)))),l.length&&await this.f.markAsUninstalled(...l)}C(l,P){let S=this.b.get(l);S||this.b.set(l,S=new O.$ki(p=>this.j.extUri.getComparisonKey(p))),S.add(P)}D(l,P){const S=this.b.get(l);S&&S.delete(P),S?.size||this.b.delete(l)}F(l,P){return`${L.$Dl.toKey(l.id)}@${P}`}G(l){const[P,S]=(0,A.$do)(l);return S?{identifier:{id:P},version:S}:void 0}}e.$ip=E}),define(ne[140],se([0,1,111,39]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=void 0;async function O(A,L,E,u,l,P,S){const p={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${L.nameShort})`};if((0,D.$6n)(L,E)&&(0,D.$8n)(u)===3){const m=await(0,N.$Mo)(E,l,P);p["X-Market-User-Id"]=m,p["VSCode-SessionId"]=S.machineId||m}return p}e.$No=O}),define(ne[141],se([0,1,170,19,8,2,16,15,22,18,20,26,6,64,11]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=void 0;let v=e.$vq=class extends m.$uq{constructor(b,g,y,t){super(y),this.h=b,this.i=t,this.g=this.B(new d(g,t)),this.h.registerParticipant({postInstall:async o=>this.j(o),postUninstall:async o=>this.k(o)})}async getBuiltInExtensionTranslationsUri(b,g){const t=(await this.g.getLanguagePacks())[g];if(!t){this.i.warn(`No language pack found for ${g}`);return}const o=t.translations[b];return o?j.URI.file(o):void 0}async getInstalledLanguages(){const b=await this.g.getLanguagePacks(),g=Object.keys(b).map(y=>{const t=b[y];return{...this.f(y,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort((y,t)=>y.label.localeCompare(t.label)),g}async j(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",b.identifier.id),await this.update())}async k(b){const g=await this.g.getLanguagePacks();Object.keys(g).some(y=>g[y]&&g[y].extensions.some(t=>(0,S.$bo)(t.extensionIdentifier,b.identifier)))&&(this.i.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),y=await this.g.update(g);return!(0,D.$$e)(Object.keys(b),Object.keys(y))}};e.$vq=v=pe([te(0,P.$Nn),te(1,l.$th),te(2,P.$Ln),te(3,p.$Ni)],v);let d=class extends A.$kb{constructor(b,g){super(),this.i=g,this.c={},this.f=(0,E.$$b)(b.userDataPath,"languagepacks.json"),this.g=new O.$yg}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(b){return this.m(g=>{Object.keys(g).forEach(y=>delete g[y]),this.j(g,...b)}).then(()=>this.c)}j(b,...g){for(const y of g)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.k(b,y);Object.keys(b).forEach(y=>this.l(b[y]))}k(b,g){const y=g.identifier,t=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const o of t)if(g.location.scheme===L.Schemas.file&&f(o)){let n=b[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},b[o.languageId]=n);const i=n.extensions.filter(s=>(0,S.$bo)(s.extensionIdentifier,y))[0];i?i.version=g.manifest.version:n.extensions.push({extensionIdentifier:y,version:g.manifest.version});for(const s of o.translations)n.translations[s.id]=(0,E.$$b)(g.location.fsPath,s.path)}}l(b){if(b){const g=(0,N.createHash)("md5");for(const y of b.extensions)g.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);b.hash=g.digest("hex")}}m(b=()=>null){return this.g.queue(()=>{let g=null;return u.Promises.readFile(this.f,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(g=b(y),y)).then(y=>{for(const o of Object.keys(y))y[o]||delete y[o];this.c=y,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),u.Promises.writeFile(this.f,t)}).then(()=>g,y=>this.i.error(y))})}};d=pe([te(0,l.$th),te(1,p.$Ni)],d);function f(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const b of h.translations)if(typeof b.id!="string"||typeof b.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(ne[142],se([0,1,9,30,39]),function(G,e,N,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",L="https://mobile.events.data.microsoft.com/ping";async function E(l,P,S){const p=await new Promise((f,h)=>{G(["@microsoft/1ds-core-js"],f,h)}),m=await new Promise((f,h)=>{G(["@microsoft/1ds-post-js"],f,h)}),j=new p.AppInsightsCore,v=new m.PostChannel,d={instrumentationKey:l,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(S){d.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:S};d.extensionConfig[v.identifier]=f}return j.initialize(d,[]),j.addTelemetryInitializer(f=>{P&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),j}class u{constructor(P,S,p,m,j){this.e=P,this.f=S,this.g=p,this.h=j,this.c=A,this.d=L,this.g||(this.g={}),typeof m=="function"?this.a=m():this.a=m,this.b=null}i(P){if(this.a){if(typeof this.a!="string"){P(this.a);return}this.b||(this.b=E(this.a,this.e,this.h)),this.b.then(S=>{P(S)},S=>{(0,N.$X)(S),console.error(S)})}}log(P,S){if(!this.a)return;S=(0,D.$Gm)(S,this.g),S=(0,O.$9n)(S);const p=this.f+"/"+P;try{this.i(m=>{m.pluginVersionString=S?.properties.version??"Unknown",m.track({name:p,baseData:{name:p,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this.a?new Promise(P=>{this.i(S=>{S.unload(!0,()=>{this.a=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.$jM=u}),define(ne[143],se([0,1,2,30,12,28,103,24,42,144,31,36,25,39]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;let j=e.$Bq=class{constructor(f,h,b){this.k=h,this.l=b,this.d={},this.i=new N.$jb,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,A.$ld)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$ld)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(p.$Yk)||g.affectsConfiguration(p.$1k)||g.affectsConfiguration(p.$Zk))&&this.m()}))}setExperimentProperty(f,h){this.d[f]=h}m(){let f=(0,m.$8n)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const b=h.usage?3:h.error?2:0;f=Math.min(f,b)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,h,b){this.g<h||(b=(0,D.$Gm)(b,this.d),b=(0,m.$ao)(b,this.j),b=(0,D.$Gm)(b,this.c),this.b.forEach(g=>g.log(f,b)))}publicLog(f,h){this.n(f,3,h)}publicLog2(f,h){this.publicLog(f,h)}publicLogError(f,h){this.h&&this.n(f,2,h)}publicLogError2(f,h){this.publicLogError(f,h)}};j.IDLE_START_EVENT_NAME="UserIdleStart",j.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$Bq=j=pe([te(1,E.$Rh),te(2,P.$6i)],j);function v(){const d=(0,L.localize)(0,null,l.default.nameLong),f=l.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=O.$o?"":(0,L.localize)(3,null),b=(0,L.localize)(4,null),g=(0,L.localize)(5,null),y=(0,L.localize)(6,null),t=(0,L.localize)(7,null),o=`
|       | ${b} | ${g} | ${y} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,L.localize)(8,null);return`
${d} ${f} ${h}

&nbsp;

${t}
${o}

&nbsp;

${n}
`}S.$Pm.as(u.$Um.Configuration).registerConfiguration({id:p.$Xk,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[p.$Yk]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.$Pm.as(u.$Um.Configuration).registerConfiguration({id:p.$Xk,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[p.$1k]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,L.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,L.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${p.$Yk}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[145],se([0,1,171,142]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=void 0;class O extends D.$jM{constructor(L,E,u,l){const P={sendPOST:(S,p)=>{const m={method:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data)}};try{const j=N.request(S.urlString,m,v=>{v.on("data",function(d){p(v.statusCode??200,v.headers,d.toString())}),v.on("error",function(d){p(0,{})})});j.write(S.data),j.end()}catch{p(0,{})}}};super(L,E,u,l,P)}}e.$kM=O}),define(ne[146],se([0,1,15,22]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v4b=void 0;async function O(A,L){const E=Object.create(null),u=(P,S)=>{const p=JSON.parse(P);E[S]=p};if(L){const P=[],S=await D.Promises.readdir(L);for(const m of S)try{(await D.Promises.stat((0,N.$$b)(L,m))).isDirectory()&&P.push(m)}catch{}const p=[];for(const m of P)(await D.Promises.readdir((0,N.$$b)(L,m))).filter(v=>v==="telemetry.json").length===1&&p.push(m);for(const m of p){const j=(await D.Promises.readFile((0,N.$$b)(L,m,"telemetry.json"))).toString();u(j,m)}}let l=(await D.Promises.readFile((0,N.$$b)(A,"telemetry-core.json"))).toString();return u(l,"vscode-core"),l=(await D.Promises.readFile((0,N.$$b)(A,"telemetry-extensions.json"))).toString(),u(l,"vscode-extensions"),JSON.stringify(E,null,4)}e.$v4b=O}),define(ne[147],se([0,1,12,74,25]),function(G,e,N,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S3b=void 0;async function A(L,E){let u=L.getItem(O.$Wk);return(typeof u!="string"||N.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,D.$qm)(E.error.bind(E))),u}e.$S3b=A}),define(ne[27],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=void 0,e.$lk=(0,N.$lh)("IUriIdentityService")}),define(ne[148],se([0,1,27,112,13,17,72,5,2]),function(G,e,N,D,O,A,L,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class l{constructor(p){this.uri=p,this.time=l._clock++}touch(){return this.time=l._clock++,this}}l._clock=0;let P=e.$$q=class{constructor(p){this.g=p,this.c=new u.$jb,this.f=2**16;const m=new Map,j=v=>{let d=m.get(v.scheme);return d===void 0&&(d=p.hasProvider(v)&&!this.g.hasCapability(v,1024),m.set(v.scheme,d)),d};this.c.add(E.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(v=>{m.delete(v.scheme)})),this.extUri=new A.$Uf(j),this.d=new L.$0q((v,d)=>this.extUri.compare(v,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,A.$7f)(p));const m=this.d.get(p);return m?m.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new l(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((j,v)=>j[1].time<v[1].time?1:j[1].time>v[1].time?-1:0);l._clock=0,this.d.clear();const m=this.f*.5;for(let j=0;j<m;j++)this.d.set(p[j][0],p[j][1].touch())}};e.$$q=P=pe([te(0,O.$Oj)],P),(0,D.$8q)(N.$lk,P,1)}),define(ne[149],se([0,1,105,15,54,17,11,10,16]),function(G,e,N,D,O,A,L,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.WorkbenchState=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$uh=(0,E.$lh)("contextService");function l(i){const s=i;return typeof s?.id=="string"&&L.URI.isUri(s.uri)}e.$vh=l;function P(i){return typeof i?.id=="string"&&!l(i)&&!p(i)}e.$wh=P,e.$xh={id:"ext-dev"},e.$yh={id:"empty-window"};function S(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$cc)(i)}:s?e.$xh:e.$yh;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$zh=S;function p(i){const s=i;return typeof s?.id=="string"&&L.URI.isUri(s.configPath)}e.$Ah=p;function m(i){const s=i;if(s?.uri)return{id:s.id,uri:L.URI.revive(s.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:L.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.$Bh=m;var j;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(j||(e.WorkbenchState=j={}));function v(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$Ch=v;function d(i){const s=i;return!!(s&&typeof s=="object"&&L.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$Dh=d;class f{constructor(s,a,c,I,w){this.h=s,this.j=c,this.k=I,this.l=w,this.c=O.$rh.forUris(this.l,()=>!0),this.folders=a}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=O.$rh.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Eh=f;class h{constructor(s,a){this.raw=a,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$6f)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Fh=h;function b(i){return new h({uri:i,index:0,name:(0,A.$2f)(i)},{uri:i.toString()})}e.$Gh=b,e.$Hh="code-workspace",e.$Ih=`.${e.$Hh}`,e.$Jh=[{name:(0,N.localize)(0,null),extensions:[e.$Hh]}],e.$Kh="workspace.json";function g(i,s){return A.$Wf.isEqualOrParent(i,s.untitledWorkspacesHome)}e.$Lh=g;function y(i){let s;return L.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===u.Schemas.tmp}e.$Mh=y,e.$Nh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Nh}e.$Oh=t;function o(i,s){return!g(i,s)&&!y(i)}e.$Ph=o;function n(i){return(typeof i=="string"?(0,D.$dc)(i):(0,A.$4f)(i))===e.$Ih}e.$Qh=n}),define(ne[21],se([0,1,45,5,2,17,11,104,18,13,10,6,149,35,27,8,29,28,3]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m,j,v,d,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=void 0;function b(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&L.URI.isUri(i.location)&&L.URI.isUri(i.globalStorageHome)&&L.URI.isUri(i.settingsResource)&&L.URI.isUri(i.keybindingsResource)&&L.URI.isUri(i.tasksResource)&&L.URI.isUri(i.snippetsHome)&&L.URI.isUri(i.extensionsResource))}e.$mk=b,e.$nk=(0,P.$lh)("IUserDataProfilesService");function g(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:L.URI.revive(n.location).with({scheme:i}),globalStorageHome:L.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:L.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:L.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:L.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:L.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:L.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:L.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$ok=g;function y(n,i,s,a,c){return{id:n,name:i,location:s,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,A.$6f)(s,"globalStorage"),settingsResource:(0,A.$6f)(s,"settings.json"),keybindingsResource:(0,A.$6f)(s,"keybindings.json"),tasksResource:(0,A.$6f)(s,"tasks.json"),snippetsHome:(0,A.$6f)(s,"snippets"),extensionsResource:(0,A.$6f)(s,"extensions.json"),cacheHome:(0,A.$6f)(a,n),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.$pk=y;let t=e.$qk=class extends O.$kb{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,s,a,c){super(),this.n=i,this.r=s,this.s=a,this.t=c,this.f=!0,this.h=this.B(new D.$5c),this.onDidChangeProfiles=this.h.event,this.i=this.B(new D.$5c),this.onWillCreateProfile=this.i.event,this.j=this.B(new D.$5c),this.onWillRemoveProfile=this.j.event,this.k=this.B(new D.$5c),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new m.$ji,emptyWindows:new Map},this.profilesHome=(0,A.$6f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,A.$6f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=[];if(this.f)try{for(const I of this.J()){if(!I.name||!(0,h.$ge)(I.name)||!I.location){this.t.warn("Skipping the invalid stored profile",I.location||I.name);continue}i.push(y((0,A.$3f)(I.location),I.name,I.location,this.g,{shortName:I.shortName,useDefaultFlags:I.useDefaultFlags}))}}catch(I){this.t.error(I)}const s=new m.$ji,a=new Map,c=this.w();if(i.unshift({...c,extensionsResource:this.O()??c.extensionsResource,isDefault:!0}),i.length)try{const I=this.M();if(I.workspaces)for(const[w,$]of Object.entries(I.workspaces)){const M=L.URI.parse(w),Q=i.find(J=>J.id===$);Q&&s.set(M,Q)}if(I.emptyWindows)for(const[w,$]of Object.entries(I.emptyWindows)){const M=i.find(Q=>Q.id===$);M&&a.set(w,M)}}catch(I){this.t.error(I)}this.u={profiles:i,workspaces:s,emptyWindows:a}}return this.u}w(){return y("__default__profile__",(0,E.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(i){const s="Temp",a=new RegExp(`${(0,f.$ld)(s)}\\s(\\d+)`);let c=0;for(const w of this.profiles){const $=a.exec(w.name),M=$?parseInt($[1]):0;c=M>c?M:c}const I=`${s} ${c+1}`;return this.createProfile((0,N.$_h)((0,d.$3e)()).toString(16),I,{transient:!0},i)}async createNamedProfile(i,s,a){return this.createProfile((0,N.$_h)((0,d.$3e)()).toString(16),i,s,a)}async createProfile(i,s,a,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.y(i,s,a);return c&&await this.setProfileForWorkspace(c,I),I}async y(i,s,a){if(!(0,h.$ge)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let c=this.l.get(s);return c||(c=(async()=>{try{const I=this.profiles.find(M=>M.name===s||M.id===i);if(I)return I;const w=y(i,s,(0,A.$6f)(this.profilesHome,i),this.g,a);await this.r.createFolder(w.location);const $=[];return this.i.fire({profile:w,join(M){$.push(M)}}),await v.Promises.settled($),this.D([w],[],[]),w}finally{this.l.delete(s)}})(),this.l.set(s,c)),c}async updateProfile(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(c=>c.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=y(a.id,s.name??a.name,a.location,this.g,{shortName:s.shortName??a.shortName,transient:s.transient??a.isTransient,useDefaultFlags:s.useDefaultFlags??a.useDefaultFlags}),this.D([],[],[a]),a}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(c=>c.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this.j.fire({profile:s,join(c){a.push(c)}});try{await Promise.allSettled(a)}catch(c){this.t.error(c)}for(const c of[...this.v.emptyWindows.keys()])s.id===this.v.emptyWindows.get(c)?.id&&this.v.emptyWindows.delete(c);for(const c of[...this.v.workspaces.keys()])s.id===this.v.workspaces.get(c)?.id&&this.v.workspaces.delete(c);this.H(),this.D([],[s],[]);try{await this.r.del(s.cacheHome,{recursive:!0})}catch(c){(0,l.$5j)(c)!==1&&this.t.error(c)}}async setProfileForWorkspace(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(c=>c.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);this.G(i,a)}unsetWorkspace(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,s)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(s=>s.isDirectory&&this.profiles.every(a=>!this.s.extUri.isEqual(a.location,s.resource))).map(s=>this.r.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(s=>!this.C(s));await Promise.allSettled(i.map(s=>this.removeProfile(s)))}getProfileForWorkspace(i){const s=this.z(i);return L.URI.isUri(s)?this.m.workspaces.get(s)??this.v.workspaces.get(s):this.m.emptyWindows.get(s)??this.v.emptyWindows.get(s)}z(i){return(0,p.$vh)(i)?i.uri:(0,p.$Ah)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(s=>this.s.extUri.isEqual(s.location,i.location))||[...this.m.workspaces.values()].some(s=>this.s.extUri.isEqual(s.location,i.location))||[...this.v.emptyWindows.values()].some(s=>this.s.extUri.isEqual(s.location,i.location))||[...this.v.workspaces.values()].some(s=>this.s.extUri.isEqual(s.location,i.location)))}D(i,s,a){const c=[...this.profiles,...i],I=[];this.m.profiles=[];for(let w of c)w.isDefault||s.some($=>w.id===$.id)||(w=a.find($=>w.id===$.id)??w,w.isTransient?this.m.profiles.push(w):I.push({location:w.location,name:w.name,shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}));this.L(I),this.u=void 0,this.F(i,s,a)}F(i,s,a){this.h.fire({added:i,removed:s,updated:a,all:this.profiles})}G(i,s,a){a=s?.isTransient?!0:a,a||this.G(i,void 0,!0);const c=this.z(i),I=a?this.m:this.v;L.URI.isUri(c)?(I.workspaces.delete(c),s&&I.workspaces.set(c,s)):(I.emptyWindows.delete(c),s&&I.emptyWindows.set(c,s)),a||this.H()}H(){const i={};for(const[a,c]of this.v.workspaces.entries())i[a.toString()]=c.id;const s={};for(const[a,c]of this.v.emptyWindows.entries())s[a.toString()]=c.id;this.N({workspaces:i,emptyWindows:s}),this.u=void 0}I(i){const s={},a=this.w();if(i.workspaces)for(const[I,w]of Object.entries(i.workspaces)){const $=L.URI.parse(w);s[I]=this.s.extUri.isEqual($,a.location)?a.id:this.s.extUri.basename($)}const c={};if(i.emptyWindows)for(const[I,w]of Object.entries(i.emptyWindows)){const $=L.URI.parse(w);c[I]=this.s.extUri.isEqual($,a.location)?a.id:this.s.extUri.basename($)}return{workspaces:s,emptyWindows:c}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",e.$qk=t=pe([te(0,u.$sh),te(1,l.$Oj),te(2,j.$lk),te(3,S.$Ni)],t);class o extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.$rk=o}),define(ne[150],se([0,1,19,8,23,9,5,2,12,3,11,89,20,26,37,6,31,25,21]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m,j,v,d,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=void 0;let b=e.$3o=class extends E.$kb{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,s,a,c,I){super(),this.t=i,this.u=s,this.v=a,this.w=c,this.y=I,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new L.$5c),this.m=this.B(new L.$5c),this.n=this.B(new L.$5c),this.p=this.B(new L.$5c),this.s=[],this.B((0,E.$ib)(()=>{this.j.forEach(({task:w})=>w.cancel()),this.k.forEach(w=>w.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const s=await this.getTargetPlatform();return i.allTargetPlatforms.some(a=>(0,p.$In)(a,i.allTargetPlatforms,s))}async installFromGallery(i,s={}){try{const c=(await this.installGalleryExtensions([{extension:i,options:s}])).find(({identifier:I})=>(0,m.$bo)(I,i.identifier));if(c?.local)return c?.local;throw c?.error?c.error:y(new Error(`Unknown error while installing extension ${i.identifier.id}`))}catch(a){throw y(a)}}async installGalleryExtensions(i){if(!this.t.isEnabled())throw new p.$Mn(S.localize(0,null),p.ExtensionManagementErrorCode.Internal);const s=[],a=[];await Promise.allSettled(i.map(async({extension:c,options:I})=>{try{const w=await this.H(c,!!I?.installGivenVersion,!!I?.installPreReleaseVersion);a.push({...w,options:I})}catch(w){s.push({identifier:c.identifier,operation:2,source:c,error:w})}})),a.length&&s.push(...await this.z(a));for(const c of s)c.error&&(this.v.error("Failed to install extension.",c.identifier.id),this.v.error(c.error),c.source&&!P.URI.isUri(c.source)&&t(this.u,"extensionGallery:install",{extensionData:(0,m.$jo)(c.source),error:c.error}));return s}async uninstall(i,s={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.J(i,s)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.P(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i){const s=[];return await Promise.allSettled(i.map(async a=>{try{const c=await this.C(a);s.push(...c)}catch(c){s.push({identifier:{id:(0,m.$go)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:c})}})),this.m.fire(s),s}async C({manifest:i,extension:s,options:a}){const c=a.isApplicationScoped||a.isBuiltin||(0,j.$Gl)(i),I={...a,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(s)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:c,profileLocation:c?this.y.defaultProfile.extensionsResource:a.profileLocation??this.Q()},w=ue=>`${m.$co.create(ue).toString()}${I.profileLocation?`-${I.profileLocation.toString()}`:""}`;if(!P.URI.isUri(s)){const ue=this.j.get(w(s));if(ue)return this.v.info("Extensions is already requested to install",s.identifier.id),await ue.task.waitUntilTaskIsFinished(),[]}const $=[],M=[],Q=[],J=this.R(i,s,I);P.URI.isUri(s)||this.j.set(w(s),{task:J,waitingTasks:[]}),this.l.fire({identifier:J.identifier,source:s,profileLocation:I.profileLocation}),this.v.info("Installing extension:",J.identifier.id),$.push({task:J,manifest:i});let ie=!1;try{if(I.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",J.identifier.id);else try{const x=await this.G(J.identifier,i,!!I.installOnlyNewlyAddedFromExtensionPack,!!I.installPreReleaseVersion,I.profileLocation),ce=await this.getInstalled(void 0,I.profileLocation);for(const{gallery:le,manifest:oe}of(0,N.$of)(x,({gallery:V})=>V.identifier.id)){ie=ie||!!oe.extensionDependencies?.some(F=>(0,m.$bo)({id:F},J.identifier));const V=w(le),H=this.j.get(V);if(H){if(this.D(J,H.task)){const F=H.task.identifier;this.v.info("Waiting for already requested installing extension",F.id,J.identifier.id),H.waitingTasks.push(J),M.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,U=>U.some(W=>(0,m.$bo)(W.identifier,F)))).then(U=>{if(this.v.info("Finished waiting for already requested installing extension",F.id,J.identifier.id),!U.find(X=>(0,m.$bo)(X.identifier,F))?.local)throw new Error(`Extension ${F.id} is not installed`)}))}}else if(!ce.some(({identifier:F})=>(0,m.$bo)(F,le.identifier))){const F=this.R(oe,le,{...I,donotIncludePackAndDependencies:!0});this.j.set(V,{task:F,waitingTasks:[J]}),this.l.fire({identifier:F.identifier,source:le,profileLocation:I.profileLocation}),this.v.info("Installing extension:",F.identifier.id,J.identifier.id),$.push({task:F,manifest:oe})}}}catch(x){if(P.URI.isUri(J.source))(0,N.$nf)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",J.identifier.id,x.message),(0,N.$nf)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",J.identifier.id,x.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",J.identifier.id),x}const ue=$.reduce((x,{task:ce,manifest:le})=>(x.set(ce.identifier.id.toLowerCase(),{task:ce,manifest:le}),x),new Map);for(;ue.size;){let x;const ce=[...ue.values()].filter(({manifest:le})=>!le.extensionDependencies?.some(oe=>ue.has(oe.toLowerCase())));ce.length?x=ue.size===1?ce:ce.filter(({task:le})=>!(le===J&&!ie)):(this.v.info("Found extensions with circular dependencies",ce.map(({task:le})=>le.identifier.id)),x=[...ue.values()]),await this.F(x.map(async({task:le})=>{const oe=new Date().getTime();try{const V=await le.run();if(await this.F(this.s.map(H=>H.postInstall(V,le.source,I,O.CancellationToken.None))),!P.URI.isUri(le.source)){const H=le.operation===3,F=H?void 0:(new Date().getTime()-le.source.lastUpdated)/1e3;if(t(this.u,H?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$jo)(le.source),verificationStatus:le.verificationStatus,duration:new Date().getTime()-oe,durationSinceUpdate:F}),u.$o&&le.operation!==3)try{await this.t.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}Q.push({local:V,identifier:le.identifier,operation:le.operation,source:le.source,context:I.context,profileLocation:le.profileLocation,applicationScoped:V.isApplicationScoped})}catch(V){throw P.URI.isUri(le.source)||t(this.u,le.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$jo)(le.source),verificationStatus:le.verificationStatus,duration:new Date().getTime()-oe,error:V}),this.v.error("Error while installing the extension:",le.identifier.id),V}finally{ue.delete(le.identifier.id.toLowerCase())}}))}return M.length&&await this.F(M),Q.forEach(({identifier:x})=>this.v.info("Extension installed successfully:",x.id)),Q}catch(ue){if($.forEach(({task:x})=>x.cancel()),Q.length)try{const x=await Promise.allSettled(Q.map(({local:ce})=>this.S(ce,{versionOnly:!0,profileLocation:I.profileLocation}).run()));for(let ce=0;ce<x.length;ce++){const le=x[ce],{identifier:oe}=Q[ce];le.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",oe.id):this.v.warn("Rollback: Error while uninstalling extension",oe.id,(0,A.$8)(le.reason))}}catch(x){this.v.warn("Error while rolling back extensions",(0,A.$8)(x),Q.map(({identifier:ce})=>ce.id))}return $.map(({task:x})=>({identifier:x.identifier,operation:2,source:x.source,context:I.context,profileLocation:I.profileLocation,error:ue}))}finally{for(const{task:ue}of $)ue.source&&!P.URI.isUri(ue.source)&&this.j.delete(w(ue.source))}}D(i,s){for(const[,{task:a,waitingTasks:c}]of this.j.entries())if(a===i&&(c.includes(s)||c.some(I=>this.D(I,s)))||a===s&&c[0]&&!this.D(i,c[0]))return!1;return!0}async F(i){const s=[],a=[],c=await Promise.allSettled(i);for(const I of c)I.status==="fulfilled"?s.push(I.value):a.push(I.reason);if(a.length)throw g(a);return s}async G(i,s,a,c,I){if(!this.t.isEnabled())return[];const w=await this.getInstalled(void 0,I),$=[],M=[],Q=async(J,ie)=>{$.push(J);const ue=ie.extensionDependencies||[],x=[...ue];if(ie.extensionPack){const ce=a?w.find(le=>(0,m.$bo)(le.identifier,J)):void 0;for(const le of ie.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(oe=>(0,m.$bo)({id:oe},{id:le}))||x.every(oe=>!(0,m.$bo)({id:oe},{id:le}))&&x.push(le)}if(x.length){const ce=x.filter(le=>$.every(oe=>!(0,m.$bo)(oe,{id:le})));if(ce.length){const le=await this.t.getExtensions(ce.map(oe=>({id:oe,preRelease:c})),O.CancellationToken.None);for(const oe of le){if($.find(F=>(0,m.$bo)(F,oe.identifier)))continue;const V=ue.some(F=>(0,m.$bo)({id:F},oe.identifier));let H;try{H=await this.H(oe,!1,c)}catch(F){if(F instanceof p.$Mn&&F.code===p.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!V){this.v.info("Skipping the packed extension as it cannot be installed",oe.identifier.id);continue}else throw F}M.push({gallery:H.extension,manifest:H.manifest}),await Q(H.extension.identifier,H.manifest)}}}};return await Q(i,s),M}async H(i,s,a){if((await this.getExtensionsControlManifest()).malicious.some($=>(0,m.$bo)(i.identifier,$)))throw new p.$Mn(S.localize(1,null,i.identifier.id),p.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const $=await this.getTargetPlatform();throw new p.$Mn(S.localize(2,null,i.identifier.id,this.w.nameLong,(0,p.$En)($)),p.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const I=await this.I(i,s,a);if(I){if(a&&!s&&i.hasPreReleaseVersion&&!I.properties.isPreReleaseVersion)throw new p.$Mn(S.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),p.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],O.CancellationToken.None))[0]?new p.$Mn(S.localize(4,null,i.identifier.id),p.ExtensionManagementErrorCode.ReleaseVersionNotFound):new p.$Mn(S.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),p.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",I.identifier.id);const w=await this.t.getManifest(I,O.CancellationToken.None);if(w===null)throw new p.$Mn(`Missing manifest for extension ${i.identifier.id}`,p.ExtensionManagementErrorCode.Invalid);if(w.version!==I.version)throw new p.$Mn(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,p.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:w}}async I(i,s,a){const c=await this.getTargetPlatform();let I=null;return!s&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==a&&(I=(await this.t.getExtensions([{...i.identifier,preRelease:a}],{targetPlatform:c,compatible:!0},O.CancellationToken.None))[0]||null),!I&&await this.t.isExtensionCompatible(i,a,c)&&(I=i),I||(s?I=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:c,compatible:!0},O.CancellationToken.None))[0]||null:I=await this.t.getCompatibleExtension(i,a,c)),I}async J(i,s){const a={...s,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:s.profileLocation??this.Q()},c=J=>`${J.id.toLowerCase()}${a.versionOnly?`-${i.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,I=this.k.get(c(i.identifier));if(I)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),I.waitUntilTaskIsFinished();const w=J=>{const ie=this.S(J,a);return this.k.set(c(ie.extension.identifier),ie),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${J.identifier.id}@${J.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${J.identifier.id}@${J.manifest.version}`),this.n.fire({identifier:J.identifier,profileLocation:a.profileLocation,applicationScoped:J.isApplicationScoped}),ie},$=(J,ie)=>{ie?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${J.identifier.id}@${J.manifest.version}`,a.profileLocation.toString(),ie.message):this.v.error("Failed to uninstall extension:",`${J.identifier.id}@${J.manifest.version}`,ie.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${J.identifier.id}@${J.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${J.identifier.id}@${J.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,m.$io)(J),error:ie}),this.p.fire({identifier:J.identifier,error:ie?.code,profileLocation:a.profileLocation,applicationScoped:J.isApplicationScoped})},M=[],Q=[];try{M.push(w(i));const J=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const ie=this.N(i,J);for(const ue of ie)this.k.has(c(ue.identifier))?this.v.info("Extensions is already requested to uninstall",ue.identifier.id):M.push(w(ue))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.L(M.map(ie=>ie.extension),J,i),await this.F(M.map(async ie=>{try{if(await ie.run(),await this.F(this.s.map(ue=>ue.postUninstall(ie.extension,a,O.CancellationToken.None))),ie.extension.identifier.uuid)try{await this.t.reportStatistic(ie.extension.manifest.publisher,ie.extension.manifest.name,ie.extension.manifest.version,"uninstall")}catch{}$(ie.extension)}catch(ue){const x=ue instanceof p.$Mn?ue:new p.$Mn((0,A.$8)(ue),p.ExtensionManagementErrorCode.Internal);throw $(ie.extension,x),x}finally{Q.push(ie)}}))}catch(J){const ie=J instanceof p.$Mn?J:new p.$Mn((0,A.$8)(J),p.ExtensionManagementErrorCode.Internal);for(const ue of M){try{ue.cancel()}catch{}Q.includes(ue)||$(ue.extension,ie)}throw ie}finally{for(const J of M)this.k.delete(c(J.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",J.extension.identifier.id)}}L(i,s,a){for(const c of i){const I=this.O(c,s);if(I.length){const w=I.filter($=>!i.some(M=>(0,m.$bo)(M.identifier,$.identifier)));if(w.length)throw new Error(this.M(c,w,a))}}}M(i,s,a){return a===i?s.length===1?S.localize(6,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?S.localize(7,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):S.localize(8,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?S.localize(9,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?S.localize(10,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):S.localize(11,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}N(i,s,a=[]){if(a.indexOf(i)!==-1)return[];a.push(i);const c=i.manifest.extensionPack?i.manifest.extensionPack:[];if(c.length){const I=s.filter($=>!$.isBuiltin&&c.some(M=>(0,m.$bo)({id:M},$.identifier))),w=[];for(const $ of I)w.push(...this.N($,s,a));return[...I,...w]}return[]}O(i,s){return s.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(c=>(0,m.$bo)({id:c},i.identifier)))}async P(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$3o=b=pe([te(0,p.$Ln),te(1,f.$Rk),te(2,v.$Ni),te(3,d.$6i),te(4,h.$nk)],b);function g(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$4o=g;function y(n){if(n instanceof p.$Mn)return n;const i=new p.$Mn(n.message,p.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}e.$5o=y;function t(n,i,{extensionData:s,verificationStatus:a,duration:c,error:I,durationSinceUpdate:w}){let $,M;(0,l.$oe)(a)&&(a===!0?a="Verified":(a===!1||($=p.ExtensionManagementErrorCode.Signature,M=a),a="Unverified")),I&&(I instanceof p.$Mn?($=I.code,I.code===p.ExtensionManagementErrorCode.Signature&&(M=I.message)):$=p.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...s,verificationStatus:a,success:!I,duration:c,errorcode:$,errorcodeDetail:M,durationSinceUpdate:w})}class o{constructor(){this.d=new D.$qg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$fg)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$fg)(i=>new Promise((s,a)=>{const c=i.onCancellationRequested(()=>{c.dispose(),a(new A.$2)})})),this.d.open()),this.g.cancel()}}e.$6o=o}),define(ne[40],se([0,1,8,14,2,5,35,11,20,26,13,10,6,21,27,3,9,25]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m,j,v,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class b extends Error{constructor(n,i){super(n),this.code=i}}e.$7o=b,e.$8o=(0,S.$lh)("IExtensionsProfileScannerService");let g=e.$9o=class extends O.$kb{constructor(n,i,s,a,c,I){super(),this.i=n,this.j=i,this.k=s,this.l=a,this.m=c,this.n=I,this.b=this.B(new A.$5c),this.onAddExtensions=this.b.event,this.c=this.B(new A.$5c),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$5c),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$5c),this.onDidRemoveExtensions=this.g.event,this.h=new L.$ji}scanProfileExtensions(n,i){return this.p(n,void 0,i)}async addExtensionsToProfile(n,i){const s=[],a=[];try{return await this.p(i,c=>{const I=[];for(const w of c)n.some(([$])=>(0,l.$bo)($.identifier,w.identifier)&&$.manifest.version!==w.version)?s.push(w):I.push(w);for(const[w,$]of n)if(!I.some(M=>(0,l.$bo)(M.identifier,w.identifier)&&M.version===w.manifest.version)){const M={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:$};a.push(M),I.push(M)}return a.length&&this.b.fire({extensions:a,profileLocation:i}),s.length&&this.f.fire({extensions:s,profileLocation:i}),I}),a.length&&this.c.fire({extensions:a,profileLocation:i}),s.length&&this.g.fire({extensions:s,profileLocation:i}),a}catch(c){throw a.length&&this.c.fire({extensions:a,error:c,profileLocation:i}),s.length&&this.g.fire({extensions:s,error:c,profileLocation:i}),c}}async updateMetadata(n,i){const s=[];return await this.p(i,a=>{const c=[];for(const I of a){const w=n.find(([$])=>(0,l.$bo)($.identifier,I.identifier)&&$.manifest.version===I.version);w&&(I.metadata={...I.metadata,...w[1]},s.push(I)),c.push(I)}return c}),s}async removeExtensionFromProfile(n,i){const s=[];this.f.fire({extensions:s,profileLocation:i});try{await this.p(i,a=>{const c=[];for(const I of a)(0,l.$bo)(I.identifier,n.identifier)?s.push(I):c.push(I);return s.length&&this.f.fire({extensions:s,profileLocation:i}),c}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(a){throw s.length&&this.g.fire({extensions:s,error:a,profileLocation:i}),a}}async p(n,i,s){return this.w(n).queue(async()=>{let a=[],c;try{const I=await this.j.readFile(n);c=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,P.$5j)(I)!==1)throw I;if(this.l.extUri.isEqual(n,this.k.defaultProfile.extensionsResource)&&(c=await this.v()),!c&&s?.bailOutWhenFileNotFound)throw new b((0,d.$8)(I),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.r(n);let I=!1;for(const w of c){y(w)||this.r(n);let $;if((0,v.$ge)(w.relativeLocation)&&w.relativeLocation)$=this.t(w.relativeLocation);else if((0,v.$ge)(w.location))$=this.t(w.location),I=!0,w.relativeLocation=w.location,w.location=$.toJSON();else{$=E.URI.revive(w.location);const M=this.s($);M&&(I=!0,w.relativeLocation=M)}a.push({identifier:w.identifier,location:$,version:w.version,metadata:w.metadata})}I&&await this.j.writeFile(n,D.$Ib.fromString(JSON.stringify(c)))}if(i){a=i(a);const I=a.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.s(w.location),metadata:w.metadata}));await this.j.writeFile(n,D.$Ib.fromString(JSON.stringify(I)))}return a})}r(n){const i=new b(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(n){return this.l.extUri.isEqual(this.l.extUri.dirname(n),this.i)?this.l.extUri.basename(n):void 0}t(n){return this.l.extUri.joinPath(this.i,n)}async v(){return this.u||(this.u=(async()=>{const n=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let s;try{s=(await this.j.readFile(n)).value.toString()}catch(c){if((0,P.$5j)(c)===1)return;throw c}this.n.info("Migrating extensions from old default profile location",n.toString());let a;try{const c=JSON.parse(s);Array.isArray(c)&&c.every(I=>y(I))?a=c:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.n.error(c)}if(a)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,D.$Ib.fromString(JSON.stringify(a)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",n.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(c){if((0,P.$5j)(c)===3)this.n.info("Migration from old default profile location to new location is done by another window",n.toString(),this.k.defaultProfile.extensionsResource.toString());else throw c}try{await this.j.del(n)}catch(c){(0,P.$5j)(c)!==1&&this.n.error(c)}try{await this.j.del(i)}catch(c){(0,P.$5j)(c)!==1&&this.n.error(c)}return a})()),this.u}w(n){let i=this.h.get(n);return i||(i=new N.$yg,this.h.set(n,i)),i}};e.$9o=g=pe([te(1,P.$Oj),te(2,m.$nk),te(3,j.$lk),te(4,f.$Rk),te(5,p.$Ni)],g);function y(o){return(0,v.$ie)(o)&&(0,u.$Kn)(o.identifier)&&(t(o.location)||(0,v.$ge)(o.location)&&o.location)&&((0,v.$ne)(o.relativeLocation)||(0,v.$ge)(o.relativeLocation))&&o.version&&(0,v.$ge)(o.version)}function t(o){return o?(0,v.$ge)(o.path)&&(0,v.$ge)(o.scheme):!1}}),define(ne[49],se([0,1,19,8,30,14,9,52,79,2,16,15,12,17,41,53,3,11,93,18,26,37,47,13,10,6,31,5,46,40,21,27,110]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m,j,v,d,f,h,b,g,y,t,o,n,i,s,a,c,I,w,$,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.Translations=void 0;var Q;(function(oe){function V(H,F){if(H===F)return!0;const U=Object.keys(H),W=new Set;for(const X of Object.keys(F))W.add(X);if(U.length!==W.size)return!1;for(const X of U){if(H[X]!==F[X])return!1;W.delete(X)}return W.size===0}oe.equals=V})(Q||(e.Translations=Q={})),e.$_o=(0,n.$lh)("IExtensionsScannerService");let J=e.$ap=class extends l.$kb{constructor(V,H,F,U,W,X,Y,z,C,R,r,k){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=H,this.l=F,this.m=U,this.n=W,this.r=X,this.s=Y,this.t=z,this.u=C,this.v=R,this.w=r,this.y=k,this.g=this.B(new a.$5c),this.onDidChangeCache=this.g.event,this.h=(0,m.$6f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(x,this.m,this.h)),this.j=this.B(this.y.createInstance(x,this.m,this.h)),this.k=this.B(this.y.createInstance(ue,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,g.$mo)(this.s,this.t)),this.z}async scanAllExtensions(V,H,F){const[U,W]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(H)]),X=F?await this.scanExtensionsUnderDevelopment(V,[...U,...W]):[];return this.G(U,W,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const H=[];H.push(this.H(!!V.useCache,V.language)),H.push(this.I(V.language,!!V.checkControlFile));const[F,U]=await Promise.all(H);return this.F([...F,...U],0,V,!1)}async scanUserExtensions(V){const H=V.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",H);const F=this.w.extUri.isEqual(V.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.L(H,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,F),W=V.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k;let X;try{X=await W.scanExtensions(U)}catch(Y){if(Y instanceof I.$7o&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),X=await W.scanExtensions(U);else throw Y}return X=await this.F(X,1,V,!0),this.t.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(V,H){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const F=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(U=>U.scheme===P.Schemas.file).map(async U=>{const W=await this.L(U,!1,1,!0,V.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(Y=>(Y.type=H.find(z=>(0,g.$bo)(z.identifier,Y.identifier))?.type??Y.type,this.k.validate(Y,W)))}))).flat();return this.F(F,"development",V,!0)}return[]}async scanExistingExtension(V,H,F){const U=await this.L(V,!1,H,!0,F.language,!0,void 0),W=await this.k.scanExtension(U);return!W||!F.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(V,H,F){const U=await this.L(V,!1,H,!0,F.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions(U);return this.F(W,H,F,!0)}async scanMetadata(V){const H=(0,m.$6f)(V,"package.json"),F=(await this.s.readFile(H)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(V,H){const F=(0,m.$6f)(V,"package.json"),U=(await this.s.readFile(F)).value.toString(),W=JSON.parse(U);H.isMachineScoped=H.isMachineScoped||void 0,H.isBuiltin=H.isBuiltin||void 0,W.__metadata={...W.__metadata,...H},await this.s.writeFile((0,m.$6f)(V,"package.json"),A.$Ib.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof I.$7o&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw V}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.r.addExtensionsToProfile(V.map(H=>[H,H.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,A.$Ib.fromString(JSON.stringify([])))}catch(H){(0,o.$5j)(H)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$8)(H))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.t.error(V)}finally{this.C=void 0}})()),this.C}async F(V,H,F,U){return F.includeAllVersions||(V=this.G(H===0?V:void 0,H===1?V:void 0,H==="development"?V:void 0,await this.getTargetPlatform(),U)),F.includeInvalid||(V=V.filter(W=>W.isValid)),V.sort((W,X)=>{const Y=S.$cc(W.location.fsPath),z=S.$cc(X.location.fsPath);return Y<z?-1:Y>z?1:0})}G(V,H,F,U,W){const X=(z,C,R)=>{if(z.isValid&&!C.isValid)return!1;if(z.isValid===C.isValid){if(W&&j.gt(z.manifest.version,C.manifest.version))return this.t.debug(`Skipping extension ${C.location.path} with lower version ${C.manifest.version} in favour of ${z.location.path} with version ${z.manifest.version}`),!1;if(j.eq(z.manifest.version,C.manifest.version)){if(z.type===0)return this.t.debug(`Skipping extension ${C.location.path} in favour of system extension ${z.location.path} with same version`),!1;if(z.targetPlatform===U)return this.t.debug(`Skipping extension ${C.location.path} from different target platform ${C.targetPlatform}`),!1}}return R?this.t.warn(`Overwriting user extension ${z.location.path} with ${C.location.path}.`):this.t.debug(`Overwriting user extension ${z.location.path} with ${C.location.path}.`),!0},Y=new y.$Fl;return V?.forEach(z=>{const C=Y.get(z.identifier.id);(!C||X(C,z,!1))&&Y.set(z.identifier.id,z)}),H?.forEach(z=>{const C=Y.get(z.identifier.id);if(!C&&V&&z.type===0){this.t.debug(`Skipping obsolete system extension ${z.location.path}.`);return}(!C||X(C,z,!1))&&Y.set(z.identifier.id,z)}),F?.forEach(z=>{const C=Y.get(z.identifier.id);(!C||X(C,z,!0))&&Y.set(z.identifier.id,z),Y.set(z.identifier.id,z)}),[...Y.values()]}async H(V,H){this.t.trace("Started scanning system extensions");const F=await this.L(this.systemExtensionsLocation,!1,0,!0,H,!0,void 0),W=await(V&&!F.devMode?this.i:this.k).scanExtensions(F);return this.t.trace("Scanned system extensions:",W.length),W}async I(V,H){const F=this.u.isBuilt?[]:this.v.builtInExtensions;if(!F?.length)return[];this.t.trace("Started scanning dev system extensions");const U=H?await this.J():{},W=[],X=f.URI.file(S.$9b(S.$$b(P.$1e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const z of F){const C=U[z.name]||"marketplace";switch(C){case"disabled":break;case"marketplace":W.push((0,m.$6f)(X,z.name));break;default:W.push(f.URI.file(C));break}}const Y=await Promise.all(W.map(async z=>this.k.scanExtension(await this.L(z,!1,0,!0,V,!0,void 0))));return this.t.trace("Scanned dev system extensions:",Y.length),(0,N.$jf)(Y)}async J(){try{const V=await this.s.readFile(this.l);return JSON.parse(V.value.toString())}catch{return{}}}async L(V,H,F,U,W,X,Y){const z=await this.f(W??p.$v),C=await this.M(V),R=H&&!this.w.extUri.isEqual(V,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,r=R?await this.M(R):void 0;return new ie(V,C,R,r,H,Y,F,U,X,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,W,z)}async M(V){try{const H=await this.s.stat(V);if(typeof H.mtime=="number")return H.mtime}catch{}}};e.$ap=J=pe([te(4,w.$nk),te(5,I.$8o),te(6,o.$Oj),te(7,i.$Ni),te(8,b.$sh),te(9,s.$6i),te(10,$.$lk),te(11,n.$kh)],J);class ie{constructor(V,H,F,U,W,X,Y,z,C,R,r,k,T,B,Z){this.location=V,this.mtime=H,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=U,this.profile=W,this.profileScanOptions=X,this.type=Y,this.excludeObsolete=z,this.validate=C,this.productVersion=R,this.productDate=r,this.productCommit=k,this.devMode=T,this.language=B,this.translations=Z}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,H){return(0,m.$Yf)(V.location,H.location)&&V.mtime===H.mtime&&(0,m.$Yf)(V.applicationExtensionslocation,H.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===H.applicationExtensionslocationMtime&&V.profile===H.profile&&O.$Hm(V.profileScanOptions,H.profileScanOptions)&&V.type===H.type&&V.excludeObsolete===H.excludeObsolete&&V.validate===H.validate&&V.productVersion===H.productVersion&&V.productDate===H.productDate&&V.productCommit===H.productCommit&&V.devMode===H.devMode&&V.language===H.language&&Q.equals(V.translations,H.translations)}}e.$bp=ie;let ue=class extends l.$kb{constructor(V,H,F,U,W){super(),this.f=V,this.g=H,this.h=F,this.i=U,this.j=W}async scanExtensions(V){const H=V.profile?await this.l(V):await this.k(V);let F={};if(V.excludeObsolete&&V.type===1)try{const U=(await this.i.readFile(this.f)).value.toString();F=JSON.parse(U)}catch{}return(0,d.$te)(F)?H:H.filter(U=>!F[g.$co.create(U).toString()])}async k(V){const H=await this.i.resolve(V.location);if(!H.children?.length)return[];const F=await Promise.all(H.children.map(async U=>{if(!U.isDirectory||V.type===1&&(0,m.$3f)(U.resource).indexOf(".")===0)return null;const W=new ie(U.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(W)}));return(0,N.$jf)(F).sort((U,W)=>U.location.path<W.location.path?-1:1)}async l(V){let H=await this.m(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){H=H.filter(U=>!U.metadata?.isApplicationScoped);const F=await this.m(V.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,V);H.push(...F)}return H}async m(V,H,F){const U=await this.g.scanProfileExtensions(V,F.profileScanOptions);if(!U.length)return[];const W=await Promise.all(U.map(async X=>{if(H(X)){const Y=new ie(X.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.profileScanOptions,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(Y,X.metadata)}return null}));return(0,N.$jf)(W)}async scanOneOrMultipleExtensions(V){try{if(await this.i.exists((0,m.$6f)(V.location,"package.json"))){const H=await this.scanExtension(V);return H?[H]:[]}else return await this.scanExtensions(V)}catch(H){return this.j.error(`Error scanning extensions at ${V.location.path}:`,(0,L.$8)(H)),[]}}async scanExtension(V,H){try{let F=await this.scanExtensionManifest(V.location);if(F){F.publisher||(F.publisher=y.$zl),H=H??F.__metadata,delete F.__metadata;const U=(0,g.$go)(F.publisher,F.name),W=H?.id?{id:U,uuid:H.id}:{id:U},X=H?.isSystem?0:V.type,Y=X===0||!!H?.isBuiltin;F=await this.n(V.location,F,ie.createNlsConfiguration(V));const z={type:X,identifier:W,manifest:F,location:V.location,isBuiltin:Y,targetPlatform:H?.targetPlatform??"undefined",metadata:H,isValid:!0,validations:[]};return V.validate?this.validate(z,V):z}}catch(F){V.type!==0&&this.j.error(F)}return null}validate(V,H){let F=!0;const U=(0,t.$ro)(H.productVersion,H.productDate,H.location,V.manifest,V.isBuiltin);for(const[W,X]of U)W===v.default.Error&&(F=!1,this.j.error(this.u(H.location,X)));return V.isValid=F,V.validations=U,V}async scanExtensionManifest(V){const H=(0,m.$6f)(V,"package.json");let F;try{F=(await this.i.readFile(H)).value.toString()}catch(W){return(0,o.$5j)(W)!==1&&this.j.error(this.u(V,(0,h.localize)(0,null,H.path,W.message))),null}let U;try{U=JSON.parse(F)}catch{const X=[];(0,E.$tm)(F,X);for(const Y of X)this.j.error(this.u(V,(0,h.localize)(1,null,H.path,Y.offset,Y.length,(0,u.$0o)(Y.error))));return null}return(0,E.$Cm)(U)!=="object"?(this.j.error(this.u(V,(0,h.localize)(2,null,H.path))),null):U}async n(V,H,F){const U=await this.r(V,H,F);if(U)try{const W=[],X=await this.s(U.default,W);if(W.length>0)return W.forEach(z=>{this.j.error(this.u(V,(0,h.localize)(3,null,U.default?.path,(0,u.$0o)(z.error))))}),H;if((0,E.$Cm)(U)!=="object")return this.j.error(this.u(V,(0,h.localize)(4,null,U.default?.path))),H;const Y=U.values||Object.create(null);return(0,M.$$o)(H,Y,X)}catch{}return H}async r(V,H,F){const U=(0,m.$6f)(V,"package.nls.json"),W=(C,R)=>{R.forEach(r=>{this.j.error(this.u(V,(0,h.localize)(5,null,C?.path,(0,u.$0o)(r.error))))})},X=C=>{this.j.error(this.u(V,(0,h.localize)(6,null,C?.path)))},Y=`${H.publisher}.${H.name}`,z=F.translations[Y];if(z)try{const C=f.URI.file(z),R=(await this.i.readFile(C)).value.toString(),r=[],k=(0,E.$tm)(R,r);return r.length>0?(W(C,r),{values:void 0,default:U}):(0,E.$Cm)(k)!=="object"?(X(C),{values:void 0,default:U}):{values:k.contents?k.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.i.exists(U))return;let R;try{R=await this.t(V,F)}catch{return}if(!R.localized)return{values:void 0,default:R.original};try{const r=(await this.i.readFile(R.localized)).value.toString(),k=[],T=(0,E.$tm)(r,k);return k.length>0?(W(R.localized,k),{values:void 0,default:R.original}):(0,E.$Cm)(T)!=="object"?(X(R.localized),{values:void 0,default:R.original}):{values:T,default:R.original}}catch{return{values:void 0,default:R.original}}}}async s(V,H){if(V)try{const F=(await this.i.readFile(V)).value.toString();return(0,E.$tm)(F,H)}catch{}}t(V,H){return new Promise((F,U)=>{const W=X=>{const Y=(0,m.$6f)(V,`package.nls.${X}.json`);this.i.exists(Y).then(z=>{z&&F({localized:Y,original:(0,m.$6f)(V,"package.nls.json")});const C=X.lastIndexOf("-");C===-1?F({localized:(0,m.$6f)(V,"package.nls.json"),original:null}):(X=X.substring(0,C),W(X))})};if(H.devMode||H.pseudo||!H.language)return F({localized:(0,m.$6f)(V,"package.nls.json"),original:null});W(H.language)})}u(V,H){return`[${V.path}]: ${H}`}};ue=pe([te(1,I.$8o),te(2,$.$lk),te(3,o.$Oj),te(4,i.$Ni)],ue);let x=class extends ue{constructor(V,H,F,U,W,X,Y){super(H,U,W,X,Y),this.z=V,this.C=F,this.w=this.B(new D.$pg(3e3)),this.y=this.B(new a.$5c),this.onDidChangeCache=this.y.event}async scanExtensions(V){const H=this.H(V),F=await this.D(H);if(this.v=V,F&&F.input&&ie.equals(F.input,this.v))return this.j.debug("Using cached extensions scan result",V.location.toString()),this.w.trigger(()=>this.G()),F.result.map(W=>(W.location=f.URI.revive(W.location),W));const U=await super.scanExtensions(V);return await this.F(H,{input:V,result:U}),U}async D(V){try{const H=await this.i.readFile(V),F=JSON.parse(H.value.toString());return{result:F.result,input:(0,c.$Ug)(F.input)}}catch(H){this.j.debug("Error while reading the extension cache file:",V.path,(0,L.$8)(H))}return null}async F(V,H){try{await this.i.writeFile(V,A.$Ib.fromString(JSON.stringify(H)))}catch(F){this.j.debug("Error while writing the extension cache file:",V.path,(0,L.$8)(F))}}async G(){if(!this.v)return;const V=this.H(this.v),H=await this.D(V);if(!H)return;const F=H.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!O.$Hm(U,F))try{this.j.info("Invalidating Cache",F,U),await this.i.del(V),this.y.fire()}catch(W){this.j.error(W)}}H(V){const H=this.I(V);return this.h.extUri.joinPath(H.cacheHome,V.type===0?y.$yl:y.$xl)}I(V){return V.type===0?this.C.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.z.extensionsResource)?this.z:this.C.profiles.find(H=>this.h.extUri.isEqual(V.location,H.extensionsResource))??this.z:this.C.defaultProfile}};x=pe([te(2,w.$nk),te(3,I.$8o),te(4,$.$lk),te(5,o.$Oj),te(6,i.$Ni)],x);function ce(oe,V){const H=(0,g.$eo)(oe.manifest.publisher,oe.manifest.name);return{id:H,identifier:new y.$Dl(H),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:V,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}e.$cp=ce;class le extends J{constructor(V,H,F,U,W,X,Y,z,C,R,r,k){super(V,H,(0,m.$6f)(F,".vscode-oss-dev","extensions","control.json"),U,W,X,Y,z,C,R,r,k),this.N=(async()=>{if(p.$y)try{const T=await this.s.readFile(f.URI.file(p.$y));return JSON.parse(T.value.toString())}catch{}return Object.create(null)})()}f(V){return this.N}}e.$dp=le}),define(ne[151],se([0,1,58,8,33,5,2,16,15,22,6,21]),function(G,e,N,D,O,A,L,E,u,l,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=void 0;let p=e.$fp=class extends L.$kb{constructor(j,v){super(),this.b=j,this.f=v,this.a=new D.$xg(5)}async postUninstall(j){const v=this.g(j,"uninstall");v&&(this.f.info(j.identifier.id,j.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,j),this.f.info("Finished running post uninstall script",j.identifier.id,j.manifest.version)}catch(d){this.f.error("Failed to run post uninstall script",j.identifier.id,j.manifest.version),this.f.error(d)}}));try{await l.Promises.rm(this.j(j))}catch(d){this.f.error("Error while removing extension storage path",j.identifier.id),this.f.error(d)}}g(j,v){const d=`vscode:${v}`;if(j.location.scheme===E.Schemas.file&&j.manifest&&j.manifest.scripts&&typeof j.manifest.scripts[d]=="string"){const f=j.manifest.scripts[d].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(j.identifier.id,j.manifest.version,`${d} should be a node script`),null):{script:(0,u.$$b)(j.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(j,v,d,f,h){return new Promise((b,g)=>{const y=this.i(j,v,d,h);let t;const o=n=>{t&&(clearTimeout(t),t=null),n?g(n):b(void 0)};y.on("error",n=>{o((0,O.$9h)(n)||"Unknown")}),y.on("exit",(n,i)=>{o(n?`post-${v} process exited with code ${n}`:void 0)}),f&&(t=setTimeout(()=>{t=null,y.kill(),g("timed out")},5e3))})}i(j,v,d,f){const h={silent:!0,execArgv:void 0},b=(0,N.fork)(j,[`--type=extension-post-${v}`,...d],h);b.stdout.setEncoding("utf8"),b.stderr.setEncoding("utf8");const g=A.Event.fromNodeEventEmitter(b.stdout,"data"),y=A.Event.fromNodeEventEmitter(b.stderr,"data");g(n=>this.f.info(f.identifier.id,f.manifest.version,`post-${v}`,n)),y(n=>this.f.error(f.identifier.id,f.manifest.version,`post-${v}`,n));const t=A.Event.any(A.Event.map(g,n=>({data:`%c${n}`,format:[""]})),A.Event.map(y,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(t,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(f.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),b}j(j){return(0,u.$$b)(this.b.defaultProfile.globalStorageHome.fsPath,j.identifier.id.toLowerCase())}};e.$fp=p=pe([te(0,S.$nk),te(1,P.$Ni)],p)}),define(ne[152],se([0,1,6,21,27,25,40,13,18,11]),function(G,e,N,D,O,A,L,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=void 0;let P=e.$vM=class extends L.$9o{constructor(p,m,j,v,d,f){super(l.URI.file(p.extensionsPath),m,j,v,d,f)}};e.$vM=P=pe([te(0,u.$th),te(1,E.$Oj),te(2,D.$nk),te(3,O.$lk),te(4,A.$Rk),te(5,N.$Ni)],P)}),define(ne[153],se([0,1,11,18,40,49,13,10,6,31,27,21]),function(G,e,N,D,O,A,L,E,u,l,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P3b=void 0;let p=e.$P3b=class extends A.$dp{constructor(j,v,d,f,h,b,g,y){super(N.URI.file(h.builtinExtensionsPath),N.URI.file(h.extensionsPath),h.userHome,j.defaultProfile,j,v,d,f,h,b,g,y)}};e.$P3b=p=pe([te(0,S.$nk),te(1,O.$8o),te(2,L.$Oj),te(3,u.$Ni),te(4,D.$th),te(5,l.$6i),te(6,P.$lk),te(7,E.$kh)],p)}),define(ne[154],se([0,1,8,5,2,121,3,84,10,21]),function(G,e,N,D,O,A,L,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Go=e.$Fo=e.$Eo=void 0,e.$Eo="__$__isNewStorageMarker",e.$Fo="__$__targetStorageMarker",e.$Go=(0,u.$lh)("storageService");var P;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var S;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var p;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function m(h){const b=h.get(e.$Fo);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.$Ho=m;class j extends O.$kb{constructor(b={flushInterval:j.a}){super(),this.j=b,this.b=this.B(new D.$8c),this.onDidChangeValue=this.b.event,this.c=this.B(new D.$8c),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$5c),this.onWillSaveState=this.f.event,this.h=this.B(new N.$Cg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new O.$lb),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,N.$Gg)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,O.$fb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(b,g){const{key:y,external:t}=g;if(y===e.$Fo){switch(b){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:b})}else this.b.fire({scope:b,key:y,target:this.F(b)[y],external:t})}r(b){this.f.fire({reason:b})}get(b,g,y){return this.L(g)?.get(b,y)}getBoolean(b,g,y){return this.L(g)?.getBoolean(b,y)}getNumber(b,g,y){return this.L(g)?.getNumber(b,y)}getObject(b,g,y){return this.L(g)?.getObject(b,y)}storeAll(b,g){this.t(()=>{for(const y of b)this.store(y.key,y.value,y.scope,y.target,g)})}store(b,g,y,t,o=!1){if((0,L.$pe)(g)){this.remove(b,y,o);return}this.t(()=>{this.u(b,y,t),this.L(y)?.set(b,g,o)})}remove(b,g,y=!1){this.t(()=>{this.u(b,g,void 0),this.L(g)?.delete(b,y)})}t(b){this.b.pause(),this.c.pause();try{b()}finally{this.b.resume(),this.c.resume()}}keys(b,g){const y=[],t=this.F(b);for(const o of Object.keys(t))t[o]===g&&y.push(o);return y}u(b,g,y,t=!1){const o=this.F(g);typeof y=="number"?o[b]!==y&&(o[b]=y,this.L(g)?.set(e.$Fo,JSON.stringify(o),t)):typeof o[b]=="number"&&(delete o[b],this.L(g)?.set(e.$Fo,JSON.stringify(o),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(b){switch(b){case-1:return this.D;case 0:return this.z;default:return this.w}}G(b){const g=this.L(b);return g?m(g):Object.create(null)}isNew(b){return this.getBoolean(e.$Eo,b)===!0}async flush(b=P.NONE){this.f.fire({reason:b});const g=this.L(-1),y=this.L(0),t=this.L(1);switch(b){case P.NONE:await N.Promises.settled([g?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await N.Promises.settled([g?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.L(-1)?.items??new Map,g=this.L(0)?.items??new Map,y=this.L(1)?.items??new Map;return f(b,g,y,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(b,g){return this.r(P.NONE),(0,l.$mk)(b)?this.N(b,g):this.O(b,g)}H(b,g){return!(b.id===g.id||v(g)&&v(b))}I(b,g,y){this.t(()=>{const t=new Set;for(const[o,n]of b)t.add(o),g.get(o)!==n&&this.n(y,{key:o,external:!0});for(const[o]of g.items)t.has(o)||this.n(y,{key:o,external:!0})})}}e.$Io=j,j.a=60*1e3;function v(h){return h.isDefault||!!h.useDefaultFlags?.uiState}e.$Jo=v;class d extends j{constructor(){super(),this.p=this.B(new E.$Co(new E.$Do,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new E.$Co(new E.$Do,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new E.$Co(new E.$Do,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(b=>this.n(1,b))),this.B(this.P.onDidChangeStorage(b=>this.n(0,b))),this.B(this.p.onDidChangeStorage(b=>this.n(-1,b)))}L(b){switch(b){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(b){return!1}}e.$Ko=d;async function f(h,b,g,y,t,o){const n=Q=>{try{return JSON.parse(Q)}catch{return Q}},i=new Map,s=new Map;h.forEach((Q,J)=>{i.set(J,Q),s.set(J,n(Q))});const a=new Map,c=new Map;b.forEach((Q,J)=>{a.set(J,Q),c.set(J,n(Q))});const I=new Map,w=new Map;g.forEach((Q,J)=>{I.set(J,Q),w.set(J,n(Q))}),console.group(y!==t?`Storage: Application (path: ${y})`:`Storage: Application & Profile (path: ${y}, default profile)`);const $=[];if(i.forEach((Q,J)=>{$.push({key:J,value:Q})}),console.table($),console.groupEnd(),console.log(s),y!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Q=[];a.forEach((J,ie)=>{Q.push({key:ie,value:J})}),console.table(Q),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${o})`);const M=[];I.forEach((Q,J)=>{M.push({key:J,value:Q})}),console.table(M),console.groupEnd(),console.log(w)}e.$Lo=f}),define(ne[155],se([0,1,19,23,9,12,34,3,11,24,18,20,26,47,13,6,31,43,140,154,25]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m,j,v,d,f,h,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=void 0;const y=A.$o?"web":(0,S.$Gn)(A.$t,L.$6b),t="X-Market-Search-Activity-Id";var o;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function n(...R){return String(R.reduce((r,k)=>r|k,0))}var i;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class w{constructor(r=I){this.d=r}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(r,k=this.d.pageSize){return new w({...this.d,pageNumber:r,pageSize:k})}withFilter(r,...k){const T=[...this.d.criteria,...k.length?k.map(B=>({filterType:r,value:B})):[{filterType:r}]];return new w({...this.d,criteria:T})}withSortBy(r){return new w({...this.d,sortBy:r})}withSortOrder(r){return new w({...this.d,sortOrder:r})}withFlags(...r){return new w({...this.d,flags:r.reduce((k,T)=>k|T,0)})}withAssetTypes(...r){return new w({...this.d,assetTypes:r})}withSource(r){return new w({...this.d,source:r})}get raw(){const{criteria:r,pageNumber:k,pageSize:T,sortBy:B,sortOrder:Z,flags:_,assetTypes:re}=this.d;return{filters:[{criteria:r,pageNumber:k,pageSize:T,sortBy:B,sortOrder:Z}],assetTypes:re,flags:_}}get searchText(){const r=this.d.criteria.filter(k=>k.filterType===i.SearchText)[0];return r&&r.value?r.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(r=>String(r.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function $(R,r){const k=(R||[]).filter(T=>T.statisticName===r)[0];return k?k.value:0}function M(R){const r="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(T=>T.assetType.indexOf(r)===0).reduce((T,B)=>{const Z=ie(R,B.assetType);return Z&&T.push([B.assetType.substring(r.length),Z]),T},[])}function Q(R){if(R.properties){const r=R.properties.filter(B=>B.key===s.Repository),k=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),T=r.filter(B=>k.test(B.value))[0];return T?{uri:T.value,fallbackUri:T.value}:null}return ie(R,s.Repository)}function J(R){return{uri:`${R.fallbackAssetUri}/${s.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${s.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function ie(R,r){return R.files.filter(T=>T.assetType===r)[0]?{uri:`${R.assetUri}/${r}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${r}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function ue(R,r){const k=R.properties?R.properties.filter(B=>B.key===r):[],T=k.length>0&&k[0].value;return T?T.split(",").map(B=>(0,p.$fo)(B)):[]}function x(R){const r=R.properties?R.properties.filter(k=>k.key===a.Engine):[];return r.length>0&&r[0].value||""}function ce(R){const r=R.properties?R.properties.filter(k=>k.key===a.PreRelease):[];return r.length>0&&r[0].value==="true"}function le(R){const r=R.properties?R.properties.filter(T=>T.key===a.LocalizedLanguages):[],k=r.length>0&&r[0].value||"";return k?k.split(","):[]}function oe(R){return R.properties?.find(r=>r.key===a.SponsorLink)?.value}function V(R){return R.indexOf("preview")!==-1}function H(R){return R.targetPlatform?(0,S.$Fn)(R.targetPlatform):"undefined"}function F(R){const r=(0,N.$of)(R.versions.map(H)),k=!!R.tags?.includes(S.$Bn),T=r.indexOf("web");return k?T===-1&&r.push("web"):T!==-1&&r.splice(T,1),r}function U(R,r){const k=(0,S.$Jn)(r);for(let T=0;T<R.length;T++){const B=R[T];if(B.version===R[T-1]?.version){let Z=T;const _=H(B);if(_===r)for(;Z>0&&R[Z-1].version===B.version;)Z--;else if(k.includes(_))for(;Z>0&&R[Z-1].version===B.version&&H(R[Z-1])!==r;)Z--;Z!==T&&(R.splice(T,1),R.splice(Z,0,B))}}return R}e.$Oo=U;function W(R,r,k){R.telemetryData={index:r,querySource:k,queryActivityId:R.queryContext?.[t]}}function X(R,r,k,T){const B=R.versions[0],Z={manifest:ie(r,s.Manifest),readme:ie(r,s.Details),changelog:ie(r,s.Changelog),license:ie(r,s.License),repository:Q(r),download:J(r),icon:ie(r,s.Icon),signature:ie(r,s.Signature),coreTranslations:M(r)};return{identifier:{id:(0,p.$go)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:r.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:oe(B),description:R.shortDescription||"",installCount:$(R.statistics,"install"),rating:$(R.statistics,"averagerating"),ratingCount:$(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:k,assets:Z,properties:{dependencies:ue(r,a.Dependency),extensionPack:ue(r,a.ExtensionPack),engine:x(r),localizedLanguages:le(r),targetPlatform:H(r),isPreReleaseVersion:ce(r)},hasPreReleaseVersion:ce(B),hasReleaseVersion:!0,preview:V(R.flags),isSigned:!!Z.signature,queryContext:T}}let Y=class{constructor(r,k,T,B,Z,_,re,de){this.k=k,this.l=T,this.n=B,this.o=Z,this.q=_,this.u=re,this.w=de;const $e=re.extensionsGallery,he=$e?.servicePPEUrl&&de.getValue("_extensionsGallery.enablePPE");this.d=he?$e.servicePPEUrl:$e?.serviceUrl,this.g=he?void 0:$e?.searchUrl,this.h=$e?.controlUrl,this.j=(0,h.$No)(re.version,re,this.n,this.w,this.q,r,this.o)}x(r=""){return`${this.d}${r}`}isEnabled(){return!!this.d}async getExtensions(r,k,T){const B=D.CancellationToken.isCancellationToken(k)?{}:k,Z=D.CancellationToken.isCancellationToken(k)?k:T,_=[],re=[],de=[],$e=[];let he=!0;for(const fe of r){fe.uuid?re.push(fe.uuid):_.push(fe.id);const be=!!(fe.version||fe.preRelease);de.push({id:fe.id,uuid:fe.uuid,includePreRelease:be}),fe.version&&$e.push({id:fe.id,uuid:fe.uuid,version:fe.version}),he=he&&!!fe.hasPreRelease&&!be}if(!re.length&&!_.length)return[];let me=new w().withPage(1,r.length);re.length&&(me=me.withFilter(i.ExtensionId,...re)),_.length&&(me=me.withFilter(i.ExtensionName,..._)),(B.queryAllVersions||he)&&(me=me.withFlags(me.flags,o.IncludeVersions)),B.source&&(me=me.withSource(B.source));const{extensions:ae}=await this.z(me,{targetPlatform:B.targetPlatform??y,includePreRelease:de,versions:$e,compatible:!!B.compatible},Z);return B.source&&ae.forEach((fe,be)=>W(fe,be,B.source)),ae}async getCompatibleExtension(r,k,T){if((0,S.$Hn)(r.allTargetPlatforms,T))return null;if(await this.isExtensionCompatible(r,k,T))return r;const B=new w().withFlags(o.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,r.identifier.uuid),{extensions:Z}=await this.z(B,{targetPlatform:T,compatible:!0,includePreRelease:k},D.CancellationToken.None);return Z[0]||null}async isExtensionCompatible(r,k,T){if(!(0,S.$In)(r.properties.targetPlatform,r.allTargetPlatforms,T)||!k&&r.properties.isPreReleaseVersion)return!1;let B=r.properties.engine;if(!B){const Z=await this.getManifest(r,D.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");B=Z.engines.vscode}return(0,m.$to)(B,this.u.version,this.u.date)}async y(r,k,T,B,Z){if(!(0,S.$In)(H(r),B,Z)||k!=="any"&&ce(r)!==(k==="prerelease"))return!1;if(T)try{const _=await this.E(r);if(!(0,m.$to)(_,this.u.version,this.u.date))return!1}catch(_){return this.l.error(`Error while getting the engine for the version ${r.version}.`,(0,O.$8)(_)),!1}return!0}async query(r,k){let T=r.text||"";const B=r.pageSize??50;let Z=new w().withPage(1,B);T?(T=T.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,me,ae)=>(Z=Z.withFilter(i.Category,ae||me),"")),T=T.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,me,ae)=>(Z=Z.withFilter(i.Tag,ae||me),"")),T=T.replace(/\bfeatured(\s+|\b|$)/g,()=>(Z=Z.withFilter(i.Featured),"")),T=T.trim(),T&&(T=T.length<200?T:T.substring(0,200),Z=Z.withFilter(i.SearchText,T)),Z=Z.withSortBy(0)):r.ids?Z=Z.withFilter(i.ExtensionId,...r.ids):r.names?Z=Z.withFilter(i.ExtensionName,...r.names):Z=Z.withSortBy(4),typeof r.sortBy=="number"&&(Z=Z.withSortBy(r.sortBy)),typeof r.sortOrder=="number"&&(Z=Z.withSortOrder(r.sortOrder)),r.source&&(Z=Z.withSource(r.source));const _=async(he,me)=>{const{extensions:ae,total:fe}=await this.z(he,{targetPlatform:y,compatible:!1,includePreRelease:!!r.includePreRelease},me);return ae.forEach((be,Se)=>W(be,(he.pageNumber-1)*he.pageSize+Se,r.source)),{extensions:ae,total:fe}},{extensions:re,total:de}=await _(Z,k),$e=async(he,me)=>{if(me.isCancellationRequested)throw new O.$2;const{extensions:ae}=await _(Z.withPage(he+1),me);return ae};return{firstPage:re,total:de,pageSize:Z.pageSize,getPage:$e}}async z(r,k,T){const B=r.flags;r.flags&o.IncludeLatestVersionOnly&&r.flags&o.IncludeVersions&&(r=r.withFlags(r.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(r.flags&o.IncludeLatestVersionOnly)&&!(r.flags&o.IncludeVersions)&&(r=r.withFlags(r.flags,o.IncludeLatestVersionOnly)),k.versions?.length&&(r=r.withFlags(r.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),r=r.withFlags(r.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:Z,total:_,context:re}=await this.B(r,T);if(!(r.flags&o.IncludeLatestVersionOnly)){const me=[];for(const ae of Z){const fe=await this.A(ae,k,re);fe&&me.push(fe)}return{extensions:me,total:_}}const $e=[],he=new Map;for(let me=0;me<Z.length;me++){const ae=Z[me],fe={id:(0,p.$go)(ae.publisher.publisherName,ae.extensionName),uuid:ae.extensionId},be=(0,E.$me)(k.includePreRelease)?k.includePreRelease:!!k.includePreRelease.find(Le=>(0,p.$bo)(Le,fe))?.includePreRelease;if(k.compatible&&(0,S.$Hn)(F(ae),k.targetPlatform))continue;const Se=await this.A(ae,k,re);!Se||Se.properties.isPreReleaseVersion&&(!be||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==k.targetPlatform&&Se.hasPreReleaseVersion?he.set(ae.extensionId,me):$e.push([me,Se])}if(he.size){const me=new Date().getTime(),ae=new w().withFlags(B&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,he.size).withFilter(i.ExtensionId,...he.keys()),{extensions:fe}=await this.z(ae,k,T);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-me,count:he.size});for(const be of fe){const Se=he.get(be.identifier.uuid);$e.push([Se,be])}}return{extensions:$e.sort((me,ae)=>me[0]-ae[0]).map(([,me])=>me),total:_}}async A(r,k,T){const B={id:(0,p.$go)(r.publisher.publisherName,r.extensionName),uuid:r.extensionId},Z=k.versions?.find($e=>(0,p.$bo)($e,B))?.version,_=(0,E.$me)(k.includePreRelease)?k.includePreRelease:!!k.includePreRelease.find($e=>(0,p.$bo)($e,B))?.includePreRelease,re=F(r),de=U(r.versions,k.targetPlatform);if(k.compatible&&(0,S.$Hn)(re,k.targetPlatform))return null;for(let $e=0;$e<de.length;$e++){const he=de[$e];if(!(Z&&he.version!==Z)){if(await this.y(he,_?"any":"release",k.compatible,re,k.targetPlatform))return X(r,he,re,T);if(Z&&he.version===Z)return null}}return Z||k.compatible?null:X(r,r.versions[0],re)}async B(r,k){if(!this.isEnabled())throw new Error("No extension gallery service configured.");r=r.withFlags(r.flags,o.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(o.Unpublished));const T=await this.j,B=JSON.stringify(r.raw),Z={...T,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},_=new Date().getTime();let re,de,$e=0;try{if(re=await this.k.request({type:"POST",url:this.g&&r.criteria.some(me=>me.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:B,headers:Z},k),re.res.statusCode&&re.res.statusCode>=400&&re.res.statusCode<500)return{galleryExtensions:[],total:$e};const he=await(0,f.$zo)(re);if(he){const me=he.results[0],ae=me.extensions,fe=me.resultMetadata&&me.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return $e=fe&&fe.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:ae,total:$e,context:{[t]:re.res.headers.activityid}}}return{galleryExtensions:[],total:$e}}catch(he){throw de=he,he}finally{this.o.publicLog2("galleryService:query",{...r.telemetryData,requestBodySize:String(B.length),duration:new Date().getTime()-_,success:!!re&&(0,f.$wo)(re),responseBodySize:re?.res.headers["Content-Length"],statusCode:re?String(re.res.statusCode):void 0,errorCode:de?(0,O.$1)(de)?"canceled":(0,O.$8)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String($e)})}}async reportStatistic(r,k,T,B){if(!this.isEnabled())return;const Z=A.$o?this.x(`/itemName/${r}.${k}/version/${T}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${r}/extensions/${k}/${T}/stats?statType=${B}`),_=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",de={...await this.j,Accept:_};try{await this.k.request({type:"POST",url:Z,headers:de},D.CancellationToken.None)}catch{}}async download(r,k,T){this.l.trace("ExtensionGalleryService#download",r.identifier.id);const B=(0,p.$jo)(r),Z=new Date().getTime(),_=me=>this.o.publicLog("galleryService:downloadVSIX",{...B,duration:me}),re=T===2?"install":T===3?"update":"",de=re?{uri:`${r.assets.download.uri}${u.URI.parse(r.assets.download.uri).query?"&":"?"}${re}=true`,fallbackUri:`${r.assets.download.fallbackUri}${u.URI.parse(r.assets.download.fallbackUri).query?"&":"?"}${re}=true`}:r.assets.download,$e=r.queryContext?.[t]?{[t]:r.queryContext[t]}:void 0,he=await this.D(de,$e?{headers:$e}:void 0);await this.q.writeFile(k,he.stream),_(new Date().getTime()-Z)}async downloadSignatureArchive(r,k){if(!r.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",r.identifier.id);const T=await this.D(r.assets.signature);await this.q.writeFile(k,T.stream)}async getReadme(r,k){if(r.assets.readme){const T=await this.D(r.assets.readme,{},k);return await(0,f.$yo)(T)||""}return""}async getManifest(r,k){if(r.assets.manifest){const T=await this.D(r.assets.manifest,{},k),B=await(0,f.$yo)(T);return B?JSON.parse(B):null}return null}async C(r,k){const T=ie(r,s.Manifest);if(!T)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},Z=await this.D(T,{headers:B});return await(0,f.$zo)(Z)}async getCoreTranslation(r,k){const T=r.assets.coreTranslations.filter(B=>B[0]===k.toUpperCase())[0];if(T){const B=await this.D(T[1]),Z=await(0,f.$yo)(B);return Z?JSON.parse(Z):null}return null}async getChangelog(r,k){if(r.assets.changelog){const T=await this.D(r.assets.changelog,{},k);return await(0,f.$yo)(T)||""}return""}async getAllCompatibleVersions(r,k,T){let B=new w().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);r.identifier.uuid?B=B.withFilter(i.ExtensionId,r.identifier.uuid):B=B.withFilter(i.ExtensionName,r.identifier.id);const{galleryExtensions:Z}=await this.B(B,D.CancellationToken.None);if(!Z.length)return[];const _=F(Z[0]);if((0,S.$Hn)(_,T))return[];const re=[];await Promise.all(Z[0].versions.map(async he=>{try{await this.y(he,k?"any":"release",!0,_,T)&&re.push(he)}catch{}}));const de=[],$e=new Set;for(const he of U(re,T))$e.has(he.version)||($e.add(he.version),de.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:ce(he)}));return de}async D(r,k={},T=D.CancellationToken.None){const B=await this.j,Z={type:"GET"},_={...B,...k.headers||{}};k={...k,...Z,headers:_};const re=r.uri,de=r.fallbackUri,$e={...k,url:re};try{const he=await this.k.request($e,T);if(he.res.statusCode===200)return he;const me=await(0,f.$yo)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${me}`)}catch(he){if((0,O.$1)(he))throw he;const me=(0,O.$8)(he);this.o.publicLog2("galleryService:cdnFallback",{url:re,message:me});const ae={...k,url:de};return this.k.request(ae,T)}}async E(r){let k=x(r);if(!k){const T=await this.C(r,D.CancellationToken.None);if(!T)throw new Error("Manifest was not found");k=T.engines.vscode}return k}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const r=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(r.res.statusCode!==200)throw new Error("Could not get extensions report.");const k=await(0,f.$zo)(r),T=[],B={},Z=[];if(k){for(const _ of k.malicious)T.push({id:_});if(k.migrateToPreRelease)for(const[_,re]of Object.entries(k.migrateToPreRelease))(!re.engine||(0,m.$to)(re.engine,this.u.version,this.u.date))&&(B[_.toLowerCase()]={disallowInstall:!0,extension:{id:re.id,displayName:re.displayName,autoMigrate:{storage:!!re.migrateStorage},preRelease:!0}});if(k.deprecated)for(const[_,re]of Object.entries(k.deprecated))re&&(B[_.toLowerCase()]=(0,E.$me)(re)?{}:re);if(k.search)for(const _ of k.search)Z.push(_)}return{malicious:T,deprecated:B,search:Z}}};Y=pe([te(1,f.$uo),te(2,v.$Ni),te(3,P.$sh),te(4,g.$Rk),te(5,j.$Oj),te(6,d.$6i),te(7,l.$Rh)],Y);let z=e.$Po=class extends Y{constructor(r,k,T,B,Z,_,re,de){super(r,k,T,B,Z,_,re,de)}};e.$Po=z=pe([te(0,b.$Go),te(1,f.$uo),te(2,v.$Ni),te(3,P.$sh),te(4,g.$Rk),te(5,j.$Oj),te(6,d.$6i),te(7,l.$Rh)],z);let C=e.$Qo=class extends Y{constructor(r,k,T,B,Z,_,re){super(void 0,r,k,T,B,Z,_,re)}};e.$Qo=C=pe([te(0,f.$uo),te(1,v.$Ni),te(2,P.$sh),te(3,g.$Rk),te(4,j.$Oj),te(5,d.$6i),te(6,l.$Rh)],C)}),define(ne[156],se([0,1,11,18,13,6,137,27,21,3,68]),function(G,e,N,D,O,A,L,E,u,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.$sM=void 0;let S=e.$sM=class qe extends u.$qk{constructor(v,d,f,h,b){super(f,h,d,b),this.P=v,this.Q=f}J(){return this.P.getItem(qe.b,[]).map(d=>({...d,location:(0,l.$ge)(d.location)?this.s.extUri.joinPath(this.profilesHome,d.location):N.URI.revive(d.location)}))}M(){const v=this.P.getItem(qe.c,{});return this.P.getItem(qe.a,!1)?v:this.I(v)}O(){return this.s.extUri.joinPath(N.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};S.a="profileAssociationsMigration",e.$sM=S=pe([te(0,L.$nM),te(1,E.$lk),te(2,D.$th),te(3,O.$Oj),te(4,A.$Ni)],S);let p=e.$tM=class Ce extends S{constructor(v,d,f,h,b){super(v,d,f,h,b),this.W=v}L(v){v.length?this.W.setItem(Ce.b,v.map(d=>({...d,location:this.s.extUri.basename(d.location)}))):this.W.removeItem(Ce.b)}J(){const v=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(v),this.W.setItem("userDataProfilesMigration",!0)),v}N(v){v.emptyWindows||v.workspaces?this.W.setItem(Ce.c,v):this.W.removeItem(Ce.c)}M(){const v="workspaceAndProfileInfo",d=this.W.getItem(v,void 0);if(d){this.W.removeItem(v);const h=d.reduce((b,{workspace:g,profile:y})=>(b[N.URI.revive(g).toString()]=N.URI.revive(y).toString(),b),{});this.W.setItem(Ce.c,{workspaces:h})}const f=super.M();return this.W.getItem(Ce.a,!1)||(this.N(f),this.W.setItem(Ce.a,!0)),f}};e.$tM=p=pe([te(0,L.$oM),te(1,E.$lk),te(2,D.$th),te(3,O.$Oj),te(4,A.$Ni)],p);let m=e.$uM=class extends p{constructor(v,d,f,h){super(new P.$rM(0,d,h,f),v,d,f,h)}async init(){return await this.W.init(),super.init()}};e.$uM=m=pe([te(0,E.$lk),te(1,D.$th),te(2,O.$Oj),te(3,A.$Ni)],m)}),define(ne[50],se([0,1,123,8,15,3,22,85,172,173]),function(G,e,N,D,O,A,L,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.zip=e.$Yo=e.$Xo=void 0,e.$Xo="end of central directory record signature not found";const P=new RegExp(e.$Xo);class S extends Error{constructor(o,n){let i=n.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=n}}e.$Yo=S;function p(t){const o=t.externalFileAttributes>>16||33188;return[448,56,7].map(n=>o&n).reduce((n,i)=>n+i,o&61440)}function m(t){if(t instanceof S)return t;let o;return P.test(t.message)&&(o="CorruptZip"),new S(o,t)}function j(t,o,n,i,s,a){const c=O.$bc(o),I=O.$$b(i,c);if(!I.startsWith(i))return Promise.reject(new Error(E.localize(0,null,o)));const w=O.$$b(i,o);let $;return a.onCancellationRequested(()=>{$?.destroy()}),Promise.resolve(L.Promises.mkdir(I,{recursive:!0})).then(()=>new Promise((M,Q)=>{if(!a.isCancellationRequested)try{$=(0,N.createWriteStream)(w,{mode:n}),$.once("close",()=>M()),$.once("error",Q),t.once("error",Q),t.pipe($)}catch(J){Q(J)}}))}function v(t,o,n,i){let s=(0,D.$fg)(()=>Promise.resolve()),a=0;return i.onCancellationRequested(()=>{s.cancel(),t.close()}),new Promise((c,I)=>{const w=new D.$mg,$=M=>{M.isCancellationRequested||(a++,t.readEntry())};t.once("error",I),t.once("close",()=>s.then(()=>{i.isCancellationRequested||t.entryCount===a?c():I(new S("Incomplete",new Error(E.localize(1,null,a,t.entryCount))))},I)),t.readEntry(),t.on("entry",M=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(M.fileName)){$(i);return}const Q=M.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(Q)){const ue=O.$$b(o,Q);s=(0,D.$fg)(x=>L.Promises.mkdir(ue,{recursive:!0}).then(()=>$(x)).then(void 0,I));return}const J=f(t,M),ie=p(M);s=(0,D.$fg)(ue=>w.queue(()=>J.then(x=>j(x,Q,ie,o,n,ue).then(()=>$(ue)))).then(null,I))})})}function d(t,o=!1){return new Promise((n,i)=>{(0,u.open)(t,o?{lazyEntries:!0}:void 0,(s,a)=>{s?i(m(s)):n((0,A.$re)(a))})})}function f(t,o){return new Promise((n,i)=>{t.openReadStream(o,(s,a)=>{s?i(m(s)):n((0,A.$re)(a))})})}function h(t,o){return new Promise((n,i)=>{const s=new l.ZipFile;o.forEach(c=>{c.contents?s.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&s.addFile(c.localPath,c.path)}),s.end();const a=(0,N.createWriteStream)(t);s.outputStream.pipe(a),s.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>n(t))})}e.zip=h;function b(t,o,n={},i){const s=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let a=d(t,!0);return n.overwrite&&(a=a.then(c=>L.Promises.rm(o).then(()=>c))),a.then(c=>v(c,o,{sourcePathRegex:s},i))}e.$1o=b;function g(t,o){return d(t).then(n=>new Promise((i,s)=>{n.on("entry",a=>{a.fileName===o&&f(n,a).then(c=>i(c),c=>s(c))}),n.once("close",()=>s(new Error(E.localize(2,null,o))))}))}function y(t,o){return g(t,o).then(n=>new Promise((i,s)=>{const a=[];n.once("error",s),n.on("data",c=>a.push(c)),n.on("end",()=>i(Buffer.concat(a)))}))}e.$2o=y}),define(ne[157],se([0,1,8,9,2,16,12,17,41,3,29,22,50,24,18,20,26,60,13,6]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m,j,v,d,f,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;let g=e.$ep=class Ve extends O.$kb{constructor(t,o,n,i,s,a){super(),this.h=o,this.i=n,this.j=i,this.k=s,this.l=a,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,o,n){await this.g;const i=(0,E.$6f)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,i,a=>this.i.download(t,a,o))}catch(a){throw new v.$Mn(a.message,v.ExtensionManagementErrorCode.Download)}let s=!1;if(n&&this.m(t)){const a=await this.n(t);try{s=await this.k.verify(i.fsPath,a.fsPath,this.l.getLevel()===b.LogLevel.Trace)}catch(c){const I=c;if(s=I.code,I.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${I.output}`),s===v.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===v.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new v.$Mn(p.$Xo,v.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(a)}catch(c){this.l.error(c)}}}return s===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):s===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${s}': ${t.identifier.id}`),{location:i,verificationStatus:s}}m(t){if(!t.isSigned)return!1;const o=this.j.getValue("extensions.verifySignature");return(0,l.$me)(o)?o:!0}async n(t){await this.g;const o=(0,E.$6f)(this.extensionsDownloadDir,`${this.v(t)}${Ve.c}`);return await this.r(t,o,n=>this.i.downloadSignatureArchive(t,n)),o}async r(t,o,n){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await n(o);return}const i=(0,E.$6f)(this.extensionsDownloadDir,`.${(0,P.$3e)()}`);await this.h.exists(i)||await n(i);try{await this.t(i,o,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(i)}catch{}if(s.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.l.info(`Rename failed because of ${(0,D.$8)(s)}. Deleted the file from downloaded location`,i.path),s}}async delete(t){await this.g,await this.h.del(t)}async t(t,o,n){try{await S.Promises.rename(t.fsPath,o.fsPath)}catch(i){if(L.$i&&i&&i.code==="EPERM"&&Date.now()<n)return this.l.info(`Failed renaming ${t} to ${o} with 'EPERM' error. Trying again...`),this.t(t,o,n);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],n=[],i=[];for(const c of t.children)if(c.name.endsWith(Ve.c))i.push(c.resource);else{const I=d.$co.parse(c.name);I&&n.push([I,c])}const s=(0,d.$ho)(n,([c])=>c),a=[];for(const c of s)c.sort((I,w)=>u.rcompare(I[0].version,w[0].version)),o.push(...c.slice(1).map(I=>I[1].resource)),a.push(c[0][1]);a.sort((c,I)=>c.mtime-I.mtime),o.push(...a.slice(0,Math.max(0,a.length-this.f)).map(c=>c.resource)),o.push(...i),await N.Promises.settled(o.map(c=>(this.l.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(t){this.l.error(t)}}v(t){return this.f?d.$co.create(t).toString().toLowerCase():(0,P.$3e)()}};g.c=".sigzip",e.$ep=g=pe([te(0,j.$th),te(1,h.$Oj),te(2,v.$Ln),te(3,m.$Rh),te(4,f.$Ro),te(5,b.$Ni)],g)}),define(ne[158],se([0,1,50,95]),function(G,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=void 0;function O(A){return(0,N.$2o)(A,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$gp=O}),define(ne[159],se([0,1,8,14,23,33,9,5,2,35,16,15,12,17,41,3,11,29,22,50,94,59,18,150,20,26,40,49,157,151,158,132,139,47,13,10,6,31,25,27,21]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m,j,v,d,f,h,b,g,y,t,o,n,i,s,a,c,I,w,$,M,Q,J,ie,ue,x,ce,le,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$jp=(0,ie.$mh)(n.$Nn);let V=e.$kp=class extends o.$3o{constructor(z,C,R,r,k,T,B,Z,_,re,de,$e){super(z,C,R,re,$e),this.$=k,this.ab=T,this.bb=B,this.cb=_,this.db=de,this.Y=this.B(new E.$5c),this.onDidUpdateExtensionMetadata=this.Y.event,this.Z=new Map,this.lb=new l.$ki;const he=this.B(Z.createInstance(I.$fp));this.U=this.B(Z.createInstance(H,ae=>he.postUninstall(ae))),this.W=this.B(new $.$hp($e,_,de,this,this.v)),this.X=this.B(Z.createInstance(c.$ep));const me=this.B(new M.$ip(this,this.$,$e,T,de,_,R));this.B(me.onDidChangeExtensionsByAnotherSource(ae=>this.kb(ae))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.$mo)(this.cb,this.v)),this.eb}async zip(z){this.v.trace("ExtensionManagementService#zip",z.identifier.id);const C=await this.jb(z),R=await(0,b.zip)((0,m.$6f)(this.X.extensionsDownloadDir,(0,f.$3e)()).fsPath,C);return d.URI.file(R)}async unzip(z){return this.v.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const{location:C,cleanup:R}=await this.fb(z),r=S.$_b(C.fsPath);try{return await(0,w.$gp)(r)}finally{await R()}}getInstalled(z,C=this.y.defaultProfile.extensionsResource){return this.U.scanExtensions(z??null,C)}scanAllUserInstalledExtensions(){return this.U.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(z){return this.U.scanUserExtensionAtLocation(z)}async install(z,C={}){this.v.trace("ExtensionManagementService#install",z.toString());const{location:R,cleanup:r}=await this.fb(z);try{const k=await(0,w.$gp)(S.$_b(R.fsPath)),T=(0,i.$go)(k.publisher,k.name);if(k.engines&&k.engines.vscode&&!(0,Q.$to)(k.engines.vscode,this.w.version,this.w.date))throw new Error(g.localize(0,null,T,this.w.version));const B=await this.z([{manifest:k,extension:R,options:C}]);if(B[0]?.local)return B[0]?.local;throw B[0]?.error?B[0].error:(0,o.$5o)(new Error(`Unknown error while installing extension ${T}`))}finally{await r()}}async installFromLocation(z,C){this.v.trace("ExtensionManagementService#installFromLocation",z.toString());const R=await this.U.scanUserExtensionAtLocation(z);if(!R)throw new Error(`Cannot find a valid extension from the location ${z.toString()}`);return await this.ob([[R,void 0]],C),this.v.info("Successfully installed extension",R.identifier.id,C.toString()),R}async installExtensionsFromProfile(z,C,R){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",z,C.toString(),R.toString());const r=(await this.U.scanExtensions(1,C)).filter(k=>z.some(T=>(0,i.$bo)(T,k.identifier)));if(r.length){const k=await Promise.all(r.map(T=>this.U.scanMetadata(T,C)));await this.ob(r.map((T,B)=>[T,k[B]]),R),this.v.info("Successfully installed extensions",r.map(T=>T.identifier.id),R.toString())}return r}async updateMetadata(z,C,R=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",z.identifier.id),C.isPreReleaseVersion&&(C.preRelease=!0),C.isMachineScoped=C.isMachineScoped||void 0,C.isBuiltin=C.isBuiltin||void 0,C.pinned=C.pinned||void 0,z=await this.U.updateMetadata(z,C,R),this.W.invalidate(R),this.Y.fire(z),z}async reinstallFromGallery(z){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",z.identifier.id),!this.t.isEnabled())throw new Error(g.localize(1,null));const C=await this.getTargetPlatform(),[R]=await this.t.getExtensions([{...z.identifier,preRelease:z.preRelease}],{targetPlatform:C,compatible:!0},O.CancellationToken.None);if(!R)throw new Error(g.localize(2,null));await this.U.setUninstalled(z);try{await this.U.removeUninstalledExtension(z)}catch(r){throw new Error(g.localize(3,null,(0,A.$9h)(r)))}return this.installFromGallery(R)}copyExtensions(z,C){return this.U.copyExtensions(z,C)}markAsUninstalled(...z){return this.U.setUninstalled(...z)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.U.cleanUp()}catch(z){this.v.error(z)}}async download(z,C,R){const{location:r}=await this.X.download(z,C,!R);return r}async fb(z){if(z.scheme===P.Schemas.file)return{location:z,async cleanup(){}};this.v.trace("Downloading extension from",z.toString());const C=(0,m.$6f)(this.X.extensionsDownloadDir,(0,f.$3e)());return await this.bb.download(z,C),this.v.info("Downloaded extension to",C.toString()),{location:C,cleanup:async()=>{try{await this.cb.del(C)}catch(r){this.v.error(r)}}}}Q(){return this.y.defaultProfile.extensionsResource}R(z,C,R){if(d.URI.isUri(C))return new W(z,C,R,this.t,this.U,this.db,this.y,this.$,this.ab,this.v);const r=i.$co.create(C).toString();let k=this.Z.get(r);return k||(this.Z.set(r,k=new U(z,C,R,this.X,this.U,this.db,this.y,this.$,this.ab,this.v)),k.waitUntilTaskIsFinished().finally(()=>this.Z.delete(r))),k}S(z,C){return new X(z,C.profileLocation,this.ab)}async jb(z){const C=async r=>{let k=await h.Promises.readdir(r);k=k.map(Z=>S.$$b(r,Z));const T=await Promise.all(k.map(Z=>h.Promises.stat(Z)));let B=Promise.resolve([]);return T.forEach((Z,_)=>{const re=k[_];Z.isFile()&&(B=B.then(de=>[...de,re])),Z.isDirectory()&&(B=B.then(de=>C(re).then($e=>[...de,...$e])))}),B};return(await C(z.location.fsPath)).map(r=>({path:`extension/${S.$ac(z.location.fsPath,r)}`,localPath:r}))}async kb({added:z,removed:C}){if(C)for(const R of C.extensions)this.v.info("Extensions removed from another source",R.id,C.profileLocation.toString()),this.p.fire({identifier:R,profileLocation:C.profileLocation});if(z){const r=(await this.U.scanExtensions(1,z.profileLocation)).filter(k=>z.extensions.some(T=>(0,i.$bo)(T,k.identifier)));this.m.fire(r.map(k=>(this.v.info("Extensions added from another source",k.identifier.id,z.profileLocation.toString()),{identifier:k.identifier,local:k,profileLocation:z.profileLocation,operation:1})))}}async mb(){this.B(this.U.onExtract(C=>this.lb.add(C)));const z=await this.cb.resolve(this.$.userExtensionsLocation);for(const C of z.children??[])C.isDirectory&&this.lb.add(C.resource);this.B(this.cb.watch(this.$.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(C=>this.nb(C)))}async nb(z){if(!z.affects(this.$.userExtensionsLocation,1))return;const C=[];for(const R of z.rawAdded){if(this.lb.has(R)||!this.db.extUri.isEqual(this.db.extUri.dirname(R),this.$.userExtensionsLocation)||this.db.extUri.isEqual(R,this.db.extUri.joinPath(this.$.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(R).startsWith(".")||!(await this.cb.stat(R)).isDirectory)continue;const r=await this.U.scanUserExtensionAtLocation(R);r&&r.installedTimestamp===void 0&&(this.lb.add(R),C.push(r))}C.length&&(await this.ob(C.map(R=>[R,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",C.map(R=>R.identifier.id)))}async ob(z,C){const R=z.map(r=>r[0]);await this.pb(R),await this.ab.addExtensionsToProfile(z,C),this.m.fire(R.map(r=>({local:r,identifier:r.identifier,operation:1,profileLocation:C})))}async pb(z){const C=await this.U.getUninstalledExtensions();for(const R of z){const r=i.$co.create(R);C[r.toString()]&&(this.v.trace("Removing the extension from uninstalled list:",r.id),await this.U.setInstalled(r),this.v.info("Removed the extension from uninstalled list:",r.id))}}};e.$kp=V=pe([te(0,n.$Ln),te(1,ce.$Rk),te(2,ue.$Ni),te(3,t.$th),te(4,a.$_o),te(5,s.$8o),te(6,y.$qn),te(7,ie.$kh),te(8,J.$Oj),te(9,x.$6i),te(10,le.$lk),te(11,oe.$nk)],V);let H=e.$lp=class extends u.$kb{constructor(z,C,R,r,k,T){super(),this.k=z,this.l=C,this.m=R,this.n=r,this.p=k,this.s=T,this.h=this.B(new E.$5c),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,m.$6f)(this.m.userExtensionsLocation,".obsolete"),this.g=new N.$yg}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(z,C){const R={includeInvalid:!0,profileLocation:C};let r=[];return z===null||z===0?r.push(...await this.m.scanAllExtensions({includeInvalid:!0},R,!1)):z===1&&r.push(...await this.m.scanUserExtensions(R)),r=z!==null?r.filter(k=>k.type===z):r,Promise.all(r.map(k=>this.y(k)))}async scanAllUserExtensions(z){const C=await this.m.scanUserExtensions({includeAllVersions:!z,includeInvalid:!0});return Promise.all(C.map(R=>this.y(R)))}async scanUserExtensionAtLocation(z){try{const C=await this.m.scanExistingExtension(z,1,{includeInvalid:!0});if(C)return await this.y(C)}catch(C){this.s.error(C)}return null}async extractUserExtension(z,C,R,r,k){await this.j.catch(()=>{});const T=z.toString(),B=S.$$b(this.m.userExtensionsLocation.fsPath,`.${(0,f.$3e)()}`),Z=S.$$b(this.m.userExtensionsLocation.fsPath,T);let _=await this.l.exists(d.URI.file(Z));if(_&&r){try{await h.Promises.rm(Z)}catch{throw new n.$Mn(g.localize(4,null,Z,z.id),n.ExtensionManagementErrorCode.Delete)}_=!1}if(!_){await this.u(z,C,B,k),await this.m.updateMetadata(d.URI.file(B),R);try{this.h.fire(d.URI.file(Z)),await this.v(z,B,Z,Date.now()+2*60*1e3),this.s.info("Renamed to",Z)}catch(re){try{await h.Promises.rm(B)}catch{}if(re.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",z.id);else throw this.s.info(`Rename failed because of ${(0,L.$8)(re)}. Deleted from extracted location`,B),re}}return this.w(d.URI.file(Z),1)}async scanMetadata(z,C){return C?(await this.n.scanProfileExtensions(C)).find(r=>(0,i.$bo)(r.identifier,z.identifier))?.metadata:this.m.scanMetadata(z.location)}async updateMetadata(z,C,R){return R?await this.n.updateMetadata([[z,C]],R):await this.m.updateMetadata(z.location,C),this.w(z.location,z.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...z){const C=z.map(R=>i.$co.create(R));await this.t(R=>C.forEach(r=>{R[r.toString()]=!0,this.s.info("Marked extension as uninstalled",r.toString())}))}async setInstalled(z){await this.t(C=>delete C[z.toString()])}async removeExtension(z,C){this.s.trace(`Deleting ${C} extension from disk`,z.identifier.id,z.location.fsPath);const R=this.p.extUri.joinPath(this.p.extUri.dirname(z.location),`._${(0,f.$3e)()}`);await this.v(z.identifier,z.location.fsPath,R.fsPath,Date.now()+2*60*1e3),await this.l.del(R,{recursive:!0}),this.s.info("Deleted from disk",z.identifier.id,z.location.fsPath)}async removeUninstalledExtension(z){await this.removeExtension(z,"uninstalled"),await this.t(C=>delete C[i.$co.create(z).toString()])}async copyExtensions(z,C){const R=await this.scanExtensions(1,z),r=await Promise.all(R.filter(k=>!k.isApplicationScoped).map(async k=>[k,await this.scanMetadata(k,z)]));await this.n.addExtensionsToProfile(r,C)}async t(z){return this.g.queue(async()=>{let C;try{C=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(r){if((0,J.$5j)(r)!==1)throw r}let R={};if(C)try{R=JSON.parse(C)}catch{}return z&&(z(R),Object.keys(R).length?await this.l.writeFile(this.c,D.$Ib.fromString(JSON.stringify(R))):await this.l.del(this.c)),R})}async u(z,C,R,r){this.s.trace(`Started extracting the extension from ${C} to ${R}`);try{await h.Promises.rm(R)}catch(k){throw new n.$Mn(this.D(k).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,b.$1o)(C,R,{sourcePath:"extension",overwrite:!0},r),this.s.info(`Extracted extension to ${R}:`,z.id)}catch(k){try{await h.Promises.rm(R)}catch{}let T=n.ExtensionManagementErrorCode.Extract;throw k instanceof b.$Yo&&(k.type==="CorruptZip"?T=n.ExtensionManagementErrorCode.CorruptZip:k.type==="Incomplete"&&(T=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$Mn(k.message,T)}}async v(z,C,R,r){try{await h.Promises.rename(C,R)}catch(k){if(p.$i&&k&&k.code==="EPERM"&&Date.now()<r)return this.s.info(`Failed renaming ${C} to ${R} with 'EPERM' error. Trying again...`,z.id),this.v(z,C,R,r);throw new n.$Mn(k.message||g.localize(5,null,C,R),k.code||n.ExtensionManagementErrorCode.Rename)}}async w(z,C){const R=await this.m.scanExistingExtension(z,C,{includeInvalid:!0});if(R)return this.y(R);throw new Error(g.localize(6,null,z.path))}async y(z){const C=await this.l.resolve(z.location);let R,r;return C.children&&(R=C.children.find(({name:k})=>/^readme(\.txt|\.md|)$/i.test(k))?.resource,r=C.children.find(({name:k})=>/^changelog(\.txt|\.md|)$/i.test(k))?.resource),{identifier:z.identifier,type:z.type,isBuiltin:z.isBuiltin||!!z.metadata?.isBuiltin,location:z.location,manifest:z.manifest,targetPlatform:z.targetPlatform,validations:z.validations,isValid:z.isValid,readmeUrl:R,changelogUrl:r,publisherDisplayName:z.metadata?.publisherDisplayName||null,publisherId:z.metadata?.publisherId||null,isApplicationScoped:!!z.metadata?.isApplicationScoped,isMachineScoped:!!z.metadata?.isMachineScoped,isPreReleaseVersion:!!z.metadata?.isPreReleaseVersion,preRelease:!!z.metadata?.preRelease,installedTimestamp:z.metadata?.installedTimestamp,updated:!!z.metadata?.updated,pinned:!!z.metadata?.pinned}}async z(){const z=await this.getUninstalledExtensions();if(Object.keys(z).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys(z));const C=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=new Set;for(const k of C)z[i.$co.create(k).toString()]||R.add(k.identifier.id.toLowerCase());try{const k=(0,i.$ho)(C,T=>T.identifier);await N.Promises.settled(k.map(async T=>{const B=T.sort((Z,_)=>j.rcompare(Z.manifest.version,_.manifest.version))[0];R.has(B.identifier.id.toLowerCase())||await this.k(await this.y(B))}))}catch(k){this.s.error(k)}const r=C.filter(k=>k.metadata&&z[i.$co.create(k).toString()]);await Promise.allSettled(r.map(k=>this.removeUninstalledExtension(k)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const z=[];let C;try{C=await this.l.resolve(this.m.userExtensionsLocation)}catch(R){(0,J.$5j)(R)!==1&&this.s.error(R)}for(const R of C?.children??[])R.isDirectory&&R.name.startsWith("._")&&(0,f.$2e)(R.name.substring(2))&&z.push((async()=>{this.s.trace("Deleting the generated extension folder",R.resource.toString());try{await this.l.del(R.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",R.resource.toString())}catch(r){this.s.error(r)}})());await Promise.allSettled(z)}D(z){const C=Array.isArray(z)?z:[z];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((R,r)=>new Error(`${R.message}${R.message?",":""}${r instanceof Error?r.message:r}`),new Error(""))}};e.$lp=H=pe([te(1,J.$Oj),te(2,a.$_o),te(3,s.$8o),te(4,le.$lk),te(5,ue.$Ni)],H);class F extends o.$6o{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,v.$ne)(this.m.operation)?this.l:this.m.operation}constructor(z,C,R,r,k,T,B,Z,_){super(),this.identifier=z,this.source=C,this.m=R,this.n=r,this.o=k,this.p=T,this.q=B,this.s=Z,this.t=_,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(z){const[C,R]=await this.y(z);return this.j=C.isBuiltin||C.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[C,R]],this.j),C}async v({zipPath:z,key:C,metadata:R},r,k){let T=await this.w(C);return T||(this.t.trace("Extracting extension...",C.id),T=await this.n.extractUserExtension(C,z,R,r,k),this.t.info("Extracting extension completed.",C.id)),T}async w(z){return await this.x(z)?(this.t.trace("Removing the extension from uninstalled list:",z.id),await this.n.setInstalled(z),this.t.info("Removed the extension from uninstalled list:",z.id),(await this.n.scanAllUserExtensions(!0)).find(r=>i.$co.create(r).equals(z))):void 0}async x(z){return!!(await this.n.getUninstalledExtensions())[z.toString()]}}class U extends F{constructor(z,C,R,r,k,T,B,Z,_,re){super(C.identifier,C,R,k,T,B,Z,_,re),this.z=C,this.A=r}async y(z){const R=(await this.n.scanExtensions(null,this.m.profileLocation)).find(B=>(0,i.$bo)(B.identifier,this.z.identifier));R&&(this.l=3);const r={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||R?.isMachineScoped,isBuiltin:this.m.isBuiltin||R?.isBuiltin,isSystem:R?.type===0?!0:void 0,updated:!!R,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,v.$me)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:R?.preRelease)};if(R?.manifest.version===this.z.version)return[await this.n.updateMetadata(R,r),r];const{location:k,verificationStatus:T}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=T,this.C(k.fsPath),[await this.v({zipPath:k.fsPath,key:i.$co.create(this.z),metadata:r},!1,z),r]}catch(B){try{await this.A.delete(k)}catch(Z){this.t.warn("Error while deleting the downloaded file",k.toString(),(0,L.$8)(Z))}throw B}}async C(z){try{await(0,w.$gp)(z)}catch(C){throw new n.$Mn((0,o.$4o)(C).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$mp=U;class W extends F{constructor(z,C,R,r,k,T,B,Z,_,re){super({id:(0,i.$go)(z.publisher,z.name)},C,R,k,T,B,Z,_,re),this.z=z,this.A=C,this.B=r}async h(z){const C=await super.h(z);return this.E(C,z),C}async y(z){const C=new i.$co(this.identifier,this.z.version),r=(await this.n.scanExtensions(1,this.m.profileLocation)).find(B=>(0,i.$bo)(this.identifier,B.identifier)),k={isApplicationScoped:this.m.isApplicationScoped||r?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||r?.isMachineScoped,isBuiltin:this.m.isBuiltin||r?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(r)if(this.l=3,C.equals(new i.$co(r.identifier,r.manifest.version)))try{await this.n.removeExtension(r,"existing")}catch{throw new Error(g.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&j.gt(r.manifest.version,this.z.version)&&await this.n.setUninstalled(r);else{const B=await this.w(C);if(B)try{await this.n.removeExtension(B,"existing")}catch{throw new Error(g.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:S.$_b(this.A.fsPath),key:C,metadata:k},!0,z),k]}async E(z,C){try{let[R]=await this.B.getExtensions([{id:z.identifier.id,version:z.manifest.version}],C);if(R||([R]=await this.B.getExtensions([{id:z.identifier.id}],C)),R){const r={id:R.identifier.uuid,publisherDisplayName:R.publisherDisplayName,publisherId:R.publisherId,isPreReleaseVersion:R.properties.isPreReleaseVersion,preRelease:R.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(z,r,this.m.profileLocation)}}catch{}}}class X extends o.$6o{constructor(z,C,R){super(),this.extension=z,this.j=C,this.k=R}async h(z){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[160],se([0,1,135,8,14,9,3,24,18,136,6,43,134,174]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0;let j=e.$zq=class extends S.$vo{constructor(h,b,g,y){super(y),this.j=h,this.k=b,this.l=g,this.m(),this.B(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const h=this.j.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,b){const{f:g,g:y}=this;let t;try{t=await(0,l.$ul)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,A.$8)(i)))}const o={...process.env,...t},n=h.agent?h.agent:await(0,p.$yq)(h.url||"",o,{proxyUrl:g,strictSSL:y});return h.agent=n,h.strictSSL=y,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>d(h,b))}async resolveProxy(h){}};e.$zq=j=pe([te(0,E.$Rh),te(1,u.$th),te(2,P.$Ni),te(3,P.$Oi)],j);async function v(f){return((0,N.parse)(f.url).protocol==="https:"?await new Promise((g,y)=>{G(["https"],g,y)}):await new Promise((g,y)=>{G(["http"],g,y)})).request}async function d(f,h){return D.Promises.withAsyncBody(async(b,g)=>{const y=(0,N.parse)(f.url),t=f.getRawRequest?f.getRawRequest(f):await v(f),o={hostname:y.hostname,port:y.port?parseInt(y.port):y.protocol==="https:"?443:80,protocol:y.protocol,path:y.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,L.$me)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(o.auth=f.user+":"+f.password);const n=t(o,i=>{const s=(0,L.$ke)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)d({...f,url:i.headers.location,followRedirects:s-1},h).then(b,g);else{let a=i;!f.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,m.createGunzip)())),b({res:i,stream:(0,O.$Wb)(a)})}});n.on("error",g),f.timeout&&n.setTimeout(f.timeout),f.isChromiumNetwork&&n.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&n.write(f.data),n.end(),h.onCancellationRequested(()=>{n.abort(),g(new A.$2)})})}e.$Aq=d}),define(ne[175],se([0,1,32,8,33,9,2,16,15,12,34,11,22,24,131,59,133,18,109,155,20,60,138,40,49,159,153,13,120,122,48,118,63,64,141,6,127,38,128,144,31,43,160,68,69,25,143,39,145,146,27,148,21,156,147,152,124,126,4]),function(G,e,N,D,O,A,L,E,u,l,P,S,p,m,j,v,d,f,h,b,g,y,t,o,n,i,s,a,c,I,w,$,M,Q,J,ie,ue,x,ce,le,oe,V,H,F,U,W,X,Y,z,C,R,r,k,T,B,Z,_,re,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class $e extends L.$kb{constructor(ae){super(),this.b=ae,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[ae,fe]=await this.f();return ae.invokeFunction(async be=>{const Se=be.get(ie.$Ni),Le=be.get(a.$Oj),Ue=be.get(f.$th),q=be.get(k.$nk);Se.info("CLI main",this.b),this.g(Se),await this.h(Ue,Le,q,ae),await Promise.all(fe.map(K=>{(0,D.$jg)(K.flush(),1e3)}))})}async f(){const ae=new M.$jh,fe={_serviceBrand:void 0,...le.default};ae.set(oe.$6i,fe);const be=new h.$Tl(this.b,fe);ae.set(f.$th,be),await Promise.all([be.appSettingsHome.fsPath,be.extensionsPath].map(ke=>ke?p.Promises.mkdir(ke,{recursive:!0}):void 0));const Se=new re.$mM((0,ie.$2i)(be),be.logsHome);ae.set(ie.$Oi,Se);const Le=this.B(Se.createLogger("cli",{name:(0,de.localize)(0,null)})),Ue=[];Se.getLogLevel()===ie.LogLevel.Trace&&Ue.push(new ie.$Vi(Se.getLogLevel()));const q=this.B(new _.$wM(Le,Ue));ae.set(ie.$Ni,q);const K=this.B(new c.$op(q));ae.set(a.$Oj,K);const ee=this.B(new I.$Np(q));K.registerProvider(E.Schemas.file,ee);const ge=new r.$$q(K);ae.set(R.$lk,ge);const we=new F.$qM(1,be,q,K),Re=new T.$sM(we,ge,be,K,q);ae.set(k.$nk,Re);const Ee=l.$i&&fe.win32RegValueName?this.B(new ce.$$3b(q,fe.win32RegValueName)):be.policyFile?this.B(new ue.$_3b(be.policyFile,K,q)):new x.$Tm;ae.set(x.$Rm,Ee);const De=this.B(new j.$hn(Re.defaultProfile.settingsResource,K,Ee,q));ae.set(m.$Rh,De),await Promise.all([we.init(),De.initialize()]);let Ie;try{Ie=await(0,B.$S3b)(we,q)}catch(ke){ke.code!=="ENOENT"&&q.error(ke)}Re.init(),ae.set(R.$lk,new r.$$q(K)),ae.set(V.$uo,new w.$ih(H.$zq,void 0,!0)),ae.set(v.$qn,new w.$ih(d.$LM,void 0,!0)),ae.set(o.$8o,new w.$ih(Z.$vM,void 0,!0)),ae.set(n.$_o,new w.$ih(s.$P3b,void 0,!0)),ae.set(y.$Ro,new w.$ih(y.$So,void 0,!0)),ae.set(i.$jp,new w.$ih(i.$kp,void 0,!0)),ae.set(g.$Ln,new w.$ih(b.$Qo,void 0,!0)),ae.set(Q.$tq,new w.$ih(J.$vq,void 0,!1));const je=[],ze=(0,Y.$$n)(fe,De);if((0,Y.$6n)(fe,be)){fe.aiConfig&&fe.aiConfig.ariaKey&&je.push(new z.$kM(ze,"monacoworkbench",null,fe.aiConfig.ariaKey));const ke={appenders:je,sendErrorTelemetry:!1,commonProperties:(0,U.$Vn)((0,N.release)(),(0,N.hostname)(),process.arch,fe.commit,fe.version,Ie,ze),piiPaths:(0,Y.$_n)(be)};ae.set(W.$Rk,new w.$ih(X.$Bq,[ke],!1))}else ae.set(W.$Rk,Y.$Zn);return[new $.$Qp(ae),je]}g(ae){(0,A.setUnexpectedErrorHandler)(fe=>{const be=(0,O.$9h)(fe,!0);be&&ae.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",fe=>{(0,A.$W)(fe)||(0,A.$X)(fe)}),process.on("unhandledRejection",fe=>(0,A.$X)(fe))}async h(ae,fe,be,Se){let Le;if(ae.args.profile&&(Le=be.profiles.find(q=>q.name===ae.args.profile),!Le))throw new Error(`Profile '${ae.args.profile}' not found.`);const Ue=(Le??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(t.$To,new ie.$Vi(ie.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,Ue);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const q={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Ue};return Se.createInstance(t.$To,new ie.$Vi(ie.LogLevel.Info,!1)).installExtensions(this.i(this.b["install-extension"]||[]),this.i(this.b["install-builtin-extension"]||[]),q,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(t.$To,new ie.$Vi(ie.LogLevel.Info,!1)).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Ue);if(this.b["locate-extension"])return Se.createInstance(t.$To,new ie.$Vi(ie.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,C.$v4b)(ae.appRoot,ae.extensionsPath))}}i(ae){return ae.map(fe=>/\.vsix$/i.test(fe)?S.URI.file((0,u.$0b)(fe)?fe:(0,u.$$b)((0,P.cwd)(),fe)):fe)}}async function he(me){const ae=new $e(me);try{await ae.run()}finally{ae.dispose()}}e.main=he})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/660393deaaa6d1996740ff4880f1bad43768c814/core/vs/code/node/cliProcessMain.js.map
