/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/types","vs/nls","vs/base/common/uri","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/path","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/network","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(ne){for(var e=[],R=0,M=ne.length;R<M;R++)e[R]=ae[ne[R]];return e};define(ae[59],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.$Qg=e.$Pg=void 0;function R(O){return(C,k,m)=>{let S=null,E=null;if(typeof m.value=="function"?(S="value",E=m.value):typeof m.get=="function"&&(S="get",E=m.get),!E)throw new Error("not supported");m[S]=O(E,k)}}function M(O,C,k){let m=null,S=null;if(typeof k.value=="function"?(m="value",S=k.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(m="get",S=k.get),!S)throw new Error("not supported");const E=`$memoize$${C}`;k[m]=function(...b){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,b)}),this[E]}}e.$Pg=M;function L(O,C,k){return R((m,S)=>{const E=`$debounce$${S}`,b=`$debounce$result$${S}`;return function(...f){this[b]||(this[b]=k?k():void 0),clearTimeout(this[E]),C&&(this[b]=C(this[b],...f),f=[this[b]]),this[E]=setTimeout(()=>{m.apply(this,f),this[b]=k?k():void 0},O)}})}e.$Qg=L;function j(O,C,k){return R((m,S)=>{const E=`$throttle$timer$${S}`,b=`$throttle$result$${S}`,f=`$throttle$lastRun$${S}`,$=`$throttle$pending$${S}`;return function(...v){if(this[b]||(this[b]=k?k():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),C&&(this[b]=C(this[b],...v)),this[$])return;const a=this[f]+O;a<=Date.now()?(this[f]=Date.now(),m.apply(this,[this[b]]),this[b]=k?k():void 0):(this[$]=!0,this[E]=setTimeout(()=>{this[$]=!1,this[f]=Date.now(),m.apply(this,[this[b]]),this[b]=k?k():void 0},a-Date.now()))}})}e.$Rg=j}),define(ae[7],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.$W=e.setUnexpectedErrorHandler=e.$U=e.$T=void 0;class R{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?w.isErrorNoTelemetry(r)?new w(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(i=>{i(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.$T=R,e.$U=new R;function M(n){e.$U.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=M;function L(n){if(!n||typeof n!="object")return!1;const r=n;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.$W=L;function j(n){m(n)||e.$U.onUnexpectedError(n)}e.$X=j;function O(n){m(n)||e.$U.onUnexpectedExternalError(n)}e.$Y=O;function C(n){if(n instanceof Error){const{name:r,message:i}=n,t=n.stacktrace||n.stack;return{$isError:!0,name:r,message:i,stack:t,noTelemetry:w.isErrorNoTelemetry(n)}}return n}e.$Z=C;const k="Canceled";function m(n){return n instanceof S?!0:n instanceof Error&&n.name===k&&n.message===k}e.$1=m;class S extends Error{constructor(){super(k),this.name=this.message}}e.$2=S;function E(){const n=new Error(k);return n.name=n.message,n}e.$3=E;function b(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.$4=b;function f(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.$5=f;function $(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.$6=$;function v(n){const r=new Error(`${n} has been disposed`);return r.name="DISPOSED",r}e.$7=v;function a(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.$8=a;class h extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.$9=h;class u extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.$0=u;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=p;class w extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof w)return r;const i=new w;return i.message=r.message,i.stack=r.stack,i}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.$_=w;class I extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,I.prototype)}}e.$ab=I}),define(ae[21],ce([0,1,7]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.CompareResult=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.top=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=void 0;function M(z,J=0){return z[z.length-(1+J)]}e.$9e=M;function L(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$0e=L;function j(z,J,te=(oe,he)=>oe===he){if(z===J)return!0;if(!z||!J||z.length!==J.length)return!1;for(let oe=0,he=z.length;oe<he;oe++)if(!te(z[oe],J[oe]))return!1;return!0}e.$$e=j;function O(z,J){const te=z.length-1;J<te&&(z[J]=z[te]),z.pop()}e.$_e=O;function C(z,J,te){return k(z.length,oe=>te(z[oe],J))}e.$af=C;function k(z,J){let te=0,oe=z-1;for(;te<=oe;){const he=(te+oe)/2|0,fe=J(he);if(fe<0)te=he+1;else if(fe>0)oe=he-1;else return he}return-(te+1)}e.$bf=k;function m(z,J){let te=0,oe=z.length;if(oe===0)return 0;for(;te<oe;){const he=Math.floor((te+oe)/2);J(z[he])?oe=he:te=he+1}return te}e.$cf=m;function S(z,J,te){if(z=z|0,z>=J.length)throw new TypeError("invalid index");const oe=J[Math.floor(J.length*Math.random())],he=[],fe=[],be=[];for(const pe of J){const Ee=te(pe,oe);Ee<0?he.push(pe):Ee>0?fe.push(pe):be.push(pe)}return z<he.length?S(z,he,te):z<he.length+be.length?be[0]:S(z-(he.length+be.length),fe,te)}e.$df=S;function E(z,J){const te=[];let oe;for(const he of z.slice(0).sort(J))!oe||J(oe[0],he)!==0?(oe=[he],te.push(oe)):oe.push(he);return te}e.$ef=E;function b(z,J,te){const oe=[];function he(pe,Ee,Ce){if(Ee===0&&Ce.length===0)return;const Le=oe[oe.length-1];Le&&Le.start+Le.deleteCount===pe?(Le.deleteCount+=Ee,Le.toInsert.push(...Ce)):oe.push({start:pe,deleteCount:Ee,toInsert:Ce})}let fe=0,be=0;for(;;){if(fe===z.length){he(fe,0,J.slice(be));break}if(be===J.length){he(fe,z.length-fe,[]);break}const pe=z[fe],Ee=J[be],Ce=te(pe,Ee);Ce===0?(fe+=1,be+=1):Ce<0?(he(fe,1,[]),fe+=1):Ce>0&&(he(fe,0,[Ee]),be+=1)}return oe}e.$ff=b;function f(z,J,te){const oe=b(z,J,te),he=[],fe=[];for(const be of oe)he.push(...z.slice(be.start,be.start+be.deleteCount)),fe.push(...be.toInsert);return{removed:he,added:fe}}e.$gf=f;function $(z,J,te){if(te===0)return[];const oe=z.slice(0,te).sort(J);return a(z,J,oe,te,z.length),oe}e.top=$;function v(z,J,te,oe,he){return te===0?Promise.resolve([]):new Promise((fe,be)=>{(async()=>{const pe=z.length,Ee=z.slice(0,te).sort(J);for(let Ce=te,Le=Math.min(te+oe,pe);Ce<pe;Ce=Le,Le=Math.min(Le+oe,pe)){if(Ce>te&&await new Promise(Ue=>setTimeout(Ue)),he&&he.isCancellationRequested)throw new R.$2;a(z,J,Ee,Ce,Le)}return Ee})().then(fe,be)})}e.$if=v;function a(z,J,te,oe,he){for(const fe=te.length;oe<he;oe++){const be=z[oe];if(J(be,te[fe-1])<0){te.pop();const pe=m(te,Ee=>J(be,Ee)<0);te.splice(pe,0,be)}}}function h(z){return z.filter(J=>!!J)}e.$jf=h;function u(z){let J=0;for(let te=0;te<z.length;te++)z[te]&&(z[J]=z[te],J+=1);z.length=J}e.$kf=u;function p(z,J,te){z.splice(te,0,z.splice(J,1)[0])}e.$lf=p;function w(z){return!Array.isArray(z)||z.length===0}e.$mf=w;function I(z){return Array.isArray(z)&&z.length>0}e.$nf=I;function n(z,J=te=>te){const te=new Set;return z.filter(oe=>{const he=J(oe);return te.has(he)?!1:(te.add(he),!0)})}e.$of=n;function r(z){const J=new Set;return te=>{const oe=z(te);return J.has(oe)?!1:(J.add(oe),!0)}}e.$pf=r;function i(z,J){const te=t(z,J);if(te!==-1)return z[te]}e.$qf=i;function t(z,J){for(let te=z.length-1;te>=0;te--){const oe=z[te];if(J(oe))return te}return-1}e.$rf=t;function s(z,J){return z.length>0?z[0]:J}e.$sf=s;function o(z,J){return z.length>0?z[z.length-1]:J}e.$tf=o;function c(z,J,te=(oe,he)=>oe===he){let oe=0;for(let he=0,fe=Math.min(z.length,J.length);he<fe&&te(z[he],J[he]);he++)oe++;return oe}e.$uf=c;function y(z){return[].concat(...z)}e.$vf=y;function d(z,J){let te=typeof J=="number"?z:0;typeof J=="number"?te=z:(te=0,J=z);const oe=[];if(te<=J)for(let he=te;he<J;he++)oe.push(he);else for(let he=te;he>J;he--)oe.push(he);return oe}e.$wf=d;function l(z,J,te){return z.reduce((oe,he)=>(oe[J(he)]=te?te(he):he,oe),Object.create(null))}e.$xf=l;function P(z,J){return z.push(J),()=>D(z,J)}e.$yf=P;function D(z,J){const te=z.indexOf(J);if(te>-1)return z.splice(te,1),J}e.$zf=D;function T(z,J,te){const oe=z.slice(0,J),he=z.slice(J);return oe.concat(te,he)}e.$Af=T;function F(z,J){let te;if(typeof J=="number"){let oe=J;te=()=>{const he=Math.sin(oe++)*179426549;return he-Math.floor(he)}}else te=Math.random;for(let oe=z.length-1;oe>0;oe-=1){const he=Math.floor(te()*(oe+1)),fe=z[oe];z[oe]=z[he],z[he]=fe}}e.$Bf=F;function H(z,J){const te=z.indexOf(J);te>-1&&(z.splice(te,1),z.unshift(J))}e.$Cf=H;function V(z,J){const te=z.indexOf(J);te>-1&&(z.splice(te,1),z.push(J))}e.$Df=V;function W(z,J){for(const te of J)z.push(te)}e.$Ef=W;function x(z,J){return Array.isArray(z)?z.map(J):J(z)}e.$Ff=x;function ee(z){return Array.isArray(z)?z:[z]}e.$Gf=ee;function X(z){return z[Math.floor(Math.random()*z.length)]}e.$Hf=X;function _(z,J){for(const te of z){const oe=J(te);if(oe!==void 0)return oe}}e.$If=_;function q(z,J,te){const oe=B(z,J),he=z.length,fe=te.length;z.length=he+fe;for(let be=he-1;be>=oe;be--)z[be+fe]=z[be];for(let be=0;be<fe;be++)z[be+oe]=te[be]}e.$Jf=q;function G(z,J,te,oe){const he=B(z,J),fe=z.splice(he,te);return q(z,he,oe),fe}e.$Kf=G;function B(z,J){return J<0?Math.max(J+z.length,0):Math.min(J,z.length)}var ie;(function(z){function J(he){return he<0}z.isLessThan=J;function te(he){return he>0}z.isGreaterThan=te;function oe(he){return he===0}z.isNeitherLessOrGreaterThan=oe,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function re(z,J){return(te,oe)=>J(z(te),z(oe))}e.$Lf=re;function K(...z){return(J,te)=>{for(const oe of z){const he=oe(J,te);if(!ie.isNeitherLessOrGreaterThan(he))return he}return ie.neitherLessOrGreaterThan}}e.$Mf=K;const Z=(z,J)=>z-J;e.$Nf=Z;function N(z,J){if(z.length===0)return;let te=z[0];for(let oe=1;oe<z.length;oe++){const he=z[oe];J(he,te)>0&&(te=he)}return te}e.$Of=N;function g(z,J){if(z.length===0)return;let te=z[0];for(let oe=1;oe<z.length;oe++){const he=z[oe];J(he,te)>=0&&(te=he)}return te}e.$Pf=g;function A(z,J){return N(z,(te,oe)=>-J(te,oe))}e.$Qf=A;class U{constructor(J){this.f=J,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(J){let te=this.c;for(;te<this.f.length&&J(this.f[te]);)te++;const oe=te===this.c?null:this.f.slice(this.c,te);return this.c=te,oe}takeFromEndWhile(J){let te=this.d;for(;te>=0&&J(this.f[te]);)te--;const oe=te===this.d?null:this.f.slice(te+1,this.d+1);return this.d=te,oe}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const J=this.f[this.c];return this.c++,J}removeLast(){const J=this.f[this.d];return this.d--,J}takeCount(J){const te=this.f.slice(this.c,this.c+J);return this.c+=J,te}}e.$Rf=U;class Q{constructor(J){this.iterate=J}forEach(J){this.iterate(te=>(J(te),!0))}toArray(){const J=[];return this.iterate(te=>(J.push(te),!0)),J}filter(J){return new Q(te=>this.iterate(oe=>J(oe)?te(oe):!0))}map(J){return new Q(te=>this.iterate(oe=>te(J(oe))))}some(J){let te=!1;return this.iterate(oe=>(te=J(oe),!te)),te}findFirst(J){let te;return this.iterate(oe=>J(oe)?(te=oe,!1):!0),te}findLast(J){let te;return this.iterate(oe=>(J(oe)&&(te=oe),!0)),te}findLastMaxBy(J){let te,oe=!0;return this.iterate(he=>((oe||ie.isGreaterThan(J(he,te)))&&(oe=!1,te=he),!0)),te}}e.$Sf=Q,Q.empty=new Q(z=>{})}),define(ae[122],ce([0,1,7]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oc=e.$nc=e.$mc=e.$lc=e.ok=void 0;function M(k,m){if(!k)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=M;function L(k,m="Unreachable"){throw new Error(m)}e.$lc=L;function j(k){if(!k)throw new R.$ab("Assertion Failed")}e.$mc=j;function O(k){if(!k()){debugger;k(),(0,R.$X)(new R.$ab("Assertion Failed"))}}e.$nc=O;function C(k,m){let S=0;for(;S<k.length-1;){const E=k[S],b=k[S+1];if(!m(E,b))return!1;S++}return!0}e.$oc=C}),define(ae[82],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function R(M){const L=this;let j=!1,O;return function(){return j||(j=!0,O=M.apply(L,arguments)),O}}e.$bb=R}),define(ae[60],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(M){function L(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}M.is=L;const j=Object.freeze([]);function O(){return j}M.empty=O;function*C(w){yield w}M.single=C;function k(w){return L(w)?w:C(w)}M.wrap=k;function m(w){return w||j}M.from=m;function S(w){return!w||w[Symbol.iterator]().next().done===!0}M.isEmpty=S;function E(w){return w[Symbol.iterator]().next().value}M.first=E;function b(w,I){for(const n of w)if(I(n))return!0;return!1}M.some=b;function f(w,I){for(const n of w)if(I(n))return n}M.find=f;function*$(w,I){for(const n of w)I(n)&&(yield n)}M.filter=$;function*v(w,I){let n=0;for(const r of w)yield I(r,n++)}M.map=v;function*a(...w){for(const I of w)for(const n of I)yield n}M.concat=a;function h(w,I,n){let r=n;for(const i of w)r=I(r,i);return r}M.reduce=h;function*u(w,I,n=w.length){for(I<0&&(I+=w.length),n<0?n+=w.length:n>w.length&&(n=w.length);I<n;I++)yield w[I]}M.slice=u;function p(w,I=Number.POSITIVE_INFINITY){const n=[];if(I===0)return[n,w];const r=w[Symbol.iterator]();for(let i=0;i<I;i++){const t=r.next();if(t.done)return[n,M.empty()];n.push(t.value)}return[n,{[Symbol.iterator](){return r}}]}M.consume=p})(R||(e.Iterable=R={}))}),define(ae[34],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(R||(e.ScanError=R={}));var M;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var L;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var j;(function(n){n.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function O(n,r=!1){let i=0;const t=n.length;let s="",o=0,c=16,y=0;function d(V){let W=0,x=0;for(;W<V;){const ee=n.charCodeAt(i);if(ee>=48&&ee<=57)x=x*16+ee-48;else if(ee>=65&&ee<=70)x=x*16+ee-65+10;else if(ee>=97&&ee<=102)x=x*16+ee-97+10;else break;i++,W++}return W<V&&(x=-1),x}function l(V){i=V,s="",o=0,c=16,y=0}function P(){const V=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&m(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&m(n.charCodeAt(i)))for(i++;i<n.length&&m(n.charCodeAt(i));)i++;else return y=3,n.substring(V,i);let W=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&m(n.charCodeAt(i))){for(i++;i<n.length&&m(n.charCodeAt(i));)i++;W=i}else y=3;return n.substring(V,W)}function D(){let V="",W=i;for(;;){if(i>=t){V+=n.substring(W,i),y=2;break}const x=n.charCodeAt(i);if(x===34){V+=n.substring(W,i),i++;break}if(x===92){if(V+=n.substring(W,i),i++,i>=t){y=2;break}switch(n.charCodeAt(i++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const X=d(4);X>=0?V+=String.fromCharCode(X):y=4;break}default:y=5}W=i;continue}if(x>=0&&x<=31)if(k(x)){V+=n.substring(W,i),y=2;break}else y=6;i++}return V}function T(){if(s="",y=0,o=i,i>=t)return o=t,c=17;let V=n.charCodeAt(i);if(C(V)){do i++,s+=String.fromCharCode(V),V=n.charCodeAt(i);while(C(V));return c=15}if(k(V))return i++,s+=String.fromCharCode(V),V===13&&n.charCodeAt(i)===10&&(i++,s+=`
`),c=14;switch(V){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,s=D(),c=10;case 47:{const W=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<t&&!k(n.charCodeAt(i));)i++;return s=n.substring(W,i),c=12}if(n.charCodeAt(i+1)===42){i+=2;const x=t-1;let ee=!1;for(;i<x;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,ee=!0;break}i++}return ee||(i++,y=1),s=n.substring(W,i),c=13}return s+=String.fromCharCode(V),i++,c=16}case 45:if(s+=String.fromCharCode(V),i++,i===t||!m(n.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=P(),c=11;default:for(;i<t&&F(V);)i++,V=n.charCodeAt(i);if(o!==i){switch(s=n.substring(o,i),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(V),i++,c=16}}function F(V){if(C(V)||k(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let V;do V=T();while(V>=12&&V<=15);return V}return{setPosition:l,getPosition:()=>i,scan:r?H:T,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>y}}e.$rm=O;function C(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function k(n){return n===10||n===13||n===8232||n===8233}function m(n){return n>=48&&n<=57}var S;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(S||(S={}));function E(n,r){const i=[],t=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function y(d,l,P,D){o.value=d,o.offset=l,o.length=P,o.type=D,o.colonOffset=void 0,s=o}try{p(n,{onObjectBegin:(d,l)=>{if(r<=d)throw t;s=void 0,c=r>d,i.push("")},onObjectProperty:(d,l,P)=>{if(r<l||(y(d,l,P,"property"),i[i.length-1]=d,r<=l+P))throw t},onObjectEnd:(d,l)=>{if(r<=d)throw t;s=void 0,i.pop()},onArrayBegin:(d,l)=>{if(r<=d)throw t;s=void 0,i.push(0)},onArrayEnd:(d,l)=>{if(r<=d)throw t;s=void 0,i.pop()},onLiteralValue:(d,l,P)=>{if(r<l||(y(d,l,P,I(d)),r<=l+P))throw t},onSeparator:(d,l,P)=>{if(r<=l)throw t;if(d===":"&&s&&s.type==="property")s.colonOffset=l,c=!1,s=void 0;else if(d===","){const D=i[i.length-1];typeof D=="number"?i[i.length-1]=D+1:(c=!0,i[i.length-1]=""),s=void 0}}})}catch(d){if(d!==t)throw d}return{path:i,previousNode:s,isAtPropertyKey:c,matches:d=>{let l=0;for(let P=0;l<d.length&&P<i.length;P++)if(d[l]===i[P]||d[l]==="*")l++;else if(d[l]!=="**")return!1;return l===d.length}}}e.$sm=E;function b(n,r=[],i=j.DEFAULT){let t=null,s=[];const o=[];function c(d){Array.isArray(s)?s.push(d):t!==null&&(s[t]=d)}return p(n,{onObjectBegin:()=>{const d={};c(d),o.push(s),s=d,t=null},onObjectProperty:d=>{t=d},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const d=[];c(d),o.push(s),s=d,t=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:c,onError:(d,l,P)=>{r.push({error:d,offset:l,length:P})}},i),s[0]}e.$tm=b;function f(n,r=[],i=j.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(d){t.type==="property"&&(t.length=d-t.offset,t=t.parent)}function o(d){return t.children.push(d),d}p(n,{onObjectBegin:d=>{t=o({type:"object",offset:d,length:-1,parent:t,children:[]})},onObjectProperty:(d,l,P)=>{t=o({type:"property",offset:l,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:d,offset:l,length:P,parent:t})},onObjectEnd:(d,l)=>{t.length=d+l-t.offset,t=t.parent,s(d+l)},onArrayBegin:(d,l)=>{t=o({type:"array",offset:d,length:-1,parent:t,children:[]})},onArrayEnd:(d,l)=>{t.length=d+l-t.offset,t=t.parent,s(d+l)},onLiteralValue:(d,l,P)=>{o({type:I(d),offset:l,length:P,parent:t,value:d}),s(l+P)},onSeparator:(d,l,P)=>{t.type==="property"&&(d===":"?t.colonOffset=l:d===","&&s(l))},onError:(d,l,P)=>{r.push({error:d,offset:l,length:P})}},i);const y=t.children[0];return y&&delete y.parent,y}e.$um=f;function $(n,r){if(!n)return;let i=n;for(const t of r)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===t){i=o.children[1],s=!0;break}if(!s)return}else{const s=t;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.$vm=$;function v(n){if(!n.parent||!n.parent.children)return[];const r=v(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;r.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&r.push(i)}return r}e.$wm=v;function a(n){switch(n.type){case"array":return n.children.map(a);case"object":{const r=Object.create(null);for(const i of n.children){const t=i.children[1];t&&(r[i.children[0].value]=a(t))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$xm=a;function h(n,r,i=!1){return r>=n.offset&&r<n.offset+n.length||i&&r===n.offset+n.length}e.$ym=h;function u(n,r,i=!1){if(h(n,r,i)){const t=n.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=r;s++){const o=u(t[s],r,i);if(o)return o}return n}}e.$zm=u;function p(n,r,i=j.DEFAULT){const t=O(n,!1);function s(re){return re?()=>re(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(re){return re?K=>re(K,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=s(r.onObjectBegin),y=o(r.onObjectProperty),d=s(r.onObjectEnd),l=s(r.onArrayBegin),P=s(r.onArrayEnd),D=o(r.onLiteralValue),T=o(r.onSeparator),F=s(r.onComment),H=o(r.onError),V=i&&i.disallowComments,W=i&&i.allowTrailingComma;function x(){for(;;){const re=t.scan();switch(t.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:V||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(re){case 12:case 13:V?ee(10):F();break;case 16:ee(1);break;case 15:case 14:break;default:return re}}}function ee(re,K=[],Z=[]){if(H(re),K.length+Z.length>0){let N=t.getToken();for(;N!==17;){if(K.indexOf(N)!==-1){x();break}else if(Z.indexOf(N)!==-1)break;N=x()}}}function X(re){const K=t.getTokenValue();return re?D(K):y(K),x(),!0}function _(){switch(t.getToken()){case 11:{let re=0;try{re=JSON.parse(t.getTokenValue()),typeof re!="number"&&(ee(2),re=0)}catch{ee(2)}D(re);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return x(),!0}function q(){return t.getToken()!==10?(ee(3,[],[2,5]),!1):(X(!1),t.getToken()===6?(T(":"),x(),ie()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function G(){c(),x();let re=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(re||ee(4,[],[]),T(","),x(),t.getToken()===2&&W)break}else re&&ee(6,[],[]);q()||ee(4,[],[2,5]),re=!0}return d(),t.getToken()!==2?ee(7,[2],[]):x(),!0}function B(){l(),x();let re=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(re||ee(4,[],[]),T(","),x(),t.getToken()===4&&W)break}else re&&ee(6,[],[]);ie()||ee(4,[],[4,5]),re=!0}return P(),t.getToken()!==4?ee(8,[4],[]):x(),!0}function ie(){switch(t.getToken()){case 3:return B();case 1:return G();case 10:return X(!0);default:return _()}}return x(),t.getToken()===17?i.allowEmptyContent?!0:(ee(4,[],[]),!1):ie()?(t.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.$Am=p;function w(n,r){const i=O(n),t=[];let s,o=0,c;do switch(c=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:o!==c&&t.push(n.substring(o,c)),r!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,r)),o=i.getPosition();break}while(s!==17);return t.join("")}e.$Bm=w;function I(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$Cm=I}),define(ae[41],ce([0,1,34]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=e.$BR=e.$AR=e.$zR=void 0;function M(m,S,E){let b,f,$,v,a;if(S){for(v=S.offset,a=v+S.length,$=v;$>0&&!k(m,$-1);)$--;let c=a;for(;c<m.length&&!k(m,c);)c++;f=m.substring($,c),b=O(f,E)}else f=m,b=0,$=0,v=0,a=m.length;const h=C(E,m);let u=!1,p=0,w;E.insertSpaces?w=j(" ",E.tabSize||4):w="	";const I=(0,R.$rm)(f,!1);let n=!1;function r(){return h+j(w,b+p)}function i(){let c=I.scan();for(u=!1;c===15||c===14;)u=u||c===14,c=I.scan();return n=c===16||I.getTokenError()!==0,c}const t=[];function s(c,y,d){!n&&y<a&&d>v&&m.substring(y,d)!==c&&t.push({offset:y,length:d-y,content:c})}let o=i();if(o!==17){const c=I.getTokenOffset()+$,y=j(w,b);s(y,$,c)}for(;o!==17;){let c=I.getTokenOffset()+I.getTokenLength()+$,y=i(),d="";for(;!u&&(y===12||y===13);){const P=I.getTokenOffset()+$;s(" ",c,P),c=I.getTokenOffset()+I.getTokenLength()+$,d=y===12?r():"",y=i()}if(y===2)o!==1&&(p--,d=r());else if(y===4)o!==3&&(p--,d=r());else{switch(o){case 3:case 1:p++,d=r();break;case 5:case 12:d=r();break;case 13:u?d=r():d=" ";break;case 6:d=" ";break;case 10:if(y===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?d=" ":y!==5&&y!==17&&(n=!0);break;case 16:n=!0;break}u&&(y===12||y===13)&&(d=r())}const l=I.getTokenOffset()+$;s(d,c,l),o=y}return t}e.$zR=M;function L(m,S){const E=JSON.stringify(m,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?E.replace(/\r\n|\r|\n/g,S.eol):E}e.$AR=L;function j(m,S){let E="";for(let b=0;b<S;b++)E+=m;return E}function O(m,S){let E=0,b=0;const f=S.tabSize||4;for(;E<m.length;){const $=m.charAt(E);if($===" ")b++;else if($==="	")b+=f;else break;E++}return Math.floor(b/f)}function C(m,S){for(let E=0;E<S.length;E++){const b=S.charAt(E);if(b==="\r")return E+1<S.length&&S.charAt(E+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return m&&m.eol||`
`}e.$BR=C;function k(m,S){return`\r
`.indexOf(m.charAt(S))!==-1}e.$CR=k}),define(ae[83],ce([0,1,34,41]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HR=e.$GR=e.$FR=e.$ER=e.$DR=void 0;function L(m,S,E){return j(m,S,void 0,E)}e.$DR=L;function j(m,S,E,b,f){const $=S.slice(),v=[],a=(0,R.$um)(m,v);let h,u;for(;$.length>0&&(u=$.pop(),h=(0,R.$vm)(a,$),h===void 0&&E!==void 0);)typeof u=="string"?E={[u]:E}:E=[E];if(h)if(h.type==="object"&&typeof u=="string"&&Array.isArray(h.children)){const p=(0,R.$vm)(h,[u]);if(p!==void 0)if(E===void 0){if(!p.parent)throw new Error("Malformed AST");const w=h.children.indexOf(p.parent);let I,n=p.parent.offset+p.parent.length;if(w>0){const r=h.children[w-1];I=r.offset+r.length}else I=h.offset+1,h.children.length>1&&(n=h.children[1].offset);return O(m,{offset:I,length:n-I,content:""},b)}else return O(m,{offset:p.offset,length:p.length,content:JSON.stringify(E)},b);else{if(E===void 0)return[];const w=`${JSON.stringify(u)}: ${JSON.stringify(E)}`,I=f?f(h.children.map(r=>r.children[0].value)):h.children.length;let n;if(I>0){const r=h.children[I-1];n={offset:r.offset+r.length,length:0,content:","+w}}else h.children.length===0?n={offset:h.offset+1,length:0,content:w}:n={offset:h.offset+1,length:0,content:w+","};return O(m,n,b)}}else if(h.type==="array"&&typeof u=="number"&&Array.isArray(h.children))if(E!==void 0){const p=`${JSON.stringify(E)}`;let w;if(h.children.length===0||u===0)w={offset:h.offset+1,length:0,content:h.children.length===0?p:p+","};else{const I=u===-1||u>h.children.length?h.children.length:u,n=h.children[I-1];w={offset:n.offset+n.length,length:0,content:","+p}}return O(m,w,b)}else{const p=u,w=h.children[p];let I;if(h.children.length===1)I={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===p){const n=h.children[p-1],r=n.offset+n.length,i=h.offset+h.length;I={offset:r,length:i-2-r,content:""}}else I={offset:w.offset,length:h.children[p+1].offset-w.offset,content:""};return O(m,I,b)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${h.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return O(m,{offset:a?a.offset:0,length:a?a.length:0,content:JSON.stringify(E)},b)}}e.$ER=j;function O(m,S,E){let b=C(m,S),f=S.offset,$=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;f>0&&!(0,M.$CR)(b,f-1);)f--;for(;$<b.length&&!(0,M.$CR)(b,$);)$++}const v=(0,M.$zR)(b,{offset:f,length:$-f},E);for(let h=v.length-1;h>=0;h--){const u=v[h];b=C(b,u),f=Math.min(f,u.offset),$=Math.max($,u.offset+u.length),$+=u.content.length-u.length}const a=m.length-(b.length-$)-f;return[{offset:f,length:a,content:b.substring(f,$)}]}e.$FR=O;function C(m,S){return m.substring(0,S.offset)+S.content+m.substring(S.offset+S.length)}e.$GR=C;function k(m,S){const E=S.slice(0).sort((f,$)=>{const v=f.offset-$.offset;return v===0?f.length-$.length:v});let b=m.length;for(let f=E.length-1;f>=0;f--){const $=E[f];if($.offset+$.length<=b)m=C(m,$);else throw new Error("Overlapping edit");b=$.offset}return m}e.$HR=k}),define(ae[84],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=void 0;class R{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$S=R}),define(ae[2],ce([0,1,82,60]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=e.$cb=void 0;const L=!1;let j=null;function O(o){j=o}if(e.$cb=O,L){const o="__is_disposable_tracked__";O(new class{trackDisposable(c){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[o]||console.log(y)},3e3)}setParent(c,y){if(c&&c!==u.None)try{c[o]=!0}catch{}}markAsDisposed(c){if(c&&c!==u.None)try{c[o]=!0}catch{}}markAsSingleton(c){}})}function C(o){return j?.trackDisposable(o),o}function k(o){j?.markAsDisposed(o)}function m(o,c){j?.setParent(o,c)}function S(o,c){if(j)for(const y of o)j.setParent(y,c)}function E(o){return j?.markAsSingleton(o),o}e.$db=E;function b(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.$eb=b;function f(o){if(M.Iterable.is(o)){const c=[];for(const y of o)if(y)try{y.dispose()}catch(d){c.push(d)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.$fb=f;function $(o){for(const c of o)b(c)&&c.dispose();return[]}e.$gb=$;function v(...o){const c=a(()=>f(o));return S(o,c),c}e.$hb=v;function a(o){const c=C({dispose:(0,R.$bb)(()=>{k(c),o()})});return c}e.$ib=a;class h{constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return m(c,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(c),c}}e.$jb=h,h.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this.q=new h,C(this),m(this.q,this)}dispose(){k(this),this.q.dispose()}B(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(c)}}e.$kb=u,u.None=Object.freeze({dispose(){}});class p{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(c){this.b||c===this.a||(this.a?.dispose(),c&&m(c,this),this.a=c)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const c=this.a;return this.a=void 0,c&&m(c,null),c}}e.$lb=p;class w{constructor(c){this.b=c,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$mb=w;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(c){let y=c;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,k(this))},this}}e.$nb=I;class n{constructor(){this.a=new Map}acquire(c,...y){let d=this.a.get(c);d||(d={counter:0,object:this.b(c,...y)},this.a.set(c,d));const{object:l}=d,P=(0,R.$bb)(()=>{--d.counter===0&&(this.c(c,d.object),this.a.delete(c))});return d.counter++,{object:l,dispose:P}}}e.$ob=n;class r{constructor(c){this.a=c}async acquire(c,...y){const d=this.a.acquire(c,...y);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(l){throw d.dispose(),l}}}e.$pb=r;class i{constructor(c){this.object=c}dispose(){}}e.$qb=i;function t(o){const c=new h;try{o(c)}finally{c.dispose()}}e.$rb=t;class s{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(c){return this.a.has(c)}get(c){return this.a.get(c)}set(c,y,d=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),d||this.a.get(c)?.dispose(),this.a.set(c,y)}deleteAndDispose(c){this.a.get(c)?.dispose(),this.a.delete(c)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$sb=s}),define(ae[85],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jc=void 0;class R{constructor(j){this.element=j,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class M{constructor(){this.a=R.Undefined,this.b=R.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===R.Undefined}clear(){let j=this.a;for(;j!==R.Undefined;){const O=j.next;j.prev=R.Undefined,j.next=R.Undefined,j=O}this.a=R.Undefined,this.b=R.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,O){const C=new R(j);if(this.a===R.Undefined)this.a=C,this.b=C;else if(O){const m=this.b;this.b=C,C.prev=m,m.next=C}else{const m=this.a;this.a=C,C.next=m,m.prev=C}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(C))}}shift(){if(this.a!==R.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==R.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==R.Undefined&&j.next!==R.Undefined){const O=j.prev;O.next=j.next,j.next.prev=O}else j.prev===R.Undefined&&j.next===R.Undefined?(this.a=R.Undefined,this.b=R.Undefined):j.next===R.Undefined?(this.b=this.b.prev,this.b.next=R.Undefined):j.prev===R.Undefined&&(this.a=this.a.next,this.a.prev=R.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==R.Undefined;)yield j.element,j=j.next}}e.$jc=M}),define(ae[35],ce([0,1]),function(ne,e){"use strict";var R,M,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.Touch=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;function j(v,a,h){let u=v.get(a);return u===void 0&&(u=h,v.set(a,u)),u}e.$gi=j;function O(v){const a=[];return v.forEach((h,u)=>{a.push(`${u} => ${h}`)}),`Map(${v.size}) {${a.join(", ")}}`}e.$hi=O;function C(v){const a=[];return v.forEach(h=>{a.push(h)}),`Set(${v.size}) {${a.join(", ")}}`}e.$ii=C;class k{constructor(a,h){this.uri=a,this.value=h}}class m{constructor(a,h){this[R]="ResourceMap",a instanceof m?(this.b=new Map(a.b),this.c=h??m.a):(this.b=new Map,this.c=a??m.a)}set(a,h){return this.b.set(this.c(a),new k(a,h)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,h){typeof h<"u"&&(a=a.bind(h));for(const[u,p]of this.b)a(p.value,p.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}e.$ji=m,m.a=v=>v.toString();class S{constructor(a,h){this[M]="ResourceSet",!a||typeof a=="function"?this.a=new m(a):(this.a=new m(h),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,h){this.a.forEach((u,p)=>a.call(h,p,p,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$ki=S;var E;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class b{constructor(){this[L]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,h=0){const u=this.a.get(a);if(u)return h!==0&&this.j(u,h),u.value}set(a,h,u=0){let p=this.a.get(a);if(p)p.value=h,u!==0&&this.j(p,u);else{switch(p={key:a,value:h,next:void 0,previous:void 0},u){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(a,p),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const h=this.a.get(a);if(h)return this.a.delete(a),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,h){const u=this.e;let p=this.b;for(;p;){if(h?a.bind(h)(p.value,p.key,this):a(p.value,p.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const a=this,h=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(a.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const w={value:u.key,done:!1};return u=u.next,w}else return{value:void 0,done:!0}}};return p}values(){const a=this,h=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(a.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const w={value:u.value,done:!1};return u=u.next,w}else return{value:void 0,done:!0}}};return p}entries(){const a=this,h=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(a.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const w={value:[u.key,u.value],done:!1};return u=u.next,w}else return{value:void 0,done:!0}}};return p}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let h=this.b,u=this.size;for(;h&&u>a;)this.a.delete(h.key),h=h.next,u--;this.b=h,this.d=u,h&&(h.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const h=a.next,u=a.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}a.next=void 0,a.previous=void 0,this.e++}j(a,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(a===this.b)return;const u=a.next,p=a.previous;a===this.c?(p.next=void 0,this.c=p):(u.previous=p,p.next=u),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(h===2){if(a===this.c)return;const u=a.next,p=a.previous;a===this.b?(u.previous=void 0,this.b=u):(u.previous=p,p.next=u),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((h,u)=>{a.push([u,h])}),a}fromJSON(a){this.clear();for(const[h,u]of a)this.set(h,u)}}e.$li=b;class f extends b{constructor(a,h=1){super(),this.k=a,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,h=2){return super.get(a,h)}peek(a){return super.get(a,0)}set(a,h){return super.set(a,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$mi=f;class ${constructor(){this.a=new Map}add(a){return this.a.set(a,(this.a.get(a)||0)+1),this}delete(a){let h=this.a.get(a)||0;return h===0?!1:(h--,h===0?this.a.delete(a):this.a.set(a,h),!0)}has(a){return this.a.has(a)}}e.$ni=$}),define(ae[86],ce([0,1,35]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=void 0;const M=new R.$mi(1e4);function L(m){return k(m,"NFC",M)}e.$3k=L;const j=new R.$mi(1e4);function O(m){return k(m,"NFD",j)}e.$4k=O;const C=/[^\u0000-\u0080]/;function k(m,S,E){if(!m)return m;const b=E.get(m);if(b)return b;let f;return C.test(m)?f=m.normalize(S):f=m,E.set(m,f),f}e.$5k=function(){const m=/[\u0300-\u036f]/g;return function(S){return O(S).replace(m,"")}}()}),function(){function ne(L){const j=[];typeof L=="number"&&j.push("code/timeOrigin",L);function O(k){j.push(k,Date.now())}function C(){const k=[];for(let m=0;m<j.length;m+=2)k.push({name:j[m],startTime:j[m+1]});return k}return{mark:O,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))j.push({name:O.name,startTime:Math.round(L+O.startTime)});return j}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function R(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=R(M))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var M in R)(typeof exports=="object"?exports:ne)[M]=R[M]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function R(M){if(e[M])return e[M].exports;var L=e[M]={i:M,l:!1,exports:{}};return ne[M].call(L.exports,L,L.exports,R),L.l=!0,L.exports}return R.m=ne,R.c=e,R.d=function(M,L,j){R.o(M,L)||Object.defineProperty(M,L,{enumerable:!0,get:j})},R.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},R.t=function(M,L){if(1&L&&(M=R(M)),8&L||4&L&&typeof M=="object"&&M&&M.__esModule)return M;var j=Object.create(null);if(R.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:M}),2&L&&typeof M!="string")for(var O in M)R.d(j,O,function(C){return M[C]}.bind(null,O));return j},R.n=function(M){var L=M&&M.__esModule?function(){return M.default}:function(){return M};return R.d(L,"a",L),L},R.o=function(M,L){return Object.prototype.hasOwnProperty.call(M,L)},R.p="",R(R.s=0)}([function(ne,e,R){(function(M){var L;e=ne.exports=Z,L=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],k=e.src=[],m=0,S=m++;k[S]="0|[1-9]\\d*";var E=m++;k[E]="[0-9]+";var b=m++;k[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=m++;k[f]="("+k[S]+")\\.("+k[S]+")\\.("+k[S]+")";var $=m++;k[$]="("+k[E]+")\\.("+k[E]+")\\.("+k[E]+")";var v=m++;k[v]="(?:"+k[S]+"|"+k[b]+")";var a=m++;k[a]="(?:"+k[E]+"|"+k[b]+")";var h=m++;k[h]="(?:-("+k[v]+"(?:\\."+k[v]+")*))";var u=m++;k[u]="(?:-?("+k[a]+"(?:\\."+k[a]+")*))";var p=m++;k[p]="[0-9A-Za-z-]+";var w=m++;k[w]="(?:\\+("+k[p]+"(?:\\."+k[p]+")*))";var I=m++,n="v?"+k[f]+k[h]+"?"+k[w]+"?";k[I]="^"+n+"$";var r="[v=\\s]*"+k[$]+k[u]+"?"+k[w]+"?",i=m++;k[i]="^"+r+"$";var t=m++;k[t]="((?:<|>)?=?)";var s=m++;k[s]=k[E]+"|x|X|\\*";var o=m++;k[o]=k[S]+"|x|X|\\*";var c=m++;k[c]="[v=\\s]*("+k[o]+")(?:\\.("+k[o]+")(?:\\.("+k[o]+")(?:"+k[h]+")?"+k[w]+"?)?)?";var y=m++;k[y]="[v=\\s]*("+k[s]+")(?:\\.("+k[s]+")(?:\\.("+k[s]+")(?:"+k[u]+")?"+k[w]+"?)?)?";var d=m++;k[d]="^"+k[t]+"\\s*"+k[c]+"$";var l=m++;k[l]="^"+k[t]+"\\s*"+k[y]+"$";var P=m++;k[P]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=m++;k[D]="(?:~>?)";var T=m++;k[T]="(\\s*)"+k[D]+"\\s+",C[T]=new RegExp(k[T],"g");var F=m++;k[F]="^"+k[D]+k[c]+"$";var H=m++;k[H]="^"+k[D]+k[y]+"$";var V=m++;k[V]="(?:\\^)";var W=m++;k[W]="(\\s*)"+k[V]+"\\s+",C[W]=new RegExp(k[W],"g");var x=m++;k[x]="^"+k[V]+k[c]+"$";var ee=m++;k[ee]="^"+k[V]+k[y]+"$";var X=m++;k[X]="^"+k[t]+"\\s*("+r+")$|^$";var _=m++;k[_]="^"+k[t]+"\\s*("+n+")$|^$";var q=m++;k[q]="(\\s*)"+k[t]+"\\s*("+r+"|"+k[c]+")",C[q]=new RegExp(k[q],"g");var G=m++;k[G]="^\\s*("+k[c]+")\\s+-\\s+("+k[c]+")\\s*$";var B=m++;k[B]="^\\s*("+k[y]+")\\s+-\\s+("+k[y]+")\\s*$";var ie=m++;k[ie]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)L(re,k[re]),C[re]||(C[re]=new RegExp(k[re]));function K(le,de){if(le instanceof Z)return le;if(typeof le!="string"||le.length>j||!(de?C[i]:C[I]).test(le))return null;try{return new Z(le,de)}catch{return null}}function Z(le,de){if(le instanceof Z){if(le.loose===de)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof Z))return new Z(le,de);L("SemVer",le,de),this.loose=de;var $e=le.trim().match(de?C[i]:C[I]);if(!$e)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<O)return Pe}return Se}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=K,e.valid=function(le,de){var $e=K(le,de);return $e?$e.version:null},e.clean=function(le,de){var $e=K(le.trim().replace(/^[=v]+/,""),de);return $e?$e.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(le){return L("SemVer.compare",this.version,this.loose,le),le instanceof Z||(le=new Z(le,this.loose)),this.compareMain(le)||this.comparePre(le)},Z.prototype.compareMain=function(le){return le instanceof Z||(le=new Z(le,this.loose)),g(this.major,le.major)||g(this.minor,le.minor)||g(this.patch,le.patch)},Z.prototype.comparePre=function(le){if(le instanceof Z||(le=new Z(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var de=0;do{var $e=this.prerelease[de],Se=le.prerelease[de];if(L("prerelease compare",de,$e,Se),$e===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if($e===void 0)return-1;if($e!==Se)return g($e,Se)}while(++de)},Z.prototype.inc=function(le,de){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,de,$e,Se){typeof $e=="string"&&(Se=$e,$e=void 0);try{return new Z(le,$e).inc(de,Se).version}catch{return null}},e.diff=function(le,de){if(z(le,de))return null;var $e=K(le),Se=K(de);if($e.prerelease.length||Se.prerelease.length){for(var Pe in $e)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&$e[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in $e)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&$e[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=g;var N=/^[0-9]+$/;function g(le,de){var $e=N.test(le),Se=N.test(de);return $e&&Se&&(le=+le,de=+de),$e&&!Se?-1:Se&&!$e?1:le<de?-1:le>de?1:0}function A(le,de,$e){return new Z(le,$e).compare(new Z(de,$e))}function U(le,de,$e){return A(le,de,$e)>0}function Q(le,de,$e){return A(le,de,$e)<0}function z(le,de,$e){return A(le,de,$e)===0}function J(le,de,$e){return A(le,de,$e)!==0}function te(le,de,$e){return A(le,de,$e)>=0}function oe(le,de,$e){return A(le,de,$e)<=0}function he(le,de,$e,Se){var Pe;switch(de){case"===":typeof le=="object"&&(le=le.version),typeof $e=="object"&&($e=$e.version),Pe=le===$e;break;case"!==":typeof le=="object"&&(le=le.version),typeof $e=="object"&&($e=$e.version),Pe=le!==$e;break;case"":case"=":case"==":Pe=z(le,$e,Se);break;case"!=":Pe=J(le,$e,Se);break;case">":Pe=U(le,$e,Se);break;case">=":Pe=te(le,$e,Se);break;case"<":Pe=Q(le,$e,Se);break;case"<=":Pe=oe(le,$e,Se);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function fe(le,de){if(le instanceof fe){if(le.loose===de)return le;le=le.value}if(!(this instanceof fe))return new fe(le,de);L("comparator",le,de),this.loose=de,this.parse(le),this.semver===be?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(le,de){return g(de,le)},e.major=function(le,de){return new Z(le,de).major},e.minor=function(le,de){return new Z(le,de).minor},e.patch=function(le,de){return new Z(le,de).patch},e.compare=A,e.compareLoose=function(le,de){return A(le,de,!0)},e.rcompare=function(le,de,$e){return A(de,le,$e)},e.sort=function(le,de){return le.sort(function($e,Se){return e.compare($e,Se,de)})},e.rsort=function(le,de){return le.sort(function($e,Se){return e.rcompare($e,Se,de)})},e.gt=U,e.lt=Q,e.eq=z,e.neq=J,e.gte=te,e.lte=oe,e.cmp=he,e.Comparator=fe;var be={};function pe(le,de){if(le instanceof pe)return le.loose===de?le:new pe(le.raw,de);if(le instanceof fe)return new pe(le.value,de);if(!(this instanceof pe))return new pe(le,de);if(this.loose=de,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function Ee(le){return!le||le.toLowerCase()==="x"||le==="*"}function Ce(le,de,$e,Se,Pe,Me,Ie,qe,Ae,Fe,Te,Oe,se){return((de=Ee($e)?"":Ee(Se)?">="+$e+".0.0":Ee(Pe)?">="+$e+"."+Se+".0":">="+de)+" "+(qe=Ee(Ae)?"":Ee(Fe)?"<"+(+Ae+1)+".0.0":Ee(Te)?"<"+Ae+"."+(+Fe+1)+".0":Oe?"<="+Ae+"."+Fe+"."+Te+"-"+Oe:"<="+qe)).trim()}function Le(le,de){for(var $e=0;$e<le.length;$e++)if(!le[$e].test(de))return!1;if(de.prerelease.length){for($e=0;$e<le.length;$e++)if(L(le[$e].semver),le[$e].semver!==be&&le[$e].semver.prerelease.length>0){var Se=le[$e].semver;if(Se.major===de.major&&Se.minor===de.minor&&Se.patch===de.patch)return!0}return!1}return!0}function Ue(le,de,$e){try{de=new pe(de,$e)}catch{return!1}return de.test(le)}function Ge(le,de,$e,Se){var Pe,Me,Ie,qe,Ae;switch(le=new Z(le,Se),de=new pe(de,Se),$e){case">":Pe=U,Me=oe,Ie=Q,qe=">",Ae=">=";break;case"<":Pe=Q,Me=te,Ie=U,qe="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(le,de,Se))return!1;for(var Fe=0;Fe<de.set.length;++Fe){var Te=de.set[Fe],Oe=null,se=null;if(Te.forEach(function(ue){ue.semver===be&&(ue=new fe(">=0.0.0")),Oe=Oe||ue,se=se||ue,Pe(ue.semver,Oe.semver,Se)?Oe=ue:Ie(ue.semver,se.semver,Se)&&(se=ue)}),Oe.operator===qe||Oe.operator===Ae||(!se.operator||se.operator===qe)&&Me(le,se.semver)||se.operator===Ae&&Ie(le,se.semver))return!1}return!0}fe.prototype.parse=function(le){var de=this.loose?C[X]:C[_],$e=le.match(de);if(!$e)throw new TypeError("Invalid comparator: "+le);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new Z($e[2],this.loose):this.semver=be},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(le){return L("Comparator.test",le,this.loose),this.semver===be||(typeof le=="string"&&(le=new Z(le,this.loose)),he(le,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(le,de){if(!(le instanceof fe))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new pe(le.value,de),Ue(this.value,$e,de);if(le.operator==="")return $e=new pe(this.value,de),Ue(le.semver,$e,de);var Se=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Me=this.semver.version===le.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),qe=he(this.semver,"<",le.semver,de)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Ae=he(this.semver,">",le.semver,de)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Se||Pe||Me&&Ie||qe||Ae},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(le){var de=this.loose;le=le.trim(),L("range",le,de);var $e=de?C[B]:C[G];le=le.replace($e,Ce),L("hyphen replace",le),le=le.replace(C[q],"$1$2$3"),L("comparator trim",le,C[q]),le=(le=(le=le.replace(C[T],"$1~")).replace(C[W],"$1^")).split(/\s+/).join(" ");var Se=de?C[X]:C[_],Pe=le.split(" ").map(function(Me){return function(Ie,qe){return L("comp",Ie),Ie=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(Te){return function(Oe,se){L("caret",Oe,se);var ue=se?C[ee]:C[x];return Oe.replace(ue,function(ge,me,ye,ke,Re){var De;return L("caret",Oe,ge,me,ye,ke,Re),Ee(me)?De="":Ee(ye)?De=">="+me+".0.0 <"+(+me+1)+".0.0":Ee(ke)?De=me==="0"?">="+me+"."+ye+".0 <"+me+"."+(+ye+1)+".0":">="+me+"."+ye+".0 <"+(+me+1)+".0.0":Re?(L("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),De=me==="0"?ye==="0"?">="+me+"."+ye+"."+ke+Re+" <"+me+"."+ye+"."+(+ke+1):">="+me+"."+ye+"."+ke+Re+" <"+me+"."+(+ye+1)+".0":">="+me+"."+ye+"."+ke+Re+" <"+(+me+1)+".0.0"):(L("no pr"),De=me==="0"?ye==="0"?">="+me+"."+ye+"."+ke+" <"+me+"."+ye+"."+(+ke+1):">="+me+"."+ye+"."+ke+" <"+me+"."+(+ye+1)+".0":">="+me+"."+ye+"."+ke+" <"+(+me+1)+".0.0"),L("caret return",De),De})}(Te,Fe)}).join(" ")}(Ie,qe),L("caret",Ie),Ie=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(Te){return function(Oe,se){var ue=se?C[H]:C[F];return Oe.replace(ue,function(ge,me,ye,ke,Re){var De;return L("tilde",Oe,ge,me,ye,ke,Re),Ee(me)?De="":Ee(ye)?De=">="+me+".0.0 <"+(+me+1)+".0.0":Ee(ke)?De=">="+me+"."+ye+".0 <"+me+"."+(+ye+1)+".0":Re?(L("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),De=">="+me+"."+ye+"."+ke+Re+" <"+me+"."+(+ye+1)+".0"):De=">="+me+"."+ye+"."+ke+" <"+me+"."+(+ye+1)+".0",L("tilde return",De),De})}(Te,Fe)}).join(" ")}(Ie,qe),L("tildes",Ie),Ie=function(Ae,Fe){return L("replaceXRanges",Ae,Fe),Ae.split(/\s+/).map(function(Te){return function(Oe,se){Oe=Oe.trim();var ue=se?C[l]:C[d];return Oe.replace(ue,function(ge,me,ye,ke,Re,De){L("xRange",Oe,ge,me,ye,ke,Re,De);var Be=Ee(ye),je=Be||Ee(ke),ze=je||Ee(Re);return me==="="&&ze&&(me=""),Be?ge=me===">"||me==="<"?"<0.0.0":"*":me&&ze?(je&&(ke=0),ze&&(Re=0),me===">"?(me=">=",je?(ye=+ye+1,ke=0,Re=0):ze&&(ke=+ke+1,Re=0)):me==="<="&&(me="<",je?ye=+ye+1:ke=+ke+1),ge=me+ye+"."+ke+"."+Re):je?ge=">="+ye+".0.0 <"+(+ye+1)+".0.0":ze&&(ge=">="+ye+"."+ke+".0 <"+ye+"."+(+ke+1)+".0"),L("xRange return",ge),ge})}(Te,Fe)}).join(" ")}(Ie,qe),L("xrange",Ie),Ie=function(Ae,Fe){return L("replaceStars",Ae,Fe),Ae.trim().replace(C[ie],"")}(Ie,qe),L("stars",Ie),Ie}(Me,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Me){return!!Me.match(Se)})),Pe=Pe.map(function(Me){return new fe(Me,de)})},pe.prototype.intersects=function(le,de){if(!(le instanceof pe))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Se){return le.set.some(function(Pe){return Pe.every(function(Me){return Se.intersects(Me,de)})})})})},e.toComparators=function(le,de){return new pe(le,de).set.map(function($e){return $e.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new Z(le,this.loose));for(var de=0;de<this.set.length;de++)if(Le(this.set[de],le))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(le,de,$e){var Se=null,Pe=null;try{var Me=new pe(de,$e)}catch{return null}return le.forEach(function(Ie){Me.test(Ie)&&(Se&&Pe.compare(Ie)!==-1||(Pe=new Z(Se=Ie,$e)))}),Se},e.minSatisfying=function(le,de,$e){var Se=null,Pe=null;try{var Me=new pe(de,$e)}catch{return null}return le.forEach(function(Ie){Me.test(Ie)&&(Se&&Pe.compare(Ie)!==1||(Pe=new Z(Se=Ie,$e)))}),Se},e.validRange=function(le,de){try{return new pe(le,de).range||"*"}catch{return null}},e.ltr=function(le,de,$e){return Ge(le,de,"<",$e)},e.gtr=function(le,de,$e){return Ge(le,de,">",$e)},e.outside=Ge,e.prerelease=function(le,de){var $e=K(le,de);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(le,de,$e){return le=new pe(le,$e),de=new pe(de,$e),le.intersects(de)},e.coerce=function(le){if(le instanceof Z)return le;if(typeof le!="string")return null;var de=le.match(C[P]);return de==null?null:K((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,R(1))},function(ne,e){var R,M,L=ne.exports={};function j(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function C(a){if(R===setTimeout)return setTimeout(a,0);if((R===j||!R)&&setTimeout)return R=setTimeout,setTimeout(a,0);try{return R(a,0)}catch{try{return R.call(null,a,0)}catch{return R.call(this,a,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:j}catch{R=j}try{M=typeof clearTimeout=="function"?clearTimeout:O}catch{M=O}})();var k,m=[],S=!1,E=-1;function b(){S&&k&&(S=!1,k.length?m=k.concat(m):E=-1,m.length&&f())}function f(){if(!S){var a=C(b);S=!0;for(var h=m.length;h;){for(k=m,m=[];++E<h;)k&&k[E].run();E=-1,h=m.length}k=null,S=!1,function(u){if(M===clearTimeout)return clearTimeout(u);if((M===O||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(u);try{M(u)}catch{try{return M.call(null,u)}catch{return M.call(this,u)}}}(a)}}function $(a,h){this.fun=a,this.array=h}function v(){}L.nextTick=function(a){var h=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)h[u-1]=arguments[u];m.push(new $(a,h)),m.length!==1||S||C(f)},$.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=v,L.addListener=v,L.once=v,L.off=v,L.removeListener=v,L.removeAllListeners=v,L.emit=v,L.prependListener=v,L.prependOnceListener=v,L.listeners=function(a){return[]},L.binding=function(a){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(a){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ae[123],ce([0,1]),function(ne,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class M{constructor(C,k,m){this.level=C,this.key=k,this.value=m,this.forward=[]}}const L=void 0;class j{constructor(C,k=2**16){this.comparator=C,this[R]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new M(this.c,L,L)}get size(){return this.f}clear(){this.e=new M(this.c,L,L)}has(C){return!!j.g(this,C,this.comparator)}get(C){return j.g(this,C,this.comparator)?.value}set(C,k){return j.h(this,C,k,this.comparator)&&(this.f+=1),this}delete(C){const k=j.k(this,C,this.comparator);return k&&(this.f-=1),k}forEach(C,k){let m=this.e.forward[0];for(;m;)C.call(k,m.value,m.key,this),m=m.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this.e.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this.e.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this.e.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",k=this.e.forward[0];for(;k;)C+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return C}static g(C,k,m){let S=C.e;for(let E=C.d-1;E>=0;E--)for(;S.forward[E]&&m(S.forward[E].key,k)<0;)S=S.forward[E];if(S=S.forward[0],S&&m(S.key,k)===0)return S}static h(C,k,m,S){const E=[];let b=C.e;for(let f=C.d-1;f>=0;f--){for(;b.forward[f]&&S(b.forward[f].key,k)<0;)b=b.forward[f];E[f]=b}if(b=b.forward[0],b&&S(b.key,k)===0)return b.value=m,!1;{const f=j.j(C);if(f>C.d){for(let $=C.d;$<f;$++)E[$]=C.e;C.d=f}b=new M(f,k,m);for(let $=0;$<f;$++)b.forward[$]=E[$].forward[$],E[$].forward[$]=b;return!0}}static j(C,k=.5){let m=1;for(;Math.random()<k&&m<C.c;)m+=1;return m}static k(C,k,m){const S=[];let E=C.e;for(let b=C.d-1;b>=0;b--){for(;E.forward[b]&&m(E.forward[b].key,k)<0;)E=E.forward[b];S[b]=E}if(E=E.forward[0],!E||m(E.key,k)!==0)return!1;for(let b=0;b<C.d&&S[b].forward[b]===E;b++)S[b].forward[b]=E.forward[b];for(;C.d>0&&C.e.forward[C.d-1]===L;)C.d-=1;return!0}}e.$0q=j}),define(ae[87],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;const R=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(j){return new M(j)}constructor(j){this.c=R&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$1c=M}),define(ae[3],ce([0,1,7,82,2,85,87]),function(ne,e,R,M,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.Event=void 0;const C=!1,k=!1;var m;(function(y){y.None=()=>L.$kb.None;function d(z){if(k){const{onDidAddListener:J}=z,te=$.create();let oe=0;z.onDidAddListener=()=>{++oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),te.print()),J?.()}}}function l(z,J){return ee(z,()=>{},0,void 0,!0,void 0,J)}y.defer=l;function P(z){return(J,te=null,oe)=>{let he=!1,fe;return fe=z(be=>{if(!he)return fe?fe.dispose():he=!0,J.call(te,be)},null,oe),he&&fe.dispose(),fe}}y.once=P;function D(z,J,te){return x((oe,he=null,fe)=>z(be=>oe.call(he,J(be)),null,fe),te)}y.map=D;function T(z,J,te){return x((oe,he=null,fe)=>z(be=>{J(be),oe.call(he,be)},null,fe),te)}y.forEach=T;function F(z,J,te){return x((oe,he=null,fe)=>z(be=>J(be)&&oe.call(he,be),null,fe),te)}y.filter=F;function H(z){return z}y.signal=H;function V(...z){return(J,te=null,oe)=>(0,L.$hb)(...z.map(he=>he(fe=>J.call(te,fe),null,oe)))}y.any=V;function W(z,J,te,oe){let he=te;return D(z,fe=>(he=J(he,fe),he),oe)}y.reduce=W;function x(z,J){let te;const oe={onWillAddFirstListener(){te=z(he.fire,he)},onDidRemoveLastListener(){te?.dispose()}};J||d(oe);const he=new p(oe);return J?.add(he),he.event}function ee(z,J,te=100,oe=!1,he=!1,fe,be){let pe,Ee,Ce,Le=0,Ue;const Ge={leakWarningThreshold:fe,onWillAddFirstListener(){pe=z(de=>{Le++,Ee=J(Ee,de),oe&&!Ce&&(le.fire(Ee),Ee=void 0),Ue=()=>{const $e=Ee;Ee=void 0,Ce=void 0,(!oe||Le>1)&&le.fire($e),Le=0},typeof te=="number"?(clearTimeout(Ce),Ce=setTimeout(Ue,te)):Ce===void 0&&(Ce=0,queueMicrotask(Ue))})},onWillRemoveListener(){he&&Le>0&&Ue?.()},onDidRemoveLastListener(){Ue=void 0,pe.dispose()}};be||d(Ge);const le=new p(Ge);return be?.add(le),le.event}y.debounce=ee;function X(z,J=0,te){return y.debounce(z,(oe,he)=>oe?(oe.push(he),oe):[he],J,void 0,!0,void 0,te)}y.accumulate=X;function _(z,J=(oe,he)=>oe===he,te){let oe=!0,he;return F(z,fe=>{const be=oe||!J(fe,he);return oe=!1,he=fe,be},te)}y.latch=_;function q(z,J,te){return[y.filter(z,J,te),y.filter(z,oe=>!J(oe),te)]}y.split=q;function G(z,J=!1,te=[]){let oe=te.slice(),he=z(pe=>{oe?oe.push(pe):be.fire(pe)});const fe=()=>{oe?.forEach(pe=>be.fire(pe)),oe=null},be=new p({onWillAddFirstListener(){he||(he=z(pe=>be.fire(pe)))},onDidAddFirstListener(){oe&&(J?setTimeout(fe):fe())},onDidRemoveLastListener(){he&&he.dispose(),he=null}});return be.event}y.buffer=G;class B{constructor(J){this.event=J,this.d=new L.$jb}map(J){return new B(D(this.event,J,this.d))}forEach(J){return new B(T(this.event,J,this.d))}filter(J){return new B(F(this.event,J,this.d))}reduce(J,te){return new B(W(this.event,J,te,this.d))}latch(){return new B(_(this.event,void 0,this.d))}debounce(J,te=100,oe=!1,he=!1,fe){return new B(ee(this.event,J,te,oe,he,fe,this.d))}on(J,te,oe){return this.event(J,te,oe)}once(J,te,oe){return P(this.event)(J,te,oe)}dispose(){this.d.dispose()}}function ie(z){return new B(z)}y.chain=ie;function re(z,J,te=oe=>oe){const oe=(...pe)=>be.fire(te(...pe)),he=()=>z.on(J,oe),fe=()=>z.removeListener(J,oe),be=new p({onWillAddFirstListener:he,onDidRemoveLastListener:fe});return be.event}y.fromNodeEventEmitter=re;function K(z,J,te=oe=>oe){const oe=(...pe)=>be.fire(te(...pe)),he=()=>z.addEventListener(J,oe),fe=()=>z.removeEventListener(J,oe),be=new p({onWillAddFirstListener:he,onDidRemoveLastListener:fe});return be.event}y.fromDOMEventEmitter=K;function Z(z){return new Promise(J=>P(z)(J))}y.toPromise=Z;function N(z,J){return J(void 0),z(te=>J(te))}y.runAndSubscribe=N;function g(z,J){let te=null;function oe(fe){te?.dispose(),te=new L.$jb,J(fe,te)}oe(void 0);const he=z(fe=>oe(fe));return(0,L.$ib)(()=>{he.dispose(),te?.dispose()})}y.runAndSubscribeWithStore=g;class A{constructor(J,te){this._observable=J,this.d=0,this.f=!1;const oe={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};te||d(oe),this.emitter=new p(oe),te&&te.add(this.emitter)}beginUpdate(J){this.d++}handlePossibleChange(J){}handleChange(J,te){this.f=!0}endUpdate(J){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function U(z,J){return new A(z,J).emitter.event}y.fromObservable=U;function Q(z){return J=>{let te=0,oe=!1;const he={beginUpdate(){te++},endUpdate(){te--,te===0&&(z.reportChanges(),oe&&(oe=!1,J()))},handlePossibleChange(){},handleChange(){oe=!0}};return z.addObserver(he),{dispose(){z.removeObserver(he)}}}}y.fromObservableLight=Q})(m||(e.Event=m={}));class S{constructor(d){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${d}_${S.d++}`,S.all.add(this)}start(d){this.f=new O.$1c,this.listenerCount=d}stop(){if(this.f){const d=this.f.elapsed();this.durations.push(d),this.elapsedOverall+=d,this.invocationCount+=1,this.f=void 0}}}e.$3c=S,S.all=new Set,S.d=0;let E=-1;function b(y){const d=E;return E=y,{dispose(){E=d}}}e.$4c=b;class f{constructor(d,l=Math.random().toString(18).slice(2,5)){this.threshold=d,this.name=l,this.f=0}dispose(){this.d?.clear()}check(d,l){const P=this.threshold;if(P<=0||l<P)return;this.d||(this.d=new Map);const D=this.d.get(d.value)||0;if(this.d.set(d.value,D+1),this.f-=1,this.f<=0){this.f=P*.5;let T,F=0;for(const[H,V]of this.d)(!T||F<V)&&(T=H,F=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${F}):`),console.warn(T)}return()=>{const T=this.d.get(d.value)||0;this.d.set(d.value,T-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(d){this.value=d}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class a{constructor(d){this.value=d,this.id=v++}}const h=2,u=(y,d)=>{if(y instanceof a)d(y);else for(let l=0;l<y.length;l++){const P=y[l];P&&d(P)}};class p{constructor(d){this.u=0,this.d=d,this.f=E>0||this.d?.leakWarningThreshold?new f(this.d?.leakWarningThreshold??E):void 0,this.g=this.d?._profName?new S(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(C){const d=this.q;queueMicrotask(()=>{u(d,l=>l.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(d,l,P)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$kb.None;if(this.j)return L.$kb.None;l&&(d=d.bind(l));const D=new a(d);let T,F;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(D.stack=$.create(),T=this.f.check(D.stack,this.u+1)),C&&(D.stack=F??$.create()),this.q?this.q instanceof a?(this.t??=new I,this.q=[this.q,D]):this.q.push(D):(this.d?.onWillAddFirstListener?.(this),this.q=D,this.d?.onDidAddFirstListener?.(this)),this.u++;const H=(0,L.$ib)(()=>{T?.(),this.v(D)});return P instanceof L.$jb?P.add(H):Array.isArray(P)&&P.push(H),H},this.m}v(d){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const l=this.q,P=l.indexOf(d);if(P===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,l[P]=void 0;const D=this.t.current===this;if(this.u*h<=l.length){let T=0;for(let F=0;F<l.length;F++)l[F]?l[T++]=l[F]:D&&(this.t.end--,T<this.t.i&&this.t.i--);l.length=T}}w(d,l){if(!d)return;const P=this.d?.onListenerError||R.$X;if(!P){d.value(l);return}try{d.value(l)}catch(D){P(D)}}x(d){const l=d.current.q;for(;d.i<d.end;)this.w(l[d.i++],d.value);d.reset()}fire(d){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof a)this.w(this.q,d);else{const l=this.t;l.enqueue(this,d,this.q.length),this.x(l)}this.g?.stop()}hasListeners(){return this.u>0}}e.$5c=p;const w=()=>new I;e.$6c=w;class I{constructor(){this.i=-1,this.end=0}enqueue(d,l,P){this.i=0,this.end=P,this.current=d,this.value=l}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends p{async fireAsync(d,l,P){if(this.q)for(this.h||(this.h=new j.$jc),u(this.q,D=>this.h.push([D.value,d]));this.h.size>0&&!l.isCancellationRequested;){const[D,T]=this.h.shift(),F=[],H={...T,token:l,waitUntil:V=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");P&&(V=P(V,D)),F.push(V)}};try{D(H)}catch(V){(0,R.$X)(V);continue}Object.freeze(F),await Promise.allSettled(F).then(V=>{for(const W of V)W.status==="rejected"&&(0,R.$X)(W.reason)})}}}e.$7c=n;class r extends p{get isPaused(){return this.h!==0}constructor(d){super(d),this.h=0,this.s=new j.$jc,this.y=d?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const d=Array.from(this.s);this.s.clear(),super.fire(this.y(d))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(d){this.u&&(this.h!==0?this.s.push(d):super.fire(d))}}e.$8c=r;class i extends r{constructor(d){super(d),this.k=d.delay??100}fire(d){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(d)}}e.$9c=i;class t extends p{constructor(d){super(d),this.h=[],this.k=d?.merge}fire(d){this.hasListeners()&&(this.h.push(d),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(l=>super.fire(l)),this.h=[]}))}}e.$0c=t;class s{constructor(){this.f=!1,this.g=[],this.d=new p({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(d){const l={event:d,listener:null};this.g.push(l),this.f&&this.k(l);const P=()=>{this.f&&this.m(l);const D=this.g.indexOf(l);this.g.splice(D,1)};return(0,L.$ib)((0,M.$bb)(P))}h(){this.f=!0,this.g.forEach(d=>this.k(d))}j(){this.f=!1,this.g.forEach(d=>this.m(d))}k(d){d.listener=d.event(l=>this.d.fire(l))}m(d){d.listener&&d.listener.dispose(),d.listener=null}dispose(){this.d.dispose()}}e.$$c=s;class o{constructor(){this.d=[]}wrapEvent(d){return(l,P,D)=>d(T=>{const F=this.d[this.d.length-1];F?F.push(()=>l.call(P,T)):l.call(P,T)},void 0,D)}bufferEvents(d){const l=[];this.d.push(l);const P=d();return this.d.pop(),l.forEach(D=>D()),P}}e.$_c=o;class c{constructor(){this.d=!1,this.f=m.None,this.g=L.$kb.None,this.h=new p({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(d){this.f=d,this.d&&(this.g.dispose(),this.g=d(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$ad=c}),define(ae[26],ce([0,1,3]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=e.CancellationToken=void 0;const M=Object.freeze(function(C,k){const m=setTimeout(C.bind(k),0);return{dispose(){clearTimeout(m)}}});var L;(function(C){function k(m){return m===C.None||m===C.Cancelled||m instanceof j?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}C.isCancellationToken=k,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(L||(e.CancellationToken=L={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new R.$5c),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(k){this.a=void 0,this.b=void 0,this.b=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new j),this.a}cancel(){this.a?this.a instanceof j&&this.a.cancel():this.a=L.Cancelled}dispose(k=!1){k&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof j&&this.a.dispose():this.a=L.None}}e.$bd=O}),define(ae[124],ce([0,1,26]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ed=e.$dd=e.$cd=void 0;class M{constructor(C){this.b=C,this.a=null}get(){if(this.a)return this.a;const C=new R.$bd,k=this.b(C.token);return this.a={promise:k,dispose:()=>{this.a=null,C.cancel(),C.dispose()}},this.a}}e.$cd=M;class L{constructor(C){this.c=C,this.a=void 0,this.b=void 0}get(C){const k=JSON.stringify(C);return this.b!==k&&(this.b=k,this.a=this.c(C)),this.a}}e.$dd=L;class j{get cachedValues(){return this.a}constructor(C){this.b=C,this.a=new Map}get(C){if(this.a.has(C))return this.a.get(C);const k=this.b(C);return this.a.set(C,k),k}}e.$ed=j}),define(ae[42],ce([0,1,7,2]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=void 0;function L(w){const I=w;return I?typeof I.read=="function":!1}e.$tb=L;function j(w){const I=w;return I?[I.on,I.pause,I.resume,I.destroy].every(n=>typeof n=="function"):!1}e.$ub=j;function O(w){const I=w;return I?j(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.$vb=O;function C(w,I){return new k(w,I)}e.$wb=C;class k{constructor(I,n){this.e=I,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(I){if(!this.a.destroyed){if(this.a.flowing)this.g(I);else if(this.b.data.push(I),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(I){this.a.destroyed||(this.a.flowing?this.h(I):this.b.error.push(I))}end(I){this.a.destroyed||(typeof I<"u"&&this.write(I),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(I){this.c.data.slice(0).forEach(n=>n(I))}h(I){this.c.error.length===0?(0,R.$X)(I):this.c.error.slice(0).forEach(n=>n(I))}i(){this.c.end.slice(0).forEach(I=>I())}on(I,n){if(!this.a.destroyed)switch(I){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(I,n){if(this.a.destroyed)return;let r;switch(I){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const i=r.indexOf(n);i>=0&&r.splice(i,1)}}j(){if(this.b.data.length>0){const I=this.e(this.b.data);this.g(I),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const I of this.b.error)this.h(I);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(w,I){const n=[];let r;for(;(r=w.read())!==null;)n.push(r);return I(n)}e.$xb=m;function S(w,I,n){const r=[];let i;for(;(i=w.read())!==null&&r.length<n;)r.push(i);return i===null&&r.length>0?I(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const t=i;return i=void 0,t}return w.read()}}}e.$yb=S;function E(w,I){return new Promise((n,r)=>{const i=[];b(w,{onData:t=>{I&&i.push(t)},onError:t=>{I?r(t):n(void 0)},onEnd:()=>{n(I?I(i):void 0)}})})}e.$zb=E;function b(w,I){let n=!1;return w.on("error",r=>{n||I.onError(r)}),w.on("end",()=>{n||I.onEnd()}),w.on("data",r=>{n||I.onData(r)}),(0,M.$ib)(()=>n=!0)}e.$Ab=b;function f(w,I){return new Promise((n,r)=>{const i=new M.$jb,t=[],s=y=>{if(t.push(y),t.length>I)return i.dispose(),w.pause(),n({stream:w,buffer:t,ended:!1})},o=y=>r(y),c=()=>n({stream:w,buffer:t,ended:!0});i.add((0,M.$ib)(()=>w.removeListener("error",o))),w.on("error",o),i.add((0,M.$ib)(()=>w.removeListener("end",c))),w.on("end",c),i.add((0,M.$ib)(()=>w.removeListener("data",s))),w.on("data",s)})}e.$Bb=f;function $(w,I){const n=C(I);return n.end(w),n}e.$Cb=$;function v(){const w=C(()=>{throw new Error("not supported")});return w.end(),w}e.$Db=v;function a(w){let I=!1;return{read:()=>I?null:(I=!0,w)}}e.$Eb=a;function h(w,I,n){const r=C(n);return b(w,{onData:i=>r.write(I.data(i)),onError:i=>r.error(I.error?I.error(i):i),onEnd:()=>r.end()}),r}e.$Fb=h;function u(w,I,n){let r=!1;return{read:()=>{const i=I.read();return r?i:(r=!0,i!==null?n([w,i]):w)}}}e.$Gb=u;function p(w,I,n){let r=!1;const i=C(n);return b(I,{onData:t=>r?i.write(t):(r=!0,i.write(n([w,t]))),onError:t=>i.error(t),onEnd:()=>{r||(r=!0,i.write(w)),i.end()}}),i}e.$Hb=p}),define(ae[16],ce([0,1,84,42]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=void 0;const L=typeof Buffer<"u",j=new R.$S(()=>new Uint8Array(256));let O,C;class k{static alloc(l){return L?new k(Buffer.allocUnsafe(l)):new k(new Uint8Array(l))}static wrap(l){return L&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new k(l)}static fromString(l,P){return!(P?.dontUseNodeBuffer||!1)&&L?new k(Buffer.from(l)):(O||(O=new TextEncoder),new k(O.encode(l)))}static fromByteArray(l){const P=k.alloc(l.length);for(let D=0,T=l.length;D<T;D++)P.buffer[D]=l[D];return P}static concat(l,P){if(typeof P>"u"){P=0;for(let F=0,H=l.length;F<H;F++)P+=l[F].byteLength}const D=k.alloc(P);let T=0;for(let F=0,H=l.length;F<H;F++){const V=l[F];D.set(V,T),T+=V.byteLength}return D}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=k.alloc(this.byteLength);return l.set(this),l}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(l,P){return new k(this.buffer.subarray(l,P))}set(l,P){if(l instanceof k)this.buffer.set(l.buffer,P);else if(l instanceof Uint8Array)this.buffer.set(l,P);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),P);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return E(this.buffer,l)}writeUInt32BE(l,P){b(this.buffer,l,P)}readUInt32LE(l){return f(this.buffer,l)}writeUInt32LE(l,P){$(this.buffer,l,P)}readUInt8(l){return v(this.buffer,l)}writeUInt8(l,P){a(this.buffer,l,P)}indexOf(l){const P=l instanceof k?l.buffer:l,D=P.byteLength,T=this.buffer,F=T.byteLength;if(D===0)return 0;if(D===1)return T.indexOf(P[0]);if(D>F)return-1;const H=j.value;H.fill(P.length);for(let ee=0;ee<P.length;ee++)H[P[ee]]=P.length-ee-1;let V=P.length-1,W=V,x=-1;for(;V<F;)if(T[V]===P[W]){if(W===0){x=V;break}V--,W--}else V+=Math.max(P.length-W,H[T[V]]),W=P.length-1;return x}}e.$Ib=k;function m(d,l){return d[l+0]<<0>>>0|d[l+1]<<8>>>0}e.$Jb=m;function S(d,l,P){d[P+0]=l&255,l=l>>>8,d[P+1]=l&255}e.$Kb=S;function E(d,l){return d[l]*2**24+d[l+1]*2**16+d[l+2]*2**8+d[l+3]}e.$Lb=E;function b(d,l,P){d[P+3]=l,l=l>>>8,d[P+2]=l,l=l>>>8,d[P+1]=l,l=l>>>8,d[P]=l}e.$Mb=b;function f(d,l){return d[l+0]<<0>>>0|d[l+1]<<8>>>0|d[l+2]<<16>>>0|d[l+3]<<24>>>0}e.$Nb=f;function $(d,l,P){d[P+0]=l&255,l=l>>>8,d[P+1]=l&255,l=l>>>8,d[P+2]=l&255,l=l>>>8,d[P+3]=l&255}e.$Ob=$;function v(d,l){return d[l]}e.$Pb=v;function a(d,l,P){d[P]=l}e.$Qb=a;function h(d){return M.$xb(d,l=>k.concat(l))}e.$Rb=h;function u(d){return M.$Eb(d)}e.$Sb=u;function p(d){return M.$zb(d,l=>k.concat(l))}e.$Tb=p;async function w(d){return d.ended?k.concat(d.buffer):k.concat([...d.buffer,await p(d.stream)])}e.$Ub=w;function I(d){return M.$Cb(d,l=>k.concat(l))}e.$Vb=I;function n(d){return M.$Fb(d,{data:l=>typeof l=="string"?k.fromString(l):k.wrap(l)},l=>k.concat(l))}e.$Wb=n;function r(d){return M.$wb(l=>k.concat(l),d)}e.$Xb=r;function i(d,l){return M.$Gb(d,l,P=>k.concat(P))}e.$Yb=i;function t(d,l){return M.$Hb(d,l,P=>k.concat(P))}e.$Zb=t;function s(d){let l=0,P=0,D=0;const T=new Uint8Array(Math.floor(d.length/4*3)),F=V=>{switch(P){case 3:T[D++]=l|V,P=0;break;case 2:T[D++]=l|V>>>2,l=V<<6,P=3;break;case 1:T[D++]=l|V>>>4,l=V<<4,P=2;break;default:l=V<<2,P=1}};for(let V=0;V<d.length;V++){const W=d.charCodeAt(V);if(W>=65&&W<=90)F(W-65);else if(W>=97&&W<=122)F(W-97+26);else if(W>=48&&W<=57)F(W-48+52);else if(W===43||W===45)F(62);else if(W===47||W===95)F(63);else{if(W===61)break;throw new SyntaxError(`Unexpected base64 character ${d[V]}`)}}const H=D;for(;P>0;)F(0);return k.wrap(T).slice(0,H)}e.$1b=s;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:d},l=!0,P=!1){const D=P?c:o;let T="";const F=d.byteLength%3;let H=0;for(;H<d.byteLength-F;H+=3){const V=d[H+0],W=d[H+1],x=d[H+2];T+=D[V>>>2],T+=D[(V<<4|W>>>4)&63],T+=D[(W<<2|x>>>6)&63],T+=D[x&63]}if(F===1){const V=d[H+0];T+=D[V>>>2],T+=D[V<<4&63],l&&(T+="==")}else if(F===2){const V=d[H+0],W=d[H+1];T+=D[V>>>2],T+=D[(V<<4|W>>>4)&63],T+=D[W<<2&63],l&&(T+="=")}return T}e.$2b=y}),define(ae[27],ce([0,1,124,84]),function(ne,e,R,M){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.GraphemeBreakType=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=void 0;function j(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.$hd=j;const O=/{(\d+)}/g;function C(se,...ue){return ue.length===0?se:se.replace(O,function(ge,me){const ye=parseInt(me,10);return isNaN(ye)||ye<0||ye>=ue.length?ge:ue[ye]})}e.$id=C;const k=/{([^}]+)}/g;function m(se,ue){return se.replace(k,(ge,me)=>ue[me]??ge)}e.$jd=m;function S(se){return se.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.$kd=S;function E(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$ld=E;function b(se,ue){let ge=0;const me=ue.charCodeAt(0);for(let ye=se.length-1;ye>=0;ye--)se.charCodeAt(ye)===me&&ge++;return ge}e.$md=b;function f(se,ue,ge="\u2026"){return se.length<=ue?se:`${se.substr(0,ue)}${ge}`}e.$nd=f;function $(se,ue=" "){const ge=v(se,ue);return a(ge,ue)}e.$od=$;function v(se,ue){if(!se||!ue)return se;const ge=ue.length;if(ge===0||se.length===0)return se;let me=0;for(;se.indexOf(ue,me)===me;)me=me+ge;return se.substring(me)}e.$pd=v;function a(se,ue){if(!se||!ue)return se;const ge=ue.length,me=se.length;if(ge===0||me===0)return se;let ye=me,ke=-1;for(;ke=se.lastIndexOf(ue,ye-1),!(ke===-1||ke+ge!==ye);){if(ke===0)return"";ye=ke}return se.substring(0,ye)}e.$qd=a;function h(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$rd=h;function u(se){return se.replace(/\*/g,"")}e.$sd=u;function p(se,ue,ge={}){if(!se)throw new Error("Cannot create regex from empty string");ue||(se=E(se)),ge.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let me="";return ge.global&&(me+="g"),ge.matchCase||(me+="i"),ge.multiline&&(me+="m"),ge.unicode&&(me+="u"),new RegExp(se,me)}e.$td=p;function w(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.$ud=w;function I(se){return!!se.match(/([^\\]|^)(\\\\)*\\\d+/)}e.$vd=I;function n(se){return(se.global?"g":"")+(se.ignoreCase?"i":"")+(se.multiline?"m":"")+(se.unicode?"u":"")}e.$wd=n;function r(se){return se.split(/\r\n|\r|\n/)}e.$xd=r;function i(se){for(let ue=0,ge=se.length;ue<ge;ue++){const me=se.charCodeAt(ue);if(me!==32&&me!==9)return ue}return-1}e.$yd=i;function t(se,ue=0,ge=se.length){for(let me=ue;me<ge;me++){const ye=se.charCodeAt(me);if(ye!==32&&ye!==9)return se.substring(ue,me)}return se.substring(ue,ge)}e.$zd=t;function s(se,ue=se.length-1){for(let ge=ue;ge>=0;ge--){const me=se.charCodeAt(ge);if(me!==32&&me!==9)return ge}return-1}e.$Ad=s;function o(se,ue,ge){const me=[];let ye=0;for(const ke of se.matchAll(ue)){if(me.push(se.slice(ye,ke.index)),ke.index===void 0)throw new Error("match.index should be defined");ye=ke.index+ke[0].length,me.push(ge(ke[0],...ke.slice(1),ke.index,se,ke.groups))}return me.push(se.slice(ye)),Promise.all(me).then(ke=>ke.join(""))}e.$Bd=o;function c(se,ue){return se<ue?-1:se>ue?1:0}e.$Cd=c;function y(se,ue,ge=0,me=se.length,ye=0,ke=ue.length){for(;ge<me&&ye<ke;ge++,ye++){const Be=se.charCodeAt(ge),je=ue.charCodeAt(ye);if(Be<je)return-1;if(Be>je)return 1}const Re=me-ge,De=ke-ye;return Re<De?-1:Re>De?1:0}e.$Dd=y;function d(se,ue){return l(se,ue,0,se.length,0,ue.length)}e.$Ed=d;function l(se,ue,ge=0,me=se.length,ye=0,ke=ue.length){for(;ge<me&&ye<ke;ge++,ye++){let Be=se.charCodeAt(ge),je=ue.charCodeAt(ye);if(Be===je)continue;if(Be>=128||je>=128)return y(se.toLowerCase(),ue.toLowerCase(),ge,me,ye,ke);D(Be)&&(Be-=32),D(je)&&(je-=32);const ze=Be-je;if(ze!==0)return ze}const Re=me-ge,De=ke-ye;return Re<De?-1:Re>De?1:0}e.$Fd=l;function P(se){return se>=48&&se<=57}e.$Gd=P;function D(se){return se>=97&&se<=122}e.$Hd=D;function T(se){return se>=65&&se<=90}e.$Id=T;function F(se,ue){return se.length===ue.length&&l(se,ue)===0}e.$Jd=F;function H(se,ue){const ge=ue.length;return ue.length>se.length?!1:l(se,ue,0,ge)===0}e.$Kd=H;function V(se,ue){const ge=Math.min(se.length,ue.length);let me;for(me=0;me<ge;me++)if(se.charCodeAt(me)!==ue.charCodeAt(me))return me;return ge}e.$Ld=V;function W(se,ue){const ge=Math.min(se.length,ue.length);let me;const ye=se.length-1,ke=ue.length-1;for(me=0;me<ge;me++)if(se.charCodeAt(ye-me)!==ue.charCodeAt(ke-me))return me;return ge}e.$Md=W;function x(se){return 55296<=se&&se<=56319}e.$Nd=x;function ee(se){return 56320<=se&&se<=57343}e.$Od=ee;function X(se,ue){return(se-55296<<10)+(ue-56320)+65536}e.$Pd=X;function _(se,ue,ge){const me=se.charCodeAt(ge);if(x(me)&&ge+1<ue){const ye=se.charCodeAt(ge+1);if(ee(ye))return X(me,ye)}return me}e.$Qd=_;function q(se,ue){const ge=se.charCodeAt(ue-1);if(ee(ge)&&ue>1){const me=se.charCodeAt(ue-2);if(x(me))return X(me,ge)}return ge}class G{get offset(){return this.e}constructor(ue,ge=0){this.c=ue,this.d=ue.length,this.e=ge}setOffset(ue){this.e=ue}prevCodePoint(){const ue=q(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=_(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.$Rd=G;class B{get offset(){return this.c.offset}constructor(ue,ge=0){this.c=new G(ue,ge)}nextGraphemeLength(){const ue=Pe.getInstance(),ge=this.c,me=ge.offset;let ye=ue.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const ke=ge.offset,Re=ue.getGraphemeBreakType(ge.nextCodePoint());if($e(ye,Re)){ge.setOffset(ke);break}ye=Re}return ge.offset-me}prevGraphemeLength(){const ue=Pe.getInstance(),ge=this.c,me=ge.offset;let ye=ue.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const ke=ge.offset,Re=ue.getGraphemeBreakType(ge.prevCodePoint());if($e(Re,ye)){ge.setOffset(ke);break}ye=Re}return me-ge.offset}eol(){return this.c.eol()}}e.$Sd=B;function ie(se,ue){return new B(se,ue).nextGraphemeLength()}e.$Td=ie;function re(se,ue){return new B(se,ue).prevGraphemeLength()}e.$Ud=re;function K(se,ue){ue>0&&ee(se.charCodeAt(ue))&&ue--;const ge=ue+ie(se,ue);return[ge-re(se,ge),ge]}e.$Vd=K;function Z(se){const ue=new B(se);let ge=0;for(;!ue.eol();)ge++,ue.nextGraphemeLength();return ge}e.$Wd=Z;let N;function g(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function A(se){return N||(N=g()),N.test(se)}e.$Xd=A;const U=/^[\t\n\r\x20-\x7E]*$/;function Q(se){return U.test(se)}e.$Yd=Q,e.$Zd=/[\u2028\u2029]/;function z(se){return e.$Zd.test(se)}e.$1d=z;function J(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.$2d=J;function te(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.$3d=te;function oe(se,ue){if(se.length<ue)return se;const ge=/\b/g;let me=0;for(;ge.test(se)&&!(se.length-ge.lastIndex<ue);)me=ge.lastIndex,ge.lastIndex+=1;return se.substring(me).replace(/^\s/,"")}e.$4d=oe;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,fe=/\x1b\].*?\x07/g;function be(se){return se&&(se=se.replace(he,"").replace(fe,"")),se}e.$5d=be,e.$6d=String.fromCharCode(65279);function pe(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.$7d=pe;function Ee(se){return pe(se)?se.substr(1):se}e.$8d=Ee;function Ce(se,ue){if(!se||!ue||se.length<ue.length)return!1;const ge=ue.length,me=se.toLowerCase();let ye=0,ke=-1;for(;ye<ge;){const Re=me.indexOf(ue[ye],ke+1);if(Re<0)return!1;ke=Re,ye++}return!0}e.$9d=Ce;function Le(se,ue=!1){return se?(ue&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.$0d=Le;function Ue(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.$$d=Ue;function Ge(se,ue=1){if(ue===0)return"";let ge=-1;do ge=se.indexOf(`
`,ge+1),ue--;while(ue>0&&ge>=0);return ge===-1?se:(se[ge-1]==="\r"&&ge--,se.substr(0,ge))}e.$_d=Ge;function le(se){return se=se%(2*26),se<26?String.fromCharCode(97+se):String.fromCharCode(65+se-26)}e.$ae=le;function de(se){return Pe.getInstance().getGraphemeBreakType(se)}e.$be=de;function $e(se,ue){return se===0?ue!==5&&ue!==7:se===2&&ue===3?!1:se===4||se===2||se===3||ue===4||ue===2||ue===3?!0:!(se===8&&(ue===8||ue===9||ue===11||ue===12)||(se===11||se===9)&&(ue===9||ue===10)||(se===12||se===10)&&ue===10||ue===5||ue===13||ue===7||se===1||se===13&&ue===14||se===6&&ue===6)}var Se;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Se||(e.GraphemeBreakType=Se={}));class Pe{static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=Me()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const ge=this.d,me=ge.length/3;let ye=1;for(;ye<=me;)if(ue<ge[3*ye])ye=2*ye;else if(ue>ge[3*ye+1])ye=2*ye+1;else return ge[3*ye+2];return 0}}Pe.c=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ie(se,ue){if(se===0)return 0;const ge=qe(se,ue);if(ge!==void 0)return ge;const me=new G(ue,se);return me.prevCodePoint(),me.offset}e.$ce=Ie;function qe(se,ue){const ge=new G(ue,se);let me=ge.prevCodePoint();for(;Ae(me)||me===65039||me===8419;){if(ge.offset===0)return;me=ge.prevCodePoint()}if(!te(me))return;let ye=ge.offset;return ye>0&&ge.prevCodePoint()===8205&&(ye=ge.offset),ye}function Ae(se){return 127995<=se&&se<=127999}var Fe;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.$de="\xA0";class Te{static getInstance(ue){return Te.d.get(Array.from(ue))}static getLocales(){return Te.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ee=Te,L=Te,Te.c=new M.$S(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Te.d=new R.$dd(se=>{function ue(je){const ze=new Map;for(let Ve=0;Ve<je.length;Ve+=2)ze.set(je[Ve],je[Ve+1]);return ze}function ge(je,ze){const Ve=new Map(je);for(const[_e,nt]of ze)Ve.set(_e,nt);return Ve}function me(je,ze){if(!je)return ze;const Ve=new Map;for(const[_e,nt]of je)ze.has(_e)&&Ve.set(_e,nt);return Ve}const ye=L.c.value;let ke=se.filter(je=>!je.startsWith("_")&&je in ye);ke.length===0&&(ke=["_default"]);let Re;for(const je of ke){const ze=ue(ye[je]);Re=me(Re,ze)}const De=ue(ye._common),Be=ge(De,Re);return new Te(Be)}),Te.e=new M.$S(()=>Object.keys(Te.c.value).filter(se=>!se.startsWith("_")));class Oe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Oe.c())),this.d}static isInvisibleCharacter(ue){return Oe.e().has(ue)}static get codePoints(){return Oe.e()}}e.$fe=Oe,Oe.d=void 0}),define(ae[61],ce([0,1,27]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=void 0;function M(h){return L(h,0)}e.$_h=M;function L(h,u){switch(typeof h){case"object":return h===null?j(349,u):Array.isArray(h)?k(h,u):m(h,u);case"string":return C(h,u);case"boolean":return O(h,u);case"number":return j(h,u);case"undefined":return j(937,u);default:return j(617,u)}}e.$ai=L;function j(h,u){return(u<<5)-u+h|0}e.$bi=j;function O(h,u){return j(h?433:863,u)}function C(h,u){u=j(149417,u);for(let p=0,w=h.length;p<w;p++)u=j(h.charCodeAt(p),u);return u}e.$ci=C;function k(h,u){return u=j(104579,u),h.reduce((p,w)=>L(w,p),u)}function m(h,u){return u=j(181387,u),Object.keys(h).sort().reduce((p,w)=>(p=C(w,p),L(h[w],p)),u)}class S{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=L(u,this.g),this.g}}e.$di=S;var E;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function b(h,u,p=32){const w=p-u,I=~((1<<w)-1);return(h<<u|(I&h)>>>w)>>>0}function f(h,u=0,p=h.byteLength,w=0){for(let I=0;I<p;I++)h[u+I]=w}function $(h,u,p="0"){for(;h.length<u;)h=p+h;return h}function v(h,u=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(p=>p.toString(16).padStart(2,"0")).join(""):$((h>>>0).toString(16),u/4)}e.$ei=v;class a{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const p=u.length;if(p===0)return;const w=this.p;let I=this.r,n=this.u,r,i;for(n!==0?(r=n,i=-1,n=0):(r=u.charCodeAt(0),i=0);;){let t=r;if(R.$Nd(r))if(i+1<p){const s=u.charCodeAt(i+1);R.$Od(s)?(i++,t=R.$Pd(r,s)):t=65533}else{n=r;break}else R.$Od(r)&&(t=65533);if(I=this.w(w,I,t),i++,i<p)r=u.charCodeAt(i);else break}this.r=I,this.u=n}w(u,p,w){return w<128?u[p++]=w:w<2048?(u[p++]=192|(w&1984)>>>6,u[p++]=128|(w&63)>>>0):w<65536?(u[p++]=224|(w&61440)>>>12,u[p++]=128|(w&4032)>>>6,u[p++]=128|(w&63)>>>0):(u[p++]=240|(w&1835008)>>>18,u[p++]=128|(w&258048)>>>12,u[p++]=128|(w&4032)>>>6,u[p++]=128|(w&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=a.g,p=this.q;for(let c=0;c<64;c+=4)u.setUint32(c,p.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)u.setUint32(c,b(u.getUint32(c-12,!1)^u.getUint32(c-32,!1)^u.getUint32(c-56,!1)^u.getUint32(c-64,!1),1),!1);let w=this.h,I=this.l,n=this.m,r=this.n,i=this.o,t,s,o;for(let c=0;c<80;c++)c<20?(t=I&n|~I&r,s=1518500249):c<40?(t=I^n^r,s=1859775393):c<60?(t=I&n|I&r|n&r,s=2400959708):(t=I^n^r,s=3395469782),o=b(w,5)+t+i+s+u.getUint32(c*4,!1)&4294967295,i=r,r=n,n=b(I,30),I=w,w=o;this.h=this.h+w&4294967295,this.l=this.l+I&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+i&4294967295}}e.$fi=a,a.g=new DataView(new ArrayBuffer(320))}),define(ae[88],ce([0,1,27]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(M||(M={})),function(L){const j="error",O="warning",C="warn",k="info",m="ignore";function S(b){return b?R.$Jd(j,b)?L.Error:R.$Jd(O,b)||R.$Jd(C,b)?L.Warning:R.$Jd(k,b)?L.Info:L.Ignore:L.Ignore}L.fromValue=S;function E(b){switch(b){case L.Error:return j;case L.Warning:return O;case L.Info:return k;default:return m}}L.toString=E}(M||(M={})),e.default=M}),define(ae[125],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0,e.$2c=Symbol("MicrotaskDelay")}),define(ae[46],ce([0,1,21,27]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;class L{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const $=f.charCodeAt(0),v=this.b.charCodeAt(this.c);return $-v}value(){return this.b[this.c]}}e.$nh=L;class j{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,M.$Dd)(f,this.b,0,f.length,this.c,this.d):(0,M.$Fd)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$oh=j;class O{constructor(f=!0,$=!0){this.f=f,this.g=$}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let $=f.length-1;$>=0;$--,this.c--){const v=this.b.charCodeAt($);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,M.$Dd)(f,this.b,0,f.length,this.d,this.e):(0,M.$Fd)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ph=O;var C;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(C||(C={}));class k{constructor(f,$){this.f=f,this.g=$,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,M.$Ed)(f,this.c.scheme);if(this.d[this.e]===2)return(0,M.$Ed)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,M.$Cd)(f,this.c.query);if(this.d[this.e]===5)return(0,M.$Cd)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$qh=k;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(S||(S={}));class E{static forUris(f=()=>!1,$=()=>!1){return new E(new k(f,$))}static forPaths(f=!1){return new E(new O(void 0,!f))}static forStrings(){return new E(new L)}static forConfigKeys(){return new E(new j)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,$){if($){const v=$.slice(0);(0,R.$Bf)(v);for(const a of v)this.set(a,f)}else{const v=f.slice(0);(0,R.$Bf)(v);for(const a of v)this.set(a[0],a[1])}}set(f,$){const v=this.b.reset(f);let a;this.c||(this.c=new m,this.c.segment=v.value());const h=[];for(a=this.c;;){const p=v.cmp(a.segment);if(p>0)a.left||(a.left=new m,a.left.segment=v.value()),h.push([-1,a]),a=a.left;else if(p<0)a.right||(a.right=new m,a.right.segment=v.value()),h.push([1,a]),a=a.right;else if(v.hasNext())v.next(),a.mid||(a.mid=new m,a.mid.segment=v.value()),h.push([0,a]),a=a.mid;else break}const u=a.value;a.value=$,a.key=f;for(let p=h.length-1;p>=0;p--){const w=h[p][1];w.updateHeight();const I=w.balanceFactor();if(I<-1||I>1){const n=h[p][0],r=h[p+1][0];if(n===1&&r===1)h[p][1]=w.rotateLeft();else if(n===-1&&r===-1)h[p][1]=w.rotateRight();else if(n===1&&r===-1)w.right=h[p+1][1]=h[p+1][1].rotateRight(),h[p][1]=w.rotateLeft();else if(n===-1&&r===1)w.left=h[p+1][1]=h[p+1][1].rotateLeft(),h[p][1]=w.rotateRight();else throw new Error;if(p>0)switch(h[p-1][0]){case-1:h[p-1][1].left=h[p][1];break;case 1:h[p-1][1].right=h[p][1];break;case 0:h[p-1][1].mid=h[p][1];break}else this.c=h[0][1]}}return u}get(f){return this.d(f)?.value}d(f){const $=this.b.reset(f);let v=this.c;for(;v;){const a=$.cmp(v.segment);if(a>0)v=v.left;else if(a<0)v=v.right;else if($.hasNext())$.next(),v=v.mid;else break}return v}has(f){const $=this.d(f);return!($?.value===void 0&&$?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,$){const v=this.b.reset(f),a=[];let h=this.c;for(;h;){const u=v.cmp(h.segment);if(u>0)a.push([-1,h]),h=h.left;else if(u<0)a.push([1,h]),h=h.right;else if(v.hasNext())v.next(),a.push([0,h]),h=h.mid;else break}if(h){if($?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const u=this.f(h.right);if(u.key){const{key:p,value:w,segment:I}=u;this.e(u.key,!1),h.key=p,h.value=w,h.segment=I}}else{const u=h.left??h.right;if(a.length>0){const[p,w]=a[a.length-1];switch(p){case-1:w.left=u;break;case 0:w.mid=u;break;case 1:w.right=u;break}}else this.c=u}for(let u=a.length-1;u>=0;u--){const p=a[u][1];p.updateHeight();const w=p.balanceFactor();if(w>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),a[u][1]=p.rotateLeft()):w<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),a[u][1]=p.rotateRight()),u>0)switch(a[u-1][0]){case-1:a[u-1][1].left=a[u][1];break;case 1:a[u-1][1].right=a[u][1];break;case 0:a[u-1][1].mid=a[u][1];break}else this.c=a[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const $=this.b.reset(f);let v=this.c,a;for(;v;){const h=$.cmp(v.segment);if(h>0)v=v.left;else if(h<0)v=v.right;else if($.hasNext())$.next(),a=v.value||a,v=v.mid;else break}return v&&v.value||a}findSuperstr(f){return this.g(f,!1)}g(f,$){const v=this.b.reset(f);let a=this.c;for(;a;){const h=v.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(v.hasNext())v.next(),a=a.mid;else return a.mid?this.h(a.mid):$?a.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[$,v]of this)f(v,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const $=[];return this.j(f,$),$[Symbol.iterator]()}j(f,$){f&&(f.left&&this.j(f.left,$),f.value&&$.push([f.key,f.value]),f.mid&&this.j(f.mid,$),f.right&&this.j(f.right,$))}_isBalanced(){const f=$=>{if(!$)return!0;const v=$.balanceFactor();return v<-1||v>1?!1:f($.left)&&f($.right)};return f(this.c)}}e.$rh=E}),define(ae[10],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;function R(r){return typeof r=="string"}e.$ge=R;function M(r){return Array.isArray(r)&&r.every(i=>R(i))}e.$he=M;function L(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.$ie=L;function j(r){const i=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof i}e.$je=j;function O(r){return typeof r=="number"&&!isNaN(r)}e.$ke=O;function C(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.$le=C;function k(r){return r===!0||r===!1}e.$me=k;function m(r){return typeof r>"u"}e.$ne=m;function S(r){return!E(r)}e.$oe=S;function E(r){return m(r)||r===null}e.$pe=E;function b(r,i){if(!r)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$qe=b;function f(r){if(E(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.$re=f;function $(...r){const i=[];for(let t=0;t<r.length;t++){const s=r[t];if(E(s))throw new Error(`Assertion Failed: argument at index ${t} is undefined or null`);i.push(s)}return i}e.$se=$;const v=Object.prototype.hasOwnProperty;function a(r){if(!L(r))return!1;for(const i in r)if(v.call(r,i))return!1;return!0}e.$te=a;function h(r){return typeof r=="function"}e.$ue=h;function u(...r){return r.length>0&&r.every(h)}e.$ve=u;function p(r,i){const t=Math.min(r.length,i.length);for(let s=0;s<t;s++)w(r[s],i[s])}e.$we=p;function w(r,i){if(R(i)){if(typeof r!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(h(i)){try{if(r instanceof i)return}catch{}if(!E(r)&&r.constructor===i||i.length===1&&i.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$xe=w;function I(r){return r===null?void 0:r}e.$ye=I;function n(r){return typeof r>"u"?null:r}e.$ze=n}),define(ae[31],ce([0,1,10]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=void 0;function M(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const u=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([p,w])=>{u[p]=w&&typeof w=="object"?M(w):w}),u}e.$Dm=M;function L(h){if(!h||typeof h!="object")return h;const u=[h];for(;u.length>0;){const p=u.shift();Object.freeze(p);for(const w in p)if(j.call(p,w)){const I=p[w];typeof I=="object"&&!Object.isFrozen(I)&&!(0,R.$je)(I)&&u.push(I)}}return h}e.$Em=L;const j=Object.prototype.hasOwnProperty;function O(h,u){return C(h,u,new Set)}e.$Fm=O;function C(h,u,p){if((0,R.$pe)(h))return h;const w=u(h);if(typeof w<"u")return w;if(Array.isArray(h)){const I=[];for(const n of h)I.push(C(n,u,p));return I}if((0,R.$ie)(h)){if(p.has(h))throw new Error("Cannot clone recursive data-structure");p.add(h);const I={};for(const n in h)j.call(h,n)&&(I[n]=C(h[n],u,p));return p.delete(h),I}return h}function k(h,u,p=!0){return(0,R.$ie)(h)?((0,R.$ie)(u)&&Object.keys(u).forEach(w=>{w in h?p&&((0,R.$ie)(h[w])&&(0,R.$ie)(u[w])?k(h[w],u[w],p):h[w]=u[w]):h[w]=u[w]}),h):u}e.$Gm=k;function m(h,u){if(h===u)return!0;if(h==null||u===null||u===void 0||typeof h!=typeof u||typeof h!="object"||Array.isArray(h)!==Array.isArray(u))return!1;let p,w;if(Array.isArray(h)){if(h.length!==u.length)return!1;for(p=0;p<h.length;p++)if(!m(h[p],u[p]))return!1}else{const I=[];for(w in h)I.push(w);I.sort();const n=[];for(w in u)n.push(w);if(n.sort(),!m(I,n))return!1;for(p=0;p<I.length;p++)if(!m(h[I[p]],u[I[p]]))return!1}return!0}e.$Hm=m;function S(h){const u=new Set;return JSON.stringify(h,(p,w)=>{if((0,R.$ie)(w)||Array.isArray(w)){if(u.has(w))return"[Circular]";u.add(w)}return w})}e.$Im=S;function E(h,u){const p=Object.create(null);return!h||!u||Object.keys(u).forEach(I=>{const n=h[I],r=u[I];m(n,r)||(p[I]=r)}),p}e.$Jm=E;function b(h,u){const p=u.toLowerCase(),w=Object.keys(h).find(I=>I.toLowerCase()===p);return w?h[w]:h[u]}e.$Km=b;function f(h,u){const p=Object.create(null);for(const[w,I]of Object.entries(h))u(w,I)&&(p[w]=I);return p}e.$Lm=f;function $(h){let u=[],p=Object.getPrototypeOf(h);for(;Object.prototype!==p;)u=u.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return u}e.$Mm=$;function v(h){const u=[];for(const p of $(h))typeof h[p]=="function"&&u.push(p);return u}e.$Nm=v;function a(h,u){const p=I=>function(){const n=Array.prototype.slice.call(arguments,0);return u(I,n)},w={};for(const I of h)w[I]=p(I);return w}e.$Om=a}),define(ae[32],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(L){return R.test(L)}e.$2e=M,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(C){for(let k=0;k<C.length;k++)C[k]=Math.floor(Math.random()*256);return C};const j=new Uint8Array(16),O=[];for(let C=0;C<256;C++)O.push(C.toString(16).padStart(2,"0"));return function(){L(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let k=0,m="";return m+=O[j[k++]],m+=O[j[k++]],m+=O[j[k++]],m+=O[j[k++]],m+="-",m+=O[j[k++]],m+=O[j[k++]],m+="-",m+=O[j[k++]],m+=O[j[k++]],m+="-",m+=O[j[k++]],m+=O[j[k++]],m+="-",m+=O[j[k++]],m+=O[j[k++]],m+=O[j[k++]],m+=O[j[k++]],m+=O[j[k++]],m+=O[j[k++]],m}}()}),define(ae[126],ce([0,1,36]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0;const M=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(O){const C=O.replace(/\-/g,":").toLowerCase();return!M.has(C)}function j(){const O=(0,R.networkInterfaces)();for(const C in O){const k=O[C];if(k){for(const{mac:m}of k)if(L(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$om=j}),define(ae[127],ce([0,1,36,46,32,126]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=void 0,e.$pm=new class{c(m){return this.a||(this.a=M.$rh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,S=0;const E=(0,R.networkInterfaces)();for(const b in E){const f=E[b];if(f)for(const{mac:$,internal:v}of f)v||(S+=1,this.c($.toUpperCase())&&(m+=1))}this.b=S>0?m/S:0}return this.b}};let O;async function C(m){return O||(O=(async()=>await k(m)||L.$3e())()),O}e.$qm=C;async function k(m){try{const S=await new Promise((b,f)=>{ne(["crypto"],b,f)}),E=(0,j.$om)();return S.createHash("sha256").update(E,"utf8").digest("hex")}catch(S){m(S);return}}}),define(ae[128],ce([0,1,62]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7e=e.$6e=e.$5e=void 0;function M(C,k,m,S=1){let E=!1;return new Promise(b=>{const f=setTimeout(()=>{if(!E)return E=!0,b(0)},m);L(C,k,S,$=>{if(!E)return E=!0,clearTimeout(f),b($)})})}e.$5e=M;function L(C,k,m,S){if(k===0)return S(0);const E=new R.Socket;E.once("connect",()=>(O(E),L(C+m,k-1,m,S))),E.once("data",()=>{}),E.once("error",b=>(O(E),b.code!=="ECONNREFUSED"?L(C+m,k-1,m,S):S(C))),E.connect(C,"127.0.0.1")}e.$6e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(C,k,m,S="127.0.0.1"){let E=!1,b,f=1;const $=R.createServer({pauseOnConnect:!0});function v(a,h){E||(E=!0,$.removeAllListeners(),$.close(),b&&clearTimeout(b),h(a))}return new Promise(a=>{b=setTimeout(()=>{v(0,a)},m),$.on("listening",()=>{v(C,a)}),$.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&f<k?(C++,f++,$.listen(C,S)):v(0,a)}),$.on("close",()=>{v(0,a)}),$.listen(C,S)})}e.$7e=j;function O(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(k){console.error(k)}}}),define(ae[129],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5R=void 0;function R(M){return!!M.parentPort}e.$5R=R}),define(ae[130],ce([11,9]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ae[63],ce([0,1,130]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=void 0;const M=60,L=M*60,j=L*24,O=j*7,C=j*30,k=j*365;function m(E,b,f,$){typeof E!="number"&&(E=E.getTime());const v=Math.round((new Date().getTime()-E)/1e3);if(v<-30)return(0,R.localize)(0,null,m(new Date().getTime()+v*1e3,!1));if(!$&&v<30)return(0,R.localize)(1,null);let a;return v<M?(a=v,b?a===1?f?(0,R.localize)(2,null,a):(0,R.localize)(3,null,a):f?(0,R.localize)(4,null,a):(0,R.localize)(5,null,a):a===1?f?(0,R.localize)(6,null,a):(0,R.localize)(7,null,a):f?(0,R.localize)(8,null,a):(0,R.localize)(9,null,a)):v<L?(a=Math.floor(v/M),b?a===1?f?(0,R.localize)(10,null,a):(0,R.localize)(11,null,a):f?(0,R.localize)(12,null,a):(0,R.localize)(13,null,a):a===1?f?(0,R.localize)(14,null,a):(0,R.localize)(15,null,a):f?(0,R.localize)(16,null,a):(0,R.localize)(17,null,a)):v<j?(a=Math.floor(v/L),b?a===1?f?(0,R.localize)(18,null,a):(0,R.localize)(19,null,a):f?(0,R.localize)(20,null,a):(0,R.localize)(21,null,a):a===1?f?(0,R.localize)(22,null,a):(0,R.localize)(23,null,a):f?(0,R.localize)(24,null,a):(0,R.localize)(25,null,a)):v<O?(a=Math.floor(v/j),b?a===1?(0,R.localize)(26,null,a):(0,R.localize)(27,null,a):a===1?(0,R.localize)(28,null,a):(0,R.localize)(29,null,a)):v<C?(a=Math.floor(v/O),b?a===1?f?(0,R.localize)(30,null,a):(0,R.localize)(31,null,a):f?(0,R.localize)(32,null,a):(0,R.localize)(33,null,a):a===1?f?(0,R.localize)(34,null,a):(0,R.localize)(35,null,a):f?(0,R.localize)(36,null,a):(0,R.localize)(37,null,a)):v<k?(a=Math.floor(v/C),b?a===1?f?(0,R.localize)(38,null,a):(0,R.localize)(39,null,a):f?(0,R.localize)(40,null,a):(0,R.localize)(41,null,a):a===1?f?(0,R.localize)(42,null,a):(0,R.localize)(43,null,a):f?(0,R.localize)(44,null,a):(0,R.localize)(45,null,a)):(a=Math.floor(v/k),b?a===1?f?(0,R.localize)(46,null,a):(0,R.localize)(47,null,a):f?(0,R.localize)(48,null,a):(0,R.localize)(49,null,a):a===1?f?(0,R.localize)(50,null,a):(0,R.localize)(51,null,a):f?(0,R.localize)(52,null,a):(0,R.localize)(53,null,a))}e.$Nl=m;function S(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Ol=S}),define(ae[131],ce([11,9]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,21,10,131]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=e.$9h=void 0;function j(E,b){return b&&(E.stack||E.stacktrace)?L.localize(0,null,C(E),O(E.stack)||O(E.stacktrace)):C(E)}function O(E){return Array.isArray(E)?E.join(`
`):E}function C(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function k(E=null,b=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const f=R.$jf(E),$=k(f[0],b);return f.length>1?L.localize(4,null,$,f.length):$}if(M.$ge(E))return E;if(E.detail){const f=E.detail;if(f.error)return j(f.error,b);if(f.exception)return j(f.exception,b)}return E.stack?j(E,b):E.message?E.message:L.localize(5,null)}e.$9h=k;function m(E){const b=E;return b instanceof Error&&Array.isArray(b.actions)}e.$0h=m;function S(E,b){let f;return typeof E=="string"?f=new Error(E):f=E,f.actions=b,f}e.$$h=S}),define(ae[132],ce([11,9]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(ae[133],ce([0,1,132]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=void 0;function M(L){switch(L){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}e.$0o=M}),define(ae[134],ce([11,9]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,134]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let M=!1,L=!1,j=!1,O=!1,C=!1,k=!1,m=!1,S=!1,E=!1,b=!1,f,$=e.$f,v=e.$f,a,h;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?u=e.$g.vscode.process:typeof process<"u"&&(u=process);const p=typeof u?.versions?.electron=="string",w=p&&u?.type==="renderer";if(typeof navigator=="object"&&!w)h=navigator.userAgent,M=h.indexOf("Windows")>=0,L=h.indexOf("Macintosh")>=0,S=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=h.indexOf("Linux")>=0,b=h?.indexOf("Mobi")>=0,k=!0,f=R.getConfiguredDefaultLocale(R.localize(0,null))||e.$f,$=f,v=navigator.language;else if(typeof u=="object"){M=u.platform==="win32",L=u.platform==="darwin",j=u.platform==="linux",O=j&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,m=p,E=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$f,$=e.$f;const y=u.env.VSCODE_NLS_CONFIG;if(y)try{const d=JSON.parse(y),l=d.availableLanguages["*"];f=d.locale,v=d.osLocale,$=l||e.$f,a=d._translationsConfigFile}catch{}C=!0}else console.error("Unable to resolve platform.");var I;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(I||(e.Platform=I={}));function n(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=n;let r=0;L?r=1:M?r=3:j&&(r=2),e.$i=M,e.$j=L,e.$k=j,e.$l=O,e.$m=C,e.$n=m,e.$o=k,e.$p=k&&typeof e.$g.importScripts=="function",e.$q=S,e.$r=b,e.$s=E,e.$t=r,e.$u=h,e.$v=$;var i;(function(y){function d(){return e.$v}y.value=d;function l(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}y.isDefaultVariant=l;function P(){return e.$v==="en"}y.isDefault=P})(i||(e.Language=i={})),e.$w=f,e.$x=v,e.$y=a,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const y=[];e.$g.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let P=0,D=y.length;P<D;P++){const T=y[P];if(T.id===l.data.vscodeScheduleAsyncWork){y.splice(P,1),T.callback();return}}});let d=0;return l=>{const P=++d;y.push({id:P,callback:l}),e.$g.postMessage({vscodeScheduleAsyncWork:P},"*")}}return y=>setTimeout(y)})();var t;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=L||S?2:M?1:3;let s=!0,o=!1;function c(){if(!o){o=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,s=new Uint16Array(y.buffer)[0]===(2<<8)+1}return s}e.$C=c,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(ae[37],ce([0,1,5]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6b=e.$5b=e.env=e.cwd=void 0;let M;if(typeof R.$g.vscode<"u"&&typeof R.$g.vscode.process<"u"){const L=R.$g.vscode.process;M={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return R.$i?"win32":R.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.$5b=M.platform,e.$6b=M.arch}),define(ae[15],ce([0,1,37]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ic=e.sep=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=void 0;const M=65,L=97,j=90,O=122,C=46,k=47,m=92,S=58,E=63;class b extends Error{constructor(r,i,t){let s;typeof i=="string"&&i.indexOf("not ")===0?(s="must not be",i=i.replace(/^not /,"")):s="must be";const o=r.indexOf(".")!==-1?"property":"argument";let c=`The "${r}" ${o} ${s} of type ${i}`;c+=`. Received type ${typeof t}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function f(n,r){if(n===null||typeof n!="object")throw new b(r,"Object",n)}function $(n,r){if(typeof n!="string")throw new b(r,"string",n)}const v=R.$5b==="win32";function a(n){return n===k||n===m}function h(n){return n===k}function u(n){return n>=M&&n<=j||n>=L&&n<=O}function p(n,r,i,t){let s="",o=0,c=-1,y=0,d=0;for(let l=0;l<=n.length;++l){if(l<n.length)d=n.charCodeAt(l);else{if(t(d))break;d=k}if(t(d)){if(!(c===l-1||y===1))if(y===2){if(s.length<2||o!==2||s.charCodeAt(s.length-1)!==C||s.charCodeAt(s.length-2)!==C){if(s.length>2){const P=s.lastIndexOf(i);P===-1?(s="",o=0):(s=s.slice(0,P),o=s.length-1-s.lastIndexOf(i)),c=l,y=0;continue}else if(s.length!==0){s="",o=0,c=l,y=0;continue}}r&&(s+=s.length>0?`${i}..`:"..",o=2)}else s.length>0?s+=`${i}${n.slice(c+1,l)}`:s=n.slice(c+1,l),o=l-c-1;c=l,y=0}else d===C&&y!==-1?++y:y=-1}return s}function w(n,r){f(r,"pathObject");const i=r.dir||r.root,t=r.base||`${r.name||""}${r.ext||""}`;return i?i===r.root?`${i}${t}`:`${i}${n}${t}`:t}e.$7b={resolve(...n){let r="",i="",t=!1;for(let s=n.length-1;s>=-1;s--){let o;if(s>=0){if(o=n[s],$(o,"path"),o.length===0)continue}else r.length===0?o=R.cwd():(o=R.env[`=${r}`]||R.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===m)&&(o=`${r}\\`));const c=o.length;let y=0,d="",l=!1;const P=o.charCodeAt(0);if(c===1)a(P)&&(y=1,l=!0);else if(a(P))if(l=!0,a(o.charCodeAt(1))){let D=2,T=D;for(;D<c&&!a(o.charCodeAt(D));)D++;if(D<c&&D!==T){const F=o.slice(T,D);for(T=D;D<c&&a(o.charCodeAt(D));)D++;if(D<c&&D!==T){for(T=D;D<c&&!a(o.charCodeAt(D));)D++;(D===c||D!==T)&&(d=`\\\\${F}\\${o.slice(T,D)}`,y=D)}}}else y=1;else u(P)&&o.charCodeAt(1)===S&&(d=o.slice(0,2),y=2,c>2&&a(o.charCodeAt(2))&&(l=!0,y=3));if(d.length>0)if(r.length>0){if(d.toLowerCase()!==r.toLowerCase())continue}else r=d;if(t){if(r.length>0)break}else if(i=`${o.slice(y)}\\${i}`,t=l,l&&r.length>0)break}return i=p(i,!t,"\\",a),t?`${r}\\${i}`:`${r}${i}`||"."},normalize(n){$(n,"path");const r=n.length;if(r===0)return".";let i=0,t,s=!1;const o=n.charCodeAt(0);if(r===1)return h(o)?"\\":n;if(a(o))if(s=!0,a(n.charCodeAt(1))){let y=2,d=y;for(;y<r&&!a(n.charCodeAt(y));)y++;if(y<r&&y!==d){const l=n.slice(d,y);for(d=y;y<r&&a(n.charCodeAt(y));)y++;if(y<r&&y!==d){for(d=y;y<r&&!a(n.charCodeAt(y));)y++;if(y===r)return`\\\\${l}\\${n.slice(d)}\\`;y!==d&&(t=`\\\\${l}\\${n.slice(d,y)}`,i=y)}}}else i=1;else u(o)&&n.charCodeAt(1)===S&&(t=n.slice(0,2),i=2,r>2&&a(n.charCodeAt(2))&&(s=!0,i=3));let c=i<r?p(n.slice(i),!s,"\\",a):"";return c.length===0&&!s&&(c="."),c.length>0&&a(n.charCodeAt(r-1))&&(c+="\\"),t===void 0?s?`\\${c}`:c:s?`${t}\\${c}`:`${t}${c}`},isAbsolute(n){$(n,"path");const r=n.length;if(r===0)return!1;const i=n.charCodeAt(0);return a(i)||r>2&&u(i)&&n.charCodeAt(1)===S&&a(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let r,i;for(let o=0;o<n.length;++o){const c=n[o];$(c,"path"),c.length>0&&(r===void 0?r=i=c:r+=`\\${c}`)}if(r===void 0)return".";let t=!0,s=0;if(typeof i=="string"&&a(i.charCodeAt(0))){++s;const o=i.length;o>1&&a(i.charCodeAt(1))&&(++s,o>2&&(a(i.charCodeAt(2))?++s:t=!1))}if(t){for(;s<r.length&&a(r.charCodeAt(s));)s++;s>=2&&(r=`\\${r.slice(s)}`)}return e.$7b.normalize(r)},relative(n,r){if($(n,"from"),$(r,"to"),n===r)return"";const i=e.$7b.resolve(n),t=e.$7b.resolve(r);if(i===t||(n=i.toLowerCase(),r=t.toLowerCase(),n===r))return"";let s=0;for(;s<n.length&&n.charCodeAt(s)===m;)s++;let o=n.length;for(;o-1>s&&n.charCodeAt(o-1)===m;)o--;const c=o-s;let y=0;for(;y<r.length&&r.charCodeAt(y)===m;)y++;let d=r.length;for(;d-1>y&&r.charCodeAt(d-1)===m;)d--;const l=d-y,P=c<l?c:l;let D=-1,T=0;for(;T<P;T++){const H=n.charCodeAt(s+T);if(H!==r.charCodeAt(y+T))break;H===m&&(D=T)}if(T!==P){if(D===-1)return t}else{if(l>P){if(r.charCodeAt(y+T)===m)return t.slice(y+T+1);if(T===2)return t.slice(y+T)}c>P&&(n.charCodeAt(s+T)===m?D=T:T===2&&(D=3)),D===-1&&(D=0)}let F="";for(T=s+D+1;T<=o;++T)(T===o||n.charCodeAt(T)===m)&&(F+=F.length===0?"..":"\\..");return y+=D,F.length>0?`${F}${t.slice(y,d)}`:(t.charCodeAt(y)===m&&++y,t.slice(y,d))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const r=e.$7b.resolve(n);if(r.length<=2)return n;if(r.charCodeAt(0)===m){if(r.charCodeAt(1)===m){const i=r.charCodeAt(2);if(i!==E&&i!==C)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(u(r.charCodeAt(0))&&r.charCodeAt(1)===S&&r.charCodeAt(2)===m)return`\\\\?\\${r}`;return n},dirname(n){$(n,"path");const r=n.length;if(r===0)return".";let i=-1,t=0;const s=n.charCodeAt(0);if(r===1)return a(s)?n:".";if(a(s)){if(i=t=1,a(n.charCodeAt(1))){let y=2,d=y;for(;y<r&&!a(n.charCodeAt(y));)y++;if(y<r&&y!==d){for(d=y;y<r&&a(n.charCodeAt(y));)y++;if(y<r&&y!==d){for(d=y;y<r&&!a(n.charCodeAt(y));)y++;if(y===r)return n;y!==d&&(i=t=y+1)}}}}else u(s)&&n.charCodeAt(1)===S&&(i=r>2&&a(n.charCodeAt(2))?3:2,t=i);let o=-1,c=!0;for(let y=r-1;y>=t;--y)if(a(n.charCodeAt(y))){if(!c){o=y;break}}else c=!1;if(o===-1){if(i===-1)return".";o=i}return n.slice(0,o)},basename(n,r){r!==void 0&&$(r,"ext"),$(n,"path");let i=0,t=-1,s=!0,o;if(n.length>=2&&u(n.charCodeAt(0))&&n.charCodeAt(1)===S&&(i=2),r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let c=r.length-1,y=-1;for(o=n.length-1;o>=i;--o){const d=n.charCodeAt(o);if(a(d)){if(!s){i=o+1;break}}else y===-1&&(s=!1,y=o+1),c>=0&&(d===r.charCodeAt(c)?--c===-1&&(t=o):(c=-1,t=y))}return i===t?t=y:t===-1&&(t=n.length),n.slice(i,t)}for(o=n.length-1;o>=i;--o)if(a(n.charCodeAt(o))){if(!s){i=o+1;break}}else t===-1&&(s=!1,t=o+1);return t===-1?"":n.slice(i,t)},extname(n){$(n,"path");let r=0,i=-1,t=0,s=-1,o=!0,c=0;n.length>=2&&n.charCodeAt(1)===S&&u(n.charCodeAt(0))&&(r=t=2);for(let y=n.length-1;y>=r;--y){const d=n.charCodeAt(y);if(a(d)){if(!o){t=y+1;break}continue}s===-1&&(o=!1,s=y+1),d===C?i===-1?i=y:c!==1&&(c=1):i!==-1&&(c=-1)}return i===-1||s===-1||c===0||c===1&&i===s-1&&i===t+1?"":n.slice(i,s)},format:w.bind(null,"\\"),parse(n){$(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const i=n.length;let t=0,s=n.charCodeAt(0);if(i===1)return a(s)?(r.root=r.dir=n,r):(r.base=r.name=n,r);if(a(s)){if(t=1,a(n.charCodeAt(1))){let D=2,T=D;for(;D<i&&!a(n.charCodeAt(D));)D++;if(D<i&&D!==T){for(T=D;D<i&&a(n.charCodeAt(D));)D++;if(D<i&&D!==T){for(T=D;D<i&&!a(n.charCodeAt(D));)D++;D===i?t=D:D!==T&&(t=D+1)}}}}else if(u(s)&&n.charCodeAt(1)===S){if(i<=2)return r.root=r.dir=n,r;if(t=2,a(n.charCodeAt(2))){if(i===3)return r.root=r.dir=n,r;t=3}}t>0&&(r.root=n.slice(0,t));let o=-1,c=t,y=-1,d=!0,l=n.length-1,P=0;for(;l>=t;--l){if(s=n.charCodeAt(l),a(s)){if(!d){c=l+1;break}continue}y===-1&&(d=!1,y=l+1),s===C?o===-1?o=l:P!==1&&(P=1):o!==-1&&(P=-1)}return y!==-1&&(o===-1||P===0||P===1&&o===y-1&&o===c+1?r.base=r.name=n.slice(c,y):(r.name=n.slice(c,o),r.base=n.slice(c,y),r.ext=n.slice(o,y))),c>0&&c!==t?r.dir=n.slice(0,c-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const I=(()=>{if(v){const n=/\\/g;return()=>{const r=R.cwd().replace(n,"/");return r.slice(r.indexOf("/"))}}return()=>R.cwd()})();e.$8b={resolve(...n){let r="",i=!1;for(let t=n.length-1;t>=-1&&!i;t--){const s=t>=0?n[t]:I();$(s,"path"),s.length!==0&&(r=`${s}/${r}`,i=s.charCodeAt(0)===k)}return r=p(r,!i,"/",h),i?`/${r}`:r.length>0?r:"."},normalize(n){if($(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===k,i=n.charCodeAt(n.length-1)===k;return n=p(n,!r,"/",h),n.length===0?r?"/":i?"./":".":(i&&(n+="/"),r?`/${n}`:n)},isAbsolute(n){return $(n,"path"),n.length>0&&n.charCodeAt(0)===k},join(...n){if(n.length===0)return".";let r;for(let i=0;i<n.length;++i){const t=n[i];$(t,"path"),t.length>0&&(r===void 0?r=t:r+=`/${t}`)}return r===void 0?".":e.$8b.normalize(r)},relative(n,r){if($(n,"from"),$(r,"to"),n===r||(n=e.$8b.resolve(n),r=e.$8b.resolve(r),n===r))return"";const i=1,t=n.length,s=t-i,o=1,c=r.length-o,y=s<c?s:c;let d=-1,l=0;for(;l<y;l++){const D=n.charCodeAt(i+l);if(D!==r.charCodeAt(o+l))break;D===k&&(d=l)}if(l===y)if(c>y){if(r.charCodeAt(o+l)===k)return r.slice(o+l+1);if(l===0)return r.slice(o+l)}else s>y&&(n.charCodeAt(i+l)===k?d=l:l===0&&(d=0));let P="";for(l=i+d+1;l<=t;++l)(l===t||n.charCodeAt(l)===k)&&(P+=P.length===0?"..":"/..");return`${P}${r.slice(o+d)}`},toNamespacedPath(n){return n},dirname(n){if($(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===k;let i=-1,t=!0;for(let s=n.length-1;s>=1;--s)if(n.charCodeAt(s)===k){if(!t){i=s;break}}else t=!1;return i===-1?r?"/":".":r&&i===1?"//":n.slice(0,i)},basename(n,r){r!==void 0&&$(r,"ext"),$(n,"path");let i=0,t=-1,s=!0,o;if(r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let c=r.length-1,y=-1;for(o=n.length-1;o>=0;--o){const d=n.charCodeAt(o);if(d===k){if(!s){i=o+1;break}}else y===-1&&(s=!1,y=o+1),c>=0&&(d===r.charCodeAt(c)?--c===-1&&(t=o):(c=-1,t=y))}return i===t?t=y:t===-1&&(t=n.length),n.slice(i,t)}for(o=n.length-1;o>=0;--o)if(n.charCodeAt(o)===k){if(!s){i=o+1;break}}else t===-1&&(s=!1,t=o+1);return t===-1?"":n.slice(i,t)},extname(n){$(n,"path");let r=-1,i=0,t=-1,s=!0,o=0;for(let c=n.length-1;c>=0;--c){const y=n.charCodeAt(c);if(y===k){if(!s){i=c+1;break}continue}t===-1&&(s=!1,t=c+1),y===C?r===-1?r=c:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||t===-1||o===0||o===1&&r===t-1&&r===i+1?"":n.slice(r,t)},format:w.bind(null,"/"),parse(n){$(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const i=n.charCodeAt(0)===k;let t;i?(r.root="/",t=1):t=0;let s=-1,o=0,c=-1,y=!0,d=n.length-1,l=0;for(;d>=t;--d){const P=n.charCodeAt(d);if(P===k){if(!y){o=d+1;break}continue}c===-1&&(y=!1,c=d+1),P===C?s===-1?s=d:l!==1&&(l=1):s!==-1&&(l=-1)}if(c!==-1){const P=o===0&&i?1:o;s===-1||l===0||l===1&&s===c-1&&s===o+1?r.base=r.name=n.slice(P,c):(r.name=n.slice(P,s),r.base=n.slice(P,c),r.ext=n.slice(s,c))}return o>0?r.dir=n.slice(0,o-1):i&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$8b.win32=e.$7b.win32=e.$7b,e.$8b.posix=e.$7b.posix=e.$8b,e.$9b=v?e.$7b.normalize:e.$8b.normalize,e.$0b=v?e.$7b.isAbsolute:e.$8b.isAbsolute,e.$$b=v?e.$7b.join:e.$8b.join,e.$_b=v?e.$7b.resolve:e.$8b.resolve,e.$ac=v?e.$7b.relative:e.$8b.relative,e.$bc=v?e.$7b.dirname:e.$8b.dirname,e.$cc=v?e.$7b.basename:e.$8b.basename,e.$dc=v?e.$7b.extname:e.$8b.extname,e.$ec=v?e.$7b.format:e.$8b.format,e.$fc=v?e.$7b.parse:e.$8b.parse,e.$gc=v?e.$7b.toNamespacedPath:e.$8b.toNamespacedPath,e.sep=v?e.$7b.sep:e.$8b.sep,e.$ic=v?e.$7b.delimiter:e.$8b.delimiter}),define(ae[47],ce([0,1,15,5,27,10]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function O(o){return o===47||o===92}e.$Ae=O;function C(o){return o.replace(/[\\/]/g,R.$8b.sep)}e.$Be=C;function k(o){return o.indexOf("/")===-1&&(o=C(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.$Ce=k;function m(o,c=R.$8b.sep){if(!o)return"";const y=o.length,d=o.charCodeAt(0);if(O(d)){if(O(o.charCodeAt(1))&&!O(o.charCodeAt(2))){let P=3;const D=P;for(;P<y&&!O(o.charCodeAt(P));P++);if(D!==P&&!O(o.charCodeAt(P+1))){for(P+=1;P<y;P++)if(O(o.charCodeAt(P)))return o.slice(0,P+1).replace(/[\\/]/g,c)}}return c}else if(h(d)&&o.charCodeAt(1)===58)return O(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let l=o.indexOf("://");if(l!==-1){for(l+=3;l<y;l++)if(O(o.charCodeAt(l)))return o.slice(0,l+1)}return""}e.$De=m;function S(o){if(!M.$i||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let y=2;const d=y;for(;y<o.length&&(c=o.charCodeAt(y),c!==92);y++);return!(d===y||(c=o.charCodeAt(y+1),isNaN(c)||c===92))}e.$Ee=S;const E=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(o,c=M.$i){const y=c?E:b;return!(!o||o.length===0||/^\s+$/.test(o)||(y.lastIndex=0,y.test(o))||c&&f.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.$Fe=$;function v(o,c,y){const d=o===c;return!y||d?d:!o||!c?!1:(0,L.$Jd)(o,c)}e.$Ge=v;function a(o,c,y,d=R.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(y){if(!(0,L.$Kd)(o,c))return!1;if(c.length===o.length)return!0;let P=c.length;return c.charAt(c.length-1)===d&&P--,o.charAt(P)===d}return c.charAt(c.length-1)!==d&&(c+=d),o.indexOf(c)===0}e.$He=a;function h(o){return o>=65&&o<=90||o>=97&&o<=122}e.$Ie=h;function u(o,c){return M.$i&&o.endsWith(":")&&(o+=R.sep),(0,R.$0b)(o)||(o=(0,R.$$b)(c,o)),o=(0,R.$9b)(o),M.$i?(o=(0,L.$qd)(o,R.sep),o.endsWith(":")&&(o+=R.sep)):(o=(0,L.$qd)(o,R.sep),o||(o=R.sep)),o}e.$Je=u;function p(o){const c=(0,R.$9b)(o);return M.$i?o.length>3?!1:w(c)&&(o.length===2||c.charCodeAt(2)===92):c===R.$8b.sep}e.$Ke=p;function w(o,c=M.$i){return c?h(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.$Le=w;function I(o,c=M.$i){return w(o,c)?o[0]:void 0}e.$Me=I;function n(o,c,y){return c.length>o.length?-1:o===c?0:(y&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.$Ne=n;function r(o){const c=o.split(":");let y,d,l;for(const P of c){const D=Number(P);(0,j.$ke)(D)?d===void 0?d=D:l===void 0&&(l=D):y=y?[y,P].join(":"):P}if(!y)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:y,line:d!==void 0?d:void 0,column:l!==void 0?l:d!==void 0?1:void 0}}e.$Oe=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(o,c,y=8){let d="";for(let P=0;P<y;P++){let D;P===0&&M.$i&&!c&&(y===3||y===4)?D=t:D=i,d+=D.charAt(Math.floor(Math.random()*D.length))}let l;return c?l=`${c}-${d}`:l=d,o?(0,R.$$b)(o,l):l}e.$Pe=s}),define(ae[135],ce([0,1,15]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=void 0,e.$qr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(S){const E=(0,R.$dc)(S),b=M[E.toLowerCase()];return b!==void 0?b:O(S)}e.$rr=j;function O(S){const E=(0,R.$dc)(S);return L[E.toLowerCase()]}e.$sr=O;function C(S){for(const E in L)if(L[E]===S)return E}e.$tr=C;const k=/^(.+)\/(.+?)(;.+)?$/;function m(S,E){const b=k.exec(S);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:E?void 0:S}e.$ur=m}),define(ae[89],ce([0,1,5]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.TerminateResponseCode=e.Source=void 0;var M;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(M||(e.Source=M={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function j(C,...k){const m=k.reduce((b,f)=>(b[f]=!0,b),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(b=>!m[b]).forEach(b=>{for(let f=0;f<S.length;f++)if(b.search(S[f])!==-1){delete C[b];break}})}e.$bl=j;function O(C){C&&(delete C.DEBUG,R.$j&&delete C.DYLD_LIBRARY_PATH,R.$k&&delete C.LD_PRELOAD)}e.$cl=O}),define(ae[12],ce([0,1,15,5]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,j=/^\//,O=/^\/\//;function C(t,s){if(!t.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!L.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!j.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(t,s){return!t&&!s?"file":t}function m(t,s){switch(t){case"https":case"http":case"file":s?s[0]!==E&&(s=E+s):s=E;break}return s}const S="",E="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(s){return s instanceof f?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,o,c,y,d,l=!1){typeof s=="object"?(this.scheme=s.scheme||S,this.authority=s.authority||S,this.path=s.path||S,this.query=s.query||S,this.fragment=s.fragment||S):(this.scheme=k(s,l),this.authority=o||S,this.path=m(this.scheme,c||S),this.query=y||S,this.fragment=d||S,C(this,l))}get fsPath(){return w(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:c,path:y,query:d,fragment:l}=s;return o===void 0?o=this.scheme:o===null&&(o=S),c===void 0?c=this.authority:c===null&&(c=S),y===void 0?y=this.path:y===null&&(y=S),d===void 0?d=this.query:d===null&&(d=S),l===void 0?l=this.fragment:l===null&&(l=S),o===this.scheme&&c===this.authority&&y===this.path&&d===this.query&&l===this.fragment?this:new a(o,c,y,d,l)}static parse(s,o=!1){const c=b.exec(s);return c?new a(c[2]||S,i(c[4]||S),i(c[5]||S),i(c[7]||S),i(c[9]||S),o):new a(S,S,S,S,S)}static file(s){let o=S;if(M.$i&&(s=s.replace(/\\/g,E)),s[0]===E&&s[1]===E){const c=s.indexOf(E,2);c===-1?(o=s.substring(2),s=E):(o=s.substring(2,c),s=s.substring(c)||E)}return new a("file",o,s,S,S)}static from(s,o){return new a(s.scheme,s.authority,s.path,s.query,s.fragment,o)}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return M.$i&&s.scheme==="file"?c=f.file(R.$7b.join(w(s,!0),...o)).path:c=R.$8b.join(s.path,...o),s.with({path:c})}toString(s=!1){return I(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof f)return s;{const o=new a(s);return o._formatted=s.external??null,o._fsPath=s._sep===v?s.fsPath??null:null,o}}else return s}}e.URI=f;function $(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$Re=$;const v=M.$i?1:void 0;class a extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(s=!1){return s?I(this,!0):(this._formatted||(this._formatted=I(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=v),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,s,o){let c,y=-1;for(let d=0;d<t.length;d++){const l=t.charCodeAt(d);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||s&&l===47||o&&l===91||o&&l===93||o&&l===58)y!==-1&&(c+=encodeURIComponent(t.substring(y,d)),y=-1),c!==void 0&&(c+=t.charAt(d));else{c===void 0&&(c=t.substr(0,d));const P=h[l];P!==void 0?(y!==-1&&(c+=encodeURIComponent(t.substring(y,d)),y=-1),c+=P):y===-1&&(y=d)}}return y!==-1&&(c+=encodeURIComponent(t.substring(y))),c!==void 0?c:t}function p(t){let s;for(let o=0;o<t.length;o++){const c=t.charCodeAt(o);c===35||c===63?(s===void 0&&(s=t.substr(0,o)),s+=h[c]):s!==void 0&&(s+=t[o])}return s!==void 0?s:t}function w(t,s){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?s?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,M.$i&&(o=o.replace(/\//g,"\\")),o}e.$Se=w;function I(t,s){const o=s?p:u;let c="",{scheme:y,authority:d,path:l,query:P,fragment:D}=t;if(y&&(c+=y,c+=":"),(d||y==="file")&&(c+=E,c+=E),d){let T=d.indexOf("@");if(T!==-1){const F=d.substr(0,T);d=d.substr(T+1),T=F.lastIndexOf(":"),T===-1?c+=o(F,!1,!1):(c+=o(F.substr(0,T),!1,!1),c+=":",c+=o(F.substr(T+1),!1,!0)),c+="@"}d=d.toLowerCase(),T=d.lastIndexOf(":"),T===-1?c+=o(d,!1,!0):(c+=o(d.substr(0,T),!1,!0),c+=d.substr(T))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const T=l.charCodeAt(1);T>=65&&T<=90&&(l=`/${String.fromCharCode(T+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const T=l.charCodeAt(0);T>=65&&T<=90&&(l=`${String.fromCharCode(T+32)}:${l.substr(2)}`)}c+=o(l,!0,!1)}return P&&(c+="?",c+=o(P,!1,!1)),D&&(c+="#",c+=s?D:u(D,!1,!1)),c}function n(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+n(t.substr(3)):t}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(t){return t.match(r)?t.replace(r,s=>n(s)):t}}),define(ae[136],ce([0,1,12]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Ap=e.$zp=e.$yp=void 0;function M(m){const S=m;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.$yp=M;function L(m){const S=[];let E;try{const b=JSON.parse(m.arguments),f=b[b.length-1];f&&f.__$stack&&(b.pop(),E=f.__$stack),S.push(...b)}catch{S.push("Unable to log remote console arguments",m.arguments)}return{args:S,stack:E}}e.$zp=L;function j(m){if(typeof m!="string")return j(L(m).stack);const S=m;if(S){const E=O(S),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(b&&b.length===4)return{uri:R.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$Ap=j;function O(m){if(!m)return m;const S=m.indexOf(`
`);return S===-1?m:m.substring(0,S)}function C(m,S){const{args:E,stack:b}=L(m),f=typeof E[0]=="string"&&E.length===1;let $=O(b);$&&($=`(${$.trim()})`);let v=[];if(typeof E[0]=="string"?$&&f?v=[`%c[${S}] %c${E[0]} %c${$}`,k("blue"),k(""),k("grey")]:v=[`%c[${S}] %c${E[0]}`,k("blue"),k(""),...E.slice(1)]:v=[`%c[${S}]%`,k("blue"),...E],$&&!f&&v.push($),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,v)}e.log=C;function k(m){return`color: ${m}`}}),define(ae[64],ce([0,1,16,27,12]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=e.$Tg=e.$Sg=void 0;function j(m){return JSON.stringify(m,C)}e.$Sg=j;function O(m){let S=JSON.parse(m);return S=k(S),S}e.$Tg=O;function C(m,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:(0,M.$wd)(S)}:S}function k(m,S=0){if(!m||S>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return L.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof R.$Ib||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let E=0;E<m.length;++E)m[E]=k(m[E],S+1);else for(const E in m)Object.hasOwnProperty.call(m,E)&&(m[E]=k(m[E],S+1))}return m}e.$Ug=k}),define(ae[25],ce([0,1,7,5,12]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var j;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(j||(e.Schemas=j={})),e.$Te="vscode-tkn",e.$Ue="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${j.vscodeRemoteResource}`}setPreferredWebSchema(S){this.d=S}setDelegate(S){this.e=S}setServerRootPath(S){this.f=`${S}/${j.vscodeRemoteResource}`}set(S,E,b){this.a[S]=E,this.b[S]=b}setConnectionToken(S,E){this.c[S]=E}getPreferredWebSchema(){return this.d}rewrite(S){if(this.e)try{return this.e(S)}catch(a){return R.$X(a),S}const E=S.authority;let b=this.a[E];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const f=this.b[E],$=this.c[E];let v=`path=${encodeURIComponent(S.path)}`;return typeof $=="string"&&(v+=`&${e.$Ue}=${encodeURIComponent($)}`),L.URI.from({scheme:M.$o?this.d:j.vscodeRemoteResource,authority:`${b}:${f}`,path:this.f,query:v})}}e.$Ve=new O,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class C{asBrowserUri(S){const E=this.b(S,ne);return this.uriToBrowserUri(E)}uriToBrowserUri(S){return S.scheme===j.vscodeRemote?e.$Ve.rewrite(S):S.scheme===j.file&&(M.$m||M.$p&&M.$g.origin===`${j.vscodeFileResource}://${C.a}`)?S.with({scheme:j.vscodeFileResource,authority:S.authority||C.a,query:null,fragment:null}):S}asFileUri(S){const E=this.b(S,ne);return this.uriToFileUri(E)}uriToFileUri(S){return S.scheme===j.vscodeFileResource?S.with({scheme:j.file,authority:S.authority!==C.a?S.authority:null,query:null,fragment:null}):S}b(S,E){return L.URI.isUri(S)?S:L.URI.parse(E.toUrl(S))}}C.a="vscode-app",e.$1e=new C;var k;(function(m){const S=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(S.get("3"));const E="vscode-coi";function b($){let v;typeof $=="string"?v=new URL($).searchParams:$ instanceof URL?v=$.searchParams:L.URI.isUri($)&&(v=new URL($.toString(!0)).searchParams);const a=v?.get(E);if(a)return S.get(a)}m.getHeadersFromQuery=b;function f($,v,a){if(!globalThis.crossOriginIsolated)return;const h=v&&a?"3":a?"2":"1";$ instanceof URLSearchParams?$.set(E,h):$[E]=h}m.addSearchParam=f})(k||(e.COI=k={}))}),define(ae[22],ce([0,1,47,25,15,5,27,12]),function(ne,e,R,M,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.DataUri=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function k(f){return(0,C.$Se)(f,!0)}e.$Tf=k;class m{constructor($){this.a=$}compare($,v,a=!1){return $===v?0:(0,O.$Cd)(this.getComparisonKey($,a),this.getComparisonKey(v,a))}isEqual($,v,a=!1){return $===v?!0:!$||!v?!1:this.getComparisonKey($,a)===this.getComparisonKey(v,a)}getComparisonKey($,v=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,v,a=!1){if($.scheme===v.scheme){if($.scheme===M.Schemas.file)return R.$He(k($),k(v),this.a($))&&$.query===v.query&&(a||$.fragment===v.fragment);if((0,e.$$f)($.authority,v.authority))return R.$He($.path,v.path,this.a($),"/")&&$.query===v.query&&(a||$.fragment===v.fragment)}return!1}joinPath($,...v){return C.URI.joinPath($,...v)}basenameOrAuthority($){return(0,e.$3f)($)||$.authority}basename($){return L.$8b.basename($.path)}extname($){return L.$8b.extname($.path)}dirname($){if($.path.length===0)return $;let v;return $.scheme===M.Schemas.file?v=C.URI.file(L.$bc(k($))).path:(v=L.$8b.dirname($.path),$.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),v="/")),$.with({path:v})}normalizePath($){if(!$.path.length)return $;let v;return $.scheme===M.Schemas.file?v=C.URI.file(L.$9b(k($))).path:v=L.$8b.normalize($.path),$.with({path:v})}relativePath($,v){if($.scheme!==v.scheme||!(0,e.$$f)($.authority,v.authority))return;if($.scheme===M.Schemas.file){const u=L.$ac(k($),k(v));return j.$i?R.$Be(u):u}let a=$.path||"/";const h=v.path||"/";if(this.a($)){let u=0;for(const p=Math.min(a.length,h.length);u<p&&!(a.charCodeAt(u)!==h.charCodeAt(u)&&a.charAt(u).toLowerCase()!==h.charAt(u).toLowerCase());u++);a=h.substr(0,u)+a.substr(u)}return L.$8b.relative(a,h)}resolvePath($,v){if($.scheme===M.Schemas.file){const a=C.URI.file(L.$_b(k($),v));return $.with({authority:a.authority,path:a.path})}return v=R.$Ce(v),$.with({path:L.$8b.resolve($.path,v)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,v){return $===v||$!==void 0&&v!==void 0&&(0,O.$Jd)($,v)}hasTrailingPathSeparator($,v=L.sep){if($.scheme===M.Schemas.file){const a=k($);return a.length>R.$De(a).length&&a[a.length-1]===v}else{const a=$.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,v=L.sep){return(0,e.$_f)($,v)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,v=L.sep){let a=!1;if($.scheme===M.Schemas.file){const h=k($);a=h!==void 0&&h.length===R.$De(h).length&&h[h.length-1]===v}else{v="/";const h=$.path;a=h.length===1&&h.charCodeAt(h.length-1)===47}return!a&&!(0,e.$_f)($,v)?$.with({path:$.path+"/"}):$}}e.$Uf=m,e.$Vf=new m(()=>!1),e.$Wf=new m(f=>f.scheme===M.Schemas.file?!j.$k:!0),e.$Xf=new m(f=>!0),e.$Yf=e.$Vf.isEqual.bind(e.$Vf),e.$Zf=e.$Vf.isEqualOrParent.bind(e.$Vf),e.$1f=e.$Vf.getComparisonKey.bind(e.$Vf),e.$2f=e.$Vf.basenameOrAuthority.bind(e.$Vf),e.$3f=e.$Vf.basename.bind(e.$Vf),e.$4f=e.$Vf.extname.bind(e.$Vf),e.$5f=e.$Vf.dirname.bind(e.$Vf),e.$6f=e.$Vf.joinPath.bind(e.$Vf),e.$7f=e.$Vf.normalizePath.bind(e.$Vf),e.$8f=e.$Vf.relativePath.bind(e.$Vf),e.$9f=e.$Vf.resolvePath.bind(e.$Vf),e.$0f=e.$Vf.isAbsolutePath.bind(e.$Vf),e.$$f=e.$Vf.isEqualAuthority.bind(e.$Vf),e.$_f=e.$Vf.hasTrailingPathSeparator.bind(e.$Vf),e.$ag=e.$Vf.removeTrailingPathSeparator.bind(e.$Vf),e.$bg=e.$Vf.addTrailingPathSeparator.bind(e.$Vf);function S(f,$){const v=[];for(let a=0;a<f.length;a++){const h=$(f[a]);f.some((u,p)=>p===a?!1:(0,e.$Zf)(h,$(u)))||v.push(f[a])}return v}e.$cg=S;var E;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function $(v){const a=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(p=>{const[w,I]=p.split(":");w&&I&&a.set(w,I)});const u=v.path.substring(0,v.path.indexOf(";"));return u&&a.set(f.META_DATA_MIME,u),a}f.parseMetaData=$})(E||(e.DataUri=E={}));function b(f,$,v){if($){let a=f.path;return a&&a[0]!==L.$8b.sep&&(a=L.$8b.sep+a),f.with({scheme:v,authority:$,path:a})}return f.with({scheme:v})}e.$dg=b}),define(ae[6],ce([0,1,26,7,3,2,22,5,125]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Og=e.$Ng=e.$Mg=e.Promises=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=void 0;function m(N){return!!N&&typeof N.then=="function"}e.$eg=m;function S(N){const g=new R.$bd,A=N(g.token),U=new Promise((Q,z)=>{const J=g.token.onCancellationRequested(()=>{J.dispose(),g.dispose(),z(new M.$2)});Promise.resolve(A).then(te=>{J.dispose(),g.dispose(),Q(te)},te=>{J.dispose(),g.dispose(),z(te)})});return new class{cancel(){g.cancel()}then(Q,z){return U.then(Q,z)}catch(Q){return this.then(void 0,Q)}finally(Q){return U.finally(Q)}}}e.$fg=S;function E(N,g,A){return new Promise((U,Q)=>{const z=g.onCancellationRequested(()=>{z.dispose(),U(A)});N.then(U,Q).finally(()=>z.dispose())})}e.$gg=E;function b(N,g){return new Promise((A,U)=>{const Q=g.onCancellationRequested(()=>{Q.dispose(),U(new M.$2)});N.then(A,U).finally(()=>Q.dispose())})}e.$hg=b;async function f(N){let g=-1;const A=N.map((U,Q)=>U.then(z=>(g=Q,z)));try{return await Promise.race(A)}finally{N.forEach((U,Q)=>{Q!==g&&U.cancel()})}}e.$ig=f;function $(N,g,A){let U;const Q=setTimeout(()=>{U?.(void 0),A?.()},g);return Promise.race([N.finally(()=>clearTimeout(Q)),new Promise(z=>U=z)])}e.$jg=$;function v(N){return new Promise((g,A)=>{const U=N();m(U)?U.then(g,A):g(U)})}e.$kg=v;class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(g){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=g,!this.b){const A=()=>{if(this.b=null,this.f)return;const U=this.queue(this.d);return this.d=null,U};this.b=new Promise(U=>{this.a.then(A,A).then(U)})}return new Promise((A,U)=>{this.b.then(A,U)})}return this.a=g(),new Promise((A,U)=>{this.a.then(Q=>{this.a=null,A(Q)},Q=>{this.a=null,U(Q)})})}dispose(){this.f=!0}}e.$lg=a;class h{constructor(){this.a=Promise.resolve(null)}queue(g){return this.a=this.a.then(()=>g(),()=>g())}}e.$mg=h;class u{constructor(){this.a=new Map}queue(g,A){const Q=(this.a.get(g)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.a.get(g)===Q&&this.a.delete(g)});return this.a.set(g,Q),Q}}e.$ng=u;const p=(N,g)=>{let A=!0;const U=setTimeout(()=>{A=!1,g()},N);return{isTriggered:()=>A,dispose:()=>{clearTimeout(U),A=!1}}},w=N=>{let g=!0;return queueMicrotask(()=>{g&&(g=!1,N())}),{isTriggered:()=>g,dispose:()=>{g=!1}}};class I{constructor(g){this.defaultDelay=g,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(g,A=this.defaultDelay){this.g=g,this.h(),this.b||(this.b=new Promise((Q,z)=>{this.d=Q,this.f=z}).then(()=>{if(this.b=null,this.d=null,this.g){const Q=this.g;return this.g=null,Q()}}));const U=()=>{this.a=null,this.d?.(null)};return this.a=A===k.$2c?w(U):p(A,U),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$2),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$og=I;class n{constructor(g){this.a=new I(g),this.b=new a}trigger(g,A){return this.a.trigger(()=>this.b.queue(g),A)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.$pg=n;class r{constructor(){this.a=!1,this.b=new Promise((g,A)=>{this.d=g})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$qg=r;class i extends r{constructor(g){super(),this.f=setTimeout(()=>this.open(),g)}open(){clearTimeout(this.f),super.open()}}e.$rg=i;function t(N,g){return g?new Promise((A,U)=>{const Q=setTimeout(()=>{z.dispose(),A()},N),z=g.onCancellationRequested(()=>{clearTimeout(Q),z.dispose(),U(new M.$2)})}):S(A=>t(N,A))}e.$sg=t;function s(N,g=0){const A=setTimeout(N,g);return(0,j.$ib)(()=>clearTimeout(A))}e.$tg=s;function o(N){const g=[];let A=0;const U=N.length;function Q(){return A<U?N[A++]():null}function z(J){J!=null&&g.push(J);const te=Q();return te?te.then(z):Promise.resolve(g)}return Promise.resolve(null).then(z)}e.$ug=o;function c(N,g=U=>!!U,A=null){let U=0;const Q=N.length,z=()=>{if(U>=Q)return Promise.resolve(A);const J=N[U++];return Promise.resolve(J()).then(oe=>g(oe)?Promise.resolve(oe):z())};return z()}e.$vg=c;function y(N,g=U=>!!U,A=null){if(N.length===0)return Promise.resolve(A);let U=N.length;const Q=()=>{U=-1;for(const z of N)z.cancel?.()};return new Promise((z,J)=>{for(const te of N)te.then(oe=>{--U>=0&&g(oe)?(Q(),z(oe)):U===0&&z(A)}).catch(oe=>{--U>=0&&(Q(),J(oe))})})}e.$wg=y;class d{constructor(g){this.a=0,this.d=g,this.f=[],this.b=0,this.g=new L.$5c}get onDrained(){return this.g.event}get size(){return this.a}queue(g){return this.a++,new Promise((A,U)=>{this.f.push({factory:g,c:A,e:U}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const g=this.f.shift();this.b++;const A=g.factory();A.then(g.c,g.e),A.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$xg=d;class l extends d{constructor(){super(1)}}e.$yg=l;class P{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const g=new G;return this.b.add(g),g.p}d(){for(const[,g]of this.a)if(g.size>0)return!1;return!0}queueFor(g,A=O.$Vf){const U=A.getComparisonKey(g);let Q=this.a.get(U);return Q||(Q=new l,L.Event.once(Q.onDrained)(()=>{Q?.dispose(),this.a.delete(U),this.f()}),this.a.set(U,Q)),Q}f(){this.d()&&this.g()}g(){for(const g of this.b)g.complete();this.b.clear()}dispose(){for(const[,g]of this.a)g.dispose();this.a.clear(),this.g()}}e.$zg=P;class D{constructor(g,A){this.a=-1,typeof g=="function"&&typeof A=="number"&&this.setIfNotSet(g,A)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(g,A){this.cancel(),this.a=setTimeout(()=>{this.a=-1,g()},A)}setIfNotSet(g,A){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,g()},A))}}e.$Ag=D;class T{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(g,A){this.cancel(),this.a=setInterval(()=>{g()},A)}}e.$Bg=T;class F{constructor(g,A){this.b=-1,this.a=g,this.d=A,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(g=this.d){this.cancel(),this.b=setTimeout(this.f,g)}get delay(){return this.d}set delay(g){this.d=g}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Cg=F;class H{constructor(g,A){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.a=g,this.b=A,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(g=this.b){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(g/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dg=H;class V extends F{constructor(g,A){super(g,A),this.j=[]}work(g){this.j.push(g),this.isScheduled()||this.schedule()}h(){const g=this.j;this.j=[],this.a?.(g)}dispose(){this.j=[],super.dispose()}}e.$Eg=V;class W extends j.$kb{constructor(g,A){super(),this.g=g,this.h=A,this.a=[],this.b=this.B(new j.$lb),this.f=!1}get pending(){return this.a.length}work(g){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+g.length>this.g.maxBufferedWork)return!1}else if(this.pending+g.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const A of g)this.a.push(A);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fg=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Gg=N=>{(0,C.$A)(()=>{if(g)return;const A=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let g=!1;return{dispose(){g||(g=!0)}}}:e.$Gg=(N,g)=>{const A=requestIdleCallback(N,typeof g=="number"?{timeout:g}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(A))}}}}();class x{constructor(g){this.d=!1,this.a=()=>{try{this.f=g()}catch(A){this.g=A}finally{this.d=!0}},this.b=(0,e.$Gg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Hg=x;async function ee(N,g,A){let U;for(let Q=0;Q<A;Q++)try{return await N()}catch(z){U=z,await t(g)}throw U}e.$Ig=ee;class X{hasPending(g){return this.a?typeof g=="number"?this.a.taskId===g:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(g,A,U){return this.a={taskId:g,cancel:()=>U?.(),promise:A},A.then(()=>this.d(g),()=>this.d(g)),A}d(g){this.a&&g===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const g=this.b;this.b=void 0,g.run().then(g.promiseResolve,g.promiseReject)}}setNext(g){if(this.b)this.b.run=g;else{let A,U;const Q=new Promise((z,J)=>{A=z,U=J});this.b={run:g,promise:Q,promiseResolve:A,promiseReject:U}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Jg=X;class _{constructor(g,A=()=>Date.now()){this.d=g,this.f=A,this.a=0,this.b=0}increment(){const g=this.f();return g-this.a>this.d&&(this.a=g,this.b=0),this.b++,this.b}}e.$Kg=_;var q;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(q||(q={}));class G{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((g,A)=>{this.a=g,this.b=A})}complete(g){return new Promise(A=>{this.a(g),this.d={outcome:0,value:g},A()})}error(g){return new Promise(A=>{this.b(g),this.d={outcome:1,value:g},A()})}cancel(){return this.error(new M.$2)}}e.$Lg=G;var B;(function(N){async function g(U){let Q;const z=await Promise.all(U.map(J=>J.then(te=>te,te=>{Q||(Q=te)})));if(typeof Q<"u")throw Q;return z}N.settled=g;function A(U){return new Promise(async(Q,z)=>{try{await U(Q,z)}catch(J){z(J)}})}N.withAsyncBody=A})(B||(e.Promises=B={}));var ie;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(ie||(ie={}));class re{static fromArray(g){return new re(A=>{A.emitMany(g)})}static fromPromise(g){return new re(async A=>{A.emitMany(await g)})}static fromPromises(g){return new re(async A=>{await Promise.all(g.map(async U=>A.emitOne(await U)))})}static merge(g){return new re(async A=>{await Promise.all(g.map(async U=>{for await(const Q of U)A.emitOne(Q)}))})}constructor(g){this.a=0,this.b=[],this.d=null,this.f=new L.$5c,queueMicrotask(async()=>{const A={emitOne:U=>this.g(U),emitMany:U=>this.h(U),reject:U=>this.k(U)};try{await Promise.resolve(g(A)),this.j()}catch(U){this.k(U)}finally{A.emitOne=void 0,A.emitMany=void 0,A.reject=void 0}})}[Symbol.asyncIterator](){let g=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(g<this.b.length)return{done:!1,value:this.b[g++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(g,A){return new re(async U=>{for await(const Q of g)U.emitOne(A(Q))})}map(g){return re.map(this,g)}static filter(g,A){return new re(async U=>{for await(const Q of g)A(Q)&&U.emitOne(Q)})}filter(g){return re.filter(this,g)}static coalesce(g){return re.filter(g,A=>!!A)}coalesce(){return re.coalesce(this)}static async toPromise(g){const A=[];for await(const U of g)A.push(U);return A}toPromise(){return re.toPromise(this)}g(g){this.a===0&&(this.b.push(g),this.f.fire())}h(g){this.a===0&&(this.b=this.b.concat(g),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(g){this.a===0&&(this.a=2,this.d=g,this.f.fire())}}e.$Mg=re,re.EMPTY=re.fromArray([]);class K extends re{constructor(g,A){super(A),this.l=g}cancel(){this.l.cancel()}}e.$Ng=K;function Z(N){const g=new R.$bd,A=N(g.token);return new K(g,async U=>{const Q=g.token.onCancellationRequested(()=>{Q.dispose(),g.dispose(),U.reject(new M.$2)});try{for await(const z of A){if(g.token.isCancellationRequested)return;U.emitOne(z)}Q.dispose(),g.dispose()}catch(z){Q.dispose(),g.dispose(),U.reject(z)}})}e.$Og=Z}),define(ae[90],ce([0,1,21,6,47,35,15,5,27]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0;function m(){return Object.create(null)}e.$8i=m,e.$9i="**",e.$0i="/";const S="[/\\\\]",E="[^/\\\\]",b=/\//g;function f(_,q){switch(_){case 0:return"";case 1:return`${E}*?`;default:return`(?:${S}|${E}+${S}${q?`|${S}${E}+`:""})*?`}}function $(_,q){if(!_)return[];const G=[];let B=!1,ie=!1,re="";for(const K of _){switch(K){case q:if(!B&&!ie){G.push(re),re="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}re+=K}return re&&G.push(re),G}e.$$i=$;function v(_){if(!_)return"";let q="";const G=$(_,e.$0i);if(G.every(B=>B===e.$9i))q=".*";else{let B=!1;G.forEach((ie,re)=>{if(ie===e.$9i){if(B)return;q+=f(2,re===G.length-1)}else{let K=!1,Z="",N=!1,g="";for(const A of ie){if(A!=="}"&&K){Z+=A;continue}if(N&&(A!=="]"||!g)){let U;A==="-"?U=A:(A==="^"||A==="!")&&!g?U="^":A===e.$0i?U="":U=(0,k.$ld)(A),g+=U;continue}switch(A){case"{":K=!0;continue;case"[":N=!0;continue;case"}":{const Q=`(?:${$(Z,",").map(z=>v(z)).join("|")})`;q+=Q,K=!1,Z="";break}case"]":{q+="["+g+"]",N=!1,g="";break}case"?":q+=E;continue;case"*":q+=f(1);continue;default:q+=(0,k.$ld)(A)}}re<G.length-1&&(G[re+1]!==e.$9i||re+2<G.length)&&(q+=S)}B=ie===e.$9i})}return q}const a=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new j.$mi(1e4),r=function(){return!1},i=function(){return null};function t(_,q){if(!_)return i;let G;typeof _!="string"?G=_.pattern:G=_,G=G.trim();const B=`${G}_${!!q.trimForExclusions}`;let ie=n.get(B);if(ie)return s(ie,_);let re;return a.test(G)?ie=c(G.substr(4),G):(re=h.exec(o(G,q)))?ie=y(re[1],G):(q.trimForExclusions?p:u).test(G)?ie=d(G,q):(re=w.exec(o(G,q)))?ie=l(re[1].substr(1),G,!0):(re=I.exec(o(G,q)))?ie=l(re[1],G,!1):ie=P(G),n.set(B,ie),s(ie,_)}function s(_,q){if(typeof q=="string")return _;const G=function(B,ie){return(0,L.$He)(B,q.base,!C.$k)?_((0,k.$pd)(B.substr(q.base.length),O.sep),ie):null};return G.allBasenames=_.allBasenames,G.allPaths=_.allPaths,G.basenames=_.basenames,G.patterns=_.patterns,G}function o(_,q){return q.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function c(_,q){return function(G,B){return typeof G=="string"&&G.endsWith(_)?q:null}}function y(_,q){const G=`/${_}`,B=`\\${_}`,ie=function(K,Z){return typeof K!="string"?null:Z?Z===_?q:null:K===_||K.endsWith(G)||K.endsWith(B)?q:null},re=[_];return ie.basenames=re,ie.patterns=[q],ie.allBasenames=re,ie}function d(_,q){const G=ee(_.slice(1,-1).split(",").map(Z=>t(Z,q)).filter(Z=>Z!==i),_),B=G.length;if(!B)return i;if(B===1)return G[0];const ie=function(Z,N){for(let g=0,A=G.length;g<A;g++)if(G[g](Z,N))return _;return null},re=G.find(Z=>!!Z.allBasenames);re&&(ie.allBasenames=re.allBasenames);const K=G.reduce((Z,N)=>N.allPaths?Z.concat(N.allPaths):Z,[]);return K.length&&(ie.allPaths=K),ie}function l(_,q,G){const B=O.sep===O.$8b.sep,ie=B?_:_.replace(b,O.sep),re=O.sep+ie,K=O.$8b.sep+_;let Z;return G?Z=function(N,g){return typeof N=="string"&&(N===ie||N.endsWith(re)||!B&&(N===_||N.endsWith(K)))?q:null}:Z=function(N,g){return typeof N=="string"&&(N===ie||!B&&N===_)?q:null},Z.allPaths=[(G?"*/":"./")+_],Z}function P(_){try{const q=new RegExp(`^${v(_)}$`);return function(G){return q.lastIndex=0,typeof G=="string"&&q.test(G)?_:null}}catch{return i}}function D(_,q,G){return!_||typeof q!="string"?!1:T(_)(q,void 0,G)}e.$_i=D;function T(_,q={}){if(!_)return r;if(typeof _=="string"||F(_)){const G=t(_,q);if(G===i)return r;const B=function(ie,re){return!!G(ie,re)};return G.allBasenames&&(B.allBasenames=G.allBasenames),G.allPaths&&(B.allPaths=G.allPaths),B}return W(_,q)}e.$aj=T;function F(_){const q=_;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.$bj=F;function H(_){return _.allBasenames||[]}e.$cj=H;function V(_){return _.allPaths||[]}e.$dj=V;function W(_,q){const G=ee(Object.getOwnPropertyNames(_).map(Z=>x(Z,_[Z],q)).filter(Z=>Z!==i)),B=G.length;if(!B)return i;if(!G.some(Z=>!!Z.requiresSiblings)){if(B===1)return G[0];const Z=function(A,U){let Q;for(let z=0,J=G.length;z<J;z++){const te=G[z](A,U);if(typeof te=="string")return te;(0,M.$eg)(te)&&(Q||(Q=[]),Q.push(te))}return Q?(async()=>{for(const z of Q){const J=await z;if(typeof J=="string")return J}return null})():null},N=G.find(A=>!!A.allBasenames);N&&(Z.allBasenames=N.allBasenames);const g=G.reduce((A,U)=>U.allPaths?A.concat(U.allPaths):A,[]);return g.length&&(Z.allPaths=g),Z}const ie=function(Z,N,g){let A,U;for(let Q=0,z=G.length;Q<z;Q++){const J=G[Q];J.requiresSiblings&&g&&(N||(N=(0,O.$cc)(Z)),A||(A=N.substr(0,N.length-(0,O.$dc)(Z).length)));const te=J(Z,N,A,g);if(typeof te=="string")return te;(0,M.$eg)(te)&&(U||(U=[]),U.push(te))}return U?(async()=>{for(const Q of U){const z=await Q;if(typeof z=="string")return z}return null})():null},re=G.find(Z=>!!Z.allBasenames);re&&(ie.allBasenames=re.allBasenames);const K=G.reduce((Z,N)=>N.allPaths?Z.concat(N.allPaths):Z,[]);return K.length&&(ie.allPaths=K),ie}function x(_,q,G){if(q===!1)return i;const B=t(_,G);if(B===i)return i;if(typeof q=="boolean")return B;if(q){const ie=q.when;if(typeof ie=="string"){const re=(K,Z,N,g)=>{if(!g||!B(K,Z))return null;const A=ie.replace("$(basename)",()=>N),U=g(A);return(0,M.$eg)(U)?U.then(Q=>Q?_:null):U?_:null};return re.requiresSiblings=!0,re}}return B}function ee(_,q){const G=_.filter(Z=>!!Z.basenames);if(G.length<2)return _;const B=G.reduce((Z,N)=>{const g=N.basenames;return g?Z.concat(g):Z},[]);let ie;if(q){ie=[];for(let Z=0,N=B.length;Z<N;Z++)ie.push(q)}else ie=G.reduce((Z,N)=>{const g=N.patterns;return g?Z.concat(g):Z},[]);const re=function(Z,N){if(typeof Z!="string")return null;if(!N){let A;for(A=Z.length;A>0;A--){const U=Z.charCodeAt(A-1);if(U===47||U===92)break}N=Z.substr(A)}const g=B.indexOf(N);return g!==-1?ie[g]:null};re.basenames=B,re.patterns=ie,re.allBasenames=B;const K=_.filter(Z=>!Z.basenames);return K.push(re),K}function X(_,q){return(0,R.$$e)(_,q,(G,B)=>typeof G=="string"&&typeof B=="string"?G===B:typeof G!="string"&&typeof B!="string"?G.base===B.base&&G.pattern===B.pattern:!1)}e.$ej=X}),define(ae[91],ce([0,1,16,12]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=e.$lm=e.$km=e.$jm=void 0;function L(E){return E.toJSON()}class j{constructor(b){this.a=b}transformIncoming(b){const f=this.a.transformIncoming(b);return f===b?b:L(M.URI.from(f))}transformOutgoing(b){const f=this.a.transformOutgoing(b);return f===b?b:L(M.URI.from(f))}transformOutgoingURI(b){const f=this.a.transformOutgoing(b);return f===b?b:M.URI.from(f)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$jm=j,e.$km=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function O(E,b,f){if(!E||f>200)return null;if(typeof E=="object"){if(E instanceof M.URI)return b.transformOutgoing(E);for(const $ in E)if(Object.hasOwnProperty.call(E,$)){const v=O(E[$],b,f+1);v!==null&&(E[$]=v)}}return null}function C(E,b){const f=O(E,b,0);return f===null?E:f}e.$lm=C;function k(E,b,f,$){if(!E||$>200)return null;if(typeof E=="object"){if(E.$mid===1)return f?M.URI.revive(b.transformIncoming(E)):b.transformIncoming(E);if(E instanceof R.$Ib)return null;for(const v in E)if(Object.hasOwnProperty.call(E,v)){const a=k(E[v],b,f,$+1);a!==null&&(E[v]=a)}}return null}function m(E,b){const f=k(E,b,!1,0);return f===null?E:f}e.$mm=m;function S(E,b){const f=k(E,b,!0,0);return f===null?E:f}e.$nm=S}),define(ae[30],ce([0,1,51,36,261,6,47,86,15,5,22,12]),function(ne,e,R,M,L,j,O,C,k,m,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function f(W,x=b.UNLINK,ee){if((0,O.$Ke)(W))throw new Error("rimraf - will refuse to recursively delete root");return x===b.UNLINK?v(W):$(W,ee)}async function $(W,x=(0,O.$Pe)((0,M.tmpdir)())){try{try{await R.promises.rename(W,x)}catch(ee){return ee.code==="ENOENT"?void 0:v(W)}v(x).catch(ee=>{})}catch(ee){if(ee.code!=="ENOENT")throw ee}}async function v(W){return(0,L.promisify)(R.rm)(W,{recursive:!0,force:!0,maxRetries:3})}function a(W){if((0,O.$Ke)(W))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function h(W,x){return w(await(x?u(W):(0,L.promisify)(R.readdir)(W)))}async function u(W){try{return await(0,L.promisify)(R.readdir)(W,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const x=[],ee=await h(W);for(const X of ee){let _=!1,q=!1,G=!1;try{const B=await e.Promises.lstat((0,k.$$b)(W,X));_=B.isFile(),q=B.isDirectory(),G=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}x.push({name:X,isFile:()=>_,isDirectory:()=>q,isSymbolicLink:()=>G})}return x}function p(W){return w(R.readdirSync(W))}e.readdirSync=p;function w(W){return W.map(x=>typeof x=="string"?m.$j?(0,C.$3k)(x):x:(x.name=m.$j?(0,C.$3k)(x.name):x.name,x))}async function I(W){const x=await h(W),ee=[];for(const X of x)await r.existsDirectory((0,k.$$b)(W,X))&&ee.push(X);return ee}function n(W,x=1e3){return new Promise(ee=>{let X=!1;const _=setInterval(()=>{X||(X=!0,R.access(W,q=>{X=!1,q&&(clearInterval(_),ee(void 0))}))},x)})}e.whenDeleted=n;var r;(function(W){async function x(_){let q;try{if(q=await e.Promises.lstat(_),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(_),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(m.$i&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw B}throw G}}W.stat=x;async function ee(_){try{const{stat:q,symbolicLink:G}=await W.stat(_);return q.isFile()&&G?.dangling!==!0}catch{}return!1}W.existsFile=ee;async function X(_){try{const{stat:q,symbolicLink:G}=await W.stat(_);return q.isDirectory()&&G?.dangling!==!0}catch{}return!1}W.existsDirectory=X})(r||(e.SymlinkSupport=r={}));const i=new j.$zg;function t(W,x,ee){return i.queueFor(E.URI.file(W),S.$Wf).queue(()=>{const X=d(ee);return new Promise((_,q)=>c(W,x,X,G=>G?q(G):_()))})}let s=!0;function o(W){s=W}e.configureFlushOnWrite=o;function c(W,x,ee,X){if(!s)return R.writeFile(W,x,{mode:ee.mode,flag:ee.flag},X);R.open(W,ee.flag,ee.mode,(_,q)=>{if(_)return X(_);R.writeFile(q,x,G=>{if(G)return R.close(q,()=>X(G));R.fdatasync(q,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),o(!1)),R.close(q,ie=>X(ie))))})})}function y(W,x,ee){const X=d(ee);if(!s)return R.writeFileSync(W,x,{mode:X.mode,flag:X.flag});const _=R.openSync(W,X.flag,X.mode);try{R.writeFileSync(_,x);try{R.fdatasyncSync(_)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),o(!1)}}finally{R.closeSync(_)}}e.writeFileSync=y;function d(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function l(W,x){if(W!==x)try{await e.Promises.rename(W,x)}catch(ee){if(W.toLowerCase()!==x.toLowerCase()&&ee.code==="EXDEV"||W.endsWith("."))await P(W,x,{preserveSymlinks:!1}),await f(W,b.MOVE);else throw ee}}async function P(W,x,ee){return T(W,x,{root:{source:W,target:x},options:ee,handledSourcePaths:new Set})}const D=511;async function T(W,x,ee){if(ee.handledSourcePaths.has(W))return;ee.handledSourcePaths.add(W);const{stat:X,symbolicLink:_}=await r.stat(W);if(_){if(ee.options.preserveSymlinks)try{return await V(W,x,ee)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(_.dangling)return}return X.isDirectory()?F(W,x,X.mode&D,ee):H(W,x,X.mode&D)}async function F(W,x,ee,X){await e.Promises.mkdir(x,{recursive:!0,mode:ee});const _=await h(W);for(const q of _)await T((0,k.$$b)(W,q),(0,k.$$b)(x,q),X)}async function H(W,x,ee){await e.Promises.copyFile(W,x),await e.Promises.chmod(x,ee)}async function V(W,x,ee){let X=await e.Promises.readlink(W);(0,O.$He)(X,ee.root.source,!m.$k)&&(X=(0,k.$$b)(ee.root.target,X.substr(ee.root.source.length+1))),await e.Promises.symlink(X,x)}e.Promises=new class{get access(){return(0,L.promisify)(R.access)}get stat(){return(0,L.promisify)(R.stat)}get lstat(){return(0,L.promisify)(R.lstat)}get utimes(){return(0,L.promisify)(R.utimes)}get read(){return(W,x,ee,X,_)=>new Promise((q,G)=>{R.read(W,x,ee,X,_,(B,ie,re)=>B?G(B):q({bytesRead:ie,buffer:re}))})}get readFile(){return(0,L.promisify)(R.readFile)}get write(){return(W,x,ee,X,_)=>new Promise((q,G)=>{R.write(W,x,ee,X,_,(B,ie,re)=>B?G(B):q({bytesWritten:ie,buffer:re}))})}get appendFile(){return(0,L.promisify)(R.appendFile)}get fdatasync(){return(0,L.promisify)(R.fdatasync)}get truncate(){return(0,L.promisify)(R.truncate)}get rename(){return(0,L.promisify)(R.rename)}get copyFile(){return(0,L.promisify)(R.copyFile)}get open(){return(0,L.promisify)(R.open)}get close(){return(0,L.promisify)(R.close)}get symlink(){return(0,L.promisify)(R.symlink)}get readlink(){return(0,L.promisify)(R.readlink)}get chmod(){return(0,L.promisify)(R.chmod)}get mkdir(){return(0,L.promisify)(R.mkdir)}get unlink(){return(0,L.promisify)(R.unlink)}get rmdir(){return(0,L.promisify)(R.rmdir)}get realpath(){return(0,L.promisify)(R.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return I}get writeFile(){return t}get rm(){return f}get move(){return l}get copy(){return P}}}),define(ae[137],ce([0,1,51,15,5,27,30]),function(ne,e,R,M,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=void 0;function C(b){if(L.$k)return b;const f=(0,M.$bc)(b);if(b===f)return b;const $=((0,M.$cc)(b)||b).toLowerCase();try{const a=(0,O.readdirSync)(f).filter(h=>h.toLowerCase()===$);if(a.length===1){const h=C(f);if(h)return(0,M.$$b)(h,a[0])}else if(a.length>1){const h=a.indexOf($);if(h>=0){const u=C(f);if(u)return(0,M.$$b)(u,a[h])}}}catch{}return null}e.$Fp=C;async function k(b){if(L.$k)return b;const f=(0,M.$bc)(b);if(b===f)return b;const $=((0,M.$cc)(b)||b).toLowerCase();try{const a=(await O.Promises.readdir(f)).filter(h=>h.toLowerCase()===$);if(a.length===1){const h=await k(f);if(h)return(0,M.$$b)(h,a[0])}else if(a.length>1){const h=a.indexOf($);if(h>=0){const u=await k(f);if(u)return(0,M.$$b)(u,a[h])}}}catch{}return null}e.$Gp=k;async function m(b){try{return await O.Promises.realpath(b)}catch{const $=E(b);return await O.Promises.access($,R.constants.R_OK),$}}e.$Hp=m;function S(b){try{return R.realpathSync(b)}catch{const $=E(b);return R.accessSync($,R.constants.R_OK),$}}e.$Ip=S;function E(b){return(0,j.$qd)((0,M.$9b)(b),M.sep)}}),define(ae[138],ce([0,1,15,5,37,89,10,30]),function(ne,e,R,M,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$el=e.$dl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function k(E=L.env){return E.comspec||"cmd.exe"}e.$dl=k;function m(E){let b=[],f=!1;const $=function(v){if(f){b.push(v);return}(!E.send(v,h=>{if(h&&console.error(h),f=!1,b.length>0){const u=b.slice(0);b=[],u.forEach(p=>$(p))}})||M.$i)&&(f=!0)};return{send:$}}e.$el=m;var S;(function(E){async function b(f,$,v){if(R.$0b(f))return f;if($===void 0&&($=L.cwd()),R.$bc(f)!=="."||(v===void 0&&O.$ge(L.env.PATH)&&(v=L.env.PATH.split(R.$ic)),v===void 0||v.length===0))return R.$$b($,f);async function h(u){if(await C.Promises.exists(u)){let p;try{p=await C.Promises.stat(u)}catch(w){w.message.startsWith("EACCES")&&(p=await C.Promises.lstat(u))}return p?!p.isDirectory():!1}return!1}for(const u of v){let p;if(R.$0b(u)?p=R.$$b(u,f):p=R.$$b($,u,f),await h(p))return p;let w=p+".com";if(await h(w)||(w=p+".exe",await h(w)))return w}return R.$$b($,f)}E.findExecutable=b})(S||(e.win32=S={}))}),define(ae[139],ce([0,1,65,25]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;function L(O){return new Promise((C,k)=>{let m;const S=new Map;function E(f,$,v,a,h){const u=S.get($);if(f===O||u){const p={name:b(v),cmd:v,pid:f,ppid:$,load:a,mem:h};S.set(f,p),f===O&&(m=p),u&&(u.children||(u.children=[]),u.children.push(p),u.children.length>1&&(u.children=u.children.sort((w,I)=>w.pid-I.pid)))}}function b(f){const $=/--utility-sub-type=network/i,v=/--ms-enable-electron-run-as-node/i,a=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,p=/--type=([a-zA-Z-]+)/;if(a.exec(f))return"electron-crash-reporter";if(h.exec(f))return"winpty-agent";if(u.exec(f))return"conpty-agent";let w=p.exec(f);if(w&&w.length===2)return w[1]==="renderer"?"window":w[1]==="utility"?$.exec(f)?"utility-network-service":"utility-process":w[1]==="extensionHost"?"extension-host":w[1];const I=/[a-zA-Z-]+\.js/g;let n="";do w=I.exec(f),w&&(n+=w+" ");while(w);return n&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${n})`:v.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,v)=>{ne(["@vscode/windows-process-tree"],$,v)}).then($=>{$.getProcessList(O,v=>{if(!v){k(new Error(`Root process ${O} not found`));return}$.getProcessCpuUsage(v,a=>{const h=new Map;a.forEach(u=>{const p=f(u.commandLine||"");h.set(u.pid,{name:b(p),cmd:p,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),m=h.get(O),m?(h.forEach(u=>{const p=h.get(u.ppid);p&&(p.children||(p.children=[]),p.children.push(u))}),h.forEach(u=>{u.children&&(u.children=u.children.sort((p,w)=>p.pid-w.pid))}),C(m)):k(new Error(`Root process ${O} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let f=function(){let $=[m];const v=[];for(;$.length;){const h=$.shift();h&&(v.push(h.pid),h.children&&($=$.concat(h.children)))}let a=JSON.stringify(M.$1e.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+v.join(" "),(0,R.exec)(a,{},(h,u,p)=>{if(h||p)k(h||new Error(p.toString()));else{const w=u.toString().split(`
`);for(let I=0;I<v.length;I++){const n=S.get(v[I]);n.load=parseFloat(w[I])}if(!m){k(new Error(`Root process ${O} not found`));return}C(m)}})};(0,R.exec)("which ps",{},($,v,a)=>{if($||a)if(process.platform!=="linux")k($||new Error(a.toString()));else{const h=JSON.stringify(M.$1e.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(h,{},(u,p,w)=>{u||w?k(u||new Error(w.toString())):(j(p,E),f())})}else{const h=v.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${h} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,w,I)=>{p||I&&!I.includes("screen size is bogus")?k(p||new Error(I.toString())):(j(w,E),process.platform==="linux"?f():m?C(m):k(new Error(`Root process ${O} not found`)))})}})}})}e.$br=L;function j(O,C){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=O.toString().split(`
`);for(const S of m){const E=k.exec(S.trim());E&&E.length===6&&C(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var we=this&&this.__decorate||function(ne,e,R,M){var L=arguments.length,j=L<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,R):M,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ne,e,R,M);else for(var C=ne.length-1;C>=0;C--)(O=ne[C])&&(j=(L<3?O(j):L>3?O(e,R,j):O(e,R))||j);return L>3&&j&&Object.defineProperty(e,R,j),j};define(ae[43],ce([0,1,21,6,16,26,59,7,3,2,64,27,10]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.ProxyChannel=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.RequestInitiator=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=void 0;var f;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(f||(f={}));function $(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(v||(v={}));function a(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(h||(h={}));function u(q){let G=0;for(let B=0;;B+=7){const ie=q.read(1);if(G|=(ie.buffer[0]&127)<<B,!(ie.buffer[0]&128))return G}}const p=i(0);function w(q,G){if(G===0){q.write(p);return}let B=0;for(let re=G;re!==0;re=re>>>7)B++;const ie=L.$Ib.alloc(B);for(let re=0;G!==0;re++)ie.buffer[re]=G&127,G=G>>>7,G>0&&(ie.buffer[re]|=128);q.write(ie)}class I{constructor(G){this.b=G,this.a=0}read(G){const B=this.b.slice(this.a,this.a+G);return this.a+=B.byteLength,B}}e.$Vg=I;class n{constructor(){this.a=[]}get buffer(){return L.$Ib.concat(this.a)}write(G){this.a.push(G)}}e.$Wg=n;var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(r||(r={}));function i(q){const G=L.$Ib.alloc(1);return G.writeUInt8(q,0),G}const t={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object),Uint:i(r.Int)},s=typeof Buffer<"u";function o(q,G){if(typeof G>"u")q.write(t.Undefined);else if(typeof G=="string"){const B=L.$Ib.fromString(G);q.write(t.String),w(q,B.byteLength),q.write(B)}else if(s&&Buffer.isBuffer(G)){const B=L.$Ib.wrap(G);q.write(t.Buffer),w(q,B.byteLength),q.write(B)}else if(G instanceof L.$Ib)q.write(t.VSBuffer),w(q,G.byteLength),q.write(G);else if(Array.isArray(G)){q.write(t.Array),w(q,G.length);for(const B of G)o(q,B)}else if(typeof G=="number"&&(G|0)===G)q.write(t.Uint),w(q,G);else{const B=L.$Ib.fromString(JSON.stringify(G));q.write(t.Object),w(q,B.byteLength),q.write(B)}}e.$Xg=o;function c(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(u(q)).toString();case r.Buffer:return q.read(u(q)).buffer;case r.VSBuffer:return q.read(u(q));case r.Array:{const B=u(q),ie=[];for(let re=0;re<B;re++)ie.push(c(q));return ie}case r.Object:return JSON.parse(q.read(u(q)).toString());case r.Int:return u(q)}}e.$Yg=c;class y{constructor(G,B,ie=null,re=1e3){this.h=G,this.j=B,this.k=ie,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(G,B){this.b.set(G,B),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const B=this.o([G.type]);this.k?.logOutgoing(B,0,1,a(G.type));return}case 201:case 202:case 204:case 203:{const B=this.o([G.type,G.id],G.data);this.k?.logOutgoing(B,G.id,1,a(G.type),G.data);return}}}o(G,B=void 0){const ie=new n;return o(ie,G),o(ie,B),this.p(ie.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const B=new I(G),ie=c(B),re=c(B),K=ie[0];switch(K){case 100:return this.k?.logIncoming(G.byteLength,ie[1],1,`${$(K)}: ${ie[2]}.${ie[3]}`,re),this.s({type:K,id:ie[1],channelName:ie[2],name:ie[3],arg:re});case 102:return this.k?.logIncoming(G.byteLength,ie[1],1,`${$(K)}: ${ie[2]}.${ie[3]}`,re),this.t({type:K,id:ie[1],channelName:ie[2],name:ie[3],arg:re});case 101:return this.k?.logIncoming(G.byteLength,ie[1],1,`${$(K)}`),this.u({type:K,id:ie[1]});case 103:return this.k?.logIncoming(G.byteLength,ie[1],1,`${$(K)}`),this.u({type:K,id:ie[1]})}}s(G){const B=this.b.get(G.channelName);if(!B){this.v(G);return}const ie=new j.$bd;let re;try{re=B.call(this.j,G.name,G.arg,ie.token)}catch(N){re=Promise.reject(N)}const K=G.id;re.then(N=>{this.m({id:K,data:N,type:201}),this.d.delete(G.id)},N=>{N instanceof Error?this.m({id:K,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.m({id:K,data:N,type:203}),this.d.delete(G.id)});const Z=(0,m.$ib)(()=>ie.cancel());this.d.set(G.id,Z)}t(G){const B=this.b.get(G.channelName);if(!B){this.v(G);return}const ie=G.id,K=B.listen(this.j,G.name,G.arg)(Z=>this.m({id:ie,data:Z,type:204}));this.d.set(G.id,K)}u(G){const B=this.d.get(G.id);B&&(B.dispose(),this.d.delete(G.id))}v(G){let B=this.g.get(G.channelName);B||(B=[],this.g.set(G.channelName,B));const ie=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:G,timeoutTimer:ie})}w(G){const B=this.g.get(G);if(B){for(const ie of B)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.$fb)(this.d.values()),this.d.clear()}}e.$Zg=y;var d;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(d||(e.RequestInitiator=d={}));class l{constructor(G,B=null){this.l=G,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$5c,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=B}getChannel(G){const B=this;return{call(ie,re,K){return B.a?Promise.reject(new C.$2):B.m(G,ie,re,K)},listen(ie,re){return B.a?k.Event.None:B.o(G,ie,re)}}}m(G,B,ie,re=j.CancellationToken.None){const K=this.g++,N={id:K,type:100,channelName:G,name:B,arg:ie};if(re.isCancellationRequested)return Promise.reject(new C.$2);let g;return new Promise((U,Q)=>{if(re.isCancellationRequested)return Q(new C.$2);const z=()=>{const he=fe=>{switch(fe.type){case 201:this.f.delete(K),U(fe.data);break;case 202:{this.f.delete(K);const be=new Error(fe.data.message);be.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,be.name=fe.data.name,Q(be);break}case 203:this.f.delete(K),Q(fe.data);break}};this.f.set(K,he),this.p(N)};let J=null;this.b===h.Idle?z():(J=(0,M.$fg)(he=>this.u()),J.then(()=>{J=null,z()}));const te=()=>{J?(J.cancel(),J=null):this.p({id:K,type:101}),Q(new C.$2)},oe=re.onCancellationRequested(te);g=(0,m.$hb)((0,m.$ib)(te),oe),this.d.add(g)}).finally(()=>{this.d.delete(g)})}o(G,B,ie){const re=this.g++,Z={id:re,type:102,channelName:G,name:B,arg:ie};let N=null;const g=new k.$5c({onWillAddFirstListener:()=>{N=(0,M.$fg)(U=>this.u()),N.then(()=>{N=null,this.d.add(g),this.p(Z)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.d.delete(g),this.p({id:re,type:103}))}}),A=U=>g.fire(U.data);return this.f.set(re,A),g.event}p(G){switch(G.type){case 100:case 102:{const B=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(B,G.id,0,`${$(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const B=this.q([G.type,G.id]);this.j?.logOutgoing(B,G.id,0,$(G.type));return}}}q(G,B=void 0){const ie=new n;return o(ie,G),o(ie,B),this.r(ie.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const B=new I(G),ie=c(B),re=c(B),K=ie[0];switch(K){case 200:return this.j?.logIncoming(G.byteLength,0,0,a(K)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,ie[1],0,a(K),re),this.t({type:ie[0],id:ie[1],data:re})}}t(G){if(G.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.$fb)(this.d.values()),this.d.clear()}}e.$1g=l,we([O.$Pg],l.prototype,"onDidInitializePromise",null);class P{get connections(){const G=[];return this.f.forEach(B=>G.push(B)),G}constructor(G){this.a=new Map,this.f=new Set,this.g=new k.$5c,this.onDidAddConnection=this.g.event,this.h=new k.$5c,this.onDidRemoveConnection=this.h.event,G(({protocol:B,onDidClientDisconnect:ie})=>{k.Event.once(B.onMessage)(K=>{const Z=new I(K),N=c(Z),g=new y(B,N),A=new l(B);this.a.forEach((Q,z)=>g.registerChannel(z,Q));const U={channelServer:g,channelClient:A,ctx:N};this.f.add(U),this.g.fire(U),ie(()=>{g.dispose(),A.dispose(),this.f.delete(U),this.h.fire(U)})})})}getChannel(G,B){const ie=this;return{call(re,K,Z){let N;if((0,b.$ue)(B)){const A=(0,R.$Hf)(ie.connections.filter(B));N=A?Promise.resolve(A):k.Event.toPromise(k.Event.filter(ie.onDidAddConnection,B))}else N=B.routeCall(ie,re,K);const g=N.then(A=>A.channelClient.getChannel(G));return T(g).call(re,K,Z)},listen(re,K){if((0,b.$ue)(B))return ie.j(G,B,re,K);const Z=B.routeEvent(ie,re,K).then(N=>N.channelClient.getChannel(G));return T(Z).listen(re,K)}}}j(G,B,ie,re){const K=this;let Z=new m.$jb;const N=new k.$5c({onWillAddFirstListener:()=>{Z=new m.$jb;const g=new k.$$c,A=new Map,U=z=>{const te=z.channelClient.getChannel(G).listen(ie,re),oe=g.add(te);A.set(z,oe)},Q=z=>{const J=A.get(z);J&&(J.dispose(),A.delete(z))};K.connections.filter(B).forEach(U),k.Event.filter(K.onDidAddConnection,B)(U,void 0,Z),K.onDidRemoveConnection(Q,void 0,Z),g.event(N.fire,N,Z),Z.add(g)},onDidRemoveLastListener:()=>{Z.dispose()}});return N.event}registerChannel(G,B){this.a.set(G,B),this.f.forEach(ie=>{ie.channelServer.registerChannel(G,B)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$2g=P;class D{constructor(G,B,ie=null){const re=new n;o(re,B),G.send(re.buffer),this.a=new l(G,ie),this.d=new y(G,B,ie)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,B){this.d.registerChannel(G,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$3g=D;function T(q){return{call(G,B,ie){return q.then(re=>re.call(G,B,ie))},listen(G,B){const ie=new k.$ad;return q.then(re=>ie.input=re.listen(G,B)),ie.event}}}e.$4g=T;function F(q){let G=!1;return{call(B,ie,re){return G?q.call(B,ie,re):(0,M.$sg)(0).then(()=>G=!0).then(()=>q.call(B,ie,re))},listen(B,ie){if(G)return q.listen(B,ie);const re=new k.$ad;return(0,M.$sg)(0).then(()=>G=!0).then(()=>re.input=q.listen(B,ie)),re.event}}}e.$5g=F;class H{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const B of G.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await k.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$6g=H;var V;(function(q){function G(K,Z){const N=K,g=Z&&Z.disableMarshalling,A=new Map;for(const U in N)ie(U)&&A.set(U,k.Event.buffer(N[U],!0));return new class{listen(U,Q,z){const J=A.get(Q);if(J)return J;if(re(Q)){const te=N[Q];if(typeof te=="function")return te.call(N,z)}throw new Error(`Event not found: ${Q}`)}call(U,Q,z){const J=N[Q];if(typeof J=="function"){if(!g&&Array.isArray(z))for(let te=0;te<z.length;te++)z[te]=(0,S.$Ug)(z[te]);return J.apply(N,z)}throw new Error(`Method not found: ${Q}`)}}}q.fromService=G;function B(K,Z){const N=Z&&Z.disableMarshalling;return new Proxy({},{get(g,A){if(typeof A=="string")return Z?.properties?.has(A)?Z.properties.get(A):re(A)?function(U){return K.listen(A,U)}:ie(A)?K.listen(A):async function(...U){let Q;Z&&!(0,b.$pe)(Z.context)?Q=[Z.context,...U]:Q=U;const z=await K.call(A,Q);return N?z:(0,S.$Ug)(z)};throw new Error(`Property not found: ${String(A)}`)}})}q.toService=B;function ie(K){return K[0]==="o"&&K[1]==="n"&&E.$Id(K.charCodeAt(2))}function re(K){return/^onDynamic/.test(K)&&E.$Id(K.charCodeAt(9))}})(V||(e.ProxyChannel=V={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const G=q.toString();if(G!=="[object Object]")return G}return q}function ee(q){return Array.isArray(q)?q.map(x):x(q)}function X(q,G,B,ie,re,K,Z){Z=ee(Z);const N=W[re],g=N[ie%N.length];let A=[`%c[${q}]%c[${String(G).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${g}`];/\($/.test(K)?(A=A.concat(Z),A.push(")")):A.push(Z),console.log.apply(console,A)}class _{constructor(G,B){this.d=G,this.f=B,this.a=0,this.b=0}logOutgoing(G,B,ie,re,K){this.b+=G,X(this.d,this.b,G,B,ie,re,K)}logIncoming(G,B,ie,re,K){this.a+=G,X(this.f,this.a,G,B,ie,re,K)}}e.$7g=_}),define(ae[92],ce([0,1,16,3,2,43]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_g=e.$$g=e.$0g=e.$9g=e.ProtocolConstants=e.$8g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var C;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let o=0;function c(d,l){if(!s.has(d)){const P=String(++o);s.set(d,P)}return s.get(d)}function y(d,l,P,D){if(!t.enableDiagnostics)return;const T=c(d,l);if(D instanceof R.$Ib||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const F=R.$Ib.alloc(D.byteLength);F.set(D),t.records.push({timestamp:Date.now(),id:T,label:l,type:P,buff:F})}else t.records.push({timestamp:Date.now(),id:T,label:l,type:P,data:D})}t.traceSocketEvent=y})(C||(e.SocketDiagnostics=C={}));var k;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let m=null;function S(){return m||(m=R.$Ib.alloc(0)),m}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,o){if(s===0)return S();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const l=this.a[0];return o&&(this.a.shift(),this.b-=s),l}if(this.a[0].byteLength>s){const l=this.a[0].slice(0,s);return o&&(this.a[0]=this.a[0].slice(s),this.b-=s),l}const c=R.$Ib.alloc(s);let y=0,d=0;for(;s>0;){const l=this.a[d];if(l.byteLength>s){const P=l.slice(0,s);c.set(P,y),y+=s,o&&(this.a[d]=l.slice(s),this.b-=s),s-=s}else c.set(l,y),y+=l.byteLength,o?(this.a.shift(),this.b-=l.byteLength):d++,s-=l.byteLength}return c}}e.$8g=E;var b;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(b||(b={}));function f(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class v{constructor(s,o,c,y){this.type=s,this.id=o,this.ack=c,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends L.$kb{constructor(s){super(),this.f=this.B(new M.$5c),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new E,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const c=this.g.messageType,y=this.g.id,d=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new v(c,y,d,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=R.$Ib.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(o,s.data)}g(s,o){const c=this.f===0;return this.d.push(s,o),this.f+=s.byteLength+o.byteLength,c}h(){const s=R.$Ib.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,o){this.g(s,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class u extends L.$kb{constructor(s){super(),this.f=new M.$5c,this.onMessage=this.f.event,this.g=new M.$5c,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new h(this.a)),this.c=this.B(new a(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new v(1,0,0,s))}}e.$9g=u;class p extends j.$3g{static fromSocket(s,o){return new p(new u(s),o)}get onDidDispose(){return this.b.onDidDispose}constructor(s,o,c=null){super(s,o,c),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$0g=p;class w{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new M.$5c({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$$g=w;class I{constructor(s){this.data=s,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let s=0,o=this.a;for(;o;)o=o.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let o=0,c=this.a;for(;c;)s[o++]=c.data,c=c.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const o=new I(s);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const s=Date.now();for(let o=0;o<r.a;o++)this.c[o]=s-1e3*o;setInterval(()=>{for(let o=r.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),o=(1+r.a)*1e3;let c=0;for(let y=0;y<r.a;y++)s-this.c[y]<=o&&c++;return 1-c/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;class i{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new w,this.onControlMessage=this.u.event,this.v=new w,this.onMessage=this.v.event,this.w=new w,this.onDidDispose=this.w.event,this.x=new w,this.onSocketClose=this.x.event,this.y=new w,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??r.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$jb,this.o=s.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new a(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new v(5,0,0,S());this.p.write(s),this.p.flush()}sendPause(){const s=new v(7,0,0,S());this.p.write(s)}sendResume(){const s=new v(8,0,0,S());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,o){this.a=!0,this.r.dispose(),this.r=new L.$jb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new a(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new v(3,0,this.h,S());this.p.write(s);const o=this.b.toArray();for(let c=0,y=o.length;c<y;c++)this.p.write(o[c]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const o=this.b.peek();if(o&&o.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new v(6,0,0,S())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let c=0,y=o.length;c<y;c++)this.p.write(o[c]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const o=++this.c;this.h=this.g;const c=new v(1,o,this.h,s);this.b.push(c),this.a||(this.p.write(c),this.B())}sendControl(s){const o=new v(2,0,0,s);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),o=Date.now()-s.writtenTime,c=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(o>=2e4&&c>=2e4&&y>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:c});return}const d=Math.max(2e4-o,2e4-c,2e4-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},d)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new v(3,0,this.h,S());this.p.write(s)}D(){this.h=this.g;const s=new v(9,0,this.h,S());this.p.write(s)}}e.$_g=i}),define(ae[93],ce([0,1,65,6,16,26,136,7,3,2,31,138,89,43]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=void 0;class $ extends f.$Zg{constructor(h){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",u=>L.$Ib.wrap(Buffer.from(u,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Cp=$;class v{constructor(h,u){this.i=h,this.j=u,this.c=new Set,this.g=new Map,this.h=new k.$5c,this.onDidProcessExit=this.h.event;const p=u&&u.timeout?u.timeout:6e4;this.b=new M.$og(p),this.d=null,this.f=null}getChannel(h){const u=this;return{call(p,w,I){return u.k(h,p,w,I)},listen(p,w){return u.l(h,p,w)}}}k(h,u,p,w=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(C.$3());this.b.cancel();const I=this.n(h),n=(0,M.$fg)(t=>I.call(u,p,t)),r=w.onCancellationRequested(()=>n.cancel()),i=(0,m.$ib)(()=>n.cancel());return this.c.add(i),n.finally(()=>{r.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(h,u,p){if(!this.b)return k.Event.None;this.b.cancel();let w;const I=new k.$5c({onWillAddFirstListener:()=>{w=this.n(h).listen(u,p)(I.fire,I),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return I.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,S.$Dm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,b.$cl)(u.env),this.d=(0,R.fork)(this.i,h,u);const p=new k.$5c;k.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,O.$yp)(s)){(0,O.log)(s,`IPC Library: ${this.j.serverName}`);return}p.fire(L.$Ib.wrap(Buffer.from(s,"base64")))});const I=this.j.useQueue?(0,E.$el)(this.d):this.d,n=s=>this.d&&this.d.connected&&I.send(s.buffer.toString("base64")),r=p.event,i={send:n,onMessage:r};this.f=new f.$1g(i);const t=()=>this.o();process.once("exit",t),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,o)=>{process.removeListener("exit",t),this.c.forEach(c=>(0,m.$fb)(c)),this.c.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:o})})}return this.f}n(h){let u=this.g.get(h);return u||(u=this.m.getChannel(h),this.g.set(h,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Dp=v}),define(ae[140],ce([0,1,129,16,43,3,10,21]),function(ne,e,R,M,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7R=e.$6R=void 0;class k{constructor(b){this.a=b,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",f=>M.$Ib.wrap(f.data)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}class m extends L.$2g{static b(){(0,O.$qe)((0,R.$5R)(process),"Electron Utility Process");const b=new j.$5c;return process.parentPort.on("message",f=>{const $=(0,C.$sf)(f.ports);$&&b.fire($)}),j.Event.map(b.event,f=>({protocol:new k(f),onDidClientDisconnect:j.Event.fromNodeEventEmitter(f,"close")}))}constructor(){super(m.b())}}e.$6R=m;function S(E,b,f){const $=v=>{v.data===b&&(E.removeListener("message",$),f())};E.on("message",$)}e.$7R=S}),define(ae[66],ce([0,1,6,3,2,64,10]),function(ne,e,R,M,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.StorageState=e.$Bo=e.StorageHint=void 0;var C;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(e.StorageHint=C={}));function k(b){const f=b;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$Bo=k;var m;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(m||(e.StorageState=m={}));class S extends L.$kb{constructor(f,$=Object.create(null)){super(),this.m=f,this.n=$,this.b=this.B(new M.$8c),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=new R.$pg(S.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(f=>this.r(f)))}r(f){this.b.pause();try{f.changed?.forEach(($,v)=>this.s(v,$)),f.deleted?.forEach($=>this.s($,void 0))}finally{this.b.resume()}}s(f,$){if(this.c===m.Closed)return;let v=!1;(0,O.$pe)($)?v=this.f.delete(f):this.f.get(f)!==$&&(this.f.set(f,$),v=!0),v&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.n.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(f,$){const v=this.f.get(f);return(0,O.$pe)(v)?$:v}getBoolean(f,$){const v=this.get(f);return(0,O.$pe)(v)?$:v==="true"}getNumber(f,$){const v=this.get(f);return(0,O.$pe)(v)?$:parseInt(v,10)}getObject(f,$){const v=this.get(f);return(0,O.$pe)(v)?$:(0,j.$Tg)(v)}async set(f,$,v=!1){if(this.c===m.Closed)return;if((0,O.$pe)($))return this.delete(f,v);const a=(0,O.$ie)($)||Array.isArray($)?(0,j.$Sg)($):String($);if(this.f.get(f)!==a)return this.f.set(f,a),this.j.set(f,a),this.h.delete(f),this.b.fire({key:f,external:v}),this.w()}async delete(f,$=!1){if(!(this.c===m.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:$}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=m.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(f).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(f){if(this.u)return this.w(f)}async w(f){return this.g.trigger(()=>this.v(),f)}async whenFlushed(){if(this.u)return new Promise(f=>this.l.push(f))}isInMemory(){return this.n.hint===C.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Co=S,S.a=100;class E{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach(($,v)=>this.a.set(v,$)),f.delete?.forEach($=>this.a.delete($))}async close(){}}e.$Do=E}),define(ae[141],ce([11,9]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(ae[142],ce([11,9]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[143],ce([11,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[144],ce([11,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(ae[145],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[146],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[147],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[148],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[149],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[150],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[151],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[152],ce([11,9]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(ae[153],ce([11,9]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ae[154],ce([11,9]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(ae[155],ce([11,9]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[156],ce([11,9]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[157],ce([11,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[158],ce([11,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[159],ce([11,9]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(ae[160],ce([11,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[161],ce([11,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[162],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[163],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[164],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[165],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[166],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[167],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[168],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[169],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[170],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[171],ce([11,9]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ae[172],ce([0,1,7,144]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.TokenType=void 0;var L;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(L||(e.TokenType=L={}));function j(...m){switch(m.length){case 1:return(0,M.localize)(0,null,m[0]);case 2:return(0,M.localize)(1,null,m[0],m[1]);case 3:return(0,M.localize)(2,null,m[0],m[1],m[2]);default:return}}const O=(0,M.localize)(3,null),C=(0,M.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return S.isTripleEq?"===":"==";case 4:return S.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return S.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return S.lexeme;case 18:return S.lexeme;case 19:return S.lexeme;case 20:return"EOF";default:throw(0,R.$5)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(S){const E=this.d,b=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:b};this.g.push({offset:E,lexeme:b,additionalInfo:S}),this.f.push(f)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const E=this.c.substring(this.d,this.e),b=k.b.get(E);b?this.k(b):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,E=!1,b=!1;for(;;){if(S>=this.c.length){this.e=S,this.l(C);return}const $=this.c.charCodeAt(S);if(E)E=!1;else if($===47&&!b){S++;break}else $===91?b=!0:$===92?E=!0:$===93&&(b=!1);S++}for(;S<this.c.length&&k.a.has(this.c.charCodeAt(S));)S++;this.e=S;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$oi=k,k.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0))),k.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(ae[173],ce([0,1,63,59,25,15,37,22,12]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,j.$bc)(L.$1e.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,j.$$b)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,C.$6f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,C.$6f)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,R.$Ol)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$$b)(this.userDataPath,"logs",f)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.$6f)(k.URI.file((0,j.$$b)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.$6f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.$6f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.$6f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=O.env.VSCODE_PORTABLE;return f?k.URI.file((0,j.$$b)(f,"argv.json")):(0,C.$6f)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,j.$$b)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,j.$_b)(f):(0,j.$9b)((0,j.$$b)(L.$1e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?k.URI.file((0,j.$_b)(f)):k.URI.file((0,j.$$b)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,j.$_b)(f);const $=O.env.VSCODE_EXTENSIONS;if($)return $;const v=O.env.VSCODE_PORTABLE;return v?(0,j.$$b)(v,"extensions"):(0,C.$6f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map($=>/^[^:/?#]+?:\/\//.test($)?k.URI.parse($):k.URI.file((0,j.$9b)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?k.URI.parse(f):k.URI.file((0,j.$9b)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$Pl.test(f))}get extensionLogLevel(){const f=[];for(const $ of this.args.log||[]){const v=e.$Pl.exec($);v&&v[1]&&v[2]&&f.push([v[1],v[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,C.$6f)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=O.env.VSCODE_PORTABLE;return f?k.URI.file((0,j.$$b)(f,"policy.json")):(0,C.$6f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,$,v){this.a=f,this.b=$,this.c=v,this.editSessionId=this.args.editSessionId}}e.$Ql=m,we([M.$Pg],m.prototype,"appRoot",null),we([M.$Pg],m.prototype,"userHome",null),we([M.$Pg],m.prototype,"userDataPath",null),we([M.$Pg],m.prototype,"appSettingsHome",null),we([M.$Pg],m.prototype,"tmpDir",null),we([M.$Pg],m.prototype,"cacheHome",null),we([M.$Pg],m.prototype,"stateResource",null),we([M.$Pg],m.prototype,"userRoamingDataHome",null),we([M.$Pg],m.prototype,"userDataSyncHome",null),we([M.$Pg],m.prototype,"sync",null),we([M.$Pg],m.prototype,"machineSettingsResource",null),we([M.$Pg],m.prototype,"workspaceStorageHome",null),we([M.$Pg],m.prototype,"localHistoryHome",null),we([M.$Pg],m.prototype,"keyboardLayoutResource",null),we([M.$Pg],m.prototype,"argvResource",null),we([M.$Pg],m.prototype,"isExtensionDevelopment",null),we([M.$Pg],m.prototype,"untitledWorkspacesHome",null),we([M.$Pg],m.prototype,"builtinExtensionsPath",null),we([M.$Pg],m.prototype,"extensionsPath",null),we([M.$Pg],m.prototype,"extensionDevelopmentLocationURI",null),we([M.$Pg],m.prototype,"extensionDevelopmentKind",null),we([M.$Pg],m.prototype,"extensionTestsLocationURI",null),we([M.$Pg],m.prototype,"debugExtensionHost",null),we([M.$Pg],m.prototype,"logLevel",null),we([M.$Pg],m.prototype,"extensionLogLevel",null),we([M.$Pg],m.prototype,"serviceMachineIdResource",null),we([M.$Pg],m.prototype,"disableTelemetry",null),we([M.$Pg],m.prototype,"disableWorkspaceTrust",null),we([M.$Pg],m.prototype,"policyFile",null);function S(b,f){return E(b["inspect-extensions"],b["inspect-brk-extensions"],5870,f,b.debugId,b.extensionEnvironment)}e.$Rl=S;function E(b,f,$,v,a,h){const p=Number(f||b)||(v?null:$),w=p?!!f:!1;let I;if(h)try{I=JSON.parse(h)}catch{}return{port:p,break:w,debugId:a,env:I}}e.$Sl=E}),function(){"use strict";function ne(e,R,M){function L(O,C){const k=j(O,C),m=[k];return e.isAbsolute(k)||m.unshift(M),e.resolve(...m)}function j(O,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,C);const S=O["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(E,"AppData","Roaming")}break;case"darwin":m=e.join(R.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,C)}return{getUserDataPath:L}}if(typeof define=="function")define(ae[174],ce([262,36,37]),function(e,R,M){return ne(e,R,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=ne(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[175],ce([0,1,36,173,174]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Tl=void 0;class j extends M.$Ql{constructor(m,S){super(m,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,L.getUserDataPath)(m,S.nameShort)},S)}}e.$Tl=j;function O(k,m){return(0,M.$Sl)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,m,k.extensionEnvironment)}e.$Ul=O;function C(k,m){return(0,M.$Sl)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,m,k.extensionEnvironment)}e.$Vl=C}),define(ae[176],ce([0,1,10,147]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=void 0;function L(O,C,k){try{j(O,C,k)}catch(m){console.error(m?.message??m)}return O}e.$$o=L;function j(O,C,k){const m=(S,E,b)=>{const f=S[E];if((0,R.$ge)(f)){const $=f,v=$.length;if(v>1&&$[0]==="%"&&$[v-1]==="%"){const a=$.substr(1,v-2);let h=C[a];h===void 0&&k&&(h=k[a]);const u=typeof h=="string"?h:h?.message,p=k?.[a],w=typeof p=="string"?p:p?.message;if(!u){w||console.warn(`[${O.name}]: ${(0,M.localize)(0,null,a)}`);return}if(b&&(E==="title"||E==="category")&&w&&w!==u){const I={value:u,original:w};S[E]=I}else S[E]=u}}else if((0,R.$ie)(f))for(const $ in f)f.hasOwnProperty($)&&($==="commands"?m(f,$,!0):m(f,$,b));else if(Array.isArray(f))for(let $=0;$<f.length;$++)m(f,$,b)};for(const S in O)O.hasOwnProperty(S)&&m(O,S)}}),define(ae[177],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$84b=e.$74b=void 0;class R{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$74b=R;class M{constructor(j){this.a=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,C){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(C[0])}throw new Error(`Call not found: ${O}`)}}e.$84b=M}),define(ae[67],ce([0,1,22,88,151,52]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function k(h){return h=h.trim(),h==="*"||O.test(h)}e.$no=k;function m(h){if(!k(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=h.match(O);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$oo=m;function S(h){if(!h)return null;const u=h.majorBase,p=h.majorMustEqual,w=h.minorBase;let I=h.minorMustEqual;const n=h.patchBase;let r=h.patchMustEqual;h.hasCaret&&(u===0||(I=!1),r=!1);let i=0;if(h.preRelease){const t=C.exec(h.preRelease);if(t){const[,s,o,c]=t;i=Date.UTC(Number(s),Number(o)-1,Number(c))}}return{majorBase:u,majorMustEqual:p,minorBase:w,minorMustEqual:I,patchBase:n,patchMustEqual:r,isMinimum:h.hasGreaterEquals,notBefore:i}}e.$po=S;function E(h,u,p){let w;typeof h=="string"?w=S(m(h)):w=h;let I;u instanceof Date?I=u.getTime():typeof u=="string"&&(I=new Date(u).getTime());let n;if(typeof p=="string"?n=S(m(p)):n=p,!w||!n)return!1;const r=w.majorBase,i=w.minorBase,t=w.patchBase;let s=n.majorBase,o=n.minorBase,c=n.patchBase;const y=n.notBefore;let d=n.majorMustEqual,l=n.minorMustEqual,P=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:i>o?!0:i<o||I&&I<y?!1:t>=c:(r===1&&s===0&&(!d||!l||!P)&&(s=1,o=0,c=0,d=!0,l=!1,P=!1),r<s?!1:r>s?!d:i<o?!1:i>o?!l:t<c?!1:t>c?!P:!(I&&I<y))}e.$qo=E;function b(h,u,p,w,I){const n=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return n.push([M.default.Error,L.localize(0,null)]),n;if(typeof w.name!="string")return n.push([M.default.Error,L.localize(1,null,"name")]),n;if(typeof w.version!="string")return n.push([M.default.Error,L.localize(2,null,"version")]),n;if(!w.engines)return n.push([M.default.Error,L.localize(3,null,"engines")]),n;if(typeof w.engines.vscode!="string")return n.push([M.default.Error,L.localize(4,null,"engines.vscode")]),n;if(typeof w.extensionDependencies<"u"&&!a(w.extensionDependencies))return n.push([M.default.Error,L.localize(5,null,"extensionDependencies")]),n;if(typeof w.activationEvents<"u"){if(!a(w.activationEvents))return n.push([M.default.Error,L.localize(6,null,"activationEvents")]),n;if(typeof w.main>"u"&&typeof w.browser>"u")return n.push([M.default.Error,L.localize(7,null,"activationEvents","main","browser")]),n}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&n.push([M.default.Warning,L.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return n.push([M.default.Error,L.localize(9,null,"main")]),n;{const t=(0,R.$6f)(p,w.main);(0,R.$Zf)(t,p)||n.push([M.default.Warning,L.localize(10,null,t.path,p.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return n.push([M.default.Error,L.localize(11,null,"browser")]),n;{const t=(0,R.$6f)(p,w.browser);(0,R.$Zf)(t,p)||n.push([M.default.Warning,L.localize(12,null,t.path,p.path)])}}if(!j.valid(w.version))return n.push([M.default.Error,L.localize(13,null)]),n;const r=[];if(!f(h,u,w,I,r))for(const t of r)n.push([M.default.Error,t]);return n}e.$ro=b;function f(h,u,p,w,I){return w||typeof p.main>"u"&&typeof p.browser>"u"?!0:v(h,u,p.engines.vscode,I)}e.$so=f;function $(h,u,p){return h==="*"||v(u,p,h)}e.$to=$;function v(h,u,p,w=[]){const I=S(m(p));if(!I)return w.push(L.localize(14,null,p)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return w.push(L.localize(15,null,p)),!1}else if(!I.majorMustEqual)return w.push(L.localize(16,null,p)),!1;return E(h,u,I)?!0:(w.push(L.localize(17,null,h,p)),!1)}function a(h){if(!Array.isArray(h))return!1;for(let u=0,p=h.length;u<p;u++)if(typeof h[u]!="string")return!1;return!0}}),define(ae[44],ce([0,1,16,32]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=void 0;async function L(j,O,C){let k=C&&C.get("storage.serviceMachineId",-1)||null;if(k)return k;try{const S=(await O.readFile(j.serviceMachineIdResource)).value.toString();k=(0,M.$2e)(S)?S:null}catch{k=null}if(!k){k=(0,M.$3e)();try{await O.writeFile(j.serviceMachineIdResource,R.$Ib.fromString(k))}catch{}}return C?.store("storage.serviceMachineId",k,-1,1),k}e.$Mo=L}),define(ae[68],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=void 0;class R{constructor(L,j=[],O=!1){this.ctor=L,this.staticArguments=j,this.supportsDelayedInstantiation=O}}e.$ih=R}),define(ae[178],ce([0,1,68]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.InstantiationType=void 0;const M=[];var L;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function j(C,k,m){k instanceof R.$ih||(k=new R.$ih(k,[],!!m)),M.push([C,k])}e.$8q=j;function O(){return M}e.$9q=O}),define(ae[179],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=void 0;class R{constructor(j,O){this.key=j,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$Op=R;class M{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const O of this.a.values())O.outgoing.size===0&&j.push(O);return j}insertEdge(j,O){const C=this.lookupOrInsertNode(j),k=this.lookupOrInsertNode(O);C.outgoing.set(k.key,k),k.incoming.set(C.key,C)}removeNode(j){const O=this.b(j);this.a.delete(O);for(const C of this.a.values())C.outgoing.delete(O),C.incoming.delete(O)}lookupOrInsertNode(j){const O=this.b(j);let C=this.a.get(O);return C||(C=new R(O,j),this.a.set(O,C)),C}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[O,C]of this.a)j.push(`${O}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,O]of this.a){const C=new Set([j]),k=this.c(O,C);if(k)return k}}c(j,O){for(const[C,k]of j.outgoing){if(O.has(C))return[...O,C].join(" -> ");O.add(C);const m=this.c(k,O);if(m)return m;O.delete(C)}}}e.$Pp=M}),define(ae[4],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e._util=void 0;var R;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function C(k){return k[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=C})(R||(e._util=R={})),e.$kh=L("instantiationService");function M(O,C,k){C[R.DI_TARGET]===C?C[R.DI_DEPENDENCIES].push({id:O,index:k}):(C[R.DI_DEPENDENCIES]=[{id:O,index:k}],C[R.DI_TARGET]=C)}function L(O){if(R.serviceIds.has(O))return R.serviceIds.get(O);const C=function(k,m,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(C,k,S)};return C.toString=()=>O,R.serviceIds.set(O,C),C}e.$lh=L;function j(O){return O}e.$mh=j}),define(ae[180],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C4b=void 0,e.$C4b=(0,R.$lh)("checksumService")}),define(ae[18],ce([0,1,10,12,4]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.ConfigurationTarget=e.$Th=e.$Sh=e.$Rh=void 0,e.$Rh=(0,L.$lh)("configurationService");function j(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof M.URI)}e.$Sh=j;function O(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof M.URI)}e.$Th=O;var C;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(C||(e.ConfigurationTarget=C={}));function k(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Uh=k;function m(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$Vh=m;function S(h,u){const p=Object.create(null);for(const w in h)E(p,w,h[w],u);return p}e.$Wh=S;function E(h,u,p,w){const I=u.split("."),n=I.pop();let r=h;for(let i=0;i<I.length;i++){const t=I[i];let s=r[t];switch(typeof s){case"undefined":s=r[t]=Object.create(null);break;case"object":break;default:w(`Ignoring ${u} as ${I.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=p}catch{w(`Ignoring ${u} as ${I.join(".")} is ${JSON.stringify(r)}`)}else w(`Ignoring ${u} as ${I.join(".")} is ${JSON.stringify(r)}`)}e.$Xh=E;function b(h,u){const p=u.split(".");f(h,p)}e.$Yh=b;function f(h,u){const p=u.shift();if(u.length===0){delete h[p];return}if(Object.keys(h).indexOf(p)!==-1){const w=h[p];typeof w=="object"&&!Array.isArray(w)&&(f(w,u),Object.keys(w).length===0&&delete h[p])}}function $(h,u,p){function w(r,i){let t=r;for(const s of i){if(typeof t!="object"||t===null)return;t=t[s]}return t}const I=u.split("."),n=w(h,I);return typeof n>"u"?p:n}e.$Zh=$;function v(h,u,p){Object.keys(u).forEach(w=>{w!=="__proto__"&&(w in h?R.$ie(h[w])&&R.$ie(u[w])?v(h[w],u[w],p):p&&(h[w]=u[w]):h[w]=u[w])})}e.$1h=v;function a(h){return h.replace(/[\[\]]/g,"")}e.$2h=a}),define(ae[94],ce([0,1,5,27,172,4,143,7]),function(ne,e,R,M,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.ContextKeyExprType=e.$pi=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",R.$j),k.set("isLinux",R.$k),k.set("isWindows",R.$i),k.set("isWeb",R.$o),k.set("isMacNative",R.$j&&!R.$o),k.set("isEdge",R.$G),k.set("isFirefox",R.$E),k.set("isChrome",R.$D),k.set("isSafari",R.$F);function m(N,g){if(k.get(N)!==void 0)throw(0,C.$4)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(N,g)}e.$pi=m;const S=Object.prototype.hasOwnProperty;var E;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const b={regexParsingWithErrorRecovery:!0},f=(0,O.localize)(0,null),$=(0,O.localize)(1,null),v=(0,O.localize)(2,null),a=(0,O.localize)(3,null),h=(0,O.localize)(4,null),u=(0,O.localize)(5,null),p=(0,O.localize)(6,null),w=(0,O.localize)(7,null);class I{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(g=b){this.k=g,this.d=new L.$oi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(g){if(g===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(g).scan(),this.g=0,this.h=[];try{const A=this.l();if(!this.E()){const U=this.D(),Q=U.type===17?u:void 0;throw this.h.push({message:h,offset:U.offset,lexeme:L.$oi.getLexeme(U),additionalInfo:Q}),I.c}return A}catch(A){if(A!==I.c)throw A;return}}l(){return this.m()}m(){const g=[this.o()];for(;this.y(16);){const A=this.o();g.push(A)}return g.length===1?g[0]:n.or(...g)}o(){const g=[this.s()];for(;this.y(15);){const A=this.s();g.push(A)}return g.length===1?g[0]:n.and(...g)}s(){if(this.y(2)){const g=this.D();switch(g.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const A=this.l();return this.A(1,a),A?.negate()}case 17:return this.z(),D.create(g.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",g)}}return this.t()}t(){const g=this.D();switch(g.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const A=this.l();return this.A(1,a),A}case 17:{const A=g.lexeme;if(this.z(),this.y(9)){const Q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Q.type!==10)throw this.B("REGEX",Q);const z=Q.lexeme,J=z.lastIndexOf("/"),te=J===z.length-1?void 0:this.w(z.substring(J+1));let oe;try{oe=new RegExp(z.substring(1,J),te)}catch{throw this.B("REGEX",Q)}return x.create(A,oe)}switch(Q.type){case 10:case 19:{const z=[Q.lexeme];this.z();let J=this.D(),te=0;for(let pe=0;pe<Q.lexeme.length;pe++)Q.lexeme.charCodeAt(pe)===40?te++:Q.lexeme.charCodeAt(pe)===41&&te--;for(;!this.E()&&J.type!==15&&J.type!==16;){switch(J.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let pe=0;pe<J.lexeme.length;pe++)J.lexeme.charCodeAt(pe)===40?te++:Q.lexeme.charCodeAt(pe)===41&&te--}if(te<0)break;z.push(L.$oi.getLexeme(J)),this.z(),J=this.D()}const oe=z.join(""),he=oe.lastIndexOf("/"),fe=he===oe.length-1?void 0:this.w(oe.substring(he+1));let be;try{be=new RegExp(oe.substring(1,he),fe)}catch{throw this.B("REGEX",Q)}return n.regex(A,be)}case 18:{const z=Q.lexeme;this.z();let J=null;if(!(0,M.$hd)(z)){const te=z.indexOf("/"),oe=z.lastIndexOf("/");if(te!==oe&&te>=0){const he=z.slice(te+1,oe),fe=z[oe+1]==="i"?"i":"";try{J=new RegExp(he,fe)}catch{throw this.B("REGEX",Q)}}}if(J===null)throw this.B("REGEX",Q);return x.create(A,J)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const Q=this.u();return n.notIn(A,Q)}switch(this.D().type){case 3:{this.z();const Q=this.u();if(this.x().type===18)return n.equals(A,Q);switch(Q){case"true":return n.has(A);case"false":return n.not(A);default:return n.equals(A,Q)}}case 4:{this.z();const Q=this.u();if(this.x().type===18)return n.notEquals(A,Q);switch(Q){case"true":return n.not(A);case"false":return n.has(A);default:return n.notEquals(A,Q)}}case 5:return this.z(),V.create(A,this.u());case 6:return this.z(),W.create(A,this.u());case 7:return this.z(),F.create(A,this.u());case 8:return this.z(),H.create(A,this.u());case 13:return this.z(),n.in(A,this.u());default:return n.has(A)}}case 20:throw this.h.push({message:p,offset:g.offset,lexeme:"",additionalInfo:w}),I.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const g=this.D();switch(g.type){case 17:case 18:return this.z(),g.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(g){return g.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(g){return this.C(g)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(g,A){if(this.C(g))return this.z();throw this.B(A,this.D())}B(g,A,U){const Q=(0,O.localize)(8,null,g,L.$oi.getLexeme(A)),z=A.offset,J=L.$oi.getLexeme(A);return this.h.push({message:Q,offset:z,lexeme:J,additionalInfo:U}),I.c}C(g){return this.D().type===g}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$qi=I,I.c=new Error;class n{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(g){return c.create(g)}static equals(g,A){return y.create(g,A)}static notEquals(g,A){return P.create(g,A)}static regex(g,A){return x.create(g,A)}static in(g,A){return d.create(g,A)}static notIn(g,A){return l.create(g,A)}static not(g){return D.create(g)}static and(...g){return _.create(g,null,!0)}static or(...g){return q.create(g,null,!0)}static greater(g,A){return F.create(g,A)}static greaterEquals(g,A){return H.create(g,A)}static smaller(g,A){return V.create(g,A)}static smallerEquals(g,A){return W.create(g,A)}static deserialize(g){return g==null?void 0:this.c.parse(g)}}e.$ri=n,n.c=new I({regexParsingWithErrorRecovery:!1});function r(N){const g=new I({regexParsingWithErrorRecovery:!1});return N.map(A=>(g.parse(A),g.lexingErrors.length>0?g.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,O.localize)(9,null,U.additionalInfo):(0,O.localize)(10,null),offset:U.offset,length:U.lexeme.length})):g.parsingErrors.length>0?g.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}e.$si=r;function i(N,g){const A=N?N.substituteConstants():void 0,U=g?g.substituteConstants():void 0;return!A&&!U?!0:!A||!U?!1:A.equals(U)}e.$ti=i;function t(N,g){return N.cmp(g)}class s{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return o.INSTANCE}}e.$ui=s,s.INSTANCE=new s;class o{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return s.INSTANCE}}e.$vi=o,o.INSTANCE=new o;class c{static create(g,A=null){const U=k.get(g);return typeof U=="boolean"?U?o.INSTANCE:s.INSTANCE:new c(g,A)}constructor(g,A){this.key=g,this.c=A,this.type=2}cmp(g){return g.type!==this.type?this.type-g.type:B(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=k.get(this.key);return typeof g=="boolean"?g?o.INSTANCE:s.INSTANCE:this}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.$wi=c;class y{static create(g,A,U=null){if(typeof A=="boolean")return A?c.create(g,U):D.create(g,U);const Q=k.get(g);return typeof Q=="boolean"?A===(Q?"true":"false")?o.INSTANCE:s.INSTANCE:new y(g,A,U)}constructor(g,A,U){this.c=g,this.d=A,this.f=U,this.type=4}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){const g=k.get(this.c);if(typeof g=="boolean"){const A=g?"true":"false";return this.d===A?o.INSTANCE:s.INSTANCE}return this}evaluate(g){return g.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(g){return g.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$xi=y;class d{static create(g,A){return new d(g,A)}constructor(g,A){this.d=g,this.f=A,this.type=10,this.c=null}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.d,this.f,g.d,g.f)}equals(g){return g.type===this.type?this.d===g.d&&this.f===g.f:!1}substituteConstants(){return this}evaluate(g){const A=g.getValue(this.f),U=g.getValue(this.d);return Array.isArray(A)?A.includes(U):typeof U=="string"&&typeof A=="object"&&A!==null?S.call(A,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(g){return g.mapIn(this.d,this.f)}negate(){return this.c||(this.c=l.create(this.d,this.f)),this.c}}e.$yi=d;class l{static create(g,A){return new l(g,A)}constructor(g,A){this.d=g,this.f=A,this.type=11,this.c=d.create(g,A)}cmp(g){return g.type!==this.type?this.type-g.type:this.c.cmp(g.c)}equals(g){return g.type===this.type?this.c.equals(g.c):!1}substituteConstants(){return this}evaluate(g){return!this.c.evaluate(g)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(g){return g.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$zi=l;class P{static create(g,A,U=null){if(typeof A=="boolean")return A?D.create(g,U):c.create(g,U);const Q=k.get(g);return typeof Q=="boolean"?A===(Q?"true":"false")?s.INSTANCE:o.INSTANCE:new P(g,A,U)}constructor(g,A,U){this.c=g,this.d=A,this.f=U,this.type=5}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){const g=k.get(this.c);if(typeof g=="boolean"){const A=g?"true":"false";return this.d===A?s.INSTANCE:o.INSTANCE}return this}evaluate(g){return g.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(g){return g.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Ai=P;class D{static create(g,A=null){const U=k.get(g);return typeof U=="boolean"?U?s.INSTANCE:o.INSTANCE:new D(g,A)}constructor(g,A){this.c=g,this.d=A,this.type=3}cmp(g){return g.type!==this.type?this.type-g.type:B(this.c,g.c)}equals(g){return g.type===this.type?this.c===g.c:!1}substituteConstants(){const g=k.get(this.c);return typeof g=="boolean"?g?s.INSTANCE:o.INSTANCE:this}evaluate(g){return!g.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(g){return g.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.$Bi=D;function T(N,g){if(typeof N=="string"){const A=parseFloat(N);isNaN(A)||(N=A)}return typeof N=="string"||typeof N=="number"?g(N):s.INSTANCE}class F{static create(g,A,U=null){return T(A,Q=>new F(g,Q,U))}constructor(g,A,U){this.c=g,this.d=A,this.f=U,this.type=12}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(g){return g.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Ci=F;class H{static create(g,A,U=null){return T(A,Q=>new H(g,Q,U))}constructor(g,A,U){this.c=g,this.d=A,this.f=U,this.type=13}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(g){return g.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Di=H;class V{static create(g,A,U=null){return T(A,Q=>new V(g,Q,U))}constructor(g,A,U){this.c=g,this.d=A,this.f=U,this.type=14}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(g){return g.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$Ei=V;class W{static create(g,A,U=null){return T(A,Q=>new W(g,Q,U))}constructor(g,A,U){this.c=g,this.d=A,this.f=U,this.type=15}cmp(g){return g.type!==this.type?this.type-g.type:ie(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(g){return g.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Fi=W;class x{static create(g,A){return new x(g,A)}constructor(g,A){this.d=g,this.f=A,this.type=7,this.c=null}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.d<g.d)return-1;if(this.d>g.d)return 1;const A=this.f?this.f.source:"",U=g.f?g.f.source:"";return A<U?-1:A>U?1:0}equals(g){if(g.type===this.type){const A=this.f?this.f.source:"",U=g.f?g.f.source:"";return this.d===g.d&&A===U}return!1}substituteConstants(){return this}evaluate(g){const A=g.getValue(this.d);return this.f?this.f.test(A):!1}serialize(){const g=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${g}`}keys(){return[this.d]}map(g){return g.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$Gi=x;class ee{static create(g){return new ee(g)}constructor(g){this.c=g,this.type=8}cmp(g){return g.type!==this.type?this.type-g.type:this.c.cmp(g.c)}equals(g){return g.type===this.type?this.c.equals(g.c):!1}substituteConstants(){return this}evaluate(g){return!this.c.evaluate(g)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(g){return new ee(this.c.map(g))}negate(){return this.c}}e.$Hi=ee;function X(N){let g=null;for(let A=0,U=N.length;A<U;A++){const Q=N[A].substituteConstants();if(N[A]!==Q&&g===null){g=[];for(let z=0;z<A;z++)g[z]=N[z]}g!==null&&(g[A]=Q)}return g===null?N:g}class _{static create(g,A,U){return _.d(g,A,U)}constructor(g,A){this.expr=g,this.c=A,this.type=6}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let A=0,U=this.expr.length;A<U;A++){const Q=t(this.expr[A],g.expr[A]);if(Q!==0)return Q}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let A=0,U=this.expr.length;A<U;A++)if(!this.expr[A].equals(g.expr[A]))return!1;return!0}return!1}substituteConstants(){const g=X(this.expr);return g===this.expr?this:_.create(g,this.c,!1)}evaluate(g){for(let A=0,U=this.expr.length;A<U;A++)if(!this.expr[A].evaluate(g))return!1;return!0}static d(g,A,U){const Q=[];let z=!1;for(const J of g)if(J){if(J.type===1){z=!0;continue}if(J.type===0)return s.INSTANCE;if(J.type===6){Q.push(...J.expr);continue}Q.push(J)}if(Q.length===0&&z)return o.INSTANCE;if(Q.length!==0){if(Q.length===1)return Q[0];Q.sort(t);for(let J=1;J<Q.length;J++)Q[J-1].equals(Q[J])&&(Q.splice(J,1),J--);if(Q.length===1)return Q[0];for(;Q.length>1;){const J=Q[Q.length-1];if(J.type!==9)break;Q.pop();const te=Q.pop(),oe=Q.length===0,he=q.create(J.expr.map(fe=>_.create([fe,te],null,U)),null,oe);he&&(Q.push(he),Q.sort(t))}if(Q.length===1)return Q[0];if(U){for(let J=0;J<Q.length;J++)for(let te=J+1;te<Q.length;te++)if(Q[J].negate().equals(Q[te]))return s.INSTANCE;if(Q.length===1)return Q[0]}return new _(Q,A)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(const A of this.expr)g.push(...A.keys());return g}map(g){return new _(this.expr.map(A=>A.map(g)),null)}negate(){if(!this.c){const g=[];for(const A of this.expr)g.push(A.negate());this.c=q.create(g,this,!0)}return this.c}}e.$Ii=_;class q{static create(g,A,U){return q.d(g,A,U)}constructor(g,A){this.expr=g,this.c=A,this.type=9}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let A=0,U=this.expr.length;A<U;A++){const Q=t(this.expr[A],g.expr[A]);if(Q!==0)return Q}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let A=0,U=this.expr.length;A<U;A++)if(!this.expr[A].equals(g.expr[A]))return!1;return!0}return!1}substituteConstants(){const g=X(this.expr);return g===this.expr?this:q.create(g,this.c,!1)}evaluate(g){for(let A=0,U=this.expr.length;A<U;A++)if(this.expr[A].evaluate(g))return!0;return!1}static d(g,A,U){let Q=[],z=!1;if(g){for(let J=0,te=g.length;J<te;J++){const oe=g[J];if(oe){if(oe.type===0){z=!0;continue}if(oe.type===1)return o.INSTANCE;if(oe.type===9){Q=Q.concat(oe.expr);continue}Q.push(oe)}}if(Q.length===0&&z)return s.INSTANCE;Q.sort(t)}if(Q.length!==0){if(Q.length===1)return Q[0];for(let J=1;J<Q.length;J++)Q[J-1].equals(Q[J])&&(Q.splice(J,1),J--);if(Q.length===1)return Q[0];if(U){for(let J=0;J<Q.length;J++)for(let te=J+1;te<Q.length;te++)if(Q[J].negate().equals(Q[te]))return o.INSTANCE;if(Q.length===1)return Q[0]}return new q(Q,A)}}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(const A of this.expr)g.push(...A.keys());return g}map(g){return new q(this.expr.map(A=>A.map(g)),null)}negate(){if(!this.c){const g=[];for(const A of this.expr)g.push(A.negate());for(;g.length>1;){const A=g.shift(),U=g.shift(),Q=[];for(const z of Z(A))for(const J of Z(U))Q.push(_.create([z,J],null,!1));g.unshift(q.create(Q,null,!1))}this.c=q.create(g,this,!0)}return this.c}}e.$Ji=q;class G extends c{static all(){return G.d.values()}constructor(g,A,U){super(g,null),this.f=A,typeof U=="object"?G.d.push({...U,key:g}):U!==!0&&G.d.push({key:g,description:U,type:A!=null?typeof A:void 0})}bindTo(g){return g.createKey(this.key,this.f)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(g){return y.create(this.key,g)}notEqualsTo(g){return P.create(this.key,g)}}e.$Ki=G,G.d=[],e.$Li=(0,j.$lh)("contextKeyService");function B(N,g){return N<g?-1:N>g?1:0}function ie(N,g,A,U){return N<A?-1:N>A?1:g<U?-1:g>U?1:0}function re(N,g){if(N.type===0||g.type===1)return!0;if(N.type===9)return g.type===9?K(N.expr,g.expr):!1;if(g.type===9){for(const A of g.expr)if(re(N,A))return!0;return!1}if(N.type===6){if(g.type===6)return K(g.expr,N.expr);for(const A of N.expr)if(re(A,g))return!0;return!1}return N.equals(g)}e.$Mi=re;function K(N,g){let A=0,U=0;for(;A<N.length&&U<g.length;){const Q=N[A].cmp(g[U]);if(Q<0)return!1;Q===0&&A++,U++}return A===N.length}function Z(N){return N.type===9?N.expr:[N]}}),define(ae[95],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.ID=void 0,e.ID="diagnosticsService",e.$1l=(0,R.$lh)(e.ID);function M(j){return!!j.hostName&&!!j.errorMessage}e.$2l=M;class L{async getPerformanceInfo(O,C){return{}}async getSystemInfo(O,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,C){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$3l=L}),define(ae[96],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0,e.$qn=(0,R.$lh)("downloadService")}),define(ae[14],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=void 0,e.$sh=(0,R.$lh)("environmentService"),e.$th=(0,R.$mh)(e.$sh)}),define(ae[28],ce([0,1,146,4]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ln=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=void 0,e.$zn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$An=new RegExp(e.$zn),e.$Bn="__web_extension",e.$Cn="skipWalkthrough",e.$Dn="extensionsSync";function L(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$En=L;function j(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Fn=j;function O(u,p){switch(u){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Gn=O;function C(u,p){return p==="web"&&!u.includes("web")}e.$Hn=C;function k(u,p,w){return C(p,w)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===w?!0:m(w).includes(u)}e.$In=k;function m(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Jn=m;function S(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$Kn=S;var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var b;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var f;(function(u){u.Install="install",u.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var $;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Ln=(0,M.$lh)("extensionGalleryService");var v;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var a;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class h extends Error{constructor(p,w){super(p),this.code=w,this.name=w}}e.$Mn=h,e.$Nn=(0,M.$lh)("extensionManagementService"),e.$On="extensionsIdentifiers/disabled",e.$Pn="extensionsIdentifiers/enabled",e.$Qn=(0,M.$lh)("IGlobalExtensionEnablementService"),e.$Rn=(0,M.$lh)("IExtensionTipsService"),e.$Sn=(0,R.localize)(0,null),e.$Tn={value:e.$Sn,original:"Extensions"},e.$Un={value:(0,R.localize)(1,null),original:"Preferences"}}),define(ae[181],ce([0,1,3,2,31,12,91,28]),function(ne,e,R,M,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=void 0;function k(a,h){return a?j.URI.revive(h?h.transformIncoming(a):a):void 0}function m(a,h){return h?h.transformOutgoingURI(a):a}function S(a,h){h=h||O.$km;const u=a.manifest;return{...(0,O.$nm)({...a,manifest:void 0},h),manifest:u}}function E(a,h){return a?.profileLocation?(0,O.$nm)(a,h??O.$km):a}function b(a,h){return h?(0,L.$Fm)(a,u=>u instanceof j.URI?h.transformOutgoingURI(u):void 0):a}class f{constructor(h,u){this.a=h,this.b=u,this.onInstallExtension=R.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=R.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,u){const p=this.b(h);switch(u){case"onInstallExtension":return R.Event.map(this.onInstallExtension,w=>({...w,profileLocation:w.profileLocation?m(w.profileLocation,p):w.profileLocation}));case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,w=>w.map(I=>({...I,local:I.local?b(I.local,p):I.local,profileLocation:I.profileLocation?m(I.profileLocation,p):I.profileLocation})));case"onUninstallExtension":return R.Event.map(this.onUninstallExtension,w=>({...w,profileLocation:w.profileLocation?m(w.profileLocation,p):w.profileLocation}));case"onDidUninstallExtension":return R.Event.map(this.onDidUninstallExtension,w=>({...w,profileLocation:w.profileLocation?m(w.profileLocation,p):w.profileLocation}));case"onDidUpdateExtensionMetadata":return R.Event.map(this.onDidUpdateExtensionMetadata,w=>b(w,p))}throw new Error("Invalid listen")}async call(h,u,p){const w=this.b(h);switch(u){case"zip":{const I=S(p[0],w),n=await this.a.zip(I);return m(n,w)}case"unzip":return this.a.unzip(k(p[0],w));case"install":return this.a.install(k(p[0],w),E(p[1],w));case"installFromLocation":return this.a.installFromLocation(k(p[0],w),k(p[1],w));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(p[0],k(p[1],w),k(p[2],w));case"getManifest":return this.a.getManifest(k(p[0],w));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(p[0]);case"installFromGallery":return this.a.installFromGallery(p[0],E(p[1],w));case"installGalleryExtensions":{const I=p[0];return this.a.installGalleryExtensions(I.map(({extension:n,options:r})=>({extension:n,options:E(r,w)??{}})))}case"uninstall":return this.a.uninstall(S(p[0],w),E(p[1],w));case"reinstallFromGallery":return this.a.reinstallFromGallery(S(p[0],w));case"getInstalled":return(await this.a.getInstalled(p[0],k(p[1],w))).map(n=>b(n,w));case"copyExtensions":return this.a.copyExtensions(k(p[0],w),k(p[1],w));case"updateMetadata":{const I=await this.a.updateMetadata(S(p[0],w),p[1],k(p[2],w));return b(I,w)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(p[0],p[1],p[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Uo=f;class $ extends M.$kb{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.k=h,this.c=this.B(new R.$5c),this.f=this.B(new R.$5c),this.g=this.B(new R.$5c),this.h=this.B(new R.$5c),this.j=this.B(new R.$5c),this.B(this.k.listen("onInstallExtension")(u=>this.l(this.c,{...u,source:this.m(u.source)?j.URI.revive(u.source):u.source,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(u=>this.l(this.f,u.map(p=>({...p,local:p.local?S(p.local,null):p.local,source:this.m(p.source)?j.URI.revive(p.source):p.source,profileLocation:j.URI.revive(p.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(u=>this.l(this.g,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(u=>this.l(this.h,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(S(u,null))))}l(h,u){h.fire(u)}m(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(h){const u=await this.getTargetPlatform();return h.allTargetPlatforms.some(p=>(0,C.$In)(p,h.allTargetPlatforms,u))}zip(h){return Promise.resolve(this.k.call("zip",[h]).then(u=>j.URI.revive(u)))}unzip(h){return Promise.resolve(this.k.call("unzip",[h]))}install(h,u){return Promise.resolve(this.k.call("install",[h,u])).then(p=>S(p,null))}installFromLocation(h,u){return Promise.resolve(this.k.call("installFromLocation",[h,u])).then(p=>S(p,null))}async installExtensionsFromProfile(h,u,p){return(await this.k.call("installExtensionsFromProfile",[h,u,p])).map(I=>S(I,null))}getManifest(h){return Promise.resolve(this.k.call("getManifest",[h]))}installFromGallery(h,u){return Promise.resolve(this.k.call("installFromGallery",[h,u])).then(p=>S(p,null))}async installGalleryExtensions(h){return(await this.k.call("installGalleryExtensions",[h])).map(p=>({...p,local:p.local?S(p.local,null):p.local,source:this.m(p.source)?j.URI.revive(p.source):p.source,profileLocation:j.URI.revive(p.profileLocation)}))}uninstall(h,u){return Promise.resolve(this.k.call("uninstall",[h,u]))}reinstallFromGallery(h){return Promise.resolve(this.k.call("reinstallFromGallery",[h])).then(u=>S(u,null))}getInstalled(h=null,u){return Promise.resolve(this.k.call("getInstalled",[h,u])).then(p=>p.map(w=>S(w,null)))}updateMetadata(h,u,p){return Promise.resolve(this.k.call("updateMetadata",[h,u,p])).then(w=>S(w,null))}copyExtensions(h,u){return this.k.call("copyExtensions",[h,u])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(h,u,p){const w=await this.k.call("download",[h,u,p]);return j.URI.revive(w)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Vo=$;class v{constructor(h){this.a=h}listen(h,u){throw new Error("Invalid listen")}call(h,u,p){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Wo=v}),define(ae[97],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=void 0,e.$Ro=(0,R.$lh)("IExtensionSignatureVerificationService");class M{b(){return this.a||(this.a=new Promise((j,O)=>ne(["node-vsce-sign"],async C=>j(C),O))),this.a}async verify(j,O,C){let k;try{k=await this.b()}catch{return!1}return k.verify(j,O,C)}}e.$So=M}),define(ae[98],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MRb=e.RecommendationsNotificationResult=e.$LRb=e.RecommendationSource=void 0;var M;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(M||(e.RecommendationSource=M={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$LRb=L;var j;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$MRb=(0,R.$lh)("IExtensionRecommendationNotificationService")}),define(ae[13],ce([0,1,46,15,27,10,12,153,4,5,25]),function(ne,e,R,M,L,j,O,C,k,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.FileKind=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.FileOperationResult=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.FileChangeType=e.$6j=e.FileOperation=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.FileSystemProviderErrorCode=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Pj=e.$Oj=void 0,e.$Oj=(0,k.$lh)("fileService");function E(B){return B.create===!0}e.$Pj=E;var b;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var f;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var $;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function v(B){return!!(B.capabilities&2)}e.$Qj=v;function a(B){return!!(B.capabilities&8)}e.$Rj=a;function h(B){return!!(B.capabilities&131072)}e.$Sj=h;function u(B){return!!(B.capabilities&4)}e.$Tj=u;function p(B){return!!(B.capabilities&16)}e.$Uj=p;function w(B){return v(B)?!!(B.capabilities&16384):!1}e.$Vj=w;function I(B){return v(B)?!!(B.capabilities&32768):!1}e.$Wj=I;function n(B){return!!(B.capabilities&65536)}e.$Xj=n;function r(B){return!!(B.capabilities&2048)}e.$Yj=r;var i;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(i||(e.FileSystemProviderErrorCode=i={}));class t extends Error{static create(ie,re){const K=new t(ie.toString(),re);return c(K,re),K}constructor(ie,re){super(ie),this.code=re}}e.$Zj=t;function s(B,ie){return t.create(B,ie)}e.$1j=s;function o(B){return B||s((0,C.localize)(0,null),i.Unknown)}e.$2j=o;function c(B,ie){return B.name=ie?`${ie} (FileSystemError)`:"FileSystemError",B}e.$3j=c;function y(B){if(!B)return i.Unknown;if(B instanceof t)return B.code;const ie=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!ie)return i.Unknown;switch(ie[1]){case i.FileExists:return i.FileExists;case i.FileIsADirectory:return i.FileIsADirectory;case i.FileNotADirectory:return i.FileNotADirectory;case i.FileNotFound:return i.FileNotFound;case i.FileTooLarge:return i.FileTooLarge;case i.FileWriteLocked:return i.FileWriteLocked;case i.NoPermissions:return i.NoPermissions;case i.Unavailable:return i.Unavailable}return i.Unknown}e.$4j=y;function d(B){if(B instanceof H)return B.fileOperationResult;switch(y(B)){case i.FileNotFound:return 1;case i.FileIsADirectory:return 0;case i.FileNotADirectory:return 9;case i.FileWriteLocked:return 5;case i.NoPermissions:return 6;case i.FileExists:return 4;case i.FileTooLarge:return 7;default:return 10}}e.$5j=d;var l;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(l||(e.FileOperation=l={}));class P{constructor(ie,re,K){this.resource=ie,this.operation=re,this.target=K}isOperation(ie){return this.operation===ie}}e.$6j=P;var D;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(D||(e.FileChangeType=D={}));class T{constructor(ie,re){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const K=new Map;for(const Z of ie){const N=K.get(Z.type);switch(N?N.push([Z.resource,Z]):K.set(Z.type,[[Z.resource,Z]]),Z.type){case 1:this.rawAdded.push(Z.resource);break;case 0:this.rawUpdated.push(Z.resource);break;case 2:this.rawDeleted.push(Z.resource);break}}for(const[Z,N]of K)switch(Z){case 1:this.a=R.$rh.forUris(()=>re),this.a.fill(N);break;case 0:this.b=R.$rh.forUris(()=>re),this.b.fill(N);break;case 2:this.c=R.$rh.forUris(()=>re),this.c.fill(N);break}}contains(ie,...re){return this.d(ie,{includeChildren:!1},...re)}affects(ie,...re){return this.d(ie,{includeChildren:!0},...re)}d(ie,re,...K){if(!ie)return!1;const Z=K.length>0;return!!((!Z||K.includes(1))&&(this.a?.get(ie)||re.includeChildren&&this.a?.findSuperstr(ie))||(!Z||K.includes(0))&&(this.b?.get(ie)||re.includeChildren&&this.b?.findSuperstr(ie))||(!Z||K.includes(2))&&(this.c?.findSubstr(ie)||re.includeChildren&&this.c?.findSuperstr(ie)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$7j=T;function F(B,ie,re){return!B||!ie||B===ie||ie.length>B.length?!1:(ie.charAt(ie.length-1)!==M.sep&&(ie+=M.sep),re?(0,L.$Kd)(B,ie):B.indexOf(ie)===0)}e.$8j=F;class H extends Error{constructor(ie,re,K){super(ie),this.fileOperationResult=re,this.options=K}}e.$9j=H;class V extends H{constructor(ie,re,K,Z){super(ie,re,Z),this.fileOperationResult=re,this.size=K}}e.$0j=V;class W extends H{constructor(ie,re,K){super(ie,2,K),this.stat=re}}e.$$j=W;var x;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(x||(e.FileOperationResult=x={})),e.$_j={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ak={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$bk="files.associations",e.$ck="files.exclude",e.$dk="files.readonlyInclude",e.$ek="files.readonlyExclude",e.$fk="files.readonlyFromPermissions";var ee;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.$gk="";function X(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.$hk=X;async function _(B,ie){if(!ie.hasProvider(O.URI.from({scheme:B.scheme})))return new Promise(re=>{const K=ie.onDidChangeFileSystemProviderRegistrations(Z=>{Z.scheme===B.scheme&&Z.added&&(K.dispose(),re())})})}e.$ik=_;class q{static formatSize(ie){return(0,j.$ke)(ie)||(ie=0),ie<q.KB?(0,C.localize)(1,null,ie.toFixed(0)):ie<q.MB?(0,C.localize)(2,null,(ie/q.KB).toFixed(2)):ie<q.GB?(0,C.localize)(3,null,(ie/q.MB).toFixed(2)):ie<q.TB?(0,C.localize)(4,null,(ie/q.GB).toFixed(2)):(0,C.localize)(5,null,(ie/q.TB).toFixed(2))}}e.$jk=q,q.KB=1024,q.MB=q.KB*q.KB,q.GB=q.MB*q.KB,q.TB=q.GB*q.KB;function G(B){const ie=typeof B=="string"||B?.scheme===S.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===S.Schemas.file?1024*q.MB:ie?10*q.MB:m.$o?50*q.MB:1024*q.MB}e.$kk=G});var Y=this&&this.__param||function(ne,e){return function(R,M){e(R,M,ne)}};define(ae[182],ce([0,1,69,42,13]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D4b=void 0;let j=e.$D4b=class{constructor(C){this.a=C}async checksum(C){const k=(await this.a.readFileStream(C)).value;return new Promise((m,S)=>{const E=(0,R.createHash)("md5");(0,M.$Ab)(k,{onData:b=>E.update(b.buffer),onError:b=>S(b),onEnd:()=>m(E.digest("base64").replace(/=+$/,""))})})}};e.$D4b=j=we([Y(0,L.$Oj)],j)}),define(ae[183],ce([0,1,16,38,7,3,2,42,12,32,13]),function(ne,e,R,M,L,j,O,C,k,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=e.$eM=void 0,e.$eM="localFilesystem";class E extends O.$kb{constructor(f,$){super(),this.a=f,this.b=$,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$5c),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$5c),this.onDidWatchError=this.g.event,this.h=(0,m.$3e)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,$){const{buffer:v}=await this.a.call("readFile",[f,$]);return v}readFileStream(f,$,v){const a=(0,C.$wb)(u=>R.$Ib.concat(u.map(p=>R.$Ib.wrap(p))).buffer),h=this.a.listen("readFileStream",[f,$])(u=>{if(u instanceof R.$Ib)a.write(u.buffer);else{if(u==="end")a.end();else{let p;if(u instanceof Error)p=u;else{const w=u;p=(0,S.$1j)(w.message??(0,M.$9h)(w),w.code??S.FileSystemProviderErrorCode.Unknown)}a.error(p),a.end()}h.dispose()}});return v.onCancellationRequested(()=>{a.error((0,L.$3)()),a.end(),h.dispose()}),a}writeFile(f,$,v){return this.a.call("writeFile",[f,R.$Ib.wrap($),v])}open(f,$){return this.a.call("open",[f,$])}close(f){return this.a.call("close",[f])}async read(f,$,v,a,h){const[u,p]=await this.a.call("read",[f,$,h]);return v.set(u.buffer.slice(0,p),a),p}write(f,$,v,a,h){return this.a.call("write",[f,$,R.$Ib.wrap(v),a,h])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,$){return this.a.call("delete",[f,$])}rename(f,$,v){return this.a.call("rename",[f,$,v])}copy(f,$,v){return this.a.call("copy",[f,$,v])}cloneFile(f,$){return this.a.call("cloneFile",[f,$])}i(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const $=f;this.f.fire($.map(v=>({resource:k.URI.revive(v.resource),type:v.type})))}else{const $=f;this.g.fire($)}}))}watch(f,$){const v=(0,m.$3e)();return this.a.call("watch",[this.h,v,f,$]),(0,O.$ib)(()=>this.a.call("unwatch",[this.h,v]))}}e.$fM=E}),define(ae[99],ce([0,1,16,7,154,13]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;async function O(S,E,b,f,$,v){let a;try{await C(S,E,b,f,$,v)}catch(h){a=h}finally{a&&$.errorTransformer&&(a=$.errorTransformer(a)),typeof a<"u"&&b.error(a),b.end()}}e.$np=O;async function C(S,E,b,f,$,v){k(v);const a=await S.open(E,{create:!1});try{k(v);let h=0,u=0,p=$&&typeof $.length=="number"?$.length:void 0,w=R.$Ib.alloc(Math.min($.bufferSize,typeof p=="number"?p:$.bufferSize)),I=$&&typeof $.position=="number"?$.position:0,n=0;do u=await S.read(a,I,w.buffer,n,w.byteLength-n),I+=u,n+=u,h+=u,typeof p=="number"&&(p-=u),n===w.byteLength&&(await b.write(f(w)),w=R.$Ib.alloc(Math.min($.bufferSize,typeof p=="number"?p:$.bufferSize)),n=0);while(u>0&&(typeof p!="number"||p>0)&&k(v)&&m(h,$));if(n>0){let r=n;typeof p=="number"&&(r=Math.min(n,p)),b.write(f(w.slice(0,r)))}}catch(h){throw(0,j.$2j)(h)}finally{await S.close(a)}}function k(S){if(S.isCancellationRequested)throw(0,M.$3)();return!0}function m(S,E){if(typeof E?.limits?.size=="number"&&S>E.limits.size)throw(0,j.$1j)((0,L.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[53],ce([0,1,90,2,15,5,12,13]),function(ne,e,R,M,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=void 0;function k(h){return h.recursive===!0}e.$pp=k;class m extends M.$kb{constructor(u,p,w,I){super(),this.h=u,this.i=p,this.j=w,this.k=I,this.c=this.B(new M.$lb),this.f=void 0,this.g=0}m(){const u=new M.$jb;this.c.value=u,this.b=this.l(u),this.b.setVerboseLogging(this.j),u.add(this.b.onDidChangeFile(p=>this.h(p))),u.add(this.b.onDidLogMessage(p=>this.i(p))),u.add(this.b.onDidError(p=>this.n(p)))}n(u){this.k.restartOnError?this.g<m.a&&this.f?(this.r(`restarting watcher after error: ${u}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${u}`):this.r(u)}p(u){this.g++,this.m(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.j=u,await this.b?.setVerboseLogging(u)}r(u){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${u}`})}s(u){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$qp=m,m.a=5;class S extends m{constructor(u,p,w){super(u,p,w,{type:"node.js",restartOnError:!1})}}e.$rp=S;class E extends m{constructor(u,p,w){super(u,p,w,{type:"universal",restartOnError:!0})}}e.$sp=E;function b(h){return h.map(u=>({type:u.type,resource:O.URI.file(u.path)}))}e.$tp=b;function f(h){const u=new a;for(const p of h)u.processEvent(p);return u.coalesce()}e.$up=f;function $(h,u){return typeof u=="string"&&!u.startsWith(R.$9i)&&!(0,L.$0b)(u)?{base:h,pattern:u}:u}e.$vp=$;function v(h,u){const p=[];for(const w of u)p.push((0,R.$aj)($(h,w)));return p}e.$wp=v;class a{constructor(){this.a=new Set,this.b=new Map}c(u){return j.$k?u.path:u.path.toLowerCase()}processEvent(u){const p=this.b.get(this.c(u));let w=!1;if(p){const I=p.type,n=u.type;p.path!==u.path&&(u.type===2||u.type===1)?w=!0:I===1&&n===2?(this.b.delete(this.c(u)),this.a.delete(p)):I===2&&n===1?p.type=0:I===1&&n===0||(p.type=n)}else w=!0;w&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],p=[];return Array.from(this.a).filter(w=>w.type!==2?(u.push(w),!1):!0).sort((w,I)=>w.path.length-I.path.length).filter(w=>p.some(I=>(0,C.$8j)(w.path,I,!j.$k))?!1:(p.push(w.path),!0)).concat(u)}}}),define(ae[184],ce([0,1,51,6,26,47,2,86,15,5,137,30,53]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=void 0;class f extends O.$kb{constructor(a,h,u,p){super(),this.j=a,this.k=h,this.l=u,this.m=p,this.c=this.B(new M.$Fg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},w=>this.k(w))),this.f=this.B(new M.$Eg(w=>this.u(w),f.b)),this.g=(0,b.$wp)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,b.$wp)(this.j.path,this.j.includes):void 0,this.i=new L.$bd,this.ready=this.n()}async n(){try{const a=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const h=await E.Promises.stat(a);this.B(await this.s(a,h.isDirectory()))}catch(a){a.code!=="ENOENT"?this.w(a):this.z(a)}}async r(a){let h=a.path;try{h=await E.Promises.realpath(a.path),a.path===h&&(h=await(0,S.$Gp)(a.path)??a.path),a.path!==h&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${h})`)}catch{}return h}async s(a,h){if(m.$j&&(0,j.$He)(a,"/Volumes/",!0))return this.w(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$kb.None;const u=new L.$bd(this.i.token),p=new O.$jb;try{const w=(0,k.$cc)(a),I=(0,R.watch)(a);p.add((0,O.$ib)(()=>{I.removeAllListeners(),I.close()})),this.z(`Started watching: '${a}'`);const n=new Set;if(h)try{for(const i of await E.Promises.readdir(a))n.add(i)}catch(i){this.w(i)}const r=new Map;p.add((0,O.$ib)(()=>{for(const[,i]of r)i.dispose();r.clear()})),I.on("error",(i,t)=>{this.w(`Failed to watch ${a} for changes using fs.watch() (${i}, ${t})`),this.dispose()}),I.on("change",(i,t)=>{if(u.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${t}`);let s="";if(t&&(s=t.toString(),m.$j&&(s=(0,C.$3k)(s))),!(!s||i!=="change"&&i!=="rename"))if(h)if(i==="rename"){r.get(s)?.dispose();const o=setTimeout(async()=>{if(r.delete(s),s===w&&!await E.Promises.exists(a)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.v((0,k.$$b)(a,s));if(u.token.isCancellationRequested)return;let y;c?n.has(s)?y=0:(y=1,n.add(s)):(n.delete(s),y=2),this.t({path:(0,k.$$b)(this.j.path,s),type:y})},f.a);r.set(s,(0,O.$ib)(()=>clearTimeout(o)))}else{let o;n.has(s)?o=0:(o=1,n.add(s)),this.t({path:(0,k.$$b)(this.j.path,s),type:o})}else if(i==="rename"||s!==w){const o=setTimeout(async()=>{const c=await E.Promises.exists(a);u.token.isCancellationRequested||(c?(this.t({path:this.j.path,type:0},!0),p.add(await this.s(a,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);p.clear(),p.add((0,O.$ib)(()=>clearTimeout(o)))}else this.t({path:this.j.path,type:0},!0)})}catch(w){await E.Promises.exists(a)&&!u.token.isCancellationRequested&&this.w(`Failed to watch ${a} for changes using fs.watch() (${w.toString()})`)}return(0,O.$ib)(()=>{u.dispose(!0),p.dispose()})}t(a,h=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!h&&this.g.some(u=>u(a.path))?this.m&&this.z(` >> ignored (excluded) ${a.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(u=>u(a.path))?this.m&&this.z(` >> ignored (not included) ${a.path}`):this.f.work(a))}u(a){const h=(0,b.$up)(a);if(h.length>0){if(this.m)for(const p of h)this.z(`>> normalized ${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`);this.c.work(h)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(a){if(m.$k)return E.Promises.exists(a);try{const h=(0,k.$cc)(a);return(await E.Promises.readdir((0,k.$bc)(a))).some(p=>p===h)}catch(h){return this.z(h),!1}}setVerboseLogging(a){this.m=a}w(a){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}y(a){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}z(a){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Jp=f,f.a=100,f.b=75;async function $(v,a,h,u,p=512){const w=await E.Promises.open(v,"r"),I=Buffer.allocUnsafe(p),n=new L.$bd(u);let r,i=!1;const t={path:v,excludes:[],recursive:!1},s=new f(t,o=>{(async()=>{for(const{type:c}of o)if(c===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:y}=await E.Promises.read(w,I,0,p,null);if(!y||n.token.isCancellationRequested)break;a(I.slice(0,y))}}catch(y){r=new Error(y),n.dispose(!0)}finally{i=!1}}})()});return await s.ready,h(),new Promise((o,c)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await E.Promises.close(w)}catch(y){r=new Error(y)}r?c(r):o()})})}e.$Kp=$}),define(ae[185],ce([0,1,3,90,2,5,184]),function(ne,e,R,M,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;class C extends L.$kb{constructor(){super(...arguments),this.a=this.B(new R.$5c),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$5c),this.onDidLogMessage=this.b.event,this.onDidError=R.Event.None,this.c=new Map,this.f=!1}async watch(m){const S=this.i(m),E=S.filter(f=>{const $=this.c.get(f.path);return $?!(0,M.$ej)($.request.excludes,f.excludes)||!(0,M.$ej)($.request.includes,f.includes):!0}),b=Array.from(this.c.values()).filter(({request:f})=>!S.find($=>$.path===f.path&&(0,M.$ej)($.excludes,f.excludes)&&(0,M.$ej)($.includes,f.includes))).map(({request:f})=>f.path);E.length&&this.j(`Request to start watching: ${E.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),b.length&&this.j(`Request to stop watching: ${b.join(",")}`);for(const f of b)this.h(f);for(const f of E)this.g(f)}g(m){const S=new O.$Jp(m,b=>this.a.fire(b),b=>this.b.fire(b),this.f),E={request:m,instance:S};this.c.set(m.path,E)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const S=this.c.get(m);S&&(this.c.delete(m),S.instance.dispose())}i(m){const S=new Map;for(const E of m){const b=j.$k?E.path:E.path.toLowerCase();S.set(b,E)}return Array.from(S.values())}async setVerboseLogging(m){this.f=m;for(const[,S]of this.c)S.instance.setVerboseLogging(m)}j(m){this.f&&this.b.fire({type:"trace",message:this.k(m)})}k(m,S){return S?`[File Watcher (node.js)] ${m} (path: ${S.request.path})`:`[File Watcher (node.js)] ${m}`}}e.$Lp=C}),define(ae[186],ce([0,1,53,185]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class L extends R.$rp{constructor(O,C,k){super(O,C,k),this.m()}l(){return new M.$Lp}}e.$Mp=L}),define(ae[187],ce([0,1,25,43,93,53]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;class O extends j.$sp{constructor(k,m,S){super(k,m,S),this.m()}l(k){const m=k.add(new L.$Dp(R.$1e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(m.onDidProcessExit(({code:S,signal:E})=>this.n(`terminated by itself with code ${S}, signal: ${E}`))),M.ProxyChannel.toService((0,M.$5g)(m.getChannel("watcher")))}}e.$Ep=O}),define(ae[70],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=void 0;class R{constructor(...L){this.a=new Map;for(const[j,O]of L)this.set(j,O)}set(L,j){const O=this.a.get(L);return this.a.set(L,j),O}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$jh=R}),define(ae[188],ce([0,1,6,7,2,68,179,4,70,85]),function(ne,e,R,M,L,j,O,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0;const S=!1;class E extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class b{constructor(a=new k.$jh,h=!1,u,p=S){this.f=a,this.g=h,this.h=u,this.i=p,this.o=new Set,this.f.set(C.$kh,this),this._globalGraph=p?u?._globalGraph??new O.$Pp(w=>w):void 0}createChild(a){return new b(a,this.g,this,this.i)}invokeFunction(a,...h){const u=$.traceInvocation(this.i,a);let p=!1;try{return a({get:I=>{if(p)throw(0,M.$5)("service accessor is only valid during the invocation of its target method");const n=this.m(I,u);if(!n)throw new Error(`[invokeFunction] unknown service '${I}'`);return n}},...h)}finally{p=!0,u.stop()}}createInstance(a,...h){let u,p;return a instanceof j.$ih?(u=$.traceCreation(this.i,a.ctor),p=this.j(a.ctor,a.staticArguments.concat(h),u)):(u=$.traceCreation(this.i,a),p=this.j(a,h,u)),u.stop(),p}j(a,h=[],u){const p=C._util.getServiceDependencies(a).sort((n,r)=>n.index-r.index),w=[];for(const n of p){const r=this.m(n.id,u);r||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${n.id}.`,!1),w.push(r)}const I=p.length>0?p[0].index:h.length;if(h.length!==I){console.trace(`[createInstance] First service dependency of ${a.name} at position ${I+1} conflicts with ${h.length} static arguments`);const n=I-h.length;n>0?h=h.concat(new Array(n)):h=h.slice(0,I)}return Reflect.construct(a,h.concat(w))}k(a,h){if(this.f.get(a)instanceof j.$ih)this.f.set(a,h);else if(this.h)this.h.k(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const h=this.f.get(a);return!h&&this.h?this.h.l(a):h}m(a,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const u=this.l(a);return u instanceof j.$ih?this.q(a,u,h.branch(a,!0)):(h.branch(a,!1),u)}q(a,h,u){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,h,u)}finally{this.o.delete(a)}}r(a,h,u){const p=new O.$Pp(n=>n.id.toString());let w=0;const I=[{id:a,desc:h,_trace:u}];for(;I.length;){const n=I.pop();if(p.lookupOrInsertNode(n),w++>1e3)throw new E(p);for(const r of C._util.getServiceDependencies(n.desc.ctor)){const i=this.l(r.id);if(i||this.u(`[createInstance] ${a} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),i instanceof j.$ih){const t={id:r.id,desc:i,_trace:n._trace.branch(r.id,!0)};p.insertEdge(n,t),I.push(t)}}}for(;;){const n=p.roots();if(n.length===0){if(!p.isEmpty())throw new E(p);break}for(const{data:r}of n){if(this.l(r.id)instanceof j.$ih){const t=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,t)}p.removeNode(r)}}return this.l(a)}s(a,h,u=[],p,w){if(this.f.get(a)instanceof j.$ih)return this.t(a,h,u,p,w);if(this.h)return this.h.s(a,h,u,p,w);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(a,h,u=[],p,w){if(p){const I=new b(void 0,this.g,this,this.i);I.c=String(a);const n=new Map,r=new R.$Hg(()=>{const i=I.j(h,u,w);for(const[t,s]of n){const o=i[t];if(typeof o=="function")for(const c of s)o.apply(i,c)}return n.clear(),i});return new Proxy(Object.create(null),{get(i,t){if(!r.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let c=n.get(t);return c||(c=new m.$jc,n.set(t,c)),(d,l,P)=>{const D=c.push([d,l,P]);return(0,L.$ib)(D)}}if(t in i)return i[t];const s=r.value;let o=s[t];return typeof o!="function"||(o=o.bind(s),i[t]=o),o},set(i,t,s){return r.value[t]=s,!0},getPrototypeOf(i){return h.prototype}})}else return this.j(h,u,w)}u(a,h){if(h&&console.warn(a),this.g)throw new Error(a)}}e.$Qp=b;var f;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(f||(f={}));class ${static traceInvocation(a,h){return a?new $(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(a,h){return a?new $(1,h.name):$.c}constructor(a,h){this.type=a,this.name=h,this.g=Date.now(),this.h=[]}branch(a,h){const u=new $(3,a.toString());return this.h.push([a,h,u]),u}stop(){const a=Date.now()-this.g;$.f+=a;let h=!1;function u(w,I){const n=[],r=new Array(w+1).join("	");for(const[i,t,s]of I.h)if(t&&s){h=!0,n.push(`${r}CREATES -> ${i}`);const o=u(w+1,s);o&&n.push(o)}else n.push(`${r}uses -> ${i}`);return n.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(a>2||h)&&$.all.add(p.join(`
`))}}e.$Rp=$,$.all=new Set,$.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}},$.f=0}),define(ae[71],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b4b=e.$a4b=void 0,e.$a4b=(0,R.$lh)("mainProcessService");class M{constructor(j,O){this.a=j,this.b=O}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,O){this.a.registerChannel(j,O)}}e.$b4b=M}),define(ae[72],ce([0,1,26,2,5,156,28,4]),function(ne,e,R,M,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=e.$sq=void 0;function k(S){return S.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$sq=k,e.$tq=(0,C.$lh)("languagePackService");let m=e.$uq=class extends M.$kb{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new R.$bd;setTimeout(()=>E.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const $=b.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some(a=>a.startsWith("lp-"))).map(v=>{const a=v.properties.localizedLanguages?.[0],h=k(v);return{...this.f(h,a,v),extensionId:v.identifier.id,galleryExtension:v}});return $.push(this.f("en","English")),$}f(E,b,f){const $=b??E;let v;if($!==E&&(v=`(${E})`),E.toLowerCase()===L.$v.toLowerCase()&&(v??="",v+=(0,j.localize)(0,null)),f?.installCount){v??="";const a=f.installCount;let h;a>1e6?h=`${Math.floor(a/1e5)/10}M`:a>1e3?h=`${Math.floor(a/1e3)}K`:h=String(a),v+=` $(cloud-download) ${h}`}return{id:E,label:$,description:v}}};e.$uq=m=we([Y(0,O.$Ln)],m)}),define(ae[189],ce([0,1,2,72]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z4b=void 0;let L=e.$z4b=class extends R.$kb{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$z4b=L=we([Y(0,M.$tq)],L)}),define(ae[8],ce([0,1,38,3,61,2,35,5,22,10,12,94,4]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.log=e.$Qi=e.LogLevel=e.$Pi=e.$Oi=e.$Ni=void 0,e.$Ni=(0,b.$lh)("logService"),e.$Oi=(0,b.$lh)("loggerService");function f(){return new Date().toISOString()}function $(d){return(0,m.$ke)(d)}e.$Pi=$;var v;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$Qi=v.Info;function a(d,l,P){switch(l){case v.Trace:d.trace(P);break;case v.Debug:d.debug(P);break;case v.Info:d.info(P);break;case v.Warning:d.warn(P);break;case v.Error:d.error(P);break;case v.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=a;function h(d,l=!1){let P="";for(let D=0;D<d.length;D++){let T=d[D];if(T instanceof Error&&(T=(0,R.$9h)(T,l)),typeof T=="object")try{T=JSON.stringify(T)}catch{}P+=(D>0?" ":"")+T}return P}class u extends j.$kb{constructor(){super(...arguments),this.b=e.$Qi,this.c=this.B(new M.$5c),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==v.Off&&this.b<=l}}e.$Si=u;class p extends u{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...P){this.f(v.Trace)&&this.g(v.Trace,h([l,...P],!0))}debug(l,...P){this.f(v.Debug)&&this.g(v.Debug,h([l,...P]))}info(l,...P){this.f(v.Info)&&this.g(v.Info,h([l,...P]))}warn(l,...P){this.f(v.Warning)&&this.g(v.Warning,h([l,...P]))}error(l,...P){if(this.f(v.Error))if(l instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=l.stack,this.g(v.Error,h(D))}else this.g(v.Error,h([l,...P]))}flush(){}}e.$Ti=p;class w extends u{constructor(l=e.$Qi){super(),this.setLevel(l),this.g=!C.$i}trace(l,...P){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,l,...P):console.log(`[main ${f()}]`,l,...P))}debug(l,...P){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,l,...P):console.log(`[main ${f()}]`,l,...P))}info(l,...P){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,l,...P):console.log(`[main ${f()}]`,l,...P))}warn(l,...P){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,l,...P):console.warn(`[main ${f()}]`,l,...P))}error(l,...P){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,l,...P):console.error(`[main ${f()}]`,l,...P))}dispose(){}flush(){}}e.$Ui=w;class I extends u{constructor(l=e.$Qi,P=!0){super(),this.g=P,this.setLevel(l)}trace(l,...P){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",l,...P):console.log(l,...P))}debug(l,...P){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",l,...P):console.log(l,...P))}info(l,...P){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",l,...P):console.log(l,...P))}warn(l,...P){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",l,...P):console.log(l,...P))}error(l,...P){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",l,...P):console.error(l,...P))}dispose(){}flush(){}}e.$Vi=I;class n extends u{constructor(l,P=e.$Qi){super(),this.g=l,this.setLevel(P)}trace(l,...P){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(l),...P])}debug(l,...P){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(l),...P])}info(l,...P){this.f(v.Info)&&this.g.log(v.Info,[this.h(l),...P])}warn(l,...P){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(l),...P])}error(l,...P){this.f(v.Error)&&this.g.log(v.Error,[this.h(l),...P])}h(l){return typeof l=="string"?l:(0,R.$9h)(l,this.f(v.Trace))}dispose(){}flush(){}}e.$Wi=n;class r extends u{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const P of this.g)P.setLevel(l);super.setLevel(l)}trace(l,...P){for(const D of this.g)D.trace(l,...P)}debug(l,...P){for(const D of this.g)D.debug(l,...P)}info(l,...P){for(const D of this.g)D.info(l,...P)}warn(l,...P){for(const D of this.g)D.warn(l,...P)}error(l,...P){for(const D of this.g)D.error(l,...P)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.$Xi=r;class i extends j.$kb{constructor(l,P,D){if(super(),this.h=l,this.j=P,this.b=new O.$ji,this.c=this.B(new M.$5c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$5c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$5c),this.onDidChangeVisibility=this.g.event,D)for(const T of D)this.b.set(T.resource,{logger:void 0,info:T})}k(l){return(0,m.$ge)(l)?[...this.b.values()].find(P=>P.info.id===l):this.b.get(l)}getLogger(l){return this.k(l)?.logger}createLogger(l,P){const D=this.l(l),T=(0,m.$ge)(l)?l:P?.id??(0,L.$_h)(D.toString()).toString(16);let F=this.b.get(D)?.logger;const H=P?.logLevel==="always"?v.Trace:P?.logLevel;F||(F=this.m(D,H??this.getLogLevel(D)??this.h,{...P,id:T}));const V={logger:F,info:{resource:D,id:T,logLevel:H,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(V.info),this.b.set(D,V),F}l(l){return(0,m.$ge)(l)?(0,k.$6f)(this.j,`${l}.log`):l}setLogLevel(l,P){if(S.URI.isUri(l)){const D=l,T=P,F=this.b.get(D);F&&T!==F.info.logLevel&&(F.info.logLevel=T===this.h?void 0:T,F.logger?.setLevel(T),this.b.set(F.info.resource,F),this.f.fire([D,T]))}else{this.h=l;for(const[D,T]of this.b.entries())this.b.get(D)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(l,P){const D=this.k(l);D&&P!==!D.info.hidden&&(D.info.hidden=!P,this.b.set(D.info.resource,D),this.g.fire([D.info.resource,P]))}getLogLevel(l){let P;return l&&(P=this.b.get(l)?.info.logLevel),P??this.h}registerLogger(l){const P=this.b.get(l.resource);P?P.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.b.set(l.resource,{info:l,logger:void 0}),this.c.fire({added:[l],removed:[]}))}deregisterLogger(l){const P=this.b.get(l);P&&(P.logger&&P.logger.dispose(),this.b.delete(l),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const l of this.b.values())yield l.info}getRegisteredLogger(l){return this.b.get(l)?.info}dispose(){this.b.forEach(l=>l.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yi=i;class t{constructor(){this.onDidChangeLogLevel=new M.$5c().event}setLevel(l){}getLevel(){return v.Info}trace(l,...P){}debug(l,...P){}info(l,...P){}warn(l,...P){}error(l,...P){}critical(l,...P){}dispose(){}flush(){}}e.$Zi=t;class s extends t{}e.$1i=s;function o(d){if(d.verbose)return v.Trace;if(typeof d.logLevel=="string"){const l=y(d.logLevel.toLowerCase());if(l!==void 0)return l}return e.$Qi}e.$2i=o;function c(d){switch(d){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$3i=c;function y(d){switch(d){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$4i=y,e.$5i=new E.$Ki("logLevel",c(v.Info))}),define(ae[190],ce([0,1,6,7,2,22,30,14,8]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A4b=void 0;let m=e.$A4b=class extends L.$kb{constructor(E,b){super(),this.a=E,this.b=b,this.B(new R.$Cg(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,j.$3f)(this.a.logsHome),b=(0,j.$5f)(this.a.logsHome),v=(await O.Promises.readdir(b.fsPath)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==E),a=v.slice(0,Math.max(0,v.length-9));a.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${a.join(", ")}'`),await Promise.all(a.map(h=>O.Promises.rm((0,j.$6f)(b,h).fsPath))))}catch(E){(0,M.$X)(E)}}};e.$A4b=m=we([Y(0,C.$sh),Y(1,k.$Ni)],m)}),define(ae[191],ce([0,1,21,6,7,3,2,15,53,8]),function(ne,e,R,M,L,j,O,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;class S extends O.$kb{constructor(b,f){super(),this.a=b,this.b=f,this.c=this.B(new j.$5c),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$5c),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new M.$pg(0)),this.s=[],this.t=this.B(new M.$pg(0))}watch(b,f){return f.recursive||this.b?.watcher?.forceUniversal?this.l(b,f):this.u(b,f)}l(b,f){const $={path:this.C(b),excludes:f.excludes,includes:f.includes,recursive:f.recursive},v=(0,R.$yf)(this.j,$);return this.m(),(0,O.$ib)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(b=>(0,L.$X)(b))}n(){this.h||(this.h=this.B(this.p(f=>this.c.fire((0,k.$tp)(f)),f=>this.z(f),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const f of this.j)(0,k.$pp)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const f of this.j)(0,k.$pp)(f)&&b.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(b,f){const $={path:this.C(b),excludes:f.excludes,includes:f.includes,recursive:!1},v=(0,R.$yf)(this.s,$);return this.v(),(0,O.$ib)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(b=>(0,L.$X)(b))}w(){return this.r||(this.r=this.B(this.y(b=>this.c.fire((0,k.$tp)(b)),b=>this.z(b),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.r.watch(this.s)}z(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}C(b){return(0,C.$9b)(b.fsPath)}}e.$xp=S}),define(ae[192],ce([0,1,21,6,16,26,3,61,60,2,46,25,100,22,42,152,13,99,8,7]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;let w=e.$op=class extends m.$kb{constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new O.$5c),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$5c),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$5c),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new O.$5c),this.onDidRunOperation=this.m.event,this.R=this.B(new O.$5c),this.onDidFilesChange=this.R.event,this.S=this.B(new O.$5c),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new M.$zg)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${n}`);const i=new m.$jb;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),i.add(r.onDidChangeFile(t=>this.R.fire(new a.$7j(t,!this.O(r))))),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(t=>this.S.fire(new Error(t)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,m.$ib)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,m.$fb)(i)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(i){r.push(i)}}),!this.h.has(n)&&await M.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const i=this.h.get(n.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return k.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,f.$0f)(n))throw new a.$9j((0,v.localize)(0,null,this.nb(n)),8);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const i=new p.$_;throw i.message=(0,v.localize)(1,null,n.toString()),i}return r}async k(n){const r=await this.j(n);if((0,a.$Tj)(r)||(0,a.$Qj)(r)||(0,a.$Uj)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(n){const r=await this.j(n);if((0,a.$Tj)(r)||(0,a.$Qj)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.n(n,r)}catch(i){throw(0,a.$4j)(i)===a.FileSystemProviderErrorCode.FileNotFound?new a.$9j((0,v.localize)(2,null,this.nb(n)),1):(0,a.$2j)(i)}}async n(n,r){const i=await this.j(n),t=this.O(i),s=r?.resolveTo,o=r?.resolveSingleChildDescendants,c=r?.resolveMetadata,y=await i.stat(n);let d;return this.p(i,n,y,void 0,!!c,(l,P)=>(d||(d=S.$rh.forUris(()=>!t),d.set(n,!0),s&&d.fill(!0,s)),d.get(l.resource)||d.findSuperstr(l.resource.with({query:null,fragment:null}))?!0:l.isDirectory&&o?P===1:!1))}async p(n,r,i,t,s,o){const{providerExtUri:c}=this.N(n),y={resource:r,name:c.basename(r),isFile:(i.type&a.FileType.File)!==0,isDirectory:(i.type&a.FileType.Directory)!==0,isSymbolicLink:(i.type&a.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&a.FilePermission.Readonly)||!!(n.capabilities&2048),locked:!!((i.permissions??0)&a.FilePermission.Locked),etag:(0,a.$hk)({mtime:i.mtime,size:i.size}),children:void 0};if(y.isDirectory&&o(y,t)){try{const d=await n.readdir(r),l=await M.Promises.settled(d.map(async([P,D])=>{try{const T=c.joinPath(r,P),F=s?await n.stat(T):{type:D};return await this.p(n,T,F,d.length,s,o)}catch(T){return this.b.trace(T),null}}));y.children=(0,R.$jf)(l)}catch(d){this.b.trace(d),y.children=[]}return y}return y}async resolveAll(n){return M.Promises.settled(n.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),i=await r.stat(n);return this.p(r,n,i,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.r(n,r)}catch(i){return i}return!0}async r(n,r){if(!r?.overwrite&&await this.exists(n))throw new a.$9j((0,v.localize)(3,null,this.nb(n)),3,r)}async createFile(n,r=L.$Ib.fromString(""),i){await this.r(n,i);const t=await this.writeFile(n,r);return this.m.fire(new a.$6j(n,0,t)),t}async writeFile(n,r,i){const t=this.lb(await this.l(n),n),{providerExtUri:s}=this.N(t);try{await this.s(t,n,i)||await this.P(t,s.dirname(n));let c;if((0,a.$Qj)(t)&&!(r instanceof L.$Ib))if((0,$.$ub)(r)){const y=await(0,$.$Bb)(r,3);y.ended?c=L.$Ib.concat(y.buffer):c=y}else c=(0,$.$yb)(r,y=>L.$Ib.concat(y),3);else c=r;if(!(0,a.$Tj)(t)||(0,a.$Qj)(t)&&c instanceof L.$Ib)await this.cb(t,n,i,c);else{const y=c instanceof L.$Ib?(0,L.$Sb)(c):c;i?.atomic!==!1&&i?.atomic?.postfix?await this.Y(t,n,(0,f.$6f)((0,f.$5f)(n),`${(0,f.$3f)(n)}${i.atomic.postfix}`),i,y):await this.Z(t,n,i,y)}this.m.fire(new a.$6j(n,4))}catch(o){throw new a.$9j((0,v.localize)(4,null,this.nb(n),(0,a.$2j)(o).toString()),(0,a.$5j)(o),i)}return this.resolve(n,{resolveMetadata:!0})}async s(n,r,i){const t=!!i?.unlock;if(t&&!(n.capabilities&8192))throw new Error((0,v.localize)(5,null,this.nb(r)));if(!!i?.atomic){if(!(n.capabilities&32768))throw new Error((0,v.localize)(6,null,this.nb(r)));if(t)throw new Error((0,v.localize)(7,null,this.nb(r)))}let o;try{o=await n.stat(r)}catch{return}if(o.type&a.FileType.Directory)throw new a.$9j((0,v.localize)(8,null,this.nb(r)),0,i);if(this.mb(r,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==a.$gk&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,a.$hk)({mtime:i.mtime,size:o.size}))throw new a.$9j((0,v.localize)(9,null),3,i);return o}async readFile(n,r,i){const t=await this.k(n);return r?.atomic?this.t(t,n,r,i):this.u(t,n,r,i)}async t(n,r,i,t){return new Promise((s,o)=>{this.X.queueFor(r,this.N(n).providerExtUri).queue(async()=>{try{const c=await this.u(n,r,i,t);s(c)}catch(c){o(c)}})})}async u(n,r,i,t){const s=await this.v(n,r,{...i,preferUnbuffered:!0},t);return{...s,value:await(0,L.$Tb)(s.value)}}async readFileStream(n,r,i){const t=await this.k(n);return this.v(t,n,r,i)}async v(n,r,i,t){const s=new j.$bd(t),o=this.F(r,i).then(y=>y,y=>{throw s.cancel(),y});let c;try{return typeof i?.etag=="string"&&i.etag!==a.$gk&&await o,i?.atomic&&(0,a.$Vj)(n)||!((0,a.$Tj)(n)||(0,a.$Uj)(n))||(0,a.$Qj)(n)&&i?.preferUnbuffered?c=this.D(n,r,i):(0,a.$Uj)(n)?c=this.z(n,r,s.token,i):c=this.C(n,r,s.token,i),{...await o,value:c}}catch(y){throw c&&await(0,$.$zb)(c),this.w(y,r,i)}}w(n,r,i){const t=(0,v.localize)(10,null,this.nb(r),(0,a.$2j)(n).toString());return n instanceof a.$$j?new a.$$j(t,n.stat,i):n instanceof a.$0j?new a.$0j(t,n.fileOperationResult,n.size,n.options):new a.$9j(t,(0,a.$5j)(n),i)}z(n,r,i,t=Object.create(null)){const s=n.readFileStream(r,t,i);return(0,$.$Fb)(s,{data:o=>o instanceof L.$Ib?o:L.$Ib.wrap(o),error:o=>this.w(o,r,t)},o=>L.$Ib.concat(o))}C(n,r,i,t=Object.create(null)){const s=(0,L.$Xb)();return(0,h.$np)(n,r,s,o=>o,{...t,bufferSize:this.a,errorTransformer:o=>this.w(o,r,t)},i),s}D(n,r,i){const t=(0,$.$wb)(s=>L.$Ib.concat(s));return(async()=>{try{let s;i?.atomic&&(0,a.$Vj)(n)?s=await n.readFile(r,{atomic:!0}):s=await n.readFile(r),typeof i?.position=="number"&&(s=s.slice(i.position)),typeof i?.length=="number"&&(s=s.slice(0,i.length)),this.G(r,s.byteLength,i),t.end(L.$Ib.wrap(s))}catch(s){t.error(s),t.end()}})(),t}async F(n,r){const i=await this.resolve(n,{resolveMetadata:!0});if(i.isDirectory)throw new a.$9j((0,v.localize)(11,null,this.nb(n)),0,r);if(typeof r?.etag=="string"&&r.etag!==a.$gk&&r.etag===i.etag)throw new a.$$j((0,v.localize)(12,null),i,r);return this.G(n,i.size,r),i}G(n,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new a.$0j((0,v.localize)(13,null,this.nb(n)),7,r,i)}async canMove(n,r,i){return this.H(n,r,"move",i)}async canCopy(n,r,i){return this.H(n,r,"copy",i)}async H(n,r,i,t){if(n.toString()!==r.toString())try{const s=i==="move"?this.lb(await this.l(n),n):await this.k(n),o=this.lb(await this.l(r),r);await this.M(s,n,o,r,i,t)}catch(s){return s}return!0}async move(n,r,i){const t=this.lb(await this.l(n),n),s=this.lb(await this.l(r),r),o=await this.I(t,n,s,r,"move",!!i),c=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new a.$6j(n,o==="move"?2:3,c)),c}async copy(n,r,i){const t=await this.k(n),s=this.lb(await this.l(r),r),o=await this.I(t,n,s,r,"copy",!!i),c=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new a.$6j(n,o==="copy"?3:2,c)),c}async I(n,r,i,t,s,o){if(r.toString()===t.toString())return s;const{exists:c,isSameResourceWithDifferentPathCase:y}=await this.M(n,r,i,t,s,o);if(c&&!y&&o&&await this.del(t,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(t)),s==="copy"){if(n===i&&(0,a.$Rj)(n))await n.copy(r,t,{overwrite:o});else{const d=await this.resolve(r);d.isDirectory?await this.L(n,d,i,t):await this.J(n,r,i,t)}return s}else return n===i?(await n.rename(r,t,{overwrite:o}),s):(await this.I(n,r,i,t,"copy",o),await this.del(r,{recursive:!0}),"copy")}async J(n,r,i,t){if((0,a.$Tj)(n)&&(0,a.$Tj)(i))return this.eb(n,r,i,t);if((0,a.$Tj)(n)&&(0,a.$Qj)(i))return this.kb(n,r,i,t);if((0,a.$Qj)(n)&&(0,a.$Tj)(i))return this.ib(n,r,i,t);if((0,a.$Qj)(n)&&(0,a.$Qj)(i))return this.gb(n,r,i,t)}async L(n,r,i,t){await i.mkdir(t),Array.isArray(r.children)&&await M.Promises.settled(r.children.map(async s=>{const o=this.N(i).providerExtUri.joinPath(t,s.name);return s.isDirectory?this.L(n,await this.resolve(s.resource),i,o):this.J(n,s.resource,i,o)}))}async M(n,r,i,t,s,o){let c=!1;if(n===i){const{providerExtUri:d,isPathCaseSensitive:l}=this.N(n);if(l||(c=d.isEqual(r,t)),c&&s==="copy")throw new Error((0,v.localize)(14,null,this.nb(r),this.nb(t)));if(!c&&d.isEqualOrParent(t,r))throw new Error((0,v.localize)(15,null,this.nb(r),this.nb(t)))}const y=await this.exists(t);if(y&&!c){if(!o)throw new a.$9j((0,v.localize)(16,null,this.nb(r),this.nb(t)),4);if(n===i){const{providerExtUri:d}=this.N(n);if(d.isEqualOrParent(r,t))throw new Error((0,v.localize)(17,null,this.nb(r),this.nb(t)))}}return{exists:y,isSameResourceWithDifferentPathCase:c}}N(n){const r=this.O(n);return{providerExtUri:r?f.$Vf:f.$Xf,isPathCaseSensitive:r}}O(n){return!!(n.capabilities&1024)}async createFolder(n){const r=this.lb(await this.j(n),n);await this.P(r,n);const i=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new a.$6j(n,0,i)),i}async P(n,r){const i=[],{providerExtUri:t}=this.N(n);for(;!t.isEqual(r,t.dirname(r));)try{if(!((await n.stat(r)).type&a.FileType.Directory))throw new Error((0,v.localize)(18,null,this.nb(r)));break}catch(s){if((0,a.$4j)(s)!==a.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(t.basename(r)),r=t.dirname(r)}for(let s=i.length-1;s>=0;s--){r=t.joinPath(r,i[s]);try{await n.mkdir(r)}catch(o){if((0,a.$4j)(o)!==a.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(n,r){try{await this.Q(n,r)}catch(i){return i}return!0}async Q(n,r){const i=this.lb(await this.j(n),n),t=!!r?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,v.localize)(19,null,this.nb(n)));const s=r?.atomic;if(s&&!(i.capabilities&65536))throw new Error((0,v.localize)(20,null,this.nb(n)));if(t&&s)throw new Error((0,v.localize)(21,null,this.nb(n)));let o;try{o=await i.stat(n)}catch{}if(o)this.mb(n,o);else throw new a.$9j((0,v.localize)(22,null,this.nb(n)),1);if(!!!r?.recursive){const y=await this.resolve(n);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,v.localize)(23,null,this.nb(n)))}return i}async del(n,r){const i=await this.Q(n,r),t=!!r?.useTrash,s=!!r?.recursive,o=r?.atomic??!1;await i.delete(n,{recursive:s,useTrash:t,atomic:o}),this.m.fire(new a.$6j(n,1))}async cloneFile(n,r){const i=await this.j(n),t=this.lb(await this.l(r),r);if(i===t&&this.N(i).providerExtUri.isEqual(n,r))return;if(i===t&&(0,a.$Sj)(i))return i.cloneFile(n,r);await this.P(t,this.N(t).providerExtUri.dirname(r));const s=this.X.queueFor(n,this.N(i).providerExtUri);return i===t&&(0,a.$Rj)(i)?s.queue(()=>i.copy(n,r,{overwrite:!0})):s.queue(()=>this.J(i,n,t,r))}watch(n,r={recursive:!1,excludes:[]}){const i=new m.$jb;let t=!1,s=()=>{t=!0};return i.add((0,m.$ib)(()=>s())),(async()=>{try{const o=await this.W(n,r);t?(0,m.$fb)(o):s=()=>(0,m.$fb)(o)}catch(o){this.b.error(o)}})(),i}async W(n,r){const i=await this.j(n),t=(0,C.$_h)([this.N(i).providerExtUri.getComparisonKey(n),r]);let s=this.U.get(t);return s||(s={count:0,disposable:i.watch(n,r)},this.U.set(t,s)),s.count+=1,(0,m.$ib)(()=>{s&&(s.count--,s.count===0&&((0,m.$fb)(s.disposable),this.U.delete(t)))})}dispose(){super.dispose();for(const[,n]of this.U)(0,m.$fb)(n.disposable);this.U.clear()}async Y(n,r,i,t,s){await this.Z(n,i,t,s);try{await n.rename(i,r,{overwrite:!0})}catch(o){try{await n.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async Z(n,r,i,t){return this.X.queueFor(r,this.N(n).providerExtUri).queue(async()=>{const s=await n.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,$.$ub)(t)||(0,$.$vb)(t)?await this.$(n,s,t):await this.ab(n,s,t)}catch(o){throw(0,a.$2j)(o)}finally{await n.close(s)}})}async $(n,r,i){let t=0,s;if((0,$.$vb)(i)){if(i.buffer.length>0){const o=L.$Ib.concat(i.buffer);await this.bb(n,r,o,o.byteLength,t,0),t+=o.byteLength}if(i.ended)return;s=i.stream}else s=i;return new Promise((o,c)=>{(0,$.$Ab)(s,{onData:async y=>{s.pause();try{await this.bb(n,r,y,y.byteLength,t,0)}catch(d){return c(d)}t+=y.byteLength,setTimeout(()=>s.resume())},onError:y=>c(y),onEnd:()=>o()})})}async ab(n,r,i){let t=0,s;for(;(s=i.read())!==null;)await this.bb(n,r,s,s.byteLength,t,0),t+=s.byteLength}async bb(n,r,i,t,s,o){let c=0;for(;c<t;){const y=await n.write(r,s+c,i.buffer,o+c,t-c);c+=y}}async cb(n,r,i,t){return this.X.queueFor(r,this.N(n).providerExtUri).queue(()=>this.db(n,r,i,t))}async db(n,r,i,t){let s;t instanceof L.$Ib?s=t:(0,$.$ub)(t)?s=await(0,L.$Tb)(t):(0,$.$vb)(t)?s=await(0,L.$Ub)(t):s=(0,L.$Rb)(t),await n.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async eb(n,r,i,t){return this.X.queueFor(t,this.N(i).providerExtUri).queue(()=>this.fb(n,r,i,t))}async fb(n,r,i,t){let s,o;try{s=await n.open(r,{create:!1}),o=await i.open(t,{create:!0,unlock:!1});const c=L.$Ib.alloc(this.a);let y=0,d=0,l=0;do l=await n.read(s,y,c.buffer,d,c.byteLength-d),await this.bb(i,o,c,l,y,d),y+=l,d+=l,d===c.byteLength&&(d=0);while(l>0)}catch(c){throw(0,a.$2j)(c)}finally{await M.Promises.settled([typeof s=="number"?n.close(s):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async gb(n,r,i,t){return this.X.queueFor(t,this.N(i).providerExtUri).queue(()=>this.hb(n,r,i,t))}async hb(n,r,i,t){return i.writeFile(t,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(n,r,i,t){return this.X.queueFor(t,this.N(i).providerExtUri).queue(()=>this.jb(n,r,i,t))}async jb(n,r,i,t){const s=await i.open(t,{create:!0,unlock:!1});try{const o=await n.readFile(r);await this.bb(i,s,L.$Ib.wrap(o),o.byteLength,0,0)}catch(o){throw(0,a.$2j)(o)}finally{await i.close(s)}}async kb(n,r,i,t){const s=await(0,L.$Tb)(this.C(n,r,j.CancellationToken.None));await this.cb(i,t,void 0,s)}lb(n,r){if(n.capabilities&2048)throw new a.$9j((0,v.localize)(24,null,this.nb(r)),6);return n}mb(n,r){if((r.permissions??0)&a.FilePermission.Readonly)throw new a.$9j((0,v.localize)(25,null,this.nb(n)),6)}nb(n){return n.scheme===E.Schemas.file?n.fsPath:n.toString(!0)}};e.$op=w=we([Y(0,u.$Ni)],w)}),define(ae[193],ce([0,1,51,263,6,35,16,3,47,2,15,5,22,42,30,155,13,99,191,38,187,186]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u,p,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0,(()=>{try{(0,M.gracefulify)(R)}catch(r){console.error(`Error enabling graceful-fs: ${(0,p.$9h)(r)}`)}})();class n extends u.$xp{constructor(i,t){super(i,t),this.onDidChangeCapabilities=C.Event.None,this.I=new j.$ji(s=>b.$Wf.getComparisonKey(s)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,E.$k&&(this.F|=1024)),this.F}async stat(i){try{const{stat:t,symbolicLink:s}=await $.SymlinkSupport.stat(this.C(i));return{type:this.H(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:a.FilePermission.Locked}}catch(t){throw this.ab(t)}}async G(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const t=await $.Promises.readdir(this.C(i),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,b.$6f)(i,o.name))).type:c=this.H(o),s.push([o.name,c])}catch(c){this.a.trace(c)}})),s}catch(t){throw this.ab(t)}}H(i,t){let s;return t?.dangling?s=a.FileType.Unknown:i.isFile()?s=a.FileType.File:i.isDirectory()?s=a.FileType.Directory:s=a.FileType.Unknown,t&&(s|=a.FileType.SymbolicLink),s}async J(i){const t=this.C(i);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let s;for(;s=this.I.get(i);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await s.wait();const o=new L.$qg;return this.I.set(i,o),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,m.$ib)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.I.get(i)===o&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.I.delete(i)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),o.open()})}async readFile(i,t){let s;try{t?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),s=await this.J(i));const o=this.C(i);return await $.Promises.readFile(o)}catch(o){throw this.ab(o)}finally{s?.dispose()}}L(i){n.D&&this.a.trace(i)}readFileStream(i,t,s){const o=(0,f.$wb)(c=>O.$Ib.concat(c.map(y=>O.$Ib.wrap(y))).buffer);return(0,h.$np)(this,i,o,c=>c.buffer,{...t,bufferSize:256*1024},s),o}async writeFile(i,t,s){return s?.atomic!==!1&&s?.atomic?.postfix?this.M(i,(0,b.$6f)((0,b.$5f)(i),`${(0,b.$3f)(i)}${s.atomic.postfix}`),t,s):this.N(i,t,s)}async M(i,t,s,o){await this.N(t,s,o);try{await this.rename(t,i,{overwrite:!0})}catch(c){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}async N(i,t,s){let o;try{const c=this.C(i);if(!s.create||!s.overwrite){if(await $.Promises.exists(c)){if(!s.overwrite)throw(0,a.$1j)((0,v.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,a.$1j)((0,v.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(o,0,t,0,t.byteLength)}catch(c){throw await this.bb(i,c)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(i){n.R=i}async open(i,t){const s=this.C(i);let o;(0,a.$Pj)(t)&&(o=await this.J(i));let c;try{if((0,a.$Pj)(t)&&t.unlock)try{const{stat:d}=await $.SymlinkSupport.stat(s);d.mode&128||await $.Promises.chmod(s,d.mode|128)}catch(d){d.code!=="ENOENT"&&this.a.trace(d)}let y;if((0,a.$Pj)(t)){if(E.$i)try{await $.Promises.truncate(s,0),y="r+"}catch(d){d.code!=="ENOENT"&&this.a.trace(d)}y||(y="w")}else y="r";c=await $.Promises.open(s,y)}catch(y){throw o?.dispose(),(0,a.$Pj)(t)?await this.bb(i,y):this.ab(y)}if(this.O.set(c,0),(0,a.$Pj)(t)&&this.Q.set(c,i),o){const y=this.P.get(c);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${s})`),this.P.set(c,o),y&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${s})`),y.dispose())}return c}async close(i){const t=this.P.get(i);try{if(this.O.delete(i),this.Q.delete(i)&&n.R)try{await $.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await $.Promises.close(i)}catch(s){throw this.ab(s)}finally{t&&(this.P.get(i)===t&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.P.delete(i)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),t.dispose())}}async read(i,t,s,o,c){const y=this.S(i,t);let d=null;try{d=(await $.Promises.read(i,s,o,c,y)).bytesRead}catch(l){throw this.ab(l)}finally{this.U(i,y,d)}return d}S(i,t){return t===this.O.get(i)?null:t}U(i,t,s){const o=this.O.get(i);typeof o=="number"&&(typeof t=="number"||(typeof s=="number"?this.O.set(i,o+s):this.O.delete(i)))}async write(i,t,s,o,c){return(0,L.$Ig)(()=>this.W(i,t,s,o,c),100,3)}async W(i,t,s,o,c){const y=this.S(i,t);let d=null;try{d=(await $.Promises.write(i,s,o,c,y)).bytesWritten}catch(l){throw await this.bb(this.Q.get(i),l)}finally{this.U(i,y,d)}return d}async mkdir(i){try{await $.Promises.mkdir(this.C(i))}catch(t){throw this.ab(t)}}async delete(i,t){try{const s=this.C(i);if(t.recursive){let o;t?.atomic!==!1&&t.atomic.postfix&&(o=(0,S.$$b)((0,S.$bc)(s),`${(0,S.$cc)(s)}${t.atomic.postfix}`)),await $.Promises.rm(s,$.RimRafMode.MOVE,o)}else try{await $.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let c=!1;try{const{stat:y,symbolicLink:d}=await $.SymlinkSupport.stat(s);c=y.isDirectory()&&!d}catch{}if(c)await $.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.ab(s)}}async rename(i,t,s){const o=this.C(i),c=this.C(t);if(o!==c)try{await this.X(i,t,"move",s.overwrite),await $.Promises.move(o,c)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,v.localize)(2,null,(0,S.$cc)(o),(0,S.$cc)((0,S.$bc)(c)),y.toString()))),this.ab(y)}}async copy(i,t,s){const o=this.C(i),c=this.C(t);if(o!==c)try{await this.X(i,t,"copy",s.overwrite),await $.Promises.copy(o,c,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,v.localize)(3,null,(0,S.$cc)(o),(0,S.$cc)((0,S.$bc)(c)),y.toString()))),this.ab(y)}}async X(i,t,s,o){const c=this.C(i),y=this.C(t);let d=!1;if(!!(this.capabilities&1024)||(d=(0,k.$Ge)(c,y,!0)),d){if(s==="copy")throw(0,a.$1j)((0,v.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const P=await this.G(i);if(!P)throw(0,a.$1j)((0,v.localize)(5,null),a.FileSystemProviderErrorCode.FileNotFound);const D=await this.G(t);if(D){if(!o)throw(0,a.$1j)((0,v.localize)(6,null),a.FileSystemProviderErrorCode.FileExists);P.type&a.FileType.File&&D.type&a.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,t){return this.Y(i,t,!1)}async Y(i,t,s){const o=this.C(i),c=this.C(t),y=!!(this.capabilities&1024);if((0,k.$Ge)(o,c,!y))return;const d=new m.$jb;try{const[l,P]=await Promise.all([this.J(i),this.J(t)]);d.add(l),d.add(P),s&&await $.Promises.mkdir((0,S.$bc)(c),{recursive:!0}),await $.Promises.copyFile(o,c)}catch(l){if(l.code==="ENOENT"&&!s)return this.Y(i,t,!0);throw this.ab(l)}finally{d.dispose()}}p(i,t,s){return new w.$Ep(o=>i(o),o=>t(o),s)}y(i,t,s){return new I.$Mp(o=>i(o),o=>t(o),s)}ab(i){if(i instanceof a.$Zj)return i;let t=i,s;switch(i.code){case"ENOENT":s=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=a.FileSystemProviderErrorCode.Unknown;break;default:s=a.FileSystemProviderErrorCode.Unknown}return(0,a.$1j)(t,s)}async bb(i,t){let s=this.ab(t);if(i&&s.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await $.SymlinkSupport.stat(this.C(i));o.mode&128||(s=(0,a.$1j)(t,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$Np=n,n.D=!1,n.R=!0}),define(ae[101],ce([0,1,3,2,4,8]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$54b=e.$44b=void 0,e.$44b=(0,L.$lh)("sharedProcessLifecycleService");let O=e.$54b=class extends M.$kb{constructor(k){super(),this.b=k,this.a=this.B(new R.$5c),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$54b=O=we([Y(0,j.$Ni)],O)}),define(ae[194],ce([0,1,12,3,8,2]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=e.$Jq=void 0;class O extends L.$Yi{constructor(E,b,f,$,v){super(b,f,$),this.n=E,this.p=v,this.B(v.listen("onDidChangeLogLevel",E)(a=>{(0,L.$Pi)(a)?super.setLogLevel(a):super.setLogLevel(R.URI.revive(a[0]),a[1])})),this.B(v.listen("onDidChangeVisibility",E)(([a,h])=>super.setVisibility(R.URI.revive(a),h))),this.B(v.listen("onDidChangeLoggers",E)(({added:a,removed:h})=>{for(const u of a)super.registerLogger({...u,resource:R.URI.revive(u.resource)});for(const u of h)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new L.$Wi({log:(E,b)=>{this.p.call("consoleLog",[E,b])}})}registerLogger(E){super.registerLogger(E),this.p.call("registerLogger",[E,this.n])}deregisterLogger(E){super.deregisterLogger(E),this.p.call("deregisterLogger",[E,this.n])}setLogLevel(E,b){super.setLogLevel(E,b),this.p.call("setLogLevel",[E,b])}setVisibility(E,b){super.setVisibility(E,b),this.p.call("setVisibility",[this.l(E),b])}m(E,b,f){return new C(this.p,E,b,f,this.n)}static setLogLevel(E,b,f){return E.call("setLogLevel",[b,f])}}e.$Jq=O;class C extends L.$Ti{constructor(E,b,f,$,v){super($?.logLevel==="always"),this.m=E,this.n=b,this.k=!1,this.l=[],this.setLevel(f),this.m.call("createLogger",[b,$,v]).then(()=>{this.r(this.l),this.k=!0})}g(E,b){const f=[[E,b]];this.k?this.r(f):this.l.push(...f)}r(E){this.m.call("log",[this.n,E])}}class k{constructor(E,b){this.a=E,this.b=b}listen(E,b){const f=this.b(E);switch(b){case"onDidChangeLoggers":return M.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(v=>this.c(v,f)),removed:[...$.removed].map(v=>this.c(v,f))}));case"onDidChangeVisibility":return M.Event.map(this.a.onDidChangeVisibility,$=>[f.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return M.Event.map(this.a.onDidChangeLogLevel,$=>(0,L.$Pi)($)?$:[f.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${b}`)}async call(E,b,f){const $=this.b(E);switch(b){case"setLogLevel":return(0,L.$Pi)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(R.URI.revive($.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(v=>this.c(v,$)))}throw new Error(`Call not found: ${b}`)}c(E,b){return{...E,resource:b.transformOutgoingURI(E.resource)}}}e.$Kq=k;class m extends j.$kb{constructor(E,b){super(),b.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(f=>b.call("setLogLevel",[f]))),b.call("getRegisteredLoggers").then(f=>{for(const $ of f)E.registerLogger({...$,resource:R.URI.revive($.resource)})}),this.B(b.listen("onDidChangeVisibility")(([f,$])=>E.setVisibility(R.URI.revive(f),$))),this.B(b.listen("onDidChangeLoggers")(({added:f,removed:$})=>{for(const v of f)E.registerLogger({...v,resource:R.URI.revive(v.resource)});for(const v of $)E.deregisterLogger(v.resource)}))}}e.$Lq=m}),define(ae[195],ce([0,1,2,8]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=void 0;class L extends R.$kb{constructor(O,C=[]){super(),this.a=new M.$Xi([O,...C]),this.B(O.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...C){this.a.trace(O,...C)}debug(O,...C){this.a.debug(O,...C)}info(O,...C){this.a.info(O,...C)}warn(O,...C){this.a.warn(O,...C)}error(O,...C){this.a.error(O,...C)}flush(){this.a.flush()}}e.$wM=L}),define(ae[54],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R2b=void 0,e.$R2b=(0,R.$lh)("nativeHostService")}),define(ae[55],ce([0,1,3,60,2,4]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0,e.$Rm=(0,j.$lh)("policy");class O extends L.$kb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new R.$5c),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const S=Object.keys(this.f).length;return this.f={...m,...this.f},S!==Object.keys(this.f).length&&await this.i(m),M.Iterable.reduce(this.g.entries(),(E,[b,f])=>({...E,[b]:f}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return M.Iterable.reduce(Object.entries(this.f),(m,[S,E])=>({...m,[S]:{definition:E,value:this.g.get(S)}}),{})}}e.$Sm=O;class C{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Tm=C}),define(ae[196],ce([0,1,3,2,55]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O3b=e.$N3b=void 0;class j{constructor(k){this.b=k,this.a=new M.$jb}listen(k,m){switch(m){case"onDidChange":return R.Event.map(this.b.onDidChange,S=>S.reduce((E,b)=>({...E,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${m}`)}call(k,m,S){switch(m){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(S)}throw new Error(`Call not found: ${m}`)}dispose(){this.a.dispose()}}e.$N3b=j;class O extends L.$Sm{constructor(k,m){super(),this.a=m;for(const S in k){const{definition:E,value:b}=k[S];this.f[S]=E,b!==void 0&&this.g.set(S,b)}this.a.listen("onDidChange")(S=>{for(const E in S){const b=S[E];b===null?this.g.delete(E):this.g.set(E,b)}this.h.fire(Object.keys(S))})}async i(k){const m=await this.a.call("updatePolicyDefinitions",k);for(const S in m)this.g.set(S,m[S])}}e.$O3b=O}),define(ae[102],ce([0,1,5,37]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;if(typeof R.$g.vscode<"u"&&typeof R.$g.vscode.context<"u"){const j=R.$g.vscode.context.configuration();if(j)L=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,M.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:j.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.80.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(ae[24],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=void 0,e.$6i=(0,R.$lh)("productService"),e.$7i="vscode://schemas/vscode-product"}),define(ae[197],ce([0,1,6,7,2,15,30,8,24]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x4b=void 0;let m=e.$x4b=class extends L.$kb{constructor(E,b,f){super(),this.b=b,this.c=f,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new R.$Cg(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const b=Date.now(),f=(0,j.$bc)(E),$=(0,j.$cc)(E),v=await O.Promises.readdir(f);await Promise.all(v.map(async a=>{if(a===$)return;const h=(0,j.$$b)(f,a),u=await O.Promises.stat(h);if(u.isDirectory()&&b-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${a}.`),O.Promises.rm(h)}))}catch(b){(0,M.$X)(b)}}};e.$x4b=m=we([Y(1,k.$6i),Y(2,C.$Ni)],m)}),define(ae[198],ce([0,1,6,7,2,15,30,14,8,24]),function(ne,e,R,M,L,j,O,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y4b=void 0;let S=e.$y4b=class extends L.$kb{constructor(b,f,$){super(),this.b=b,this.c=f,this.f=$,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new R.$Cg(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const b=Object.create(null),f=JSON.parse(await O.Promises.readFile((0,j.$$b)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(f)){const p=f[u];b[`${p.hash}.${u}`]=!0}const $=(0,j.$$b)(this.b.userDataPath,"clp");if(!await O.Promises.exists($))return;const a=await O.Promises.readdir($);for(const u of a){if(b[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await O.Promises.rm((0,j.$$b)($,u))}const h=Date.now();for(const u of Object.keys(b)){const p=(0,j.$$b)($,u),w=await O.Promises.readdir(p);for(const I of w){if(I==="tcf.json")continue;const n=(0,j.$$b)(p,I),r=await O.Promises.stat(n);r.isDirectory()&&h-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$$b)(u,I)}`),await O.Promises.rm(n))}}}catch(b){(0,M.$X)(b)}}};e.$y4b=S=we([Y(0,C.$th),Y(1,k.$Ni),Y(2,m.$6i)],S)}),define(ae[199],ce([0,1,15,4]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$WE=void 0,e.$WE=(0,M.$lh)("IV8InspectProfilingService");var L;(function(j){function O(k){return!!(k.samples&&k.timeDeltas)}j.isValidProfile=O;function C(k,m="noAbsolutePaths"){for(const S of k.nodes)S.callFrame&&S.callFrame.url&&((0,R.$0b)(S.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(S.callFrame.url))&&(S.callFrame.url=(0,R.$$b)(m,(0,R.$cc)(S.callFrame.url)));return k}j.rewriteAbsolutePaths=C})(L||(e.Utils=L={}))}),define(ae[200],ce([0,1,32]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U4b=void 0;class M{constructor(){this.a=new Map}async startProfiling(j){const C=await(await new Promise((m,S)=>{ne(["v8-inspect-profiler"],m,S)})).startProfiling({port:j.port,checkForPaused:!0}),k=(0,R.$3e)();return this.a.set(k,C),k}async stopProfiling(j){const O=this.a.get(j);if(!O)throw new Error(`UNKNOWN session '${j}'`);const C=await O.stop();return this.a.delete(j),C.profile}}e.$U4b=M}),define(ae[40],ce([0,1,122,10]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=void 0;class L{constructor(){this.a=new Map}add(O,C){R.ok(M.$ge(O)),R.ok(M.$ie(C)),R.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,C)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$Pm=new L}),define(ae[103],ce([0,1,3,40]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0,e.$Qm={JSONContribution:"base.contributions.json"};function L(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class j{constructor(){this.b=new R.$5c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,m){this.a[L(k)]=m,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const O=new j;M.$Pm.add(e.$Qm.JSONContribution,O)}),define(ae[48],ce([0,1,21,3,10,142,18,103,40]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.ConfigurationScope=e.$Um=e.EditPresentationTypes=void 0;var m;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.$Um={Configuration:"base.contributions.configuration"};var S;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$Vm={properties:{},patternProperties:{}},e.$Wm={properties:{},patternProperties:{}},e.$Xm={properties:{},patternProperties:{}},e.$Ym={properties:{},patternProperties:{}},e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m="vscode://schemas/settings/resourceLanguage",e.$3m="vscode://schemas/settings/configurationDefaults";const E=k.$Pm.as(C.$Qm.JSONContribution);class b{constructor(){this.h=new Set,this.i=new M.$5c,this.onDidSchemaChange=this.i.event,this.j=new M.$5c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$2m,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const i=new Set;this.n(n,r,i),E.registerSchema(e.$2m,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(n){const r=new Set;this.o(n,r),E.registerSchema(e.$2m,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const i=new Set;this.o(r,i),this.n(n,!1,i),E.registerSchema(e.$2m,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const i=[];for(const{overrides:t,source:s}of n)for(const o in t)if(r.add(o),e.$5m.test(o)){const c=this.a.get(o),y=c?.valuesSources??new Map;if(s)for(const D of Object.keys(t[o]))y.set(D,s);const d={...c?.value||{},...t[o]};this.a.set(o,{source:s,value:d,valuesSources:y});const l=(0,O.$2h)(o),P={type:"object",default:d,description:j.localize(1,null,l),$ref:e.$2m,defaultDefaultValue:d,source:L.$ge(s)?void 0:s,defaultValueSource:s};i.push(...v(o)),this.d[o]=P,this.b.properties[o]=P}else{this.a.set(o,{value:t[o],source:s});const c=this.d[o];c&&(this.w(o,c),this.r(o,c))}this.m(i)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:i,source:t}of n)for(const s in i){const o=this.a.get(s),c=L.$ge(t)?t:t?.id,y=L.$ge(o?.source)?o?.source:o?.source?.id;if(c===y)if(r.add(s),this.a.delete(s),e.$5m.test(s))delete this.d[s],delete this.b.properties[s];else{const d=this.d[s];d&&(this.w(s,d),this.r(s,d))}}this.u()}deltaConfiguration(n){let r=!1;const i=new Set;n.removedDefaults&&(this.l(n.removedDefaults,i),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,i),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,i),n.addedConfigurations&&this.n(n.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,i){n.forEach(t=>{this.p(t,r,t.extensionInfo,t.restrictedProperties,void 0,i),this.c.push(t),this.q(t)})}o(n,r){const i=t=>{if(t.properties)for(const s in t.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,t.properties[s])}t.allOf?.forEach(s=>i(s))};for(const t of n){i(t);const s=this.c.indexOf(t);s!==-1&&this.c.splice(s,1)}}p(n,r=!0,i,t,s=3,o){s=L.$pe(n.scope)?s:n.scope;const c=n.properties;if(c)for(const d in c){const l=c[d];if(r&&p(d,l)){delete c[d];continue}if(l.source=i,l.defaultDefaultValue=c[d].default,this.w(d,l),e.$5m.test(d)?l.scope=void 0:(l.scope=L.$pe(l.scope)?s:l.scope,l.restricted=L.$pe(l.restricted)?!!t?.includes(d):l.restricted),c[d].hasOwnProperty("included")&&!c[d].included){this.f[d]=c[d],delete c[d];continue}else this.d[d]=c[d],c[d].policy?.name&&this.e.set(c[d].policy.name,d);!c[d].deprecationMessage&&c[d].markdownDeprecationMessage&&(c[d].deprecationMessage=c[d].markdownDeprecationMessage),o.add(d)}const y=n.allOf;if(y)for(const d of y)this.p(d,r,i,t,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=i=>{const t=i.properties;if(t)for(const o in t)this.r(o,t[o]);i.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$Vm.properties[n]=r,r.scope){case 1:e.$Wm.properties[n]=r;break;case 2:e.$Xm.properties[n]=r;break;case 6:e.$Ym.properties[n]=r;break;case 3:e.$Zm.properties[n]=r;break;case 4:e.$1m.properties[n]=r;break;case 5:e.$1m.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$Vm.properties[n],r.scope){case 1:delete e.$Wm.properties[n];break;case 2:delete e.$Xm.properties[n];break;case 6:delete e.$Ym.properties[n];break;case 3:delete e.$Zm.properties[n];break;case 4:case 5:delete e.$1m.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,i={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$2m};this.w(r,i),e.$Vm.properties[r]=i,e.$Wm.properties[r]=i,e.$Xm.properties[r]=i,e.$Ym.properties[r]=i,e.$Zm.properties[r]=i,e.$1m.properties[r]=i}}v(){const n={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$2m};e.$Vm.patternProperties[e.$4m]=n,e.$Wm.patternProperties[e.$4m]=n,e.$Xm.patternProperties[e.$4m]=n,e.$Ym.patternProperties[e.$4m]=n,e.$Zm.patternProperties[e.$4m]=n,e.$1m.patternProperties[e.$4m]=n,this.i.fire()}w(n,r){const i=this.a.get(n);let t=i?.value,s=i?.source;L.$ne(t)&&(t=r.defaultDefaultValue,s=void 0),L.$ne(t)&&(t=h(r.type)),r.default=t,r.defaultValueSource=s}}const f="\\[([^\\]]+)\\]",$=new RegExp(f,"g");e.$4m=`^(${f})+$`,e.$5m=new RegExp(e.$4m);function v(I){const n=[];if(e.$5m.test(I)){let r=$.exec(I);for(;r?.length;){const i=r[1].trim();i&&n.push(i),r=$.exec(I)}}return(0,R.$of)(n)}e.$6m=v;function a(I){return I.reduce((n,r)=>`${n}[${r}]`,"")}e.$7m=a;function h(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$8m=h;const u=new b;k.$Pm.add(e.$Um.Configuration,u);function p(I,n){return I.trim()?e.$5m.test(I)?j.localize(7,null,I):u.getConfigurationProperties()[I]!==void 0?j.localize(8,null,I):n.policy?.name&&u.getPolicyConfigurations().get(n.policy?.name)!==void 0?j.localize(9,null,I,n.policy?.name,u.getPolicyConfigurations().get(n.policy?.name)):null:j.localize(6,null)}e.$9m=p;function w(){const I=[],n=u.getConfigurationProperties();for(const r of Object.keys(n))I.push([r,n[r].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.$0m=w}),define(ae[73],ce([0,1,21,3,34,2,35,31,10,12,18,48,40]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=void 0;function f(r){return Object.isFrozen(r)?r:C.$Em(r)}class ${constructor(i={},t=[],s=[],o){this.b=i,this.c=t,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(t=>{if(t instanceof $)return t;const s=new v("");return s.parseRaw(t),s.configurationModel});this.f=i.reduce((t,s)=>s===t?s:t.merge(s),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,S.$Zh)(this.contents,i):this.contents}inspect(i,t){const s=this.rawConfiguration.getValue(i),o=t?this.rawConfiguration.getOverrideValue(i,t):void 0,c=t?this.rawConfiguration.override(t).getValue(i):s;return{value:s,override:o,merged:c}}getOverrideValue(i,t){const s=this.i(t);return s?i?(0,S.$Zh)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const s of this.overrides)s.identifiers.includes(i)&&t.push(...s.keys);return R.$of(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return R.$of(i)}override(i){let t=this.a.get(i);return t||(t=this.g(i),this.a.set(i,t)),t}merge(...i){const t=C.$Dm(this.contents),s=C.$Dm(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const y of i)if(c.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.h(t,y.contents);for(const d of y.overrides){const[l]=s.filter(P=>R.$$e(P.identifiers,d.identifiers));l?(this.h(l.contents,d.contents),l.keys.push(...d.keys),l.keys=R.$of(l.keys)):s.push(C.$Dm(d))}for(const d of y.keys)o.indexOf(d)===-1&&o.push(d)}return new $(t,o,s,c.every(y=>y instanceof $)?void 0:c)}g(i){const t=this.i(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const s={};for(const o of R.$of([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o];const y=t[o];y&&(typeof c=="object"&&typeof y=="object"?(c=C.$Dm(c),this.h(c,y)):c=y),s[o]=c}return new $(s,this.keys,this.overrides)}h(i,t){for(const s of Object.keys(t)){if(s in i&&k.$ie(i[s])&&k.$ie(t[s])){this.h(i[s],t[s]);continue}i[s]=C.$Dm(t[s])}}i(i){let t=null,s=null;const o=c=>{c&&(s?this.h(s,c):s=C.$Dm(c))};for(const c of this.overrides)R.$$e(c.identifiers,[i])?t=c.contents:c.identifiers.includes(i)&&o(c.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,t){this.j(i,t,!0)}setValue(i,t){this.j(i,t,!1)}removeValue(i){const t=this.keys.indexOf(i);t!==-1&&(this.keys.splice(t,1),(0,S.$Yh)(this.contents,i),E.$5m.test(i)&&this.overrides.splice(this.overrides.findIndex(s=>R.$$e(s.identifiers,(0,E.$6m)(i))),1))}j(i,t,s){(0,S.$Xh)(this.contents,i,t,o=>console.error(o)),s=s||this.keys.indexOf(i)===-1,s&&this.keys.push(i),E.$5m.test(i)&&this.overrides.push({identifiers:(0,E.$6m)(i),keys:Object.keys(this.contents[i]),contents:(0,S.$Wh)(this.contents[i],o=>console.error(o))})}}e.$$m=$;class v{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,t){if(!k.$pe(i)){const s=this.g(i);this.parseRaw(s,t)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,t){this.a=i;const{contents:s,keys:o,overrides:c,restricted:y,hasExcludedProperties:d}=this.h(i,t);this.b=new $(s,o,c,d?[i]:void 0),this.c=y||[]}g(i){let t={},s=null,o=[];const c=[],y=[];function d(P){Array.isArray(o)?o.push(P):s!==null&&(o[s]=P)}const l={onObjectBegin:()=>{const P={};d(P),c.push(o),o=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const P=[];d(P),c.push(o),o=P,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:d,onError:(P,D,T)=>{y.push({error:P,offset:D,length:T})}};if(i)try{L.$Am(i,l),t=o[0]||{}}catch(P){console.error(`Error while parsing settings file ${this.f}: ${P}`),this.d=[P]}return t}h(i,t){const s=b.$Pm.as(E.$Um.Configuration).getConfigurationProperties(),o=this.i(i,s,!0,t);i=o.raw;const c=(0,S.$Wh)(i,l=>console.error(`Conflict in settings file ${this.f}: ${l}`)),y=Object.keys(i),d=this.j(i,l=>console.error(`Conflict in settings file ${this.f}: ${l}`));return{contents:c,keys:y,overrides:d,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(i,t,s,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:c};const y={},d=[];for(const l in i)if(E.$5m.test(l)&&s){const P=this.i(i[l],t,!1,o);y[l]=P.raw,c=c||P.hasExcludedProperties,d.push(...P.restricted)}else{const P=t[l],D=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&d.push(l),(D===void 0||o.scopes===void 0||o.scopes.includes(D))&&!(o.skipRestricted&&P?.restricted)?y[l]=i[l]:c=!0}return{raw:y,restricted:d,hasExcludedProperties:c}}j(i,t){const s=[];for(const o of Object.keys(i))if(E.$5m.test(o)){const c={};for(const y in i[o])c[y]=i[o][y];s.push({identifiers:(0,E.$6m)(o),keys:Object.keys(c),contents:(0,S.$Wh)(c,t)})}return s}}e.$_m=v;class a extends j.$kb{constructor(i,t,s,o){super(),this.f=i,this.g=t,this.h=o,this.c=this.B(new M.$5c),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(M.Event.any(M.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),M.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&s.isEqual(c.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new $}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$an=a;class h{constructor(i,t,s,o,c,y,d,l,P,D,T,F,H){this.a=i,this.b=t,this.c=s,this.overrideIdentifiers=o,this.d=c,this.f=y,this.g=d,this.h=l,this.i=P,this.j=D,this.k=T,this.l=F,this.m=H}get value(){return f(this.c)}n(i,t,s){const o=i.inspect(t,s);return{get value(){return f(o.value)},get override(){return f(o.override)},get merged(){return f(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(i,t,s,o,c=new $,y=new $,d=new O.$ji,l=new $,P=new O.$ji){this.c=i,this.d=t,this.f=s,this.g=o,this.h=c,this.i=y,this.j=d,this.l=l,this.m=P,this.a=null,this.b=new O.$ji,this.n=null}getValue(i,t,s){return this.q(i,t,s).getValue(i)}updateValue(i,t,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new $,this.m.set(s.resource,o))):o=this.l,t===void 0?o.removeValue(i):o.setValue(i,t),s.resource||(this.a=null)}inspect(i,t,s){const o=this.q(i,t,s),c=this.u(t.resource,s),y=t.resource?this.m.get(t.resource)||this.l:this.l,d=new Set;for(const l of o.overrides)for(const P of l.identifiers)o.getOverrideValue(i,P)!==void 0&&d.add(P);return new h(i,t,o.getValue(i),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,c||void 0,y)}keys(i){const t=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,t){this.j.set(i,t),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const s=[];if(!t){const{added:o,updated:c,removed:y}=I(this.c,i);t=[...o,...c,...y]}for(const o of t)for(const c of(0,E.$6m)(o)){const y=this.c.getKeysForOverrideIdentifier(c),d=i.getKeysForOverrideIdentifier(c),l=[...d.filter(P=>y.indexOf(P)===-1),...y.filter(P=>d.indexOf(P)===-1),...y.filter(P=>!C.$Hm(this.c.override(c).getValue(P),i.override(c).getValue(P)))];s.push([c,l])}return this.updateDefaultConfiguration(i),{keys:t,overrides:s}}compareAndUpdatePolicyConfiguration(i){const{added:t,updated:s,removed:o}=I(this.d,i),c=[...t,...s,...o];return c.length&&this.updatePolicyConfiguration(i),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=I(this.applicationConfiguration,i),y=[...t,...s,...o];return y.length&&this.updateApplicationConfiguration(i),{keys:y,overrides:c}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=I(this.localUserConfiguration,i),y=[...t,...s,...o];return y.length&&this.updateLocalUserConfiguration(i),{keys:y,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=I(this.remoteUserConfiguration,i),y=[...t,...s,...o];return y.length&&this.updateRemoteUserConfiguration(i),{keys:y,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=I(this.workspaceConfiguration,i),y=[...t,...s,...o];return y.length&&this.updateWorkspaceConfiguration(i),{keys:y,overrides:c}}compareAndUpdateFolderConfiguration(i,t){const s=this.p.get(i),{added:o,updated:c,removed:y,overrides:d}=I(s,t),l=[...o,...c,...y];return(l.length||!s)&&this.updateFolderConfiguration(i,t),{keys:l,overrides:d}}compareAndDeleteFolderConfiguration(i){const t=this.p.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:o,removed:c,overrides:y}=I(t,void 0);return{keys:[...s,...o,...c],overrides:y}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,t,s){let o=this.r(t,s);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(o=o.merge(this.d)),o}r({resource:i},t){let s=this.s();if(t&&i){const o=t.getFolder(i);o&&(s=this.t(o.uri)||s);const c=this.m.get(i);c&&(s=s.merge(c))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let t=this.b.get(i);if(!t){const s=this.s(),o=this.j.get(i);o?(t=s.merge(o),this.b.set(i,t)):t=s}return t}u(i,t){if(t&&i){const s=t.getFolder(i);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,t)=>{const{contents:s,overrides:o,keys:c}=this.j.get(t);return i.push([t,{contents:s,overrides:o,keys:c}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(t=>i.add(t)),this.userConfiguration.keys.forEach(t=>i.add(t)),this.i.keys.forEach(t=>i.add(t)),this.j.forEach(t=>t.keys.forEach(s=>i.add(s))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}w(i){const t=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.i.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o))),[...t.values()]}static parse(i){const t=this.x(i.defaults),s=this.x(i.policy),o=this.x(i.application),c=this.x(i.user),y=this.x(i.workspace),d=i.folders.reduce((l,P)=>(l.set(m.URI.revive(P[0]),this.x(P[1])),l),new O.$ji);return new u(t,s,o,c,new $,y,d,new $,new O.$ji)}static x(i){return new $(i.contents,i.keys,i.overrides)}}e.$bn=u;function p(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const i=new Set,t=new Map;for(const o of r)o.keys.forEach(c=>i.add(c)),o.overrides.forEach(([c,y])=>{const d=(0,O.$gi)(t,c,new Set);y.forEach(l=>d.add(l))});const s=[];return t.forEach((o,c)=>s.push([c,[...o.values()]])),{keys:[...i.values()],overrides:s}}e.$cn=p;class w{constructor(i,t,s,o){this.change=i,this.f=t,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of i.keys)this.affectedKeys.add(c);for(const[,c]of i.overrides)for(const y of c)this.affectedKeys.add(y);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(i,t){const s=this.a+i,o=this.d.indexOf(s);if(o<0)return!1;const c=o+s.length;if(c>=this.d.length)return!1;const y=this.d.charCodeAt(c);if(y!==this.b&&y!==this.c)return!1;if(t){const d=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.f?.workspace):void 0,l=this.g.getValue(i,t,this.h);return!C.$Hm(d,l)}return!0}}e.$dn=w;function I(r,i){const{added:t,removed:s,updated:o}=n(i?.rawConfiguration,r?.rawConfiguration),c=[],y=r?.getAllOverrideIdentifiers()||[],d=i?.getAllOverrideIdentifiers()||[];if(i){const l=d.filter(P=>!y.includes(P));for(const P of l)c.push([P,i.getKeysForOverrideIdentifier(P)])}if(r){const l=y.filter(P=>!d.includes(P));for(const P of l)c.push([P,r.getKeysForOverrideIdentifier(P)])}if(i&&r){for(const l of y)if(d.includes(l)){const P=n({contents:r.getOverrideValue(void 0,l)||{},keys:r.getKeysForOverrideIdentifier(l)},{contents:i.getOverrideValue(void 0,l)||{},keys:i.getKeysForOverrideIdentifier(l)});c.push([l,[...P.added,...P.removed,...P.updated]])}}return{added:t,removed:s,updated:o,overrides:c}}function n(r,i){const t=r?i?r.keys.filter(c=>i.keys.indexOf(c)===-1):[...r.keys]:[],s=i?r?i.keys.filter(c=>r.keys.indexOf(c)===-1):[...i.keys]:[],o=[];if(r&&i){for(const c of i.keys)if(r.keys.indexOf(c)!==-1){const y=(0,S.$Zh)(i.contents,c),d=(0,S.$Zh)(r.contents,c);C.$Hm(y,d)||o.push(c)}}return{added:t,removed:s,updated:o}}}),define(ae[201],ce([0,1,21,3,2,31,10,73,48,8,55,40]),function(ne,e,R,M,L,j,O,C,k,m,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=void 0;class b extends L.$kb{constructor(){super(...arguments),this.a=this.B(new M.$5c),this.onDidChangeConfiguration=this.a.event,this.b=new C.$$m}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$Pm.as(k.$Um.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:h})=>this.c(Array.from(a),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(a,h){this.h(a,E.$Pm.as(k.$Um.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:a})}f(){return{}}g(){this.b=new C.$$m;const a=E.$Pm.as(k.$Um.Configuration).getConfigurationProperties();this.h(Object.keys(a),a)}h(a,h){const u=this.f();for(const p of a){const w=u[p],I=h[p];w!==void 0?this.b.addValue(p,w):I?this.b.addValue(p,I.default):this.b.removeValue(p)}}}e.$en=b;class f{constructor(){this.onDidChangeConfiguration=M.Event.None,this.configurationModel=new C.$$m}async initialize(){return this.configurationModel}}e.$fn=f;let $=e.$gn=class extends L.$kb{get configurationModel(){return this.b}constructor(a,h,u){super(),this.c=a,this.f=h,this.g=u,this.a=this.B(new M.$5c),this.onDidChangeConfiguration=this.a.event,this.b=new C.$$m}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(a=>this.i(a))),this.B(this.c.onDidChangeConfiguration(async({properties:a})=>this.j(await this.h(a),!0))),this.b}async h(a){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",a);const h={},u=[],p=E.$Pm.as(k.$Um.Configuration).getConfigurationProperties();for(const w of a){const I=p[w];if(!I){u.push(w);continue}if(I.policy){if(I.type!=="string"&&I.type!=="number"){this.g.warn(`Policy ${I.policy.name} has unsupported type ${I.type}`);continue}u.push(w),h[I.policy.name]={type:I.type}}}return(0,O.$te)(h)||await this.f.updatePolicyDefinitions(h),u}i(a){this.g.trace("PolicyConfiguration#onDidChangePolicies",a);const h=E.$Pm.as(k.$Um.Configuration).getPolicyConfigurations(),u=(0,R.$jf)(a.map(p=>h.get(p)));this.j(u,!0)}j(a,h){this.g.trace("PolicyConfiguration#update",a);const u=E.$Pm.as(k.$Um.Configuration).getConfigurationProperties(),p=[],w=this.b.isEmpty();for(const I of a){const n=u[I]?.policy?.name;if(n){const r=this.f.getPolicyValue(n);(w?r!==void 0:!(0,j.$Hm)(this.b.getValue(I),r))&&p.push([I,r])}else this.b.getValue(I)!==void 0&&p.push([I,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const I=this.b;this.b=new C.$$m;for(const n of I.keys)this.b.setValue(n,I.getValue(n));for(const[n,r]of p)r===void 0?this.b.removeValue(n):this.b.setValue(n,r);h&&this.a.fire(this.b)}}};e.$gn=$=we([Y(1,S.$Rm),Y(2,m.$Ni)],$)}),define(ae[202],ce([0,1,6,3,2,22,18,73,201,55]),function(ne,e,R,M,L,j,O,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0;class S extends L.$kb{constructor(b,f,$,v){super(),this.i=b,this.h=this.B(new M.$5c),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new k.$en),this.c=$ instanceof m.$Tm?new k.$fn:this.B(new k.$gn(this.b,$,v)),this.f=this.B(new C.$an(this.i,void 0,j.$Wf,f)),this.a=new C.$bn(this.b.configurationModel,this.c.configurationModel,new C.$$m,new C.$$m),this.g=this.B(new R.$Cg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:h})=>this.k(a,h))),this.B(this.c.onDidChangeConfiguration(a=>this.l(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,f,$]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new C.$bn(b,f,new C.$$m,$)}getConfigurationData(){return this.a.toData()}getValue(b,f){const $=typeof b=="string"?b:void 0,v=(0,O.$Sh)(b)?b:(0,O.$Sh)(f)?f:{};return this.a.getValue($,v,void 0)}updateValue(b,f,$,v){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.j(b)}j(b){const f=this.a.toData(),$=this.a.compareAndUpdateLocalUserConfiguration(b);this.m($,f,2)}k(b,f){const $=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(b,f);this.m(v,$,7)}l(b){const f=this.a.toData(),$=this.a.compareAndUpdatePolicyConfiguration(b);this.m($,f,7)}m(b,f,$){const v=new C.$dn(b,{data:f},this.a);v.source=$,v.sourceConfig=this.n($),this.h.fire(v)}n(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$hn=S}),define(ae[203],ce([0,1,16]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thb=e.$shb=void 0;const M=(L,j,O)=>{const C=new Uint8Array(16);for(let S=0;S<16;S++)C[S]=Math.round(Math.random()*256);const k=(0,R.$2b)(R.$Ib.wrap(C));return[`GET ws://localhost${L}?${j}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$shb=M,e.$thb=R.$Ib.fromString(`\r
\r
`)}),define(ae[204],ce([0,1,7,4]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=e.RemoteAuthorityResolverErrorCode=e.$uk=e.$tk=e.RemoteConnectionType=e.$sk=void 0,e.$sk=(0,M.$lh)("remoteAuthorityResolverService");var L;(function(S){S[S.WebSocket=0]="WebSocket",S[S.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class j{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$tk=j;class O{constructor(E,b){this.host=E,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$uk=O;var C;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(C||(e.RemoteAuthorityResolverErrorCode=C={}));class k extends R.$_{static isNotAvailable(E){return E instanceof k&&E._code===C.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof k&&E._code===C.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof k&&E._code===C.NoResolverFound}static isHandled(E){return E instanceof k&&E.isHandled}constructor(E,b=C.Unknown,f){super(E),this._message=E,this._code=b,this._detail=f,this.isHandled=b===C.NotAvailable&&f===!0,Object.setPrototypeOf(this,k.prototype)}}e.$vk=k;function m(S){const E=S.indexOf("+");return E===-1?S:S.substring(0,E)}e.$wk=m}),define(ae[74],ce([0,1,25]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=void 0;function M(m){return m.scheme===R.Schemas.vscodeRemote?m.authority:void 0}e.$xk=M;function L(m){if(!m)return;const S=m.indexOf("+");return S<0?m:m.substr(0,S)}e.$yk=L;function j(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.$zk=j;function O(m){const{host:S,port:E}=k(m);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:S,port:E}}e.$Ak=O;function C(m,S){let{host:E,port:b}=k(m);return typeof b>"u"&&(b=S),{host:E,port:b}}e.$Bk=C;function k(m){const S=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const E=m.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const b=m.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:m,port:void 0}}}),define(ae[49],ce([0,1,27,4,74]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.TargetPlatform=e.ExtensionType=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=void 0,e.$xl="extensions.user.cache",e.$yl="extensions.builtin.cache",e.$zl="undefined_publisher",e.$Al=["ui","workspace","web"];function j(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Bl=j,e.$Cl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(O||(e.ExtensionType=O={}));var C;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(C||(e.TargetPlatform=C={}));class k{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,h){if(typeof a>"u"||a===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof a=="string"||typeof h=="string"){const u=typeof a=="string"?a:a.value,p=typeof h=="string"?h:h.value;return R.$Jd(u,p)}return a._lower===h._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.$Dl=k;class m{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const h of a)this.add(h)}add(a){this.c.add(k.toKey(a))}delete(a){return this.c.delete(k.toKey(a))}has(a){return this.c.has(k.toKey(a))}}e.$El=m;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(k.toKey(a))}get(a){return this.c.get(k.toKey(a))}has(a){return this.c.has(k.toKey(a))}set(a,h){this.c.set(k.toKey(a),h)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fl=S;function E(v){return b(v)}e.$Gl=E;function b(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$Hl=b;function f(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$Il=f;function $(v,a){if(a){const h=`onResolveRemoteAuthority:${(0,L.$yk)(a)}`;return!!v.activationEvents?.includes(h)}return!1}e.$Jl=$,e.$Kl=(0,M.$lh)("IBuiltinExtensionsScannerService")}),define(ae[205],ce([0,1,2,49,13]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=void 0;class j extends R.$kb{constructor(C,k,m,S,E){super(),this.a=C,this.b=k,this.c=m,this.f=E,this.B(S.onDidInstallExtensions(b=>this.g(b))),this.B(S.onDidUninstallExtension(b=>this.h(b)))}g(C){for(const k of C)k.local&&this.invalidate(k.profileLocation)}h(C){C.error||this.invalidate(C.profileLocation)}async invalidate(C){if(C)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,C)&&await this.i(k);else await this.i(this.a.defaultProfile)}async i(C){try{await this.b.del(this.c.extUri.joinPath(C.cacheHome,M.$xl))}catch(k){(0,L.$5j)(k)!==1&&this.f.error(k)}}}e.$hp=j}),define(ae[206],ce([0,1,6,16,26,7,3,2,100,87,32,92,204,74]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.PersistentConnectionEventType=e.$Ik=e.$Hk=e.$Gk=e.ConnectionType=void 0;const $=30*1e3;var v;(function(N){N[N.Management=1]="Management",N[N.ExtensionHost=2]="ExtensionHost",N[N.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function a(N){switch(N){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(N){const g=new L.$bd;return setTimeout(()=>g.cancel(),N),g.token}function u(N,g){if(N.isCancellationRequested||g.isCancellationRequested)return L.CancellationToken.Cancelled;const A=new L.$bd;return N.onCancellationRequested(()=>A.cancel()),g.onCancellationRequested(()=>A.cancel()),A.token}class p{get didTimeout(){return this.c==="timedout"}constructor(g){this.c="pending",this.d=new C.$jb,this.promise=new Promise((A,U)=>{this.f=A,this.g=U}),g.isCancellationRequested?this.h():this.d.add(g.onCancellationRequested(()=>this.h()))}registerDisposable(g){this.c==="pending"?this.d.add(g):g.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const g=new Error("Time limit reached");return g.code="ETIMEDOUT",g.syscall="connect",g}resolve(g){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(g))}reject(g){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(g))}}function w(N,g){const A=new p(g);return A.registerDisposable(N.onControlMessage(U=>{const Q=JSON.parse(U.toString()),z=G(Q);z?A.reject(z):A.resolve(Q)})),A.promise}function I(N,g,A,U,Q,z,J,te){const oe=new p(te),he=m.$1c.create(!1);return N.info(`Creating a socket (${J})...`),k.mark(`code/willCreateSocket/${z}`),g.connect(A,U,Q,J).then(fe=>{oe.didTimeout?(k.mark(`code/didCreateSocketError/${z}`),N.info(`Creating a socket (${J}) finished after ${he.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(k.mark(`code/didCreateSocketOK/${z}`),N.info(`Creating a socket (${J}) was successful after ${he.elapsed()} ms.`),oe.resolve(fe))},fe=>{k.mark(`code/didCreateSocketError/${z}`),N.info(`Creating a socket (${J}) returned an error after ${he.elapsed()} ms.`),N.error(fe),oe.reject(fe)}),oe.promise}function n(N,g){const A=new p(g);return N.then(U=>{A.didTimeout||A.resolve(U)},U=>{A.didTimeout||A.reject(U)}),A.promise}async function r(N,g,A,U){const Q=K(N,g);N.logService.trace(`${Q} 1/6. invoking socketFactory.connect().`);let z;try{z=await I(N.logService,N.remoteSocketFactoryService,N.connectTo,(0,f.$zk)(N),`reconnectionToken=${N.reconnectionToken}&reconnection=${N.reconnectionProtocol?"true":"false"}`,a(g),`renderer-${a(g)}-${N.reconnectionToken}`,U)}catch(fe){throw N.logService.error(`${Q} socketFactory.connect() failed or timed out. Error:`),N.logService.error(fe),fe}N.logService.trace(`${Q} 2/6. socketFactory.connect() was successful.`);let J,te;N.reconnectionProtocol?(N.reconnectionProtocol.beginAcceptReconnection(z,null),J=N.reconnectionProtocol,te=!1):(J=new E.$_g({socket:z}),te=!0),N.logService.trace(`${Q} 3/6. sending AuthRequest control message.`);const oe=await n(N.signService.createNewMessage((0,S.$3e)()),U),he={type:"auth",auth:N.connectionToken||"00000000000000000000",data:oe.data};J.sendControl(M.$Ib.fromString(JSON.stringify(he)));try{const fe=await w(J,u(U,h(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(N.logService.trace(`${Q} 4/6. received SignRequest control message.`),!await n(N.signService.validate(oe,fe.signedData),U)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const pe=await n(N.signService.sign(fe.data),U),Ee={type:"connectionType",commit:N.commit,signedData:pe,desiredConnectionType:g};return A&&(Ee.args=A),N.logService.trace(`${Q} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(M.$Ib.fromString(JSON.stringify(Ee))),{protocol:J,ownsProtocol:te}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(N.logService.error(`${Q} the handshake timed out. Error:`),N.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(N.logService.error(`${Q} received error control message when negotiating connection. Error:`),N.logService.error(fe)),te&&q(J),fe}}async function i(N,g,A,U){const Q=Date.now(),z=K(N,g),{protocol:J,ownsProtocol:te}=await r(N,g,A,U),oe=new p(U);return oe.registerDisposable(J.onControlMessage(he=>{const fe=JSON.parse(he.toString()),be=G(fe);be?(N.logService.error(`${z} received error control message when negotiating connection. Error:`),N.logService.error(be),te&&q(J),oe.reject(be)):(N.reconnectionProtocol?.endAcceptReconnection(),N.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${Z(Q)}!`),oe.resolve({protocol:J,firstMessage:fe}))})),oe.promise}async function t(N,g){const{protocol:A}=await i(N,1,void 0,g);return{protocol:A}}async function s(N,g,A){const{protocol:U,firstMessage:Q}=await i(N,2,g,A),z=Q&&Q.debugPort;return{protocol:U,debugPort:z}}async function o(N,g,A){const U=Date.now(),Q=K(N,3),{protocol:z}=await r(N,3,g,A);return N.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${Z(U)}!`),z}async function c(N,g,A){const{connectTo:U,connectionToken:Q}=await N.addressProvider.getAddress();return{commit:N.commit,quality:N.quality,connectTo:U,connectionToken:Q,reconnectionToken:g,reconnectionProtocol:A,remoteSocketFactoryService:N.remoteSocketFactoryService,signService:N.signService,logService:N.logService}}async function y(N,g,A){return l(N,async U=>{const{protocol:Q}=await t(U,L.CancellationToken.None);return new X(N,g,A,U.reconnectionToken,Q)})}e.$Gk=y;async function d(N,g){return l(N,async A=>{const{protocol:U,debugPort:Q}=await s(A,g,L.CancellationToken.None);return new _(N,g,A.reconnectionToken,U,Q)})}e.$Hk=d;async function l(N,g){for(let U=1;;U++)try{const Q=(0,S.$3e)(),z=await c(N,Q,null);return await g(z)}catch(Q){if(U<5)N.logService.error(`[remote-connection][attempt ${U}] An error occurred in initial connection! Will retry... Error:`),N.logService.error(Q);else throw N.logService.error(`[remote-connection][attempt ${U}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),N.logService.error(Q),ee.triggerPermanentFailure(0,0,b.$vk.isHandled(Q)),Q}}async function P(N,g,A){const U=await c(N,(0,S.$3e)(),null);return await o(U,{host:g,port:A},L.CancellationToken.None)}e.$Ik=P;function D(N){return(0,R.$fg)(g=>new Promise((A,U)=>{const Q=setTimeout(A,N*1e3);g.onCancellationRequested(()=>{clearTimeout(Q),A()})}))}var T;(function(N){N[N.ConnectionLost=0]="ConnectionLost",N[N.ReconnectionWait=1]="ReconnectionWait",N[N.ReconnectionRunning=2]="ReconnectionRunning",N[N.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",N[N.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class F{constructor(g,A){this.reconnectionToken=g,this.millisSinceLastIncomingData=A,this.type=0}}e.$Jk=F;class H{constructor(g,A,U,Q){this.reconnectionToken=g,this.millisSinceLastIncomingData=A,this.durationSeconds=U,this.c=Q,this.type=1}skipWait(){this.c.cancel()}}e.$Kk=H;class V{constructor(g,A,U){this.reconnectionToken=g,this.millisSinceLastIncomingData=A,this.attempt=U,this.type=2}}e.$Lk=V;class W{constructor(g,A,U){this.reconnectionToken=g,this.millisSinceLastIncomingData=A,this.attempt=U,this.type=4}}e.$Mk=W;class x{constructor(g,A,U,Q){this.reconnectionToken=g,this.millisSinceLastIncomingData=A,this.attempt=U,this.handled=Q,this.type=3}}e.$Nk=x;class ee extends C.$kb{static triggerPermanentFailure(g,A,U){this._permanentFailure=!0,this.f=g,this.g=A,this.h=U,this.i.forEach(Q=>Q.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(g=>g.s())}static debugPauseSocketWriting(){this.i.forEach(g=>g.w())}get k(){return this.c||ee._permanentFailure}constructor(g,A,U,Q,z){super(),this.n=g,this.p=A,this.reconnectionToken=U,this.protocol=Q,this.r=z,this.j=this.B(new O.$5c),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new W(this.reconnectionToken,0,0)),this.B(Q.onSocketClose(J=>{const te=re(this.n,this.reconnectionToken,!0);J?J.type===0?(this.p.logService.info(`${te} received socket close event (hadError: ${J.hadError}).`),J.error&&this.p.logService.error(J.error)):(this.p.logService.info(`${te} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.p.logService.error(J.event)):this.p.logService.info(`${te} received socket close event.`),this.s()})),this.B(Q.onSocketTimeout(J=>{const te=re(this.n,this.reconnectionToken,!0);this.p.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.s()})),ee.i.push(this),this.B((0,C.$ib)(()=>{const J=ee.i.indexOf(this);J>=0&&ee.i.splice(J,1)})),this.k&&this.v(ee.f,ee.g,ee.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const g=re(this.n,this.reconnectionToken,!0);this.p.logService.info(`${g} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const A=[0,5,5,10,10,10,10,10,30];let U=-1;do{U++;const Q=U<A.length?A[U]:A[A.length-1];try{if(Q>0){const J=D(Q);this.j.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q,J)),this.p.logService.info(`${g} waiting for ${Q} seconds before reconnecting...`);try{await J}catch{}}if(this.k){this.p.logService.error(`${g} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1)),this.p.logService.info(`${g} resolving connection...`);const z=await c(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${g} connecting to ${z.connectTo}...`),await this.y(z,h($)),this.p.logService.info(`${g} reconnected!`),this.j.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${g} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(U>360){this.p.logService.error(`${g} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(b.$vk.isTemporarilyNotAvailable(z)){this.p.logService.info(`${g} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.p.logService.info(`${g} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(z);continue}if((0,j.$1)(z)){this.p.logService.info(`${g} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(z);continue}if(z instanceof b.$vk){this.p.logService.error(`${g} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),U+1,b.$vk.isHandled(z));break}this.p.logService.error(`${g} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}}while(!this.k&&!this.m)}u(g,A,U){this.r?ee.triggerPermanentFailure(g,A,U):this.v(g,A,U)}v(g,A,U){this.j.fire(new x(this.reconnectionToken,g,A,U)),q(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.$Ok=ee,ee._permanentFailure=!1,ee.f=0,ee.g=0,ee.h=!1,ee.i=[];class X extends ee{constructor(g,A,U,Q,z){super(1,g,Q,z,!0),this.client=this.B(new E.$0g(z,{remoteAuthority:A,clientId:U},g.ipcLogger))}async y(g,A){await t(g,A)}}e.$Pk=X;class _ extends ee{constructor(g,A,U,Q,z){super(2,g,U,Q,!1),this.z=A,this.debugPort=z}async y(g,A){await s(g,this.z,A)}}e.$Qk=_;function q(N){try{N.acceptDisconnect();const g=N.getSocket();N.dispose(),g.dispose()}catch(g){(0,j.$X)(g)}}function G(N){if(N&&N.type==="error"){const g=new Error(`Connection error: ${N.reason}`);return g.code="VSCODE_CONNECTION_ERROR",g}return null}function B(N,g){for(;N.length<g;)N+=" ";return N}function ie(N,g){return`[remote-connection][${B(a(N),13)}][${g.substr(0,5)}\u2026]`}function re(N,g,A){return`${ie(N,g)}[${A?"reconnect":"initial"}]`}function K(N,g){return`${re(g,N.reconnectionToken,!!N.reconnectionProtocol)}[${N.connectTo}]`}function Z(N){return`${Date.now()-N} ms`}}),define(ae[104],ce([0,1,2,4]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.$Ck=void 0,e.$Ck=(0,M.$lh)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(O,C){return this.a[O]??=[],this.a[O].push(C),(0,R.$ib)(()=>{const k=this.a[O]?.indexOf(C);typeof k=="number"&&k>=0&&this.a[O]?.splice(k,1)})}b(O){return(this.a[O.type]||[]).find(k=>k.supports(O))}connect(O,C,k,m){const S=this.b(O);if(!S)throw new Error(`No socket factory found for ${O}`);return S.connect(O,C,k,m)}}e.$Dk=L}),define(ae[207],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R4b=e.$Q4b=void 0,e.$Q4b=(0,R.$lh)("sharedProcessTunnelService"),e.$R4b="sharedProcessTunnel"}),define(ae[105],ce([0,1,4,157]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$24b=e.$14b=e.$Z4b=e.$Y4b=e.$X4b=e.TunnelStates=e.$W4b=void 0,e.$W4b=(0,R.$lh)("IRemoteTunnelService");var L;(function(j){j.disconnected=O=>({type:"disconnected",onTokenFailed:O}),j.connected=O=>({type:"connected",info:O}),j.connecting=O=>({type:"connecting",progress:O}),j.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$X4b="remote.tunnels.access",e.$Y4b=e.$X4b+".hostNameOverride",e.$Z4b=e.$X4b+".preventSleep",e.$14b="remoteTunnelService",e.$24b=(0,M.localize)(0,null)}),define(ae[56],ce([0,1,16,7,2,159,48,4,8,40]),function(ne,e,R,M,L,j,O,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=void 0,e.$uo=(0,C.$lh)("requestService");class S{constructor(I){this.b=I}toJSON(){if(!this.a){const I=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?I[n]="*****":I[n]=this.b[n];this.a=I}return this.a}}class E extends L.$kb{constructor(I){super(),this.b=0,this.a=I.createLogger("network",{name:(0,j.localize)(0,null),when:k.$5i.isEqualTo((0,k.$3i)(k.LogLevel.Trace)).serialize()})}async c(I,n,r){const i=`${I} #${++this.b}: ${n.url}`;this.a.trace(`${i} - begin`,n.type,new S(n.headers??{}));try{const t=await r();return this.a.trace(`${i} - end`,n.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${i} - error`,n.type,(0,M.$8)(t)),t}}}e.$vo=E;function b(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.$wo=b;function f(w){return w.res.statusCode===204}async function $(w){return f(w)?null:(await(0,R.$Tb)(w.stream)).toString()}e.$xo=$;async function v(w){if(!b(w))throw new Error("Server returned "+w.res.statusCode);return $(w)}e.$yo=v;async function a(w){if(!b(w))throw new Error("Server returned "+w.res.statusCode);if(f(w))return null;const n=(await(0,R.$Tb)(w.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}e.$zo=a;function h(w){p(w)}e.$Ao=h;let u;function p(w){const I=m.$Pm.as(O.$Um.Configuration),n=u;u={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(5,null),(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null)],default:"override",description:(0,j.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(10,null),restricted:!0}}},I.updateConfigurations({add:[u],remove:n?[n]:[]})}p(1)}),define(ae[208],ce([0,1,26,25,13,56]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=void 0;let O=e.$LM=class{constructor(k,m){this.a=k,this.b=m}async download(k,m,S=R.CancellationToken.None){if(k.scheme===M.Schemas.file||k.scheme===M.Schemas.vscodeRemote){await this.b.copy(k,m);return}const E={type:"GET",url:k.toString(!0)},b=await this.a.request(E,S);if(b.res.statusCode===200)await this.b.writeFile(m,b.stream);else{const f=await(0,j.$yo)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${f}`)}}};e.$LM=O=we([Y(0,j.$uo),Y(1,L.$Oj)],O)}),define(ae[209],ce([0,1,16,26]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=void 0;class L{constructor(C){this.a=C}listen(C,k){throw new Error("Invalid listen")}call(C,k,m,S=M.CancellationToken.None){switch(k){case"request":return this.a.request(m[0],S).then(async({res:E,stream:b})=>{const f=await(0,R.$Tb)(b);return[{statusCode:E.statusCode,headers:E.headers},f]});case"resolveProxy":return this.a.resolveProxy(m[0])}throw new Error("Invalid call")}}e.$wq=L;class j{constructor(C){this.a=C}async request(C,k){const[m,S]=await this.a.call("request",[C],k);return{res:m,stream:(0,R.$Vb)(S)}}async resolveProxy(C){return this.a.call("resolveProxy",[C])}}e.$xq=j}),define(ae[210],ce([0,1,59,25,175]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E4b=void 0;class j extends L.$Tl{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:M.Schemas.vscodeUserData})}}e.$E4b=j,we([R.$Pg],j.prototype,"userRoamingDataHome",null)}),define(ae[211],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pYb=void 0;class R{constructor(){this.b=new Map}async createNewMessage(L){try{const j=await this.c();if(j){const O=String(R.a++);return this.b.set(O,j),{id:O,data:j.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,j){if(!L.id)return!0;const O=this.b.get(L.id);if(!O)return!1;this.b.delete(L.id);try{return O.validate(j)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$pYb=R,R.a=1}),define(ae[106],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=void 0,e.$Ek="signService",e.$Fk=(0,R.$lh)(e.$Ek)}),define(ae[212],ce([0,1,211]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$03b=void 0;class M extends R.$pYb{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(O=>new O.signer().sign(j))}h(){return new Promise((j,O)=>ne(["vsda"],j,O))}}e.$03b=M}),define(ae[75],ce([0,1,3,2]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0wb=e.$9wb=e.$8wb=e.$7wb=void 0;class L extends M.$kb{constructor(E,b,f){super(),this.a=E,this.b=b,this.c=f}async getItems(){const E={profile:this.b,workspace:this.c},b=await this.a.call("getItems",E);return new Map(b)}updateItems(E){const b={profile:this.b,workspace:this.c};return E.insert&&(b.insert=Array.from(E.insert.entries())),E.delete&&(b.delete=Array.from(E.delete.values())),this.a.call("updateItems",b)}}class j extends L{constructor(E,b){super(E,b,void 0),this.f=this.B(new R.$5c),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class O extends j{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$7wb=O;class C extends j{constructor(E,b){super(E,b)}async close(){this.dispose()}}e.$8wb=C;class k extends L{constructor(E,b){super(E,void 0,b),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.$9wb=k;class m{constructor(E){this.a=E}isUsed(E){const b={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",b)}}e.$0wb=m}),define(ae[107],ce([0,1,5,37,32]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=void 0;function j(k){if(R.$t===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function O(k,m,S,E,b,f,$,v){const a=Object.create(null);a["common.machineId"]=f,a.sessionID=(0,L.$3e)()+Date.now(),a.commitHash=E,a.version=b,a["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,R.$h)(R.$t),a["common.nodePlatform"]=M.$5b,a["common.nodeArch"]=S,a["common.product"]=v||"desktop",$&&(a["common.msftInternal"]=$);let h=0;const u=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),R.$l&&(a["common.snap"]="true");const p=j(m);return p&&(a["common.platformDetail"]=p),a}e.$Vn=O;function C(k){const m=M.env.USERDNSDOMAIN;if(!m)return!1;const S=m.toLowerCase();return k.some(E=>S===E)}e.$Wn=C}),define(ae[20],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0,e.$Rk=(0,R.$lh)("telemetryService"),e.$Sk=(0,R.$lh)("customEndpointTelemetryService"),e.$Tk="telemetry.currentSessionDate",e.$Uk="telemetry.firstSessionDate",e.$Vk="telemetry.lastSessionDate",e.$Wk="telemetry.machineId",e.$Xk="telemetry",e.$Yk="telemetry.telemetryLevel",e.$Zk="telemetry.enableCrashReporter",e.$1k="telemetry.enableTelemetry";var M;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var L;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ae[213],ce([0,1,36,6,34,25,15,5,12,127,30,139,95,13,24,20]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=e.$cr=void 0;const a=new Map;async function h(n,r){const i=`${n}::${r.join(":")}`,t=a.get(i);if(t)return t;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,c=new Map,y=2e4;function d(P,D,T,F){const H=D.substring(P.length+1);return M.Promises.withAsyncBody(async V=>{let W;try{W=await S.Promises.readdir(D,{withFileTypes:!0})}catch{V();return}if(F.count>=y){F.count+=W.length,F.maxReached=!0,V();return}let x=W.length;if(x===0){V();return}let ee=W;F.count+W.length>y&&(F.maxReached=!0,x=y-F.count,ee=W.slice(0,x)),F.count+=W.length;for(const X of ee)if(X.isDirectory()){if(T.includes(X.name)||await d(P,(0,O.$$b)(D,X.name),T,F),--x===0){V();return}}else{const _=X.name.lastIndexOf(".");if(_>=0){const q=X.name.substring(_+1);q&&o.set(q,(o.get(q)??0)+1)}for(const q of s)q.relativePathPattern?.test(H)!==!1&&q.filePattern.test(X.name)&&c.set(q.tag,(c.get(q.tag)??0)+1);if(--x===0){V();return}}})}const l=M.Promises.withAsyncBody(async P=>{const D={count:0,maxReached:!1};await d(n,n,r,D);const T=await w(n);P({configFiles:u(c),fileTypes:u(o),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:T})});return a.set(i,l),l}e.$cr=h;function u(n){return Array.from(n.entries(),([r,i])=>({name:r,count:i})).sort((r,i)=>i.count-r.count)}function p(){const n={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/f.$jk.GB).toFixed(2)}GB (${(R.freemem()/f.$jk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.$pm.value()*100)}%`},r=R.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.$dr=p;async function w(n){try{const r=new Map,i=(0,O.$$b)(n,".vscode","launch.json"),t=await S.Promises.readFile(i),s=[],o=(0,L.$tm)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),[];if((0,L.$Cm)(o)==="object"&&o.configurations)for(const c of o.configurations){const y=c.type;y&&(r.has(y)?r.set(y,r.get(y)+1):r.set(y,1))}return u(r)}catch{return[]}}e.$er=w;let I=e.$fr=class{constructor(r,i){this.c=r,this.d=i}f(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}g(r){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const t=R.cpus();return t&&t.length>0&&i.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),i.push(`Memory (System):  ${(R.totalmem()/f.$jk.GB).toFixed(2)}GB (${(R.freemem()/f.$jk.GB).toFixed(2)}GB free)`),C.$i||i.push(`Load (avg):       ${R.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(m.$pm.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,E.$br)(r.mainPID),this.k(r)]).then(async t=>{let[s,o]=t,c=this.m(r,s);return i.forEach(y=>{if((0,b.$2l)(y))c+=`
${y.errorMessage}`,o+=`
${y.errorMessage}`;else if(c+=`

Remote: ${y.hostName}`,y.processes&&(c+=`
${this.m(r,y.processes)}`),y.workspaceMetadata){o+=`
|  Remote: ${y.hostName}`;for(const d of Object.keys(y.workspaceMetadata)){const l=y.workspaceMetadata[d];let P=`${l.fileCount} files`;l.maxFilesReached&&(P=`more than ${P}`),o+=`|    Folder (${d}): ${P}`,o+=this.h(l)}}}),{processInfo:c,workspaceInfo:o}})}async getSystemInfo(r,i){const{memory:t,vmHint:s,os:o,cpus:c}=p(),y={os:o,memory:t,cpus:c,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return C.$i||(y.load=`${R.loadavg().map(d=>Math.round(d)).join(", ")}`),C.$k&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(r,i){const t=[];return(0,E.$br)(r.mainPID).then(async s=>(t.push(""),t.push(this.g(r)),t.push(""),t.push(this.m(r,s)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(r))),i.forEach(o=>{if((0,b.$2l)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.f(o.machineInfo)),o.processes&&t.push(this.m(r,o.processes)),o.workspaceMetadata)for(const c of Object.keys(o.workspaceMetadata)){const y=o.workspaceMetadata[c];let d=`${y.fileCount} files`;y.maxFilesReached&&(d=`more than ${d}`),t.push(`Folder (${c}): ${d}`),t.push(this.h(y))}}),t.push(""),t.push(""),t.join(`
`)))}h(r){const i=[];let s=0;const o=(l,P)=>{const D=` ${l}(${P})`;s+D.length>60?(i.push(c),c="|                 ",s=c.length):s+=D.length,c+=D};let c="|      File types:";const y=10,d=r.fileTypes.length>y?y:r.fileTypes.length;for(let l=0;l<d;l++){const P=r.fileTypes[l];o(P.name,P.count)}if(i.push(c),r.configFiles.length>=0&&(c="|      Conf files:",s=0,r.configFiles.forEach(l=>{o(l.name,l.count)}),i.push(c)),r.launchConfigFiles.length>0){let l="|      Launch Configs:";r.launchConfigFiles.forEach(P=>{const D=P.count>1?` ${P.name}(${P.count})`:` ${P.name}`;l+=D}),i.push(l)}return i.join(`
`)}j(r){const i=Math.max(...Object.keys(r).map(t=>t.length));return Object.keys(r).map(t=>`${t}:  ${" ".repeat(i-t.length)}  ${r[t]}`).join(`
                  `)}k(r){const i=[],t=[];return r.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const c=k.URI.revive(o);if(c.scheme===j.Schemas.file){const y=c.fsPath;t.push(h(y,["node_modules",".git"]).then(d=>{let l=`${d.fileCount} files`;d.maxFilesReached&&(l=`more than ${l}`),i.push(`|    Folder (${(0,O.$cc)(y)}): ${l}`),i.push(this.h(d))}).catch(d=>{i.push(`|      Error: Unable to collect workspace stats for folder ${y} (${d.toString()})`)}))}else i.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(r,i){const t=new Map;r.windows.forEach(o=>t.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:c})=>t.set(o,c));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.n(r.mainPID,t,s,i,0),s.join(`
`)}n(r,i,t,s,o){const c=o===0;let y;c?y=s.pid===r?`${this.d.applicationName} main`:"remote agent":i.has(s.pid)?y=i.get(s.pid):y=`${"  ".repeat(o)} ${s.name}`;const d=process.platform==="win32"?s.mem:R.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(d/f.$jk.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(s.children)&&s.children.forEach(l=>this.n(r,i,t,l,o+1))}async getWorkspaceFileExtensions(r){const i=new Set;for(const{uri:t}of r.folders){const s=k.URI.revive(t);if(s.scheme!==j.Schemas.file)continue;const o=s.fsPath;try{(await h(o,["node_modules",".git"])).fileTypes.forEach(y=>i.add(y.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const t=k.URI.revive(i);if(t.scheme!==j.Schemas.file)continue;const s=t.fsPath;try{const o=await h(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(c=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:c.name,count:c.count})}),o.launchConfigFiles.forEach(c=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:c.name,count:c.count})}),o.configFiles.forEach(c=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};e.$fr=I=we([Y(0,v.$Rk),Y(1,$.$6i)],I)}),define(ae[108],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p3b=e.$o3b=void 0;class R{constructor(j){this.b=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,{eventName:C,data:k}){return this.b.forEach(m=>m.log(C,k)),Promise.resolve(null)}}e.$o3b=R;class M{constructor(j){this.b=j}log(j,O){return this.b.call("log",{eventName:j,data:O}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$p3b=M}),define(ae[45],ce([0,1,31,10,3,18,74,107,20]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0;class m{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$Xn=m;class S{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Yn=S,e.$Zn=new S;class E{async publicLog(s,o,c){}async publicLogError(s,o,c){}}e.$1n=E,e.$2n="telemetry",e.$3n="extensionTelemetryLog",e.$4n={log:()=>null,flush:()=>Promise.resolve(null)};function b(t,s){return L.Event.debounce(s.onDidChangeConfiguration,(c,y)=>{const d=c?new Set([...c.affectedKeys,...y.affectedKeys]):y.affectedKeys;return{...y,affectedKeys:d}},1e3,!0)(c=>{c.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,j.$Uh)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.$5n=b;function f(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry||s.extensionTestsLocationURI)}e.$6n=f;function $(t,s){return!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$7n=$;function v(t){const s=t.getValue(k.$Yk),o=t.getValue(k.$Zk);if(t.getValue(k.$1k)===!1||o===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$8n=v;function a(t){const s={},o={},c={};p(t,c);for(let y in c){y=y.length>150?y.substr(y.length-149):y;const d=c[y];typeof d=="number"?o[y]=d:typeof d=="boolean"?o[y]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${y} has been trimmed to 8192, the original length is ${d.length}`),s[y]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(s[y]=d)}return{properties:s,measurements:o}}e.$9n=a;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const s=(0,O.$yk)(t);return h.has(s)?s:"other"}e.$0n=u;function p(t,s,o=0,c){if(t)for(const y of Object.getOwnPropertyNames(t)){const d=t[y],l=c?c+y:y;Array.isArray(d)?s[l]=(0,R.$Im)(d):d instanceof Date?s[l]=d.toISOString():(0,M.$ie)(d)?o<2?p(d,s,o+1,l+"."):s[l]=(0,R.$Im)(d):s[l]=d}}function w(t,s){const o=t.msftInternalDomains||[],c=s.getValue("telemetry.internalTesting");return(0,C.$Wn)(o)||c}e.$$n=w;function I(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$_n=I;function n(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let o=t;const c=[];for(const P of s)for(;;){const D=P.exec(t);if(!D)break;c.push([D.index,P.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(o="";;){const P=d.exec(t);if(!P)break;const D=c.some(([T,F])=>P.index<F&&T<d.lastIndex);!y.test(P[0])&&!D&&(o+=t.substring(l,P.index)+"<REDACTED: user-file-path>",l=d.lastIndex)}return l<t.length&&(o+=t.substr(l)),o}function r(t){if(!t)return t;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of s)if(o.regex.test(t))return`<REDACTED: ${o.label}>`;return t}function i(t,s){return(0,R.$Fm)(t,o=>{if(o instanceof m||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let c=o.replaceAll("%20"," ");c=n(c,s);for(const y of s)c=c.replace(y,"");return c=r(c),c}})}e.$ao=i}),define(ae[33],ce([0,1,27,28,49,5,12,7,37,45]),function(ne,e,R,M,L,j,O,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0;function S(i,t){return i.uuid&&t.uuid?i.uuid===t.uuid:i.id===t.id?!0:(0,R.$Ed)(i.id,t.id)===0}e.$bo=S;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(t){const s=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new b(t.identifier,s,o)}static parse(t){const s=E.exec(t);return s&&s[1]&&s[2]?new b({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof b?S(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$co=b;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(i){const t=f.exec(i);return t&&t[1]?[a(t[1]),t[2]]:[a(i),void 0]}e.$do=$;function v(i,t){return`${i}.${t}`}e.$eo=v;function a(i){return i.toLowerCase()}e.$fo=a;function h(i,t){return a(v(i??L.$zl,t))}e.$go=h;function u(i,t){const s=[],o=c=>{for(const y of s)if(y.some(d=>S(t(d),t(c))))return y;return null};for(const c of i){const y=o(c);y?y.push(c):s.push([c])}return s}e.$ho=u;function p(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$io=p;function w(i){return{id:new m.$Xn(i.identifier.id),name:new m.$Xn(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$jo=w,e.$ko=new L.$Dl("pprice.better-merge");function I(i,t){const s=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&s.every(y=>!S(y.identifier,{id:c}))){const y=i.filter(d=>S(d.identifier,{id:c}));y.length===1&&(s.push(y[0]),o.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$lo=I;async function n(i,t){if(!j.$k)return!1;let s;try{s=(await i.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await i.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,C.$8)(c))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(i,t){const s=await n(i,t),o=(0,M.$Gn)(s?"alpine":j.$t,k.$6b);return t.debug("ComputeTargetPlatform:",o),o}e.$mo=r}),define(ae[214],ce([0,1,21,2,22,12,13,24,6,3,15,5,37,33]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v1b=e.$u1b=void 0;let $=e.$u1b=class extends M.$kb{constructor(p,w){super(),this.b=p,this.c=w,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,I])=>this.a.set(I.configPath,I))}getConfigBasedTips(p){return this.f(p)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(p){const w=[];for(const[I,n]of this.a)if(!(n.configScheme&&n.configScheme!==p.scheme))try{const r=(await this.b.readFile((0,L.$6f)(p,I))).value.toString();for(const[i,t]of Object.entries(n.recommendations))(!t.contentPattern||new RegExp(t.contentPattern,"mig").test(r))&&w.push({extensionId:i,extensionName:t.name,configName:n.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack,whenNotInstalled:t.whenNotInstalled})}catch{}return w}};e.$u1b=$=we([Y(0,O.$Oj),Y(1,C.$6i)],$);const v="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";class h extends ${constructor(p,w,I,n,r,i,t,s){super(t,s),this.m=p,this.n=w,this.r=I,this.s=n,this.t=r,this.u=i,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,s.exeBasedExtensionTips&&Object.entries(s.exeBasedExtensionTips).forEach(([o,c])=>{const y=[],d=[],l=[];Object.entries(c.recommendations).forEach(([P,D])=>{D.important?c.important?y.push({extensionId:P,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):d.push({extensionId:P,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):l.push({extensionId:P,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),y.length&&this.g.set(o,{exeFriendlyName:c.friendlyName,windowsPath:c.windowsPath,recommendations:y}),d.length&&this.h.set(o,{exeFriendlyName:c.friendlyName,windowsPath:c.windowsPath,recommendations:d}),l.length&&this.j.set(o,{exeFriendlyName:c.friendlyName,windowsPath:c.windowsPath,recommendations:l})}),(0,k.$sg)(3e3).then(async()=>{await this.v(),this.z(),this.C()})}async getImportantExecutableBasedTips(){const p=await this.L(this.g),w=await this.L(this.h);return[...p,...w]}getOtherExecutableBasedTips(){return this.L(this.j)}async v(){const p=await this.L(this.g),w=await this.L(this.h),I=await this.s.getInstalled();this.k=this.w(p,I),this.l=this.w(w,I)}w(p,w){const I=new Map;p.forEach(s=>I.set(s.extensionId.toLowerCase(),s));const{installed:n,uninstalled:r}=this.J([...I.keys()],w);for(const s of n){const o=I.get(s);o&&this.r.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:s,exeName:o.exeName})}for(const s of r){const o=I.get(s);o&&this.r.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:s,exeName:o.exeName})}const i=this.H(),t=new Map;for(const s of r){const o=I.get(s);if(o&&(!i[o.exeName]||!i[o.exeName].includes(o.extensionId))){let c=t.get(o.exeName);c||(c=[],t.set(o.exeName,c)),c.push(o)}}return t}z(){if(this.k.size===0)return;const[p,w]=[...this.k.entries()][0];this.D(w).then(I=>{switch(I){case"reacted":this.I(w[0].exeName,w);break;case"ignored":this.k.delete(p);break;case"incompatibleWindow":{const n=m.Event.once(m.Event.latch(m.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(n(()=>this.z()));break}case"toomany":{const n=this.B((0,k.$tg)(()=>{n.dispose(),this.z()},36e5));break}}})}C(){if(this.l.size===0)return;const p=this.F(),w=Date.now()-p,I=7*24*60*60*1e3;if(w<I){const i=this.B((0,k.$tg)(()=>{i.dispose(),this.C()},I-w));return}const[n,r]=[...this.l.entries()][0];this.D(r).then(i=>{switch(i){case"reacted":{this.G(Date.now()),this.l.delete(n),this.I(r[0].exeName,r);const t=this.B((0,k.$tg)(()=>{t.dispose(),this.C()},I));break}case"ignored":this.l.delete(n),this.C();break;case"incompatibleWindow":{const t=m.Event.once(m.Event.latch(m.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(t(()=>this.C()));break}case"toomany":{const t=this.B((0,k.$tg)(()=>{t.dispose(),this.C()},36e5));break}}})}async D(p){const w=await this.s.getInstalled(1),I=p.filter(n=>!n.whenNotInstalled||n.whenNotInstalled.every(r=>w.every(i=>!(0,f.$bo)(i.identifier,{id:r})))).map(({extensionId:n})=>n.toLowerCase());return this.u.promptImportantExtensionsInstallNotification({extensions:I,source:3,name:p[0].exeFriendlyName,searchValue:`@exe:"${p[0].exeName}"`})}F(){let p=this.t.getNumber(a,-1);return p||(p=Date.now(),this.G(p)),p}G(p){this.t.store(a,p,-1,1)}H(){return JSON.parse(this.t.get(v,-1,"{}"))}I(p,w){const I=this.H();I[p]=w.map(({extensionId:n})=>n.toLowerCase()),this.t.store(v,JSON.stringify(I),-1,0)}J(p,w){const I=[],n=[],r=w.reduce((i,t)=>(i.add(t.identifier.id.toLowerCase()),i),new Set);return p.forEach(i=>{r.has(i.toLowerCase())?I.push(i):n.push(i)}),{installed:I,uninstalled:n}}async L(p){const w=[],I=new Map;for(const n of p.keys()){const r=p.get(n);if(!r||!(0,R.$nf)(r.recommendations))continue;const i=[];E.$i?r.windowsPath&&i.push(r.windowsPath.replace("%USERPROFILE%",()=>b.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>b.env.ProgramFiles).replace("%APPDATA%",()=>b.env.APPDATA).replace("%WINDIR%",()=>b.env.WINDIR)):(i.push((0,S.$$b)("/usr/local/bin",n)),i.push((0,S.$$b)("/usr/bin",n)),i.push((0,S.$$b)(this.m.fsPath,n)));for(const t of i){let s=I.get(t);if(s===void 0&&(s=await this.b.exists(j.URI.file(t)),I.set(t,s)),s)for(const{extensionId:o,extensionName:c,isExtensionPack:y,whenNotInstalled:d}of r.recommendations)w.push({extensionId:o,extensionName:c,isExtensionPack:y,exeName:n,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:d})}}return w}}e.$v1b=h}),define(ae[215],ce([0,1,26,33]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3Rb=void 0;async function L(j,O,C,k,m){try{const S=await j.getExtensionsControlManifest();if(!S.deprecated)return;const E=await j.getInstalled(1);for(const[b,f]of Object.entries(S.deprecated)){if(!f?.extension)continue;const{id:$,autoMigrate:v,preRelease:a}=f.extension;if(!v)continue;const h=E.find(p=>(0,M.$bo)(p.identifier,{id:b}));if(!h)continue;const u=(await O.getExtensions([{id:$,preRelease:a}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!u){m.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${$}' extension is not found`);continue}try{m.info(`Migrating '${h.identifier.id}' extension to '${$}' extension...`);const p=!k.getDisabledExtensions().some(I=>(0,M.$bo)(I,h.identifier));await j.uninstall(h),m.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let w=E.find(I=>(0,M.$bo)(I.identifier,{id:$}));(!w||!w.isPreReleaseVersion&&p)&&(w=await j.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),m.info(`Installed the pre-release extension '${w.identifier.id}'`),p||(await k.disableExtension(w.identifier),m.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),v.storage&&(C.addToMigrationList((0,M.$eo)(h.manifest.publisher,h.manifest.name),(0,M.$eo)(w.manifest.publisher,w.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${h.identifier.id}' extension to '${$}' extension.`)}catch(p){m.error(p)}}}catch(S){m.error(S)}}e.$3Rb=L}),define(ae[216],ce([0,1,3,2,35,33,49]),function(ne,e,R,M,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=void 0;class C extends M.$kb{constructor(m,S,E,b,f,$,v){super(),this.f=m,this.g=S,this.h=E,this.i=b,this.j=f,this.k=$,this.l=v,this.a=this.B(new R.$5c),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new M.$sb),this.m().then(null,a=>v.error(a))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles),this.n(),await this.z()}n(){this.B(this.h.onDidChangeProfiles(m=>this.p(m.added))),this.B(this.i.onAddExtensions(m=>this.r(m))),this.B(this.i.onDidAddExtensions(m=>this.s(m))),this.B(this.i.onRemoveExtensions(m=>this.t(m))),this.B(this.i.onDidRemoveExtensions(m=>this.u(m))),this.B(this.k.onDidFilesChange(m=>this.v(m)))}async p(m){try{m.length&&await Promise.all(m.map(S=>(this.c.set(S.id,(0,M.$hb)(this.k.watch(this.j.extUri.dirname(S.extensionsResource)),this.k.watch(S.extensionsResource))),this.y(S.extensionsResource))))}catch(S){throw this.l.error(S),S}}async r(m){for(const S of m.extensions)this.C(this.F(S.identifier,S.version),m.profileLocation)}async s(m){for(const S of m.extensions){const E=this.F(S.identifier,S.version);m.error?this.D(E,m.profileLocation):this.C(E,m.profileLocation)}}async t(m){for(const S of m.extensions)this.D(this.F(S.identifier,S.version),m.profileLocation)}async u(m){const S=[],E=[];for(const b of m.extensions){const f=this.F(b.identifier,b.version);m.error?this.C(f,m.profileLocation):(this.D(f,m.profileLocation),this.b.has(f)||(this.l.debug("Extension is removed from all profiles",b.identifier.id,b.version),E.push(this.f.scanInstalledExtensionAtLocation(b.location).then($=>{$?S.push($):this.l.info("Extension not found at the location",b.location.toString())},$=>this.l.error($)))))}try{await Promise.all(E),S.length&&await this.z(S)}catch(b){this.l.error(b)}}v(m){for(const S of this.h.profiles)m.contains(S.extensionsResource,0,1)&&this.w(S.extensionsResource)}async w(m){const S=[],E=[],b=await this.i.scanProfileExtensions(m),f=new Set,$=new Set;for(const[v,a]of this.b)a.has(m)&&$.add(v);for(const v of b){const a=this.F(v.identifier,v.version);f.add(a),$.has(a)||(S.push(v.identifier),this.C(a,m))}for(const v of $)if(!f.has(v)){const a=this.G(v);a&&(E.push(a.identifier),this.D(v,m))}(S.length||E.length)&&this.a.fire({added:S.length?{extensions:S,profileLocation:m}:void 0,removed:E.length?{extensions:E,profileLocation:m}:void 0})}async y(m){const S=await this.i.scanProfileExtensions(m);for(const E of S)this.C(this.F(E.identifier,E.version),m)}async z(m){m||(m=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.F(E.identifier,E.manifest.version)))),m.length&&await this.f.markAsUninstalled(...m)}C(m,S){let E=this.b.get(m);E||this.b.set(m,E=new L.$ki(b=>this.j.extUri.getComparisonKey(b))),E.add(S)}D(m,S){const E=this.b.get(m);E&&E.delete(S),E?.size||this.b.delete(m)}F(m,S){return`${O.$Dl.toKey(m.id)}@${S}`}G(m){const[S,E]=(0,j.$do)(m);return E?{identifier:{id:S},version:E}:void 0}}e.$ip=C}),define(ae[217],ce([0,1,44,45]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=void 0;async function L(j,O,C,k,m,S,E){const b={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${O.nameShort})`};if((0,M.$6n)(O,C)&&(0,M.$8n)(k)===3){const f=await(0,R.$Mo)(C,m,S);b["X-Market-User-Id"]=f,b["VSCode-SessionId"]=E.machineId||f}return b}e.$No=L}),define(ae[218],ce([0,1,69,21,6,2,25,15,30,14,28,33,8,72,12]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=void 0;let v=e.$vq=class extends f.$uq{constructor(p,w,I,n){super(I),this.h=p,this.i=n,this.g=this.B(new a(w,n)),this.h.registerParticipant({postInstall:async r=>this.j(r),postUninstall:async r=>this.k(r)})}async getBuiltInExtensionTranslationsUri(p,w){const n=(await this.g.getLanguagePacks())[w];if(!n){this.i.warn(`No language pack found for ${w}`);return}const r=n.translations[p];return r?$.URI.file(r):void 0}async getInstalledLanguages(){const p=await this.g.getLanguagePacks(),w=Object.keys(p).map(I=>{const n=p[I];return{...this.f(I,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return w.push(this.f("en","English")),w.sort((I,n)=>I.label.localeCompare(n.label)),w}async j(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",p.identifier.id),await this.update())}async k(p){const w=await this.g.getLanguagePacks();Object.keys(w).some(I=>w[I]&&w[I].extensions.some(n=>(0,E.$bo)(n.extensionIdentifier,p.identifier)))&&(this.i.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,w]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),I=await this.g.update(w);return!(0,M.$$e)(Object.keys(p),Object.keys(I))}};e.$vq=v=we([Y(0,S.$Nn),Y(1,m.$th),Y(2,S.$Ln),Y(3,b.$Ni)],v);let a=class extends j.$kb{constructor(p,w){super(),this.i=w,this.c={},this.f=(0,C.$$b)(p.userDataPath,"languagepacks.json"),this.g=new L.$yg}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(p){return this.m(w=>{Object.keys(w).forEach(I=>delete w[I]),this.j(w,...p)}).then(()=>this.c)}j(p,...w){for(const I of w)I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&this.k(p,I);Object.keys(p).forEach(I=>this.l(p[I]))}k(p,w){const I=w.identifier,n=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const r of n)if(w.location.scheme===O.Schemas.file&&h(r)){let i=p[r.languageId];i||(i={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},p[r.languageId]=i);const t=i.extensions.filter(s=>(0,E.$bo)(s.extensionIdentifier,I))[0];t?t.version=w.manifest.version:i.extensions.push({extensionIdentifier:I,version:w.manifest.version});for(const s of r.translations)i.translations[s.id]=(0,C.$$b)(w.location.fsPath,s.path)}}l(p){if(p){const w=(0,R.createHash)("md5");for(const I of p.extensions)w.update(I.extensionIdentifier.uuid||I.extensionIdentifier.id).update(I.version);p.hash=w.digest("hex")}}m(p=()=>null){return this.g.queue(()=>{let w=null;return k.Promises.readFile(this.f,"utf8").then(void 0,I=>I.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(I)).then(I=>{try{return JSON.parse(I)}catch{return{}}}).then(I=>(w=p(I),I)).then(I=>{for(const r of Object.keys(I))I[r]||delete I[r];this.c=I,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),k.Promises.writeFile(this.f,n)}).then(()=>w,I=>this.i.error(I))})}};a=we([Y(0,m.$th),Y(1,b.$Ni)],a);function h(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const p of u.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ae[219],ce([0,1,7,31,45]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=void 0;const j="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function C(m,S,E){const b=await new Promise((h,u)=>{ne(["@microsoft/1ds-core-js"],h,u)}),f=await new Promise((h,u)=>{ne(["@microsoft/1ds-post-js"],h,u)}),$=new b.AppInsightsCore,v=new f.PostChannel,a={instrumentationKey:m,endpointUrl:j,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(E){a.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:E};a.extensionConfig[v.identifier]=h}return $.initialize(a,[]),$.addTelemetryInitializer(h=>{S&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),$}class k{constructor(S,E,b,f,$){this.e=S,this.f=E,this.g=b,this.h=$,this.c=j,this.d=O,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(S){if(this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=C(this.a,this.e,this.h)),this.b.then(E=>{S(E)},E=>{(0,R.$X)(E),console.error(E)})}}log(S,E){if(!this.a)return;E=(0,M.$Gm)(E,this.g),E=(0,L.$9n)(E);const b=this.f+"/"+S;try{this.i(f=>{f.pluginVersionString=E?.properties.version??"Unknown",f.track({name:b,baseData:{name:b,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i(E=>{E.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.$jM=k}),define(ae[109],ce([0,1,2,160,14,8,24,45]),function(ne,e,R,M,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TZb=void 0;let k=e.$TZb=class extends R.$kb{constructor(S,E,b,f,$=""){super(),this.b=$;const v=E.getLogger(C.$2n);if(v)this.a=this.B(v);else{const h=(0,C.$7n)(f,b)?" (Not Sent)":"",u=()=>(0,C.$6n)(f,b)&&S.getLevel()===j.LogLevel.Trace;this.a=this.B(E.createLogger(C.$2n,{name:(0,M.localize)(0,null,h),hidden:!u()})),this.B(S.onDidChangeLogLevel(()=>E.setVisibility(C.$2n,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(S,E){this.a.trace(`${this.b}telemetry/${S}`,(0,C.$9n)(E))}};e.$TZb=k=we([Y(0,j.$Ni),Y(1,j.$Oi),Y(2,L.$sh),Y(3,O.$6i)],k)}),define(ae[110],ce([0,1,2,31,5,27,161,18,48,102,24,40,20,45]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;let $=e.$Bq=class{constructor(h,u,p){this.k=u,this.l=p,this.d={},this.i=new R.$jb,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,j.$ld)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$ld)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration(b.$Yk)||w.affectsConfiguration(b.$1k)||w.affectsConfiguration(b.$Zk))&&this.m()}))}setExperimentProperty(h,u){this.d[h]=u}m(){let h=(0,f.$8n)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const p=u.usage?3:u.error?2:0;h=Math.min(h,p)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,u,p){this.g<u||(p=(0,M.$Gm)(p,this.d),p=(0,f.$ao)(p,this.j),p=(0,M.$Gm)(p,this.c),this.b.forEach(w=>w.log(h,p)))}publicLog(h,u){this.n(h,3,u)}publicLog2(h,u){this.publicLog(h,u)}publicLogError(h,u){this.h&&this.n(h,2,u)}publicLogError2(h,u){this.publicLogError(h,u)}};$.IDLE_START_EVENT_NAME="UserIdleStart",$.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$Bq=$=we([Y(1,C.$Rh),Y(2,S.$6i)],$);function v(){const a=(0,O.localize)(0,null,m.default.nameLong),h=m.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=L.$o?"":(0,O.localize)(3,null),p=(0,O.localize)(4,null),w=(0,O.localize)(5,null),I=(0,O.localize)(6,null),n=(0,O.localize)(7,null),r=`
|       | ${p} | ${w} | ${I} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,O.localize)(8,null);return`
${a} ${h} ${u}

&nbsp;

${n}
${r}

&nbsp;

${i}
`}E.$Pm.as(k.$Um.Configuration).registerConfiguration({id:b.$Xk,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[b.$Yk]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$Pm.as(k.$Um.Configuration).registerConfiguration({id:b.$Xk,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[b.$1k]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,O.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,O.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${b.$Yk}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[220],ce([0,1,264,219]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=void 0;class L extends M.$jM{constructor(O,C,k,m){const S={sendPOST:(E,b)=>{const f={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const $=R.request(E.urlString,f,v=>{v.on("data",function(a){b(v.statusCode??200,v.headers,a.toString())}),v.on("error",function(a){b(0,{})})});$.write(E.data),$.end()}catch{b(0,{})}}};super(O,C,k,m,S)}}e.$kM=L}),define(ae[221],ce([0,1,25,93,18,14,8,24,20,108,109,110]),function(ne,e,R,M,L,j,O,C,k,m,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F4b=void 0;let b=e.$F4b=class{constructor($,v,a,h,u,p){this.b=$,this.c=v,this.d=a,this.e=h,this.f=u,this.g=p,this.a=new Map}h($){if(!this.a.has($.id)){const v=Object.create(null);v["common.vscodemachineid"]=this.c.machineId,v["common.vscodesessionid"]=this.c.sessionId;const a=[$.id,JSON.stringify(v),$.aiKey],u=new M.$Dp(R.$1e.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:a,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),p=[new m.$p3b(u),new S.$TZb(this.d,this.e,this.f,this.g,`[${$.id}] `)];this.a.set($.id,new E.$Bq({appenders:p,sendErrorTelemetry:$.sendErrorTelemetry},this.b,this.g))}return this.a.get($.id)}publicLog($,v,a){this.h($).publicLog(v,a)}publicLogError($,v,a){this.h($).publicLogError(v,a)}};e.$F4b=b=we([Y(0,L.$Rh),Y(1,k.$Rk),Y(2,O.$Ni),Y(3,O.$Oi),Y(4,j.$sh),Y(5,C.$6i)],b)}),define(ae[76],ce([0,1,3,18,4,8]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dz=e.$Cz=e.$Bz=e.$Az=e.$zz=e.$yz=e.$xz=e.$wz=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$vz=e.$uz=void 0,e.$uz=(0,L.$lh)("tunnelService"),e.$vz=(0,L.$lh)("sharedTunnelsService");var O;(function(v){v.Http="http",v.Https="https"})(O||(e.TunnelProtocol=O={}));var C;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(C||(e.TunnelPrivacyId=C={}));var k;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(k||(e.ProvidedOnAutoForward=k={}));function m(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(a)return{address:a[1],port:+a[2]}}e.$wz=m,e.$xz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(v){return e.$xz.indexOf(v)>=0}e.$yz=S,e.$zz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(v){return e.$zz.indexOf(v)>=0}e.$Az=E;function b(v,a,h,u){if(h===1)return!1;if(h===2&&E(a)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(p?.length===4&&parseInt(p[1])>=18)return!1}return v<1024}e.$Bz=b;class f{constructor(a,h,u){this.remoteAddress=a,this.localAddress=h,this.b=u,this.a=new R.$5c,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Cz=f;let $=e.$Dz=class{constructor(a,h){this.i=a,this.j=h,this.a=new R.$5c,this.onTunnelOpened=this.a.event,this.b=new R.$5c,this.onTunnelClosed=this.b.event,this.c=new R.$5c,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const a=this.j.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this.e=a,a?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this.f=a.elevation,this.g=a.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const a=[],h=Array.from(this.d.values());for(const u of h){const p=Array.from(u.values());for(const w of p){const I=await w.value;I&&a.push(I)}}return a}async dispose(){for(const a of this.d.values()){for(const{value:h}of a.values())await h.then(u=>u?.dispose());a.clear()}this.d.clear()}setEnvironmentTunnel(a,h,u,p,w){this.o(a,h,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:h,localAddress:u,privacy:p,protocol:w,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,h){(E(a)||S(a))&&(a=e.$xz[0]);const u=this.q(a,h);if(u)return++u.refcount,u.value}openTunnel(a,h,u,p,w,I=!1,n,r){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${u} on local port ${w}.`),!a)return;if(h||(h="localhost"),p||(p=this.k),this.e&&this.h.has(u)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(a,h,u,p,w,I,n,r);return i?i.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,u);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(t);return(t.tunnelRemoteHost!==h||t.tunnelRemotePort!==u)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&t.privacy!==n&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const h=this.d.get(a.tunnelRemoteHost);if(h){const u=h.get(a.tunnelRemotePort);u&&(u.refcount--,await this.n(a.tunnelRemoteHost,a.tunnelRemotePort,u))}}}}async n(a,h,u){if(u.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${h}.`);const p=u.value.then(async w=>{w&&(await w.dispose(!0),this.b.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this.d.has(a)&&this.d.get(a).delete(h),p}}async closeTunnel(a,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${h} `);const u=this.d.get(a);if(u&&u.has(h)){const p=u.get(h);p.refcount=0,await this.n(a,h,p)}}o(a,h,u){this.d.has(a)||this.d.set(a,new Map),this.d.get(a).set(h,{refcount:1,value:u})}async p(a,h){const u=this.d.get(a);if(u){const p=u.get(h);(p?await p.value:void 0)||u.delete(h),u.size===0&&this.d.delete(a)}}q(a,h){const u=[a];S(a)?(u.push(...e.$xz),u.push(...e.$zz)):E(a)&&u.push(...e.$zz);const p=u.map(w=>this.d.get(w));for(const w of p){const I=w?.get(h);if(I)return I}}canTunnel(a){return!!m(a)}s(a,h,u,p,w,I,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${u} on local port ${p}.`);const r=u;this.h.add(r);const i=p===void 0?u:p,t={elevationRequired:w?this.isPortPrivileged(i):!1},s={remoteAddress:{host:h,port:u},localAddressPort:p,privacy:I,public:I?I!==C.Private:void 0,protocol:n},o=a.forwardPort(s,t);return o?(this.o(h,u,o),o.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),o}};e.$Dz=$=we([Y(0,j.$Ni),Y(1,M.$Rh)],$)}),define(ae[222],ce([0,1,8,76,2,7,6]),function(ne,e,R,M,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S4b=void 0;class C extends L.$kb{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$Lg),this.b.p)}setAddress(S){this.a=S,this.b&&(this.b.complete(S),this.b=null)}setTunnel(S){this.B(S)}}let k=e.$S4b=class Et extends L.$kb{constructor(S,E){super(),this.f=S,this.g=E,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(S=>S.dispose())}async createTunnel(){return{id:String(++Et.a)}}async startTunnel(S,E,b,f,$,v,a){const h=new C,u=await Promise.resolve(this.f.openTunnel(S,h,b,f,$,v,a));if(!u)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${b}:${f} (remote).`),h.dispose(),new Error("Could not create tunnel");if(this.c.has(E))throw this.c.delete(E),h.dispose(),await u.dispose(),(0,j.$3)();return h.setTunnel(u),this.b.set(E,h),this.g.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${u.localAddress} (local) to ${b}:${f} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(S,E){const b=this.b.get(S);b&&b.setAddress(E)}async destroyTunnel(S){const E=this.b.get(S);if(E){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${S}.`),this.b.delete(S),await E.dispose();return}this.c.add(S)}};k.a=0,e.$S4b=k=we([Y(0,M.$vz),Y(1,R.$Ni)],k)}),define(ae[223],ce([0,1,62,36,128,6,2,18,8,24,206,76,106,5,104]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$83b=e.$73b=e.$63b=void 0;async function v(w,I,n,r,i){let t;for(let s=3;s&&(t?.dispose(),t=await new a(w,I,n,r,i).waitForReady(),!(i&&L.$6e[i]||!L.$6e[t.tunnelLocalPort]));s--);return t}class a extends O.$kb{constructor(I,n,r,i,t){super(),this.j=n,this.k=t,this.privacy=E.TunnelPrivacyId.Private,this.i=new Map,this.a=I,this.b=R.createServer(),this.c=new j.$qg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const I=this.k??this.tunnelRemotePort,n=(0,E.$Az)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,L.$7e)(I,2,1e3,n),i=null;return this.b.listen(r,this.j),await this.c.wait(),i=this.b.address(),i||(r=0,this.b.listen(r,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(I){I.pause();const n=(0,E.$yz)(this.tunnelRemoteHost)||(0,E.$Az)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,S.$Ik)(this.a,n,this.tunnelRemotePort),i=r.getSocket().socket,t=r.readEntireBuffer();r.dispose(),t.byteLength>0&&I.write(t.buffer),I.on("end",()=>{I.localAddress&&this.i.delete(I.localAddress),i.end()}),I.on("close",()=>i.end()),I.on("error",()=>{I.localAddress&&this.i.delete(I.localAddress),i.destroy()}),i.on("end",()=>I.end()),i.on("close",()=>I.end()),i.on("error",()=>{I.destroy()}),I.pipe(i),i.pipe(I),I.localAddress&&this.i.set(I.localAddress,()=>{I.end(),i.end()})}}let h=e.$63b=class extends E.$Dz{constructor(I,n,r,i,t){super(n,t),this.t=I,this.u=r,this.v=i}isPortPrivileged(I){return(0,E.$Bz)(I,this.k,f.OS,M.release())}r(I,n,r,i,t,s,o,c){const y=this.q(n,r);if(y)return++y.refcount,y.value;if(this.e)return this.s(this.e,n,r,t,s,o,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${t}.`);const d={commit:this.v.commit,quality:this.v.quality,addressProvider:I,remoteSocketFactoryService:this.t,signService:this.u,logService:this.i,ipcLogger:null},l=v(d,i,n,r,t);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,r,l),l}}};e.$63b=h=we([Y(0,$.$Ck),Y(1,k.$Ni),Y(2,b.$Fk),Y(3,m.$6i),Y(4,C.$Rh)],h);let u=e.$73b=class extends h{constructor(I,n,r,i,t){super(I,n,r,i,t)}};e.$73b=u=we([Y(0,$.$Ck),Y(1,k.$Ni),Y(2,b.$Fk),Y(3,m.$6i),Y(4,C.$Rh)],u);let p=e.$83b=class extends O.$kb{constructor(I,n,r,i,t){super(),this.b=I,this.c=n,this.f=r,this.g=i,this.h=t,this.a=new Map}async openTunnel(I,n,r,i,t,s,o,c,y){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${i} on local port ${s}.`),!this.a.has(I)){const d=new u(this.b,this.c,this.g,this.f,this.h);this.B(d),this.a.set(I,d),d.onTunnelClosed(async()=>{(await d.tunnels).length===0&&(d.dispose(),this.a.delete(I))})}return this.a.get(I).openTunnel(n,r,i,t,s,o,c,y)}};e.$83b=p=we([Y(0,$.$Ck),Y(1,k.$Ni),Y(2,m.$6i),Y(3,b.$Fk),Y(4,C.$Rh)],p)}),define(ae[29],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=void 0,e.$lk=(0,R.$lh)("IUriIdentityService")}),define(ae[224],ce([0,1,29,178,13,22,123,3,2]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class m{constructor(b){this.uri=b,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let S=e.$$q=class{constructor(b){this.g=b,this.c=new k.$jb,this.f=2**16;const f=new Map,$=v=>{let a=f.get(v.scheme);return a===void 0&&(a=b.hasProvider(v)&&!this.g.hasCapability(v,1024),f.set(v.scheme,a)),a};this.c.add(C.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(v=>{f.delete(v.scheme)})),this.extUri=new j.$Uf($),this.d=new O.$0q((v,a)=>this.extUri.compare(v,a,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,j.$7f)(b));const f=this.d.get(b);return f?f.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new m(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort(($,v)=>$[1].time<v[1].time?1:$[1].time>v[1].time?-1:0);m._clock=0,this.d.clear();const f=this.f*.5;for(let $=0;$<f;$++)this.d.set(b[$][0],b[$][1].touch())}};e.$$q=S=we([Y(0,L.$Oj)],S),(0,M.$8q)(R.$lk,S,1)}),define(ae[225],ce([0,1,3,2,13,42,46,16]),function(ne,e,R,M,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T4b=void 0;class k extends M.$kb{get capabilities(){return this.f.capabilities&-5}constructor(S,E,b,f){super(),this.c=S,this.f=E,this.g=b,this.h=f,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new R.$5c),this.onDidChangeFile=this.a.event,this.b=O.$rh.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile($=>this.i($)))}watch(S,E){this.b.set(S,S);const b=this.f.watch(this.j(S),E);return(0,M.$ib)(()=>{this.b.delete(S),b.dispose()})}stat(S){return this.f.stat(this.j(S))}mkdir(S){return this.f.mkdir(this.j(S))}rename(S,E,b){return this.f.rename(this.j(S),this.j(E),b)}readFile(S){return this.f.readFile(this.j(S),{atomic:!0})}readFileStream(S,E,b){const f=(0,j.$wb)($=>C.$Ib.concat($.map(v=>C.$Ib.wrap(v))).buffer);return(async()=>{try{const $=await this.readFile(S);f.end($)}catch($){f.error($),f.end()}})(),f}readdir(S){return this.f.readdir(this.j(S))}writeFile(S,E,b){return this.f.writeFile(this.j(S),E,b)}delete(S,E){return this.f.delete(this.j(S),E)}copy(S,E,b){if((0,L.$Rj)(this.f))return this.f.copy(this.j(S),this.j(E),b);throw new Error("copy not supported")}i(S){const E=[];for(const b of S){if(b.resource.scheme!==this.c)continue;const f=this.k(b.resource);this.b.findSubstr(f)&&E.push({resource:f,type:b.type})}E.length&&(this.h.debug("User data changed"),this.a.fire(E))}j(S){return S.with({scheme:this.c})}k(S){return S.with({scheme:this.g})}}e.$T4b=k}),define(ae[57],ce([0,1,83]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nwb=e.$Mwb=e.edit=void 0;function M(O,C,k,m){const S=(0,R.$ER)(O,C,k,m)[0];return S&&(O=O.substring(0,S.offset)+S.content+O.substring(S.offset+S.length)),O}e.edit=M;function L(O,C,k){let m=k;for(;m>=0;){if(O.charAt(m)===C.charAt(C.length-1)&&C.length===1)return m+1;if(m--,C.length===2&&m>=0&&O.charAt(m)===C.charAt(0))return m+2}return 0}e.$Mwb=L;function j(O,C,k){let m=k;for(;m>=0;)if(O.charAt(m)===C.charAt(C.length-1)&&C.length===1||(m++,C.length===2&&m>=0&&O.charAt(m)===C.charAt(1)))return m;return O.length-1}e.$Nwb=j}),define(ae[226],ce([0,1,31,52,10]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EYb=void 0;function j(f,$,v,a,h,u){const p=[],w=[],I=[];if(!$){const V=f.filter(({identifier:W})=>h.every(x=>x.toLowerCase()!==W.id.toLowerCase()));return{local:{added:p,removed:w,updated:I},remote:V.length>0?{added:V,updated:[],removed:[],all:V}:null}}f=f.map(E),$=$.map(E),v=v?v.map(E):null;const n=new Map,r=V=>{V.uuid&&n.set(V.id.toLowerCase(),V.uuid)};f.forEach(({identifier:V})=>r(V)),$.forEach(({identifier:V})=>r(V)),v?.forEach(({identifier:V})=>r(V));const i=V=>{const W=V.identifier.uuid||n.get(V.identifier.id.toLowerCase());return W?`uuid:${W}`:`id:${V.identifier.id.toLowerCase()}`},t=(V,W)=>(V.set(i(W),W),V),s=f.reduce(t,new Map),o=$.reduce(t,new Map),c=$.reduce((V,W)=>t(V,(0,R.$Dm)(W)),new Map),y=v?v.reduce(t,new Map):null,d=a.reduce(t,new Map),l=h.reduce((V,W)=>{const x=n.get(W.toLowerCase());return V.add(x?`uuid:${x}`:`id:${W.toLowerCase()}`)},new Set),P=u?u.reduce((V,{id:W,uuid:x})=>(x=x??n.get(W.toLowerCase()),V.add(x?`uuid:${x}`:`id:${W.toLowerCase()}`)),new Set):null,D=O(s,o,l,!1);if(D.added.size>0||D.removed.size>0||D.updated.size>0){const V=O(y,s,l,!1),W=O(y,o,l,!0),x=(ee,X,_,q)=>{let G,B,ie;return X.installed?(G=q.pinned,ie=q.preRelease,G&&(B=q.version)):(G=_.pinned,ie=_.preRelease,G&&(B=_.version)),G===void 0&&(G=X.pinned,G&&(B=X.version)),ie===void 0&&(ie=X.preRelease),{...q,installed:X.installed||_.installed,pinned:G,preRelease:ie,version:B??(_.version&&(!X.installed||M.gt(_.version,X.version))?_.version:X.version),state:k(X,_,y?.get(ee))}};for(const ee of W.removed.values()){const X=s.get(ee);if(!X)continue;const _=(0,L.$re)(y?.get(ee)),q=P&&!P.has(ee)&&_.installed;X.installed&&q?w.push(X.identifier):c.set(ee,X)}for(const ee of W.added.values()){const X=(0,L.$re)(o.get(ee)),_=s.get(ee);if(_){if(D.updated.has(ee)){const q=x(ee,_,X,X);C(_,X,!1,!1)||I.push(b(q,ee)),c.set(ee,q)}}else X.installed&&p.push(b(X,ee))}for(const ee of W.updated.values()){const X=(0,L.$re)(o.get(ee)),_=(0,L.$re)(y?.get(ee)),q=s.get(ee);if(q)if(P&&!P.has(ee)&&_.installed&&q.installed&&!X.installed)w.push(q.identifier);else{const B=x(ee,q,X,X);I.push(b(B,ee)),c.set(ee,B)}else X.installed&&p.push(b(X,ee))}for(const ee of V.added.values())W.added.has(ee)||c.set(ee,(0,L.$re)(s.get(ee)));for(const ee of V.updated.values()){if(W.removed.has(ee)||W.updated.has(ee))continue;const X=(0,L.$re)(s.get(ee)),_=(0,L.$re)(o.get(ee));c.set(ee,x(ee,X,_,X))}for(const ee of V.removed.values())W.updated.has(ee)||W.removed.has(ee)||d.has(ee)||(0,L.$re)(o.get(ee)).installed&&P&&(P.has(ee)||!(0,L.$re)(y?.get(ee)).installed||c.delete(ee))}const T=[],F=O(o,c,new Set,!0),H=F.added.size>0||F.updated.size>0||F.removed.size>0;return H&&c.forEach((V,W)=>T.push(b(V,W))),{local:{added:p,removed:w,updated:I},remote:H?{added:[...F.added].map(V=>c.get(V)),updated:[...F.updated].map(V=>c.get(V)),removed:[...F.removed].map(V=>o.get(V)),all:T}:null}}e.$EYb=j;function O(f,$,v,a){const h=f?[...f.keys()].filter(n=>!v.has(n)):[],u=[...$.keys()].filter(n=>!v.has(n)),p=u.filter(n=>!h.includes(n)).reduce((n,r)=>(n.add(r),n),new Set),w=h.filter(n=>!u.includes(n)).reduce((n,r)=>(n.add(r),n),new Set),I=new Set;for(const n of h){if(w.has(n))continue;const r=f.get(n),i=$.get(n);(!i||!C(r,i,a,!0))&&I.add(n)}return{added:p,removed:w,updated:I}}function C(f,$,v,a){return!(f.disabled!==$.disabled||a&&f.installed!==$.installed||f.installed&&$.installed&&(f.preRelease!==$.preRelease||f.pinned!==$.pinned||$.pinned&&f.version!==$.version)||!S(f.state,$.state)||v&&f.version!==$.version)}function k(f,$,v){const a=f.state,h=$.state,u=v?.state;if(!$.version||a&&M.gt(f.version,$.version))return a;if(h&&M.gt($.version,f.version)||!a)return h;if(!h)return a;const p=(0,R.$Dm)(a),w=u?m(u,h):{added:Object.keys(h).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set},I=u?m(u,a):{added:Object.keys(a).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set};for(const n of[...w.added.values(),...w.updated.values()])p[n]=h[n];for(const n of w.removed.values())I.updated.has(n)||delete p[n];return p}function m(f,$){const v=Object.keys(f),a=Object.keys($),h=a.filter(w=>!v.includes(w)).reduce((w,I)=>(w.add(I),w),new Set),u=v.filter(w=>!a.includes(w)).reduce((w,I)=>(w.add(I),w),new Set),p=new Set;for(const w of v){if(u.has(w))continue;const I=f[w],n=$[w];(0,R.$Hm)(I,n)||p.add(w)}return{added:h,removed:u,updated:p}}function S(f={},$={}){const{added:v,removed:a,updated:h}=m(f,$);return v.size===0&&a.size===0&&h.size===0}function E(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function b(f,$){const v={identifier:{id:f.identifier.id,uuid:$.startsWith("uuid:")?$.substring(5):void 0},version:f.version,preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled&&(v.disabled=!0),f.installed&&(v.installed=!0),f.state&&(v.state=f.state),v}}),define(ae[111],ce([0,1,21,18,4]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fyb=e.$Eyb=void 0,e.$Eyb=(0,L.$lh)("IIgnoredExtensionsManagementService");let j=e.$Fyb=class{constructor(C){this.a=C}hasToNeverSyncExtension(C){return this.b().includes(C.toLowerCase())}hasToAlwaysSyncExtension(C){return this.b().includes(`-${C.toLowerCase()}`)}updateIgnoredExtensions(C,k){let m=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return m=m.filter(S=>S!==C&&S!==`-${C}`),k&&m.push(C.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}updateSynchronizedExtensions(C,k){let m=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return m=m.filter(S=>S!==C&&S!==`-${C}`),k&&m.push(`-${C.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}getIgnoredExtensions(C){const k=C.filter(b=>b.isMachineScoped).map(b=>b.identifier.id.toLowerCase()),m=this.b().map(b=>b.toLowerCase()),S=[],E=[];if(Array.isArray(m))for(const b of m)b.startsWith("-")?E.push(b.substring(1)):S.push(b);return(0,R.$of)([...k,...S].filter(b=>!E.includes(b)))}b(){let C=this.a.inspect("settingsSync.ignoredExtensions").userValue;return C!==void 0||(C=this.a.inspect("sync.ignoredExtensions").userValue,C!==void 0)?C:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$Fyb=j=we([Y(0,M.$Rh)],j)}),define(ae[227],ce([0,1,21,34,31,94,57]),function(ne,e,R,M,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KYb=void 0;function C(w){return(0,M.$tm)(w)||[]}async function k(w,I,n,r,i){const t=C(w),s=C(I),o=n?C(n):null,c=[...t,...s,...o||[]].map(x=>x.key),y=await i.resolveUserBindings(c),d=S(t,s,o,y);if(!d.hasLocalForwarded&&!d.hasRemoteForwarded)return{mergeContent:w,hasChanges:!1,hasConflicts:!1};if(!d.hasLocalForwarded&&d.hasRemoteForwarded)return{mergeContent:I,hasChanges:!0,hasConflicts:!1};if(d.hasLocalForwarded&&!d.hasRemoteForwarded)return{mergeContent:w,hasChanges:!0,hasConflicts:!1};const l=b(t),P=b(s),D=o?b(o):null,T=$(l,P,y),F=D?$(D,l,y):{added:[...l.keys()].reduce((x,ee)=>(x.add(ee),x),new Set),removed:new Set,updated:new Set},H=D?$(D,P,y):{added:[...P.keys()].reduce((x,ee)=>(x.add(ee),x),new Set),removed:new Set,updated:new Set},V=m(T,F,H);let W=w;for(const x of V.removed.values())V.conflicts.has(x)||(W=u(W,x,r));for(const x of V.added.values()){if(V.conflicts.has(x))continue;const ee=P.get(x);if(ee.some(X=>X.command!==`-${x}`&&d.conflicts.has(y[X.key]))){V.conflicts.add(x);continue}W=h(W,ee,r)}for(const x of V.updated.values()){if(V.conflicts.has(x))continue;const ee=P.get(x);if(ee.some(X=>X.command!==`-${x}`&&d.conflicts.has(y[X.key]))){V.conflicts.add(x);continue}W=p(W,x,ee,r)}return{mergeContent:W,hasChanges:!0,hasConflicts:V.conflicts.size>0}}e.$KYb=k;function m(w,I,n){const r=new Set,i=new Set,t=new Set,s=new Set;for(const o of I.removed.values())n.updated.has(o)&&s.add(o);for(const o of n.removed.values())s.has(o)||(I.updated.has(o)?s.add(o):i.add(o));for(const o of I.added.values())s.has(o)||n.added.has(o)&&w.updated.has(o)&&s.add(o);for(const o of n.added.values())s.has(o)||(I.added.has(o)?w.updated.has(o)&&s.add(o):r.add(o));for(const o of I.updated.values())s.has(o)||n.updated.has(o)&&w.updated.has(o)&&s.add(o);for(const o of n.updated.values())s.has(o)||(I.updated.has(o)?w.updated.has(o)&&s.add(o):t.add(o));return{added:r,removed:i,updated:t,conflicts:s}}function S(w,I,n,r){const i=new Set,t=E(w,r),s=E(I,r),o=n?E(n,r):null,c=f(t,s);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const y=o?f(o,t):{added:[...t.keys()].reduce((F,H)=>(F.add(H),F),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const d=o?f(o,s):{added:[...s.keys()].reduce((F,H)=>(F.add(H),F),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:l,removed:P,updated:D,conflicts:T}=m(c,y,d);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:l,removed:P,updated:D,conflicts:T}}function E(w,I){const n=new Map;for(const r of w){const i=I[r.key];let t=n.get(i);t||(t=[],n.set(i,t)),t.push(r)}return n}function b(w){const I=new Map;for(const n of w){const r=n.command[0]==="-"?n.command.substring(1):n.command;let i=I.get(r);i||(i=[],I.set(r,i)),i.push(n)}return I}function f(w,I){const n=[...w.keys()],r=[...I.keys()],i=r.filter(o=>!n.includes(o)).reduce((o,c)=>(o.add(c),o),new Set),t=n.filter(o=>!r.includes(o)).reduce((o,c)=>(o.add(c),o),new Set),s=new Set;for(const o of n){if(t.has(o))continue;const c=w.get(o).map(d=>({...d,key:o})),y=I.get(o).map(d=>({...d,key:o}));(0,R.$$e)(c,y,(d,l)=>a(d,l))||s.add(o)}return{added:i,removed:t,updated:s}}function $(w,I,n){const r=[...w.keys()],i=[...I.keys()],t=i.filter(c=>!r.includes(c)).reduce((c,y)=>(c.add(y),c),new Set),s=r.filter(c=>!i.includes(c)).reduce((c,y)=>(c.add(y),c),new Set),o=new Set;for(const c of r){if(s.has(c))continue;const y=w.get(c).map(l=>({...l,key:n[l.key]})),d=I.get(c).map(l=>({...l,key:n[l.key]}));v(y,d)||o.add(c)}return{added:t,removed:s,updated:o}}function v(w,I){return!(!(0,R.$$e)(w.filter(({command:n})=>n[0]!=="-"),I.filter(({command:n})=>n[0]!=="-"),(n,r)=>a(n,r))||!(0,R.$$e)(w.filter(({command:n})=>n[0]==="-"),I.filter(({command:n})=>n[0]==="-"),(n,r)=>a(n,r)))}function a(w,I){if(w.command!==I.command||w.key!==I.key)return!1;const n=j.$ri.deserialize(w.when),r=j.$ri.deserialize(I.when);return!(n&&!r||!n&&r||n&&r&&!n.equals(r)||!L.$Hm(w.args,I.args))}function h(w,I,n){for(const r of I)w=O.edit(w,[-1],r,n);return w}function u(w,I,n){const r=C(w);for(let i=r.length-1;i>=0;i--)(r[i].command===I||r[i].command===`-${I}`)&&(w=O.edit(w,[i],void 0,n));return w}function p(w,I,n,r){const i=C(w),t=i.findIndex(s=>s.command===I||s.command===`-${I}`);for(let s=i.length-1;s>=0;s--)(i[s].command===I||i[s].command===`-${I}`)&&(w=O.edit(w,[s],void 0,r));for(let s=n.length-1;s>=0;s--)w=O.edit(w,[t],n[s],r);return w}}),define(ae[228],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SYb=e.$RYb=void 0;function R(j,O,C){const k={},m={},S=new Set;if(!O)return{local:{added:k,updated:m,removed:[...S.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const E=M(j,O);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:k,updated:m,removed:[...S.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const b=M(C,j),f=M(C,O),$={},v={},a=new Set,h=new Set;for(const u of b.removed.values())f.updated.has(u)?k[u]=O[u]:a.add(u);for(const u of f.removed.values())h.has(u)||(b.updated.has(u)?h.add(u):S.add(u));for(const u of b.updated.values())h.has(u)||(f.updated.has(u)?E.updated.has(u)&&h.add(u):v[u]=j[u]);for(const u of f.updated.values())h.has(u)||(b.updated.has(u)?E.updated.has(u)&&h.add(u):j[u]!==void 0&&(m[u]=O[u]));for(const u of b.added.values())h.has(u)||(f.added.has(u)?E.updated.has(u)&&h.add(u):$[u]=j[u]);for(const u of f.added.values())h.has(u)||(b.added.has(u)?E.updated.has(u)&&h.add(u):k[u]=O[u]);return{local:{added:k,removed:[...S.values()],updated:m},remote:{added:$,removed:[...a.values()],updated:v},conflicts:[...h.values()]}}e.$RYb=R;function M(j,O){const C=j?Object.keys(j):[],k=O?Object.keys(O):[],m=k.filter(b=>!C.includes(b)).reduce((b,f)=>(b.add(f),b),new Set),S=C.filter(b=>!k.includes(b)).reduce((b,f)=>(b.add(f),b),new Set),E=new Set;for(const b of C){if(S.has(b))continue;const f=j[b],$=O[b];f!==$&&E.add(b)}return{added:m,removed:S,updated:E}}function L(j,O){const{added:C,removed:k,updated:m}=M(j,O);return C.size===0&&k.size===0&&m.size===0}e.$SYb=L}),define(ae[229],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y1b=void 0;function R(L,j,O,C){const k={added:[],removed:[],updated:[]};let m={added:[],removed:[],updated:[]};if(!j){const E=L.filter(({id:b})=>!C.includes(b));return E.length?m.added=E:m=null,{local:k,remote:m}}const S=M(L,j,C);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const E=M(O,L,C),b=M(O,j,C);for(const f of b.removed){const $=L.find(v=>v.id===f);$&&k.removed.push($)}for(const f of b.added){const $=j.find(v=>v.id===f);E.added.includes(f)?S.updated.includes(f)&&k.updated.push($):k.added.push($)}for(const f of b.updated)k.updated.push(j.find($=>$.id===f));for(const f of E.added)b.added.includes(f)||m.added.push(L.find($=>$.id===f));for(const f of E.updated)b.removed.includes(f)||b.updated.includes(f)||m.updated.push(L.find($=>$.id===f));for(const f of E.removed){const $=j.find(v=>v.id===f);$&&m.removed.push($)}}return m.added.length===0&&m.removed.length===0&&m.updated.length===0&&(m=null),{local:k,remote:m}}e.$y1b=R;function M(L,j,O){L=L?L.filter(({id:b})=>!O.includes(b)):[],j=j.filter(({id:b})=>!O.includes(b));const C=L.map(({id:b})=>b),k=j.map(({id:b})=>b),m=k.filter(b=>!C.includes(b)),S=C.filter(b=>!k.includes(b)),E=[];for(const{id:b,name:f,shortName:$}of L){if(S.includes(b))continue;const v=j.find(a=>a.id===b);(!v||v.name!==f||v.shortName!==$)&&E.push(b)}return{added:m,removed:S,updated:E}}}),define(ae[23],ce([0,1,21,10,167,48,28,4,103,40]),function(ne,e,R,M,L,j,O,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndb=e.$Mdb=e.$Ldb=e.$Kdb=e.$Jdb=e.$Idb=e.$Hdb=e.$Gdb=e.$Fdb=e.$Edb=e.$Ddb=e.MergeState=e.Change=e.SyncStatus=e.$Cdb=e.$Bdb=e.$Adb=e.UserDataSyncErrorCode=e.$zdb=e.$ydb=e.$xdb=e.$wdb=e.$vdb=e.$udb=e.$tdb=e.$sdb=e.$rdb=e.SyncResource=e.$qdb=e.$pdb=e.$odb=e.$ndb=e.$mdb=e.$ldb=e.$kdb=void 0,e.$kdb="configurationSync.store";function S(){const s=m.$Pm.as(j.$Um.Configuration).getConfigurationProperties();return Object.keys(s).filter(o=>!!s[o].disallowSyncIgnore)}e.$ldb=S;function E(){const s=m.$Pm.as(j.$Um.Configuration).getConfigurationProperties(),o=Object.keys(s).filter(d=>!!s[d].ignoreSync),c=Object.keys(s).filter(d=>s[d].scope===2||s[d].scope===6),y=S();return(0,R.$of)([e.$kdb,...o,...c,...y])}e.$mdb=E,e.$ndb="settingsSync",e.$odb="settingsSync.keybindingsPerPlatform";function b(){const s="vscode://schemas/ignoredSettings",o=m.$Pm.as(j.$Um.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$odb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:O.$zn,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const c=m.$Pm.as(k.$Qm.JSONContribution),y=()=>{const d=S(),l=E().filter(F=>F!==e.$kdb),P=Object.keys(j.$Vm.properties).filter(F=>!l.includes(F)),D=l.filter(F=>!d.includes(F)),T={items:{type:"string",enum:[...P,...D.map(F=>`-${F}`)]}};c.registerSchema(s,T)};return o.onDidUpdateConfiguration(()=>y())}e.$pdb=b;function f(s){return s&&(0,M.$ie)(s)&&(0,M.$ge)(s.id)&&Array.isArray(s.scopes)}e.$qdb=f;var $;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles",s.WorkspaceState="workspaceState"})($||(e.SyncResource=$={})),e.$rdb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function v(s,...o){return s?[s,...o]:o}e.$sdb=v;function a(s,o,c,y){return y.joinPath(c.userDataSyncHome,...v(s,o,`lastSync${o}.json`))}e.$tdb=a,e.$udb=(0,C.$lh)("IUserDataSyncStoreManagementService"),e.$vdb=(0,C.$lh)("IUserDataSyncStoreService"),e.$wdb=(0,C.$lh)("IUserDataSyncBackupStoreService"),e.$xdb="x-operation-id",e.$ydb="X-Execution-Id";function h(s){const o={};return o[e.$ydb]=s,o}e.$zdb=h;var u;(function(s){s.Unauthorized="Unauthorized",s.Forbidden="Forbidden",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class p extends Error{constructor(o,c,y,d){super(o),this.code=c,this.resource=y,this.operationId=d,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Adb=p;class w extends p{constructor(o,c,y,d,l){super(o,y,void 0,l),this.url=c,this.serverCode=d}}e.$Bdb=w;class I extends p{constructor(o,c){super(o,c)}}e.$Cdb=I,function(s){function o(c){if(c instanceof s)return c;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(c.name);if(y&&y[1]){const d=y[2]==="unknown"?void 0:y[2],l=y[3]==="unknown"?void 0:y[3];return new s(c.message,y[1],d,l)}return new s(c.message,"Unknown")}s.toUserDataSyncError=o}(p||(e.$Adb=p={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r||(e.Change=r={}));var i;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(i||(e.MergeState=i={})),e.$Ddb="sync.store.url.type";function t(s){return`sync.enable.${s}`}e.$Edb=t,e.$Fdb=(0,C.$lh)("IUserDataSyncEnablementService"),e.$Gdb=(0,C.$lh)("IUserDataSyncService"),e.$Hdb=(0,C.$lh)("IUserDataSyncResourceProviderService"),e.$Idb=(0,C.$lh)("IUserDataAutoSyncService"),e.$Jdb=(0,C.$lh)("IUserDataSyncUtilService"),e.$Kdb=(0,C.$lh)("IUserDataSyncLogService"),e.$Ldb="userDataSync",e.$Mdb="vscode-userdata-sync",e.$Ndb="preview"}),define(ae[230],ce([0,1,31,23]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1xb=void 0;function L(O,C,k,m,S){if(!C)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const E=j(O,C);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const b=k?j(k,C):{added:Object.keys(C).reduce((u,p)=>(u.add(p),u),new Set),removed:new Set,updated:new Set},f=k?j(k,O):{added:Object.keys(O).reduce((u,p)=>(u.add(p),u),new Set),removed:new Set,updated:new Set},$={added:{},removed:[],updated:{}},v=R.$Dm(C),a=!k;for(const u of f.added.values())u!==M.$Ddb&&a&&b.added.has(u)||(v[u]=O[u]);for(const u of f.updated.values())v[u]=O[u];for(const u of f.removed.values())m.unregistered.includes(u)||delete v[u];for(const u of b.added.values()){const p=C[u];if(m.machine.includes(u)){S.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(k&&f.added.has(u))continue;const w=O[u];w&&w.value===p.value||u===M.$Ddb&&a&&f.added.has(u)||(w?$.updated[u]=p:$.added[u]=p)}for(const u of b.updated.values()){const p=C[u];if(m.machine.includes(u)){S.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(u)||f.removed.has(u))continue;const w=O[u];w&&w.value===p.value||($.updated[u]=p)}for(const u of b.removed.values()){if(m.machine.includes(u)){S.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}f.updated.has(u)||f.removed.has(u)||$.removed.push(u)}const h=j(C,v);return{local:$,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:v}}}e.$1xb=L;function j(O,C){const k=Object.keys(O),m=Object.keys(C),S=m.filter(f=>!k.includes(f)).reduce((f,$)=>(f.add($),f),new Set),E=k.filter(f=>!m.includes(f)).reduce((f,$)=>(f.add($),f),new Set),b=new Set;for(const f of k){if(E.has(f))continue;const $=O[f],v=C[f];R.$Hm($,v)||b.add(f)}return{added:S,removed:E,updated:b}}}),define(ae[231],ce([0,1,21,34,83,41,31,57,23]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Twb=e.$Swb=e.$Rwb=e.$Qwb=e.$Pwb=e.$Owb=void 0;function m(c,y,d){let l=[];d?l=E(d):l=S(y);const P=[],D=[...(0,k.$ldb)()];if(Array.isArray(l))for(const T of l)T.startsWith("-")?D.push(T.substring(1)):P.push(T);return(0,R.$of)([...c,...P].filter(T=>!D.includes(T)))}e.$Owb=m;function S(c){let y=c.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=c.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:c.getValue("settingsSync.ignoredSettings")||[]}function E(c){const y=(0,M.$tm)(c);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function b(c,y){const d=(0,M.$tm)(c)||{};let l="{}";for(const P of Object.keys(d)){const D=(0,L.$ER)(l,[P],d[P],y);l=(0,L.$HR)(l,D)}return l}e.$Pwb=b;function f(c,y,d,l){if(d.length){const P=o(y),D=(0,M.$tm)(y)||{},T=(0,M.$tm)(c);if(!T)return c;const F=[];for(const H of d){const V=D[H],W=T[H];V===void 0?c=C.edit(c,[H],void 0,l):W!==void 0?c=C.edit(c,[H],V,l):F.push(n(H,P))}F.sort((H,V)=>H.startOffset-V.startOffset),F.forEach(H=>c=u(H.setting.key,y,c,l))}return c}e.$Qwb=f;function $(c,y,d,l,P,D){const T=f(c,y,l,D),F=d!==T,H=d!==y;if(!F&&!H)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!H)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(H&&!F)return{conflictsSettings:[],localContent:f(y,c,l,D),remoteContent:null,hasConflicts:!1};if(d===null&&a(c)){const A=v(c,y,l)?null:f(y,c,l,D);return{conflictsSettings:[],localContent:A,remoteContent:null,hasConflicts:!1}}let V=c,W=y;const x=(0,M.$tm)(c),ee=(0,M.$tm)(y),X=d?(0,M.$tm)(d):null,_=l.reduce((A,U)=>(A.add(U),A),new Set),q=h(x,ee,_),G=h(X,x,_),B=h(X,ee,_),ie=new Map,re=new Set,K=A=>{re.add(A);const U=P.filter(({key:Q})=>Q===A)[0];U?(V=C.edit(V,[A],U.value,D),W=C.edit(W,[A],U.value,D)):ie.set(A,{key:A,localValue:x[A],remoteValue:ee[A]})};for(const A of G.removed.values())B.updated.has(A)?K(A):W=C.edit(W,[A],void 0,D);for(const A of B.removed.values())re.has(A)||(G.updated.has(A)?K(A):V=C.edit(V,[A],void 0,D));for(const A of G.updated.values())re.has(A)||(B.updated.has(A)?q.updated.has(A)&&K(A):W=C.edit(W,[A],x[A],D));for(const A of B.updated.values())re.has(A)||(G.updated.has(A)?q.updated.has(A)&&K(A):V=C.edit(V,[A],ee[A],D));for(const A of G.added.values())re.has(A)||(B.added.has(A)?q.updated.has(A)&&K(A):W=u(A,V,W,D));for(const A of B.added.values())re.has(A)||(G.added.has(A)?q.updated.has(A)&&K(A):V=u(A,W,V,D));const Z=ie.size>0||!v(V,W,l),N=Z||!v(V,c,[]),g=Z||!v(W,y,[]);return{localContent:N?V:null,remoteContent:g?W:null,conflictsSettings:[...ie.values()],hasConflicts:Z}}e.$Rwb=$;function v(c,y,d){if(c===y)return!0;const l=(0,M.$tm)(c),P=(0,M.$tm)(y),D=d.reduce((H,V)=>(H.add(V),H),new Set),T=o(c).filter(H=>!(H.setting&&D.has(H.setting.key))),F=o(y).filter(H=>!(H.setting&&D.has(H.setting.key)));if(T.length!==F.length)return!1;for(let H=0;H<T.length;H++){const V=T[H],W=F[H];if(V.setting&&W.setting){if(V.setting.key!==W.setting.key||!O.$Hm(l[V.setting.key],P[V.setting.key]))return!1}else if(!V.setting&&!W.setting){if(V.value!==W.value)return!1}else return!1}return!0}function a(c){return c?o(c).length===0:!0}e.$Swb=a;function h(c,y,d){const l=c?Object.keys(c).filter(H=>!d.has(H)):[],P=Object.keys(y).filter(H=>!d.has(H)),D=P.filter(H=>!l.includes(H)).reduce((H,V)=>(H.add(V),H),new Set),T=l.filter(H=>!P.includes(H)).reduce((H,V)=>(H.add(V),H),new Set),F=new Set;if(c)for(const H of l){if(T.has(H))continue;const V=c[H],W=y[H];O.$Hm(V,W)||F.add(H)}return{added:D,removed:T,updated:F}}function u(c,y,d,l){const P=(0,M.$tm)(y),D=o(y),T=o(d),F=p(c,D,T);return w(d,c,P[c],F,T,l)}e.$Twb=u;function p(c,y,d){const l=y.findIndex(D=>D.setting?.key===c),P=y[l-1];if(P){if(P.setting){const T=n(P.setting.key,d);if(T)return{index:d.indexOf(T),insertAfter:!0}}else{const T=r(l,y);if(T){const F=n(T.setting.key,d);if(F){const H=i(d.indexOf(F),d),V=t(y,T,y[l]);if(H){const W=t(d,F,H),x=s(V,W);return x?{index:d.indexOf(x),insertAfter:!0}:{index:d.indexOf(H),insertAfter:!1}}else{const W=t(d,F,d[d.length-1]),x=s(V,W);return x?{index:d.indexOf(x),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const D=y[l+1];if(D)if(D.setting){const T=n(D.setting.key,d);if(T)return{index:d.indexOf(T),insertAfter:!1}}else{const T=i(l,y);if(T){const F=n(T.setting.key,d);if(F){const H=r(d.indexOf(F),d),V=t(y,y[l],T);if(H){const W=t(d,H,F),x=s(V.reverse(),W.reverse());return x?{index:d.indexOf(x),insertAfter:!1}:{index:d.indexOf(H),insertAfter:!0}}else{const W=t(d,d[0],F),x=s(V.reverse(),W.reverse());return x?{index:d.indexOf(x),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function w(c,y,d,l,P,D){let T;return l.index===-1?T=(0,L.$ER)(c,[y],d,D):T=I(c,y,d,l,P,D).map(F=>(0,L.$FR)(c,F,D)[0]),(0,L.$HR)(c,T)}function I(c,y,d,l,P,D){const T=`${JSON.stringify(y)}: ${JSON.stringify(d)}`,F=(0,j.$BR)(D,c),H=P[l.index];if(l.insertAfter){const V=[];if(H.setting)V.push({offset:H.endOffset,length:0,content:","+T});else{const W=i(l.index,P),x=r(l.index,P),ee=x?.setting?.commaOffset;x&&ee===void 0&&V.push({offset:x.endOffset,length:0,content:","});const X=ee!==void 0&&ee>H.endOffset;V.push({offset:X?ee+1:H.endOffset,length:0,content:W?F+T+",":F+T})}return V}else{if(H.setting)return[{offset:H.startOffset,length:0,content:T+","}];const V=(P[l.index-1]&&!P[l.index-1].setting?F:"")+T+(i(l.index,P)?",":"")+F;return[{offset:H.startOffset,length:0,content:V}]}}function n(c,y){return y.filter(d=>d.setting?.key===c)[0]}function r(c,y){for(let d=c-1;d>=0;d--)if(y[d].setting)return y[d]}function i(c,y){for(let d=c+1;d<y.length;d++)if(y[d].setting)return y[d]}function t(c,y,d){const l=c.indexOf(y),P=c.indexOf(d);return c.filter((D,T)=>l<T&&T<P)}function s(c,y){if(c.length&&y.length){let d=0;for(;d<y.length&&d<c.length;d++)if(c[d].value!==y[d].value)return y[d-1];return y[d-1]}}function o(c){const y=[];let d=-1,l,P;const D={onObjectBegin:T=>{d++},onObjectProperty:(T,F,H)=>{d===0&&(l=F,P=T)},onObjectEnd:(T,F)=>{d--,d===0&&y.push({startOffset:l,endOffset:T+F,value:c.substring(l,T+F),setting:{key:P,commaOffset:void 0}})},onArrayBegin:(T,F)=>{d++},onArrayEnd:(T,F)=>{d--,d===0&&y.push({startOffset:l,endOffset:T+F,value:c.substring(l,T+F),setting:{key:P,commaOffset:void 0}})},onLiteralValue:(T,F,H)=>{d===0&&y.push({startOffset:l,endOffset:F+H,value:c.substring(l,F+H),setting:{key:P,commaOffset:void 0}})},onSeparator:(T,F,H)=>{if(d===0&&T===","){let V=y.length-1;for(;V>=0&&!y[V].setting;V--);const W=y[V];W&&y.splice(V,1,{startOffset:W.startOffset,endOffset:W.endOffset,value:W.value,setting:{key:W.setting.key,commaOffset:F}})}},onComment:(T,F)=>{d===0&&y.push({startOffset:T,endOffset:T+F,value:c.substring(T,T+F)})}};return(0,M.$Am)(c,D),y}}),define(ae[77],ce([0,1,3,2,4,23]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zwb=e.$ywb=void 0,e.$ywb=(0,L.$lh)("IUserDataSyncAccountService");let O=e.$zwb=class extends M.$kb{get account(){return this.a}constructor(k,m){super(),this.g=k,this.h=m,this.b=this.B(new R.$5c),this.onDidChangeAccount=this.b.event,this.c=this.B(new R.$5c),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(S=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,S),this.updateAccount(void 0),S==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$zwb=O=we([Y(0,j.$vdb),Y(1,j.$Kdb)],O)}),define(ae[232],ce([0,1,2,12]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M4b=e.$L4b=e.$K4b=e.$J4b=e.$I4b=e.$H4b=e.$G4b=void 0;class L{constructor(b){this.a=b}listen(b,f){switch(f){case"onError":return this.a.onError}throw new Error(`Event not found: ${f}`)}call(b,f,$){switch(f){case"triggerSync":return this.a.triggerSync($[0],$[1],$[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff($[0])}throw new Error("Invalid call")}}e.$G4b=L;class j{constructor(b){this.a=b}listen(b,f){throw new Error(`Event not found: ${f}`)}call(b,f,$){switch(f){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings($[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(M.URI.revive($[0]))}throw new Error("Invalid call")}}e.$H4b=j;class O{constructor(b){this.a=b}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(b){return this.a.call("resolveUserKeybindings",[b])}async resolveFormattingOptions(b){return this.a.call("resolveFormattingOptions",[b])}}e.$I4b=O;class C{constructor(b){this.a=b}listen(b,f){switch(f){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${f}`)}async call(b,f,$){switch(f){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine($[0],$[1]);case"setEnablements":return this.a.setEnablements($)}throw new Error("Invalid call")}}e.$J4b=C;class k{constructor(b){this.a=b}listen(b,f){switch(f){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${f}`)}call(b,f,$){switch(f){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount($)}throw new Error("Invalid call")}}e.$K4b=k;class m{constructor(b){this.a=b}listen(b,f){switch(f){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${f}`)}call(b,f,$){switch(f){case"switch":return this.a.switch($[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$L4b=m;class S extends R.$kb{constructor(b){super(),this.a=b,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(b){return this.a.call("switch",[b])}async getPreviousUserDataSyncStore(){const b=await this.a.call("getPreviousUserDataSyncStore");return this.b(b)}b(b){return{url:M.URI.revive(b.url),type:b.type,defaultUrl:M.URI.revive(b.defaultUrl),insidersUrl:M.URI.revive(b.insidersUrl),stableUrl:M.URI.revive(b.stableUrl),canSwitch:b.canSwitch,authenticationProviders:b.authenticationProviders}}}e.$M4b=S}),define(ae[233],ce([0,1,168,8,23]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gyb=void 0;let j=e.$Gyb=class extends M.$Si{constructor(C){super(),this.g=this.B(C.createLogger(L.$Ldb,{name:(0,R.localize)(0,null)}))}trace(C,...k){this.g.trace(C,...k)}debug(C,...k){this.g.debug(C,...k)}info(C,...k){this.g.info(C,...k)}warn(C,...k){this.g.warn(C,...k)}error(C,...k){this.g.error(C,...k)}flush(){this.g.flush()}};e.$Gyb=j=we([Y(0,M.$Oi)],j)}),define(ae[234],ce([0,1,6,3,2]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K3b=void 0;class j extends L.$kb{constructor({onDidOpenWindow:C,onDidFocusWindow:k,getActiveWindowId:m}){super(),this.a=this.B(new L.$jb),M.Event.latch(M.Event.any(C,k))(this.f,this,this.a),this.b=(0,R.$fg)(()=>m()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(C){this.b&&(this.b.cancel(),this.b=void 0),this.c=C}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$K3b=j}),define(ae[112],ce([0,1,171,15,46,22,12,4,25]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.WorkbenchState=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$uh=(0,C.$lh)("contextService");function m(t){const s=t;return typeof s?.id=="string"&&O.URI.isUri(s.uri)}e.$vh=m;function S(t){return typeof t?.id=="string"&&!m(t)&&!b(t)}e.$wh=S,e.$xh={id:"ext-dev"},e.$yh={id:"empty-window"};function E(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,M.$cc)(t)}:s?e.$xh:e.$yh;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$zh=E;function b(t){const s=t;return typeof s?.id=="string"&&O.URI.isUri(s.configPath)}e.$Ah=b;function f(t){const s=t;if(s?.uri)return{id:s.id,uri:O.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:O.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}e.$Bh=f;var $;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function v(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$Ch=v;function a(t){const s=t;return!!(s&&typeof s=="object"&&O.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$Dh=a;class h{constructor(s,o,c,y,d){this.h=s,this.j=c,this.k=y,this.l=d,this.c=L.$rh.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=L.$rh.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Eh=h;class u{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,j.$6f)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Fh=u;function p(t){return new u({uri:t,index:0,name:(0,j.$2f)(t)},{uri:t.toString()})}e.$Gh=p,e.$Hh="code-workspace",e.$Ih=`.${e.$Hh}`,e.$Jh=[{name:(0,R.localize)(0,null),extensions:[e.$Hh]}],e.$Kh="workspace.json";function w(t,s){return j.$Wf.isEqualOrParent(t,s.untitledWorkspacesHome)}e.$Lh=w;function I(t){let s;return O.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===k.Schemas.tmp}e.$Mh=I,e.$Nh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(t){return t.id===e.$Nh}e.$Oh=n;function r(t,s){return!w(t,s)&&!I(t)}e.$Ph=r;function i(t){return(typeof t=="string"?(0,M.$dc)(t):(0,j.$4f)(t))===e.$Ih}e.$Qh=i}),define(ae[17],ce([0,1,61,3,2,22,12,162,14,13,4,8,112,35,29,6,32,27,10]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=void 0;function p(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$mk=p,e.$nk=(0,S.$lh)("IUserDataProfilesService");function w(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:O.URI.revive(i.location).with({scheme:t}),globalStorageHome:O.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$ok=w;function I(i,t,s,o,c){return{id:i,name:t,location:s,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,j.$6f)(s,"globalStorage"),settingsResource:(0,j.$6f)(s,"settings.json"),keybindingsResource:(0,j.$6f)(s,"keybindings.json"),tasksResource:(0,j.$6f)(s,"tasks.json"),snippetsHome:(0,j.$6f)(s,"snippets"),extensionsResource:(0,j.$6f)(s,"extensions.json"),cacheHome:(0,j.$6f)(o,i),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.$pk=I;let n=e.$qk=class extends L.$kb{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(t,s,o,c){super(),this.n=t,this.r=s,this.s=o,this.t=c,this.f=!0,this.h=this.B(new M.$5c),this.onDidChangeProfiles=this.h.event,this.i=this.B(new M.$5c),this.onWillCreateProfile=this.i.event,this.j=this.B(new M.$5c),this.onWillRemoveProfile=this.j.event,this.k=this.B(new M.$5c),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new f.$ji,emptyWindows:new Map},this.profilesHome=(0,j.$6f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,j.$6f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(t){this.f!==t&&(this.u=void 0,this.f=t)}isEnabled(){return this.f}get v(){if(!this.u){const t=[];if(this.f)try{for(const y of this.J()){if(!y.name||!(0,u.$ge)(y.name)||!y.location){this.t.warn("Skipping the invalid stored profile",y.location||y.name);continue}t.push(I((0,j.$3f)(y.location),y.name,y.location,this.g,{shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}))}}catch(y){this.t.error(y)}const s=new f.$ji,o=new Map,c=this.w();if(t.unshift({...c,extensionsResource:this.O()??c.extensionsResource,isDefault:!0}),t.length)try{const y=this.M();if(y.workspaces)for(const[d,l]of Object.entries(y.workspaces)){const P=O.URI.parse(d),D=t.find(T=>T.id===l);D&&s.set(P,D)}if(y.emptyWindows)for(const[d,l]of Object.entries(y.emptyWindows)){const P=t.find(D=>D.id===l);P&&o.set(d,P)}}catch(y){this.t.error(y)}this.u={profiles:t,workspaces:s,emptyWindows:o}}return this.u}w(){return I("__default__profile__",(0,C.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(t){const s="Temp",o=new RegExp(`${(0,h.$ld)(s)}\\s(\\d+)`);let c=0;for(const d of this.profiles){const l=o.exec(d.name),P=l?parseInt(l[1]):0;c=P>c?P:c}const y=`${s} ${c+1}`;return this.createProfile((0,R.$_h)((0,a.$3e)()).toString(16),y,{transient:!0},t)}async createNamedProfile(t,s,o){return this.createProfile((0,R.$_h)((0,a.$3e)()).toString(16),t,s,o)}async createProfile(t,s,o,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.y(t,s,o);return c&&await this.setProfileForWorkspace(c,y),y}async y(t,s,o){if(!(0,u.$ge)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let c=this.l.get(s);return c||(c=(async()=>{try{const y=this.profiles.find(P=>P.name===s||P.id===t);if(y)return y;const d=I(t,s,(0,j.$6f)(this.profilesHome,t),this.g,o);await this.r.createFolder(d.location);const l=[];return this.i.fire({profile:d,join(P){l.push(P)}}),await v.Promises.settled(l),this.D([d],[],[]),d}finally{this.l.delete(s)}})(),this.l.set(s,c)),c}async updateProfile(t,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(c=>c.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=I(o.id,s.name??o.name,o.location,this.g,{shortName:s.shortName??o.shortName,transient:s.transient??o.isTransient,useDefaultFlags:s.useDefaultFlags??o.useDefaultFlags}),this.D([],[],[o]),o}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(c=>c.id===t.id);if(!s)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this.j.fire({profile:s,join(c){o.push(c)}});try{await Promise.allSettled(o)}catch(c){this.t.error(c)}for(const c of[...this.v.emptyWindows.keys()])s.id===this.v.emptyWindows.get(c)?.id&&this.v.emptyWindows.delete(c);for(const c of[...this.v.workspaces.keys()])s.id===this.v.workspaces.get(c)?.id&&this.v.workspaces.delete(c);this.H(),this.D([],[s],[]);try{await this.r.del(s.cacheHome,{recursive:!0})}catch(c){(0,m.$5j)(c)!==1&&this.t.error(c)}}async setProfileForWorkspace(t,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(c=>c.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);this.G(t,o)}unsetWorkspace(t,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(t,void 0,s)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const t=await this.r.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(s=>s.isDirectory&&this.profiles.every(o=>!this.s.extUri.isEqual(o.location,s.resource))).map(s=>this.r.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.m.profiles.filter(s=>!this.C(s));await Promise.allSettled(t.map(s=>this.removeProfile(s)))}getProfileForWorkspace(t){const s=this.z(t);return O.URI.isUri(s)?this.m.workspaces.get(s)??this.v.workspaces.get(s):this.m.emptyWindows.get(s)??this.v.emptyWindows.get(s)}z(t){return(0,b.$vh)(t)?t.uri:(0,b.$Ah)(t)?t.configPath:t.id}C(t){return!!([...this.m.emptyWindows.values()].some(s=>this.s.extUri.isEqual(s.location,t.location))||[...this.m.workspaces.values()].some(s=>this.s.extUri.isEqual(s.location,t.location))||[...this.v.emptyWindows.values()].some(s=>this.s.extUri.isEqual(s.location,t.location))||[...this.v.workspaces.values()].some(s=>this.s.extUri.isEqual(s.location,t.location)))}D(t,s,o){const c=[...this.profiles,...t],y=[];this.m.profiles=[];for(let d of c)d.isDefault||s.some(l=>d.id===l.id)||(d=o.find(l=>d.id===l.id)??d,d.isTransient?this.m.profiles.push(d):y.push({location:d.location,name:d.name,shortName:d.shortName,useDefaultFlags:d.useDefaultFlags}));this.L(y),this.u=void 0,this.F(t,s,o)}F(t,s,o){this.h.fire({added:t,removed:s,updated:o,all:this.profiles})}G(t,s,o){o=s?.isTransient?!0:o,o||this.G(t,void 0,!0);const c=this.z(t),y=o?this.m:this.v;O.URI.isUri(c)?(y.workspaces.delete(c),s&&y.workspaces.set(c,s)):(y.emptyWindows.delete(c),s&&y.emptyWindows.set(c,s)),o||this.H()}H(){const t={};for(const[o,c]of this.v.workspaces.entries())t[o.toString()]=c.id;const s={};for(const[o,c]of this.v.emptyWindows.entries())s[o.toString()]=c.id;this.N({workspaces:t,emptyWindows:s}),this.u=void 0}I(t){const s={},o=this.w();if(t.workspaces)for(const[y,d]of Object.entries(t.workspaces)){const l=O.URI.parse(d);s[y]=this.s.extUri.isEqual(l,o.location)?o.id:this.s.extUri.basename(l)}const c={};if(t.emptyWindows)for(const[y,d]of Object.entries(t.emptyWindows)){const l=O.URI.parse(d);c[y]=this.s.extUri.isEqual(l,o.location)?o.id:this.s.extUri.basename(l)}return{workspaces:s,emptyWindows:c}}J(){return[]}L(t){throw new Error("not implemented")}M(){return{}}N(t){throw new Error("not implemented")}O(){}};n.b="userDataProfiles",n.c="profileAssociations",e.$qk=n=we([Y(0,k.$sh),Y(1,m.$Oj),Y(2,$.$lk),Y(3,E.$Ni)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(t){this.a=t}M(){return this.R}N(t){this.R=t}}e.$rk=r}),define(ae[235],ce([0,1,6,2,17]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V4b=void 0;let j=e.$V4b=class extends M.$kb{constructor(C){super(),this.B(new R.$Cg(()=>{C.cleanUp()},10*1e3)).schedule()}};e.$V4b=j=we([Y(0,L.$nk)],j)}),define(ae[236],ce([0,1,21,6,26,7,3,2,5,10,12,145,28,33,49,8,24,20,17]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=void 0;let p=e.$3o=class extends C.$kb{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(t,s,o,c,y){super(),this.t=t,this.u=s,this.v=o,this.w=c,this.y=y,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new O.$5c),this.m=this.B(new O.$5c),this.n=this.B(new O.$5c),this.p=this.B(new O.$5c),this.s=[],this.B((0,C.$ib)(()=>{this.j.forEach(({task:d})=>d.cancel()),this.k.forEach(d=>d.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(t){const s=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,b.$In)(o,t.allTargetPlatforms,s))}async installFromGallery(t,s={}){try{const c=(await this.installGalleryExtensions([{extension:t,options:s}])).find(({identifier:y})=>(0,f.$bo)(y,t.identifier));if(c?.local)return c?.local;throw c?.error?c.error:I(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(o){throw I(o)}}async installGalleryExtensions(t){if(!this.t.isEnabled())throw new b.$Mn(E.localize(0,null),b.ExtensionManagementErrorCode.Internal);const s=[],o=[];await Promise.allSettled(t.map(async({extension:c,options:y})=>{try{const d=await this.H(c,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);o.push({...d,options:y})}catch(d){s.push({identifier:c.identifier,operation:2,source:c,error:d})}})),o.length&&s.push(...await this.z(o));for(const c of s)c.error&&(this.v.error("Failed to install extension.",c.identifier.id),this.v.error(c.error),c.source&&!S.URI.isUri(c.source)&&n(this.u,"extensionGallery:install",{extensionData:(0,f.$jo)(c.source),error:c.error}));return s}async uninstall(t,s={}){return this.v.trace("ExtensionManagementService#uninstall",t.identifier.id),this.J(t,s)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.P(),this.h=t),this.g}registerParticipant(t){this.s.push(t)}async z(t){const s=[];return await Promise.allSettled(t.map(async o=>{try{const c=await this.C(o);s.push(...c)}catch(c){s.push({identifier:{id:(0,f.$go)(o.manifest.publisher,o.manifest.name)},operation:2,source:o.extension,error:c})}})),this.m.fire(s),s}async C({manifest:t,extension:s,options:o}){const c=o.isApplicationScoped||o.isBuiltin||(0,$.$Gl)(t),y={...o,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(s)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:c,profileLocation:c?this.y.defaultProfile.extensionsResource:o.profileLocation??this.Q()},d=H=>`${f.$co.create(H).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!S.URI.isUri(s)){const H=this.j.get(d(s));if(H)return this.v.info("Extensions is already requested to install",s.identifier.id),await H.task.waitUntilTaskIsFinished(),[]}const l=[],P=[],D=[],T=this.R(t,s,y);S.URI.isUri(s)||this.j.set(d(s),{task:T,waitingTasks:[]}),this.l.fire({identifier:T.identifier,source:s,profileLocation:y.profileLocation}),this.v.info("Installing extension:",T.identifier.id),l.push({task:T,manifest:t});let F=!1;try{if(y.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const V=await this.G(T.identifier,t,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),W=await this.getInstalled(void 0,y.profileLocation);for(const{gallery:x,manifest:ee}of(0,R.$of)(V,({gallery:X})=>X.identifier.id)){F=F||!!ee.extensionDependencies?.some(q=>(0,f.$bo)({id:q},T.identifier));const X=d(x),_=this.j.get(X);if(_){if(this.D(T,_.task)){const q=_.task.identifier;this.v.info("Waiting for already requested installing extension",q.id,T.identifier.id),_.waitingTasks.push(T),P.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,G=>G.some(B=>(0,f.$bo)(B.identifier,q)))).then(G=>{if(this.v.info("Finished waiting for already requested installing extension",q.id,T.identifier.id),!G.find(ie=>(0,f.$bo)(ie.identifier,q))?.local)throw new Error(`Extension ${q.id} is not installed`)}))}}else if(!W.some(({identifier:q})=>(0,f.$bo)(q,x.identifier))){const q=this.R(ee,x,{...y,donotIncludePackAndDependencies:!0});this.j.set(X,{task:q,waitingTasks:[T]}),this.l.fire({identifier:q.identifier,source:x,profileLocation:y.profileLocation}),this.v.info("Installing extension:",q.identifier.id,T.identifier.id),l.push({task:q,manifest:ee})}}}catch(V){if(S.URI.isUri(T.source))(0,R.$nf)(t.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",T.identifier.id,V.message),(0,R.$nf)(t.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",T.identifier.id,V.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),V}const H=l.reduce((V,{task:W,manifest:x})=>(V.set(W.identifier.id.toLowerCase(),{task:W,manifest:x}),V),new Map);for(;H.size;){let V;const W=[...H.values()].filter(({manifest:x})=>!x.extensionDependencies?.some(ee=>H.has(ee.toLowerCase())));W.length?V=H.size===1?W:W.filter(({task:x})=>!(x===T&&!F)):(this.v.info("Found extensions with circular dependencies",W.map(({task:x})=>x.identifier.id)),V=[...H.values()]),await this.F(V.map(async({task:x})=>{const ee=new Date().getTime();try{const X=await x.run();if(await this.F(this.s.map(_=>_.postInstall(X,x.source,y,L.CancellationToken.None))),!S.URI.isUri(x.source)){const _=x.operation===3,q=_?void 0:(new Date().getTime()-x.source.lastUpdated)/1e3;if(n(this.u,_?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$jo)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-ee,durationSinceUpdate:q}),k.$o&&x.operation!==3)try{await this.t.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}D.push({local:X,identifier:x.identifier,operation:x.operation,source:x.source,context:y.context,profileLocation:x.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw S.URI.isUri(x.source)||n(this.u,x.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$jo)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-ee,error:X}),this.v.error("Error while installing the extension:",x.identifier.id),X}finally{H.delete(x.identifier.id.toLowerCase())}}))}return P.length&&await this.F(P),D.forEach(({identifier:V})=>this.v.info("Extension installed successfully:",V.id)),D}catch(H){if(l.forEach(({task:V})=>V.cancel()),D.length)try{const V=await Promise.allSettled(D.map(({local:W})=>this.S(W,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let W=0;W<V.length;W++){const x=V[W],{identifier:ee}=D[W];x.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",ee.id):this.v.warn("Rollback: Error while uninstalling extension",ee.id,(0,j.$8)(x.reason))}}catch(V){this.v.warn("Error while rolling back extensions",(0,j.$8)(V),D.map(({identifier:W})=>W.id))}return l.map(({task:V})=>({identifier:V.identifier,operation:2,source:V.source,context:y.context,profileLocation:y.profileLocation,error:H}))}finally{for(const{task:H}of l)H.source&&!S.URI.isUri(H.source)&&this.j.delete(d(H.source))}}D(t,s){for(const[,{task:o,waitingTasks:c}]of this.j.entries())if(o===t&&(c.includes(s)||c.some(y=>this.D(y,s)))||o===s&&c[0]&&!this.D(t,c[0]))return!1;return!0}async F(t){const s=[],o=[],c=await Promise.allSettled(t);for(const y of c)y.status==="fulfilled"?s.push(y.value):o.push(y.reason);if(o.length)throw w(o);return s}async G(t,s,o,c,y){if(!this.t.isEnabled())return[];const d=await this.getInstalled(void 0,y),l=[],P=[],D=async(T,F)=>{l.push(T);const H=F.extensionDependencies||[],V=[...H];if(F.extensionPack){const W=o?d.find(x=>(0,f.$bo)(x.identifier,T)):void 0;for(const x of F.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(ee=>(0,f.$bo)({id:ee},{id:x}))||V.every(ee=>!(0,f.$bo)({id:ee},{id:x}))&&V.push(x)}if(V.length){const W=V.filter(x=>l.every(ee=>!(0,f.$bo)(ee,{id:x})));if(W.length){const x=await this.t.getExtensions(W.map(ee=>({id:ee,preRelease:c})),L.CancellationToken.None);for(const ee of x){if(l.find(q=>(0,f.$bo)(q,ee.identifier)))continue;const X=H.some(q=>(0,f.$bo)({id:q},ee.identifier));let _;try{_=await this.H(ee,!1,c)}catch(q){if(q instanceof b.$Mn&&q.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!X){this.v.info("Skipping the packed extension as it cannot be installed",ee.identifier.id);continue}else throw q}P.push({gallery:_.extension,manifest:_.manifest}),await D(_.extension.identifier,_.manifest)}}}};return await D(t,s),P}async H(t,s,o){if((await this.getExtensionsControlManifest()).malicious.some(l=>(0,f.$bo)(t.identifier,l)))throw new b.$Mn(E.localize(1,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const l=await this.getTargetPlatform();throw new b.$Mn(E.localize(2,null,t.identifier.id,this.w.nameLong,(0,b.$En)(l)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const y=await this.I(t,s,o);if(y){if(o&&!s&&t.hasPreReleaseVersion&&!y.properties.isPreReleaseVersion)throw new b.$Mn(E.localize(3,null,t.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.t.getExtensions([t.identifier],L.CancellationToken.None))[0]?new b.$Mn(E.localize(4,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.$Mn(E.localize(5,null,t.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",y.identifier.id);const d=await this.t.getManifest(y,L.CancellationToken.None);if(d===null)throw new b.$Mn(`Missing manifest for extension ${t.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(d.version!==y.version)throw new b.$Mn(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:d}}async I(t,s,o){const c=await this.getTargetPlatform();let y=null;return!s&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(y=(await this.t.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},L.CancellationToken.None))[0]||null),!y&&await this.t.isExtensionCompatible(t,o,c)&&(y=t),y||(s?y=(await this.t.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},L.CancellationToken.None))[0]||null:y=await this.t.getCompatibleExtension(t,o,c)),y}async J(t,s){const o={...s,profileLocation:t.isApplicationScoped?this.y.defaultProfile.extensionsResource:s.profileLocation??this.Q()},c=T=>`${T.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,y=this.k.get(c(t.identifier));if(y)return this.v.info("Extensions is already requested to uninstall",t.identifier.id),y.waitUntilTaskIsFinished();const d=T=>{const F=this.S(T,o);return this.k.set(c(F.extension.identifier),F),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.n.fire({identifier:T.identifier,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped}),F},l=(T,F)=>{F?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString(),F.message):this.v.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,F.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),n(this.u,"extensionGallery:uninstall",{extensionData:(0,f.$io)(T),error:F}),this.p.fire({identifier:T.identifier,error:F?.code,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped})},P=[],D=[];try{P.push(d(t));const T=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.N(t,T);for(const H of F)this.k.has(c(H.identifier))?this.v.info("Extensions is already requested to uninstall",H.identifier.id):P.push(d(H))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.L(P.map(F=>F.extension),T,t),await this.F(P.map(async F=>{try{if(await F.run(),await this.F(this.s.map(H=>H.postUninstall(F.extension,o,L.CancellationToken.None))),F.extension.identifier.uuid)try{await this.t.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}l(F.extension)}catch(H){const V=H instanceof b.$Mn?H:new b.$Mn((0,j.$8)(H),b.ExtensionManagementErrorCode.Internal);throw l(F.extension,V),V}finally{D.push(F)}}))}catch(T){const F=T instanceof b.$Mn?T:new b.$Mn((0,j.$8)(T),b.ExtensionManagementErrorCode.Internal);for(const H of P){try{H.cancel()}catch{}D.includes(H)||l(H.extension,F)}throw F}finally{for(const T of P)this.k.delete(c(T.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}L(t,s,o){for(const c of t){const y=this.O(c,s);if(y.length){const d=y.filter(l=>!t.some(P=>(0,f.$bo)(P.identifier,l.identifier)));if(d.length)throw new Error(this.M(c,d,o))}}}M(t,s,o){return o===t?s.length===1?E.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?E.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):E.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?E.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?E.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):E.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}N(t,s,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const y=s.filter(l=>!l.isBuiltin&&c.some(P=>(0,f.$bo)({id:P},l.identifier))),d=[];for(const l of y)d.push(...this.N(l,s,o));return[...y,...d]}return[]}O(t,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,f.$bo)({id:c},t.identifier)))}async P(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const t=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$3o=p=we([Y(0,b.$Ln),Y(1,h.$Rk),Y(2,v.$Ni),Y(3,a.$6i),Y(4,u.$nk)],p);function w(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((s,o)=>new Error(`${s.message}${s.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.$4o=w;function I(i){if(i instanceof b.$Mn)return i;const t=new b.$Mn(i.message,b.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$5o=I;function n(i,t,{extensionData:s,verificationStatus:o,duration:c,error:y,durationSinceUpdate:d}){let l,P;(0,m.$oe)(o)&&(o===!0?o="Verified":(o===!1||(l=b.ExtensionManagementErrorCode.Signature,P=o),o="Unverified")),y&&(y instanceof b.$Mn?(l=y.code,y.code===b.ExtensionManagementErrorCode.Signature&&(P=y.message)):l=b.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...s,verificationStatus:o,success:!y,duration:c,errorcode:l,errorcodeDetail:P,durationSinceUpdate:d})}class r{constructor(){this.d=new M.$qg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,M.$fg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,M.$fg)(t=>new Promise((s,o)=>{const c=t.onCancellationRequested(()=>{c.dispose(),o(new j.$2)})})),this.d.open()),this.g.cancel()}}e.$6o=r}),define(ae[50],ce([0,1,6,16,2,3,35,12,28,33,13,4,8,17,29,10,7,20]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class p extends Error{constructor(i,t){super(i),this.code=t}}e.$7o=p,e.$8o=(0,E.$lh)("IExtensionsProfileScannerService");let w=e.$9o=class extends L.$kb{constructor(i,t,s,o,c,y){super(),this.i=i,this.j=t,this.k=s,this.l=o,this.m=c,this.n=y,this.b=this.B(new j.$5c),this.onAddExtensions=this.b.event,this.c=this.B(new j.$5c),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$5c),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$5c),this.onDidRemoveExtensions=this.g.event,this.h=new O.$ji}scanProfileExtensions(i,t){return this.p(i,void 0,t)}async addExtensionsToProfile(i,t){const s=[],o=[];try{return await this.p(t,c=>{const y=[];for(const d of c)i.some(([l])=>(0,m.$bo)(l.identifier,d.identifier)&&l.manifest.version!==d.version)?s.push(d):y.push(d);for(const[d,l]of i)if(!y.some(P=>(0,m.$bo)(P.identifier,d.identifier)&&P.version===d.manifest.version)){const P={identifier:d.identifier,version:d.manifest.version,location:d.location,metadata:l};o.push(P),y.push(P)}return o.length&&this.b.fire({extensions:o,profileLocation:t}),s.length&&this.f.fire({extensions:s,profileLocation:t}),y}),o.length&&this.c.fire({extensions:o,profileLocation:t}),s.length&&this.g.fire({extensions:s,profileLocation:t}),o}catch(c){throw o.length&&this.c.fire({extensions:o,error:c,profileLocation:t}),s.length&&this.g.fire({extensions:s,error:c,profileLocation:t}),c}}async updateMetadata(i,t){const s=[];return await this.p(t,o=>{const c=[];for(const y of o){const d=i.find(([l])=>(0,m.$bo)(l.identifier,y.identifier)&&l.manifest.version===y.version);d&&(y.metadata={...y.metadata,...d[1]},s.push(y)),c.push(y)}return c}),s}async removeExtensionFromProfile(i,t){const s=[];this.f.fire({extensions:s,profileLocation:t});try{await this.p(t,o=>{const c=[];for(const y of o)(0,m.$bo)(y.identifier,i.identifier)?s.push(y):c.push(y);return s.length&&this.f.fire({extensions:s,profileLocation:t}),c}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:t}),o}}async p(i,t,s){return this.w(i).queue(async()=>{let o=[],c;try{const y=await this.j.readFile(i);c=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,S.$5j)(y)!==1)throw y;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(c=await this.v()),!c&&s?.bailOutWhenFileNotFound)throw new p((0,a.$8)(y),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.r(i);let y=!1;for(const d of c){I(d)||this.r(i);let l;if((0,v.$ge)(d.relativeLocation)&&d.relativeLocation)l=this.t(d.relativeLocation);else if((0,v.$ge)(d.location))l=this.t(d.location),y=!0,d.relativeLocation=d.location,d.location=l.toJSON();else{l=C.URI.revive(d.location);const P=this.s(l);P&&(y=!0,d.relativeLocation=P)}o.push({identifier:d.identifier,location:l,version:d.version,metadata:d.metadata})}y&&await this.j.writeFile(i,M.$Ib.fromString(JSON.stringify(c)))}if(t){o=t(o);const y=o.map(d=>({identifier:d.identifier,version:d.version,location:d.location.toJSON(),relativeLocation:this.s(d.location),metadata:d.metadata}));await this.j.writeFile(i,M.$Ib.fromString(JSON.stringify(y)))}return o})}r(i){const t=new p(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),t=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let s;try{s=(await this.j.readFile(i)).value.toString()}catch(c){if((0,S.$5j)(c)===1)return;throw c}this.n.info("Migrating extensions from old default profile location",i.toString());let o;try{const c=JSON.parse(s);Array.isArray(c)&&c.every(y=>I(y))?o=c:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.n.error(c)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,M.$Ib.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(c){if((0,S.$5j)(c)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw c}try{await this.j.del(i)}catch(c){(0,S.$5j)(c)!==1&&this.n.error(c)}try{await this.j.del(t)}catch(c){(0,S.$5j)(c)!==1&&this.n.error(c)}return o})()),this.u}w(i){let t=this.h.get(i);return t||(t=new R.$yg,this.h.set(i,t)),t}};e.$9o=w=we([Y(1,S.$Oj),Y(2,f.$nk),Y(3,$.$lk),Y(4,h.$Rk),Y(5,b.$Ni)],w);function I(r){return(0,v.$ie)(r)&&(0,k.$Kn)(r.identifier)&&(n(r.location)||(0,v.$ge)(r.location)&&r.location)&&((0,v.$ne)(r.relativeLocation)||(0,v.$ge)(r.relativeLocation))&&r.version&&(0,v.$ge)(r.version)}function n(r){return r?(0,v.$ge)(r.path)&&(0,v.$ge)(r.scheme):!1}}),define(ae[78],ce([0,1,21,6,31,16,7,34,133,2,25,15,5,22,52,88,10,12,148,14,33,49,67,13,4,8,24,3,64,50,17,29,176]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u,p,w,I,n,r,i,t,s,o,c,y,d,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.Translations=void 0;var D;(function(ee){function X(_,q){if(_===q)return!0;const G=Object.keys(_),B=new Set;for(const ie of Object.keys(q))B.add(ie);if(G.length!==B.size)return!1;for(const ie of G){if(_[ie]!==q[ie])return!1;B.delete(ie)}return B.size===0}ee.equals=X})(D||(e.Translations=D={})),e.$_o=(0,i.$lh)("IExtensionsScannerService");let T=e.$ap=class extends m.$kb{constructor(X,_,q,G,B,ie,re,K,Z,N,g,A){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=_,this.l=q,this.m=G,this.n=B,this.r=ie,this.s=re,this.t=K,this.u=Z,this.v=N,this.w=g,this.y=A,this.g=this.B(new o.$5c),this.onDidChangeCache=this.g.event,this.h=(0,f.$6f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(V,this.m,this.h)),this.j=this.B(this.y.createInstance(V,this.m,this.h)),this.k=this.B(this.y.createInstance(H,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,w.$mo)(this.s,this.t)),this.z}async scanAllExtensions(X,_,q){const[G,B]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(_)]),ie=q?await this.scanExtensionsUnderDevelopment(X,[...G,...B]):[];return this.G(G,B,ie,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const _=[];_.push(this.H(!!X.useCache,X.language)),_.push(this.I(X.language,!!X.checkControlFile));const[q,G]=await Promise.all(_);return this.F([...q,...G],0,X,!1)}async scanUserExtensions(X){const _=X.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",_);const q=this.w.extUri.isEqual(X.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,G=await this.L(_,!!X.profileLocation,1,!X.includeUninstalled,X.language,!0,q),B=X.useCache&&!G.devMode&&G.excludeObsolete?this.j:this.k;let ie;try{ie=await B.scanExtensions(G)}catch(re){if(re instanceof y.$7o&&re.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),ie=await B.scanExtensions(G);else throw re}return ie=await this.F(ie,1,X,!0),this.t.trace("Scanned user extensions:",ie.length),ie}async scanExtensionsUnderDevelopment(X,_){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const q=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(G=>G.scheme===S.Schemas.file).map(async G=>{const B=await this.L(G,!1,1,!0,X.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(B)).map(re=>(re.type=_.find(K=>(0,w.$bo)(K.identifier,re.identifier))?.type??re.type,this.k.validate(re,B)))}))).flat();return this.F(q,"development",X,!0)}return[]}async scanExistingExtension(X,_,q){const G=await this.L(X,!1,_,!0,q.language,!0,void 0),B=await this.k.scanExtension(G);return!B||!q.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(X,_,q){const G=await this.L(X,!1,_,!0,q.language,!0,void 0),B=await this.k.scanOneOrMultipleExtensions(G);return this.F(B,_,q,!0)}async scanMetadata(X){const _=(0,f.$6f)(X,"package.json"),q=(await this.s.readFile(_)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(X,_){const q=(0,f.$6f)(X,"package.json"),G=(await this.s.readFile(q)).value.toString(),B=JSON.parse(G);_.isMachineScoped=_.isMachineScoped||void 0,_.isBuiltin=_.isBuiltin||void 0,B.__metadata={...B.__metadata,..._},await this.s.writeFile((0,f.$6f)(X,"package.json"),j.$Ib.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(X){if(X instanceof y.$7o&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw X}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const X=await this.scanUserExtensions({includeInvalid:!0});if(X.length)await this.r.addExtensionsToProfile(X.map(_=>[_,_.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,j.$Ib.fromString(JSON.stringify([])))}catch(_){(0,r.$5j)(_)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$8)(_))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(X){this.t.error(X)}finally{this.C=void 0}})()),this.C}async F(X,_,q,G){return q.includeAllVersions||(X=this.G(_===0?X:void 0,_===1?X:void 0,_==="development"?X:void 0,await this.getTargetPlatform(),G)),q.includeInvalid||(X=X.filter(B=>B.isValid)),X.sort((B,ie)=>{const re=E.$cc(B.location.fsPath),K=E.$cc(ie.location.fsPath);return re<K?-1:re>K?1:0})}G(X,_,q,G,B){const ie=(K,Z,N)=>{if(K.isValid&&!Z.isValid)return!1;if(K.isValid===Z.isValid){if(B&&$.gt(K.manifest.version,Z.manifest.version))return this.t.debug(`Skipping extension ${Z.location.path} with lower version ${Z.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if($.eq(K.manifest.version,Z.manifest.version)){if(K.type===0)return this.t.debug(`Skipping extension ${Z.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===G)return this.t.debug(`Skipping extension ${Z.location.path} from different target platform ${Z.targetPlatform}`),!1}}return N?this.t.warn(`Overwriting user extension ${K.location.path} with ${Z.location.path}.`):this.t.debug(`Overwriting user extension ${K.location.path} with ${Z.location.path}.`),!0},re=new I.$Fl;return X?.forEach(K=>{const Z=re.get(K.identifier.id);(!Z||ie(Z,K,!1))&&re.set(K.identifier.id,K)}),_?.forEach(K=>{const Z=re.get(K.identifier.id);if(!Z&&X&&K.type===0){this.t.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!Z||ie(Z,K,!1))&&re.set(K.identifier.id,K)}),q?.forEach(K=>{const Z=re.get(K.identifier.id);(!Z||ie(Z,K,!0))&&re.set(K.identifier.id,K),re.set(K.identifier.id,K)}),[...re.values()]}async H(X,_){this.t.trace("Started scanning system extensions");const q=await this.L(this.systemExtensionsLocation,!1,0,!0,_,!0,void 0),B=await(X&&!q.devMode?this.i:this.k).scanExtensions(q);return this.t.trace("Scanned system extensions:",B.length),B}async I(X,_){const q=this.u.isBuilt?[]:this.v.builtInExtensions;if(!q?.length)return[];this.t.trace("Started scanning dev system extensions");const G=_?await this.J():{},B=[],ie=h.URI.file(E.$9b(E.$$b(S.$1e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of q){const Z=G[K.name]||"marketplace";switch(Z){case"disabled":break;case"marketplace":B.push((0,f.$6f)(ie,K.name));break;default:B.push(h.URI.file(Z));break}}const re=await Promise.all(B.map(async K=>this.k.scanExtension(await this.L(K,!1,0,!0,X,!0,void 0))));return this.t.trace("Scanned dev system extensions:",re.length),(0,R.$jf)(re)}async J(){try{const X=await this.s.readFile(this.l);return JSON.parse(X.value.toString())}catch{return{}}}async L(X,_,q,G,B,ie,re){const K=await this.f(B??b.$v),Z=await this.M(X),N=_&&!this.w.extUri.isEqual(X,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,g=N?await this.M(N):void 0;return new F(X,Z,N,g,_,re,q,G,ie,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,B,K)}async M(X){try{const _=await this.s.stat(X);if(typeof _.mtime=="number")return _.mtime}catch{}}};e.$ap=T=we([Y(4,d.$nk),Y(5,y.$8o),Y(6,r.$Oj),Y(7,t.$Ni),Y(8,p.$sh),Y(9,s.$6i),Y(10,l.$lk),Y(11,i.$kh)],T);class F{constructor(X,_,q,G,B,ie,re,K,Z,N,g,A,U,Q,z){this.location=X,this.mtime=_,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=G,this.profile=B,this.profileScanOptions=ie,this.type=re,this.excludeObsolete=K,this.validate=Z,this.productVersion=N,this.productDate=g,this.productCommit=A,this.devMode=U,this.language=Q,this.translations=z}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,_){return(0,f.$Yf)(X.location,_.location)&&X.mtime===_.mtime&&(0,f.$Yf)(X.applicationExtensionslocation,_.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&X.profile===_.profile&&L.$Hm(X.profileScanOptions,_.profileScanOptions)&&X.type===_.type&&X.excludeObsolete===_.excludeObsolete&&X.validate===_.validate&&X.productVersion===_.productVersion&&X.productDate===_.productDate&&X.productCommit===_.productCommit&&X.devMode===_.devMode&&X.language===_.language&&D.equals(X.translations,_.translations)}}e.$bp=F;let H=class extends m.$kb{constructor(X,_,q,G,B){super(),this.f=X,this.g=_,this.h=q,this.i=G,this.j=B}async scanExtensions(X){const _=X.profile?await this.l(X):await this.k(X);let q={};if(X.excludeObsolete&&X.type===1)try{const G=(await this.i.readFile(this.f)).value.toString();q=JSON.parse(G)}catch{}return(0,a.$te)(q)?_:_.filter(G=>!q[w.$co.create(G).toString()])}async k(X){const _=await this.i.resolve(X.location);if(!_.children?.length)return[];const q=await Promise.all(_.children.map(async G=>{if(!G.isDirectory||X.type===1&&(0,f.$3f)(G.resource).indexOf(".")===0)return null;const B=new F(G.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(B)}));return(0,R.$jf)(q).sort((G,B)=>G.location.path<B.location.path?-1:1)}async l(X){let _=await this.m(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.h.extUri.isEqual(X.location,X.applicationExtensionslocation)){_=_.filter(G=>!G.metadata?.isApplicationScoped);const q=await this.m(X.applicationExtensionslocation,G=>!!G.metadata?.isBuiltin||!!G.metadata?.isApplicationScoped,X);_.push(...q)}return _}async m(X,_,q){const G=await this.g.scanProfileExtensions(X,q.profileScanOptions);if(!G.length)return[];const B=await Promise.all(G.map(async ie=>{if(_(ie)){const re=new F(ie.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(re,ie.metadata)}return null}));return(0,R.$jf)(B)}async scanOneOrMultipleExtensions(X){try{if(await this.i.exists((0,f.$6f)(X.location,"package.json"))){const _=await this.scanExtension(X);return _?[_]:[]}else return await this.scanExtensions(X)}catch(_){return this.j.error(`Error scanning extensions at ${X.location.path}:`,(0,O.$8)(_)),[]}}async scanExtension(X,_){try{let q=await this.scanExtensionManifest(X.location);if(q){q.publisher||(q.publisher=I.$zl),_=_??q.__metadata,delete q.__metadata;const G=(0,w.$go)(q.publisher,q.name),B=_?.id?{id:G,uuid:_.id}:{id:G},ie=_?.isSystem?0:X.type,re=ie===0||!!_?.isBuiltin;q=await this.n(X.location,q,F.createNlsConfiguration(X));const K={type:ie,identifier:B,manifest:q,location:X.location,isBuiltin:re,targetPlatform:_?.targetPlatform??"undefined",metadata:_,isValid:!0,validations:[]};return X.validate?this.validate(K,X):K}}catch(q){X.type!==0&&this.j.error(q)}return null}validate(X,_){let q=!0;const G=(0,n.$ro)(_.productVersion,_.productDate,_.location,X.manifest,X.isBuiltin);for(const[B,ie]of G)B===v.default.Error&&(q=!1,this.j.error(this.u(_.location,ie)));return X.isValid=q,X.validations=G,X}async scanExtensionManifest(X){const _=(0,f.$6f)(X,"package.json");let q;try{q=(await this.i.readFile(_)).value.toString()}catch(B){return(0,r.$5j)(B)!==1&&this.j.error(this.u(X,(0,u.localize)(0,null,_.path,B.message))),null}let G;try{G=JSON.parse(q)}catch{const ie=[];(0,C.$tm)(q,ie);for(const re of ie)this.j.error(this.u(X,(0,u.localize)(1,null,_.path,re.offset,re.length,(0,k.$0o)(re.error))));return null}return(0,C.$Cm)(G)!=="object"?(this.j.error(this.u(X,(0,u.localize)(2,null,_.path))),null):G}async n(X,_,q){const G=await this.r(X,_,q);if(G)try{const B=[],ie=await this.s(G.default,B);if(B.length>0)return B.forEach(K=>{this.j.error(this.u(X,(0,u.localize)(3,null,G.default?.path,(0,k.$0o)(K.error))))}),_;if((0,C.$Cm)(G)!=="object")return this.j.error(this.u(X,(0,u.localize)(4,null,G.default?.path))),_;const re=G.values||Object.create(null);return(0,P.$$o)(_,re,ie)}catch{}return _}async r(X,_,q){const G=(0,f.$6f)(X,"package.nls.json"),B=(Z,N)=>{N.forEach(g=>{this.j.error(this.u(X,(0,u.localize)(5,null,Z?.path,(0,k.$0o)(g.error))))})},ie=Z=>{this.j.error(this.u(X,(0,u.localize)(6,null,Z?.path)))},re=`${_.publisher}.${_.name}`,K=q.translations[re];if(K)try{const Z=h.URI.file(K),N=(await this.i.readFile(Z)).value.toString(),g=[],A=(0,C.$tm)(N,g);return g.length>0?(B(Z,g),{values:void 0,default:G}):(0,C.$Cm)(A)!=="object"?(ie(Z),{values:void 0,default:G}):{values:A.contents?A.contents.package:void 0,default:G}}catch{return{values:void 0,default:G}}else{if(!await this.i.exists(G))return;let N;try{N=await this.t(X,q)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const g=(await this.i.readFile(N.localized)).value.toString(),A=[],U=(0,C.$tm)(g,A);return A.length>0?(B(N.localized,A),{values:void 0,default:N.original}):(0,C.$Cm)(U)!=="object"?(ie(N.localized),{values:void 0,default:N.original}):{values:U,default:N.original}}catch{return{values:void 0,default:N.original}}}}async s(X,_){if(X)try{const q=(await this.i.readFile(X)).value.toString();return(0,C.$tm)(q,_)}catch{}}t(X,_){return new Promise((q,G)=>{const B=ie=>{const re=(0,f.$6f)(X,`package.nls.${ie}.json`);this.i.exists(re).then(K=>{K&&q({localized:re,original:(0,f.$6f)(X,"package.nls.json")});const Z=ie.lastIndexOf("-");Z===-1?q({localized:(0,f.$6f)(X,"package.nls.json"),original:null}):(ie=ie.substring(0,Z),B(ie))})};if(_.devMode||_.pseudo||!_.language)return q({localized:(0,f.$6f)(X,"package.nls.json"),original:null});B(_.language)})}u(X,_){return`[${X.path}]: ${_}`}};H=we([Y(1,y.$8o),Y(2,l.$lk),Y(3,r.$Oj),Y(4,t.$Ni)],H);let V=class extends H{constructor(X,_,q,G,B,ie,re){super(_,G,B,ie,re),this.z=X,this.C=q,this.w=this.B(new M.$pg(3e3)),this.y=this.B(new o.$5c),this.onDidChangeCache=this.y.event}async scanExtensions(X){const _=this.H(X),q=await this.D(_);if(this.v=X,q&&q.input&&F.equals(q.input,this.v))return this.j.debug("Using cached extensions scan result",X.location.toString()),this.w.trigger(()=>this.G()),q.result.map(B=>(B.location=h.URI.revive(B.location),B));const G=await super.scanExtensions(X);return await this.F(_,{input:X,result:G}),G}async D(X){try{const _=await this.i.readFile(X),q=JSON.parse(_.value.toString());return{result:q.result,input:(0,c.$Ug)(q.input)}}catch(_){this.j.debug("Error while reading the extension cache file:",X.path,(0,O.$8)(_))}return null}async F(X,_){try{await this.i.writeFile(X,j.$Ib.fromString(JSON.stringify(_)))}catch(q){this.j.debug("Error while writing the extension cache file:",X.path,(0,O.$8)(q))}}async G(){if(!this.v)return;const X=this.H(this.v),_=await this.D(X);if(!_)return;const q=_.result,G=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!L.$Hm(G,q))try{this.j.info("Invalidating Cache",q,G),await this.i.del(X),this.y.fire()}catch(B){this.j.error(B)}}H(X){const _=this.I(X);return this.h.extUri.joinPath(_.cacheHome,X.type===0?I.$yl:I.$xl)}I(X){return X.type===0?this.C.defaultProfile:X.profile?this.h.extUri.isEqual(X.location,this.z.extensionsResource)?this.z:this.C.profiles.find(_=>this.h.extUri.isEqual(X.location,_.extensionsResource))??this.z:this.C.defaultProfile}};V=we([Y(2,d.$nk),Y(3,y.$8o),Y(4,l.$lk),Y(5,r.$Oj),Y(6,t.$Ni)],V);function W(ee,X){const _=(0,w.$eo)(ee.manifest.publisher,ee.manifest.name);return{id:_,identifier:new I.$Dl(_),isBuiltin:ee.type===0,isUserBuiltin:ee.type===1&&ee.isBuiltin,isUnderDevelopment:X,extensionLocation:ee.location,uuid:ee.identifier.uuid,targetPlatform:ee.targetPlatform,...ee.manifest}}e.$cp=W;class x extends T{constructor(X,_,q,G,B,ie,re,K,Z,N,g,A){super(X,_,(0,f.$6f)(q,".vscode-oss-dev","extensions","control.json"),G,B,ie,re,K,Z,N,g,A),this.N=(async()=>{if(b.$y)try{const U=await this.s.readFile(h.URI.file(b.$y));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}f(X){return this.N}}e.$dp=x}),define(ae[237],ce([0,1,65,6,38,3,2,25,15,30,8,17]),function(ne,e,R,M,L,j,O,C,k,m,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=void 0;let b=e.$fp=class extends O.$kb{constructor($,v){super(),this.b=$,this.f=v,this.a=new M.$xg(5)}async postUninstall($){const v=this.g($,"uninstall");v&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(a){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(a)}}));try{await m.Promises.rm(this.j($))}catch(a){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(a)}}g($,v){const a=`vscode:${v}`;if($.location.scheme===C.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[a]=="string"){const h=$.manifest.scripts[a].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn($.identifier.id,$.manifest.version,`${a} should be a node script`),null):{script:(0,k.$$b)($.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h($,v,a,h,u){return new Promise((p,w)=>{const I=this.i($,v,a,u);let n;const r=i=>{n&&(clearTimeout(n),n=null),i?w(i):p(void 0)};I.on("error",i=>{r((0,L.$9h)(i)||"Unknown")}),I.on("exit",(i,t)=>{r(i?`post-${v} process exited with code ${i}`:void 0)}),h&&(n=setTimeout(()=>{n=null,I.kill(),w("timed out")},5e3))})}i($,v,a,h){const u={silent:!0,execArgv:void 0},p=(0,R.fork)($,[`--type=extension-post-${v}`,...a],u);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const w=j.Event.fromNodeEventEmitter(p.stdout,"data"),I=j.Event.fromNodeEventEmitter(p.stderr,"data");w(i=>this.f.info(h.identifier.id,h.manifest.version,`post-${v}`,i)),I(i=>this.f.error(h.identifier.id,h.manifest.version,`post-${v}`,i));const n=j.Event.any(j.Event.map(w,i=>({data:`%c${i}`,format:[""]})),j.Event.map(I,i=>({data:`%c${i}`,format:["color: red"]})));return j.Event.debounce(n,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),p}j($){return(0,k.$$b)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$fp=b=we([Y(0,E.$nk),Y(1,S.$Ni)],b)}),define(ae[238],ce([0,1,8,17,29,20,50,13,14,12]),function(ne,e,R,M,L,j,O,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=void 0;let S=e.$vM=class extends O.$9o{constructor(b,f,$,v,a,h){super(m.URI.file(b.extensionsPath),f,$,v,a,h)}};e.$vM=S=we([Y(0,k.$th),Y(1,C.$Oj),Y(2,M.$nk),Y(3,L.$lk),Y(4,j.$Rk),Y(5,R.$Ni)],S)}),define(ae[239],ce([0,1,12,14,50,78,13,4,8,24,29,17]),function(ne,e,R,M,L,j,O,C,k,m,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P3b=void 0;let b=e.$P3b=class extends j.$dp{constructor($,v,a,h,u,p,w,I){super(R.URI.file(u.builtinExtensionsPath),R.URI.file(u.extensionsPath),u.userHome,$.defaultProfile,$,v,a,h,u,p,w,I)}};e.$P3b=b=we([Y(0,E.$nk),Y(1,L.$8o),Y(2,O.$Oj),Y(3,k.$Ni),Y(4,M.$th),Y(5,m.$6i),Y(6,S.$lk),Y(7,C.$kh)],b)}),define(ae[19],ce([0,1,6,3,2,100,10,66,4,17]),function(ne,e,R,M,L,j,O,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Go=e.$Fo=e.$Eo=void 0,e.$Eo="__$__isNewStorageMarker",e.$Fo="__$__targetStorageMarker",e.$Go=(0,k.$lh)("storageService");var S;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var E;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var b;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function f(u){const p=u.get(e.$Fo);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}e.$Ho=f;class $ extends L.$kb{constructor(p={flushInterval:$.a}){super(),this.j=p,this.b=this.B(new M.$8c),this.onDidChangeValue=this.b.event,this.c=this.B(new M.$8c),this.onDidChangeTarget=this.c.event,this.f=this.B(new M.$5c),this.onWillSaveState=this.f.event,this.h=this.B(new R.$Cg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new L.$lb),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,R.$Gg)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,L.$fb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.J()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(p,w){const{key:I,external:n}=w;if(I===e.$Fo){switch(p){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:I,target:this.F(p)[I],external:n})}r(p){this.f.fire({reason:p})}get(p,w,I){return this.L(w)?.get(p,I)}getBoolean(p,w,I){return this.L(w)?.getBoolean(p,I)}getNumber(p,w,I){return this.L(w)?.getNumber(p,I)}getObject(p,w,I){return this.L(w)?.getObject(p,I)}storeAll(p,w){this.t(()=>{for(const I of p)this.store(I.key,I.value,I.scope,I.target,w)})}store(p,w,I,n,r=!1){if((0,O.$pe)(w)){this.remove(p,I,r);return}this.t(()=>{this.u(p,I,n),this.L(I)?.set(p,w,r)})}remove(p,w,I=!1){this.t(()=>{this.u(p,w,void 0),this.L(w)?.delete(p,I)})}t(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,w){const I=[],n=this.F(p);for(const r of Object.keys(n))n[r]===w&&I.push(r);return I}u(p,w,I,n=!1){const r=this.F(w);typeof I=="number"?r[p]!==I&&(r[p]=I,this.L(w)?.set(e.$Fo,JSON.stringify(r),n)):typeof r[p]=="number"&&(delete r[p],this.L(w)?.set(e.$Fo,JSON.stringify(r),n))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(p){switch(p){case-1:return this.D;case 0:return this.z;default:return this.w}}G(p){const w=this.L(p);return w?f(w):Object.create(null)}isNew(p){return this.getBoolean(e.$Eo,p)===!0}async flush(p=S.NONE){this.f.fire({reason:p});const w=this.L(-1),I=this.L(0),n=this.L(1);switch(p){case S.NONE:await R.Promises.settled([w?.whenFlushed()??Promise.resolve(),I?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await R.Promises.settled([w?.flush(0)??Promise.resolve(),I?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.L(-1)?.items??new Map,w=this.L(0)?.items??new Map,I=this.L(1)?.items??new Map;return h(p,w,I,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(p,w){return this.r(S.NONE),(0,m.$mk)(p)?this.N(p,w):this.O(p,w)}H(p,w){return!(p.id===w.id||v(w)&&v(p))}I(p,w,I){this.t(()=>{const n=new Set;for(const[r,i]of p)n.add(r),w.get(r)!==i&&this.n(I,{key:r,external:!0});for(const[r]of w.items)n.has(r)||this.n(I,{key:r,external:!0})})}}e.$Io=$,$.a=60*1e3;function v(u){return u.isDefault||!!u.useDefaultFlags?.uiState}e.$Jo=v;class a extends ${constructor(){super(),this.p=this.B(new C.$Co(new C.$Do,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new C.$Co(new C.$Do,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new C.$Co(new C.$Do,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(p=>this.n(1,p))),this.B(this.P.onDidChangeStorage(p=>this.n(0,p))),this.B(this.p.onDidChangeStorage(p=>this.n(-1,p)))}L(p){switch(p){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(p){return!1}}e.$Ko=a;async function h(u,p,w,I,n,r){const i=D=>{try{return JSON.parse(D)}catch{return D}},t=new Map,s=new Map;u.forEach((D,T)=>{t.set(T,D),s.set(T,i(D))});const o=new Map,c=new Map;p.forEach((D,T)=>{o.set(T,D),c.set(T,i(D))});const y=new Map,d=new Map;w.forEach((D,T)=>{y.set(T,D),d.set(T,i(D))}),console.group(I!==n?`Storage: Application (path: ${I})`:`Storage: Application & Profile (path: ${I}, default profile)`);const l=[];if(t.forEach((D,T)=>{l.push({key:T,value:D})}),console.table(l),console.groupEnd(),console.log(s),I!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const D=[];o.forEach((T,F)=>{D.push({key:F,value:T})}),console.table(D),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${r})`);const P=[];y.forEach((D,T)=>{P.push({key:T,value:D})}),console.table(P),console.groupEnd(),console.log(d)}e.$Lo=h}),define(ae[113],ce([0,1,3,2,10,28,33,19]),function(ne,e,R,M,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xwb=e.$wwb=void 0;let k=e.$wwb=class extends M.$kb{constructor(E,b){super(),this.a=new R.$5c,this.onDidChangeEnablement=this.a.event,this.b=this.B(new m(E)),this.B(this.b.onDidChange(f=>this.a.fire({extensions:f,source:"storage"}))),this.B(b.onDidInstallExtensions(f=>f.forEach(({local:$,operation:v})=>{$&&v===4&&this.f($.identifier)})))}async enableExtension(E,b){return this.f(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}async disableExtension(E,b){return this.c(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}getDisabledExtensions(){return this.h(j.$On)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const b=this.getDisabledExtensions();return b.every(f=>!(0,O.$bo)(f,E))?(b.push(E),this.g(b),!0):!1}f(E){const b=this.getDisabledExtensions();for(let f=0;f<b.length;f++){const $=b[f];if((0,O.$bo)($,E))return b.splice(f,1),this.g(b),!0}return!1}g(E){this.i(j.$On,E)}h(E){return this.b.get(E,0)}i(E,b){this.b.set(E,b,0)}};e.$wwb=k=we([Y(0,C.$Go),Y(1,j.$Nn)],k);class m extends M.$kb{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new R.$5c),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(b=>this.f(b)))}get(E,b){let f;return b===0?((0,L.$pe)(this.a[E])&&(this.a[E]=this.g(E,b)),f=this.a[E]):f=this.g(E,b),JSON.parse(f)}set(E,b,f){const $=JSON.stringify(b.map(({id:a,uuid:h})=>({id:a,uuid:h})));this.g(E,f)!==$&&(f===0&&(b.length?this.a[E]=$:delete this.a[E]),this.h(E,b.length?$:void 0,f))}f(E){if(E.scope===0&&!(0,L.$pe)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const f=this.get(E.key,E.scope);delete this.a[E.key];const $=this.get(E.key,E.scope),v=f.filter(h=>!$.some(u=>(0,O.$bo)(h,u))),a=$.filter(h=>!f.some(u=>(0,O.$bo)(u,h)));(v.length||a.length)&&this.b.fire([...v,...a])}}g(E,b){return this.c.get(E,b,"[]")}h(E,b,f){b?this.c.store(E,b,f,1):this.c.remove(E,f)}}e.$xwb=m}),define(ae[240],ce([0,1,21,26,7,5,37,10,12,18,14,28,33,67,13,8,24,56,217,19,20]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=void 0;const I=j.$o?"web":(0,E.$Gn)(j.$t,O.$6b),n="X-Market-Search-Activity-Id";var r;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function i(...N){return String(N.reduce((g,A)=>g|A,0))}var t;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class d{constructor(g=y){this.d=g}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(g,A=this.d.pageSize){return new d({...this.d,pageNumber:g,pageSize:A})}withFilter(g,...A){const U=[...this.d.criteria,...A.length?A.map(Q=>({filterType:g,value:Q})):[{filterType:g}]];return new d({...this.d,criteria:U})}withSortBy(g){return new d({...this.d,sortBy:g})}withSortOrder(g){return new d({...this.d,sortOrder:g})}withFlags(...g){return new d({...this.d,flags:g.reduce((A,U)=>A|U,0)})}withAssetTypes(...g){return new d({...this.d,assetTypes:g})}withSource(g){return new d({...this.d,source:g})}get raw(){const{criteria:g,pageNumber:A,pageSize:U,sortBy:Q,sortOrder:z,flags:J,assetTypes:te}=this.d;return{filters:[{criteria:g,pageNumber:A,pageSize:U,sortBy:Q,sortOrder:z}],assetTypes:te,flags:J}}get searchText(){const g=this.d.criteria.filter(A=>A.filterType===t.SearchText)[0];return g&&g.value?g.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(g=>String(g.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function l(N,g){const A=(N||[]).filter(U=>U.statisticName===g)[0];return A?A.value:0}function P(N){const g="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(U=>U.assetType.indexOf(g)===0).reduce((U,Q)=>{const z=F(N,Q.assetType);return z&&U.push([Q.assetType.substring(g.length),z]),U},[])}function D(N){if(N.properties){const g=N.properties.filter(Q=>Q.key===s.Repository),A=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=g.filter(Q=>A.test(Q.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return F(N,s.Repository)}function T(N){return{uri:`${N.fallbackAssetUri}/${s.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${s.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function F(N,g){return N.files.filter(U=>U.assetType===g)[0]?{uri:`${N.assetUri}/${g}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${g}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function H(N,g){const A=N.properties?N.properties.filter(Q=>Q.key===g):[],U=A.length>0&&A[0].value;return U?U.split(",").map(Q=>(0,b.$fo)(Q)):[]}function V(N){const g=N.properties?N.properties.filter(A=>A.key===o.Engine):[];return g.length>0&&g[0].value||""}function W(N){const g=N.properties?N.properties.filter(A=>A.key===o.PreRelease):[];return g.length>0&&g[0].value==="true"}function x(N){const g=N.properties?N.properties.filter(U=>U.key===o.LocalizedLanguages):[],A=g.length>0&&g[0].value||"";return A?A.split(","):[]}function ee(N){return N.properties?.find(g=>g.key===o.SponsorLink)?.value}function X(N){return N.indexOf("preview")!==-1}function _(N){return N.targetPlatform?(0,E.$Fn)(N.targetPlatform):"undefined"}function q(N){const g=(0,R.$of)(N.versions.map(_)),A=!!N.tags?.includes(E.$Bn),U=g.indexOf("web");return A?U===-1&&g.push("web"):U!==-1&&g.splice(U,1),g}function G(N,g){const A=(0,E.$Jn)(g);for(let U=0;U<N.length;U++){const Q=N[U];if(Q.version===N[U-1]?.version){let z=U;const J=_(Q);if(J===g)for(;z>0&&N[z-1].version===Q.version;)z--;else if(A.includes(J))for(;z>0&&N[z-1].version===Q.version&&_(N[z-1])!==g;)z--;z!==U&&(N.splice(U,1),N.splice(z,0,Q))}}return N}e.$Oo=G;function B(N,g,A){N.telemetryData={index:g,querySource:A,queryActivityId:N.queryContext?.[n]}}function ie(N,g,A,U){const Q=N.versions[0],z={manifest:F(g,s.Manifest),readme:F(g,s.Details),changelog:F(g,s.Changelog),license:F(g,s.License),repository:D(g),download:T(g),icon:F(g,s.Icon),signature:F(g,s.Signature),coreTranslations:P(g)};return{identifier:{id:(0,b.$go)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:g.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:ee(Q),description:N.shortDescription||"",installCount:l(N.statistics,"install"),rating:l(N.statistics,"averagerating"),ratingCount:l(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:A,assets:z,properties:{dependencies:H(g,o.Dependency),extensionPack:H(g,o.ExtensionPack),engine:V(g),localizedLanguages:x(g),targetPlatform:_(g),isPreReleaseVersion:W(g)},hasPreReleaseVersion:W(Q),hasReleaseVersion:!0,preview:X(N.flags),isSigned:!!z.signature,queryContext:U}}let re=class{constructor(g,A,U,Q,z,J,te,oe){this.k=A,this.l=U,this.n=Q,this.o=z,this.q=J,this.u=te,this.w=oe;const he=te.extensionsGallery,fe=he?.servicePPEUrl&&oe.getValue("_extensionsGallery.enablePPE");this.d=fe?he.servicePPEUrl:he?.serviceUrl,this.g=fe?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,u.$No)(te.version,te,this.n,this.w,this.q,g,this.o)}x(g=""){return`${this.d}${g}`}isEnabled(){return!!this.d}async getExtensions(g,A,U){const Q=M.CancellationToken.isCancellationToken(A)?{}:A,z=M.CancellationToken.isCancellationToken(A)?A:U,J=[],te=[],oe=[],he=[];let fe=!0;for(const Ee of g){Ee.uuid?te.push(Ee.uuid):J.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);oe.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&he.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),fe=fe&&!!Ee.hasPreRelease&&!Ce}if(!te.length&&!J.length)return[];let be=new d().withPage(1,g.length);te.length&&(be=be.withFilter(t.ExtensionId,...te)),J.length&&(be=be.withFilter(t.ExtensionName,...J)),(Q.queryAllVersions||fe)&&(be=be.withFlags(be.flags,r.IncludeVersions)),Q.source&&(be=be.withSource(Q.source));const{extensions:pe}=await this.z(be,{targetPlatform:Q.targetPlatform??I,includePreRelease:oe,versions:he,compatible:!!Q.compatible},z);return Q.source&&pe.forEach((Ee,Ce)=>B(Ee,Ce,Q.source)),pe}async getCompatibleExtension(g,A,U){if((0,E.$Hn)(g.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(g,A,U))return g;const Q=new d().withFlags(r.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,g.identifier.uuid),{extensions:z}=await this.z(Q,{targetPlatform:U,compatible:!0,includePreRelease:A},M.CancellationToken.None);return z[0]||null}async isExtensionCompatible(g,A,U){if(!(0,E.$In)(g.properties.targetPlatform,g.allTargetPlatforms,U)||!A&&g.properties.isPreReleaseVersion)return!1;let Q=g.properties.engine;if(!Q){const z=await this.getManifest(g,M.CancellationToken.None);if(!z)throw new Error("Manifest was not found");Q=z.engines.vscode}return(0,f.$to)(Q,this.u.version,this.u.date)}async y(g,A,U,Q,z){if(!(0,E.$In)(_(g),Q,z)||A!=="any"&&W(g)!==(A==="prerelease"))return!1;if(U)try{const J=await this.E(g);if(!(0,f.$to)(J,this.u.version,this.u.date))return!1}catch(J){return this.l.error(`Error while getting the engine for the version ${g.version}.`,(0,L.$8)(J)),!1}return!0}async query(g,A){let U=g.text||"";const Q=g.pageSize??50;let z=new d().withPage(1,Q);U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,be,pe)=>(z=z.withFilter(t.Category,pe||be),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,be,pe)=>(z=z.withFilter(t.Tag,pe||be),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(z=z.withFilter(t.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),z=z.withFilter(t.SearchText,U)),z=z.withSortBy(0)):g.ids?z=z.withFilter(t.ExtensionId,...g.ids):g.names?z=z.withFilter(t.ExtensionName,...g.names):z=z.withSortBy(4),typeof g.sortBy=="number"&&(z=z.withSortBy(g.sortBy)),typeof g.sortOrder=="number"&&(z=z.withSortOrder(g.sortOrder)),g.source&&(z=z.withSource(g.source));const J=async(fe,be)=>{const{extensions:pe,total:Ee}=await this.z(fe,{targetPlatform:I,compatible:!1,includePreRelease:!!g.includePreRelease},be);return pe.forEach((Ce,Le)=>B(Ce,(fe.pageNumber-1)*fe.pageSize+Le,g.source)),{extensions:pe,total:Ee}},{extensions:te,total:oe}=await J(z,A),he=async(fe,be)=>{if(be.isCancellationRequested)throw new L.$2;const{extensions:pe}=await J(z.withPage(fe+1),be);return pe};return{firstPage:te,total:oe,pageSize:z.pageSize,getPage:he}}async z(g,A,U){const Q=g.flags;g.flags&r.IncludeLatestVersionOnly&&g.flags&r.IncludeVersions&&(g=g.withFlags(g.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(g.flags&r.IncludeLatestVersionOnly)&&!(g.flags&r.IncludeVersions)&&(g=g.withFlags(g.flags,r.IncludeLatestVersionOnly)),A.versions?.length&&(g=g.withFlags(g.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),g=g.withFlags(g.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:z,total:J,context:te}=await this.B(g,U);if(!(g.flags&r.IncludeLatestVersionOnly)){const be=[];for(const pe of z){const Ee=await this.A(pe,A,te);Ee&&be.push(Ee)}return{extensions:be,total:J}}const he=[],fe=new Map;for(let be=0;be<z.length;be++){const pe=z[be],Ee={id:(0,b.$go)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Ce=(0,C.$me)(A.includePreRelease)?A.includePreRelease:!!A.includePreRelease.find(Ue=>(0,b.$bo)(Ue,Ee))?.includePreRelease;if(A.compatible&&(0,E.$Hn)(q(pe),A.targetPlatform))continue;const Le=await this.A(pe,A,te);!Le||Le.properties.isPreReleaseVersion&&(!Ce||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==A.targetPlatform&&Le.hasPreReleaseVersion?fe.set(pe.extensionId,be):he.push([be,Le])}if(fe.size){const be=new Date().getTime(),pe=new d().withFlags(Q&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,fe.size).withFilter(t.ExtensionId,...fe.keys()),{extensions:Ee}=await this.z(pe,A,U);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-be,count:fe.size});for(const Ce of Ee){const Le=fe.get(Ce.identifier.uuid);he.push([Le,Ce])}}return{extensions:he.sort((be,pe)=>be[0]-pe[0]).map(([,be])=>be),total:J}}async A(g,A,U){const Q={id:(0,b.$go)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},z=A.versions?.find(he=>(0,b.$bo)(he,Q))?.version,J=(0,C.$me)(A.includePreRelease)?A.includePreRelease:!!A.includePreRelease.find(he=>(0,b.$bo)(he,Q))?.includePreRelease,te=q(g),oe=G(g.versions,A.targetPlatform);if(A.compatible&&(0,E.$Hn)(te,A.targetPlatform))return null;for(let he=0;he<oe.length;he++){const fe=oe[he];if(!(z&&fe.version!==z)){if(await this.y(fe,J?"any":"release",A.compatible,te,A.targetPlatform))return ie(g,fe,te,U);if(z&&fe.version===z)return null}}return z||A.compatible?null:ie(g,g.versions[0],te)}async B(g,A){if(!this.isEnabled())throw new Error("No extension gallery service configured.");g=g.withFlags(g.flags,r.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(r.Unpublished));const U=await this.j,Q=JSON.stringify(g.raw),z={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},J=new Date().getTime();let te,oe,he=0;try{if(te=await this.k.request({type:"POST",url:this.g&&g.criteria.some(be=>be.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:Q,headers:z},A),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:he};const fe=await(0,h.$zo)(te);if(fe){const be=fe.results[0],pe=be.extensions,Ee=be.resultMetadata&&be.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return he=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:he,context:{[n]:te.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(fe){throw oe=fe,fe}finally{this.o.publicLog2("galleryService:query",{...g.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-J,success:!!te&&(0,h.$wo)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:oe?(0,L.$1)(oe)?"canceled":(0,L.$8)(oe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(g,A,U,Q){if(!this.isEnabled())return;const z=j.$o?this.x(`/itemName/${g}.${A}/version/${U}/statType/${Q==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${g}/extensions/${A}/${U}/stats?statType=${Q}`),J=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",oe={...await this.j,Accept:J};try{await this.k.request({type:"POST",url:z,headers:oe},M.CancellationToken.None)}catch{}}async download(g,A,U){this.l.trace("ExtensionGalleryService#download",g.identifier.id);const Q=(0,b.$jo)(g),z=new Date().getTime(),J=be=>this.o.publicLog("galleryService:downloadVSIX",{...Q,duration:be}),te=U===2?"install":U===3?"update":"",oe=te?{uri:`${g.assets.download.uri}${k.URI.parse(g.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${g.assets.download.fallbackUri}${k.URI.parse(g.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:g.assets.download,he=g.queryContext?.[n]?{[n]:g.queryContext[n]}:void 0,fe=await this.D(oe,he?{headers:he}:void 0);await this.q.writeFile(A,fe.stream),J(new Date().getTime()-z)}async downloadSignatureArchive(g,A){if(!g.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",g.identifier.id);const U=await this.D(g.assets.signature);await this.q.writeFile(A,U.stream)}async getReadme(g,A){if(g.assets.readme){const U=await this.D(g.assets.readme,{},A);return await(0,h.$yo)(U)||""}return""}async getManifest(g,A){if(g.assets.manifest){const U=await this.D(g.assets.manifest,{},A),Q=await(0,h.$yo)(U);return Q?JSON.parse(Q):null}return null}async C(g,A){const U=F(g,s.Manifest);if(!U)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},z=await this.D(U,{headers:Q});return await(0,h.$zo)(z)}async getCoreTranslation(g,A){const U=g.assets.coreTranslations.filter(Q=>Q[0]===A.toUpperCase())[0];if(U){const Q=await this.D(U[1]),z=await(0,h.$yo)(Q);return z?JSON.parse(z):null}return null}async getChangelog(g,A){if(g.assets.changelog){const U=await this.D(g.assets.changelog,{},A);return await(0,h.$yo)(U)||""}return""}async getAllCompatibleVersions(g,A,U){let Q=new d().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);g.identifier.uuid?Q=Q.withFilter(t.ExtensionId,g.identifier.uuid):Q=Q.withFilter(t.ExtensionName,g.identifier.id);const{galleryExtensions:z}=await this.B(Q,M.CancellationToken.None);if(!z.length)return[];const J=q(z[0]);if((0,E.$Hn)(J,U))return[];const te=[];await Promise.all(z[0].versions.map(async fe=>{try{await this.y(fe,A?"any":"release",!0,J,U)&&te.push(fe)}catch{}}));const oe=[],he=new Set;for(const fe of G(te,U))he.has(fe.version)||(he.add(fe.version),oe.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:W(fe)}));return oe}async D(g,A={},U=M.CancellationToken.None){const Q=await this.j,z={type:"GET"},J={...Q,...A.headers||{}};A={...A,...z,headers:J};const te=g.uri,oe=g.fallbackUri,he={...A,url:te};try{const fe=await this.k.request(he,U);if(fe.res.statusCode===200)return fe;const be=await(0,h.$yo)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${be}`)}catch(fe){if((0,L.$1)(fe))throw fe;const be=(0,L.$8)(fe);this.o.publicLog2("galleryService:cdnFallback",{url:te,message:be});const pe={...A,url:oe};return this.k.request(pe,U)}}async E(g){let A=V(g);if(!A){const U=await this.C(g,M.CancellationToken.None);if(!U)throw new Error("Manifest was not found");A=U.engines.vscode}return A}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const g=await this.k.request({type:"GET",url:this.h},M.CancellationToken.None);if(g.res.statusCode!==200)throw new Error("Could not get extensions report.");const A=await(0,h.$zo)(g),U=[],Q={},z=[];if(A){for(const J of A.malicious)U.push({id:J});if(A.migrateToPreRelease)for(const[J,te]of Object.entries(A.migrateToPreRelease))(!te.engine||(0,f.$to)(te.engine,this.u.version,this.u.date))&&(Q[J.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(A.deprecated)for(const[J,te]of Object.entries(A.deprecated))te&&(Q[J.toLowerCase()]=(0,C.$me)(te)?{}:te);if(A.search)for(const J of A.search)z.push(J)}return{malicious:U,deprecated:Q,search:z}}};re=we([Y(1,h.$uo),Y(2,v.$Ni),Y(3,S.$sh),Y(4,w.$Rk),Y(5,$.$Oj),Y(6,a.$6i),Y(7,m.$Rh)],re);let K=e.$Po=class extends re{constructor(g,A,U,Q,z,J,te,oe){super(g,A,U,Q,z,J,te,oe)}};e.$Po=K=we([Y(0,p.$Go),Y(1,h.$uo),Y(2,v.$Ni),Y(3,S.$sh),Y(4,w.$Rk),Y(5,$.$Oj),Y(6,a.$6i),Y(7,m.$Rh)],K);let Z=e.$Qo=class extends re{constructor(g,A,U,Q,z,J,te){super(void 0,g,A,U,Q,z,J,te)}};e.$Qo=Z=we([Y(0,h.$uo),Y(1,v.$Ni),Y(2,S.$sh),Y(3,w.$Rk),Y(4,$.$Oj),Y(5,a.$6i),Y(6,m.$Rh)],Z)}),define(ae[79],ce([0,1,4,3,2,19,33,24,21,8,10]),function(ne,e,R,M,L,j,O,C,k,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jz=e.$iz=void 0,e.$iz=(0,R.$lh)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let b=e.$jz=class Qe extends L.$kb{static b($){return`extensionKeys/${(0,O.$fo)($.id)}@${$.version}`}static c($){const v=E.exec($);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions($,v){const a=await $.getInstalled(),h=[];for(const[u,p]of Qe.f(v)){const w=a.find(I=>(0,O.$bo)(I.identifier,{id:u}))?.manifest.version;for(const I of p)w!==I&&h.push(Qe.b({id:u,version:I}))}for(const u of h)v.remove(u,0)}static f($){const v=new Map,a=$.keys(0,1);for(const h of a){const u=Qe.c(h);if(u){let p=v.get(u.id.toLowerCase());p||v.set(u.id.toLowerCase(),p=[]),p.push(u.version)}}return v}constructor($,v,a){super(),this.i=$,this.j=v,this.k=a,this.g=this.B(new M.$5c),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Qe.f($),this.B(this.i.onDidChangeValue(h=>this.l(h)))}l($){if($.scope!==0)return;if(this.h.has($.key.toLowerCase())){this.g.fire();return}const v=Qe.c($.key);if(v){if(this.i.get($.key,0)===void 0)this.h.delete(v.id.toLowerCase());else{let a=this.h.get(v.id.toLowerCase());a||this.h.set(v.id.toLowerCase(),a=[]),a.push(v.version),this.g.fire()}return}}m($){if((0,S.$ge)($))return $;const v=$.manifest?$.manifest.publisher:$.publisher,a=$.manifest?$.manifest.name:$.name;return(0,O.$eo)(v,a)}getExtensionState($,v){const a=this.m($),h=this.getExtensionStateRaw($,v);if(h)try{return JSON.parse(h)}catch(u){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${a}, global: ${v}): ${u}`)}}getExtensionStateRaw($,v){const a=this.m($),h=this.i.get(a,v?0:1);return h&&h?.length>Qe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${a}, global: ${v}): ${h.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),h}setExtensionState($,v,a){const h=this.m($);v===void 0?this.i.remove(h,a?0:1):this.i.store(h,JSON.stringify(v),a?0:1,1)}setKeysForSync($,v){this.i.store(Qe.b($),JSON.stringify(v),0,1)}getKeysForSync($){const v=this.j.extensionSyncedKeys?.[$.id.toLowerCase()],a=this.i.get(Qe.b($),0),h=a?JSON.parse(a):void 0;return h&&v?(0,k.$of)([...h,...v]):h||v}addToMigrationList($,v){if($!==v){const a=this.n.filter(h=>!h.includes($)&&!h.includes(v));a.push([$,v]),this.n=a}}getSourceExtensionToMigrate($){const v=this.n.find(([,a])=>$===a);return v?v[0]:void 0}get n(){const $=this.i.get("extensionStorage.migrationList",-1,"[]");try{const v=JSON.parse($);if(Array.isArray(v))return v}catch{}return[]}set n($){$.length?this.i.store("extensionStorage.migrationList",JSON.stringify($),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};b.a=512*1024,e.$jz=b=we([Y(0,j.$Go),Y(1,C.$6i),Y(2,m.$Ni)],b)}),define(ae[241],ce([0,1,28,13,24,14,98,54,19,20,214]),function(ne,e,R,M,L,j,O,C,k,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$04b=void 0;let E=e.$04b=class extends S.$v1b{constructor(f,$,v,a,h,u,p,w){super(f.userHome,h,$,v,a,u,p,w)}};e.$04b=E=we([Y(0,j.$th),Y(1,m.$Rk),Y(2,R.$Nn),Y(3,k.$Go),Y(4,C.$R2b),Y(5,O.$MRb),Y(6,M.$Oj),Y(7,L.$6i)],E)}),define(ae[242],ce([0,1,105,3,20,14,2,8,15,65,24,5,6,101,18,158,36,19,10]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$64b=void 0;const p=[R.$Y4b,R.$Z4b],w="remoteTunnelSession";let I=e.$64b=class extends O.$kb{constructor(i,t,s,o,c,y,d){super(),this.s=i,this.t=t,this.u=s,this.v=y,this.w=d,this.b=new M.$5c,this.onDidTokenFailed=this.b.event,this.f=new M.$5c,this.onDidChangeTunnelStatus=this.f.event,this.g=new M.$5c,this.onDidChangeSession=this.g.event,this.r=!1,this.h=this.B(o.createLogger(R.$14b,{name:R.$24b})),this.n=new b.$og(100),this.B(this.h.onDidChangeLogLevel(l=>this.h.info("Log level changed to "+(0,C.$3i)(l)))),this.B(c.onWillShutdown(()=>{this.j?.cancel(),this.j=void 0,this.dispose()})),this.B(y.onDidChangeConfiguration(l=>{p.some(P=>l.affectsConfiguration(P))&&this.n.trigger(()=>this.D())})),this.i=this.I(),this.k=R.TunnelStates.uninitialized}async getTunnelStatus(){return this.k}y(i){this.k=i,this.f.fire(i)}z(i){n(i,this.i)||(this.i=i,this.g.fire(i),this.J(i),i?(this.h.info(`Session updated: ${i.accountLabel} (${i.providerId})`),i.token&&this.h.info(`Session token updated: ${i.accountLabel} (${i.providerId})`)):this.h.info("Session reset"))}async getSession(){return this.i}async initialize(i){if(this.r)return this.k;this.r=!0,this.z(i);try{await this.n.trigger(()=>this.D())}catch(t){this.h.error(t)}return this.k}C(){if(!this.p){let i;E.$j?i=this.u.appRoot:i=(0,k.$bc)((0,k.$bc)(this.u.appRoot)),this.p=(0,k.$$b)(i,"bin",`${this.t.tunnelApplicationName}${E.$i?".exe":""}`)}return this.p}async startTunnel(i){if(n(i,this.i)&&this.k.type!=="disconnected")return this.k;this.z(i);try{await this.n.trigger(()=>this.D())}catch(t){this.h.error(t)}return this.k}async stopTunnel(){this.z(void 0),this.j&&(this.j.cancel(),this.j=void 0);const i=(t,s)=>{s?this.h.error(t):this.h.info(t)};try{await this.F("stop",["kill"],i)}catch(t){this.h.error(t)}this.y(R.TunnelStates.disconnected())}async D(){this.s.publicLog2("remoteTunnel.enablement",{enabled:!!this.i}),this.j&&(this.j.cancel(),this.j=void 0);let i=!1,t="";const s=(P,D)=>{D?this.h.error(P):t+=P,!this.u.isBuilt&&P.startsWith("   Compiling")&&this.y(R.TunnelStates.connecting((0,v.localize)(0,null)))},o=this.F("status",["status"],s);this.j=o;try{if(await o,this.j!==o)return;if(i=!!JSON.parse(t.trim().split(`
`).find(D=>D.startsWith("{"))).tunnel,this.h.info(i?"Other tunnel running, attaching...":"No other tunnel running"),!i&&!this.i){this.j=void 0,this.y(R.TunnelStates.disconnected());return}}catch(P){this.h.error(P),this.j=void 0,this.y(R.TunnelStates.disconnected());return}const c=this.i;if(c&&c.token){const P=c.token;this.y(R.TunnelStates.connecting((0,v.localize)(1,null,c.accountLabel,c.providerId)));const D=(F,H)=>{F=F.replaceAll(P,"*".repeat(4)),s(F,H)},T=this.F("login",["user","login","--provider",c.providerId,"--access-token",P,"--log",(0,C.$3i)(this.h.getLevel())],D);this.j=T;try{if(await T,this.j!==T)return}catch(F){this.h.error(F),this.j=void 0,this.b.fire(c),this.y(R.TunnelStates.disconnected(c));return}}const y=this.H();y?this.y(R.TunnelStates.connecting((0,v.localize)(2,null,y))):this.y(R.TunnelStates.connecting((0,v.localize)(3,null)));const d=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,C.$3i)(this.h.getLevel())];y?d.push("--name",y):d.push("--random-name"),this.G()&&d.push("--no-sleep");const l=this.F("tunnel",d,(P,D)=>{D?this.h.error(P):this.h.info(P);const T=P.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(T){const F={link:T[1],domain:T[2],tunnelName:T[4],isAttached:i};this.y(R.TunnelStates.connected(F))}else P.match(/error refreshing token/)&&(l.cancel(),this.b.fire(c),this.y(R.TunnelStates.disconnected(c)))});this.j=l,l.finally(()=>{l===this.j&&(this.h.info("tunnel process terminated"),this.j=void 0,this.i=void 0,this.y(R.TunnelStates.disconnected()))})}F(i,t,s=()=>{}){return(0,b.$fg)(o=>new Promise((c,y)=>{o.isCancellationRequested&&c(-1);let d;const l=["ignore","pipe","pipe"];if(o.onCancellationRequested(()=>{d&&(this.h.info(`${i} terminating(${d.pid})`),d.kill())}),!this.u.isBuilt)s(`Building tunnel CLI from sources and run
`,!1),s(`${i} Spawning: cargo run -- tunnel ${t.join(" ")}
`,!1),d=(0,m.spawn)("cargo",["run","--","tunnel",...t],{cwd:(0,k.$$b)(this.u.appRoot,"cli"),stdio:l});else{s(`Running tunnel CLI
`,!1);const P=this.C();s(`${i} Spawning: ${P} tunnel ${t.join(" ")}
`,!1),d=(0,m.spawn)(P,["tunnel",...t],{cwd:(0,a.homedir)(),stdio:l})}d.stdout.on("data",P=>{if(d){const D=P.toString();s(D,!1)}}),d.stderr.on("data",P=>{if(d){const D=P.toString();s(D,!0)}}),d.on("exit",P=>{d&&(s(`${i} exit(${d.pid}): + ${P} `,!1),d=void 0,c(P||0))}),d.on("error",P=>{d&&(s(`${i} error(${d.pid}): + ${P} `,!0),d=void 0,y())})}))}async getTunnelName(){return this.H()}G(){return!!this.v.getValue(R.$Z4b)}H(){let i=this.v.getValue(R.$Y4b)||(0,a.hostname)();return i=i.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),i||void 0}I(){try{const i=this.w.get(w,-1);if(i){const t=JSON.parse(i);if(t&&(0,u.$ge)(t.accountLabel)&&(0,u.$ge)(t.sessionId)&&(0,u.$ge)(t.providerId))return t;this.h.error("Problems restoring session from storage, invalid format",t)}}catch(i){this.h.error("Problems restoring session from storage",i)}}J(i){if(i){const t={providerId:i.providerId,sessionId:i.sessionId,accountLabel:i.accountLabel};this.w.store(w,JSON.stringify(t),-1,1)}else this.w.remove(w,-1)}};e.$64b=I=we([Y(0,L.$Rk),Y(1,S.$6i),Y(2,j.$th),Y(3,C.$Oi),Y(4,f.$44b),Y(5,$.$Rh),Y(6,h.$Go)],I);function n(r,i){return r&&i?r.sessionId===i.sessionId&&r.providerId===i.providerId&&r.token===i.token:r===i}}),define(ae[243],ce([0,1,6,2,22,66,19,75,17]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$4b=void 0;class m extends O.$Io{constructor(E,b,f,$){super(),this.X=E,this.Y=b,this.Z=f,this.$=$,this.p=this.Y.defaultProfile,this.s=this.ab(),this.P=this.Y.currentProfile,this.Q=this.B(new M.$jb),this.R=this.bb(this.P),this.S=this.X?.id,this.U=this.B(new M.$jb),this.W=this.cb(this.X)}ab(){const E=this.B(new C.$7wb(this.Z.getChannel("storage"))),b=this.B(new j.$Co(E));return this.B(b.onDidChangeStorage(f=>this.n(-1,f))),b}bb(E){this.Q.clear(),this.P=E;let b;if((0,O.$Jo)(E))b=this.s;else{const f=this.Q.add(new C.$8wb(this.Z.getChannel("storage"),E));b=this.Q.add(new j.$Co(f))}return this.Q.add(b.onDidChangeStorage(f=>this.n(0,f))),b}cb(E){this.U.clear(),this.S=E?.id;let b;if(E){const f=this.U.add(new C.$9wb(this.Z.getChannel("storage"),E));b=this.U.add(new j.$Co(f)),this.U.add(b.onDidChangeStorage($=>this.n(1,$)))}return b}async J(){await R.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(E){switch(E){case-1:return this.s;case 0:return this.R;default:return this.W}}M(E){switch(E){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,L.$6f)(this.$.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(O.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(E){if(!this.H(this.P,E))return;const b=this.R,f=b.items;b!==this.s&&await b.close(),this.R=this.bb(E),await this.R.init(),this.I(f,this.R,0)}async O(E,b){const f=this.W,$=f?.items??new Map;await f?.close(),this.W=this.cb(E),await this.W.init(),this.I($,this.W,1)}hasScope(E){return(0,k.$mk)(E)?this.P.id===E.id:this.S===E.id}}e.$$4b=m}),define(ae[244],ce([0,1,3,2,17,91]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=void 0;class O{constructor(m,S){this.a=m,this.b=S}listen(m,S){const E=this.b(m);switch(S){case"onDidChangeProfiles":return R.Event.map(this.a.onDidChangeProfiles,b=>({all:b.all.map(f=>(0,j.$lm)({...f},E)),added:b.added.map(f=>(0,j.$lm)({...f},E)),removed:b.removed.map(f=>(0,j.$lm)({...f},E)),updated:b.updated.map(f=>(0,j.$lm)({...f},E))}))}throw new Error(`Invalid listen ${S}`)}async call(m,S,E){const b=this.b(m);switch(S){case"createProfile":{const f=await this.a.createProfile(E[0],E[1],E[2]);return(0,j.$lm)({...f},b)}case"updateProfile":{let f=(0,L.$ok)((0,j.$mm)(E[0],b),this.a.profilesHome.scheme);return f=await this.a.updateProfile(f,E[1]),(0,j.$lm)({...f},b)}case"removeProfile":{const f=(0,L.$ok)((0,j.$mm)(E[0],b),this.a.profilesHome.scheme);return this.a.removeProfile(f)}}throw new Error(`Invalid call ${S}`)}}e.$CM=O;class C extends M.$kb{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(m,S,E){super(),this.profilesHome=S,this.f=E,this.a=[],this.b=this.B(new R.$5c),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=m.map(b=>(0,L.$ok)(b,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(b=>{const f=b.added.map(a=>(0,L.$ok)(a,this.profilesHome.scheme)),$=b.removed.map(a=>(0,L.$ok)(a,this.profilesHome.scheme)),v=b.updated.map(a=>(0,L.$ok)(a,this.profilesHome.scheme));this.a=b.all.map(a=>(0,L.$ok)(a,this.profilesHome.scheme)),this.b.fire({added:f,removed:$,updated:v,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(m){this.c=m}isEnabled(){return this.c}async createNamedProfile(m,S,E){const b=await this.f.call("createNamedProfile",[m,S,E]);return(0,L.$ok)(b,this.profilesHome.scheme)}async createProfile(m,S,E,b){const f=await this.f.call("createProfile",[m,S,E,b]);return(0,L.$ok)(f,this.profilesHome.scheme)}async createTransientProfile(m){const S=await this.f.call("createTransientProfile",[m]);return(0,L.$ok)(S,this.profilesHome.scheme)}async setProfileForWorkspace(m,S){await this.f.call("setProfileForWorkspace",[m,S])}removeProfile(m){return this.f.call("removeProfile",[m])}async updateProfile(m,S){const E=await this.f.call("updateProfile",[m,S]);return(0,L.$ok)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$DM=C}),define(ae[58],ce([0,1,2,66,4,19,3,75,17]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$axb=e.$_wb=e.$$wb=void 0,e.$$wb=(0,L.$lh)("IUserDataProfileStorageService");let m=e.$_wb=class extends R.$kb{constructor(f){super(),this.a=f}async readStorageData(f){return this.withProfileScopedStorageService(f,async $=>this.b($))}async updateStorageData(f,$,v){return this.withProfileScopedStorageService(f,async a=>this.c(a,$,v))}async withProfileScopedStorageService(f,$){if(this.a.hasScope(f))return $(this.a);const v=await this.g(f),a=new E(v);try{await a.initialize();const h=await $(a);return await a.flush(),h}finally{a.dispose(),await this.f(v)}}b(f){const $=new Map,v=a=>{for(const h of f.keys(0,a))$.set(h,{value:f.get(h,0),target:a})};return v(0),v(1),$}c(f,$,v){f.storeAll(Array.from($.entries()).map(([a,h])=>({key:a,value:h,scope:0,target:v})),!0)}async f(f){try{await f.close()}finally{(0,R.$eb)(f)&&f.dispose()}}};e.$_wb=m=we([Y(0,j.$Go)],m);class S extends m{constructor(f,$,v,a){super(v),this.i=f;const h=f.getChannel("profileStorageListener"),u=this.B(new R.$lb);this.h=this.B(new O.$5c({onWillAddFirstListener:()=>{u.value=h.listen("onDidChange")(p=>{a.trace("profile storage changes",p),this.h.fire({targetChanges:p.targetChanges.map(w=>(0,k.$ok)(w,$.profilesHome.scheme)),valueChanges:p.valueChanges.map(w=>({...w,profile:(0,k.$ok)(w.profile,$.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(f){const $=this.i.getChannel("storage");return(0,j.$Jo)(f)?new C.$7wb($):new C.$8wb($,f)}}e.$axb=S;class E extends j.$Io{constructor(f){super({flushInterval:100}),this.p=this.B(new M.$Co(f))}J(){return this.p.init()}L(f){return f===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(ae[245],ce([0,1,19,8,17,71,58]),function(ne,e,R,M,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P4b=void 0;let C=e.$P4b=class extends O.$axb{constructor(m,S,E,b){super(m,S,E,b)}};e.$P4b=C=we([Y(0,j.$a4b),Y(1,L.$nk),Y(2,R.$Go),Y(3,M.$Ni)],C)}),define(ae[39],ce([0,1,21,6,16,26,3,34,2,27,10,163,18,14,13,8,44,19,20,29,23,17]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u,p,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zxb=e.$Yxb=e.$Xxb=e.$Wxb=e.$Vxb=e.$Uxb=e.$Txb=void 0;function n(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||r(y.syncData)))}e.$Txb=n;function r(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}e.$Uxb=r;function i(y,d){return`${(0,m.$$d)(y)}${d.isDefault?"":` (${d.name})`}`}e.$Vxb=i;let t=e.$Wxb=class extends k.$kb{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(d,l,P,D,T,F,H,V,W,x,ee,X){super(),this.syncResource=d,this.collection=l,this.C=P,this.D=D,this.F=T,this.G=F,this.H=H,this.I=V,this.J=W,this.L=x,this.M=ee,this.c=null,this.k="idle",this.l=this.B(new O.$5c),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new O.$5c),this.onDidChangeConflicts=this.n.event,this.s=new M.$pg(50),this.t=this.B(new O.$5c),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=i(d.syncResource,d.profile),this.h=X.extUri,this.f=this.h.joinPath(D.userDataSyncHome,...(0,w.$sdb)(d.profile.isDefault?void 0:d.profile.id,d.syncResource)),this.g=this.h.joinPath(this.f,w.$Ndb),this.u=(0,w.$tdb)(d.profile.isDefault?void 0:d.profile.id,d.syncResource,D,this.h),this.j=(0,a.$Mo)(D,P,T)}N(){this.s.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const d=await this.c;this.c=null;const l=await this.U(d.remoteUserData,d.lastSyncUserData,!0,this.lb());this.P(l)}else{this.L.trace(`${this.y}: Checking for local changes...`);const d=await this.getLastSyncUserData();(d?await this.rb(d):!0)&&this.t.fire()}}P(d){this.k!==d&&(this.k=d,this.l.fire(d))}async sync(d,l={}){await this.Q(d,!0,this.lb(),l)}async preview(d,l,P={}){return this.Q(d,!1,l,P)}async apply(d,l={}){try{this.z={...l};const P=await this.Y(d);return this.P(P),this.c}finally{this.z={}}}async Q(d,l,P,D){try{if(this.z={...D},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let T="idle";try{const F=await this.getLastSyncUserData(),H=await this.S(d,F);return T=await this.U(H,F,l,P),T==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(T)}}finally{this.z={}}}async replace(d){const l=this.hb(d);if(!l)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const P=await this.getLastSyncUserData(),D=await this.S(null,P),T=await this.R(D),F=await this.nb({ref:D.ref,syncData:l},P,T,this.lb(),j.CancellationToken.None),H=[];for(const V of F){const W=await this.pb(V,V.remoteResource,void 0,j.CancellationToken.None),{remoteChange:x}=await this.pb(V,V.previewResource,V.remoteContent,j.CancellationToken.None);H.push([V,{...W,remoteChange:x!==0?x:2}])}await this.qb(D,P,H,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(d){const l=await this.j;return!!d.syncData?.machineId&&d.syncData.machineId===l}async S(d,l){if(l){const P=d?d[this.resource]:void 0;if(l.ref===P||P===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async U(d,l,P,D){if(d.syncData&&d.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new w.$Adb((0,E.localize)(0,null,this.resource,this.mb,d.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(d,l,P,D)}catch(T){if(T instanceof w.$Adb)switch(T.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.U(d,l,P,D);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),d=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.U(d,l,P,D)}throw T}}async W(d,l,P,D){try{const T=await this.R(d),F=!T&&l===null&&this.db()!==void 0,H=P&&!F;this.c||(this.c=(0,M.$fg)(W=>this.bb(d,l,T,H,D,W)));let V=await this.c;if(P&&F){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const W of V.resourcePreviews)V=await this.accept(W.remoteResource)||V}return this.$(V.resourcePreviews),V.resourcePreviews.some(({mergeState:W})=>W==="conflict")?"hasConflicts":P?await this.Y(!1):"syncing"}catch(T){throw this.c=null,T}}async merge(d){return await this.X(d,async l=>{const P=await this.ob(l,j.CancellationToken.None);await this.C.writeFile(l.previewResource,L.$Ib.fromString(P?.content||""));const D=P&&!P.hasConflicts?await this.pb(l,l.previewResource,void 0,j.CancellationToken.None):void 0;return l.acceptResult=D,l.mergeState=P.hasConflicts?"conflict":D?"accepted":"preview",l.localChange=D?D.localChange:P.localChange,l.remoteChange=D?D.remoteChange:P.remoteChange,l}),this.c}async accept(d,l){return await this.X(d,async P=>{const D=await this.pb(P,d,l,j.CancellationToken.None);return P.acceptResult=D,P.mergeState="accepted",P.localChange=D.localChange,P.remoteChange=D.remoteChange,P}),this.c}async discard(d){return await this.X(d,async l=>{const P=await this.ob(l,j.CancellationToken.None);return await this.C.writeFile(l.previewResource,L.$Ib.fromString(P.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=P.localChange,l.remoteChange=P.remoteChange,l}),this.c}async X(d,l){if(!this.c)return;let P=await this.c;const D=P.resourcePreviews.findIndex(({localResource:T,remoteResource:F,previewResource:H})=>this.h.isEqual(T,d)||this.h.isEqual(F,d)||this.h.isEqual(H,d));D!==-1&&(this.c=(0,M.$fg)(async T=>{const F=[...P.resourcePreviews];return F[D]=await l(F[D]),{...P,resourcePreviews:F}}),P=await this.c,this.$(P.resourcePreviews),P.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(d){if(!this.c)return"idle";const l=await this.c;return l.resourcePreviews.some(({mergeState:P})=>P==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:P})=>P!=="accepted")?"syncing":(await this.qb(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(P=>[P,P.acceptResult]),d),this.c=null,await this.Z(),"idle")}async Z(){try{await this.C.del(this.g,{recursive:!0})}catch{}}$(d){const l=d.filter(({mergeState:P})=>P==="conflict");(0,R.$$e)(this.m,l,(P,D)=>this.h.isEqual(P.previewResource,D.previewResource))||(this.m=l,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const d=await this.getLastSyncUserData();return!!d&&d.syncData!==null}async ab(d){const l=this.c?await this.c:null;if(l)for(const P of l.resourcePreviews){if(this.h.isEqual(P.acceptedResource,d))return P.acceptResult?P.acceptResult.content:null;if(this.h.isEqual(P.remoteResource,d))return P.remoteContent;if(this.h.isEqual(P.localResource,d))return P.localContent;if(this.h.isEqual(P.baseResource,d))return P.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(d){(0,$.$5j)(d)!==1&&this.L.error(d)}}async bb(d,l,P,D,T,F){const H=await this.nb(d,l,P,T,F),V=[];for(const W of H){const x=W.previewResource.with({scheme:w.$Mdb,authority:"accepted"});if(W.localChange===0&&W.remoteChange===0)V.push({...W,acceptedResource:x,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const ee=D?await this.ob(W,F):void 0;if(F.isCancellationRequested)break;await this.C.writeFile(W.previewResource,L.$Ib.fromString(ee?.content||""));const X=ee&&!ee.hasConflicts?await this.pb(W,W.previewResource,void 0,F):void 0;V.push({...W,acceptResult:X,mergeState:ee?.hasConflicts?"conflict":X?"accepted":"preview",localChange:X?X.localChange:ee?ee.localChange:W.localChange,remoteChange:X?X.remoteChange:ee?ee.remoteChange:W.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:d,lastSyncUserData:l,resourcePreviews:V,isLastSyncFromCurrentMachine:P}}async getLastSyncUserData(){let d=this.db();if(d||(d=await this.gb()),!d)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const l=JSON.parse(d),P=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!l.version&&!!P&&l.version!==P,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${P}.`),await this.resetLocal(),null;let D,T=1;for(;D===void 0&&T++<6;)try{const F=await this.eb();F&&(F.ref===l.ref?D=F.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof $.$9j&&F.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(F instanceof w.$Adb)throw F;this.L.error(F,T)}}if(D===void 0)try{const F=await this.G.resolveResourceContent(this.resource,l.ref,this.collection,this.z);D=F===null?null:this.hb(F),await this.fb({ref:l.ref,syncData:D})}catch(F){if(F instanceof w.$Adb&&F.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw F}return D===void 0?null:{...l,syncData:D}}async cb(d,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const P=this.I.getResourceSyncStateVersion(this.resource),D={ref:d.ref,version:P,...l};this.F.store(this.v,JSON.stringify(D),-1,1),await this.fb(d)}db(){return this.F.get(this.v,-1)}async eb(){const d=(await this.C.readFile(this.u)).value.toString();try{const l=d?JSON.parse(d):void 0;if(n(l))return l}catch(l){this.L.error(l)}}async fb(d){await this.C.writeFile(this.u,L.$Ib.fromString(JSON.stringify(d)))}async gb(){try{const d=await this.C.readFile(this.u),l=JSON.parse(d.value.toString());await this.C.del(this.u),l.ref&&l.content!==void 0?(this.F.store(this.v,JSON.stringify({...l,content:void 0}),-1,1),await this.fb({ref:l.ref,syncData:l.content===null?null:JSON.parse(l.content)})):this.L.info(`${this.y}: Migrating last sync user data. Invalid data.`,l)}catch(d){d instanceof $.$9j&&d.fileOperationResult===1?this.L.info(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(d)}return this.F.get(this.v,-1)}async getRemoteUserData(d){const{ref:l,content:P}=await this.ib(d);let D=null;return P!==null&&(D=this.hb(P)),{ref:l,syncData:D}}hb(d){try{const l=JSON.parse(d);if(r(l))return l}catch(l){this.L.error(l)}throw new w.$Adb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(d){const l=d?{ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null}:null;return this.G.readResource(this.resource,l,this.collection,this.z)}async jb(d,l){const P=await this.j,D={version:this.mb,machineId:P,content:d};try{return l=await this.G.writeResource(this.resource,JSON.stringify(D),l,this.collection,this.z),{ref:l,syncData:D}}catch(T){throw T instanceof w.$Adb&&T.code==="TooLarge"&&(T=new w.$Adb(T.message,T.code,this.resource)),T}}async kb(d){const l={version:this.mb,content:d};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.$([]),await this.Z(),this.P("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(w.$ndb)}};e.$Wxb=t=we([Y(2,$.$Oj),Y(3,f.$sh),Y(4,h.$Go),Y(5,w.$vdb),Y(6,w.$wdb),Y(7,w.$Fdb),Y(8,u.$Rk),Y(9,w.$Kdb),Y(10,b.$Rh),Y(11,p.$lk)],t);let s=e.$Xxb=class extends t{constructor(d,l,P,D,T,F,H,V,W,x,ee,X,_){super(l,P,D,T,F,H,V,W,x,ee,X,_),this.i=d,this.B(this.C.watch(this.h.dirname(d))),this.B(this.C.onDidFilesChange(q=>this.tb(q)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(d,l,P){try{l?await this.C.writeFile(this.i,L.$Ib.fromString(d),P?void 0:l):await this.C.createFile(this.i,L.$Ib.fromString(d),{overwrite:P})}catch(D){throw D instanceof $.$9j&&D.fileOperationResult===1||D instanceof $.$9j&&D.fileOperationResult===3?new w.$Adb(D.message,"LocalPreconditionFailed"):D}}async sb(){try{await this.C.del(this.i)}catch(d){if(!(d instanceof $.$9j&&d.fileOperationResult===1))throw d}}tb(d){d.contains(this.i)&&this.N()}};e.$Xxb=s=we([Y(3,$.$Oj),Y(4,f.$sh),Y(5,h.$Go),Y(6,w.$vdb),Y(7,w.$wdb),Y(8,w.$Fdb),Y(9,u.$Rk),Y(10,w.$Kdb),Y(11,b.$Rh),Y(12,p.$lk)],s);let o=e.$Yxb=class extends s{constructor(d,l,P,D,T,F,H,V,W,x,ee,X,_,q){super(d,l,P,D,T,F,H,V,W,x,ee,_,q),this.ub=X,this.wb=void 0}vb(d,l){const P=[],D=(0,C.$tm)(d,P,{allowEmptyContent:!0,allowTrailingComma:!0});return P.length>0||!(0,S.$ne)(D)&&l!==Array.isArray(D)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};e.$Yxb=o=we([Y(3,$.$Oj),Y(4,f.$sh),Y(5,h.$Go),Y(6,w.$vdb),Y(7,w.$wdb),Y(8,w.$Fdb),Y(9,u.$Rk),Y(10,w.$Kdb),Y(11,w.$Jdb),Y(12,b.$Rh),Y(13,p.$lk)],o);let c=e.$Zxb=class{constructor(d,l,P,D,T,F,H){this.resource=d,this.g=l,this.h=P,this.j=D,this.k=T,this.l=F,this.d=H.extUri,this.f=(0,w.$tdb)(void 0,this.resource,P,this.d)}async initialize({ref:d,content:l}){if(!l){this.j.info("Remote content does not exist.",this.resource);return}const P=this.m(l);if(P)try{await this.o({ref:d,syncData:P})}catch(D){this.j.error(D)}}m(d){try{const l=JSON.parse(d);if(r(l))return l}catch(l){this.j.error(l)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(d,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const P={ref:d.ref,version:void 0,...l};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(P),-1,1),await this.k.writeFile(this.f,L.$Ib.fromString(JSON.stringify(d)))}};e.$Zxb=c=we([Y(1,I.$nk),Y(2,f.$sh),Y(3,v.$Ni),Y(4,$.$Oj),Y(5,h.$Go),Y(6,p.$lk)],c)}),define(ae[114],ce([0,1,6,26,7,3,41,2,27,18,14,113,28,33,79,13,4,70,8,19,20,29,17,39,226,111,23,58]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u,p,w,I,n,r,i,t,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JYb=e.$IYb=e.$HYb=e.$GYb=e.$FYb=void 0;async function c(T,F){const H=JSON.parse(T.content);if(T.version===1||T.version===2){const V=(await F.getInstalled(0)).filter(W=>W.isBuiltin);for(const W of H)T.version===1&&(W.enabled===!1&&(W.disabled=!0),delete W.enabled),T.version===2&&V.every(x=>!(0,f.$bo)(x.identifier,W.identifier))&&(W.installed=!0)}return H}function y(T){return JSON.parse(T.content)}e.$FYb=y;function d(T,F){return T.sort((H,V)=>!H.identifier.uuid&&V.identifier.uuid?-1:H.identifier.uuid&&!V.identifier.uuid?1:(0,k.$Cd)(H.identifier.id,V.identifier.id)),F?(0,O.$AR)(T,{}):JSON.stringify(T)}e.$GYb=d;let l=e.$HYb=class extends r.$Wxb{constructor(F,H,V,W,x,ee,X,_,q,G,B,ie,re,K,Z,N,g){super({syncResource:"extensions",profile:F},H,W,V,x,ee,X,ie,re,G,B,Z),this.yb=_,this.zb=q,this.Ab=g,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:s.$Mdb,authority:"base"}),this.ub=this.sb.with({scheme:s.$Mdb,authority:"local"}),this.vb=this.sb.with({scheme:s.$Mdb,authority:"remote"}),this.wb=this.sb.with({scheme:s.$Mdb,authority:"accepted"}),this.xb=this.Ab.createInstance(P),this.B(j.Event.any(j.Event.filter(this.yb.onDidInstallExtensions,A=>A.some(({local:U})=>!!U)),j.Event.filter(this.yb.onDidUninstallExtension,A=>!A.error),j.Event.filter(N.onDidChange,A=>A.valueChanges.some(({profile:U,changes:Q})=>this.syncResource.profile.id===U.id&&Q.some(z=>z.key===b.$On))),K.onDidChangeExtensionStorageToSync)(()=>this.N()))}async nb(F,H){const V=F.syncData?await c(F.syncData,this.yb):null,W=H?.skippedExtensions??[],x=H?.builtinExtensions??null,ee=H?.syncData?await c(H.syncData,this.yb):null,{localExtensions:X,ignoredExtensions:_}=await this.xb.getLocalExtensions(this.syncResource.profile);V?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:G}=(0,i.$EYb)(X,V,ee,W,_,x),B={local:q,remote:G,content:this.Db(X,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:G!==null?2:0},ie=this.Kb(X,!1);return[{skippedExtensions:W,builtinExtensions:x,baseResource:this.tb,baseContent:ee?this.Kb(ee,!1):ie,localResource:this.ub,localContent:ie,localExtensions:X,remoteResource:this.vb,remoteExtensions:V,remoteContent:V?this.Kb(V,!1):null,previewResource:this.sb,previewResult:B,localChange:B.localChange,remoteChange:B.remoteChange,acceptedResource:this.wb}]}async rb(F){const H=F.syncData?await c(F.syncData,this.yb):null,{localExtensions:V,ignoredExtensions:W}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$EYb)(V,H,H,F.skippedExtensions||[],W,F.builtinExtensions||[]);return x!==null}Db(F,H,V,W){const x=[...H,...V],ee=new Set,X=_=>{ee.add(_.id.toLowerCase()),_.uuid&&ee.add(_.uuid)};x.forEach(({identifier:_})=>X(_)),W.forEach(X);for(const _ of F)ee.has(_.identifier.id.toLowerCase())||_.identifier.uuid&&ee.has(_.identifier.uuid)||x.push(_);return this.Kb(x,!1)}async ob(F,H){return{...F.previewResult,hasConflicts:!1}}async pb(F,H,V,W){if(this.h.isEqual(H,this.ub))return this.Gb(F);if(this.h.isEqual(H,this.vb))return this.Hb(F);if(this.h.isEqual(H,this.sb))return F.previewResult;throw new Error(`Invalid Resource: ${H.toString()}`)}async Gb(F){const H=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),V=this.zb.getIgnoredExtensions(H),W=(0,i.$EYb)(F.localExtensions,null,null,F.skippedExtensions,V,F.builtinExtensions),{local:x,remote:ee}=W;return{content:F.localContent,local:x,remote:ee,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:ee!==null?2:0}}async Hb(F){const H=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),V=this.zb.getIgnoredExtensions(H),W=F.remoteContent?JSON.parse(F.remoteContent):null;if(W!==null){const x=(0,i.$EYb)(F.localExtensions,W,F.localExtensions,[],V,F.builtinExtensions),{local:ee,remote:X}=x;return{content:F.remoteContent,local:ee,remote:X,localChange:ee.added.length>0||ee.removed.length>0||ee.updated.length>0?2:0,remoteChange:X!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(F,H,V,W){let{skippedExtensions:x,builtinExtensions:ee,localExtensions:X}=V[0][0];const{local:_,remote:q,localChange:G,remoteChange:B}=V[0][1];if(G===0&&B===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),G!==0&&(await this.kb(JSON.stringify(X)),x=await this.xb.updateLocalExtensions(_.added,_.removed,_.updated,x,this.syncResource.profile)),q){this.L.trace(`${this.y}: Updating remote extensions...`);const ie=JSON.stringify(q.all);F=await this.jb(ie,W?null:F.ref),this.L.info(`${this.y}: Updated remote extensions.${q.added.length?` Added: ${JSON.stringify(q.added.map(re=>re.identifier.id))}.`:""}${q.updated.length?` Updated: ${JSON.stringify(q.updated.map(re=>re.identifier.id))}.`:""}${q.removed.length?` Removed: ${JSON.stringify(q.removed.map(re=>re.identifier.id))}.`:""}`)}H?.ref!==F.ref&&(this.L.trace(`${this.y}: Updating last synchronized extensions...`),ee=this.Jb(X,ee),await this.cb(F,{skippedExtensions:x,builtinExtensions:ee}),this.L.info(`${this.y}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ie=>ie.identifier.id))}.`:""}`))}Jb(F,H){const V=new Set,W=[];for(const x of F)V.add(x.identifier.id.toLowerCase()),x.installed||W.push(x.identifier);if(H)for(const x of H)V.has(x.id.toLowerCase())||W.push(x);return W}async resolveContent(F){if(this.h.isEqual(this.vb,F)||this.h.isEqual(this.tb,F)||this.h.isEqual(this.ub,F)||this.h.isEqual(this.wb,F)){const H=await this.ab(F);return H&&this.Kb(JSON.parse(H),!0)}return null}Kb(F,H){return d(F,H)}async hasLocalData(){try{const{localExtensions:F}=await this.xb.getLocalExtensions(this.syncResource.profile);if(F.some(H=>H.installed||H.disabled))return!0}catch{}return!1}};e.$HYb=l=we([Y(2,S.$sh),Y(3,v.$Oj),Y(4,p.$Go),Y(5,s.$vdb),Y(6,s.$wdb),Y(7,b.$Nn),Y(8,t.$Eyb),Y(9,s.$Kdb),Y(10,m.$Rh),Y(11,s.$Fdb),Y(12,w.$Rk),Y(13,$.$iz),Y(14,I.$lk),Y(15,o.$$wb),Y(16,a.$kh)],l);let P=e.$IYb=class{constructor(F,H,V,W,x,ee){this.a=F,this.b=H,this.c=V,this.d=W,this.f=x,this.g=ee}async getLocalExtensions(F){const H=await this.a.getInstalled(void 0,F.extensionsResource),V=this.d.getIgnoredExtensions(H);return{localExtensions:await this.j(F,async(x,ee)=>{const X=x.getDisabledExtensions();return H.map(_=>{const{identifier:q,isBuiltin:G,manifest:B,preRelease:ie,pinned:re}=_,K={identifier:q,preRelease:ie,version:B.version,pinned:!!re};X.some(Z=>(0,f.$bo)(Z,q))&&(K.disabled=!0),G||(K.installed=!0);try{const Z=ee.getKeysForSync({id:q.id,version:B.version});if(Z){const N=ee.getExtensionState(_,!0)||{};K.state=Object.keys(N).reduce((g,A)=>(Z.includes(A)&&(g[A]=N[A]),g),{})}}catch(Z){this.g.info(`${(0,r.$Vxb)("extensions",F)}: Error while parsing extension state`,(0,L.$8)(Z))}return K})}),ignoredExtensions:V}}async updateLocalExtensions(F,H,V,W,x){const ee=(0,r.$Vxb)("extensions",x),X=[],_=new Map,q=[],G=[],B=await this.a.getInstalled(void 0,x.extensionsResource);if((F.length||V.length)&&await this.j(x,async(K,Z)=>{await R.Promises.settled([...F,...V].map(async N=>{const g=B.find(Q=>(0,f.$bo)(Q.identifier,N.identifier));if(g&&g.isBuiltin){N.state&&g.manifest.version===N.version&&this.h(N.state,g,g.manifest.version,Z),K.getDisabledExtensions().some(z=>(0,f.$bo)(z,N.identifier))!==!!N.disabled&&(N.disabled?(this.g.trace(`${ee}: Disabling extension...`,N.identifier.id),await K.disableExtension(N.identifier),this.g.info(`${ee}: Disabled extension`,N.identifier.id)):(this.g.trace(`${ee}: Enabling extension...`,N.identifier.id),await K.enableExtension(N.identifier),this.g.info(`${ee}: Enabled extension`,N.identifier.id))),q.push(N.identifier);return}const A=N.pinned?N.version:void 0,U=(await this.c.getExtensions([{...N.identifier,version:A,preRelease:A?void 0:N.preRelease}],M.CancellationToken.None))[0];if(N.state&&(g?g.manifest.version===N.version:U)&&this.h(N.state,g||U,g?.manifest.version,Z),U)try{K.getDisabledExtensions().some(z=>(0,f.$bo)(z,N.identifier))!==!!N.disabled&&(N.disabled?(this.g.trace(`${ee}: Disabling extension...`,N.identifier.id,U.version),await K.disableExtension(U.identifier),this.g.info(`${ee}: Disabled extension`,N.identifier.id,U.version)):(this.g.trace(`${ee}: Enabling extension...`,N.identifier.id,U.version),await K.enableExtension(U.identifier),this.g.info(`${ee}: Enabled extension`,N.identifier.id,U.version))),(!g||g.preRelease!==N.preRelease||g.pinned!==N.pinned||A&&g.manifest.version!==A)&&(await this.a.canInstall(U)?(X.push({extension:U,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:N.pinned&&!!N.version,installPreReleaseVersion:N.preRelease,profileLocation:x.extensionsResource,context:{[b.$Cn]:!0,[b.$Dn]:!0}}}),_.set(U.identifier.id.toLowerCase(),N)):(this.g.info(`${ee}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),G.push(N)))}catch(Q){G.push(N),this.g.error(Q),this.g.info(`${ee}: Skipped synchronizing extension`,U.displayName||U.identifier.id)}else G.push(N),this.g.info(`${ee}: Skipped synchronizing extension because the extension is not found.`,N.identifier.id)}))}),H.length){const K=B.filter(({identifier:Z,isBuiltin:N})=>!N&&H.some(g=>(0,f.$bo)(Z,g)));await R.Promises.settled(K.map(async Z=>{this.g.trace(`${ee}: Uninstalling local extension...`,Z.identifier.id),await this.a.uninstall(Z,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${ee}: Uninstalled local extension.`,Z.identifier.id),q.push(Z.identifier)}))}const ie=await this.a.installGalleryExtensions(X);for(const{identifier:K,local:Z,error:N,source:g}of ie){const A=g;if(Z)this.g.info(`${ee}: Installed extension.`,K.id,A.version),q.push(K);else{const U=_.get(K.id.toLowerCase());U&&(G.push(U),this.g.info(`${ee}: Skipped synchronizing extension`,A.displayName||A.identifier.id)),N instanceof b.$Mn&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatiblePreRelease,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(N.code)?this.g.info(`${ee}: Skipped synchronizing extension because the compatible extension is not found.`,A.displayName||A.identifier.id):N&&this.g.error(N)}}const re=[];for(const K of W)q.some(Z=>(0,f.$bo)(Z,K.identifier))||re.push(K);for(const K of G)re.some(Z=>(0,f.$bo)(Z.identifier,K.identifier))||re.push(K);return re}h(F,H,V,W){const x=W.getExtensionState(H,!0)||{},ee=V?W.getKeysForSync({id:H.identifier.id,version:V}):void 0;ee?ee.forEach(X=>{x[X]=F[X]}):Object.keys(F).forEach(X=>x[X]=F[X]),W.setExtensionState(H,x,!0)}async j(F,H){return this.b.withProfileScopedStorageService(F,async V=>{const W=new C.$jb,x=this.f.createChild(new h.$jh([p.$Go,V])),ee=W.add(x.createInstance(E.$wwb)),X=W.add(x.createInstance($.$jz));try{return await H(ee,X)}finally{W.dispose()}})}};e.$IYb=P=we([Y(0,b.$Nn),Y(1,o.$$wb),Y(2,b.$Ln),Y(3,t.$Eyb),Y(4,a.$kh),Y(5,s.$Kdb)],P);let D=e.$JYb=class extends r.$Zxb{constructor(F,H,V,W,x,ee,X,_){super("extensions",W,x,ee,V,X,_),this.p=F,this.q=H}async t(F){return F.syncData?await c(F.syncData,this.p):null}u(F,H){const V=[],W=[],x=[];for(const ee of F){if(this.q.hasToNeverSyncExtension(ee.identifier.id))continue;const X=H.find(_=>(0,f.$bo)(_.identifier,ee.identifier));X?(V.push(X),ee.disabled&&x.push(ee.identifier)):ee.installed&&(W.push({...ee.identifier,preRelease:!!ee.preRelease}),ee.disabled&&x.push(ee.identifier))}return{installedExtensions:V,newExtensions:W,disabledExtensions:x,remoteExtensions:F}}};e.$JYb=D=we([Y(0,b.$Nn),Y(1,t.$Eyb),Y(2,v.$Oj),Y(3,n.$nk),Y(4,S.$sh),Y(5,u.$Ni),Y(6,p.$Go),Y(7,I.$lk)],D)}),define(ae[115],ce([0,1,16,7,3,34,41,5,32,18,14,13,8,44,19,20,29,39,57,230,23,17,58,4]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u,p,w,I,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6xb=e.$5xb=e.$4xb=e.$3xb=e.$2xb=void 0;const i="globalState.argv.",t=["locale"];function s(P,D){const T=P.storage?Object.keys(P.storage).sort():[],F={};return T.forEach(H=>F[H]=P.storage[H]),P.storage=F,D?(0,O.$AR)(P,{}):JSON.stringify(P)}e.$2xb=s;const o=1;let c=e.$3xb=class extends h.$Wxb{constructor(D,T,F,H,V,W,x,ee,X,_,q,G,B,ie){super({syncResource:"globalState",profile:D},T,H,ee,G,V,W,X,_,x,q,B),this.wb=F,this.mb=o,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:w.$Mdb,authority:"base"}),this.sb=this.p.with({scheme:w.$Mdb,authority:"local"}),this.tb=this.p.with({scheme:w.$Mdb,authority:"remote"}),this.ub=this.p.with({scheme:w.$Mdb,authority:"accepted"}),this.vb=ie.createInstance(y),this.B(H.watch(this.h.dirname(this.D.argvResource))),this.B(L.Event.any(L.Event.filter(H.onDidFilesChange,re=>re.contains(this.D.argvResource)),L.Event.filter(F.onDidChange,re=>!!(re.targetChanges.some(K=>this.syncResource.profile.id===K.id)||re.valueChanges.some(({profile:K,changes:Z})=>this.syncResource.profile.id===K.id&&Z.some(N=>N.target===0)))))(()=>this.N()))}async nb(D,T,F){const H=D.syncData?JSON.parse(D.syncData.content):null;T=T===null&&F?D:T;const V=T&&T.syncData?JSON.parse(T.syncData.content):null,W=await this.vb.getLocalGlobalState(this.syncResource.profile);H?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const x=await this.Eb(V),{local:ee,remote:X}=(0,p.$1xb)(W.storage,H?H.storage:null,V?V.storage:null,x,this.L),_={content:null,local:ee,remote:X,localChange:Object.keys(ee.added).length>0||Object.keys(ee.updated).length>0||ee.removed.length>0?2:0,remoteChange:X.all!==null?2:0},q=s(W,!1);return[{baseResource:this.r,baseContent:V?s(V,!1):q,localResource:this.sb,localContent:q,localUserData:W,remoteResource:this.tb,remoteContent:H?s(H,!1):null,previewResource:this.p,previewResult:_,localChange:_.localChange,remoteChange:_.remoteChange,acceptedResource:this.ub,storageKeys:x}]}async rb(D){const T=D.syncData?JSON.parse(D.syncData.content):null;if(T===null)return!0;const F=await this.vb.getLocalGlobalState(this.syncResource.profile),H=await this.Eb(T),{remote:V}=(0,p.$1xb)(F.storage,T.storage,T.storage,H,this.L);return V.all!==null}async ob(D,T){return{...D.previewResult,hasConflicts:!1}}async pb(D,T,F,H){if(this.h.isEqual(T,this.sb))return this.Bb(D);if(this.h.isEqual(T,this.tb))return this.Cb(D);if(this.h.isEqual(T,this.p))return D.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Bb(D){return{content:D.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(D.localUserData.storage),removed:[],updated:[],all:D.localUserData.storage},localChange:0,remoteChange:2}}async Cb(D){if(D.remoteContent!==null){const T=JSON.parse(D.remoteContent),{local:F,remote:H}=(0,p.$1xb)(D.localUserData.storage,T.storage,null,D.storageKeys,this.L);return{content:D.remoteContent,local:F,remote:H,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:H!==null?2:0}}else return{content:D.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(D,T,F,H){const{localUserData:V}=F[0][0],{local:W,remote:x,localChange:ee,remoteChange:X}=F[0][1];if(ee===0&&X===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),ee!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify(V)),await this.vb.writeLocalGlobalState(W,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),X!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const _=JSON.stringify({storage:x.all});D=await this.jb(_,H?null:D.ref),this.L.info(`${this.y}: Updated remote ui state.${x.added.length?` Added: ${x.added}.`:""}${x.updated.length?` Updated: ${x.updated}.`:""}${x.removed.length?` Removed: ${x.removed}.`:""}`)}T?.ref!==D.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(D),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(D){if(this.h.isEqual(this.tb,D)||this.h.isEqual(this.r,D)||this.h.isEqual(this.sb,D)||this.h.isEqual(this.ub,D)){const T=await this.ab(D);return T&&s(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:D}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(D).length>1||D[`${i}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(D){const T=await this.wb.readStorageData(this.syncResource.profile),F=[],H=[];for(const[x,ee]of T)ee.target===0?F.push(x):ee.target===1&&H.push(x);const V=[...F,...H],W=D?.storage?Object.keys(D.storage).filter(x=>!x.startsWith(i)&&!V.includes(x)&&T.get(x)!==void 0):[];if(!C.$o){const x=[...w.$rdb.map(ee=>(0,w.$Edb)(ee)),w.$Ddb];W.push(...x),H.push(...x)}return{user:F,machine:H,unregistered:W}}};e.$3xb=c=we([Y(2,n.$$wb),Y(3,E.$Oj),Y(4,w.$vdb),Y(5,w.$wdb),Y(6,w.$Kdb),Y(7,S.$sh),Y(8,w.$Fdb),Y(9,v.$Rk),Y(10,m.$Rh),Y(11,$.$Go),Y(12,a.$lk),Y(13,r.$kh)],c);let y=e.$4xb=class{constructor(D,T,F,H){this.a=D,this.b=T,this.c=F,this.d=H}async getLocalGlobalState(D){const T={};if(D.isDefault){const H=await this.f(),V=(0,j.$tm)(H);for(const W of t)V[W]!==void 0&&(T[`${i}${W}`]={version:1,value:V[W]})}const F=await this.c.readStorageData(D);for(const[H,V]of F)V.value&&V.target===0&&(T[H]={version:1,value:V.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const D=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),D.value.toString()}catch(D){this.d.debug((0,M.$8)(D))}return"{}"}async writeLocalGlobalState({added:D,removed:T,updated:F},H){const V=(0,h.$Vxb)("globalState",H),W={},x=new Map,ee=await this.c.readStorageData(H),X=(_,q)=>{for(const G of _){if(G.startsWith(i)){W[G.substring(i.length)]=q?q[G].value:void 0;continue}if(q){const B=q[G];B.value!==ee.get(G)?.value&&x.set(G,B.value)}else ee.get(G)!==void 0&&x.set(G,void 0)}};if(X(Object.keys(D),D),X(Object.keys(F),F),X(T),Object.keys(W).length){this.d.trace(`${V}: Updating locale...`);const _=await this.f();let q=_;for(const G of Object.keys(W))q=(0,u.edit)(q,[G],W[G],{});_!==q&&(this.d.trace(`${V}: Updating locale...`),await this.a.writeFile(this.b.argvResource,R.$Ib.fromString(q)),this.d.info(`${V}: Updated locale.`)),this.d.info(`${V}: Updated locale`)}x.size&&(this.d.trace(`${V}: Updating global state...`),await this.c.updateStorageData(H,x,0),this.d.info(`${V}: Updated global state`,[...x.keys()]))}};e.$4xb=y=we([Y(0,E.$Oj),Y(1,S.$sh),Y(2,n.$$wb),Y(3,w.$Kdb)],y);let d=e.$5xb=class extends h.$Zxb{constructor(D,T,F,H,V,W){super("globalState",F,H,V,T,D,W)}async o(D){const T=D.syncData?JSON.parse(D.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},H={};for(const V of Object.keys(T.storage))V.startsWith(i)?F[V.substring(i.length)]=T.storage[V].value:this.l.get(V,0)===void 0&&(H[V]=T.storage[V].value);if(Object.keys(F).length){let V="{}";try{V=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const W of Object.keys(F))V=(0,u.edit)(V,[W],F[W],{});await this.k.writeFile(this.h.argvResource,R.$Ib.fromString(V))}if(Object.keys(H).length){const V=[];for(const W of Object.keys(H))V.push({key:W,value:H[W],scope:0,target:0});this.l.storeAll(V,!0)}}};e.$5xb=d=we([Y(0,$.$Go),Y(1,E.$Oj),Y(2,I.$nk),Y(3,S.$sh),Y(4,w.$Kdb),Y(5,a.$lk)],d);let l=e.$6xb=class{constructor(D,T,F,H,V){this.a=D,this.b=T,this.c=F,this.d=H,this.f=V}getSyncStoreType(D){return this.h(D)?.storage[w.$Ddb]?.value}async sync(D){const T=(0,w.$zdb)((0,k.$3e)());try{return await this.g(D,T)}catch(F){if(F instanceof w.$Adb)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(D,T)}throw F}}async g(D,T){const F=await this.a.readResource("globalState",null,void 0,T),H=this.h(F)||{storage:{}};H.storage[w.$Ddb]={value:D,version:o};const V=await(0,f.$Mo)(this.c,this.d,this.b),W={version:o,machineId:V,content:s(H,!1)};await this.a.writeResource("globalState",JSON.stringify(W),F.ref,void 0,T)}h({content:D}){if(!D)return null;const T=JSON.parse(D);if((0,h.$Uxb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$6xb=l=we([Y(1,$.$Go),Y(2,S.$sh),Y(3,E.$Oj),Y(4,b.$Ni)],l)}),define(ae[116],ce([0,1,21,16,3,34,5,10,164,18,14,13,19,20,29,17,39,227,23]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NYb=e.$MYb=e.$LYb=void 0;function p(n,r,i){try{const t=JSON.parse(n);if(!r)return(0,C.$ne)(t.all)?null:t.all;switch(O.OS){case 2:return(0,C.$ne)(t.mac)?null:t.mac;case 3:return(0,C.$ne)(t.linux)?null:t.linux;case 1:return(0,C.$ne)(t.windows)?null:t.windows}}catch(t){return i.error(t),null}}e.$LYb=p;let w=e.$MYb=class extends a.$Yxb{constructor(r,i,t,s,o,c,y,d,l,P,D,T,F){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},i,d,l,P,t,s,y,T,o,D,c,F),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:u.$Mdb,authority:"base"}),this.Bb=this.zb.with({scheme:u.$Mdb,authority:"local"}),this.Cb=this.zb.with({scheme:u.$Mdb,authority:"remote"}),this.Db=this.zb.with({scheme:u.$Mdb,authority:"accepted"}),this.B(L.Event.filter(c.onDidChangeConfiguration,H=>H.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.N()))}async nb(r,i,t,s){const o=r.syncData?p(r.syncData.content,s.keybindingsPerPlatform??this.Lb(),this.L):null;i=i===null&&t?r:i;const c=i?this.Jb(i):null,y=await this.p(),d=await this.xb();let l=null,P=!1,D=!1,T=!1;if(o){let V=y?y.value.toString():"[]";if(V=V||"[]",this.vb(V,!0))throw new u.$Adb((0,k.localize)(0,null),"LocalInvalidContent",this.resource);if(!c||c!==V||c!==o){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const W=await(0,h.$KYb)(V,o,c,d,this.ub);W.hasChanges&&(l=W.mergeContent,T=W.hasConflicts,P=T||W.mergeContent!==V,D=T||W.mergeContent!==o)}}else y&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),l=y.value.toString(),D=!0);const F={content:T?c:l,localChange:P?y?2:1:0,remoteChange:D?2:0,hasConflicts:T},H=y?y.value.toString():null;return[{fileContent:y,baseResource:this.Ab,baseContent:c,localResource:this.Bb,localContent:H,localChange:F.localChange,remoteResource:this.Cb,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.zb,previewResult:F,acceptedResource:this.Db}]}async rb(r){const i=this.Jb(r);if(i===null)return!0;const t=await this.p(),s=t?t.value.toString():"",o=await this.xb(),c=await(0,h.$KYb)(s||"[]",i,i,o,this.ub);return c.hasConflicts||c.mergeContent!==i}async ob(r,i){return r.previewResult}async pb(r,i,t,s){if(this.h.isEqual(i,this.Bb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(i,this.Cb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(i,this.zb))return t===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:t,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async qb(r,i,t,s){const{fileContent:o}=t[0][0];let{content:c,localChange:y,remoteChange:d}=t[0][1];if(y===0&&d===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.vb(c,!0)))throw new u.$Adb((0,k.localize)(1,null),"LocalInvalidContent",this.resource);if(y!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),o&&await this.kb(this.Kb(o.value.toString())),await this.r(c||"[]",o,s),this.L.info(`${this.y}: Updated local keybindings`)),d!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const l=this.Kb(c||"[]",r.syncData?.content);r=await this.jb(l,s?null:r.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}i?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(r,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.p();if(r){const i=(0,j.$tm)(r.value.toString());if((0,R.$nf)(i))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Cb,r)||this.h.isEqual(this.Ab,r)||this.h.isEqual(this.Bb,r)||this.h.isEqual(this.Db,r)?this.ab(r):null}Jb(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Lb()?null:p(r.syncData.content,this.Lb(),this.L)}Kb(r,i){let t={};try{t=JSON.parse(i||"{}")}catch(s){this.L.error(s)}switch(this.Lb()?delete t.all:t.all=r,O.OS){case 2:t.mac=r;break;case 3:t.linux=r;break;case 1:t.windows=r;break}return JSON.stringify(t)}Lb(){return!!this.M.getValue(u.$odb)}};e.$MYb=w=we([Y(2,u.$vdb),Y(3,u.$wdb),Y(4,u.$Kdb),Y(5,m.$Rh),Y(6,u.$Fdb),Y(7,E.$Oj),Y(8,S.$sh),Y(9,b.$Go),Y(10,u.$Jdb),Y(11,f.$Rk),Y(12,$.$lk)],w);let I=e.$NYb=class extends a.$Zxb{constructor(r,i,t,s,o,c){super("keybindings",i,t,s,r,o,c)}async o(r){const i=r.syncData?this.p(r.syncData.content):null;if(!i){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,M.$Ib.fromString(i)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),i=(0,j.$tm)(r.value.toString());return!(0,R.$nf)(i)}catch(r){return r.fileOperationResult===1}}p(r){try{return p(r,!0,this.j)}catch(i){return this.j.error(i),null}}};e.$NYb=I=we([Y(0,E.$Oj),Y(1,v.$nk),Y(2,S.$sh),Y(3,u.$Kdb),Y(4,b.$Go),Y(5,$.$lk)],I)}),define(ae[117],ce([0,1,16,3,165,18,73,14,28,13,19,20,29,17,39,57,231,23]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QYb=e.$PYb=e.$OYb=void 0;function u(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function p(n){const r=JSON.parse(n);return u(r)?r:{settings:n}}e.$OYb=p;let w=e.$PYb=class extends $.$Yxb{constructor(r,i,t,s,o,c,y,d,l,P,D,T,F,H){super(r.settingsResource,{syncResource:"settings",profile:r},i,t,s,o,c,y,D,T,d,l,P,H),this.zb=F,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:h.$Mdb,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.$Mdb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.$Mdb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.$Mdb,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(r){const i=await this.getLastSyncUserData(),t=await this.S(r,i),s=this.Gb(t),o=new O.$_m(h.$ndb);return s?.settings&&o.parse(s.settings),o.configurationModel.getValue(h.$ndb)||{}}async nb(r,i,t){const s=await this.p(),o=await this.xb(),c=this.Gb(r);i=i===null&&t?r:i;const y=i?this.Gb(i):null,d=await this.Kb();let l=null,P=!1,D=!1,T=!1;if(c){let W=s?s.value.toString().trim():"{}";W=W||"{}",this.Lb(W),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const x=(0,a.$Rwb)(W,c.settings,y?y.settings:null,d,[],o);l=x.localContent||x.remoteContent,P=x.localContent!==null,D=x.remoteContent!==null,T=x.hasConflicts}else s&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),l=s.value.toString().trim()||"{}",this.Lb(l),D=!0);const F=s?s.value.toString():null,H=y?.settings??null,V={content:T?H:l,localChange:P?2:0,remoteChange:D?2:0,hasConflicts:T};return[{fileContent:s,baseResource:this.baseResource,baseContent:H,localResource:this.localResource,localContent:F,localChange:V.localChange,remoteResource:this.remoteResource,remoteContent:c?c.settings:null,remoteChange:V.remoteChange,previewResource:this.previewResource,previewResult:V,acceptedResource:this.acceptedResource}]}async rb(r){const i=this.Gb(r);if(i===null)return!0;const t=await this.p(),s=t?t.value.toString().trim():"",o=await this.Kb(),c=await this.xb();return(0,a.$Rwb)(s||"{}",i.settings,i.settings,o,[],c).remoteContent!==null}async ob(r,i){const t=await this.xb(),s=await this.Kb();return{...r.previewResult,content:r.previewResult.content?(0,a.$Qwb)(r.previewResult.content,"{}",s,t):null}}async pb(r,i,t,s){const o=await this.xb(),c=await this.Kb();if(this.h.isEqual(i,this.localResource))return{content:r.fileContent?(0,a.$Qwb)(r.fileContent.value.toString(),"{}",c,o):null,localChange:0,remoteChange:2};if(this.h.isEqual(i,this.remoteResource))return{content:r.remoteContent!==null?(0,a.$Qwb)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",c,o):null,localChange:2,remoteChange:0};if(this.h.isEqual(i,this.previewResource))return t===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:t!==null?(0,a.$Qwb)(t,r.fileContent?r.fileContent.value.toString():"{}",c,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async qb(r,i,t,s){const{fileContent:o}=t[0][0];let{content:c,localChange:y,remoteChange:d}=t[0][1];if(y===0&&d===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.Lb(c),y!==0&&(this.L.trace(`${this.y}: Updating local settings...`),o&&await this.kb(JSON.stringify(this.Ib(o.value.toString()))),await this.r(c,o,s),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),d!==0){const l=await this.xb(),P=this.Gb(r),D=await this.Kb(c);c=(0,a.$Qwb)(c,P?P.settings:"{}",D,l),this.L.trace(`${this.y}: Updating remote settings...`),r=await this.jb(JSON.stringify(this.Ib(c)),s?null:r.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}i?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(r),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.p();if(r){const i=await this.xb(),t=(0,v.edit)(r.value.toString(),[h.$kdb],void 0,i);return!(0,a.$Swb)(t)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.ab(r):null}async ab(r){let i=await super.ab(r);if(i){const t=await this.xb(),s=await this.Kb();i=(0,a.$Qwb)(i,"{}",s,t)}return i}Gb(r){return r.syncData?this.Hb(r.syncData.content):null}Hb(r){try{return p(r)}catch(i){this.L.error(i)}return null}Ib(r){return{settings:r}}async Kb(r){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const t=M.Event.any(M.Event.filter(this.zb.onDidInstallExtensions,s=>s.some(({local:o})=>!!o)),M.Event.filter(this.zb.onDidUninstallExtension,s=>!s.error))(()=>{t.dispose(),this.Jb=void 0})}const i=await this.Jb;return(0,a.$Owb)(i,this.M,r)}Lb(r){if(this.vb(r,!1))throw new h.$Adb((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$PYb=w=we([Y(2,m.$Oj),Y(3,C.$sh),Y(4,S.$Go),Y(5,h.$vdb),Y(6,h.$wdb),Y(7,h.$Kdb),Y(8,h.$Jdb),Y(9,j.$Rh),Y(10,h.$Fdb),Y(11,E.$Rk),Y(12,k.$Nn),Y(13,b.$lk)],w);let I=e.$QYb=class extends $.$Zxb{constructor(r,i,t,s,o,c){super("settings",i,t,s,r,o,c)}async o(r){const i=r.syncData?this.p(r.syncData.content):null;if(!i){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,R.$Ib.fromString(i.settings)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,a.$Swb)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}p(r){try{return p(r)}catch(i){this.j.error(i)}return null}};e.$QYb=I=we([Y(0,m.$Oj),Y(1,f.$nk),Y(2,C.$sh),Y(3,h.$Kdb),Y(4,S.$Go),Y(5,b.$lk)],I)}),define(ae[118],ce([0,1,16,3,31,18,14,13,19,20,29,17,39,228,23]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VYb=e.$UYb=e.$TYb=void 0;function v(u){return JSON.parse(u.content)}e.$TYb=v;let a=e.$UYb=class extends b.$Wxb{constructor(p,w,I,n,r,i,t,s,o,c,y,d){super({syncResource:"snippets",profile:p},w,n,I,r,i,t,c,y,s,o,d),this.mb=1,this.p=p.snippetsHome,this.B(this.C.watch(I.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(M.Event.filter(this.C.onDidFilesChange,l=>l.affects(this.p))(()=>this.N()))}async nb(p,w,I){const n=await this.Cb(),r=this.Bb(n),i=p.syncData?this.Ab(p.syncData):null;w=w===null&&I?p:w;const t=w&&w.syncData?this.Ab(w.syncData):null;i?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,f.$RYb)(r,i,t);return this.wb(s,n,i||{},t||{})}async rb(p){const w=p.syncData?this.Ab(p.syncData):null;if(w===null)return!0;const I=await this.Cb(),n=this.Bb(I),r=(0,f.$RYb)(n,w,w);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async ob(p,w){return p.previewResult}async pb(p,w,I,n){if(this.h.isEqualOrParent(w,this.g.with({scheme:$.$Mdb,authority:"local"})))return{content:p.fileContent?p.fileContent.value.toString():null,localChange:0,remoteChange:p.fileContent?p.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(w,this.g.with({scheme:$.$Mdb,authority:"remote"})))return{content:p.remoteContent,localChange:p.remoteContent!==null?p.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(w,this.g))return I===void 0?{content:p.previewResult.content,localChange:p.previewResult.localChange,remoteChange:p.previewResult.remoteChange}:{content:I,localChange:I===null?p.fileContent!==null?3:0:2,remoteChange:I===null?p.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async qb(p,w,I,n){const r=I.map(([i,t])=>({...i,acceptResult:t}));r.every(({localChange:i,remoteChange:t})=>i===0&&t===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),r.some(({localChange:i})=>i!==0)&&(await this.xb(r),await this.yb(r,n)),r.some(({remoteChange:i})=>i!==0)&&(p=await this.zb(r,p,n)),w?.ref!==p.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(p),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:i}of r)try{await this.C.del(i)}catch{}}wb(p,w,I,n){const r=new Map;for(const i of Object.keys(p.local.added)){const t={content:p.local.added[i],hasConflicts:!1,localChange:1,remoteChange:0};r.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"remote"}),remoteContent:I[i],previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"accepted"})})}for(const i of Object.keys(p.local.updated)){const t={content:p.local.updated[i],hasConflicts:!1,localChange:2,remoteChange:0},s=w[i]?w[i].value.toString():null;r.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"local"}),fileContent:w[i],localContent:s,remoteResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"remote"}),remoteContent:I[i],previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"accepted"})})}for(const i of p.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=w[i]?w[i].value.toString():null;r.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"local"}),fileContent:w[i],localContent:s,remoteResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"accepted"})})}for(const i of Object.keys(p.remote.added)){const t={content:p.remote.added[i],hasConflicts:!1,localChange:0,remoteChange:1},s=w[i]?w[i].value.toString():null;r.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"local"}),fileContent:w[i],localContent:s,remoteResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"accepted"})})}for(const i of Object.keys(p.remote.updated)){const t={content:p.remote.updated[i],hasConflicts:!1,localChange:0,remoteChange:2},s=w[i]?w[i].value.toString():null;r.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"local"}),fileContent:w[i],localContent:s,remoteResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"remote"}),remoteContent:I[i],previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"accepted"})})}for(const i of p.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"remote"}),remoteContent:I[i],previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"accepted"})})}for(const i of p.conflicts){const t={content:n[i]??null,hasConflicts:!0,localChange:w[i]?2:1,remoteChange:I[i]?2:1},s=w[i]?w[i].value.toString():null;r.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"local"}),fileContent:w[i]||null,localContent:s,remoteResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"remote"}),remoteContent:I[i]||null,previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"accepted"})})}for(const i of Object.keys(w))if(!r.has(i)){const t={content:w[i]?w[i].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=w[i]?w[i].value.toString():null;r.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"local"}),fileContent:w[i]||null,localContent:s,remoteResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"remote"}),remoteContent:I[i]||null,previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:$.$Mdb,authority:"accepted"})})}return[...r.values()]}async resolveContent(p){return this.h.isEqualOrParent(p,this.g.with({scheme:$.$Mdb,authority:"remote"}))||this.h.isEqualOrParent(p,this.g.with({scheme:$.$Mdb,authority:"local"}))||this.h.isEqualOrParent(p,this.g.with({scheme:$.$Mdb,authority:"base"}))||this.h.isEqualOrParent(p,this.g.with({scheme:$.$Mdb,authority:"accepted"}))?this.ab(p):null}async hasLocalData(){try{const p=await this.Cb();if(Object.keys(p).length)return!0}catch{}return!1}async xb(p){const w={};for(const I of p)I.fileContent&&(w[this.h.basename(I.localResource)]=I.fileContent);await this.kb(JSON.stringify(this.Bb(w)))}async yb(p,w){for(const{fileContent:I,acceptResult:n,localResource:r,remoteResource:i,localChange:t}of p)if(t!==0){const s=i?this.h.basename(i):this.h.basename(r),o=this.h.joinPath(this.p,s);t===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(o)),await this.C.del(o),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(o))):t===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(o)),await this.C.createFile(o,R.$Ib.fromString(n.content),{overwrite:w}),this.L.info(`${this.y}: Created snippet`,this.h.basename(o))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(o)),await this.C.writeFile(o,R.$Ib.fromString(n.content),w?void 0:I),this.L.info(`${this.y}: Updated snippet`,this.h.basename(o)))}}async zb(p,w,I){const n=w.syncData?this.Ab(w.syncData):{},r=(0,L.$Dm)(n);for(const{acceptResult:i,localResource:t,remoteResource:s,remoteChange:o}of p)if(o!==0){const c=t?this.h.basename(t):this.h.basename(s);o===3?delete r[c]:r[c]=i.content}return(0,f.$SYb)(n,r)||(this.L.trace(`${this.y}: Updating remote snippets...`),w=await this.jb(JSON.stringify(r),I?null:w.ref),this.L.info(`${this.y}: Updated remote snippets`)),w}Ab(p){return v(p)}Bb(p){const w={};for(const I of Object.keys(p))w[I]=p[I].value.toString();return w}async Cb(){const p={};let w;try{w=await this.C.resolve(this.p)}catch(I){if(I instanceof C.$9j&&I.fileOperationResult===1)return p;throw I}for(const I of w.children||[]){const n=I.resource,r=this.h.extname(n);if(r===".json"||r===".code-snippets"){const i=this.h.relativePath(this.p,n),t=await this.C.readFile(n);p[i]=t}}return p}};e.$UYb=a=we([Y(2,O.$sh),Y(3,C.$Oj),Y(4,k.$Go),Y(5,$.$vdb),Y(6,$.$wdb),Y(7,$.$Kdb),Y(8,j.$Rh),Y(9,$.$Fdb),Y(10,m.$Rk),Y(11,S.$lk)],a);let h=e.$VYb=class extends b.$Zxb{constructor(p,w,I,n,r,i){super("snippets",w,I,n,p,r,i)}async o(p){const w=p.syncData?JSON.parse(p.syncData.content):null;if(!w){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(w)){const r=w[n];if(r){const i=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(i,R.$Ib.fromString(r)),this.j.info("Created snippet",this.d.basename(i))}}await this.n(p)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(p){return p.fileOperationResult===1}}};e.$VYb=h=we([Y(0,C.$Oj),Y(1,E.$nk),Y(2,O.$sh),Y(3,$.$Kdb),Y(4,k.$Go),Y(5,S.$lk)],h)}),define(ae[119],ce([0,1,16,18,14,13,19,20,29,17,39,23]),function(ne,e,R,M,L,j,O,C,k,m,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YYb=e.$XYb=e.$WYb=void 0;function b(a,h){try{return JSON.parse(a).tasks??null}catch(u){return h.error(u),null}}e.$WYb=b;let f=e.$XYb=class extends S.$Xxb{constructor(h,u,p,w,I,n,r,i,t,s,o,c){super(h.tasksResource,{syncResource:"tasks",profile:h},u,i,t,s,p,w,r,o,I,n,c),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:E.$Mdb,authority:"base"}),this.xb=this.vb.with({scheme:E.$Mdb,authority:"local"}),this.yb=this.vb.with({scheme:E.$Mdb,authority:"remote"}),this.zb=this.vb.with({scheme:E.$Mdb,authority:"accepted"})}async nb(h,u,p,w){const I=h.syncData?b(h.syncData.content,this.L):null;u=u===null&&p?h:u;const n=u?.syncData?b(u.syncData.content,this.L):null,r=await this.p();let i=null,t=!1,s=!1,o=!1;if(h.syncData){const d=r?r.value.toString():null;if(!n||n!==d||n!==I){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const l=v(d,I,n);i=l.content,o=l.hasConflicts,t=l.hasLocalChanged,s=l.hasRemoteChanged}}else r&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),i=r.value.toString(),s=!0);const c={content:o?n:i,localChange:t?r?2:1:0,remoteChange:s?2:0,hasConflicts:o},y=r?r.value.toString():null;return[{fileContent:r,baseResource:this.wb,baseContent:n,localResource:this.xb,localContent:y,localChange:c.localChange,remoteResource:this.yb,remoteContent:I,remoteChange:c.remoteChange,previewResource:this.vb,previewResult:c,acceptedResource:this.zb}]}async rb(h){const u=h?.syncData?b(h.syncData.content,this.L):null;if(u===null)return!0;const p=await this.p(),w=p?p.value.toString():null,I=v(w,u,u);return I.hasLocalChanged||I.hasRemoteChanged}async ob(h,u){return h.previewResult}async pb(h,u,p,w){if(this.h.isEqual(u,this.xb))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.yb))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.vb))return p===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:p,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async qb(h,u,p,w){const{fileContent:I}=p[0][0],{content:n,localChange:r,remoteChange:i}=p[0][1];if(r===0&&i===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),r!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),I&&await this.kb(JSON.stringify(this.Fb(I.value.toString()))),n?await this.r(n,I,w):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),i!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const t=JSON.stringify(this.Fb(n));h=await this.jb(t,w?null:h.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}u?.ref!==h.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(h),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(h){return this.h.isEqual(this.yb,h)||this.h.isEqual(this.wb,h)||this.h.isEqual(this.xb,h)||this.h.isEqual(this.zb,h)?this.ab(h):null}Fb(h){return h?{tasks:h}:{}}};e.$XYb=f=we([Y(2,E.$vdb),Y(3,E.$wdb),Y(4,E.$Kdb),Y(5,M.$Rh),Y(6,E.$Fdb),Y(7,j.$Oj),Y(8,L.$sh),Y(9,O.$Go),Y(10,C.$Rk),Y(11,k.$lk)],f);let $=e.$YYb=class extends S.$Zxb{constructor(h,u,p,w,I,n){super("tasks",u,p,w,h,I,n),this.c=this.g.defaultProfile.tasksResource}async o(h){const u=h.syncData?b(h.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,R.$Ib.fromString(u)),await this.n(h)}async p(){return this.k.exists(this.c)}};e.$YYb=$=we([Y(0,j.$Oj),Y(1,m.$nk),Y(2,L.$sh),Y(3,E.$Kdb),Y(4,O.$Go),Y(5,k.$lk)],$);function v(a,h,u){if(a===null&&h===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(a===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const p=u!==a,w=u!==h;return!p&&!w?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:p&&!w?{content:a,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:w&&!p?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:a,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[120],ce([0,1,41,18,14,13,19,20,29,17,39,229,23]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B1b=e.$A1b=e.$z1b=void 0;let f=e.$z1b=class extends S.$Wxb{constructor(h,u,p,w,I,n,r,i,t,s,o,c,y){super({syncResource:"profiles",profile:h},u,w,I,n,r,i,o,c,t,s,y),this.r=p,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:b.$Mdb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$Mdb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$Mdb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$Mdb,authority:"accepted"})}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?v(h.syncData):null}async getRemoteSyncedProfiles(h){const u=await this.getLastSyncUserData(),p=await this.S(h,u);return p?.syncData?v(p.syncData):null}async nb(h,u,p){if(!this.r.isEnabled())throw new b.$Adb("Cannot sync profiles because they are disabled","LocalError");const w=h.syncData?v(h.syncData):null,I=u?.syncData?v(u.syncData):null,n=this.zb(),{local:r,remote:i}=(0,E.$y1b)(n,w,I,[]),t={local:r,remote:i,content:I?this.Ab(I):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:i!==null?2:0},s=$(n,!1);return[{baseResource:this.baseResource,baseContent:I?this.Ab(I):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:w?this.Ab(w):null,remoteProfiles:w,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async rb(h){const u=h?.syncData?v(h.syncData):null,p=this.zb(),{remote:w}=(0,E.$y1b)(p,u,u,[]);return!!w?.added.length||!!w?.removed.length||!!w?.updated.length}async ob(h,u){return{...h.previewResult,hasConflicts:!1}}async pb(h,u,p,w){if(this.h.isEqual(u,this.localResource))return this.wb(h);if(this.h.isEqual(u,this.remoteResource))return this.xb(h);if(this.h.isEqual(u,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async wb(h){const u=this.zb(),p=(0,E.$y1b)(u,null,null,[]),{local:w,remote:I}=p;return{content:h.localContent,local:w,remote:I,localChange:w.added.length>0||w.removed.length>0||w.updated.length>0?2:0,remoteChange:I!==null?2:0}}async xb(h){const u=h.remoteContent?JSON.parse(h.remoteContent):null,p=[],w=[];for(const I of this.zb()){const n=u?.find(r=>r.id===I.id);n&&(p.push({id:I.id,name:I.name,collection:n.collection}),w.push(I))}if(u!==null){const I=(0,E.$y1b)(w,u,p,[]),{local:n,remote:r}=I;return{content:h.remoteContent,local:n,remote:r,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(h,u,p,w){const{local:I,remote:n,localChange:r,remoteChange:i}=p[0][1];r===0&&i===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const t=p[0][0].remoteProfiles||[];if(t.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new b.$Adb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0){await this.kb($(this.zb(),!1));const s=[];for(const o of I.added)s.push((async()=>{this.L.trace(`${this.y}: Creating '${o.name}' profile...`),await this.r.createProfile(o.id,o.name,{shortName:o.shortName}),this.L.info(`${this.y}: Created profile '${o.name}'.`)})());for(const o of I.removed)s.push((async()=>{this.L.trace(`${this.y}: Removing '${o.name}' profile...`),await this.r.removeProfile(o),this.L.info(`${this.y}: Removed profile '${o.name}'.`)})());for(const o of I.updated){const c=this.r.profiles.find(y=>y.id===o.id);c?s.push((async()=>{this.L.trace(`${this.y}: Updating '${o.name}' profile...`),await this.r.updateProfile(c,{name:o.name,shortName:o.shortName}),this.L.info(`${this.y}: Updated profile '${o.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${o.id}' to update.`)}await Promise.all(s)}if(i!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const s=[],o=t.length+(n?.added.length??0)<=20;if(o)for(const c of n?.added||[]){const y=await this.G.createCollection(this.z);s.push(y),t.push({id:c.id,name:c.name,collection:y,shortName:c.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const c of n?.removed||[])t.splice(t.findIndex(({id:y})=>c.id===y),1);for(const c of n?.updated||[]){const y=t.find(({id:d})=>c.id===d);y&&t.splice(t.indexOf(y),1,{id:c.id,name:c.name,collection:y.collection,shortName:c.shortName})}try{h=await this.updateRemoteProfiles(t,w?null:h.ref),this.L.info(`${this.y}: Updated remote profiles.${o&&n?.added.length?` Added: ${JSON.stringify(n.added.map(c=>c.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(c=>c.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(c=>c.name))}.`:""}`)}catch(c){if(s.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const y of s)await this.G.deleteCollection(y,this.z)}throw c}for(const c of n?.removed||[])await this.G.deleteCollection(c.collection,this.z)}u?.ref!==h.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(h),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,u){return this.jb(this.Ab(h),u)}async hasLocalData(){return this.zb().length>0}async resolveContent(h){if(this.h.isEqual(this.remoteResource,h)||this.h.isEqual(this.baseResource,h)||this.h.isEqual(this.localResource,h)||this.h.isEqual(this.acceptedResource,h)){const u=await this.ab(h);return u&&(0,R.$AR)(JSON.parse(u),{})}return null}zb(){return this.r.profiles.filter(h=>!h.isDefault&&!h.isTransient)}Ab(h){return JSON.stringify([...h].sort((u,p)=>u.name.localeCompare(p.name)))}};e.$z1b=f=we([Y(2,m.$nk),Y(3,j.$Oj),Y(4,L.$sh),Y(5,O.$Go),Y(6,b.$vdb),Y(7,b.$wdb),Y(8,b.$Kdb),Y(9,M.$Rh),Y(10,b.$Fdb),Y(11,C.$Rk),Y(12,k.$lk)],f);function $(a,h){const u=[...a].sort((p,w)=>p.name.localeCompare(w.name)).map(p=>({id:p.id,name:p.name}));return h?(0,R.$AR)(u,{}):JSON.stringify(u)}e.$A1b=$;function v(a){return JSON.parse(a.content)}e.$B1b=v}),define(ae[246],ce([0,1,6,16,63,2,22,18,14,13,17,23]),function(ne,e,R,M,L,j,O,C,k,m,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x1b=void 0;let b=e.$x1b=class extends j.$kb{constructor($,v,a,h,u){super(),this.a=$,this.b=v,this.c=a,this.f=h,this.g=u,this.h()}async h(){for(const v of this.g.profiles)for(const a of E.$rdb)try{await this.j(this.i(v,a))}catch(h){this.f.error(h)}let $;try{$=await this.b.resolve(this.a.userDataSyncHome)}catch(v){(0,m.$5j)(v)!==1&&this.f.error(v);return}if($.children){for(const v of $.children)if(v.isDirectory&&!this.g.profiles.some(a=>a.id===v.name))try{this.f.info("Deleting non existing profile from backup",v.resource.path),await this.b.del(v.resource,{recursive:!0})}catch(a){this.f.error(a)}}}async getAllRefs($,v){const a=this.i($,v);try{const h=await this.b.resolve(a);if(h.children)return h.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.k(p)}))}catch(h){if((0,m.$5j)(h)!==1)throw h}return[]}async resolveContent($,v,a){const h=this.i($,v),u=(0,O.$6f)(h,a);try{return(await this.b.readFile(u)).value.toString()}catch(p){return this.f.error(p),null}}async backup($,v,a){const h=this.i($,v),u=(0,O.$6f)(h,`${(0,L.$Ol)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(u,M.$Ib.fromString(a))}catch(p){this.f.error(p)}try{this.j(h)}catch{}}i($,v){return(0,O.$6f)(this.a.userDataSyncHome,...$.isDefault?[v]:[$.id,v])}async j($){try{try{if(!await this.b.exists($))return}catch{return}const v=await this.b.resolve($);if(v.children){const a=v.children.filter(w=>w.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(w.name)).sort(),h=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=a.filter(w=>Date.now()-this.k(w)>h);const p=a.length-u.length;p<10&&(u=u.slice(10-p)),await R.Promises.settled(u.map(async w=>{this.f.info("Deleting from backup",w.resource.path),await this.b.del(w.resource)}))}}catch(v){this.f.error(v)}}k($){return $.ctime||new Date(parseInt($.name.substring(0,4)),parseInt($.name.substring(4,6))-1,parseInt($.name.substring(6,8)),parseInt($.name.substring(9,11)),parseInt($.name.substring(11,13)),parseInt($.name.substring(13,15))).getTime()}};e.$x1b=b=we([Y(0,k.$sh),Y(1,m.$Oj),Y(2,C.$Rh),Y(3,E.$Kdb),Y(4,S.$nk)],b)}),define(ae[247],ce([0,1,3,2,5,14,19,20,23]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m1b=void 0;const m="sync.enable";let S=e.$m1b=class extends M.$kb{constructor(b,f,$,v){super(),this.c=b,this.f=f,this.g=$,this.h=v,this.a=new R.$5c,this.onDidChangeEnablement=this.a.event,this.b=new R.$5c,this.onDidChangeResourceEnablement=this.b.event,this.B(b.onDidChangeValue(a=>this.j(a)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(m,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(b){b&&!this.canToggleEnablement()||(this.f.publicLog2(m,{enabled:b}),this.c.store(m,b,-1,1))}isResourceEnabled(b){return this.c.getBoolean((0,k.$Edb)(b),-1,!0)}setResourceEnablement(b,f){if(this.isResourceEnabled(b)!==f){const $=(0,k.$Edb)(b);this.i($,f)}}getResourceSyncStateVersion(b){}i(b,f){this.c.store(b,f,-1,L.$o?0:1)}j(b){if(b.scope!==-1)return;if(m===b.key){this.a.fire(this.isEnabled());return}const f=k.$rdb.filter($=>(0,k.$Edb)($)===b.key)[0];if(f){this.b.fire([f,this.isResourceEnabled(f)]);return}}};e.$m1b=S=we([Y(0,O.$Go),Y(1,C.$Rk),Y(2,j.$sh),Y(3,k.$udb)],S)}),define(ae[80],ce([0,1,3,2,5,27,169,14,13,4,24,44,19,23]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BWb=e.$AWb=e.$zWb=void 0,e.$zWb=(0,m.$lh)("IUserDataSyncMachinesService");const $="sync.currentMachineName",v="Safari",a="Chrome",h="Edge",u="Firefox",p="Android";function w(r){switch(r){case v:case a:case h:case u:case p:case(0,L.$h)(0):return!0}return!1}e.$AWb=w;function I(){return L.$F?v:L.$D?a:L.$G?h:L.$E?u:L.$H?p:(0,L.$h)(L.$o?0:L.$t)}let n=e.$BWb=class it extends M.$kb{constructor(i,t,s,o,c,y){super(),this.h=s,this.i=o,this.j=c,this.k=y,this.c=this.B(new R.$5c),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$Mo)(i,t,s)}async getMachines(i){const t=await this.f;return(await this.m(i)).machines.map(o=>({...o,isCurrent:o.id===t}))}async addCurrentMachine(i){const t=await this.f,s=await this.m(i);s.machines.some(({id:o})=>o===t)||(s.machines.push({id:t,name:this.l(s.machines),platform:I()}),await this.n(s))}async removeCurrentMachine(i){const t=await this.f,s=await this.m(i),o=s.machines.filter(({id:c})=>c!==t);o.length!==s.machines.length&&(s.machines=o,await this.n(s))}async renameMachine(i,t,s){const o=await this.m(s),c=o.machines.find(({id:y})=>y===i);if(c){c.name=t,await this.n(o);const y=await this.f;i===y&&this.h.store($,t,-1,1)}}async setEnablements(i){const t=await this.m();for(const[s,o]of i){const c=t.machines.find(y=>y.id===s);c&&(c.disabled=o?void 0:!0)}await this.n(t)}l(i){const t=this.h.get($,-1);if(t)return t;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${I()} (${this.k.nameShort})`,o=new RegExp(`${(0,j.$ld)(s)}\\s#(\\d+)`);let c=0;for(const y of i){const d=o.exec(y.name),l=d?parseInt(d[1]):0;c=l>c?l:c}return`${s} #${c+1}`}async m(i){this.g=await this.p(i);const t=this.r(this.g);if(t.version!==it.a)throw new Error((0,O.localize)(0,null,this.k.nameLong));return t}async n(i){const t=JSON.stringify(i),s=await this.i.writeResource(it.b,t,this.g?.ref||null);this.g={ref:s,content:t},this.c.fire()}async p(i){if(this.g){const t=i&&i.latest?i.latest[it.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.i.readResource(it.b,this.g)}r(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.j.error(t)}return{version:it.a,machines:[]}}};n.a=1,n.b="machines",e.$BWb=n=we([Y(0,C.$sh),Y(1,k.$Oj),Y(2,b.$Go),Y(3,f.$vdb),Y(4,f.$Kdb),Y(5,S.$6i)],n)}),define(ae[248],ce([0,1,6,63,38,7,3,2,5,22,12,166,24,19,20,23,77,80]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D1b=void 0;const u="sync.disableMachineEventually",p="sync.sessionId",w="sync.storeUrl",I="sync.productQuality";let n=e.$D1b=class extends C.$kb{get j(){const t=this.z.get(w,-1);return t?S.URI.parse(t):void 0}set j(t){t?this.z.store(w,t.toString(),-1,1):this.z.remove(w,-1)}get l(){return this.z.get(I,-1)}set l(t){t?this.z.store(I,t,-1,1):this.z.remove(I,-1)}constructor(t,s,o,c,y,d,l,P,D,T){super(),this.n=s,this.p=o,this.r=c,this.s=y,this.u=d,this.v=l,this.w=P,this.y=D,this.z=T,this.a=this.B(new C.$lb),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$5c),this.onError=this.h.event,this.N=[],this.f=this.B(new R.$pg(this.O())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=t.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,m.$Yf)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(l.onDidChangeAccount(()=>this.C())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(y.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(O.Event.filter(this.r.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:t,message:s}=this.F();t?this.a.value===void 0&&(this.a.value=new r(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.w,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.I(o))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.u.info(s),this.a.clear()):s&&this.r.isEnabled()&&this.u.info(s))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,M.$Ol)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(t,s,o){try{this.v.account&&!o&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(p,-1),t?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(c){if(this.u.error(c),s)this.G(!1);else throw c}}G(t){this.r.isEnabled()!==t&&(this.r.setEnablement(t),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(t){if(!t){this.b=0;return}const s=v.$Adb.toUserDataSyncError(t);s instanceof v.$Cdb&&this.w.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?k.$o&&s.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(s),this.b++),this.h.fire(s)}async J(){this.z.store(u,!0,-1,1),await(0,R.$sg)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(u,-1,!1)}M(){this.z.remove(u,-1)}async triggerSync(t,s,o){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...t),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const c=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:c}),this.N=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};e.$D1b=n=we([Y(0,b.$6i),Y(1,v.$udb),Y(2,v.$vdb),Y(3,v.$Fdb),Y(4,v.$Gdb),Y(5,v.$Kdb),Y(6,a.$ywb),Y(7,$.$Rk),Y(8,h.$zWb),Y(9,f.$Go)],n);class r extends C.$kb{constructor(t,s,o,c,y,d,l,P,D){super(),this.j=t,this.k=s,this.l=o,this.m=c,this.n=y,this.p=d,this.r=l,this.s=P,this.u=D,this.b=this.B(new C.$lb),this.c=this.B(new O.$5c),this.onDidStartSync=this.c.event,this.f=this.B(new O.$5c),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.v())),this.B((0,C.$ib)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}v(){this.b.value=(0,R.$tg)(()=>this.sync(r.a,!1),this.k)}sync(t,s){const o=(0,R.$fg)(async c=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(y){if((0,j.$1)(y))return}return this.z(t,s,c)});return this.i=o,this.i.finally(()=>this.i=void 0),this.i}w(){return this.j!==void 0&&!(0,m.$Yf)(this.j,this.l.userDataSyncStore?.url)}async y(){const t=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!t&&(!(0,m.$Yf)(s.defaultUrl,t.defaultUrl)||!(0,m.$Yf)(s.insidersUrl,t.insidersUrl)||!(0,m.$Yf)(s.stableUrl,t.stableUrl))}async z(t,s,o){this.r.info(`Auto Sync: Triggered by ${t}`),this.c.fire();let c;try{await this.C(s,o)}catch(y){if(this.r.error(y),c=y,v.$Adb.toUserDataSyncError(y).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.C(s,o),c=void 0}catch(d){this.r.error(d),c=d}}this.f.fire(c)}async C(t,s){if(this.h=await this.n.createSyncTask(this.g,t),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.w()?await this.y()?new v.$Cdb((0,E.localize)(0,null),"DefaultServiceChanged"):new v.$Cdb((0,E.localize)(1,null),"ServiceChanged"):new v.$Cdb((0,E.localize)(2,null),"TurnedOff");const o=this.u.get(p,-1);if(o&&this.g&&o!==this.g.session)throw this.w()?await this.y()?new v.$Cdb((0,E.localize)(3,null),"DefaultServiceChanged"):new v.$Cdb((0,E.localize)(4,null),"ServiceChanged"):new v.$Cdb((0,E.localize)(5,null),"SessionExpired");const c=await this.p.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const y=c.find(l=>l.isCurrent);if(y?.disabled)throw new v.$Cdb((0,E.localize)(6,null),"TurnedOff");const d=new Date().getTime();if(await this.h.run(),this.s.publicLog2("settingsSync:sync",{duration:new Date().getTime()-d}),this.g===null)try{this.g=await this.m.manifest(null)}catch(l){throw new v.$Cdb((0,L.$9h)(l),l instanceof v.$Adb?l.code:"Unknown")}this.g&&this.g.session!==o&&this.u.store(p,this.g.session,-1,1),!s.isCancellationRequested&&(y||await this.p.addCurrentMachine(this.g||void 0))}register(t){return super.B(t)}}r.a="Interval"}),define(ae[249],ce([0,1,12,170,14,13,44,19,29,23,17,39,118,117,116,18,119,114,115,4,120,41]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u,p,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c2b=void 0;let n=e.$c2b=class We{constructor(i,t,s,o,c,y,d,l,P,D){this.e=i,this.f=t,this.g=s,this.h=c,this.i=y,this.j=d,this.k=l,this.l=P,this.m=D,this.d=o.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const t=this.K(i.content,"profiles");return(0,w.$B1b)(t)}return[]}async getRemoteSyncResourceHandles(i,t){return(await this.e.getAllResourceRefs(i,t?.collection)).map(({created:o,ref:c})=>({created:o,uri:this.I({remote:!0,syncResource:i,profile:t?.id??this.k.defaultProfile.id,collection:t?.collection,ref:c,node:void 0})}))}async getLocalSyncResourceHandles(i,t){return(await this.f.getAllRefs(t,i)).map(({created:o,ref:c})=>({created:o,uri:this.I({remote:!1,syncResource:i,profile:t.id,collection:void 0,ref:c,node:void 0})}))}resolveUserDataSyncResource({uri:i}){const t=this.J(i),s=t?this.k.profiles.find(o=>o.id===t.profile):void 0;return t&&s?{profile:s,syncResource:t?.syncResource}:void 0}async getAssociatedResources({uri:i}){const t=this.J(i);if(!t)return[];const s=this.k.profiles.find(o=>o.id===t.profile);switch(t.syncResource){case"settings":return this.r(i,s);case"keybindings":return this.t(i,s);case"tasks":return this.v(i,s);case"snippets":return this.x(i,s);case"globalState":return this.C(i,s);case"extensions":return this.z(i,s);case"profiles":return this.F(i,s);case"workspaceState":return[]}}async getMachineId({uri:i}){const t=this.J(i);if(t){if(t.remote){if(t.ref){const{content:s}=await this.L(t.syncResource,t.ref,t.collection);if(s)return this.K(s,t.syncResource)?.machineId}return}return(0,O.$Mo)(this.h,this.j,this.i)}}async resolveContent(i){const t=this.J(i);if(!t||t.node===We.a)return null;if(t.ref){const s=await this.n(t.remote,t.syncResource,t.profile,t.collection,t.ref);return t.node&&s?this.o(t.syncResource,s,t.node):s}return!t.remote&&!t.node?this.q(t.syncResource,t.profile):null}async n(i,t,s,o,c){if(i){const{content:d}=await this.L(t,c,o);return d}const y=this.k.profiles.find(d=>d.id===s);return y?this.f.resolveContent(y,t,c):null}o(i,t,s){const o=this.K(t,i);switch(i){case"settings":return this.s(o,s);case"keybindings":return this.u(o,s);case"tasks":return this.w(o,s);case"snippets":return this.y(o,s);case"globalState":return this.D(o,s);case"extensions":return this.A(o,s);case"profiles":return this.G(o,s);case"workspaceState":return null}}async q(i,t){const s=this.k.profiles.find(o=>o.id===t);if(!s)return null;switch(i){case"globalState":return this.E(s);case"extensions":return this.B(s);case"profiles":return this.H(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}r(i,t){const s=this.d.joinPath(i,"settings.json"),o=t?t.settingsResource:this.d.joinPath(i,We.a);return[{resource:s,comparableResource:o}]}s(i,t){switch(t){case"settings.json":return(0,f.$OYb)(i.content).settings}return null}t(i,t){const s=this.d.joinPath(i,"keybindings.json"),o=t?t.keybindingsResource:this.d.joinPath(i,We.a);return[{resource:s,comparableResource:o}]}u(i,t){switch(t){case"keybindings.json":return(0,$.$LYb)(i.content,!!this.l.getValue(m.$odb),this.g)}return null}v(i,t){const s=this.d.joinPath(i,"tasks.json"),o=t?t.tasksResource:this.d.joinPath(i,We.a);return[{resource:s,comparableResource:o}]}w(i,t){switch(t){case"tasks.json":return(0,a.$WYb)(i.content,this.g)}return null}async x(i,t){const s=await this.resolveContent(i);if(s){const o=this.K(s,"snippets");if(o){const c=(0,b.$TYb)(o),y=[];for(const d of Object.keys(c)){const l=this.d.joinPath(i,d),P=t?this.d.joinPath(t.snippetsHome,d):this.d.joinPath(i,We.a);y.push({resource:l,comparableResource:P})}return y}}return[]}y(i,t){return(0,b.$TYb)(i)[t]||null}z(i,t){const s=this.d.joinPath(i,"extensions.json"),o=t?this.I({remote:!1,syncResource:"extensions",profile:t.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,We.a);return[{resource:s,comparableResource:o}]}A(i,t){switch(t){case"extensions.json":return(0,h.$GYb)((0,h.$FYb)(i),!0)}return null}async B(i){const{localExtensions:t}=await this.m.createInstance(h.$IYb).getLocalExtensions(i);return(0,h.$GYb)(t,!0)}C(i,t){const s=this.d.joinPath(i,"globalState.json"),o=t?this.I({remote:!1,syncResource:"globalState",profile:t.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,We.a);return[{resource:s,comparableResource:o}]}D(i,t){switch(t){case"globalState.json":return(0,u.$2xb)(JSON.parse(i.content),!0)}return null}async E(i){const t=await this.m.createInstance(u.$4xb).getLocalGlobalState(i);return(0,u.$2xb)(t,!0)}F(i,t){const s=this.d.joinPath(i,"profiles.json"),o=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:o}]}G(i,t){switch(t){case"profiles.json":return(0,I.$AR)(JSON.parse(i.content),{})}return null}async H(i){return(0,w.$A1b)(this.k.profiles.filter(t=>!t.isDefault&&!t.isTransient),!0)}I(i){const t=i.remote?We.b:We.c,s=[i.syncResource,i.profile];return i.collection&&s.push(`collection:${i.collection}`),i.ref&&s.push(`ref:${i.ref}`),i.node&&s.push(i.node),this.d.joinPath(R.URI.from({scheme:m.$Mdb,authority:t,path:"/"}),...s)}J(i){if(i.scheme!==m.$Mdb||i.authority!==We.c&&i.authority!==We.b)return;const t=[];for(;i.path!=="/";)t.unshift(this.d.basename(i)),i=this.d.dirname(i);if(t.length<2)return;const s=i.authority===We.b,o=t.shift(),c=t.shift();let y,d,l;for(;t.length;){const P=t.shift();P.startsWith("collection:")?y=P.substring(11):P.startsWith("ref:")?d=P.substring(4):l=P}return{remote:s,syncResource:o,profile:c,collection:y,ref:d,node:l}}K(i,t){try{const s=JSON.parse(i);if((0,E.$Uxb)(s))return s}catch(s){this.g.error(s)}throw new m.$Adb((0,M.localize)(0,null),"IncompatibleRemoteContent",t)}async L(i,t,s){const o=await this.e.resolveResourceContent(i,t,s);return{ref:t,content:o}}};n.a="not-existing-resource",n.b="remote-backup",n.c="local-backup",e.$c2b=n=we([Y(0,m.$vdb),Y(1,m.$wdb),Y(2,m.$Kdb),Y(3,k.$lk),Y(4,L.$sh),Y(5,C.$Go),Y(6,j.$Oj),Y(7,S.$nk),Y(8,v.$Rh),Y(9,p.$kh)],n)}),define(ae[250],ce([0,1,21,6,26,38,3,2,22,10,32,18,28,4,19,20,17,114,115,116,117,118,119,120,23]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u,p,w,I,n,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C1b=void 0;const t="sync.lastSyncTime";let s=e.$C1b=class extends C.$kb{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(l,P,D,T,F,H,V,W,x){super(),this.v=l,this.w=P,this.y=D,this.z=T,this.C=F,this.D=H,this.F=V,this.G=W,this.H=x,this.f="uninitialized",this.g=this.B(new O.$5c),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$5c),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new O.$5c),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new O.$5c),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new O.$5c),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new O.$5c),this.onDidResetLocal=this.r.event,this.t=this.B(new O.$5c),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=P.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(t,-1,void 0),this.B((0,C.$ib)(()=>this.W()))}async createSyncTask(l,P){this.X(),this.z.info("Sync started.");const D=new Date().getTime(),T=(0,S.$3e)();try{const W=(0,i.$zdb)(T);P&&(W["Cache-Control"]="no-cache"),l=await this.v.manifest(l,W)}catch(W){const x=i.$Adb.toUserDataSyncError(W);throw y(x,T,this.w,this.C),x}const F=!1,H=this;let V;return{manifest:l,async run(){if(F)throw new Error("Can run a task only once");V=(0,M.$fg)(W=>H.I(l,!1,T,W)),await V.finally(()=>V=void 0),H.z.info(`Sync done. Took ${new Date().getTime()-D}ms`),H.S()},stop(){return V?.cancel(),H.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new i.$Adb("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const l=new Date().getTime(),P=(0,S.$3e)(),D=(0,i.$zdb)(P);let T;try{T=await this.v.manifest(null,D)}catch(V){const W=i.$Adb.toUserDataSyncError(V);throw y(W,P,this.w,this.C),W}await this.resetLocal();const F=this,H=new L.$bd;return{id:P,async merge(){return F.I(T,!0,P,H.token)},async apply(){try{try{await F.L(T,P,H.token)}catch(V){if(i.$Adb.toUserDataSyncError(V).code==="MethodNotFound")F.z.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.z.info("Applying manual sync again..."),await F.L(T,P,H.token);else throw V}}catch(V){throw F.z.error(V),V}F.z.info(`Sync done. Took ${new Date().getTime()-l}ms`),F.S()},async stop(){H.cancel(),await F.N(),await F.resetLocal()}}}async I(l,P,D,T){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(F,l,P,D,T));const H=F.enabled.find(V=>V.resource==="profiles");if(H){const V=await H.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.J(V,l,P,D,T)}}finally{this.l.fire(this.k)}}async J(l,P,D,T,F){for(const H of l){if(F.isCancellationRequested)return;const V=this.G.profiles.find(x=>x.id===H.id);if(!V){this.z.error(`Profile with id:${H.id} and name: ${H.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",H.name);const W=this.getOrCreateActiveProfileSynchronizer(V,H);this.k.push(...await this.M(W,P,D,T,F))}for(const[H,V]of this.u.entries())this.G.profiles.some(W=>W.id===V[0].profile.id)||(V[1].dispose(),this.u.delete(H))}async L(l,P,D){const T=this.U();for(const x of T){if(D.isCancellationRequested)return;await x.apply(P,D)}const F=T.find(x=>x.profile.isDefault);if(!F)return;const H=F.enabled.find(x=>x.resource==="profiles");if(!H)return;const W=(await H.getRemoteSyncedProfiles(l?.latest??null)||[]).filter(x=>T.every(ee=>ee.profile.id!==x.id));W.length&&await this.J(W,l,!1,P,D)}async M(l,P,D,T,F){return(await l.sync(P,D,T,F)).map(([V,W])=>({profile:l.profile,syncResource:V,error:W}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(l=>l.stop()))}async resolveContent(l){const P=await this.H.resolveContent(l);if(P)return P;for(const D of this.U())for(const T of D.enabled){const F=await T.resolveContent(l);if(F)return F}return null}async replace(l){this.X();const P=this.H.resolveUserDataSyncResource(l);if(!P)return;const D=await this.resolveContent(l.uri);D&&await this.O(P.profile,async T=>{if(P.syncResource===T.resource)return await T.replace(D),!0})}async accept(l,P,D,T){this.X(),await this.O(l.profile,async F=>{if(l.syncResource===F.resource)return await F.accept(P,D),T&&await F.apply((0,m.$me)(T)?!1:T.force,(0,i.$zdb)((0,S.$3e)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(l,P){return this.H.getRemoteSyncResourceHandles(l,P)}async getLocalSyncResourceHandles(l,P){return this.H.getLocalSyncResourceHandles(l,P??this.G.defaultProfile)}async getAssociatedResources(l){return this.H.getAssociatedResources(l)}async getMachineId(l){return this.H.getMachineId(l)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async P=>{if(P.resource!=="globalState"&&await P.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async P=>{if(await P.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(l){this.z.error(l)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(t,-1);for(const[l]of this.u.values())try{await l.resetLocal()}catch(P){this.z.error(P)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const l=await this.H.getRemoteSyncedProfiles(),P=l.map(H=>H.collection),D=await this.v.getAllCollections(),T=D.filter(H=>!P.includes(H));T.length&&(this.z.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(H=>this.v.deleteCollection(H))),this.z.info("Deleted redundant collections on server"));const F=l.filter(H=>D.includes(H.collection));if(F.length!==l.length){this.z.info("Updating remote profiles with invalid collections on server");const H=this.y.createInstance(r.$z1b,this.G.defaultProfile,void 0);try{await H.updateRemoteProfiles(F,null),this.z.info("Updated remote profiles on server")}finally{H.dispose()}}}async O(l,P){const D=new C.$jb;try{const T=this.u.get(l.id);if(T){const x=await this.P(T[0],P,D);return(0,m.$ne)(x)?null:x}if(l.isDefault){const x=D.add(this.y.createInstance(o,l,void 0)),ee=await this.P(x,P,D);return(0,m.$ne)(ee)?null:ee}if(this.G.isEnabled())return null;const F=D.add(this.y.createInstance(r.$z1b,l,void 0)),H=await this.v.manifest(null),W=(await F.getRemoteSyncedProfiles(H?.latest??null)||[]).find(x=>x.id===l.id);if(W){const x=D.add(this.y.createInstance(o,l,W.collection)),ee=await this.P(x,P,D);return(0,m.$ne)(ee)?null:ee}return null}finally{D.dispose()}}async P(l,P,D){const T=[...l.enabled,...l.disabled.reduce((F,H)=>(H!=="workspaceState"&&F.push(D.add(l.createSynchronizer(H))),F),[])];for(const F of T){const H=await P(F);if(!(0,m.$ne)(H))return H}}Q(l){const P=this.f;this.f!==l&&(this.f=l,this.g.fire(l),P==="hasConflicts"&&this.S())}R(){const l=this.U().map(P=>P.conflicts).flat();(0,R.$$e)(this.i,l,(P,D)=>P.profile.id===D.profile.id&&P.syncResource===D.syncResource&&(0,R.$$e)(P.conflicts,D.conflicts,(T,F)=>(0,k.$Yf)(T.previewResource,F.previewResource)))||(this.i=l,this.j.fire(l))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(t,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(l,P){let D=this.u.get(l.id);if(D&&D[0].collection!==P?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),D[1].dispose(),D=void 0,this.u.delete(l.id)),!D){const T=new C.$jb,F=T.add(this.y.createInstance(o,l,P?.collection));T.add(F.onDidChangeStatus(H=>this.Q(H))),T.add(F.onDidChangeConflicts(H=>this.R())),T.add(F.onDidChangeLocal(H=>this.h.fire(H))),this.u.set(l.id,D=[F,T])}return D[0]}U(){const l=[];for(const[P]of this.u.values())l.push(P);return l}W(){this.u.forEach(([,l])=>l.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};e.$C1b=s=we([Y(0,i.$vdb),Y(1,i.$udb),Y(2,f.$kh),Y(3,i.$Kdb),Y(4,v.$Rk),Y(5,$.$Go),Y(6,i.$Fdb),Y(7,a.$nk),Y(8,i.$Hdb)],s);let o=class extends C.$kb{get enabled(){return this.f.sort((l,P)=>l[1]-P[1]).map(([l])=>l)}get disabled(){return i.$rdb.filter(l=>!this.l.isResourceEnabled(l))}get status(){return this.g}get conflicts(){return this.j}constructor(l,P,D,T,F,H,V,W,x,ee){super(),this.profile=l,this.collection=P,this.l=D,this.m=T,this.n=F,this.r=H,this.t=V,this.u=W,this.v=x,this.w=ee,this.f=[],this.g="idle",this.h=this.B(new O.$5c),this.onDidChangeStatus=this.h.event,this.i=this.B(new O.$5c),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new O.$5c),this.onDidChangeConflicts=this.k.event,this.B(D.onDidChangeResourceEnablement(([X,_])=>this.y(X,_))),this.B((0,C.$ib)(()=>this.f.splice(0,this.f.length).forEach(([,,X])=>X.dispose())));for(const X of i.$rdb)D.isResourceEnabled(X)&&this.z(X)}y(l,P){P?this.z(l):this.C(l)}z(l){if(this.f.some(([F])=>F.resource===l))return;if(l==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(l==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled())||l==="workspaceState")return;const P=new C.$jb,D=P.add(this.createSynchronizer(l));P.add(D.onDidChangeStatus(()=>this.G())),P.add(D.onDidChangeConflicts(()=>this.H())),P.add(D.onDidChangeLocal(()=>this.i.fire(l)));const T=this.I(l);this.f.push([D,T,P])}C(l){const P=this.f.findIndex(([D])=>D.resource===l);if(P!==-1){const[[D,,T]]=this.f.splice(P,1);T.dispose(),this.G(),Promise.allSettled([D.stop(),D.resetLocal()]).then(null,F=>this.u.error(F))}}createSynchronizer(l){switch(l){case"settings":return this.m.createInstance(w.$PYb,this.profile,this.collection);case"keybindings":return this.m.createInstance(p.$MYb,this.profile,this.collection);case"snippets":return this.m.createInstance(I.$UYb,this.profile,this.collection);case"tasks":return this.m.createInstance(n.$XYb,this.profile,this.collection);case"globalState":return this.m.createInstance(u.$3xb,this.profile,this.collection);case"extensions":return this.m.createInstance(h.$HYb,this.profile,this.collection);case"profiles":return this.m.createInstance(r.$z1b,this.profile,this.collection)}}async sync(l,P,D,T){if(T.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const H=[],V=(0,i.$zdb)(D),W=(this.collection?l?.collections?.[this.collection]?.latest:l?.latest)??null,x=P?await this.D(W):{};for(const ee of F){if(T.isCancellationRequested)return[];if(!this.l.isResourceEnabled(ee.resource))return[];try{if(P){const X=await ee.preview(W,x,V);if(X)for(const _ of X.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&await ee.merge(_.previewResource)}else await ee.sync(W,V)}catch(X){const _=i.$Adb.toUserDataSyncError(X);if(y(_,D,this.r,this.t),c(X))throw _;this.u.error(X),this.u.error(`${ee.resource}: ${(0,j.$9h)(X)}`),H.push([ee.resource,_])}}return H}finally{this.G()}}async apply(l,P){const D=(0,i.$zdb)(l);for(const T of this.enabled){if(P.isCancellationRequested)return;try{await T.apply(!1,D)}catch(F){const H=i.$Adb.toUserDataSyncError(F);if(y(H,l,this.r,this.t),c(F))throw H;this.u.error(F),this.u.error(`${T.resource}: ${(0,j.$9h)(F)}`)}}}async stop(){for(const l of this.enabled)try{l.status!=="idle"&&await l.stop()}catch(P){this.u.error(P)}}async resetLocal(){for(const l of this.enabled)try{await l.resetLocal()}catch(P){this.u.error(`${l.resource}: ${(0,j.$9h)(P)}`),this.u.error(P)}}async D(l){if(!this.profile.isDefault)return{};const P=this.w.getValue(i.$ndb),D=this.enabled.find(T=>T instanceof w.$PYb);if(D){const T=await D.getRemoteUserDataSyncConfiguration(l);return{...P,...T}}return P}F(l){this.g!==l&&(this.g=l,this.h.fire(l))}G(){return this.H(),this.enabled.some(l=>l.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(l=>l.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const l=this.enabled.filter(P=>P.status==="hasConflicts").filter(P=>P.conflicts.conflicts.length>0).map(P=>P.conflicts);(0,R.$$e)(this.j,l,(P,D)=>P.syncResource===D.syncResource&&(0,R.$$e)(P.conflicts,D.conflicts,(T,F)=>(0,k.$Yf)(T.previewResource,F.previewResource)))||(this.j=l,this.k.fire(l))}I(l){switch(l){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=we([Y(2,i.$Fdb),Y(3,f.$kh),Y(4,b.$Ln),Y(5,i.$udb),Y(6,v.$Rk),Y(7,i.$Kdb),Y(8,a.$nk),Y(9,E.$Rh)],o);function c(d){if(d instanceof i.$Adb)switch(d.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function y(d,l,P,D){D.publicLog2("sync/error",{code:d.code,serverCode:d instanceof i.$Bdb?String(d.serverCode):void 0,url:d instanceof i.$Bdb?d.url:void 0,resource:d.resource,executionId:l,service:P.userDataSyncStore.url.toString()})}}),define(ae[251],ce([0,1,3,2,12,17,23]),function(ne,e,R,M,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O4b=e.$N4b=void 0;function C(b,f){return{...b,profile:(0,j.$ok)(b.profile,f.profilesHome.scheme)}}function k(b){return{created:b.created,uri:L.URI.revive(b.uri)}}class m{constructor(f,$,v){this.c=f,this.d=$,this.f=v,this.a=new Map,this.b=new R.$5c}listen(f,$){switch($){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${$}`)}async call(f,$,v){try{return await this.g(f,$,v)}catch(a){throw this.f.error(a),a}}async g(f,$,v){switch($){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(v[0]));case"accept":return this.c.accept(C(v[0],this.d),L.URI.revive(v[1]),v[2],v[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(v[0],v[1]?(0,j.$ok)(v[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(v[0],v[1]);case"replace":return this.c.replace(k(v[0]));case"getAssociatedResources":return this.c.getAssociatedResources(k(v[0]));case"getMachineId":return this.c.getMachineId(k(v[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if($.startsWith("manualSync/")){const a=$.substring(11),h=v[0],u=this.h(h);switch(v=v.slice(1),a){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(f){const $=this.a.get(this.j(f));if(!$)throw new Error(`Manual sync taks not found: ${f}`);return $}async i(){const f=await this.c.createManualSyncTask();return this.a.set(this.j(f.id),f),f.id}j(f){return`manualSyncTask-${f}`}}e.$N4b=m;let S=e.$O4b=class extends M.$kb{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(f,$){super(),this.k=$,this.b="uninitialized",this.c=this.B(new R.$5c),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new R.$5c),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new R.$5c),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new R.$5c),this.onSyncErrors=this.j.event,this.a={call(v,a,h){return f.call(v,a,h).then(null,u=>{throw O.$Adb.toUserDataSyncError(u)})},listen(v,a){return f.listen(v,a)}},this.a.call("_getInitialData").then(([v,a,h])=>{this.l(v),this.m(a),h&&this.n(h),this.B(this.a.listen("onDidChangeStatus")(u=>this.l(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.n(u)))}),this.B(this.a.listen("onDidChangeConflicts")(v=>this.m(v))),this.B(this.a.listen("onSyncErrors")(v=>this.j.fire(v.map(a=>({...a,error:O.$Adb.toUserDataSyncError(a.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.a.call("createManualSyncTask"),$=this;return new E(f,{async call(a,h,u){return $.a.call(`manualSync/${a}`,[f,...Array.isArray(h)?h:[h]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(f,$,v,a){return this.a.call("accept",[f,$,v,a])}resolveContent(f){return this.a.call("resolveContent",[f])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(f,$){return(await this.a.call("getLocalSyncResourceHandles",[f,$])).map(({created:a,uri:h})=>({created:a,uri:L.URI.revive(h)}))}async getRemoteSyncResourceHandles(f,$){return(await this.a.call("getRemoteSyncResourceHandles",[f,$])).map(({created:a,uri:h})=>({created:a,uri:L.URI.revive(h)}))}async getAssociatedResources(f){return(await this.a.call("getAssociatedResources",[f])).map(({resource:v,comparableResource:a})=>({resource:L.URI.revive(v),comparableResource:L.URI.revive(a)}))}getMachineId(f){return this.a.call("getMachineId",[f])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(f){return this.a.call("replace",[f])}async l(f){this.b=f,this.c.fire(f)}async m(f){this.f=f.map($=>({syncResource:$.syncResource,profile:(0,j.$ok)($.profile,this.k.profilesHome.scheme),conflicts:$.conflicts.map(v=>({...v,baseResource:L.URI.revive(v.baseResource),localResource:L.URI.revive(v.localResource),remoteResource:L.URI.revive(v.remoteResource),previewResource:L.URI.revive(v.previewResource)}))})),this.g.fire(this.f)}n(f){this.h!==f&&(this.h=f,this.i.fire(f))}};e.$O4b=S=we([Y(1,j.$nk)],S);class E extends M.$kb{constructor(f,$){super(),this.id=f,this.a=$}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(ae[252],ce([0,1,6,26,7,3,2,135,5,22,10,12,32,18,14,13,24,56,44,19,23]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sxb=e.$Rxb=e.$Qxb=e.$Pxb=e.$Oxb=void 0;const I="sync.previous.store",n="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",t=100,s=1e3*60*5;let o=e.$Oxb=class extends O.$kb{get userDataSyncStore(){return this.b}get c(){return this.h.get(w.$Ddb,-1)}set c(D){this.h.store(w.$Ddb,D,-1,k.$o?0:1)}constructor(D,T,F){super(),this.f=D,this.g=T,this.h=F,this.a=this.B(new j.$5c),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(j.Event.filter(F.onDidChangeValue,H=>H.key===w.$Ddb&&H.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[w.$kdb],this.g.getValue(w.$kdb)),this.a.fire()}j(D,T){D=k.$o&&D?.web?{...D,...D.web}:D;const F={...D||{},...T||{}};if(F&&(0,S.$ge)(F.url)&&(0,S.$ie)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(H=>Array.isArray(F.authenticationProviders[H].scopes))){const H=F,V=!!H.canSwitch&&!T?.url,W=H.url===H.insidersUrl?"insiders":"stable",x=(V?this.c:void 0)||W,ee=T?.url||(x==="insiders"?H.insidersUrl:x==="stable"?H.stableUrl:H.url);return{url:E.URI.parse(ee),type:x,defaultType:W,defaultUrl:E.URI.parse(H.url),stableUrl:E.URI.parse(H.stableUrl),insidersUrl:E.URI.parse(H.insidersUrl),canSwitch:V,authenticationProviders:Object.keys(H.authenticationProviders).reduce((X,_)=>(X.push({id:_,scopes:H.authenticationProviders[_].scopes}),X),[])}}}};e.$Oxb=o=we([Y(0,a.$6i),Y(1,f.$Rh),Y(2,p.$Go)],o);let c=e.$Pxb=class extends o{constructor(D,T,F){super(D,T,F);const H=this.h.get(I,-1);H&&(this.k=JSON.parse(H));const V=this.f[w.$kdb];V?this.h.store(I,JSON.stringify(V),-1,1):this.h.remove(I,-1)}async switch(D){D!==this.c&&(this.c=D,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};e.$Pxb=c=we([Y(0,a.$6i),Y(1,f.$Rh),Y(2,p.$Go)],c);let y=e.$Qxb=class extends O.$kb{get donotMakeRequestsUntil(){return this.i}constructor(D,T,F,H,V,W,x){super(),this.k=F,this.l=H,this.m=x,this.g=this.B(new j.$5c),this.onTokenFailed=this.g.event,this.h=this.B(new j.$5c),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new j.$5c),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.r=void 0,this.n(D),this.c=(0,u.$Mo)(V,W,x).then(ee=>{const X={"X-Client-Name":`${T.applicationName}${k.$o?"-web":""}`,"X-Client-Version":T.version};return T.commit&&(X["X-Client-Commit"]=T.commit),X}),this.f=new l(t,s,this.k,this.l),this.p(),this.B((0,O.$ib)(()=>{this.r&&(this.r.cancel(),this.r=void 0)}))}setAuthToken(D,T){this.b={token:D,type:T}}n(D){this.a=D?(0,m.$6f)(D,"v1"):void 0}p(){const D=this.m.getNumber(n,-1);D&&Date.now()<D&&this.s(new Date(D))}s(D){this.i?.getTime()!==D?.getTime()&&(this.i=D,this.r&&(this.r.cancel(),this.r=void 0),this.i?(this.m.store(n,this.i.getTime(),-1,1),this.r=(0,R.$fg)(T=>(0,R.$sg)(this.i.getTime()-Date.now(),T).then(()=>this.s(void 0))),this.r.then(null,T=>null)):this.m.remove(n,-1),this.j.fire())}async getAllCollections(D={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,m.$6f)(this.a,"collection").toString();D={...D},D["Content-Type"]="application/json";const F=await this.v(T,{type:"GET",headers:D},[],M.CancellationToken.None);return(await(0,h.$zo)(F))?.map(({id:H})=>H)||[]}async createCollection(D={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,m.$6f)(this.a,"collection").toString();D={...D},D["Content-Type"]=C.$qr.text;const F=await this.v(T,{type:"POST",headers:D},[],M.CancellationToken.None),H=await(0,h.$yo)(F);if(!H)throw new w.$Bdb("Server did not return the collection id",T,"NoCollection",F.res.statusCode,F.res.headers[w.$xdb]);return H}async deleteCollection(D,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=D?(0,m.$6f)(this.a,"collection",D).toString():(0,m.$6f)(this.a,"collection").toString();T={...T},await this.v(F,{type:"DELETE",headers:T},[],M.CancellationToken.None)}async getAllResourceRefs(D,T){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.t(this.a,T,D),H={},V=await this.v(F.toString(),{type:"GET",headers:H},[],M.CancellationToken.None);return(await(0,h.$zo)(V)||[]).map(({url:x,created:ee})=>({ref:(0,m.$8f)(F,F.with({path:x})),created:ee*1e3}))}async resolveResourceContent(D,T,F,H={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=(0,m.$6f)(this.t(this.a,F,D),T).toString();H={...H},H["Cache-Control"]="no-cache";const W=await this.v(V,{type:"GET",headers:H},[],M.CancellationToken.None);return await(0,h.$yo)(W)}async deleteResource(D,T,F){if(!this.a)throw new Error("No settings sync store url configured.");const H=T!==null?(0,m.$6f)(this.t(this.a,F,D),T).toString():this.t(this.a,F,D).toString(),V={};await this.v(H,{type:"DELETE",headers:V},[],M.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const D=(0,m.$6f)(this.a,"resource").toString(),T={"Content-Type":C.$qr.text};await this.v(D,{type:"DELETE",headers:T},[],M.CancellationToken.None)}async readResource(D,T,F,H={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=(0,m.$6f)(this.t(this.a,F,D),"latest").toString();H={...H},H["Cache-Control"]="no-cache",T&&(H["If-None-Match"]=T.ref);const W=await this.v(V,{type:"GET",headers:H},[304],M.CancellationToken.None);let x=null;if(W.res.statusCode===304&&(x=T),x===null){const ee=W.res.headers.etag;if(!ee)throw new w.$Bdb("Server did not return the ref",V,"NoRef",W.res.statusCode,W.res.headers[w.$xdb]);const X=await(0,h.$yo)(W);if(!X&&W.res.statusCode===304)throw new w.$Bdb("Empty response",V,"EmptyResponse",W.res.statusCode,W.res.headers[w.$xdb]);x={ref:ee,content:X}}return x}async writeResource(D,T,F,H,V={}){if(!this.a)throw new Error("No settings sync store url configured.");const W=this.t(this.a,H,D).toString();V={...V},V["Content-Type"]=C.$qr.text,F&&(V["If-Match"]=F);const x=await this.v(W,{type:"POST",data:T,headers:V},[],M.CancellationToken.None),ee=x.res.headers.etag;if(!ee)throw new w.$Bdb("Server did not return the ref",W,"NoRef",x.res.statusCode,x.res.headers[w.$xdb]);return ee}async manifest(D,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,m.$6f)(this.a,"manifest").toString();T={...T},T["Content-Type"]="application/json",D&&(T["If-None-Match"]=D.ref);const H=await this.v(F,{type:"GET",headers:T},[304],M.CancellationToken.None);let V=null;if(H.res.statusCode===304&&(V=D),!V){const x=H.res.headers.etag;if(!x)throw new w.$Bdb("Server did not return the ref",F,"NoRef",H.res.statusCode,H.res.headers[w.$xdb]);const ee=await(0,h.$yo)(H);if(!ee&&H.res.statusCode===304)throw new w.$Bdb("Empty response",F,"EmptyResponse",H.res.statusCode,H.res.headers[w.$xdb]);ee&&(V={...JSON.parse(ee),ref:x})}const W=this.m.get(r,-1);return W&&V&&W!==V.session&&this.u(),V===null&&W&&this.u(),V&&this.m.store(r,V.session,-1,1),V}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.u()}t(D,T,F){return T?(0,m.$6f)(D,"collection",T,"resource",F):(0,m.$6f)(D,"resource",F)}u(){this.m.remove(r,-1),this.m.remove(i,-1)}async v(D,T,F,H){if(!this.b)throw new w.$Bdb("No Auth Token Available",D,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new w.$Bdb(`${T.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",void 0,void 0);this.s(void 0);const V=await this.c;T.headers={...T.headers||{},...V,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.w(T.headers),this.l.trace("Sending request to server",{url:D,type:T.type,headers:{...T.headers,authorization:void 0}});let W;try{W=await this.f.request(D,T,H)}catch(q){if(!(q instanceof w.$Bdb)){let G="RequestFailed";const B=(0,L.$8)(q).toLowerCase();B.includes("xhr timeout")?G="RequestTimeout":B.includes("protocol")&&B.includes("not supported")?G="RequestProtocolNotSupported":B.includes("request path contains unescaped characters")?G="RequestPathNotEscaped":B.includes("headers must be an object")?G="RequestHeadersNotObject":(0,L.$1)(q)&&(G="RequestCanceled"),q=new w.$Bdb(`Connection refused for the request '${D}'.`,D,G,void 0,void 0)}throw this.l.info("Request failed",D),q}const x=W.res.headers[w.$xdb],ee={url:D,status:W.res.statusCode,"execution-id":T.headers[w.$ydb],"operation-id":x},X=(0,h.$wo)(W)||W.res.statusCode&&F.includes(W.res.statusCode);let _="";if(X?this.l.trace("Request succeeded",ee):(this.l.info("Request failed",ee),_=await(0,h.$xo)(W)||""),W.res.statusCode===401||W.res.statusCode===403){if(this.b=void 0,W.res.statusCode===401)throw this.g.fire("Unauthorized"),new w.$Bdb(`${T.type} request '${D}' failed because of Unauthorized (401).`,D,"Unauthorized",W.res.statusCode,x);if(W.res.statusCode===403)throw this.g.fire("Forbidden"),new w.$Bdb(`${T.type} request '${D}' failed because the access is forbidden (403).`,D,"Forbidden",W.res.statusCode,x)}if(this.h.fire(),W.res.statusCode===404)throw new w.$Bdb(`${T.type} request '${D}' failed because the requested resource is not found (404).`,D,"NotFound",W.res.statusCode,x);if(W.res.statusCode===405)throw new w.$Bdb(`${T.type} request '${D}' failed because the requested endpoint is not found (405). ${_}`,D,"MethodNotFound",W.res.statusCode,x);if(W.res.statusCode===409)throw new w.$Bdb(`${T.type} request '${D}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,D,"Conflict",W.res.statusCode,x);if(W.res.statusCode===410)throw new w.$Bdb(`${T.type} request '${D}' failed because the requested resource is not longer available (410).`,D,"Gone",W.res.statusCode,x);if(W.res.statusCode===412)throw new w.$Bdb(`${T.type} request '${D}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,D,"PreconditionFailed",W.res.statusCode,x);if(W.res.statusCode===413)throw new w.$Bdb(`${T.type} request '${D}' failed because of too large payload (413).`,D,"TooLarge",W.res.statusCode,x);if(W.res.statusCode===426)throw new w.$Bdb(`${T.type} request '${D}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,D,"UpgradeRequired",W.res.statusCode,x);if(W.res.statusCode===429){const q=W.res.headers["retry-after"];throw q?(this.s(new Date(Date.now()+parseInt(q)*1e3)),new w.$Bdb(`${T.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",W.res.statusCode,x)):new w.$Bdb(`${T.type} request '${D}' failed because of too many requests (429).`,D,"RemoteTooManyRequests",W.res.statusCode,x)}if(!X)throw new w.$Bdb("Server returned "+W.res.statusCode,D,"Unknown",W.res.statusCode,x);return W}w(D){let T=this.m.get(i,-1);T===void 0&&(T=(0,b.$3e)(),this.m.store(i,T,-1,1)),D["X-Machine-Session-Id"]=T;const F=this.m.get(r,-1);F!==void 0&&(D["X-User-Session-Id"]=F)}};e.$Qxb=y=we([Y(1,a.$6i),Y(2,h.$uo),Y(3,w.$Kdb),Y(4,$.$sh),Y(5,v.$Oj),Y(6,p.$Go)],y);let d=e.$Rxb=class extends y{constructor(D,T,F,H,V,W,x){super(D.userDataSyncStore?.url,T,F,H,V,W,x),this.B(D.onDidChangeUserDataSyncStore(()=>this.n(D.userDataSyncStore?.url)))}};e.$Rxb=d=we([Y(0,w.$udb),Y(1,a.$6i),Y(2,h.$uo),Y(3,w.$Kdb),Y(4,$.$sh),Y(5,v.$Oj),Y(6,p.$Go)],d);class l{constructor(D,T,F,H){this.c=D,this.d=T,this.f=F,this.g=H,this.a=[],this.b=void 0}request(D,T,F){if(this.h()&&this.i(),T.url=D,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new w.$Bdb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,D,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(D),this.f.request(T,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$Sxb=l}),define(ae[253],ce([0,1,3,54,24,19,20,248,23,77,80]),function(ne,e,R,M,L,j,O,C,k,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$94b=void 0;let E=e.$94b=class extends C.$D1b{constructor(f,$,v,a,h,u,p,w,I,n,r){super(f,$,v,a,h,p,w,I,n,r),this.B(R.Event.debounce(R.Event.any(R.Event.map(u.onDidFocusWindow,()=>"windowFocus"),R.Event.map(u.onDidOpenWindow,()=>"windowOpen")),(i,t)=>i?[...i,t]:[t],1e3)(i=>this.triggerSync(i,!0,!1)))}};e.$94b=E=we([Y(0,L.$6i),Y(1,k.$udb),Y(2,k.$vdb),Y(3,k.$Fdb),Y(4,k.$Gdb),Y(5,M.$R2b),Y(6,k.$Kdb),Y(7,m.$ywb),Y(8,O.$Rk),Y(9,S.$zWb),Y(10,j.$Go)],E)}),define(ae[254],ce([0,1,69,25,5,22]),function(ne,e,R,M,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p2b=e.$o2b=e.$n2b=e.$m2b=void 0,e.$m2b=128/4;function O(m){function S(){let E=m.scheme===M.Schemas.file?(0,j.$Tf)(m):m.toString();return L.$k||(E=E.toLowerCase()),(0,R.createHash)("md5").update(E).digest("hex")}return{id:S(),configPath:m}}e.$n2b=O;function C(m,S){function E(){if(m.scheme!==M.Schemas.file)return(0,R.createHash)("md5").update(m.toString()).digest("hex");if(!S)return;let f;return L.$k?f=S.ino:L.$j?f=S.birthtime.getTime():L.$i&&(typeof S.birthtimeMs=="number"?f=Math.floor(S.birthtimeMs):f=S.birthtime.getTime()),(0,R.createHash)("md5").update(m.fsPath).update(f?String(f):"").digest("hex")}const b=E();if(typeof b=="string")return{id:b,uri:m}}e.$o2b=C;function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$p2b=k}),define(ae[255],ce([0,1,6,7,2,15,30,14,8,75,112,254,54,71]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B4b=void 0;let $=e.$B4b=class extends L.$kb{constructor(a,h,u,p){super(),this.a=a,this.b=h,this.c=u,this.f=p,this.B(new R.$Cg(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const a=await O.Promises.readdir(this.a.workspaceStorageHome.fsPath),h=new m.$0wb(this.f.getChannel("storage"));await Promise.all(a.map(async u=>{const p=(0,j.$$b)(this.a.workspaceStorageHome.fsPath,u);u.length===E.$m2b||u===S.$xh.id||(await this.c.getWindows()).some(n=>n.workspace?.id===u)||await h.isUsed(p)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${u} as it seems to be an unused empty workspace.`),await O.Promises.rm(p))}))}catch(a){(0,M.$X)(a)}}};e.$B4b=$=we([Y(0,C.$th),Y(1,k.$Ni),Y(2,b.$R2b),Y(3,f.$a4b)],$)}),define(ae[81],ce([0,1,51,6,15,10,30,141,265,266]),function(ne,e,R,M,L,j,O,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.zip=e.$Yo=e.$Xo=void 0,e.$Xo="end of central directory record signature not found";const S=new RegExp(e.$Xo);class E extends Error{constructor(r,i){let t=i.message;switch(r){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=r,this.cause=i}}e.$Yo=E;function b(n){const r=n.externalFileAttributes>>16||33188;return[448,56,7].map(i=>r&i).reduce((i,t)=>i+t,r&61440)}function f(n){if(n instanceof E)return n;let r;return S.test(n.message)&&(r="CorruptZip"),new E(r,n)}function $(n,r,i,t,s,o){const c=L.$bc(r),y=L.$$b(t,c);if(!y.startsWith(t))return Promise.reject(new Error(C.localize(0,null,r)));const d=L.$$b(t,r);let l;return o.onCancellationRequested(()=>{l?.destroy()}),Promise.resolve(O.Promises.mkdir(y,{recursive:!0})).then(()=>new Promise((P,D)=>{if(!o.isCancellationRequested)try{l=(0,R.createWriteStream)(d,{mode:i}),l.once("close",()=>P()),l.once("error",D),n.once("error",D),n.pipe(l)}catch(T){D(T)}}))}function v(n,r,i,t){let s=(0,M.$fg)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{s.cancel(),n.close()}),new Promise((c,y)=>{const d=new M.$mg,l=P=>{P.isCancellationRequested||(o++,n.readEntry())};n.once("error",y),n.once("close",()=>s.then(()=>{t.isCancellationRequested||n.entryCount===o?c():y(new E("Incomplete",new Error(C.localize(1,null,o,n.entryCount))))},y)),n.readEntry(),n.on("entry",P=>{if(t.isCancellationRequested)return;if(!i.sourcePathRegex.test(P.fileName)){l(t);return}const D=P.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(D)){const H=L.$$b(r,D);s=(0,M.$fg)(V=>O.Promises.mkdir(H,{recursive:!0}).then(()=>l(V)).then(void 0,y));return}const T=h(n,P),F=b(P);s=(0,M.$fg)(H=>d.queue(()=>T.then(V=>$(V,D,F,r,i,H).then(()=>l(H)))).then(null,y))})})}function a(n,r=!1){return new Promise((i,t)=>{(0,k.open)(n,r?{lazyEntries:!0}:void 0,(s,o)=>{s?t(f(s)):i((0,j.$re)(o))})})}function h(n,r){return new Promise((i,t)=>{n.openReadStream(r,(s,o)=>{s?t(f(s)):i((0,j.$re)(o))})})}function u(n,r){return new Promise((i,t)=>{const s=new m.ZipFile;r.forEach(c=>{c.contents?s.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&s.addFile(c.localPath,c.path)}),s.end();const o=(0,R.createWriteStream)(n);s.outputStream.pipe(o),s.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>i(n))})}e.zip=u;function p(n,r,i={},t){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let o=a(n,!0);return i.overwrite&&(o=o.then(c=>O.Promises.rm(r).then(()=>c))),o.then(c=>v(c,r,{sourcePathRegex:s},t))}e.$1o=p;function w(n,r){return a(n).then(i=>new Promise((t,s)=>{i.on("entry",o=>{o.fileName===r&&h(i,o).then(c=>t(c),c=>s(c))}),i.once("close",()=>s(new Error(C.localize(2,null,r))))}))}function I(n,r){return w(n,r).then(i=>new Promise((t,s)=>{const o=[];i.once("error",s),i.on("data",c=>o.push(c)),i.on("end",()=>t(Buffer.concat(o)))}))}e.$2o=I}),define(ae[256],ce([0,1,6,7,2,25,5,22,52,10,32,30,81,18,14,28,33,97,13,8]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;let w=e.$ep=class $t extends L.$kb{constructor(n,r,i,t,s,o){super(),this.h=r,this.i=i,this.j=t,this.k=s,this.l=o,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(n,r,i){await this.g;const t=(0,C.$6f)(this.extensionsDownloadDir,this.v(n));try{await this.r(n,t,o=>this.i.download(n,o,r))}catch(o){throw new v.$Mn(o.message,v.ExtensionManagementErrorCode.Download)}let s=!1;if(i&&this.m(n)){const o=await this.n(n);try{s=await this.k.verify(t.fsPath,o.fsPath,this.l.getLevel()===p.LogLevel.Trace)}catch(c){const y=c;if(s=y.code,y.output&&this.l.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${y.output}`),s===v.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===v.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new v.$Mn(b.$Xo,v.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(c){this.l.error(c)}}}return s===!0?this.l.info(`Extension signature is verified: ${n.identifier.id}`):s===!1?this.l.info(`Extension signature verification is not done: ${n.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${s}': ${n.identifier.id}`),{location:t,verificationStatus:s}}m(n){if(!n.isSigned)return!1;const r=this.j.getValue("extensions.verifySignature");return(0,m.$me)(r)?r:!0}async n(n){await this.g;const r=(0,C.$6f)(this.extensionsDownloadDir,`${this.v(n)}${$t.c}`);return await this.r(n,r,i=>this.i.downloadSignatureArchive(n,i)),r}async r(n,r,i){if(await this.h.exists(r))return;if(r.scheme!==j.Schemas.file){await i(r);return}const t=(0,C.$6f)(this.extensionsDownloadDir,`.${(0,S.$3e)()}`);await this.h.exists(t)||await i(t);try{await this.t(t,r,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(t)}catch{}if(s.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,r.path);else throw this.l.info(`Rename failed because of ${(0,M.$8)(s)}. Deleted the file from downloaded location`,t.path),s}}async delete(n){await this.g,await this.h.del(n)}async t(n,r,i){try{await E.Promises.rename(n.fsPath,r.fsPath)}catch(t){if(O.$i&&t&&t.code==="EPERM"&&Date.now()<i)return this.l.info(`Failed renaming ${n} to ${r} with 'EPERM' error. Trying again...`),this.t(n,r,i);throw t}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const r=[],i=[],t=[];for(const c of n.children)if(c.name.endsWith($t.c))t.push(c.resource);else{const y=a.$co.parse(c.name);y&&i.push([y,c])}const s=(0,a.$ho)(i,([c])=>c),o=[];for(const c of s)c.sort((y,d)=>k.rcompare(y[0].version,d[0].version)),r.push(...c.slice(1).map(y=>y[1].resource)),o.push(c[0][1]);o.sort((c,y)=>c.mtime-y.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(c=>c.resource)),r.push(...t),await R.Promises.settled(r.map(c=>(this.l.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(n){this.l.error(n)}}v(n){return this.f?a.$co.create(n).toString().toLowerCase():(0,S.$3e)()}};w.c=".sigzip",e.$ep=w=we([Y(0,$.$th),Y(1,u.$Oj),Y(2,v.$Ln),Y(3,f.$Rh),Y(4,h.$Ro),Y(5,p.$Ni)],w)}),define(ae[257],ce([0,1,81,150]),function(ne,e,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=void 0;function L(j){return(0,R.$2o)(j,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,M.localize)(0,null))}})}e.$gp=L}),define(ae[121],ce([0,1,6,16,26,38,7,3,2,35,25,15,5,22,52,10,12,32,30,81,149,96,14,236,28,33,50,78,256,237,257,205,216,67,13,4,8,24,20,29,17]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u,p,w,I,n,r,i,t,s,o,c,y,d,l,P,D,T,F,H,V,W,x,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$jp=(0,F.$mh)(i.$Nn);let X=e.$kp=class extends r.$3o{constructor(K,Z,N,g,A,U,Q,z,J,te,oe,he){super(K,Z,N,te,he),this.$=A,this.ab=U,this.bb=Q,this.cb=J,this.db=oe,this.Y=this.B(new C.$5c),this.onDidUpdateExtensionMetadata=this.Y.event,this.Z=new Map,this.lb=new m.$ki;const fe=this.B(z.createInstance(y.$fp));this.U=this.B(z.createInstance(_,pe=>fe.postUninstall(pe))),this.W=this.B(new l.$hp(he,J,oe,this,this.v)),this.X=this.B(z.createInstance(c.$ep));const be=this.B(new P.$ip(this,this.$,he,U,oe,J,N));this.B(be.onDidChangeExtensionsByAnotherSource(pe=>this.kb(pe))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,t.$mo)(this.cb,this.v)),this.eb}async zip(K){this.v.trace("ExtensionManagementService#zip",K.identifier.id);const Z=await this.jb(K),N=await(0,p.zip)((0,f.$6f)(this.X.extensionsDownloadDir,(0,h.$3e)()).fsPath,Z);return a.URI.file(N)}async unzip(K){return this.v.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:Z,cleanup:N}=await this.fb(K),g=E.$_b(Z.fsPath);try{return await(0,d.$gp)(g)}finally{await N()}}getInstalled(K,Z=this.y.defaultProfile.extensionsResource){return this.U.scanExtensions(K??null,Z)}scanAllUserInstalledExtensions(){return this.U.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.U.scanUserExtensionAtLocation(K)}async install(K,Z={}){this.v.trace("ExtensionManagementService#install",K.toString());const{location:N,cleanup:g}=await this.fb(K);try{const A=await(0,d.$gp)(E.$_b(N.fsPath)),U=(0,t.$go)(A.publisher,A.name);if(A.engines&&A.engines.vscode&&!(0,D.$to)(A.engines.vscode,this.w.version,this.w.date))throw new Error(w.localize(0,null,U,this.w.version));const Q=await this.z([{manifest:A,extension:N,options:Z}]);if(Q[0]?.local)return Q[0]?.local;throw Q[0]?.error?Q[0].error:(0,r.$5o)(new Error(`Unknown error while installing extension ${U}`))}finally{await g()}}async installFromLocation(K,Z){this.v.trace("ExtensionManagementService#installFromLocation",K.toString());const N=await this.U.scanUserExtensionAtLocation(K);if(!N)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.ob([[N,void 0]],Z),this.v.info("Successfully installed extension",N.identifier.id,Z.toString()),N}async installExtensionsFromProfile(K,Z,N){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",K,Z.toString(),N.toString());const g=(await this.U.scanExtensions(1,Z)).filter(A=>K.some(U=>(0,t.$bo)(U,A.identifier)));if(g.length){const A=await Promise.all(g.map(U=>this.U.scanMetadata(U,Z)));await this.ob(g.map((U,Q)=>[U,A[Q]]),N),this.v.info("Successfully installed extensions",g.map(U=>U.identifier.id),N.toString())}return g}async updateMetadata(K,Z,N=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",K.identifier.id),Z.isPreReleaseVersion&&(Z.preRelease=!0),Z.isMachineScoped=Z.isMachineScoped||void 0,Z.isBuiltin=Z.isBuiltin||void 0,Z.pinned=Z.pinned||void 0,K=await this.U.updateMetadata(K,Z,N),this.W.invalidate(N),this.Y.fire(K),K}async reinstallFromGallery(K){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.t.isEnabled())throw new Error(w.localize(1,null));const Z=await this.getTargetPlatform(),[N]=await this.t.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:Z,compatible:!0},L.CancellationToken.None);if(!N)throw new Error(w.localize(2,null));await this.U.setUninstalled(K);try{await this.U.removeUninstalledExtension(K)}catch(g){throw new Error(w.localize(3,null,(0,j.$9h)(g)))}return this.installFromGallery(N)}copyExtensions(K,Z){return this.U.copyExtensions(K,Z)}markAsUninstalled(...K){return this.U.setUninstalled(...K)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.U.cleanUp()}catch(K){this.v.error(K)}}async download(K,Z,N){const{location:g}=await this.X.download(K,Z,!N);return g}async fb(K){if(K.scheme===S.Schemas.file)return{location:K,async cleanup(){}};this.v.trace("Downloading extension from",K.toString());const Z=(0,f.$6f)(this.X.extensionsDownloadDir,(0,h.$3e)());return await this.bb.download(K,Z),this.v.info("Downloaded extension to",Z.toString()),{location:Z,cleanup:async()=>{try{await this.cb.del(Z)}catch(g){this.v.error(g)}}}}Q(){return this.y.defaultProfile.extensionsResource}R(K,Z,N){if(a.URI.isUri(Z))return new B(K,Z,N,this.t,this.U,this.db,this.y,this.$,this.ab,this.v);const g=t.$co.create(Z).toString();let A=this.Z.get(g);return A||(this.Z.set(g,A=new G(K,Z,N,this.X,this.U,this.db,this.y,this.$,this.ab,this.v)),A.waitUntilTaskIsFinished().finally(()=>this.Z.delete(g))),A}S(K,Z){return new ie(K,Z.profileLocation,this.ab)}async jb(K){const Z=async g=>{let A=await u.Promises.readdir(g);A=A.map(z=>E.$$b(g,z));const U=await Promise.all(A.map(z=>u.Promises.stat(z)));let Q=Promise.resolve([]);return U.forEach((z,J)=>{const te=A[J];z.isFile()&&(Q=Q.then(oe=>[...oe,te])),z.isDirectory()&&(Q=Q.then(oe=>Z(te).then(he=>[...oe,...he])))}),Q};return(await Z(K.location.fsPath)).map(g=>({path:`extension/${E.$ac(K.location.fsPath,g)}`,localPath:g}))}async kb({added:K,removed:Z}){if(Z)for(const N of Z.extensions)this.v.info("Extensions removed from another source",N.id,Z.profileLocation.toString()),this.p.fire({identifier:N,profileLocation:Z.profileLocation});if(K){const g=(await this.U.scanExtensions(1,K.profileLocation)).filter(A=>K.extensions.some(U=>(0,t.$bo)(U,A.identifier)));this.m.fire(g.map(A=>(this.v.info("Extensions added from another source",A.identifier.id,K.profileLocation.toString()),{identifier:A.identifier,local:A,profileLocation:K.profileLocation,operation:1})))}}async mb(){this.B(this.U.onExtract(Z=>this.lb.add(Z)));const K=await this.cb.resolve(this.$.userExtensionsLocation);for(const Z of K.children??[])Z.isDirectory&&this.lb.add(Z.resource);this.B(this.cb.watch(this.$.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(Z=>this.nb(Z)))}async nb(K){if(!K.affects(this.$.userExtensionsLocation,1))return;const Z=[];for(const N of K.rawAdded){if(this.lb.has(N)||!this.db.extUri.isEqual(this.db.extUri.dirname(N),this.$.userExtensionsLocation)||this.db.extUri.isEqual(N,this.db.extUri.joinPath(this.$.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(N).startsWith(".")||!(await this.cb.stat(N)).isDirectory)continue;const g=await this.U.scanUserExtensionAtLocation(N);g&&g.installedTimestamp===void 0&&(this.lb.add(N),Z.push(g))}Z.length&&(await this.ob(Z.map(N=>[N,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",Z.map(N=>N.identifier.id)))}async ob(K,Z){const N=K.map(g=>g[0]);await this.pb(N),await this.ab.addExtensionsToProfile(K,Z),this.m.fire(N.map(g=>({local:g,identifier:g.identifier,operation:1,profileLocation:Z})))}async pb(K){const Z=await this.U.getUninstalledExtensions();for(const N of K){const g=t.$co.create(N);Z[g.toString()]&&(this.v.trace("Removing the extension from uninstalled list:",g.id),await this.U.setInstalled(g),this.v.info("Removed the extension from uninstalled list:",g.id))}}};e.$kp=X=we([Y(0,i.$Ln),Y(1,W.$Rk),Y(2,H.$Ni),Y(3,n.$th),Y(4,o.$_o),Y(5,s.$8o),Y(6,I.$qn),Y(7,F.$kh),Y(8,T.$Oj),Y(9,V.$6i),Y(10,x.$lk),Y(11,ee.$nk)],X);let _=e.$lp=class extends k.$kb{constructor(K,Z,N,g,A,U){super(),this.k=K,this.l=Z,this.m=N,this.n=g,this.p=A,this.s=U,this.h=this.B(new C.$5c),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,f.$6f)(this.m.userExtensionsLocation,".obsolete"),this.g=new R.$yg}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(K,Z){const N={includeInvalid:!0,profileLocation:Z};let g=[];return K===null||K===0?g.push(...await this.m.scanAllExtensions({includeInvalid:!0},N,!1)):K===1&&g.push(...await this.m.scanUserExtensions(N)),g=K!==null?g.filter(A=>A.type===K):g,Promise.all(g.map(A=>this.y(A)))}async scanAllUserExtensions(K){const Z=await this.m.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(Z.map(N=>this.y(N)))}async scanUserExtensionAtLocation(K){try{const Z=await this.m.scanExistingExtension(K,1,{includeInvalid:!0});if(Z)return await this.y(Z)}catch(Z){this.s.error(Z)}return null}async extractUserExtension(K,Z,N,g,A){await this.j.catch(()=>{});const U=K.toString(),Q=E.$$b(this.m.userExtensionsLocation.fsPath,`.${(0,h.$3e)()}`),z=E.$$b(this.m.userExtensionsLocation.fsPath,U);let J=await this.l.exists(a.URI.file(z));if(J&&g){try{await u.Promises.rm(z)}catch{throw new i.$Mn(w.localize(4,null,z,K.id),i.ExtensionManagementErrorCode.Delete)}J=!1}if(!J){await this.u(K,Z,Q,A),await this.m.updateMetadata(a.URI.file(Q),N);try{this.h.fire(a.URI.file(z)),await this.v(K,Q,z,Date.now()+2*60*1e3),this.s.info("Renamed to",z)}catch(te){try{await u.Promises.rm(Q)}catch{}if(te.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.s.info(`Rename failed because of ${(0,O.$8)(te)}. Deleted from extracted location`,Q),te}}return this.w(a.URI.file(z),1)}async scanMetadata(K,Z){return Z?(await this.n.scanProfileExtensions(Z)).find(g=>(0,t.$bo)(g.identifier,K.identifier))?.metadata:this.m.scanMetadata(K.location)}async updateMetadata(K,Z,N){return N?await this.n.updateMetadata([[K,Z]],N):await this.m.updateMetadata(K.location,Z),this.w(K.location,K.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...K){const Z=K.map(N=>t.$co.create(N));await this.t(N=>Z.forEach(g=>{N[g.toString()]=!0,this.s.info("Marked extension as uninstalled",g.toString())}))}async setInstalled(K){await this.t(Z=>delete Z[K.toString()])}async removeExtension(K,Z){this.s.trace(`Deleting ${Z} extension from disk`,K.identifier.id,K.location.fsPath);const N=this.p.extUri.joinPath(this.p.extUri.dirname(K.location),`._${(0,h.$3e)()}`);await this.v(K.identifier,K.location.fsPath,N.fsPath,Date.now()+2*60*1e3),await this.l.del(N,{recursive:!0}),this.s.info("Deleted from disk",K.identifier.id,K.location.fsPath)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.t(Z=>delete Z[t.$co.create(K).toString()])}async copyExtensions(K,Z){const N=await this.scanExtensions(1,K),g=await Promise.all(N.filter(A=>!A.isApplicationScoped).map(async A=>[A,await this.scanMetadata(A,K)]));await this.n.addExtensionsToProfile(g,Z)}async t(K){return this.g.queue(async()=>{let Z;try{Z=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(g){if((0,T.$5j)(g)!==1)throw g}let N={};if(Z)try{N=JSON.parse(Z)}catch{}return K&&(K(N),Object.keys(N).length?await this.l.writeFile(this.c,M.$Ib.fromString(JSON.stringify(N))):await this.l.del(this.c)),N})}async u(K,Z,N,g){this.s.trace(`Started extracting the extension from ${Z} to ${N}`);try{await u.Promises.rm(N)}catch(A){throw new i.$Mn(this.D(A).message,i.ExtensionManagementErrorCode.Delete)}try{await(0,p.$1o)(Z,N,{sourcePath:"extension",overwrite:!0},g),this.s.info(`Extracted extension to ${N}:`,K.id)}catch(A){try{await u.Promises.rm(N)}catch{}let U=i.ExtensionManagementErrorCode.Extract;throw A instanceof p.$Yo&&(A.type==="CorruptZip"?U=i.ExtensionManagementErrorCode.CorruptZip:A.type==="Incomplete"&&(U=i.ExtensionManagementErrorCode.IncompleteZip)),new i.$Mn(A.message,U)}}async v(K,Z,N,g){try{await u.Promises.rename(Z,N)}catch(A){if(b.$i&&A&&A.code==="EPERM"&&Date.now()<g)return this.s.info(`Failed renaming ${Z} to ${N} with 'EPERM' error. Trying again...`,K.id),this.v(K,Z,N,g);throw new i.$Mn(A.message||w.localize(5,null,Z,N),A.code||i.ExtensionManagementErrorCode.Rename)}}async w(K,Z){const N=await this.m.scanExistingExtension(K,Z,{includeInvalid:!0});if(N)return this.y(N);throw new Error(w.localize(6,null,K.path))}async y(K){const Z=await this.l.resolve(K.location);let N,g;return Z.children&&(N=Z.children.find(({name:A})=>/^readme(\.txt|\.md|)$/i.test(A))?.resource,g=Z.children.find(({name:A})=>/^changelog(\.txt|\.md|)$/i.test(A))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:N,changelogUrl:g,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned}}async z(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys(K));const Z=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),N=new Set;for(const A of Z)K[t.$co.create(A).toString()]||N.add(A.identifier.id.toLowerCase());try{const A=(0,t.$ho)(Z,U=>U.identifier);await R.Promises.settled(A.map(async U=>{const Q=U.sort((z,J)=>$.rcompare(z.manifest.version,J.manifest.version))[0];N.has(Q.identifier.id.toLowerCase())||await this.k(await this.y(Q))}))}catch(A){this.s.error(A)}const g=Z.filter(A=>A.metadata&&K[t.$co.create(A).toString()]);await Promise.allSettled(g.map(A=>this.removeUninstalledExtension(A)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const K=[];let Z;try{Z=await this.l.resolve(this.m.userExtensionsLocation)}catch(N){(0,T.$5j)(N)!==1&&this.s.error(N)}for(const N of Z?.children??[])N.isDirectory&&N.name.startsWith("._")&&(0,h.$2e)(N.name.substring(2))&&K.push((async()=>{this.s.trace("Deleting the generated extension folder",N.resource.toString());try{await this.l.del(N.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",N.resource.toString())}catch(g){this.s.error(g)}})());await Promise.allSettled(K)}D(K){const Z=Array.isArray(K)?K:[K];return Z.length===1?Z[0]instanceof Error?Z[0]:new Error(Z[0]):Z.reduce((N,g)=>new Error(`${N.message}${N.message?",":""}${g instanceof Error?g.message:g}`),new Error(""))}};e.$lp=_=we([Y(1,T.$Oj),Y(2,o.$_o),Y(3,s.$8o),Y(4,x.$lk),Y(5,H.$Ni)],_);class q extends r.$6o{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,v.$ne)(this.m.operation)?this.l:this.m.operation}constructor(K,Z,N,g,A,U,Q,z,J){super(),this.identifier=K,this.source=Z,this.m=N,this.n=g,this.o=A,this.p=U,this.q=Q,this.s=z,this.t=J,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(K){const[Z,N]=await this.y(K);return this.j=Z.isBuiltin||Z.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[Z,N]],this.j),Z}async v({zipPath:K,key:Z,metadata:N},g,A){let U=await this.w(Z);return U||(this.t.trace("Extracting extension...",Z.id),U=await this.n.extractUserExtension(Z,K,N,g,A),this.t.info("Extracting extension completed.",Z.id)),U}async w(K){return await this.x(K)?(this.t.trace("Removing the extension from uninstalled list:",K.id),await this.n.setInstalled(K),this.t.info("Removed the extension from uninstalled list:",K.id),(await this.n.scanAllUserExtensions(!0)).find(g=>t.$co.create(g).equals(K))):void 0}async x(K){return!!(await this.n.getUninstalledExtensions())[K.toString()]}}class G extends q{constructor(K,Z,N,g,A,U,Q,z,J,te){super(Z.identifier,Z,N,A,U,Q,z,J,te),this.z=Z,this.A=g}async y(K){const N=(await this.n.scanExtensions(null,this.m.profileLocation)).find(Q=>(0,t.$bo)(Q.identifier,this.z.identifier));N&&(this.l=3);const g={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||N?.isMachineScoped,isBuiltin:this.m.isBuiltin||N?.isBuiltin,isSystem:N?.type===0?!0:void 0,updated:!!N,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,v.$me)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:N?.preRelease)};if(N?.manifest.version===this.z.version)return[await this.n.updateMetadata(N,g),g];const{location:A,verificationStatus:U}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=U,this.C(A.fsPath),[await this.v({zipPath:A.fsPath,key:t.$co.create(this.z),metadata:g},!1,K),g]}catch(Q){try{await this.A.delete(A)}catch(z){this.t.warn("Error while deleting the downloaded file",A.toString(),(0,O.$8)(z))}throw Q}}async C(K){try{await(0,d.$gp)(K)}catch(Z){throw new i.$Mn((0,r.$4o)(Z).message,i.ExtensionManagementErrorCode.Invalid)}}}e.$mp=G;class B extends q{constructor(K,Z,N,g,A,U,Q,z,J,te){super({id:(0,t.$go)(K.publisher,K.name)},Z,N,A,U,Q,z,J,te),this.z=K,this.A=Z,this.B=g}async h(K){const Z=await super.h(K);return this.E(Z,K),Z}async y(K){const Z=new t.$co(this.identifier,this.z.version),g=(await this.n.scanExtensions(1,this.m.profileLocation)).find(Q=>(0,t.$bo)(this.identifier,Q.identifier)),A={isApplicationScoped:this.m.isApplicationScoped||g?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||g?.isMachineScoped,isBuiltin:this.m.isBuiltin||g?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(g)if(this.l=3,Z.equals(new t.$co(g.identifier,g.manifest.version)))try{await this.n.removeExtension(g,"existing")}catch{throw new Error(w.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&$.gt(g.manifest.version,this.z.version)&&await this.n.setUninstalled(g);else{const Q=await this.w(Z);if(Q)try{await this.n.removeExtension(Q,"existing")}catch{throw new Error(w.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:E.$_b(this.A.fsPath),key:Z,metadata:A},!0,K),A]}async E(K,Z){try{let[N]=await this.B.getExtensions([{id:K.identifier.id,version:K.manifest.version}],Z);if(N||([N]=await this.B.getExtensions([{id:K.identifier.id}],Z)),N){const g={id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(K,g,this.m.profileLocation)}}catch{}}}class ie extends r.$6o{constructor(K,Z,N){super(),this.extension=K,this.j=Z,this.k=N}async h(K){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ae[258],ce([0,1,2,28,79,215,121,8,19]),function(ne,e,R,M,L,j,O,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$34b=void 0;let m=e.$34b=class extends R.$kb{constructor(E,b,f,$,v,a){super(),E.cleanUp(),(0,j.$3Rb)(E,b,f,$,a),L.$jz.removeOutdatedExtensionVersions(E,v)}};e.$34b=m=we([Y(0,O.$jp),Y(1,M.$Ln),Y(2,L.$iz),Y(3,M.$Qn),Y(4,k.$Go),Y(5,C.$Ni)],m)}),define(ae[259],ce([0,1,69,62,36,267,16,7,3,2,15,5,32,43,92]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0;class v{traceSocketEvent(l,P){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,P)}constructor(l,P=""){this.f=!0,this.debugLabel=P,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,C.$X)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(l){const P=D=>{this.traceSocketEvent("read",D),l(O.$Ib.wrap(D))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(l){const P=D=>{l({type:0,hadError:D,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(l){const P=()=>{l()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(l){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,C.$X)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,C.$X)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.$ah=v;var a;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize",d[d.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(a||(a={}));var h;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(h||(h={}));class u extends m.$kb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(l,P){this.socket.traceSocketEvent(l,P)}constructor(l,P,D,T){super(),this.f=this.B(new k.$5c),this.g=this.B(new k.$5c),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:D?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new p(this,P,D,T,this.f,(F,H)=>this.k(F,H))),this.B(this.a.onError(F=>{console.error(F),(0,C.$X)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new $.$8g,this.B(this.socket.onData(F=>this.l(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this.f.event(l)}onClose(l){return this.g.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){let P=0;for(;P<l.byteLength;)this.a.writeMessage(l.slice(P,Math.min(P+262144,l.byteLength))),P+=262144}k(l,P){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let D=2;l.byteLength<126?D+=0:l.byteLength<2**16?D+=2:D+=8;const T=O.$Ib.alloc(D);if(P?T.writeUInt8(194,0):T.writeUInt8(130,0),l.byteLength<126)T.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){T.writeUInt8(126,1);let F=1;T.writeUInt8(l.byteLength>>>8&255,++F),T.writeUInt8(l.byteLength>>>0&255,++F)}else{T.writeUInt8(127,1);let F=1;T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(l.byteLength>>>24&255,++F),T.writeUInt8(l.byteLength>>>16&255,++F),T.writeUInt8(l.byteLength>>>8&255,++F),T.writeUInt8(l.byteLength>>>0&255,++F)}this.socket.write(O.$Ib.concat([T,l]))}end(){this.h=!0,this.socket.end()}l(l){if(l.byteLength!==0){for(this.b.acceptChunk(l);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const P=this.b.peek(this.j.readLen),D=P.readUInt8(0),T=(D&128)>>>7,F=(D&64)>>>6,H=P.readUInt8(1),V=(H&128)>>>7,W=H&127;this.j.state=2,this.j.readLen=2+(V?4:0)+(W===126?2:0)+(W===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const P=this.b.read(this.j.readLen),D=P.readUInt8(1),T=(D&128)>>>7;let F=D&127,H=1;F===126?F=P.readUInt8(++H)*2**8+P.readUInt8(++H):F===127&&(F=P.readUInt8(++H)*0+P.readUInt8(++H)*0+P.readUInt8(++H)*0+P.readUInt8(++H)*0+P.readUInt8(++H)*2**24+P.readUInt8(++H)*2**16+P.readUInt8(++H)*2**8+P.readUInt8(++H));let V=0;T&&(V=P.readUInt8(++H)*2**24+P.readUInt8(++H)*2**16+P.readUInt8(++H)*2**8+P.readUInt8(++H)),this.j.state=3,this.j.readLen=F,this.j.mask=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const P=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),n(P,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(P,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$bh=u;class p extends m.$kb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Ib.alloc(0)}constructor(l,P,D,T,F,H){super(),this.l=l,this.m=F,this.n=H,this.a=this.B(new k.$5c),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$5c),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new k.$5c),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,P?(this.b=this.B(new w(this.l,T,D,{windowBits:15})),this.f=this.B(new I(this.l,{windowBits:15})),this.B(this.b.onError(V=>this.a.fire(V))),this.B(this.f.onError(V=>this.a.fire(V)))):(this.b=null,this.f=null)}writeMessage(l){this.g.push(l),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const l=this.g.shift();if(this.f){const P=await this.s(this.f,l);this.n(P,!0)}else this.n(l,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(l,P){return new Promise((D,T)=>{l.write(P),l.flush(F=>D(F))})}acceptFrame(l,P,D){this.h.push({data:l,isCompressed:P,isLastFrameOfMessage:D}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const l=this.h.shift();if(this.b&&l.isCompressed){const P=await this.w(this.b,l.data,l.isLastFrameOfMessage);this.m.fire(P)}else this.m.fire(l.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(l,P,D){return new Promise((T,F)=>{l.write(P),D&&l.write(O.$Ib.fromByteArray([0,0,255,255])),l.flush(H=>T(H))})}}class w extends m.$kb{get recordedInflateBytes(){return this.j?O.$Ib.concat(this.f):O.$Ib.alloc(0)}constructor(l,P,D,T){super(),this.h=l,this.j=P,this.a=this.B(new k.$5c),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(T),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(O.$Ib.wrap(F))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(l){this.j&&this.f.push(l.clone()),this.h.traceSocketEvent("zlibInflateWrite",l),this.b.write(l.buffer)}flush(l){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const P=O.$Ib.concat(this.g);this.g.length=0,l(P)})}}class I extends m.$kb{constructor(l,P){super(),this.g=l,this.a=this.B(new k.$5c),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(O.$Ib.wrap(D))})}write(l){this.g.traceSocketEvent("zlibDeflateWrite",l.buffer),this.b.write(l.buffer)}flush(l){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let P=O.$Ib.concat(this.f);this.f.length=0,P=P.slice(0,P.byteLength-4),l(P)})}}function n(d,l){if(l===0)return;const P=d.byteLength>>>2;for(let W=0;W<P;W++){const x=d.readUInt32BE(W*4);d.writeUInt32BE(x^l,W*4)}const D=P*4,T=d.byteLength-D,F=l>>>24&255,H=l>>>16&255,V=l>>>8&255;T>=1&&d.writeUInt8(d.readUInt8(D)^F,D),T>=2&&d.writeUInt8(d.readUInt8(D+1)^H,D+1),T>=3&&d.writeUInt8(d.readUInt8(D+2)^V,D+2)}e.$ch=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function i(){const d=(0,b.$3e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;const l=process.platform!=="darwin"&&e.$ch?e.$ch:(0,L.tmpdir)(),P=(0,S.$$b)(l,`vscode-ipc-${d}.sock`);return s(P),P}e.$dh=i;function t(d,l,P){const D=(0,R.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${P}-${l}-sock`;const T=P.substr(0,4),F=l.substr(0,6),H=D.substr(0,8);let V;return process.platform!=="darwin"&&e.$ch&&!process.env.VSCODE_PORTABLE?V=(0,S.$$b)(e.$ch,`vscode-${H}-${T}-${F}.sock`):V=(0,S.$$b)(d,`${T}-${F}.sock`),s(V),V}e.$eh=t;function s(d){const l=r[E.$t];typeof l=="number"&&d.length>=l&&console.warn(`WARNING: IPC handle "${d}" is longer than ${l} chars, try a shorter --user-data-dir`)}class o extends f.$2g{static b(l){const P=k.Event.fromNodeEventEmitter(l,"connection");return k.Event.map(P,D=>({protocol:new $.$9g(new v(D,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(D,"close"))}))}constructor(l){super(o.b(l)),this.d=l}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$fh=o;function c(d){return new Promise((l,P)=>{const D=(0,M.createServer)();D.on("error",P),D.listen(d,()=>{D.removeListener("error",P),l(new o(D))})})}e.$gh=c;function y(d,l){return new Promise((P,D)=>{const T=(0,M.createConnection)(d,()=>{T.removeListener("error",D),P($.$0g.fromSocket(new v(T,`ipc-client${l}`),l))});T.once("error",D)})}e.$hh=y}),define(ae[260],ce([0,1,62,259,203]),function(ne,e,R,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_4b=void 0,e.$_4b=new class{supports(j){return!0}connect({host:j,port:O},C,k,m){return new Promise((S,E)=>{const b=R.createConnection({host:j,port:O},()=>{b.removeListener("error",E),b.write((0,L.$shb)(C,k,m));const f=$=>{$.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",f),S(new M.$ah(b,m)))};b.on("data",f)});b.setNoDelay(!0),b.once("error",E)})}}}),define(ae[268],ce([0,1,36,38,7,2,25,12,43,140,197,198,189,190,255,180,182,18,202,95,213,96,208,14,210,113,240,28,97,181,121,98,13,192,193,68,4,188,70,72,218,8,194,102,24,56,19,107,20,108,109,110,45,221,79,111,23,77,246,232,233,80,247,250,251,252,58,245,234,106,212,76,223,207,222,29,224,5,225,183,200,199,78,239,17,50,196,55,244,220,235,105,249,258,9,195,101,242,238,209,177,54,253,241,71,243,104,260]),function(ne,e,R,M,L,j,O,C,k,m,S,E,b,f,$,v,a,h,u,p,w,I,n,r,i,t,s,o,c,y,d,l,P,D,T,F,H,V,W,x,ee,X,_,q,G,B,ie,re,K,Z,N,g,A,U,Q,z,J,te,oe,he,fe,be,pe,Ee,Ce,Le,Ue,Ge,le,de,$e,Se,Pe,Me,Ie,qe,Ae,Fe,Te,Oe,se,ue,ge,me,ye,ke,Re,De,Be,je,ze,Ve,_e,nt,kt,St,gt,Pt,Ct,Rt,It,Lt,Ot,jt,mt,Dt,bt,At){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Nt extends j.$kb{constructor(ve){super(),this.c=ve,this.a=this.B(new m.$6R),this.b=void 0,this.f()}f(){let ve=!1;const Ne=()=>{ve||(ve=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ne),(0,m.$7R)(process.parentPort,"vscode:electron-main->shared-process=exit",Ne)}async init(){const ve=await this.g();(0,J.$pdb)(),ve.invokeFunction(Ne=>{const Xe=Ne.get(X.$Ni);Xe.trace("sharedProcess configuration",JSON.stringify(this.c)),this.h(Ne),this.i(Xe)}),this.B((0,j.$hb)(ve.createInstance(S.$x4b,this.c.codeCachePath),ve.createInstance(E.$y4b),ve.createInstance($.$B4b),ve.createInstance(f.$A4b),ve.createInstance(b.$z4b),ve.createInstance(nt.$34b),ve.createInstance(ze.$V4b)))}async g(){const ve=new W.$jh,Ne={_serviceBrand:void 0,...q.default};ve.set(G.$6i,Ne);const Xe=new k.$6g(He=>He==="main"),Je=new mt.$b4b(this.a,Xe);ve.set(mt.$a4b,Je);const at=this.c.policiesData?new Re.$O3b(this.c.policiesData,Je.getChannel("policy")):new De.$Tm;ve.set(De.$Rm,at);const Ye=new i.$E4b(this.c.args,Ne);ve.set(r.$th,Ye);const et=new _.$Jq(void 0,this.c.logLevel,Ye.logsHome,this.c.loggers.map(He=>({...He,resource:C.URI.revive(He.resource)})),Je.getChannel("logger"));ve.set(X.$Oi,et);const ct=this.B(et.createLogger("sharedprocess",{name:(0,kt.localize)(0,null)})),ut=this.B(new X.$Vi(ct.getLevel())),Ke=this.B(new St.$wM(ct,[ut]));ve.set(X.$Ni,Ke),this.b=this.B(new gt.$54b(Ke)),ve.set(gt.$44b,this.b);const Ze=this.B(new D.$op(Ke));ve.set(P.$Oj,Ze);const ft=this.B(new T.$Np(Ke));Ze.registerProvider(O.Schemas.file,ft);const dt=this.B(new Te.$T4b(O.Schemas.file,this.B(new Oe.$fM(Je.getChannel(Oe.$eM),{pathCaseSensitive:Fe.$k})),O.Schemas.vscodeUserData,Ke));Ze.registerProvider(O.Schemas.vscodeUserData,dt);const tt=this.B(new Be.$DM(this.c.profiles.all,C.URI.revive(this.c.profiles.home).with({scheme:Ye.userRoamingDataHome.scheme}),Je.getChannel("userDataProfiles")));ve.set(ye.$nk,tt);const xe=this.B(new u.$hn(tt.defaultProfile.settingsResource,Ze,at,Ke));ve.set(h.$Rh,xe);const st=new Dt.$$4b(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},Je,Ye);ve.set(ie.$Go,st),this.B((0,j.$ib)(()=>st.flush())),await Promise.all([xe.initialize(),st.initialize()]);const Mt=new Ae.$$q(Ze);ve.set(qe.$lk,Mt),ve.set(B.$uo,new Rt.$xq(Je.getChannel("request"))),ve.set(v.$C4b,new F.$ih(a.$D4b,void 0,!1)),ve.set(ue.$WE,new F.$ih(se.$U4b,void 0,!1));const yt=k.ProxyChannel.toService(Je.getChannel("nativeHost"));ve.set(Lt.$R2b,yt),ve.set(I.$qn,new F.$ih(n.$LM,void 0,!0));const Tt=this.B(new le.$K3b(yt)),Ft=new k.$6g(He=>Tt.getActiveClientId().then(ht=>He===ht));ve.set(l.$MRb,new It.$74b(this.a.getChannel("extensionRecommendationNotification",Ft)));let lt;const rt=[],pt=(0,A.$$n)(Ne,xe);if((0,A.$6n)(Ne,Ye)){const He=new N.$TZb(Ke,et,Ye,Ne);if(rt.push(He),Ne.aiConfig?.ariaKey){const ht=new je.$kM(pt,"monacoworkbench",null,Ne.aiConfig.ariaKey);this.B((0,j.$ib)(()=>ht.flush())),rt.push(ht)}lt=new g.$Bq({appenders:rt,commonProperties:(0,re.$Vn)((0,R.release)(),(0,R.hostname)(),process.arch,Ne.commit,Ne.version,this.c.machineId,pt),sendErrorTelemetry:!0,piiPaths:(0,A.$_n)(Ye)},xe,Ne)}else{lt=A.$Zn;const He=A.$4n;rt.push(He)}this.a.registerChannel("telemetryAppender",new Z.$o3b(rt)),ve.set(K.$Rk,lt);const zt=new U.$F4b(xe,lt,Ke,et,Ye,Ne);ve.set(K.$Sk,zt),ve.set(ke.$8o,new F.$ih(Ct.$vM,void 0,!0)),ve.set(ge.$_o,new F.$ih(me.$P3b,void 0,!0)),ve.set(c.$Ro,new F.$ih(c.$So,void 0,!0)),ve.set(d.$jp,new F.$ih(d.$kp,void 0,!0)),ve.set(o.$Ln,new F.$ih(s.$Po,void 0,!0)),ve.set(o.$Rn,new F.$ih(jt.$04b,void 0,!1)),ve.set(x.$tq,new F.$ih(ee.$vq,void 0,!1)),ve.set(p.$1l,new F.$ih(w.$fr,void 0,!1)),ve.set(te.$ywb,new F.$ih(te.$zwb,void 0,!0)),ve.set(J.$Kdb,new F.$ih(fe.$Gyb,void 0,!0)),ve.set(J.$Jdb,new he.$I4b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ve.set(o.$Qn,new F.$ih(t.$wwb,void 0,!1)),ve.set(z.$Eyb,new F.$ih(z.$Fyb,void 0,!0)),ve.set(Q.$iz,new F.$ih(Q.$jz)),ve.set(J.$udb,new F.$ih(Le.$Pxb,void 0,!0)),ve.set(J.$vdb,new F.$ih(Le.$Rxb,void 0,!0)),ve.set(be.$zWb,new F.$ih(be.$BWb,void 0,!0)),ve.set(J.$wdb,new F.$ih(oe.$x1b,void 0,!1)),ve.set(J.$Fdb,new F.$ih(pe.$m1b,void 0,!0)),ve.set(J.$Gdb,new F.$ih(Ee.$C1b,void 0,!1)),ve.set(Ue.$$wb,new F.$ih(Ge.$P4b,void 0,!0)),ve.set(J.$Hdb,new F.$ih(_e.$c2b,void 0,!0)),ve.set(de.$Fk,new F.$ih($e.$03b,void 0,!1));const vt=new bt.$Dk;return ve.set(bt.$Ck,vt),vt.register(0,At.$_4b),ve.set(Se.$vz,new F.$ih(Pe.$83b)),ve.set(Me.$Q4b,new F.$ih(Ie.$S4b)),ve.set(Ve.$W4b,new F.$ih(Pt.$64b)),new V.$Qp(ve)}h(ve){const Ne=new y.$Uo(ve.get(o.$Nn),()=>null);this.a.registerChannel("extensions",Ne);const Xe=k.ProxyChannel.fromService(ve.get(x.$tq));this.a.registerChannel("languagePacks",Xe);const Je=k.ProxyChannel.fromService(ve.get(p.$1l));this.a.registerChannel("diagnostics",Je);const at=new y.$Wo(ve.get(o.$Rn));this.a.registerChannel("extensionTipsService",at);const Ye=k.ProxyChannel.fromService(ve.get(v.$C4b));this.a.registerChannel("checksum",Ye);const et=k.ProxyChannel.fromService(ve.get(ue.$WE));this.a.registerChannel("v8InspectProfiling",et);const ct=new he.$J4b(ve.get(be.$zWb));this.a.registerChannel("userDataSyncMachines",ct);const ut=k.ProxyChannel.fromService(ve.get(K.$Sk));this.a.registerChannel("customEndpointTelemetry",ut);const Ke=new he.$K4b(ve.get(te.$ywb));this.a.registerChannel("userDataSyncAccount",Ke);const Ze=new he.$L4b(ve.get(J.$udb));this.a.registerChannel("userDataSyncStoreManagement",Ze);const ft=new Ce.$N4b(ve.get(J.$Gdb),ve.get(ye.$nk),ve.get(X.$Ni));this.a.registerChannel("userDataSync",ft);const dt=this.B(ve.get(H.$kh).createInstance(Ot.$94b)),tt=new he.$G4b(dt);this.a.registerChannel("userDataAutoSync",tt);const xe=k.ProxyChannel.fromService(ve.get(Me.$Q4b));this.a.registerChannel(Me.$R4b,xe);const st=k.ProxyChannel.fromService(ve.get(Ve.$W4b));this.a.registerChannel("remoteTunnel",st)}i(ve){process.on("uncaughtException",Ne=>(0,L.$X)(Ne)),process.on("unhandledRejection",Ne=>(0,L.$X)(Ne)),(0,L.setUnexpectedErrorHandler)(Ne=>{const Xe=(0,M.$9h)(Ne,!0);Xe&&ve.error(`[uncaught exception in sharedProcess]: ${Xe}`)})}}async function wt(ot){const ve=new Nt(ot);process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"),await ve.init(),process.parentPort.postMessage("vscode:shared-process->electron-main=init-done")}e.main=wt,process.parentPort.once("message",ot=>{wt(ot.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/660393deaaa6d1996740ff4880f1bad43768c814/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
