/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/types","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/resources","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Fe=function(te){for(var e=[],g=0,C=te.length;g<C;g++)e[g]=Re[te[g]];return e};define(Re[64],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function g(T,f){const k=Object.create(null);for(const m of T){const F=f(m);let D=k[F];D||(D=k[F]=[]),D.push(m)}return k}e.$I=g;function C(T,f){const k=[],m=[];for(const F of T)f.has(F)||k.push(F);for(const F of f)T.has(F)||m.push(F);return{removed:k,added:m}}e.$J=C;function S(T,f){const k=[],m=[];for(const[F,D]of T)f.has(F)||k.push(D);for(const[F,D]of f)T.has(F)||m.push(D);return{removed:k,added:m}}e.$K=S;class z{constructor(){this.a=new Map}add(f,k){let m=this.a.get(f);m||(m=new Set,this.a.set(f,m)),m.add(k)}delete(f,k){const m=this.a.get(f);m&&(m.delete(k),m.size===0&&this.a.delete(f))}forEach(f,k){const m=this.a.get(f);m&&m.forEach(k)}}e.$L=z}),define(Re[65],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.$Qg=e.$Pg=void 0;function g(T){return(f,k,m)=>{let F=null,D=null;if(typeof m.value=="function"?(F="value",D=m.value):typeof m.get=="function"&&(F="get",D=m.get),!D)throw new Error("not supported");m[F]=T(D,k)}}function C(T,f,k){let m=null,F=null;if(typeof k.value=="function"?(m="value",F=k.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(m="get",F=k.get),!F)throw new Error("not supported");const D=`$memoize$${f}`;k[m]=function(...h){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,h)}),this[D]}}e.$Pg=C;function S(T,f,k){return g((m,F)=>{const D=`$debounce$${F}`,h=`$debounce$result$${F}`;return function(...b){this[h]||(this[h]=k?k():void 0),clearTimeout(this[D]),f&&(this[h]=f(this[h],...b),b=[this[h]]),this[D]=setTimeout(()=>{m.apply(this,b),this[h]=k?k():void 0},T)}})}e.$Qg=S;function z(T,f,k){return g((m,F)=>{const D=`$throttle$timer$${F}`,h=`$throttle$result$${F}`,b=`$throttle$lastRun$${F}`,$=`$throttle$pending$${F}`;return function(...u){if(this[h]||(this[h]=k?k():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),f&&(this[h]=f(this[h],...u)),this[$])return;const t=this[b]+T;t<=Date.now()?(this[b]=Date.now(),m.apply(this,[this[h]]),this[h]=k?k():void 0):(this[$]=!0,this[D]=setTimeout(()=>{this[$]=!1,this[b]=Date.now(),m.apply(this,[this[h]]),this[h]=k?k():void 0},t-Date.now()))}})}e.$Rg=z}),define(Re[88],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gL=e.$fL=void 0;class g{constructor(S){this.a=S,this.b=0}nextId(){return this.a+ ++this.b}}e.$fL=g,e.$gL=new g("id#")}),define(Re[115],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(g||(e.ScanError=g={}));var C;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var S;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var z;(function(i){i.DEFAULT={allowTrailingComma:!0}})(z||(e.ParseOptions=z={}));function T(i,l=!1){let n=0;const s=i.length;let p="",I=0,d=16,A=0;function E(W){let N=0,H=0;for(;N<W;){const j=i.charCodeAt(n);if(j>=48&&j<=57)H=H*16+j-48;else if(j>=65&&j<=70)H=H*16+j-65+10;else if(j>=97&&j<=102)H=H*16+j-97+10;else break;n++,N++}return N<W&&(H=-1),H}function a(W){n=W,p="",I=0,d=16,A=0}function o(){const W=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&m(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&m(i.charCodeAt(n)))for(n++;n<i.length&&m(i.charCodeAt(n));)n++;else return A=3,i.substring(W,n);let N=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&m(i.charCodeAt(n))){for(n++;n<i.length&&m(i.charCodeAt(n));)n++;N=n}else A=3;return i.substring(W,N)}function L(){let W="",N=n;for(;;){if(n>=s){W+=i.substring(N,n),A=2;break}const H=i.charCodeAt(n);if(H===34){W+=i.substring(N,n),n++;break}if(H===92){if(W+=i.substring(N,n),n++,n>=s){A=2;break}switch(i.charCodeAt(n++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const O=E(4);O>=0?W+=String.fromCharCode(O):A=4;break}default:A=5}N=n;continue}if(H>=0&&H<=31)if(k(H)){W+=i.substring(N,n),A=2;break}else A=6;n++}return W}function B(){if(p="",A=0,I=n,n>=s)return I=s,d=17;let W=i.charCodeAt(n);if(f(W)){do n++,p+=String.fromCharCode(W),W=i.charCodeAt(n);while(f(W));return d=15}if(k(W))return n++,p+=String.fromCharCode(W),W===13&&i.charCodeAt(n)===10&&(n++,p+=`
`),d=14;switch(W){case 123:return n++,d=1;case 125:return n++,d=2;case 91:return n++,d=3;case 93:return n++,d=4;case 58:return n++,d=6;case 44:return n++,d=5;case 34:return n++,p=L(),d=10;case 47:{const N=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!k(i.charCodeAt(n));)n++;return p=i.substring(N,n),d=12}if(i.charCodeAt(n+1)===42){n+=2;const H=s-1;let j=!1;for(;n<H;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,j=!0;break}n++}return j||(n++,A=1),p=i.substring(N,n),d=13}return p+=String.fromCharCode(W),n++,d=16}case 45:if(p+=String.fromCharCode(W),n++,n===s||!m(i.charCodeAt(n)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return p+=o(),d=11;default:for(;n<s&&G(W);)n++,W=i.charCodeAt(n);if(I!==n){switch(p=i.substring(I,n),p){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return p+=String.fromCharCode(W),n++,d=16}}function G(W){if(f(W)||k(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let W;do W=B();while(W>=12&&W<=15);return W}return{setPosition:a,getPosition:()=>n,scan:l?q:B,getToken:()=>d,getTokenValue:()=>p,getTokenOffset:()=>I,getTokenLength:()=>n-I,getTokenError:()=>A}}e.$rm=T;function f(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function k(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var F;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(F||(F={}));function D(i,l){const n=[],s=new Object;let p;const I={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function A(E,a,o,L){I.value=E,I.offset=a,I.length=o,I.type=L,I.colonOffset=void 0,p=I}try{w(i,{onObjectBegin:(E,a)=>{if(l<=E)throw s;p=void 0,d=l>E,n.push("")},onObjectProperty:(E,a,o)=>{if(l<a||(A(E,a,o,"property"),n[n.length-1]=E,l<=a+o))throw s},onObjectEnd:(E,a)=>{if(l<=E)throw s;p=void 0,n.pop()},onArrayBegin:(E,a)=>{if(l<=E)throw s;p=void 0,n.push(0)},onArrayEnd:(E,a)=>{if(l<=E)throw s;p=void 0,n.pop()},onLiteralValue:(E,a,o)=>{if(l<a||(A(E,a,o,y(E)),l<=a+o))throw s},onSeparator:(E,a,o)=>{if(l<=a)throw s;if(E===":"&&p&&p.type==="property")p.colonOffset=a,d=!1,p=void 0;else if(E===","){const L=n[n.length-1];typeof L=="number"?n[n.length-1]=L+1:(d=!0,n[n.length-1]=""),p=void 0}}})}catch(E){if(E!==s)throw E}return{path:n,previousNode:p,isAtPropertyKey:d,matches:E=>{let a=0;for(let o=0;a<E.length&&o<n.length;o++)if(E[a]===n[o]||E[a]==="*")a++;else if(E[a]!=="**")return!1;return a===E.length}}}e.$sm=D;function h(i,l=[],n=z.DEFAULT){let s=null,p=[];const I=[];function d(E){Array.isArray(p)?p.push(E):s!==null&&(p[s]=E)}return w(i,{onObjectBegin:()=>{const E={};d(E),I.push(p),p=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{p=I.pop()},onArrayBegin:()=>{const E=[];d(E),I.push(p),p=E,s=null},onArrayEnd:()=>{p=I.pop()},onLiteralValue:d,onError:(E,a,o)=>{l.push({error:E,offset:a,length:o})}},n),p[0]}e.$tm=h;function b(i,l=[],n=z.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(E){s.type==="property"&&(s.length=E-s.offset,s=s.parent)}function I(E){return s.children.push(E),E}w(i,{onObjectBegin:E=>{s=I({type:"object",offset:E,length:-1,parent:s,children:[]})},onObjectProperty:(E,a,o)=>{s=I({type:"property",offset:a,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:E,offset:a,length:o,parent:s})},onObjectEnd:(E,a)=>{s.length=E+a-s.offset,s=s.parent,p(E+a)},onArrayBegin:(E,a)=>{s=I({type:"array",offset:E,length:-1,parent:s,children:[]})},onArrayEnd:(E,a)=>{s.length=E+a-s.offset,s=s.parent,p(E+a)},onLiteralValue:(E,a,o)=>{I({type:y(E),offset:a,length:o,parent:s,value:E}),p(a+o)},onSeparator:(E,a,o)=>{s.type==="property"&&(E===":"?s.colonOffset=a:E===","&&p(a))},onError:(E,a,o)=>{l.push({error:E,offset:a,length:o})}},n);const A=s.children[0];return A&&delete A.parent,A}e.$um=b;function $(i,l){if(!i)return;let n=i;for(const s of l)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let p=!1;for(const I of n.children)if(Array.isArray(I.children)&&I.children[0].value===s){n=I.children[1],p=!0;break}if(!p)return}else{const p=s;if(n.type!=="array"||p<0||!Array.isArray(n.children)||p>=n.children.length)return;n=n.children[p]}return n}e.$vm=$;function u(i){if(!i.parent||!i.parent.children)return[];const l=u(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;l.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&l.push(n)}return l}e.$wm=u;function t(i){switch(i.type){case"array":return i.children.map(t);case"object":{const l=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(l[n.children[0].value]=t(s))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$xm=t;function r(i,l,n=!1){return l>=i.offset&&l<i.offset+i.length||n&&l===i.offset+i.length}e.$ym=r;function c(i,l,n=!1){if(r(i,l,n)){const s=i.children;if(Array.isArray(s))for(let p=0;p<s.length&&s[p].offset<=l;p++){const I=c(s[p],l,n);if(I)return I}return i}}e.$zm=c;function w(i,l,n=z.DEFAULT){const s=T(i,!1);function p(ce){return ce?()=>ce(s.getTokenOffset(),s.getTokenLength()):()=>!0}function I(ce){return ce?ke=>ce(ke,s.getTokenOffset(),s.getTokenLength()):()=>!0}const d=p(l.onObjectBegin),A=I(l.onObjectProperty),E=p(l.onObjectEnd),a=p(l.onArrayBegin),o=p(l.onArrayEnd),L=I(l.onLiteralValue),B=I(l.onSeparator),G=p(l.onComment),q=I(l.onError),W=n&&n.disallowComments,N=n&&n.allowTrailingComma;function H(){for(;;){const ce=s.scan();switch(s.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:W||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(ce){case 12:case 13:W?j(10):G();break;case 16:j(1);break;case 15:case 14:break;default:return ce}}}function j(ce,ke=[],Ce=[]){if(q(ce),ke.length+Ce.length>0){let me=s.getToken();for(;me!==17;){if(ke.indexOf(me)!==-1){H();break}else if(Ce.indexOf(me)!==-1)break;me=H()}}}function O(ce){const ke=s.getTokenValue();return ce?L(ke):A(ke),H(),!0}function ue(){switch(s.getToken()){case 11:{let ce=0;try{ce=JSON.parse(s.getTokenValue()),typeof ce!="number"&&(j(2),ce=0)}catch{j(2)}L(ce);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return H(),!0}function pe(){return s.getToken()!==10?(j(3,[],[2,5]),!1):(O(!1),s.getToken()===6?(B(":"),H(),Y()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function Pe(){d(),H();let ce=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ce||j(4,[],[]),B(","),H(),s.getToken()===2&&N)break}else ce&&j(6,[],[]);pe()||j(4,[],[2,5]),ce=!0}return E(),s.getToken()!==2?j(7,[2],[]):H(),!0}function _(){a(),H();let ce=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ce||j(4,[],[]),B(","),H(),s.getToken()===4&&N)break}else ce&&j(6,[],[]);Y()||j(4,[],[4,5]),ce=!0}return o(),s.getToken()!==4?j(8,[4],[]):H(),!0}function Y(){switch(s.getToken()){case 3:return _();case 1:return Pe();case 10:return O(!0);default:return ue()}}return H(),s.getToken()===17?n.allowEmptyContent?!0:(j(4,[],[]),!1):Y()?(s.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.$Am=w;function v(i,l){const n=T(i),s=[];let p,I=0,d;do switch(d=n.getPosition(),p=n.scan(),p){case 12:case 13:case 17:I!==d&&s.push(i.substring(I,d)),l!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,l)),I=n.getPosition();break}while(p!==17);return s.join("")}e.$Bm=v;function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$Cm=y}),define(Re[28],Fe([1,0]),function(te,e){"use strict";var g,C,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.Touch=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;function z(u,t,r){let c=u.get(t);return c===void 0&&(c=r,u.set(t,c)),c}e.$gi=z;function T(u){const t=[];return u.forEach((r,c)=>{t.push(`${c} => ${r}`)}),`Map(${u.size}) {${t.join(", ")}}`}e.$hi=T;function f(u){const t=[];return u.forEach(r=>{t.push(r)}),`Set(${u.size}) {${t.join(", ")}}`}e.$ii=f;class k{constructor(t,r){this.uri=t,this.value=r}}class m{constructor(t,r){this[g]="ResourceMap",t instanceof m?(this.b=new Map(t.b),this.c=r??m.a):(this.b=new Map,this.c=t??m.a)}set(t,r){return this.b.set(this.c(t),new k(t,r)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[c,w]of this.b)t(w.value,w.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(g=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.$ji=m,m.a=u=>u.toString();class F{constructor(t,r){this[C]="ResourceSet",!t||typeof t=="function"?this.a=new m(t):(this.a=new m(r),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,r){this.a.forEach((c,w)=>t.call(r,w,w,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$ki=F;var D;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(D||(e.Touch=D={}));class h{constructor(){this[S]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,r=0){const c=this.a.get(t);if(c)return r!==0&&this.j(c,r),c.value}set(t,r,c=0){let w=this.a.get(t);if(w)w.value=r,c!==0&&this.j(w,c);else{switch(w={key:t,value:r,next:void 0,previous:void 0},c){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(t,w),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this.a.get(t);if(r)return this.a.delete(t),this.i(r),this.d--,r.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,r){const c=this.e;let w=this.b;for(;w;){if(r?t.bind(r)(w.value,w.key,this):t(w.value,w.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const t=this,r=this.e;let c=this.b;const w={[Symbol.iterator](){return w},next(){if(t.e!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const v={value:c.key,done:!1};return c=c.next,v}else return{value:void 0,done:!0}}};return w}values(){const t=this,r=this.e;let c=this.b;const w={[Symbol.iterator](){return w},next(){if(t.e!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const v={value:c.value,done:!1};return c=c.next,v}else return{value:void 0,done:!0}}};return w}entries(){const t=this,r=this.e;let c=this.b;const w={[Symbol.iterator](){return w},next(){if(t.e!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const v={value:[c.key,c.value],done:!1};return c=c.next,v}else return{value:void 0,done:!0}}};return w}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.b,c=this.size;for(;r&&c>t;)this.a.delete(r.key),r=r.next,c--;this.b=r,this.d=c,r&&(r.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const r=t.next,c=t.previous;if(!r||!c)throw new Error("Invalid list");r.previous=c,c.next=r}t.next=void 0,t.previous=void 0,this.e++}j(t,r){if(!this.b||!this.c)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this.b)return;const c=t.next,w=t.previous;t===this.c?(w.next=void 0,this.c=w):(c.previous=w,w.next=c),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(r===2){if(t===this.c)return;const c=t.next,w=t.previous;t===this.b?(c.previous=void 0,this.b=c):(c.previous=w,w.next=c),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((r,c)=>{t.push([c,r])}),t}fromJSON(t){this.clear();for(const[r,c]of t)this.set(r,c)}}e.$li=h;class b extends h{constructor(t,r=1){super(),this.k=t,this.l=Math.min(Math.max(0,r),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$mi=b;class ${constructor(){this.a=new Map}add(t){return this.a.set(t,(this.a.get(t)||0)+1),this}delete(t){let r=this.a.get(t)||0;return r===0?!1:(r--,r===0?this.a.delete(t):this.a.set(t,r),!0)}has(t){return this.a.has(t)}}e.$ni=$}),function(te,e){typeof define=="function"&&define.amd?define(Re[116],Fe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(ye,$e){for(var Se=0;Se<$e.length;Se++){var ae=$e[Se];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(ye,ae.key,ae)}}function g(ye,$e,Se){return $e&&e(ye.prototype,$e),Se&&e(ye,Se),Object.defineProperty(ye,"prototype",{writable:!1}),ye}function C(ye,$e){if(ye){if(typeof ye=="string")return S(ye,$e);var Se=Object.prototype.toString.call(ye).slice(8,-1);if(Se==="Object"&&ye.constructor&&(Se=ye.constructor.name),Se==="Map"||Se==="Set")return Array.from(ye);if(Se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Se))return S(ye,$e)}}function S(ye,$e){($e==null||$e>ye.length)&&($e=ye.length);for(var Se=0,ae=new Array($e);Se<$e;Se++)ae[Se]=ye[Se];return ae}function z(ye,$e){var Se=typeof Symbol<"u"&&ye[Symbol.iterator]||ye["@@iterator"];if(Se)return(Se=Se.call(ye)).next.bind(Se);if(Array.isArray(ye)||(Se=C(ye))||$e&&ye&&typeof ye.length=="number"){Se&&(ye=Se);var ae=0;return function(){return ae>=ye.length?{done:!0}:{done:!1,value:ye[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=T();function f(ye){te.defaults=ye}var k=/[&<>"']/,m=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function($e){return h[$e]};function $(ye,$e){if($e){if(k.test(ye))return ye.replace(m,b)}else if(F.test(ye))return ye.replace(D,b);return ye}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ye){return ye.replace(u,function($e,Se){return Se=Se.toLowerCase(),Se==="colon"?":":Se.charAt(0)==="#"?Se.charAt(1)==="x"?String.fromCharCode(parseInt(Se.substring(2),16)):String.fromCharCode(+Se.substring(1)):""})}var r=/(^|[^\[])\^/g;function c(ye,$e){ye=typeof ye=="string"?ye:ye.source,$e=$e||"";var Se={replace:function(le,ne){return ne=ne.source||ne,ne=ne.replace(r,"$1"),ye=ye.replace(le,ne),Se},getRegex:function(){return new RegExp(ye,$e)}};return Se}var w=/[^\w:]/g,v=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function y(ye,$e,Se){if(ye){var ae;try{ae=decodeURIComponent(t(Se)).replace(w,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}$e&&!v.test(Se)&&(Se=p($e,Se));try{Se=encodeURI(Se).replace(/%25/g,"%")}catch{return null}return Se}var i={},l=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(ye,$e){i[" "+ye]||(l.test(ye)?i[" "+ye]=ye+"/":i[" "+ye]=E(ye,"/",!0)),ye=i[" "+ye];var Se=ye.indexOf(":")===-1;return $e.substring(0,2)==="//"?Se?$e:ye.replace(n,"$1")+$e:$e.charAt(0)==="/"?Se?$e:ye.replace(s,"$1")+$e:ye+$e}var I={exec:function(){}};function d(ye){for(var $e=1,Se,ae;$e<arguments.length;$e++){Se=arguments[$e];for(ae in Se)Object.prototype.hasOwnProperty.call(Se,ae)&&(ye[ae]=Se[ae])}return ye}function A(ye,$e){var Se=ye.replace(/\|/g,function(ne,ee,P){for(var K=!1,V=ee;--V>=0&&P[V]==="\\";)K=!K;return K?"|":" |"}),ae=Se.split(/ \|/),le=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>$e)ae.splice($e);else for(;ae.length<$e;)ae.push("");for(;le<ae.length;le++)ae[le]=ae[le].trim().replace(/\\\|/g,"|");return ae}function E(ye,$e,Se){var ae=ye.length;if(ae===0)return"";for(var le=0;le<ae;){var ne=ye.charAt(ae-le-1);if(ne===$e&&!Se)le++;else if(ne!==$e&&Se)le++;else break}return ye.slice(0,ae-le)}function a(ye,$e){if(ye.indexOf($e[1])===-1)return-1;for(var Se=ye.length,ae=0,le=0;le<Se;le++)if(ye[le]==="\\")le++;else if(ye[le]===$e[0])ae++;else if(ye[le]===$e[1]&&(ae--,ae<0))return le;return-1}function o(ye){ye&&ye.sanitize&&!ye.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(ye,$e){if($e<1)return"";for(var Se="";$e>1;)$e&1&&(Se+=ye),$e>>=1,ye+=ye;return Se+ye}function B(ye,$e,Se,ae){var le=$e.href,ne=$e.title?$($e.title):null,ee=ye[1].replace(/\\([\[\]])/g,"$1");if(ye[0].charAt(0)!=="!"){ae.state.inLink=!0;var P={type:"link",raw:Se,href:le,title:ne,text:ee,tokens:ae.inlineTokens(ee)};return ae.state.inLink=!1,P}return{type:"image",raw:Se,href:le,title:ne,text:$(ee)}}function G(ye,$e){var Se=ye.match(/^(\s+)(?:```)/);if(Se===null)return $e;var ae=Se[1];return $e.split(`
`).map(function(le){var ne=le.match(/^\s+/);if(ne===null)return le;var ee=ne[0];return ee.length>=ae.length?le.slice(ae.length):le}).join(`
`)}var q=function(){function ye(Se){this.options=Se||te.defaults}var $e=ye.prototype;return $e.space=function(ae){var le=this.rules.block.newline.exec(ae);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},$e.code=function(ae){var le=this.rules.block.code.exec(ae);if(le){var ne=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:E(ne,`
`)}}},$e.fences=function(ae){var le=this.rules.block.fences.exec(ae);if(le){var ne=le[0],ee=G(ne,le[3]||"");return{type:"code",raw:ne,lang:le[2]?le[2].trim():le[2],text:ee}}},$e.heading=function(ae){var le=this.rules.block.heading.exec(ae);if(le){var ne=le[2].trim();if(/#$/.test(ne)){var ee=E(ne,"#");(this.options.pedantic||!ee||/ $/.test(ee))&&(ne=ee.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:ne,tokens:this.lexer.inline(ne)}}},$e.hr=function(ae){var le=this.rules.block.hr.exec(ae);if(le)return{type:"hr",raw:le[0]}},$e.blockquote=function(ae){var le=this.rules.block.blockquote.exec(ae);if(le){var ne=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},$e.list=function(ae){var le=this.rules.block.list.exec(ae);if(le){var ne,ee,P,K,V,J,re,de,ie,ve,Ee,Be,We=le[1].trim(),_e=We.length>1,He={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Be=!1,!(!(le=Qe.exec(ae))||this.rules.block.hr.test(ae)));){if(ne=le[0],ae=ae.substring(ne.length),de=le[2].split(`
`,1)[0],ie=ae.split(`
`,1)[0],this.options.pedantic?(K=2,Ee=de.trimLeft()):(K=le[2].search(/[^ ]/),K=K>4?1:K,Ee=de.slice(K),K+=le[1].length),J=!1,!de&&/^ *$/.test(ie)&&(ne+=ie+`
`,ae=ae.substring(ie.length+1),Be=!0),!Be)for(var it=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ct=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");ae&&(ve=ae.split(`
`,1)[0],de=ve,this.options.pedantic&&(de=de.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(de)||rt.test(de)||it.test(de)||ct.test(ae)));){if(de.search(/[^ ]/)>=K||!de.trim())Ee+=`
`+de.slice(K);else if(!J)Ee+=`
`+de;else break;!J&&!de.trim()&&(J=!0),ne+=ve+`
`,ae=ae.substring(ve.length+1)}He.loose||(re?He.loose=!0:/\n *\n *$/.test(ne)&&(re=!0)),this.options.gfm&&(ee=/^\[[ xX]\] /.exec(Ee),ee&&(P=ee[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:ne,task:!!ee,checked:P,loose:!1,text:Ee}),He.raw+=ne}He.items[He.items.length-1].raw=ne.trimRight(),He.items[He.items.length-1].text=Ee.trimRight(),He.raw=He.raw.trimRight();var Oe=He.items.length;for(V=0;V<Oe;V++){this.lexer.state.top=!1,He.items[V].tokens=this.lexer.blockTokens(He.items[V].text,[]);var st=He.items[V].tokens.filter(function(X){return X.type==="space"}),x=st.every(function(X){for(var ge=X.raw.split(""),je=0,Ne=z(ge),Ze;!(Ze=Ne()).done;){var tt=Ze.value;if(tt===`
`&&(je+=1),je>1)return!0}return!1});!He.loose&&st.length&&x&&(He.loose=!0,He.items[V].loose=!0)}return He}},$e.html=function(ae){var le=this.rules.block.html.exec(ae);if(le){var ne={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var ee=this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]);ne.type="paragraph",ne.text=ee,ne.tokens=this.lexer.inline(ee)}return ne}},$e.def=function(ae){var le=this.rules.block.def.exec(ae);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var ne=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:le[0],href:le[2],title:le[3]}}},$e.table=function(ae){var le=this.rules.block.table.exec(ae);if(le){var ne={type:"table",header:A(le[1]).map(function(re){return{text:re}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=le[0];var ee=ne.align.length,P,K,V,J;for(P=0;P<ee;P++)/^ *-+: *$/.test(ne.align[P])?ne.align[P]="right":/^ *:-+: *$/.test(ne.align[P])?ne.align[P]="center":/^ *:-+ *$/.test(ne.align[P])?ne.align[P]="left":ne.align[P]=null;for(ee=ne.rows.length,P=0;P<ee;P++)ne.rows[P]=A(ne.rows[P],ne.header.length).map(function(re){return{text:re}});for(ee=ne.header.length,K=0;K<ee;K++)ne.header[K].tokens=this.lexer.inline(ne.header[K].text);for(ee=ne.rows.length,K=0;K<ee;K++)for(J=ne.rows[K],V=0;V<J.length;V++)J[V].tokens=this.lexer.inline(J[V].text);return ne}}},$e.lheading=function(ae){var le=this.rules.block.lheading.exec(ae);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},$e.paragraph=function(ae){var le=this.rules.block.paragraph.exec(ae);if(le){var ne=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:ne,tokens:this.lexer.inline(ne)}}},$e.text=function(ae){var le=this.rules.block.text.exec(ae);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},$e.escape=function(ae){var le=this.rules.inline.escape.exec(ae);if(le)return{type:"escape",raw:le[0],text:$(le[1])}},$e.tag=function(ae){var le=this.rules.inline.tag.exec(ae);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]):le[0]}},$e.link=function(ae){var le=this.rules.inline.link.exec(ae);if(le){var ne=le[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ee=E(ne.slice(0,-1),"\\");if((ne.length-ee.length)%2===0)return}else{var P=a(le[2],"()");if(P>-1){var K=le[0].indexOf("!")===0?5:4,V=K+le[1].length+P;le[2]=le[2].substring(0,P),le[0]=le[0].substring(0,V).trim(),le[3]=""}}var J=le[2],re="";if(this.options.pedantic){var de=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);de&&(J=de[1],re=de[3])}else re=le[3]?le[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(ne)?J=J.slice(1):J=J.slice(1,-1)),B(le,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:re&&re.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},$e.reflink=function(ae,le){var ne;if((ne=this.rules.inline.reflink.exec(ae))||(ne=this.rules.inline.nolink.exec(ae))){var ee=(ne[2]||ne[1]).replace(/\s+/g," ");if(ee=le[ee.toLowerCase()],!ee||!ee.href){var P=ne[0].charAt(0);return{type:"text",raw:P,text:P}}return B(ne,ee,ne[0],this.lexer)}},$e.emStrong=function(ae,le,ne){ne===void 0&&(ne="");var ee=this.rules.inline.emStrong.lDelim.exec(ae);if(ee&&!(ee[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var P=ee[1]||ee[2]||"";if(!P||P&&(ne===""||this.rules.inline.punctuation.exec(ne))){var K=ee[0].length-1,V,J,re=K,de=0,ie=ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ie.lastIndex=0,le=le.slice(-1*ae.length+K);(ee=ie.exec(le))!=null;)if(V=ee[1]||ee[2]||ee[3]||ee[4]||ee[5]||ee[6],!!V){if(J=V.length,ee[3]||ee[4]){re+=J;continue}else if((ee[5]||ee[6])&&K%3&&!((K+J)%3)){de+=J;continue}if(re-=J,!(re>0)){if(J=Math.min(J,J+re+de),Math.min(K,J)%2){var ve=ae.slice(1,K+ee.index+J);return{type:"em",raw:ae.slice(0,K+ee.index+J+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var Ee=ae.slice(2,K+ee.index+J-1);return{type:"strong",raw:ae.slice(0,K+ee.index+J+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},$e.codespan=function(ae){var le=this.rules.inline.code.exec(ae);if(le){var ne=le[2].replace(/\n/g," "),ee=/[^ ]/.test(ne),P=/^ /.test(ne)&&/ $/.test(ne);return ee&&P&&(ne=ne.substring(1,ne.length-1)),ne=$(ne,!0),{type:"codespan",raw:le[0],text:ne}}},$e.br=function(ae){var le=this.rules.inline.br.exec(ae);if(le)return{type:"br",raw:le[0]}},$e.del=function(ae){var le=this.rules.inline.del.exec(ae);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},$e.autolink=function(ae,le){var ne=this.rules.inline.autolink.exec(ae);if(ne){var ee,P;return ne[2]==="@"?(ee=$(this.options.mangle?le(ne[1]):ne[1]),P="mailto:"+ee):(ee=$(ne[1]),P=ee),{type:"link",raw:ne[0],text:ee,href:P,tokens:[{type:"text",raw:ee,text:ee}]}}},$e.url=function(ae,le){var ne;if(ne=this.rules.inline.url.exec(ae)){var ee,P;if(ne[2]==="@")ee=$(this.options.mangle?le(ne[0]):ne[0]),P="mailto:"+ee;else{var K;do K=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(K!==ne[0]);ee=$(ne[0]),ne[1]==="www."?P="http://"+ee:P=ee}return{type:"link",raw:ne[0],text:ee,href:P,tokens:[{type:"text",raw:ee,text:ee}]}}},$e.inlineText=function(ae,le){var ne=this.rules.inline.text.exec(ae);if(ne){var ee;return this.lexer.state.inRawBlock?ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):$(ne[0]):ne[0]:ee=$(this.options.smartypants?le(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ee}}},ye}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=c(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=c(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=c(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=c(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=c(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=d({},W),W.gfm=d({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=c(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=d({},W.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:c(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=c(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=c(W._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=c(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=c(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=c(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=c(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=c(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=c(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=c(N.reflink).replace("label",N._label).replace("ref",W._label).getRegex(),N.nolink=c(N.nolink).replace("ref",W._label).getRegex(),N.reflinkSearch=c(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=d({},N),N.pedantic=d({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=d({},N.normal,{escape:c(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=c(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=d({},N.gfm,{br:c(N.br).replace("{2,}","*").getRegex(),text:c(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function H(ye){return ye.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(ye){var $e="",Se,ae,le=ye.length;for(Se=0;Se<le;Se++)ae=ye.charCodeAt(Se),Math.random()>.5&&(ae="x"+ae.toString(16)),$e+="&#"+ae+";";return $e}var O=function(){function ye(Se){this.tokens=[],this.tokens.links=Object.create(null),this.options=Se||te.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:W.normal,inline:N.normal};this.options.pedantic?(ae.block=W.pedantic,ae.inline=N.pedantic):this.options.gfm&&(ae.block=W.gfm,this.options.breaks?ae.inline=N.breaks:ae.inline=N.gfm),this.tokenizer.rules=ae}ye.lex=function(ae,le){var ne=new ye(le);return ne.lex(ae)},ye.lexInline=function(ae,le){var ne=new ye(le);return ne.inlineTokens(ae)};var $e=ye.prototype;return $e.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},$e.blockTokens=function(ae,le){var ne=this;le===void 0&&(le=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(re,de,ie){return de+"    ".repeat(ie.length)});for(var ee,P,K,V;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(re){return(ee=re.call({lexer:ne},ae,le))?(ae=ae.substring(ee.raw.length),le.push(ee),!0):!1}))){if(ee=this.tokenizer.space(ae)){ae=ae.substring(ee.raw.length),ee.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(ee);continue}if(ee=this.tokenizer.code(ae)){ae=ae.substring(ee.raw.length),P=le[le.length-1],P&&(P.type==="paragraph"||P.type==="text")?(P.raw+=`
`+ee.raw,P.text+=`
`+ee.text,this.inlineQueue[this.inlineQueue.length-1].src=P.text):le.push(ee);continue}if(ee=this.tokenizer.fences(ae)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(ee=this.tokenizer.heading(ae)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(ee=this.tokenizer.hr(ae)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(ee=this.tokenizer.blockquote(ae)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(ee=this.tokenizer.list(ae)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(ee=this.tokenizer.html(ae)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(ee=this.tokenizer.def(ae)){ae=ae.substring(ee.raw.length),P=le[le.length-1],P&&(P.type==="paragraph"||P.type==="text")?(P.raw+=`
`+ee.raw,P.text+=`
`+ee.raw,this.inlineQueue[this.inlineQueue.length-1].src=P.text):this.tokens.links[ee.tag]||(this.tokens.links[ee.tag]={href:ee.href,title:ee.title});continue}if(ee=this.tokenizer.table(ae)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(ee=this.tokenizer.lheading(ae)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(K=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var re=1/0,de=ae.slice(1),ie=void 0;ne.options.extensions.startBlock.forEach(function(ve){ie=ve.call({lexer:this},de),typeof ie=="number"&&ie>=0&&(re=Math.min(re,ie))}),re<1/0&&re>=0&&(K=ae.substring(0,re+1))}(),this.state.top&&(ee=this.tokenizer.paragraph(K))){P=le[le.length-1],V&&P.type==="paragraph"?(P.raw+=`
`+ee.raw,P.text+=`
`+ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=P.text):le.push(ee),V=K.length!==ae.length,ae=ae.substring(ee.raw.length);continue}if(ee=this.tokenizer.text(ae)){ae=ae.substring(ee.raw.length),P=le[le.length-1],P&&P.type==="text"?(P.raw+=`
`+ee.raw,P.text+=`
`+ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=P.text):le.push(ee);continue}if(ae){var J="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,le},$e.inline=function(ae,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:ae,tokens:le}),le},$e.inlineTokens=function(ae,le){var ne=this;le===void 0&&(le=[]);var ee,P,K,V=ae,J,re,de;if(this.tokens.links){var ie=Object.keys(this.tokens.links);if(ie.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(V))!=null;)ie.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(V=V.slice(0,J.index)+"["+L("a",J[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(V))!=null;)V=V.slice(0,J.index)+"["+L("a",J[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(V))!=null;)V=V.slice(0,J.index)+"++"+V.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(re||(de=""),re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(ee=Ee.call({lexer:ne},ae,le))?(ae=ae.substring(ee.raw.length),le.push(ee),!0):!1}))){if(ee=this.tokenizer.escape(ae)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(ee=this.tokenizer.tag(ae)){ae=ae.substring(ee.raw.length),P=le[le.length-1],P&&ee.type==="text"&&P.type==="text"?(P.raw+=ee.raw,P.text+=ee.text):le.push(ee);continue}if(ee=this.tokenizer.link(ae)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(ee=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(ee.raw.length),P=le[le.length-1],P&&ee.type==="text"&&P.type==="text"?(P.raw+=ee.raw,P.text+=ee.text):le.push(ee);continue}if(ee=this.tokenizer.emStrong(ae,V,de)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(ee=this.tokenizer.codespan(ae)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(ee=this.tokenizer.br(ae)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(ee=this.tokenizer.del(ae)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(ee=this.tokenizer.autolink(ae,j)){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(!this.state.inLink&&(ee=this.tokenizer.url(ae,j))){ae=ae.substring(ee.raw.length),le.push(ee);continue}if(K=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,Be=ae.slice(1),We=void 0;ne.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},Be),typeof We=="number"&&We>=0&&(Ee=Math.min(Ee,We))}),Ee<1/0&&Ee>=0&&(K=ae.substring(0,Ee+1))}(),ee=this.tokenizer.inlineText(K,H)){ae=ae.substring(ee.raw.length),ee.raw.slice(-1)!=="_"&&(de=ee.raw.slice(-1)),re=!0,P=le[le.length-1],P&&P.type==="text"?(P.raw+=ee.raw,P.text+=ee.text):le.push(ee);continue}if(ae){var ve="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return le},g(ye,null,[{key:"rules",get:function(){return{block:W,inline:N}}}]),ye}(),ue=function(){function ye(Se){this.options=Se||te.defaults}var $e=ye.prototype;return $e.code=function(ae,le,ne){var ee=(le||"").match(/\S*/)[0];if(this.options.highlight){var P=this.options.highlight(ae,ee);P!=null&&P!==ae&&(ne=!0,ae=P)}return ae=ae.replace(/\n$/,"")+`
`,ee?'<pre><code class="'+this.options.langPrefix+$(ee,!0)+'">'+(ne?ae:$(ae,!0))+`</code></pre>
`:"<pre><code>"+(ne?ae:$(ae,!0))+`</code></pre>
`},$e.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},$e.html=function(ae){return ae},$e.heading=function(ae,le,ne,ee){if(this.options.headerIds){var P=this.options.headerPrefix+ee.slug(ne);return"<h"+le+' id="'+P+'">'+ae+"</h"+le+`>
`}return"<h"+le+">"+ae+"</h"+le+`>
`},$e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},$e.list=function(ae,le,ne){var ee=le?"ol":"ul",P=le&&ne!==1?' start="'+ne+'"':"";return"<"+ee+P+`>
`+ae+"</"+ee+`>
`},$e.listitem=function(ae){return"<li>"+ae+`</li>
`},$e.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},$e.paragraph=function(ae){return"<p>"+ae+`</p>
`},$e.table=function(ae,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+le+`</table>
`},$e.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},$e.tablecell=function(ae,le){var ne=le.header?"th":"td",ee=le.align?"<"+ne+' align="'+le.align+'">':"<"+ne+">";return ee+ae+("</"+ne+`>
`)},$e.strong=function(ae){return"<strong>"+ae+"</strong>"},$e.em=function(ae){return"<em>"+ae+"</em>"},$e.codespan=function(ae){return"<code>"+ae+"</code>"},$e.br=function(){return this.options.xhtml?"<br/>":"<br>"},$e.del=function(ae){return"<del>"+ae+"</del>"},$e.link=function(ae,le,ne){if(ae=y(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ne;var ee='<a href="'+$(ae)+'"';return le&&(ee+=' title="'+le+'"'),ee+=">"+ne+"</a>",ee},$e.image=function(ae,le,ne){if(ae=y(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ne;var ee='<img src="'+ae+'" alt="'+ne+'"';return le&&(ee+=' title="'+le+'"'),ee+=this.options.xhtml?"/>":">",ee},$e.text=function(ae){return ae},ye}(),pe=function(){function ye(){}var $e=ye.prototype;return $e.strong=function(ae){return ae},$e.em=function(ae){return ae},$e.codespan=function(ae){return ae},$e.del=function(ae){return ae},$e.html=function(ae){return ae},$e.text=function(ae){return ae},$e.link=function(ae,le,ne){return""+ne},$e.image=function(ae,le,ne){return""+ne},$e.br=function(){return""},ye}(),Pe=function(){function ye(){this.seen={}}var $e=ye.prototype;return $e.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},$e.getNextSafeSlug=function(ae,le){var ne=ae,ee=0;if(this.seen.hasOwnProperty(ne)){ee=this.seen[ae];do ee++,ne=ae+"-"+ee;while(this.seen.hasOwnProperty(ne))}return le||(this.seen[ae]=ee,this.seen[ne]=0),ne},$e.slug=function(ae,le){le===void 0&&(le={});var ne=this.serialize(ae);return this.getNextSafeSlug(ne,le.dryrun)},ye}(),_=function(){function ye(Se){this.options=Se||te.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new Pe}ye.parse=function(ae,le){var ne=new ye(le);return ne.parse(ae)},ye.parseInline=function(ae,le){var ne=new ye(le);return ne.parseInline(ae)};var $e=ye.prototype;return $e.parse=function(ae,le){le===void 0&&(le=!0);var ne="",ee,P,K,V,J,re,de,ie,ve,Ee,Be,We,_e,He,Qe,it,ct,et,rt,Oe=ae.length;for(ee=0;ee<Oe;ee++){if(Ee=ae[ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(rt=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){ne+=rt||"";continue}switch(Ee.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,t(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(ie="",de="",V=Ee.header.length,P=0;P<V;P++)de+=this.renderer.tablecell(this.parseInline(Ee.header[P].tokens),{header:!0,align:Ee.align[P]});for(ie+=this.renderer.tablerow(de),ve="",V=Ee.rows.length,P=0;P<V;P++){for(re=Ee.rows[P],de="",J=re.length,K=0;K<J;K++)de+=this.renderer.tablecell(this.parseInline(re[K].tokens),{header:!1,align:Ee.align[K]});ve+=this.renderer.tablerow(de)}ne+=this.renderer.table(ie,ve);continue}case"blockquote":{ve=this.parse(Ee.tokens),ne+=this.renderer.blockquote(ve);continue}case"list":{for(Be=Ee.ordered,We=Ee.start,_e=Ee.loose,V=Ee.items.length,ve="",P=0;P<V;P++)Qe=Ee.items[P],it=Qe.checked,ct=Qe.task,He="",Qe.task&&(et=this.renderer.checkbox(it),_e?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=et+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=et+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:et}):He+=et),He+=this.parse(Qe.tokens,_e),ve+=this.renderer.listitem(He,ct,it);ne+=this.renderer.list(ve,Be,We);continue}case"html":{ne+=this.renderer.html(Ee.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(ve=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;ee+1<Oe&&ae[ee+1].type==="text";)Ee=ae[++ee],ve+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);ne+=le?this.renderer.paragraph(ve):ve;continue}default:{var st='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return ne},$e.parseInline=function(ae,le){le=le||this.renderer;var ne="",ee,P,K,V=ae.length;for(ee=0;ee<V;ee++){if(P=ae[ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[P.type]&&(K=this.options.extensions.renderers[P.type].call({parser:this},P),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(P.type))){ne+=K||"";continue}switch(P.type){case"escape":{ne+=le.text(P.text);break}case"html":{ne+=le.html(P.text);break}case"link":{ne+=le.link(P.href,P.title,this.parseInline(P.tokens,le));break}case"image":{ne+=le.image(P.href,P.title,P.text);break}case"strong":{ne+=le.strong(this.parseInline(P.tokens,le));break}case"em":{ne+=le.em(this.parseInline(P.tokens,le));break}case"codespan":{ne+=le.codespan(P.text);break}case"br":{ne+=le.br();break}case"del":{ne+=le.del(this.parseInline(P.tokens,le));break}case"text":{ne+=le.text(P.text);break}default:{var J='Token with "'+P.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return ne},ye}();function Y(ye,$e,Se){if(typeof ye>"u"||ye===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");if(typeof $e=="function"&&(Se=$e,$e=null),$e=d({},Y.defaults,$e||{}),o($e),Se){var ae=$e.highlight,le;try{le=O.lex(ye,$e)}catch(V){return Se(V)}var ne=function(J){var re;if(!J)try{$e.walkTokens&&Y.walkTokens(le,$e.walkTokens),re=_.parse(le,$e)}catch(de){J=de}return $e.highlight=ae,J?Se(J):Se(null,re)};if(!ae||ae.length<3||(delete $e.highlight,!le.length))return ne();var ee=0;Y.walkTokens(le,function(V){V.type==="code"&&(ee++,setTimeout(function(){ae(V.text,V.lang,function(J,re){if(J)return ne(J);re!=null&&re!==V.text&&(V.text=re,V.escaped=!0),ee--,ee===0&&ne()})},0))}),ee===0&&ne();return}function P(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+$(V.message+"",!0)+"</pre>";throw V}try{var K=O.lex(ye,$e);if($e.walkTokens){if($e.async)return Promise.all(Y.walkTokens(K,$e.walkTokens)).then(function(){return _.parse(K,$e)}).catch(P);Y.walkTokens(K,$e.walkTokens)}return _.parse(K,$e)}catch(V){P(V)}}Y.options=Y.setOptions=function(ye){return d(Y.defaults,ye),f(Y.defaults),Y},Y.getDefaults=T,Y.defaults=te.defaults,Y.use=function(){for(var ye=arguments.length,$e=new Array(ye),Se=0;Se<ye;Se++)$e[Se]=arguments[Se];var ae=d.apply(void 0,[{}].concat($e)),le=Y.defaults.extensions||{renderers:{},childTokens:{}},ne;$e.forEach(function(ee){if(ee.extensions&&(ne=!0,ee.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var V=le.renderers?le.renderers[K.name]:null;V?le.renderers[K.name]=function(){for(var J=arguments.length,re=new Array(J),de=0;de<J;de++)re[de]=arguments[de];var ie=K.renderer.apply(this,re);return ie===!1&&(ie=V.apply(this,re)),ie}:le.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[K.level]?le[K.level].unshift(K.tokenizer):le[K.level]=[K.tokenizer],K.start&&(K.level==="block"?le.startBlock?le.startBlock.push(K.start):le.startBlock=[K.start]:K.level==="inline"&&(le.startInline?le.startInline.push(K.start):le.startInline=[K.start]))}K.childTokens&&(le.childTokens[K.name]=K.childTokens)})),ee.renderer&&function(){var K=Y.defaults.renderer||new ue,V=function(de){var ie=K[de];K[de]=function(){for(var ve=arguments.length,Ee=new Array(ve),Be=0;Be<ve;Be++)Ee[Be]=arguments[Be];var We=ee.renderer[de].apply(K,Ee);return We===!1&&(We=ie.apply(K,Ee)),We}};for(var J in ee.renderer)V(J);ae.renderer=K}(),ee.tokenizer&&function(){var K=Y.defaults.tokenizer||new q,V=function(de){var ie=K[de];K[de]=function(){for(var ve=arguments.length,Ee=new Array(ve),Be=0;Be<ve;Be++)Ee[Be]=arguments[Be];var We=ee.tokenizer[de].apply(K,Ee);return We===!1&&(We=ie.apply(K,Ee)),We}};for(var J in ee.tokenizer)V(J);ae.tokenizer=K}(),ee.walkTokens){var P=Y.defaults.walkTokens;ae.walkTokens=function(K){var V=[];return V.push(ee.walkTokens.call(this,K)),P&&(V=V.concat(P.call(this,K))),V}}ne&&(ae.extensions=le),Y.setOptions(ae)})},Y.walkTokens=function(ye,$e){for(var Se=[],ae=function(){var P=ne.value;switch(Se=Se.concat($e.call(Y,P)),P.type){case"table":{for(var K=z(P.header),V;!(V=K()).done;){var J=V.value;Se=Se.concat(Y.walkTokens(J.tokens,$e))}for(var re=z(P.rows),de;!(de=re()).done;)for(var ie=de.value,ve=z(ie),Ee;!(Ee=ve()).done;){var Be=Ee.value;Se=Se.concat(Y.walkTokens(Be.tokens,$e))}break}case"list":{Se=Se.concat(Y.walkTokens(P.items,$e));break}default:Y.defaults.extensions&&Y.defaults.extensions.childTokens&&Y.defaults.extensions.childTokens[P.type]?Y.defaults.extensions.childTokens[P.type].forEach(function(We){Se=Se.concat(Y.walkTokens(P[We],$e))}):P.tokens&&(Se=Se.concat(Y.walkTokens(P.tokens,$e)))}},le=z(ye),ne;!(ne=le()).done;)ae();return Se},Y.parseInline=function(ye,$e){if(typeof ye>"u"||ye===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");$e=d({},Y.defaults,$e||{}),o($e);try{var Se=O.lexInline(ye,$e);return $e.walkTokens&&Y.walkTokens(Se,$e.walkTokens),_.parseInline(Se,$e)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+$(ae.message+"",!0)+"</pre>";throw ae}},Y.Parser=_,Y.parser=_.parse,Y.Renderer=ue,Y.TextRenderer=pe,Y.Lexer=O,Y.lexer=O.lex,Y.Tokenizer=q,Y.Slugger=Pe,Y.parse=Y;var ce=Y.options,ke=Y.setOptions,Ce=Y.use,me=Y.walkTokens,R=Y.parseInline,Q=Y,he=_.parse,De=O.lex;te.Lexer=O,te.Parser=_,te.Renderer=ue,te.Slugger=Pe,te.TextRenderer=pe,te.Tokenizer=q,te.getDefaults=T,te.lexer=De,te.marked=Y,te.options=ce,te.parse=Q,te.parseInline=R,te.parser=he,te.setOptions=ke,te.use=Ce,te.walkTokens=me,Object.defineProperty(te,"__esModule",{value:!0})}),define(Re[117],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.$rl=e.rot=e.$pl=void 0;function g(f,k,m){return Math.min(Math.max(f,k),m)}e.$pl=g;function C(f,k){return(k+f%k)%k}e.rot=C;class S{constructor(){this.a=0}getNext(){return this.a++}}e.$rl=S;class z{constructor(){this.a=1,this.b=0}update(k){return this.b=this.b+(k-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$sl=z;class T{constructor(k){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(k),this.c.fill(0,0,k)}update(k){const m=this.c[this.d];return this.c[this.d]=k,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=k,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$tl=T}),function(){function te(S){const z=[];typeof S=="number"&&z.push("code/timeOrigin",S);function T(k){z.push(k,Date.now())}function f(){const k=[];for(let m=0;m<z.length;m+=2)k.push({name:z[m],startTime:z[m+1]});return k}return{mark:T,getMarks:f}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const z=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const T of performance.getEntriesByType("mark"))z.push({name:T.name,startTime:Math.round(S+T.startTime)});return z}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function g(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=g(C))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var g=e();for(var C in g)(typeof exports=="object"?exports:te)[C]=g[C]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function g(C){if(e[C])return e[C].exports;var S=e[C]={i:C,l:!1,exports:{}};return te[C].call(S.exports,S,S.exports,g),S.l=!0,S.exports}return g.m=te,g.c=e,g.d=function(C,S,z){g.o(C,S)||Object.defineProperty(C,S,{enumerable:!0,get:z})},g.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},g.t=function(C,S){if(1&S&&(C=g(C)),8&S||4&S&&typeof C=="object"&&C&&C.__esModule)return C;var z=Object.create(null);if(g.r(z),Object.defineProperty(z,"default",{enumerable:!0,value:C}),2&S&&typeof C!="string")for(var T in C)g.d(z,T,function(f){return C[f]}.bind(null,T));return z},g.n=function(C){var S=C&&C.__esModule?function(){return C.default}:function(){return C};return g.d(S,"a",S),S},g.o=function(C,S){return Object.prototype.hasOwnProperty.call(C,S)},g.p="",g(g.s=0)}([function(te,e,g){(function(C){var S;e=te.exports=Ce,S=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var z=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,f=e.re=[],k=e.src=[],m=0,F=m++;k[F]="0|[1-9]\\d*";var D=m++;k[D]="[0-9]+";var h=m++;k[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=m++;k[b]="("+k[F]+")\\.("+k[F]+")\\.("+k[F]+")";var $=m++;k[$]="("+k[D]+")\\.("+k[D]+")\\.("+k[D]+")";var u=m++;k[u]="(?:"+k[F]+"|"+k[h]+")";var t=m++;k[t]="(?:"+k[D]+"|"+k[h]+")";var r=m++;k[r]="(?:-("+k[u]+"(?:\\."+k[u]+")*))";var c=m++;k[c]="(?:-?("+k[t]+"(?:\\."+k[t]+")*))";var w=m++;k[w]="[0-9A-Za-z-]+";var v=m++;k[v]="(?:\\+("+k[w]+"(?:\\."+k[w]+")*))";var y=m++,i="v?"+k[b]+k[r]+"?"+k[v]+"?";k[y]="^"+i+"$";var l="[v=\\s]*"+k[$]+k[c]+"?"+k[v]+"?",n=m++;k[n]="^"+l+"$";var s=m++;k[s]="((?:<|>)?=?)";var p=m++;k[p]=k[D]+"|x|X|\\*";var I=m++;k[I]=k[F]+"|x|X|\\*";var d=m++;k[d]="[v=\\s]*("+k[I]+")(?:\\.("+k[I]+")(?:\\.("+k[I]+")(?:"+k[r]+")?"+k[v]+"?)?)?";var A=m++;k[A]="[v=\\s]*("+k[p]+")(?:\\.("+k[p]+")(?:\\.("+k[p]+")(?:"+k[c]+")?"+k[v]+"?)?)?";var E=m++;k[E]="^"+k[s]+"\\s*"+k[d]+"$";var a=m++;k[a]="^"+k[s]+"\\s*"+k[A]+"$";var o=m++;k[o]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=m++;k[L]="(?:~>?)";var B=m++;k[B]="(\\s*)"+k[L]+"\\s+",f[B]=new RegExp(k[B],"g");var G=m++;k[G]="^"+k[L]+k[d]+"$";var q=m++;k[q]="^"+k[L]+k[A]+"$";var W=m++;k[W]="(?:\\^)";var N=m++;k[N]="(\\s*)"+k[W]+"\\s+",f[N]=new RegExp(k[N],"g");var H=m++;k[H]="^"+k[W]+k[d]+"$";var j=m++;k[j]="^"+k[W]+k[A]+"$";var O=m++;k[O]="^"+k[s]+"\\s*("+l+")$|^$";var ue=m++;k[ue]="^"+k[s]+"\\s*("+i+")$|^$";var pe=m++;k[pe]="(\\s*)"+k[s]+"\\s*("+l+"|"+k[d]+")",f[pe]=new RegExp(k[pe],"g");var Pe=m++;k[Pe]="^\\s*("+k[d]+")\\s+-\\s+("+k[d]+")\\s*$";var _=m++;k[_]="^\\s*("+k[A]+")\\s+-\\s+("+k[A]+")\\s*$";var Y=m++;k[Y]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)S(ce,k[ce]),f[ce]||(f[ce]=new RegExp(k[ce]));function ke(ie,ve){if(ie instanceof Ce)return ie;if(typeof ie!="string"||ie.length>z||!(ve?f[n]:f[y]).test(ie))return null;try{return new Ce(ie,ve)}catch{return null}}function Ce(ie,ve){if(ie instanceof Ce){if(ie.loose===ve)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>z)throw new TypeError("version is longer than "+z+" characters");if(!(this instanceof Ce))return new Ce(ie,ve);S("SemVer",ie,ve),this.loose=ve;var Ee=ie.trim().match(ve?f[n]:f[y]);if(!Ee)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(Be){if(/^[0-9]+$/.test(Be)){var We=+Be;if(We>=0&&We<T)return We}return Be}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=ke,e.valid=function(ie,ve){var Ee=ke(ie,ve);return Ee?Ee.version:null},e.clean=function(ie,ve){var Ee=ke(ie.trim().replace(/^[=v]+/,""),ve);return Ee?Ee.version:null},e.SemVer=Ce,Ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ce.prototype.toString=function(){return this.version},Ce.prototype.compare=function(ie){return S("SemVer.compare",this.version,this.loose,ie),ie instanceof Ce||(ie=new Ce(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},Ce.prototype.compareMain=function(ie){return ie instanceof Ce||(ie=new Ce(ie,this.loose)),R(this.major,ie.major)||R(this.minor,ie.minor)||R(this.patch,ie.patch)},Ce.prototype.comparePre=function(ie){if(ie instanceof Ce||(ie=new Ce(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ve=0;do{var Ee=this.prerelease[ve],Be=ie.prerelease[ve];if(S("prerelease compare",ve,Ee,Be),Ee===void 0&&Be===void 0)return 0;if(Be===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==Be)return R(Ee,Be)}while(++ve)},Ce.prototype.inc=function(ie,ve){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ve,Ee,Be){typeof Ee=="string"&&(Be=Ee,Ee=void 0);try{return new Ce(ie,Ee).inc(ve,Be).version}catch{return null}},e.diff=function(ie,ve){if(ye(ie,ve))return null;var Ee=ke(ie),Be=ke(ve);if(Ee.prerelease.length||Be.prerelease.length){for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==Be[We])return"pre"+We;return"prerelease"}for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==Be[We])return We},e.compareIdentifiers=R;var me=/^[0-9]+$/;function R(ie,ve){var Ee=me.test(ie),Be=me.test(ve);return Ee&&Be&&(ie=+ie,ve=+ve),Ee&&!Be?-1:Be&&!Ee?1:ie<ve?-1:ie>ve?1:0}function Q(ie,ve,Ee){return new Ce(ie,Ee).compare(new Ce(ve,Ee))}function he(ie,ve,Ee){return Q(ie,ve,Ee)>0}function De(ie,ve,Ee){return Q(ie,ve,Ee)<0}function ye(ie,ve,Ee){return Q(ie,ve,Ee)===0}function $e(ie,ve,Ee){return Q(ie,ve,Ee)!==0}function Se(ie,ve,Ee){return Q(ie,ve,Ee)>=0}function ae(ie,ve,Ee){return Q(ie,ve,Ee)<=0}function le(ie,ve,Ee,Be){var We;switch(ve){case"===":typeof ie=="object"&&(ie=ie.version),typeof Ee=="object"&&(Ee=Ee.version),We=ie===Ee;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof Ee=="object"&&(Ee=Ee.version),We=ie!==Ee;break;case"":case"=":case"==":We=ye(ie,Ee,Be);break;case"!=":We=$e(ie,Ee,Be);break;case">":We=he(ie,Ee,Be);break;case">=":We=Se(ie,Ee,Be);break;case"<":We=De(ie,Ee,Be);break;case"<=":We=ae(ie,Ee,Be);break;default:throw new TypeError("Invalid operator: "+ve)}return We}function ne(ie,ve){if(ie instanceof ne){if(ie.loose===ve)return ie;ie=ie.value}if(!(this instanceof ne))return new ne(ie,ve);S("comparator",ie,ve),this.loose=ve,this.parse(ie),this.semver===ee?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(ie,ve){return R(ve,ie)},e.major=function(ie,ve){return new Ce(ie,ve).major},e.minor=function(ie,ve){return new Ce(ie,ve).minor},e.patch=function(ie,ve){return new Ce(ie,ve).patch},e.compare=Q,e.compareLoose=function(ie,ve){return Q(ie,ve,!0)},e.rcompare=function(ie,ve,Ee){return Q(ve,ie,Ee)},e.sort=function(ie,ve){return ie.sort(function(Ee,Be){return e.compare(Ee,Be,ve)})},e.rsort=function(ie,ve){return ie.sort(function(Ee,Be){return e.rcompare(Ee,Be,ve)})},e.gt=he,e.lt=De,e.eq=ye,e.neq=$e,e.gte=Se,e.lte=ae,e.cmp=le,e.Comparator=ne;var ee={};function P(ie,ve){if(ie instanceof P)return ie.loose===ve?ie:new P(ie.raw,ve);if(ie instanceof ne)return new P(ie.value,ve);if(!(this instanceof P))return new P(ie,ve);if(this.loose=ve,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function K(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function V(ie,ve,Ee,Be,We,_e,He,Qe,it,ct,et,rt,Oe){return((ve=K(Ee)?"":K(Be)?">="+Ee+".0.0":K(We)?">="+Ee+"."+Be+".0":">="+ve)+" "+(Qe=K(it)?"":K(ct)?"<"+(+it+1)+".0.0":K(et)?"<"+it+"."+(+ct+1)+".0":rt?"<="+it+"."+ct+"."+et+"-"+rt:"<="+Qe)).trim()}function J(ie,ve){for(var Ee=0;Ee<ie.length;Ee++)if(!ie[Ee].test(ve))return!1;if(ve.prerelease.length){for(Ee=0;Ee<ie.length;Ee++)if(S(ie[Ee].semver),ie[Ee].semver!==ee&&ie[Ee].semver.prerelease.length>0){var Be=ie[Ee].semver;if(Be.major===ve.major&&Be.minor===ve.minor&&Be.patch===ve.patch)return!0}return!1}return!0}function re(ie,ve,Ee){try{ve=new P(ve,Ee)}catch{return!1}return ve.test(ie)}function de(ie,ve,Ee,Be){var We,_e,He,Qe,it;switch(ie=new Ce(ie,Be),ve=new P(ve,Be),Ee){case">":We=he,_e=ae,He=De,Qe=">",it=">=";break;case"<":We=De,_e=Se,He=he,Qe="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(re(ie,ve,Be))return!1;for(var ct=0;ct<ve.set.length;++ct){var et=ve.set[ct],rt=null,Oe=null;if(et.forEach(function(st){st.semver===ee&&(st=new ne(">=0.0.0")),rt=rt||st,Oe=Oe||st,We(st.semver,rt.semver,Be)?rt=st:He(st.semver,Oe.semver,Be)&&(Oe=st)}),rt.operator===Qe||rt.operator===it||(!Oe.operator||Oe.operator===Qe)&&_e(ie,Oe.semver)||Oe.operator===it&&He(ie,Oe.semver))return!1}return!0}ne.prototype.parse=function(ie){var ve=this.loose?f[O]:f[ue],Ee=ie.match(ve);if(!Ee)throw new TypeError("Invalid comparator: "+ie);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new Ce(Ee[2],this.loose):this.semver=ee},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(ie){return S("Comparator.test",ie,this.loose),this.semver===ee||(typeof ie=="string"&&(ie=new Ce(ie,this.loose)),le(ie,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(ie,ve){if(!(ie instanceof ne))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new P(ie.value,ve),re(this.value,Ee,ve);if(ie.operator==="")return Ee=new P(this.value,ve),re(ie.semver,Ee,ve);var Be=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),_e=this.semver.version===ie.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Qe=le(this.semver,"<",ie.semver,ve)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),it=le(this.semver,">",ie.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return Be||We||_e&&He||Qe||it},e.Range=P,P.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},P.prototype.toString=function(){return this.range},P.prototype.parseRange=function(ie){var ve=this.loose;ie=ie.trim(),S("range",ie,ve);var Ee=ve?f[_]:f[Pe];ie=ie.replace(Ee,V),S("hyphen replace",ie),ie=ie.replace(f[pe],"$1$2$3"),S("comparator trim",ie,f[pe]),ie=(ie=(ie=ie.replace(f[B],"$1~")).replace(f[N],"$1^")).split(/\s+/).join(" ");var Be=ve?f[O]:f[ue],We=ie.split(" ").map(function(_e){return function(He,Qe){return S("comp",He),He=function(it,ct){return it.trim().split(/\s+/).map(function(et){return function(rt,Oe){S("caret",rt,Oe);var st=Oe?f[j]:f[H];return rt.replace(st,function(x,X,ge,je,Ne){var Ze;return S("caret",rt,x,X,ge,je,Ne),K(X)?Ze="":K(ge)?Ze=">="+X+".0.0 <"+(+X+1)+".0.0":K(je)?Ze=X==="0"?">="+X+"."+ge+".0 <"+X+"."+(+ge+1)+".0":">="+X+"."+ge+".0 <"+(+X+1)+".0.0":Ne?(S("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ze=X==="0"?ge==="0"?">="+X+"."+ge+"."+je+Ne+" <"+X+"."+ge+"."+(+je+1):">="+X+"."+ge+"."+je+Ne+" <"+X+"."+(+ge+1)+".0":">="+X+"."+ge+"."+je+Ne+" <"+(+X+1)+".0.0"):(S("no pr"),Ze=X==="0"?ge==="0"?">="+X+"."+ge+"."+je+" <"+X+"."+ge+"."+(+je+1):">="+X+"."+ge+"."+je+" <"+X+"."+(+ge+1)+".0":">="+X+"."+ge+"."+je+" <"+(+X+1)+".0.0"),S("caret return",Ze),Ze})}(et,ct)}).join(" ")}(He,Qe),S("caret",He),He=function(it,ct){return it.trim().split(/\s+/).map(function(et){return function(rt,Oe){var st=Oe?f[q]:f[G];return rt.replace(st,function(x,X,ge,je,Ne){var Ze;return S("tilde",rt,x,X,ge,je,Ne),K(X)?Ze="":K(ge)?Ze=">="+X+".0.0 <"+(+X+1)+".0.0":K(je)?Ze=">="+X+"."+ge+".0 <"+X+"."+(+ge+1)+".0":Ne?(S("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ze=">="+X+"."+ge+"."+je+Ne+" <"+X+"."+(+ge+1)+".0"):Ze=">="+X+"."+ge+"."+je+" <"+X+"."+(+ge+1)+".0",S("tilde return",Ze),Ze})}(et,ct)}).join(" ")}(He,Qe),S("tildes",He),He=function(it,ct){return S("replaceXRanges",it,ct),it.split(/\s+/).map(function(et){return function(rt,Oe){rt=rt.trim();var st=Oe?f[a]:f[E];return rt.replace(st,function(x,X,ge,je,Ne,Ze){S("xRange",rt,x,X,ge,je,Ne,Ze);var tt=K(ge),$t=tt||K(je),wt=$t||K(Ne);return X==="="&&wt&&(X=""),tt?x=X===">"||X==="<"?"<0.0.0":"*":X&&wt?($t&&(je=0),wt&&(Ne=0),X===">"?(X=">=",$t?(ge=+ge+1,je=0,Ne=0):wt&&(je=+je+1,Ne=0)):X==="<="&&(X="<",$t?ge=+ge+1:je=+je+1),x=X+ge+"."+je+"."+Ne):$t?x=">="+ge+".0.0 <"+(+ge+1)+".0.0":wt&&(x=">="+ge+"."+je+".0 <"+ge+"."+(+je+1)+".0"),S("xRange return",x),x})}(et,ct)}).join(" ")}(He,Qe),S("xrange",He),He=function(it,ct){return S("replaceStars",it,ct),it.trim().replace(f[Y],"")}(He,Qe),S("stars",He),He}(_e,ve)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(Be)})),We=We.map(function(_e){return new ne(_e,ve)})},P.prototype.intersects=function(ie,ve){if(!(ie instanceof P))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(Be){return ie.set.some(function(We){return We.every(function(_e){return Be.intersects(_e,ve)})})})})},e.toComparators=function(ie,ve){return new P(ie,ve).set.map(function(Ee){return Ee.map(function(Be){return Be.value}).join(" ").trim().split(" ")})},P.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new Ce(ie,this.loose));for(var ve=0;ve<this.set.length;ve++)if(J(this.set[ve],ie))return!0;return!1},e.satisfies=re,e.maxSatisfying=function(ie,ve,Ee){var Be=null,We=null;try{var _e=new P(ve,Ee)}catch{return null}return ie.forEach(function(He){_e.test(He)&&(Be&&We.compare(He)!==-1||(We=new Ce(Be=He,Ee)))}),Be},e.minSatisfying=function(ie,ve,Ee){var Be=null,We=null;try{var _e=new P(ve,Ee)}catch{return null}return ie.forEach(function(He){_e.test(He)&&(Be&&We.compare(He)!==1||(We=new Ce(Be=He,Ee)))}),Be},e.validRange=function(ie,ve){try{return new P(ie,ve).range||"*"}catch{return null}},e.ltr=function(ie,ve,Ee){return de(ie,ve,"<",Ee)},e.gtr=function(ie,ve,Ee){return de(ie,ve,">",Ee)},e.outside=de,e.prerelease=function(ie,ve){var Ee=ke(ie,ve);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(ie,ve,Ee){return ie=new P(ie,Ee),ve=new P(ve,Ee),ie.intersects(ve)},e.coerce=function(ie){if(ie instanceof Ce)return ie;if(typeof ie!="string")return null;var ve=ie.match(f[o]);return ve==null?null:ke((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,g(1))},function(te,e){var g,C,S=te.exports={};function z(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function f(t){if(g===setTimeout)return setTimeout(t,0);if((g===z||!g)&&setTimeout)return g=setTimeout,setTimeout(t,0);try{return g(t,0)}catch{try{return g.call(null,t,0)}catch{return g.call(this,t,0)}}}(function(){try{g=typeof setTimeout=="function"?setTimeout:z}catch{g=z}try{C=typeof clearTimeout=="function"?clearTimeout:T}catch{C=T}})();var k,m=[],F=!1,D=-1;function h(){F&&k&&(F=!1,k.length?m=k.concat(m):D=-1,m.length&&b())}function b(){if(!F){var t=f(h);F=!0;for(var r=m.length;r;){for(k=m,m=[];++D<r;)k&&k[D].run();D=-1,r=m.length}k=null,F=!1,function(c){if(C===clearTimeout)return clearTimeout(c);if((C===T||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(c);try{C(c)}catch{try{return C.call(null,c)}catch{return C.call(this,c)}}}(t)}}function $(t,r){this.fun=t,this.array=r}function u(){}S.nextTick=function(t){var r=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)r[c-1]=arguments[c];m.push(new $(t,r)),m.length!==1||F||f(b)},$.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=u,S.addListener=u,S.once=u,S.off=u,S.removeListener=u,S.removeAllListeners=u,S.emit=u,S.prependListener=u,S.prependOnceListener=u,S.listeners=function(t){return[]},S.binding=function(t){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(t){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Re[118],Fe([1,0,9,6]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=void 0;function S(v){const y=v;return y?typeof y.read=="function":!1}e.$tb=S;function z(v){const y=v;return y?[y.on,y.pause,y.resume,y.destroy].every(i=>typeof i=="function"):!1}e.$ub=z;function T(v){const y=v;return y?z(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.$vb=T;function f(v,y){return new k(v,y)}e.$wb=f;class k{constructor(y,i){this.e=y,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(y){if(!this.a.destroyed){if(this.a.flowing)this.g(y);else if(this.b.data.push(y),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(y){this.a.destroyed||(this.a.flowing?this.h(y):this.b.error.push(y))}end(y){this.a.destroyed||(typeof y<"u"&&this.write(y),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(y){this.c.data.slice(0).forEach(i=>i(y))}h(y){this.c.error.length===0?(0,g.$X)(y):this.c.error.slice(0).forEach(i=>i(y))}i(){this.c.end.slice(0).forEach(y=>y())}on(y,i){if(!this.a.destroyed)switch(y){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(y,i){if(this.a.destroyed)return;let l;switch(y){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const n=l.indexOf(i);n>=0&&l.splice(n,1)}}j(){if(this.b.data.length>0){const y=this.e(this.b.data);this.g(y),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const y of this.b.error)this.h(y);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(v,y){const i=[];let l;for(;(l=v.read())!==null;)i.push(l);return y(i)}e.$xb=m;function F(v,y,i){const l=[];let n;for(;(n=v.read())!==null&&l.length<i;)l.push(n);return n===null&&l.length>0?y(l):{read:()=>{if(l.length>0)return l.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return v.read()}}}e.$yb=F;function D(v,y){return new Promise((i,l)=>{const n=[];h(v,{onData:s=>{y&&n.push(s)},onError:s=>{y?l(s):i(void 0)},onEnd:()=>{i(y?y(n):void 0)}})})}e.$zb=D;function h(v,y){let i=!1;return v.on("error",l=>{i||y.onError(l)}),v.on("end",()=>{i||y.onEnd()}),v.on("data",l=>{i||y.onData(l)}),(0,C.$ib)(()=>i=!0)}e.$Ab=h;function b(v,y){return new Promise((i,l)=>{const n=new C.$jb,s=[],p=A=>{if(s.push(A),s.length>y)return n.dispose(),v.pause(),i({stream:v,buffer:s,ended:!1})},I=A=>l(A),d=()=>i({stream:v,buffer:s,ended:!0});n.add((0,C.$ib)(()=>v.removeListener("error",I))),v.on("error",I),n.add((0,C.$ib)(()=>v.removeListener("end",d))),v.on("end",d),n.add((0,C.$ib)(()=>v.removeListener("data",p))),v.on("data",p)})}e.$Bb=b;function $(v,y){const i=f(y);return i.end(v),i}e.$Cb=$;function u(){const v=f(()=>{throw new Error("not supported")});return v.end(),v}e.$Db=u;function t(v){let y=!1;return{read:()=>y?null:(y=!0,v)}}e.$Eb=t;function r(v,y,i){const l=f(i);return h(v,{onData:n=>l.write(y.data(n)),onError:n=>l.error(y.error?y.error(n):n),onEnd:()=>l.end()}),l}e.$Fb=r;function c(v,y,i){let l=!1;return{read:()=>{const n=y.read();return l?n:(l=!0,n!==null?i([v,n]):v)}}}e.$Gb=c;function w(v,y,i){let l=!1;const n=f(i);return h(y,{onData:s=>l?n.write(s):(l=!0,n.write(i([v,s]))),onError:s=>n.error(s),onEnd:()=>{l||(l=!0,n.write(v)),n.end()}}),n}e.$Hb=w}),define(Re[25],Fe([1,0,66,118]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=void 0;const S=typeof Buffer<"u",z=new g.$S(()=>new Uint8Array(256));let T,f;class k{static alloc(a){return S?new k(Buffer.allocUnsafe(a)):new k(new Uint8Array(a))}static wrap(a){return S&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new k(a)}static fromString(a,o){return!(o?.dontUseNodeBuffer||!1)&&S?new k(Buffer.from(a)):(T||(T=new TextEncoder),new k(T.encode(a)))}static fromByteArray(a){const o=k.alloc(a.length);for(let L=0,B=a.length;L<B;L++)o.buffer[L]=a[L];return o}static concat(a,o){if(typeof o>"u"){o=0;for(let G=0,q=a.length;G<q;G++)o+=a[G].byteLength}const L=k.alloc(o);let B=0;for(let G=0,q=a.length;G<q;G++){const W=a[G];L.set(W,B),B+=W.byteLength}return L}constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}clone(){const a=k.alloc(this.byteLength);return a.set(this),a}toString(){return S?this.buffer.toString():(f||(f=new TextDecoder),f.decode(this.buffer))}slice(a,o){return new k(this.buffer.subarray(a,o))}set(a,o){if(a instanceof k)this.buffer.set(a.buffer,o);else if(a instanceof Uint8Array)this.buffer.set(a,o);else if(a instanceof ArrayBuffer)this.buffer.set(new Uint8Array(a),o);else if(ArrayBuffer.isView(a))this.buffer.set(new Uint8Array(a.buffer,a.byteOffset,a.byteLength),o);else throw new Error("Unknown argument 'array'")}readUInt32BE(a){return D(this.buffer,a)}writeUInt32BE(a,o){h(this.buffer,a,o)}readUInt32LE(a){return b(this.buffer,a)}writeUInt32LE(a,o){$(this.buffer,a,o)}readUInt8(a){return u(this.buffer,a)}writeUInt8(a,o){t(this.buffer,a,o)}indexOf(a){const o=a instanceof k?a.buffer:a,L=o.byteLength,B=this.buffer,G=B.byteLength;if(L===0)return 0;if(L===1)return B.indexOf(o[0]);if(L>G)return-1;const q=z.value;q.fill(o.length);for(let j=0;j<o.length;j++)q[o[j]]=o.length-j-1;let W=o.length-1,N=W,H=-1;for(;W<G;)if(B[W]===o[N]){if(N===0){H=W;break}W--,N--}else W+=Math.max(o.length-N,q[B[W]]),N=o.length-1;return H}}e.$Ib=k;function m(E,a){return E[a+0]<<0>>>0|E[a+1]<<8>>>0}e.$Jb=m;function F(E,a,o){E[o+0]=a&255,a=a>>>8,E[o+1]=a&255}e.$Kb=F;function D(E,a){return E[a]*2**24+E[a+1]*2**16+E[a+2]*2**8+E[a+3]}e.$Lb=D;function h(E,a,o){E[o+3]=a,a=a>>>8,E[o+2]=a,a=a>>>8,E[o+1]=a,a=a>>>8,E[o]=a}e.$Mb=h;function b(E,a){return E[a+0]<<0>>>0|E[a+1]<<8>>>0|E[a+2]<<16>>>0|E[a+3]<<24>>>0}e.$Nb=b;function $(E,a,o){E[o+0]=a&255,a=a>>>8,E[o+1]=a&255,a=a>>>8,E[o+2]=a&255,a=a>>>8,E[o+3]=a&255}e.$Ob=$;function u(E,a){return E[a]}e.$Pb=u;function t(E,a,o){E[o]=a}e.$Qb=t;function r(E){return C.$xb(E,a=>k.concat(a))}e.$Rb=r;function c(E){return C.$Eb(E)}e.$Sb=c;function w(E){return C.$zb(E,a=>k.concat(a))}e.$Tb=w;async function v(E){return E.ended?k.concat(E.buffer):k.concat([...E.buffer,await w(E.stream)])}e.$Ub=v;function y(E){return C.$Cb(E,a=>k.concat(a))}e.$Vb=y;function i(E){return C.$Fb(E,{data:a=>typeof a=="string"?k.fromString(a):k.wrap(a)},a=>k.concat(a))}e.$Wb=i;function l(E){return C.$wb(a=>k.concat(a),E)}e.$Xb=l;function n(E,a){return C.$Gb(E,a,o=>k.concat(o))}e.$Yb=n;function s(E,a){return C.$Hb(E,a,o=>k.concat(o))}e.$Zb=s;function p(E){let a=0,o=0,L=0;const B=new Uint8Array(Math.floor(E.length/4*3)),G=W=>{switch(o){case 3:B[L++]=a|W,o=0;break;case 2:B[L++]=a|W>>>2,a=W<<6,o=3;break;case 1:B[L++]=a|W>>>4,a=W<<4,o=2;break;default:a=W<<2,o=1}};for(let W=0;W<E.length;W++){const N=E.charCodeAt(W);if(N>=65&&N<=90)G(N-65);else if(N>=97&&N<=122)G(N-97+26);else if(N>=48&&N<=57)G(N-48+52);else if(N===43||N===45)G(62);else if(N===47||N===95)G(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${E[W]}`)}}const q=L;for(;o>0;)G(0);return k.wrap(B).slice(0,q)}e.$1b=p;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function A({buffer:E},a=!0,o=!1){const L=o?d:I;let B="";const G=E.byteLength%3;let q=0;for(;q<E.byteLength-G;q+=3){const W=E[q+0],N=E[q+1],H=E[q+2];B+=L[W>>>2],B+=L[(W<<4|N>>>4)&63],B+=L[(N<<2|H>>>6)&63],B+=L[H&63]}if(G===1){const W=E[q+0];B+=L[W>>>2],B+=L[W<<4&63],a&&(B+="==")}else if(G===2){const W=E[q+0],N=E[q+1];B+=L[W>>>2],B+=L[(W<<4|N>>>4)&63],B+=L[N<<2&63],a&&(B+="=")}return B}e.$2b=A}),define(Re[119],Fe([1,0,28,13]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.FuzzyScore=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.or=void 0;function S(...ne){return function(ee,P){for(let K=0,V=ne.length;K<V;K++){const J=ne[K](ee,P);if(J)return J}return null}}e.or=S,e.$gj=z.bind(void 0,!1),e.$hj=z.bind(void 0,!0);function z(ne,ee,P){if(!P||P.length<ee.length)return null;let K;return ne?K=C.$Kd(P,ee):K=P.indexOf(ee)===0,K?ee.length>0?[{start:0,end:ee.length}]:[]:null}function T(ne,ee){const P=ee.toLowerCase().indexOf(ne.toLowerCase());return P===-1?null:[{start:P,end:P+ne.length}]}e.$ij=T;function f(ne,ee){return k(ne.toLowerCase(),ee.toLowerCase(),0,0)}e.$jj=f;function k(ne,ee,P,K){if(P===ne.length)return[];if(K===ee.length)return null;if(ne[P]===ee[K]){let V=null;return(V=k(ne,ee,P+1,K+1))?r({start:K,end:K+1},V):null}return k(ne,ee,P,K+1)}function m(ne){return 97<=ne&&ne<=122}function F(ne){return 65<=ne&&ne<=90}e.$kj=F;function D(ne){return 48<=ne&&ne<=57}function h(ne){return ne===32||ne===9||ne===10||ne===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>b.add(ne.charCodeAt(0)));function $(ne){return h(ne)||b.has(ne)}function u(ne,ee){return ne===ee||$(ne)&&$(ee)}function t(ne){return m(ne)||F(ne)||D(ne)}function r(ne,ee){return ee.length===0?ee=[ne]:ne.end===ee[0].start?ee[0].start=ne.start:ee.unshift(ne),ee}function c(ne,ee){for(let P=ee;P<ne.length;P++){const K=ne.charCodeAt(P);if(F(K)||D(K)||P>0&&!t(ne.charCodeAt(P-1)))return P}return ne.length}function w(ne,ee,P,K){if(P===ne.length)return[];if(K===ee.length)return null;if(ne[P]!==ee[K].toLowerCase())return null;{let V=null,J=K+1;for(V=w(ne,ee,P+1,K+1);!V&&(J=c(ee,J))<ee.length;)V=w(ne,ee,P+1,J),J++;return V===null?null:r({start:K,end:K+1},V)}}function v(ne){let ee=0,P=0,K=0,V=0,J=0;for(let Ee=0;Ee<ne.length;Ee++)J=ne.charCodeAt(Ee),F(J)&&ee++,m(J)&&P++,t(J)&&K++,D(J)&&V++;const re=ee/ne.length,de=P/ne.length,ie=K/ne.length,ve=V/ne.length;return{upperPercent:re,lowerPercent:de,alphaPercent:ie,numericPercent:ve}}function y(ne){const{upperPercent:ee,lowerPercent:P}=ne;return P===0&&ee>.6}function i(ne){const{upperPercent:ee,lowerPercent:P,alphaPercent:K,numericPercent:V}=ne;return P>.2&&ee<.8&&K>.6&&V<.2}function l(ne){let ee=0,P=0,K=0,V=0;for(let J=0;J<ne.length;J++)K=ne.charCodeAt(J),F(K)&&ee++,m(K)&&P++,h(K)&&V++;return(ee===0||P===0)&&V===0?ne.length<=30:ee<=5}function n(ne,ee){if(!ee||(ee=ee.trim(),ee.length===0)||!l(ne)||ee.length>60)return null;const P=v(ee);if(!i(P)){if(!y(P))return null;ee=ee.toLowerCase()}let K=null,V=0;for(ne=ne.toLowerCase();V<ee.length&&(K=w(ne,ee,0,V))===null;)V=c(ee,V+1);return K}e.$lj=n;function s(ne,ee,P=!1){if(!ee||ee.length===0)return null;let K=null,V=0;for(ne=ne.toLowerCase(),ee=ee.toLowerCase();V<ee.length&&(K=p(ne,ee,0,V,P))===null;)V=I(ee,V+1);return K}e.$mj=s;function p(ne,ee,P,K,V){if(P===ne.length)return[];if(K===ee.length)return null;if(u(ne.charCodeAt(P),ee.charCodeAt(K))){let J=null,re=K+1;if(J=p(ne,ee,P+1,K+1,V),!V)for(;!J&&(re=I(ee,re))<ee.length;)J=p(ne,ee,P+1,re,V),re++;return J?ne.charCodeAt(P)!==ee.charCodeAt(K)?J:r({start:K,end:K+1},J):null}else return null}function I(ne,ee){for(let P=ee;P<ne.length;P++)if($(ne.charCodeAt(P))||P>0&&$(ne.charCodeAt(P-1)))return P;return ne.length}const d=S(e.$hj,n,T),A=S(e.$hj,n,f),E=new g.$mi(1e4);function a(ne,ee,P=!1){if(typeof ne!="string"||typeof ee!="string")return null;let K=E.get(ne);K||(K=new RegExp(C.$rd(ne),"i"),E.set(ne,K));const V=K.exec(ee);return V?[{start:V.index,end:V.index+V[0].length}]:P?A(ne,ee):d(ne,ee)}e.$nj=a;function o(ne,ee){const P=he(ne,ne.toLowerCase(),0,ee,ee.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return P?B(P):null}e.$oj=o;function L(ne,ee,P,K,V,J){const re=Math.min(13,ne.length);for(;P<re;P++){const de=he(ne,ee,P,K,V,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(de)return de}return[0,J]}e.$pj=L;function B(ne){if(typeof ne>"u")return[];const ee=[],P=ne[1];for(let K=ne.length-1;K>1;K--){const V=ne[K]+P,J=ee[ee.length-1];J&&J.end===V?J.end=V+1:ee.push({start:V,end:V+1})}return ee}e.$qj=B;const G=128;function q(){const ne=[],ee=[];for(let P=0;P<=G;P++)ee[P]=0;for(let P=0;P<=G;P++)ne.push(ee.slice(0));return ne}function W(ne){const ee=[];for(let P=0;P<=ne;P++)ee[P]=0;return ee}const N=W(2*G),H=W(2*G),j=q(),O=q(),ue=q(),pe=!1;function Pe(ne,ee,P,K,V){function J(de,ie,ve=" "){for(;de.length<ie;)de=ve+de;return de}let re=` |   |${K.split("").map(de=>J(de,3)).join("|")}
`;for(let de=0;de<=P;de++)de===0?re+=" |":re+=`${ee[de-1]}|`,re+=ne[de].slice(0,V+1).map(ie=>J(ie.toString(),3)).join("|")+`
`;return re}function _(ne,ee,P,K){ne=ne.substr(ee),P=P.substr(K),console.log(Pe(O,ne,ne.length,P,P.length)),console.log(Pe(ue,ne,ne.length,P,P.length)),console.log(Pe(j,ne,ne.length,P,P.length))}function Y(ne,ee){if(ee<0||ee>=ne.length)return!1;const P=ne.codePointAt(ee);switch(P){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.$3d(P)}}function ce(ne,ee){if(ee<0||ee>=ne.length)return!1;switch(ne.charCodeAt(ee)){case 32:case 9:return!0;default:return!1}}function ke(ne,ee,P){return ee[ne]!==P[ne]}function Ce(ne,ee,P,K,V,J,re=!1){for(;ee<P&&V<J;)ne[ee]===K[V]&&(re&&(N[ee]=V),ee+=1),V+=1;return ee===P}e.$rj=Ce;var me;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(me||(me={}));var R;(function(ne){ne.Default=[-100,0];function ee(P){return!P||P.length===2&&P[0]===-100&&P[1]===0}ne.isDefault=ee})(R||(e.FuzzyScore=R={}));class Q{constructor(ee,P){this.firstMatchCanBeWeak=ee,this.boostFullMatch=P}}e.$sj=Q,Q.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function he(ne,ee,P,K,V,J,re=Q.default){const de=ne.length>G?G:ne.length,ie=K.length>G?G:K.length;if(P>=de||J>=ie||de-P>ie-J||!Ce(ee,P,de,V,J,ie,!0))return;De(de,ie,P,J,ee,V);let ve=1,Ee=1,Be=P,We=J;const _e=[!1];for(ve=1,Be=P;Be<de;ve++,Be++){const et=N[Be],rt=H[Be],Oe=Be+1<de?H[Be+1]:ie;for(Ee=et-J+1,We=et;We<Oe;Ee++,We++){let st=Number.MIN_SAFE_INTEGER,x=!1;We<=rt&&(st=ye(ne,ee,Be,P,K,V,We,ie,J,j[ve-1][Ee-1]===0,_e));let X=0;st!==Number.MAX_SAFE_INTEGER&&(x=!0,X=st+O[ve-1][Ee-1]);const ge=We>et,je=ge?O[ve][Ee-1]+(j[ve][Ee-1]>0?-5:0):0,Ne=We>et+1&&j[ve][Ee-1]>0,Ze=Ne?O[ve][Ee-2]+(j[ve][Ee-2]>0?-5:0):0;if(Ne&&(!ge||Ze>=je)&&(!x||Ze>=X))O[ve][Ee]=Ze,ue[ve][Ee]=3,j[ve][Ee]=0;else if(ge&&(!x||je>=X))O[ve][Ee]=je,ue[ve][Ee]=2,j[ve][Ee]=0;else if(x)O[ve][Ee]=X,ue[ve][Ee]=1,j[ve][Ee]=j[ve-1][Ee-1]+1;else throw new Error("not possible")}}if(pe&&_(ne,P,K,J),!_e[0]&&!re.firstMatchCanBeWeak)return;ve--,Ee--;const He=[O[ve][Ee],J];let Qe=0,it=0;for(;ve>=1;){let et=Ee;do{const rt=ue[ve][et];if(rt===3)et=et-2;else if(rt===2)et=et-1;else break}while(et>=1);Qe>1&&ee[P+ve-1]===V[J+Ee-1]&&!ke(et+J-1,K,V)&&Qe+1>j[ve][et]&&(et=Ee),et===Ee?Qe++:Qe=1,it||(it=et),ve--,Ee=et-1,He.push(Ee)}ie===de&&re.boostFullMatch&&(He[0]+=2);const ct=it-de;return He[0]-=ct,He}e.$tj=he;function De(ne,ee,P,K,V,J){let re=ne-1,de=ee-1;for(;re>=P&&de>=K;)V[re]===J[de]&&(H[re]=de,re--),de--}function ye(ne,ee,P,K,V,J,re,de,ie,ve,Ee){if(ee[P]!==J[re])return Number.MIN_SAFE_INTEGER;let Be=1,We=!1;return re===P-K?Be=ne[P]===V[re]?7:5:ke(re,V,J)&&(re===0||!ke(re-1,V,J))?(Be=ne[P]===V[re]?7:5,We=!0):Y(J,re)&&(re===0||!Y(J,re-1))?Be=5:(Y(J,re-1)||ce(J,re-1))&&(Be=5,We=!0),Be>1&&P===K&&(Ee[0]=!0),We||(We=ke(re,V,J)||Y(J,re-1)||ce(J,re-1)),P===K?re>ie&&(Be-=We?3:5):ve?Be+=We?2:0:Be+=We?0:1,re+1===de&&(Be-=We?3:5),Be}function $e(ne,ee,P,K,V,J,re){return ae(ne,ee,P,K,V,J,!0,re)}e.$uj=$e;function Se(ne,ee,P,K,V,J,re){return ae(ne,ee,P,K,V,J,!1,re)}e.$vj=Se;function ae(ne,ee,P,K,V,J,re,de){let ie=he(ne,ee,P,K,V,J,de);if(ie&&!re)return ie;if(ne.length>=3){const ve=Math.min(7,ne.length-1);for(let Ee=P+1;Ee<ve;Ee++){const Be=le(ne,Ee);if(Be){const We=he(Be,Be.toLowerCase(),P,K,V,J,de);We&&(We[0]-=3,(!ie||We[0]>ie[0])&&(ie=We))}}}return ie}function le(ne,ee){if(ee+1>=ne.length)return;const P=ne[ee],K=ne[ee+1];if(P!==K)return ne.slice(0,ee)+K+P+ne.slice(ee+2)}}),define(Re[29],Fe([1,0,13]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(C||(C={})),function(S){const z="error",T="warning",f="warn",k="info",m="ignore";function F(h){return h?g.$Jd(z,h)?S.Error:g.$Jd(T,h)||g.$Jd(f,h)?S.Warning:g.$Jd(k,h)?S.Info:S.Ignore:S.Ignore}S.fromValue=F;function D(h){switch(h){case S.Error:return z;case S.Warning:return T;case S.Info:return k;default:return m}}S.toString=D}(C||(C={})),e.default=C}),define(Re[120],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0,e.$2c=Symbol("MicrotaskDelay")}),define(Re[48],Fe([1,0,18,13]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;class S{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const $=b.charCodeAt(0),u=this.b.charCodeAt(this.c);return $-u}value(){return this.b[this.c]}}e.$nh=S;class z{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,C.$Dd)(b,this.b,0,b.length,this.c,this.d):(0,C.$Fd)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$oh=z;class T{constructor(b=!0,$=!0){this.f=b,this.g=$}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let $=b.length-1;$>=0;$--,this.c--){const u=this.b.charCodeAt($);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,C.$Dd)(b,this.b,0,b.length,this.d,this.e):(0,C.$Fd)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ph=T;var f;(function(h){h[h.Scheme=1]="Scheme",h[h.Authority=2]="Authority",h[h.Path=3]="Path",h[h.Query=4]="Query",h[h.Fragment=5]="Fragment"})(f||(f={}));class k{constructor(b,$){this.f=b,this.g=$,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new T(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,C.$Ed)(b,this.c.scheme);if(this.d[this.e]===2)return(0,C.$Ed)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,C.$Cd)(b,this.c.query);if(this.d[this.e]===5)return(0,C.$Cd)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$qh=k;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var F;(function(h){h[h.Left=-1]="Left",h[h.Mid=0]="Mid",h[h.Right=1]="Right"})(F||(F={}));class D{static forUris(b=()=>!1,$=()=>!1){return new D(new k(b,$))}static forPaths(b=!1){return new D(new T(void 0,!b))}static forStrings(){return new D(new S)}static forConfigKeys(){return new D(new z)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,$){if($){const u=$.slice(0);(0,g.$Bf)(u);for(const t of u)this.set(t,b)}else{const u=b.slice(0);(0,g.$Bf)(u);for(const t of u)this.set(t[0],t[1])}}set(b,$){const u=this.b.reset(b);let t;this.c||(this.c=new m,this.c.segment=u.value());const r=[];for(t=this.c;;){const w=u.cmp(t.segment);if(w>0)t.left||(t.left=new m,t.left.segment=u.value()),r.push([-1,t]),t=t.left;else if(w<0)t.right||(t.right=new m,t.right.segment=u.value()),r.push([1,t]),t=t.right;else if(u.hasNext())u.next(),t.mid||(t.mid=new m,t.mid.segment=u.value()),r.push([0,t]),t=t.mid;else break}const c=t.value;t.value=$,t.key=b;for(let w=r.length-1;w>=0;w--){const v=r[w][1];v.updateHeight();const y=v.balanceFactor();if(y<-1||y>1){const i=r[w][0],l=r[w+1][0];if(i===1&&l===1)r[w][1]=v.rotateLeft();else if(i===-1&&l===-1)r[w][1]=v.rotateRight();else if(i===1&&l===-1)v.right=r[w+1][1]=r[w+1][1].rotateRight(),r[w][1]=v.rotateLeft();else if(i===-1&&l===1)v.left=r[w+1][1]=r[w+1][1].rotateLeft(),r[w][1]=v.rotateRight();else throw new Error;if(w>0)switch(r[w-1][0]){case-1:r[w-1][1].left=r[w][1];break;case 1:r[w-1][1].right=r[w][1];break;case 0:r[w-1][1].mid=r[w][1];break}else this.c=r[0][1]}}return c}get(b){return this.d(b)?.value}d(b){const $=this.b.reset(b);let u=this.c;for(;u;){const t=$.cmp(u.segment);if(t>0)u=u.left;else if(t<0)u=u.right;else if($.hasNext())$.next(),u=u.mid;else break}return u}has(b){const $=this.d(b);return!($?.value===void 0&&$?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,$){const u=this.b.reset(b),t=[];let r=this.c;for(;r;){const c=u.cmp(r.segment);if(c>0)t.push([-1,r]),r=r.left;else if(c<0)t.push([1,r]),r=r.right;else if(u.hasNext())u.next(),t.push([0,r]),r=r.mid;else break}if(r){if($?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const c=this.f(r.right);if(c.key){const{key:w,value:v,segment:y}=c;this.e(c.key,!1),r.key=w,r.value=v,r.segment=y}}else{const c=r.left??r.right;if(t.length>0){const[w,v]=t[t.length-1];switch(w){case-1:v.left=c;break;case 0:v.mid=c;break;case 1:v.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const w=t[c][1];w.updateHeight();const v=w.balanceFactor();if(v>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),t[c][1]=w.rotateLeft()):v<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),t[c][1]=w.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const $=this.b.reset(b);let u=this.c,t;for(;u;){const r=$.cmp(u.segment);if(r>0)u=u.left;else if(r<0)u=u.right;else if($.hasNext())$.next(),t=u.value||t,u=u.mid;else break}return u&&u.value||t}findSuperstr(b){return this.g(b,!1)}g(b,$){const u=this.b.reset(b);let t=this.c;for(;t;){const r=u.cmp(t.segment);if(r>0)t=t.left;else if(r<0)t=t.right;else if(u.hasNext())u.next(),t=t.mid;else return t.mid?this.h(t.mid):$?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[$,u]of this)b(u,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const $=[];return this.j(b,$),$[Symbol.iterator]()}j(b,$){b&&(b.left&&this.j(b.left,$),b.value&&$.push([b.key,b.value]),b.mid&&this.j(b.mid,$),b.right&&this.j(b.right,$))}_isBalanced(){const b=$=>{if(!$)return!0;const u=$.balanceFactor();return u<-1||u>1?!1:b($.left)&&b($.right)};return b(this.c)}}e.$rh=D}),define(Re[40],Fe([1,0,89]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$zj=e.ThemeColor=void 0;var C;(function(T){function f(k){return k&&typeof k=="object"&&typeof k.id=="string"}T.isThemeColor=f})(C||(e.ThemeColor=C={}));function S(T){return{id:T}}e.$zj=S;var z;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const f=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function k(c){const w=f.exec(c.id);if(!w)return k(g.$yj.error);const[,v,y]=w,i=["codicon","codicon-"+v];return y&&i.push("codicon-modifier-"+y.substring(1)),i}T.asClassNameArray=k;function m(c){return k(c).join(" ")}T.asClassName=m;function F(c){return"."+k(c).join(".")}T.asCSSSelector=F;function D(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||C.isThemeColor(c.color))}T.isThemeIcon=D;const h=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function b(c){const w=h.exec(c);if(!w)return;const[,v]=w;return{id:v}}T.fromString=b;function $(c){return{id:c}}T.fromId=$;function u(c,w){let v=c.id;const y=v.lastIndexOf("~");return y!==-1&&(v=v.substring(0,y)),w&&(v=`${v}~${w}`),{id:v}}T.modify=u;function t(c){const w=c.id.lastIndexOf("~");if(w!==-1)return c.id.substring(w+1)}T.getModifier=t;function r(c,w){return c.id===w.id&&c.color?.id===w.color?.id}T.isEqual=r})(z||(e.ThemeIcon=z={}))}),define(Re[121],Fe([1,0,119,13,40]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=void 0;const z="$(",T=new RegExp(`\\$\\(${S.ThemeIcon.iconNameExpression}(?:${S.ThemeIcon.iconModifierExpression})?\\)`,"g"),f=new RegExp(`(\\\\)?${T.source}`,"g");function k(r){return r.replace(f,(c,w)=>w?c:`\\${c}`)}e.$Aj=k;const m=new RegExp(`\\\\${T.source}`,"g");function F(r){return r.replace(m,c=>`\\${c}`)}e.$Bj=F;const D=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function h(r){return r.indexOf(z)===-1?r:r.replace(D,(c,w,v,y)=>v?c:w||y||"")}e.$Cj=h;function b(r){return r?r.replace(/\$\((.*?)\)/g,(c,w)=>` ${w} `).trim():""}e.$Dj=b;const $=new RegExp(`\\$\\(${S.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(r){$.lastIndex=0;let c="";const w=[];let v=0;for(;;){const y=$.lastIndex,i=$.exec(r),l=r.substring(y,i?.index);if(l.length>0){c+=l;for(let n=0;n<l.length;n++)w.push(v)}if(!i)break;v+=i[0].length}return{text:c,iconOffsets:w}}e.$Ej=u;function t(r,c,w=!1){const{text:v,iconOffsets:y}=c;if(!y||y.length===0)return(0,g.$nj)(r,v,w);const i=(0,C.$pd)(v," "),l=v.length-i.length,n=(0,g.$nj)(r,i,w);if(n)for(const s of n){const p=y[s.start+l]+l;s.start+=p,s.end+=p}return n}e.$Fj=t}),define(Re[36],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(S){return g.test(S)}e.$2e=C,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(f){for(let k=0;k<f.length;k++)f[k]=Math.floor(Math.random()*256);return f};const z=new Uint8Array(16),T=[];for(let f=0;f<256;f++)T.push(f.toString(16).padStart(2,"0"));return function(){S(z),z[6]=z[6]&15|64,z[8]=z[8]&63|128;let k=0,m="";return m+=T[z[k++]],m+=T[z[k++]],m+=T[z[k++]],m+=T[z[k++]],m+="-",m+=T[z[k++]],m+=T[z[k++]],m+="-",m+=T[z[k++]],m+=T[z[k++]],m+="-",m+=T[z[k++]],m+=T[z[k++]],m+="-",m+=T[z[k++]],m+=T[z[k++]],m+=T[z[k++]],m+=T[z[k++]],m+=T[z[k++]],m+=T[z[k++]],m}}()}),define(Re[122],Fe([1,0,18,67,36]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=e.$8r=e.$7r=void 0;function z(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$7r=z;function T(D,h,b){const $={id:(0,S.$3e)(),name:D,uri:h,data:b};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$8r=T;class f{constructor(){this.a=new Map}get size(){let h=0;for(const b of this.a)h++;return h}has(h){return this.a.has(this.b(h))}matches(h){const b=[...this.a.keys()];return C.Iterable.some(this,([$,u])=>u.asFile())&&b.push("files"),F(k(h),b)}get(h){return this.a.get(this.b(h))?.[0]}append(h,b){const $=this.a.get(h);$?$.push(b):this.a.set(this.b(h),[b])}replace(h,b){this.a.set(this.b(h),[b])}delete(h){this.a.delete(this.b(h))}*[Symbol.iterator](){for(const[h,b]of this.a)for(const $ of b)yield[h,$]}b(h){return k(h)}}e.$9r=f;function k(D){return D.toLowerCase()}function m(D,h){return F(k(D),h.map(k))}e.$0r=m;function F(D,h){if(D==="*/*")return h.length>0;if(h.includes(D))return!0;const b=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[$,u,t]=b;return t==="*"?h.some(r=>r.startsWith(u+"/")):!1}e.$$r=Object.freeze({create:D=>(0,g.$of)(D.map(h=>h.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$$r.split(D).filter(h=>!h.startsWith("#"))})}),define(Re[123],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0,e.$Dr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[124],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.$us=e.IndentAction=void 0;var g;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(g||(e.IndentAction=g={}));class C{constructor(f){if(this.e=null,this.f=!1,this.open=f.open,this.close=f.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(f.notIn))for(let k=0,m=f.notIn.length;k<m;k++)switch(f.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(f){switch(f){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(f,k){if(f.getTokenCount()===0)return!0;const m=f.findTokenIndexAtOffset(k-2),F=f.getStandardTokenType(m);return this.isOK(F)}g(f,k){for(let m=f;m<=k;m++){const F=String.fromCharCode(m);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$us=C;class S{constructor(f){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of f)z(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),z(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),z(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),z(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&z(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$vs=S;function z(T,f,k){T.has(f)?T.get(f).push(k):T.set(f,[k])}}),define(Re[125],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$93=e.$83=void 0;class g{constructor(){this.a=new Map}removeDragOperationTransfer(z){if(z&&this.a.has(z)){const T=this.a.get(z);return this.a.delete(z),T}}addDragOperationTransfer(z,T){this.a.set(z,T)}}e.$83=g;class C{constructor(z){this.identifier=z}}e.$93=C}),define(Re[126],Fe([11,12]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Re[127],Fe([1,0,5,6,126]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=void 0;class z extends C.$kb{constructor(h,b="",$="",u=!0,t){super(),this.h=this.B(new g.$5c),this.onDidChange=this.h.event,this.w=!0,this.j=h,this.m=b,this.u=$,this.w=u,this.C=t}get id(){return this.j}get label(){return this.m}set label(h){this.D(h)}D(h){this.m!==h&&(this.m=h,this.h.fire({label:h}))}get tooltip(){return this.n||""}set tooltip(h){this.F(h)}F(h){this.n!==h&&(this.n=h,this.h.fire({tooltip:h}))}get class(){return this.u}set class(h){this.G(h)}G(h){this.u!==h&&(this.u=h,this.h.fire({class:h}))}get enabled(){return this.w}set enabled(h){this.H(h)}H(h){this.w!==h&&(this.w=h,this.h.fire({enabled:h}))}get checked(){return this.z}set checked(h){this.I(h)}I(h){this.z!==h&&(this.z=h,this.h.fire({checked:h}))}async run(h,b){this.C&&await this.C(h)}}e.$3h=z;class T extends C.$kb{constructor(){super(...arguments),this.f=this.B(new g.$5c),this.onWillRun=this.f.event,this.h=this.B(new g.$5c),this.onDidRun=this.h.event}async run(h,b){if(!h.enabled)return;this.f.fire({action:h});let $;try{await this.k(h,b)}catch(u){$=u}this.h.fire({action:h,error:$})}async k(h,b){await h.run(b)}}e.$4h=T;class f{constructor(){this.id=f.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let b=[];for(const $ of h)$.length&&(b.length?b=[...b,new f,...$]:b=$);return b}async run(){}}e.$5h=f,f.ID="vs.actions.separator";class k{get actions(){return this.a}constructor(h,b,$,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=b,this.class=u,this.a=$}async run(){}}e.$6h=k;class m extends z{constructor(){super(m.ID,S.localize(0,null),void 0,!1)}}e.$7h=m,m.ID="vs.actions.empty";function F(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async()=>D.run(),tooltip:D.label}}e.$8h=F}),define(Re[128],Fe([11,12]),function(te,e){return te.create("vs/base/common/date",e)}),define(Re[129],Fe([1,0,128]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=void 0;const C=60,S=C*60,z=S*24,T=z*7,f=z*30,k=z*365;function m(D,h,b,$){typeof D!="number"&&(D=D.getTime());const u=Math.round((new Date().getTime()-D)/1e3);if(u<-30)return(0,g.localize)(0,null,m(new Date().getTime()+u*1e3,!1));if(!$&&u<30)return(0,g.localize)(1,null);let t;return u<C?(t=u,h?t===1?b?(0,g.localize)(2,null,t):(0,g.localize)(3,null,t):b?(0,g.localize)(4,null,t):(0,g.localize)(5,null,t):t===1?b?(0,g.localize)(6,null,t):(0,g.localize)(7,null,t):b?(0,g.localize)(8,null,t):(0,g.localize)(9,null,t)):u<S?(t=Math.floor(u/C),h?t===1?b?(0,g.localize)(10,null,t):(0,g.localize)(11,null,t):b?(0,g.localize)(12,null,t):(0,g.localize)(13,null,t):t===1?b?(0,g.localize)(14,null,t):(0,g.localize)(15,null,t):b?(0,g.localize)(16,null,t):(0,g.localize)(17,null,t)):u<z?(t=Math.floor(u/S),h?t===1?b?(0,g.localize)(18,null,t):(0,g.localize)(19,null,t):b?(0,g.localize)(20,null,t):(0,g.localize)(21,null,t):t===1?b?(0,g.localize)(22,null,t):(0,g.localize)(23,null,t):b?(0,g.localize)(24,null,t):(0,g.localize)(25,null,t)):u<T?(t=Math.floor(u/z),h?t===1?(0,g.localize)(26,null,t):(0,g.localize)(27,null,t):t===1?(0,g.localize)(28,null,t):(0,g.localize)(29,null,t)):u<f?(t=Math.floor(u/T),h?t===1?b?(0,g.localize)(30,null,t):(0,g.localize)(31,null,t):b?(0,g.localize)(32,null,t):(0,g.localize)(33,null,t):t===1?b?(0,g.localize)(34,null,t):(0,g.localize)(35,null,t):b?(0,g.localize)(36,null,t):(0,g.localize)(37,null,t)):u<k?(t=Math.floor(u/f),h?t===1?b?(0,g.localize)(38,null,t):(0,g.localize)(39,null,t):b?(0,g.localize)(40,null,t):(0,g.localize)(41,null,t):t===1?b?(0,g.localize)(42,null,t):(0,g.localize)(43,null,t):b?(0,g.localize)(44,null,t):(0,g.localize)(45,null,t)):(t=Math.floor(u/k),h?t===1?b?(0,g.localize)(46,null,t):(0,g.localize)(47,null,t):b?(0,g.localize)(48,null,t):(0,g.localize)(49,null,t):t===1?b?(0,g.localize)(50,null,t):(0,g.localize)(51,null,t):b?(0,g.localize)(52,null,t):(0,g.localize)(53,null,t))}e.$Nl=m;function F(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Ol=F}),define(Re[130],Fe([11,12]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Re[41],Fe([1,0,18,10,130]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=e.$9h=void 0;function z(D,h){return h&&(D.stack||D.stacktrace)?S.localize(0,null,f(D),T(D.stack)||T(D.stacktrace)):f(D)}function T(D){return Array.isArray(D)?D.join(`
`):D}function f(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?S.localize(1,null,D.message):D.message||S.localize(2,null)}function k(D=null,h=!1){if(!D)return S.localize(3,null);if(Array.isArray(D)){const b=g.$jf(D),$=k(b[0],h);return b.length>1?S.localize(4,null,$,b.length):$}if(C.$ge(D))return D;if(D.detail){const b=D.detail;if(b.error)return z(b.error,h);if(b.exception)return z(b.exception,h)}return D.stack?z(D,h):D.message?D.message:S.localize(5,null)}e.$9h=k;function m(D){const h=D;return h instanceof Error&&Array.isArray(h.actions)}e.$0h=m;function F(D,h){let b;return typeof D=="string"?b=new Error(D):b=D,b.actions=h,b}e.$$h=F}),define(Re[131],Fe([1,0,66,19]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;const S=new g.$S(()=>{const A=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:A,collatorIsNumeric:A.resolvedOptions().numeric}}),z=new g.$S(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new g.$S(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function f(A,E,a=!1){const o=A||"",L=E||"",B=S.value.collator.compare(o,L);return S.value.collatorIsNumeric&&B===0&&o!==L?o<L?-1:1:B}e.$Up=f;function k(A,E){const a=z.value.collator;return A=A||"",E=E||"",v(a,A,E)}e.$Vp=k;function m(A,E){const a=z.value.collator;return A=A||"",E=E||"",n(A,E)||v(a,A,E)}e.$Wp=m;function F(A,E){const a=z.value.collator;return A=A||"",E=E||"",l(A,E)||v(a,A,E)}e.$Xp=F;function D(A,E){return A=A||"",E=E||"",A===E?0:A<E?-1:1}e.$Yp=D;function h(A,E){const[a,o]=c(A),[L,B]=c(E);let G=S.value.collator.compare(o,B);if(G===0){if(S.value.collatorIsNumeric&&o!==B)return o<B?-1:1;if(G=S.value.collator.compare(a,L),S.value.collatorIsNumeric&&G===0&&a!==L)return a<L?-1:1}return G}e.$Zp=h;function b(A,E){A=A||"",E=E||"";const a=w(A),o=w(E),L=z.value.collator,B=T.value.collator;return v(B,a,o)||v(L,A,E)}e.$1p=b;function $(A,E){A=A||"",E=E||"";const a=w(A),o=w(E),L=z.value.collator,B=T.value.collator;return v(B,a,o)||n(A,E)||v(L,A,E)}e.$2p=$;function u(A,E){A=A||"",E=E||"";const a=w(A),o=w(E),L=z.value.collator,B=T.value.collator;return v(B,a,o)||l(A,E)||v(L,A,E)}e.$3p=u;function t(A,E){A=A||"",E=E||"";const a=w(A).toLowerCase(),o=w(E).toLowerCase();return a!==o?a<o?-1:1:A!==E?A<E?-1:1:0}e.$4p=t;const r=/^(.*?)(\.([^.]*))?$/;function c(A,E=!1){const a=A?r.exec(A):[];let o=[a&&a[1]||"",a&&a[3]||""];return E&&(!o[0]&&o[1]||o[0]&&o[0].charAt(0)===".")&&(o=[o[0]+"."+o[1],""]),o}function w(A){const E=A?r.exec(A):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function v(A,E,a){const o=A.compare(E,a);return o!==0?o:E.length!==a.length?E.length<a.length?-1:1:0}function y(A){const E=A.charAt(0);return E.toLocaleUpperCase()!==E}function i(A){const E=A.charAt(0);return E.toLocaleLowerCase()!==E}function l(A,E){return y(A)&&i(E)?-1:i(A)&&y(E)?1:0}function n(A,E){return i(A)&&y(E)?-1:y(A)&&i(E)?1:0}function s(A,E,a=!1){return a||(A=A&&A.toLowerCase(),E=E&&E.toLowerCase()),A===E?0:A<E?-1:1}function p(A,E,a=!1){const o=A.split(C.sep),L=E.split(C.sep),B=o.length-1,G=L.length-1;let q,W;for(let N=0;;N++){if(q=B===N,W=G===N,q&&W)return f(o[N],L[N],a);if(q)return-1;if(W)return 1;const H=s(o[N],L[N],a);if(H!==0)return H}}e.$5p=p;function I(A,E,a){const o=A.toLowerCase(),L=E.toLowerCase(),B=d(A,E,a);if(B)return B;const G=o.endsWith(a),q=L.endsWith(a);if(G!==q)return G?-1:1;const W=f(o,L);return W!==0?W:o.localeCompare(L)}e.$6p=I;function d(A,E,a){const o=A.toLowerCase(),L=E.toLowerCase(),B=o.startsWith(a),G=L.startsWith(a);if(B!==G)return B?-1:1;if(B&&G){if(o.length<L.length)return-1;if(o.length>L.length)return 1}return 0}e.$7p=d}),define(Re[42],Fe([1,0,19,21,13,10]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function T(I){return I===47||I===92}e.$Ae=T;function f(I){return I.replace(/[\\/]/g,g.$8b.sep)}e.$Be=f;function k(I){return I.indexOf("/")===-1&&(I=f(I)),/^[a-zA-Z]:(\/|$)/.test(I)&&(I="/"+I),I}e.$Ce=k;function m(I,d=g.$8b.sep){if(!I)return"";const A=I.length,E=I.charCodeAt(0);if(T(E)){if(T(I.charCodeAt(1))&&!T(I.charCodeAt(2))){let o=3;const L=o;for(;o<A&&!T(I.charCodeAt(o));o++);if(L!==o&&!T(I.charCodeAt(o+1))){for(o+=1;o<A;o++)if(T(I.charCodeAt(o)))return I.slice(0,o+1).replace(/[\\/]/g,d)}}return d}else if(r(E)&&I.charCodeAt(1)===58)return T(I.charCodeAt(2))?I.slice(0,2)+d:I.slice(0,2);let a=I.indexOf("://");if(a!==-1){for(a+=3;a<A;a++)if(T(I.charCodeAt(a)))return I.slice(0,a+1)}return""}e.$De=m;function F(I){if(!C.$i||!I||I.length<5)return!1;let d=I.charCodeAt(0);if(d!==92||(d=I.charCodeAt(1),d!==92))return!1;let A=2;const E=A;for(;A<I.length&&(d=I.charCodeAt(A),d!==92);A++);return!(E===A||(d=I.charCodeAt(A+1),isNaN(d)||d===92))}e.$Ee=F;const D=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(I,d=C.$i){const A=d?D:h;return!(!I||I.length===0||/^\s+$/.test(I)||(A.lastIndex=0,A.test(I))||d&&b.test(I)||I==="."||I===".."||d&&I[I.length-1]==="."||d&&I.length!==I.trim().length||I.length>255)}e.$Fe=$;function u(I,d,A){const E=I===d;return!A||E?E:!I||!d?!1:(0,S.$Jd)(I,d)}e.$Ge=u;function t(I,d,A,E=g.sep){if(I===d)return!0;if(!I||!d||d.length>I.length)return!1;if(A){if(!(0,S.$Kd)(I,d))return!1;if(d.length===I.length)return!0;let o=d.length;return d.charAt(d.length-1)===E&&o--,I.charAt(o)===E}return d.charAt(d.length-1)!==E&&(d+=E),I.indexOf(d)===0}e.$He=t;function r(I){return I>=65&&I<=90||I>=97&&I<=122}e.$Ie=r;function c(I,d){return C.$i&&I.endsWith(":")&&(I+=g.sep),(0,g.$0b)(I)||(I=(0,g.$$b)(d,I)),I=(0,g.$9b)(I),C.$i?(I=(0,S.$qd)(I,g.sep),I.endsWith(":")&&(I+=g.sep)):(I=(0,S.$qd)(I,g.sep),I||(I=g.sep)),I}e.$Je=c;function w(I){const d=(0,g.$9b)(I);return C.$i?I.length>3?!1:v(d)&&(I.length===2||d.charCodeAt(2)===92):d===g.$8b.sep}e.$Ke=w;function v(I,d=C.$i){return d?r(I.charCodeAt(0))&&I.charCodeAt(1)===58:!1}e.$Le=v;function y(I,d=C.$i){return v(I,d)?I[0]:void 0}e.$Me=y;function i(I,d,A){return d.length>I.length?-1:I===d?0:(A&&(I=I.toLowerCase(),d=d.toLowerCase()),I.indexOf(d))}e.$Ne=i;function l(I){const d=I.split(":");let A,E,a;for(const o of d){const L=Number(o);(0,z.$ke)(L)?E===void 0?E=L:a===void 0&&(a=L):A=A?[A,o].join(":"):o}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:E!==void 0?E:void 0,column:a!==void 0?a:E!==void 0?1:void 0}}e.$Oe=l;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(I,d,A=8){let E="";for(let o=0;o<A;o++){let L;o===0&&C.$i&&!d&&(A===3||A===4)?L=s:L=n,E+=L.charAt(Math.floor(Math.random()*L.length))}let a;return d?a=`${d}-${E}`:a=E,I?(0,g.$$b)(I,a):a}e.$Pe=p}),define(Re[68],Fe([1,0,19]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=void 0,e.$qr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function z(F){const D=(0,g.$dc)(F),h=C[D.toLowerCase()];return h!==void 0?h:T(F)}e.$rr=z;function T(F){const D=(0,g.$dc)(F);return S[D.toLowerCase()]}e.$sr=T;function f(F){for(const D in S)if(S[D]===F)return D}e.$tr=f;const k=/^(.+)\/(.+?)(;.+)?$/;function m(F,D){const h=k.exec(F);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:D?void 0:F}e.$ur=m}),define(Re[69],Fe([1,0,25,13,2]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=e.$Tg=e.$Sg=void 0;function z(m){return JSON.stringify(m,f)}e.$Sg=z;function T(m){let F=JSON.parse(m);return F=k(F),F}e.$Tg=T;function f(m,F){return F instanceof RegExp?{$mid:2,source:F.source,flags:(0,C.$wd)(F)}:F}function k(m,F=0){if(!m||F>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return S.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof g.$Ib||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let D=0;D<m.length;++D)m[D]=k(m[D],F+1);else for(const D in m)Object.hasOwnProperty.call(m,D)&&(m[D]=k(m[D],F+1))}return m}e.$Ug=k}),define(Re[14],Fe([1,0,9,21,2]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var z;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(z||(e.Schemas=z={})),e.$Te="vscode-tkn",e.$Ue="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${z.vscodeRemoteResource}`}setPreferredWebSchema(F){this.d=F}setDelegate(F){this.e=F}setServerRootPath(F){this.f=`${F}/${z.vscodeRemoteResource}`}set(F,D,h){this.a[F]=D,this.b[F]=h}setConnectionToken(F,D){this.c[F]=D}getPreferredWebSchema(){return this.d}rewrite(F){if(this.e)try{return this.e(F)}catch(t){return g.$X(t),F}const D=F.authority;let h=this.a[D];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const b=this.b[D],$=this.c[D];let u=`path=${encodeURIComponent(F.path)}`;return typeof $=="string"&&(u+=`&${e.$Ue}=${encodeURIComponent($)}`),S.URI.from({scheme:C.$o?this.d:z.vscodeRemoteResource,authority:`${h}:${b}`,path:this.f,query:u})}}e.$Ve=new T,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class f{asBrowserUri(F){const D=this.b(F,te);return this.uriToBrowserUri(D)}uriToBrowserUri(F){return F.scheme===z.vscodeRemote?e.$Ve.rewrite(F):F.scheme===z.file&&(C.$m||C.$p&&C.$g.origin===`${z.vscodeFileResource}://${f.a}`)?F.with({scheme:z.vscodeFileResource,authority:F.authority||f.a,query:null,fragment:null}):F}asFileUri(F){const D=this.b(F,te);return this.uriToFileUri(D)}uriToFileUri(F){return F.scheme===z.vscodeFileResource?F.with({scheme:z.file,authority:F.authority!==f.a?F.authority:null,query:null,fragment:null}):F}b(F,D){return S.URI.isUri(F)?F:S.URI.parse(D.toUrl(F))}}f.a="vscode-app",e.$1e=new f;var k;(function(m){const F=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(F.get("3"));const D="vscode-coi";function h($){let u;typeof $=="string"?u=new URL($).searchParams:$ instanceof URL?u=$.searchParams:S.URI.isUri($)&&(u=new URL($.toString(!0)).searchParams);const t=u?.get(D);if(t)return F.get(t)}m.getHeadersFromQuery=h;function b($,u,t){if(!globalThis.crossOriginIsolated)return;const r=u&&t?"3":t?"2":"1";$ instanceof URLSearchParams?$.set(D,r):$[D]=r}m.addSearchParam=b})(k||(e.COI=k={}))}),define(Re[20],Fe([1,0,42,14,19,21,13,2]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.DataUri=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function k(b){return(0,f.$Se)(b,!0)}e.$Tf=k;class m{constructor($){this.a=$}compare($,u,t=!1){return $===u?0:(0,T.$Cd)(this.getComparisonKey($,t),this.getComparisonKey(u,t))}isEqual($,u,t=!1){return $===u?!0:!$||!u?!1:this.getComparisonKey($,t)===this.getComparisonKey(u,t)}getComparisonKey($,u=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,u,t=!1){if($.scheme===u.scheme){if($.scheme===C.Schemas.file)return g.$He(k($),k(u),this.a($))&&$.query===u.query&&(t||$.fragment===u.fragment);if((0,e.$$f)($.authority,u.authority))return g.$He($.path,u.path,this.a($),"/")&&$.query===u.query&&(t||$.fragment===u.fragment)}return!1}joinPath($,...u){return f.URI.joinPath($,...u)}basenameOrAuthority($){return(0,e.$3f)($)||$.authority}basename($){return S.$8b.basename($.path)}extname($){return S.$8b.extname($.path)}dirname($){if($.path.length===0)return $;let u;return $.scheme===C.Schemas.file?u=f.URI.file(S.$bc(k($))).path:(u=S.$8b.dirname($.path),$.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),u="/")),$.with({path:u})}normalizePath($){if(!$.path.length)return $;let u;return $.scheme===C.Schemas.file?u=f.URI.file(S.$9b(k($))).path:u=S.$8b.normalize($.path),$.with({path:u})}relativePath($,u){if($.scheme!==u.scheme||!(0,e.$$f)($.authority,u.authority))return;if($.scheme===C.Schemas.file){const c=S.$ac(k($),k(u));return z.$i?g.$Be(c):c}let t=$.path||"/";const r=u.path||"/";if(this.a($)){let c=0;for(const w=Math.min(t.length,r.length);c<w&&!(t.charCodeAt(c)!==r.charCodeAt(c)&&t.charAt(c).toLowerCase()!==r.charAt(c).toLowerCase());c++);t=r.substr(0,c)+t.substr(c)}return S.$8b.relative(t,r)}resolvePath($,u){if($.scheme===C.Schemas.file){const t=f.URI.file(S.$_b(k($),u));return $.with({authority:t.authority,path:t.path})}return u=g.$Ce(u),$.with({path:S.$8b.resolve($.path,u)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,u){return $===u||$!==void 0&&u!==void 0&&(0,T.$Jd)($,u)}hasTrailingPathSeparator($,u=S.sep){if($.scheme===C.Schemas.file){const t=k($);return t.length>g.$De(t).length&&t[t.length-1]===u}else{const t=$.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,u=S.sep){return(0,e.$_f)($,u)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,u=S.sep){let t=!1;if($.scheme===C.Schemas.file){const r=k($);t=r!==void 0&&r.length===g.$De(r).length&&r[r.length-1]===u}else{u="/";const r=$.path;t=r.length===1&&r.charCodeAt(r.length-1)===47}return!t&&!(0,e.$_f)($,u)?$.with({path:$.path+"/"}):$}}e.$Uf=m,e.$Vf=new m(()=>!1),e.$Wf=new m(b=>b.scheme===C.Schemas.file?!z.$k:!0),e.$Xf=new m(b=>!0),e.$Yf=e.$Vf.isEqual.bind(e.$Vf),e.$Zf=e.$Vf.isEqualOrParent.bind(e.$Vf),e.$1f=e.$Vf.getComparisonKey.bind(e.$Vf),e.$2f=e.$Vf.basenameOrAuthority.bind(e.$Vf),e.$3f=e.$Vf.basename.bind(e.$Vf),e.$4f=e.$Vf.extname.bind(e.$Vf),e.$5f=e.$Vf.dirname.bind(e.$Vf),e.$6f=e.$Vf.joinPath.bind(e.$Vf),e.$7f=e.$Vf.normalizePath.bind(e.$Vf),e.$8f=e.$Vf.relativePath.bind(e.$Vf),e.$9f=e.$Vf.resolvePath.bind(e.$Vf),e.$0f=e.$Vf.isAbsolutePath.bind(e.$Vf),e.$$f=e.$Vf.isEqualAuthority.bind(e.$Vf),e.$_f=e.$Vf.hasTrailingPathSeparator.bind(e.$Vf),e.$ag=e.$Vf.removeTrailingPathSeparator.bind(e.$Vf),e.$bg=e.$Vf.addTrailingPathSeparator.bind(e.$Vf);function F(b,$){const u=[];for(let t=0;t<b.length;t++){const r=$(b[t]);b.some((c,w)=>w===t?!1:(0,e.$Zf)(r,$(c)))||u.push(b[t])}return u}e.$cg=F;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function $(u){const t=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(w=>{const[v,y]=w.split(":");v&&y&&t.set(v,y)});const c=u.path.substring(0,u.path.indexOf(";"));return c&&t.set(b.META_DATA_MIME,c),t}b.parseMetaData=$})(D||(e.DataUri=D={}));function h(b,$,u){if($){let t=b.path;return t&&t[0]!==S.$8b.sep&&(t=S.$8b.sep+t),b.with({scheme:u,authority:$,path:t})}return b.with({scheme:u})}e.$dg=h}),define(Re[16],Fe([1,0,22,9,5,6,20,21,120]),function(te,e,g,C,S,z,T,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Og=e.$Ng=e.$Mg=e.Promises=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=void 0;function m(me){return!!me&&typeof me.then=="function"}e.$eg=m;function F(me){const R=new g.$bd,Q=me(R.token),he=new Promise((De,ye)=>{const $e=R.token.onCancellationRequested(()=>{$e.dispose(),R.dispose(),ye(new C.$2)});Promise.resolve(Q).then(Se=>{$e.dispose(),R.dispose(),De(Se)},Se=>{$e.dispose(),R.dispose(),ye(Se)})});return new class{cancel(){R.cancel()}then(De,ye){return he.then(De,ye)}catch(De){return this.then(void 0,De)}finally(De){return he.finally(De)}}}e.$fg=F;function D(me,R,Q){return new Promise((he,De)=>{const ye=R.onCancellationRequested(()=>{ye.dispose(),he(Q)});me.then(he,De).finally(()=>ye.dispose())})}e.$gg=D;function h(me,R){return new Promise((Q,he)=>{const De=R.onCancellationRequested(()=>{De.dispose(),he(new C.$2)});me.then(Q,he).finally(()=>De.dispose())})}e.$hg=h;async function b(me){let R=-1;const Q=me.map((he,De)=>he.then(ye=>(R=De,ye)));try{return await Promise.race(Q)}finally{me.forEach((he,De)=>{De!==R&&he.cancel()})}}e.$ig=b;function $(me,R,Q){let he;const De=setTimeout(()=>{he?.(void 0),Q?.()},R);return Promise.race([me.finally(()=>clearTimeout(De)),new Promise(ye=>he=ye)])}e.$jg=$;function u(me){return new Promise((R,Q)=>{const he=me();m(he)?he.then(R,Q):R(he)})}e.$kg=u;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(R){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=R,!this.b){const Q=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Q,Q).then(he)})}return new Promise((Q,he)=>{this.b.then(Q,he)})}return this.a=R(),new Promise((Q,he)=>{this.a.then(De=>{this.a=null,Q(De)},De=>{this.a=null,he(De)})})}dispose(){this.f=!0}}e.$lg=t;class r{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.$mg=r;class c{constructor(){this.a=new Map}queue(R,Q){const De=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(R)===De&&this.a.delete(R)});return this.a.set(R,De),De}}e.$ng=c;const w=(me,R)=>{let Q=!0;const he=setTimeout(()=>{Q=!1,R()},me);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(he),Q=!1}}},v=me=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,me())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class y{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,Q=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((De,ye)=>{this.d=De,this.f=ye}).then(()=>{if(this.b=null,this.d=null,this.g){const De=this.g;return this.g=null,De()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Q===k.$2c?v(he):w(Q,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$2),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$og=y;class i{constructor(R){this.a=new y(R),this.b=new t}trigger(R,Q){return this.a.trigger(()=>this.b.queue(R),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.$pg=i;class l{constructor(){this.a=!1,this.b=new Promise((R,Q)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$qg=l;class n extends l{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.$rg=n;function s(me,R){return R?new Promise((Q,he)=>{const De=setTimeout(()=>{ye.dispose(),Q()},me),ye=R.onCancellationRequested(()=>{clearTimeout(De),ye.dispose(),he(new C.$2)})}):F(Q=>s(me,Q))}e.$sg=s;function p(me,R=0){const Q=setTimeout(me,R);return(0,z.$ib)(()=>clearTimeout(Q))}e.$tg=p;function I(me){const R=[];let Q=0;const he=me.length;function De(){return Q<he?me[Q++]():null}function ye($e){$e!=null&&R.push($e);const Se=De();return Se?Se.then(ye):Promise.resolve(R)}return Promise.resolve(null).then(ye)}e.$ug=I;function d(me,R=he=>!!he,Q=null){let he=0;const De=me.length,ye=()=>{if(he>=De)return Promise.resolve(Q);const $e=me[he++];return Promise.resolve($e()).then(ae=>R(ae)?Promise.resolve(ae):ye())};return ye()}e.$vg=d;function A(me,R=he=>!!he,Q=null){if(me.length===0)return Promise.resolve(Q);let he=me.length;const De=()=>{he=-1;for(const ye of me)ye.cancel?.()};return new Promise((ye,$e)=>{for(const Se of me)Se.then(ae=>{--he>=0&&R(ae)?(De(),ye(ae)):he===0&&ye(Q)}).catch(ae=>{--he>=0&&(De(),$e(ae))})})}e.$wg=A;class E{constructor(R){this.a=0,this.d=R,this.f=[],this.b=0,this.g=new S.$5c}get onDrained(){return this.g.event}get size(){return this.a}queue(R){return this.a++,new Promise((Q,he)=>{this.f.push({factory:R,c:Q,e:he}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const R=this.f.shift();this.b++;const Q=R.factory();Q.then(R.c,R.e),Q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$xg=E;class a extends E{constructor(){super(1)}}e.$yg=a;class o{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const R=new Pe;return this.b.add(R),R.p}d(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueFor(R,Q=T.$Vf){const he=Q.getComparisonKey(R);let De=this.a.get(he);return De||(De=new a,S.Event.once(De.onDrained)(()=>{De?.dispose(),this.a.delete(he),this.f()}),this.a.set(he,De)),De}f(){this.d()&&this.g()}g(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.g()}}e.$zg=o;class L{constructor(R,Q){this.a=-1,typeof R=="function"&&typeof Q=="number"&&this.setIfNotSet(R,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},Q)}setIfNotSet(R,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},Q))}}e.$Ag=L;class B{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(R,Q){this.cancel(),this.a=setInterval(()=>{R()},Q)}}e.$Bg=B;class G{constructor(R,Q){this.b=-1,this.a=R,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Cg=G;class q{constructor(R,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=R,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dg=q;class W extends G{constructor(R,Q){super(R,Q),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.$Eg=W;class N extends z.$kb{constructor(R,Q){super(),this.g=R,this.h=Q,this.a=[],this.b=this.B(new z.$lb),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of R)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fg=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Gg=me=>{(0,f.$A)(()=>{if(R)return;const Q=Date.now()+15;me(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Q-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.$Gg=(me,R)=>{const Q=requestIdleCallback(me,typeof R=="number"?{timeout:R}:void 0);let he=!1;return{dispose(){he||(he=!0,cancelIdleCallback(Q))}}}}();class H{constructor(R){this.d=!1,this.a=()=>{try{this.f=R()}catch(Q){this.g=Q}finally{this.d=!0}},this.b=(0,e.$Gg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Hg=H;async function j(me,R,Q){let he;for(let De=0;De<Q;De++)try{return await me()}catch(ye){he=ye,await s(R)}throw he}e.$Ig=j;class O{hasPending(R){return this.a?typeof R=="number"?this.a.taskId===R:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(R,Q,he){return this.a={taskId:R,cancel:()=>he?.(),promise:Q},Q.then(()=>this.d(R),()=>this.d(R)),Q}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this.b)this.b.run=R;else{let Q,he;const De=new Promise((ye,$e)=>{Q=ye,he=$e});this.b={run:R,promise:De,promiseResolve:Q,promiseReject:he}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Jg=O;class ue{constructor(R,Q=()=>Date.now()){this.d=R,this.f=Q,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.$Kg=ue;var pe;(function(me){me[me.Resolved=0]="Resolved",me[me.Rejected=1]="Rejected"})(pe||(pe={}));class Pe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((R,Q)=>{this.a=R,this.b=Q})}complete(R){return new Promise(Q=>{this.a(R),this.d={outcome:0,value:R},Q()})}error(R){return new Promise(Q=>{this.b(R),this.d={outcome:1,value:R},Q()})}cancel(){return this.error(new C.$2)}}e.$Lg=Pe;var _;(function(me){async function R(he){let De;const ye=await Promise.all(he.map($e=>$e.then(Se=>Se,Se=>{De||(De=Se)})));if(typeof De<"u")throw De;return ye}me.settled=R;function Q(he){return new Promise(async(De,ye)=>{try{await he(De,ye)}catch($e){ye($e)}})}me.withAsyncBody=Q})(_||(e.Promises=_={}));var Y;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(Y||(Y={}));class ce{static fromArray(R){return new ce(Q=>{Q.emitMany(R)})}static fromPromise(R){return new ce(async Q=>{Q.emitMany(await R)})}static fromPromises(R){return new ce(async Q=>{await Promise.all(R.map(async he=>Q.emitOne(await he)))})}static merge(R){return new ce(async Q=>{await Promise.all(R.map(async he=>{for await(const De of he)Q.emitOne(De)}))})}constructor(R){this.a=0,this.b=[],this.d=null,this.f=new S.$5c,queueMicrotask(async()=>{const Q={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(R(Q)),this.j()}catch(he){this.k(he)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.f.event)}while(!0)}}}static map(R,Q){return new ce(async he=>{for await(const De of R)he.emitOne(Q(De))})}map(R){return ce.map(this,R)}static filter(R,Q){return new ce(async he=>{for await(const De of R)Q(De)&&he.emitOne(De)})}filter(R){return ce.filter(this,R)}static coalesce(R){return ce.filter(R,Q=>!!Q)}coalesce(){return ce.coalesce(this)}static async toPromise(R){const Q=[];for await(const he of R)Q.push(he);return Q}toPromise(){return ce.toPromise(this)}g(R){this.a===0&&(this.b.push(R),this.f.fire())}h(R){this.a===0&&(this.b=this.b.concat(R),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(R){this.a===0&&(this.a=2,this.d=R,this.f.fire())}}e.$Mg=ce,ce.EMPTY=ce.fromArray([]);class ke extends ce{constructor(R,Q){super(Q),this.l=R}cancel(){this.l.cancel()}}e.$Ng=ke;function Ce(me){const R=new g.$bd,Q=me(R.token);return new ke(R,async he=>{const De=R.token.onCancellationRequested(()=>{De.dispose(),R.dispose(),he.reject(new C.$2)});try{for await(const ye of Q){if(R.token.isCancellationRequested)return;he.emitOne(ye)}De.dispose(),R.dispose()}catch(ye){De.dispose(),R.dispose(),he.reject(ye)}})}e.$Og=Ce}),define(Re[37],Fe([1,0,18,16,42,28,19,21,13]),function(te,e,g,C,S,z,T,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0;function m(){return Object.create(null)}e.$8i=m,e.$9i="**",e.$0i="/";const F="[/\\\\]",D="[^/\\\\]",h=/\//g;function b(ue,pe){switch(ue){case 0:return"";case 1:return`${D}*?`;default:return`(?:${F}|${D}+${F}${pe?`|${F}${D}+`:""})*?`}}function $(ue,pe){if(!ue)return[];const Pe=[];let _=!1,Y=!1,ce="";for(const ke of ue){switch(ke){case pe:if(!_&&!Y){Pe.push(ce),ce="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}ce+=ke}return ce&&Pe.push(ce),Pe}e.$$i=$;function u(ue){if(!ue)return"";let pe="";const Pe=$(ue,e.$0i);if(Pe.every(_=>_===e.$9i))pe=".*";else{let _=!1;Pe.forEach((Y,ce)=>{if(Y===e.$9i){if(_)return;pe+=b(2,ce===Pe.length-1)}else{let ke=!1,Ce="",me=!1,R="";for(const Q of Y){if(Q!=="}"&&ke){Ce+=Q;continue}if(me&&(Q!=="]"||!R)){let he;Q==="-"?he=Q:(Q==="^"||Q==="!")&&!R?he="^":Q===e.$0i?he="":he=(0,k.$ld)(Q),R+=he;continue}switch(Q){case"{":ke=!0;continue;case"[":me=!0;continue;case"}":{const De=`(?:${$(Ce,",").map(ye=>u(ye)).join("|")})`;pe+=De,ke=!1,Ce="";break}case"]":{pe+="["+R+"]",me=!1,R="";break}case"?":pe+=D;continue;case"*":pe+=b(1);continue;default:pe+=(0,k.$ld)(Q)}}ce<Pe.length-1&&(Pe[ce+1]!==e.$9i||ce+2<Pe.length)&&(pe+=F)}_=Y===e.$9i})}return pe}const t=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new z.$mi(1e4),l=function(){return!1},n=function(){return null};function s(ue,pe){if(!ue)return n;let Pe;typeof ue!="string"?Pe=ue.pattern:Pe=ue,Pe=Pe.trim();const _=`${Pe}_${!!pe.trimForExclusions}`;let Y=i.get(_);if(Y)return p(Y,ue);let ce;return t.test(Pe)?Y=d(Pe.substr(4),Pe):(ce=r.exec(I(Pe,pe)))?Y=A(ce[1],Pe):(pe.trimForExclusions?w:c).test(Pe)?Y=E(Pe,pe):(ce=v.exec(I(Pe,pe)))?Y=a(ce[1].substr(1),Pe,!0):(ce=y.exec(I(Pe,pe)))?Y=a(ce[1],Pe,!1):Y=o(Pe),i.set(_,Y),p(Y,ue)}function p(ue,pe){if(typeof pe=="string")return ue;const Pe=function(_,Y){return(0,S.$He)(_,pe.base,!f.$k)?ue((0,k.$pd)(_.substr(pe.base.length),T.sep),Y):null};return Pe.allBasenames=ue.allBasenames,Pe.allPaths=ue.allPaths,Pe.basenames=ue.basenames,Pe.patterns=ue.patterns,Pe}function I(ue,pe){return pe.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function d(ue,pe){return function(Pe,_){return typeof Pe=="string"&&Pe.endsWith(ue)?pe:null}}function A(ue,pe){const Pe=`/${ue}`,_=`\\${ue}`,Y=function(ke,Ce){return typeof ke!="string"?null:Ce?Ce===ue?pe:null:ke===ue||ke.endsWith(Pe)||ke.endsWith(_)?pe:null},ce=[ue];return Y.basenames=ce,Y.patterns=[pe],Y.allBasenames=ce,Y}function E(ue,pe){const Pe=j(ue.slice(1,-1).split(",").map(Ce=>s(Ce,pe)).filter(Ce=>Ce!==n),ue),_=Pe.length;if(!_)return n;if(_===1)return Pe[0];const Y=function(Ce,me){for(let R=0,Q=Pe.length;R<Q;R++)if(Pe[R](Ce,me))return ue;return null},ce=Pe.find(Ce=>!!Ce.allBasenames);ce&&(Y.allBasenames=ce.allBasenames);const ke=Pe.reduce((Ce,me)=>me.allPaths?Ce.concat(me.allPaths):Ce,[]);return ke.length&&(Y.allPaths=ke),Y}function a(ue,pe,Pe){const _=T.sep===T.$8b.sep,Y=_?ue:ue.replace(h,T.sep),ce=T.sep+Y,ke=T.$8b.sep+ue;let Ce;return Pe?Ce=function(me,R){return typeof me=="string"&&(me===Y||me.endsWith(ce)||!_&&(me===ue||me.endsWith(ke)))?pe:null}:Ce=function(me,R){return typeof me=="string"&&(me===Y||!_&&me===ue)?pe:null},Ce.allPaths=[(Pe?"*/":"./")+ue],Ce}function o(ue){try{const pe=new RegExp(`^${u(ue)}$`);return function(Pe){return pe.lastIndex=0,typeof Pe=="string"&&pe.test(Pe)?ue:null}}catch{return n}}function L(ue,pe,Pe){return!ue||typeof pe!="string"?!1:B(ue)(pe,void 0,Pe)}e.$_i=L;function B(ue,pe={}){if(!ue)return l;if(typeof ue=="string"||G(ue)){const Pe=s(ue,pe);if(Pe===n)return l;const _=function(Y,ce){return!!Pe(Y,ce)};return Pe.allBasenames&&(_.allBasenames=Pe.allBasenames),Pe.allPaths&&(_.allPaths=Pe.allPaths),_}return N(ue,pe)}e.$aj=B;function G(ue){const pe=ue;return pe?typeof pe.base=="string"&&typeof pe.pattern=="string":!1}e.$bj=G;function q(ue){return ue.allBasenames||[]}e.$cj=q;function W(ue){return ue.allPaths||[]}e.$dj=W;function N(ue,pe){const Pe=j(Object.getOwnPropertyNames(ue).map(Ce=>H(Ce,ue[Ce],pe)).filter(Ce=>Ce!==n)),_=Pe.length;if(!_)return n;if(!Pe.some(Ce=>!!Ce.requiresSiblings)){if(_===1)return Pe[0];const Ce=function(Q,he){let De;for(let ye=0,$e=Pe.length;ye<$e;ye++){const Se=Pe[ye](Q,he);if(typeof Se=="string")return Se;(0,C.$eg)(Se)&&(De||(De=[]),De.push(Se))}return De?(async()=>{for(const ye of De){const $e=await ye;if(typeof $e=="string")return $e}return null})():null},me=Pe.find(Q=>!!Q.allBasenames);me&&(Ce.allBasenames=me.allBasenames);const R=Pe.reduce((Q,he)=>he.allPaths?Q.concat(he.allPaths):Q,[]);return R.length&&(Ce.allPaths=R),Ce}const Y=function(Ce,me,R){let Q,he;for(let De=0,ye=Pe.length;De<ye;De++){const $e=Pe[De];$e.requiresSiblings&&R&&(me||(me=(0,T.$cc)(Ce)),Q||(Q=me.substr(0,me.length-(0,T.$dc)(Ce).length)));const Se=$e(Ce,me,Q,R);if(typeof Se=="string")return Se;(0,C.$eg)(Se)&&(he||(he=[]),he.push(Se))}return he?(async()=>{for(const De of he){const ye=await De;if(typeof ye=="string")return ye}return null})():null},ce=Pe.find(Ce=>!!Ce.allBasenames);ce&&(Y.allBasenames=ce.allBasenames);const ke=Pe.reduce((Ce,me)=>me.allPaths?Ce.concat(me.allPaths):Ce,[]);return ke.length&&(Y.allPaths=ke),Y}function H(ue,pe,Pe){if(pe===!1)return n;const _=s(ue,Pe);if(_===n)return n;if(typeof pe=="boolean")return _;if(pe){const Y=pe.when;if(typeof Y=="string"){const ce=(ke,Ce,me,R)=>{if(!R||!_(ke,Ce))return null;const Q=Y.replace("$(basename)",()=>me),he=R(Q);return(0,C.$eg)(he)?he.then(De=>De?ue:null):he?ue:null};return ce.requiresSiblings=!0,ce}}return _}function j(ue,pe){const Pe=ue.filter(Ce=>!!Ce.basenames);if(Pe.length<2)return ue;const _=Pe.reduce((Ce,me)=>{const R=me.basenames;return R?Ce.concat(R):Ce},[]);let Y;if(pe){Y=[];for(let Ce=0,me=_.length;Ce<me;Ce++)Y.push(pe)}else Y=Pe.reduce((Ce,me)=>{const R=me.patterns;return R?Ce.concat(R):Ce},[]);const ce=function(Ce,me){if(typeof Ce!="string")return null;if(!me){let Q;for(Q=Ce.length;Q>0;Q--){const he=Ce.charCodeAt(Q-1);if(he===47||he===92)break}me=Ce.substr(Q)}const R=_.indexOf(me);return R!==-1?Y[R]:null};ce.basenames=_,ce.patterns=Y,ce.allBasenames=_;const ke=ue.filter(Ce=>!Ce.basenames);return ke.push(ce),ke}function O(ue,pe){return(0,g.$$e)(ue,pe,(Pe,_)=>typeof Pe=="string"&&typeof _=="string"?Pe===_:typeof Pe!="string"&&typeof _!="string"?Pe.base===_.base&&Pe.pattern===_.pattern:!1)}e.$ej=O}),define(Re[70],Fe([1,0,9,121,20,13,2]),function(te,e,g,C,S,z,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.MarkdownStringTextNewlineStyle=void 0;var f;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(f||(e.MarkdownStringTextNewlineStyle=f={}));class k{constructor(r="",c=!1){if(this.value=r,typeof this.value!="string")throw(0,g.$4)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(r,c=0){return this.value+=h(this.supportThemeIcons?(0,C.$Aj)(r):r).replace(/([ \t]+)/g,(w,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(r){return this.value+=r,this}appendCodeblock(r,c){return this.value+="\n```",this.value+=r,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(r,c,w){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(r),")"),w&&(this.value+=` "${this.c(this.c(w,'"'),")")}"`),this.value+=")",this}c(r,c){const w=new RegExp((0,z.$ld)(c),"g");return r.replace(w,(v,y)=>r.charAt(y-1)!=="\\"?`\\${v}`:v)}}e.$Gj=k;function m(t){return F(t)?!t.value:Array.isArray(t)?t.every(m):!0}e.$Hj=m;function F(t){return t instanceof k?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$Ij=F;function D(t,r){return t===r?!0:!t||!r?!1:t.value===r.value&&t.isTrusted===r.isTrusted&&t.supportThemeIcons===r.supportThemeIcons&&t.supportHtml===r.supportHtml&&(t.baseUri===r.baseUri||!!t.baseUri&&!!r.baseUri&&(0,S.$Yf)(T.URI.from(t.baseUri),T.URI.from(r.baseUri)))}e.$Jj=D;function h(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Kj=h;function b(t){return t.replace(/"/g,"&quot;")}e.$Lj=b;function $(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Mj=$;function u(t){const r=[],c=t.split("|").map(v=>v.trim());t=c[0];const w=c[1];if(w){const v=/height=(\d+)/.exec(w),y=/width=(\d+)/.exec(w),i=v?v[1]:"",l=y?y[1]:"",n=isFinite(parseInt(l)),s=isFinite(parseInt(i));n&&r.push(`width="${l}"`),s&&r.push(`height="${i}"`)}return{href:t,dimensions:r}}e.$Nj=u}),define(Re[90],Fe([1,0,18,42,19,21,20,13]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wz=e.$Vz=e.$Uz=e.$Tz=e.$Sz=e.$Rz=e.$Qz=e.$Pz=e.$Oz=e.$Nz=void 0;function k(s,p){const{os:I,tildify:d,relative:A}=p;if(A){const o=m(s,A,I);if(typeof o=="string")return o}let E=s.fsPath;if(I===1&&!z.$i?E=E.replace(/\//g,"\\"):I!==1&&z.$i&&(E=E.replace(/\\/g,"/")),I!==1&&d?.userHome){const o=d.userHome.fsPath;let L;s.scheme!==d.userHome.scheme&&s.path.startsWith(S.$8b.sep)?L=d.userHome.with({path:s.path}).fsPath:L=s.fsPath,E=h(L,o,I)}return(I===1?S.$7b:S.$8b).normalize(F(E,I===1))}e.$Nz=k;function m(s,p,I){const d=I===1?S.$7b:S.$8b,A=I===3?T.$Vf:T.$Xf,E=p.getWorkspace(),a=(0,g.$sf)(E.folders);if(!a)return;s.scheme!==a.uri.scheme&&s.path.startsWith(S.$8b.sep)&&(s=a.uri.with({path:s.path}));const o=p.getWorkspaceFolder(s);if(!o)return;let L;if(A.isEqual(o.uri,s)?L="":L=A.relativePath(o.uri,s)??"",L&&(L=d.normalize(L)),E.folders.length>1&&!p.noPrefix){const B=o.name?o.name:A.basenameOrAuthority(o.uri);L=L?`${B} \u2022 ${L}`:B}return L}function F(s,p=z.$i){return(0,C.$Le)(s,p)?s.charAt(0).toUpperCase()+s.slice(1):s}e.$Oz=F;let D=Object.create(null);function h(s,p,I=z.OS){if(I===1||!s||!p)return s;let d=D.original===p?D.normalized:void 0;d||(d=p,z.$i&&(d=(0,C.$Be)(d)),d=`${(0,f.$qd)(d,S.$8b.sep)}${S.$8b.sep}`,D={original:p,normalized:d});let A=s;return z.$i&&(A=(0,C.$Be)(A)),(I===3?A.startsWith(d):(0,f.$Kd)(A,d))?`~/${A.substr(d.length)}`:s}e.$Pz=h;function b(s,p){return s.replace(/^~($|\/|\\)/,`${p}$1`)}e.$Qz=b;const $="\u2026",u="\\\\",t="~";function r(s,p=S.sep){const I=new Array(s.length);let d=!1;for(let A=0;A<s.length;A++){const E=s[A];if(E===""){I[A]=`.${p}`;continue}if(!E){I[A]=E;continue}d=!0;let a="",o=E;o.indexOf(u)===0?(a=o.substr(0,o.indexOf(u)+u.length),o=o.substr(o.indexOf(u)+u.length)):o.indexOf(p)===0?(a=o.substr(0,o.indexOf(p)+p.length),o=o.substr(o.indexOf(p)+p.length)):o.indexOf(t)===0&&(a=o.substr(0,o.indexOf(t)+t.length),o=o.substr(o.indexOf(t)+t.length));const L=o.split(p);for(let B=1;d&&B<=L.length;B++)for(let G=L.length-B;d&&G>=0;G--){d=!1;let q=L.slice(G,G+B).join(p);for(let W=0;!d&&W<s.length;W++)if(W!==A&&s[W]&&s[W].indexOf(q)>-1){const N=G+B===L.length,H=G>0&&s[W].indexOf(p)>-1?p+q:q,j=s[W].endsWith(H);d=!N||j}if(!d){let W="";(L[0].endsWith(":")||a!=="")&&(G===1&&(G=0,B++,q=L[0]+p+q),G>0&&(W=L[0]+p),W=a+W),G>0&&(W=W+$+p),W=W+q,G+B<L.length&&(W=W+p+$),I[A]=W}}d&&(I[A]=E)}return I}e.$Rz=r;var c;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function w(s,p=Object.create(null)){const I=[];let d=!1,A="";for(const E of s)if(E==="$"||d&&E==="{")A&&I.push({value:A,type:c.TEXT}),A="",d=!0;else if(E==="}"&&d){const a=p[A];if(typeof a=="string")a.length&&I.push({value:a,type:c.VARIABLE});else if(a){const o=I[I.length-1];(!o||o.type!==c.SEPARATOR)&&I.push({value:a.label,type:c.SEPARATOR})}A="",d=!1}else A+=E;return A&&!d&&I.push({value:A,type:c.TEXT}),I.filter((E,a)=>{if(E.type===c.SEPARATOR){const o=I[a-1],L=I[a+1];return[o,L].every(B=>B&&(B.type===c.VARIABLE||B.type===c.TEXT)&&B.value.length>0)}return!0}).map(E=>E.value).join("")}e.$Sz=w;function v(s,p){return z.$j||p?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,z.$j?"&":"&&"):s.replace(/&&|&/g,I=>I==="&"?"&&":"&")}e.$Tz=v;function y(s,p){return z.$j||p?s.replace(/\(&&\w\)|&&/g,""):z.$i?s.replace(/&&|&/g,I=>I==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.$Uz=y;function i(s){return s.replace(/&/g,"&&")}e.$Vz=i;function l(s){if(s.endsWith("]")){const p=s.lastIndexOf(" [",s.length-2);if(p!==-1){const I=n(s.substring(0,p));return{name:I.name,parentPath:I.parentPath+s.substring(p)}}}return n(s)}e.$Wz=l;function n(s){const p=s.indexOf("/")!==-1?S.$8b:S.$7b,I=p.basename(s),d=p.dirname(s);return I.length?{name:I,parentPath:d}:{name:d,parentPath:""}}}),define(Re[132],Fe([1,0,25,2]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=e.$lm=e.$km=e.$jm=void 0;function S(D){return D.toJSON()}class z{constructor(h){this.a=h}transformIncoming(h){const b=this.a.transformIncoming(h);return b===h?h:S(C.URI.from(b))}transformOutgoing(h){const b=this.a.transformOutgoing(h);return b===h?h:S(C.URI.from(b))}transformOutgoingURI(h){const b=this.a.transformOutgoing(h);return b===h?h:C.URI.from(b)}transformOutgoingScheme(h){return this.a.transformOutgoingScheme(h)}}e.$jm=z,e.$km=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function T(D,h,b){if(!D||b>200)return null;if(typeof D=="object"){if(D instanceof C.URI)return h.transformOutgoing(D);for(const $ in D)if(Object.hasOwnProperty.call(D,$)){const u=T(D[$],h,b+1);u!==null&&(D[$]=u)}}return null}function f(D,h){const b=T(D,h,0);return b===null?D:b}e.$lm=f;function k(D,h,b,$){if(!D||$>200)return null;if(typeof D=="object"){if(D.$mid===1)return b?C.URI.revive(h.transformIncoming(D)):h.transformIncoming(D);if(D instanceof g.$Ib)return null;for(const u in D)if(Object.hasOwnProperty.call(D,u)){const t=k(D[u],h,b,$+1);t!==null&&(D[u]=t)}}return null}function m(D,h){const b=k(D,h,!1,0);return b===null?D:b}e.$mm=m;function F(D,h){const b=k(D,h,!0,0);return b===null?D:b}e.$nm=F}),define(Re[133],Fe([1,0,37,19]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xE=void 0;function S(z,T,f,k,m,F){if(Array.isArray(z)){let D=0;for(const h of z){const b=S(h,T,f,k,m,F);if(b===10)return b;b>D&&(D=b)}return D}else{if(typeof z=="string")return k?z==="*"?5:z===f?10:0:0;if(z){const{language:D,pattern:h,scheme:b,hasAccessToAllModels:$,notebookType:u}=z;if(!k&&!$)return 0;u&&m&&(T=m);let t=0;if(b)if(b===T.scheme)t=10;else if(b==="*")t=5;else return 0;if(D)if(D===f)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(u)if(u===F)t=10;else if(u==="*"&&F!==void 0)t=Math.max(t,5);else return 0;if(h){let r;if(typeof h=="string"?r=h:r={...h,base:(0,C.$9b)(h.base)},r===T.fsPath||(0,g.$_i)(r,T.fsPath))t=10;else return 0}return t}else return 0}}e.$xE=S}),define(Re[91],Fe([1,0,25,21]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d7=e.$c7=void 0;var S;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(S||(S={}));function z(D){for(let h=0,b=D.length;h<b;h+=4){const $=D[h+0],u=D[h+1],t=D[h+2],r=D[h+3];D[h+0]=r,D[h+1]=t,D[h+2]=u,D[h+3]=$}}function T(D){const h=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return C.$C()||z(h),g.$Ib.wrap(h)}function f(D){const h=D.buffer;if(C.$C()||z(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const b=new Uint8Array(h.byteLength);return b.set(h),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function k(D){const h=new Uint32Array(m(D));let b=0;if(h[b++]=D.id,D.type==="full")h[b++]=1,h[b++]=D.data.length,h.set(D.data,b),b+=D.data.length;else{h[b++]=2,h[b++]=D.deltas.length;for(const $ of D.deltas)h[b++]=$.start,h[b++]=$.deleteCount,$.data?(h[b++]=$.data.length,h.set($.data,b),b+=$.data.length):h[b++]=0}return T(h)}e.$c7=k;function m(D){let h=0;if(h+=1+1,D.type==="full")h+=1+D.data.length;else{h+=1,h+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(h+=b.data.length)}return h}function F(D){const h=f(D);let b=0;const $=h[b++];if(h[b++]===1){const c=h[b++],w=h.subarray(b,b+c);return b+=c,{id:$,type:"full",data:w}}const t=h[b++],r=[];for(let c=0;c<t;c++){const w=h[b++],v=h[b++],y=h[b++];let i;y>0&&(i=h.subarray(b,b+y),b+=y),r[c]={start:w,deleteCount:v,data:i}}return{id:$,type:"delta",deltas:r}}e.$d7=F}),define(Re[134],Fe([11,12]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Re[135],Fe([1,0,18,23,21,123,136,134]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(x){x[x.None=0]="None",x[x.Keep=1]="Keep",x[x.Brackets=2]="Brackets",x[x.Advanced=3]="Advanced",x[x.Full=4]="Full"})(k||(e.EditorAutoIndentStrategy=k={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=m;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class D{constructor(X,ge,je,Ne){this.id=X,this.name=ge,this.defaultValue=je,this.schema=Ne}applyUpdate(X,ge){return b(X,ge)}compute(X,ge,je){return je}}class h{constructor(X,ge){this.newValue=X,this.didChange=ge}}e.ApplyUpdateResult=h;function b(x,X){if(typeof x!="object"||typeof X!="object"||!x||!X)return new h(X,x!==X);if(Array.isArray(x)||Array.isArray(X)){const je=Array.isArray(x)&&Array.isArray(X)&&g.$$e(x,X);return new h(X,!je)}let ge=!1;for(const je in X)if(X.hasOwnProperty(je)){const Ne=b(x[je],X[je]);Ne.didChange&&(x[je]=Ne.newValue,ge=!0)}return new h(x,ge)}class ${constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,ge){return b(X,ge)}validate(X){return this.defaultValue}}class u{constructor(X,ge,je,Ne){this.id=X,this.name=ge,this.defaultValue=je,this.schema=Ne}applyUpdate(X,ge){return b(X,ge)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,ge,je){return je}}function t(x,X){return typeof x>"u"?X:x==="false"?!1:!!x}e.boolean=t;class r extends u{constructor(X,ge,je,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=je),super(X,ge,je,Ne)}validate(X){return t(X,this.defaultValue)}}function c(x,X,ge,je){if(typeof x>"u")return X;let Ne=parseInt(x,10);return isNaN(Ne)?X:(Ne=Math.max(ge,Ne),Ne=Math.min(je,Ne),Ne|0)}e.clampedInt=c;class w extends u{static clampedInt(X,ge,je,Ne){return c(X,ge,je,Ne)}constructor(X,ge,je,Ne,Ze,tt=void 0){typeof tt<"u"&&(tt.type="integer",tt.default=je,tt.minimum=Ne,tt.maximum=Ze),super(X,ge,je,tt),this.minimum=Ne,this.maximum=Ze}validate(X){return w.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function v(x,X,ge,je){if(typeof x>"u")return X;const Ne=y.float(x,X);return y.clamp(Ne,ge,je)}e.clampedFloat=v;class y extends u{static clamp(X,ge,je){return X<ge?ge:X>je?je:X}static float(X,ge){if(typeof X=="number")return X;if(typeof X>"u")return ge;const je=parseFloat(X);return isNaN(je)?ge:je}constructor(X,ge,je,Ne,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=je),super(X,ge,je,Ze),this.validationFn=Ne}validate(X){return this.validationFn(y.float(X,this.defaultValue))}}class i extends u{static string(X,ge){return typeof X!="string"?ge:X}constructor(X,ge,je,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=je),super(X,ge,je,Ne)}validate(X){return i.string(X,this.defaultValue)}}function l(x,X,ge,je){return typeof x!="string"?X:je&&x in je?je[x]:ge.indexOf(x)===-1?X:x}e.stringSet=l;class n extends u{constructor(X,ge,je,Ne,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ne,Ze.default=je),super(X,ge,je,Ze),this.c=Ne}validate(X){return l(X,this.defaultValue,this.c)}}class s extends D{constructor(X,ge,je,Ne,Ze,tt,$t=void 0){typeof $t<"u"&&($t.type="string",$t.enum=Ze,$t.default=Ne),super(X,ge,je,$t),this.c=Ze,this.d=tt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function p(x){switch(x){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class I extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",tags:["accessibility"],description:f.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ge,je){return je===0?X.accessibilitySupport:je}}class d extends D{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:f.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertSpace:t(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var A;(function(x){x[x.Hidden=0]="Hidden",x[x.Blink=1]="Blink",x[x.Smooth=2]="Smooth",x[x.Phase=3]="Phase",x[x.Expand=4]="Expand",x[x.Solid=5]="Solid"})(A||(e.TextEditorCursorBlinkingStyle=A={}));function E(x){switch(x){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(x){x[x.Line=1]="Line",x[x.Block=2]="Block",x[x.Underline=3]="Underline",x[x.LineThin=4]="LineThin",x[x.BlockOutline=5]="BlockOutline",x[x.UnderlineThin=6]="UnderlineThin"})(a||(e.TextEditorCursorStyle=a={}));function o(x){switch(x){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function L(x){switch(x){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class B extends ${constructor(){super(138)}compute(X,ge,je){const Ne=["monaco-editor"];return ge.get(37)&&Ne.push(ge.get(37)),X.extraEditorClassName&&Ne.push(X.extraEditorClassName),ge.get(71)==="default"?Ne.push("mouse-default"):ge.get(71)==="copy"&&Ne.push("mouse-copy"),ge.get(108)&&Ne.push("showUnused"),ge.get(136)&&Ne.push("showDeprecated"),Ne.join(" ")}}class G extends r{constructor(){super(35,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(X,ge,je){return je&&X.emptySelectionClipboard}}class q extends D{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:f.localize(16,null),included:S.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:f.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{cursorMoveOnType:t(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":l(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":l(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(ge.loop,this.defaultValue.loop)}}}class W extends D{constructor(){super(49,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?W.OFF:X==="true"?W.ON:X:X?W.ON:W.OFF}}e.EditorFontLigatures=W,W.OFF='"liga" off, "calt" off',W.ON='"liga" on, "calt" on';class N extends D{constructor(){super(52,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:f.localize(22,null)},{type:"string",description:f.localize(23,null)}],description:f.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?N.OFF:X==="true"?N.TRANSLATE:X:X?N.TRANSLATE:N.OFF}compute(X,ge,je){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=N,N.OFF="normal",N.TRANSLATE="translate";class H extends ${constructor(){super(48)}compute(X,ge,je){return X.fontInfo}}class j extends u{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(25,null)})}validate(X){const ge=y.float(X,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:y.clamp(ge,6,100)}compute(X,ge,je){return X.fontInfo.fontSize}}class O extends D{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:O.d,maximum:O.e,errorMessage:f.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:O.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(w.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,O.d,O.e))}}O.c=["normal","bold","100","200","300","400","500","600","700","800","900"],O.d=1,O.e=1e3;class ue extends D{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[f.localize(28,null),f.localize(29,null),f.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:f.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:f.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:f.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:je,description:f.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:je,description:f.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:je,description:f.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:je,description:f.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:je,description:f.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{multiple:l(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??l(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??l(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??l(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??l(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??l(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class pe extends D{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:f.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:f.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:f.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:f.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),delay:w.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:t(ge.sticky,this.defaultValue.sticky),above:t(ge.above,this.defaultValue.above)}}}var Pe;(function(x){x[x.None=0]="None",x[x.Text=1]="Text",x[x.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class _ extends ${constructor(){super(141)}compute(X,ge,je){return _.computeLayout(ge,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const ge=X.height/X.lineHeight,je=Math.floor(X.paddingTop/X.lineHeight);let Ne=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Ne=Math.max(Ne,ge-1));const Ze=(je+X.viewLineCount+Ne)/(X.pixelRatio*X.height),tt=Math.floor(X.viewLineCount/Ze);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Ne,desiredRatio:Ze,minimapLineCount:tt}}static c(X,ge){const je=X.outerWidth,Ne=X.outerHeight,Ze=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const tt=ge.stableMinimapLayoutInput,$t=tt&&X.outerHeight===tt.outerHeight&&X.lineHeight===tt.lineHeight&&X.typicalHalfwidthCharacterWidth===tt.typicalHalfwidthCharacterWidth&&X.pixelRatio===tt.pixelRatio&&X.scrollBeyondLastLine===tt.scrollBeyondLastLine&&X.paddingTop===tt.paddingTop&&X.paddingBottom===tt.paddingBottom&&X.minimap.enabled===tt.minimap.enabled&&X.minimap.side===tt.minimap.side&&X.minimap.size===tt.minimap.size&&X.minimap.showSlider===tt.minimap.showSlider&&X.minimap.renderCharacters===tt.minimap.renderCharacters&&X.minimap.maxColumn===tt.minimap.maxColumn&&X.minimap.scale===tt.minimap.scale&&X.verticalScrollbarWidth===tt.verticalScrollbarWidth&&X.isViewportWrapping===tt.isViewportWrapping,wt=X.lineHeight,Lt=X.typicalHalfwidthCharacterWidth,Gt=X.scrollBeyondLastLine,Wt=X.minimap.renderCharacters;let yt=Ze>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Ut=X.minimap.maxColumn,Mt=X.minimap.size,Nt=X.minimap.side,Kt=X.verticalScrollbarWidth,Vt=X.viewLineCount,at=X.remainingWidth,ft=X.isViewportWrapping,jt=Wt?2:3;let Rt=Math.floor(Ze*Ne);const St=Rt/Ze;let ut=!1,Ct=!1,Tt=jt*yt,Ae=yt/Ze,we=1;if(Mt==="fill"||Mt==="fit"){const{typicalViewportLineCount:xe,extraLinesBeforeFirstLine:Et,extraLinesBeyondLastLine:It,desiredRatio:Pt,minimapLineCount:mt}=_.computeContainedMinimapLineCount({viewLineCount:Vt,scrollBeyondLastLine:Gt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Ne,lineHeight:wt,pixelRatio:Ze});if(Vt/mt>1)ut=!0,Ct=!0,yt=1,Tt=1,Ae=yt/Ze;else{let dt=!1,vt=yt+1;if(Mt==="fit"){const bt=Math.ceil((Et+Vt+It)*Tt);ft&&$t&&at<=ge.stableFitRemainingWidth?(dt=!0,vt=ge.stableFitMaxMinimapScale):dt=bt>Rt}if(Mt==="fill"||dt){ut=!0;const bt=yt;Tt=Math.min(wt*Ze,Math.max(1,Math.floor(1/Pt))),ft&&$t&&at<=ge.stableFitRemainingWidth&&(vt=ge.stableFitMaxMinimapScale),yt=Math.min(vt,Math.max(1,Math.floor(Tt/jt))),yt>bt&&(we=Math.min(2,yt/bt)),Ae=yt/Ze/we,Rt=Math.ceil(Math.max(xe,Et+Vt+It)*Tt),ft?(ge.stableMinimapLayoutInput=X,ge.stableFitRemainingWidth=at,ge.stableFitMaxMinimapScale=yt):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const be=Math.floor(Ut*Ae),Z=Math.min(be,Math.max(0,Math.floor((at-Kt-2)*Ae/(Lt+Ae)))+e.MINIMAP_GUTTER_WIDTH);let Le=Math.floor(Ze*Z);const Ue=Le/Ze;Le=Math.floor(Le*we);const Ge=Wt?1:2,Ke=Nt==="left"?0:je-Z-Kt;return{renderMinimap:Ge,minimapLeft:Ke,minimapWidth:Z,minimapHeightIsEditorHeight:ut,minimapIsSampling:Ct,minimapScale:yt,minimapLineHeight:Tt,minimapCanvasInnerWidth:Le,minimapCanvasInnerHeight:Rt,minimapCanvasOuterWidth:Ue,minimapCanvasOuterHeight:St}}static computeLayout(X,ge){const je=ge.outerWidth|0,Ne=ge.outerHeight|0,Ze=ge.lineHeight|0,tt=ge.lineNumbersDigitCount|0,$t=ge.typicalHalfwidthCharacterWidth,wt=ge.maxDigitWidth,Lt=ge.pixelRatio,Gt=ge.viewLineCount,Wt=X.get(133),yt=Wt==="inherit"?X.get(132):Wt,Ut=yt==="inherit"?X.get(128):yt,Mt=X.get(131),Nt=ge.isDominatedByLongLines,Kt=X.get(55),Vt=X.get(65).renderType!==0,at=X.get(66),ft=X.get(102),jt=X.get(81),Rt=X.get(70),St=X.get(100),ut=St.verticalScrollbarSize,Ct=St.verticalHasArrows,Tt=St.arrowSize,Ae=St.horizontalScrollbarSize,we=X.get(41),be=X.get(107)!=="never";let Z=X.get(63);we&&be&&(Z+=16);let Le=0;if(Vt){const Bt=Math.max(tt,at);Le=Math.round(Bt*wt)}let Ue=0;Kt&&(Ue=Ze*ge.glyphMarginDecorationLaneCount);let Ge=0,Ke=Ge+Ue,xe=Ke+Le,Et=xe+Z;const It=je-Ue-Le-Z;let Pt=!1,mt=!1,pt=-1;yt==="inherit"&&Nt?(Pt=!0,mt=!0):Ut==="on"||Ut==="bounded"?mt=!0:Ut==="wordWrapColumn"&&(pt=Mt);const dt=_.c({outerWidth:je,outerHeight:Ne,lineHeight:Ze,typicalHalfwidthCharacterWidth:$t,pixelRatio:Lt,scrollBeyondLastLine:ft,paddingTop:jt.top,paddingBottom:jt.bottom,minimap:Rt,verticalScrollbarWidth:ut,viewLineCount:Gt,remainingWidth:It,isViewportWrapping:mt},ge.memory||new F);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Ge+=dt.minimapWidth,Ke+=dt.minimapWidth,xe+=dt.minimapWidth,Et+=dt.minimapWidth);const vt=It-dt.minimapWidth,bt=Math.max(1,Math.floor((vt-ut-2)/$t)),Zt=Ct?Tt:0;return mt&&(pt=Math.max(1,bt),Ut==="bounded"&&(pt=Math.min(pt,Mt))),{width:je,height:Ne,glyphMarginLeft:Ge,glyphMarginWidth:Ue,glyphMarginDecorationLaneCount:ge.glyphMarginDecorationLaneCount,lineNumbersLeft:Ke,lineNumbersWidth:Le,decorationsLeft:xe,decorationsWidth:Z,contentLeft:Et,contentWidth:vt,minimap:dt,viewportColumn:bt,isWordWrapMinified:Pt,isViewportWrapping:mt,wrappingColumn:pt,verticalScrollbarWidth:ut,horizontalScrollbarHeight:Ae,overviewRuler:{top:Zt,width:ut,height:Ne-2*Zt,right:0}}}}e.EditorLayoutInfoComputer=_;class Y extends D{constructor(){super(135,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[f.localize(46,null),f.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:f.localize(48,null)}})}validate(X){return l(X,"simple",["simple","advanced"])}compute(X,ge,je){return ge.get(2)===2?"advanced":je}}class ce extends D{constructor(){const X={enabled:!0};super(62,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:f.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:t(X.enabled,this.defaultValue.enabled)}}}class ke extends D{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(112,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:f.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:f.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:f.localize(52,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),maxLineCount:w.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:l(ge.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class Ce extends D{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(137,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:f.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[f.localize(54,null),f.localize(55,null,S.$j?"Ctrl+Option":"Ctrl+Alt"),f.localize(56,null,S.$j?"Ctrl+Option":"Ctrl+Alt"),f.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:f.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:f.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:f.localize(60,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:l(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:w.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(ge.fontFamily,this.defaultValue.fontFamily),padding:t(ge.padding,this.defaultValue.padding)}}}class me extends D{constructor(){super(63,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):w.clampedInt(X,this.defaultValue,0,1e3)}compute(X,ge,je){return je<0?w.clampedInt(-je*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class R extends y{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>y.clamp(X,0,150),{markdownDescription:f.localize(61,null)})}compute(X,ge,je){return X.fontInfo.lineHeight}}class Q extends D{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:f.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:f.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(64,null),f.localize(65,null),f.localize(66,null)],default:X.size,description:f.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:f.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:f.localize(69,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:f.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:f.localize(72,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),autohide:t(ge.autohide,this.defaultValue.autohide),size:l(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:l(ge.side,this.defaultValue.side,["right","left"]),showSlider:l(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(ge.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(ge.scale,1,1,3),maxColumn:w.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function he(x){return x==="ctrlCmd"?S.$j?"metaKey":"ctrlKey":"altKey"}class De extends D{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(74,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{top:w.clampedInt(ge.top,0,0,1e3),bottom:w.clampedInt(ge.bottom,0,0,1e3)}}}class ye extends D{constructor(){const X={enabled:!0,cycle:!0};super(83,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:f.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:f.localize(76,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),cycle:t(ge.cycle,this.defaultValue.cycle)}}}class $e extends ${constructor(){super(139)}compute(X,ge,je){return X.pixelRatio}}class Se extends D{constructor(){const X={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[f.localize(77,null),f.localize(78,null),f.localize(79,null)]}];super(86,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:X.strings,description:f.localize(80,null)},comments:{anyOf:ge,default:X.comments,description:f.localize(81,null)},other:{anyOf:ge,default:X.other,description:f.localize(82,null)}},default:X,markdownDescription:f.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Lt=X?"on":"off";return{comments:Lt,strings:Lt,other:Lt}}if(!X||typeof X!="object")return this.defaultValue;const{other:ge,comments:je,strings:Ne}=X,Ze=["on","inline","off"];let tt,$t,wt;return typeof ge=="boolean"?tt=ge?"on":"off":tt=l(ge,this.defaultValue.other,Ze),typeof je=="boolean"?$t=je?"on":"off":$t=l(je,this.defaultValue.comments,Ze),typeof Ne=="boolean"?wt=Ne?"on":"off":wt=l(Ne,this.defaultValue.strings,Ze),{other:tt,comments:$t,strings:wt}}}var ae;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative",x[x.Interval=3]="Interval",x[x.Custom=4]="Custom"})(ae||(e.RenderLineNumbersType=ae={}));class le extends D{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(84,null),f.localize(85,null),f.localize(86,null),f.localize(87,null)],default:"on",description:f.localize(88,null)})}validate(X){let ge=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(ge=4,je=X):X==="interval"?ge=3:X==="relative"?ge=2:X==="on"?ge=1:ge=0),{renderType:ge,renderFn:je}}}function ne(x){const X=x.get(95);return X==="editable"?x.get(88):X!=="on"}e.filterValidationDecorations=ne;class ee extends D{constructor(){const X=[],ge={type:"number",description:f.localize(89,null)};super(99,"rulers",X,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:f.localize(90,null),format:"color-hex"}}}]},default:X,description:f.localize(91,null)})}validate(X){if(Array.isArray(X)){const ge=[];for(const je of X)if(typeof je=="number")ge.push({column:w.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Ne=je;ge.push({column:w.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ge.sort((je,Ne)=>je.column-Ne.column),ge}return this.defaultValue}}class P extends D{constructor(){super(89,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function K(x,X){if(typeof x!="string")return X;switch(x){case"hidden":return 2;case"visible":return 3;default:return 1}}class V extends D{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(100,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(92,null),f.localize(93,null),f.localize(94,null)],default:"auto",description:f.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(96,null),f.localize(97,null),f.localize(98,null)],default:"auto",description:f.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:f.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:f.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:f.localize(102,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X,je=w.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=w.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:K(ge.vertical,this.defaultValue.vertical),horizontal:K(ge.horizontal,this.defaultValue.horizontal),useShadows:t(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:w.clampedInt(ge.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:w.clampedInt(ge.verticalSliderSize,Ne,0,1e3),scrollByPage:t(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends D{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(122,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:f.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:f.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:f.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:f.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:f.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:f.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:f.localize(109,null)}})}applyUpdate(X,ge){let je=!1;ge.allowedCharacters&&X&&(C.$Hm(X.allowedCharacters,ge.allowedCharacters)||(X={...X,allowedCharacters:ge.allowedCharacters},je=!0)),ge.allowedLocales&&X&&(C.$Hm(X.allowedLocales,ge.allowedLocales)||(X={...X,allowedLocales:ge.allowedLocales},je=!0));const Ne=super.applyUpdate(X,ge);return je?new h(Ne.newValue,!0):Ne}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{nonBasicASCII:ve(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ve(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ve(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,ge){if(typeof X!="object"||!X)return ge;const je={};for(const[Ne,Ze]of Object.entries(X))Ze===!0&&(je[Ne]=!0);return je}}class re extends D{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(60,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:f.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[f.localize(111,null),f.localize(112,null)],description:f.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:f.localize(114,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),mode:l(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:l(ge.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(ge.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(ge.keepOnBlur,this.defaultValue.keepOnBlur)}}}class de extends D{constructor(){const X={enabled:z.$Dr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:z.$Dr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:f.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:f.localize(116,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ie extends D{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(117,null),f.localize(118,null),f.localize(119,null)],default:X.bracketPairs,description:f.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(121,null),f.localize(122,null),f.localize(123,null)],default:X.bracketPairsHorizontal,description:f.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:f.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:f.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[f.localize(127,null),f.localize(128,null),f.localize(129,null)],default:X.highlightActiveIndentation,description:f.localize(130,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{bracketPairs:ve(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ve(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:ve(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ve(x,X,ge){const je=ge.indexOf(x);return je===-1?X:ge[je]}class Ee extends D{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(115,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(131,null),f.localize(132,null)],default:X.insertMode,description:f.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:f.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:f.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:f.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[f.localize(137,null),f.localize(138,null),f.localize(139,null),f.localize(140,null)],default:X.selectionMode,markdownDescription:f.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:f.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:f.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:f.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:f.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:f.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:f.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(178,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertMode:l(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:l(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(ge.showIcons,this.defaultValue.showIcons),showStatusBar:t(ge.showStatusBar,this.defaultValue.showStatusBar),preview:t(ge.preview,this.defaultValue.preview),previewMode:l(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(ge.showMethods,this.defaultValue.showMethods),showFunctions:t(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:t(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(ge.showFields,this.defaultValue.showFields),showVariables:t(ge.showVariables,this.defaultValue.showVariables),showClasses:t(ge.showClasses,this.defaultValue.showClasses),showStructs:t(ge.showStructs,this.defaultValue.showStructs),showInterfaces:t(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:t(ge.showModules,this.defaultValue.showModules),showProperties:t(ge.showProperties,this.defaultValue.showProperties),showEvents:t(ge.showEvents,this.defaultValue.showEvents),showOperators:t(ge.showOperators,this.defaultValue.showOperators),showUnits:t(ge.showUnits,this.defaultValue.showUnits),showValues:t(ge.showValues,this.defaultValue.showValues),showConstants:t(ge.showConstants,this.defaultValue.showConstants),showEnums:t(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:t(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(ge.showKeywords,this.defaultValue.showKeywords),showWords:t(ge.showWords,this.defaultValue.showWords),showColors:t(ge.showColors,this.defaultValue.showColors),showFiles:t(ge.showFiles,this.defaultValue.showFiles),showReferences:t(ge.showReferences,this.defaultValue.showReferences),showFolders:t(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:t(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(ge.showSnippets,this.defaultValue.showSnippets),showUsers:t(ge.showUsers,this.defaultValue.showUsers),showIssues:t(ge.showIssues,this.defaultValue.showIssues)}}}class Be extends D{constructor(){super(110,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(179,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:f.localize(180,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(X.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(x){x[x.None=0]="None",x[x.Same=1]="Same",x[x.Indent=2]="Indent",x[x.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends D{constructor(){super(134,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[f.localize(181,null),f.localize(182,null),f.localize(183,null),f.localize(184,null)],description:f.localize(185,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,ge,je){return ge.get(2)===2?0:je}}class He extends ${constructor(){super(142)}compute(X,ge,je){const Ne=ge.get(141);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class Qe extends D{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(34,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:f.localize(186,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:f.localize(187,null),enum:["afterDrop","never"],enumDescriptions:[f.localize(188,null),f.localize(189,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),showDropSelector:l(ge.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends D{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(82,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:f.localize(190,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:f.localize(191,null),enum:["afterPaste","never"],enumDescriptions:[f.localize(192,null),f.localize(193,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),showPasteSelector:l(ge.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:S.$j?et:S.$k?rt:ct,fontWeight:"normal",fontSize:S.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(x){return e.editorOptionsRegistry[x.id]=x,x}var st;(function(x){x[x.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",x[x.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",x[x.accessibilitySupport=2]="accessibilitySupport",x[x.accessibilityPageSize=3]="accessibilityPageSize",x[x.ariaLabel=4]="ariaLabel",x[x.autoClosingBrackets=5]="autoClosingBrackets",x[x.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",x[x.autoClosingDelete=7]="autoClosingDelete",x[x.autoClosingOvertype=8]="autoClosingOvertype",x[x.autoClosingQuotes=9]="autoClosingQuotes",x[x.autoIndent=10]="autoIndent",x[x.automaticLayout=11]="automaticLayout",x[x.autoSurround=12]="autoSurround",x[x.bracketPairColorization=13]="bracketPairColorization",x[x.guides=14]="guides",x[x.codeLens=15]="codeLens",x[x.codeLensFontFamily=16]="codeLensFontFamily",x[x.codeLensFontSize=17]="codeLensFontSize",x[x.colorDecorators=18]="colorDecorators",x[x.colorDecoratorsLimit=19]="colorDecoratorsLimit",x[x.columnSelection=20]="columnSelection",x[x.comments=21]="comments",x[x.contextmenu=22]="contextmenu",x[x.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",x[x.cursorBlinking=24]="cursorBlinking",x[x.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",x[x.cursorStyle=26]="cursorStyle",x[x.cursorSurroundingLines=27]="cursorSurroundingLines",x[x.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",x[x.cursorWidth=29]="cursorWidth",x[x.disableLayerHinting=30]="disableLayerHinting",x[x.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",x[x.domReadOnly=32]="domReadOnly",x[x.dragAndDrop=33]="dragAndDrop",x[x.dropIntoEditor=34]="dropIntoEditor",x[x.emptySelectionClipboard=35]="emptySelectionClipboard",x[x.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",x[x.extraEditorClassName=37]="extraEditorClassName",x[x.fastScrollSensitivity=38]="fastScrollSensitivity",x[x.find=39]="find",x[x.fixedOverflowWidgets=40]="fixedOverflowWidgets",x[x.folding=41]="folding",x[x.foldingStrategy=42]="foldingStrategy",x[x.foldingHighlight=43]="foldingHighlight",x[x.foldingImportsByDefault=44]="foldingImportsByDefault",x[x.foldingMaximumRegions=45]="foldingMaximumRegions",x[x.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",x[x.fontFamily=47]="fontFamily",x[x.fontInfo=48]="fontInfo",x[x.fontLigatures=49]="fontLigatures",x[x.fontSize=50]="fontSize",x[x.fontWeight=51]="fontWeight",x[x.fontVariations=52]="fontVariations",x[x.formatOnPaste=53]="formatOnPaste",x[x.formatOnType=54]="formatOnType",x[x.glyphMargin=55]="glyphMargin",x[x.gotoLocation=56]="gotoLocation",x[x.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",x[x.hover=58]="hover",x[x.inDiffEditor=59]="inDiffEditor",x[x.inlineSuggest=60]="inlineSuggest",x[x.letterSpacing=61]="letterSpacing",x[x.lightbulb=62]="lightbulb",x[x.lineDecorationsWidth=63]="lineDecorationsWidth",x[x.lineHeight=64]="lineHeight",x[x.lineNumbers=65]="lineNumbers",x[x.lineNumbersMinChars=66]="lineNumbersMinChars",x[x.linkedEditing=67]="linkedEditing",x[x.links=68]="links",x[x.matchBrackets=69]="matchBrackets",x[x.minimap=70]="minimap",x[x.mouseStyle=71]="mouseStyle",x[x.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",x[x.mouseWheelZoom=73]="mouseWheelZoom",x[x.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",x[x.multiCursorModifier=75]="multiCursorModifier",x[x.multiCursorPaste=76]="multiCursorPaste",x[x.multiCursorLimit=77]="multiCursorLimit",x[x.occurrencesHighlight=78]="occurrencesHighlight",x[x.overviewRulerBorder=79]="overviewRulerBorder",x[x.overviewRulerLanes=80]="overviewRulerLanes",x[x.padding=81]="padding",x[x.pasteAs=82]="pasteAs",x[x.parameterHints=83]="parameterHints",x[x.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",x[x.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",x[x.quickSuggestions=86]="quickSuggestions",x[x.quickSuggestionsDelay=87]="quickSuggestionsDelay",x[x.readOnly=88]="readOnly",x[x.readOnlyMessage=89]="readOnlyMessage",x[x.renameOnType=90]="renameOnType",x[x.renderControlCharacters=91]="renderControlCharacters",x[x.renderFinalNewline=92]="renderFinalNewline",x[x.renderLineHighlight=93]="renderLineHighlight",x[x.renderLineHighlightOnlyWhenFocus=94]="renderLineHighlightOnlyWhenFocus",x[x.renderValidationDecorations=95]="renderValidationDecorations",x[x.renderWhitespace=96]="renderWhitespace",x[x.revealHorizontalRightPadding=97]="revealHorizontalRightPadding",x[x.roundedSelection=98]="roundedSelection",x[x.rulers=99]="rulers",x[x.scrollbar=100]="scrollbar",x[x.scrollBeyondLastColumn=101]="scrollBeyondLastColumn",x[x.scrollBeyondLastLine=102]="scrollBeyondLastLine",x[x.scrollPredominantAxis=103]="scrollPredominantAxis",x[x.selectionClipboard=104]="selectionClipboard",x[x.selectionHighlight=105]="selectionHighlight",x[x.selectOnLineNumbers=106]="selectOnLineNumbers",x[x.showFoldingControls=107]="showFoldingControls",x[x.showUnused=108]="showUnused",x[x.snippetSuggestions=109]="snippetSuggestions",x[x.smartSelect=110]="smartSelect",x[x.smoothScrolling=111]="smoothScrolling",x[x.stickyScroll=112]="stickyScroll",x[x.stickyTabStops=113]="stickyTabStops",x[x.stopRenderingLineAfter=114]="stopRenderingLineAfter",x[x.suggest=115]="suggest",x[x.suggestFontSize=116]="suggestFontSize",x[x.suggestLineHeight=117]="suggestLineHeight",x[x.suggestOnTriggerCharacters=118]="suggestOnTriggerCharacters",x[x.suggestSelection=119]="suggestSelection",x[x.tabCompletion=120]="tabCompletion",x[x.tabIndex=121]="tabIndex",x[x.unicodeHighlighting=122]="unicodeHighlighting",x[x.unusualLineTerminators=123]="unusualLineTerminators",x[x.useShadowDOM=124]="useShadowDOM",x[x.useTabStops=125]="useTabStops",x[x.wordBreak=126]="wordBreak",x[x.wordSeparators=127]="wordSeparators",x[x.wordWrap=128]="wordWrap",x[x.wordWrapBreakAfterCharacters=129]="wordWrapBreakAfterCharacters",x[x.wordWrapBreakBeforeCharacters=130]="wordWrapBreakBeforeCharacters",x[x.wordWrapColumn=131]="wordWrapColumn",x[x.wordWrapOverride1=132]="wordWrapOverride1",x[x.wordWrapOverride2=133]="wordWrapOverride2",x[x.wrappingIndent=134]="wrappingIndent",x[x.wrappingStrategy=135]="wrappingStrategy",x[x.showDeprecated=136]="showDeprecated",x[x.inlayHints=137]="inlayHints",x[x.editorClassName=138]="editorClassName",x[x.pixelRatio=139]="pixelRatio",x[x.tabFocusMode=140]="tabFocusMode",x[x.layoutInfo=141]="layoutInfo",x[x.wrappingInfo=142]="wrappingInfo",x[x.defaultColorDecorators=143]="defaultColorDecorators",x[x.colorDecoratorsActivatedOn=144]="colorDecoratorsActivatedOn"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(194,null)})),acceptSuggestionOnEnter:Oe(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(195,null),""],markdownDescription:f.localize(196,null)})),accessibilitySupport:Oe(new I),accessibilityPageSize:Oe(new w(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(197,null),tags:["accessibility"]})),ariaLabel:Oe(new i(4,"ariaLabel",f.localize(198,null))),screenReaderAnnounceInlineSuggestion:Oe(new r(6,"screenReaderAnnounceInlineSuggestion",!0,{description:f.localize(199,null),tags:["accessibility"]})),autoClosingBrackets:Oe(new n(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(200,null),f.localize(201,null),""],description:f.localize(202,null)})),autoClosingDelete:Oe(new n(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(203,null),""],description:f.localize(204,null)})),autoClosingOvertype:Oe(new n(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(205,null),""],description:f.localize(206,null)})),autoClosingQuotes:Oe(new n(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(207,null),f.localize(208,null),""],description:f.localize(209,null)})),autoIndent:Oe(new s(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],p,{enumDescriptions:[f.localize(210,null),f.localize(211,null),f.localize(212,null),f.localize(213,null),f.localize(214,null)],description:f.localize(215,null)})),automaticLayout:Oe(new r(11,"automaticLayout",!1)),autoSurround:Oe(new n(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(216,null),f.localize(217,null),f.localize(218,null),""],description:f.localize(219,null)})),bracketPairColorization:Oe(new de),bracketPairGuides:Oe(new ie),stickyTabStops:Oe(new r(113,"stickyTabStops",!1,{description:f.localize(220,null)})),codeLens:Oe(new r(15,"codeLens",!0,{description:f.localize(221,null)})),codeLensFontFamily:Oe(new i(16,"codeLensFontFamily","",{description:f.localize(222,null)})),codeLensFontSize:Oe(new w(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(223,null)})),colorDecorators:Oe(new r(18,"colorDecorators",!0,{description:f.localize(224,null)})),colorDecoratorActivatedOn:Oe(new n(144,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[f.localize(225,null),f.localize(226,null),f.localize(227,null)],description:f.localize(228,null)})),colorDecoratorsLimit:Oe(new w(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:f.localize(229,null)})),columnSelection:Oe(new r(20,"columnSelection",!1,{description:f.localize(230,null)})),comments:Oe(new d),contextmenu:Oe(new r(22,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new r(23,"copyWithSyntaxHighlighting",!0,{description:f.localize(231,null)})),cursorBlinking:Oe(new s(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],E,{description:f.localize(232,null)})),cursorSmoothCaretAnimation:Oe(new n(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[f.localize(233,null),f.localize(234,null),f.localize(235,null)],description:f.localize(236,null)})),cursorStyle:Oe(new s(26,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:f.localize(237,null)})),cursorSurroundingLines:Oe(new w(27,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(238,null)})),cursorSurroundingLinesStyle:Oe(new n(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(239,null),f.localize(240,null)],description:f.localize(241,null)})),cursorWidth:Oe(new w(29,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(242,null)})),disableLayerHinting:Oe(new r(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new r(31,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new r(32,"domReadOnly",!1)),dragAndDrop:Oe(new r(33,"dragAndDrop",!0,{description:f.localize(243,null)})),emptySelectionClipboard:Oe(new G),dropIntoEditor:Oe(new Qe),stickyScroll:Oe(new ke),experimentalWhitespaceRendering:Oe(new n(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[f.localize(244,null),f.localize(245,null),f.localize(246,null)],description:f.localize(247,null)})),extraEditorClassName:Oe(new i(37,"extraEditorClassName","")),fastScrollSensitivity:Oe(new y(38,"fastScrollSensitivity",5,x=>x<=0?5:x,{markdownDescription:f.localize(248,null)})),find:Oe(new q),fixedOverflowWidgets:Oe(new r(40,"fixedOverflowWidgets",!1)),folding:Oe(new r(41,"folding",!0,{description:f.localize(249,null)})),foldingStrategy:Oe(new n(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(250,null),f.localize(251,null)],description:f.localize(252,null)})),foldingHighlight:Oe(new r(43,"foldingHighlight",!0,{description:f.localize(253,null)})),foldingImportsByDefault:Oe(new r(44,"foldingImportsByDefault",!1,{description:f.localize(254,null)})),foldingMaximumRegions:Oe(new w(45,"foldingMaximumRegions",5e3,10,65e3,{description:f.localize(255,null)})),unfoldOnClickAfterEndOfLine:Oe(new r(46,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(256,null)})),fontFamily:Oe(new i(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(257,null)})),fontInfo:Oe(new H),fontLigatures2:Oe(new W),fontSize:Oe(new j),fontWeight:Oe(new O),fontVariations:Oe(new N),formatOnPaste:Oe(new r(53,"formatOnPaste",!1,{description:f.localize(258,null)})),formatOnType:Oe(new r(54,"formatOnType",!1,{description:f.localize(259,null)})),glyphMargin:Oe(new r(55,"glyphMargin",!0,{description:f.localize(260,null)})),gotoLocation:Oe(new ue),hideCursorInOverviewRuler:Oe(new r(57,"hideCursorInOverviewRuler",!1,{description:f.localize(261,null)})),hover:Oe(new pe),inDiffEditor:Oe(new r(59,"inDiffEditor",!1)),letterSpacing:Oe(new y(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,x=>y.clamp(x,-5,20),{description:f.localize(262,null)})),lightbulb:Oe(new ce),lineDecorationsWidth:Oe(new me),lineHeight:Oe(new R),lineNumbers:Oe(new le),lineNumbersMinChars:Oe(new w(66,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new r(67,"linkedEditing",!1,{description:f.localize(263,null)})),links:Oe(new r(68,"links",!0,{description:f.localize(264,null)})),matchBrackets:Oe(new n(69,"matchBrackets","always",["always","near","never"],{description:f.localize(265,null)})),minimap:Oe(new Q),mouseStyle:Oe(new n(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new y(72,"mouseWheelScrollSensitivity",1,x=>x===0?1:x,{markdownDescription:f.localize(266,null)})),mouseWheelZoom:Oe(new r(73,"mouseWheelZoom",!1,{markdownDescription:f.localize(267,null)})),multiCursorMergeOverlapping:Oe(new r(74,"multiCursorMergeOverlapping",!0,{description:f.localize(268,null)})),multiCursorModifier:Oe(new s(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[f.localize(269,null),f.localize(270,null)],markdownDescription:f.localize(271,null)})),multiCursorPaste:Oe(new n(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(272,null),f.localize(273,null)],markdownDescription:f.localize(274,null)})),multiCursorLimit:Oe(new w(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:f.localize(275,null)})),occurrencesHighlight:Oe(new r(78,"occurrencesHighlight",!0,{description:f.localize(276,null)})),overviewRulerBorder:Oe(new r(79,"overviewRulerBorder",!0,{description:f.localize(277,null)})),overviewRulerLanes:Oe(new w(80,"overviewRulerLanes",3,0,3)),padding:Oe(new De),pasteAs:Oe(new it),parameterHints:Oe(new ye),peekWidgetDefaultFocus:Oe(new n(84,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(278,null),f.localize(279,null)],description:f.localize(280,null)})),definitionLinkOpensInPeek:Oe(new r(85,"definitionLinkOpensInPeek",!1,{description:f.localize(281,null)})),quickSuggestions:Oe(new Se),quickSuggestionsDelay:Oe(new w(87,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(282,null)})),readOnly:Oe(new r(88,"readOnly",!1)),readOnlyMessage:Oe(new P),renameOnType:Oe(new r(90,"renameOnType",!1,{description:f.localize(283,null),markdownDeprecationMessage:f.localize(284,null)})),renderControlCharacters:Oe(new r(91,"renderControlCharacters",!0,{description:f.localize(285,null),restricted:!0})),renderFinalNewline:Oe(new n(92,"renderFinalNewline",S.$k?"dimmed":"on",["off","on","dimmed"],{description:f.localize(286,null)})),renderLineHighlight:Oe(new n(93,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(287,null)],description:f.localize(288,null)})),renderLineHighlightOnlyWhenFocus:Oe(new r(94,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(289,null)})),renderValidationDecorations:Oe(new n(95,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new n(96,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(290,null),f.localize(291,null),f.localize(292,null),""],description:f.localize(293,null)})),revealHorizontalRightPadding:Oe(new w(97,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Oe(new r(98,"roundedSelection",!0,{description:f.localize(294,null)})),rulers:Oe(new ee),scrollbar:Oe(new V),scrollBeyondLastColumn:Oe(new w(101,"scrollBeyondLastColumn",4,0,1073741824,{description:f.localize(295,null)})),scrollBeyondLastLine:Oe(new r(102,"scrollBeyondLastLine",!0,{description:f.localize(296,null)})),scrollPredominantAxis:Oe(new r(103,"scrollPredominantAxis",!0,{description:f.localize(297,null)})),selectionClipboard:Oe(new r(104,"selectionClipboard",!0,{description:f.localize(298,null),included:S.$k})),selectionHighlight:Oe(new r(105,"selectionHighlight",!0,{description:f.localize(299,null)})),selectOnLineNumbers:Oe(new r(106,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new n(107,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[f.localize(300,null),f.localize(301,null),f.localize(302,null)],description:f.localize(303,null)})),showUnused:Oe(new r(108,"showUnused",!0,{description:f.localize(304,null)})),showDeprecated:Oe(new r(136,"showDeprecated",!0,{description:f.localize(305,null)})),inlayHints:Oe(new Ce),snippetSuggestions:Oe(new n(109,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(306,null),f.localize(307,null),f.localize(308,null),f.localize(309,null)],description:f.localize(310,null)})),smartSelect:Oe(new Be),smoothScrolling:Oe(new r(111,"smoothScrolling",!1,{description:f.localize(311,null)})),stopRenderingLineAfter:Oe(new w(114,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new Ee),inlineSuggest:Oe(new re),suggestFontSize:Oe(new w(116,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(312,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new w(117,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(313,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new r(118,"suggestOnTriggerCharacters",!0,{description:f.localize(314,null)})),suggestSelection:Oe(new n(119,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(315,null),f.localize(316,null),f.localize(317,null)],description:f.localize(318,null)})),tabCompletion:Oe(new n(120,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(319,null),f.localize(320,null),f.localize(321,null)],description:f.localize(322,null)})),tabIndex:Oe(new w(121,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new J),unusualLineTerminators:Oe(new n(123,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(323,null),f.localize(324,null),f.localize(325,null)],description:f.localize(326,null)})),useShadowDOM:Oe(new r(124,"useShadowDOM",!0)),useTabStops:Oe(new r(125,"useTabStops",!0,{description:f.localize(327,null)})),wordBreak:Oe(new n(126,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[f.localize(328,null),f.localize(329,null)],description:f.localize(330,null)})),wordSeparators:Oe(new i(127,"wordSeparators",T.$Er,{description:f.localize(331,null)})),wordWrap:Oe(new n(128,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(332,null),f.localize(333,null),f.localize(334,null),f.localize(335,null)],description:f.localize(336,null)})),wordWrapBreakAfterCharacters:Oe(new i(129,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new i(130,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new w(131,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(337,null)})),wordWrapOverride1:Oe(new n(132,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new n(133,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Oe(new B),defaultColorDecorators:Oe(new r(143,"defaultColorDecorators",!1,{markdownDescription:f.localize(338,null)})),pixelRatio:Oe(new $e),tabFocusMode:Oe(new r(140,"tabFocusMode",!1,{markdownDescription:f.localize(339,null)})),layoutInfo:Oe(new _),wrappingInfo:Oe(new He),wrappingIndent:Oe(new _e),wrappingStrategy:Oe(new Y)}}),define(Re[137],Fe([11,12]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[138],Fe([11,12]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[139],Fe([11,12]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(Re[140],Fe([11,12]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[141],Fe([11,12]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[142],Fe([11,12]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Re[143],Fe([11,12]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Re[144],Fe([11,12]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[145],Fe([11,12]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Re[146],Fe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostChat",e)}),define(Re[147],Fe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[148],Fe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[149],Fe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[150],Fe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[151],Fe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Re[152],Fe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[153],Fe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[154],Fe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[155],Fe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[156],Fe([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[157],Fe([11,12]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Re[158],Fe([11,12]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Re[159],Fe([11,12]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[160],Fe([11,12]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[161],Fe([11,12]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[162],Fe([11,12]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[163],Fe([11,12]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[164],Fe([11,12]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[165],Fe([11,12]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[166],Fe([1,0,9,139]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.TokenType=void 0;var S;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(S||(e.TokenType=S={}));function z(...m){switch(m.length){case 1:return(0,C.localize)(0,null,m[0]);case 2:return(0,C.localize)(1,null,m[0],m[1]);case 3:return(0,C.localize)(2,null,m[0],m[1],m[2]);default:return}}const T=(0,C.localize)(3,null),f=(0,C.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(F){switch(F.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return F.isTripleEq?"===":"==";case 4:return F.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return F.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return F.lexeme;case 18:return F.lexeme;case 19:return F.lexeme;case 20:return"EOF";default:throw(0,g.$5)(`unhandled token type: ${JSON.stringify(F)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(F){return this.c=F,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(z("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(z("&&"));break;case 124:this.h(124)?this.k(16):this.l(z("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(F){return this.r()||this.c.charCodeAt(this.e)!==F?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(F){this.f.push({type:F,offset:this.d})}l(F){const D=this.d,h=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:h};this.g.push({offset:D,lexeme:h,additionalInfo:F}),this.f.push(b)}n(){this.m.lastIndex=this.d;const F=this.m.exec(this.c);if(F){this.e=this.d+F[0].length;const D=this.c.substring(this.d,this.e),h=k.b.get(D);h?this.k(h):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let F=this.e,D=!1,h=!1;for(;;){if(F>=this.c.length){this.e=F,this.l(f);return}const $=this.c.charCodeAt(F);if(D)D=!1;else if($===47&&!h){F++;break}else $===91?h=!0:$===92?D=!0:$===93&&(h=!1);F++}for(;F<this.c.length&&k.a.has(this.c.charCodeAt(F));)F++;this.e=F;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$oi=k,k.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0))),k.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Re[167],Fe([1,0,20,29,141,270]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,f=/^-(\d{4})(\d{2})(\d{2})$/;function k(r){return r=r.trim(),r==="*"||T.test(r)}e.$no=k;function m(r){if(!k(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=r.match(T);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$oo=m;function F(r){if(!r)return null;const c=r.majorBase,w=r.majorMustEqual,v=r.minorBase;let y=r.minorMustEqual;const i=r.patchBase;let l=r.patchMustEqual;r.hasCaret&&(c===0||(y=!1),l=!1);let n=0;if(r.preRelease){const s=f.exec(r.preRelease);if(s){const[,p,I,d]=s;n=Date.UTC(Number(p),Number(I)-1,Number(d))}}return{majorBase:c,majorMustEqual:w,minorBase:v,minorMustEqual:y,patchBase:i,patchMustEqual:l,isMinimum:r.hasGreaterEquals,notBefore:n}}e.$po=F;function D(r,c,w){let v;typeof r=="string"?v=F(m(r)):v=r;let y;c instanceof Date?y=c.getTime():typeof c=="string"&&(y=new Date(c).getTime());let i;if(typeof w=="string"?i=F(m(w)):i=w,!v||!i)return!1;const l=v.majorBase,n=v.minorBase,s=v.patchBase;let p=i.majorBase,I=i.minorBase,d=i.patchBase;const A=i.notBefore;let E=i.majorMustEqual,a=i.minorMustEqual,o=i.patchMustEqual;return i.isMinimum?l>p?!0:l<p?!1:n>I?!0:n<I||y&&y<A?!1:s>=d:(l===1&&p===0&&(!E||!a||!o)&&(p=1,I=0,d=0,E=!0,a=!1,o=!1),l<p?!1:l>p?!E:n<I?!1:n>I?!a:s<d?!1:s>d?!o:!(y&&y<A))}e.$qo=D;function h(r,c,w,v,y){const i=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return i.push([C.default.Error,S.localize(0,null)]),i;if(typeof v.name!="string")return i.push([C.default.Error,S.localize(1,null,"name")]),i;if(typeof v.version!="string")return i.push([C.default.Error,S.localize(2,null,"version")]),i;if(!v.engines)return i.push([C.default.Error,S.localize(3,null,"engines")]),i;if(typeof v.engines.vscode!="string")return i.push([C.default.Error,S.localize(4,null,"engines.vscode")]),i;if(typeof v.extensionDependencies<"u"&&!t(v.extensionDependencies))return i.push([C.default.Error,S.localize(5,null,"extensionDependencies")]),i;if(typeof v.activationEvents<"u"){if(!t(v.activationEvents))return i.push([C.default.Error,S.localize(6,null,"activationEvents")]),i;if(typeof v.main>"u"&&typeof v.browser>"u")return i.push([C.default.Error,S.localize(7,null,"activationEvents","main","browser")]),i}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&i.push([C.default.Warning,S.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return i.push([C.default.Error,S.localize(9,null,"main")]),i;{const s=(0,g.$6f)(w,v.main);(0,g.$Zf)(s,w)||i.push([C.default.Warning,S.localize(10,null,s.path,w.path)])}}if(typeof v.browser<"u"){if(typeof v.browser!="string")return i.push([C.default.Error,S.localize(11,null,"browser")]),i;{const s=(0,g.$6f)(w,v.browser);(0,g.$Zf)(s,w)||i.push([C.default.Warning,S.localize(12,null,s.path,w.path)])}}if(!z.valid(v.version))return i.push([C.default.Error,S.localize(13,null)]),i;const l=[];if(!b(r,c,v,y,l))for(const s of l)i.push([C.default.Error,s]);return i}e.$ro=h;function b(r,c,w,v,y){return v||typeof w.main>"u"&&typeof w.browser>"u"?!0:u(r,c,w.engines.vscode,y)}e.$so=b;function $(r,c,w){return r==="*"||u(c,w,r)}e.$to=$;function u(r,c,w,v=[]){const y=F(m(w));if(!y)return v.push(S.localize(14,null,w)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return v.push(S.localize(15,null,w)),!1}else if(!y.majorMustEqual)return v.push(S.localize(16,null,w)),!1;return D(r,c,y)?!0:(v.push(S.localize(17,null,r,w)),!1)}function t(r){if(!Array.isArray(r))return!1;for(let c=0,w=r.length;c<w;c++)if(typeof r[c]!="string")return!1;return!0}}),define(Re[71],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=void 0;class g{constructor(S,z=[],T=!1){this.ctor=S,this.staticArguments=z,this.supportsDelayedInstantiation=T}}e.$ih=g}),define(Re[72],Fe([1,0,71]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.InstantiationType=void 0;const C=[];var S;(function(f){f[f.Eager=0]="Eager",f[f.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function z(f,k,m){k instanceof g.$ih||(k=new g.$ih(k,[],!!m)),C.push([f,k])}e.$8q=z;function T(){return C}e.$9q=T}),define(Re[168],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=void 0;class g{constructor(z,T){this.key=z,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$Op=g;class C{constructor(z){this.b=z,this.a=new Map}roots(){const z=[];for(const T of this.a.values())T.outgoing.size===0&&z.push(T);return z}insertEdge(z,T){const f=this.lookupOrInsertNode(z),k=this.lookupOrInsertNode(T);f.outgoing.set(k.key,k),k.incoming.set(f.key,f)}removeNode(z){const T=this.b(z);this.a.delete(T);for(const f of this.a.values())f.outgoing.delete(T),f.incoming.delete(T)}lookupOrInsertNode(z){const T=this.b(z);let f=this.a.get(T);return f||(f=new g(T,z),this.a.set(T,f)),f}lookup(z){return this.a.get(this.b(z))}isEmpty(){return this.a.size===0}toString(){const z=[];for(const[T,f]of this.a)z.push(`${T}
	(-> incoming)[${[...f.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...f.outgoing.keys()].join(",")}]
`);return z.join(`
`)}findCycleSlow(){for(const[z,T]of this.a){const f=new Set([z]),k=this.c(T,f);if(k)return k}}c(z,T){for(const[f,k]of z.outgoing){if(T.has(f))return[...T,f].join(" -> ");T.add(f);const m=this.c(k,T);if(m)return m;T.delete(f)}}}e.$Pp=C}),define(Re[3],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e._util=void 0;var g;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function f(k){return k[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=f})(g||(e._util=g={})),e.$kh=S("instantiationService");function C(T,f,k){f[g.DI_TARGET]===f?f[g.DI_DEPENDENCIES].push({id:T,index:k}):(f[g.DI_DEPENDENCIES]=[{id:T,index:k}],f[g.DI_TARGET]=f)}function S(T){if(g.serviceIds.has(T))return g.serviceIds.get(T);const f=function(k,m,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(f,k,F)};return f.toString=()=>T,g.serviceIds.set(T,f),f}e.$lh=S;function z(T){return T}e.$mh=z}),define(Re[43],Fe([1,0,10,2,3]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.ConfigurationTarget=e.$Th=e.$Sh=e.$Rh=void 0,e.$Rh=(0,S.$lh)("configurationService");function z(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof C.URI)}e.$Sh=z;function T(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof C.URI)}e.$Th=T;var f;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(f||(e.ConfigurationTarget=f={}));function k(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Uh=k;function m(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}e.$Vh=m;function F(r,c){const w=Object.create(null);for(const v in r)D(w,v,r[v],c);return w}e.$Wh=F;function D(r,c,w,v){const y=c.split("."),i=y.pop();let l=r;for(let n=0;n<y.length;n++){const s=y[n];let p=l[s];switch(typeof p){case"undefined":p=l[s]=Object.create(null);break;case"object":break;default:v(`Ignoring ${c} as ${y.slice(0,n+1).join(".")} is ${JSON.stringify(p)}`);return}l=p}if(typeof l=="object"&&l!==null)try{l[i]=w}catch{v(`Ignoring ${c} as ${y.join(".")} is ${JSON.stringify(l)}`)}else v(`Ignoring ${c} as ${y.join(".")} is ${JSON.stringify(l)}`)}e.$Xh=D;function h(r,c){const w=c.split(".");b(r,w)}e.$Yh=h;function b(r,c){const w=c.shift();if(c.length===0){delete r[w];return}if(Object.keys(r).indexOf(w)!==-1){const v=r[w];typeof v=="object"&&!Array.isArray(v)&&(b(v,c),Object.keys(v).length===0&&delete r[w])}}function $(r,c,w){function v(l,n){let s=l;for(const p of n){if(typeof s!="object"||s===null)return;s=s[p]}return s}const y=c.split("."),i=v(r,y);return typeof i>"u"?w:i}e.$Zh=$;function u(r,c,w){Object.keys(c).forEach(v=>{v!=="__proto__"&&(v in r?g.$ie(r[v])&&g.$ie(c[v])?u(r[v],c[v],w):w&&(r[v]=c[v]):r[v]=c[v])})}e.$1h=u;function t(r){return r.replace(/[\[\]]/g,"")}e.$2h=t}),define(Re[31],Fe([1,0,21,13,166,3,138,9]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.ContextKeyExprType=e.$pi=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",g.$j),k.set("isLinux",g.$k),k.set("isWindows",g.$i),k.set("isWeb",g.$o),k.set("isMacNative",g.$j&&!g.$o),k.set("isEdge",g.$G),k.set("isFirefox",g.$E),k.set("isChrome",g.$D),k.set("isSafari",g.$F);function m(me,R){if(k.get(me)!==void 0)throw(0,f.$4)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(me,R)}e.$pi=m;const F=Object.prototype.hasOwnProperty;var D;(function(me){me[me.False=0]="False",me[me.True=1]="True",me[me.Defined=2]="Defined",me[me.Not=3]="Not",me[me.Equals=4]="Equals",me[me.NotEquals=5]="NotEquals",me[me.And=6]="And",me[me.Regex=7]="Regex",me[me.NotRegex=8]="NotRegex",me[me.Or=9]="Or",me[me.In=10]="In",me[me.NotIn=11]="NotIn",me[me.Greater=12]="Greater",me[me.GreaterEquals=13]="GreaterEquals",me[me.Smaller=14]="Smaller",me[me.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const h={regexParsingWithErrorRecovery:!0},b=(0,T.localize)(0,null),$=(0,T.localize)(1,null),u=(0,T.localize)(2,null),t=(0,T.localize)(3,null),r=(0,T.localize)(4,null),c=(0,T.localize)(5,null),w=(0,T.localize)(6,null),v=(0,T.localize)(7,null);class y{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(R=h){this.k=R,this.d=new S.$oi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(R){if(R===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(R).scan(),this.g=0,this.h=[];try{const Q=this.l();if(!this.E()){const he=this.D(),De=he.type===17?c:void 0;throw this.h.push({message:r,offset:he.offset,lexeme:S.$oi.getLexeme(he),additionalInfo:De}),y.c}return Q}catch(Q){if(Q!==y.c)throw Q;return}}l(){return this.m()}m(){const R=[this.o()];for(;this.y(16);){const Q=this.o();R.push(Q)}return R.length===1?R[0]:i.or(...R)}o(){const R=[this.s()];for(;this.y(15);){const Q=this.s();R.push(Q)}return R.length===1?R[0]:i.and(...R)}s(){if(this.y(2)){const R=this.D();switch(R.type){case 11:return this.z(),p.INSTANCE;case 12:return this.z(),I.INSTANCE;case 0:{this.z();const Q=this.l();return this.A(1,t),Q?.negate()}case 17:return this.z(),L.create(R.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",R)}}return this.t()}t(){const R=this.D();switch(R.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const Q=this.l();return this.A(1,t),Q}case 17:{const Q=R.lexeme;if(this.z(),this.y(9)){const De=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),De.type!==10)throw this.B("REGEX",De);const ye=De.lexeme,$e=ye.lastIndexOf("/"),Se=$e===ye.length-1?void 0:this.w(ye.substring($e+1));let ae;try{ae=new RegExp(ye.substring(1,$e),Se)}catch{throw this.B("REGEX",De)}return H.create(Q,ae)}switch(De.type){case 10:case 19:{const ye=[De.lexeme];this.z();let $e=this.D(),Se=0;for(let P=0;P<De.lexeme.length;P++)De.lexeme.charCodeAt(P)===40?Se++:De.lexeme.charCodeAt(P)===41&&Se--;for(;!this.E()&&$e.type!==15&&$e.type!==16;){switch($e.type){case 0:Se++;break;case 1:Se--;break;case 10:case 18:for(let P=0;P<$e.lexeme.length;P++)$e.lexeme.charCodeAt(P)===40?Se++:De.lexeme.charCodeAt(P)===41&&Se--}if(Se<0)break;ye.push(S.$oi.getLexeme($e)),this.z(),$e=this.D()}const ae=ye.join(""),le=ae.lastIndexOf("/"),ne=le===ae.length-1?void 0:this.w(ae.substring(le+1));let ee;try{ee=new RegExp(ae.substring(1,le),ne)}catch{throw this.B("REGEX",De)}return i.regex(Q,ee)}case 18:{const ye=De.lexeme;this.z();let $e=null;if(!(0,C.$hd)(ye)){const Se=ye.indexOf("/"),ae=ye.lastIndexOf("/");if(Se!==ae&&Se>=0){const le=ye.slice(Se+1,ae),ne=ye[ae+1]==="i"?"i":"";try{$e=new RegExp(le,ne)}catch{throw this.B("REGEX",De)}}}if($e===null)throw this.B("REGEX",De);return H.create(Q,$e)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,u);const De=this.u();return i.notIn(Q,De)}switch(this.D().type){case 3:{this.z();const De=this.u();if(this.x().type===18)return i.equals(Q,De);switch(De){case"true":return i.has(Q);case"false":return i.not(Q);default:return i.equals(Q,De)}}case 4:{this.z();const De=this.u();if(this.x().type===18)return i.notEquals(Q,De);switch(De){case"true":return i.not(Q);case"false":return i.has(Q);default:return i.notEquals(Q,De)}}case 5:return this.z(),W.create(Q,this.u());case 6:return this.z(),N.create(Q,this.u());case 7:return this.z(),G.create(Q,this.u());case 8:return this.z(),q.create(Q,this.u());case 13:return this.z(),i.in(Q,this.u());default:return i.has(Q)}}case 20:throw this.h.push({message:w,offset:R.offset,lexeme:"",additionalInfo:v}),y.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const R=this.D();switch(R.type){case 17:case 18:return this.z(),R.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(R){return R.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(R){return this.C(R)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(R,Q){if(this.C(R))return this.z();throw this.B(Q,this.D())}B(R,Q,he){const De=(0,T.localize)(8,null,R,S.$oi.getLexeme(Q)),ye=Q.offset,$e=S.$oi.getLexeme(Q);return this.h.push({message:De,offset:ye,lexeme:$e,additionalInfo:he}),y.c}C(R){return this.D().type===R}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$qi=y,y.c=new Error;class i{static false(){return p.INSTANCE}static true(){return I.INSTANCE}static has(R){return d.create(R)}static equals(R,Q){return A.create(R,Q)}static notEquals(R,Q){return o.create(R,Q)}static regex(R,Q){return H.create(R,Q)}static in(R,Q){return E.create(R,Q)}static notIn(R,Q){return a.create(R,Q)}static not(R){return L.create(R)}static and(...R){return ue.create(R,null,!0)}static or(...R){return pe.create(R,null,!0)}static greater(R,Q){return G.create(R,Q)}static greaterEquals(R,Q){return q.create(R,Q)}static smaller(R,Q){return W.create(R,Q)}static smallerEquals(R,Q){return N.create(R,Q)}static deserialize(R){return R==null?void 0:this.c.parse(R)}}e.$ri=i,i.c=new y({regexParsingWithErrorRecovery:!1});function l(me){const R=new y({regexParsingWithErrorRecovery:!1});return me.map(Q=>(R.parse(Q),R.lexingErrors.length>0?R.lexingErrors.map(he=>({errorMessage:he.additionalInfo?(0,T.localize)(9,null,he.additionalInfo):(0,T.localize)(10,null),offset:he.offset,length:he.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(he=>({errorMessage:he.additionalInfo?`${he.message}. ${he.additionalInfo}`:he.message,offset:he.offset,length:he.lexeme.length})):[]))}e.$si=l;function n(me,R){const Q=me?me.substituteConstants():void 0,he=R?R.substituteConstants():void 0;return!Q&&!he?!0:!Q||!he?!1:Q.equals(he)}e.$ti=n;function s(me,R){return me.cmp(R)}class p{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return I.INSTANCE}}e.$ui=p,p.INSTANCE=new p;class I{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return p.INSTANCE}}e.$vi=I,I.INSTANCE=new I;class d{static create(R,Q=null){const he=k.get(R);return typeof he=="boolean"?he?I.INSTANCE:p.INSTANCE:new d(R,Q)}constructor(R,Q){this.key=R,this.c=Q,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=k.get(this.key);return typeof R=="boolean"?R?I.INSTANCE:p.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$wi=d;class A{static create(R,Q,he=null){if(typeof Q=="boolean")return Q?d.create(R,he):L.create(R,he);const De=k.get(R);return typeof De=="boolean"?Q===(De?"true":"false")?I.INSTANCE:p.INSTANCE:new A(R,Q,he)}constructor(R,Q,he){this.c=R,this.d=Q,this.f=he,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:Y(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=k.get(this.c);if(typeof R=="boolean"){const Q=R?"true":"false";return this.d===Q?I.INSTANCE:p.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.$xi=A;class E{static create(R,Q){return new E(R,Q)}constructor(R,Q){this.d=R,this.f=Q,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:Y(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const Q=R.getValue(this.f),he=R.getValue(this.d);return Array.isArray(Q)?Q.includes(he):typeof he=="string"&&typeof Q=="object"&&Q!==null?F.call(Q,he):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=a.create(this.d,this.f)),this.c}}e.$yi=E;class a{static create(R,Q){return new a(R,Q)}constructor(R,Q){this.d=R,this.f=Q,this.type=11,this.c=E.create(R,Q)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$zi=a;class o{static create(R,Q,he=null){if(typeof Q=="boolean")return Q?L.create(R,he):d.create(R,he);const De=k.get(R);return typeof De=="boolean"?Q===(De?"true":"false")?p.INSTANCE:I.INSTANCE:new o(R,Q,he)}constructor(R,Q,he){this.c=R,this.d=Q,this.f=he,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:Y(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=k.get(this.c);if(typeof R=="boolean"){const Q=R?"true":"false";return this.d===Q?p.INSTANCE:I.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Ai=o;class L{static create(R,Q=null){const he=k.get(R);return typeof he=="boolean"?he?p.INSTANCE:I.INSTANCE:new L(R,Q)}constructor(R,Q){this.c=R,this.d=Q,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:_(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=k.get(this.c);return typeof R=="boolean"?R?p.INSTANCE:I.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=d.create(this.c,this)),this.d}}e.$Bi=L;function B(me,R){if(typeof me=="string"){const Q=parseFloat(me);isNaN(Q)||(me=Q)}return typeof me=="string"||typeof me=="number"?R(me):p.INSTANCE}class G{static create(R,Q,he=null){return B(Q,De=>new G(R,De,he))}constructor(R,Q,he){this.c=R,this.d=Q,this.f=he,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:Y(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Ci=G;class q{static create(R,Q,he=null){return B(Q,De=>new q(R,De,he))}constructor(R,Q,he){this.c=R,this.d=Q,this.f=he,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:Y(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Di=q;class W{static create(R,Q,he=null){return B(Q,De=>new W(R,De,he))}constructor(R,Q,he){this.c=R,this.d=Q,this.f=he,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:Y(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Ei=W;class N{static create(R,Q,he=null){return B(Q,De=>new N(R,De,he))}constructor(R,Q,he){this.c=R,this.d=Q,this.f=he,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:Y(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Fi=N;class H{static create(R,Q){return new H(R,Q)}constructor(R,Q){this.d=R,this.f=Q,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const Q=this.f?this.f.source:"",he=R.f?R.f.source:"";return Q<he?-1:Q>he?1:0}equals(R){if(R.type===this.type){const Q=this.f?this.f.source:"",he=R.f?R.f.source:"";return this.d===R.d&&Q===he}return!1}substituteConstants(){return this}evaluate(R){const Q=R.getValue(this.d);return this.f?this.f.test(Q):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=j.create(this)),this.c}}e.$Gi=H;class j{static create(R){return new j(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(R){return new j(this.c.map(R))}negate(){return this.c}}e.$Hi=j;function O(me){let R=null;for(let Q=0,he=me.length;Q<he;Q++){const De=me[Q].substituteConstants();if(me[Q]!==De&&R===null){R=[];for(let ye=0;ye<Q;ye++)R[ye]=me[ye]}R!==null&&(R[Q]=De)}return R===null?me:R}class ue{static create(R,Q,he){return ue.d(R,Q,he)}constructor(R,Q){this.expr=R,this.c=Q,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let Q=0,he=this.expr.length;Q<he;Q++){const De=s(this.expr[Q],R.expr[Q]);if(De!==0)return De}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let Q=0,he=this.expr.length;Q<he;Q++)if(!this.expr[Q].equals(R.expr[Q]))return!1;return!0}return!1}substituteConstants(){const R=O(this.expr);return R===this.expr?this:ue.create(R,this.c,!1)}evaluate(R){for(let Q=0,he=this.expr.length;Q<he;Q++)if(!this.expr[Q].evaluate(R))return!1;return!0}static d(R,Q,he){const De=[];let ye=!1;for(const $e of R)if($e){if($e.type===1){ye=!0;continue}if($e.type===0)return p.INSTANCE;if($e.type===6){De.push(...$e.expr);continue}De.push($e)}if(De.length===0&&ye)return I.INSTANCE;if(De.length!==0){if(De.length===1)return De[0];De.sort(s);for(let $e=1;$e<De.length;$e++)De[$e-1].equals(De[$e])&&(De.splice($e,1),$e--);if(De.length===1)return De[0];for(;De.length>1;){const $e=De[De.length-1];if($e.type!==9)break;De.pop();const Se=De.pop(),ae=De.length===0,le=pe.create($e.expr.map(ne=>ue.create([ne,Se],null,he)),null,ae);le&&(De.push(le),De.sort(s))}if(De.length===1)return De[0];if(he){for(let $e=0;$e<De.length;$e++)for(let Se=$e+1;Se<De.length;Se++)if(De[$e].negate().equals(De[Se]))return p.INSTANCE;if(De.length===1)return De[0]}return new ue(De,Q)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const Q of this.expr)R.push(...Q.keys());return R}map(R){return new ue(this.expr.map(Q=>Q.map(R)),null)}negate(){if(!this.c){const R=[];for(const Q of this.expr)R.push(Q.negate());this.c=pe.create(R,this,!0)}return this.c}}e.$Ii=ue;class pe{static create(R,Q,he){return pe.d(R,Q,he)}constructor(R,Q){this.expr=R,this.c=Q,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let Q=0,he=this.expr.length;Q<he;Q++){const De=s(this.expr[Q],R.expr[Q]);if(De!==0)return De}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let Q=0,he=this.expr.length;Q<he;Q++)if(!this.expr[Q].equals(R.expr[Q]))return!1;return!0}return!1}substituteConstants(){const R=O(this.expr);return R===this.expr?this:pe.create(R,this.c,!1)}evaluate(R){for(let Q=0,he=this.expr.length;Q<he;Q++)if(this.expr[Q].evaluate(R))return!0;return!1}static d(R,Q,he){let De=[],ye=!1;if(R){for(let $e=0,Se=R.length;$e<Se;$e++){const ae=R[$e];if(ae){if(ae.type===0){ye=!0;continue}if(ae.type===1)return I.INSTANCE;if(ae.type===9){De=De.concat(ae.expr);continue}De.push(ae)}}if(De.length===0&&ye)return p.INSTANCE;De.sort(s)}if(De.length!==0){if(De.length===1)return De[0];for(let $e=1;$e<De.length;$e++)De[$e-1].equals(De[$e])&&(De.splice($e,1),$e--);if(De.length===1)return De[0];if(he){for(let $e=0;$e<De.length;$e++)for(let Se=$e+1;Se<De.length;Se++)if(De[$e].negate().equals(De[Se]))return I.INSTANCE;if(De.length===1)return De[0]}return new pe(De,Q)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const Q of this.expr)R.push(...Q.keys());return R}map(R){return new pe(this.expr.map(Q=>Q.map(R)),null)}negate(){if(!this.c){const R=[];for(const Q of this.expr)R.push(Q.negate());for(;R.length>1;){const Q=R.shift(),he=R.shift(),De=[];for(const ye of Ce(Q))for(const $e of Ce(he))De.push(ue.create([ye,$e],null,!1));R.unshift(pe.create(De,null,!1))}this.c=pe.create(R,this,!0)}return this.c}}e.$Ji=pe;class Pe extends d{static all(){return Pe.d.values()}constructor(R,Q,he){super(R,null),this.f=Q,typeof he=="object"?Pe.d.push({...he,key:R}):he!==!0&&Pe.d.push({key:R,description:he,type:Q!=null?typeof Q:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return A.create(this.key,R)}notEqualsTo(R){return o.create(this.key,R)}}e.$Ki=Pe,Pe.d=[],e.$Li=(0,z.$lh)("contextKeyService");function _(me,R){return me<R?-1:me>R?1:0}function Y(me,R,Q,he){return me<Q?-1:me>Q?1:R<he?-1:R>he?1:0}function ce(me,R){if(me.type===0||R.type===1)return!0;if(me.type===9)return R.type===9?ke(me.expr,R.expr):!1;if(R.type===9){for(const Q of R.expr)if(ce(me,Q))return!0;return!1}if(me.type===6){if(R.type===6)return ke(R.expr,me.expr);for(const Q of me.expr)if(ce(Q,R))return!0;return!1}return me.equals(R)}e.$Mi=ce;function ke(me,R){let Q=0,he=0;for(;Q<me.length&&he<R.length;){const De=me[Q].cmp(R[he]);if(De<0)return!1;De===0&&Q++,he++}return Q===me.length}function Ce(me){return me.type===9?me.expr:[me]}}),define(Re[169],Fe([1,0,3]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=void 0,e.$sh=(0,g.$lh)("environmentService"),e.$th=(0,g.$mh)(e.$sh)}),define(Re[92],Fe([1,0,140,3]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ln=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=void 0,e.$zn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$An=new RegExp(e.$zn),e.$Bn="__web_extension",e.$Cn="skipWalkthrough",e.$Dn="extensionsSync";function S(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$En=S;function z(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Fn=z;function T(c,w){switch(c){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Gn=T;function f(c,w){return w==="web"&&!c.includes("web")}e.$Hn=f;function k(c,w,v){return f(w,v)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===v?!0:m(v).includes(c)}e.$In=k;function m(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Jn=m;function F(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$Kn=F;var D;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var h;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(h||(e.SortOrder=h={}));var b;(function(c){c.Install="install",c.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var $;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Ln=(0,C.$lh)("extensionGalleryService");var u;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(u||(e.ExtensionManagementErrorCode=u={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class r extends Error{constructor(w,v){super(w),this.code=v,this.name=v}}e.$Mn=r,e.$Nn=(0,C.$lh)("extensionManagementService"),e.$On="extensionsIdentifiers/disabled",e.$Pn="extensionsIdentifiers/enabled",e.$Qn=(0,C.$lh)("IGlobalExtensionEnablementService"),e.$Rn=(0,C.$lh)("IExtensionTipsService"),e.$Sn=(0,g.localize)(0,null),e.$Tn={value:e.$Sn,original:"Extensions"},e.$Un={value:(0,g.localize)(1,null),original:"Preferences"}}),define(Re[38],Fe([1,0,48,19,13,10,2,142,3,21,14]),function(te,e,g,C,S,z,T,f,k,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.FileKind=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.FileOperationResult=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.FileChangeType=e.$6j=e.FileOperation=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.FileSystemProviderErrorCode=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Pj=e.$Oj=void 0,e.$Oj=(0,k.$lh)("fileService");function D(_){return _.create===!0}e.$Pj=D;var h;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var b;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(b||(e.FilePermission=b={}));var $;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function u(_){return!!(_.capabilities&2)}e.$Qj=u;function t(_){return!!(_.capabilities&8)}e.$Rj=t;function r(_){return!!(_.capabilities&131072)}e.$Sj=r;function c(_){return!!(_.capabilities&4)}e.$Tj=c;function w(_){return!!(_.capabilities&16)}e.$Uj=w;function v(_){return u(_)?!!(_.capabilities&16384):!1}e.$Vj=v;function y(_){return u(_)?!!(_.capabilities&32768):!1}e.$Wj=y;function i(_){return!!(_.capabilities&65536)}e.$Xj=i;function l(_){return!!(_.capabilities&2048)}e.$Yj=l;var n;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(Y,ce){const ke=new s(Y.toString(),ce);return d(ke,ce),ke}constructor(Y,ce){super(Y),this.code=ce}}e.$Zj=s;function p(_,Y){return s.create(_,Y)}e.$1j=p;function I(_){return _||p((0,f.localize)(0,null),n.Unknown)}e.$2j=I;function d(_,Y){return _.name=Y?`${Y} (FileSystemError)`:"FileSystemError",_}e.$3j=d;function A(_){if(!_)return n.Unknown;if(_ instanceof s)return _.code;const Y=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!Y)return n.Unknown;switch(Y[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$4j=A;function E(_){if(_ instanceof q)return _.fileOperationResult;switch(A(_)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$5j=E;var a;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(a||(e.FileOperation=a={}));class o{constructor(Y,ce,ke){this.resource=Y,this.operation=ce,this.target=ke}isOperation(Y){return this.operation===Y}}e.$6j=o;var L;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class B{constructor(Y,ce){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ke=new Map;for(const Ce of Y){const me=ke.get(Ce.type);switch(me?me.push([Ce.resource,Ce]):ke.set(Ce.type,[[Ce.resource,Ce]]),Ce.type){case 1:this.rawAdded.push(Ce.resource);break;case 0:this.rawUpdated.push(Ce.resource);break;case 2:this.rawDeleted.push(Ce.resource);break}}for(const[Ce,me]of ke)switch(Ce){case 1:this.a=g.$rh.forUris(()=>ce),this.a.fill(me);break;case 0:this.b=g.$rh.forUris(()=>ce),this.b.fill(me);break;case 2:this.c=g.$rh.forUris(()=>ce),this.c.fill(me);break}}contains(Y,...ce){return this.d(Y,{includeChildren:!1},...ce)}affects(Y,...ce){return this.d(Y,{includeChildren:!0},...ce)}d(Y,ce,...ke){if(!Y)return!1;const Ce=ke.length>0;return!!((!Ce||ke.includes(1))&&(this.a?.get(Y)||ce.includeChildren&&this.a?.findSuperstr(Y))||(!Ce||ke.includes(0))&&(this.b?.get(Y)||ce.includeChildren&&this.b?.findSuperstr(Y))||(!Ce||ke.includes(2))&&(this.c?.findSubstr(Y)||ce.includeChildren&&this.c?.findSuperstr(Y)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$7j=B;function G(_,Y,ce){return!_||!Y||_===Y||Y.length>_.length?!1:(Y.charAt(Y.length-1)!==C.sep&&(Y+=C.sep),ce?(0,S.$Kd)(_,Y):_.indexOf(Y)===0)}e.$8j=G;class q extends Error{constructor(Y,ce,ke){super(Y),this.fileOperationResult=ce,this.options=ke}}e.$9j=q;class W extends q{constructor(Y,ce,ke,Ce){super(Y,ce,Ce),this.fileOperationResult=ce,this.size=ke}}e.$0j=W;class N extends q{constructor(Y,ce,ke){super(Y,2,ke),this.stat=ce}}e.$$j=N;var H;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.$_j={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ak={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$bk="files.associations",e.$ck="files.exclude",e.$dk="files.readonlyInclude",e.$ek="files.readonlyExclude",e.$fk="files.readonlyFromPermissions";var j;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(j||(e.FileKind=j={})),e.$gk="";function O(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$hk=O;async function ue(_,Y){if(!Y.hasProvider(T.URI.from({scheme:_.scheme})))return new Promise(ce=>{const ke=Y.onDidChangeFileSystemProviderRegistrations(Ce=>{Ce.scheme===_.scheme&&Ce.added&&(ke.dispose(),ce())})})}e.$ik=ue;class pe{static formatSize(Y){return(0,z.$ke)(Y)||(Y=0),Y<pe.KB?(0,f.localize)(1,null,Y.toFixed(0)):Y<pe.MB?(0,f.localize)(2,null,(Y/pe.KB).toFixed(2)):Y<pe.GB?(0,f.localize)(3,null,(Y/pe.MB).toFixed(2)):Y<pe.TB?(0,f.localize)(4,null,(Y/pe.GB).toFixed(2)):(0,f.localize)(5,null,(Y/pe.TB).toFixed(2))}}e.$jk=pe,pe.KB=1024,pe.MB=pe.KB*pe.KB,pe.GB=pe.MB*pe.KB,pe.TB=pe.GB*pe.KB;function Pe(_){const Y=typeof _=="string"||_?.scheme===F.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===F.Schemas.file?1024*pe.MB:Y?10*pe.MB:m.$o?50*pe.MB:1024*pe.MB}e.$kk=Pe}),define(Re[73],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=void 0;class g{constructor(...S){this.a=new Map;for(const[z,T]of S)this.set(z,T)}set(S,z){const T=this.a.get(S);return this.a.set(S,z),T}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$jh=g}),define(Re[170],Fe([1,0,16,9,6,71,168,3,73,171]),function(te,e,g,C,S,z,T,f,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0;const F=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class h{constructor(t=new k.$jh,r=!1,c,w=F){this.f=t,this.g=r,this.h=c,this.i=w,this.o=new Set,this.f.set(f.$kh,this),this._globalGraph=w?c?._globalGraph??new T.$Pp(v=>v):void 0}createChild(t){return new h(t,this.g,this,this.i)}invokeFunction(t,...r){const c=$.traceInvocation(this.i,t);let w=!1;try{return t({get:y=>{if(w)throw(0,C.$5)("service accessor is only valid during the invocation of its target method");const i=this.m(y,c);if(!i)throw new Error(`[invokeFunction] unknown service '${y}'`);return i}},...r)}finally{w=!0,c.stop()}}createInstance(t,...r){let c,w;return t instanceof z.$ih?(c=$.traceCreation(this.i,t.ctor),w=this.j(t.ctor,t.staticArguments.concat(r),c)):(c=$.traceCreation(this.i,t),w=this.j(t,r,c)),c.stop(),w}j(t,r=[],c){const w=f._util.getServiceDependencies(t).sort((i,l)=>i.index-l.index),v=[];for(const i of w){const l=this.m(i.id,c);l||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${i.id}.`,!1),v.push(l)}const y=w.length>0?w[0].index:r.length;if(r.length!==y){console.trace(`[createInstance] First service dependency of ${t.name} at position ${y+1} conflicts with ${r.length} static arguments`);const i=y-r.length;i>0?r=r.concat(new Array(i)):r=r.slice(0,y)}return Reflect.construct(t,r.concat(v))}k(t,r){if(this.f.get(t)instanceof z.$ih)this.f.set(t,r);else if(this.h)this.h.k(t,r);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const r=this.f.get(t);return!r&&this.h?this.h.l(t):r}m(t,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof z.$ih?this.q(t,c,r.branch(t,!0)):(r.branch(t,!1),c)}q(t,r,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,r,c)}finally{this.o.delete(t)}}r(t,r,c){const w=new T.$Pp(i=>i.id.toString());let v=0;const y=[{id:t,desc:r,_trace:c}];for(;y.length;){const i=y.pop();if(w.lookupOrInsertNode(i),v++>1e3)throw new D(w);for(const l of f._util.getServiceDependencies(i.desc.ctor)){const n=this.l(l.id);if(n||this.u(`[createInstance] ${t} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(l.id)),n instanceof z.$ih){const s={id:l.id,desc:n,_trace:i._trace.branch(l.id,!0)};w.insertEdge(i,s),y.push(s)}}}for(;;){const i=w.roots();if(i.length===0){if(!w.isEmpty())throw new D(w);break}for(const{data:l}of i){if(this.l(l.id)instanceof z.$ih){const s=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,s)}w.removeNode(l)}}return this.l(t)}s(t,r,c=[],w,v){if(this.f.get(t)instanceof z.$ih)return this.t(t,r,c,w,v);if(this.h)return this.h.s(t,r,c,w,v);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}t(t,r,c=[],w,v){if(w){const y=new h(void 0,this.g,this,this.i);y.c=String(t);const i=new Map,l=new g.$Hg(()=>{const n=y.j(r,c,v);for(const[s,p]of i){const I=n[s];if(typeof I=="function")for(const d of p)I.apply(n,d)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!l.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let d=i.get(s);return d||(d=new m.$jc,i.set(s,d)),(E,a,o)=>{const L=d.push([E,a,o]);return(0,S.$ib)(L)}}if(s in n)return n[s];const p=l.value;let I=p[s];return typeof I!="function"||(I=I.bind(p),n[s]=I),I},set(n,s,p){return l.value[s]=p,!0},getPrototypeOf(n){return r.prototype}})}else return this.j(r,c,v)}u(t,r){if(r&&console.warn(t),this.g)throw new Error(t)}}e.$Qp=h;var b;(function(u){u[u.None=0]="None",u[u.Creation=1]="Creation",u[u.Invocation=2]="Invocation",u[u.Branch=3]="Branch"})(b||(b={}));class ${static traceInvocation(t,r){return t?new $(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(t,r){return t?new $(1,r.name):$.c}constructor(t,r){this.type=t,this.name=r,this.g=Date.now(),this.h=[]}branch(t,r){const c=new $(3,t.toString());return this.h.push([t,r,c]),c}stop(){const t=Date.now()-this.g;$.f+=t;let r=!1;function c(v,y){const i=[],l=new Array(v+1).join("	");for(const[n,s,p]of y.h)if(s&&p){r=!0,i.push(`${l}CREATES -> ${n}`);const I=c(v+1,p);I&&i.push(I)}else i.push(`${l}uses -> ${n}`);return i.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(t>2||r)&&$.all.add(w.join(`
`))}}e.$Rp=$,$.all=new Set,$.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}},$.f=0}),define(Re[15],Fe([1,0,41,5,93,6,28,21,20,10,2,31,3]),function(te,e,g,C,S,z,T,f,k,m,F,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.log=e.$Qi=e.LogLevel=e.$Pi=e.$Oi=e.$Ni=void 0,e.$Ni=(0,h.$lh)("logService"),e.$Oi=(0,h.$lh)("loggerService");function b(){return new Date().toISOString()}function $(E){return(0,m.$ke)(E)}e.$Pi=$;var u;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(u||(e.LogLevel=u={})),e.$Qi=u.Info;function t(E,a,o){switch(a){case u.Trace:E.trace(o);break;case u.Debug:E.debug(o);break;case u.Info:E.info(o);break;case u.Warning:E.warn(o);break;case u.Error:E.error(o);break;case u.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=t;function r(E,a=!1){let o="";for(let L=0;L<E.length;L++){let B=E[L];if(B instanceof Error&&(B=(0,g.$9h)(B,a)),typeof B=="object")try{B=JSON.stringify(B)}catch{}o+=(L>0?" ":"")+B}return o}class c extends z.$kb{constructor(){super(...arguments),this.b=e.$Qi,this.c=this.B(new C.$5c),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==u.Off&&this.b<=a}}e.$Si=c;class w extends c{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...o){this.f(u.Trace)&&this.g(u.Trace,r([a,...o],!0))}debug(a,...o){this.f(u.Debug)&&this.g(u.Debug,r([a,...o]))}info(a,...o){this.f(u.Info)&&this.g(u.Info,r([a,...o]))}warn(a,...o){this.f(u.Warning)&&this.g(u.Warning,r([a,...o]))}error(a,...o){if(this.f(u.Error))if(a instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=a.stack,this.g(u.Error,r(L))}else this.g(u.Error,r([a,...o]))}flush(){}}e.$Ti=w;class v extends c{constructor(a=e.$Qi){super(),this.setLevel(a),this.g=!f.$i}trace(a,...o){this.f(u.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,a,...o):console.log(`[main ${b()}]`,a,...o))}debug(a,...o){this.f(u.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,a,...o):console.log(`[main ${b()}]`,a,...o))}info(a,...o){this.f(u.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,a,...o):console.log(`[main ${b()}]`,a,...o))}warn(a,...o){this.f(u.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,a,...o):console.warn(`[main ${b()}]`,a,...o))}error(a,...o){this.f(u.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,a,...o):console.error(`[main ${b()}]`,a,...o))}dispose(){}flush(){}}e.$Ui=v;class y extends c{constructor(a=e.$Qi,o=!0){super(),this.g=o,this.setLevel(a)}trace(a,...o){this.f(u.Trace)&&(this.g?console.log("%cTRACE","color: #888",a,...o):console.log(a,...o))}debug(a,...o){this.f(u.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",a,...o):console.log(a,...o))}info(a,...o){this.f(u.Info)&&(this.g?console.log("%c INFO","color: #33f",a,...o):console.log(a,...o))}warn(a,...o){this.f(u.Warning)&&(this.g?console.log("%c WARN","color: #993",a,...o):console.log(a,...o))}error(a,...o){this.f(u.Error)&&(this.g?console.log("%c  ERR","color: #f33",a,...o):console.error(a,...o))}dispose(){}flush(){}}e.$Vi=y;class i extends c{constructor(a,o=e.$Qi){super(),this.g=a,this.setLevel(o)}trace(a,...o){this.f(u.Trace)&&this.g.log(u.Trace,[this.h(a),...o])}debug(a,...o){this.f(u.Debug)&&this.g.log(u.Debug,[this.h(a),...o])}info(a,...o){this.f(u.Info)&&this.g.log(u.Info,[this.h(a),...o])}warn(a,...o){this.f(u.Warning)&&this.g.log(u.Warning,[this.h(a),...o])}error(a,...o){this.f(u.Error)&&this.g.log(u.Error,[this.h(a),...o])}h(a){return typeof a=="string"?a:(0,g.$9h)(a,this.f(u.Trace))}dispose(){}flush(){}}e.$Wi=i;class l extends c{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const o of this.g)o.setLevel(a);super.setLevel(a)}trace(a,...o){for(const L of this.g)L.trace(a,...o)}debug(a,...o){for(const L of this.g)L.debug(a,...o)}info(a,...o){for(const L of this.g)L.info(a,...o)}warn(a,...o){for(const L of this.g)L.warn(a,...o)}error(a,...o){for(const L of this.g)L.error(a,...o)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.$Xi=l;class n extends z.$kb{constructor(a,o,L){if(super(),this.h=a,this.j=o,this.b=new T.$ji,this.c=this.B(new C.$5c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$5c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$5c),this.onDidChangeVisibility=this.g.event,L)for(const B of L)this.b.set(B.resource,{logger:void 0,info:B})}k(a){return(0,m.$ge)(a)?[...this.b.values()].find(o=>o.info.id===a):this.b.get(a)}getLogger(a){return this.k(a)?.logger}createLogger(a,o){const L=this.l(a),B=(0,m.$ge)(a)?a:o?.id??(0,S.$_h)(L.toString()).toString(16);let G=this.b.get(L)?.logger;const q=o?.logLevel==="always"?u.Trace:o?.logLevel;G||(G=this.m(L,q??this.getLogLevel(L)??this.h,{...o,id:B}));const W={logger:G,info:{resource:L,id:B,logLevel:q,name:o?.name,hidden:o?.hidden,extensionId:o?.extensionId,when:o?.when}};return this.registerLogger(W.info),this.b.set(L,W),G}l(a){return(0,m.$ge)(a)?(0,k.$6f)(this.j,`${a}.log`):a}setLogLevel(a,o){if(F.URI.isUri(a)){const L=a,B=o,G=this.b.get(L);G&&B!==G.info.logLevel&&(G.info.logLevel=B===this.h?void 0:B,G.logger?.setLevel(B),this.b.set(G.info.resource,G),this.f.fire([L,B]))}else{this.h=a;for(const[L,B]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(a,o){const L=this.k(a);L&&o!==!L.info.hidden&&(L.info.hidden=!o,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,o]))}getLogLevel(a){let o;return a&&(o=this.b.get(a)?.info.logLevel),o??this.h}registerLogger(a){const o=this.b.get(a.resource);o?o.info.hidden!==a.hidden&&this.setVisibility(a.resource,!a.hidden):(this.b.set(a.resource,{info:a,logger:void 0}),this.c.fire({added:[a],removed:[]}))}deregisterLogger(a){const o=this.b.get(a);o&&(o.logger&&o.logger.dispose(),this.b.delete(a),this.c.fire({added:[],removed:[o.info]}))}*getRegisteredLoggers(){for(const a of this.b.values())yield a.info}getRegisteredLogger(a){return this.b.get(a)?.info}dispose(){this.b.forEach(a=>a.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yi=n;class s{constructor(){this.onDidChangeLogLevel=new C.$5c().event}setLevel(a){}getLevel(){return u.Info}trace(a,...o){}debug(a,...o){}info(a,...o){}warn(a,...o){}error(a,...o){}critical(a,...o){}dispose(){}flush(){}}e.$Zi=s;class p extends s{}e.$1i=p;function I(E){if(E.verbose)return u.Trace;if(typeof E.logLevel=="string"){const a=A(E.logLevel.toLowerCase());if(a!==void 0)return a}return e.$Qi}e.$2i=I;function d(E){switch(E){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}e.$3i=d;function A(E){switch(E){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.$4i=A,e.$5i=new D.$Ki("logLevel",d(u.Info))}),define(Re[172],Fe([1,0,6,15]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=void 0;class S extends g.$kb{constructor(T,f=[]){super(),this.a=new C.$Xi([T,...f]),this.B(T.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...f){this.a.trace(T,...f)}debug(T,...f){this.a.debug(T,...f)}info(T,...f){this.a.info(T,...f)}warn(T,...f){this.a.warn(T,...f)}error(T,...f){this.a.error(T,...f)}flush(){this.a.flush()}}e.$wM=S}),define(Re[94],Fe([1,0,29,143,3]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var z;(function(k){k[k.Unnecessary=1]="Unnecessary",k[k.Deprecated=2]="Deprecated"})(z||(e.MarkerTag=z={}));var T;(function(k){k[k.Hint=1]="Hint",k[k.Info=2]="Info",k[k.Warning=4]="Warning",k[k.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(k){function m($,u){return u-$}k.compare=m;const F=Object.create(null);F[k.Error]=(0,C.localize)(0,null),F[k.Warning]=(0,C.localize)(1,null),F[k.Info]=(0,C.localize)(2,null);function D($){return F[$]||""}k.toString=D;function h($){switch($){case g.default.Error:return k.Error;case g.default.Warning:return k.Warning;case g.default.Info:return k.Info;case g.default.Ignore:return k.Hint}}k.fromSeverity=h;function b($){switch($){case k.Error:return g.default.Error;case k.Warning:return g.default.Warning;case k.Info:return g.default.Info;case k.Hint:return g.default.Ignore}}k.toSeverity=b}(T||(e.MarkerSeverity=T={}));var f;(function(k){const m="";function F(h){return D(h,!0)}k.makeKey=F;function D(h,b){const $=[m];return h.source?$.push(h.source.replace("\xA6","\\\xA6")):$.push(m),h.code?typeof h.code=="string"?$.push(h.code.replace("\xA6","\\\xA6")):$.push(h.code.value.replace("\xA6","\\\xA6")):$.push(m),h.severity!==void 0&&h.severity!==null?$.push(T.toString(h.severity)):$.push(m),h.message&&b?$.push(h.message.replace("\xA6","\\\xA6")):$.push(m),h.startLineNumber!==void 0&&h.startLineNumber!==null?$.push(h.startLineNumber.toString()):$.push(m),h.startColumn!==void 0&&h.startColumn!==null?$.push(h.startColumn.toString()):$.push(m),h.endLineNumber!==void 0&&h.endLineNumber!==null?$.push(h.endLineNumber.toString()):$.push(m),h.endColumn!==void 0&&h.endColumn!==null?$.push(h.endColumn.toString()):$.push(m),$.push(m),$.join("\xA6")}k.makeKeyOptionalMessage=D})(f||(e.IMarkerData=f={})),e.$hs=(0,S.$lh)("markerService")}),define(Re[173],Fe([1,0,5,29,3]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nz=e.$mz=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$lz=e.Severity=void 0,e.Severity=C.default,e.$lz=(0,S.$lh)("notificationService");var z;(function(F){F[F.DEFAULT=0]="DEFAULT",F[F.SILENT=1]="SILENT",F[F.URGENT=2]="URGENT"})(z||(e.NotificationPriority=z={}));var T;(function(F){F[F.WORKSPACE=0]="WORKSPACE",F[F.PROFILE=1]="PROFILE",F[F.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));var f;(function(F){F[F.OFF=0]="OFF",F[F.SILENT=1]="SILENT",F[F.ERROR=2]="ERROR"})(f||(e.NotificationsFilter=f={}));class k{constructor(){this.progress=new m,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$mz=k;class m{infinite(){}done(){}total(D){}worked(D){}}e.$nz=m}),define(Re[95],Fe([1,0,13,2,3]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yY=e.$xY=e.$wY=e.$vY=e.$uY=void 0,e.$uY=(0,S.$lh)("openerService");function z(m,F){return C.URI.isUri(m)?(0,g.$Jd)(m.scheme,F):(0,g.$Kd)(m,F+":")}e.$vY=z;function T(m,...F){return F.some(D=>z(m,D))}e.$wY=T;function f(m,F){return m.with({fragment:`${F.startLineNumber},${F.startColumn}${F.endLineNumber?`-${F.endLineNumber}${F.endColumn?`,${F.endColumn}`:""}`:""}`})}e.$xY=f;function k(m){let F;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return D&&(F={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},m=m.with({fragment:""})),{selection:F,uri:m}}e.$yY=k}),define(Re[174],Fe([1,0,3]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=void 0,e.$6i=(0,g.$lh)("productService"),e.$7i="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(te,e,g,C){var S=arguments.length,z=S<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,g):C,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")z=Reflect.decorate(te,e,g,C);else for(var f=te.length-1;f>=0;f--)(T=te[f])&&(z=(S<3?T(z):S>3?T(e,g,z):T(e,g))||z);return S>3&&z&&Object.defineProperty(e,g,z),z},Ve=this&&this.__param||function(te,e){return function(g,C){e(g,C,te)}};define(Re[175],Fe([1,0,16,22,6,3]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tz=e.$sz=e.$rz=e.$qz=e.$pz=e.ProgressLocation=e.$oz=void 0,e.$oz=(0,z.$lh)("progressService");var T;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.$pz=Object.freeze({total(){},worked(){},done(){}});class f{get value(){return this.a}constructor(D){this.b=D}report(D){this.a=D,this.b(this.a)}}e.$qz=f,f.None=Object.freeze({report(){}});let k=e.$rz=class extends S.$kb{constructor(D,h){super(),this.a=new g.$Lg,h.withProgress(D,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,S.$ib)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};e.$rz=k=qe([Ve(1,e.$oz)],k);class m extends S.$kb{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new S.$jb)}start(D){this.stop();const h=++this.a,b=new C.$bd;return this.f=setTimeout(()=>{h===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,S.$ib)(()=>clearTimeout(this.f))),this.b.add((0,S.$ib)(()=>b.cancel())),this.b.add((0,S.$ib)(()=>this.c?this.c.done():void 0)),{id:h,token:b.token,stop:()=>this.h(h),isCurrent:()=>this.a===h}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.$sz=m,e.$tz=(0,z.$lh)("editorProgressService")}),define(Re[30],Fe([1,0,49,10]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=void 0;class S{constructor(){this.a=new Map}add(T,f){g.ok(C.$ge(T)),g.ok(C.$ie(f)),g.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,f)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$Pm=new S}),define(Re[74],Fe([1,0,5,30]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0,e.$Qm={JSONContribution:"base.contributions.json"};function S(f){return f.length>0&&f.charAt(f.length-1)==="#"?f.substring(0,f.length-1):f}class z{constructor(){this.b=new g.$5c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,m){this.a[S(k)]=m,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const T=new z;C.$Pm.add(e.$Qm.JSONContribution,T)}),define(Re[96],Fe([1,0,18,5,10,137,43,74,30]),function(te,e,g,C,S,z,T,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.ConfigurationScope=e.$Um=e.EditPresentationTypes=void 0;var m;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.$Um={Configuration:"base.contributions.configuration"};var F;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(F||(e.ConfigurationScope=F={})),e.$Vm={properties:{},patternProperties:{}},e.$Wm={properties:{},patternProperties:{}},e.$Xm={properties:{},patternProperties:{}},e.$Ym={properties:{},patternProperties:{}},e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m="vscode://schemas/settings/resourceLanguage",e.$3m="vscode://schemas/settings/configurationDefaults";const D=k.$Pm.as(f.$Qm.JSONContribution);class h{constructor(){this.h=new Set,this.i=new C.$5c,this.onDidSchemaChange=this.i.event,this.j=new C.$5c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:z.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$2m,this.g),this.v()}registerConfiguration(i,l=!0){this.registerConfigurations([i],l)}registerConfigurations(i,l=!0){const n=new Set;this.n(i,l,n),D.registerSchema(e.$2m,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const l=new Set;this.o(i,l),D.registerSchema(e.$2m,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:i,remove:l}){const n=new Set;this.o(l,n),this.n(i,!1,n),D.registerSchema(e.$2m,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const l=new Set;this.k(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(i,l){const n=[];for(const{overrides:s,source:p}of i)for(const I in s)if(l.add(I),e.$5m.test(I)){const d=this.a.get(I),A=d?.valuesSources??new Map;if(p)for(const L of Object.keys(s[I]))A.set(L,p);const E={...d?.value||{},...s[I]};this.a.set(I,{source:p,value:E,valuesSources:A});const a=(0,T.$2h)(I),o={type:"object",default:E,description:z.localize(1,null,a),$ref:e.$2m,defaultDefaultValue:E,source:S.$ge(p)?void 0:p,defaultValueSource:p};n.push(...u(I)),this.d[I]=o,this.b.properties[I]=o}else{this.a.set(I,{value:s[I],source:p});const d=this.d[I];d&&(this.w(I,d),this.r(I,d))}this.m(n)}deregisterDefaultConfigurations(i){const l=new Set;this.l(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(i,l){for(const{overrides:n,source:s}of i)for(const p in n){const I=this.a.get(p),d=S.$ge(s)?s:s?.id,A=S.$ge(I?.source)?I?.source:I?.source?.id;if(d===A)if(l.add(p),this.a.delete(p),e.$5m.test(p))delete this.d[p],delete this.b.properties[p];else{const E=this.d[p];E&&(this.w(p,E),this.r(p,E))}}this.u()}deltaConfiguration(i){let l=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),l=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),l=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const l of i)this.h.add(l);this.u()}n(i,l,n){i.forEach(s=>{this.p(s,l,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,l){const n=s=>{if(s.properties)for(const p in s.properties){l.add(p);const I=this.d[p];I?.policy?.name&&this.e.delete(I.policy.name),delete this.d[p],this.s(p,s.properties[p])}s.allOf?.forEach(p=>n(p))};for(const s of i){n(s);const p=this.c.indexOf(s);p!==-1&&this.c.splice(p,1)}}p(i,l=!0,n,s,p=3,I){p=S.$pe(i.scope)?p:i.scope;const d=i.properties;if(d)for(const E in d){const a=d[E];if(l&&w(E,a)){delete d[E];continue}if(a.source=n,a.defaultDefaultValue=d[E].default,this.w(E,a),e.$5m.test(E)?a.scope=void 0:(a.scope=S.$pe(a.scope)?p:a.scope,a.restricted=S.$pe(a.restricted)?!!s?.includes(E):a.restricted),d[E].hasOwnProperty("included")&&!d[E].included){this.f[E]=d[E],delete d[E];continue}else this.d[E]=d[E],d[E].policy?.name&&this.e.set(d[E].policy.name,E);!d[E].deprecationMessage&&d[E].markdownDeprecationMessage&&(d[E].deprecationMessage=d[E].markdownDeprecationMessage),I.add(E)}const A=i.allOf;if(A)for(const E of A)this.p(E,l,n,s,p,I)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const l=n=>{const s=n.properties;if(s)for(const I in s)this.r(I,s[I]);n.allOf?.forEach(l)};l(i)}r(i,l){switch(e.$Vm.properties[i]=l,l.scope){case 1:e.$Wm.properties[i]=l;break;case 2:e.$Xm.properties[i]=l;break;case 6:e.$Ym.properties[i]=l;break;case 3:e.$Zm.properties[i]=l;break;case 4:e.$1m.properties[i]=l;break;case 5:e.$1m.properties[i]=l,this.g.properties[i]=l;break}}s(i,l){switch(delete e.$Vm.properties[i],l.scope){case 1:delete e.$Wm.properties[i];break;case 2:delete e.$Xm.properties[i];break;case 6:delete e.$Ym.properties[i];break;case 3:delete e.$Zm.properties[i];break;case 4:case 5:delete e.$1m.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const l=`[${i}]`,n={type:"object",description:z.localize(2,null),errorMessage:z.localize(3,null),$ref:e.$2m};this.w(l,n),e.$Vm.properties[l]=n,e.$Wm.properties[l]=n,e.$Xm.properties[l]=n,e.$Ym.properties[l]=n,e.$Zm.properties[l]=n,e.$1m.properties[l]=n}}v(){const i={type:"object",description:z.localize(4,null),errorMessage:z.localize(5,null),$ref:e.$2m};e.$Vm.patternProperties[e.$4m]=i,e.$Wm.patternProperties[e.$4m]=i,e.$Xm.patternProperties[e.$4m]=i,e.$Ym.patternProperties[e.$4m]=i,e.$Zm.patternProperties[e.$4m]=i,e.$1m.patternProperties[e.$4m]=i,this.i.fire()}w(i,l){const n=this.a.get(i);let s=n?.value,p=n?.source;S.$ne(s)&&(s=l.defaultDefaultValue,p=void 0),S.$ne(s)&&(s=r(l.type)),l.default=s,l.defaultValueSource=p}}const b="\\[([^\\]]+)\\]",$=new RegExp(b,"g");e.$4m=`^(${b})+$`,e.$5m=new RegExp(e.$4m);function u(y){const i=[];if(e.$5m.test(y)){let l=$.exec(y);for(;l?.length;){const n=l[1].trim();n&&i.push(n),l=$.exec(y)}}return(0,g.$of)(i)}e.$6m=u;function t(y){return y.reduce((i,l)=>`${i}[${l}]`,"")}e.$7m=t;function r(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$8m=r;const c=new h;k.$Pm.add(e.$Um.Configuration,c);function w(y,i){return y.trim()?e.$5m.test(y)?z.localize(7,null,y):c.getConfigurationProperties()[y]!==void 0?z.localize(8,null,y):i.policy?.name&&c.getPolicyConfigurations().get(i.policy?.name)!==void 0?z.localize(9,null,y,i.policy?.name,c.getPolicyConfigurations().get(i.policy?.name)):null:z.localize(6,null)}e.$9m=w;function v(){const y=[],i=c.getConfigurationProperties();for(const l of Object.keys(i))y.push([l,i[l].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.$0m=v}),define(Re[176],Fe([1,0,18,5,115,6,28,23,10,2,43,96,30]),function(te,e,g,C,S,z,T,f,k,m,F,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=void 0;function b(l){return Object.isFrozen(l)?l:f.$Em(l)}class ${constructor(n={},s=[],p=[],I){this.b=n,this.c=s,this.d=p,this.raw=I,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof $)return s;const p=new u("");return p.parseRaw(s),p.configurationModel});this.f=n.reduce((s,p)=>p===s?p:s.merge(p),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,F.$Zh)(this.contents,n):this.contents}inspect(n,s){const p=this.rawConfiguration.getValue(n),I=s?this.rawConfiguration.getOverrideValue(n,s):void 0,d=s?this.rawConfiguration.override(s).getValue(n):p;return{value:p,override:I,merged:d}}getOverrideValue(n,s){const p=this.i(s);return p?n?(0,F.$Zh)(p,n):p:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const p of this.overrides)p.identifiers.includes(n)&&s.push(...p.keys);return g.$of(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return g.$of(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=f.$Dm(this.contents),p=f.$Dm(this.overrides),I=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const A of n)if(d.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(s,A.contents);for(const E of A.overrides){const[a]=p.filter(o=>g.$$e(o.identifiers,E.identifiers));a?(this.h(a.contents,E.contents),a.keys.push(...E.keys),a.keys=g.$of(a.keys)):p.push(f.$Dm(E))}for(const E of A.keys)I.indexOf(E)===-1&&I.push(E)}return new $(s,I,p,d.every(A=>A instanceof $)?void 0:d)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const p={};for(const I of g.$of([...Object.keys(this.contents),...Object.keys(s)])){let d=this.contents[I];const A=s[I];A&&(typeof d=="object"&&typeof A=="object"?(d=f.$Dm(d),this.h(d,A)):d=A),p[I]=d}return new $(p,this.keys,this.overrides)}h(n,s){for(const p of Object.keys(s)){if(p in n&&k.$ie(n[p])&&k.$ie(s[p])){this.h(n[p],s[p]);continue}n[p]=f.$Dm(s[p])}}i(n){let s=null,p=null;const I=d=>{d&&(p?this.h(p,d):p=f.$Dm(d))};for(const d of this.overrides)g.$$e(d.identifiers,[n])?s=d.contents:d.identifiers.includes(n)&&I(d.contents);return I(s),p}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,F.$Yh)(this.contents,n),D.$5m.test(n)&&this.overrides.splice(this.overrides.findIndex(p=>g.$$e(p.identifiers,(0,D.$6m)(n))),1))}j(n,s,p){(0,F.$Xh)(this.contents,n,s,I=>console.error(I)),p=p||this.keys.indexOf(n)===-1,p&&this.keys.push(n),D.$5m.test(n)&&this.overrides.push({identifiers:(0,D.$6m)(n),keys:Object.keys(this.contents[n]),contents:(0,F.$Wh)(this.contents[n],I=>console.error(I))})}}e.$$m=$;class u{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!k.$pe(n)){const p=this.g(n);this.parseRaw(p,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:p,keys:I,overrides:d,restricted:A,hasExcludedProperties:E}=this.h(n,s);this.b=new $(p,I,d,E?[n]:void 0),this.c=A||[]}g(n){let s={},p=null,I=[];const d=[],A=[];function E(o){Array.isArray(I)?I.push(o):p!==null&&(I[p]=o)}const a={onObjectBegin:()=>{const o={};E(o),d.push(I),I=o,p=null},onObjectProperty:o=>{p=o},onObjectEnd:()=>{I=d.pop()},onArrayBegin:()=>{const o=[];E(o),d.push(I),I=o,p=null},onArrayEnd:()=>{I=d.pop()},onLiteralValue:E,onError:(o,L,B)=>{A.push({error:o,offset:L,length:B})}};if(n)try{S.$Am(n,a),s=I[0]||{}}catch(o){console.error(`Error while parsing settings file ${this.f}: ${o}`),this.d=[o]}return s}h(n,s){const p=h.$Pm.as(D.$Um.Configuration).getConfigurationProperties(),I=this.i(n,p,!0,s);n=I.raw;const d=(0,F.$Wh)(n,a=>console.error(`Conflict in settings file ${this.f}: ${a}`)),A=Object.keys(n),E=this.j(n,a=>console.error(`Conflict in settings file ${this.f}: ${a}`));return{contents:d,keys:A,overrides:E,restricted:I.restricted,hasExcludedProperties:I.hasExcludedProperties}}i(n,s,p,I){let d=!1;if(!I?.scopes&&!I?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:d};const A={},E=[];for(const a in n)if(D.$5m.test(a)&&p){const o=this.i(n[a],s,!1,I);A[a]=o.raw,d=d||o.hasExcludedProperties,E.push(...o.restricted)}else{const o=s[a],L=o?typeof o.scope<"u"?o.scope:3:void 0;o?.restricted&&E.push(a),(L===void 0||I.scopes===void 0||I.scopes.includes(L))&&!(I.skipRestricted&&o?.restricted)?A[a]=n[a]:d=!0}return{raw:A,restricted:E,hasExcludedProperties:d}}j(n,s){const p=[];for(const I of Object.keys(n))if(D.$5m.test(I)){const d={};for(const A in n[I])d[A]=n[I][A];p.push({identifiers:(0,D.$6m)(I),keys:Object.keys(d),contents:(0,F.$Wh)(d,s)})}return p}}e.$_m=u;class t extends z.$kb{constructor(n,s,p,I){super(),this.f=n,this.g=s,this.h=I,this.c=this.B(new C.$5c),this.onDidChange=this.c.event,this.a=new u(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(p.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(C.Event.any(C.Event.filter(this.h.onDidFilesChange,d=>d.contains(this.f)),C.Event.filter(this.h.onDidRunOperation,d=>(d.isOperation(0)||d.isOperation(3)||d.isOperation(1)||d.isOperation(4))&&p.isEqual(d.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new $}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$an=t;class r{constructor(n,s,p,I,d,A,E,a,o,L,B,G,q){this.a=n,this.b=s,this.c=p,this.overrideIdentifiers=I,this.d=d,this.f=A,this.g=E,this.h=a,this.i=o,this.j=L,this.k=B,this.l=G,this.m=q}get value(){return b(this.c)}n(n,s,p){const I=n.inspect(s,p);return{get value(){return b(I.value)},get override(){return b(I.override)},get merged(){return b(I.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(n,s,p,I,d=new $,A=new $,E=new T.$ji,a=new $,o=new T.$ji){this.c=n,this.d=s,this.f=p,this.g=I,this.h=d,this.i=A,this.j=E,this.l=a,this.m=o,this.a=null,this.b=new T.$ji,this.n=null}getValue(n,s,p){return this.q(n,s,p).getValue(n)}updateValue(n,s,p={}){let I;p.resource?(I=this.m.get(p.resource),I||(I=new $,this.m.set(p.resource,I))):I=this.l,s===void 0?I.removeValue(n):I.setValue(n,s),p.resource||(this.a=null)}inspect(n,s,p){const I=this.q(n,s,p),d=this.u(s.resource,p),A=s.resource?this.m.get(s.resource)||this.l:this.l,E=new Set;for(const a of I.overrides)for(const o of a.identifiers)I.getOverrideValue(n,o)!==void 0&&E.add(o);return new r(n,s,I.getValue(n),E.size?[...E]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,p?this.i:void 0,d||void 0,A)}keys(n){const s=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const p=[];if(!s){const{added:I,updated:d,removed:A}=y(this.c,n);s=[...I,...d,...A]}for(const I of s)for(const d of(0,D.$6m)(I)){const A=this.c.getKeysForOverrideIdentifier(d),E=n.getKeysForOverrideIdentifier(d),a=[...E.filter(o=>A.indexOf(o)===-1),...A.filter(o=>E.indexOf(o)===-1),...A.filter(o=>!f.$Hm(this.c.override(d).getValue(o),n.override(d).getValue(o)))];p.push([d,a])}return this.updateDefaultConfiguration(n),{keys:s,overrides:p}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:p,removed:I}=y(this.d,n),d=[...s,...p,...I];return d.length&&this.updatePolicyConfiguration(n),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:p,removed:I,overrides:d}=y(this.applicationConfiguration,n),A=[...s,...p,...I];return A.length&&this.updateApplicationConfiguration(n),{keys:A,overrides:d}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:p,removed:I,overrides:d}=y(this.localUserConfiguration,n),A=[...s,...p,...I];return A.length&&this.updateLocalUserConfiguration(n),{keys:A,overrides:d}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:p,removed:I,overrides:d}=y(this.remoteUserConfiguration,n),A=[...s,...p,...I];return A.length&&this.updateRemoteUserConfiguration(n),{keys:A,overrides:d}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:p,removed:I,overrides:d}=y(this.workspaceConfiguration,n),A=[...s,...p,...I];return A.length&&this.updateWorkspaceConfiguration(n),{keys:A,overrides:d}}compareAndUpdateFolderConfiguration(n,s){const p=this.p.get(n),{added:I,updated:d,removed:A,overrides:E}=y(p,s),a=[...I,...d,...A];return(a.length||!p)&&this.updateFolderConfiguration(n,s),{keys:a,overrides:E}}compareAndDeleteFolderConfiguration(n){const s=this.p.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:p,updated:I,removed:d,overrides:A}=y(s,void 0);return{keys:[...p,...I,...d],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,s,p){let I=this.r(s,p);return s.overrideIdentifier&&(I=I.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(I=I.merge(this.d)),I}r({resource:n},s){let p=this.s();if(s&&n){const I=s.getFolder(n);I&&(p=this.t(I.uri)||p);const d=this.m.get(n);d&&(p=p.merge(d))}return p}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let s=this.b.get(n);if(!s){const p=this.s(),I=this.j.get(n);I?(s=p.merge(I),this.b.set(n,s)):s=p}return s}u(n,s){if(s&&n){const p=s.getFolder(n);if(p)return this.j.get(p.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:p,overrides:I,keys:d}=this.j.get(s);return n.push([s,{contents:p,overrides:I,keys:d}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(p=>n.add(p))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(p=>n.add(p))),[...n.values()]}w(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(p=>s.add(p)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(p=>s.add(p)),this.i.getKeysForOverrideIdentifier(n).forEach(p=>s.add(p)),this.j.forEach(p=>p.getKeysForOverrideIdentifier(n).forEach(I=>s.add(I))),[...s.values()]}static parse(n){const s=this.x(n.defaults),p=this.x(n.policy),I=this.x(n.application),d=this.x(n.user),A=this.x(n.workspace),E=n.folders.reduce((a,o)=>(a.set(m.URI.revive(o[0]),this.x(o[1])),a),new T.$ji);return new c(s,p,I,d,new $,A,E,new $,new T.$ji)}static x(n){return new $(n.contents,n.keys,n.overrides)}}e.$bn=c;function w(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const n=new Set,s=new Map;for(const I of l)I.keys.forEach(d=>n.add(d)),I.overrides.forEach(([d,A])=>{const E=(0,T.$gi)(s,d,new Set);A.forEach(a=>E.add(a))});const p=[];return s.forEach((I,d)=>p.push([d,[...I.values()]])),{keys:[...n.values()],overrides:p}}e.$cn=w;class v{constructor(n,s,p,I){this.change=n,this.f=s,this.g=p,this.h=I,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const d of n.keys)this.affectedKeys.add(d);for(const[,d]of n.overrides)for(const A of d)this.affectedKeys.add(A);this.d=this.a;for(const d of this.affectedKeys)this.d+=d+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(n,s){const p=this.a+n,I=this.d.indexOf(p);if(I<0)return!1;const d=I+p.length;if(d>=this.d.length)return!1;const A=this.d.charCodeAt(d);if(A!==this.b&&A!==this.c)return!1;if(s){const E=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,a=this.g.getValue(n,s,this.h);return!f.$Hm(E,a)}return!0}}e.$dn=v;function y(l,n){const{added:s,removed:p,updated:I}=i(n?.rawConfiguration,l?.rawConfiguration),d=[],A=l?.getAllOverrideIdentifiers()||[],E=n?.getAllOverrideIdentifiers()||[];if(n){const a=E.filter(o=>!A.includes(o));for(const o of a)d.push([o,n.getKeysForOverrideIdentifier(o)])}if(l){const a=A.filter(o=>!E.includes(o));for(const o of a)d.push([o,l.getKeysForOverrideIdentifier(o)])}if(n&&l){for(const a of A)if(E.includes(a)){const o=i({contents:l.getOverrideValue(void 0,a)||{},keys:l.getKeysForOverrideIdentifier(a)},{contents:n.getOverrideValue(void 0,a)||{},keys:n.getKeysForOverrideIdentifier(a)});d.push([a,[...o.added,...o.removed,...o.updated]])}}return{added:s,removed:p,updated:I,overrides:d}}function i(l,n){const s=l?n?l.keys.filter(d=>n.keys.indexOf(d)===-1):[...l.keys]:[],p=n?l?n.keys.filter(d=>l.keys.indexOf(d)===-1):[...n.keys]:[],I=[];if(l&&n){for(const d of n.keys)if(l.keys.indexOf(d)!==-1){const A=(0,F.$Zh)(n.contents,d),E=(0,F.$Zh)(l.contents,d);f.$Hm(A,E)||I.push(d)}}return{added:s,removed:p,updated:I}}}),define(Re[97],Fe([1,0,9,3]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=e.RemoteAuthorityResolverErrorCode=e.$uk=e.$tk=e.RemoteConnectionType=e.$sk=void 0,e.$sk=(0,C.$lh)("remoteAuthorityResolverService");var S;(function(F){F[F.WebSocket=0]="WebSocket",F[F.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class z{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$tk=z;class T{constructor(D,h){this.host=D,this.port=h,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$uk=T;var f;(function(F){F.Unknown="Unknown",F.NotAvailable="NotAvailable",F.TemporarilyNotAvailable="TemporarilyNotAvailable",F.NoResolverFound="NoResolverFound"})(f||(e.RemoteAuthorityResolverErrorCode=f={}));class k extends g.$_{static isNotAvailable(D){return D instanceof k&&D._code===f.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof k&&D._code===f.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof k&&D._code===f.NoResolverFound}static isHandled(D){return D instanceof k&&D.isHandled}constructor(D,h=f.Unknown,b){super(D),this._message=D,this._code=h,this._detail=b,this.isHandled=h===f.NotAvailable&&b===!0,Object.setPrototypeOf(this,k.prototype)}}e.$vk=k;function m(F){const D=F.indexOf("+");return D===-1?F:F.substring(0,D)}e.$wk=m}),define(Re[50],Fe([1,0,14]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=void 0;function C(m){return m.scheme===g.Schemas.vscodeRemote?m.authority:void 0}e.$xk=C;function S(m){if(!m)return;const F=m.indexOf("+");return F<0?m:m.substr(0,F)}e.$yk=S;function z(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.$zk=z;function T(m){const{host:F,port:D}=k(m);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:F,port:D}}e.$Ak=T;function f(m,F){let{host:D,port:h}=k(m);return typeof h>"u"&&(h=F),{host:D,port:h}}e.$Bk=f;function k(m){const F=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(F)return{host:F[1],port:parseInt(F[2],10)};const D=m.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const h=m.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:m,port:void 0}}}),define(Re[24],Fe([1,0,13,3,50]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.TargetPlatform=e.ExtensionType=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=void 0,e.$xl="extensions.user.cache",e.$yl="extensions.builtin.cache",e.$zl="undefined_publisher",e.$Al=["ui","workspace","web"];function z(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.$Bl=z,e.$Cl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(T||(e.ExtensionType=T={}));var f;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(f||(e.TargetPlatform=f={}));class k{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,r){if(typeof t>"u"||t===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof t=="string"||typeof r=="string"){const c=typeof t=="string"?t:t.value,w=typeof r=="string"?r:r.value;return g.$Jd(c,w)}return t._lower===r._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Dl=k;class m{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const r of t)this.add(r)}add(t){this.c.add(k.toKey(t))}delete(t){return this.c.delete(k.toKey(t))}has(t){return this.c.has(k.toKey(t))}}e.$El=m;class F{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(k.toKey(t))}get(t){return this.c.get(k.toKey(t))}has(t){return this.c.has(k.toKey(t))}set(t,r){this.c.set(k.toKey(t),r)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fl=F;function D(u){return h(u)}e.$Gl=D;function h(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.$Hl=h;function b(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.$Il=b;function $(u,t){if(t){const r=`onResolveRemoteAuthority:${(0,S.$yk)(t)}`;return!!u.activationEvents?.includes(r)}return!1}e.$Jl=$,e.$Kl=(0,C.$lh)("IBuiltinExtensionsScannerService")}),define(Re[98],Fe([1,0,9,24]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=e.$UE=void 0;class S{constructor(){this.a=new Map,this.b=new WeakMap}register(T,f){this.a.set(T,f)}readActivationEvents(T){return this.b.has(T)||this.b.set(T,this.c(T)),this.b.get(T)}createActivationEventsMap(T){const f=Object.create(null);for(const k of T){const m=this.readActivationEvents(k);m.length>0&&(f[C.$Dl.toKey(k.identifier)]=m)}return f}c(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const f=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];if(!T.contributes)return f;for(const k in T.contributes){const m=this.a.get(k);if(!m)continue;const F=T.contributes[k],D=Array.isArray(F)?F:[F];try{m(D,f)}catch(h){(0,g.$X)(h)}}return f}}e.$UE=S,e.$VE=new S}),define(Re[177],Fe([1,0,21,51,36]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=void 0;function z(k){if(g.$t===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function T(k,m,F,D,h,b,$,u){const t=Object.create(null);t["common.machineId"]=b,t.sessionID=(0,S.$3e)()+Date.now(),t.commitHash=D,t.version=h,t["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,g.$h)(g.$t),t["common.nodePlatform"]=C.$5b,t["common.nodeArch"]=F,t["common.product"]=u||"desktop",$&&(t["common.msftInternal"]=$);let r=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),g.$l&&(t["common.snap"]="true");const w=z(m);return w&&(t["common.platformDetail"]=w),t}e.$Vn=T;function f(k){const m=C.env.USERDNSDOMAIN;if(!m)return!1;const F=m.toLowerCase();return k.some(D=>F===D)}e.$Wn=f}),define(Re[178],Fe([1,0,3]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0,e.$Rk=(0,g.$lh)("telemetryService"),e.$Sk=(0,g.$lh)("customEndpointTelemetryService"),e.$Tk="telemetry.currentSessionDate",e.$Uk="telemetry.firstSessionDate",e.$Vk="telemetry.lastSessionDate",e.$Wk="telemetry.machineId",e.$Xk="telemetry",e.$Yk="telemetry.telemetryLevel",e.$Zk="telemetry.enableCrashReporter",e.$1k="telemetry.enableTelemetry";var C;(function(z){z[z.NONE=0]="NONE",z[z.CRASH=1]="CRASH",z[z.ERROR=2]="ERROR",z[z.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var S;(function(z){z.OFF="off",z.CRASH="crash",z.ERROR="error",z.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(Re[52],Fe([1,0,23,10,5,43,50,177,178]),function(te,e,g,C,S,z,T,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0;class m{constructor(p){this.value=p,this.isTrustedTelemetryValue=!0}}e.$Xn=m;class F{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Yn=F,e.$Zn=new F;class D{async publicLog(p,I,d){}async publicLogError(p,I,d){}}e.$1n=D,e.$2n="telemetry",e.$3n="extensionTelemetryLog",e.$4n={log:()=>null,flush:()=>Promise.resolve(null)};function h(s,p){return S.Event.debounce(p.onDidChangeConfiguration,(d,A)=>{const E=d?new Set([...d.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:E}},1e3,!0)(d=>{d.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,z.$Uh)(d.source),configurationKeys:Array.from(d.affectedKeys)})})}e.$5n=h;function b(s,p){return!p.isBuilt&&!p.disableTelemetry?!0:!(p.disableTelemetry||!s.enableTelemetry||p.extensionTestsLocationURI)}e.$6n=b;function $(s,p){return!(p.isBuilt||p.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$7n=$;function u(s){const p=s.getValue(k.$Yk),I=s.getValue(k.$Zk);if(s.getValue(k.$1k)===!1||I===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$8n=u;function t(s){const p={},I={},d={};w(s,d);for(let A in d){A=A.length>150?A.substr(A.length-149):A;const E=d[A];typeof E=="number"?I[A]=E:typeof E=="boolean"?I[A]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${E.length}`),p[A]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(p[A]=E)}return{properties:p,measurements:I}}e.$9n=t;const r=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(s){if(!s)return"none";const p=(0,T.$yk)(s);return r.has(p)?p:"other"}e.$0n=c;function w(s,p,I=0,d){if(s)for(const A of Object.getOwnPropertyNames(s)){const E=s[A],a=d?d+A:A;Array.isArray(E)?p[a]=(0,g.$Im)(E):E instanceof Date?p[a]=E.toISOString():(0,C.$ie)(E)?I<2?w(E,p,I+1,a+"."):p[a]=(0,g.$Im)(E):p[a]=E}}function v(s,p){const I=s.msftInternalDomains||[],d=p.getValue("telemetry.internalTesting");return(0,f.$Wn)(I)||d}e.$$n=v;function y(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$_n=y;function i(s,p){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let I=s;const d=[];for(const o of p)for(;;){const L=o.exec(s);if(!L)break;d.push([L.index,o.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(I="";;){const o=E.exec(s);if(!o)break;const L=d.some(([B,G])=>o.index<G&&B<E.lastIndex);!A.test(o[0])&&!L&&(I+=s.substring(a,o.index)+"<REDACTED: user-file-path>",a=E.lastIndex)}return a<s.length&&(I+=s.substr(a)),I}function l(s){if(!s)return s;const p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const I of p)if(I.regex.test(s))return`<REDACTED: ${I.label}>`;return s}function n(s,p){return(0,g.$Fm)(s,I=>{if(I instanceof m||Object.hasOwnProperty.call(I,"isTrustedTelemetryValue"))return I.value;if(typeof I=="string"){let d=I.replaceAll("%20"," ");d=i(d,p);for(const A of p)d=d.replace(A,"");return d=l(d),d}})}e.$ao=n}),define(Re[179],Fe([1,0,13,92,24,21,2,9,51,52]),function(te,e,g,C,S,z,T,f,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0;function F(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,g.$Ed)(n.id,s.id)===0}e.$bo=F;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(s){const p=s.manifest?s.manifest.version:s.version,I=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new h(s.identifier,p,I)}static parse(s){const p=D.exec(s);return p&&p[1]&&p[2]?new h({id:p[1]},p[2],p[4]||void 0):null}constructor(s,p,I="undefined"){this.version=p,this.targetPlatform=I,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof h?F(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$co=h;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const s=b.exec(n);return s&&s[1]?[t(s[1]),s[2]]:[t(n),void 0]}e.$do=$;function u(n,s){return`${n}.${s}`}e.$eo=u;function t(n){return n.toLowerCase()}e.$fo=t;function r(n,s){return t(u(n??S.$zl,s))}e.$go=r;function c(n,s){const p=[],I=d=>{for(const A of p)if(A.some(E=>F(s(E),s(d))))return A;return null};for(const d of n){const A=I(d);A?A.push(d):p.push([d])}return p}e.$ho=c;function w(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$io=w;function v(n){return{id:new m.$Xn(n.identifier.id),name:new m.$Xn(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$jo=v,e.$ko=new S.$Dl("pprice.better-merge");function y(n,s){const p=[],I=s.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const d=I.shift();if(d&&p.every(A=>!F(A.identifier,{id:d}))){const A=n.filter(E=>F(E.identifier,{id:d}));A.length===1&&(p.push(A[0]),I.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.$lo=y;async function i(n,s){if(!z.$k)return!1;let p;try{p=(await n.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{p=(await n.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){s.debug("Error while getting the os-release file.",(0,f.$8)(d))}}return!!p&&(p.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(n,s){const p=await i(n,s),I=(0,C.$Gn)(p?"alpine":z.$t,k.$6b);return s.debug("ComputeTargetPlatform:",I),I}e.$mo=l}),define(Re[180],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=void 0;function g(k){return[...k.entries()]}e.$Vq=g;function C(k){return k?[...k.entries()]:[]}e.$Wq=C;function S(k){return new Map(k)}e.$Xq=S;function z(k){return new Map(k??[])}e.$Yq=z;function T(k){return Array.from(k.entries()).map(m=>[m[0],g(m[1].map),C(m[1].descriptionMap)])}e.$Zq=T;function f(k){return new Map(k.map(m=>[m[0],{map:S(m[1]),descriptionMap:z(m[2])}]))}e.$1q=f}),define(Re[181],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhb=void 0;class g{constructor(S){this.b=S,this.a=new Map}dispose(){for(const S of this.a.values())S.dispose()}startBuffering(S,z,T=5){const f=z(k=>{const m=typeof k=="string"?k:k.data;let F=this.a.get(S);if(F){F.data.push(m);return}const D=setTimeout(()=>this.flushBuffer(S),T);F={data:[m],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(S),f.dispose()}},this.a.set(S,F)});return f}stopBuffering(S){this.a.get(S)?.dispose()}flushBuffer(S){const z=this.a.get(S);z&&(this.a.delete(S),this.b(S,z.data.join("")))}}e.$Jhb=g}),define(Re[182],Fe([1,0,16,89,40,5,10,2,144,74,30]),function(te,e,g,C,S,z,T,f,k,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ju=e.$Iu=e.$Hu=e.$Gu=e.$Fu=e.$Eu=e.$Du=e.$Cu=e.IconFontDefinition=e.IconContribution=e.$Bu=void 0,e.$Bu={IconContribution:"base.contributions.icons"};var D;(function(v){function y(i,l){let n=i.defaults;for(;S.ThemeIcon.isThemeIcon(n);){const s=$.getIcon(n.id);if(!s)return;n=s.defaults}return n}v.getDefinition=y})(D||(e.IconContribution=D={}));var h;(function(v){function y(l){return{weight:l.weight,style:l.style,src:l.src.map(n=>({format:n.format,location:n.location.toString()}))}}v.toJSONObject=y;function i(l){const n=s=>(0,T.$ge)(s)?s:void 0;if(l&&Array.isArray(l.src)&&l.src.every(s=>(0,T.$ge)(s.format)&&(0,T.$ge)(s.location)))return{weight:n(l.weight),style:n(l.style),src:l.src.map(s=>({format:s.format,location:f.URI.parse(s.location)}))}}v.fromJSONObject=i})(h||(e.IconFontDefinition=h={}));class b{constructor(){this.a=new z.$5c,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${S.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(y,i,l,n){const s=this.b[y];if(s){if(l&&!s.description){s.description=l,this.d.properties[y].markdownDescription=`${l} $(${y})`;const d=this.e.enum.indexOf(y);d!==-1&&(this.e.enumDescriptions[d]=l),this.a.fire()}return s}const p={id:y,description:l,defaults:i,deprecationMessage:n};this.b[y]=p;const I={$ref:"#/definitions/icons"};return n&&(I.deprecationMessage=n),l&&(I.markdownDescription=`${l}: $(${y})`),this.d.properties[y]=I,this.e.enum.push(y),this.e.enumDescriptions.push(l||""),this.a.fire(),{id:y}}deregisterIcon(y){delete this.b[y],delete this.d.properties[y];const i=this.e.enum.indexOf(y);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(y=>this.b[y])}getIcon(y){return this.b[y]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(y,i){const l=this.f[y];return l||(this.f[y]=i,this.a.fire(),i)}deregisterIconFont(y){delete this.f[y]}getIconFont(y){return this.f[y]}toString(){const y=(s,p)=>s.id.localeCompare(p.id),i=s=>{for(;S.ThemeIcon.isThemeIcon(s.defaults);)s=this.b[s.defaults.id];return`codicon codicon-${s?s.id:""}`},l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(s=>this.b[s]);for(const s of n.filter(p=>!!p.description).sort(y))l.push(`|<i class="${i(s)}"></i>|${s.id}|${S.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const s of n.filter(p=>!S.ThemeIcon.isThemeIcon(p.defaults)).sort(y))l.push(`|<i class="${i(s)}"></i>|${s.id}|`);return l.join(`
`)}}const $=new b;F.$Pm.add(e.$Bu.IconContribution,$);function u(v,y,i,l){return $.registerIcon(v,y,i,l)}e.$Cu=u;function t(){return $}e.$Du=t;function r(){const v=(0,C.$wj)();for(const y in v){const i="\\"+v[y].toString(16);$.registerIcon(y,{fontCharacter:i})}}r(),e.$Eu="vscode://schemas/icons";const c=F.$Pm.as(m.$Qm.JSONContribution);c.registerSchema(e.$Eu,$.getIconSchema());const w=new g.$Cg(()=>c.notifySchemaChanged(e.$Eu),200);$.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.$Fu=u("widget-close",C.$yj.close,(0,k.localize)(2,null)),e.$Gu=u("goto-previous-location",C.$yj.arrowUp,(0,k.localize)(3,null)),e.$Hu=u("goto-next-location",C.$yj.arrowDown,(0,k.localize)(4,null)),e.$Iu=S.ThemeIcon.modify(C.$yj.sync,"spin"),e.$Ju=S.ThemeIcon.modify(C.$yj.loading,"spin")}),define(Re[183],Fe([1,0,5,43,3,15]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dz=e.$Cz=e.$Bz=e.$Az=e.$zz=e.$yz=e.$xz=e.$wz=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$vz=e.$uz=void 0,e.$uz=(0,S.$lh)("tunnelService"),e.$vz=(0,S.$lh)("sharedTunnelsService");var T;(function(u){u.Http="http",u.Https="https"})(T||(e.TunnelProtocol=T={}));var f;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(f||(e.TunnelPrivacyId=f={}));var k;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(k||(e.ProvidedOnAutoForward=k={}));function m(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(t)return{address:t[1],port:+t[2]}}e.$wz=m,e.$xz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(u){return e.$xz.indexOf(u)>=0}e.$yz=F,e.$zz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(u){return e.$zz.indexOf(u)>=0}e.$Az=D;function h(u,t,r,c){if(r===1)return!1;if(r===2&&D(t)){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(w?.length===4&&parseInt(w[1])>=18)return!1}return u<1024}e.$Bz=h;class b{constructor(t,r,c){this.remoteAddress=t,this.localAddress=r,this.b=c,this.a=new g.$5c,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Cz=b;let $=e.$Dz=class{constructor(t,r){this.i=t,this.j=r,this.a=new g.$5c,this.onTunnelOpened=this.a.event,this.b=new g.$5c,this.onTunnelClosed=this.b.event,this.c=new g.$5c,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const t=this.j.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.e=t,t?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.f=t.elevation,this.g=t.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const t=[],r=Array.from(this.d.values());for(const c of r){const w=Array.from(c.values());for(const v of w){const y=await v.value;y&&t.push(y)}}return t}async dispose(){for(const t of this.d.values()){for(const{value:r}of t.values())await r.then(c=>c?.dispose());t.clear()}this.d.clear()}setEnvironmentTunnel(t,r,c,w,v){this.o(t,r,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:r,localAddress:c,privacy:w,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,r){(D(t)||F(t))&&(t=e.$xz[0]);const c=this.q(t,r);if(c)return++c.refcount,c.value}openTunnel(t,r,c,w,v,y=!1,i,l){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${c} on local port ${v}.`),!t)return;if(r||(r="localhost"),w||(w=this.k),this.e&&this.h.has(c)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.r(t,r,c,w,v,y,i,l);return n?n.then(s=>{if(!s){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(r,c);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.m(s);return(s.tunnelRemoteHost!==r||s.tunnelRemotePort!==c)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&s.privacy!==i&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}m(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const r=this.d.get(t.tunnelRemoteHost);if(r){const c=r.get(t.tunnelRemotePort);c&&(c.refcount--,await this.n(t.tunnelRemoteHost,t.tunnelRemotePort,c))}}}}async n(t,r,c){if(c.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${r}.`);const w=c.value.then(async v=>{v&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.d.has(t)&&this.d.get(t).delete(r),w}}async closeTunnel(t,r){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${r} `);const c=this.d.get(t);if(c&&c.has(r)){const w=c.get(r);w.refcount=0,await this.n(t,r,w)}}o(t,r,c){this.d.has(t)||this.d.set(t,new Map),this.d.get(t).set(r,{refcount:1,value:c})}async p(t,r){const c=this.d.get(t);if(c){const w=c.get(r);(w?await w.value:void 0)||c.delete(r),c.size===0&&this.d.delete(t)}}q(t,r){const c=[t];F(t)?(c.push(...e.$xz),c.push(...e.$zz)):D(t)&&c.push(...e.$zz);const w=c.map(v=>this.d.get(v));for(const v of w){const y=v?.get(r);if(y)return y}}canTunnel(t){return!!m(t)}s(t,r,c,w,v,y,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${c} on local port ${w}.`);const l=c;this.h.add(l);const n=w===void 0?c:w,s={elevationRequired:v?this.isPortPrivileged(n):!1},p={remoteAddress:{host:r,port:c},localAddressPort:w,privacy:y,public:y?y!==f.Private:void 0,protocol:i},I=t.forwardPort(p,s);return I?(this.o(r,c,I),I.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(l)})):this.h.delete(l),I}};e.$Dz=$=qe([Ve(0,z.$Ni),Ve(1,C.$Rh)],$)}),define(Re[184],Fe([1,0,3]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Ez=void 0,e.$Ez=(0,g.$lh)("editSessionIdentityService");var C;(function(S){S[S.Complete=100]="Complete",S[S.Partial=50]="Partial",S[S.None=0]="None"})(C||(e.EditSessionIdentityMatch=C={}))}),define(Re[185],Fe([1,0,14]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LI=e.$KI=e.$JI=e.$II=e.$HI=void 0;function C(k){return k.scheme!==g.Schemas.file&&k.scheme!==g.Schemas.vscodeRemote}e.$HI=C;function S(k){if(k.folders.length)return k.folders.every(m=>C(m.uri))?k.folders[0].uri:void 0;if(k.configuration&&C(k.configuration))return k.configuration}e.$II=S;function z(k){return S(k)?.scheme}e.$JI=z;function T(k){return S(k)?.authority}e.$KI=T;function f(k){return S(k)!==void 0}e.$LI=f}),define(Re[53],Fe([1,0,145,19,48,20,2,3,14]),function(te,e,g,C,S,z,T,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.WorkbenchState=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$uh=(0,f.$lh)("contextService");function m(s){const p=s;return typeof p?.id=="string"&&T.URI.isUri(p.uri)}e.$vh=m;function F(s){return typeof s?.id=="string"&&!m(s)&&!h(s)}e.$wh=F,e.$xh={id:"ext-dev"},e.$yh={id:"empty-window"};function D(s,p){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,C.$cc)(s)}:p?e.$xh:e.$yh;const I=s;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}e.$zh=D;function h(s){const p=s;return typeof p?.id=="string"&&T.URI.isUri(p.configPath)}e.$Ah=h;function b(s){const p=s;if(p?.uri)return{id:p.id,uri:T.URI.revive(p.uri)};const I=s;if(I?.configPath)return{id:I.id,configPath:T.URI.revive(I.configPath)};if(s?.id)return{id:s.id}}e.$Bh=b;var $;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function u(s){const p=s;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.$Ch=u;function t(s){const p=s;return!!(p&&typeof p=="object"&&T.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.$Dh=t;class r{constructor(p,I,d,A,E){this.h=p,this.j=d,this.k=A,this.l=E,this.c=S.$rh.forUris(this.l,()=>!0),this.folders=I}update(p){this.h=p.id,this.k=p.configuration,this.j=p.transient,this.l=p.l,this.folders=p.folders}get folders(){return this.g}set folders(p){this.g=p,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(p){this.k=p}getFolder(p){return p&&this.c.findSubstr(p)||null}n(){this.c=S.$rh.forUris(this.l,()=>!0);for(const p of this.folders)this.c.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Eh=r;class c{constructor(p,I){this.raw=I,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,z.$6f)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Fh=c;function w(s){return new c({uri:s,index:0,name:(0,z.$2f)(s)},{uri:s.toString()})}e.$Gh=w,e.$Hh="code-workspace",e.$Ih=`.${e.$Hh}`,e.$Jh=[{name:(0,g.localize)(0,null),extensions:[e.$Hh]}],e.$Kh="workspace.json";function v(s,p){return z.$Wf.isEqualOrParent(s,p.untitledWorkspacesHome)}e.$Lh=v;function y(s){let p;return T.URI.isUri(s)?p=s:p=s.configuration,p?.scheme===k.Schemas.tmp}e.$Mh=y,e.$Nh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$Nh}e.$Oh=i;function l(s,p){return!v(s,p)&&!y(s)}e.$Ph=l;function n(s){return(typeof s=="string"?(0,C.$dc)(s):(0,z.$4f)(s))===e.$Ih}e.$Qh=n}),define(Re[54],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N0b=void 0;class g{constructor(S){this.d=S,this.b=new Map,this.c=1}add(S){const z=this.c++;return this.b.set(z,S),this.e(),z}get(S,z){return this.b.has(S)?this.b.get(S)[z]:void 0}delete(S){this.b.delete(S),this.e()}e(){g.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$N0b=g,g.a=!1}),define(Re[39],Fe([1,0,14,20,3]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q0b=e.$P0b=void 0;class z{constructor(){this.a=new Set(Object.keys(g.Schemas)),this.b=new Map,this.extUri=new C.$Uf(f=>{const k=this.b.get(f.scheme);return!(k===void 0||k&1024)})}$acceptProviderInfos(f,k){k===null?this.b.delete(f.scheme):this.b.set(f.scheme,k)}isFreeScheme(f){return!this.b.has(f)&&!this.a.has(f)}getCapabilities(f){return this.b.get(f)}}e.$P0b=z,e.$Q0b=(0,S.$lh)("IExtHostFileSystemInfo")}),define(Re[27],Fe([1,0,3]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=void 0,e.$qL=(0,g.$lh)("IExtHostInitDataService")}),define(Re[186],Fe([1,0,150,15,172,27]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S_b=void 0;let T=e.$S_b=class extends S.$wM{constructor(k,m,F){const D=F.remote.isRemote?"remoteexthost":k?"workerexthost":"exthost",h=F.remote.isRemote?(0,g.localize)(0,null):k?(0,g.localize)(1,null):(0,g.localize)(2,null);super(m.createLogger(D,{name:h}))}};e.$S_b=T=qe([Ve(1,C.$Oi),Ve(2,z.$qL)],T)}),define(Re[187],Fe([1,0,16]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h$b=e.$g$b=void 0;class C{constructor(T,f,k){this.h=new Map,this.a=T,this.b=f,this.c=k,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(m=>(this.f=m,this)),this.g=this.c.onDidChangeStorage(m=>{m.shared===this.b&&m.key===this.a&&(this.f=m.value)}),this.i=new g.$Cg(()=>{const m=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const F of m.values())F.complete()}catch(F){for(const D of m.values())D.error(F)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this.d}get(T,f){let k=this.f[T];return typeof k>"u"&&(k=f),k}update(T,f){this.f[T]=f;const k=this.h.get(T);if(k!==void 0)return k.p;const m=new g.$Lg;return this.h.set(T,m),this.i.isScheduled()||this.i.schedule(),m.p}dispose(){this.g.dispose()}}e.$g$b=C;class S extends C{setKeysForSync(T){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},T)}constructor(T,f){super(T.identifier.value,!0,f),this.j=T}}e.$h$b=S}),define(Re[188],Fe([1,0,5,2]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_b=void 0;class S{constructor(T){this.c=T,this.a=new g.$5c,this.onDidSaveNotebookDocument=this.a.event,this.b=new g.$5c,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(T,f,k,m){const D=this.c.getNotebookDocument(C.URI.revive(T)).acceptModelChanged(f.value,k,m);this.b.fire(D)}$acceptDirtyStateChanged(T,f){this.c.getNotebookDocument(C.URI.revive(T)).acceptDirty(f)}$acceptModelSaved(T){const f=this.c.getNotebookDocument(C.URI.revive(T));this.a.fire(f.apiNotebook)}}e.$F_b=S}),define(Re[17],Fe([1,0,3]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bL=e.$aL=void 0,e.$aL=(0,g.$lh)("IExtHostRpcService");class C{constructor(z){this.getProxy=z.getProxy.bind(z),this.set=z.set.bind(z),this.dispose=z.dispose.bind(z),this.assertRegistered=z.assertRegistered.bind(z),this.drain=z.drain.bind(z)}}e.$bL=C});var Ye=this&&this.__classPrivateFieldSet||function(te,e,g,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Te=this&&this.__classPrivateFieldGet||function(te,e,g,C){if(g==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?C:g==="a"?C.call(te):C?C.value:e.get(te)};define(Re[189],Fe([1,0,24,5]),function(te,e,g,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$s$b=void 0;class z{constructor(f,k){S.set(this,void 0),this.b=new C.$5c,this.onDidChange=this.b.event,this.a=g.$Dl.toKey(f.identifier),Ye(this,S,k,"f"),Te(this,S,"f").onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(f){return Te(this,S,"f").get(this.a,f)}store(f,k){return Te(this,S,"f").store(this.a,f,k)}delete(f){return Te(this,S,"f").delete(this.a,f)}}e.$s$b=z,S=new WeakMap}),define(Re[75],Fe([1,0,3,183,5,17]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kob=e.$job=e.TunnelDtoConverter=void 0;var T;(function(k){function m(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:D.protocol}}k.fromApiTunnel=m;function F(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==C.TunnelPrivacyId.ConstantPrivate&&D.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}k.fromServiceTunnel=F})(T||(e.TunnelDtoConverter=T={})),e.$job=(0,g.$lh)("IExtHostTunnelService");let f=e.$kob=class{constructor(m){this.onDidChangeTunnels=new S.$5c().event}async $applyCandidateFilter(m){return m}async openTunnel(m,F){}async getTunnels(){return[]}async setTunnelFactory(m){return{dispose:()=>{}}}registerPortsAttributesProvider(m,F){return{dispose:()=>{}}}async $providePortAttributes(m,F,D,h,b){return[]}async $forwardPort(m,F){}async $closeTunnel(m){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.$kob=f=qe([Ve(0,z.$aL)],f)}),define(Re[55],Fe([1,0,3]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$20b=e.$10b=void 0,e.$10b=(0,g.$lh)("IURITransformerService");class C{constructor(z){z?(this.transformIncoming=z.transformIncoming.bind(z),this.transformOutgoing=z.transformOutgoing.bind(z),this.transformOutgoingURI=z.transformOutgoingURI.bind(z),this.transformOutgoingScheme=z.transformOutgoingScheme.bind(z)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.$20b=C}),define(Re[190],Fe([1,0,25]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F9=e.$E9=void 0;class C{constructor(){this.buffers=[]}add(k){let m=this.buffers.indexOf(k);return m<0&&(m=this.buffers.length,this.buffers.push(k)),m}}function S(f,k){if(k.serializeBuffersForPostMessage){const m=new C,D=JSON.stringify(f,(b,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:m.add($)};if(ArrayBuffer.isView($)){const u=z($);if(u)return{$$vscode_array_buffer_reference$$:!0,index:m.add($.buffer),view:{type:u,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),h=m.buffers.map(b=>{const $=new Uint8Array(b);return g.$Ib.wrap($)});return{message:D,buffers:h}}else return{message:JSON.stringify(f),buffers:[]}}e.$E9=S;function z(f){switch(f.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(f,k){const m=k.map(h=>{const b=new ArrayBuffer(h.byteLength);return new Uint8Array(b).set(h.buffer),b}),F=k.length?(h,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const $=b,{index:u}=$,t=m[u];if($.view)switch($.view.type){case 1:return new Int8Array(t,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse(f,F),arrayBuffers:m}}e.$F9=T}),define(Re[99],Fe([1,0,157,10,2,6,3,30,38,14,41,127,29]),function(te,e,g,C,S,z,T,f,k,m,F,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pE=e.$oE=e.$nE=e.EditorsOrder=e.$mE=e.CloseDirection=e.$lE=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=e.$dE=e.EditorInputCapabilities=e.$cE=e.SaveReason=e.Verbosity=e.$bE=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=e.$8D=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=void 0,e.$3D={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$4D={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.$5D="workbench.editor.sidebysideEditor",e.$6D="workbench.editors.textDiffEditor",e.$7D="workbench.editors.binaryResourceDiffEditor";var b;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var $;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function u(Y){const ce=Y;return!!ce&&typeof ce.getSelection=="function"&&!!ce.onDidChangeSelection}e.$8D=u;function t(Y,ce,ke){for(const Ce of ke.visibleEditorPanes)if(Ce.group.id===ce&&Y.matches(Ce.input))return Ce.getViewState()}e.$9D=t;function r(Y){if(I(Y))return!1;const ce=Y;return S.URI.isUri(ce?.resource)}e.$0D=r;function c(Y){if(I(Y))return!1;const ce=Y;return ce?.original!==void 0&&ce.modified!==void 0}e.$$D=c;function w(Y){if(I(Y)||c(Y))return!1;const ce=Y;return ce?.primary!==void 0&&ce.secondary!==void 0}e.$_D=w;function v(Y){if(I(Y))return!1;const ce=Y;return ce?ce.resource===void 0||ce.resource.scheme===m.Schemas.untitled||ce.forceUntitled===!0:!1}e.$aE=v;function y(Y){if(I(Y))return!1;const ce=Y;return S.URI.isUri(ce?.base?.resource)&&S.URI.isUri(ce?.input1?.resource)&&S.URI.isUri(ce?.input2?.resource)&&S.URI.isUri(ce?.result?.resource)}e.$bE=y;var i;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(i||(e.Verbosity=i={}));var l;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class n{constructor(){this.a=new Map}registerSource(ce,ke){let Ce=this.a.get(ce);return Ce||(Ce={source:ce,label:ke},this.a.set(ce,Ce)),Ce.source}getSourceLabel(ce){return this.a.get(ce)?.label??ce}}e.$cE=new n;var s;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(s||(e.EditorInputCapabilities=s={}));class p extends z.$kb{}e.$dE=p;function I(Y){return Y instanceof p}e.$eE=I;function d(Y){const ce=Y;return S.URI.isUri(ce?.preferredResource)}function A(Y){const ce=Y;return I(ce?.primary)&&I(ce?.secondary)}e.$fE=A;function E(Y){const ce=Y;return I(ce?.modified)&&I(ce?.original)}e.$gE=E;function a(Y,ce,ke,Ce,me){return _(Ce,[(0,D.$8h)({id:"workbench.action.openLargeFile",label:(0,g.localize)(2,null),run:()=>{const R={...ke,limits:{size:Number.MAX_VALUE}};Y.openEditor(ce,R)}}),(0,D.$8h)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,g.localize)(3,null),run:()=>me.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}e.$hE=a;function o(Y){return I(Y?.editor)}e.$iE=o;function L(Y){const ce=Y;return o(Y)&&ce?.group!==void 0}e.$jE=L;function B(Y){const ce=Y;return typeof ce?.groupId=="number"&&I(ce.editor)}e.$kE=B;var G;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(G||(e.EditorCloseContext=G={}));var q;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LOCKED=2]="GROUP_LOCKED",Y[Y.EDITOR_OPEN=3]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=4]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=5]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=7]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=9]="EDITOR_PIN",Y[Y.EDITOR_STICKY=10]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=11]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(q||(e.GroupModelChangeKind=q={}));var W;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class N{getOriginalUri(ce,ke){if(!ce)return;if(y(ce))return e.$lE.getOriginalUri(ce.result,ke);if(ke?.supportSideBySide){const{primary:me,secondary:R}=this.a(ce);if(me&&R){if(ke?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(me,{filterByScheme:ke.filterByScheme}),secondary:this.getOriginalUri(R,{filterByScheme:ke.filterByScheme})};if(ke?.supportSideBySide===W.ANY)return this.getOriginalUri(me,{filterByScheme:ke.filterByScheme})??this.getOriginalUri(R,{filterByScheme:ke.filterByScheme});ce=ke.supportSideBySide===W.PRIMARY?me:R}}if(c(ce)||w(ce)||y(ce))return;const Ce=d(ce)?ce.preferredResource:ce.resource;return!Ce||!ke||!ke.filterByScheme?Ce:this.b(Ce,ke.filterByScheme)}a(ce){return A(ce)||w(ce)?{primary:ce.primary,secondary:ce.secondary}:E(ce)||c(ce)?{primary:ce.modified,secondary:ce.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ce,ke){if(!ce)return;if(y(ce))return e.$lE.getCanonicalUri(ce.result,ke);if(ke?.supportSideBySide){const{primary:me,secondary:R}=this.a(ce);if(me&&R){if(ke?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(me,{filterByScheme:ke.filterByScheme}),secondary:this.getCanonicalUri(R,{filterByScheme:ke.filterByScheme})};if(ke?.supportSideBySide===W.ANY)return this.getCanonicalUri(me,{filterByScheme:ke.filterByScheme})??this.getCanonicalUri(R,{filterByScheme:ke.filterByScheme});ce=ke.supportSideBySide===W.PRIMARY?me:R}}if(c(ce)||w(ce)||y(ce))return;const Ce=ce.resource;return!Ce||!ke||!ke.filterByScheme?Ce:this.b(Ce,ke.filterByScheme)}b(ce,ke){if(Array.isArray(ke)){if(ke.some(Ce=>ce.scheme===Ce))return ce}else if(ke===ce.scheme)return ce}}e.$lE=new N;var H;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(H||(e.CloseDirection=H={}));class j{constructor(){this.c=new Map,this.d=new Map}start(ce){const ke=this.a=ce.get(T.$kh);for(const[Ce,me]of this.c)this.e(Ce,me,ke);this.c.clear()}e(ce,ke,Ce){const me=Ce.createInstance(ke);this.d.set(ce,me)}registerFileEditorFactory(ce){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ce}getFileEditorFactory(){return(0,C.$re)(this.b)}registerEditorSerializer(ce,ke){if(this.c.has(ce)||this.d.has(ce))throw new Error(`A editor serializer with type ID '${ce}' was already registered.`);return this.a?this.e(ce,ke,this.a):this.c.set(ce,ke),(0,z.$ib)(()=>{this.c.delete(ce),this.d.delete(ce)})}getEditorSerializer(ce){return this.d.get(typeof ce=="string"?ce:ce.typeId)}}f.$Pm.add(e.$3D.EditorFactory,new j);async function O(Y,ce,ke){return!Y||!Y.length?[]:await Promise.all(Y.map(async Ce=>{const me=S.URI.revive(Ce.fileUri);if(!me){ke.info("Cannot resolve the path because it is not valid.",Ce);return}if(!await ce.canHandleResource(me)){ke.info("Cannot resolve the path because it cannot be handled",Ce);return}let Q=Ce.exists,he=Ce.type;if(typeof Q!="boolean"||typeof he!="number")try{he=(await ce.stat(me)).isDirectory?k.FileType.Directory:k.FileType.Unknown,Q=!0}catch(ye){ke.error(ye),Q=!1}if(!Q&&Ce.openOnlyIfExists){ke.info("Cannot resolve the path because it does not exist",Ce);return}if(he===k.FileType.Directory){ke.info("Cannot resolve the path because it is a directory",Ce);return}const De={...Ce.options,pinned:!0};return Q?{resource:me,options:De}:{resource:me,options:De,forceUntitled:!0}}))}e.$mE=O;var ue;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function pe(Y){const ce=Y;if(!ce)return!1;const ke=ce;if(ke.modified)return pe(ke.modified);const Ce=ce;return!!(Ce.contributionsState&&Ce.viewState&&Array.isArray(Ce.cursorState))}e.$nE=pe;function Pe(Y){return(0,F.$0h)(Y)}e.$oE=Pe;function _(Y,ce,ke){const Ce=(0,F.$$h)(Y,ce);return Ce.forceMessage=ke?.forceMessage,Ce.forceSeverity=ke?.forceSeverity,Ce.allowDialog=ke?.allowDialog,Ce}e.$pE=_}),define(Re[191],Fe([1,0,5,158,3,6,28,30,18,64,23,89,182]),function(te,e,g,C,S,z,T,f,k,m,F,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wE=e.$vE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$uE=e.$tE=e.ViewContentGroups=e.$sE=e.$rE=e.ViewContainerLocation=e.Extensions=e.$qE=void 0,e.$qE=(0,h.$Cu)("default-view-icon",D.$yj.window,(0,C.localize)(0,null));var b;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var $;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$rE=[0,1,2];function u(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$sE=u;class t extends z.$kb{constructor(){super(...arguments),this.c=this.B(new g.$5c),this.onDidRegister=this.c.event,this.f=this.B(new g.$5c),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,k.$vf)([...this.g.values()])}registerViewContainer(s,p,I){const d=this.get(s.id);if(d)return d;const A=s;return A.openCommandActionDescriptor=I?.doNotRegisterOpenCommand?void 0:A.openCommandActionDescriptor??{id:A.id},(0,T.$gi)(this.g,p,[]).push(A),I?.isDefault&&this.h.push(A),this.c.fire({viewContainer:A,viewContainerLocation:p}),A}deregisterViewContainer(s){for(const p of this.g.keys()){const I=this.g.get(p),d=I?.indexOf(s);if(d!==-1){I?.splice(d,1),I.length===0&&this.g.delete(p),this.f.fire({viewContainer:s,viewContainerLocation:p});return}}}get(s){return this.all.filter(p=>p.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(p=>this.getViewContainers(p).filter(I=>I?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(p=>this.getViewContainerLocation(p)===s)}}f.$Pm.add(b.ViewContainersRegistry,new t);var r;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(r||(e.ViewContentGroups=r={}));function c(n,s){const p=n.group??r.More,I=s.group??r.More;return p!==I?p.localeCompare(I):(n.order??5)-(s.order??5)}class w extends z.$kb{constructor(){super(...arguments),this.c=this.B(new g.$5c),this.onViewsRegistered=this.c.event,this.f=this.B(new g.$5c),this.onViewsDeregistered=this.f.event,this.g=this.B(new g.$5c),this.onDidChangeContainer=this.g.event,this.h=this.B(new g.$5c),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new m.$L}registerViews(s,p){this.registerViews2([{views:s,viewContainer:p}])}registerViews2(s){s.forEach(({views:p,viewContainer:I})=>this.l(p,I)),this.c.fire(s)}deregisterViews(s,p){const I=this.m(s,p);I.length&&this.f.fire({views:I,viewContainer:p})}moveViews(s,p){for(const I of this.j.keys())if(I!==p){const d=this.m(s,I);d.length&&(this.l(d,p),this.g.fire({views:d,from:I,to:p}))}}getViews(s){return this.j.get(s)||[]}getView(s){for(const p of this.i){const I=(this.j.get(p)||[]).filter(d=>d.id===s)[0];if(I)return I}return null}getViewContainer(s){for(const p of this.i)if((this.j.get(p)||[]).filter(d=>d.id===s)[0])return p;return null}registerViewWelcomeContent(s,p){return this.k.add(s,p),this.h.fire(s),(0,z.$ib)(()=>{this.k.delete(s,p),this.h.fire(s)})}registerViewWelcomeContent2(s,p){const I=new Map;for(const[d,A]of p)this.k.add(s,A),I.set(d,(0,z.$ib)(()=>{this.k.delete(s,A),this.h.fire(s)}));return this.h.fire(s),I}getViewWelcomeContent(s){const p=[];return this.k.forEach(s,I=>p.push(I)),p.sort(c)}l(s,p){let I=this.j.get(p);I||(I=[],this.j.set(p,I),this.i.push(p));for(const d of s){if(this.getView(d.id)!==null)throw new Error((0,C.localize)(1,null,d.id));I.push(d)}}m(s,p){const I=this.j.get(p);if(!I)return[];const d=[],A=[];for(const E of I)s.includes(E)?d.push(E):A.push(E);return d.length&&(A.length?this.j.set(p,A):(this.j.delete(p),this.i.splice(this.i.indexOf(p),1))),d}}f.$Pm.add(b.ViewsRegistry,new w),e.$tE=(0,S.$lh)("viewsService"),e.$uE=(0,S.$lh)("viewDescriptorService");var v;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(v||(e.ViewVisibilityState=v={}));var y;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(y||(e.TreeItemCollapsibleState=y={}));class i{constructor(s,p){this.c=!1,this.d=!1,(0,F.$Gm)(this,s),this.d=!!p,this.resolve=async I=>{if(p&&!this.c){const d=await p(I);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}I.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$vE=i;class l extends Error{constructor(s){super((0,C.localize)(2,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$wE=l}),define(Re[192],Fe([1,0,5,16,159]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$9=void 0;class z{constructor(){this.f=new Map,this.k=[],this.m=new g.$5c,this.n=new g.$5c,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(f){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=f}onEvent(f){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=f}onRequest(f){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=f}sendResponse(f){f.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${f.command}`)):this.s("response",f)}sendRequest(f,k,m,F){const D={command:f};if(k&&Object.keys(k).length>0&&(D.arguments=k),this.s("request",D),typeof F=="number"){const h=setTimeout(()=>{clearTimeout(h);const b=this.f.get(D.seq);if(b){this.f.delete(D.seq);const $={type:"response",seq:0,request_seq:D.seq,success:!1,command:f,message:(0,S.localize)(0,null,F,f)};b($)}},F)}return m&&this.f.set(D.seq,m),D.seq}acceptMessage(f){this.j?this.j(f):(this.k.push(f),this.k.length===1&&this.q())}o(f,k){return f.type!=="event"||k.type!=="event"}async q(){let f;for(;this.k.length;){if((!f||this.o(this.k[0],f))&&await(0,C.$sg)(0),f=this.k.shift(),!f)return;switch(f.type){case"event":this.i?.(f);break;case"request":this.g?.(f);break;case"response":{const k=f,m=this.f.get(k.request_seq);m&&(this.f.delete(k.request_seq),m(k));break}}}}s(f,k){k.type=f,k.seq=this.d++,this.sendMessage(k)}async u(){if(this.f.size===0)return Promise.resolve();const f=new Map;this.f.forEach((k,m)=>f.set(m,k)),await(0,C.$sg)(500),f.forEach((k,m)=>{k({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.f.delete(m)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$$9=z}),define(Re[193],Fe([1,0,160,31,3]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$HG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$GG=e.MemoryRangeType=e.$FG=e.State=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=void 0,e.$DF="workbench.view.debug",e.$EF="workbench.debug.variablesView",e.$FF="workbench.debug.watchExpressionsView",e.$GF="workbench.debug.callStackView",e.$HF="workbench.debug.loadedScriptsView",e.$IF="workbench.debug.breakPointsView",e.$JF="workbench.debug.disassemblyView",e.$KF="workbench.panel.repl",e.$LF="workbench.panel.repl.view",e.$MF=new C.$Ki("debugType",void 0,{type:"string",description:g.localize(0,null)}),e.$NF=new C.$Ki("debugConfigurationType",void 0,{type:"string",description:g.localize(1,null)}),e.$OF=new C.$Ki("debugState","inactive",{type:"string",description:g.localize(2,null)}),e.$PF="debugUx",e.$QF=new C.$Ki(e.$PF,"default",{type:"string",description:g.localize(3,null)}),e.$RF=new C.$Ki("hasDebugged",!1,{type:"boolean",description:g.localize(4,null)}),e.$SF=new C.$Ki("inDebugMode",!1,{type:"boolean",description:g.localize(5,null)}),e.$TF=new C.$Ki("inDebugRepl",!1,{type:"boolean",description:g.localize(6,null)}),e.$UF=new C.$Ki("breakpointWidgetVisible",!1,{type:"boolean",description:g.localize(7,null)}),e.$VF=new C.$Ki("inBreakpointWidget",!1,{type:"boolean",description:g.localize(8,null)}),e.$WF=new C.$Ki("breakpointsFocused",!0,{type:"boolean",description:g.localize(9,null)}),e.$XF=new C.$Ki("watchExpressionsFocused",!0,{type:"boolean",description:g.localize(10,null)}),e.$YF=new C.$Ki("watchExpressionsExist",!1,{type:"boolean",description:g.localize(11,null)}),e.$ZF=new C.$Ki("variablesFocused",!0,{type:"boolean",description:g.localize(12,null)}),e.$1F=new C.$Ki("expressionSelected",!1,{type:"boolean",description:g.localize(13,null)}),e.$2F=new C.$Ki("breakpointInputFocused",!1,{type:"boolean",description:g.localize(14,null)}),e.$3F=new C.$Ki("callStackItemType",void 0,{type:"string",description:g.localize(15,null)}),e.$4F=new C.$Ki("callStackSessionIsAttach",!1,{type:"boolean",description:g.localize(16,null)}),e.$5F=new C.$Ki("callStackItemStopped",!1,{type:"boolean",description:g.localize(17,null)}),e.$6F=new C.$Ki("callStackSessionHasOneThread",!1,{type:"boolean",description:g.localize(18,null)}),e.$7F=new C.$Ki("watchItemType",void 0,{type:"string",description:g.localize(19,null)}),e.$8F=new C.$Ki("canViewMemory",void 0,{type:"boolean",description:g.localize(20,null)}),e.$9F=new C.$Ki("breakpointItemType",void 0,{type:"string",description:g.localize(21,null)}),e.$0F=new C.$Ki("breakpointSupportsCondition",!1,{type:"boolean",description:g.localize(22,null)}),e.$$F=new C.$Ki("loadedScriptsSupported",!1,{type:"boolean",description:g.localize(23,null)}),e.$_F=new C.$Ki("loadedScriptsItemType",void 0,{type:"string",description:g.localize(24,null)}),e.$aG=new C.$Ki("focusedSessionIsAttach",!1,{type:"boolean",description:g.localize(25,null)}),e.$bG=new C.$Ki("stepBackSupported",!1,{type:"boolean",description:g.localize(26,null)}),e.$cG=new C.$Ki("restartFrameSupported",!1,{type:"boolean",description:g.localize(27,null)}),e.$dG=new C.$Ki("stackFrameSupportsRestart",!1,{type:"boolean",description:g.localize(28,null)}),e.$eG=new C.$Ki("jumpToCursorSupported",!1,{type:"boolean",description:g.localize(29,null)}),e.$fG=new C.$Ki("stepIntoTargetsSupported",!1,{type:"boolean",description:g.localize(30,null)}),e.$gG=new C.$Ki("breakpointsExist",!1,{type:"boolean",description:g.localize(31,null)}),e.$hG=new C.$Ki("debuggersAvailable",!1,{type:"boolean",description:g.localize(32,null)}),e.$iG=new C.$Ki("debugExtensionAvailable",!0,{type:"boolean",description:g.localize(33,null)}),e.$jG=new C.$Ki("debugProtocolVariableMenuContext",void 0,{type:"string",description:g.localize(34,null)}),e.$kG=new C.$Ki("debugSetVariableSupported",!1,{type:"boolean",description:g.localize(35,null)}),e.$lG=new C.$Ki("debugSetExpressionSupported",!1,{type:"boolean",description:g.localize(36,null)}),e.$mG=new C.$Ki("breakWhenValueChangesSupported",!1,{type:"boolean",description:g.localize(37,null)}),e.$nG=new C.$Ki("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:g.localize(38,null)}),e.$oG=new C.$Ki("breakWhenValueIsReadSupported",!1,{type:"boolean",description:g.localize(39,null)}),e.$pG=new C.$Ki("terminateDebuggeeSupported",!1,{type:"boolean",description:g.localize(40,null)}),e.$qG=new C.$Ki("suspendDebuggeeSupported",!1,{type:"boolean",description:g.localize(41,null)}),e.$rG=new C.$Ki("variableEvaluateNamePresent",!1,{type:"boolean",description:g.localize(42,null)}),e.$sG=new C.$Ki("variableIsReadonly",!1,{type:"boolean",description:g.localize(43,null)}),e.$tG=new C.$Ki("exceptionWidgetVisible",!1,{type:"boolean",description:g.localize(44,null)}),e.$uG=new C.$Ki("multiSessionRepl",!1,{type:"boolean",description:g.localize(45,null)}),e.$vG=new C.$Ki("multiSessionDebug",!1,{type:"boolean",description:g.localize(46,null)}),e.$wG=new C.$Ki("disassembleRequestSupported",!1,{type:"boolean",description:g.localize(47,null)}),e.$xG=new C.$Ki("disassemblyViewFocus",!1,{type:"boolean",description:g.localize(48,null)}),e.$yG=new C.$Ki("languageSupportsDisassembleRequest",!1,{type:"boolean",description:g.localize(49,null)}),e.$zG=new C.$Ki("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:g.localize(50,null)});const z=h=>g.localize(51,null,h);e.$AG=z,e.$BG="editor.contrib.debug",e.$CG="editor.contrib.breakpoint",e.$DG="debug",e.$EG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:g.localize(52,null)};var T;(function(h){h[h.Inactive=0]="Inactive",h[h.Initializing=1]="Initializing",h[h.Stopped=2]="Stopped",h[h.Running=3]="Running"})(T||(e.State=T={}));function f(h){switch(h){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$FG=f;var k;(function(h){h[h.Valid=0]="Valid",h[h.Unreadable=1]="Unreadable",h[h.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$GG="vscode-debug-memory";var m;(function(h){h[h.Initial=1]="Initial",h[h.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var F;(function(h){h.UnverifiedBreakpoints="unverifiedBreakpoints"})(F||(e.DebuggerString=F={})),e.$HG=(0,S.$lh)("debugService");var D;(function(h){h[h.CONDITION=0]="CONDITION",h[h.HIT_COUNT=1]="HIT_COUNT",h[h.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Re[194],Fe([1,0,13,2,19,23,14,44,22,18]),function(te,e,g,C,S,z,T,f,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=void 0;const F=/{([^}]+)}/g;function D(d,A,E){return d.replace(F,function(a,o){return A&&o.length>0&&o[0]!=="_"?a:E&&E.hasOwnProperty(o)?E[o]:a})}e.$DE=D;function h(d){const A={};for(const E of Object.keys(d))E.startsWith("!")||(A[E]=d[E]);return A}e.$EE=h;function b(d){return d.configuration.request==="attach"&&!$(d)&&(!d.parentSession||b(d.parentSession))}e.$FE=b;function $(d){let A=d.configuration.type;if(A)return A==="vslsShare"&&(A=d.configuration.adapterProxy.configuration.type),(0,g.$Jd)(A,"extensionhost")||(0,g.$Jd)(A,"pwa-extensionhost")?d:d.parentSession?$(d.parentSession):void 0}e.$GE=$;function u(d){return d.type&&(d.label||d.program||d.runtime)}e.$HE=u;function t(d,A,E){let a,o=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let B=null;for(;B=L.exec(d);){const G=B.index+1,q=G+B[0].length;if(G<=A&&q>=E){a=B[0],o=G;break}}if(a){const G=/\w+/g;let q=null;for(;(q=G.exec(a))&&!(q.index+1+o+q[0].length>=E););q&&(a=a.substring(0,G.lastIndex))}return a?{start:o,end:o+a.length-1}:{start:0,end:0}}e.$IE=t;async function r(d,A,E,a){if(d.evaluatableExpressionProvider.has(A)){const o=d.evaluatableExpressionProvider.ordered(A),L=(0,m.$jf)(await Promise.all(o.map(async B=>{try{return await B.provideEvaluatableExpression(A,E,a??k.CancellationToken.None)}catch{return}})));if(L.length>0){let B=L[0].expression;const G=L[0].range;return B||(B=A.getLineContent(E.lineNumber).substring(G.startColumn-1,G.endColumn-1)),{range:G,matchingExpression:B}}}else{const o=A.getLineContent(E.lineNumber),{start:L,end:B}=t(o,E.column,E.column),G=o.substring(L-1,B);return{matchingExpression:G,range:new f.$Kr(E.lineNumber,L,E.lineNumber,L+G.length)}}return null}e.$JE=r;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(d){return!!(d&&d.match(c))}e.$KE=w;function v(d){if(typeof d.path=="string"&&!(typeof d.sourceReference=="number"&&d.sourceReference>0)){if(w(d.path))return C.URI.parse(d.path);if((0,S.$0b)(d.path))return C.URI.file(d.path)}return d.path}function y(d){if(typeof d.path=="object"){const A=C.URI.revive(d.path);if(A)return A.scheme===T.Schemas.file?A.fsPath:A.toString()}return d.path}function i(d,A){const E=A?v:y,a=(0,z.$Dm)(d);return n(a,(o,L)=>{o&&L&&(L.path=E(L))}),a}e.$LE=i;function l(d,A){const E=A?v:y,a=(0,z.$Dm)(d);return n(a,(o,L)=>{!o&&L&&(L.path=E(L))}),a}e.$ME=l;function n(d,A){switch(d.type){case"event":{const E=d;switch(E.event){case"output":A(!1,E.body.source);break;case"loadedSource":A(!1,E.body.source);break;case"breakpoint":A(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=d;switch(E.command){case"setBreakpoints":A(!0,E.arguments.source);break;case"breakpointLocations":A(!0,E.arguments.source);break;case"source":A(!0,E.arguments.source);break;case"gotoTargets":A(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(a=>A(!1,a));break;default:break}break}case"response":{const E=d;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(a=>A(!1,a.source));break;case"loadedSources":E.body.sources.forEach(a=>A(!1,a));break;case"scopes":E.body.scopes.forEach(a=>A(!1,a.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(a=>A(!1,a.source));break;case"setBreakpoints":E.body.breakpoints.forEach(a=>A(!1,a.source));break;case"disassemble":E.body?.instructions.forEach(o=>A(!1,o.location));break;default:break}break}}}function s(d){return d.filter(A=>!A.presentation?.hidden).sort((A,E)=>A.presentation?E.presentation?A.presentation.group?E.presentation.group?A.presentation.group!==E.presentation.group?A.presentation.group.localeCompare(E.presentation.group):p(A.presentation.order,E.presentation.order):-1:E.presentation.group?1:p(A.presentation.order,E.presentation.order):-1:E.presentation?1:0)}e.$NE=s;function p(d,A){return typeof d!="number"?typeof A!="number"?0:1:typeof A!="number"?-1:d-A}async function I(d,A){const E=d.getValue("debug.saveBeforeStart",{overrideIdentifier:A.activeTextEditorLanguageId});if(E!=="none"&&(await A.saveAll(),E==="allEditorsInActiveGroup")){const a=A.activeEditorPane;a&&a.input.resource?.scheme===T.Schemas.untitled&&await A.save({editor:a.input,groupId:a.group.id})}await d.reloadConfiguration()}e.$OE=I}),define(Re[76],Fe([1,0,25,37,67,68,14,19,21,31]),function(te,e,g,C,S,z,T,f,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=e.$gH=e.$fH=e.CellStatusbarAlignment=e.$eH=e.$dH=e.$cH=e.NotebookEditorPriority=e.$bH=e.$aH=e.$_G=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$$G=e.$0G=e.$9G=e.$8G=e.CellKind=e.$7G=e.$6G=e.$5G=void 0,e.$5G="workbench.editor.notebook",e.$6G="workbench.editor.notebookTextDiffEditor",e.$7G="workbench.editor.interactive";var F;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(F||(e.CellKind=F={})),e.$8G=["application/json","application/javascript","text/html","image/svg+xml",z.$qr.latex,z.$qr.markdown,"image/png","image/jpeg",z.$qr.text],e.$9G=[z.$qr.latex,z.$qr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",z.$qr.text],e.$0G=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$$G="_notAvailable";var D;(function(j){j[j.Running=1]="Running",j[j.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var h;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(h||(e.NotebookCellExecutionState=h={}));var b;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var $;(function(j){j[j.WithHardKernelDependency=0]="WithHardKernelDependency",j[j.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",j[j.Pure=2]="Pure",j[j.Never=3]="Never"})($||(e.NotebookRendererMatch=$={}));var u;(function(j){j.Always="always",j.Never="never",j.Optional="optional"})(u||(e.RendererMessagingSpec=u={}));var t;(function(j){j[j.ModelChange=1]="ModelChange",j[j.Move=2]="Move",j[j.ChangeCellLanguage=5]="ChangeCellLanguage",j[j.Initialize=6]="Initialize",j[j.ChangeCellMetadata=7]="ChangeCellMetadata",j[j.Output=8]="Output",j[j.OutputItem=9]="OutputItem",j[j.ChangeCellContent=10]="ChangeCellContent",j[j.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",j[j.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",j[j.ChangeCellMime=13]="ChangeCellMime",j[j.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var r;(function(j){j[j.Handle=0]="Handle",j[j.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var c;(function(j){j[j.Replace=1]="Replace",j[j.Output=2]="Output",j[j.Metadata=3]="Metadata",j[j.CellLanguage=4]="CellLanguage",j[j.DocumentMetadata=5]="DocumentMetadata",j[j.Move=6]="Move",j[j.OutputItems=7]="OutputItems",j[j.PartialMetadata=8]="PartialMetadata",j[j.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var w;(function(j){j.scheme=T.Schemas.vscodeNotebookCell;const O=["W","X","Y","Z","a","b","c","d","e","f"],ue=new RegExp(`^[${O.join("")}]+`),pe=7;function Pe(me,R){const Q=R.toString(pe),De=`${Q.length<O.length?O[Q.length-1]:"z"}${Q}s${(0,g.$2b)(g.$Ib.fromString(me.scheme),!0,!0)}`;return me.with({scheme:j.scheme,fragment:De})}j.generate=Pe;function _(me){if(me.scheme!==j.scheme)return;const R=me.fragment.indexOf("s");if(R<0)return;const Q=parseInt(me.fragment.substring(0,R).replace(ue,""),pe),he=(0,g.$1b)(me.fragment.substring(R+1)).toString();if(!isNaN(Q))return{handle:Q,notebook:me.with({scheme:he,fragment:null})}}j.parse=_;function Y(me,R){return me.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${R??""},${me.scheme!==T.Schemas.file?me.scheme:""}`})}j.generateCellOutputUri=Y;function ce(me){if(me.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const R=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(me.fragment);if(!R)return;const Q=R[1]&&R[1]!==""?R[1]:void 0,he=R[2];return{outputId:Q,notebook:me.with({scheme:he||T.Schemas.file,fragment:null})}}j.parseCellOutputUri=ce;function ke(me,R,Q){return j.generate(me,R).with({scheme:Q})}j.generateCellPropertyUri=ke;function Ce(me,R){if(me.scheme===R)return j.parse(me.with({scheme:j.scheme}))}j.parseCellPropertyUri=Ce})(w||(e.CellUri=w={}));const v=j=>k.$i?j.replace(/\//g,"\\"):j;class y{constructor(O=[],ue=e.$8G){this.e=ue,this.d=[...new Set(O)].map(pe=>({pattern:pe,matches:C.$aj(v(pe))}))}sort(O){const ue=new Map(S.Iterable.map(O,Pe=>[Pe,v(Pe)]));let pe=[];for(const{matches:Pe}of this.d)for(const[_,Y]of ue)if(Pe(Y)){pe.push(_),ue.delete(_);break}return ue.size&&(pe=pe.concat([...ue.keys()].sort((Pe,_)=>this.e.indexOf(Pe)-this.e.indexOf(_)))),pe}prioritize(O,ue){const pe=this.f(O);if(pe===-1){this.d.unshift({pattern:O,matches:C.$aj(v(O))});return}const Pe=new Set(ue.map(Y=>this.f(Y,pe)));Pe.delete(-1);const _=Array.from(Pe).sort();this.d.splice(pe+1,0,..._.map(Y=>this.d[Y]));for(let Y=_.length-1;Y>=0;Y--)this.d.splice(_[Y],1)}toArray(){return this.d.map(O=>O.pattern)}f(O,ue=this.d.length){const pe=v(O);for(let Pe=0;Pe<ue;Pe++)if(this.d[Pe].matches(pe))return Pe;return-1}}e.$_G=y;function i(j,O,ue,pe=(Pe,_)=>Pe===_){const Pe=[];function _(ke,Ce,me){if(Ce===0&&me.length===0)return;const R=Pe[Pe.length-1];R&&R.start+R.deleteCount===ke?(R.deleteCount+=Ce,R.toInsert.push(...me)):Pe.push({start:ke,deleteCount:Ce,toInsert:me})}let Y=0,ce=0;for(;;){if(Y===j.length){_(Y,0,O.slice(ce));break}if(ce===O.length){_(Y,j.length-Y,[]);break}const ke=j[Y],Ce=O[ce];if(pe(ke,Ce)){Y+=1,ce+=1;continue}ue(Ce)?(_(Y,1,[]),Y+=1):(_(Y,0,[Ce]),ce+=1)}return Pe}e.$aH=i,e.$bH=new m.$Ki("notebookEditorCursorAtBoundary","none");var l;(function(j){j.default="default",j.option="option"})(l||(e.NotebookEditorPriority=l={}));function n(j){const O=j;return!!((typeof O.include=="string"||C.$bj(O.include))&&(typeof O.exclude=="string"||C.$bj(O.exclude)))}e.$cH=n;function s(j,O,ue){if(Array.isArray(j.viewType)&&j.viewType.indexOf(O)>=0||j.viewType===O)return!0;if(j.filenamePattern){const pe=n(j.filenamePattern)?j.filenamePattern.include:j.filenamePattern,Pe=n(j.filenamePattern)?j.filenamePattern.exclude:void 0;if(C.$_i(pe,(0,f.$cc)(ue.fsPath).toLowerCase()))return!(Pe&&C.$_i(Pe,(0,f.$cc)(ue.fsPath).toLowerCase()))}return!1}e.$dH=s,e.$eH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var p;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class I{static create(O){return`${I.d}${O}`}static parse(O){if(O.startsWith(I.d))return O.substring(I.d.length)}}e.$fH=I,I.d="notebook/";function d(j){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(j)}e.$gH=d;const A=new TextDecoder;function E(j){const O=[];let ue=!1;for(const pe of j)(O.length===0||ue)&&(O.push(pe),ue=!0);return B(O),H(g.$Ib.concat(O.map(pe=>g.$Ib.wrap(pe))))}e.$hH=E;const a=`${String.fromCharCode(27)}[A`,o=a.split("").map(j=>j.charCodeAt(0)),L=10;function B(j){j.forEach((O,ue)=>{if(ue===0||O.length<a.length)return;const pe=j[ue-1],Pe=O.subarray(0,a.length);if(Pe[0]===o[0]&&Pe[1]===o[1]&&Pe[2]===o[2]){const _=pe.lastIndexOf(L);if(_===-1)return;j[ue-1]=pe.subarray(0,_),j[ue]=O.subarray(a.length)}})}function G(j){let O=j;do j=O,O=j.replace(/[^\n]\x08/gm,"");while(O.length<j.length);return j}function q(j){for(j=j.replace(/\r+\n/gm,`
`);j.search(/\r[^$]/g)>-1;){const O=j.match(/^(.*)\r+/m)[1];let ue=j.match(/\r+(.*)$/m)[1];ue=ue+O.slice(ue.length,O.length),j=j.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ue)}return j}const W="\b".charCodeAt(0),N="\r".charCodeAt(0);function H(j){return!j.buffer.includes(W)&&!j.buffer.includes(N)?j:g.$Ib.fromString(q(G(A.decode(j.buffer))))}});var Ye=this&&this.__classPrivateFieldSet||function(te,e,g,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Te=this&&this.__classPrivateFieldGet||function(te,e,g,C){if(g==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?C:g==="a"?C.call(te):C?C.value:e.get(te)};define(Re[7],Fe([1,0,18,9,70,28,68,13,10,2,36,24,38,97,76]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$){"use strict";var u,t,r,c,w,v,y,i,l,n,s,p,I,d,A,E,a,o,L,B,G,q,W,N,H,j;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.TestRunProfileKind=e.TestResultState=e.$IK=e.$HK=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$GK=e.$FK=e.$EK=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$DK=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.ColorThemeKind=e.$xK=e.$wK=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$vK=e.DebugConsoleMode=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$pK=e.$oK=e.FileChangeType=e.$nK=e.$mK=e.$lK=e.$kK=e.InlineCompletionTriggerKind=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.ConfigurationTarget=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$ZJ=e.ViewBadge=e.ProgressLocation=e.$YJ=e.$XJ=e.TaskScope=e.ShellQuoting=e.$WJ=e.$VJ=e.$UJ=e.TaskPanelKind=e.TaskRevealKind=e.$TJ=e.TerminalLocation=e.$SJ=e.$RJ=e.$QJ=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$LJ=e.StatusBarAlignment=e.ViewColumn=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$GJ=e.$FJ=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.LanguageStatusSeverity=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.CodeActionTriggerKind=e.$sJ=e.$rJ=e.SymbolTag=e.SymbolKind=e.$qJ=e.DocumentHighlightKind=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.DiagnosticSeverity=e.DiagnosticTag=e.$lJ=e.$kJ=e.FileEditType=e.$jJ=e.$iJ=e.$hJ=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(U){return Object.assign(U,{apply:function(){const oe=arguments.length===1?[]:arguments[1];return Reflect.construct(U,oe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(U,[]);{const[oe,...Ie]=arguments;return Reflect.construct(U,Ie,oe.constructor)}}})}var ue;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(ue||(e.TerminalOutputAnchor=ue={}));var pe;(function(U){U[U.Command=0]="Command",U[U.Opener=1]="Opener"})(pe||(e.TerminalQuickFixType=pe={}));let Pe=e.$aJ=l=class{static from(...M){let oe=M;return new l(function(){if(oe){for(const Ie of oe)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();oe=void 0}})}constructor(M){u.set(this,void 0),Ye(this,u,M,"f")}dispose(){typeof Te(this,u,"f")=="function"&&(Te(this,u,"f").call(this),Ye(this,u,void 0,"f"))}};u=new WeakMap,e.$aJ=Pe=l=qe([O],Pe);let _=e.$bJ=n=class{static Min(...M){if(M.length===0)throw new TypeError;let oe=M[0];for(let Ie=1;Ie<M.length;Ie++){const Je=M[Ie];Je.isBefore(oe)&&(oe=Je)}return oe}static Max(...M){if(M.length===0)throw new TypeError;let oe=M[0];for(let Ie=1;Ie<M.length;Ie++){const Je=M[Ie];Je.isAfter(oe)&&(oe=Je)}return oe}static isPosition(M){if(!M)return!1;if(M instanceof n)return!0;const{line:oe,character:Ie}=M;return typeof oe=="number"&&typeof Ie=="number"}static of(M){if(M instanceof n)return M;if(this.isPosition(M))return new n(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(M,oe){if(M<0)throw(0,C.$4)("line must be non-negative");if(oe<0)throw(0,C.$4)("character must be non-negative");this.c=M,this.e=oe}isBefore(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<M.e}isBeforeOrEqual(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<=M.e}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this.c===M.c&&this.e===M.e}compareTo(M){return this.c<M.c?-1:this.c>M.line?1:this.e<M.e?-1:this.e>M.e?1:0}translate(M,oe=0){if(M===null||oe===null)throw(0,C.$4)();let Ie;return typeof M>"u"?Ie=0:typeof M=="number"?Ie=M:(Ie=typeof M.lineDelta=="number"?M.lineDelta:0,oe=typeof M.characterDelta=="number"?M.characterDelta:0),Ie===0&&oe===0?this:new n(this.line+Ie,this.character+oe)}with(M,oe=this.character){if(M===null||oe===null)throw(0,C.$4)();let Ie;return typeof M>"u"?Ie=this.line:typeof M=="number"?Ie=M:(Ie=typeof M.line=="number"?M.line:this.line,oe=typeof M.character=="number"?M.character:this.character),Ie===this.line&&oe===this.character?this:new n(Ie,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$bJ=_=n=qe([O],_);let Y=e.$cJ=s=class{static isRange(M){return M instanceof s?!0:M?_.isPosition(M.start)&&_.isPosition(M.end):!1}static of(M){if(M instanceof s)return M;if(this.isRange(M))return new s(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(M,oe,Ie,Je){let Xe,ot;if(typeof M=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof Je=="number"?(Xe=new _(M,oe),ot=new _(Ie,Je)):_.isPosition(M)&&_.isPosition(oe)&&(Xe=_.of(M),ot=_.of(oe)),!Xe||!ot)throw new Error("Invalid arguments");Xe.isBefore(ot)?(this.c=Xe,this.e=ot):(this.c=ot,this.e=Xe)}contains(M){return s.isRange(M)?this.contains(M.start)&&this.contains(M.end):_.isPosition(M)?!(_.of(M).isBefore(this.c)||this.e.isBefore(M)):!1}isEqual(M){return this.c.isEqual(M.c)&&this.e.isEqual(M.e)}intersection(M){const oe=_.Max(M.start,this.c),Ie=_.Min(M.end,this.e);if(!oe.isAfter(Ie))return new s(oe,Ie)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const oe=_.Min(M.start,this.c),Ie=_.Max(M.end,this.end);return new s(oe,Ie)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(M,oe=this.end){if(M===null||oe===null)throw(0,C.$4)();let Ie;return M?_.isPosition(M)?Ie=M:(Ie=M.start||this.start,oe=M.end||this.end):Ie=this.start,Ie.isEqual(this.c)&&oe.isEqual(this.end)?this:new s(Ie,oe)}toJSON(){return[this.start,this.end]}};e.$cJ=Y=s=qe([O],Y);let ce=e.$dJ=p=class extends Y{static isSelection(M){return M instanceof p?!0:M?Y.isRange(M)&&_.isPosition(M.anchor)&&_.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(M,oe,Ie,Je){let Xe,ot;if(typeof M=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof Je=="number"?(Xe=new _(M,oe),ot=new _(Ie,Je)):_.isPosition(M)&&_.isPosition(oe)&&(Xe=_.of(M),ot=_.of(oe)),!Xe||!ot)throw new Error("Invalid arguments");super(Xe,ot),this.f=Xe,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$dJ=ce=p=qe([O],ce);const ke=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,C.$4)("connectionToken")};class Ce{static isResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.host=="string"&&typeof M.port=="number"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,oe,Ie){if(typeof M!="string"||M.length===0)throw(0,C.$4)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,C.$4)("port");typeof Ie<"u"&&ke(Ie),this.host=M,this.port=Math.round(oe),this.connectionToken=Ie}}e.$eJ=Ce;class me{static isManagedResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.makeConnection=="function"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,oe){this.makeConnection=M,this.connectionToken=oe,typeof oe<"u"&&ke(oe)}}e.$fJ=me;class R extends Error{static NotAvailable(M,oe){return new R(M,b.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(M){return new R(M,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,oe=b.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(M),this._message=M,this._code=oe,this._detail=Ie,Object.setPrototypeOf(this,R.prototype)}}e.$gJ=R;var Q;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var he;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(he||(e.EnvironmentVariableMutatorType=he={}));let De=e.$hJ=I=class{static isTextEdit(M){return M instanceof I?!0:M?Y.isRange(M)&&typeof M.newText=="string":!1}static replace(M,oe){return new I(M,oe)}static insert(M,oe){return I.replace(new Y(M,M),oe)}static delete(M){return I.replace(M,"")}static setEndOfLine(M){const oe=new I(new Y(new _(0,0),new _(0,0)),"");return oe.newEol=M,oe}get range(){return this.c}set range(M){if(M&&!Y.isRange(M))throw(0,C.$4)("range");this.c=M}get newText(){return this.e||""}set newText(M){if(M&&typeof M!="string")throw(0,C.$4)("newText");this.e=M}get newEol(){return this.f}set newEol(M){if(M&&typeof M!="number")throw(0,C.$4)("newEol");this.f=M}constructor(M,oe){this.c=M,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$hJ=De=I=qe([O],De);let ye=e.$iJ=d=class{static isNotebookCellEdit(M){return M instanceof d?!0:M?_t.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,oe){return new d(M,oe)}static insertCells(M,oe){return new d(new _t(M,M),oe)}static deleteCells(M){return new d(M,[])}static updateCellMetadata(M,oe){const Ie=new d(new _t(M,M),[]);return Ie.newCellMetadata=oe,Ie}static updateNotebookMetadata(M){const oe=new d(new _t(0,0),[]);return oe.newNotebookMetadata=M,oe}constructor(M,oe){this.range=M,this.newCells=oe}};e.$iJ=ye=d=qe([O],ye);class $e{static isSnippetTextEdit(M){return M instanceof $e?!0:M?Y.isRange(M.range)&&le.isSnippetString(M.snippet):!1}static replace(M,oe){return new $e(M,oe)}static insert(M,oe){return $e.replace(new Y(M,M),oe)}constructor(M,oe){this.range=M,this.snippet=oe}}e.$jJ=$e;var Se;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(Se||(e.FileEditType=Se={}));let ae=e.$kJ=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(M,oe,Ie,Je){this.c.push({_type:1,from:M,to:oe,options:Ie,metadata:Je})}createFile(M,oe,Ie){this.c.push({_type:1,from:void 0,to:M,options:oe,metadata:Ie})}deleteFile(M,oe,Ie){this.c.push({_type:1,from:M,to:void 0,options:oe,metadata:Ie})}e(M,oe,Ie){this.c.push({_type:3,metadata:Ie,uri:M,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(M,oe,Ie,Je){const Xe=oe.start,ot=oe.end;(Xe!==ot||Ie.length>0)&&this.c.push({_type:5,uri:M,index:Xe,count:ot-Xe,cells:Ie,metadata:Je})}g(M,oe,Ie,Je){this.c.push({_type:3,metadata:Je,uri:M,edit:{editType:3,index:oe,metadata:Ie}})}replace(M,oe,Ie,Je){this.c.push({_type:2,uri:M,edit:new De(oe,Ie),metadata:Je})}insert(M,oe,Ie,Je){this.replace(M,new Y(oe,oe),Ie,Je)}delete(M,oe,Ie){this.replace(M,oe,"",Ie)}has(M){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===M.toString())}set(M,oe){if(oe)for(const Ie of oe){if(!Ie)continue;let Je,Xe;Array.isArray(Ie)?(Je=Ie[0],Xe=Ie[1]):Je=Ie,ye.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(M,Je.range.start,Je.newCellMetadata,Xe):Je.newNotebookMetadata?this.e(M,Je.newNotebookMetadata,Xe):this.f(M,Je.range,Je.newCells,Xe):$e.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:M,range:Je.range,edit:Je.snippet,metadata:Xe}):this.c.push({_type:2,uri:M,edit:Je,metadata:Xe})}else{for(let Ie=0;Ie<this.c.length;Ie++){const Je=this.c[Ie];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===M.toString()&&(this.c[Ie]=void 0);break}}(0,g.$kf)(this.c)}}get(M){const oe=[];for(const Ie of this.c)Ie._type===2&&Ie.uri.toString()===M.toString()&&oe.push(Ie.edit);return oe}entries(){const M=new z.$ji;for(const oe of this.c)if(oe._type===2){let Ie=M.get(oe.uri);Ie||(Ie=[oe.uri,[]],M.set(oe.uri,Ie)),Ie[1].push(oe.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$kJ=ae=qe([O],ae);let le=e.$lJ=A=class{static isSnippetString(M){return M instanceof A?!0:M?typeof M.value=="string":!1}static c(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this.e=1,this.value=M||""}appendText(M){return this.value+=A.c(M),this}appendTabstop(M=this.e++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,oe=this.e++){if(typeof M=="function"){const Ie=new A;Ie.e=this.e,M(Ie),this.e=Ie.e,M=Ie.value}else M=A.c(M);return this.value+="${",this.value+=oe,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,oe=this.e++){const Ie=M.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(M,oe){if(typeof oe=="function"){const Ie=new A;Ie.e=this.e,oe(Ie),this.e=Ie.e,oe=Ie.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$lJ=le=A=qe([O],le);var ne;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var ee;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let P=e.$mJ=E=class{static isLocation(M){return M instanceof E?!0:M?Y.isRange(M.range)&&m.URI.isUri(M.uri):!1}constructor(M,oe){if(this.uri=M,oe)if(Y.isRange(oe))this.range=Y.of(oe);else if(_.isPosition(oe))this.range=new Y(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$mJ=P=E=qe([O],P);let K=e.$nJ=class{static is(M){return M?typeof M.message=="string"&&M.location&&Y.isRange(M.location.range)&&m.URI.isUri(M.location.uri):!1}constructor(M,oe){this.location=M,this.message=oe}static isEqual(M,oe){return M===oe?!0:!M||!oe?!1:M.message===oe.message&&M.location.range.isEqual(oe.location.range)&&M.location.uri.toString()===oe.location.uri.toString()}};e.$nJ=K=qe([O],K);let V=e.$oJ=class{constructor(M,oe,Ie=ee.Error){if(!Y.isRange(M))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=M,this.message=oe,this.severity=Ie}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,oe){return M===oe?!0:!M||!oe?!1:M.message===oe.message&&M.severity===oe.severity&&M.code===oe.code&&M.severity===oe.severity&&M.source===oe.source&&M.range.isEqual(oe.range)&&(0,g.$$e)(M.tags,oe.tags)&&(0,g.$$e)(M.relatedInformation,oe.relatedInformation,K.isEqual)}};e.$oJ=V=qe([O],V);let J=e.$pJ=class{constructor(M,oe){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=oe}};e.$pJ=J=qe([O],J);var re;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let de=e.$qJ=class{constructor(M,oe=re.Text){this.range=M,this.kind=oe}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$qJ=de=qe([O],de);var ie;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(ie||(e.SymbolKind=ie={}));var ve;(function(U){U[U.Deprecated=1]="Deprecated"})(ve||(e.SymbolTag=ve={}));let Ee=e.$rJ=a=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,oe,Ie,Je,Xe){this.name=M,this.kind=oe,this.containerName=Xe,typeof Ie=="string"&&(this.containerName=Ie),Je instanceof P?this.location=Je:Ie instanceof Y&&(this.location=new P(Je,Ie)),a.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};e.$rJ=Ee=a=qe([O],Ee);let Be=e.$sJ=o=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(o.validate)}constructor(M,oe,Ie,Je,Xe){this.name=M,this.detail=oe,this.kind=Ie,this.range=Je,this.selectionRange=Xe,this.children=[],o.validate(this)}};e.$sJ=Be=o=qe([O],Be);var We;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(We||(e.CodeActionTriggerKind=We={}));let _e=e.$tJ=class{constructor(M,oe){this.title=M,this.kind=oe}};e.$tJ=_e=qe([O],_e);let He=e.$uJ=L=class{constructor(M){this.value=M}append(M){return new L(this.value?this.value+L.c+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+L.c)}};He.c=".",e.$uJ=He=L=qe([O],He);class Qe extends He{constructor(M){super(M),this.value=M}}e.$vJ=Qe,He.Empty=new He(""),He.QuickFix=He.Empty.append("quickfix"),He.Refactor=He.Empty.append("refactor"),He.RefactorExtract=He.Refactor.append("extract"),He.RefactorInline=He.Refactor.append("inline"),He.RefactorMove=He.Refactor.append("move"),He.RefactorRewrite=He.Refactor.append("rewrite"),He.Source=He.Empty.append("source"),He.SourceOrganizeImports=He.Source.append("organizeImports"),He.SourceFixAll=He.Source.append("fixAll"),He.Notebook=He.Empty.append("notebook");let it=e.$wJ=class{constructor(M,oe){if(this.range=M,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$wJ=it=qe([O],it);class ct{constructor(M,oe,Ie,Je,Xe,ot){this.kind=M,this.name=oe,this.detail=Ie,this.uri=Je,this.range=Xe,this.selectionRange=ot}}e.$xJ=ct;class et{constructor(M,oe){this.fromRanges=oe,this.from=M}}e.$yJ=et;class rt{constructor(M,oe){this.fromRanges=oe,this.to=M}}e.$zJ=rt;var Oe;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let st=e.$AJ=class{constructor(M,oe){this.range=M,this.command=oe}get isResolved(){return!!this.command}};e.$AJ=st=qe([O],st);let x=e.$BJ=B=class{static isMarkdownString(M){return M instanceof B?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,oe=!1){t.set(this,void 0),Ye(this,t,new S.$Gj(M,{supportThemeIcons:oe}),"f")}get value(){return Te(this,t,"f").value}set value(M){Te(this,t,"f").value=M}get isTrusted(){return Te(this,t,"f").isTrusted}set isTrusted(M){Te(this,t,"f").isTrusted=M}get supportThemeIcons(){return Te(this,t,"f").supportThemeIcons}set supportThemeIcons(M){Te(this,t,"f").supportThemeIcons=M}get supportHtml(){return Te(this,t,"f").supportHtml}set supportHtml(M){Te(this,t,"f").supportHtml=M}get baseUri(){return Te(this,t,"f").baseUri}set baseUri(M){Te(this,t,"f").baseUri=M}appendText(M){return Te(this,t,"f").appendText(M),this}appendMarkdown(M){return Te(this,t,"f").appendMarkdown(M),this}appendCodeblock(M,oe){return Te(this,t,"f").appendCodeblock(oe??"",M),this}};t=new WeakMap,e.$BJ=x=B=qe([O],x);let X=e.$CJ=class{constructor(M,oe){this.label=M,this.documentation=oe}};e.$CJ=X=qe([O],X);let ge=e.$DJ=class{constructor(M,oe){this.label=M,this.documentation=oe,this.parameters=[]}};e.$DJ=ge=qe([O],ge);let je=e.$EJ=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$EJ=je=qe([O],je);var Ne;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(Ne||(e.SignatureHelpTriggerKind=Ne={}));var Ze;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Ze||(e.InlayHintKind=Ze={}));let tt=e.$FJ=class{constructor(M){this.value=M}};e.$FJ=tt=qe([O],tt);let $t=e.$GJ=class{constructor(M,oe,Ie){this.position=M,this.label=oe,this.kind=Ie}};e.$GJ=$t=qe([O],$t);var wt;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(wt||(e.CompletionTriggerKind=wt={}));var Lt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Lt||(e.CompletionItemKind=Lt={}));var Gt;(function(U){U[U.Deprecated=1]="Deprecated"})(Gt||(e.CompletionItemTag=Gt={}));let Wt=e.$HJ=class{constructor(M,oe){this.label=M,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Lt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$HJ=Wt=qe([O],Wt);let yt=e.$IJ=class{constructor(M=[],oe=!1){this.items=M,this.isIncomplete=oe}};e.$IJ=yt=qe([O],yt);let Ut=e.$JJ=class{constructor(M,oe,Ie){this.insertText=M,this.range=oe,this.command=Ie}};e.$JJ=Ut=qe([O],Ut);let Mt=e.$KJ=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.$KJ=Mt=qe([O],Mt);var Nt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Nt||(e.ViewColumn=Nt={}));var Kt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Kt||(e.StatusBarAlignment=Kt={}));function Vt(U,M){return`${D.$Dl.toKey(U)}.${M}`}e.$LJ=Vt;var at;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(at||(e.TextEditorLineNumbersStyle=at={}));var ft;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(ft||(e.TextDocumentSaveReason=ft={}));var jt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(jt||(e.TextEditorRevealType=jt={}));var Rt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Rt||(e.TextEditorSelectionChangeKind=Rt={}));var St;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(St||(e.TextDocumentChangeReason=St={}));var ut;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(ut||(e.DecorationRangeBehavior=ut={})),function(U){function M(oe){switch(oe){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=M}(Rt||(e.TextEditorSelectionChangeKind=Rt={}));let Ct=e.$MJ=class{constructor(M,oe){if(oe&&!m.URI.isUri(oe))throw(0,C.$4)("target");if(!Y.isRange(M)||M.isEmpty)throw(0,C.$4)("range");this.range=M,this.target=oe}};e.$MJ=Ct=qe([O],Ct);let Tt=e.$NJ=class{constructor(M,oe,Ie,Je){this.red=M,this.green=oe,this.blue=Ie,this.alpha=Je}};e.$NJ=Tt=qe([O],Tt);let Ae=e.$OJ=class{constructor(M,oe){if(oe&&!(oe instanceof Tt))throw(0,C.$4)("color");if(!Y.isRange(M)||M.isEmpty)throw(0,C.$4)("range");this.range=M,this.color=oe}};e.$OJ=Ae=qe([O],Ae);let we=e.$PJ=class{constructor(M){if(!M||typeof M!="string")throw(0,C.$4)("label");this.label=M}};e.$PJ=we=qe([O],we);var be;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(be||(e.ColorFormat=be={}));var Z;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Z||(e.SourceControlInputBoxValidationType=Z={}));var Le;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(Le||(e.TerminalExitReason=Le={}));class Ue{constructor(M,oe,Ie){if(this.startIndex=M,this.length=oe,this.tooltip=Ie,typeof M!="number"||M<0)throw(0,C.$4)("startIndex");if(typeof oe!="number"||oe<1)throw(0,C.$4)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,C.$4)("tooltip")}}e.$QJ=Ue;class Ge{constructor(M){this.uri=M}}e.$RJ=Ge;class Ke{constructor(M){this.terminalCommand=M}}e.$SJ=Ke;var xe;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(xe||(e.TerminalLocation=xe={}));class Et{constructor(M){if(this.options=M,typeof M!="object")throw(0,C.$4)("options")}}e.$TJ=Et;var It;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var Pt;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(Pt||(e.TaskPanelKind=Pt={}));let mt=e.$UJ=G=class{static from(M){switch(M){case"clean":return G.Clean;case"build":return G.Build;case"rebuild":return G.Rebuild;case"test":return G.Test;default:return}}constructor(M,oe){if(this.label=oe,typeof M!="string"||typeof oe!="string")throw(0,C.$4)("name");this.c=M}get id(){return this.c}};mt.Clean=new G("clean","Clean"),mt.Build=new G("build","Build"),mt.Rebuild=new G("rebuild","Rebuild"),mt.Test=new G("test","Test"),e.$UJ=mt=G=qe([O],mt);function pt(U){let M="";for(let oe=0;oe<U.length;oe++)M+=U[oe].replace(/,/g,",,")+",";return M}let dt=e.$VJ=class{constructor(M,oe,Ie){if(typeof M!="string")throw(0,C.$4)("process");this.e=[],this.c=M,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=Ie):this.f=oe)}get process(){return this.c}set process(M){if(typeof M!="string")throw(0,C.$4)("process");this.c=M}get args(){return this.e}set args(M){Array.isArray(M)||(M=[]),this.e=M}get options(){return this.f}set options(M){this.f=M}computeId(){const M=[];if(M.push("process"),this.c!==void 0&&M.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)M.push(oe);return pt(M)}};e.$VJ=dt=qe([O],dt);let vt=e.$WJ=class{constructor(M,oe,Ie){if(this.f=[],Array.isArray(oe)){if(!M)throw(0,C.$4)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,C.$4)("command");this.e=M,this.f=oe,this.g=Ie}else{if(typeof M!="string")throw(0,C.$4)("commandLine");this.c=M,this.g=oe}}get commandLine(){return this.c}set commandLine(M){if(typeof M!="string")throw(0,C.$4)("commandLine");this.c=M}get command(){return this.e?this.e:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,C.$4)("command");this.e=M}get args(){return this.f}set args(M){this.f=M||[]}get options(){return this.g}set options(M){this.g=M}computeId(){const M=[];if(M.push("shell"),this.c!==void 0&&M.push(this.c),this.e!==void 0&&M.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)M.push(typeof oe=="string"?oe:oe.value);return pt(M)}};e.$WJ=vt=qe([O],vt);var bt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(bt||(e.ShellQuoting=bt={}));var Zt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Zt||(e.TaskScope=Zt={}));class Bt{constructor(M){this.c=M}computeId(){return"customExecution"+(0,F.$3e)()}set callback(M){this.c=M}get callback(){return this.c}}e.$XJ=Bt;let ni=e.$YJ=q=class{constructor(M,oe,Ie,Je,Xe,ot){this.j=!1,this.k=this.definition=M;let ht;typeof oe=="string"?(this.m=this.name=oe,this.t=this.source=Ie,this.execution=Je,ht=Xe,this.j=!0):oe===Zt.Global||oe===Zt.Workspace?(this.target=oe,this.m=this.name=Ie,this.t=this.source=Je,this.execution=Xe,ht=ot):(this.target=oe,this.m=this.name=Ie,this.t=this.source=Je,this.execution=Xe,ht=ot),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(M){this.h=M}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof dt?this.k={type:q.e,id:this.n.computeId()}:this.n instanceof vt?this.k={type:q.f,id:this.n.computeId()}:this.n instanceof Bt?this.k={type:q.c,id:this.n.computeId()}:this.k={type:q.g,id:(0,F.$3e)()}}get definition(){return this.k}set definition(M){if(M==null)throw(0,C.$4)("Kind can't be undefined or null");this.y(),this.k=M}get scope(){return this.l}set target(M){this.y(),this.l=M}get name(){return this.m}set name(M){if(typeof M!="string")throw(0,C.$4)("name");this.y(),this.m=M}get execution(){return this.n}set execution(M){M===null&&(M=void 0),this.y(),this.n=M;const oe=this.k.type;(q.g===oe||q.e===oe||q.f===oe||q.c===oe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(M){if(Array.isArray(M))this.y(),this.o=M,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.y(),this.r=M}get source(){return this.t}set source(M){if(typeof M!="string"||M.length===0)throw(0,C.$4)("source must be a string of length > 0");this.y(),this.t=M}get group(){return this.u}set group(M){M===null&&(M=void 0),this.y(),this.u=M}get detail(){return this.x}set detail(M){M===null&&(M=void 0),this.x=M}get presentationOptions(){return this.v}set presentationOptions(M){M==null&&(M=Object.create(null)),this.y(),this.v=M}get runOptions(){return this.w}set runOptions(M){M==null&&(M=Object.create(null)),this.y(),this.w=M}};ni.c="customExecution",ni.e="process",ni.f="shell",ni.g="$empty",e.$YJ=ni=q=qe([O],ni);var ai;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(ai||(e.ProgressLocation=ai={}));var yi;(function(U){function M(oe){const Ie=oe;return(0,k.$ke)(Ie.value)?Ie.tooltip&&!(0,k.$ge)(Ie.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ie.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ie.value),!1)}U.isViewBadge=M})(yi||(e.ViewBadge=yi={}));let At=e.$ZJ=W=class{static isTreeItem(M,oe){const Ie=M;if(Ie.checkboxState!==void 0){const Je=(0,k.$ke)(Ie.checkboxState)?Ie.checkboxState:(0,k.$ie)(Ie.checkboxState)&&(0,k.$ke)(Ie.checkboxState.state)?Ie.checkboxState.state:void 0,Xe=!(0,k.$ke)(Ie.checkboxState)&&(0,k.$ie)(Ie.checkboxState)?Ie.checkboxState.tooltip:void 0;if(Je===void 0||Je!==fi.Checked&&Je!==fi.Unchecked||Xe!==void 0&&!(0,k.$ge)(Xe))return console.log("INVALID tree item, invalid checkboxState",Ie.checkboxState),!1}if(M instanceof W)return!0;if(Ie.label!==void 0&&!(0,k.$ge)(Ie.label)&&!Ie.label?.label)return console.log("INVALID tree item, invalid label",Ie.label),!1;if(Ie.id!==void 0&&!(0,k.$ge)(Ie.id))return console.log("INVALID tree item, invalid id",Ie.id),!1;if(Ie.iconPath!==void 0&&!(0,k.$ge)(Ie.iconPath)&&!m.URI.isUri(Ie.iconPath)&&(!Ie.iconPath||!(0,k.$ge)(Ie.iconPath.id))){const Je=Ie.iconPath;if(!Je||!(0,k.$ge)(Je.light)&&!m.URI.isUri(Je.light)&&!(0,k.$ge)(Je.dark)&&!m.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Ie.iconPath),!1}return Ie.description!==void 0&&!(0,k.$ge)(Ie.description)&&typeof Ie.description!="boolean"?(console.log("INVALID tree item, invalid description",Ie.description),!1):Ie.resourceUri!==void 0&&!m.URI.isUri(Ie.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ie.resourceUri),!1):Ie.tooltip!==void 0&&!(0,k.$ge)(Ie.tooltip)&&!(Ie.tooltip instanceof x)?(console.log("INVALID tree item, invalid tooltip",Ie.tooltip),!1):Ie.command!==void 0&&!Ie.command.command?(console.log("INVALID tree item, invalid command",Ie.command),!1):Ie.collapsibleState!==void 0&&Ie.collapsibleState<ci.None&&Ie.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ie.collapsibleState),!1):Ie.contextValue!==void 0&&!(0,k.$ge)(Ie.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ie.contextValue),!1):Ie.accessibilityInformation!==void 0&&!Ie.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ie.accessibilityInformation),!1):!0}constructor(M,oe=ci.None){this.collapsibleState=oe,m.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.$ZJ=At=W=qe([O],At);var ci;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(ci||(e.TreeItemCollapsibleState=ci={}));var fi;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(fi||(e.TreeItemCheckboxState=fi={}));let kt=e.$1J=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M){this.value=M}};e.$1J=kt=qe([O],kt);class Ei extends kt{}e.$2J=Ei;class Ti extends Ei{constructor(M){super(""),r.set(this,void 0),Ye(this,r,M,"f")}asFile(){return Te(this,r,"f")}}e.$3J=Ti,r=new WeakMap;class gi{constructor(M,oe,Ie,Je){this.name=M,this.uri=oe,this._itemId=Ie,this.c=Je}data(){return this.c()}}e.$4J=gi;let Li=e.$5J=class{constructor(M){c.add(this),w.set(this,new Map);for(const[oe,Ie]of M??[]){const Je=Te(this,w,"f").get(Te(this,c,"m",v).call(this,oe));Je?Je.push(Ie):Te(this,w,"f").set(Te(this,c,"m",v).call(this,oe),[Ie])}}get(M){return Te(this,w,"f").get(Te(this,c,"m",v).call(this,M))?.[0]}set(M,oe){Te(this,w,"f").set(Te(this,c,"m",v).call(this,M),[oe])}forEach(M,oe){for(const[Ie,Je]of Te(this,w,"f"))for(const Xe of Je)M.call(oe,Xe,Ie,this)}*[(w=new WeakMap,c=new WeakSet,Symbol.iterator)](){for(const[M,oe]of Te(this,w,"f"))for(const Ie of oe)yield[M,Ie]}};v=function(M){return M.toLowerCase()},e.$5J=Li=qe([O],Li);let Mi=e.$6J=class{constructor(M){this.insertText=M}};e.$6J=Mi=qe([O],Mi);let zt=e.$7J=class{constructor(M,oe,Ie){this.id=oe,this.label=Ie,this.insertText=M}};e.$7J=zt=qe([O],zt);let Qt=e.$8J=class{constructor(M,oe){this.id=M,this.color=oe}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.$8J=Qt=qe([O],Qt),Qt.File=new Qt("file"),Qt.Folder=new Qt("folder");let zi=e.$9J=class{constructor(M){this.id=M}};e.$9J=zi=qe([O],zi);var ui;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(ui||(e.ConfigurationTarget=ui={}));let li=e.$0J=class{get base(){return this.c}set base(M){this.c=M,this.e=m.URI.file(M)}get baseUri(){return this.e}set baseUri(M){this.e=M,this.c=M.fsPath}constructor(M,oe){if(typeof M!="string"&&(!M||!m.URI.isUri(M)&&!m.URI.isUri(M.uri)))throw(0,C.$4)("base");if(typeof oe!="string")throw(0,C.$4)("pattern");typeof M=="string"?this.baseUri=m.URI.file(M):m.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$0J=li=qe([O],li);const lt=new WeakMap;function an(U,M){lt.set(U,M)}e.$$J=an;let qt=e.$_J=class{constructor(M,oe,Ie,Je){this.enabled=typeof M=="boolean"?M:!0,typeof oe=="string"&&(this.condition=oe),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=lt.get(this)??(0,F.$3e)()),this.c}};e.$_J=qt=qe([O],qt);let ri=e.$aK=class extends qt{constructor(M,oe,Ie,Je,Xe){if(super(oe,Ie,Je,Xe),M===null)throw(0,C.$4)("location");this.location=M}};e.$aK=ri=qe([O],ri);let Di=e.$bK=class extends qt{constructor(M,oe,Ie,Je,Xe){super(oe,Ie,Je,Xe),this.functionName=M}};e.$bK=Di=qe([O],Di);let Ni=e.$cK=class extends qt{constructor(M,oe,Ie,Je,Xe,ot,ht){if(super(Je,Xe,ot,ht),!oe)throw(0,C.$4)("dataId");this.label=M,this.dataId=oe,this.canPersist=Ie}};e.$cK=Ni=qe([O],Ni);let Oi=e.$dK=class{constructor(M,oe,Ie){this.command=M,this.args=oe||[],this.options=Ie}};e.$dK=Oi=qe([O],Oi);let Ui=e.$eK=class{constructor(M,oe){this.port=M,this.host=oe}};e.$eK=Ui=qe([O],Ui);let ki=e.$fK=class{constructor(M){this.path=M}};e.$fK=ki=qe([O],ki);let ji=e.$gK=class{constructor(M){this.implementation=M}};e.$gK=ji=qe([O],ji);let Si=e.$hK=class{constructor(M,oe,Ie){this.session=M,this.threadId=oe,this.frameId=Ie}};e.$hK=Si=qe([O],Si);let si=e.$iK=class{constructor(M,oe){this.session=M,this.threadId=oe}};e.$iK=si=qe([O],si);let Bi=e.$jK=class{constructor(M,oe){this.range=M,this.expression=oe}};e.$jK=Bi=qe([O],Bi);var mi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(mi||(e.InlineCompletionTriggerKind=mi={}));let $i=e.$kK=class{constructor(M,oe){this.range=M,this.text=oe}};e.$kK=$i=qe([O],$i);let Wi=e.$lK=class{constructor(M,oe,Ie=!0){this.range=M,this.variableName=oe,this.caseSensitiveLookup=Ie}};e.$lK=Wi=qe([O],Wi);let Ki=e.$mK=class{constructor(M,oe){this.range=M,this.expression=oe}};e.$mK=Ki=qe([O],Ki);let oi=e.$nK=class{constructor(M,oe){this.frameId=M,this.stoppedLocation=oe}};e.$nK=oi=qe([O],oi);var Vi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Vi||(e.FileChangeType=Vi={}));let qi=e.$oK=N=class extends Error{static FileExists(M){return new N(M,h.FileSystemProviderErrorCode.FileExists,N.FileExists)}static FileNotFound(M){return new N(M,h.FileSystemProviderErrorCode.FileNotFound,N.FileNotFound)}static FileNotADirectory(M){return new N(M,h.FileSystemProviderErrorCode.FileNotADirectory,N.FileNotADirectory)}static FileIsADirectory(M){return new N(M,h.FileSystemProviderErrorCode.FileIsADirectory,N.FileIsADirectory)}static NoPermissions(M){return new N(M,h.FileSystemProviderErrorCode.NoPermissions,N.NoPermissions)}static Unavailable(M){return new N(M,h.FileSystemProviderErrorCode.Unavailable,N.Unavailable)}constructor(M,oe=h.FileSystemProviderErrorCode.Unknown,Ie){super(m.URI.isUri(M)?M.toString(!0):M),this.code=Ie?.name??"Unknown",(0,h.$3j)(this,oe),Object.setPrototypeOf(this,N.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}};e.$oK=qi=N=qe([O],qi);let Ji=e.$pK=class{constructor(M,oe,Ie){this.start=M,this.end=oe,this.kind=Ie}};e.$pK=Ji=qe([O],Ji);var ei;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(ei||(e.FoldingRangeKind=ei={}));var Hi;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Hi||(e.CommentThreadCollapsibleState=Hi={}));var Gi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Gi||(e.CommentMode=Gi={}));var Ii;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Ii||(e.CommentState=Ii={}));var Qi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(Qi||(e.CommentThreadState=Qi={}));class cn{constructor(M,oe=[]){this.tokenTypes=M,this.tokenModifiers=oe}}e.$qK=cn;function un(U){return typeof U>"u"||(0,k.$he)(U)}class hi{constructor(M){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,M){this.l=!0;for(let oe=0,Ie=M.tokenTypes.length;oe<Ie;oe++)this.j.set(M.tokenTypes[oe],oe);for(let oe=0,Ie=M.tokenModifiers.length;oe<Ie;oe++)this.k.set(M.tokenModifiers[oe],oe)}}push(M,oe,Ie,Je,Xe){if(typeof M=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof Je=="number"&&(typeof Xe=="number"||typeof Xe>"u"))return typeof Xe>"u"&&(Xe=0),this.n(M,oe,Ie,Je,Xe);if(Y.isRange(M)&&typeof oe=="string"&&un(Ie))return this.m(M,oe,Ie);throw(0,C.$4)()}m(M,oe,Ie){if(!this.l)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(oe))throw new Error("`tokenType` is not in the provided legend");const Je=M.start.line,Xe=M.start.character,ot=M.end.character-M.start.character,ht=this.j.get(oe);let Ot=0;if(Ie)for(const Ht of Ie){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const Yt=this.k.get(Ht);Ot|=1<<Yt>>>0}this.n(Je,Xe,ot,ht,Ot)}n(M,oe,Ie,Je,Xe){if(this.f&&(M<this.c||M===this.c&&oe<this.e)){this.f=!1;const Ot=this.g.length/5|0;let Ht=0,Yt=0;for(let xt=0;xt<Ot;xt++){let ti=this.g[5*xt],Ri=this.g[5*xt+1];ti===0?(ti=Ht,Ri+=Yt):ti+=Ht,this.g[5*xt]=ti,this.g[5*xt+1]=Ri,Ht=ti,Yt=Ri}}let ot=M,ht=oe;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ht-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ht,this.g[this.h++]=Ie,this.g[this.h++]=Je,this.g[this.h++]=Xe,this.c=M,this.e=oe}static o(M){const oe=[],Ie=M.length/5|0;for(let ht=0;ht<Ie;ht++)oe[ht]=ht;oe.sort((ht,Ot)=>{const Ht=M[5*ht],Yt=M[5*Ot];if(Ht===Yt){const xt=M[5*ht+1],ti=M[5*Ot+1];return xt-ti}return Ht-Yt});const Je=new Uint32Array(M.length);let Xe=0,ot=0;for(let ht=0;ht<Ie;ht++){const Ot=5*oe[ht],Ht=M[Ot+0],Yt=M[Ot+1],xt=M[Ot+2],ti=M[Ot+3],Ri=M[Ot+4],An=Ht-Xe,Hn=An===0?Yt-ot:Yt,Fi=5*ht;Je[Fi+0]=An,Je[Fi+1]=Hn,Je[Fi+2]=xt,Je[Fi+3]=ti,Je[Fi+4]=Ri,Xe=Ht,ot=Yt}return Je}build(M){return this.f?new pi(new Uint32Array(this.g),M):new pi(hi.o(this.g),M)}}e.$rK=hi;class pi{constructor(M,oe){this.resultId=oe,this.data=M}}e.$sK=pi;class ze{constructor(M,oe,Ie){this.start=M,this.deleteCount=oe,this.data=Ie}}e.$tK=ze;class Xt{constructor(M,oe){this.resultId=oe,this.edits=M}}e.$uK=Xt;var Ci;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Ci||(e.DebugConsoleMode=Ci={}));let gt=e.$vK=class{constructor(){}};gt.Back={iconPath:new Qt("arrow-left")},e.$vK=gt=qe([O],gt);var Yi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Zi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var Pi;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Pi||(e.ExtensionKind=Pi={}));class ln{static validate(M){if(typeof M.badge=="string"){let oe=(0,f.$Td)(M.badge,0);if(oe<M.badge.length&&(oe+=(0,f.$Td)(M.badge,oe)),M.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!Qt.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,oe,Ie){this.badge=M,this.tooltip=oe,this.color=Ie}}e.$wK=ln;let di=e.$xK=class{constructor(M){this.kind=M}};e.$xK=di=qe([O],di);var Xi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(Xi||(e.ColorThemeKind=Xi={}));class _t{static isNotebookRange(M){return M instanceof _t?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(M,oe){if(M<0)throw(0,C.$4)("start must be positive");if(oe<0)throw(0,C.$4)("end must be positive");M<=oe?(this.c=M,this.e=oe):(this.c=oe,this.e=M)}with(M){let oe=this.c,Ie=this.e;return M.start!==void 0&&(oe=M.start),M.end!==void 0&&(Ie=M.end),oe===this.c&&Ie===this.e?this:new _t(oe,Ie)}}e.$yK=_t;class bi{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(oe=>bi.isNotebookCellData(oe))}static isNotebookCellData(M){return!0}constructor(M,oe,Ie,Je,Xe,ot,ht){this.kind=M,this.value=oe,this.languageId=Ie,this.mime=Je,this.outputs=Xe??[],this.metadata=ot,this.executionSummary=ht,bi.validate(this)}}e.$zK=bi;class _i{constructor(M){this.cells=M}}e.$AK=_i;class Jt{static isNotebookCellOutputItem(M){return M instanceof Jt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const oe={name:M.name,message:M.message,stack:M.stack};return Jt.json(oe,"application/vnd.code.notebook.error")}static stdout(M){return Jt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Jt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,oe="application/octet-stream"){return new Jt(M,oe)}static text(M,oe=T.$qr.text){const Ie=Te(Jt,y,"f",i).encode(String(M));return new Jt(Ie,oe)}static json(M,oe="text/x-json"){const Ie=JSON.stringify(M,void 0,"	");return Jt.text(Ie,oe)}constructor(M,oe){this.data=M,this.mime=oe;const Ie=(0,T.$ur)(oe,!0);if(!Ie)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}}e.$BK=Jt,y=Jt,i={value:new TextEncoder};class vi{static isNotebookCellOutput(M){return M instanceof vi?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,oe=!1){const Ie=new Set,Je=new Set;for(let Xe=0;Xe<M.length;Xe++){const ot=M[Xe],ht=(0,T.$ur)(ot.mime);if(!Ie.has(ht)||(0,$.$gH)(ht)){Ie.add(ht);continue}Je.add(Xe),oe&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Je.size===0?M:M.filter((Xe,ot)=>!Je.has(ot))}constructor(M,oe,Ie){this.items=vi.ensureUniqueMimeTypes(M,!0),typeof oe=="string"?(this.id=oe,this.metadata=Ie):(this.id=(0,F.$3e)(),this.metadata=oe??Ie)}}e.$CK=vi;var xi;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var en;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(en||(e.NotebookCellExecutionState=en={}));var tn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(tn||(e.NotebookCellStatusBarAlignment=tn={}));var nn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(nn||(e.NotebookEditorRevealType=nn={}));class hn{constructor(M,oe){this.text=M,this.alignment=oe}}e.$DK=hn;var rn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(rn||(e.NotebookControllerAffinity=rn={}));var sn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(sn||(e.NotebookControllerAffinity2=sn={}));class se{constructor(M,oe=[]){this.uri=M,this.provides=(0,g.$Gf)(oe)}}e.$EK=se;class fe{constructor(M){this.label=M}}e.$FK=fe;let Me=e.$GK=class{constructor(M,oe){this.label=M,this.timestamp=oe}};e.$GK=Me=qe([O],Me);var nt;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(nt||(e.ExtensionMode=nt={}));var Dt;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Dt||(e.ExtensionRuntime=Dt={}));var Ft;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Ft||(e.StandardTokenType=Ft={}));class Mn{constructor(M,oe){this.ranges=M,this.wordPattern=oe}}e.$HK=Mn;class zn{constructor(M){this.c=M}get autoForwardAction(){return this.c}}e.$IK=zn;var gn;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(gn||(e.TestResultState=gn={}));var mn;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(mn||(e.TestRunProfileKind=mn={}));let dn=e.$JK=class{constructor(M=void 0,oe=void 0,Ie=void 0,Je=!1){this.include=M,this.exclude=oe,this.profile=Ie,this.continuous=Je}};e.$JK=dn=qe([O],dn);let $n=e.$KK=class extends dn{};e.$KK=$n=qe([O],$n);let pn=e.$LK=H=class{static diff(M,oe,Ie){const Je=new H(M);return Je.expectedOutput=oe,Je.actualOutput=Ie,Je}constructor(M){this.message=M}};e.$LK=pn=H=qe([O],pn);let bn=e.$MK=class{constructor(M){this.id=M}};e.$MK=bn=qe([O],bn);let Ai=e.$NK=class{constructor(M,oe){this.covered=M,this.total=oe}};e.$NK=Ai=qe([O],Ai);let vn=e.$OK=j=class{static fromDetails(M,oe){const Ie=new Ai(0,0),Je=new Ai(0,0),Xe=new Ai(0,0);for(const ht of oe)if("branches"in ht){Ie.total+=1,Ie.covered+=ht.executionCount>0?1:0;for(const Ot of ht.branches)Je.total+=1,Je.covered+=Ot.executionCount>0?1:0}else Xe.total+=1,Xe.covered+=ht.executionCount>0?1:0;const ot=new j(M,Ie,Je.total>0?Je:void 0,Xe.total>0?Xe:void 0);return ot.detailedCoverage=oe,ot}constructor(M,oe,Ie,Je){this.uri=M,this.statementCoverage=oe,this.branchCoverage=Ie,this.functionCoverage=Je}};e.$OK=vn=j=qe([O],vn);let wn=e.$PK=class{constructor(M,oe,Ie=[]){this.executionCount=M,this.location=oe,this.branches=Ie}};e.$PK=wn=qe([O],wn);let yn=e.$QK=class{constructor(M,oe){this.executionCount=M,this.location=oe}};e.$QK=yn=qe([O],yn);let En=e.$RK=class{constructor(M,oe){this.executionCount=M,this.location=oe}};e.$RK=En=qe([O],En);var Dn;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Dn||(e.ExternalUriOpenerPriority=Dn={}));var kn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(kn||(e.WorkspaceTrustState=kn={}));var Sn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn||(e.PortAutoForwardAction=Sn={}));class Nn{constructor(M,oe,Ie,Je,Xe,ot){this.kind=M,this.name=oe,this.detail=Ie,this.uri=Je,this.range=Xe,this.selectionRange=ot}}e.$SK=Nn;class On{constructor(M){this.uri=M}}e.$TK=On;class Un{constructor(M,oe){this.original=M,this.modified=oe}}e.$UK=Un;class jn{constructor(M,oe,Ie,Je){this.base=M,this.input1=oe,this.input2=Ie,this.result=Je}}e.$VK=jn;class Bn{constructor(M,oe){this.uri=M,this.viewType=oe}}e.$WK=Bn;class Wn{constructor(M){this.viewType=M}}e.$XK=Wn;class Kn{constructor(M,oe){this.uri=M,this.notebookType=oe}}e.$YK=Kn;class Vn{constructor(M,oe,Ie){this.original=M,this.modified=oe,this.notebookType=Ie}}e.$ZK=Vn;class qn{constructor(){}}e.$1K=qn;class Jn{constructor(M,oe){this.uri=M,this.inputBoxUri=oe}}e.$2K=Jn;var In;(function(U){U[U.Up=1]="Up",U[U.Down=2]="Down"})(In||(e.InteractiveSessionVoteDirection=In={}));var Cn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(Cn||(e.InteractiveSessionCopyKind=Cn={}));var Pn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone"})(Pn||(e.InteractiveEditorResponseFeedbackKind=Pn={}))}),define(Re[100],Fe([1,0,49,14,13,271,136,7,18]),function(te,e,g,C,S,z,T,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eL=e.$dL=e.$cL=void 0;const m=new Map;function F($,u){u?m.set($,u):m.delete($)}e.$cL=F;function D($){return m.get($)}class h extends z.$pu{constructor(u,t,r,c,w,v,y,i){super(t,r,c,w),this.c=u,this.m=v,this.q=y,this.notebook=i,this.b=!1}dispose(){(0,g.ok)(!this.b),this.b=!0,this.q=!1}equalLines(u){return(0,k.$$e)(this.f,u)}get document(){if(!this.a){const u=this;this.a={get uri(){return u.d},get fileName(){return u.d.fsPath},get isUntitled(){return u.d.scheme===C.Schemas.untitled},get languageId(){return u.m},get version(){return u.h},get isClosed(){return u.b},get isDirty(){return u.q},save(){return u.r()},getText(t){return t?u.s(t):u.getText()},get eol(){return u.g===`
`?f.EndOfLine.LF:f.EndOfLine.CRLF},get lineCount(){return u.f.length},lineAt(t){return u.t(t)},offsetAt(t){return u.u(t)},positionAt(t){return u.v(t)},validateRange(t){return u.w(t)},validatePosition(t){return u.x(t)},getWordRangeAtPosition(t,r){return u.y(t,r)}}}return Object.freeze(this.a)}_acceptLanguageId(u){(0,g.ok)(!this.b),this.m=u}_acceptIsDirty(u){(0,g.ok)(!this.b),this.q=u}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(u){const t=this.w(u);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const r=this.g,c=t.start.line,w=t.end.line,v=[];v.push(this.f[c].substring(t.start.character));for(let y=c+1;y<w;y++)v.push(this.f[y]);return v.push(this.f[w].substring(0,t.end.character)),v.join(r)}t(u){let t;if(u instanceof f.$bJ?t=u.line:typeof u=="number"&&(t=u),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(u){return u=this.x(u),this.l(),this.j.getPrefixSum(u.line-1)+u.character}v(u){u=Math.floor(u),u=Math.max(0,u),this.l();const t=this.j.getIndexOf(u),r=this.f[t.index].length;return new f.$bJ(t.index,Math.min(t.remainder,r))}w(u){if(!(u instanceof f.$cJ))throw new Error("Invalid argument");const t=this.x(u.start),r=this.x(u.end);return t===u.start&&r===u.end?u:new f.$cJ(t.line,t.character,r.line,r.character)}x(u){if(!(u instanceof f.$bJ))throw new Error("Invalid argument");if(this.f.length===0)return u.with(0,0);let{line:t,character:r}=u,c=!1;if(t<0)t=0,r=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,r=this.f[t].length,c=!0;else{const w=this.f[t].length;r<0?(r=0,c=!0):r>w&&(r=w,c=!0)}return c?new f.$bJ(t,r):u}y(u,t){const r=this.x(u);if(!t)t=D(this.m);else if((0,S.$ud)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,T.$Ir)(r.character+1,(0,T.$Gr)(t),this.f[r.line],0);if(c)return new f.$cJ(r.line,c.startColumn-1,r.line,c.endColumn-1)}}e.$dL=h;class b{constructor(u,t,r){this.a=u,this.b=t,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new f.$cJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new f.$cJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$eL=b}),define(Re[195],Fe([1,0,7,17,5]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o_b=void 0;let z=e.$o_b=class{constructor(f){this.a=new g.$xK(g.ColorThemeKind.Dark),this.b=new S.$5c}get activeColorTheme(){return this.a}$onColorThemeChange(f){let k;switch(f){case"light":k=g.ColorThemeKind.Light;break;case"hcDark":k=g.ColorThemeKind.HighContrast;break;case"hcLight":k=g.ColorThemeKind.HighContrastLight;break;default:k=g.ColorThemeKind.Dark}this.a=new g.$xK(k),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$o_b=z=qe([Ve(0,C.$aL)],z)}),define(Re[196],Fe([1,0,3]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jH=e.CellExecutionUpdateType=void 0;var C;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(C||(e.CellExecutionUpdateType=C={})),e.$jH=(0,g.$lh)("INotebookExecutionService")}),define(Re[45],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WH=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(z){z.Delimiter="\0"})(g||(e.TestIdPathParts=g={}));var C;(function(z){z[z.IsSame=0]="IsSame",z[z.Disconnected=1]="Disconnected",z[z.IsChild=2]="IsChild",z[z.IsParent=3]="IsParent"})(C||(e.TestPosition=C={}));class S{static fromExtHostTestItem(T,f,k=T.parent){if(T._isRoot)return new S([f]);const m=[T.id];for(let F=k;F&&F.id!==f;F=F.parent)m.push(F.id);return m.push(f),new S(m.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const f=T.indexOf("\0");return f===-1?T:T.slice(0,f)}static fromString(T){return new S(T.split("\0"))}static join(T,f){return new S([...T.path,f])}static joinToString(T,f){return T.toString()+"\0"+f}static parentId(T){const f=T.lastIndexOf("\0");return f===-1?void 0:T.slice(0,f)}static localId(T){const f=T.lastIndexOf("\0");return f===-1?T:T.slice(f+1)}static isChild(T,f){return f.startsWith(T)&&f[T.length]==="\0"}static compare(T,f){return T===f?0:S.isChild(T,f)?2:S.isChild(f,T)?3:1}constructor(T,f=T.length){if(this.path=T,this.d=f,T.length===0||f<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new S(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let T=1;T<=this.d;T++)yield new S(this.path,T)}*idsToRoot(){for(let T=this.d;T>0;T--)yield new S(this.path,T)}compare(T){if(typeof T=="string")return S.compare(this.toString(),T);for(let f=0;f<T.d&&f<this.d;f++)if(T.path[f]!==this.path[f])return 1;return T.d>this.d?2:T.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let T=1;T<this.d;T++)this.c+="\0",this.c+=this.path[T]}return this.c}}e.$WH=S}),define(Re[56],Fe([1,0,2,44,45]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4H=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$3H=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$2H=e.$1H=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$ZH=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$YH=e.$XH=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var z;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(z||(e.TestResultState=z={}));var T;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var f;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$XH=[2,4,8,16,32,64];const k=A=>"runId"in A;e.$YH=k;var m;(function(A){A.serialize=E=>({range:E.range.toJSON(),uri:E.uri.toJSON()}),A.deserialize=E=>({range:C.$Kr.lift(E.range),uri:g.URI.revive(E.uri)})})(m||(e.IRichLocation=m={}));var F;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(F||(e.TestMessageType=F={}));var D;(function(A){A.serialize=E=>({message:E.message,type:0,expected:E.expected,actual:E.actual,location:E.location&&m.serialize(E.location)}),A.deserialize=E=>({message:E.message,type:0,expected:E.expected,actual:E.actual,location:E.location&&m.deserialize(E.location)})})(D||(e.ITestErrorMessage=D={}));const h=(A,E)=>`${E?"s":"e"}${A}`;e.$ZH=h;var b;(function(A){A.serialize=E=>({message:E.message,type:1,offset:E.offset,length:E.length,location:E.location&&m.serialize(E.location)}),A.deserialize=E=>({message:E.message,type:1,offset:E.offset,length:E.length,location:E.location&&m.deserialize(E.location)})})(b||(e.ITestOutputMessage=b={}));var $;(function(A){A.serialize=E=>E.type===0?D.serialize(E):b.serialize(E),A.deserialize=E=>E.type===0?D.deserialize(E):b.deserialize(E)})($||(e.ITestMessage=$={}));var u;(function(A){A.serializeWithoutMessages=E=>({state:E.state,duration:E.duration,messages:[]}),A.serialize=E=>({state:E.state,duration:E.duration,messages:E.messages.map($.serialize)}),A.deserialize=E=>({state:E.state,duration:E.duration,messages:E.messages.map($.deserialize)})})(u||(e.ITestTaskState=u={}));const t="\0",r=(A,E)=>A+t+E;e.$1H=r;const c=A=>{const E=A.indexOf(t);return{ctrlId:A.slice(0,E),tagId:A.slice(E+1)}};e.$2H=c;var w;(function(A){A.serialize=E=>({extId:E.extId,label:E.label,tags:E.tags,busy:E.busy,children:void 0,uri:E.uri?.toJSON(),range:E.range?.toJSON()||null,description:E.description,error:E.error,sortText:E.sortText}),A.deserialize=E=>({extId:E.extId,label:E.label,tags:E.tags,busy:E.busy,children:void 0,uri:E.uri?g.URI.revive(E.uri):void 0,range:E.range?C.$Kr.lift(E.range):null,description:E.description,error:E.error,sortText:E.sortText})})(w||(e.ITestItem=w={}));var v;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(v||(e.TestItemExpandState=v={}));var y;(function(A){A.serialize=E=>({expand:E.expand,item:w.serialize(E.item)}),A.deserialize=E=>({controllerId:S.$WH.root(E.item.extId),expand:E.expand,item:w.deserialize(E.item)})})(y||(e.InternalTestItem=y={}));var i;(function(A){A.serialize=E=>{let a;return E.item&&(a={},E.item.label!==void 0&&(a.label=E.item.label),E.item.tags!==void 0&&(a.tags=E.item.tags),E.item.busy!==void 0&&(a.busy=E.item.busy),E.item.uri!==void 0&&(a.uri=E.item.uri?.toJSON()),E.item.range!==void 0&&(a.range=E.item.range?.toJSON()),E.item.description!==void 0&&(a.description=E.item.description),E.item.error!==void 0&&(a.error=E.item.error),E.item.sortText!==void 0&&(a.sortText=E.item.sortText)),{extId:E.extId,expand:E.expand,item:a}},A.deserialize=E=>{let a;return E.item&&(a={},E.item.label!==void 0&&(a.label=E.item.label),E.item.tags!==void 0&&(a.tags=E.item.tags),E.item.busy!==void 0&&(a.busy=E.item.busy),E.item.range!==void 0&&(a.range=E.item.range?C.$Kr.lift(E.item.range):null),E.item.description!==void 0&&(a.description=E.item.description),E.item.error!==void 0&&(a.error=E.item.error),E.item.sortText!==void 0&&(a.sortText=E.item.sortText)),{extId:E.extId,expand:E.expand,item:a}}})(i||(e.ITestItemUpdate=i={}));const l=(A,E)=>{E.expand!==void 0&&(A.expand=E.expand),E.item!==void 0&&(A.item=A.item?Object.assign(A.item,E.item):E.item)};e.$3H=l;var n;(function(A){A.serializeWithoutMessages=E=>({...y.serialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(u.serializeWithoutMessages)}),A.serialize=E=>({...y.serialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(u.serialize)}),A.deserialize=E=>({...y.deserialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(u.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var s;(function(A){A[A.Function=0]="Function",A[A.Statement=1]="Statement"})(s||(e.DetailType=s={}));var p;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(p||(e.TestDiffOpType=p={}));var I;(function(A){A.deserialize=E=>E.op===0?{op:E.op,item:y.deserialize(E.item)}:E.op===1?{op:E.op,item:i.deserialize(E.item)}:E.op===2?{op:E.op,uri:g.URI.revive(E.uri),docv:E.docv}:E,A.serialize=E=>E.op===0?{op:E.op,item:y.serialize(E.item)}:E.op===1?{op:E.op,item:i.serialize(E.item)}:E})(I||(e.TestsDiffOp=I={}));class d{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(E){const a=this.o();for(const o of E)switch(o.op){case 0:this.j(y.deserialize(o.item),a);break;case 1:this.k(i.deserialize(o.item),a);break;case 3:this.l(o.itemId,a);break;case 5:this.m(o.itemId);break;case 4:this.updatePendingRoots(o.amount);break;case 6:this.c.set(o.tag.id,o.tag);break;case 7:this.c.delete(o.id);break}a.complete?.()}j(E,a){const o=S.$WH.parentId(E.item.extId)?.toString();let L;if(!o)L=this.p(E),this.f.add(L),this.d.set(E.item.extId,L);else if(this.d.has(o)){const B=this.d.get(o);B.children.add(E.item.extId),L=this.p(E,B),this.d.set(E.item.extId,L)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(E)}`);return}return a.add?.(L),E.expand===2&&this.g++,L}k(E,a){const o=this.d.get(E.extId);if(o)return E.expand!==void 0&&(o.expand===2&&this.g--,E.expand===2&&this.g++),(0,e.$3H)(o,E),a.update?.(o),o}l(E,a){const o=this.d.get(E);if(!o)return;const L=S.$WH.parentId(o.item.extId)?.toString();L?this.d.get(L).children.delete(o.item.extId):this.f.delete(o);const B=[[E]];for(;B.length;)for(const G of B.pop()){const q=this.d.get(G);q&&(B.push(q.children),this.d.delete(G),a.remove?.(q,q!==o),q.expand===2&&this.g--)}}m(E){}updatePendingRoots(E){this.h+=E}o(){return{}}}e.$4H=d}),define(Re[77],Fe([1,0,16,5,6,49,56,45]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.TestItemEventOp=void 0;var k;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(k||(e.TestItemEventOp=k={}));const m=(c,w)=>c===w,D=Object.entries({range:(c,w)=>c===w?!0:!c||!w?!1:c.equalsRange(w),busy:m,label:m,description:m,error:m,sortText:m,tags:(c,w)=>!(c.length!==w.length||c.some(v=>!w.includes(v)))}),h=(c,w)=>{let v;for(const[y,i]of D)i(c[y],w[y])||(v?v[y]=w[y]:v={[y]:w[y]});return v};class b extends S.$kb{get root(){return this.m.root}constructor(w){super(),this.m=w,this.f=this.B(new g.$Cg(()=>this.flushDiff(),200)),this.g=this.B(new C.$5c),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(w){this.h=w;for(const v of this.tree.values())this.G(v)}get resolveHandler(){return this.h}collectDiff(){const w=this.k;return this.k=[],w}pushDiff(w){switch(w.op){case 2:{for(const v of this.k)if(v.op===2&&v.uri===w.uri){v.docv=w.docv;return}break}case 1:{const v=this.k[this.k.length-1];if(v){if(v.op===1&&v.item.extId===w.item.extId){(0,T.$3H)(v.item,w.item);return}if(v.op===0&&v.item.item.extId===w.item.extId){(0,T.$3H)(v.item,w.item);return}}break}}this.k.push(w),this.f.isScheduled()||this.f.schedule()}expand(w,v){const y=this.tree.get(w);if(y){if((y.expandLevels===void 0||v>y.expandLevels)&&(y.expandLevels=v),y.expand===1){const i=this.I(y);return i.isOpen()?this.H(y,v-1):i.wait().then(()=>this.H(y,v-1))}else if(y.expand===3)return y.resolveBarrier?.isOpen()===!1?y.resolveBarrier.wait().then(()=>this.H(y,v-1)):this.H(y,v-1)}}dispose(){for(const w of this.tree.values())this.m.getApiFor(w.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(w,v){switch(v.op){case 3:this.L(f.$WH.joinToString(w.fullId,v.id));break;case 0:this.u(v.item,w);break;case 5:for(const y of v.ops)this.p(w,y);break;case 1:this.w(v.new,v.old,w.fullId.toString());break;case 2:this.G(w);break;case 4:this.pushDiff({op:1,item:{extId:w.fullId.toString(),item:v.update}});break;case 6:this.s(w.actual.uri);break;default:(0,z.$lc)(v)}}s(w){w&&this.pushDiff({op:2,uri:w,docv:this.m.getDocumentVersion(w)})}u(w,v){const y=f.$WH.fromExtHostTestItem(w,this.root.id,v?.actual),i=this.m.getApiFor(w);i.parent&&i.parent!==v?.actual&&this.m.getChildren(i.parent).delete(w.id);let l=this.tree.get(y.toString());if(!l){l={fullId:y,actual:w,expandLevels:v?.expandLevels?v.expandLevels-1:void 0,expand:0},w.tags.forEach(this.y,this),this.tree.set(l.fullId.toString(),l),this.C(w,v),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:l.expand,item:this.m.toITestItem(w)}}),this.F(w,l,v);return}if(l.actual===w){this.D(w,l,v);return}if(l.actual.uri?.toString()!==w.uri?.toString())return this.L(y.toString()),this.u(w,v);const n=this.m.getChildren(l.actual),s=l.actual,p=h(this.m.toITestItem(s),this.m.toITestItem(w));this.m.getApiFor(s).listener=void 0,l.actual=w,l.expand=0,p&&(p.hasOwnProperty("tags")&&(this.w(w.tags,s.tags,y.toString()),delete p.tags),this.p(l,{op:4,update:p})),this.F(w,l,v);for(const[I,d]of n)this.m.getChildren(w).get(d.id)||this.L(f.$WH.joinToString(y,d.id));this.s(l.actual.uri)}w(w,v,y){const i=new Set(v.map(l=>l.id));for(const l of w)i.delete(l.id)||this.y(l);this.pushDiff({op:1,item:{extId:y,item:{tags:w.map(l=>(0,T.$1H)(this.m.controllerId,l.id))}}}),i.forEach(this.z,this)}y(w){const v=this.j.get(w.id);v?v.refCount++:(this.j.set(w.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.$1H)(this.m.controllerId,w.id)}}))}z(w){const v=this.j.get(w);v&&!--v.refCount&&(this.j.delete(w),this.pushDiff({op:7,id:(0,T.$1H)(this.m.controllerId,w)}))}C(w,v){this.m.getApiFor(w).parent=v&&v.actual!==this.root?v.actual:void 0}D(w,v,y){this.C(w,y);const i=this.m.getApiFor(w);i.parent=y?.actual,i.listener=l=>this.p(v,l),this.G(v)}F(w,v,y){this.D(w,v,y);for(const[i,l]of this.m.getChildren(w))this.u(l,v)}G(w){let v;this.h?w.resolveBarrier?v=w.resolveBarrier.isOpen()?3:2:v=w.actual.canResolveChildren?1:0:v=0,v!==w.expand&&(w.expand=v,this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:v}}),v===1&&w.expandLevels!==void 0&&this.I(w))}H(w,v){if(v<0)return;const y=[];for(const[i,l]of this.m.getChildren(w.actual)){const n=this.expand(f.$WH.joinToString(w.fullId,l.id),v);(0,g.$eg)(n)&&y.push(n)}if(y.length)return Promise.all(y).then(()=>{})}I(w){if(w.resolveBarrier)return w.resolveBarrier;if(!this.h){const l=new g.$qg;return l.open(),l}w.expand=2,this.J(w);const v=w.resolveBarrier=new g.$qg,y=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,l)};let i;try{i=this.h(w.actual===this.root?void 0:w.actual)}catch(l){y(l)}return(0,g.$eg)(i)?i.catch(y).then(()=>{v.open(),this.G(w)}):(v.open(),this.G(w)),w.resolveBarrier}J(w){this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:w.expand}})}L(w){const v=this.tree.get(w);if(!v)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:w});const y=[v];for(;y.length;){const i=y.pop();if(i){this.m.getApiFor(i.actual).listener=void 0;for(const l of i.actual.tags)this.z(l.id);this.tree.delete(i.fullId.toString());for(const[l,n]of this.m.getChildren(i.actual))y.push(this.tree.get(f.$WH.joinToString(i.fullId,n.id)))}}}flushDiff(){const w=this.collectDiff();w.length&&this.g.fire(w)}}e.$3K=b;class $ extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.$4K=$;class u extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$5K=u;class t extends Error{constructor(w,v,y){super(`TestItem with ID "${w}" is from controller "${v}" and cannot be added as a child of an item from controller "${y}".`)}}e.$6K=t;const r=(c,w,v)=>{let y=new Map;return{get size(){return y.size},forEach(i,l){for(const n of y.values())i.call(l,n,this)},[Symbol.iterator](){return y.entries()},replace(i){const l=new Map,n=new Set(y.keys()),s={op:5,ops:[]};for(const p of i){if(!(p instanceof v))throw new u(p.id);const I=w(p).controllerId;if(I!==c.controllerId)throw new t(p.id,I,c.controllerId);if(l.has(p.id))throw new $(p.id);l.set(p.id,p),n.delete(p.id),s.ops.push({op:0,item:p})}for(const p of n.keys())s.ops.push({op:3,id:p});c.listener?.(s),y=l},add(i){if(!(i instanceof v))throw new u(i.id);y.set(i.id,i),c.listener?.({op:0,item:i})},delete(i){y.delete(i)&&c.listener?.({op:3,id:i})},get(i){return y.get(i)},toJSON(){return Array.from(y.values())}}};e.$7K=r}),define(Re[101],Fe([1,0,77]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=e.$8K=void 0;const C=new WeakMap,S=(T,f)=>{const k={controllerId:f};return C.set(T,k),k};e.$8K=S;const z=T=>{const f=C.get(T);if(!f)throw new g.$5K(T?.id||"<unknown>");return f};e.$9K=z}),define(Re[78],Fe([1,0,14,2]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slb=e.$Rlb=e.$Qlb=e.$Plb=e.$Olb=void 0,e.$Olb="vscode-cdn.net",e.$Plb=`vscode-resource.${e.$Olb}`,e.$Qlb=`'self' https://*.${e.$Olb}`;function S(f,k){return f.scheme===g.Schemas.http||f.scheme===g.Schemas.https?f:(k&&k.authority&&k.isRemote&&f.scheme===g.Schemas.file&&(f=C.URI.from({scheme:g.Schemas.vscodeRemote,authority:k.authority,path:f.path})),C.URI.from({scheme:g.Schemas.https,authority:`${f.scheme}+${z(f.authority)}.${e.$Plb}`,path:f.path,fragment:f.fragment,query:f.query}))}e.$Rlb=S;function z(f){return f.replace(/./g,k=>{const m=k.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?k:"-"+m.toString(16).padStart(4,"0")})}function T(f){return f.replace(/-([0-9a-f]{4})/g,(k,m)=>String.fromCharCode(parseInt(m,16)))}e.$Slb=T}),define(Re[197],Fe([1,0,5,6,78]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=void 0;class z{constructor(f,k,m){this.d=f,this.e=k,this.f=m,this.a=0,this.b=new C.$jb,this.c=new Map,this.b.add(k.onDidChangeVisibleTextEditors(()=>{const F=k.getVisibleTextEditors();for(const D of this.c.values())F.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(f=>f.inset.dispose()),this.b.dispose()}createWebviewEditorInset(f,k,m,F,D){let h;for(const w of this.e.getVisibleTextEditors(!0))if(w.value===f){h=w;break}if(!h)throw new Error("not a visible editor");const b=this,$=this.a++,u=new g.$5c,t=new g.$5c,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(w){return(0,S.$Rlb)(w,b.f)}get cspSource(){return S.$Qlb}set options(w){this.b=w,b.d.$setOptions($,w)}get options(){return this.b}set html(w){this.a=w,b.d.$setHtml($,w)}get html(){return this.a}get onDidReceiveMessage(){return u.event}postMessage(w){return b.d.$postMessage($,w)}},c=new class{constructor(){this.editor=f,this.line=k,this.height=m,this.webview=r,this.onDidDispose=t.event}dispose(){b.c.has($)&&(b.c.delete($),b.d.$disposeEditorInset($),t.fire(),t.dispose(),u.dispose())}};return this.d.$createEditorInset($,h.id,h.value.document.uri,k+1,m,F||{},D.identifier,D.extensionLocation),this.c.set($,{editor:f,inset:c,onDidReceiveMessage:u}),c}$onDidDispose(f){const k=this.c.get(f);k&&k.inset.dispose()}$onDidReceiveMessage(f,k){this.c.get(f)?.onDidReceiveMessage.fire(k)}}e.$Y$b=z}),define(Re[198],Fe([1,0,3]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.VariableKind=e.$DL=void 0,e.$DL=(0,g.$lh)("configurationResolverService");var C;(function(z){z.Unknown="unknown",z.Env="env",z.Config="config",z.Command="command",z.Input="input",z.ExtensionInstallFolder="extensionInstallFolder",z.WorkspaceFolder="workspaceFolder",z.Cwd="cwd",z.WorkspaceFolderBasename="workspaceFolderBasename",z.UserHome="userHome",z.LineNumber="lineNumber",z.SelectedText="selectedText",z.File="file",z.FileWorkspaceFolder="fileWorkspaceFolder",z.RelativeFile="relativeFile",z.RelativeFileDirname="relativeFileDirname",z.FileDirname="fileDirname",z.FileExtname="fileExtname",z.FileBasename="fileBasename",z.FileBasenameNoExtension="fileBasenameNoExtension",z.FileDirnameBasename="fileDirnameBasename",z.ExecPath="execPath",z.ExecInstallFolder="execInstallFolder",z.PathSeparator="pathSeparator"})(C||(e.VariableKind=C={}));class S extends Error{constructor(T,f){super(f),this.variable=T}}e.$EL=S}),define(Re[199],Fe([1,0,19,51,10,23,21,90,163,198,13]),function(te,e,g,C,S,z,T,f,k,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=void 0;class D{constructor(b,$,u,t){this.h=new Map,this.a=b,this.b=$,this.g=u,t&&(this.c=t.then(r=>this.i(r)))}i(b){if(T.$i){const $=Object.create(null);return Object.keys(b).forEach(u=>{$[u.toLowerCase()]=b[u]}),$}return b}resolveWithEnvironment(b,$,u){return this.l({env:this.i(b),userHome:void 0},$?$.uri:void 0,u)}async resolveAsync(b,$){const u={env:await this.c,userHome:await this.g};return this.l(u,b?b.uri:void 0,$)}async j(b,$,u,t){const r=z.$Dm($);T.$i&&r.windows?Object.keys(r.windows).forEach(w=>r[w]=r.windows[w]):T.$j&&r.osx?Object.keys(r.osx).forEach(w=>r[w]=r.osx[w]):T.$k&&r.linux&&Object.keys(r.linux).forEach(w=>r[w]=r.linux[w]),delete r.windows,delete r.osx,delete r.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,b?b.uri:void 0,r,u,t)}async resolveAnyAsync(b,$,u){return this.j(b,$,u)}async resolveAnyMap(b,$,u){const t=new Map;return{newConfig:await this.j(b,$,u,t),resolvedVariables:t}}resolveWithInteractionReplace(b,$,u,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,$,u,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,$){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,$)}async l(b,$,u,t,r){if(S.$ge(u))return this.m(b,$,u,t,r);if(Array.isArray(u))return Promise.all(u.map(c=>this.l(b,$,c,t,r)));if(S.$ie(u)){const c=Object.create(null),w=await Promise.all(Object.keys(u).map(async v=>[await this.m(b,$,v,t,r),await this.l(b,$,u[v],t,r)]));for(const[v,y]of w)c[v]=y;return c}return u}m(b,$,u,t,r){return(0,F.$Bd)(u,D.VARIABLE_REGEXP,async(c,w)=>{if(w.includes(D.VARIABLE_LHS))return c;let v=await this.o(b,c,w,$,t);return r?.set(w,v),v!==c&&S.$ge(v)&&v.match(D.VARIABLE_REGEXP)&&(v=await this.m(b,$,v,t,r)),v})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,$,u,t,r){let c;const w=u.split(":");w.length>1&&(u=w[0],c=w[1]);const v=l=>{const n=this.a.getFilePath();if(n)return(0,f.$Oz)(n);throw new m.$EL(l,(0,k.localize)(0,null,$))},y=l=>{const n=v(l);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,f.$Oz)(s)}throw new m.$EL(l,(0,k.localize)(1,null,$,g.$cc(n)))},i=l=>{if(c){const n=this.a.getFolderUri(c);if(n)return n;throw new m.$EL(l,(0,k.localize)(2,null,$,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new m.$EL(l,(0,k.localize)(3,null,$)):new m.$EL(l,(0,k.localize)(4,null,$))};switch(u){case"env":if(c){if(b.env){const l=b.env[T.$i?c.toLowerCase():c];if(S.$ge(l))return l}return""}throw new m.$EL(m.VariableKind.Env,(0,k.localize)(5,null,$));case"config":if(c){const l=this.a.getConfigurationValue(t,c);if(S.$pe(l))throw new m.$EL(m.VariableKind.Config,(0,k.localize)(6,null,$,c));if(S.$ie(l))throw new m.$EL(m.VariableKind.Config,(0,k.localize)(7,null,$,c));return l}throw new m.$EL(m.VariableKind.Config,(0,k.localize)(8,null,$));case"command":return this.p(m.VariableKind.Command,$,c,r,"command");case"input":return this.p(m.VariableKind.Input,$,c,r,"input");case"extensionInstallFolder":if(c){const l=await this.a.getExtension(c);if(!l)throw new m.$EL(m.VariableKind.ExtensionInstallFolder,(0,k.localize)(9,null,$,c));return this.n(l.extensionLocation)}throw new m.$EL(m.VariableKind.ExtensionInstallFolder,(0,k.localize)(10,null,$));default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,f.$Oz)(this.n(i(m.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,f.$Oz)(this.n(i(m.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,f.$Oz)(g.$cc(this.n(i(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new m.$EL(m.VariableKind.UserHome,(0,k.localize)(11,null,$))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new m.$EL(m.VariableKind.LineNumber,(0,k.localize)(12,null,$))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new m.$EL(m.VariableKind.SelectedText,(0,k.localize)(13,null,$))}case"file":return v(m.VariableKind.File);case"fileWorkspaceFolder":return y(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?g.$ac(this.n(i(m.VariableKind.RelativeFile)),v(m.VariableKind.RelativeFile)):v(m.VariableKind.RelativeFile);case"relativeFileDirname":{const l=g.$bc(v(m.VariableKind.RelativeFileDirname));if(t||c){const n=g.$ac(this.n(i(m.VariableKind.RelativeFileDirname)),l);return n.length===0?".":n}return l}case"fileDirname":return g.$bc(v(m.VariableKind.FileDirname));case"fileExtname":return g.$dc(v(m.VariableKind.FileExtname));case"fileBasename":return g.$cc(v(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=g.$cc(v(m.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-g.$dc(l).length)}case"fileDirnameBasename":return g.$cc(g.$bc(v(m.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||$}case"execInstallFolder":{const l=this.a.getAppRoot();return l||$}case"pathSeparator":return g.sep;default:try{const l=c?`${u}:${c}`:u;return this.p(m.VariableKind.Unknown,$,l,r,void 0)}catch{return $}}}}p(b,$,u,t,r){if(u&&t){const c=r===void 0?t[u]:t[r+":"+u];if(typeof c=="string")return c;throw new m.$EL(b,(0,k.localize)(14,null,$))}return $}}e.$cM=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Re[102],Fe([1,0,3,99]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tC=e.$sC=e.OpenEditorContext=e.GroupsOrder=e.$rC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$qC=void 0,e.$qC=(0,g.$lh)("editorGroupsService");var S;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(S||(e.GroupDirection=S={}));var z;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(z||(e.GroupOrientation=z={}));var T;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var f;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EVEN=1]="EVEN",$[$.TOGGLE=2]="TOGGLE"})(f||(e.GroupsArrangement=f={}));var k;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(k||(e.MergeGroupMode=k={}));function m($){const u=$;return(0,C.$eE)(u?.editor)&&(0,C.$eE)(u?.replacement)}e.$rC=m;var F;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F||(e.GroupsOrder=F={}));var D;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function h($){const u=$;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.$sC=h;function b($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$tC=b}),define(Re[200],Fe([1,0,3,102]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xC=e.$wC=e.$vC=e.$uC=void 0,e.$uC=(0,g.$lh)("editorService"),e.$vC=-1,e.$wC=-2;function S(z){const T=z;return typeof z=="number"||(0,C.$sC)(T)}e.$xC=S}),define(Re[8],Fe([1,0,18,25,122,201,70,28,116,69,68,23,10,2,44,79,94,101,99,76,45,56,200,7]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t,r,c,w,v,y,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$_K=e.$$K=e.MarkdownString=e.$0K=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Ae){function we(Z){const{selectionStartLineNumber:Le,selectionStartColumn:Ue,positionLineNumber:Ge,positionColumn:Ke}=Z,xe=new l.$bJ(Le-1,Ue-1),Et=new l.$bJ(Ge-1,Ke-1);return new l.$dJ(xe,Et)}Ae.to=we;function be(Z){const{anchor:Le,active:Ue}=Z;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Ae.from=be})(n||(e.Selection=n={}));var s;(function(Ae){function we(Z){if(!Z)return;const{start:Le,end:Ue}=Z;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Ae.from=we;function be(Z){if(!Z)return;const{startLineNumber:Le,startColumn:Ue,endLineNumber:Ge,endColumn:Ke}=Z;return new l.$cJ(Le-1,Ue-1,Ge-1,Ke-1)}Ae.to=be})(s||(e.Range=s={}));var p;(function(Ae){function we(be){switch(be){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Ae.to=we})(p||(e.TokenType=p={}));var I;(function(Ae){function we(Z){return new l.$bJ(Z.lineNumber-1,Z.column-1)}Ae.to=we;function be(Z){return{lineNumber:Z.line+1,column:Z.character+1}}Ae.from=be})(I||(e.Position=I={}));var d;(function(Ae){function we(Le,Ue,Ge){return(0,g.$jf)((0,g.$Gf)(Le).map(Ke=>be(Ke,Ue,Ge)))}Ae.from=we;function be(Le,Ue,Ge){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Ge?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:Z(Le.scheme,Ue),pattern:st.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Ge?.isBuiltin}}function Z(Le,Ue){return Ue&&typeof Le=="string"?Ue.transformOutgoingScheme(Le):Le}})(d||(e.DocumentSelector=d={}));var A;(function(Ae){function we(Z){switch(Z){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Ae.from=we;function be(Z){switch(Z){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Ae.to=be})(A||(e.DiagnosticTag=A={}));var E;(function(Ae){function we(Z){let Le;return Z.code&&((0,h.$ge)(Z.code)||(0,h.$ke)(Z.code)?Le=String(Z.code):Le={value:String(Z.code.value),target:Z.code.target}),{...s.from(Z.range),message:Z.message,source:Z.source,code:Le,severity:o.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(a.from),tags:Array.isArray(Z.tags)?(0,g.$jf)(Z.tags.map(A.from)):void 0}}Ae.from=we;function be(Z){const Le=new l.$oJ(s.to(Z),Z.message,o.to(Z.severity));return Le.source=Z.source,Le.code=(0,h.$ge)(Z.code)?Z.code:Z.code?.value,Le.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(a.to),Le.tags=Z.tags&&(0,g.$jf)(Z.tags.map(A.to)),Le}Ae.to=be})(E||(e.Diagnostic=E={}));var a;(function(Ae){function we(Z){return{...s.from(Z.location.range),message:Z.message,resource:Z.location.uri}}Ae.from=we;function be(Z){return new l.$nJ(new l.$mJ(Z.resource,s.to(Z)),Z.message)}Ae.to=be})(a||(e.DiagnosticRelatedInformation=a={}));var o;(function(Ae){function we(Z){switch(Z){case l.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ae.from=we;function be(Z){switch(Z){case t.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Ae.to=be})(o||(e.DiagnosticSeverity=o={}));var L;(function(Ae){function we(Z){return typeof Z=="number"&&Z>=l.ViewColumn.One?Z-1:Z===l.ViewColumn.Beside?i.$wC:i.$vC}Ae.from=we;function be(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=be})(L||(e.ViewColumn=L={}));function B(Ae){return typeof Ae.range<"u"}function G(Ae){return Ae.length===0?!0:!!B(Ae[0])}e.$0K=G;var q;(function(Ae){function we(Ke){return Ke.map(Ae.from)}Ae.fromMany=we;function be(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Z(Ke){let xe;if(be(Ke)){const{language:mt,value:pt}=Ke;xe={value:"```"+mt+`
`+pt+"\n```\n"}}else l.$BJ.isMarkdownString(Ke)?xe={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?xe={value:Ke}:xe={value:""};const Et=Object.create(null);xe.uris=Et;const It=mt=>{try{let pt=b.URI.parse(mt,!0);pt=pt.with({query:Le(pt.query,Et)}),Et[mt]=pt}catch{}return""},Pt=new k.marked.Renderer;return Pt.link=It,Pt.image=mt=>typeof mt=="string"?It(T.$Nj(mt).href):"",(0,k.marked)(xe.value,{renderer:Pt}),xe}Ae.from=Z;function Le(Ke,xe){if(!Ke)return Ke;let Et;try{Et=(0,m.$Tg)(Ke)}catch{}if(!Et)return Ke;let It=!1;return Et=(0,D.$Fm)(Et,Pt=>{if(b.URI.isUri(Pt)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return xe[mt]=Pt,It=!0,mt}else return}),It?JSON.stringify(Et):Ke}function Ue(Ke){const xe=new l.$BJ(Ke.value,Ke.supportThemeIcons);return xe.isTrusted=Ke.isTrusted,xe.supportHtml=Ke.supportHtml,xe.baseUri=Ke.baseUri?b.URI.from(Ke.baseUri):void 0,xe}Ae.to=Ue;function Ge(Ke){if(Ke)return typeof Ke=="string"?Ke:Ae.from(Ke)}Ae.fromStrict=Ge})(q||(e.MarkdownString=q={}));function W(Ae){return G(Ae)?Ae.map(we=>({range:s.from(we.range),hoverMessage:Array.isArray(we.hoverMessage)?q.fromMany(we.hoverMessage):we.hoverMessage?q.from(we.hoverMessage):void 0,renderOptions:we.renderOptions})):Ae.map(we=>({range:s.from(we)}))}e.$$K=W;function N(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?b.URI.file(Ae):Ae}e.$_K=N;var H;(function(Ae){function we(be){return typeof be>"u"?be:{contentText:be.contentText,contentIconPath:be.contentIconPath?N(be.contentIconPath):void 0,border:be.border,borderColor:be.borderColor,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,color:be.color,backgroundColor:be.backgroundColor,margin:be.margin,width:be.width,height:be.height}}Ae.from=we})(H||(e.ThemableDecorationAttachmentRenderOptions=H={}));var j;(function(Ae){function we(be){return typeof be>"u"?be:{backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?N(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?H.from(be.before):void 0,after:be.after?H.from(be.after):void 0}}Ae.from=we})(j||(e.ThemableDecorationRenderOptions=j={}));var O;(function(Ae){function we(be){if(typeof be>"u")return be;switch(be){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=we})(O||(e.DecorationRangeBehavior=O={}));var ue;(function(Ae){function we(be){return{isWholeLine:be.isWholeLine,rangeBehavior:be.rangeBehavior?O.from(be.rangeBehavior):void 0,overviewRulerLane:be.overviewRulerLane,light:be.light?j.from(be.light):void 0,dark:be.dark?j.from(be.dark):void 0,backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?N(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?H.from(be.before):void 0,after:be.after?H.from(be.after):void 0}}Ae.from=we})(ue||(e.DecorationRenderOptions=ue={}));var pe;(function(Ae){function we(Z){return{text:Z.newText,eol:Z.newEol&&it.from(Z.newEol),range:s.from(Z.range)}}Ae.from=we;function be(Z){const Le=new l.$hJ(s.to(Z.range),Z.text);return Le.newEol=typeof Z.eol>"u"?void 0:it.to(Z.eol),Le}Ae.to=be})(pe||(e.TextEdit=pe={}));var Pe;(function(Ae){function we(Z,Le){const Ue={edits:[]};if(Z instanceof l.$kJ){const Ge=new f.$ki;for(const Ke of Z._allEntries())Ke._type===1&&b.URI.isUri(Ke.to)&&Ke.from===void 0&&Ge.add(Ke.to);for(const Ke of Z._allEntries())if(Ke._type===1){let xe;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?xe={type:"base64",value:(0,C.$2b)(C.$Ib.wrap(Ke.options.contents))}:xe={type:"dataTransferItem",id:Ke.options.contents._itemId}),Ue.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:xe},metadata:Ke.metadata})}else Ke._type===2?Ue.edits.push({resource:Ke.uri,textEdit:pe.from(Ke.edit),versionId:Ge.has(Ke.uri)?void 0:Le?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Ue.edits.push({resource:Ke.uri,textEdit:{range:s.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ge.has(Ke.uri)?void 0:Le?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Ue.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Ue.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Le?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(tt.from)}})}return Ue}Ae.from=we;function be(Z){const Le=new l.$kJ,Ue=new f.$ji;for(const Ge of Z.edits)if(Ge.textEdit){const Ke=Ge,xe=b.URI.revive(Ke.resource),Et=s.to(Ke.textEdit.range),It=Ke.textEdit.text,Pt=Ke.textEdit.insertAsSnippet;let mt;Pt?mt=l.$jJ.replace(Et,new l.$lJ(It)):mt=l.$hJ.replace(Et,It);const pt=Ue.get(xe);pt?pt.push(mt):Ue.set(xe,[mt])}else Le.renameFile(b.URI.revive(Ge.oldResource),b.URI.revive(Ge.newResource),Ge.options);for(const[Ge,Ke]of Ue)Le.set(Ge,Ke);return Le}Ae.to=be})(Pe||(e.WorkspaceEdit=Pe={}));var _;(function(Ae){const we=Object.create(null);we[l.SymbolKind.File]=0,we[l.SymbolKind.Module]=1,we[l.SymbolKind.Namespace]=2,we[l.SymbolKind.Package]=3,we[l.SymbolKind.Class]=4,we[l.SymbolKind.Method]=5,we[l.SymbolKind.Property]=6,we[l.SymbolKind.Field]=7,we[l.SymbolKind.Constructor]=8,we[l.SymbolKind.Enum]=9,we[l.SymbolKind.Interface]=10,we[l.SymbolKind.Function]=11,we[l.SymbolKind.Variable]=12,we[l.SymbolKind.Constant]=13,we[l.SymbolKind.String]=14,we[l.SymbolKind.Number]=15,we[l.SymbolKind.Boolean]=16,we[l.SymbolKind.Array]=17,we[l.SymbolKind.Object]=18,we[l.SymbolKind.Key]=19,we[l.SymbolKind.Null]=20,we[l.SymbolKind.EnumMember]=21,we[l.SymbolKind.Struct]=22,we[l.SymbolKind.Event]=23,we[l.SymbolKind.Operator]=24,we[l.SymbolKind.TypeParameter]=25;function be(Le){return typeof we[Le]=="number"?we[Le]:6}Ae.from=be;function Z(Le){for(const Ue in we)if(we[Ue]===Le)return Number(Ue);return l.SymbolKind.Property}Ae.to=Z})(_||(e.SymbolKind=_={}));var Y;(function(Ae){function we(Z){switch(Z){case l.SymbolTag.Deprecated:return 1}}Ae.from=we;function be(Z){switch(Z){case 1:return l.SymbolTag.Deprecated}}Ae.to=be})(Y||(e.SymbolTag=Y={}));var ce;(function(Ae){function we(Z){return{name:Z.name,kind:_.from(Z.kind),tags:Z.tags&&Z.tags.map(Y.from),containerName:Z.containerName,location:Q.from(Z.location)}}Ae.from=we;function be(Z){const Le=new l.$rJ(Z.name,_.to(Z.kind),Z.containerName,Q.to(Z.location));return Le.tags=Z.tags&&Z.tags.map(Y.to),Le}Ae.to=be})(ce||(e.WorkspaceSymbol=ce={}));var ke;(function(Ae){function we(Z){const Le={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:s.from(Z.range),selectionRange:s.from(Z.selectionRange),kind:_.from(Z.kind),tags:Z.tags?.map(Y.from)??[]};return Z.children&&(Le.children=Z.children.map(we)),Le}Ae.from=we;function be(Z){const Le=new l.$sJ(Z.name,Z.detail,_.to(Z.kind),s.to(Z.range),s.to(Z.selectionRange));return(0,g.$nf)(Z.tags)&&(Le.tags=Z.tags.map(Y.to)),Z.children&&(Le.children=Z.children.map(be)),Le}Ae.to=be})(ke||(e.DocumentSymbol=ke={}));var Ce;(function(Ae){function we(Z){const Le=new l.$xJ(_.to(Z.kind),Z.name,Z.detail||"",b.URI.revive(Z.uri),s.to(Z.range),s.to(Z.selectionRange));return Le._sessionId=Z._sessionId,Le._itemId=Z._itemId,Le}Ae.to=we;function be(Z,Le,Ue){if(Le=Le??Z._sessionId,Ue=Ue??Z._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,name:Z.name,detail:Z.detail,kind:_.from(Z.kind),uri:Z.uri,range:s.from(Z.range),selectionRange:s.from(Z.selectionRange),tags:Z.tags?.map(Y.from)}}Ae.from=be})(Ce||(e.CallHierarchyItem=Ce={}));var me;(function(Ae){function we(be){return new l.$yJ(Ce.to(be.from),be.fromRanges.map(Z=>s.to(Z)))}Ae.to=we})(me||(e.CallHierarchyIncomingCall=me={}));var R;(function(Ae){function we(be){return new l.$zJ(Ce.to(be.to),be.fromRanges.map(Z=>s.to(Z)))}Ae.to=we})(R||(e.CallHierarchyOutgoingCall=R={}));var Q;(function(Ae){function we(Z){return{range:Z.range&&s.from(Z.range),uri:Z.uri}}Ae.from=we;function be(Z){return new l.$mJ(b.URI.revive(Z.uri),s.to(Z.range))}Ae.to=be})(Q||(e.location=Q={}));var he;(function(Ae){function we(Z){const Le=Z,Ue=Z;return{originSelectionRange:Le.originSelectionRange?s.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ue.uri,range:s.from(Le.targetRange?Le.targetRange:Ue.range),targetSelectionRange:Le.targetSelectionRange?s.from(Le.targetSelectionRange):void 0}}Ae.from=we;function be(Z){return{targetUri:b.URI.revive(Z.uri),targetRange:s.to(Z.range),targetSelectionRange:Z.targetSelectionRange?s.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?s.to(Z.originSelectionRange):void 0}}Ae.to=be})(he||(e.DefinitionLink=he={}));var De;(function(Ae){function we(Z){return{range:s.from(Z.range),contents:q.fromMany(Z.contents)}}Ae.from=we;function be(Z){return new l.$pJ(Z.contents.map(q.to),s.to(Z.range))}Ae.to=be})(De||(e.Hover=De={}));var ye;(function(Ae){function we(Z){return{range:s.from(Z.range),expression:Z.expression}}Ae.from=we;function be(Z){return new l.$jK(s.to(Z.range),Z.expression)}Ae.to=be})(ye||(e.EvaluatableExpression=ye={}));var $e;(function(Ae){function we(Z){if(Z instanceof l.$kK)return{type:"text",range:s.from(Z.range),text:Z.text};if(Z instanceof l.$lK)return{type:"variable",range:s.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof l.$mK)return{type:"expression",range:s.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=we;function be(Z){switch(Z.type){case"text":return{range:s.to(Z.range),text:Z.text};case"variable":return{range:s.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:s.to(Z.range),expression:Z.expression}}}Ae.to=be})($e||(e.InlineValue=$e={}));var Se;(function(Ae){function we(Z){return{frameId:Z.frameId,stoppedLocation:s.from(Z.stoppedLocation)}}Ae.from=we;function be(Z){return new l.$nK(Z.frameId,s.to(Z.stoppedLocation))}Ae.to=be})(Se||(e.InlineValueContext=Se={}));var ae;(function(Ae){function we(Z){return{range:s.from(Z.range),kind:Z.kind}}Ae.from=we;function be(Z){return new l.$qJ(s.to(Z.range),Z.kind)}Ae.to=be})(ae||(e.DocumentHighlight=ae={}));var le;(function(Ae){function we(be){switch(be){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Ae.to=we})(le||(e.CompletionTriggerKind=le={}));var ne;(function(Ae){function we(be){return{triggerKind:le.to(be.triggerKind),triggerCharacter:be.triggerCharacter}}Ae.to=we})(ne||(e.CompletionContext=ne={}));var ee;(function(Ae){function we(Z){switch(Z){case l.CompletionItemTag.Deprecated:return 1}}Ae.from=we;function be(Z){switch(Z){case 1:return l.CompletionItemTag.Deprecated}}Ae.to=be})(ee||(e.CompletionItemTag=ee={}));var P;(function(Ae){const we=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function be(Ue){return we.get(Ue)??9}Ae.from=be;const Z=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Le(Ue){return Z.get(Ue)??l.CompletionItemKind.Property}Ae.to=Le})(P||(e.CompletionItemKind=P={}));var K;(function(Ae){function we(be,Z){const Le=new l.$HJ(be.label);return Le.insertText=be.insertText,Le.kind=P.to(be.kind),Le.tags=be.tags?.map(ee.to),Le.detail=be.detail,Le.documentation=T.$Ij(be.documentation)?q.to(be.documentation):be.documentation,Le.sortText=be.sortText,Le.filterText=be.filterText,Le.preselect=be.preselect,Le.commitCharacters=be.commitCharacters,$.$Kr.isIRange(be.range)?Le.range=s.to(be.range):typeof be.range=="object"&&(Le.range={inserting:s.to(be.range.insert),replacing:s.to(be.range.replace)}),Le.keepWhitespace=typeof be.insertTextRules>"u"?!1:!!(be.insertTextRules&1),typeof be.insertTextRules<"u"&&be.insertTextRules&4?Le.insertText=new l.$lJ(be.insertText):(Le.insertText=be.insertText,Le.textEdit=Le.range instanceof l.$cJ?new l.$hJ(Le.range,Le.insertText):void 0),be.additionalTextEdits&&be.additionalTextEdits.length>0&&(Le.additionalTextEdits=be.additionalTextEdits.map(Ue=>pe.to(Ue))),Le.command=Z&&be.command?Z.fromInternal(be.command):void 0,Le}Ae.to=we})(K||(e.CompletionItem=K={}));var V;(function(Ae){function we(Z){if(typeof Z.label!="string"&&!Array.isArray(Z.label))throw new TypeError("Invalid label");return{label:Z.label,documentation:q.fromStrict(Z.documentation)}}Ae.from=we;function be(Z){return{label:Z.label,documentation:T.$Ij(Z.documentation)?q.to(Z.documentation):Z.documentation}}Ae.to=be})(V||(e.ParameterInformation=V={}));var J;(function(Ae){function we(Z){return{label:Z.label,documentation:q.fromStrict(Z.documentation),parameters:Array.isArray(Z.parameters)?Z.parameters.map(V.from):[],activeParameter:Z.activeParameter}}Ae.from=we;function be(Z){return{label:Z.label,documentation:T.$Ij(Z.documentation)?q.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(V.to):[],activeParameter:Z.activeParameter}}Ae.to=be})(J||(e.SignatureInformation=J={}));var re;(function(Ae){function we(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(J.from):[]}}Ae.from=we;function be(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(J.to):[]}}Ae.to=be})(re||(e.SignatureHelp=re={}));var de;(function(Ae){function we(be,Z){const Le=new l.$GJ(I.to(Z.position),typeof Z.label=="string"?Z.label:Z.label.map(ie.to.bind(void 0,be)),Z.kind&&ve.to(Z.kind));return Le.textEdits=Z.textEdits&&Z.textEdits.map(pe.to),Le.tooltip=T.$Ij(Z.tooltip)?q.to(Z.tooltip):Z.tooltip,Le.paddingLeft=Z.paddingLeft,Le.paddingRight=Z.paddingRight,Le}Ae.to=we})(de||(e.InlayHint=de={}));var ie;(function(Ae){function we(be,Z){const Le=new l.$FJ(Z.label);return Le.tooltip=T.$Ij(Z.tooltip)?q.to(Z.tooltip):Z.tooltip,u.Command.is(Z.command)&&(Le.command=be.fromInternal(Z.command)),Z.location&&(Le.location=Q.to(Z.location)),Le}Ae.to=we})(ie||(e.InlayHintLabelPart=ie={}));var ve;(function(Ae){function we(Z){return Z}Ae.from=we;function be(Z){return Z}Ae.to=be})(ve||(e.InlayHintKind=ve={}));var Ee;(function(Ae){function we(Z){return{range:s.from(Z.range),url:Z.target,tooltip:Z.tooltip}}Ae.from=we;function be(Z){let Le;if(Z.url)try{Le=typeof Z.url=="string"?b.URI.parse(Z.url,!0):b.URI.revive(Z.url)}catch{}return new l.$MJ(s.to(Z.range),Le)}Ae.to=be})(Ee||(e.DocumentLink=Ee={}));var Be;(function(Ae){function we(Z){const Le=new l.$PJ(Z.label);return Z.textEdit&&(Le.textEdit=pe.to(Z.textEdit)),Z.additionalTextEdits&&(Le.additionalTextEdits=Z.additionalTextEdits.map(Ue=>pe.to(Ue))),Le}Ae.to=we;function be(Z){return{label:Z.label,textEdit:Z.textEdit?pe.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Le=>pe.from(Le)):void 0}}Ae.from=be})(Be||(e.ColorPresentation=Be={}));var We;(function(Ae){function we(Z){return new l.$NJ(Z[0],Z[1],Z[2],Z[3])}Ae.to=we;function be(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}Ae.from=be})(We||(e.Color=We={}));var _e;(function(Ae){function we(Z){return{range:s.from(Z.range)}}Ae.from=we;function be(Z){return new l.$wJ(s.to(Z.range))}Ae.to=be})(_e||(e.SelectionRange=_e={}));var He;(function(Ae){function we(be){switch(be){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Ae.to=we})(He||(e.TextDocumentSaveReason=He={}));var Qe;(function(Ae){function we(Z){switch(Z){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=we;function be(Z){switch(Z){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Ae.to=be})(Qe||(e.TextEditorLineNumbersStyle=Qe={}));var it;(function(Ae){function we(Z){if(Z===l.EndOfLine.CRLF)return 1;if(Z===l.EndOfLine.LF)return 0}Ae.from=we;function be(Z){if(Z===1)return l.EndOfLine.CRLF;if(Z===0)return l.EndOfLine.LF}Ae.to=be})(it||(e.EndOfLine=it={}));var ct;(function(Ae){function we(be){if(typeof be=="object")return be.viewId;switch(be){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=we})(ct||(e.ProgressLocation=ct={}));var et;(function(Ae){function we(Z){const Le={start:Z.start+1,end:Z.end+1};return Z.kind&&(Le.kind=rt.from(Z.kind)),Le}Ae.from=we;function be(Z){const Le={start:Z.start-1,end:Z.end-1};return Z.kind&&(Le.kind=rt.to(Z.kind)),Le}Ae.to=be})(et||(e.FoldingRange=et={}));var rt;(function(Ae){function we(Z){if(Z)switch(Z){case l.FoldingRangeKind.Comment:return u.$ns.Comment;case l.FoldingRangeKind.Imports:return u.$ns.Imports;case l.FoldingRangeKind.Region:return u.$ns.Region}}Ae.from=we;function be(Z){if(Z)switch(Z.value){case u.$ns.Comment.value:return l.FoldingRangeKind.Comment;case u.$ns.Imports.value:return l.FoldingRangeKind.Imports;case u.$ns.Region.value:return l.FoldingRangeKind.Region}}Ae.to=be})(rt||(e.FoldingRangeKind=rt={}));var Oe;(function(Ae){function we(be){if(be)return{pinned:typeof be.preview=="boolean"?!be.preview:void 0,inactive:be.background,preserveFocus:be.preserveFocus,selection:typeof be.selection=="object"?s.from(be.selection):void 0,override:typeof be.override=="boolean"?c.$4D.id:void 0}}Ae.from=we})(Oe||(e.TextEditorOpenOptions=Oe={}));var st;(function(Ae){function we(Ue){return Ue instanceof l.$0J?Ue.toJSON():typeof Ue=="string"?Ue:be(Ue)||Z(Ue)?new l.$0J(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Ae.from=we;function be(Ue){const Ge=Ue;return Ge?b.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function Z(Ue){const Ge=Ue;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Le(Ue){return typeof Ue=="string"?Ue:new l.$0J(b.URI.revive(Ue.baseUri),Ue.pattern)}Ae.to=Le})(st||(e.GlobPattern=st={}));var x;(function(Ae){function we(be){if(be){if(Array.isArray(be))return be.map(we);if(typeof be=="string")return be;{const Z=be;return{language:Z.language,scheme:Z.scheme,pattern:st.from(Z.pattern),exclusive:Z.exclusive,notebookType:Z.notebookType}}}else return}Ae.from=we})(x||(e.LanguageSelector=x={}));var X;(function(Ae){function we(Z){return{start:Z.start,end:Z.end}}Ae.from=we;function be(Z){return new l.$yK(Z.start,Z.end)}Ae.to=be})(X||(e.NotebookRange=X={}));var ge;(function(Ae){function we(Z){return{timing:typeof Z.runStartTime=="number"&&typeof Z.runEndTime=="number"?{startTime:Z.runStartTime,endTime:Z.runEndTime}:void 0,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}Ae.to=we;function be(Z){return{lastRunSuccess:Z.success,runStartTime:Z.timing?.startTime,runEndTime:Z.timing?.endTime,executionOrder:Z.executionOrder}}Ae.from=be})(ge||(e.NotebookCellExecutionSummary=ge={}));var je;(function(Ae){function we(be){if(be===w.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(be===w.NotebookCellExecutionState.Pending)return;if(be===w.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${be}`)}Ae.to=we})(je||(e.NotebookCellExecutionState=je={}));var Ne;(function(Ae){function we(Z){switch(Z){case l.NotebookCellKind.Markup:return w.CellKind.Markup;case l.NotebookCellKind.Code:default:return w.CellKind.Code}}Ae.from=we;function be(Z){switch(Z){case w.CellKind.Markup:return l.NotebookCellKind.Markup;case w.CellKind.Code:default:return l.NotebookCellKind.Code}}Ae.to=be})(Ne||(e.NotebookCellKind=Ne={}));var Ze;(function(Ae){function we(Z){const Le={metadata:Z.metadata??Object.create(null),cells:[]};for(const Ue of Z.cells)l.$zK.validate(Ue),Le.cells.push(tt.from(Ue));return Le}Ae.from=we;function be(Z){const Le=new l.$AK(Z.cells.map(tt.to));return(0,h.$te)(Z.metadata)||(Le.metadata=Z.metadata),Le}Ae.to=be})(Ze||(e.NotebookData=Ze={}));var tt;(function(Ae){function we(Z){return{cellKind:Ne.from(Z.kind),language:Z.languageId,mime:Z.mime,source:Z.value,metadata:Z.metadata,internalMetadata:ge.from(Z.executionSummary??{}),outputs:Z.outputs?Z.outputs.map(wt.from):[]}}Ae.from=we;function be(Z){return new l.$zK(Ne.to(Z.cellKind),Z.source,Z.language,Z.mime,Z.outputs?Z.outputs.map(wt.to):void 0,Z.metadata,Z.internalMetadata?ge.to(Z.internalMetadata):void 0)}Ae.to=be})(tt||(e.NotebookCellData=tt={}));var $t;(function(Ae){function we(Z){return{mime:Z.mime,valueBytes:C.$Ib.wrap(Z.data)}}Ae.from=we;function be(Z){return new l.$BK(Z.valueBytes.buffer,Z.mime)}Ae.to=be})($t||(e.NotebookCellOutputItem=$t={}));var wt;(function(Ae){function we(Z){return{outputId:Z.id,items:Z.items.map($t.from),metadata:Z.metadata}}Ae.from=we;function be(Z){const Le=Z.items.map($t.to);return new l.$CK(Le,Z.outputId,Z.metadata)}Ae.to=be})(wt||(e.NotebookCellOutput=wt={}));var Lt;(function(Ae){function we(Le){return Z(Le)?{include:(0,h.$ye)(st.from(Le.include)),exclude:(0,h.$ye)(st.from(Le.exclude))}:(0,h.$ye)(st.from(Le))}Ae.from=we;function be(Le){return Z(Le)?{include:st.to(Le.include),exclude:st.to(Le.exclude)}:st.to(Le)}Ae.to=be;function Z(Le){const Ue=Le;return Ue?!(0,h.$pe)(Ue.include)&&!(0,h.$pe)(Ue.exclude):!1}})(Lt||(e.NotebookExclusiveDocumentPattern=Lt={}));var Gt;(function(Ae){function we(be,Z,Le){const Ue=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{alignment:be.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(Ue,Le),text:be.text,tooltip:be.tooltip,accessibilityInformation:be.accessibilityInformation,priority:be.priority}}Ae.from=we})(Gt||(e.NotebookStatusBarItem=Gt={}));var Wt;(function(Ae){function we(be,Z,Le){const Ue=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{command:Z.toInternal(Ue,Le),label:be.label,description:be.description,detail:be.detail,documentation:be.documentation}}Ae.from=we})(Wt||(e.NotebookKernelSourceAction=Wt={}));var yt;(function(Ae){function we(be){return{transientOutputs:be?.transientOutputs??!1,transientCellMetadata:be?.transientCellMetadata??{},transientDocumentMetadata:be?.transientDocumentMetadata??{},cellContentMetadata:be?.cellContentMetadata??{}}}Ae.from=we})(yt||(e.NotebookDocumentContentOptions=yt={}));var Ut;(function(Ae){function we(Z){return{uri:Z.uri,provides:Z.provides}}Ae.from=we;function be(Z){return new l.$EK(b.URI.revive(Z.uri),Z.provides)}Ae.to=be})(Ut||(e.NotebookRendererScript=Ut={}));var Mt;(function(Ae){function we(Z){return{message:q.fromStrict(Z.message)||"",type:0,expected:Z.expectedOutput,actual:Z.actualOutput,location:Z.location&&{range:s.from(Z.location.range),uri:Z.location.uri}}}Ae.from=we;function be(Z){const Le=new l.$LK(typeof Z.message=="string"?Z.message:q.to(Z.message));return Le.actualOutput=Z.actual,Le.expectedOutput=Z.expected,Le.location=Z.location?Q.to(Z.location):void 0,Le}Ae.to=be})(Mt||(e.TestMessage=Mt={}));var Nt;(function(Ae){Ae.namespace=y.$1H,Ae.denamespace=y.$2H})(Nt||(e.TestTag=Nt={}));var Kt;(function(Ae){function we(Z){const Le=(0,r.$9K)(Z).controllerId;return{extId:v.$WH.fromExtHostTestItem(Z,Le).toString(),label:Z.label,uri:b.URI.revive(Z.uri),busy:Z.busy,tags:Z.tags.map(Ue=>Nt.namespace(Le,Ue.id)),range:$.$Kr.lift(s.from(Z.range)),description:Z.description||null,sortText:Z.sortText||null,error:Z.error&&q.fromStrict(Z.error)||null}}Ae.from=we;function be(Z){return{parent:void 0,error:void 0,id:v.$WH.fromString(Z.extId).localId,label:Z.label,uri:b.URI.revive(Z.uri),tags:(Z.tags||[]).map(Le=>{const{tagId:Ue}=Nt.denamespace(Le);return new l.$MK(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:s.to(Z.range||void 0),canResolveChildren:!1,busy:Z.busy,description:Z.description||void 0,sortText:Z.sortText||void 0}}Ae.toPlain=be})(Kt||(e.TestItem=Kt={})),function(Ae){function we(Z){return{id:Z.id}}Ae.from=we;function be(Z){return new l.$MK(Z.id)}Ae.to=be}(Nt||(e.TestTag=Nt={}));var Vt;(function(Ae){const we=(Z,Le)=>{const Ue=[];for(const[Ke,xe]of Le)v.$WH.compare(xe.item.extId,Ke)===2&&(Le.delete(Ke),Ue.push(xe));const Ge={...Kt.toPlain(Z.item),parent:void 0,taskStates:Z.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(xe=>xe.type===0).map(Mt.to)})),children:Ue.map(Ke=>we(Ke,Le))};for(const Ke of Ge.children)Ke.parent=Ge;return Ge};function be(Z){const Le=[],Ue=new Map;for(const Ge of Z.items){Ue.set(Ge.item.extId,Ge);const Ke=v.$WH.root(Ge.item.extId);Z.request.targets.some(xe=>xe.controllerId===Ke&&xe.testIds.includes(Ge.item.extId))&&Le.push(Ge)}return{completedAt:Z.completedAt,results:Le.map(Ge=>we(Ge,Ue))}}Ae.to=be})(Vt||(e.TestResults=Vt={}));var at;(function(Ae){function we(Ue){return{covered:Ue.covered,total:Ue.covered}}function be(Ue){return"line"in Ue?I.from(Ue):s.from(Ue)}function Z(Ue){return"branches"in Ue?{count:Ue.executionCount,location:be(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&be(Ge.location)})):void 0}:{type:0,count:Ue.executionCount,location:be(Ue.location)}}Ae.fromDetailed=Z;function Le(Ue){return{uri:Ue.uri,statement:we(Ue.statementCoverage),branch:Ue.branchCoverage&&we(Ue.branchCoverage),function:Ue.functionCoverage&&we(Ue.functionCoverage),details:Ue.detailedCoverage?.map(Z)}}Ae.fromFile=Le})(at||(e.TestCoverage=at={}));var ft;(function(Ae){function we(be){switch(be){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Ae.to=we})(ft||(e.CodeActionTriggerKind=ft={}));var jt;(function(Ae){function we(Z){const Le=new l.$SK(_.to(Z.kind),Z.name,Z.detail||"",b.URI.revive(Z.uri),s.to(Z.range),s.to(Z.selectionRange));return Le._sessionId=Z._sessionId,Le._itemId=Z._itemId,Le}Ae.to=we;function be(Z,Le,Ue){if(Le=Le??Z._sessionId,Ue=Ue??Z._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,kind:_.from(Z.kind),name:Z.name,detail:Z.detail??"",uri:Z.uri,range:s.from(Z.range),selectionRange:s.from(Z.selectionRange),tags:Z.tags?.map(Y.from)}}Ae.from=be})(jt||(e.TypeHierarchyItem=jt={}));var Rt;(function(Ae){function we(be){if(be)return{value:be.value,tooltip:be.tooltip}}Ae.from=we})(Rt||(e.ViewBadge=Rt={}));var St;(function(Ae){function we(Ue,Ge,Ke){const xe=Ge.fileData;return xe?new l.$3J(new l.$4J(xe.name,b.URI.revive(xe.uri),xe.id,(0,z.$bb)(()=>Ke(xe.id)))):Ue===F.$qr.uriList&&Ge.uriListData?new l.$2J(Le(Ge.uriListData)):new l.$2J(Ge.asString)}Ae.to=we;async function be(Ue,Ge){const Ke=await Ge.asString();if(Ue===F.$qr.uriList)return{asString:Ke,fileData:void 0,uriListData:Z(Ke)};const xe=Ge.asFile();return{asString:Ke,fileData:xe?{name:xe.name,uri:xe.uri,id:xe._itemId??xe.id}:void 0}}Ae.from=be;function Z(Ue){return S.$$r.split(Ue).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return b.URI.parse(Ge)}catch{}return Ge})}function Le(Ue){return S.$$r.create(Ue.map(Ge=>typeof Ge=="string"?Ge:b.URI.revive(Ge)))}})(St||(e.DataTransferItem=St={}));var ut;(function(Ae){function we(Z,Le){const Ue=Z.items.map(([Ge,Ke])=>[Ge,St.to(Ge,Ke,Le)]);return new l.$5J(Ue)}Ae.toDataTransfer=we;async function be(Z){const Le={items:[]},Ue=[];for(const[Ge,Ke]of Z)Ue.push((async()=>{Le.items.push([Ge,await St.from(Ge,Ke)])})());return await Promise.all(Ue),Le}Ae.from=be})(ut||(e.DataTransfer=ut={}));var Ct;(function(Ae){function we(Z){return{message:Z.message,metadata:Z.metadata,title:Z.title,tooltip:Z.tooltip}}Ae.to=we;function be(Z){return{kind:"reply",message:Z.message,metadata:Z.metadata,title:Z.title,tooltip:Z.tooltip}}Ae.from=be})(Ct||(e.ChatReplyFollowup=Ct={}));var Tt;(function(Ae){function we(be){return typeof be=="string"?{title:be,message:be,kind:"reply"}:"commandId"in be?{kind:"command",title:be.title??"",commandId:be.commandId??"",args:be.args}:Ct.from(be)}Ae.from=we})(Tt||(e.ChatFollowup=Tt={}))}),define(Re[202],Fe([1,0,2,9,7,8,171]),function(te,e,g,C,S,z,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$00b=void 0;class f{constructor(m,F,D,h={timeout:1500,errors:3}){this.c=m,this.d=F,this.f=D,this.g=h,this.a=new T.$jc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(m){return(F,D,h)=>{const $={dispose:this.a.push([F,D,m])};return Array.isArray(h)&&h.push($),$}}async $participateInSave(m,F){const D=g.URI.revive(m);let h=!1;const b=setTimeout(()=>h=!0,this.g.timeout),$=[];try{for(const u of[...this.a]){if(h)break;const t=this.d.getDocument(D),r=await this.h(u,{document:t,reason:z.TextDocumentSaveReason.to(F)});$.push(r)}}finally{clearTimeout(b)}return $}h([m,F,D],h){const b=this.b.get(m);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(D,m,F,h).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const u=this.b.get(m);this.b.set(m,u?u+1:1),typeof u=="number"&&u>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(m,F,D,h){const b=[],$=Date.now(),{document:u,reason:t}=h,{version:r}=u,c=Object.freeze({document:u,reason:t,waitUntil(w){if(Object.isFrozen(b))throw(0,C.$5)("waitUntil can not be called async");b.push(Promise.resolve(w))}});try{F.apply(D,[c])}catch(w){return Promise.reject(w)}return Object.freeze(b),new Promise((w,v)=>{const y=setTimeout(()=>v(new Error("timeout")),this.g.timeout);return Promise.all(b).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(y),w(i)}).catch(i=>{clearTimeout(y),v(i)})}).then(w=>{const v={edits:[]};for(const y of w)if(Array.isArray(y)&&y.every(i=>i instanceof S.$hJ))for(const{newText:i,newEol:l,range:n}of y)v.edits.push({resource:u.uri,versionId:void 0,textEdit:{range:n&&z.Range.from(n),text:i,eol:l&&z.EndOfLine.from(l)}});if(v.edits.length!==0)return r===u.version?this.f.$tryApplyWorkspaceEdit(v):Promise.reject(new Error("concurrent_edits"))})}}e.$00b=f}),define(Re[203],Fe([1,0,14,2,8,7,76]),function(te,e,g,C,S,z,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_b=e.$k_b=void 0;class f{constructor(D,h,b,$){this.start=D,this.deletedCount=h,this.deletedItems=b,this.items=$}asApiEvent(){return{range:new z.$yK(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class k{static asModelAddData(D,h){return{EOL:h.eol,lines:h.source,languageId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,h,b){this.notebook=D,this.h=h,this.j=b,this.handle=b.handle,this.uri=C.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(S.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(S.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,h=this.h.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:S.NotebookCellKind.to(this.j.cellKind),document:h.document,get mime(){return D.g},set mime($){D.g=$},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(b)}return this.f}setOutputs(D){this.a=D.map(S.NotebookCellOutput.to)}setOutputItems(D,h,b){const $=b.map(S.NotebookCellOutputItem.to),u=this.a.find(t=>t.id===D);if(u&&(h||(u.items.length=0),u.items.push(...$),u.items.length>1&&u.items.every(t=>T.$gH(t.mime)))){const t=new Map,r=[];u.items.forEach(c=>{let w;t.has(c.mime)?w=t.get(c.mime):(w=[],t.set(c.mime,w),r.push(c.mime)),w.push(c.data)}),u.items.length=0,r.forEach(c=>{const w=T.$hH(t.get(c));u.items.push({mime:c,data:w.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(S.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$k_b=k;class m{constructor(D,h,b,$,u){this.k=D,this.l=h,this.m=b,this.uri=$,this.handle=m.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=u.viewType,this.f=Object.freeze(u.metadata??Object.create(null)),this.r([[0,0,u.cells]],!0,void 0),this.g=u.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,h={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===g.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(b){return b=D.n(b),D.b[b].apiCell},getCells(b){return(b?D.p(b):D.b).map(u=>u.apiCell)},save(){return D.q()}};this.e=Object.freeze(h)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,h,b){this.g=D.versionId,this.h=h,this.acceptDocumentPropertiesChanged({metadata:b});const $={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},u=[];for(const r of D.rawEvents)r.kind===T.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,$.contentChanges):r.kind===T.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,$.contentChanges):r.kind===T.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),u.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===T.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),u.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),u.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===T.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===T.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),u.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),u.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const t=new Map;for(let r=0;r<u.length;r++){const c=u[r],w=t.get(c.cell);if(w===void 0){const v=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,v-1)}else $.cellChanges[w]={...$.cellChanges[w],...c}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let h=D.start|0,b=D.end|0;return h<0&&(h=0),b>this.b.length&&(b=this.b.length),D.with({start:h,end:b})}p(D){D=this.o(D);const h=[];for(let b=D.start;b<D.end;b++)h.push(this.b[b]);return h}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,h,b){if(this.j)return;const $=[],u=[],t=[];if(D.reverse().forEach(r=>{const w=r[2].map(i=>{const l=new k(this,this.l,i);return h||u.push(k.asModelAddData(this.apiNotebook,i)),l}),v=new f(r[0],r[1],[],w),y=this.b.splice(r[0],r[1],...w);for(const i of y)t.push(i.uri),v.deletedItems.push(i.apiCell);$.push(v)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:t}),b)for(const r of $)b.push(r.asApiEvent())}s(D,h,b,$){const u=this.b.splice(D,h);this.b.splice(b,0,...u);const t=[new f(D,h,u.map(r=>r.apiCell),[]),new f(b,0,[],u)];for(const r of t)$.push(r.asApiEvent())}t(D,h){this.b[D].setOutputs(h)}u(D,h,b,$){this.b[D].setOutputItems(h,b,$)}v(D,h){const b=this.b[D];b.apiCell.document.languageId!==h&&this.m.$acceptModelLanguageChanged(b.uri,h)}w(D,h){const b=this.b[D];b.apiCell.mime=h}x(D,h){this.b[D].setMetadata(h)}y(D,h){this.b[D].setInternalMetadata(h)}getCellFromApiCell(D){return this.b.find(h=>h.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(h=>h.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$l_b=m,m.a=0}),define(Re[204],Fe([1,0,5,2,8,7]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L_b=void 0;class T{constructor(k,m,F,D={timeout:1500,errors:3}){this.b=k,this.c=m,this.d=F,this.f=D,this.a=new g.$7c}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(m,F,D)=>{const h=function($){m.call(F,$)};return h.extension=k,this.a.event(h,void 0,D)}}async $participateInSave(k,m,F){const D=C.URI.revive(k),h=this.c.getNotebookDocument(D);if(!h)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:h.apiNotebook,reason:S.TextDocumentSaveReason.to(m)},F,async(u,t)=>{const r=Date.now(),c=await await Promise.resolve(u);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!F.isCancellationRequested&&c&&(c instanceof z.$kJ?b.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),F.isCancellationRequested)return!1;if(b.length===0)return!0;const $={edits:[]};for(const u of b){const{edits:t}=S.WorkspaceEdit.from(u);$.edits=$.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit($)}}e.$L_b=T}),define(Re[103],Fe([1,0,9,8,7]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m_b=void 0;class z{constructor(f,k,m,F,D,h){this.id=f,this.f=k,this.notebookData=m,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=F,this.c=h}get apiEditor(){if(!this.e){const f=this;this.e={get notebook(){return f.notebookData.apiNotebook},get selection(){return f.a[0]},set selection(k){this.selections=[k]},get selections(){return f.a},set selections(k){if(!Array.isArray(k)||!k.every(S.$yK.isNotebookRange))throw(0,g.$4)("selections");f.a=k,f.g(k)},get visibleRanges(){return f.b},revealRange(k,m){f.f.$tryRevealRange(f.id,C.NotebookRange.from(k),m??S.NotebookEditorRevealType.Default)},get viewColumn(){return f.c}},z.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(f){this.d=f}_acceptVisibleRanges(f){this.b=f}_acceptSelections(f){this.a=f}g(f){this.f.$trySetSelections(this.id,f.map(C.NotebookRange.from))}_acceptViewColumn(f){this.c=f}}e.$m_b=z,z.apiEditorsToExtHost=new WeakMap}),define(Re[205],Fe([1,0,9,5,15,8]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E_b=void 0;let T=e.$E_b=class{constructor(k,m){this.c=k,this.d=m,this.a=new C.$5c({onListenerError:g.$Y}),this.b=new C.$5c({onListenerError:g.$Y}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(k,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,m);const F=this.d.getEditorById(k);m.visibleRanges&&F._acceptVisibleRanges(m.visibleRanges.ranges.map(z.NotebookRange.to)),m.selections&&F._acceptSelections(m.selections.selections.map(z.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:F.apiEditor,visibleRanges:F.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:F.apiEditor,selections:F.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const m in k)this.d.getEditorById(m)._acceptViewColumn(z.ViewColumn.to(k[m]))}};e.$E_b=T=qe([Ve(0,S.$Ni)],T)}),define(Re[206],Fe([1,0,8,175,151,22,65,9]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=void 0;class k{constructor(h){this.b=0,this.c=new Map,this.a=h}async withProgress(h,b,$){const u=this.b++,{title:t,location:r,cancellable:c}=b,w={label:(0,S.localize)(0,null,h.displayName||h.name),id:h.identifier.value};return this.a.$startProgress(u,{location:g.ProgressLocation.from(r),title:t,source:w,cancellable:c},h.isUnderDevelopment?void 0:h.identifier.value).catch(f.$Y),this.d(u,$,!!c)}d(h,b,$){let u;$&&(u=new z.$bd,this.c.set(h,u));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),u?.dispose()};let r;try{r=b(new F(this.a,h),$&&u?u.token:z.CancellationToken.None)}catch(c){throw t(h),c}return r.then(c=>t(h),c=>t(h)),r}$acceptProgressCanceled(h){const b=this.c.get(h);b&&(b.cancel(),this.c.delete(h))}}e.$I$b=k;function m(D,h){return D.message=h.message,typeof h.increment=="number"&&(typeof D.increment=="number"?D.increment+=h.increment:D.increment=h.increment),D}class F extends C.$qz{constructor(h,b){super($=>this.throttledReport($)),this.c=h,this.d=b}throttledReport(h){this.c.$progressReport(this.d,h)}}qe([(0,T.$Rg)(100,(D,h)=>m(D,h),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(Re[104],Fe([1,0,44,101,45,77,56,8,2]),function(te,e,g,C,S,z,T,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pL=e.$oL=e.$nL=e.$mL=void 0;const m=(w,v,y,i)=>{let l=v;return{enumerable:!0,configurable:!1,get(){return l},set(n){if(!y(l,n)){const s=l;l=n,w.listener?.(i(n,s))}}}},F=(w,v)=>w===v,D={range:(w,v)=>w===v?!0:!w||!v?!1:w.isEqual(v),label:F,description:F,sortText:F,busy:F,error:F,canResolveChildren:F,tags:(w,v)=>!(w.length!==v.length||w.some(y=>!v.find(i=>y.id===i.id)))},h=w=>v=>({op:4,update:w(v)}),b=(w,v)=>({range:(()=>{let y;const i=h(l=>({range:g.$Kr.lift(f.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return y},set(l){w.listener?.({op:6}),D.range(y,l)||(y=l,w.listener?.(i(l)))}}})(),label:m(w,v,D.label,h(y=>({label:y}))),description:m(w,void 0,D.description,h(y=>({description:y}))),sortText:m(w,void 0,D.sortText,h(y=>({sortText:y}))),canResolveChildren:m(w,!1,D.canResolveChildren,y=>({op:2,state:y})),busy:m(w,!1,D.busy,h(y=>({busy:y}))),error:m(w,void 0,D.error,h(y=>({error:f.MarkdownString.fromStrict(y)||null}))),tags:m(w,[],D.tags,(y,i)=>({op:1,new:y.map(f.TestTag.from),old:i.map(f.TestTag.from)}))}),$=w=>{const v=S.$WH.fromString(w.extId),y=new t(v.controllerId,v.localId,w.label,k.URI.revive(w.uri)||void 0);return y.range=f.Range.to(w.range||void 0),y.description=w.description||void 0,y.sortText=w.sortText||void 0,y.tags=w.tags.map(i=>f.TestTag.to({id:(0,T.$2H)(i).tagId})),y},u=w=>{let v;for(const y of w.tests){const i=$(y.item);(0,C.$9K)(i).parent=v,v=i}return v};e.$mL=u;class t{constructor(v,y,i,l){if(y.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(y)} symbol`);const n=(0,C.$8K)(this,v);Object.defineProperties(this,{id:{value:y,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof r?void 0:n.parent}},children:{value:(0,z.$7K)(n,C.$9K,t),enumerable:!0,writable:!1},...b(n,i)})}}e.$nL=t;class r extends t{constructor(v,y){super(v,v,y,void 0),this._isRoot=!0}}e.$oL=r;class c extends z.$3K{constructor(v,y,i){super({controllerId:v,getDocumentVersion:l=>l&&i.getDocument(l)?.version,getApiFor:C.$9K,getChildren:l=>l.children,root:new r(v,y),toITestItem:f.TestItem.from})}}e.$pL=c}),define(Re[105],Fe([1,0,49,9,88,8,7]),function(te,e,g,C,S,z,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jL=e.$iL=e.$hL=void 0;class f{constructor(h,b,$){const u=f.c.nextId();h.$registerTextEditorDecorationType(b.identifier,u,z.DecorationRenderOptions.from($)),this.value=Object.freeze({key:u,dispose(){h.$removeTextEditorDecorationType(u)}})}}e.$hL=f,f.c=new S.$fL("TextEditorDecorationType");class k{constructor(h,b){this.g=[],this.h=void 0,this.j=!1,this.c=h,this.d=h.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(h,b){this.k();let $=null;if(h instanceof T.$bJ)$=new T.$cJ(h,h);else if(h instanceof T.$cJ)$=h;else throw new Error("Unrecognized location");this.l($,b,!1)}insert(h,b){this.k(),this.l(new T.$cJ(h,h),b,!0)}delete(h){this.k();let b=null;if(h instanceof T.$cJ)b=h;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(h,b,$){const u=this.c.validateRange(h);this.g.push({range:u,text:b,forceMoveMarkers:$})}setEndOfLine(h){if(this.k(),h!==T.EndOfLine.LF&&h!==T.EndOfLine.CRLF)throw(0,C.$4)("endOfLine");this.h=h}}class m{constructor(h,b,$,u){this.c=h,this.d=b,this._accept($),this.e=u;const t=this;this.value={get tabSize(){return t.f},set tabSize(r){t.m(r)},get indentSize(){return t.g},set indentSize(r){t.o(r)},get insertSpaces(){return t.h},set insertSpaces(r){t.q(r)},get cursorStyle(){return t.j},set cursorStyle(r){t.s(r)},get lineNumbers(){return t.k},set lineNumbers(r){t.t(r)}}}_accept(h){this.f=h.tabSize,this.g=h.indentSize,this.h=h.insertSpaces,this.j=h.cursorStyle,this.k=z.TextEditorLineNumbersStyle.to(h.lineNumbers)}l(h){if(h==="auto")return"auto";if(typeof h=="number"){const b=Math.floor(h);return b>0?b:null}if(typeof h=="string"){const b=parseInt(h,10);return isNaN(b)?null:b>0?b:null}return null}m(h){const b=this.l(h);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const b=Math.floor(h);return b>0?b:null}if(typeof h=="string"){const b=parseInt(h,10);return isNaN(b)?null:b>0?b:null}return null}o(h){const b=this.n(h);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(h){return h==="auto"?"auto":h==="false"?!1:!!h}q(h){const b=this.p(h);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(h){this.j!==h&&(this.j=h,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:h})))}t(h){this.k!==h&&(this.k=h,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:z.TextEditorLineNumbersStyle.from(h)})))}assign(h){const b={};let $=!1;if(typeof h.tabSize<"u"){const u=this.l(h.tabSize);u==="auto"?($=!0,b.tabSize=u):typeof u=="number"&&this.f!==u&&(this.f=u,$=!0,b.tabSize=u)}if(typeof h.indentSize<"u"){const u=this.n(h.indentSize);u==="tabSize"?($=!0,b.indentSize=u):typeof u=="number"&&this.g!==u&&(this.g=u,$=!0,b.indentSize=u)}if(typeof h.insertSpaces<"u"){const u=this.p(h.insertSpaces);u==="auto"?($=!0,b.insertSpaces=u):this.h!==u&&(this.h=u,$=!0,b.insertSpaces=u)}typeof h.cursorStyle<"u"&&this.j!==h.cursorStyle&&(this.j=h.cursorStyle,$=!0,b.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this.k!==h.lineNumbers&&(this.k=h.lineNumbers,$=!0,b.lineNumbers=z.TextEditorLineNumbersStyle.from(h.lineNumbers)),$&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(h,b){b.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this.e.warn($)})}}e.$iL=m;class F{constructor(h,b,$,u,t,r,c,w){this.id=h,this.j=b,this.k=$,this.g=!1,this.h=new Set,this.c=t,this.d=new m(this.j,this.id,r,$),this.e=c,this.f=w;const v=this;this.value=Object.freeze({get document(){return u.value},set document(y){throw(0,C.$6)("document")},get selection(){return v.c&&v.c[0]},set selection(y){if(!(y instanceof T.$dJ))throw(0,C.$4)("selection");v.c=[y],v.l()},get selections(){return v.c},set selections(y){if(!Array.isArray(y)||y.some(i=>!(i instanceof T.$dJ)))throw(0,C.$4)("selections");v.c=y,v.l()},get visibleRanges(){return v.e},set visibleRanges(y){throw(0,C.$6)("visibleRanges")},get options(){return v.d.value},set options(y){v.g||v.d.assign(y)},get viewColumn(){return v.f},set viewColumn(y){throw(0,C.$6)("viewColumn")},edit(y,i={undoStopBefore:!0,undoStopAfter:!0}){if(v.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new k(u.value,i);return y(l),v.m(l)},insertSnippet(y,i,l={undoStopBefore:!0,undoStopAfter:!0}){if(v.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!i||Array.isArray(i)&&i.length===0)n=v.c.map(s=>z.Range.from(s));else if(i instanceof T.$bJ){const{lineNumber:s,column:p}=z.Position.from(i);n=[{startLineNumber:s,startColumn:p,endLineNumber:s,endColumn:p}]}else if(i instanceof T.$cJ)n=[z.Range.from(i)];else{n=[];for(const s of i)if(s instanceof T.$cJ)n.push(z.Range.from(s));else{const{lineNumber:p,column:I}=z.Position.from(s);n.push({startLineNumber:p,startColumn:I,endLineNumber:p,endColumn:I})}}return b.$tryInsertSnippet(h,u.value.version,y.value,n,l)},setDecorations(y,i){const l=i.length===0;l&&!v.h.has(y.key)||(l?v.h.delete(y.key):v.h.add(y.key),v.n(()=>{if(z.$0K(i))return b.$trySetDecorations(h,y.key,z.$$K(i));{const n=new Array(4*i.length);for(let s=0,p=i.length;s<p;s++){const I=i[s];n[4*s]=I.start.line+1,n[4*s+1]=I.start.character+1,n[4*s+2]=I.end.line+1,n[4*s+3]=I.end.character+1}return b.$trySetDecorationsFast(h,y.key,n)}}))},revealRange(y,i){v.n(()=>b.$tryRevealRange(h,z.Range.from(y),i||T.TextEditorRevealType.Default))},show(y){b.$tryShowEditor(h,z.ViewColumn.from(y))},hide(){b.$tryHideEditor(h)}})}dispose(){(0,g.ok)(!this.g),this.g=!0}_acceptOptions(h){(0,g.ok)(!this.g),this.d._accept(h)}_acceptVisibleRanges(h){(0,g.ok)(!this.g),this.e=h}_acceptViewColumn(h){(0,g.ok)(!this.g),this.f=h}_acceptSelections(h){(0,g.ok)(!this.g),this.c=h}async l(){const h=this.c.map(z.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,h)),this.value}m(h){const b=h.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const $=b.edits.map(t=>t.range);$.sort((t,r)=>t.end.line===r.end.line?t.end.character===r.end.character?t.start.line===r.start.line?t.start.character-r.start.character:t.start.line-r.start.line:t.end.character-r.end.character:t.end.line-r.end.line);for(let t=0,r=$.length-1;t<r;t++){const c=$[t].end;if($[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=b.edits.map(t=>({range:z.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,u,{setEndOfLine:typeof b.setEndOfLine=="number"?z.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(h){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$jL=F}),define(Re[207],Fe([1,0,155,7,20,2,5,6,191,16,7,10,18,8,22,125]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P$b=void 0;function t(w,v){if((0,D.$ge)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let y;return Array.isArray(w.highlights)&&(y=w.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),y=y.length?y:void 0),{label:w.label,highlights:y}}}class r{constructor(v,y,i){this.d=v,this.e=y,this.f=i,this.a=new Map,this.b=new u.$83;function l(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}y.registerArgumentProcessor({processArgument:n=>l(n)?this.i(n):Array.isArray(n)&&n.length>0?n.map(s=>l(s)?this.i(s):s):n})}registerTreeDataProvider(v,y,i){const l=this.createTreeView(v,{treeDataProvider:y},i);return{dispose:()=>l.dispose()}}createTreeView(v,y,i){if(!y||!y.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=y.dragAndDropController?.dropMimeTypes??[],n=y.dragAndDropController?.dragMimeTypes??[],s=!!y.dragAndDropController?.handleDrag,p=!!y.dragAndDropController?.handleDrop,I=this.h(v,y,i),d={showCollapseAll:!!y.showCollapseAll,canSelectMany:!!y.canSelectMany,dropMimeTypes:l,dragMimeTypes:n,hasHandleDrag:s,hasHandleDrop:p,manuallyManageCheckboxes:!!y.manageCheckboxStateManually},A=this.d.$registerTreeViewDataProvider(v,d);return{get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(E){I.message=E},get title(){return I.title},set title(E){I.title=E},get description(){return I.description},set description(E){I.description=E},get badge(){return I.badge},set badge(E){E!==void 0&&F.ViewBadge.isViewBadge(E)?I.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(I.badge=void 0)},reveal:(E,a)=>I.reveal(E,a),dispose:async()=>{await A,this.a.delete(v),I.dispose()}}}$getChildren(v,y){const i=this.a.get(v);return i?i.getChildren(y):Promise.reject(new k.$wE(v))}async $handleDrop(v,y,i,l,n,s,p,I){const d=this.a.get(v);if(!d)return Promise.reject(new k.$wE(v));const A=b.DataTransfer.toDataTransfer(i,async E=>(await this.d.$resolveDropFileData(v,y,E)).buffer);return p===v&&I&&await this.g(A,d,I,n,s),d.onDrop(A,l,n)}async g(v,y,i,l,n){const s=this.b.removeDragOperationTransfer(n);if(s)(await s)?.forEach((p,I)=>{p&&v.set(I,p)});else if(n&&y.handleDrag){const p=y.handleDrag(i,v,l);this.b.addDragOperationTransfer(n,p),await p}return v}async $handleDrag(v,y,i,l){const n=this.a.get(v);if(!n)return Promise.reject(new k.$wE(v));const s=await this.g(new C.$5J,n,y,l,i);if(!(!s||l.isCancellationRequested))return b.DataTransfer.from(s)}async $hasResolve(v){const y=this.a.get(v);if(!y)throw new k.$wE(v);return y.hasResolve}$resolve(v,y,i){const l=this.a.get(v);if(!l)throw new k.$wE(v);return l.resolveTreeItem(y,i)}$setExpanded(v,y,i){const l=this.a.get(v);if(!l)throw new k.$wE(v);l.setExpanded(y,i)}$setSelection(v,y){const i=this.a.get(v);if(!i)throw new k.$wE(v);i.setSelection(y)}$setFocus(v,y){const i=this.a.get(v);if(!i)throw new k.$wE(v);i.setFocus(y)}$setVisible(v,y){const i=this.a.get(v);if(!i)throw new k.$wE(v);i.setVisible(y)}$changeCheckboxState(v,y){const i=this.a.get(v);if(!i)throw new k.$wE(v);i.setCheckboxState(y)}h(v,y,i){const l=new c(v,y,this.d,this.e.converter,this.f,i);return this.a.set(v,l),l}i(v){const y=this.a.get(v.$treeViewId);return y&&"$treeItemHandle"in v?y.getExtensionElement(v.$treeItemHandle):y&&"$focusedTreeItem"in v&&v.$focusedTreeItem?y.focusedElement:null}}e.$P$b=r;class c extends f.$kb{get visible(){return this.k}get selectedElements(){return this.l.map(v=>this.getExtensionElement(v)).filter(v=>!(0,D.$pe)(v))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(v,y,i,l,n,s){if(super(),this.C=v,this.D=i,this.F=l,this.G=n,this.H=s,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new T.$5c),this.onDidExpandElement=this.r.event,this.s=this.B(new T.$5c),this.onDidCollapseElement=this.s.event,this.t=this.B(new T.$5c),this.onDidChangeSelection=this.t.event,this.u=this.B(new T.$5c),this.onDidChangeVisibility=this.u.event,this.v=this.B(new T.$5c),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new T.$5c),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new $.$bd,s.contributes&&s.contributes.views)for(const d in s.contributes.views)for(const A of s.contributes.views[d])A.id===v&&(this.J=A.name);this.f=y.treeDataProvider,this.g=y.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(d=>this.w.fire({message:!1,element:d})));let p,I;this.B(T.Event.debounce(this.w.event,(d,A)=>(d||(d={message:!1,elements:[]}),A.element!==!1&&(p||(p=new Promise(E=>I=E),this.y=this.y.then(()=>p)),Array.isArray(A.element)?d.elements.push(...A.element):d.elements.push(A.element)),A.message&&(d.message=!0),d),200,!0)(({message:d,elements:A})=>{A.length&&(this.z=this.z.then(()=>{const E=I;return p=null,this.U(A).then(()=>E())})),d&&this.D.$setMessage(this.C,this.I)}))}async getChildren(v){const y=v?this.getExtensionElement(v):void 0;if(v&&!y)return this.G.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let i=this.Q(v);return i||(i=await this.R(y)),i?i.map(l=>l.item):void 0}getExtensionElement(v){return this.i.get(v)}reveal(v,y){y=y||{select:!0,focus:!1};const i=(0,D.$pe)(y.select)?!0:y.select,l=(0,D.$pe)(y.focus)?!1:y.focus,n=(0,D.$pe)(y.expand)?!1:y.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.y.then(()=>this.N(v)).then(s=>this.P(v,s[s.length-1]).then(p=>this.D.$reveal(this.C,{item:p.item,parentChain:s.map(I=>I.item)},{select:i,focus:l,expand:n})),s=>this.G.error(s)):this.D.$reveal(this.C,void 0,{select:i,focus:l,expand:n})}get message(){return this.I}set message(v){this.I=v,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(v){this.J=v,this.D.$setTitle(this.C,v,this.L)}get description(){return this.L}set description(v){this.L=v,this.D.$setTitle(this.C,this.J,v)}get badge(){return this.M}set badge(v){this.M?.value===v?.value&&this.M?.tooltip===v?.tooltip||(this.M=b.ViewBadge.from(v),this.D.$setBadge(this.C,v))}setExpanded(v,y){const i=this.getExtensionElement(v);i&&(y?this.r.fire(Object.freeze({element:i})):this.s.fire(Object.freeze({element:i})))}setSelection(v){(0,h.$$e)(this.l,v)||(this.l=v,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this.m=v}setVisible(v){v!==this.k&&(this.k=v,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(v){const y=(await Promise.all(v.map(async i=>{const l=this.getExtensionElement(i.treeItemHandle);return l?{extensionItem:l,treeItem:await this.f.getTreeItem(l),newState:i.newState?F.TreeItemCheckboxState.Checked:F.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(i=>i!==void 0);y.forEach(i=>{i.treeItem.checkboxState=i.newState?F.TreeItemCheckboxState.Checked:F.TreeItemCheckboxState.Unchecked}),this.v.fire({items:y.map(i=>[i.extensionItem,i.newState])})}async handleDrag(v,y,i){const l=[];for(const n of v){const s=this.getExtensionElement(n);s&&l.push(s)}if(!(!this.g?.handleDrag||l.length===0))return await this.g.handleDrag(l,y,i),y}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,y,i){const l=y?this.getExtensionElement(y):void 0;if(!(!l&&y||!this.g?.handleDrop))return(0,m.$kg)(()=>this.g?.handleDrop?this.g.handleDrop(l,v,i):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,y){if(!this.f.resolveTreeItem)return;const i=this.i.get(v);if(i){const l=this.j.get(i);if(l){const n=await this.f.resolveTreeItem(l.extensionItem,i,y)??l.extensionItem;return this.cb(n),l.item.tooltip=this.$(n.tooltip),l.item.command=this.ab(l.disposableStore,n.command),l.item}}}N(v){return this.O(v).then(y=>y?this.N(y).then(i=>this.P(y,i[i.length-1]).then(l=>(i.push(l),i))):Promise.resolve([]))}O(v){const y=this.j.get(v);return y?Promise.resolve(y.parent?this.i.get(y.parent.item.handle):void 0):(0,m.$kg)(()=>this.f.getParent(v))}P(v,y){const i=this.j.get(v);return i?Promise.resolve(i):(0,m.$kg)(()=>this.f.getTreeItem(v)).then(l=>this.fb(v,l,y,!0)).then(l=>this.getChildren(y?y.item.handle:void 0).then(()=>{const n=this.getExtensionElement(l);if(n){const s=this.j.get(n);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}Q(v){if(v){let y;if(typeof v=="string"){const i=this.getExtensionElement(v);y=i?this.j.get(i):void 0}else y=v;return y&&y.children||void 0}return this.h}async R(v){this.mb(v);const y=new $.$bd(this.S.token);try{const i=v?this.j.get(v):void 0,l=await this.f.getChildren(v);if(y.token.isCancellationRequested)return;const n=await Promise.all((0,h.$jf)(l||[]).map(async s=>{const p=await this.f.getTreeItem(s);return p&&!y.token.isCancellationRequested?this.Z(s,p,i):null}));return y.token.isCancellationRequested?void 0:(0,h.$jf)(n)}finally{y.dispose()}}U(v){if(v.some(i=>!i))return this.S.dispose(!0),this.S=new $.$bd,this.ob(),this.D.$refresh(this.C);{const i=this.W(v);if(i.length)return this.X(i)}return Promise.resolve(void 0)}W(v){const y=new Set,i=v.map(n=>this.j.get(n));for(const n of i)if(n&&!y.has(n.item.handle)){let s=n;for(;s&&s.parent&&i.findIndex(p=>s&&s.parent&&p&&p.item.handle===s.parent.item.handle)===-1;){const p=this.i.get(s.parent.item.handle);s=p?this.j.get(p):void 0}s&&!s.parent&&y.add(n.item.handle)}const l=[];return y.forEach(n=>{const s=this.i.get(n);if(s){const p=this.j.get(s);p&&(!p.parent||!y.has(p.parent.item.handle))&&l.push(n)}}),l}X(v){const y={};return Promise.all(v.map(i=>this.Y(i).then(l=>{l&&(y[i]=l.item)}))).then(()=>Object.keys(y).length?this.D.$refresh(this.C,y):void 0)}Y(v){const y=this.getExtensionElement(v);if(y){const i=this.j.get(y);if(i)return this.mb(y),(0,m.$kg)(()=>this.f.getTreeItem(y)).then(l=>{if(l){const n=this.db(y,l,i.parent);return this.kb(y,n,i,i.parent),i.dispose(),n}return null})}return Promise.resolve(null)}Z(v,y,i){const l=this.db(v,y,i);if(y.id&&this.i.has(l.item.handle))throw new Error((0,g.localize)(0,null,y.id));return this.jb(v,l),this.lb(l,i),l}$(v){return F.$BJ.isMarkdownString(v)?b.MarkdownString.from(v):v}ab(v,y){return y?{...this.F.toInternal(y,v),originalId:y.command}:void 0}bb(v){if(v.checkboxState===void 0)return;let y,i,l;return typeof v.checkboxState=="number"?y=v.checkboxState:(y=v.checkboxState.state,i=v.checkboxState.tooltip,l=v.checkboxState.accessibilityInformation),{isChecked:y===F.TreeItemCheckboxState.Checked,tooltip:i,accessibilityInformation:l}}cb(v){if(!F.$ZJ.isTreeItem(v,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}db(v,y,i){this.cb(y);const l=new f.$jb,n=this.fb(v,y,i),s=this.gb(y);return{item:{handle:n,parentHandle:i?i.item.handle:void 0,label:t(y.label,this.H),description:y.description,resourceUri:y.resourceUri,tooltip:this.$(y.tooltip),command:this.ab(l,y.command),contextValue:y.contextValue,icon:s,iconDark:this.hb(y)||s,themeIcon:this.eb(y),collapsibleState:(0,D.$pe)(y.collapsibleState)?F.TreeItemCollapsibleState.None:y.collapsibleState,accessibilityInformation:y.accessibilityInformation,checkbox:this.bb(y)},extensionItem:y,parent:i,children:void 0,disposableStore:l,dispose(){l.dispose()}}}eb(v){return v.iconPath instanceof F.$8J?v.iconPath:void 0}fb(v,{id:y,label:i,resourceUri:l},n,s){if(y)return`${c.b}/${y}`;const p=t(i,this.H),I=n?n.item.handle:c.a;let d=p?p.label:l?(0,S.$3f)(l):"";d=d.indexOf("/")!==-1?d.replace("/","//"):d;const A=this.j.has(v)?this.j.get(v).item.handle:void 0,E=this.Q(n)||[];let a,o=0;do{if(a=`${I}/${o}:${d}`,s||!this.i.has(a)||A===a)break;o++}while(o<=E.length);return a}gb(v){if(v.iconPath&&!(v.iconPath instanceof F.$8J))return typeof v.iconPath=="string"||z.URI.isUri(v.iconPath)?this.ib(v.iconPath):this.ib(v.iconPath.light)}hb(v){if(v.iconPath&&!(v.iconPath instanceof F.$8J)&&v.iconPath.dark)return this.ib(v.iconPath.dark)}ib(v){return z.URI.isUri(v)?v:z.URI.file(v)}jb(v,y){this.i.set(y.item.handle,v),this.j.set(v,y)}kb(v,y,i,l){this.i.delete(y.item.handle),this.j.delete(v),y.item.handle!==i.item.handle&&this.i.delete(i.item.handle),this.jb(v,y);const n=this.Q(l)||[],s=n.filter(p=>p.item.handle===i.item.handle)[0];s&&n.splice(n.indexOf(s),1,y)}lb(v,y){y?(y.children||(y.children=[]),y.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}mb(v){if(v){const y=this.j.get(v);if(y){if(y.children)for(const i of y.children){const l=this.i.get(i.item.handle);l&&this.nb(l)}y.children=void 0}}else this.ob()}nb(v){const y=this.j.get(v);if(y){if(y.children)for(const i of y.children){const l=this.i.get(i.item.handle);l&&this.nb(l)}this.j.delete(v),this.i.delete(y.item.handle),y.dispose()}}ob(){this.h=void 0,this.i.clear(),this.j.forEach(v=>v.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.ob(),this.D.$disposeTree(this.C)}}c.a="0",c.b="1"}),define(Re[208],Fe([1,0,3,169]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oI=void 0,e.$oI=(0,g.$mh)(C.$sh)}),define(Re[106],Fe([1,0,24,5,19,6]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sZb=e.$rZb=e.$qZb=e.$pZb=e.$oZb=void 0;class T{constructor(t){this.removedDueToLooping=t}}e.$oZb=T;class f{static isHostExtension(t,r,c){if(r.getExtensionDescription(t))return!1;const w=c.getExtensionDescription(t);return w?!!((w.main||w.browser)&&w.api==="none"):!1}constructor(t,r){this.h=t,this.c=new C.$5c,this.onDidChange=this.c.event,this.d=r,this.j()}j(){this.d.sort(b),this.e=new g.$Fl,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const r=this.h.readActivationEvents(t);if(Array.isArray(r))for(let c of r)c==="onUri"&&(c=`onUri:${g.$Dl.toKey(t.identifier)}`),this.g.has(c)||this.g.set(c,[]),this.g.get(c).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,r){this.d=$(this.d,r),this.d=this.d.concat(t);const c=f.k(this.d);return this.d=$(this.d,c.map(w=>w.identifier)),this.j(),this.c.fire(void 0),new T(c)}static k(t){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(i){this.d.has(i)||(this.d.add(i),this.e.push(i))}addArc(i,l){this.addNode(i),this.addNode(l),this.c.has(i)?this.c.get(i).push(l):this.c.set(i,[l])}getArcs(i){return this.c.has(i)?this.c.get(i):[]}hasOnlyGoodArcs(i,l){const n=r.getArcs(i);for(let s=0;s<n.length;s++)if(!l.has(n[s]))return!1;return!0}getNodes(){return this.e}},c=new g.$Fl;for(const i of t)if(c.set(i.identifier,i),i.extensionDependencies)for(const l of i.extensionDependencies)r.addArc(g.$Dl.toKey(i.identifier),g.$Dl.toKey(l));const w=new Set;r.getNodes().filter(i=>r.getArcs(i).length===0).forEach(i=>w.add(i));const v=r.getNodes().filter(i=>!w.has(i));let y;do{y=!1;for(let i=0;i<v.length;i++){const l=v[i];r.hasOnlyGoodArcs(l,w)&&(v.splice(i,1),i--,w.add(l),y=!0)}}while(y);return v.map(i=>c.get(i))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const r=this.g.get(t);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const r=this.e.get(t);return r||void 0}getExtensionDescriptionByUUID(t){for(const r of this.f)if(r.uuid===t)return r}getExtensionDescriptionByIdOrUUID(t,r){return this.getExtensionDescription(t)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$pZb=f,e.$qZb={readActivationEvents:u=>u.activationEvents};class k{constructor(t){this.d=new D,this.c=new f(t,[])}async acquireLock(t){const r=await this.d.acquire(t);return new m(this,r)}deltaExtensions(t,r,c){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,c)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,r){return this.c.getExtensionDescriptionByIdOrUUID(t,r)}}e.$rZb=k;class m extends z.$kb{constructor(t,r){super(),this.f=t,this.c=!1,this.B(r)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$sZb=m;class F{constructor(t){this.name=t,this.promise=new Promise((r,c)=>{this.c=r})}resolve(t){this.c(t)}}class D{constructor(){this.c=[],this.d=!1}async acquire(t){const r=new F(t);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let r=!0;const c=setTimeout(()=>{r&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),w=()=>{r&&(clearTimeout(c),r=!1,this.d=!1,this.e())};t.resolve((0,z.$ib)(w))}}var h;(function(u){u[u.Builtin=0]="Builtin",u[u.User=1]="User",u[u.Dev=2]="Dev"})(h||(h={}));function b(u,t){const r=u.isBuiltin?0:u.isUnderDevelopment?2:1,c=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(r!==c)return r-c;const w=S.$8b.basename(u.extensionLocation.path),v=S.$8b.basename(t.extensionLocation.path);return w<v?-1:w>v?1:0}function $(u,t){const r=new g.$El(t);return u.filter(c=>!r.has(c.identifier))}}),define(Re[80],Fe([1,0,25]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Ml=e.$Ll=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(C||(e.UIKind=C={}));var S;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(S||(e.ExtensionHostExitCode=S={}));var z;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(z||(e.MessageType=z={}));function T(m){const F=g.$Ib.alloc(1);switch(m){case 0:F.writeUInt8(1,0);break;case 1:F.writeUInt8(2,0);break;case 2:F.writeUInt8(3,0);break}return F}e.$Ll=T;function f(m,F){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return F===0;case 2:return F===1;case 3:return F===2;default:return!1}}e.$Ml=f;var k;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(k||(e.NativeLogMarkers=k={}))}),define(Re[57],Fe([1,0,3,5,15,27,80,50,52,23,2,6,153]),function(te,e,g,C,S,z,T,f,k,m,F,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uL=e.$tL=e.$sL=e.$rL=void 0;let b=e.$rL=class extends D.$kb{constructor(r,c){super(),this.n=r,this.p=c,this.a=this.B(new C.$5c),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new C.$5c),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=F.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=c.createLogger(this.j,{id:k.$3n,name:(0,h.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(w=>{(0,S.$Pi)(w)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===S.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,c,w){const v=this.getTelemetryDetails(),y=new $(c,w,r,this.k,this.i,this.getBuiltInCommonProperties(r),{isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}),i=this.m.get(r.identifier.value)??[];return this.m.set(r.identifier.value,[...i,y]),y.apiTelemetryLogger}$initializeTelemetryLevel(r,c,w){this.f=r,this.g=c,this.c=w??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(r){const c=Object.create(null);switch(c["common.extname"]=`${r.publisher}.${r.name}`,c["common.extversion"]=r.version,c["common.vscodemachineid"]=this.n.telemetryInfo.machineId,c["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,c["common.vscodeversion"]=this.n.version,c["common.isnewappinstall"]=u(this.n.telemetryInfo.firstSessionDate),c["common.product"]=this.n.environment.appHost,this.n.uiKind){case T.UIKind.Web:c["common.uikind"]="web";break;case T.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,f.$yk)((0,k.$0n)(this.n.remote.authority)),c}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const c=this.getTelemetryDetails();this.m.forEach((w,v)=>{const y=w.filter(i=>!i.isDisposed);y.length===0?this.m.delete(v):this.m.set(v,y)}),this.m.forEach(w=>{for(const v of w)v.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(r,c){const v=this.m.get(r.value)?.filter(i=>!i.isDisposed);if(!v)return this.m.delete(r.value),!1;let y=!1;for(const i of v)i.ignoreUnhandledExtHostErrors||(i.logError(c),y=!0);return y}};e.$rL=b=qe([Ve(0,z.$qL),Ve(1,S.$Oi)],b);class ${static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,c,w,v,y,i,l){this.g=w,this.h=v,this.i=y,this.j=i,this.a=new C.$5c,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}}updateTelemetryEnablements(r,c){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let c="properties"in r?r.properties??{}:r;return c=(0,k.$ao)(c,[]),this.c&&(c=(0,m.$Gm)(c,this.c)),this.b||(c=(0,m.$Gm)(c,this.j)),"properties"in r?r.properties=c:r=c,r}k(r,c){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(r,c),this.h.trace(r,c))}logUsage(r,c){this.d.isUsageEnabled&&this.k(r,c)}logError(r,c){!this.d.isErrorsEnabled||!this.f||(typeof r=="string"?this.k(r,c):this.f.sendErrorData(r,c))}get apiTelemetryLogger(){if(!this.e){const r=this,c={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$sL=$;function u(t){const r=Date.now()-new Date(t).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$tL=u,e.$uL=(0,g.$lh)("IExtHostTelemetry")}),define(Re[26],Fe([1,0,5,2,179,98,24,3]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dF=e.$cF=e.$bF=e.ActivationKind=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.ExtensionHostStartup=e.$8E=e.$7E=e.$6E=e.$5E=void 0,e.$5E=Object.freeze({identifier:new T.$Dl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$6E="extensions.webWorker",e.$7E=(0,f.$lh)("extensionService");class k{constructor(y){this.dependency=y}}e.$8E=k;var m;(function(v){v[v.EagerAutoStart=1]="EagerAutoStart",v[v.EagerManualStart=2]="EagerManualStart",v[v.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class F{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:z.$VE.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(y,i){const l=[],n=[],s=[],p=[],I=D(this.c),d=D(y),A=(B,G)=>B.extensionLocation.toString()===G.extensionLocation.toString()||B.isBuiltin===G.isBuiltin||B.isUserBuiltin===G.isUserBuiltin||B.isUnderDevelopment===G.isUnderDevelopment;for(const B of this.c){const G=d.get(B.identifier);if(!G){l.push(B.identifier),I.delete(B.identifier);continue}if(!A(B,G)){l.push(B.identifier),I.delete(B.identifier);continue}}for(const B of y){const G=I.get(B.identifier);if(!G){n.push(B);continue}if(!A(G,B)){l.push(G.identifier),I.delete(G.identifier);continue}}const E=new T.$El(this.d),a=new T.$El(i);for(const B of this.d)a.has(B)||s.push(B);for(const B of i)E.has(B)||p.push(B);const o=z.$VE.createActivationEventsMap(n),L={toRemove:l,toAdd:n,addActivationEvents:o,myToRemove:s,myToAdd:p};return this.delta(L),L}delta(y){const{toRemove:i,toAdd:l,myToRemove:n,myToAdd:s}=y,p=new T.$El(i),I=new T.$El(n);for(let d=0;d<this.c.length;d++)p.has(this.c[d].identifier)&&(this.c.splice(d,1),d--);for(let d=0;d<this.d.length;d++)I.has(this.d[d])&&(this.d.splice(d,1),d--);for(const d of l)this.c.push(d);for(const d of s)this.d.push(d)}containsExtension(y){for(const i of this.d)if(T.$Dl.equals(i,y))return!0;return!1}}e.$9E=F;function D(v){const y=new T.$Fl;for(const i of v)y.set(i.identifier,i);return y}function h(v,y){return v.enabledApiProposals?v.enabledApiProposals.includes(y):!1}e.$0E=h;function b(v,y){if(!h(v,y))throw new Error(`Extension '${v.identifier.value}' CANNOT use API proposal: ${y}.
Its package.json#enabledApiProposals-property declares: ${v.enabledApiProposals?.join(", ")??"[]"} but NOT ${y}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${v.identifier.value}`)}e.$$E=b;class ${constructor(y,i,l,n){this.codeLoadingTime=y,this.activateCallTime=i,this.activateResolvedTime=l,this.activationReason=n}}e.$_E=$;class u{constructor(y,i){this.description=y,this.value=i}}e.$aF=u;var t;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function r(v){return{type:v.isBuiltin?0:1,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:(0,S.$go)(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation,targetPlatform:v.targetPlatform,validations:[],isValid:!0}}e.$bF=r;function c(v,y){return{identifier:new T.$Dl((0,S.$eo)(v.manifest.publisher,v.manifest.name)),isBuiltin:v.type===0,isUserBuiltin:v.type===1&&v.isBuiltin,isUnderDevelopment:!!y,extensionLocation:v.location,...v.manifest,uuid:v.identifier.uuid,targetPlatform:v.targetPlatform}}e.$cF=c;class w{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None,this.onWillStop=g.Event.None,this.extensions=[]}activateByEvent(y){return Promise.resolve(void 0)}activationEventIsDone(y){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(y){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(y,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(y){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$dF=w}),define(Re[209],Fe([1,0,9,106,24,26,15,16]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d$b=e.$c$b=e.$b$b=e.$a$b=e.$_0b=e.$$0b=void 0;class k{constructor(r,c,w,v){this.startup=r,this.codeLoadingTime=c,this.activateCallTime=w,this.activateResolvedTime=v}}e.$$0b=k,k.NONE=new k(!1,-1,-1,-1);class m{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,c){return r===-1||c===-1?-1:c-r}build(){return new k(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$_0b=m;class F{constructor(r,c,w,v,y,i){this.activationFailed=r,this.activationFailedError=c,this.activationTimes=w,this.module=v,this.exports=y,this.subscriptions=i}}e.$a$b=F;class D extends F{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$b$b=D;class h extends F{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$c$b=h;class b extends F{constructor(r){super(!0,r,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=e.$d$b=class{constructor(r,c,w,v){this.g=v,this.a=r,this.b=c,this.c=w,this.d=new S.$Fl,this.f=Object.create(null)}dispose(){for(const[r,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const r=[];for(const[c,w]of this.d)r.push(w.wait());await Promise.all(r)}isActivated(r){const c=this.d.get(r);return!!(c&&c.value)}getActivatedExtension(r){const c=this.d.get(r);if(!c||!c.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return c.value}async activateByEvent(r,c){if(this.f[r])return;const w=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(w.map(v=>({id:v.identifier,reason:{startup:c,extensionId:v.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,c){const w=this.a.getExtensionDescription(r);if(!w)throw new Error(`Extension '${r}' is not known`);return this.h([{id:w.identifier,reason:c}])}async h(r){const c=r.filter(w=>!this.isActivated(w.id)).map(w=>this.j(w));await Promise.all(c.map(w=>w.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const c=this.a.getExtensionDescription(r.id);if(!c){const y=new Error(`Cannot activate unknown extension '${r.id.value}'`),i=this.k(r,null,[],new b(y));return this.c.onExtensionActivationError(r.id,y,new z.$8E(r.id.value)),i}const w=[],v=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const y of v){if(this.m(y))continue;const i=this.d.get(y);if(i){w.push(i);continue}if(this.l(y)){w.push(this.j({id:this.b.getExtensionDescription(y).identifier,reason:r.reason}));continue}const l=this.a.getExtensionDescription(y);if(l){if(!l.main&&!l.browser)continue;w.push(this.j({id:l.identifier,reason:r.reason}));continue}const n=c.displayName||c.identifier.value,s=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${y}'`),p=this.k(r,c.displayName,[],new b(s));return this.c.onExtensionActivationError(c.identifier,s,new z.$8E(y)),p}return this.k(r,c.displayName,w,null)}k(r,c,w,v){const y=new u(r.id,c,r.reason,w,v,this.c,this.g);return this.d.set(r.id,y),y}l(r){return C.$pZb.isHostExtension(r,this.a,this.b)}m(r){const c=this.b.getExtensionDescription(r);return c?!c.main&&!c.browser:!1}};e.$d$b=$=qe([Ve(3,T.$Ni)],$);let u=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,c,w,v,y,i,l){this.c=r,this.d=c,this.f=w,this.g=v,this.h=y,this.j=i,this.k=l,this.a=new f.$qg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const c=this.g[r];if(c.value&&!c.value.activationFailed){this.g.splice(r,1),r--;continue}if(c.value&&c.value.activationFailed){const w=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);w.detail=c.value.activationFailedError,this.h=new b(w),this.j.onExtensionActivationError(this.c,w,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const c=new Error;if(r&&r.name&&(c.name=r.name),r&&r.message?c.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(c.stack=r.stack),this.h=new b(c),this.b&&g.$1(r))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};u=qe([Ve(6,T.$Ni)],u)}),define(Re[210],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemIcon:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemIcon.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testInvalidateResults:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testInvalidateResults.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[211],Fe([1,0,164,9,29,92,74,30,24,210,174,98]),function(te,e,g,C,S,z,T,f,k,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=void 0;const h=f.$Pm.as(T.$Qm.JSONContribution);class b{constructor(y,i,l){this.a=y,this.b=i,this.c=l}d(y,i){this.a({type:y,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(y){this.d(S.default.Error,y)}warn(y){this.d(S.default.Warning,y)}info(y){this.d(S.default.Info,y)}}e.$eF=b;class ${static a(y){const i=new k.$El;for(let l=0,n=y.length;l<n;l++)i.add(y[l].description.identifier);return i}static compute(y,i){if(!y||!y.length)return new $(i,[]);if(!i||!i.length)return new $([],y);const l=this.a(y),n=this.a(i),s=i.filter(I=>!l.has(I.description.identifier)),p=y.filter(I=>!n.has(I.description.identifier));return new $(s,p)}constructor(y,i){this.added=y,this.removed=i}}e.$fF=$;class u{constructor(y,i){this.name=y,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(y){if(this.a!==null)throw new Error("Handler already set!");this.a=y,this.d()}acceptUsers(y){this.c=$.compute(this.b,y),this.b=y,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(y){(0,C.$X)(y)}}}e.$gF=u;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[g.localize(0,null),g.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$hF={properties:{engines:{type:"object",description:g.localize(2,null),properties:{vscode:{type:"string",description:g.localize(3,null),default:"^1.22.0"}}},publisher:{description:g.localize(4,null),type:"string"},displayName:{description:g.localize(5,null),type:"string"},categories:{description:g.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:k.$Cl},{type:"string",const:"Languages",deprecationMessage:g.localize(7,null)}]}},galleryBanner:{type:"object",description:g.localize(8,null),properties:{color:{description:g.localize(9,null),type:"string"},theme:{description:g.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:g.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:g.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:g.localize(13,null)},enabledApiProposals:{markdownDescription:g.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:g.localize(15,null),type:"string",enum:["none"],enumDescriptions:[g.localize(16,null)]},activationEvents:{description:g.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:g.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:g.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:g.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:g.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:g.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:g.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:g.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:g.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:g.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:g.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:g.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:g.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:g.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:g.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:g.localize(32,null)},{label:"onUri",body:"onUri",description:g.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:g.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:g.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:g.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:g.localize(37,null)},{label:"onRenderer",description:g.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:g.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:g.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:g.localize(41,null)},{label:"*",description:g.localize(42,null),body:"*"}]}},badges:{type:"array",description:g.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:g.localize(44,null)},href:{type:"string",description:g.localize(45,null)},description:{type:"string",description:g.localize(46,null)}}}},markdown:{type:"string",description:g.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:g.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:g.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:z.$zn}},extensionPack:{description:g.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:z.$zn}},extensionKind:{description:g.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:g.localize(52,null)},{body:["workspace"],description:g.localize(53,null)},{body:["ui","workspace"],description:g.localize(54,null)},{body:["workspace","ui"],description:g.localize(55,null)},{body:[],description:g.localize(56,null)}]},capabilities:{description:g.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:g.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:g.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[g.localize(60,null),g.localize(61,null),g.localize(62,null)]},description:{type:"string",markdownDescription:g.localize(63,null)}}},untrustedWorkspaces:{description:g.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:g.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[g.localize(66,null),g.localize(67,null),g.localize(68,null)]},restrictedConfigurations:{description:g.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:g.localize(70,null)}}}}},sponsor:{description:g.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:g.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:g.localize(73,null),type:"string"},"vscode:uninstall":{description:g.localize(74,null),type:"string"}}},icon:{type:"string",description:g.localize(75,null)},l10n:{type:"string",description:g.localize(76,null)}}};class c{constructor(){this.a=new Map}registerExtensionPoint(y){if(this.a.has(y.extensionPoint))throw new Error("Duplicate extension point: "+y.extensionPoint);const i=new u(y.extensionPoint,y.defaultExtensionKind);return this.a.set(y.extensionPoint,i),y.activationEventsGenerator&&D.$VE.register(y.extensionPoint,y.activationEventsGenerator),e.$hF.properties.contributes.properties[y.extensionPoint]=y.jsonSchema,h.registerSchema(r,e.$hF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$iF=c;const w={ExtensionsRegistry:"ExtensionsRegistry"};f.$Pm.add(w.ExtensionsRegistry,new c),e.$jF=f.$Pm.as(w.ExtensionsRegistry),h.registerSchema(r,e.$hF),h.registerSchema(F.$7i,{properties:{extensionEnabledApiProposals:{description:g.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(Re[212],Fe([1,0,161,10,23,211,31,5]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sF=void 0;const k={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:g.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:g.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:g.localize(2,null),default:""}}};var m;(function(h){function b($,u,t){if(!$)return;const r=C.$ge($.type)?$.type:void 0;if(!r||r.length===0){t.error(g.localize(3,null));return}const c=[];if(Array.isArray($.required))for(const w of $.required)C.$ge(w)&&c.push(w);return{extensionId:u.value,taskType:r,required:c,properties:$.properties?S.$Dm($.properties):{},when:$.when?T.$ri.deserialize($.when):void 0}}h.from=b})(m||(m={}));const F=z.$jF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,b)=>{for(const $ of h)$.type&&b.push(`onTaskType:${$.type}`)},jsonSchema:{description:g.localize(4,null),type:"array",items:k}});class D{constructor(){this.d=new f.$5c,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,$)=>{F.setHandler((u,t)=>{this.c=void 0;try{for(const r of t.removed){const c=r.value;for(const w of c)this.a&&w.type&&this.a[w.type]&&delete this.a[w.type]}for(const r of t.added){const c=r.value;for(const w of c){const v=m.from(w,r.description.identifier,r.collector);v&&(this.a[v.taskType]=v)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const $ of this.all()){const u={type:"object",additionalProperties:!1};$.required.length>0&&(u.required=$.required.slice(0)),$.properties!==void 0?u.properties=S.$Dm($.properties):u.properties=Object.create(null),u.properties.type={type:"string",enum:[$.taskType]},b.push(u)}this.c={oneOf:b}}return this.c}}e.$sF=new D}),define(Re[213],Fe([1,0,162,10,20,23,31,212]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$CF=e.JsonSchemaVersion=e.ExecutionEngine=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$wF=e.ShellQuoting=e.$vF=e.$uF=e.$tF=void 0,e.$tF="settings",e.$uF=new T.$Ki("taskRunning",!1,g.localize(0,null)),e.$vF={value:g.localize(1,null),original:"Tasks"};var k;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(k||(e.ShellQuoting=k={})),e.$wF="$customized",function(N){function H(j){if(!j)return N.Strong;switch(j.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=H}(k||(e.ShellQuoting=k={}));var m;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(m||(e.CommandOptions=m={}));var F;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(F||(e.RevealKind=F={})),function(N){function H(j){switch(j.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=H}(F||(e.RevealKind=F={}));var D;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(N){function H(j){switch(j.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=H}(D||(e.RevealProblemKind=D={}));var h;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(h||(e.PanelKind=h={})),function(N){function H(j){switch(j.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=H}(h||(e.PanelKind=h={}));var b;(function(N){N.defaults={echo:!0,reveal:F.Always,revealProblems:D.Never,focus:!1,panel:h.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var $;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(N){function H(O){switch(O.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=H;function j(O){switch(O){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=j}($||(e.RuntimeType=$={}));var u;(function(N){function H(j){return C.$ge(j)?j:j.value}N.value=H})(u||(e.CommandString=u={}));var t;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function H(O){return O===N.Clean._id||O===N.Build._id||O===N.Rebuild._id||O===N.Test._id}N.is=H;function j(O){if(O!==void 0)return C.$ge(O)?H(O)?{_id:O,isDefault:!1}:void 0:O}N.from=j})(t||(e.TaskGroup=t={}));var r;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var c;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function H(j){switch(j){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=H})(c||(e.TaskSourceKind=c={}));var w;(function(N){N.parallel="parallel",N.sequence="sequence"})(w||(e.DependsOrder=w={}));var v;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(v||(e.RunOnOptions=v={}));var y;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:v.default,instanceLimit:1}})(y||(e.RunOptions=y={}));class i{constructor(H,j,O,ue,pe,Pe){this._label="",this._id=H,j&&(this._label=j),O&&(this.type=O),this.runOptions=ue,this.configurationProperties=pe,this._source=Pe}getDefinition(H){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const H={folder:this.d(),id:this._id};return JSON.stringify(H)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(H,j=!1){if(H===void 0)return!1;if(C.$ge(H))return H===this._label||H===this.configurationProperties.identifier||j&&H===this._id;const O=this.getDefinition(!0);return O!==void 0&&O._key===H._key}getQualifiedLabel(){const H=this.getWorkspaceFolder();return H?`${this._label} (${H.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(H){this.c===void 0&&(this.c=[]),H&&(this.c=this.c.concat(H))}get taskLoadMessages(){return this.c}}e.$xF=i;class l extends i{constructor(H,j,O,ue,pe,Pe,_,Y){super(H,O,void 0,_,Y,j),this.command={},this._source=j,this.hasDefinedMatchers=Pe,pe&&(this.command=pe)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(H=!1){if(H&&this._source.customizes!==void 0)return this._source.customizes;{let j;switch(this.command?this.command.runtime:void 0){case $.Shell:j="shell";break;case $.Process:j="process";break;case $.CustomExecution:j="customExecution";break;case void 0:j="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:j,_key:this._id,id:this._id}}}static is(H){return H instanceof l}getMapKey(){const H=this._source.config.workspaceFolder;return H?`${H.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$tF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const H=this.d();if(!H)return;let j=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(j+=this._source.kind);const O={type:e.$wF,folder:H,id:j};return JSON.stringify(O)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.$3f(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(H){return new l(H._id,H._source,H._label,H.type,H.command,H.hasDefinedMatchers,H.runOptions,H.configurationProperties)}}e.$yF=l;class n extends i{constructor(H,j,O,ue,pe,Pe,_){super(H,O,ue,Pe,_,j),this._source=j,this.configures=pe}static is(H){return H instanceof n}f(H){return H}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.$3f(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$tF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const H=this.d();if(!H)return;let j=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(j+=this._source.kind);const O={type:e.$wF,folder:H,id:j};return JSON.stringify(O)}}e.$zF=n;class s extends i{constructor(H,j,O,ue,pe,Pe,_,Y,ce){super(H,O,ue,Y,ce,j),this.defines=pe,this.hasDefinedMatchers=_,this.command=Pe,this.icon=ce.icon,this.hide=ce.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(H){return H instanceof s}getMapKey(){const H=this._source.workspaceFolder;return H?`${this._source.scope.toString()}|${H.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const H={type:"contributed",scope:this._source.scope,id:this._id};return H.folder=this.d(),JSON.stringify(H)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(H){return new s(H._id,H._source,H._label,H.type,H.defines,H.command,H.hasDefinedMatchers,H.runOptions,H.configurationProperties)}}e.$AF=s;class p extends i{constructor(H,j,O,ue,pe,Pe){super(H,O,ue,pe,Pe,j),this._source=j}clone(){return new p(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(H){return H instanceof p}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(H){return new p(H._id,H._source,H._label,H.type,H.runOptions,H.configurationProperties)}}e.$BF=p;var I;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(I||(e.ExecutionEngine=I={})),function(N){N._default=N.Terminal}(I||(e.ExecutionEngine=I={}));var d;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(d||(e.JsonSchemaVersion=d={}));class A{constructor(H){this.c=new Map;for(let j=0;j<H.length;j++)this.c.set(H[j].uri.toString(),j)}compare(H,j){const O=H.getWorkspaceFolder(),ue=j.getWorkspaceFolder();if(O&&ue){let pe=this.c.get(O.uri.toString());pe=pe===void 0?0:pe+1;let Pe=this.c.get(ue.uri.toString());return Pe=Pe===void 0?0:Pe+1,pe===Pe?H._label.localeCompare(j._label):pe-Pe}else return!O&&ue?-1:O&&!ue?1:0}}e.$CF=A;var E;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(E||(e.TaskEventKind=E={}));var a;(function(N){N.SingleRun="singleRun",N.Background="background"})(a||(e.TaskRunType=a={}));var o;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(o||(e.TaskRunSource=o={}));var L;(function(N){function H(j,O,ue,pe){if(O){const Pe={kind:j,taskId:O._id,taskName:O.configurationProperties.name,runType:O.configurationProperties.isBackground?"background":"singleRun",group:O.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ue,__task:O};return j==="start"?Pe.resolvedVariables=pe:j==="processStarted"?Pe.processId=pe:j==="processEnded"&&(Pe.exitCode=pe),Object.freeze(Pe)}else return Object.freeze({kind:"changed"})}N.create=H})(L||(e.TaskEvent=L={}));var B;(function(N){function H(O){const ue=Object.keys(O).sort();let pe="";for(const Pe of ue){let _=O[Pe];_ instanceof Object?_=H(_):typeof _=="string"&&(_=_.replace(/,/g,",,")),pe+=Pe+","+_+","}return pe}function j(O){const pe={_key:H(O),type:O.taskType};return Object.assign(pe,O),pe}N.create=j})(B||(e.KeyedTaskIdentifier=B={}));var G;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(G||(e.TaskSettingId=G={}));var q;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var W;(function(N){function H(j,O){const ue=f.$sF.get(j.type);if(ue===void 0){const Y=z.$Dm(j);return delete Y._key,B.create(Y)}const pe=Object.create(null);pe.type=ue.taskType;const Pe=new Set;ue.required.forEach(Y=>Pe.add(Y));const _=ue.properties;for(const Y of Object.keys(_)){const ce=j[Y];if(ce!=null)pe[Y]=ce;else if(Pe.has(Y)){const ke=_[Y];if(ke.default!==void 0)pe[Y]=z.$Dm(ke.default);else switch(ke.type){case"boolean":pe[Y]=!1;break;case"number":case"integer":pe[Y]=0;break;case"string":pe[Y]="";break;default:O.error(g.localize(2,null,JSON.stringify(j,void 0,0),Y));return}}}return B.create(pe)}N.createTaskIdentifier=H})(W||(e.TaskDefinition=W={}))}),define(Re[214],Fe([1,0,9]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uZb=e.$tZb=void 0;class C{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((T,f)=>{this.b=T,this.d=f,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(T){this.f||this.h||(this.f=!0,this.g=T,this.a&&this.b(T))}resolveErr(T){this.f||this.h||(this.h=!0,this.i=T,this.a?this.d(T):(0,g.$X)(T))}then(T,f){return this.j().then(T,f)}catch(T){return this.j().then(void 0,T)}finally(T){return this.j().finally(T)}}e.$tZb=C;class S extends C{constructor(){super(),this.h=!0,this.i=new g.$2}}e.$uZb=S}),define(Re[46],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mz=e.$Lz=e.$Kz=e.$Jz=void 0;class g{constructor(k){this._proxyIdentifierBrand=void 0,this.sid=k,this.nid=++g.count}}e.$Jz=g,g.count=0;const C=[];function S(f){const k=new g(f);return C[k.nid]=k,k}e.$Kz=S;function z(f){return C[f].sid}e.$Lz=z;class T{constructor(k){this.value=k}}e.$Mz=T}),define(Re[4],Fe([1,0,46]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.$$I=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$0I=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(C||(e.TextEditorRevealType=C={}));var S;(function(u){u[u.UnknownInput=0]="UnknownInput",u[u.TextInput=1]="TextInput",u[u.TextDiffInput=2]="TextDiffInput",u[u.TextMergeInput=3]="TextMergeInput",u[u.NotebookInput=4]="NotebookInput",u[u.NotebookDiffInput=5]="NotebookDiffInput",u[u.CustomEditorInput=6]="CustomEditorInput",u[u.WebviewEditorInput=7]="WebviewEditorInput",u[u.TerminalEditorInput=8]="TerminalEditorInput",u[u.InteractiveEditorInput=9]="InteractiveEditorInput"})(S||(e.TabInputKind=S={}));var z;(function(u){u[u.TAB_OPEN=0]="TAB_OPEN",u[u.TAB_CLOSE=1]="TAB_CLOSE",u[u.TAB_UPDATE=2]="TAB_UPDATE",u[u.TAB_MOVE=3]="TAB_MOVE"})(z||(e.TabModelOperationKind=z={}));var T;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var f;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(f||(e.WebviewMessageArrayBufferViewType=f={}));var k;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(k||(e.CellOutputKind=k={}));var m;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var F;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(F||(e.CandidatePortSource=F={}));class D{static mixin(t){return t._id=D.a++,t}}e.$0I=D,D.a=0;var h;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.kindModifier="m",u.commandIdent="n",u.commandId="o",u.commandArguments="p"})(h||(e.ISuggestDataDtoField=h={}));var b;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var $;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$$I={MainThreadAuthentication:(0,g.$Kz)("MainThreadAuthentication"),MainThreadBulkEdits:(0,g.$Kz)("MainThreadBulkEdits"),MainThreadClipboard:(0,g.$Kz)("MainThreadClipboard"),MainThreadCommands:(0,g.$Kz)("MainThreadCommands"),MainThreadComments:(0,g.$Kz)("MainThreadComments"),MainThreadConfiguration:(0,g.$Kz)("MainThreadConfiguration"),MainThreadConsole:(0,g.$Kz)("MainThreadConsole"),MainThreadDebugService:(0,g.$Kz)("MainThreadDebugService"),MainThreadDecorations:(0,g.$Kz)("MainThreadDecorations"),MainThreadDiagnostics:(0,g.$Kz)("MainThreadDiagnostics"),MainThreadDialogs:(0,g.$Kz)("MainThreadDiaglogs"),MainThreadDocuments:(0,g.$Kz)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,g.$Kz)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,g.$Kz)("MainThreadTextEditors"),MainThreadEditorInsets:(0,g.$Kz)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,g.$Kz)("MainThreadEditorTabs"),MainThreadErrors:(0,g.$Kz)("MainThreadErrors"),MainThreadTreeViews:(0,g.$Kz)("MainThreadTreeViews"),MainThreadDownloadService:(0,g.$Kz)("MainThreadDownloadService"),MainThreadKeytar:(0,g.$Kz)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,g.$Kz)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,g.$Kz)("MainThreadLanguages"),MainThreadLogger:(0,g.$Kz)("MainThreadLogger"),MainThreadMessageService:(0,g.$Kz)("MainThreadMessageService"),MainThreadOutputService:(0,g.$Kz)("MainThreadOutputService"),MainThreadProgress:(0,g.$Kz)("MainThreadProgress"),MainThreadQuickDiff:(0,g.$Kz)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,g.$Kz)("MainThreadQuickOpen"),MainThreadStatusBar:(0,g.$Kz)("MainThreadStatusBar"),MainThreadSecretState:(0,g.$Kz)("MainThreadSecretState"),MainThreadStorage:(0,g.$Kz)("MainThreadStorage"),MainThreadTelemetry:(0,g.$Kz)("MainThreadTelemetry"),MainThreadTerminalService:(0,g.$Kz)("MainThreadTerminalService"),MainThreadWebviews:(0,g.$Kz)("MainThreadWebviews"),MainThreadWebviewPanels:(0,g.$Kz)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,g.$Kz)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,g.$Kz)("MainThreadCustomEditors"),MainThreadUrls:(0,g.$Kz)("MainThreadUrls"),MainThreadUriOpeners:(0,g.$Kz)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,g.$Kz)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,g.$Kz)("MainThreadWorkspace"),MainThreadFileSystem:(0,g.$Kz)("MainThreadFileSystem"),MainThreadExtensionService:(0,g.$Kz)("MainThreadExtensionService"),MainThreadSCM:(0,g.$Kz)("MainThreadSCM"),MainThreadSearch:(0,g.$Kz)("MainThreadSearch"),MainThreadShare:(0,g.$Kz)("MainThreadShare"),MainThreadTask:(0,g.$Kz)("MainThreadTask"),MainThreadWindow:(0,g.$Kz)("MainThreadWindow"),MainThreadLabelService:(0,g.$Kz)("MainThreadLabelService"),MainThreadNotebook:(0,g.$Kz)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,g.$Kz)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,g.$Kz)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,g.$Kz)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,g.$Kz)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,g.$Kz)("MainThreadInteractive"),MainThreadChat:(0,g.$Kz)("MainThreadChat"),MainThreadInlineChat:(0,g.$Kz)("MainThreadInlineChatShape"),MainThreadTheming:(0,g.$Kz)("MainThreadTheming"),MainThreadTunnelService:(0,g.$Kz)("MainThreadTunnelService"),MainThreadManagedSockets:(0,g.$Kz)("MainThreadManagedSockets"),MainThreadTimeline:(0,g.$Kz)("MainThreadTimeline"),MainThreadTesting:(0,g.$Kz)("MainThreadTesting"),MainThreadLocalization:(0,g.$Kz)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,g.$Kz)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,g.$Kz)("MainThreadIssueReporter")},e.$_I={ExtHostCommands:(0,g.$Kz)("ExtHostCommands"),ExtHostConfiguration:(0,g.$Kz)("ExtHostConfiguration"),ExtHostDiagnostics:(0,g.$Kz)("ExtHostDiagnostics"),ExtHostDebugService:(0,g.$Kz)("ExtHostDebugService"),ExtHostDecorations:(0,g.$Kz)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,g.$Kz)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,g.$Kz)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,g.$Kz)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,g.$Kz)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,g.$Kz)("ExtHostEditors"),ExtHostTreeViews:(0,g.$Kz)("ExtHostTreeViews"),ExtHostFileSystem:(0,g.$Kz)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,g.$Kz)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,g.$Kz)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,g.$Kz)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,g.$Kz)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,g.$Kz)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,g.$Kz)("ExtHostQuickDiff"),ExtHostStatusBar:(0,g.$Kz)("ExtHostStatusBar"),ExtHostShare:(0,g.$Kz)("ExtHostShare"),ExtHostExtensionService:(0,g.$Kz)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,g.$Kz)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,g.$Kz)("ExtHostTerminalService"),ExtHostSCM:(0,g.$Kz)("ExtHostSCM"),ExtHostSearch:(0,g.$Kz)("ExtHostSearch"),ExtHostTask:(0,g.$Kz)("ExtHostTask"),ExtHostWorkspace:(0,g.$Kz)("ExtHostWorkspace"),ExtHostWindow:(0,g.$Kz)("ExtHostWindow"),ExtHostWebviews:(0,g.$Kz)("ExtHostWebviews"),ExtHostWebviewPanels:(0,g.$Kz)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,g.$Kz)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,g.$Kz)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,g.$Kz)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,g.$Kz)("ExtHostEditorTabs"),ExtHostProgress:(0,g.$Kz)("ExtHostProgress"),ExtHostComments:(0,g.$Kz)("ExtHostComments"),ExtHostSecretState:(0,g.$Kz)("ExtHostSecretState"),ExtHostStorage:(0,g.$Kz)("ExtHostStorage"),ExtHostUrls:(0,g.$Kz)("ExtHostUrls"),ExtHostUriOpeners:(0,g.$Kz)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,g.$Kz)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,g.$Kz)("ExtHostOutputService"),ExtHosLabelService:(0,g.$Kz)("ExtHostLabelService"),ExtHostNotebook:(0,g.$Kz)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,g.$Kz)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,g.$Kz)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,g.$Kz)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,g.$Kz)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,g.$Kz)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,g.$Kz)("ExtHostInteractive"),ExtHostInlineChat:(0,g.$Kz)("ExtHostInlineChatShape"),ExtHostChat:(0,g.$Kz)("ExtHostChat"),ExtHostSemanticSimilarity:(0,g.$Kz)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,g.$Kz)("ExtHostTheming"),ExtHostTunnelService:(0,g.$Kz)("ExtHostTunnelService"),ExtHostManagedSockets:(0,g.$Kz)("ExtHostManagedSockets"),ExtHostAuthentication:(0,g.$Kz)("ExtHostAuthentication"),ExtHostTimeline:(0,g.$Kz)("ExtHostTimeline"),ExtHostTesting:(0,g.$Kz)("ExtHostTesting"),ExtHostTelemetry:(0,g.$Kz)("ExtHostTelemetry"),ExtHostLocalization:(0,g.$Kz)("ExtHostLocalization"),ExtHostIssueReporter:(0,g.$Kz)("ExtHostIssueReporter")}}),define(Re[81],Fe([1,0,3,15,4,17]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V0b=e.$U0b=e.$T0b=void 0,e.$T0b=(0,g.$lh)("IExtHostApiDeprecationService");let T=e.$U0b=class{constructor(k,m){this.c=m,this.a=new Set,this.b=k.getProxy(S.$$I.MainThreadTelemetry)}report(k,m,F){const D=this.d(k,m);this.a.has(D)||(this.a.add(D),m.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${k}' is deprecated. ${F}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:k}))}d(k,m){return`${k}-${m.identifier.value}`}};e.$U0b=T=qe([Ve(0,z.$aL),Ve(1,C.$Ni)],T),e.$V0b=Object.freeze(new class{report(f,k,m){}})}),define(Re[215],Fe([1,0,5,4,7,24]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p_b=void 0;class T{constructor(m){this.b=new Map,this.c=[],this.d=new g.$5c,this.onDidChangeSessions=this.d.event,this.f=new f,this.g=new f,this.a=m.getProxy(C.$$I.MainThreadAuthentication)}$setProviders(m){return this.c=m,Promise.resolve()}async getSession(m,F,D,h={}){const b=z.$Dl.toKey(m.identifier),$=[...D].sort().join(" ");return await this.f.getOrCreate(`${b} ${F} ${$}`,async()=>{await this.a.$ensureProvider(F);const u=m.displayName||m.name;return this.a.$getSession(F,D,b,u,h)})}async getSessions(m,F,D){const h=z.$Dl.toKey(m.identifier),b=[...D].sort().join(" ");return await this.g.getOrCreate(`${h} ${b}`,async()=>{await this.a.$ensureProvider(F);const $=m.displayName||m.name;return this.a.$getSessions(F,D,h,$)})}async removeSession(m,F){const D=this.b.get(m);return D?D.provider.removeSession(F):this.a.$removeSession(m,F)}registerAuthenticationProvider(m,F,D,h){if(this.b.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this.b.set(m,{label:F,provider:D,options:h??{supportsMultipleAccounts:!1}}),this.c.find($=>$.id===m)||this.c.push({id:m,label:F});const b=D.onDidChangeSessions($=>{this.a.$sendDidChangeSessions(m,{added:$.added??[],changed:$.changed??[],removed:$.removed??[]})});return this.a.$registerAuthenticationProvider(m,F,h?.supportsMultipleAccounts??!1),new S.$aJ(()=>{b.dispose(),this.b.delete(m);const $=this.c.findIndex(u=>u.id===m);$>-1&&this.c.splice($),this.a.$unregisterAuthenticationProvider(m)})}$createSession(m,F,D){const h=this.b.get(m);if(h)return Promise.resolve(h.provider.createSession(F,D));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,F){const D=this.b.get(m);if(D)return Promise.resolve(D.provider.removeSession(F));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,F){const D=this.b.get(m);if(D)return Promise.resolve(D.provider.getSessions(F));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,F){return this.d.fire({provider:{id:m,label:F}}),Promise.resolve()}}e.$p_b=T;class f{constructor(){this.a=new Map}getOrCreate(m,F){const D=this.a.get(m);if(D)return D;const h=F().finally(()=>this.a.delete(m));return this.a.set(m,h),h}}}),define(Re[216],Fe([1,0,4,17,8]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v_b=void 0;let z=e.$v_b=class{constructor(f,k){this.a=f.getProxy(g.$$I.MainThreadBulkEdits),this.b={getTextDocumentVersion:m=>k.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(f,k,m){const F=S.WorkspaceEdit.from(f,this.b);return this.a.$tryApplyWorkspaceEdit(F,void 0,m?.isRefactoring??!1)}};e.$v_b=z=qe([Ve(0,C.$aL)],z)}),define(Re[217],Fe([1,0,5,67,6,58,10,146,4,8]),function(te,e,g,C,S,z,T,f,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=void 0;class F{constructor(b,$){this.extension=b,this.provider=$,this.handle=F.a++}}F.a=0;class D{constructor(b,$){this.i=$,this.b=new Map,this.d=new Map,this.e=new Map,this.g=new g.$5c,this.onDidPerformUserAction=this.g.event,this.h=b.getProxy(k.$$I.MainThreadChat)}registerChatProvider(b,$,u){const t=new F(b,u);return this.b.set(t.handle,t),this.h.$registerChatProvider(t.handle,$),(0,S.$ib)(()=>{this.h.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(b,$){const u=C.Iterable.find(this.e.keys(),t=>this.e.get(t)===b)??0;typeof u=="number"&&this.h.$transferChatSession(u,$)}addChatRequest(b){this.h.$addRequest(b)}sendInteractiveRequestToProvider(b,$){this.h.$sendRequestToProvider(b,$)}async $prepareChat(b,$,u){const t=this.b.get(b);if(!t)return;const r=await t.provider.prepareSession($,u);if(!r)return;const c=D.a++;return this.e.set(c,r),{id:c,requesterUsername:r.requester?.name,requesterAvatarIconUri:r.requester?.icon,responderUsername:r.responder?.name,responderAvatarIconUri:r.responder?.icon,inputPlaceholder:r.inputPlaceholder}}async $resolveRequest(b,$,u,t){const r=this.b.get(b);if(!r)return;const c=this.e.get($);if(!c||!r.provider.resolveRequest)return;const w=await r.provider.resolveRequest(c,u,t);if(w)return{message:typeof w.message=="string"?w.message:m.ChatReplyFollowup.from(w.message)}}async $provideWelcomeMessage(b,$){const u=this.b.get(b);if(!u||!u.provider.provideWelcomeMessage)return;const t=await u.provider.provideWelcomeMessage($);if(t)return t.map(r=>typeof r=="string"?r:r.map(c=>m.ChatReplyFollowup.from(c)))}async $provideFollowups(b,$,u){const t=this.b.get(b);if(!t)return;const r=this.e.get($);return!r||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(r,u))?.map(w=>m.ChatFollowup.from(w))}$removeRequest(b,$,u){const t=this.b.get(b);if(!t)return;const r=this.e.get($);r&&t.provider.removeRequest&&t.provider.removeRequest(r,u)}async $provideReply(b,$,u,t){const r=this.b.get(b);if(!r)return;const c=this.e.get($);if(!c)return;const w={session:c,message:typeof u.message=="string"?u.message:m.ChatReplyFollowup.to(u.message)},v=z.$1c.create(!1);let y;const i={report:s=>{if(t.isCancellationRequested)return;typeof y>"u"&&(y=v.elapsed());const p="responseId"in s?{requestId:s.responseId}:s;this.h.$acceptResponseProgress(b,$,p)}};let l;try{l=await r.provider.provideResponseWithProgress(w,i,t),l||(l={errorDetails:{message:(0,f.localize)(0,null)}})}catch(s){l={errorDetails:{message:(0,f.localize)(1,null,s.message),responseIsIncomplete:!0}},this.i.error(s)}try{if(c.saveState&&this.e.has($)){const s=c.saveState();this.h.$acceptChatState($,s)}}catch(s){this.i.warn(s)}const n={firstProgress:y??0,totalElapsed:v.elapsed()};return{errorDetails:l.errorDetails,timings:n}}async $provideSlashCommands(b,$,u){const t=this.b.get(b);if(!t)return;const r=this.e.get($);return!r||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(r,u))?.map(w=>({...w,kind:m.CompletionItemKind.from(w.kind)}))}$releaseSession(b){this.e.delete(b)}async $onDidPerformUserAction(b){this.g.fire(b)}registerSlashCommandProvider(b,$,u){const t=new F(b,u);return this.d.set(t.handle,t),this.h.$registerSlashCommandProvider(t.handle,$),(0,S.$ib)(()=>{this.h.$unregisterSlashCommandProvider(t.handle),this.d.delete(t.handle)})}async $provideProviderSlashCommands(b,$){const u=this.d.get(b);return u?(await u.provider.provideSlashCommands($))?.map(r=>({...r,kind:m.CompletionItemKind.from(r.kind)})):void 0}async $resolveSlashCommand(b,$,u){const t=this.d.get(b);if(!t)return;const r=await t.provider.resolveSlashCommand($,u);return(0,T.$ye)(r)}}e.$J_b=D,D.a=0}),define(Re[218],Fe([1,0,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y0b=void 0;class C{constructor(z){const T=z.getProxy(g.$$I.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(f){return T.$writeText(f)}})}}e.$Y0b=C});var Ye=this&&this.__classPrivateFieldSet||function(te,e,g,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Te=this&&this.__classPrivateFieldGet||function(te,e,g,C){if(g==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?C:g==="a"?C.call(te):C?C.value:e.get(te)};define(Re[32],Fe([1,0,10,7,8,23,4,18,15,69,44,272,2,6,3,17,104,25,46,41,58,52,57]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t,r,c,w,v,y,i){"use strict";var l,n,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=void 0;let p=e.$vL=class{constructor(o,L,B){l.set(this,void 0),this.b=new Map,this.c=new Map,n.set(this,void 0),s.set(this,void 0),Ye(this,l,o.getProxy(T.$$I.MainThreadCommands),"f"),this.d=L,Ye(this,s,B,"f"),Ye(this,n,o.getProxy(T.$$I.MainThreadTelemetry),"f"),this.converter=new I(this,G=>{const q=this.c.get(G);return q?.result===A.Void?q:void 0},L),this.f=[{processArgument(G){return(0,m.$Ug)(G)}},{processArgument(G){return(0,z.$Fm)(G,function(q){if(F.$Kr.isIRange(q))return S.Range.to(q);if(D.$Jr.isIPosition(q))return S.Position.to(q);if(F.$Kr.isIRange(q.range)&&h.URI.isUri(q.uri))return S.location.to(q);if(q instanceof r.$Ib)return q.buffer.buffer;if(!Array.isArray(q))return q})}}]}registerArgumentProcessor(o){this.f.push(o)}registerApiCommand(o){const L=this.registerCommand(!1,o.id,async(...B)=>{const G=o.args.map((W,N)=>{if(!W.validate(B[N]))throw new Error(`Invalid argument '${W.name}' when running '${o.id}', received: ${B[N]}`);return W.convert(B[N])}),q=await this.executeCommand(o.internalId,...G);return o.result.convert(q,B,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this.c.set(o.id,o),new C.$aJ(()=>{L.dispose(),this.c.delete(o.id)})}registerCommand(o,L,B,G,q,W){if(this.d.trace("ExtHostCommands#registerCommand",L),!L.trim().length)throw new Error("invalid id");if(this.b.has(L))throw new Error(`command '${L}' already exists`);return this.b.set(L,{callback:B,thisArg:G,description:q,extension:W}),o&&Te(this,l,"f").$registerCommand(L),new C.$aJ(()=>{this.b.delete(L)&&o&&Te(this,l,"f").$unregisterCommand(L)})}executeCommand(o,...L){return this.d.trace("ExtHostCommands#executeCommand",o),this.g(o,L,!0)}async g(o,L,B){if(this.b.has(o))return Te(this,l,"f").$fireCommandActivationEvent(o),this.h(o,L,!1);{let G=!1;const q=(0,z.$Fm)(L,function(W){if(W instanceof C.$bJ)return S.Position.from(W);if(W instanceof C.$cJ)return S.Range.from(W);if(W instanceof C.$mJ)return S.location.from(W);if(C.$yK.isNotebookRange(W))return S.NotebookRange.from(W);if(W instanceof ArrayBuffer)return G=!0,r.$Ib.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return G=!0,r.$Ib.wrap(W);if(W instanceof r.$Ib)return G=!0,W;if(!Array.isArray(W))return W});try{const W=await Te(this,l,"f").$executeCommand(o,G?new c.$Mz(q):q,B);return(0,m.$Ug)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(o,L,!1);throw W}}}async h(o,L,B){const G=this.b.get(o);if(!G)throw new Error("Unknown command");const{callback:q,thisArg:W,description:N}=G;if(N)for(let j=0;j<N.args.length;j++)try{(0,g.$xe)(L[j],N.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${N.args[j].name}' - ${N.args[j].description}`)}const H=v.$1c.create();try{return await q.apply(W,L)}catch(j){if(o===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...L);O&&(o=O.command)}if(this.d.error(j,o,G.extension?.identifier),!B)throw j;if(G.extension?.identifier){const O=Te(this,s,"f").onExtensionError(G.extension.identifier,j);this.d.trace("forwarded error to extension?",O,G.extension?.identifier)}throw new class extends Error{constructor(){super((0,w.$9h)(j)),this.id=o,this.source=G.extension?.displayName??G.extension?.name}}}finally{this.j(G,o,H.elapsed())}}j(o,L,B){o.extension&&Te(this,n,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:new y.$Xn(L),duration:B})}$executeContributedCommand(o,...L){this.d.trace("ExtHostCommands#$executeContributedCommand",o);const B=this.b.get(o);return B?(L=L.map(G=>this.f.reduce((q,W)=>W.processArgument(q,B.extension?.identifier),G)),this.h(o,L,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this.d.trace("ExtHostCommands#getCommands",o),Te(this,l,"f").$getCommands().then(L=>(o&&(L=L.filter(B=>B[0]!=="_")),L))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(const[L,B]of this.b){const{description:G}=B;G&&(o[L]=G)}return Promise.resolve(o)}};l=new WeakMap,n=new WeakMap,s=new WeakMap,e.$vL=p=qe([Ve(0,u.$aL),Ve(1,k.$Ni),Ve(2,i.$uL)],p),e.$wL=(0,$.$lh)("IExtHostCommands");class I{constructor(o,L,B){this.d=o,this.f=L,this.g=B,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(o,L){if(!o)return;const B={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return B;const G=this.f(o.command);if(G)B.id=G.internalId,B.arguments=G.args.map((q,W)=>q.convert(o.arguments&&o.arguments[W]));else if((0,f.$nf)(o.arguments)){const q=`${o.command}/${++this.c}`;this.b.set(q,o),L.add((0,b.$ib)(()=>{this.b.delete(q),this.g.trace("CommandsConverter#DISPOSE",q)})),B.$ident=q,B.id=this.delegatingCommandId,B.arguments=[q],this.g.trace("CommandsConverter#CREATE",o.command,q)}return B}fromInternal(o){return typeof o.$ident=="string"?this.b.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this.b.get(o[0])}h(...o){const L=this.getActualCommand(...o);return this.g.trace("CommandsConverter#EXECUTE",o[0],L?L.command:"MISSING"),L?this.d.executeCommand(L.command,...L.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${o[0]}`)}}e.$xL=I;class d{constructor(o,L,B,G){this.name=o,this.description=L,this.validate=B,this.convert=G}optional(){return new d(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,L){return new d(o??this.name,L??this.description,this.validate,this.convert)}}e.$yL=d,d.Uri=new d("uri","Uri of a text document",a=>h.URI.isUri(a),a=>a),d.Position=new d("position","A position in a text document",a=>C.$bJ.isPosition(a),S.Position.from),d.Range=new d("range","A range in a text document",a=>C.$cJ.isRange(a),S.Range.from),d.Selection=new d("selection","A selection in a text document",a=>C.$dJ.isSelection(a),S.Selection.from),d.Number=new d("number","",a=>typeof a=="number",a=>a),d.String=new d("string","",a=>typeof a=="string",a=>a),d.CallHierarchyItem=new d("item","A call hierarchy item",a=>a instanceof C.$xJ,S.CallHierarchyItem.from),d.TypeHierarchyItem=new d("item","A type hierarchy item",a=>a instanceof C.$SK,S.TypeHierarchyItem.from),d.TestItem=new d("testItem","A VS Code TestItem",a=>a instanceof t.$nL,S.TestItem.from);class A{constructor(o,L){this.description=o,this.convert=L}}e.$zL=A,A.Void=new A("no result",a=>a);class E{constructor(o,L,B,G,q){this.id=o,this.internalId=L,this.description=B,this.args=G,this.result=q}}e.$AL=E}),define(Re[219],Fe([1,0,18,14,2,79,91,31,95,32,8,7]),function(te,e,g,C,S,z,T,f,k,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0b=void 0;const h=[new m.$AL("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$yL.Uri,m.$yL.Position],new m.$zL("A promise that resolves to an array of DocumentHighlight-instances.",$(F.DocumentHighlight.to))),new m.$AL("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$yL.Uri],new m.$zL("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,r)=>{if((0,g.$mf)(t))return;class c extends D.$rJ{static to(v){const y=new c(v.name,F.SymbolKind.to(v.kind),v.containerName||"",new D.$mJ(r[0],F.Range.to(v.range)));return y.detail=v.detail,y.range=y.location.range,y.selectionRange=F.Range.to(v.selectionRange),y.children=v.children?v.children.map(c.to):[],y}}return t.map(c.to)})),new m.$AL("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$yL.Uri,new m.$yL("options","Formatting options",t=>!0,t=>t)],new m.$zL("A promise that resolves to an array of TextEdits.",$(F.TextEdit.to))),new m.$AL("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$yL.Uri,m.$yL.Range,new m.$yL("options","Formatting options",t=>!0,t=>t)],new m.$zL("A promise that resolves to an array of TextEdits.",$(F.TextEdit.to))),new m.$AL("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$yL.Uri,m.$yL.Position,new m.$yL("ch","Trigger character",t=>typeof t=="string",t=>t),new m.$yL("options","Formatting options",t=>!0,t=>t)],new m.$zL("A promise that resolves to an array of TextEdits.",$(F.TextEdit.to))),new m.$AL("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$yL.Uri,m.$yL.Position],new m.$zL("A promise that resolves to an array of Location or LocationLink instances.",u)),new m.$AL("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$yL.Uri,m.$yL.Position],new m.$zL("A promise that resolves to an array of Location or LocationLink instances.",u)),new m.$AL("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$yL.Uri,m.$yL.Position],new m.$zL("A promise that resolves to an array of Location or LocationLink instances.",u)),new m.$AL("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$yL.Uri,m.$yL.Position],new m.$zL("A promise that resolves to an array of Location or LocationLink instances.",u)),new m.$AL("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$yL.Uri,m.$yL.Position],new m.$zL("A promise that resolves to an array of Location-instances.",$(F.location.to))),new m.$AL("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$yL.Uri,m.$yL.Position],new m.$zL("A promise that resolves to an array of Hover-instances.",$(F.Hover.to))),new m.$AL("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$yL.Uri,new m.$yL("position","A position in a text document",t=>Array.isArray(t)&&t.every(r=>D.$bJ.isPosition(r)),t=>t.map(F.Position.from))],new m.$zL("A promise that resolves to an array of ranges.",t=>t.map(r=>{let c;for(const w of r.reverse())c=new D.$wJ(F.Range.to(w),c);return c}))),new m.$AL("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$yL.String.with("query","Search string")],new m.$zL("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(F.WorkspaceSymbol.to))),new m.$AL("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$yL.Uri,m.$yL.Position],new m.$zL("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(F.CallHierarchyItem.to))),new m.$AL("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$yL.CallHierarchyItem],new m.$zL("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(F.CallHierarchyIncomingCall.to))),new m.$AL("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$yL.CallHierarchyItem],new m.$zL("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(F.CallHierarchyOutgoingCall.to))),new m.$AL("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$yL.Uri,m.$yL.Position],new m.$zL("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:F.Range.to(t.range),placeholder:t.text}})),new m.$AL("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$yL.Uri,m.$yL.Position,m.$yL.String.with("newName","The new symbol name")],new m.$zL("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return F.WorkspaceEdit.to(t)}})),new m.$AL("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$yL.Uri,m.$yL.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$zL("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(F.DocumentLink.to))),new m.$AL("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$yL.Uri],new m.$zL("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$qK(t.tokenTypes,t.tokenModifiers)})),new m.$AL("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$yL.Uri],new m.$zL("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const r=(0,T.$d7)(t);if(r.type==="full")return new D.$sK(r.data,void 0)})),new m.$AL("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$yL.Uri,m.$yL.Range.optional()],new m.$zL("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$qK(t.tokenTypes,t.tokenModifiers)})),new m.$AL("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$yL.Uri,m.$yL.Range],new m.$zL("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const r=(0,T.$d7)(t);if(r.type==="full")return new D.$sK(r.data,void 0)})),new m.$AL("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$yL.Uri,m.$yL.Position,m.$yL.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$yL.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$zL("A promise that resolves to a CompletionList-instance.",(t,r,c)=>{if(!t)return new D.$IJ([]);const w=t.suggestions.map(v=>F.CompletionItem.to(v,c));return new D.$IJ(w,t.incomplete)})),new m.$AL("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$yL.Uri,m.$yL.Position,m.$yL.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$zL("A promise that resolves to SignatureHelp.",t=>{if(t)return F.SignatureHelp.to(t)})),new m.$AL("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$yL.Uri,m.$yL.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$zL("A promise that resolves to an array of CodeLens-instances.",(t,r,c)=>$(w=>new D.$AJ(F.Range.to(w.range),w.command&&c.fromInternal(w.command)))(t))),new m.$AL("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$yL.Uri,new m.$yL("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.$cJ.isRange(t),t=>D.$dJ.isSelection(t)?F.Selection.from(t):F.Range.from(t)),m.$yL.String.with("kind","Code action kind to return code actions for").optional(),m.$yL.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$zL("A promise that resolves to an array of Command-instances.",(t,r,c)=>$(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(w.command)}else{const v=new D.$tJ(w.title,w.kind?new D.$uJ(w.kind):void 0);return w.edit&&(v.edit=F.WorkspaceEdit.to(w.edit)),w.command&&(v.command=c.fromInternal(w.command)),v.isPreferred=w.isPreferred,v}})(t))),new m.$AL("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$yL.Uri],new m.$zL("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(r=>new D.$OJ(F.Range.to(r.range),F.Color.to(r.color))):[])),new m.$AL("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$yL("color","The color to show and insert",t=>t instanceof D.$NJ,F.Color.from),new m.$yL("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:F.Range.from(t.range)}))],new m.$zL("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(F.ColorPresentation.to):[])),new m.$AL("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$yL.Uri,m.$yL.Range],new m.$zL("A promise that resolves to an array of Inlay objects",(t,r,c)=>t.map(F.InlayHint.to.bind(void 0,c)))),new m.$AL("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$yL.Uri],new m.$zL("A promise that resolves to an array of FoldingRange objects",(t,r)=>{if(t)return t.map(F.FoldingRange.to)})),new m.$AL("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$zL("A promise that resolves to an array of NotebookContentProvider static info objects.",$(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(r=>F.NotebookExclusiveDocumentPattern.to(r))})))),new m.$AL("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$yL.Uri,m.$yL.Range],new m.$zL("A promise that resolves to an array of InlineValue objects",t=>t.map(F.InlineValue.to))),new m.$AL("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$yL("uriOrString","Uri-instance or string (only http/https)",t=>S.URI.isUri(t)||typeof t=="string"&&(0,k.$wY)(t,C.Schemas.http,C.Schemas.https),t=>t),new m.$yL("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[F.ViewColumn.from(t),void 0]:[F.ViewColumn.from(t.viewColumn),F.TextEditorOpenOptions.from(t)])).optional(),m.$yL.String.with("label","").optional()],m.$zL.Void),new m.$AL("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$yL.Uri.with("resource","Resource to open"),m.$yL.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new m.$yL("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[F.ViewColumn.from(t),void 0]:[F.ViewColumn.from(t.viewColumn),F.TextEditorOpenOptions.from(t)])).optional()],m.$zL.Void),new m.$AL("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$yL.Uri.with("left","Left-hand side resource of the diff editor"),m.$yL.Uri.with("right","Right-hand side resource of the diff editor"),m.$yL.String.with("title","Human readable title for the diff editor").optional(),new m.$yL("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[F.ViewColumn.from(t.viewColumn),F.TextEditorOpenOptions.from(t)]).optional()],m.$zL.Void),new m.$AL("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$yL.Uri,m.$yL.Position],new m.$zL("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(F.TypeHierarchyItem.to))),new m.$AL("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$yL.TypeHierarchyItem],new m.$zL("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(F.TypeHierarchyItem.to))),new m.$AL("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$yL.TypeHierarchyItem],new m.$zL("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(F.TypeHierarchyItem.to))),new m.$AL("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$yL.TestItem],m.$zL.Void),new m.$AL("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$yL.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$zL.Void),new m.$AL("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$yL.String.with("name","The context key name"),new m.$yL("value","The context key value",()=>!0,t=>t)],m.$zL.Void)];class b{static register(r){h.forEach(r.registerApiCommand,r),this.a(r)}static a(r){r.registerCommand(!1,"_validateWhenClauses",f.$si)}}e.$X0b=b;function $(t){return r=>{if(Array.isArray(r))return r.map(t)}}function u(t){if(!Array.isArray(t))return;const r=[];for(const c of t)z.$ms(c)?r.push(F.DefinitionLink.to(c)):r.push(F.location.to(c));return r}}),define(Re[220],Fe([1,0,16,65,5,6,2,79,24,8,7,4,26,10]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z0b=void 0;function $(u,t,r){const c=u.getProxy(D.$$I.MainThreadComments);class w{constructor(){this.b=new Map,this.c=new k.$Fl,t.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const A=this.b.get(d.handle);return A?A.value:d}else if(d&&d.$mid===7){const A=this.b.get(d.commentControlHandle);if(!A)return d;const E=A.getCommentThread(d.commentThreadHandle);return E?E.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const A=this.b.get(d.thread.commentControlHandle);if(!A)return d;const E=A.getCommentThread(d.thread.commentThreadHandle);return E?d.$mid===8?E.value:{thread:E.value,text:d.text}:d}else if(d&&d.$mid===10){const A=this.b.get(d.thread.commentControlHandle);if(!A)return d;const E=A.getCommentThread(d.thread.commentThreadHandle);if(!E)return d;const a=d.commentUniqueId,o=E.getCommentByUniqueId(a);return o||d}else if(d&&d.$mid===11){const A=this.b.get(d.thread.commentControlHandle);if(!A)return d;const E=A.getCommentThread(d.thread.commentThreadHandle);if(!E)return d;const a=d.text,o=d.commentUniqueId,L=E.getCommentByUniqueId(o);return L?(typeof L.body=="string"?L.body=a:L.body=new F.$BJ(a),L):d}return d}})}createCommentController(d,A,E){const a=w.a++,o=new y(d,a,A,E);this.b.set(o.handle,o);const L=this.c.get(d.identifier)||[];return L.push(o),this.c.set(d.identifier,L),o.value}$createCommentThreadTemplate(d,A,E){const a=this.b.get(d);a&&a.$createCommentThreadTemplate(A,E)}async $updateCommentThreadTemplate(d,A,E){const a=this.b.get(d);a&&a.$updateCommentThreadTemplate(A,E)}$deleteCommentThread(d,A){this.b.get(d)?.$deleteCommentThread(A)}$provideCommentingRanges(d,A,E){const a=this.b.get(d);if(!a||!a.commentingRangeProvider)return Promise.resolve(void 0);const o=r.getDocument(T.URI.revive(A));return(0,g.$kg)(async()=>{const L=await a.commentingRangeProvider.provideCommentingRanges(o,E);let B;return Array.isArray(L)?B={ranges:L,fileComments:!1}:L?B={ranges:L.ranges||[],fileComments:L.fileComments||!1}:B=(0,b.$ye)(L),B}).then(L=>{let B;return L&&(B={ranges:L.ranges.map(G=>m.Range.from(G)),fileComments:L.fileComments}),B})}$toggleReaction(d,A,E,a,o){const L=this.b.get(d);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,g.$kg)(()=>{const B=L.getCommentThread(A);if(B){const G=B.getCommentByUniqueId(a.uniqueIdInThread);if(L!==void 0&&G&&L.reactionHandler)return L.reactionHandler(G,n(o))}return Promise.resolve(void 0)})}}w.a=0;class v{set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,A,E,a,o,L,B,G){this.m=A,this.n=E,this.o=a,this.p=o,this.q=L,this.extensionDescription=B,this.r=G,this.handle=v.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new S.$5c,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new z.$lb,this.l.value=new z.$jb,this.n===void 0&&(this.n=`${d}.${this.handle}`),c.$createCommentThread(A,this.handle,this.n,this.o,m.Range.from(this.p),B.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{c.$deleteCommentThread(A,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(W){q.range=W},get comments(){return q.comments},set comments(W){q.comments=W},get collapsibleState(){return q.collapsibleState},set collapsibleState(W){q.collapsibleState=W},get canReply(){return q.canReply},set canReply(W){q.canReply=W},get contextValue(){return q.contextValue},set contextValue(W){q.contextValue=W},get label(){return q.label},set label(W){q.label=W},get state(){return q.state},set state(W){q.state=W},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new z.$jb);const d=E=>Object.prototype.hasOwnProperty.call(this.b,E),A={};d("range")&&(A.range=m.Range.from(this.p)),d("label")&&(A.label=this.label),d("contextValue")&&(A.contextValue=this.contextValue??null),d("comments")&&(A.comments=this.q.map(E=>i(this,E,this.k,this.extensionDescription))),d("collapsibleState")&&(A.collapseState=s(this.g)),d("canReply")&&(A.canReply=this.canReply),d("state")&&(A.state=p(this.h)),d("isTemplate")&&(A.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,A)}getCommentByUniqueId(d){for(const A of this.k){const E=A[0],a=A[1];if(d===a)return E}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}v.a=0,qe([(0,C.$Qg)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class y{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,A,E,a){this.f=d,this.g=A,this.h=E,this.i=a,this.a=new Map,c.$registerCommentController(this.handle,E,a);const o=this;this.value=Object.freeze({id:o.id,label:o.label,get options(){return o.options},set options(L){o.options=L},get commentingRangeProvider(){return o.commentingRangeProvider},set commentingRangeProvider(L){o.commentingRangeProvider=L},get reactionHandler(){return o.reactionHandler},set reactionHandler(L){o.reactionHandler=L},createCommentThread(L,B,G){return o.createCommentThread(L,B,G).value},dispose:()=>{o.dispose()}}),this.e=[],this.e.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(d,A,E){A===void 0&&(0,h.$$E)(this.f,"fileComments");const a=new v(this.id,this.handle,void 0,d,A,E,this.f,!1);return this.a.set(a.handle,a),a}$createCommentThreadTemplate(d,A){const E=new v(this.id,this.handle,void 0,T.URI.revive(d),m.Range.to(A),[],this.f,!0);return E.collapsibleState=f.CommentThreadCollapsibleState.Expanded,this.a.set(E.handle,E),E}$updateCommentThreadTemplate(d,A){const E=this.a.get(d);E&&(E.range=m.Range.to(A))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function i(I,d,A,E){let a=A.get(d);return a||(a=++I.commentHandle,A.set(d,a)),d.state!==void 0&&(0,h.$$E)(E,"commentsDraftState"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:a,body:typeof d.body=="string"?d.body:m.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(o=>l(o)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function l(I){return{label:I.label,iconPath:I.iconPath?m.$_K(I.iconPath):void 0,count:I.count,hasReacted:I.authorHasReacted}}function n(I){return{label:I.label||"",count:I.count||0,iconPath:I.iconPath?T.URI.revive(I.iconPath):"",authorHasReacted:I.hasReacted||!1}}function s(I){if(I!==void 0)switch(I){case F.CommentThreadCollapsibleState.Expanded:return f.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return f.CommentThreadCollapsibleState.Collapsed}return f.CommentThreadCollapsibleState.Collapsed}function p(I){if(I!==void 0)switch(I){case F.CommentThreadState.Unresolved:return f.CommentThreadState.Unresolved;case F.CommentThreadState.Resolved:return f.CommentThreadState.Resolved}return f.CommentThreadState.Unresolved}return new w}e.$Z0b=$}),define(Re[221],Fe([1,0,23,4,27,17]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R_b=void 0;let T=e.$R_b=class{constructor(F,D){this.a=F.getProxy(C.$$I.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(F,D){const h=this,b=console[F];Object.defineProperty(console,F,{set:()=>{},get:()=>function(){h.e(F,D,b,arguments)}})}e(F,D,h,b){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:k(b,this.b)}),this.c&&this.f(F,h,b)}};e.$R_b=T=qe([Ve(0,z.$aL),Ve(1,S.$qL)],T);const f=1e5;function k(m,F){const D=[];if(m.length)for(let h=0;h<m.length;h++){let b=m[h];if(typeof b>"u")b="undefined";else if(b instanceof Error){const $=b;$.stack?b=$.stack:b=$.toString()}D.push(b)}if(F){const h=new Error().stack;h&&D.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,g.$Im)(D);return h.length>f?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(Re[107],Fe([1,0,2,4,7,3,17,15,18,13,19,26]),function(te,e,g,C,S,z,T,f,k,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=e.$1$b=void 0;let h=e.$1$b=class on{constructor($,u){this.h=u,this.f=new Map,this.g=$.getProxy(C.$$I.MainThreadDecorations)}registerFileDecorationProvider($,u){const t=on.c++;this.f.set(t,{provider:$,extensionDescription:u}),this.g.$registerDecorationProvider(t,u.identifier.value);const r=$.onDidChangeFileDecorations&&$.onDidChangeFileDecorations(c=>{if(!c){this.g.$onDidChange(t,null);return}const w=(0,k.$Gf)(c);if(w.length<=on.d){this.g.$onDidChange(t,w);return}this.h.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,w.length);const v=w.map(l=>({uri:l,rank:(0,m.$md)(l.path,"/")})),y=(0,k.$ef)(v,(l,n)=>l.rank-n.rank||(0,m.$Cd)(l.uri.path,n.uri.path)),i=[];e:for(const l of y){let n;for(const s of l){const p=(0,F.$bc)(s.uri.path);if(n!==p&&(n=p,i.push(s.uri)>=on.d))break e}}this.g.$onDidChange(t,i)});return new S.$aJ(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations($,u,t){if(!this.f.has($))return Object.create(null);const r=Object.create(null),{provider:c,extensionDescription:w}=this.f.get($);return await Promise.all(u.map(async v=>{try{const{uri:y,id:i}=v,l=await Promise.resolve(c.provideFileDecoration(g.URI.revive(y),t));if(!l)return;try{S.$wK.validate(l),l.badge&&typeof l.badge!="string"&&(0,D.$$E)(w,"codiconDecoration"),r[i]=[l.propagate,l.tooltip,l.badge,l.color]}catch(n){this.h.warn(`INVALID decoration from extension '${w}': ${n}`)}}catch(y){this.h.error(y)}})),r}};h.c=0,h.d=250,e.$1$b=h=qe([Ve(0,T.$aL),Ve(1,f.$Ni)],h),e.$2$b=(0,z.$lh)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(te,e,g,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Te=this&&this.__classPrivateFieldGet||function(te,e,g,C){if(g==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?C:g==="a"?C.call(te):C?C.value:e.get(te)};define(Re[222],Fe([1,0,147,94,2,4,7,8,5,15,28,39]),function(te,e,g,C,S,z,T,f,k,m,F,D){"use strict";var h,b,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$S0b=e.$R0b=void 0;class u{constructor(c,w,v,y,i,l,n){this.d=c,this.e=w,this.f=v,this.g=y,h.set(this,void 0),b.set(this,void 0),$.set(this,void 0),this.c=!1,Ye(this,$,new F.$ji(s=>i.getComparisonKey(s)),"f"),Ye(this,h,l,"f"),Ye(this,b,n,"f")}dispose(){this.c||(Te(this,b,"f").fire([...Te(this,$,"f").keys()]),Te(this,h,"f")?.$clear(this.e),Te(this,$,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(c,w){if(!c){this.clear();return}this.h();let v=[];if(S.URI.isUri(c)){if(!w){this.delete(c);return}Te(this,$,"f").set(c,w.slice()),v=[c]}else if(Array.isArray(c)){v=[];let i;c=[...c].sort(u.j);for(const l of c){const[n,s]=l;if((!i||n.toString()!==i.toString())&&(i&&Te(this,$,"f").get(i).length===0&&Te(this,$,"f").delete(i),i=n,v.push(n),Te(this,$,"f").set(n,[])),s)Te(this,$,"f").get(n)?.push(...s);else{const p=Te(this,$,"f").get(n);p&&(p.length=0)}}}if(Te(this,b,"f").fire(v),!Te(this,h,"f"))return;const y=[];for(const i of v){let l=[];const n=Te(this,$,"f").get(i);if(n)if(n.length>this.f){l=[];const s=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(const I of n)if(I.severity===s[p]&&l.push({...f.Diagnostic.from(I),modelVersionId:this.g(i)})===this.f)break e;l.push({severity:C.MarkerSeverity.Info,message:(0,g.localize)(0,null,n.length-this.f),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=n.map(s=>({...f.Diagnostic.from(s),modelVersionId:this.g(i)}));y.push([i,l])}Te(this,h,"f").$changeMany(this.e,y)}delete(c){this.h(),Te(this,b,"f").fire([c]),Te(this,$,"f").delete(c),Te(this,h,"f")?.$changeMany(this.e,[[c,void 0]])}clear(){this.h(),Te(this,b,"f").fire([...Te(this,$,"f").keys()]),Te(this,$,"f").clear(),Te(this,h,"f")?.$clear(this.e)}forEach(c,w){this.h();for(const[v,y]of this)c.call(w,v,y,this)}*[(h=new WeakMap,b=new WeakMap,$=new WeakMap,Symbol.iterator)](){this.h();for(const c of Te(this,$,"f").keys())yield[c,this.get(c)]}get(c){this.h();const w=Te(this,$,"f").get(c);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(c){return this.h(),Array.isArray(Te(this,$,"f").get(c))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(c,w){return c[0].toString()<w[0].toString()?-1:c[0].toString()>w[0].toString()?1:0}}e.$R0b=u;let t=e.$S0b=class wi{static _mapper(c){const w=new F.$ji;for(const v of c)w.set(v,v);return{uris:Object.freeze(Array.from(w.values()))}}constructor(c,w,v,y){this.h=w,this.j=v,this.k=y,this.f=new Map,this.g=new k.$9c({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=k.Event.map(this.g.event,wi._mapper),this.e=c.getProxy(z.$$I.MainThreadDiagnostics)}createDiagnosticCollection(c,w){const{f:v,e:y,g:i,h:l,j:n,k:s}=this,p=new class{$changeMany(A,E){y.$changeMany(A,E),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,A,E.length===0?"CLEARING":E)}$clear(A){y.$clear(A),l.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,A)}dispose(){y.dispose()}};let I;if(!w)w="_generated_diagnostic_collection_name_#"+wi.c++,I=w;else if(!v.has(w))I=w;else{this.h.warn(`DiagnosticCollection with name '${w}' does already exist.`);do I=w+wi.c++;while(v.has(I))}return new class extends u{constructor(){super(w,I,wi.d,A=>s.getDocument(A)?.version,n.extUri,p,i),v.set(I,this)}dispose(){super.dispose(),v.delete(I)}}}getDiagnostics(c){if(c)return this.l(c);{const w=new Map,v=[];for(const y of this.f.values())y.forEach((i,l)=>{let n=w.get(i.toString());typeof n>"u"&&(n=v.length,w.set(i.toString(),n),v.push([i,[]])),v[n][1]=v[n][1].concat(...l)});return v}}l(c){let w=[];for(const v of this.f.values())v.has(c)&&(w=w.concat(v.get(c)));return w}$acceptMarkersChange(c){if(!this.m){const w="_generated_mirror",v=new u(w,w,wi.d,y=>{},this.j.extUri,void 0,this.g);this.f.set(w,v),this.m=v}for(const[w,v]of c)this.m.set(S.URI.revive(w),v.map(f.Diagnostic.to))}};t.c=0,t.d=1e3,e.$S0b=t=qe([Ve(1,m.$Ni),Ve(2,D.$Q0b)],t)}),define(Re[223],Fe([1,0,2,4,26]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$80b=void 0;class z{constructor(f){this.a=f.getProxy(C.$$I.MainThreadDialogs)}showOpenDialog(f,k){return k?.allowUIResources&&(0,S.$$E)(f,"showLocal"),this.a.$showOpenDialog(k).then(m=>m?m.map(F=>g.URI.revive(F)):void 0)}showSaveDialog(f){return this.a.$showSaveDialog(f).then(k=>k?g.URI.revive(k):void 0)}}e.$80b=z}),define(Re[224],Fe([1,0,9,2,7,4,14,22,13]),function(te,e,g,C,S,z,T,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$90b=void 0;class m{constructor(D,h,b){this.d=h,this.e=b,this.b=new Map,this.c=D.getProxy(z.$$I.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,h){if(Object.keys(T.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=m.a++;this.b.set(b,h),this.c.$registerTextContentProvider(b,D);let $;return typeof h.onDidChange=="function"&&($=h.onDidChange(u=>{if(u.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this.d.getDocument(u)&&this.$provideTextDocumentContent(b,u).then(t=>{if(!t&&typeof t!="string")return;const r=this.d.getDocument(u);if(!r)return;const c=(0,k.$xd)(t);if(!r.equalLines(c))return this.c.$onVirtualDocumentChange(u,t)},g.$X)})),new S.$aJ(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(D,h){const b=this.b.get(D);return b?Promise.resolve(b.provideTextDocumentContent(C.URI.revive(h),f.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}e.$90b=m,m.a=0}),define(Re[225],Fe([1,0,5,6,2,4,100,8,10,23,7,9]),function(te,e,g,C,S,z,T,f,k,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O0b=void 0;class h{constructor($,u){this.a=new g.$5c({onListenerError:D.$Y}),this.b=new g.$5c({onListenerError:D.$Y}),this.c=new g.$5c({onListenerError:D.$Y}),this.d=new g.$5c({onListenerError:D.$Y}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new C.$jb,this.h=new Map,this.f=$.getProxy(z.$$I.MainThreadDocuments),this.g=u,this.g.onDidRemoveDocuments(t=>{for(const r of t)this.b.fire(r.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const r of t)this.a.fire(r.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const u=this.g.getDocument($);if(u)return u}getDocument($){const u=this.getDocumentData($);if(!u?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return u.document}ensureDocumentData($){const u=this.g.getDocument($);if(u)return Promise.resolve(u);let t=this.h.get($.toString());return t||(t=this.f.$tryOpenDocument($).then(r=>{this.h.delete($.toString());const c=S.URI.revive(r);return(0,k.$re)(this.g.getDocument(c))},r=>(this.h.delete($.toString()),Promise.reject(r))),this.h.set($.toString(),t)),t}createDocumentData($){return this.f.$tryCreateDocument($).then(u=>S.URI.revive(u))}$acceptModelLanguageChanged($,u){const t=S.URI.revive($),r=this.g.getDocument(t);if(!r)throw new Error("unknown document");this.b.fire(r.document),r._acceptLanguageId(u),this.a.fire(r.document)}$acceptModelSaved($){const u=S.URI.revive($),t=this.g.getDocument(u);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(t.document)}$acceptDirtyStateChanged($,u){const t=S.URI.revive($),r=this.g.getDocument(t);if(!r)throw new Error("unknown document");r._acceptIsDirty(u),this.c.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,u,t){const r=S.URI.revive($),c=this.g.getDocument(r);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(u);let w;u.isUndoing?w=F.TextDocumentChangeReason.Undo:u.isRedoing&&(w=F.TextDocumentChangeReason.Redo),this.c.fire((0,m.$Em)({document:c.document,contentChanges:u.changes.map(v=>({range:f.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text})),reason:w}))}setWordDefinitionFor($,u){(0,T.$cL)($,u)}}e.$O0b=h}),define(Re[59],Fe([1,0,49,5,6,2,3,4,100,17,105,8,15,28,14,67,66]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lL=e.$kL=void 0;class r{constructor(v){this.value=v,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=e.$kL=class{constructor(v,y){this.h=v,this.i=y,this.a=null,this.b=new Map,this.c=new b.$ji,this.d=new C.$5c,this.e=new C.$5c,this.f=new C.$5c,this.g=new C.$5c,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(v){this.acceptDocumentsAndEditorsDelta(v)}acceptDocumentsAndEditorsDelta(v){const y=[],i=[],l=[];if(v.removedDocuments)for(const n of v.removedDocuments){const s=z.URI.revive(n),p=this.c.get(s);p?.unref()&&(this.c.delete(s),y.push(p.value))}if(v.addedDocuments)for(const n of v.addedDocuments){const s=z.URI.revive(n.uri);let p=this.c.get(s);if(p&&s.scheme!==$.Schemas.vscodeNotebookCell&&s.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);p||(p=new r(new k.$dL(this.h.getProxy(f.$$I.MainThreadDocuments),s,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(s,p),i.push(p.value)),p.ref()}if(v.removedEditors)for(const n of v.removedEditors){const s=this.b.get(n);this.b.delete(n),s&&l.push(s)}if(v.addedEditors)for(const n of v.addedEditors){const s=z.URI.revive(n.documentUri);g.ok(this.c.has(s),`document '${s}' does not exist`),g.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const p=this.c.get(s).value,I=new F.$jL(n.id,this.h.getProxy(f.$$I.MainThreadTextEditors),this.i,new t.$S(()=>p.document),n.selections.map(D.Selection.to),n.options,n.visibleRanges.map(d=>D.Range.to(d)),typeof n.editorPosition=="number"?D.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,I)}v.newActiveEditor!==void 0&&(g.ok(v.newActiveEditor===null||this.b.has(v.newActiveEditor),`active editor '${v.newActiveEditor}' does not exist`),this.a=v.newActiveEditor),(0,S.$fb)(y),(0,S.$fb)(l),v.removedDocuments&&this.e.fire(y),v.addedDocuments&&this.d.fire(i),(v.removedEditors||v.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),v.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(v){return this.c.get(v)?.value}allDocuments(){return u.Iterable.map(this.c.values(),v=>v.value)}getEditor(v){return this.b.get(v)}activeEditor(v){if(!this.a)return;const y=this.b.get(this.a);return v?y:y?.value}allEditors(){return[...this.b.values()]}};e.$kL=c=qe([Ve(0,m.$aL),Ve(1,h.$Ni)],c),e.$lL=(0,T.$lh)("IExtHostDocumentsAndEditors")}),define(Re[60],Fe([1,0,8,4,2,5,3,7,17,10,64]),function(te,e,g,C,S,z,T,f,k,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7$b=e.$6$b=void 0,e.$6$b=(0,T.$lh)("IExtHostEditorTabs");class D{constructor(t,r,c){this.e=c,this.d=r,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,r={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new f.$TK(S.URI.revive(this.b.input.uri));case 2:return new f.$UK(S.URI.revive(this.b.input.original),S.URI.revive(this.b.input.modified));case 3:return new f.$VK(S.URI.revive(this.b.input.base),S.URI.revive(this.b.input.input1),S.URI.revive(this.b.input.input2),S.URI.revive(this.b.input.result));case 6:return new f.$WK(S.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new f.$XK(this.b.input.viewType);case 4:return new f.$YK(S.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new f.$ZK(S.URI.revive(this.b.input.original),S.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new f.$1K;case 9:return new f.$2K(S.URI.revive(this.b.input.uri),S.URI.revive(this.b.input.inputBoxUri));default:return}}}class h{constructor(t,r){this.c=[],this.d="",this.b=t,this.e=r;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new D(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,r={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return g.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const r=this.c.find(c=>c.tabId===t.tabDto.id);if(!r)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(t.tabDto),r}activeTabId(){return this.d}}let b=e.$7$b=class{constructor(t){this.b=new z.$5c,this.c=new z.$5c,this.e=[],this.a=t.getProxy(C.$$I.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,r={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,m.$re)(t.e.find(v=>v.groupId===c)?.apiObject)},close:async(c,w)=>{const v=Array.isArray(c)?c:[c];return v.length?$(v[0])?this.j(v,w):this.i(v,w):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(t){const r=new Set(this.e.map(n=>n.groupId)),c=new Set(t.map(n=>n.groupId)),w=(0,F.$J)(r,c),v=this.e.filter(n=>w.removed.includes(n.groupId)).map(n=>n.apiObject),y=[],i=[];this.e=t.map(n=>{const s=new h(n,()=>this.d);return w.added.includes(s.groupId)?y.push(s.apiObject):i.push(s.apiObject),s});const l=(0,m.$re)(t.find(n=>n.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:y,closed:v,changed:i}))}$acceptTabGroupUpdate(t){const r=this.e.find(c=>c.groupId===t.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const r=this.e.find(w=>w.groupId===t.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const c=r.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const r of this.e)for(const c of r.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(r=>r.apiObject===t)}async i(t,r){const c=[];for(const w of t){const v=this.g(w);if(!v)throw new Error("Tab close: Invalid tab not found!");c.push(v.tabId)}return this.a.$closeTab(c,r)}async j(t,r){const c=[];for(const w of t){const v=this.h(w);if(!v)throw new Error("Group close: Invalid group not found!");c.push(v.groupId)}return this.a.$closeGroup(c,r)}};e.$7$b=b=qe([Ve(0,k.$aL)],b);function $(u){return u.tabs!==void 0}}),define(Re[226],Fe([1,0,2,4,6,7,8,273,13,25,26,70]),function(te,e,g,C,S,z,T,f,k,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$b=void 0;class h{constructor(){this.a=[]}add(u){this.b=void 0,this.a.push(u)}delete(u){const t=this.a.indexOf(u);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const u=this.a.sort(),t=[];let r,c,w=14,v=14;for(const y of u){let i=r?(0,k.$Ld)(r,y):0;for(i===0?c=1:c=v;i<y.length;i++)i+1===y.length?(w=v,v=9):v+=1,t.push([c,y.toUpperCase().charCodeAt(i),v]),t.push([c,y.toLowerCase().charCodeAt(i),v]),c=v;r=y,v=w}t.push([9,58,10]),t.push([10,47,12]),this.b=new f.$xW(t)}}provideDocumentLinks(u){this.c();const t=[],r=f.$yW.computeLinks({getLineContent(c){return u.lineAt(c-1).text},getLineCount(){return u.lineCount}},this.b);for(const c of r){const w=T.DocumentLink.to(c);w.target&&t.push(w)}return t}}class b{constructor(u,t){this.i=t,this.b=new h,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=u.getProxy(C.$$I.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(u,t,r,c={}){if(b.j(r),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(u,"*",this.b));const w=this.h++;this.b.add(t),this.d.add(t),this.c.set(w,r);let v=2;c.isCaseSensitive&&(v+=1024),c.isReadonly&&(v+=2048),typeof r.copy=="function"&&(v+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,F.$$E)(u,"fsChunks"),v+=4);let y;c.isReadonly&&(0,D.$Ij)(c.isReadonly)&&((0,F.$$E)(u,"readonlyMessage"),y={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(w,t,v,y).catch(l=>{console.error(`FAILED to register filesystem provider of ${u.identifier.value}-extension for the scheme ${t}`),console.error(l)});const i=r.onDidChangeFile(l=>{const n=[];for(const s of l){const{uri:p,type:I}=s;if(p.scheme!==t)continue;let d;switch(I){case z.FileChangeType.Changed:d=0;break;case z.FileChangeType.Created:d=1;break;case z.FileChangeType.Deleted:d=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:p,type:d})}this.a.$onFileSystemChange(w,n)});return(0,S.$ib)(()=>{i.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(w),this.a.$unregisterProvider(w)})}static j(u){if(!u)throw new Error("MISSING provider");if(typeof u.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof u.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof u.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof u.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof u.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof u.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof u.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof u.rename!="function")throw new Error("Provider does NOT implement rename")}static k(u){const{type:t,ctime:r,mtime:c,size:w,permissions:v}=u;return{type:t,ctime:r,mtime:c,size:w,permissions:v}}$stat(u,t){return Promise.resolve(this.l(u).stat(g.URI.revive(t))).then(r=>b.k(r))}$readdir(u,t){return Promise.resolve(this.l(u).readDirectory(g.URI.revive(t)))}$readFile(u,t){return Promise.resolve(this.l(u).readFile(g.URI.revive(t))).then(r=>m.$Ib.wrap(r))}$writeFile(u,t,r,c){return Promise.resolve(this.l(u).writeFile(g.URI.revive(t),r.buffer,c))}$delete(u,t,r){return Promise.resolve(this.l(u).delete(g.URI.revive(t),r))}$rename(u,t,r,c){return Promise.resolve(this.l(u).rename(g.URI.revive(t),g.URI.revive(r),c))}$copy(u,t,r,c){const w=this.l(u);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(g.URI.revive(t),g.URI.revive(r),c))}$mkdir(u,t){return Promise.resolve(this.l(u).createDirectory(g.URI.revive(t)))}$watch(u,t,r,c){const w=this.l(u).watch(g.URI.revive(r),c);this.f.set(t,w)}$unwatch(u,t){const r=this.f.get(t);r&&(r.dispose(),this.f.delete(t))}$open(u,t,r){const c=this.l(u);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(g.URI.revive(t),r))}$close(u,t){const r=this.l(u);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(t))}$read(u,t,r,c){const w=this.l(u);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const v=m.$Ib.alloc(c);return Promise.resolve(w.read(t,r,v.buffer,0,c)).then(y=>v.slice(0,y))}$write(u,t,r,c){const w=this.l(u);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(t,r,c.buffer,0,c.byteLength))}l(u){const t=this.c.get(u);if(!t){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return t}}e.$C$b=b}),define(Re[61],Fe([1,0,4,38,7,25,3,17,39,6,16,20,14]),function(te,e,g,C,S,z,T,f,k,m,F,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j$b=e.$i$b=void 0;let b=e.$i$b=class ii{constructor(u,t){this.b=new Map,this.c=new F.$zg,this.a=u.getProxy(g.$$I.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(c){try{let w;const v=r.b.get(c.scheme);return v?(await r.a.$ensureActivation(c.scheme),w=await v.impl.stat(c)):w=await r.a.$stat(c),{type:w.type,ctime:w.ctime,mtime:w.mtime,size:w.size,permissions:w.permissions===C.FilePermission.Readonly?1:void 0}}catch(w){ii.e(w)}},async readDirectory(c){try{const w=r.b.get(c.scheme);return w?(await r.a.$ensureActivation(c.scheme),(await w.impl.readDirectory(c)).slice()):await r.a.$readdir(c)}catch(w){return ii.e(w)}},async createDirectory(c){try{const w=r.b.get(c.scheme);return w&&!w.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(w.impl,w.extUri,c)):await r.a.$mkdir(c)}catch(w){return ii.e(w)}},async readFile(c){try{const w=r.b.get(c.scheme);return w?(await r.a.$ensureActivation(c.scheme),(await w.impl.readFile(c)).slice()):(await r.a.$readFile(c)).buffer}catch(w){return ii.e(w)}},async writeFile(c,w){try{const v=r.b.get(c.scheme);return v&&!v.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(v.impl,v.extUri,v.extUri.dirname(c)),await r.c.queueFor(c).queue(()=>Promise.resolve(v.impl.writeFile(c,w,{create:!0,overwrite:!0})))):await r.a.$writeFile(c,z.$Ib.wrap(w))}catch(v){return ii.e(v)}},async delete(c,w){try{const v=r.b.get(c.scheme);return v&&!v.isReadonly?(await r.a.$ensureActivation(c.scheme),await v.impl.delete(c,{recursive:!1,...w})):await r.a.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...w})}catch(v){return ii.e(v)}},async rename(c,w,v){try{return await r.a.$rename(c,w,{overwrite:!1,...v})}catch(y){return ii.e(y)}},async copy(c,w,v){try{return await r.a.$copy(c,w,{overwrite:!1,...v})}catch(y){return ii.e(y)}},isWritableFileSystem(c){const w=t.getCapabilities(c);if(typeof w=="number")return!(w&2048)}})}async d(u,t,r){const c=[];for(;!t.isEqual(r,t.dirname(r));)try{if(!((await u.stat(r)).type&C.FileType.Directory))throw S.$oK.FileExists(`Unable to create folder '${r.scheme===h.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(w){if(C.$4j(w)!==C.FileSystemProviderErrorCode.FileNotFound)throw w;c.push(t.basename(r)),r=t.dirname(r)}for(let w=c.length-1;w>=0;w--){r=t.joinPath(r,c[w]);try{await u.createDirectory(r)}catch(v){if(C.$4j(v)!==C.FileSystemProviderErrorCode.FileExists)throw v}}}static e(u){if(u instanceof S.$oK)throw u;if(u instanceof C.$Zj)switch(u.code){case C.FileSystemProviderErrorCode.FileExists:throw S.$oK.FileExists(u.message);case C.FileSystemProviderErrorCode.FileNotFound:throw S.$oK.FileNotFound(u.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw S.$oK.FileNotADirectory(u.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw S.$oK.FileIsADirectory(u.message);case C.FileSystemProviderErrorCode.NoPermissions:throw S.$oK.NoPermissions(u.message);case C.FileSystemProviderErrorCode.Unavailable:throw S.$oK.Unavailable(u.message);default:throw new S.$oK(u.message,u.name)}if(!(u instanceof Error))throw new S.$oK(String(u));if(u.name==="ENOPRO"||u.message.includes("ENOPRO"))throw S.$oK.Unavailable(u.message);switch(u.name){case C.FileSystemProviderErrorCode.FileExists:throw S.$oK.FileExists(u.message);case C.FileSystemProviderErrorCode.FileNotFound:throw S.$oK.FileNotFound(u.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw S.$oK.FileNotADirectory(u.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw S.$oK.FileIsADirectory(u.message);case C.FileSystemProviderErrorCode.NoPermissions:throw S.$oK.NoPermissions(u.message);case C.FileSystemProviderErrorCode.Unavailable:throw S.$oK.Unavailable(u.message);default:throw new S.$oK(u.message,u.name)}}addFileSystemProvider(u,t,r){return this.b.set(u,{impl:t,extUri:r?.isCaseSensitive?D.$Vf:D.$Xf,isReadonly:!!r?.isReadonly}),(0,m.$ib)(()=>this.b.delete(u))}};e.$i$b=b=qe([Ve(0,f.$aL),Ve(1,k.$Q0b)],b),e.$j$b=(0,T.$lh)("IExtHostConsumerFileSystem")}),define(Re[227],Fe([1,0,5,37,2,4,8,7]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D$b=void 0;class k{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(D,h,b,$,u,t,r,c){this.a=new g.$5c,this.b=new g.$5c,this.c=new g.$5c;const w=this.h(D,b,u);this.g=0,t&&(this.g+=1),r&&(this.g+=2),c&&(this.g+=4);const v=(0,C.$aj)(u),y=typeof u=="string",i=$(l=>{if(!t)for(const n of l.created){const s=S.URI.revive(n);v(s.fsPath)&&(!y||h.getWorkspaceFolder(s))&&this.a.fire(s)}if(!r)for(const n of l.changed){const s=S.URI.revive(n);v(s.fsPath)&&(!y||h.getWorkspaceFolder(s))&&this.b.fire(s)}if(!c)for(const n of l.deleted){const s=S.URI.revive(n);v(s.fsPath)&&(!y||h.getWorkspaceFolder(s))&&this.c.fire(s)}});this.d=f.$aJ.from(w,this.a,this.b,this.c,i)}h(D,h,b){const $=f.$aJ.from();if(typeof b=="string")return $;const u=D.getProxy(z.$$I.MainThreadFileSystem);let t=!1;(b.pattern.includes(C.$9i)||b.pattern.includes(C.$0i))&&(t=!0);const r=Math.random();return u.$watch(h.identifier.value,r,b.baseUri,{recursive:t,excludes:[]}),f.$aJ.from({dispose:()=>u.$unwatch(r)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class m{constructor(D,h,b){this.j=D,this.k=h,this.l=b,this.a=new g.$5c,this.b=new g.$5c,this.c=new g.$5c,this.d=new g.$5c,this.g=new g.$7c,this.h=new g.$7c,this.i=new g.$7c,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,h,b,$,u,t){return new k(this.j,D,h,this.a.event,T.GlobPattern.from(b),$,u,t)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,h){switch(D){case 2:this.b.fire(Object.freeze({files:h.map(b=>({oldUri:S.URI.revive(b.source),newUri:S.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:h.map(b=>S.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:h.map(b=>S.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,h){return(b,$,u)=>{const t=function(c){b.call($,c)};return t.extension=D,h.event(t,void 0,u)}}async $onWillRunFileOperation(D,h,b,$){switch(D){case 2:return await this.n(this.g,{files:h.map(u=>({oldUri:S.URI.revive(u.source),newUri:S.URI.revive(u.target)}))},b,$);case 1:return await this.n(this.i,{files:h.map(u=>S.URI.revive(u.target))},b,$);case 0:case 3:return await this.n(this.h,{files:h.map(u=>S.URI.revive(u.target))},b,$)}}async n(D,h,b,$){const u=new Set,t=[];if(await D.fireAsync(h,$,async(c,w)=>{const v=Date.now(),y=await Promise.resolve(c);y instanceof f.$kJ&&(t.push([w.extension,y]),u.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-v>b&&this.k.warn("SLOW file-participant",w.extension.identifier)}),$.isCancellationRequested||t.length===0)return;const r={edits:[]};for(const[,c]of t){const{edits:w}=T.WorkspaceEdit.from(c,{getTextDocumentVersion:v=>this.l.getDocument(v)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(w)}return{edit:r,extensionNames:Array.from(u)}}}e.$D$b=m}),define(Re[228],Fe([1,0,6,2,4,8,7,32]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K_b=void 0;class k{constructor(h,b){this.extension=h,this.provider=b,this.handle=k.a++}}k.a=0;class m{constructor(h){this.session=h,this.responses=[]}}class F{constructor(h,b,$,u){this.f=$,this.g=u,this.b=new Map,this.d=new Map,this.e=h.getProxy(S.$$I.MainThreadInlineChat),b.registerApiCommand(new f.$AL("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new f.$yL("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?z.Range.from(t.initialRange):void 0,message:t.message,autoSend:t.autoSend}})],f.$zL.Void))}registerProvider(h,b){const $=new k(h,b);return this.b.set($.handle,$),this.e.$registerInteractiveEditorProvider($.handle,h.identifier.value,typeof b.handleInteractiveEditorResponseFeedback=="function"),(0,g.$ib)(()=>{this.e.$unregisterInteractiveEditorProvider($.handle),this.b.delete($.handle)})}async $prepareSession(h,b,$,u){const t=this.b.get(h);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(C.URI.revive(b)),c=z.Selection.to($),w=await t.provider.prepareInteractiveEditorSession({document:r,selection:c},u);if(!w)return;if(w.wholeRange&&!w.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const v=F.a++;return this.d.set(v,new m(w)),{id:v,placeholder:w.placeholder,slashCommands:w.slashCommands?.map(y=>({command:y.command,detail:y.detail,refer:y.refer})),wholeRange:z.Range.from(w.wholeRange),message:w.message}}async $provideResponse(h,b,$,u){const t=this.b.get(h);if(!t)return;const r=this.d.get(b.id);if(!r)return;const c=await t.provider.provideInteractiveEditorResponse({session:r.session,prompt:$.prompt,selection:z.Selection.to($.selection),wholeRange:z.Range.to($.wholeRange),attempt:$.attempt},u);if(c){const w=r.responses.push(c)-1,v={wholeRange:z.Range.from(c.wholeRange),placeholder:c.placeholder};if(F.h(c))return{...v,id:w,type:"message",message:z.MarkdownString.from(c.contents)};const{edits:y}=c;if(y instanceof T.$kJ)return{...v,id:w,type:"bulkEdit",edits:z.WorkspaceEdit.from(y)};if(Array.isArray(y))return{...v,id:w,type:"editorEdit",edits:y.map(z.TextEdit.from)}}}$handleFeedback(h,b,$,u){const t=this.b.get(h),r=this.d.get(b),c=r?.responses[$];if(t&&c){let w;switch(u){case 1:w=T.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:w=T.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:w=T.InteractiveEditorResponseFeedbackKind.Undone;break}t.provider.handleInteractiveEditorResponseFeedback?.(r.session,c,w)}}$releaseSession(h,b){const $=this.d.get(b),u=this.b.get(h);$&&u&&u.provider.releaseInteractiveEditorSession?.($.session),this.d.delete(b)}static h(h){return typeof h=="object"&&typeof h.contents=="object"}}e.$K_b=F,F.a=0}),define(Re[229],Fe([1,0,2,32]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G_b=void 0;class S{constructor(T,f,k,m,F){this.a=f,this.b=k,this.c=m;const D=new C.$AL("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.$yL("showOptions","Show Options",h=>!0,h=>h),new C.$yL("resource","Interactive resource Uri",h=>!0,h=>h),new C.$yL("controllerId","Notebook controller Id",h=>!0,h=>h),new C.$yL("title","Interactive editor title",h=>!0,h=>h)],new C.$zL("Notebook and input URI",h=>{if(F.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const b=this.a.getEditorById(h.notebookEditorId);return F.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:g.URI.revive(h.notebookUri),inputUri:g.URI.revive(h.inputUri),notebookEditor:b.apiEditor}}return F.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:g.URI.revive(h.notebookUri),inputUri:g.URI.revive(h.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(T,f,k,m){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:f,lines:[""],languageId:k,uri:T,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(g.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,f){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.$G_b=S}),define(Re[230],Fe([1,0,4,7]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N_b=void 0;class S{constructor(T){this.a=new Map,this.b=T.getProxy(g.$$I.MainThreadIssueReporter)}async $getIssueReporterUri(T,f){if(this.a.size===0)throw new Error("No issue request handlers registered");const k=this.a.get(T);if(!k)throw new Error("Issue request handler not found");const m=await k.handleIssueUrlRequest();if(!m)throw new Error("Issue request handler returned no result");return m}registerIssueUriRequestHandler(T,f){const k=T.identifier.value;return this.a.set(k,f),this.b.$registerIssueUriRequestHandler(k),new C.$aJ(()=>{this.b.$unregisterIssueUriRequestHandler(k),this.a.delete(k)})}}e.$N_b=S}),define(Re[231],Fe([1,0,6,4]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z$b=void 0;class S{constructor(T){this.b=0,this.a=T.getProxy(C.$$I.MainThreadLabelService)}$registerResourceLabelFormatter(T){const f=this.b++;return this.a.$registerResourceLabelFormatter(f,T),(0,g.$ib)(()=>{this.a.$unregisterResourceLabelFormatter(f)})}}e.$Z$b=S}),define(Re[232],Fe([1,0,2,23,8,7,79,4,13,44,18,10,274,22,6,91,88,54,58,9,16,26,149]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t,r,c,w,v,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W0b=void 0;class l{constructor(P,K){this.d=P,this.e=K}async provideDocumentSymbols(P,K){const V=this.d.getDocument(P),J=await this.e.provideDocumentSymbols(V,K);if(!(0,F.$mf)(J))return J[0]instanceof z.$sJ?J.map(S.DocumentSymbol.from):l.f(J)}static f(P){P=P.slice(0).sort((J,re)=>{let de=J.location.range.start.compareTo(re.location.range.start);return de===0&&(de=re.location.range.end.compareTo(J.location.range.end)),de});const K=[],V=[];for(const J of P){const re={name:J.name||"!!MISSING: name!!",kind:S.SymbolKind.from(J.kind),tags:J.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:S.Range.from(J.location.range),selectionRange:S.Range.from(J.location.range),children:[]};for(;;){if(V.length===0){V.push(re),K.push(re);break}const de=V[V.length-1];if(m.$Kr.containsRange(de.range,re.range)&&!m.$Kr.equalsRange(de.range,re.range)){de.children?.push(re),V.push(re);break}V.pop()}}return K}}class n{constructor(P,K,V){this.g=P,this.h=K,this.j=V,this.e=new r.$N0b("CodeLens"),this.f=new Map}async provideCodeLenses(P,K){const V=this.g.getDocument(P),J=await this.j.provideCodeLenses(V,K);if(!J||K.isCancellationRequested)return;const re=this.e.add(J),de=new $.$jb;this.f.set(re,de);const ie={cacheId:re,lenses:[]};for(let ve=0;ve<J.length;ve++)ie.lenses.push({cacheId:[re,ve],range:S.Range.from(J[ve].range),command:this.h.toInternal(J[ve].command,de)});return ie}async resolveCodeLens(P,K){const V=P.cacheId&&this.e.get(...P.cacheId);if(!V)return;let J;if(typeof this.j.resolveCodeLens!="function"||V.isResolved?J=V:J=await this.j.resolveCodeLens(V,K),J||(J=V),K.isCancellationRequested)return;const re=P.cacheId&&this.f.get(P.cacheId[0]);if(re)return P.command=this.h.toInternal(J.command??n.d,re),P}releaseCodeLenses(P){this.f.get(P)?.dispose(),this.f.delete(P),this.e.delete(P)}}n.d={command:"missing",title:"!!MISSING: command!!"};function s(ee){return Array.isArray(ee)?ee.map(S.DefinitionLink.from):ee?[S.DefinitionLink.from(ee)]:[]}class p{constructor(P,K){this.d=P,this.e=K}async provideDefinition(P,K,V){const J=this.d.getDocument(P),re=S.Position.to(K),de=await this.e.provideDefinition(J,re,V);return s(de)}}class I{constructor(P,K){this.d=P,this.e=K}async provideDeclaration(P,K,V){const J=this.d.getDocument(P),re=S.Position.to(K),de=await this.e.provideDeclaration(J,re,V);return s(de)}}class d{constructor(P,K){this.d=P,this.e=K}async provideImplementation(P,K,V){const J=this.d.getDocument(P),re=S.Position.to(K),de=await this.e.provideImplementation(J,re,V);return s(de)}}class A{constructor(P,K){this.d=P,this.e=K}async provideTypeDefinition(P,K,V){const J=this.d.getDocument(P),re=S.Position.to(K),de=await this.e.provideTypeDefinition(J,re,V);return s(de)}}class E{constructor(P,K){this.d=P,this.e=K}async provideHover(P,K,V){const J=this.d.getDocument(P),re=S.Position.to(K),de=await this.e.provideHover(J,re,V);if(!(!de||(0,F.$mf)(de.contents)))return de.range||(de.range=J.getWordRangeAtPosition(re)),de.range||(de.range=new z.$cJ(re,re)),S.Hover.from(de)}}class a{constructor(P,K){this.d=P,this.e=K}async provideEvaluatableExpression(P,K,V){const J=this.d.getDocument(P),re=S.Position.to(K),de=await this.e.provideEvaluatableExpression(J,re,V);if(de)return S.EvaluatableExpression.from(de)}}class o{constructor(P,K){this.d=P,this.e=K}async provideInlineValues(P,K,V,J){const re=this.d.getDocument(P),de=await this.e.provideInlineValues(re,S.Range.to(K),S.InlineValueContext.to(V),J);if(Array.isArray(de))return de.map(ie=>S.InlineValue.from(ie))}}class L{constructor(P,K){this.d=P,this.e=K}async provideDocumentHighlights(P,K,V){const J=this.d.getDocument(P),re=S.Position.to(K),de=await this.e.provideDocumentHighlights(J,re,V);if(Array.isArray(de))return de.map(S.DocumentHighlight.from)}}class B{constructor(P,K){this.d=P,this.e=K}async provideLinkedEditingRanges(P,K,V){const J=this.d.getDocument(P),re=S.Position.to(K),de=await this.e.provideLinkedEditingRanges(J,re,V);if(de&&Array.isArray(de.ranges))return{ranges:(0,F.$jf)(de.ranges.map(S.Range.from)),wordPattern:de.wordPattern}}}class G{constructor(P,K){this.d=P,this.e=K}async provideReferences(P,K,V,J){const re=this.d.getDocument(P),de=S.Position.to(K),ie=await this.e.provideReferences(re,de,V,J);if(Array.isArray(ie))return ie.map(S.location.from)}}class q{constructor(P,K,V,J,re,de,ie){this.h=P,this.j=K,this.k=V,this.l=J,this.m=re,this.n=de,this.o=ie,this.e=new r.$N0b("CodeAction"),this.f=new Map,this.g=new z.$uJ("notebook")}async provideCodeActions(P,K,V,J){const re=this.h.getDocument(P),de=h.$Sr.isISelection(K)?S.Selection.to(K):S.Range.to(K),ie=[];for(const He of this.k.getDiagnostics(P))if(de.intersection(He.range)&&ie.push(He)>q.d)break;const ve={diagnostics:ie,only:V.only?new z.$uJ(V.only):void 0,triggerKind:S.CodeActionTriggerKind.to(V.trigger)},Ee=await this.l.provideCodeActions(re,de,ve,J);if(!(0,F.$nf)(Ee)||J.isCancellationRequested)return;const Be=this.e.add(Ee),We=new $.$jb;this.f.set(Be,We);const _e=[];for(let He=0;He<Ee.length;He++){const Qe=Ee[He];if(Qe)if(q.p(Qe))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:Qe.title,command:this.j.toInternal(Qe,We)});else{if(ve.triggerKind!==z.CodeActionTriggerKind.Invoke&&Qe.kind&&this.g.contains(Qe.kind))continue;ve.only&&(Qe.kind?ve.only.contains(Qe.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[Be,He],title:Qe.title,command:Qe.command&&this.j.toInternal(Qe.command,We),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(S.Diagnostic.from),edit:Qe.edit&&S.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})}}return{cacheId:Be,actions:_e}}async resolveCodeAction(P,K){const[V,J]=P,re=this.e.get(V,J);if(!re||q.p(re))return{};if(!this.l.resolveCodeAction)return{};const de=await this.l.resolveCodeAction(re,K)??re;let ie;de.edit&&(ie=S.WorkspaceEdit.from(de.edit,void 0));let ve;if(de.command){const Ee=this.f.get(V);Ee&&(ve=this.j.toInternal(de.command,Ee))}return{edit:ie,command:ve}}releaseCodeActions(P){this.f.get(P)?.dispose(),this.f.delete(P),this.e.delete(P)}static p(P){return typeof P.command=="string"&&typeof P.title=="string"}}q.d=1e3;class W{constructor(P,K,V,J,re){this.d=P,this.e=K,this.f=V,this.g=J,this.h=re}async prepareDocumentPaste(P,K,V,J){if(!this.f.prepareDocumentPaste)return;const re=this.e.getDocument(P),de=K.map(Ee=>S.Range.to(Ee)),ie=S.DataTransfer.toDataTransfer(V,()=>{throw new w.$9});if(await this.f.prepareDocumentPaste(re,de,ie,J),J.isCancellationRequested)return;const ve=Array.from(ie).filter(([,Ee])=>!(Ee instanceof z.$2J));return S.DataTransfer.from(ve)}async providePasteEdits(P,K,V,J,re){if(!this.f.provideDocumentPasteEdits)return;const de=this.e.getDocument(K),ie=V.map(Be=>S.Range.to(Be)),ve=S.DataTransfer.toDataTransfer(J,async Be=>(await this.d.$resolvePasteFileData(this.g,P,Be)).buffer),Ee=await this.f.provideDocumentPasteEdits(de,ie,ve,re);if(Ee)return{id:Ee.id?this.h.identifier.value+"."+Ee.id:this.h.identifier.value,label:Ee.label??(0,i.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,priority:Ee.priority??0,insertText:typeof Ee.insertText=="string"?Ee.insertText:{snippet:Ee.insertText.value},additionalEdit:Ee.additionalEdit?S.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}}class N{constructor(P,K){this.d=P,this.e=K}async provideDocumentFormattingEdits(P,K,V){const J=this.d.getDocument(P),re=await this.e.provideDocumentFormattingEdits(J,K,V);if(Array.isArray(re))return re.map(S.TextEdit.from)}}class H{constructor(P,K){this.d=P,this.e=K}async provideDocumentRangeFormattingEdits(P,K,V,J){const re=this.d.getDocument(P),de=S.Range.to(K),ie=await this.e.provideDocumentRangeFormattingEdits(re,de,V,J);if(Array.isArray(ie))return ie.map(S.TextEdit.from)}async provideDocumentRangesFormattingEdits(P,K,V,J){(0,D.$qe)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const re=this.d.getDocument(P),de=K.map(S.Range.to),ie=await this.e.provideDocumentRangesFormattingEdits(re,de,V,J);if(Array.isArray(ie))return ie.map(S.TextEdit.from)}}class j{constructor(P,K){this.d=P,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(P,K,V,J,re){const de=this.d.getDocument(P),ie=S.Position.to(K),ve=await this.e.provideOnTypeFormattingEdits(de,ie,V,J,re);if(Array.isArray(ve))return ve.map(S.TextEdit.from)}}class O{constructor(P,K){this.e=P,this.f=K,this.d=new r.$N0b("WorkspaceSymbols")}async provideWorkspaceSymbols(P,K){const V=await this.e.provideWorkspaceSymbols(P,K);if(!(0,F.$nf)(V))return{symbols:[]};const J=this.d.add(V),re={cacheId:J,symbols:[]};for(let de=0;de<V.length;de++){const ie=V[de];if(!ie||!ie.name){this.f.warn("INVALID SymbolInformation",ie);continue}re.symbols.push({...S.WorkspaceSymbol.from(ie),cacheId:[J,de]})}return re}async resolveWorkspaceSymbol(P,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!P.cacheId)return P;const V=this.d.get(...P.cacheId);if(V){const J=await this.e.resolveWorkspaceSymbol(V,K);return J&&(0,C.$Gm)(P,S.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(P){this.d.delete(P)}}class ue{static supportsResolving(P){return typeof P.prepareRename=="function"}constructor(P,K,V){this.d=P,this.e=K,this.f=V}async provideRenameEdits(P,K,V,J){const re=this.d.getDocument(P),de=S.Position.to(K);try{const ie=await this.e.provideRenameEdits(re,de,V,J);return ie?S.WorkspaceEdit.from(ie):void 0}catch(ie){const ve=ue.g(ie);return ve?{rejectReason:ve,edits:void 0}:Promise.reject(ie)}}async resolveRenameLocation(P,K,V){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(P),re=S.Position.to(K);try{const de=await this.e.prepareRename(J,re,V);let ie,ve;if(z.$cJ.isRange(de)?(ie=de,ve=J.getText(de)):(0,D.$ie)(de)&&(ie=de.range,ve=de.placeholder),!ie||!ve)return;if(ie.start.line>re.line||ie.end.line<re.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(ie),text:ve}}catch(de){const ie=ue.g(de);return ie?{rejectReason:ie,range:void 0,text:void 0}:Promise.reject(de)}}static g(P){return typeof P=="string"?P:P instanceof Error&&typeof P.message=="string"?P.message:void 0}}class pe{constructor(P,K){this.resultId=P,this.tokens=K}}class Pe{constructor(P,K){this.f=P,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(P,K,V){const J=this.f.getDocument(P),re=K!==0?this.d.get(K):null;let de=typeof re?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,re.resultId,V):await this.g.provideDocumentSemanticTokens(J,V);return re&&this.d.delete(K),de?(de=Pe.h(de),this.o(Pe.n(re,de),de)):null}async releaseDocumentSemanticColoring(P){this.d.delete(P)}static h(P){return Pe.j(P)?Pe.k(P)?P:new z.$sK(new Uint32Array(P.data),P.resultId):Pe.l(P)?Pe.m(P)?P:new z.$uK(P.edits.map(K=>new z.$tK(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),P.resultId):P}static j(P){return P&&!!P.data}static k(P){return P.data instanceof Uint32Array}static l(P){return P&&Array.isArray(P.edits)}static m(P){for(const K of P.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(P,K){if(!Pe.j(K)||!P||!P.tokens)return K;const V=P.tokens,J=V.length,re=K.data,de=re.length;let ie=0;const ve=Math.min(J,de);for(;ie<ve&&V[ie]===re[ie];)ie++;if(ie===J&&ie===de)return new z.$uK([],K.resultId);let Ee=0;const Be=ve-ie;for(;Ee<Be&&V[J-Ee-1]===re[de-Ee-1];)Ee++;return new z.$uK([{start:ie,deleteCount:J-ie-Ee,data:re.subarray(ie,de-Ee)}],K.resultId)}o(P,K){if(Pe.j(P)){const V=this.e++;return this.d.set(V,new pe(P.resultId,P.data)),(0,u.$c7)({id:V,type:"full",data:P.data})}if(Pe.l(P)){const V=this.e++;return Pe.j(K)?this.d.set(V,new pe(K.resultId,K.data)):this.d.set(V,new pe(P.resultId)),(0,u.$c7)({id:V,type:"delta",deltas:(P.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class _{constructor(P,K){this.d=P,this.e=K}async provideDocumentRangeSemanticTokens(P,K,V){const J=this.d.getDocument(P),re=await this.e.provideDocumentRangeSemanticTokens(J,S.Range.to(K),V);return re?this.f(re):null}f(P){return(0,u.$c7)({id:0,type:"full",data:P.data})}}class Y{static supportsResolving(P){return typeof P.resolveCompletionItem=="function"}constructor(P,K,V,J,re){this.f=P,this.g=K,this.h=V,this.j=J,this.k=re,this.d=new r.$N0b("CompletionItem"),this.e=new Map}async provideCompletionItems(P,K,V,J){const re=this.f.getDocument(P),de=S.Position.to(K),ie=re.getWordRangeAtPosition(de)||new z.$cJ(de,de),ve=ie.with({end:de}),Ee=new c.$1c,Be=await this.h.provideCompletionItems(re,de,J,S.CompletionContext.to(V));if(!Be||J.isCancellationRequested)return;const We=Array.isArray(Be)?new z.$IJ(Be):Be,_e=Y.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),He=new $.$jb;this.e.set(_e,He);const Qe=[],it={x:_e,b:Qe,a:{replace:S.Range.from(ie),insert:S.Range.from(ve)},c:We.isIncomplete||void 0,d:Ee.elapsed()};for(let ct=0;ct<We.items.length;ct++){const et=We.items[ct],rt=this.l(et,[_e,ct],ve,ie);Qe.push(rt)}return it}async resolveCompletionItem(P,K){if(typeof this.h.resolveCompletionItem!="function")return;const V=this.d.get(...P);if(!V)return;const J=this.l(V,P),re=await this.h.resolveCompletionItem(V,K);if(!re)return;const de=this.l(re,P);return(J.h!==de.h||J.i!==de.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==de.n||J.o!==de.o||!(0,C.$Hm)(J.p,de.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:de.d,c:de.c,l:de.l,h:de.h,i:de.i,n:de.n,o:de.o,p:de.p}}releaseCompletionItems(P){this.e.get(P)?.dispose(),this.e.delete(P),this.d.delete(P)}l(P,K,V,J){const re=this.e.get(K[0]);if(!re)throw Error("DisposableStore is missing...");const de=this.g.toInternal(P.command,re),ie={x:K,a:P.label,b:P.kind!==void 0?S.CompletionItemKind.from(P.kind):void 0,m:P.tags&&P.tags.map(S.CompletionItemTag.from),c:P.detail,d:typeof P.documentation>"u"?void 0:S.MarkdownString.fromStrict(P.documentation),e:P.sortText!==P.label?P.sortText:void 0,f:P.filterText!==P.label?P.filterText:void 0,g:P.preselect||void 0,i:P.keepWhitespace?1:0,k:P.commitCharacters?.join(""),l:P.additionalTextEdits&&P.additionalTextEdits.map(S.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};P.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=P.textEdit.newText):typeof P.insertText=="string"?ie.h=P.insertText:P.insertText instanceof z.$lJ&&(ie.h=P.insertText.value,ie.i|=4);let ve;return P.textEdit?ve=P.textEdit.range:P.range&&(ve=P.range),z.$cJ.isRange(ve)?ie.j=S.Range.from(ve):ve&&(!V?.isEqual(ve.inserting)||!J?.isEqual(ve.replacing))&&(ie.j={insert:S.Range.from(ve.inserting),replace:S.Range.from(ve.replacing)}),ie}}class ce{async provideInlineCompletions(P,K,V,J){}disposeCompletions(P){}handleDidShowCompletionItem(P,K,V){}handlePartialAccept(P,K,V){}}class ke extends ce{constructor(P,K,V,J){super(),this.f=P,this.g=K,this.h=V,this.j=J,this.d=new Ce,this.e=(0,y.$0E)(this.f,"inlineCompletionsAdditions"),this.k={[T.InlineCompletionTriggerKind.Automatic]:z.InlineCompletionTriggerKind.Automatic,[T.InlineCompletionTriggerKind.Explicit]:z.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,y.$0E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(P,K,V,J){const re=this.g.getDocument(P),de=S.Position.to(K),ie=await this.h.provideInlineCompletionItems(re,de,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:S.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[V.triggerKind]},J);if(!ie||J.isCancellationRequested)return;const ve=Array.isArray(ie)?ie:ie.items,Ee=this.e?Array.isArray(ie)?[]:ie.commands||[]:[],Be=this.e&&!Array.isArray(ie)?ie.suppressSuggestions:void 0,We=this.e&&!Array.isArray(ie)?ie.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:ve}),items:ve.map((Qe,it)=>{let ct;Qe.command&&(_e||(_e=new $.$jb),ct=this.j.toInternal(Qe.command,_e));const et=Qe.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:Qe.filterText,range:Qe.range?S.Range.from(Qe.range):void 0,command:ct,idx:it,completeBracketPairs:this.e?Qe.completeBracketPairs:!1}}),commands:Ee.map(Qe=>(_e||(_e=new $.$jb),this.j.toInternal(Qe,_e))),suppressSuggestions:Be,enableForwardStability:We}}disposeCompletions(P){this.d.disposeReferenceId(P)?.dispose()}handleDidShowCompletionItem(P,K,V){const J=this.d.get(P)?.items[K];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,V)}handlePartialAccept(P,K,V){const J=this.d.get(P)?.items[K];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,V)}}class Ce{constructor(){this.d=new Map,this.e=1}createReferenceId(P){const K=this.e++;return this.d.set(K,P),K}disposeReferenceId(P){const K=this.d.get(P);return this.d.delete(P),K}get(P){return this.d.get(P)}}class me{constructor(P,K){this.e=P,this.f=K,this.d=new r.$N0b("SignatureHelp")}async provideSignatureHelp(P,K,V,J){const re=this.e.getDocument(P),de=S.Position.to(K),ie=this.g(V),ve=await this.f.provideSignatureHelp(re,de,J,ie);if(ve){const Ee=this.d.add([ve]);return{...S.SignatureHelp.from(ve),id:Ee}}}g(P){let K;if(P.activeSignatureHelp){const V=S.SignatureHelp.to(P.activeSignatureHelp),J=this.d.get(P.activeSignatureHelp.id,0);J?(K=J,K.activeSignature=V.activeSignature,K.activeParameter=V.activeParameter):K=V}return{...P,activeSignatureHelp:K}}releaseSignatureHelp(P){this.d.delete(P)}}class R{constructor(P,K,V,J,re){this.f=P,this.g=K,this.h=V,this.j=J,this.k=re,this.d=new r.$N0b("InlayHints"),this.e=new Map}async provideInlayHints(P,K,V){const J=this.f.getDocument(P),re=S.Range.to(K),de=await this.h.provideInlayHints(J,re,V);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${K}`);return}if(V.isCancellationRequested)return;const ie=this.d.add(de);this.e.set(ie,new $.$jb);const ve={hints:[],cacheId:ie};for(let Ee=0;Ee<de.length;Ee++)this.l(de[Ee],re)&&ve.hints.push(this.m(de[Ee],[ie,Ee]));return this.j.trace(`[InlayHints] ${ve.hints.length} inlay hints from '${this.k.identifier.value}' for ${K}`),ve}async resolveInlayHint(P,K){if(typeof this.h.resolveInlayHint!="function")return;const V=this.d.get(...P);if(!V)return;const J=await this.h.resolveInlayHint(V,K);if(J&&this.l(J))return this.m(J,P)}releaseHints(P){this.e.get(P)?.dispose(),this.e.delete(P),this.d.delete(P)}l(P,K){return P.label.length===0||Array.isArray(P.label)&&P.label.every(V=>V.value.length===0)?(console.log("INVALID inlay hint, empty label",P),!1):!(K&&!K.contains(P.position))}m(P,K){const V=this.e.get(K[0]);if(!V)throw Error("DisposableStore is missing...");const J={label:"",cacheId:K,tooltip:S.MarkdownString.fromStrict(P.tooltip),position:S.Position.from(P.position),textEdits:P.textEdits&&P.textEdits.map(S.TextEdit.from),kind:P.kind&&S.InlayHintKind.from(P.kind),paddingLeft:P.paddingLeft,paddingRight:P.paddingRight};return typeof P.label=="string"?J.label=P.label:J.label=P.label.map(re=>{const de={label:re.value};return de.tooltip=S.MarkdownString.fromStrict(re.tooltip),z.$mJ.isLocation(re.location)&&(de.location=S.location.from(re.location)),re.command&&(de.command=this.g.toInternal(re.command,V)),de}),J}}class Q{constructor(P,K){this.e=P,this.f=K,this.d=new r.$N0b("DocumentLink")}async provideLinks(P,K){const V=this.e.getDocument(P),J=await this.f.provideDocumentLinks(V,K);if(!(!Array.isArray(J)||J.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(Q.g).map(S.DocumentLink.from)};{const re=this.d.add(J),de={links:[],cacheId:re};for(let ie=0;ie<J.length;ie++){if(!Q.g(J[ie]))continue;const ve=S.DocumentLink.from(J[ie]);ve.cacheId=[re,ie],de.links.push(ve)}return de}}}static g(P){return P.target&&P.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(P,K){if(typeof this.f.resolveDocumentLink!="function")return;const V=this.d.get(...P);if(!V)return;const J=await this.f.resolveDocumentLink(V,K);if(!(!J||!Q.g(J)))return S.DocumentLink.from(J)}releaseLinks(P){this.d.delete(P)}}class he{constructor(P,K){this.d=P,this.e=K}async provideColors(P,K){const V=this.d.getDocument(P),J=await this.e.provideDocumentColors(V,K);return Array.isArray(J)?J.map(de=>({color:S.Color.from(de.color),range:S.Range.from(de.range)})):[]}async provideColorPresentations(P,K,V){const J=this.d.getDocument(P),re=S.Range.to(K.range),de=S.Color.to(K.color),ie=await this.e.provideColorPresentations(de,{document:J,range:re},V);if(Array.isArray(ie))return ie.map(S.ColorPresentation.from)}}class De{constructor(P,K){this.d=P,this.e=K}async provideFoldingRanges(P,K,V){const J=this.d.getDocument(P),re=await this.e.provideFoldingRanges(J,K,V);if(Array.isArray(re))return re.map(S.FoldingRange.from)}}class ye{constructor(P,K,V){this.d=P,this.e=K,this.f=V}async provideSelectionRanges(P,K,V){const J=this.d.getDocument(P),re=K.map(S.Position.to),de=await this.e.provideSelectionRanges(J,re,V);if(!(0,F.$nf)(de))return[];if(de.length!==re.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ie=[];for(let ve=0;ve<re.length;ve++){const Ee=[];ie.push(Ee);let Be=re[ve],We=de[ve];for(;;){if(!We.range.contains(Be))throw new Error("INVALID selection range, must contain the previous range");if(Ee.push(S.SelectionRange.from(We)),!We.parent)break;Be=We.range,We=We.parent}}return ie}}class $e{constructor(P,K){this.f=P,this.g=K,this.d=new t.$fL(""),this.e=new Map}async prepareSession(P,K,V){const J=this.f.getDocument(P),re=S.Position.to(K),de=await this.g.prepareCallHierarchy(J,re,V);if(!de)return;const ie=this.d.nextId();return this.e.set(ie,new Map),Array.isArray(de)?de.map(ve=>this.h(ie,ve)):[this.h(ie,de)]}async provideCallsTo(P,K,V){const J=this.j(P,K);if(!J)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyIncomingCalls(J,V);if(re)return re.map(de=>({from:this.h(P,de.from),fromRanges:de.fromRanges.map(ie=>S.Range.from(ie))}))}async provideCallsFrom(P,K,V){const J=this.j(P,K);if(!J)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyOutgoingCalls(J,V);if(re)return re.map(de=>({to:this.h(P,de.to),fromRanges:de.fromRanges.map(ie=>S.Range.from(ie))}))}releaseSession(P){this.e.delete(P)}h(P,K){const V=this.e.get(P),J=S.CallHierarchyItem.from(K,P,V.size.toString(36));return V.set(J._itemId,K),J}j(P,K){return this.e.get(P)?.get(K)}}class Se{constructor(P,K){this.f=P,this.g=K,this.d=new t.$fL(""),this.e=new Map}async prepareSession(P,K,V){const J=this.f.getDocument(P),re=S.Position.to(K),de=await this.g.prepareTypeHierarchy(J,re,V);if(!de)return;const ie=this.d.nextId();return this.e.set(ie,new Map),Array.isArray(de)?de.map(ve=>this.h(ie,ve)):[this.h(ie,de)]}async provideSupertypes(P,K,V){const J=this.j(P,K);if(!J)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySupertypes(J,V);if(re)return re.map(de=>this.h(P,de))}async provideSubtypes(P,K,V){const J=this.j(P,K);if(!J)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySubtypes(J,V);if(re)return re.map(de=>this.h(P,de))}releaseSession(P){this.e.delete(P)}h(P,K){const V=this.e.get(P),J=S.TypeHierarchyItem.from(K,P,V.size.toString(36));return V.set(J._itemId,K),J}j(P,K){return this.e.get(P)?.get(K)}}class ae{constructor(P,K,V,J,re){this.d=P,this.e=K,this.f=V,this.g=J,this.h=re}async provideDocumentOnDropEdits(P,K,V,J,re){const de=this.e.getDocument(K),ie=S.Position.to(V),ve=S.DataTransfer.toDataTransfer(J,async Be=>(await this.d.$resolveDocumentOnDropFileData(this.g,P,Be)).buffer),Ee=await this.f.provideDocumentDropEdits(de,ie,ve,re);if(Ee)return{id:Ee.id?this.h.identifier.value+"."+Ee.id:this.h.identifier.value,label:Ee.label??(0,i.localize)(1,null,this.h.displayName||this.h.name),priority:Ee.priority??0,insertText:typeof Ee.insertText=="string"?Ee.insertText:{snippet:Ee.insertText.value},additionalEdit:Ee.additionalEdit?S.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}}class le{constructor(P,K){this.adapter=P,this.extension=K}}class ne{constructor(P,K,V,J,re,de,ie,ve){this.g=K,this.h=V,this.j=J,this.k=re,this.l=de,this.m=ie,this.n=ve,this.f=new Map,this.e=P.getProxy(f.$$I.MainThreadLanguageFeatures)}o(P,K){return S.DocumentSelector.from(P,this.g,K)}p(P){return new z.$aJ(()=>{this.f.delete(P),this.e.$unregister(P)})}q(){return ne.d++}async s(P,K,V,J,re,de=!1){const ie=this.f.get(P);if(!ie||!(ie.adapter instanceof K))return J;const ve=Date.now();de||this.l.trace(`[${ie.extension.identifier.value}] INVOKE provider '${V.toString().replace(/[\r\n]/g,"")}'`);const Ee=V(ie.adapter,ie.extension);return Promise.resolve(Ee).catch(Be=>{(0,w.$1)(Be)||(this.l.error(`[${ie.extension.identifier.value}] provider FAILED`),this.l.error(Be),this.n.onExtensionError(ie.extension.identifier,Be))}).finally(()=>{de||this.l.trace(`[${ie.extension.identifier.value}] provider DONE after ${Date.now()-ve}ms`)}),b.CancellationToken.isCancellationToken(re)?(0,v.$hg)(Ee,re):Ee}t(P,K){const V=this.q();return this.f.set(V,new le(P,K)),V}static u(P){return P.displayName||P.name}registerDocumentSymbolProvider(P,K,V,J){const re=this.t(new l(this.h,V),P),de=J&&J.label||ne.u(P);return this.e.$registerDocumentSymbolProvider(re,this.o(K,P),de),this.p(re)}$provideDocumentSymbols(P,K,V){return this.s(P,l,J=>J.provideDocumentSymbols(g.URI.revive(K),V),void 0,V)}registerCodeLensProvider(P,K,V){const J=this.q(),re=typeof V.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new le(new n(this.h,this.j.converter,V),P)),this.e.$registerCodeLensSupport(J,this.o(K,P),re);let de=this.p(J);if(re!==void 0){const ie=V.onDidChangeCodeLenses(ve=>this.e.$emitCodeLensEvent(re));de=z.$aJ.from(de,ie)}return de}$provideCodeLenses(P,K,V){return this.s(P,n,J=>J.provideCodeLenses(g.URI.revive(K),V),void 0,V)}$resolveCodeLens(P,K,V){return this.s(P,n,J=>J.resolveCodeLens(K,V),void 0,void 0)}$releaseCodeLenses(P,K){this.s(P,n,V=>Promise.resolve(V.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(P,K,V){const J=this.t(new p(this.h,V),P);return this.e.$registerDefinitionSupport(J,this.o(K,P)),this.p(J)}$provideDefinition(P,K,V,J){return this.s(P,p,re=>re.provideDefinition(g.URI.revive(K),V,J),[],J)}registerDeclarationProvider(P,K,V){const J=this.t(new I(this.h,V),P);return this.e.$registerDeclarationSupport(J,this.o(K,P)),this.p(J)}$provideDeclaration(P,K,V,J){return this.s(P,I,re=>re.provideDeclaration(g.URI.revive(K),V,J),[],J)}registerImplementationProvider(P,K,V){const J=this.t(new d(this.h,V),P);return this.e.$registerImplementationSupport(J,this.o(K,P)),this.p(J)}$provideImplementation(P,K,V,J){return this.s(P,d,re=>re.provideImplementation(g.URI.revive(K),V,J),[],J)}registerTypeDefinitionProvider(P,K,V){const J=this.t(new A(this.h,V),P);return this.e.$registerTypeDefinitionSupport(J,this.o(K,P)),this.p(J)}$provideTypeDefinition(P,K,V,J){return this.s(P,A,re=>re.provideTypeDefinition(g.URI.revive(K),V,J),[],J)}registerHoverProvider(P,K,V,J){const re=this.t(new E(this.h,V),P);return this.e.$registerHoverProvider(re,this.o(K,P)),this.p(re)}$provideHover(P,K,V,J){return this.s(P,E,re=>re.provideHover(g.URI.revive(K),V,J),void 0,J)}registerEvaluatableExpressionProvider(P,K,V,J){const re=this.t(new a(this.h,V),P);return this.e.$registerEvaluatableExpressionProvider(re,this.o(K,P)),this.p(re)}$provideEvaluatableExpression(P,K,V,J){return this.s(P,a,re=>re.provideEvaluatableExpression(g.URI.revive(K),V,J),void 0,J)}registerInlineValuesProvider(P,K,V,J){const re=typeof V.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new o(this.h,V),P);this.e.$registerInlineValuesProvider(de,this.o(K,P),re);let ie=this.p(de);if(re!==void 0){const ve=V.onDidChangeInlineValues(Ee=>this.e.$emitInlineValuesEvent(re));ie=z.$aJ.from(ie,ve)}return ie}$provideInlineValues(P,K,V,J,re){return this.s(P,o,de=>de.provideInlineValues(g.URI.revive(K),V,J,re),void 0,re)}registerDocumentHighlightProvider(P,K,V){const J=this.t(new L(this.h,V),P);return this.e.$registerDocumentHighlightProvider(J,this.o(K,P)),this.p(J)}$provideDocumentHighlights(P,K,V,J){return this.s(P,L,re=>re.provideDocumentHighlights(g.URI.revive(K),V,J),void 0,J)}registerLinkedEditingRangeProvider(P,K,V){const J=this.t(new B(this.h,V),P);return this.e.$registerLinkedEditingRangeProvider(J,this.o(K,P)),this.p(J)}$provideLinkedEditingRanges(P,K,V,J){return this.s(P,B,async re=>{const de=await re.provideLinkedEditingRanges(g.URI.revive(K),V,J);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?ne.w(de.wordPattern):void 0}},void 0,J)}registerReferenceProvider(P,K,V){const J=this.t(new G(this.h,V),P);return this.e.$registerReferenceSupport(J,this.o(K,P)),this.p(J)}$provideReferences(P,K,V,J,re){return this.s(P,G,de=>de.provideReferences(g.URI.revive(K),V,J,re),void 0,re)}registerCodeActionProvider(P,K,V,J){const re=new $.$jb,de=this.t(new q(this.h,this.j.converter,this.k,V,this.l,P,this.m),P);return this.e.$registerQuickFixSupport(de,this.o(K,P),{providedKinds:J?.providedCodeActionKinds?.map(ie=>ie.value),documentation:J?.documentation?.map(ie=>({kind:ie.kind.value,command:this.j.converter.toInternal(ie.command,re)}))},ne.u(P),!!V.resolveCodeAction),re.add(this.p(de)),re}$provideCodeActions(P,K,V,J,re){return this.s(P,q,de=>de.provideCodeActions(g.URI.revive(K),V,J,re),void 0,re)}$resolveCodeAction(P,K,V){return this.s(P,q,J=>J.resolveCodeAction(K,V),{},void 0)}$releaseCodeActions(P,K){this.s(P,q,V=>Promise.resolve(V.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(P,K,V){const J=this.t(new N(this.h,V),P);return this.e.$registerDocumentFormattingSupport(J,this.o(K,P),P.identifier,P.displayName||P.name),this.p(J)}$provideDocumentFormattingEdits(P,K,V,J){return this.s(P,N,re=>re.provideDocumentFormattingEdits(g.URI.revive(K),V,J),void 0,J)}registerDocumentRangeFormattingEditProvider(P,K,V){const J=typeof V.provideDocumentRangesFormattingEdits=="function";J&&(0,y.$$E)(P,"formatMultipleRanges");const re=this.t(new H(this.h,V),P);return this.e.$registerRangeFormattingSupport(re,this.o(K,P),P.identifier,P.displayName||P.name,J),this.p(re)}$provideDocumentRangeFormattingEdits(P,K,V,J,re){return this.s(P,H,de=>de.provideDocumentRangeFormattingEdits(g.URI.revive(K),V,J,re),void 0,re)}$provideDocumentRangesFormattingEdits(P,K,V,J,re){return this.s(P,H,de=>de.provideDocumentRangesFormattingEdits(g.URI.revive(K),V,J,re),void 0,re)}registerOnTypeFormattingEditProvider(P,K,V,J){const re=this.t(new j(this.h,V),P);return this.e.$registerOnTypeFormattingSupport(re,this.o(K,P),J,P.identifier),this.p(re)}$provideOnTypeFormattingEdits(P,K,V,J,re,de){return this.s(P,j,ie=>ie.provideOnTypeFormattingEdits(g.URI.revive(K),V,J,re,de),void 0,de)}registerWorkspaceSymbolProvider(P,K){const V=this.t(new O(K,this.l),P);return this.e.$registerNavigateTypeSupport(V,typeof K.resolveWorkspaceSymbol=="function"),this.p(V)}$provideWorkspaceSymbols(P,K,V){return this.s(P,O,J=>J.provideWorkspaceSymbols(K,V),{symbols:[]},V)}$resolveWorkspaceSymbol(P,K,V){return this.s(P,O,J=>J.resolveWorkspaceSymbol(K,V),void 0,void 0)}$releaseWorkspaceSymbols(P,K){this.s(P,O,V=>V.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(P,K,V){const J=this.t(new ue(this.h,V,this.l),P);return this.e.$registerRenameSupport(J,this.o(K,P),ue.supportsResolving(V)),this.p(J)}$provideRenameEdits(P,K,V,J,re){return this.s(P,ue,de=>de.provideRenameEdits(g.URI.revive(K),V,J,re),void 0,re)}$resolveRenameLocation(P,K,V,J){return this.s(P,ue,re=>re.resolveRenameLocation(g.URI.revive(K),V,J),void 0,J)}registerDocumentSemanticTokensProvider(P,K,V,J){const re=this.t(new Pe(this.h,V),P),de=typeof V.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(re,this.o(K,P),J,de);let ie=this.p(re);if(de){const ve=V.onDidChangeSemanticTokens(Ee=>this.e.$emitDocumentSemanticTokensEvent(de));ie=z.$aJ.from(ie,ve)}return ie}$provideDocumentSemanticTokens(P,K,V,J){return this.s(P,Pe,re=>re.provideDocumentSemanticTokens(g.URI.revive(K),V,J),null,J)}$releaseDocumentSemanticTokens(P,K){this.s(P,Pe,V=>V.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(P,K,V,J){const re=this.t(new _(this.h,V),P);return this.e.$registerDocumentRangeSemanticTokensProvider(re,this.o(K,P),J),this.p(re)}$provideDocumentRangeSemanticTokens(P,K,V,J){return this.s(P,_,re=>re.provideDocumentRangeSemanticTokens(g.URI.revive(K),V,J),null,J)}registerCompletionItemProvider(P,K,V,J){const re=this.t(new Y(this.h,this.j.converter,V,this.m,P),P);return this.e.$registerCompletionsProvider(re,this.o(K,P),J,Y.supportsResolving(V),P.identifier),this.p(re)}$provideCompletionItems(P,K,V,J,re){return this.s(P,Y,de=>de.provideCompletionItems(g.URI.revive(K),V,J,re),void 0,re)}$resolveCompletionItem(P,K,V){return this.s(P,Y,J=>J.resolveCompletionItem(K,V),void 0,V)}$releaseCompletionItems(P,K){this.s(P,Y,V=>V.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(P,K,V){const J=new ke(P,this.h,V,this.j.converter),re=this.t(J,P);return this.e.$registerInlineCompletionsSupport(re,this.o(K,P),J.supportsHandleEvents),this.p(re)}$provideInlineCompletions(P,K,V,J,re){return this.s(P,ce,de=>de.provideInlineCompletions(g.URI.revive(K),V,J,re),void 0,re)}$handleInlineCompletionDidShow(P,K,V,J){this.s(P,ce,async re=>{re.handleDidShowCompletionItem(K,V,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(P,K,V,J){this.s(P,ce,async re=>{re.handlePartialAccept(K,V,J)},void 0,void 0)}$freeInlineCompletionsList(P,K){this.s(P,ce,async V=>{V.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(P,K,V,J){const re=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,de=this.t(new me(this.h,V),P);return this.e.$registerSignatureHelpProvider(de,this.o(K,P),re),this.p(de)}$provideSignatureHelp(P,K,V,J,re){return this.s(P,me,de=>de.provideSignatureHelp(g.URI.revive(K),V,J,re),void 0,re)}$releaseSignatureHelp(P,K){this.s(P,me,V=>V.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(P,K,V){const J=typeof V.onDidChangeInlayHints=="function"?this.q():void 0,re=this.t(new R(this.h,this.j.converter,V,this.l,P),P);this.e.$registerInlayHintsProvider(re,this.o(K,P),typeof V.resolveInlayHint=="function",J,ne.u(P));let de=this.p(re);if(J!==void 0){const ie=V.onDidChangeInlayHints(ve=>this.e.$emitInlayHintsEvent(J));de=z.$aJ.from(de,ie)}return de}$provideInlayHints(P,K,V,J){return this.s(P,R,re=>re.provideInlayHints(g.URI.revive(K),V,J),void 0,J)}$resolveInlayHint(P,K,V){return this.s(P,R,J=>J.resolveInlayHint(K,V),void 0,V)}$releaseInlayHints(P,K){this.s(P,R,V=>V.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(P,K,V){const J=this.t(new Q(this.h,V),P);return this.e.$registerDocumentLinkProvider(J,this.o(K,P),typeof V.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(P,K,V){return this.s(P,Q,J=>J.provideLinks(g.URI.revive(K),V),void 0,V,K.scheme==="output")}$resolveDocumentLink(P,K,V){return this.s(P,Q,J=>J.resolveLink(K,V),void 0,void 0,!0)}$releaseDocumentLinks(P,K){this.s(P,Q,V=>V.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(P,K,V){const J=this.t(new he(this.h,V),P);return this.e.$registerDocumentColorProvider(J,this.o(K,P)),this.p(J)}$provideDocumentColors(P,K,V){return this.s(P,he,J=>J.provideColors(g.URI.revive(K),V),[],V)}$provideColorPresentations(P,K,V,J){return this.s(P,he,re=>re.provideColorPresentations(g.URI.revive(K),V,J),void 0,J)}registerFoldingRangeProvider(P,K,V){const J=this.q(),re=typeof V.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new le(new De(this.h,V),P)),this.e.$registerFoldingRangeProvider(J,this.o(K,P),P.identifier,re);let de=this.p(J);if(re!==void 0){const ie=V.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(re));de=z.$aJ.from(de,ie)}return de}$provideFoldingRanges(P,K,V,J){return this.s(P,De,re=>re.provideFoldingRanges(g.URI.revive(K),V,J),void 0,J)}registerSelectionRangeProvider(P,K,V){const J=this.t(new ye(this.h,V,this.l),P);return this.e.$registerSelectionRangeProvider(J,this.o(K,P)),this.p(J)}$provideSelectionRanges(P,K,V,J){return this.s(P,ye,re=>re.provideSelectionRanges(g.URI.revive(K),V,J),[],J)}registerCallHierarchyProvider(P,K,V){const J=this.t(new $e(this.h,V),P);return this.e.$registerCallHierarchyProvider(J,this.o(K,P)),this.p(J)}$prepareCallHierarchy(P,K,V,J){return this.s(P,$e,re=>Promise.resolve(re.prepareSession(g.URI.revive(K),V,J)),void 0,J)}$provideCallHierarchyIncomingCalls(P,K,V,J){return this.s(P,$e,re=>re.provideCallsTo(K,V,J),void 0,J)}$provideCallHierarchyOutgoingCalls(P,K,V,J){return this.s(P,$e,re=>re.provideCallsFrom(K,V,J),void 0,J)}$releaseCallHierarchy(P,K){this.s(P,$e,V=>Promise.resolve(V.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(P,K,V){const J=this.t(new Se(this.h,V),P);return this.e.$registerTypeHierarchyProvider(J,this.o(K,P)),this.p(J)}$prepareTypeHierarchy(P,K,V,J){return this.s(P,Se,re=>Promise.resolve(re.prepareSession(g.URI.revive(K),V,J)),void 0,J)}$provideTypeHierarchySupertypes(P,K,V,J){return this.s(P,Se,re=>re.provideSupertypes(K,V,J),void 0,J)}$provideTypeHierarchySubtypes(P,K,V,J){return this.s(P,Se,re=>re.provideSubtypes(K,V,J),void 0,J)}$releaseTypeHierarchy(P,K){this.s(P,Se,V=>Promise.resolve(V.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(P,K,V,J){const re=this.q();return this.f.set(re,new le(new ae(this.e,this.h,V,re,P),P)),this.e.$registerDocumentOnDropEditProvider(re,this.o(K,P),(0,y.$0E)(P,"dropMetadata")?J:void 0),this.p(re)}$provideDocumentOnDropEdits(P,K,V,J,re,de){return this.s(P,ae,ie=>Promise.resolve(ie.provideDocumentOnDropEdits(K,g.URI.revive(V),J,re,de)),void 0,void 0)}registerDocumentPasteEditProvider(P,K,V,J){const re=this.q();return this.f.set(re,new le(new W(this.e,this.h,V,re,P),P)),this.e.$registerPasteEditProvider(re,this.o(K,P),{supportsCopy:!!V.prepareDocumentPaste,supportsPaste:!!V.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(re)}$prepareDocumentPaste(P,K,V,J,re){return this.s(P,W,de=>de.prepareDocumentPaste(g.URI.revive(K),V,J,re),void 0,re)}$providePasteEdits(P,K,V,J,re,de){return this.s(P,W,ie=>ie.providePasteEdits(K,g.URI.revive(V),J,re,de),void 0,de)}static w(P){return{pattern:P.source,flags:(0,k.$wd)(P)}}static y(P){return{decreaseIndentPattern:ne.w(P.decreaseIndentPattern),increaseIndentPattern:ne.w(P.increaseIndentPattern),indentNextLinePattern:P.indentNextLinePattern?ne.w(P.indentNextLinePattern):void 0,unIndentedLinePattern:P.unIndentedLinePattern?ne.w(P.unIndentedLinePattern):void 0}}static z(P){return{beforeText:ne.w(P.beforeText),afterText:P.afterText?ne.w(P.afterText):void 0,previousLineText:P.previousLineText?ne.w(P.previousLineText):void 0,action:P.action}}static B(P){return P.map(ne.z)}setLanguageConfiguration(P,K,V){const{wordPattern:J}=V;if(J&&(0,k.$ud)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(K,J):this.h.setWordDefinitionFor(K,void 0),V.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",P,"Do not use."),V.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",P,"Do not use.");const re=this.q(),de={comments:V.comments,brackets:V.brackets,wordPattern:V.wordPattern?ne.w(V.wordPattern):void 0,indentationRules:V.indentationRules?ne.y(V.indentationRules):void 0,onEnterRules:V.onEnterRules?ne.B(V.onEnterRules):void 0,__electricCharacterSupport:V.__electricCharacterSupport,__characterPairSupport:V.__characterPairSupport};return this.e.$setLanguageConfiguration(re,K,de),this.p(re)}$setWordDefinitions(P){for(const K of P)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$W0b=ne,ne.d=0}),define(Re[233],Fe([1,0,4,8,7,29,16,6]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=void 0;class k{constructor(F,D,h,b){this.c=D,this.d=h,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=F.getProxy(g.$$I.MainThreadLanguages)}$acceptLanguageIds(F){this.b=F}async getLanguages(){return this.b.slice(0)}async changeLanguage(F,D){await this.a.$changeLanguage(F,D);const h=this.c.getDocumentData(F);if(!h)throw new Error(`document '${F.toString()}' NOT found`);return h.document}async tokenAtPosition(F,D){const h=F.version,b=C.Position.from(D),$=await this.a.$tokensAtPosition(F.uri,b),u={type:S.StandardTokenType.Other,range:F.getWordRangeAtPosition(D)??new S.$cJ(D.line,D.character,D.line,D.character)};if(!$)return u;const t={range:C.Range.to($.range),type:C.TokenType.to($.type)};return!t.range.contains(D)||h!==F.version?u:t}createLanguageStatusItem(F,D,h){const b=this.f++,$=this.a,u=this.g,t=`${F.identifier.value}/${D}`;if(u.has(t))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);u.add(t);const r={selector:h,id:D,name:F.displayName??F.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const w=new f.$jb,v=()=>{c?.dispose(),c=(0,T.$tg)(()=>{w.clear(),this.a.$setLanguageStatus(b,{id:t,name:r.name??F.displayName??F.name,source:F.displayName??F.name,selector:C.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===S.LanguageStatusSeverity.Error?z.default.Error:r.severity===S.LanguageStatusSeverity.Warning?z.default.Warning:z.default.Info,command:r.command&&this.d.toInternal(r.command,w),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},y={dispose(){w.dispose(),c?.dispose(),$.$removeLanguageStatus(b),u.delete(t)},get id(){return r.id},get name(){return r.name},set name(i){r.name=i,v()},get selector(){return r.selector},set selector(i){r.selector=i,v()},get text(){return r.text},set text(i){r.text=i,v()},get detail(){return r.detail},set detail(i){r.detail=i,v()},get severity(){return r.severity},set severity(i){r.severity=i,v()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(i){r.accessibilityInformation=i,v()},get command(){return r.command},set command(i){r.command=i,v()},get busy(){return r.busy},set busy(i){r.busy=i,v()}};return v(),y}}e.$E$b=k}),define(Re[82],Fe([1,0,21,13,2,3,15,4,27,17]),function(te,e,g,C,S,z,T,f,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u$b=e.$t$b=void 0;let F=e.$t$b=class{constructor(h,b,$){this.f=$,this.d=new Map,this.a=b.getProxy(f.$$I.MainThreadLocalization),this.b=h.environment.appLanguage,this.c=this.b===g.$f}getMessage(h,b){const{message:$,args:u,comment:t}=b;if(this.c)return(0,C.$jd)($,u??{});let r=$;t&&t.length>0&&(r+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(h)?.contents[r];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,C.$jd)(c??$,u??{})}getBundle(h){return this.d.get(h)?.contents}getBundleUri(h){return this.d.get(h)?.uri}async initializeLocalizedMessages(h){if(this.c||!h.l10n&&!h.isBuiltin||this.d.has(h.identifier.value))return;let b;const $=await this.g(h);if(!$){this.f.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const u=await this.a.$fetchBundleContents($),t=JSON.parse(u);b=h.isBuiltin?t.contents?.bundle:t}catch(u){this.f.error(`Failed to load translations for ${h.identifier.value} from ${$}: ${u.message}`);return}b&&this.d.set(h.identifier.value,{contents:b,uri:$})}async g(h){if(h.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(h.identifier.value,this.b);return S.URI.revive(b)}return h.l10n?S.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$t$b=F=qe([Ve(0,k.$qL),Ve(1,m.$aL),Ve(2,T.$Ni)],F),e.$u$b=(0,z.$lh)("IExtHostLocalizationService")}),define(Re[234],Fe([1,0,15,4,27,17,2,69]),function(te,e,g,C,S,z,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=void 0;let k=e.$Q_b=class extends g.$Yi{constructor(D,h){super(h.logLevel,h.logsLocation,h.loggers.map(b=>(0,f.$Ug)(b))),this.n=D.getProxy(C.$$I.MainThreadLogger)}$setLogLevel(D,h){h?this.setLogLevel(T.URI.revive(h),D):this.setLogLevel(D)}setVisibility(D,h){super.setVisibility(D,h),this.n.$setVisibility(D,h)}m(D,h,b){return new m(this.n,D,h,b)}};e.$Q_b=k=qe([Ve(0,z.$aL),Ve(1,S.$qL)],k);class m extends g.$Ti{constructor(D,h,b,$){super($?.logLevel==="always"),this.m=D,this.n=h,this.k=!1,this.l=[],this.setLevel(b),this.m.$createLogger(h,$).then(()=>{this.r(this.l),this.k=!0})}g(D,h){const b=[[D,h]];this.k?this.r(b):this.l.push(...b)}r(D){this.m.$log(this.n,D)}flush(){this.m.$flush(this.n)}}}),define(Re[83],Fe([1,0,4,3,6,17,25]),function(te,e,g,C,S,z,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$b=e.$v$b=void 0,e.$v$b=(0,C.$lh)("IExtHostManagedSockets");let f=e.$w$b=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(g.$$I.MainThreadManagedSockets)}setFactory(D,h){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new k(D,h),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const h=++this.b,b=await this.c.makeConnection(),$=new S.$jb;return this.d.set(h,new m(h,b,$)),$.add((0,S.$ib)(()=>this.d.delete(h))),$.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(h),$.dispose()})),$.add(b.onDidClose(u=>{this.a.$onDidManagedSocketClose(h,u?.stack??u?.message),$.dispose()})),$.add(b.onDidReceiveMessage(u=>this.a.$onDidManagedSocketHaveData(h,T.$Ib.wrap(u)))),h}$remoteSocketWrite(D,h){this.d.get(D)?.actual.send(h.buffer)}$remoteSocketEnd(D){const h=this.d.get(D);h&&(h.actual.end(),h.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$w$b=f=qe([Ve(0,z.$aL)],f);class k{constructor(D,h){this.socketFactoryId=D,this.makeConnection=h}}class m extends S.$kb{constructor(D,h,b){super(),this.socketId=D,this.actual=h,this.B(b)}}}),define(Re[235],Fe([1,0,4,15,26]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$b=void 0;function z(f){return f&&f.title}let T=e.$F$b=class{constructor(k,m){this.b=m,this.a=k.getProxy(g.$$I.MainThreadMessageService)}showMessage(k,m,F,D,h){const b={source:{identifier:k.identifier,label:k.displayName||k.name}};let $;typeof D=="string"||z(D)?$=[D,...h]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,$=h),b.useCustom&&(0,S.$$E)(k,"resolvers");const u=[];for(let t=0;t<$.length;t++){const r=$[t];if(typeof r=="string")u.push({title:r,handle:t,isCloseAffordance:!1});else if(typeof r=="object"){const{title:c,isCloseAffordance:w}=r;u.push({title:c,isCloseAffordance:!!w,handle:t})}else this.b.warn("Invalid message item:",r)}return this.a.$showMessage(m,F,b,u).then(t=>{if(typeof t=="number")return $[t]})}};e.$F$b=T=qe([Ve(1,C.$Ni)],T)}),define(Re[236],Fe([1,0,25,5,6,28,13,10,2,38,54,4,32,8,7,46,203,103,9,20,23]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t,r,c,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n_b=void 0;class y{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(l=>l.apiEditor)}constructor(l,n,s,p,I){this.q=s,this.r=p,this.s=I,this.f=new Map,this.g=new z.$ji,this.h=new Map,this.j=new C.$5c({onListenerError:c.$Y}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$5c({onListenerError:c.$Y}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$5c({onListenerError:c.$Y}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$5c({onListenerError:c.$Y}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new F.$N0b("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=l.getProxy(D.$$I.MainThreadNotebook),this.c=l.getProxy(D.$$I.MainThreadNotebookDocuments),this.d=l.getProxy(D.$$I.MainThreadNotebookEditors),this.i=n.converter,n.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===13){const A=d.notebookEditor?.notebookUri,E=d.cell.handle,o=this.g.get(A)?.getCell(E);if(o)return o.apiCell}if(d&&d.$mid===14){const A=d.uri,E=this.g.get(A);if(E)return E.apiNotebook}return d}}),y.y(n)}getEditorById(l){const n=this.h.get(l);if(!n)throw new Error(`unknown text editor: ${l}. known editors: ${[...this.h.keys()]} `);return n}getIdByEditor(l){for(const[n,s]of this.h)if(s.apiEditor===l)return n}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(l,n){const s=this.g.get(l);if(!s&&!n)throw new Error(`NO notebook document for '${l}'`);return s}static t(l,n){if(!n)return;const s=n.filenamePattern.map(p=>b.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(n.filenamePattern&&!s){console.warn(`Notebook content provider view options file name pattern is invalid ${n.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:n.displayName,filenamePattern:s,exclusive:n.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,n,s){const p=y.a++,I=typeof s.onDidChangeCellStatusBarItems=="function"?y.a++:void 0;this.f.set(p,s),this.b.$registerNotebookCellStatusBarItemProvider(p,I,n);let d;return I!==void 0&&(d=s.onDidChangeCellStatusBarItems(A=>this.b.$emitCellStatusBarEvent(I))),new $.$aJ(()=>{this.f.delete(p),this.b.$unregisterNotebookCellStatusBarItemProvider(p,I),d?.dispose()})}async createNotebookDocument(l){const n=await this.c.$tryCreateNotebook({viewType:l.viewType,content:l.content&&b.NotebookData.from(l.content)});return k.URI.revive(n)}async openNotebookDocument(l){const n=this.g.get(l);if(n)return n.apiNotebook;const s=await this.c.$tryOpenNotebook(l),p=this.g.get(k.URI.revive(s));return(0,f.$re)(p?.apiNotebook)}async showNotebookDocument(l,n){k.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let s;typeof n=="object"?s={position:b.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus,selections:n.selections&&n.selections.map(b.NotebookRange.from),pinned:typeof n.preview=="boolean"?!n.preview:void 0}:s={preserveFocus:!1};const p=await this.d.$tryShowNotebookDocument(l.uri,l.notebookType,s),I=p&&this.h.get(p)?.apiEditor;if(I)return I;throw p?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,n,s,p){const I=this.f.get(l),d=k.URI.revive(n),A=this.g.get(d);if(!A||!I)return;const E=A.getCellFromIndex(s);if(!E)return;const a=await I.provideCellStatusBarItems(E.apiCell,p);if(!a)return;const o=new S.$jb,L=this.p.add([o]),G=(Array.isArray(a)?a:[a]).map(q=>b.NotebookStatusBarItem.from(q,this.i,o));return{cacheId:L,items:G}}$releaseNotebookCellStatusBarItems(l){this.p.delete(l)}registerNotebookSerializer(l,n,s,p,I){if((0,T.$hd)(n))throw new Error("viewType cannot be empty or just whitespace");const d=this.u++;return this.w.set(d,{viewType:n,serializer:s,options:p}),this.b.$registerNotebookSerializer(d,{id:l.identifier,location:l.extensionLocation},n,b.NotebookDocumentContentOptions.from(p),y.t(l,I)),(0,S.$ib)(()=>{this.b.$unregisterNotebookSerializer(d)})}async $dataToNotebook(l,n,s){const p=this.w.get(l);if(!p)throw new Error("NO serializer found");const I=await p.serializer.deserializeNotebook(n.buffer,s);return new u.$Mz(b.NotebookData.from(I))}async $notebookToData(l,n,s){const p=this.w.get(l);if(!p)throw new Error("NO serializer found");const I=await p.serializer.serializeNotebook(b.NotebookData.to(n.value),s);return g.$Ib.wrap(I)}async $saveNotebook(l,n,s,p,I){const d=k.URI.revive(n),A=this.w.get(l);if(!A)throw new Error("NO serializer found");const E=this.g.get(d);if(!E)throw new Error("Document NOT found");if(E.versionId!==s)throw new Error("Document version mismatch");const a={metadata:(0,v.$Lm)(E.apiNotebook.metadata,G=>!(A.options?.transientDocumentMetadata??{})[G]),cells:[]};for(const G of E.apiNotebook.getCells()){const q=new $.$zK(G.kind,G.document.getText(),G.document.languageId,G.mime,A.options?.transientOutputs?[]:[...G.outputs],G.metadata,G.executionSummary);q.metadata=(0,v.$Lm)(G.metadata,W=>!(A.options?.transientCellMetadata??{})[W]),a.cells.push(q)}const o=await A.serializer.serializeNotebook(a,I);await this.s.value.writeFile(d,o);const L=await this.s.value.stat(d);return{name:(0,w.$3f)(d),isFile:(L.type&m.FileType.File)!==0,isDirectory:(L.type&m.FileType.Directory)!==0,isSymbolicLink:(L.type&m.FileType.SymbolicLink)!==0,mtime:L.mtime,ctime:L.ctime,size:L.size,readonly:!!((L.permissions??0)&m.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(d.scheme),locked:!!((L.permissions??0)&m.FilePermission.Locked),etag:m.$hk({mtime:L.mtime,size:L.size}),children:void 0}}x(l,n,s){if(this.h.has(n))throw new Error(`editor with id ALREADY EXSIST: ${n}`);const p=new r.$m_b(n,this.d,l,s.visibleRanges.map(b.NotebookRange.to),s.selections.map(b.NotebookRange.to),typeof s.viewColumn=="number"?b.ViewColumn.to(s.viewColumn):void 0);this.h.set(n,p)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const s of l.value.removedDocuments){const p=k.URI.revive(s),I=this.g.get(p);I&&(I.dispose(),this.g.delete(p),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(d=>d.document.uri)}),this.n.fire(I.apiNotebook));for(const d of this.h.values())d.notebookData.uri.toString()===p.toString()&&this.h.delete(d.id)}if(l.value.addedDocuments){const s=[];for(const p of l.value.addedDocuments){const I=k.URI.revive(p.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const d=new t.$l_b(this.c,this.q,this.r,I,p);s.push(...p.cells.map(A=>t.$k_b.asModelAddData(d.apiNotebook,A))),this.g.get(I)?.dispose(),this.g.set(I,d),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:s}),this.m.fire(d.apiNotebook)}}if(l.value.addedEditors)for(const s of l.value.addedEditors){if(this.h.has(s.id))return;const p=k.URI.revive(s.documentUri),I=this.g.get(p);I&&this.x(I,s.id,s)}const n=[];if(l.value.removedEditors)for(const s of l.value.removedEditors){const p=this.h.get(s);p&&(this.h.delete(s),this.k?.id===p.id&&(this.k=void 0),n.push(p))}if(l.value.visibleEditors){this.l=l.value.visibleEditors.map(p=>this.h.get(p)).filter(p=>!!p);const s=new Set;this.l.forEach(p=>s.add(p.id));for(const p of this.h.values()){const I=s.has(p.id);p._acceptVisibility(I)}this.l=[...this.h.values()].map(p=>p).filter(p=>p.visible),this.o.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this.k=void 0:l.value.newActiveEditor&&(this.h.get(l.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${l.value.newActiveEditor}`),this.k=this.h.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static y(l){const n=h.$yL.String.with("notebookType","A notebook type"),s=new h.$AL("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[n,new h.$yL("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>g.$Ib.wrap(I))],new h.$zL("Notebook Data",I=>b.NotebookData.to(I.value))),p=new h.$AL("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[n,new h.$yL("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new u.$Mz(b.NotebookData.from(I)))],new h.$zL("Bytes",I=>I.buffer));l.registerApiCommand(s),l.registerApiCommand(p)}}e.$n_b=y,y.a=0}),define(Re[237],Fe([1,0,18,16,22,5,6,28,2,24,15,54,4,32,8,7,78,196,26,46]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t,r,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C_b=e.$B_b=void 0;let v=e.$B_b=class{constructor(d,A,E,a,o){this.m=A,this.n=E,this.o=a,this.q=o,this.b=new f.$ji,this.c=new f.$ji,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new D.$N0b("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new z.$5c,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=d.getProxy(h.$$I.MainThreadNotebookKernels);const L=new b.$AL("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.$yL("options","Select kernel options",B=>!0,B=>{if(B&&"notebookEditor"in B&&"id"in B){const G=this.n.getIdByEditor(B.notebookEditor);return{id:B.id,extension:B.extension,notebookEditorId:G}}else if(B&&"notebookEditor"in B){const G=this.n.getIdByEditor(B.notebookEditor);if(G===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${B.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:G}}return B})],b.$zL.Void);this.o.registerApiCommand(L)}createNotebookController(d,A,E,a,o,L){for(const ke of this.j.values())if(ke.controller.id===A&&m.$Dl.equals(d.identifier,ke.extensionId))throw new Error(`notebook controller with id '${A}' ALREADY exist`);const B=this.k++,G=this;this.q.trace(`NotebookController[${B}], CREATED by ${d.identifier.value}, ${A}`);const q=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${d.identifier}'`);let W=!1;const N=new T.$jb,H=new z.$5c,j=new z.$5c,O={id:p(d.identifier,A),notebookType:E,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:a||d.identifier.value,preloads:L?L.map($.NotebookRendererScript.from):[]};let ue=o??q,pe;this.a.$addKernel(B,O).catch(ke=>{console.log(ke),W=!0});let Pe=0;const _=()=>{if(W)return;const ke=++Pe;Promise.resolve().then(()=>{ke===Pe&&this.a.$updateKernel(B,O)})},Y=new f.$ji,ce={get id(){return A},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:H.event,get label(){return O.label},set label(ke){O.label=ke??d.displayName??d.name,_()},get detail(){return O.detail??""},set detail(ke){O.detail=ke,_()},get description(){return O.description??""},set description(ke){O.description=ke,_()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(ke){O.supportedLanguages=ke,_()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(ke){O.supportsExecutionOrder=ke,_()},get rendererScripts(){return O.preloads?O.preloads.map($.NotebookRendererScript.to):[]},get executeHandler(){return ue},set executeHandler(ke){ue=ke??q},get interruptHandler(){return pe},set interruptHandler(ke){pe=ke,O.supportsInterrupt=!!ke,_()},createNotebookCellExecution(ke){if(W)throw new Error("notebook controller is DISPOSED");if(!Y.has(ke.notebook.uri))throw G.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ke.notebook.uri.toString()}`);return G._createNotebookCellExecution(ke,p(d.identifier,this.id))},createNotebookExecution(ke){if((0,c.$$E)(d,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!Y.has(ke.uri))throw G.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ke.uri.toString()}`);return G._createNotebookExecution(ke,p(d.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${B}], DISPOSED`),W=!0,this.j.delete(B),N.dispose(),H.dispose(),j.dispose(),this.a.$removeKernel(B))},updateNotebookAffinity(ke,Ce){Ce===u.NotebookControllerAffinity2.Hidden&&(0,c.$$E)(d,"notebookControllerAffinityHidden"),G.a.$updateNotebookPriority(B,ke.uri,Ce)},onDidReceiveMessage:j.event,postMessage(ke,Ce){return(0,c.$$E)(d,"notebookMessaging"),G.a.$postMessage(B,Ce&&G.n.getIdByEditor(Ce),ke)},asWebviewUri(ke){return(0,c.$$E)(d,"notebookMessaging"),(0,t.$Rlb)(ke,G.m.remote)}};return this.j.set(B,{extensionId:d.identifier,controller:ce,onDidReceiveMessage:j,onDidChangeSelection:H,associatedNotebooks:Y}),ce}getIdByController(d){for(const[A,E]of this.j)if(E.controller===d)return p(E.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,A){const E=this.f++,a=this;this.q.trace(`NotebookControllerDetectionTask[${E}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(E,A);const o={dispose:()=>{this.e.delete(E),a.a.$removeKernelDetectionTask(E)}};return this.e.set(E,o),o}registerKernelSourceActionProvider(d,A,E){const a=this.h++,o=typeof E.onDidChangeNotebookKernelSourceActions=="function"?a:void 0,L=this;this.g.set(a,E),this.q.trace(`NotebookKernelSourceActionProvider[${a}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(a,a,A);let B;return o!==void 0&&(B=E.onDidChangeNotebookKernelSourceActions(G=>this.a.$emitNotebookKernelSourceActionsChangeEvent(o))),{dispose:()=>{this.g.delete(a),L.a.$removeKernelSourceActionProvider(a,a),B?.dispose()}}}async $provideKernelSourceActions(d,A){const E=this.g.get(d);if(E){const a=new T.$jb;return this.i.add([a]),(await E.provideNotebookKernelSourceActions(A)??[]).map(L=>$.NotebookKernelSourceAction.from(L,this.o.converter,a))}return[]}$acceptNotebookAssociation(d,A,E){const a=this.j.get(d);if(a){const o=this.n.getNotebookDocument(k.URI.revive(A));E?a.associatedNotebooks.set(o.uri,!0):a.associatedNotebooks.delete(o.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,o.uri.toString(),E),a.onDidChangeSelection.fire({selected:E,notebook:o.apiNotebook})}}async $executeCells(d,A,E){const a=this.j.get(d);if(!a)return;const o=this.n.getNotebookDocument(k.URI.revive(A)),L=[];for(const B of E){const G=o.getCell(B);G&&L.push(G.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,o.uri.toString(),L.length),await a.controller.executeHandler.call(a.controller,L,o.apiNotebook,a.controller)}catch(B){this.q.error(`NotebookController[${d}] execute cells FAILED`,B),console.error(B)}}async $cancelCells(d,A,E){const a=this.j.get(d);if(!a)return;const o=this.n.getNotebookDocument(k.URI.revive(A));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,o.apiNotebook);else for(const L of E){const B=o.getCell(L);B&&this.b.get(B.uri)?.cancel()}if(a.controller.interruptHandler){const L=this.c.get(o.uri);E.length&&Array.isArray(L)&&L.length&&L.forEach(B=>B.dispose())}}$acceptKernelMessageFromRenderer(d,A,E){const a=this.j.get(d);if(!a)return;const o=this.n.getEditorById(A);a.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:E}))}$cellExecutionChanged(d,A,E){const o=this.n.getNotebookDocument(k.URI.revive(d)).getCell(A);if(o){const L=E?$.NotebookCellExecutionState.to(E):u.NotebookCellExecutionState.Idle;L!==void 0&&this.l.fire({cell:o.apiCell,state:L})}}_createNotebookCellExecution(d,A){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!a)throw new Error("invalid cell");if(this.b.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const o=new i(A,a,this.a);this.b.set(a.uri,o);const L=o.onDidChangeState(()=>{o.state===y.Resolved&&(o.dispose(),L.dispose(),this.b.delete(a.uri))});return o.asApiObject()}_createNotebookExecution(d,A){const E=this.n.getNotebookDocument(d.uri),a=d.getCells().find(B=>{const G=E.getCellFromApiCell(B);return G&&this.b.has(G.uri)});if(a)throw new Error(`duplicate cell execution for ${a.document.uri}`);if(this.c.has(E.uri))throw new Error(`duplicate notebook execution for ${E.uri}`);const o=new n(A,E,this.a),L=o.onDidChangeState(()=>{o.state===l.Resolved&&(o.dispose(),L.dispose(),this.c.delete(E.uri))});return this.c.set(E.uri,[o,L]),o.asApiObject()}};e.$B_b=v=qe([Ve(4,F.$Ni)],v);var y;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(y||(y={}));class i extends T.$kb{get state(){return this.f}constructor(d,A,E){super(),this.j=A,this.k=E,this.b=i.a++,this.c=new z.$5c,this.onDidChangeState=this.c.event,this.f=y.Init,this.g=this.B(new S.$bd),this.h=new s(10,a=>this.m(a)),this.i=A.internalMetadata.executionOrder,this.k.$createExecution(this.b,d,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(d){await this.h.addItem(d)}async m(d){const A=Array.isArray(d)?d:[d];return this.k.$updateExecution(this.b,new w.$Mz(A))}n(){if(this.f===y.Init)throw new Error("Must call start before modifying cell output");if(this.f===y.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(d){let A=this.j;if(d&&(A=this.j.notebook.getCellFromApiCell(d)),!A)throw new Error("INVALID cell");return A.handle}s(d){return d.map(A=>{const E=u.$CK.ensureUniqueMimeTypes(A.items,!0);return E===A.items?$.NotebookCellOutput.from(A):$.NotebookCellOutput.from({items:E,id:A.id,metadata:A.metadata})})}async t(d,A,E){const a=this.r(A),o=this.s((0,g.$Gf)(d));return this.l({editType:r.CellExecutionUpdateType.Output,cellHandle:a,append:E,outputs:o})}async w(d,A,E){return d=u.$CK.ensureUniqueMimeTypes((0,g.$Gf)(d),!0),this.l({editType:r.CellExecutionUpdateType.OutputItems,items:d.map($.NotebookCellOutputItem.from),outputId:A.id,append:E})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.j.apiCell},get executionOrder(){return d.i},set executionOrder(E){d.i=E,d.m([{editType:r.CellExecutionUpdateType.ExecutionState,executionOrder:d.i}])},start(E){if(d.f===y.Resolved||d.f===y.Started)throw new Error("Cannot call start again");d.f=y.Started,d.c.fire(),d.m({editType:r.CellExecutionUpdateType.ExecutionState,runStartTime:E})},end(E,a){if(d.f===y.Resolved)throw new Error("Cannot call resolve twice");d.f=y.Resolved,d.c.fire(),d.h.flush(),d.k.$completeExecution(d.b,new w.$Mz({runEndTime:a,lastRunSuccess:E}))},clearOutput(E){return d.n(),d.t([],E,!1)},appendOutput(E,a){return d.n(),d.t(E,a,!0)},replaceOutput(E,a){return d.n(),d.t(E,a,!1)},appendOutputItems(E,a){return d.n(),d.w(E,a,!0)},replaceOutputItems(E,a){return d.n(),d.w(E,a,!1)}})}}i.a=0;var l;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(l||(l={}));class n extends T.$kb{get state(){return this.f}constructor(d,A,E){super(),this.h=A,this.i=E,this.b=n.a++,this.c=new z.$5c,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new S.$bd),this.i.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}n.a=0;class s{constructor(d,A){this.e=d,this.f=A,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new C.$Lg,this.b=Date.now(),(0,C.$sg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const A=this.a;return this.a=[],this.f(A).finally(()=>d.complete())}}function p(I,d){return`${I.value}/${d}`}e.$C_b=p}),define(Re[238],Fe([1,0,5,4,103]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D_b=void 0;class z{constructor(f,k){this.c=k,this.a=new Map,this.b=f.getProxy(C.$$I.MainThreadNotebookRenderers)}$postRendererMessage(f,k,m){const F=this.c.getEditorById(f);this.a.get(k)?.fire({editor:F.apiEditor,message:m})}createRendererMessaging(f,k){if(!f.contributes?.notebookRenderer?.some(F=>F.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);return{onDidReceiveMessage:(F,D,h)=>this.d(k).event(F,D,h),postMessage:(F,D)=>{S.$m_b.apiEditorsToExtHost.has(F)&&([F,D]=[D,F]);const h=D&&S.$m_b.apiEditorsToExtHost.get(D);return this.b.$postMessage(h?.id,k,F)}}}d(f){let k=this.a.get(f);return k||(k=new g.$5c({onDidRemoveLastListener:()=>{k?.dispose(),this.a.delete(f)}}),this.a.set(f,k),k)}}e.$D_b=z}),define(Re[239],Fe([1,0,6,10,2,26,4]),function(te,e,g,C,S,z,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=void 0;class f{constructor(m){this.b=new Map,this.a=m.getProxy(T.$$I.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,F,D){if((0,z.$$E)(m,"profileContentHandlers"),this.b.has(F))throw new Error(`Handler with id '${F}' already registered`);return this.b.set(F,D),this.a.$registerProfileContentHandler(F,D.name,D.description,m.identifier.value),(0,g.$ib)(()=>{this.b.delete(F),this.a.$unregisterProfileContentHandler(F)})}async $saveProfile(m,F,D,h){const b=this.b.get(m);if(!b)throw new Error(`Unknown handler with id: ${m}`);return b.saveProfile(F,D,h)}async $readProfile(m,F,D){const h=this.b.get(m);if(!h)throw new Error(`Unknown handler with id: ${m}`);return h.readProfile((0,C.$ge)(F)?F:S.URI.revive(F),D)}}e.$H_b=f}),define(Re[240],Fe([1,0,2,4,16,8]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=void 0;class T{constructor(k,m){this.d=m,this.c=new Map,this.b=k.getProxy(C.$$I.MainThreadQuickDiff)}$provideOriginalResource(k,m,F){const D=g.URI.revive(m),h=this.c.get(k);return h?(0,S.$kg)(()=>h.provideOriginalResource(D,F)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(k,m,F,D){const h=T.a++;return this.c.set(h,m),this.b.$registerQuickDiffProvider(h,z.DocumentSelector.from(k,this.d),F,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(h),this.c.delete(h)}}}}e.$I_b=T,T.a=0}),define(Re[241],Fe([1,0,22,5,6,4,2,7,9,18,29,40,26,8]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J$b=void 0;function $(u,t,r){const c=u.getProxy(z.$$I.MainThreadQuickOpen);class w{constructor(d,A){this.e=new Map,this.f=0,this.a=d,this.b=A}showQuickPick(d,A,E,a=g.CancellationToken.None){this.c=void 0;const o=Promise.resolve(A),L=++this.f,B=c.$show(L,{title:E?.title,placeHolder:E?.placeHolder,matchOnDescription:E?.matchOnDescription,matchOnDetail:E?.matchOnDetail,ignoreFocusLost:E?.ignoreFocusOut,canPickMany:E?.canPickMany},a),G={},q=B.then(()=>G);return Promise.race([q,o]).then(W=>{if(W===G)return;const N=(0,h.$0E)(d,"quickPickItemTooltip"),H=(0,h.$0E)(d,"quickPickItemIcon");return o.then(j=>{const O=[];for(let ue=0;ue<j.length;ue++){const pe=j[ue];if(typeof pe=="string")O.push({label:pe,handle:ue});else if(pe.kind===f.QuickPickItemKind.Separator)O.push({type:"separator",label:pe.label});else{pe.tooltip&&!N&&console.warn(`Extension '${d.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`),pe.iconPath&&!H&&console.warn(`Extension '${d.identifier.value}' uses an icon which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`);const Pe=pe.iconPath&&H?n(pe.iconPath):void 0;O.push({label:pe.label,iconPath:Pe?.iconPath,iconClass:Pe?.iconClass,description:pe.description,detail:pe.detail,picked:pe.picked,alwaysShow:pe.alwaysShow,tooltip:N?b.MarkdownString.fromStrict(pe.tooltip):void 0,handle:ue})}}return E&&typeof E.onDidSelectItem=="function"&&(this.c=ue=>{E.onDidSelectItem(j[ue])}),c.$setItems(L,O),B.then(ue=>{if(typeof ue=="number")return j[ue];if(Array.isArray(ue))return ue.map(pe=>j[pe])})})}).then(void 0,W=>{if(!(0,k.$1)(W))return c.$setError(L,W),Promise.reject(W)})}$onItemSelected(d){this.c?.(d)}showInput(d,A=g.CancellationToken.None){return this.d=d?.validateInput,c.$input(d,typeof this.d=="function",A).then(void 0,E=>{if(!(0,k.$1)(E))return Promise.reject(E)})}async $validateInput(d){if(!this.d)return;const A=await this.d(d);if(!A||typeof A=="string")return A;let E;switch(A.severity){case f.InputBoxValidationSeverity.Info:E=F.default.Info;break;case f.InputBoxValidationSeverity.Warning:E=F.default.Warning;break;case f.InputBoxValidationSeverity.Error:E=F.default.Error;break;default:E=A.message?F.default.Error:F.default.Ignore;break}return{content:A.message,severity:E}}async showWorkspaceFolderPick(d,A=g.CancellationToken.None){const E=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!E)return;const a=await this.a.getWorkspaceFolders2();if(a)return a.find(o=>o.uri.toString()===E.uri.toString())}createQuickPick(d){const A=new s(d,()=>this.e.delete(A._id));return this.e.set(A._id,A),A}createInputBox(d){const A=new p(d,()=>this.e.delete(A._id));return this.e.set(A._id,A),A}$onDidChangeValue(d,A){this.e.get(d)?._fireDidChangeValue(A)}$onDidAccept(d){this.e.get(d)?._fireDidAccept()}$onDidChangeActive(d,A){const E=this.e.get(d);E instanceof s&&E._fireDidChangeActive(A)}$onDidChangeSelection(d,A){const E=this.e.get(d);E instanceof s&&E._fireDidChangeSelection(A)}$onDidTriggerButton(d,A){this.e.get(d)?._fireDidTriggerButton(A)}$onDidTriggerItemButton(d,A,E){const a=this.e.get(d);a instanceof s&&a._fireDidTriggerItemButton(A,E)}$onDidHide(d){this.e.get(d)?._fireDidHide()}}class v{constructor(d,A){this.x=d,this.y=A,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new C.$5c,this.q=new C.$5c,this.r=new C.$5c,this.s=new C.$5c,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(d){this.b=d,this.z({title:d})}get step(){return this.c}set step(d){this.c=d,this.z({step:d})}get totalSteps(){return this.d}set totalSteps(d){this.d=d,this.z({totalSteps:d})}get enabled(){return this.g}set enabled(d){this.g=d,this.z({enabled:d})}get busy(){return this.j}set busy(d){this.j=d,this.z({busy:d})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(d){this.k=d,this.z({ignoreFocusOut:d})}get value(){return this.l}set value(d){this.l=d,this.z({value:d})}get placeholder(){return this.m}set placeholder(d){this.m=d,this.z({placeholder:d})}get buttons(){return this.n}set buttons(d){this.n=d.slice(),this.o.clear(),d.forEach((A,E)=>{const a=A===f.$vK.Back?-1:E;this.o.set(a,A)}),this.z({buttons:d.map((A,E)=>({...n(A.iconPath),tooltip:A.tooltip,handle:A===f.$vK.Back?-1:E}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(d){this.l=d,this.q.fire(d)}_fireDidTriggerButton(d){const A=this.o.get(d);A&&this.r.fire(A)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,S.$fb)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(d){if(!this.v){for(const A of Object.keys(d)){const E=d[A];this.u[A]=E===void 0?null:E}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}v.a=1;function y(I){if(I instanceof f.$8J)return{id:I.id};const d=l(I),A=i(I);return{dark:typeof d=="string"?T.URI.file(d):d,light:typeof A=="string"?T.URI.file(A):A}}function i(I){return typeof I=="object"&&"light"in I?I.light:I}function l(I){return typeof I=="object"&&"dark"in I?I.dark:I}function n(I){const d=y(I);let A,E;return"id"in d?E=D.ThemeIcon.asClassName(d):A=d,{iconPath:A,iconClass:E}}class s extends v{constructor(d,A){super(d.identifier,A),this.O=d,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new C.$5c,this.L=[],this.M=new C.$5c,this.N=new C.$5c,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(d){this.B=d.slice(),this.C.clear(),this.D.clear(),d.forEach((o,L)=>{this.C.set(L,o),this.D.set(o,L)});const A=(0,h.$0E)(this.O,"quickPickItemTooltip"),E=(0,h.$0E)(this.O,"quickPickItemIcon"),a=[];for(let o=0;o<d.length;o++){const L=d[o];if(L.kind===f.QuickPickItemKind.Separator)a.push({type:"separator",label:L.label});else{L.tooltip&&!A&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),L.iconPath&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses an icon which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const B=L.iconPath&&E?n(L.iconPath):void 0;a.push({handle:o,label:L.label,iconPath:B?.iconPath,iconClass:B?.iconClass,description:L.description,detail:L.detail,picked:L.picked,alwaysShow:L.alwaysShow,tooltip:A?b.MarkdownString.fromStrict(L.tooltip):void 0,buttons:L.buttons?.map((G,q)=>({...n(G.iconPath),tooltip:G.tooltip,handle:q}))})}}this.z({items:a})}get canSelectMany(){return this.E}set canSelectMany(d){this.E=d,this.z({canSelectMany:d})}get matchOnDescription(){return this.F}set matchOnDescription(d){this.F=d,this.z({matchOnDescription:d})}get matchOnDetail(){return this.G}set matchOnDetail(d){this.G=d,this.z({matchOnDetail:d})}get sortByLabel(){return this.H}set sortByLabel(d){this.H=d,this.z({sortByLabel:d})}get keepScrollPosition(){return this.I}set keepScrollPosition(d){this.I=d,this.z({keepScrollPosition:d})}get activeItems(){return this.J}set activeItems(d){this.J=d.filter(A=>this.D.has(A)),this.z({activeItems:this.J.map(A=>this.D.get(A))})}get selectedItems(){return this.L}set selectedItems(d){this.L=d.filter(A=>this.D.has(A)),this.z({selectedItems:this.L.map(A=>this.D.get(A))})}_fireDidChangeActive(d){const A=(0,m.$jf)(d.map(E=>this.C.get(E)));this.J=A,this.K.fire(A)}_fireDidChangeSelection(d){const A=(0,m.$jf)(d.map(E=>this.C.get(E)));this.L=A,this.M.fire(A)}_fireDidTriggerItemButton(d,A){const E=this.C.get(d);if(!E||!E.buttons||!E.buttons.length)return;const a=E.buttons[A];a&&this.N.fire({button:a,item:E})}}class p extends v{constructor(d,A){super(d.identifier,A),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(d){this.B=d,this.z({password:d})}get prompt(){return this.C}set prompt(d){this.C=d,this.z({prompt:d})}get valueSelection(){return this.D}set valueSelection(d){this.D=d,this.z({valueSelection:d})}get validationMessage(){return this.E}set validationMessage(d){this.E=d,d?typeof d=="string"?this.z({validationMessage:d,severity:F.default.Error}):this.z({validationMessage:d.message,severity:d.severity??F.default.Error}):this.z({validationMessage:void 0,severity:F.default.Ignore})}}return new w(t,r)}e.$J$b=$});var Te=this&&this.__classPrivateFieldGet||function(te,e,g,C){if(g==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?C:g==="a"?C.call(te):C?C.value:e.get(te)},Ye=this&&this.__classPrivateFieldSet||function(te,e,g,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g};define(Re[242],Fe([1,0,2,5,65,6,16,4,18,131,15,24,40,8,26,14]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u){"use strict";var t,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$L$b=e.$K$b=void 0;function w(a){if(a)return typeof a.iconPath=="string"?g.URI.file(a.iconPath):g.URI.isUri(a.iconPath)||h.ThemeIcon.isThemeIcon(a.iconPath)?a.iconPath:void 0}function v(a,o){if(!a.iconPath&&!o.iconPath)return 0;if(a.iconPath){if(!o.iconPath)return 1}else return-1;const L=typeof a.iconPath=="string"?a.iconPath:g.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id,B=typeof o.iconPath=="string"?o.iconPath:g.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id;return(0,m.$5p)(L,B)}function y(a,o){let L=0;if(a.strikeThrough!==o.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==o.faded)return a.faded?1:-1;if(a.tooltip!==o.tooltip)return(a.tooltip||"").localeCompare(o.tooltip||"");if(L=v(a,o),L!==0)return L;if(a.light&&o.light)L=v(a.light,o.light);else{if(a.light)return 1;if(o.light)return-1}if(L!==0)return L;if(a.dark&&o.dark)L=v(a.dark,o.dark);else{if(a.dark)return 1;if(o.dark)return-1}return L}function i(a,o){if(a.command!==o.command)return a.command<o.command?-1:1;if(a.title!==o.title)return a.title<o.title?-1:1;if(a.tooltip!==o.tooltip){if(a.tooltip!==void 0&&o.tooltip!==void 0)return a.tooltip<o.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(a.arguments===o.arguments)return 0;if(a.arguments)if(o.arguments){if(a.arguments.length!==o.arguments.length)return a.arguments.length-o.arguments.length}else return 1;else return-1;for(let L=0;L<a.arguments.length;L++){const B=a.arguments[L],G=o.arguments[L];if(B!==G)return B<G?-1:1}return 0}function l(a,o){let L=(0,m.$5p)(a.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(L!==0)return L;if(a.command&&o.command)L=i(a.command,o.command);else{if(a.command)return 1;if(o.command)return-1}if(L!==0)return L;if(a.decorations&&o.decorations)L=y(a.decorations,o.decorations);else{if(a.decorations)return 1;if(o.decorations)return-1}return L}function n(a,o){for(let L=0;L<a.length;L++)if(a[L]!==o[L])return!1;return!0}function s(a,o){return a.command===o.command&&a.title===o.title&&a.tooltip===o.tooltip&&(a.arguments&&o.arguments?n(a.arguments,o.arguments):a.arguments===o.arguments)}function p(a,o){return(0,k.$$e)(a,o,s)}class I{get value(){return this.d}set value(o){o=o??"",Te(this,t,"f").$setInputBoxValue(this.l,o),this.n(o)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(o){Te(this,t,"f").$setInputBoxPlaceholder(this.l,o),this.f=o}get validateInput(){return(0,$.$$E)(this.k,"scmValidation"),this.g}set validateInput(o){if((0,$.$$E)(this.k,"scmValidation"),o&&typeof o!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=o,Te(this,t,"f").$setValidationProviderIsEnabled(this.l,!!o)}get enabled(){return this.h}set enabled(o){o=!!o,this.h!==o&&(this.h=o,Te(this,t,"f").$setInputBoxEnablement(this.l,o))}get visible(){return this.j}set visible(o){o=!!o,this.j!==o&&(this.j=o,Te(this,t,"f").$setInputBoxVisibility(this.l,o))}get document(){return(0,$.$$E)(this.k,"scmTextDocument"),Te(this,r,"f").getDocument(this.m)}constructor(o,L,B,G,q){this.k=o,this.l=G,this.m=q,t.set(this,void 0),r.set(this,void 0),this.d="",this.e=new C.$5c,this.f="",this.h=!0,this.j=!0,Ye(this,r,L,"f"),Ye(this,t,B,"f")}showValidationMessage(o,L){(0,$.$$E)(this.k,"scmValidation"),Te(this,t,"f").$showValidationMessage(this.l,o,L)}$onInputBoxValueChange(o){this.n(o)}n(o){this.d=o,this.e.fire(o)}}e.$K$b=I,t=new WeakMap,r=new WeakMap;class d{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(o){this.v=o,this.q.$updateGroupLabel(this.t,this.handle,o)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(o){this.p=o,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(o){this.f=[...o],this.k.fire()}constructor(o,L,B,G,q){this.q=o,this.s=L,this.t=B,this.u=G,this.v=q,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new C.$5c,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new C.$5c,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=d.d++}getResourceState(o){return this.g.get(o)}$executeResourceCommand(o,L){const B=this.h.get(o);return B?(0,T.$kg)(()=>this.s.executeCommand(B.command,...B.arguments||[],L)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const o=[...this.f].sort(l),B=(0,k.$ff)(this.o,o,l).map(W=>{const N=W.toInsert.map(H=>{const j=this.e++;this.g.set(j,H);const O=H.resourceUri;let ue;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const Q=new z.$jb;ue=this.s.converter.toInternal(H.command,Q),this.j.set(j,Q)}else this.h.set(j,H.command);const pe=w(H.decorations),Pe=H.decorations&&w(H.decorations.light)||pe,_=H.decorations&&w(H.decorations.dark)||pe,Y=[Pe,_],ce=H.decorations&&H.decorations.tooltip||"",ke=H.decorations&&!!H.decorations.strikeThrough,Ce=H.decorations&&!!H.decorations.faded,me=H.contextValue||"";return{rawResource:[j,O,Y,ce,ke,Ce,me,ue],handle:j}});return{start:W.start,deleteCount:W.deleteCount,toInsert:N}}),G=B.map(({start:W,deleteCount:N,toInsert:H})=>[W,N,H.map(j=>j.rawResource)]),q=B.reverse();for(const{start:W,deleteCount:N,toInsert:H}of q){const j=H.map(ue=>ue.handle),O=this.n.splice(W,N,...j);for(const ue of O)this.g.delete(ue),this.h.delete(ue),this.j.get(ue)?.dispose(),this.j.delete(ue)}return this.o=o,G}dispose(){this.l=!0,this.m.fire()}}d.d=0;class A{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(o){this.g!==o&&(this.g=o,Te(this,c,"f").$updateSourceControl(this.t,{count:o}))}get quickDiffProvider(){return this.h}set quickDiffProvider(o){this.h=o;let L;(0,$.$0E)(this.u,"quickDiffProvider")&&(L=o?.label),Te(this,c,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!o,quickDiffLabel:L})}get commitTemplate(){return this.j}set commitTemplate(o){o!==this.j&&(this.j=o,Te(this,c,"f").$updateSourceControl(this.t,{commitTemplate:o}))}get acceptInputCommand(){return this.l}set acceptInputCommand(o){this.k.value=new z.$jb,this.l=o;const L=this.v.converter.toInternal(o,this.k.value);Te(this,c,"f").$updateSourceControl(this.t,{acceptInputCommand:L})}get actionButton(){return(0,$.$$E)(this.u,"scmActionButton"),this.n}set actionButton(o){(0,$.$$E)(this.u,"scmActionButton"),this.m.value=new z.$jb,this.n=o;const L=o!==void 0?{command:this.v.converter.toInternal(o.command,this.m.value),secondaryCommands:o.secondaryCommands?.map(B=>B.map(G=>this.v.converter.toInternal(G,this.m.value))),description:o.description,enabled:o.enabled}:void 0;Te(this,c,"f").$updateSourceControl(this.t,{actionButton:L??null})}get statusBarCommands(){return this.p}set statusBarCommands(o){if(this.p&&o&&p(this.p,o))return;this.o.value=new z.$jb,this.p=o;const L=(o||[]).map(B=>this.v.converter.toInternal(B,this.o.value));Te(this,c,"f").$updateSourceControl(this.t,{statusBarCommands:L})}get selected(){return this.q}constructor(o,L,B,G,q,W,N){this.u=o,this.v=G,this.w=q,this.x=W,this.y=N,c.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new z.$lb,this.l=void 0,this.m=new z.$lb,this.o=new z.$lb,this.p=void 0,this.q=!1,this.s=new C.$5c,this.onDidChangeSelection=this.s.event,this.t=A.d++,this.z=new Map,this.A=new Set,Ye(this,c,B,"f");const H=g.URI.from({scheme:u.Schemas.vscodeSourceControl,path:`${q}/scm${this.t}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this.f=new I(o,L,Te(this,c,"f"),this.t,H),Te(this,c,"f").$registerSourceControl(this.t,q,W,N,H)}createResourceGroup(o,L){const B=new d(Te(this,c,"f"),this.v,this.t,o,L),G=C.Event.once(B.onDidDispose)(()=>this.z.delete(B));return this.z.set(B,G),this.eventuallyAddResourceGroups(),B}eventuallyAddResourceGroups(){const o=[],L=[];for(const[B,G]of this.z){G.dispose();const q=B.onDidUpdateResourceStates(()=>{this.A.add(B),this.eventuallyUpdateResourceStates()});C.Event.once(B.onDidDispose)(()=>{this.A.delete(B),q.dispose(),this.e.delete(B.handle),Te(this,c,"f").$unregisterGroup(this.t,B.handle)}),o.push([B.handle,B.id,B.label,B.features]);const W=B._takeResourceStateSnapshot();W.length>0&&L.push([B.handle,W]),this.e.set(B.handle,B)}Te(this,c,"f").$registerGroups(this.t,o,L),this.z.clear()}eventuallyUpdateResourceStates(){const o=[];this.A.forEach(L=>{const B=L._takeResourceStateSnapshot();B.length!==0&&o.push([L.handle,B])}),o.length>0&&Te(this,c,"f").$spliceResourceStates(this.t,o),this.A.clear()}getResourceGroup(o){return this.e.get(o)}setSelectionState(o){this.q=o,this.s.fire(o)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(o=>o.dispose()),Te(this,c,"f").$unregisterSourceControl(this.t)}}c=new WeakMap,A.d=0,qe([(0,S.$Qg)(100)],A.prototype,"eventuallyAddResourceGroups",null),qe([(0,S.$Qg)(100)],A.prototype,"eventuallyUpdateResourceStates",null);let E=e.$L$b=class Rn{get onDidChangeActiveProvider(){return this.j.event}constructor(o,L,B,G){this.l=L,this.m=B,this.n=G,this.g=new Map,this.h=new D.$Fl,this.j=new C.$5c,this.e=o.getProxy(f.$$I.MainThreadSCM),this.f=o.getProxy(f.$$I.MainThreadTelemetry),L.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const W=this.g.get(q.sourceControlHandle);if(!W)return q;const N=W.getResourceGroup(q.groupHandle);return N?N.getResourceState(q.handle):q}else if(q&&q.$mid===4){const W=this.g.get(q.sourceControlHandle);return W?W.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const W=this.g.get(q.handle);return W||q}return q}})}createSourceControl(o,L,B,G){this.n.trace("ExtHostSCM#createSourceControl",o.identifier.value,L,B,G),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const q=Rn.d++,W=new A(o,this.m,this.e,this.l,L,B,G);this.g.set(q,W);const N=this.h.get(o.identifier)||[];return N.push(W),this.h.set(o.identifier,N),W}getLastInputBox(o){this.n.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const L=this.h.get(o.identifier),B=L&&L[L.length-1];return B&&B.inputBox}$provideOriginalResource(o,L,B){const G=g.URI.revive(L);this.n.trace("ExtHostSCM#$provideOriginalResource",o,G.toString());const q=this.g.get(o);return!q||!q.quickDiffProvider||!q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.$kg)(()=>q.quickDiffProvider.provideOriginalResource(G,B)).then(W=>W||null)}$onInputBoxValueChange(o,L){this.n.trace("ExtHostSCM#$onInputBoxValueChange",o);const B=this.g.get(o);return B&&B.inputBox.$onInputBoxValueChange(L),Promise.resolve(void 0)}$executeResourceCommand(o,L,B,G){this.n.trace("ExtHostSCM#$executeResourceCommand",o,L,B);const q=this.g.get(o);if(!q)return Promise.resolve(void 0);const W=q.getResourceGroup(L);return W?W.$executeResourceCommand(B,G):Promise.resolve(void 0)}$validateInput(o,L,B){this.n.trace("ExtHostSCM#$validateInput",o);const G=this.g.get(o);return!G||!G.inputBox.validateInput?Promise.resolve(void 0):(0,T.$kg)(()=>G.inputBox.validateInput(L,B)).then(q=>{if(!q)return Promise.resolve(void 0);const W=b.MarkdownString.fromStrict(q.message);return W?Promise.resolve([W,q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(o){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&this.g.get(o)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=o,Promise.resolve(void 0)}};E.d=0,e.$L$b=E=qe([Ve(3,F.$Ni)],E)}),define(Re[84],Fe([1,0,4,5,3]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r$b=e.$q$b=void 0;class z{constructor(f){this.b=new C.$5c,this.onDidChangePassword=this.b.event,this.a=f.getProxy(g.$$I.MainThreadSecretState)}async $onDidChangePassword(f){this.b.fire(f)}get(f,k){return this.a.$getPassword(f,k)}store(f,k,m){return this.a.$setPassword(f,k,m)}delete(f,k){return this.a.$deletePassword(f,k)}}e.$q$b=z,e.$r$b=(0,S.$lh)("IExtHostSecretState")}),define(Re[243],Fe([1,0,4,7]),function(te,e,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M_b=void 0;class S{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(g.$$I.MainThreadSemanticSimilarity)}async $provideSimilarityScore(T,f,k,m){if(this.a.size===0)throw new Error("No semantic similarity providers registered");const F=this.a.get(T);if(!F)throw new Error("Semantic similarity provider not found");return await F.provideSimilarityScore(f,k,m)}registerSemanticSimilarityProvider(T,f){const k=this.b;return this.b++,this.a.set(k,f),this.c.$registerSemanticSimilarityProvider(k),new C.$aJ(()=>{this.c.$unregisterSemanticSimilarityProvider(k),this.a.delete(k)})}}e.$M_b=S}),define(Re[244],Fe([1,0,4,8,2]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O_b=void 0;class z{constructor(f,k){this.d=k,this.c=new Map,this.b=f.getProxy(g.$$I.MainThreadShare)}async $provideShare(f,k,m){return await this.c.get(f)?.provideShare({selection:C.Range.to(k.selection),resourceUri:S.URI.revive(k.resourceUri)},m)??void 0}registerShareProvider(f,k){const m=z.a++;return this.c.set(m,k),this.b.$registerShareProvider(m,C.DocumentSelector.from(f,this.d),k.id,k.label,k.priority),{dispose:()=>{this.b.$unregisterShareProvider(m),this.c.delete(m)}}}}e.$O_b=z,z.a=0});var Ye=this&&this.__classPrivateFieldSet||function(te,e,g,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Te=this&&this.__classPrivateFieldGet||function(te,e,g,C){if(g==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?C:g==="a"?C.call(te):C?C.value:e.get(te)};define(Re[245],Fe([1,0,7,4,152,6,8,10]),function(te,e,g,C,S,z,T,f){"use strict";var k,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$N$b=e.$M$b=void 0;class F{constructor($,u,t,r,c,w=g.StatusBarAlignment.Left,v){if(k.set(this,void 0),m.set(this,void 0),this.i=!1,this.k="",this.q=new z.$jb,Ye(this,k,$,"f"),Ye(this,m,u,"f"),c&&r){this.c=(0,g.$LJ)(r.identifier,c);const y=t.get(this.c);y&&(w=y.alignLeft?g.StatusBarAlignment.Left:g.StatusBarAlignment.Right,v=y.priority,this.j=!0,this.name=y.name,this.text=y.text,this.tooltip=y.tooltip,this.command=y.command,this.accessibilityInformation=y.accessibilityInformation)}else this.c=String(F.a++);this.e=r,this.f=c,this.g=w,this.h=this.u(v)}u($){if((0,f.$ke)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!F.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new z.$jb,typeof $=="string"?this.r={fromApi:$,internal:Te(this,m,"f").toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:Te(this,m,"f").toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Te(this,k,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let u;this.m?u=this.m:u=(0,S.localize)(0,null,this.e.displayName||this.e.name);let t=this.n;this.o&&(t=F.b.get(this.o.id));const r=T.MarkdownString.fromStrict(this.l);Te(this,k,"f").$setEntry(this.c,$,this.e?.identifier.value,u,this.k,r,this.r?.internal,t,this.o,this.g===g.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$M$b=F,k=new WeakMap,m=new WeakMap,F.a=0,F.b=new Map([["statusBarItem.errorBackground",new g.$9J("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.$9J("statusBarItem.warningForeground")]]);class D{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,S.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const u={message:$};return this.b.unshift(u),this.c(),new g.$aJ(()=>{const t=this.b.indexOf(u);t>=0&&(this.b.splice(t,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class h{constructor($,u){this.e=new Map,this.a=$.getProxy(C.$$I.MainThreadStatusBar),this.b=u,this.c=new D(this)}$acceptStaticEntries($){for(const u of $)this.e.set(u.entryId,u)}createStatusBarEntry($,u,t,r){return new F(this.a,this.b,this.e,$,u,t,r)}setStatusBarMessage($,u){const t=this.c.setMessage($);let r;return typeof u=="number"?r=setTimeout(()=>t.dispose(),u):typeof u<"u"&&u.then(()=>t.dispose(),()=>t.dispose()),new g.$aJ(()=>{t.dispose(),clearTimeout(r)})}}e.$N$b=h}),define(Re[85],Fe([1,0,4,5,3]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f$b=e.$e$b=void 0;class z{constructor(f,k){this.c=k,this.b=new C.$5c,this.onDidChangeStorage=this.b.event,this.a=f.getProxy(g.$$I.MainThreadStorage)}registerExtensionStorageKeysToSync(f,k){this.a.$registerExtensionStorageKeysToSync(f,k)}async initializeExtensionStorage(f,k,m){const F=await this.a.$initializeExtensionStorage(f,k);let D;return F&&(D=this.d(f,k,F)),D||m}setValue(f,k,m){return this.a.$setValue(f,k,m)}$acceptValue(f,k,m){const F=this.d(f,k,m);F&&this.b.fire({shared:f,key:k,value:F})}d(f,k,m){try{return JSON.parse(m)}catch(F){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${k}, global: ${f}): ${F}`)}}}e.$e$b=z,e.$f$b=(0,S.$lh)("IExtHostStorage")}),define(Re[86],Fe([1,0,3,27,15,61,2]),function(te,e,g,C,S,z,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l$b=e.$k$b=void 0,e.$k$b=(0,g.$lh)("IExtensionStoragePaths");let f=e.$l$b=class{constructor(m,F,D){this.d=F,this.f=D,this.a=m.workspace??void 0,this.b=m.environment,this.whenReady=this.h().then(h=>this.c=h)}async g(m){return T.URI.joinPath(this.b.workspaceStorageHome,m)}async h(){if(!this.a)return Promise.resolve(void 0);const m=this.a.id,F=await this.g(m);try{return await this.f.value.stat(F),this.d.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",F),await this.f.value.createDirectory(F),await this.f.value.writeFile(T.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:T.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),F}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(m){if(this.c)return T.URI.joinPath(this.c,m.identifier.value)}globalValue(m){return T.URI.joinPath(this.b.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$l$b=f=qe([Ve(0,C.$qL),Ve(1,S.$Ni),Ve(2,z.$j$b)],f)}),define(Re[62],Fe([1,0,5,4,3,2,17,6,7,154,9,180,22,36,181,40,10,16,8,26]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t,r,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p$b=e.$o$b=e.$n$b=e.$m$b=void 0,e.$m$b=(0,S.$lh)("IExtHostTerminalService");class v{constructor(a,o,L,B){this.j=a,this._id=o,this.k=L,this.l=B,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.k=Object.freeze(this.k),this.b=new Promise(q=>this.f=q);const G=this;this.value={get name(){return G.l||""},get processId(){return G.b},get creationOptions(){return G.k},get exitStatus(){return G.h},get state(){return G.i},sendText(q,W=!0){G.n(),G.j.$sendText(G._id,q,W)},show(q){G.n(),G.j.$show(G._id,q)},hide(){G.n(),G.j.$hide(G._id)},dispose(){G.a||(G.a=!0,G.j.$dispose(G._id))},get dimensions(){if(!(G.d===void 0||G.g===void 0))return{columns:G.d,rows:G.g}}}}async create(a,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.j.$createTerminal(this._id,{name:a.name,shellPath:(0,t.$ye)(a.shellPath),shellArgs:(0,t.$ye)(a.shellArgs),cwd:(0,t.$ye)(a.cwd),env:(0,t.$ye)(a.env),icon:(0,t.$ye)(I(a.iconPath)),color:u.ThemeColor.isThemeColor(a.color)?a.color.id:void 0,initialText:(0,t.$ye)(a.message),strictEnv:(0,t.$ye)(a.strictEnv),hideFromUser:(0,t.$ye)(a.hideFromUser),isFeatureTerminal:(0,t.$ye)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.$ye)(o?.useShellEnvironment),location:o?.location||this.m(a.location,o?.resolvedExtHostIdentifier),isTransient:(0,t.$ye)(a.isTransient)})}async createExtensionTerminal(a,o,L,B){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.j.$createTerminal(this._id,{name:this.l,isExtensionCustomPtyTerminal:!0,icon:L,color:u.ThemeColor.isThemeColor(B)?B.id:void 0,location:this.m(a,o),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}m(a,o){return typeof a=="object"?"parentTerminal"in a&&a.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in a?{viewColumn:c.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus}:void 0:a}n(){if(this.a)throw new Error("Terminal has already been disposed")}set name(a){this.l=a}setExitStatus(a,o){this.h=Object.freeze({code:a,reason:o})}setDimensions(a,o){return a===this.d&&o===this.g||a===0||o===0?!1:(this.d=a,this.g=o,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}_setProcessId(a){this.f?(this.f(a),this.f=void 0):this.b.then(o=>{o!==a&&(this.b=Promise.resolve(a))})}}e.$n$b=v;class y{get onProcessReady(){return this.b.event}constructor(a){this.g=a,this.id=0,this.shouldPersist=!1,this.a=new g.$5c,this.onProcessData=this.a.event,this.b=new g.$5c,this.d=new g.$5c,this.onDidChangeProperty=this.d.event,this.f=new g.$5c,this.onProcessExit=this.f.event}refreshProperty(a){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${a}`)}updateProperty(a,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${a}, value: ${o}`)}async start(){}shutdown(){this.g.close()}input(a){this.g.handleInput?.(a)}resize(a,o){this.g.setDimensions?.({columns:a,rows:o})}clearBuffer(){}async processBinary(a){}acknowledgeDataEvent(a){}async setUnicodeVersion(a){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(a){this.g.onDidWrite(o=>this.a.fire(o)),this.g.onDidClose?.((o=void 0)=>{this.f.fire(o===void 0?void 0:o)}),this.g.onDidOverrideDimensions?.(o=>{o&&this.d.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this.g.onDidChangeName?.(o=>{this.d.fire({type:"title",value:o})}),this.g.open(a||void 0),a&&this.g.setDimensions?.(a),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let i=1,l=e.$o$b=class extends f.$kb{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(a=>a.value)}get onDidWriteTerminalData(){return this.H.event}constructor(a,o){super(),this.f=[],this.g=new Map,this.h={},this.i={},this.j={},this.k=new Map,this.s=new Set,this.u=new Map,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new g.$5c,this.onDidCloseTerminal=this.z.event,this.C=new g.$5c,this.onDidOpenTerminal=this.C.event,this.D=new g.$5c,this.onDidChangeActiveTerminal=this.D.event,this.F=new g.$5c,this.onDidChangeTerminalDimensions=this.F.event,this.G=new g.$5c,this.onDidChangeTerminalState=this.G.event,this.I=new g.$5c,this.onDidChangeShell=this.I.event,this.a=o.getProxy(C.$$I.MainThreadTerminalService),this.n=new $.$Jhb(this.a.$sendProcessData),this.H=new g.$5c({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(a),this.B({dispose:()=>{for(const[L,B]of this.g)B.shutdown(!0)}})}getDefaultShell(a){return(a?this.m:this.l)?.path||""}getDefaultShellArgs(a){return(a?this.m:this.l)?.args||[]}createExtensionTerminal(a,o){const L=new v(this.a,(0,b.$3e)(),a,a.name),B=new y(a.pty);return L.createExtensionTerminal(a.location,this.J(a,o).resolvedExtHostIdentifier,I(a.iconPath),d(a.color)).then(G=>{const q=this.L(G,B);this.h[G]=q}),this.f.push(L),L.value}J(a,o){if(o=o||{},a.location&&typeof a.location=="object"&&"parentTerminal"in a.location){const L=a.location.parentTerminal;if(L){const B=this.f.find(G=>G.value===L);B&&(o.resolvedExtHostIdentifier=B._id)}}else a.location&&typeof a.location!="object"?o.location=a.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(a,o){if(!this.N(a))throw new Error(`Cannot resolve terminal with id ${a} for virtual process`);const B=new y(o),G=this.L(a,B);this.h[a]=G}async $acceptActiveTerminalChanged(a){const o=this.b;if(a===null){this.b=void 0,o!==this.b&&this.D.fire(this.b);return}const L=this.N(a);L&&(this.b=L,o!==this.b&&this.D.fire(this.b.value))}async $acceptTerminalProcessData(a,o){const L=this.N(a);L&&this.H.fire({terminal:L.value,data:o})}async $acceptTerminalDimensions(a,o,L){const B=this.N(a);B&&B.setDimensions(o,L)&&this.F.fire({terminal:B.value,dimensions:B.value.dimensions})}async $acceptTerminalMaximumDimensions(a,o,L){this.g.get(a)?.resize(o,L)}async $acceptTerminalTitleChange(a,o){const L=this.N(a);L&&(L.name=o)}async $acceptTerminalClosed(a,o,L){const B=this.P(this.f,a);if(B!==null){const G=this.f.splice(B,1)[0];G.setExitStatus(o,L),this.z.fire(G.value)}}$acceptTerminalOpened(a,o,L,B){if(o){const W=this.P(this.f,o);if(W!==null){this.f[W]._id=a,this.C.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const G={name:B.name,shellPath:B.executable,shellArgs:B.args,cwd:typeof B.cwd=="string"?B.cwd:z.URI.revive(B.cwd),env:B.env,hideFromUser:B.hideFromUser},q=new v(this.a,a,G,L);this.f.push(q),this.C.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(a,o){this.N(a)?._setProcessId(o)}async $startExtensionTerminal(a,o){const L=this.N(a);if(!L)return{message:(0,m.localize)(0,null,a)};L.isOpen||await new Promise(G=>{const q=this.onDidOpenTerminal(async W=>{W===L.value&&(q.dispose(),G())})});const B=this.g.get(a);B?B.startSendingEvents(o):this.i[a]={initialDimensions:o}}L(a,o){const L=new f.$jb;L.add(o.onProcessReady(G=>this.a.$sendProcessReady(a,G.pid,G.cwd,G.windowsPty))),L.add(o.onDidChangeProperty(G=>this.a.$sendProcessProperty(a,G))),this.n.startBuffering(a,o.onProcessData),L.add(o.onProcessExit(G=>this.M(a,G))),this.g.set(a,o);const B=this.i[a];return B&&o instanceof y&&(o.startSendingEvents(B.initialDimensions),delete this.i[a]),L}$acceptProcessAckDataEvent(a,o){this.g.get(a)?.acknowledgeDataEvent(o)}$acceptProcessInput(a,o){this.g.get(a)?.input(o)}$acceptTerminalInteraction(a){const o=this.N(a);o?.setInteractedWith()&&this.G.fire(o.value)}$acceptProcessResize(a,o,L){try{this.g.get(a)?.resize(o,L)}catch(B){if(B.code!=="EPIPE"&&B.code!=="ERR_IPC_CHANNEL_CLOSED")throw B}}$acceptProcessShutdown(a,o){this.g.get(a)?.shutdown(o)}$acceptProcessRequestInitialCwd(a){this.g.get(a)?.getInitialCwd().then(o=>this.a.$sendProcessProperty(a,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(a){this.g.get(a)?.getCwd().then(o=>this.a.$sendProcessProperty(a,{type:"cwd",value:o}))}$acceptProcessRequestLatency(a){return Promise.resolve(a)}registerLinkProvider(a){return this.s.add(a),this.s.size===1&&this.a.$startLinkProvider(),new k.$aJ(()=>{this.s.delete(a),this.s.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(a,o,L){if(this.u.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this.u.set(o,L),this.a.$registerProfileProvider(o,a.identifier.value),new k.$aJ(()=>{this.u.delete(o),this.a.$unregisterProfileProvider(o)})}registerTerminalQuickFixProvider(a,o,L){if(this.v.has(a))throw new Error(`Terminal quick fix provider "${a}" is already registered`);return this.v.set(a,L),this.a.$registerQuickFixProvider(a,o),new k.$aJ(()=>{this.v.delete(a),this.a.$unregisterQuickFixProvider(a)})}async $provideTerminalQuickFixes(a,o){const L=new h.$bd().token;if(L.isCancellationRequested)return;const B=this.v.get(a);if(!B)return;const G=await B.provideTerminalQuickFixes(o,L);if(G!==null)return G}async $createContributedProfileTerminal(a,o){const L=new h.$bd().token;let B=await this.u.get(a)?.provideTerminalProfile(L);if(!L.isCancellationRequested){if(B&&!("options"in B)&&(B={options:B}),!B||!("options"in B))throw new Error(`No terminal profile options provided for id "${a}"`);if("pty"in B.options){this.createExtensionTerminal(B.options,o);return}this.createTerminalFromOptions(B.options,o)}}async $provideLinks(a,o){const L=this.N(a);if(!L)return[];this.w.delete(a),this.y.get(a)?.dispose(!0);const G=new h.$bd;this.y.set(a,G);const q=[],W={terminal:L.value,line:o},N=[];for(const O of this.s)N.push(r.Promises.withAsyncBody(async ue=>{G.token.onCancellationRequested(()=>ue({provider:O,links:[]}));const pe=await O.provideTerminalLinks(W,G.token)||[];G.token.isCancellationRequested||ue({provider:O,links:pe})}));const H=await Promise.all(N);if(G.token.isCancellationRequested)return[];const j=new Map;for(const O of H)O&&O.links.length>0&&q.push(...O.links.map(ue=>{const pe={id:i++,startIndex:ue.startIndex,length:ue.length,label:ue.tooltip};return j.set(pe.id,{provider:O.provider,link:ue}),pe}));return this.w.set(a,j),q}$activateLink(a,o){const L=this.w.get(a)?.get(o);L&&L.provider.handleTerminalLink(L.link)}M(a,o){this.n.stopBuffering(a),this.g.delete(a),delete this.i[a];const L=this.h[a];L&&(L.dispose(),delete this.h[a]),this.a.$sendProcessExit(a,o)}N(a){return this.O(this.f,a)}O(a,o){const L=this.P(a,o);return L!==null?a[L]:null}P(a,o){const L=a.findIndex(B=>B._id===o);return L===-1?null:L}getEnvironmentVariableCollection(a){let o=this.k.get(a.identifier.value);return o||(o=new n(a),this.R(a.identifier.value,o)),o.getScopedEnvironmentVariableCollection(void 0)}Q(a,o){const L=(0,D.$Vq)(o.map),B=(0,D.$Wq)(o.descriptionMap);this.a.$setEnvironmentVariableCollection(a,o.persistent,L.length===0?void 0:L,B)}$initEnvironmentVariableCollections(a){a.forEach(o=>{const L=o[0],B=new n(void 0,o[1]);this.R(L,B)})}$acceptDefaultProfile(a,o){const L=this.l;this.l=a,this.m=o,L?.path!==a.path&&this.I.fire(a.path)}R(a,o){this.k.set(a,o),o.onDidChangeCollection(()=>{this.Q(a,o)})}};e.$o$b=l=qe([Ve(1,T.$aL)],l);class n{get persistent(){return this.b}set persistent(a){this.b=a,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(a,o){this.f=a,this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new g.$5c,this.map=new Map(o)}getScopedEnvironmentVariableCollection(a){this.f&&a&&(0,w.$$E)(this.f,"envCollectionWorkspace");const o=this.i(a);let L=this.a.get(o);return L||(L=new s(this,a),this.a.set(o,L),L.onDidChangeCollection(()=>this.d.fire())),L}replace(a,o,L,B){this.f&&L&&(0,w.$$E)(this.f,"envCollectionOptions"),this.g(a,{value:o,type:k.EnvironmentVariableMutatorType.Replace,options:L??{},scope:B})}append(a,o,L,B){this.f&&L&&(0,w.$$E)(this.f,"envCollectionOptions"),this.g(a,{value:o,type:k.EnvironmentVariableMutatorType.Append,options:L??{},scope:B})}prepend(a,o,L,B){this.f&&L&&(0,w.$$E)(this.f,"envCollectionOptions"),this.g(a,{value:o,type:k.EnvironmentVariableMutatorType.Prepend,options:L??{},scope:B})}g(a,o){if(o.options&&o.options.applyAtProcessCreation===!1&&!o.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const L=this.h(a,o.scope),B=this.map.get(L);if(!B||B.value!==o.value||B.type!==o.type||B.options?.applyAtProcessCreation!==(o.options.applyAtProcessCreation??!0)||B.options?.applyAtShellIntegration!==(o.options.applyAtShellIntegration??!1)||B.scope?.workspaceFolder?.index!==o.scope?.workspaceFolder?.index){const G=this.h(a,o.scope),q={variable:a,...o,options:{applyAtProcessCreation:o.options.applyAtProcessCreation??!0,applyAtShellIntegration:o.options.applyAtShellIntegration??!1}};this.map.set(G,q),this.d.fire()}}get(a,o){const L=this.h(a,o),B=this.map.get(L);return B?A(B):void 0}h(a,o){const L=this.i(o);return L.length?`${a}:::${L}`:a}i(a){return this.j(a?.workspaceFolder)??""}j(a){return a?a.uri.toString():void 0}getVariableMap(a){const o=new Map;for(const[L,B]of this.map)this.i(B.scope)===this.i(a)&&o.set(L,A(B));return o}delete(a,o){const L=this.h(a,o);this.map.delete(L),this.d.fire()}clear(a){if(a?.workspaceFolder){for(const[o,L]of this.map)L.scope?.workspaceFolder?.index===a.workspaceFolder.index&&this.map.delete(o);this.k(a)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(a,o){const L=this.i(o),B=this.descriptionMap.get(L);if(!B||B.description!==a){let G;typeof a=="string"?G=a:G=a?.value.split(`

`)[0];const q={description:G,scope:o};this.descriptionMap.set(L,q),this.d.fire()}}getDescription(a){const o=this.i(a);return this.descriptionMap.get(o)?.description}k(a){const o=this.i(a);this.descriptionMap.delete(o)}}class s{get persistent(){return this.b.persistent}set persistent(a){this.b.persistent=a}get onDidChangeCollection(){return this.a&&this.a.event}constructor(a,o){this.b=a,this.d=o,this.a=new g.$5c}getScopedEnvironmentVariableCollection(a){return this.b.getScopedEnvironmentVariableCollection(a)}replace(a,o,L){this.b.replace(a,o,L,this.d)}append(a,o,L){this.b.append(a,o,L,this.d)}prepend(a,o,L){this.b.prepend(a,o,L,this.d)}get(a){return this.b.get(a,this.d)}forEach(a,o){this.b.getVariableMap(this.d).forEach((L,B)=>a.call(o,B,L,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(a){this.b.delete(a,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(a){this.b.setDescription(a,this.d)}get description(){return this.b.getDescription(this.d)}}let p=e.$p$b=class extends l{constructor(a){super(!1,a)}createTerminal(a,o,L){throw new F.$0}createTerminalFromOptions(a,o){throw new F.$0}};e.$p$b=p=qe([Ve(0,T.$aL)],p);function I(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function d(E){return u.ThemeColor.isThemeColor(E)?E:void 0}function A(E){const a={...E};return delete a.scope,a.options=a.options??void 0,delete a.variable,a}});var Te=this&&this.__classPrivateFieldGet||function(te,e,g,C){if(g==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?C:g==="a"?C.call(te):C?C.value:e.get(te)},Ye=this&&this.__classPrivateFieldSet||function(te,e,g,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g};define(Re[246],Fe([1,0,18,16,25,22,5,201,93,6,23,10,36,4,17,104,8,7,45,77,56,26]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t,r,c,w,v,y){"use strict";var i,l;Object.defineProperty(e,"__esModule",{value:!0}),e.$z_b=e.$y_b=e.$x_b=e.$w_b=void 0;let n=e.$w_b=class{constructor(N,H,j){this.j=j,this.c=new T.$5c,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=N.getProxy(b.$$I.MainThreadTesting),this.h=new B(this.f),this.g=new d(this.f),H.registerArgumentProcessor({processArgument:O=>{if(O?.$mid!==15)return O;const ue=O,pe=ue.tests[ue.tests.length-1].item.extId;return this.d.get(c.$WH.root(pe))?.collection.tree.get(pe)?.actual??(0,u.$mL)(O)}}),H.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await H.executeCommand("_testing.getExplorerSelection"),ue=pe=>{const Pe=this.d.get(c.$WH.root(pe));if(Pe)return c.$WH.isRoot(pe)?Pe.controller:Pe.collection.tree.get(pe)?.actual};return{include:O?.include.map(ue).filter(D.$oe)||[],exclude:O?.exclude.map(ue).filter(D.$oe)||[]}})}createTestController(N,H,j,O){if(this.d.has(H))throw new Error(`Attempt to insert a duplicate controller with ID "${H}"`);const ue=new m.$jb,pe=ue.add(new u.$pL(H,j,this.j));pe.root.label=j;const Pe=new Map,_=this.f,Y={items:pe.root.children,get label(){return j},set label(ke){j=ke,pe.root.label=ke,_.$updateController(H,{label:j})},get refreshHandler(){return O},set refreshHandler(ke){O=ke,_.$updateController(H,{canRefresh:!!ke})},get id(){return H},createRunProfile:(ke,Ce,me,R,Q,he)=>{let De=(0,k.$_h)(ke);for(;Pe.has(De);)De++;return new G(this.f,Pe,H,De,ke,Ce,me,R,Q,he)},createTestItem(ke,Ce,me){return new u.$nL(H,ke,Ce,me)},createTestRun:(ke,Ce,me=!0)=>this.g.createTestRun(H,pe,ke,Ce,me),invalidateTestResults:ke=>{(0,y.$$E)(N,"testInvalidateResults");for(const Ce of ke instanceof Array?ke:[ke]){const me=Ce?c.$WH.fromExtHostTestItem(Ce,H).toString():H;this.f.$markTestRetired(me)}},set resolveHandler(ke){pe.resolveHandler=ke},get resolveHandler(){return pe.resolveHandler},dispose:()=>{ue.dispose()}};_.$registerTestController(H,j,!!O),ue.add((0,m.$ib)(()=>_.$unregisterTestController(H)));const ce={controller:Y,collection:pe,profiles:Pe};return this.d.set(H,ce),ue.add((0,m.$ib)(()=>this.d.delete(H))),ue.add(pe.onDidGenerateDiff(ke=>_.$publishDiff(H,ke.map(v.TestsDiffOp.serialize)))),Y}createTestObserver(){return this.h.checkout()}async runTests(N,H=z.CancellationToken.None){const j=A(N);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.d.get(j.controllerId);if(!O)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(ue=>c.$WH.fromExtHostTestItem(ue,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:q[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:N.exclude?.map(ue=>ue.id)},H)}$syncTests(){for(const{collection:N}of this.d.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,H,j){return(0,g.$If)(this.g.trackers,ue=>ue.id===N?ue.getCoverage(H):void 0)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(N,H,j,O){return(0,g.$If)(this.g.trackers,pe=>pe.id===N?pe.getCoverage(H):void 0)?.resolveFileCoverage(j,O)??Promise.resolve([])}$configureRunProfile(N,H){this.d.get(N)?.profiles.get(H)?.configureHandler?.()}async $refreshTests(N,H){await this.d.get(N)?.controller.refreshHandler?.(H)}$publishTestResults(N){this.results=Object.freeze(N.map(H=>(0,F.$Em)(t.TestResults.to(H))).concat(this.results).sort((H,j)=>j.completedAt-H.completedAt).slice(0,32)),this.c.fire()}async $expandTest(N,H){const j=this.d.get(c.$WH.fromString(N).controllerId)?.collection;j&&(await j.expand(N,H<0?1/0:H),j.flushDiff())}$acceptDiff(N){this.h.applyDiff(N.map(v.TestsDiffOp.deserialize))}async $runControllerTests(N,H){return Promise.all(N.map(j=>this.k(j,!1,H)))}async $startContinuousRun(N,H){const j=new z.$bd(H),O=await Promise.all(N.map(ue=>this.k(ue,!0,j.token)));return!H.isCancellationRequested&&!O.some(ue=>ue.error)&&await new Promise(ue=>H.onCancellationRequested(ue)),j.dispose(!0),O}async k(N,H,j){const O=this.d.get(N.controllerId);if(!O)return{};const{collection:ue,profiles:pe}=O,Pe=pe.get(N.profileId);if(!Pe)return{};const _=N.testIds.map(Ce=>ue.tree.get(Ce)).filter(D.$oe),Y=N.excludeExtIds.map(Ce=>O.collection.tree.get(Ce)).filter(D.$oe).filter(Ce=>_.some(me=>me.fullId.compare(Ce.fullId)===2));if(!_.length)return{};const ce=new r.$JK(_.some(Ce=>Ce.actual instanceof u.$oL)?void 0:_.map(Ce=>Ce.actual),Y.map(Ce=>Ce.actual),Pe,H),ke=(0,v.$YH)(N)&&this.g.prepareForMainThreadTestRun(ce,E.fromInternal(N,O.collection),j);try{return await Pe.runHandler(ce,j),{}}catch(Ce){return{error:String(Ce)}}finally{ke&&(ke.hasRunningTasks&&!j.isCancellationRequested&&await T.Event.toPromise(ke.onEnd),ke.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.g.cancelAllRuns():this.g.cancelRunById(N)}};e.$w_b=n=qe([Ve(0,$.$aL)],n);const s=1e4;var p;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(p||(p={}));class I extends m.$kb{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(N,H,j){super(),this.k=N,this.l=H,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new T.$5c),this.onEnd=this.j.event,this.h=this.B(new z.$bd(j));const O=this.B(new C.$Cg(()=>this.m(),s));this.B(this.h.token.onCancellationRequested(()=>O.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(N){return this.f.get(N)?.coverage}createRun(N){const H=this.k.id,j=this.k.controllerId,O=(0,h.$3e)(),ue=new a(this.l,H,O),pe=ce=>(ke,...Ce)=>{if(_){console.warn(`Setting the state of test "${ke.id}" is a no-op after the run ends.`);return}this.k.isIncluded(ke)&&(this.s(ke),ce(ke,...Ce))},Pe=(ce,ke)=>{const Ce=ke instanceof Array?ke.map(t.TestMessage.from):[t.TestMessage.from(ke)];if(ce.uri&&ce.range){const me={range:t.Range.from(ce.range),uri:ce.uri};for(const R of Ce)R.location=R.location||me}this.l.$appendTestMessagesInRun(H,O,c.$WH.fromExtHostTestItem(ce,j).toString(),Ce)};let _=!1;const Y={isPersisted:this.k.isPersisted,token:this.h.token,name:N,get coverageProvider(){return ue.coverageProvider},set coverageProvider(ce){ue.coverageProvider=ce},enqueued:pe(ce=>{this.l.$updateTestStateInRun(H,O,c.$WH.fromExtHostTestItem(ce,j).toString(),1)}),skipped:pe(ce=>{this.l.$updateTestStateInRun(H,O,c.$WH.fromExtHostTestItem(ce,j).toString(),5)}),started:pe(ce=>{this.l.$updateTestStateInRun(H,O,c.$WH.fromExtHostTestItem(ce,j).toString(),2)}),errored:pe((ce,ke,Ce)=>{Pe(ce,ke),this.l.$updateTestStateInRun(H,O,c.$WH.fromExtHostTestItem(ce,j).toString(),6,Ce)}),failed:pe((ce,ke,Ce)=>{Pe(ce,ke),this.l.$updateTestStateInRun(H,O,c.$WH.fromExtHostTestItem(ce,j).toString(),4,Ce)}),passed:pe((ce,ke)=>{this.l.$updateTestStateInRun(H,O,c.$WH.fromExtHostTestItem(ce,this.k.controllerId).toString(),3,ke)}),appendOutput:(ce,ke,Ce)=>{_||(Ce&&(this.k.isIncluded(Ce)?this.s(Ce):Ce=void 0),this.l.$appendOutputToRun(H,O,S.$Ib.fromString(ce),ke&&t.location.from(ke),Ce&&c.$WH.fromExtHostTestItem(Ce,j).toString()))},end:()=>{_||(_=!0,this.l.$finishedTestRunTask(H,O),this.f.delete(O),this.f.size||this.p())}};return this.f.set(O,{run:Y,coverage:ue}),this.l.$startedTestRunTask(H,{id:O,name:N,running:!0}),Y}m(){for(const{run:N}of this.f.values())N.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(N){if(!(N instanceof u.$nL))throw new w.$5K(N.id);if(this.g.has(c.$WH.fromExtHostTestItem(N,this.k.controllerId).toString()))return;const H=[],j=this.k.colllection.root;for(;;){const O=t.TestItem.from(N);if(H.unshift(O),this.g.has(O.extId)||(this.g.add(O.extId),N===j))break;N=N.parent||j}this.l.$addTestsToRun(this.k.controllerId,this.k.id,H)}}class d{get trackers(){return this.c.values()}constructor(N){this.d=N,this.c=new Map}prepareForMainThreadTestRun(N,H,j){return this.f(N,H,j)}cancelRunById(N){for(const H of this.c.values())if(H.id===N){H.cancel();return}}cancelAllRuns(){for(const N of this.c.values())N.cancel()}createTestRun(N,H,j,O,ue){const pe=this.c.get(j);if(pe)return pe.createRun(O);const Pe=E.fromPublic(N,H,j,ue),_=A(j);this.d.$startedExtensionTestRun({controllerId:N,continuous:!!j.continuous,profile:_&&{group:q[_.kind],id:_.profileId},exclude:j.exclude?.map(ce=>c.$WH.fromExtHostTestItem(ce,H.root.id).toString())??[],id:Pe.id,include:j.include?.map(ce=>c.$WH.fromExtHostTestItem(ce,H.root.id).toString())??[H.root.id],persist:ue});const Y=this.f(j,Pe);return Y.onEnd(()=>{this.d.$finishedExtensionTestRun(Pe.id),Y.dispose()}),Y.createRun(O)}f(N,H,j){const O=new I(H,this.d,j);return this.c.set(N,O),O.onEnd(()=>this.c.delete(N)),O}}e.$x_b=d;const A=W=>{if(W.profile){if(!(W.profile instanceof G))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class E{static fromPublic(N,H,j,O){return new E(N,(0,h.$3e)(),j.include?.map(ue=>c.$WH.fromExtHostTestItem(ue,N).toString())??[N],j.exclude?.map(ue=>c.$WH.fromExtHostTestItem(ue,N).toString())??[],O,H)}static fromInternal(N,H){return new E(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,H)}constructor(N,H,j,O,ue,pe){this.controllerId=N,this.id=H,this.isPersisted=ue,this.colllection=pe,this.c=j.map(Pe=>Pe+"\0"),this.d=O.map(Pe=>Pe+"\0")}isIncluded(N){const H=c.$WH.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const j of this.d)if(H===j||H.startsWith(j))return!1;for(const j of this.c)if(H===j||H.startsWith(j))return!0;return!1}}e.$y_b=E;class a{set coverageProvider(N){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this.c=N,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(N,H,j){this.f=N,this.g=H,this.h=j}async provideFileCoverage(N){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(N))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(H){throw this.d=void 0,H}}async resolveFileCoverage(N,H){const j=await this.d;let O=j?.[N];return!this.c||!j||!O?[]:(O.detailedCoverage||(O=j[N]=await this.c.resolveFileCoverage?.(O,H)??O),O.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class o{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(N){this.h=N,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(N){this.c.add(N)}update(N){Object.assign(N.revived,t.TestItem.toPlain(N.item)),this.c.has(N)||this.d.add(N)}remove(N){if(this.c.has(N)){this.c.delete(N);return}this.d.delete(N);const H=c.$WH.parentId(N.item.extId);if(H&&this.g.has(H.toString())){this.g.add(N.item.extId);return}this.f.add(N)}getChangeEvent(){const{c:N,d:H,f:j}=this;return{get added(){return[...N].map(O=>O.revived)},get updated(){return[...H].map(O=>O.revived)},get removed(){return[...j].map(O=>O.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class L extends v.$4H{constructor(){super(...arguments),this.q=new T.$5c,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(N){return this.d.get(N)}getMirroredTestDataByReference(N){return this.d.get(N.id)}p(N,H){return{...N,revived:t.TestItem.toPlain(N.item),depth:H?H.depth+1:0,children:new Set}}o(){return new o(this.q)}}class B{constructor(N){this.d=N}checkout(){this.c||(this.c=this.f());const N=this.c;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(H=>H.revived)},dispose:(0,f.$bb)(()=>{--N.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(N){return this.c?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.c?.tests.apply(N)}f(){const N=new L;return this.d.$subscribeToDiffs(),{observers:0,tests:N}}}class G{get label(){return this.d}set label(N){N!==this.d&&(this.d=N,Te(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(N){N!==this.g&&(this.g=N,Te(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this.f}set isDefault(N){N!==this.f&&(this.f=N,Te(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,Te(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?t.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this.c}set configureHandler(N){N!==this.c&&(this.c=N,Te(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,H,j,O,ue,pe,Pe,_=!1,Y=void 0,ce=!1){this.controllerId=j,this.profileId=O,this.d=ue,this.kind=pe,this.runHandler=Pe,this.f=_,this._tag=Y,this.g=ce,i.set(this,void 0),l.set(this,void 0),Ye(this,i,N,"f"),Ye(this,l,H,"f"),H.set(O,this);const ke=q[pe];if(typeof ke!="number")throw new Error(`Unknown TestRunProfile.group ${pe}`);Te(this,i,"f").$publishTestRunProfile({profileId:O,controllerId:j,tag:Y?t.TestTag.namespace(this.controllerId,Y.id):null,label:ue,group:ke,isDefault:_,hasConfigurationHandler:!1,supportsContinuousRun:ce})}dispose(){Te(this,l,"f")?.delete(this.profileId)&&(Ye(this,l,void 0,"f"),Te(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.$z_b=G,i=new WeakMap,l=new WeakMap;const q={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Re[247],Fe([1,0,18,9,5,4,105,8,7]),function(te,e,g,C,S,z,T,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O$b=void 0;class m{constructor(D,h){this.i=h,this.a=new S.$5c({onListenerError:C.$Y}),this.b=new S.$5c({onListenerError:C.$Y}),this.c=new S.$5c({onListenerError:C.$Y}),this.d=new S.$5c({onListenerError:C.$Y}),this.f=new S.$5c({onListenerError:C.$Y}),this.g=new S.$5c({onListenerError:C.$Y}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(z.$$I.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const h=this.i.allEditors();return D?h:h.map(b=>b.value)}async showTextDocument(D,h,b){let $;typeof h=="number"?$={position:f.ViewColumn.from(h),preserveFocus:b}:typeof h=="object"?$={position:f.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selection:typeof h.selection=="object"?f.Range.from(h.selection):void 0,pinned:typeof h.preview=="boolean"?!h.preview:void 0}:$={preserveFocus:!1};const u=await this.h.$tryShowTextDocument(D.uri,$),t=u&&this.i.getEditor(u);if(t)return t.value;throw u?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,h){return new T.$hL(this.h,D,h).value}$acceptEditorPropertiesChanged(D,h){const b=this.i.getEditor(D);if(!b)throw new Error("unknown text editor");if(h.options&&b._acceptOptions(h.options),h.selections){const $=h.selections.selections.map(f.Selection.to);b._acceptSelections($)}if(h.visibleRanges){const $=g.$jf(h.visibleRanges.map(f.Range.to));b._acceptVisibleRanges($)}if(h.options&&this.b.fire({textEditor:b.value,options:{...h.options,lineNumbers:f.TextEditorLineNumbersStyle.to(h.options.lineNumbers)}}),h.selections){const $=k.TextEditorSelectionChangeKind.fromValue(h.selections.source),u=h.selections.selections.map(f.Selection.to);this.a.fire({textEditor:b.value,selections:u,kind:$})}if(h.visibleRanges){const $=g.$jf(h.visibleRanges.map(f.Range.to));this.c.fire({textEditor:b.value,visibleRanges:$})}}$acceptEditorPositionData(D){for(const h in D){const b=this.i.getEditor(h);if(!b)throw new Error("Unknown text editor");const $=f.ViewColumn.to(D[h]);b.value.viewColumn!==$&&(b._acceptViewColumn($),this.d.fire({textEditor:b.value,viewColumn:$}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.$O$b=m}),define(Re[248],Fe([1,0,2,3,4,6,7,8,24,10]),function(te,e,g,C,S,z,T,f,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r_b=e.$q_b=void 0,e.$q_b=(0,C.$lh)("IExtHostTimeline");class F{constructor(b,$){this.b=new Map,this.c=new Map,this.a=b.getProxy(S.$$I.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(u,t)=>{if(u&&u.$mid===12)if(this.b.get(u.source)&&k.$Dl.equals(t,this.b.get(u.source)?.extension)){const r=u.uri===void 0?void 0:g.URI.revive(u.uri);return this.c.get(u.source)?.get(D(r))?.get(u.handle)}else return;return u}})}async $getTimeline(b,$,u,t){return this.b.get(b)?.provider.provideTimeline(g.URI.revive($),u,t)}registerTimelineProvider(b,$,u,t){const r=new z.$jb,c=this.d($.id,t,r).bind(this);let w;$.onDidChange&&(w=$.onDidChange(y=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...y,id:$.id}),this));const v=this.c;return this.f({...$,scheme:b,onDidChange:void 0,async provideTimeline(y,i,l){i?.resetCache&&(r.clear(),v.get($.id)?.clear());const n=await $.provideTimeline(y,i,l);if(n==null)return;const s=c(y,i);return{...n,source:$.id,items:n.items.map(s)}},dispose(){for(const y of v.values())y.get($.id)?.clear();w?.dispose(),r.dispose()}},u)}d(b,$,u){return(t,r)=>{let c;if(r?.cacheResults){let w=this.c.get(b);w===void 0&&(w=new Map,this.c.set(b,w));const v=D(t);c=w.get(v),c===void 0&&(c=new Map,w.set(v,c))}return w=>{const{iconPath:v,...y}=w,i=`${b}|${w.id??w.timestamp}`;c?.set(i,w);let l,n,s;w.iconPath&&(v instanceof T.$8J?s={id:v.id,color:v.color}:g.URI.isUri(v)?(l=v,n=v):{light:l,dark:n}=v);let p;return T.$BJ.isMarkdownString(y.tooltip)?p=f.MarkdownString.from(y.tooltip):(0,m.$ge)(y.tooltip)?p=y.tooltip:T.$BJ.isMarkdownString(y.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=f.MarkdownString.from(y.detail)):(0,m.$ge)(y.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=y.detail),{...y,id:y.id??void 0,handle:i,source:b,command:w.command?$.toInternal(w.command,u):void 0,icon:l,iconDark:n,themeIcon:s,tooltip:p,accessibilityInformation:w.accessibilityInformation}}}}f(b,$){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:$}),(0,z.$ib)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$r_b=F;function D(h){return h?.toString()}}),define(Re[249],Fe([1,0,6,14,2,4]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A_b=void 0;class T{constructor(k){this.c=new Map,this.b=k.getProxy(z.$$I.MainThreadUriOpeners)}registerExternalUriOpener(k,m,F,D){if(this.c.has(m))throw new Error(`Opener with id '${m}' already registered`);const h=D.schemes.find(b=>!T.a.has(b));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this.c.set(m,F),this.b.$registerUriOpener(m,D.schemes,k,D.label),(0,g.$ib)(()=>{this.c.delete(m),this.b.$unregisterUriOpener(m)})}async $canOpenUri(k,m,F){const D=this.c.get(k);if(!D)throw new Error(`Unknown opener with id: ${k}`);const h=S.URI.revive(m);return D.canOpenExternalUri(h,F)}async $openUri(k,m,F){const D=this.c.get(k);if(!D)throw new Error(`Unknown opener id: '${k}'`);return D.openExternalUri(S.URI.revive(m.resolvedUri),{sourceUri:S.URI.revive(m.sourceUri)},F)}}e.$A_b=T,T.a=new Set([C.Schemas.http,C.Schemas.https])}),define(Re[250],Fe([1,0,4,2,6,9,24]),function(te,e,g,C,S,z,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q$b=void 0;class f{constructor(m){this.c=new T.$El,this.d=new Map,this.b=m.getProxy(g.$$I.MainThreadUrls)}registerUriHandler(m,F){const D=m.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const h=f.a++;return this.c.add(D),this.d.set(h,F),this.b.$registerUriHandler(h,D,m.displayName||m.name),(0,S.$ib)(()=>{this.c.delete(D),this.d.delete(h),this.b.$unregisterUriHandler(h)})}$handleExternalUri(m,F){const D=this.d.get(m);if(!D)return Promise.resolve(void 0);try{D.handleUri(C.URI.revive(F))}catch(h){(0,z.$X)(h)}return Promise.resolve(void 0)}async createAppUri(m){return C.URI.revive(await this.b.$createAppUri(m))}}e.$Q$b=f,f.a=0});var Ye=this&&this.__classPrivateFieldSet||function(te,e,g,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Te=this&&this.__classPrivateFieldGet||function(te,e,g,C){if(g==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?C:g==="a"?C.call(te):C?C.value:e.get(te)};define(Re[63],Fe([1,0,5,14,23,2,167,190,78,4]),function(te,e,g,C,S,z,T,f,k,m){"use strict";var F,D,h,b,$,u,t,r,c,w,v,y,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=e.$U$b=e.$T$b=e.$S$b=e.$R$b=void 0;class l{constructor(o,L,B,G,q,W,N){F.set(this,void 0),D.set(this,void 0),h.set(this,void 0),b.set(this,void 0),$.set(this,void 0),u.set(this,void 0),t.set(this,""),r.set(this,void 0),c.set(this,!1),w.set(this,!1),v.set(this,void 0),y.set(this,void 0),this._onMessageEmitter=new g.$5c,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new g.$5c),this._onDidDispose=Te(this,i,"f").event,Ye(this,F,o,"f"),Ye(this,D,L,"f"),Ye(this,r,B,"f"),Ye(this,b,G,"f"),Ye(this,$,q,"f"),Ye(this,u,W,"f"),Ye(this,v,n(W),"f"),Ye(this,y,s(W),"f"),Ye(this,h,N,"f")}dispose(){Ye(this,c,!0,"f"),Te(this,i,"f").fire(),Te(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return Ye(this,w,!0,"f"),(0,k.$Rlb)(o,Te(this,b,"f"))}get cspSource(){const o=Te(this,u,"f").extensionLocation;if(o.scheme===C.Schemas.https||o.scheme===C.Schemas.http){let L=o.toString();return L.endsWith("/")||(L+="/"),L+" "+k.$Qlb}return k.$Qlb}get html(){return this.a(),Te(this,t,"f")}set html(o){this.a(),Te(this,t,"f")!==o&&(Ye(this,t,o,"f"),Te(this,y,"f")&&!Te(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(Ye(this,w,!0,"f"),Te(this,h,"f").report("Webview vscode-resource: uris",Te(this,u,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,D,"f").$setHtml(Te(this,F,"f"),this.b(o)))}get options(){return this.a(),Te(this,r,"f")}set options(o){this.a(),S.$Hm(Te(this,r,"f"),o)||Te(this,D,"f").$setOptions(Te(this,F,"f"),d(Te(this,u,"f"),Te(this,$,"f"),o)),Ye(this,r,o,"f")}async postMessage(o){if(Te(this,c,"f"))return!1;const L=(0,f.$E9)(o,{serializeBuffersForPostMessage:Te(this,v,"f")});return Te(this,D,"f").$postMessage(Te(this,F,"f"),L.message,...L.buffers)}a(){if(Te(this,c,"f"))throw new Error("Webview is disposed")}b(o){if(!Te(this,y,"f"))return o;const L=Te(this,u,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,B=Te(this,u,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Te(this,u,"f").extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,q,W,N,H,j)=>{const O=z.URI.from({scheme:N||"file",path:decodeURIComponent(H)}),ue=(0,k.$Rlb)(O,{isRemote:L,authority:B}).toString();return`${q}${ue}${j}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,q,W,N,H,j)=>{const O=z.URI.from({scheme:N||"file",path:decodeURIComponent(H)}),ue=(0,k.$Rlb)(O,{isRemote:L,authority:B}).toString();return`${q}${ue}${j}`})}}e.$R$b=l,F=new WeakMap,D=new WeakMap,h=new WeakMap,b=new WeakMap,$=new WeakMap,u=new WeakMap,t=new WeakMap,r=new WeakMap,c=new WeakMap,w=new WeakMap,v=new WeakMap,y=new WeakMap,i=new WeakMap;function n(a){try{const o=(0,T.$po)((0,T.$oo)(a.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$S$b=n;function s(a){try{const o=(0,T.$po)((0,T.$oo)(a.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class p{constructor(o,L,B,G,q){this.c=L,this.d=B,this.e=G,this.f=q,this.b=new Map,this.a=o.getProxy(m.$$I.MainThreadWebviews)}$onMessage(o,L,B){const G=this.g(o);if(G){const{message:q}=(0,f.$F9)(L,B.value);G._onMessageEmitter.fire(q)}}$onMissingCsp(o,L){this.e.warn(`${L} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,L,B){const G=new l(o,this.a,A(L),this.c,this.d,B,this.f);return this.b.set(o,G),G._onDidDispose(()=>{this.b.delete(o)}),G}deleteWebview(o){this.b.delete(o)}g(o){return this.b.get(o)}}e.$T$b=p;function I(a){return{id:a.identifier,location:a.extensionLocation}}e.$U$b=I;function d(a,o,L){return{enableCommandUris:L.enableCommandUris,enableScripts:L.enableScripts,enableForms:L.enableForms,portMapping:L.portMapping,localResourceRoots:L.localResourceRoots||E(a,o)}}e.$V$b=d;function A(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(o=>z.URI.from(o))}}function E(a,o){return[...(o?.getWorkspaceFolders()||[]).map(L=>L.uri),a.extensionLocation]}}),define(Re[251],Fe([1,0,22,93,6,14,20,2,8,63,54,4,7]),function(te,e,g,C,S,z,T,f,k,m,F,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u_b=void 0;class b{constructor(l,n){this.document=l,this.b=n,this.a=1,this.c=new F.$N0b("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,n){await this.f(l).undo(),n||this.disposeBackup()}async redo(l,n){await this.f(l).redo(),n||this.disposeBackup()}disposeEdits(l){for(const n of l)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=y(this.document.uri)+this.a++;return(0,T.$6f)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const n=this.c.get(l,0);if(!n)throw new Error("No edit found");return n}}class ${constructor(){this.a=new Map}get(l,n){return this.a.get(this.b(l,n))}add(l,n,s){const p=this.b(l,n.uri);if(this.a.has(p))throw new Error(`Document already exists for viewType:${l} resource:${n.uri}`);const I=new b(n,s);return this.a.set(p,I),I}delete(l,n){const s=this.b(l,n.uri);this.a.delete(s)}b(l,n){return`${l}@@@${n}`}}var u;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(u||(u={}));class t{constructor(){this.a=new Map}addTextProvider(l,n,s){return this.b(0,l,n,s)}addCustomProvider(l,n,s){return this.b(1,l,n,s)}get(l){return this.a.get(l)}b(l,n,s,p){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:l,extension:s,provider:p}),new h.$aJ(()=>this.a.delete(n))}}class r{constructor(l,n,s,p,I){this.d=n,this.f=s,this.g=p,this.h=I,this.b=new t,this.c=new $,this.a=l.getProxy(D.$$I.MainThreadCustomEditors)}registerCustomEditorProvider(l,n,s,p){const I=new S.$jb;return w(s)?(I.add(this.b.addTextProvider(n,l,s)),this.a.$registerTextEditorProvider((0,m.$U$b)(l),n,p.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,m.$S$b)(l))):(I.add(this.b.addCustomProvider(n,l,s)),c(s)&&I.add(s.onDidChangeCustomDocument(d=>{const A=this.i(n,d.document.uri);if(v(d)){const E=A.addEdit(d);this.a.$onDidEdit(d.document.uri,n,E,d.label)}else this.a.$onContentChange(d.document.uri,n)})),this.a.$registerCustomEditorProvider((0,m.$U$b)(l),n,p.webviewOptions||{},!!p.supportsMultipleEditorsPerDocument,(0,m.$S$b)(l))),h.$aJ.from(I,new h.$aJ(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(l,n,s,p,I){const d=this.b.get(n);if(!d)throw new Error(`No provider found for '${n}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${n}'`);const A=f.URI.revive(l),E=await d.provider.openCustomDocument(A,{backupId:s,untitledDocumentData:p?.buffer},I);let a;return c(d.provider)&&this.f&&(a=this.f.workspaceValue(d.extension)??this.f.globalValue(d.extension)),this.c.add(n,E,a),{editable:c(d.provider)}}async $disposeCustomDocument(l,n){const s=this.b.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const p=f.URI.revive(l),{document:I}=this.i(n,p);this.c.delete(n,I),I.dispose()}async $resolveCustomEditor(l,n,s,p,I,d){const A=this.b.get(s);if(!A)throw new Error(`No provider found for '${s}'`);const E=k.ViewColumn.to(I),a=this.g.createNewWebview(n,p.contentOptions,A.extension),o=this.h.createNewWebviewPanel(n,s,p.title,E,p.options,a,p.active),L=f.URI.revive(l);switch(A.type){case 1:{const{document:B}=this.i(s,L);return A.provider.resolveCustomEditor(B,o,d)}case 0:{const B=this.d.getDocument(L);return A.provider.resolveCustomTextEditor(B,o,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,n,s){this.i(n,l).disposeEdits(s)}async $onMoveCustomEditor(l,n,s){const p=this.b.get(s);if(!p)throw new Error(`No provider found for '${s}'`);if(!p.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const I=this.h.getWebviewPanel(l);if(!I)throw new Error("No webview found");const d=f.URI.revive(n),A=this.d.getDocument(d);await p.provider.moveCustomTextEditor(A,I,g.CancellationToken.None)}async $undo(l,n,s,p){return this.i(n,l).undo(s,p)}async $redo(l,n,s,p){return this.i(n,l).redo(s,p)}async $revert(l,n,s){const p=this.i(n,l);await this.j(n).revertCustomDocument(p.document,s),p.disposeBackup()}async $onSave(l,n,s){const p=this.i(n,l);await this.j(n).saveCustomDocument(p.document,s),p.disposeBackup()}async $onSaveAs(l,n,s,p){const I=this.i(n,l);return this.j(n).saveCustomDocumentAs(I.document,f.URI.revive(s),p)}async $backup(l,n,s){const p=this.i(n,l),d=await this.j(n).backupCustomDocument(p.document,{destination:p.getNewBackupUri()},s);return p.updateBackup(d),d.id}i(l,n){const s=this.c.get(l,f.URI.revive(n));if(!s)throw new Error("No custom document found");return s}j(l){const s=this.b.get(l)?.provider;if(!s||!c(s))throw new Error("Custom document is not editable");return s}}e.$u_b=r;function c(i){return!!i.onDidChangeCustomDocument}function w(i){return typeof i.resolveCustomTextEditor=="function"}function v(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function y(i){const l=i.scheme===z.Schemas.file||i.scheme===z.Schemas.untitled?i.fsPath:i.toString();return(0,C.$_h)(l)+""}});var Ye=this&&this.__classPrivateFieldSet||function(te,e,g,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Te=this&&this.__classPrivateFieldGet||function(te,e,g,C){if(g==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?C:g==="a"?C.call(te):C?C.value:e.get(te)};define(Re[252],Fe([1,0,5,6,2,36,8,63,4,7]),function(te,e,g,C,S,z,T,f,k,m){"use strict";var F,D,h,b,$,u,t,r,c,w,v,y,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$t_b=void 0;class l extends C.$kb{constructor(I,d,A,E){super(),F.set(this,void 0),D.set(this,void 0),h.set(this,void 0),b.set(this,void 0),$.set(this,void 0),u.set(this,void 0),t.set(this,void 0),r.set(this,void 0),c.set(this,!0),w.set(this,void 0),v.set(this,!1),y.set(this,this.B(new g.$5c)),this.onDidDispose=Te(this,y,"f").event,i.set(this,this.B(new g.$5c)),this.onDidChangeViewState=Te(this,i,"f").event,Ye(this,F,I,"f"),Ye(this,D,d,"f"),Ye(this,b,A,"f"),Ye(this,h,E.viewType,"f"),Ye(this,$,E.panelOptions,"f"),Ye(this,r,E.viewColumn,"f"),Ye(this,u,E.title,"f"),Ye(this,w,E.active,"f")}dispose(){Te(this,v,"f")||(Ye(this,v,!0,"f"),Te(this,y,"f").fire(),Te(this,D,"f").$disposeWebview(Te(this,F,"f")),Te(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Te(this,b,"f")}get viewType(){return this.c(),Te(this,h,"f")}get title(){return this.c(),Te(this,u,"f")}set title(I){this.c(),Te(this,u,"f")!==I&&(Ye(this,u,I,"f"),Te(this,D,"f").$setTitle(Te(this,F,"f"),I))}get iconPath(){return this.c(),Te(this,t,"f")}set iconPath(I){this.c(),Te(this,t,"f")!==I&&(Ye(this,t,I,"f"),Te(this,D,"f").$setIconPath(Te(this,F,"f"),S.URI.isUri(I)?{light:I,dark:I}:I))}get options(){return Te(this,$,"f")}get viewColumn(){if(this.c(),!(typeof Te(this,r,"f")=="number"&&Te(this,r,"f")<0))return Te(this,r,"f")}get active(){return this.c(),Te(this,w,"f")}get visible(){return this.c(),Te(this,c,"f")}_updateViewState(I){Te(this,v,"f")||(this.active!==I.active||this.visible!==I.visible||this.viewColumn!==I.viewColumn)&&(Ye(this,w,I.active,"f"),Ye(this,c,I.visible,"f"),Ye(this,r,I.viewColumn,"f"),Te(this,i,"f").fire({webviewPanel:this}))}reveal(I,d){this.c(),Te(this,D,"f").$reveal(Te(this,F,"f"),{viewColumn:typeof I>"u"?void 0:T.ViewColumn.from(I),preserveFocus:!!d})}c(){if(Te(this,v,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,D=new WeakMap,h=new WeakMap,b=new WeakMap,$=new WeakMap,u=new WeakMap,t=new WeakMap,r=new WeakMap,c=new WeakMap,w=new WeakMap,v=new WeakMap,y=new WeakMap,i=new WeakMap;class n{static c(){return(0,z.$3e)()}constructor(I,d,A){this.g=d,this.h=A,this.e=new Map,this.f=new Map,this.d=I.getProxy(k.$$I.MainThreadWebviewPanels)}createWebviewPanel(I,d,A,E,a={}){const o=typeof E=="object"?E.viewColumn:E,L={viewColumn:T.ViewColumn.from(o),preserveFocus:typeof E=="object"&&!!E.preserveFocus},B=(0,f.$S$b)(I),G=n.c();this.d.$createWebviewPanel((0,f.$U$b)(I),G,d,{title:A,panelOptions:s(a),webviewOptions:(0,f.$V$b)(I,this.h,a),serializeBuffersForPostMessage:B},L);const q=this.g.createNewWebview(G,a,I);return this.createNewWebviewPanel(G,d,A,o,a,q,!0)}$onDidChangeWebviewPanelViewStates(I){const d=Object.keys(I);d.sort((A,E)=>{const a=I[A],o=I[E];return a.active?1:o.active?-1:+a.visible-+o.visible});for(const A of d){const E=this.getWebviewPanel(A);if(!E)continue;const a=I[A];E._updateViewState({active:a.active,visible:a.visible,viewColumn:T.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(I){this.getWebviewPanel(I)?.dispose(),this.e.delete(I),this.g.deleteWebview(I)}registerWebviewPanelSerializer(I,d,A){if(this.f.has(d))throw new Error(`Serializer for '${d}' already registered`);return this.f.set(d,{serializer:A,extension:I}),this.d.$registerSerializer(d,{serializeBuffersForPostMessage:(0,f.$S$b)(I)}),new m.$aJ(()=>{this.f.delete(d),this.d.$unregisterSerializer(d)})}async $deserializeWebviewPanel(I,d,A,E){const a=this.f.get(d);if(!a)throw new Error(`No serializer found for '${d}'`);const{serializer:o,extension:L}=a,B=this.g.createNewWebview(I,A.webviewOptions,L),G=this.createNewWebviewPanel(I,d,A.title,E,A.panelOptions,B,A.active);await o.deserializeWebviewPanel(G,A.state)}createNewWebviewPanel(I,d,A,E,a,o,L){const B=new l(I,this.d,o,{viewType:d,title:A,viewColumn:E,panelOptions:a,active:L});return this.e.set(I,B),B}getWebviewPanel(I){return this.e.get(I)}}e.$t_b=n;function s(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(te,e,g,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Te=this&&this.__classPrivateFieldGet||function(te,e,g,C){if(g==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?C:g==="a"?C.call(te):C?C.value:e.get(te)};define(Re[253],Fe([1,0,5,6,63,8,4,7]),function(te,e,g,C,S,z,T,f){"use strict";var k,m,F,D,h,b,$,u,t,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$s_b=void 0;class w extends C.$kb{constructor(i,l,n,s,p,I){super(),k.set(this,void 0),m.set(this,void 0),F.set(this,void 0),D.set(this,void 0),h.set(this,!1),b.set(this,void 0),$.set(this,void 0),u.set(this,void 0),t.set(this,void 0),r.set(this,this.B(new g.$5c)),this.onDidChangeVisibility=Te(this,r,"f").event,c.set(this,this.B(new g.$5c)),this.onDidDispose=Te(this,c,"f").event,Ye(this,F,n,"f"),Ye(this,$,s,"f"),Ye(this,k,i,"f"),Ye(this,m,l,"f"),Ye(this,D,p,"f"),Ye(this,b,I,"f")}dispose(){Te(this,h,"f")||(Ye(this,h,!0,"f"),Te(this,c,"f").fire(),Te(this,D,"f").dispose(),super.dispose())}get title(){return this.a(),Te(this,$,"f")}set title(i){this.a(),Te(this,$,"f")!==i&&(Ye(this,$,i,"f"),Te(this,m,"f").$setWebviewViewTitle(Te(this,k,"f"),i))}get description(){return this.a(),Te(this,u,"f")}set description(i){this.a(),Te(this,u,"f")!==i&&(Ye(this,u,i,"f"),Te(this,m,"f").$setWebviewViewDescription(Te(this,k,"f"),i))}get visible(){return Te(this,b,"f")}get webview(){return Te(this,D,"f")}get viewType(){return Te(this,F,"f")}_setVisible(i){i===Te(this,b,"f")||Te(this,h,"f")||(Ye(this,b,i,"f"),Te(this,r,"f").fire())}get badge(){return this.a(),Te(this,t,"f")}set badge(i){this.a(),!(i?.value===Te(this,t,"f")?.value&&i?.tooltip===Te(this,t,"f")?.tooltip)&&(Ye(this,t,z.ViewBadge.from(i),"f"),Te(this,m,"f").$setWebviewViewBadge(Te(this,k,"f"),i))}show(i){this.a(),Te(this,m,"f").$show(Te(this,k,"f"),!!i)}a(){if(Te(this,h,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,m=new WeakMap,F=new WeakMap,D=new WeakMap,h=new WeakMap,b=new WeakMap,$=new WeakMap,u=new WeakMap,t=new WeakMap,r=new WeakMap,c=new WeakMap;class v{constructor(i,l){this.d=l,this.b=new Map,this.c=new Map,this.a=i.getProxy(T.$$I.MainThreadWebviewViews)}registerWebviewViewProvider(i,l,n,s){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:n,extension:i}),this.a.$registerWebviewViewProvider((0,S.$U$b)(i),l,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,S.$S$b)(i)}),new f.$aJ(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(i,l,n,s,p){const I=this.b.get(l);if(!I)throw new Error(`No view provider found for '${l}'`);const{provider:d,extension:A}=I,E=this.d.createNewWebview(i,{},A),a=new w(i,this.a,l,n,E,!0);this.c.set(i,a),await d.resolveWebviewView(a,{state:s},p)}async $onDidChangeWebviewViewVisibility(i,l){this.e(i)._setVisible(l)}async $disposeWebviewView(i){const l=this.e(i);this.c.delete(i),l.dispose(),this.d.deleteWebview(i)}e(i){const l=this.c.get(i);if(!l)throw new Error("No webview found");return l}}e.$s_b=v}),define(Re[108],Fe([1,0,5,4,2,14,13,3,17,26]),function(te,e,g,C,S,z,T,f,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X$b=e.$W$b=void 0;let F=e.$W$b=class Fn{getState(h){const b=this.d;return{get focused(){return b.focused},get active(){return(0,m.$$E)(h,"windowActivity"),b.active}}}constructor(h){this.c=new g.$5c,this.onDidChangeWindowState=this.c.event,this.d=Fn.a,this.b=h.getProxy(C.$$I.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:$})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",$)})}$onDidChangeWindowFocus(h){this.onDidChangeWindowProperty("focused",h)}$onDidChangeWindowActive(h){this.onDidChangeWindowProperty("active",h)}onDidChangeWindowProperty(h,b){b!==this.d[h]&&(this.d={...this.d,[h]:b},this.c.fire(this.d))}openUri(h,b){let $;if(typeof h=="string"){$=h;try{h=S.URI.parse(h)}catch{return Promise.reject(`Invalid uri - '${h}'`)}}return(0,T.$hd)(h.scheme)?Promise.reject("Invalid scheme - cannot be empty"):h.scheme===z.Schemas.command?Promise.reject(`Invalid scheme '${h.scheme}'`):this.b.$openUri(h,$,b)}async asExternalUri(h,b){if((0,T.$hd)(h.scheme))return Promise.reject("Invalid scheme - cannot be empty");const $=await this.b.$asExternalUri(h,b);return S.URI.from($)}};F.a={focused:!0,active:!0},e.$W$b=F=qe([Ve(0,k.$aL)],F),e.$X$b=(0,f.$lh)("IExtHostWindow")}),define(Re[254],Fe([1,0,221,27,17]),function(te,e,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=void 0;let z=e.$Xbc=class extends g.$R_b{constructor(f,k){super(f,k)}f(f,k,m){k.apply(console,m)}};e.$Xbc=z=qe([Ve(0,S.$aL),Ve(1,C.$qL)],z)}),define(Re[255],Fe([1,0,16,25,22,9,5,6,132,214,46]),function(te,e,g,C,S,z,T,f,k,m,F){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$xZb=e.ResponsiveState=e.RequestInitiator=e.$wZb=e.$vZb=void 0;function h(a,o){try{return JSON.stringify(a,o)}catch{return"null"}}const b="$$ref$$",$={[b]:-1};class u{constructor(o,L){this.jsonString=o,this.referencedBuffers=L}}function t(a,o=null,L=!1){const B=[];return{jsonString:(L?h:JSON.stringify)(a,(q,W)=>{if(typeof W>"u")return $;if(typeof W=="object"){if(W instanceof C.$Ib){const N=B.push(W)-1;return{[b]:N}}if(o)return o(q,W)}return W}),referencedBuffers:B}}e.$vZb=t;function r(a,o,L){return JSON.parse(a,(B,G)=>{if(G){const q=G[b];if(typeof q=="number")return o[q];if(L&&G.$mid===1)return L.transformIncoming(G)}return G})}e.$wZb=r;function c(a,o){return JSON.stringify(a,o)}function w(a){return a?(o,L)=>L&&L.$mid===1?a.transformOutgoing(L):L:null}var v;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));var y;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(y||(e.ResponsiveState=y={}));const i=()=>{},l=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class s extends f.$kb{constructor(o,L=null,B=null){super(),this[D]=!0,this.b=this.B(new T.$5c),this.onDidChangeResponsiveState=this.b.event,this.c=o,this.f=L,this.g=B,this.h=w(this.g),this.j=!1,this.k=[],this.l=[];for(let G=0,q=F.$Jz.count;G<q;G++)this.k[G]=null,this.l[G]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new g.$Cg(()=>this.C(),1e3)),this.c.onMessage(G=>this.G(G))}dispose(){this.j=!0,Object.keys(this.s).forEach(o=>{this.s[o].resolveErr(z.$3())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(o){this.u===0&&(this.v=Date.now()+s.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(o){this.v=Date.now()+s.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(o){this.t!==o&&(this.t=o,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(o){return this.g?(0,k.$mm)(o,this.g):o}getProxy(o){const{nid:L,sid:B}=o;return this.l[L]||(this.l[L]=this.F(L,B)),this.l[L]}F(o,L){const B={get:(G,q)=>(typeof q=="string"&&!G[q]&&q.charCodeAt(0)===36&&(G[q]=(...W)=>this.O(o,q,W)),q===n?L:G[q])};return new Proxy(Object.create(null),B)}set(o,L){return this.k[o.nid]=L,L}assertRegistered(o){for(let L=0,B=o.length;L<B;L++){const G=o[L];if(!this.k[G.nid])throw new Error(`Missing proxy instance ${G.sid}`)}}G(o){if(this.j)return;const L=o.byteLength,B=p.read(o,0),G=B.readUInt8(),q=B.readUInt32();switch(G){case 1:case 2:{let{rpcId:W,method:N,args:H}=d.deserializeRequestJSONArgs(B);this.g&&(H=(0,k.$mm)(H,this.g)),this.H(L,q,W,N,H,G===2);break}case 3:case 4:{let{rpcId:W,method:N,args:H}=d.deserializeRequestMixedArgs(B);this.g&&(H=(0,k.$mm)(H,this.g)),this.H(L,q,W,N,H,G===4);break}case 5:{this.f?.logIncoming(L,q,0,"ack"),this.z(q);break}case 6:{this.I(L,q);break}case 7:{this.J(L,q,void 0);break}case 9:{let W=d.deserializeReplyOKJSON(B);this.g&&(W=(0,k.$mm)(W,this.g)),this.J(L,q,W);break}case 10:{const W=d.deserializeReplyOKJSONWithBuffers(B,this.g);this.J(L,q,W);break}case 8:{const W=d.deserializeReplyOKVSBuffer(B);this.J(L,q,W);break}case 11:{let W=d.deserializeReplyErrError(B);this.g&&(W=(0,k.$mm)(W,this.g)),this.L(L,q,W);break}case 12:{this.L(L,q,void 0);break}default:console.error("received unexpected message"),console.error(o)}}H(o,L,B,G,q,W){this.f?.logIncoming(o,L,1,`receiveRequest ${(0,F.$Lz)(B)}.${G}(`,q);const N=String(L);let H,j;if(W){const ue=new S.$bd;q.push(ue.token),H=this.M(B,G,q),j=()=>ue.cancel()}else H=this.M(B,G,q),j=i;this.p[N]=j;const O=d.serializeAcknowledged(L);this.f?.logOutgoing(O.byteLength,L,1,"ack"),this.c.send(O),H.then(ue=>{delete this.p[N];const pe=d.serializeReplyOK(L,ue,this.h);this.f?.logOutgoing(pe.byteLength,L,1,"reply:",ue),this.c.send(pe)},ue=>{delete this.p[N];const pe=d.serializeReplyErr(L,ue);this.f?.logOutgoing(pe.byteLength,L,1,"replyErr:",ue),this.c.send(pe)})}I(o,L){this.f?.logIncoming(o,L,1,"receiveCancel");const B=String(L);this.p[B]?.()}J(o,L,B){this.f?.logIncoming(o,L,0,"receiveReply:",B);const G=String(L);if(!this.s.hasOwnProperty(G))return;const q=this.s[G];delete this.s[G],q.resolveOk(B)}L(o,L,B){this.f?.logIncoming(o,L,0,"receiveReplyErr:",B);const G=String(L);if(!this.s.hasOwnProperty(G))return;const q=this.s[G];delete this.s[G];let W;B&&(B.$isError?(W=new Error,W.name=B.name,W.message=B.message,W.stack=B.stack):W=B),q.resolveErr(W)}M(o,L,B){try{return Promise.resolve(this.N(o,L,B))}catch(G){return Promise.reject(G)}}N(o,L,B){const G=this.k[o];if(!G)throw new Error("Unknown actor "+(0,F.$Lz)(o));const q=G[L];if(typeof q!="function")throw new Error("Unknown method "+L+" on actor "+(0,F.$Lz)(o));return q.apply(G,B)}O(o,L,B){if(this.j)return new m.$uZb;let G=null;if(B.length>0&&S.CancellationToken.isCancellationToken(B[B.length-1])&&(G=B.pop()),G&&G.isCancellationRequested)return Promise.reject(z.$3());const q=d.serializeRequestArguments(B,this.h),W=++this.m,N=String(W),H=new m.$tZb;G&&G.onCancellationRequested(()=>{const O=d.serializeCancel(W);this.f?.logOutgoing(O.byteLength,W,0,"cancel"),this.c.send(d.serializeCancel(W))}),this.s[N]=H,this.y(W);const j=d.serializeRequest(W,o,L,q,!!G);return this.f?.logOutgoing(j.byteLength,W,0,`request: ${(0,F.$Lz)(o)}.${L}(`,B),this.c.send(j),H}}e.$xZb=s,D=l,s.a=3*1e3;class p{static alloc(o,L,B){const G=new p(C.$Ib.alloc(B+1+4),0);return G.writeUInt8(o),G.writeUInt32(L),G}static read(o,L){return new p(o,L)}get buffer(){return this.a}constructor(o,L){this.a=o,this.b=L}static sizeUInt8(){return 1}writeUInt8(o){this.a.writeUInt8(o,this.b),this.b+=1}readUInt8(){const o=this.a.readUInt8(this.b);return this.b+=1,o}writeUInt32(o){this.a.writeUInt32BE(o,this.b),this.b+=4}readUInt32(){const o=this.a.readUInt32BE(this.b);return this.b+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this.a.writeUInt8(o.byteLength,this.b),this.b+=1,this.a.set(o,this.b),this.b+=o.byteLength}readShortString(){const o=this.a.readUInt8(this.b);this.b+=1;const B=this.a.slice(this.b,this.b+o).toString();return this.b+=o,B}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this.a.writeUInt32BE(o.byteLength,this.b),this.b+=4,this.a.set(o,this.b),this.b+=o.byteLength}readLongString(){const o=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+o).toString();return this.b+=o,B}writeBuffer(o){this.a.writeUInt32BE(o.byteLength,this.b),this.b+=4,this.a.set(o,this.b),this.b+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this.a.writeUInt32BE(o.byteLength,this.b),this.b+=4,this.a.set(o,this.b),this.b+=o.byteLength}readVSBuffer(){const o=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+o);return this.b+=o,L}static sizeMixedArray(o){let L=0;L+=1;for(let B=0,G=o.length;B<G;B++){const q=o[B];switch(L+=1,q.type){case 1:L+=this.sizeLongString(q.value);break;case 2:L+=this.sizeVSBuffer(q.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(q.value);for(let W=0;W<q.buffers.length;++W)L+=this.sizeVSBuffer(q.buffers[W]);break;case 4:break}}return L}writeMixedArray(o){this.a.writeUInt8(o.length,this.b),this.b+=1;for(let L=0,B=o.length;L<B;L++){const G=o[L];switch(G.type){case 1:this.writeUInt8(1),this.writeLongString(G.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(G.value);break;case 3:this.writeUInt8(3),this.writeUInt32(G.buffers.length),this.writeLongString(G.value);for(let q=0;q<G.buffers.length;++q)this.writeBuffer(G.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const o=this.a.readUInt8(this.b);this.b+=1;const L=new Array(o);for(let B=0;B<o;B++)switch(this.readUInt8()){case 1:L[B]=this.readLongString();break;case 2:L[B]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),W=this.readLongString(),N=[];for(let H=0;H<q;++H)N.push(this.readVSBuffer());L[B]=new F.$Mz(r(W,N,null));break}case 4:L[B]=void 0;break}return L}}p.sizeUInt32=4;var I;(function(a){a[a.Simple=0]="Simple",a[a.Mixed=1]="Mixed"})(I||(I={}));class d{static a(o){for(let L=0,B=o.length;L<B;L++)if(o[L]instanceof C.$Ib||o[L]instanceof F.$Mz||typeof o[L]>"u")return!0;return!1}static serializeRequestArguments(o,L){if(this.a(o)){const B=[];for(let G=0,q=o.length;G<q;G++){const W=o[G];if(W instanceof C.$Ib)B[G]={type:2,value:W};else if(typeof W>"u")B[G]={type:4};else if(W instanceof F.$Mz){const{jsonString:N,referencedBuffers:H}=t(W.value,L);B[G]={type:3,value:C.$Ib.fromString(N),buffers:H}}else B[G]={type:1,value:C.$Ib.fromString(c(W,L))}}return{type:1,args:B}}return{type:0,args:c(o,L)}}static serializeRequest(o,L,B,G,q){switch(G.type){case 0:return this.b(o,L,B,G.args,q);case 1:return this.c(o,L,B,G.args,q)}}static b(o,L,B,G,q){const W=C.$Ib.fromString(B),N=C.$Ib.fromString(G);let H=0;H+=p.sizeUInt8(),H+=p.sizeShortString(W),H+=p.sizeLongString(N);const j=p.alloc(q?2:1,o,H);return j.writeUInt8(L),j.writeShortString(W),j.writeLongString(N),j.buffer}static deserializeRequestJSONArgs(o){const L=o.readUInt8(),B=o.readShortString(),G=o.readLongString();return{rpcId:L,method:B,args:JSON.parse(G)}}static c(o,L,B,G,q){const W=C.$Ib.fromString(B);let N=0;N+=p.sizeUInt8(),N+=p.sizeShortString(W),N+=p.sizeMixedArray(G);const H=p.alloc(q?4:3,o,N);return H.writeUInt8(L),H.writeShortString(W),H.writeMixedArray(G),H.buffer}static deserializeRequestMixedArgs(o){const L=o.readUInt8(),B=o.readShortString(),G=o.readMixedArray(),q=new Array(G.length);for(let W=0,N=G.length;W<N;W++){const H=G[W];typeof H=="string"?q[W]=JSON.parse(H):q[W]=H}return{rpcId:L,method:B,args:q}}static serializeAcknowledged(o){return p.alloc(5,o,0).buffer}static serializeCancel(o){return p.alloc(6,o,0).buffer}static serializeReplyOK(o,L,B){if(typeof L>"u")return this.d(o);if(L instanceof C.$Ib)return this.e(o,L);if(L instanceof F.$Mz){const{jsonString:G,referencedBuffers:q}=t(L.value,B,!0);return this.g(o,G,q)}else return this.f(o,h(L,B))}static d(o){return p.alloc(7,o,0).buffer}static e(o,L){let B=0;B+=p.sizeVSBuffer(L);const G=p.alloc(8,o,B);return G.writeVSBuffer(L),G.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static f(o,L){const B=C.$Ib.fromString(L);let G=0;G+=p.sizeLongString(B);const q=p.alloc(9,o,G);return q.writeLongString(B),q.buffer}static g(o,L,B){const G=C.$Ib.fromString(L);let q=0;q+=p.sizeUInt32,q+=p.sizeLongString(G);for(const N of B)q+=p.sizeVSBuffer(N);const W=p.alloc(10,o,q);W.writeUInt32(B.length),W.writeLongString(G);for(const N of B)W.writeBuffer(N);return W.buffer}static deserializeReplyOKJSON(o){const L=o.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(o,L){const B=o.readUInt32(),G=o.readLongString(),q=[];for(let W=0;W<B;++W)q.push(o.readVSBuffer());return new F.$Mz(r(G,q,L))}static serializeReplyErr(o,L){const B=L?h(z.$Z(L),null):void 0;if(typeof B!="string")return this.h(o);const G=C.$Ib.fromString(B);let q=0;q+=p.sizeLongString(G);const W=p.alloc(11,o,q);return W.writeLongString(G),W.buffer}static deserializeReplyErrError(o){const L=o.readLongString();return JSON.parse(L)}static h(o){return p.alloc(12,o,0).buffer}}var A;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",a[a.ReplyErrError=11]="ReplyErrError",a[a.ReplyErrEmpty=12]="ReplyErrEmpty"})(A||(A={}));var E;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",a[a.Undefined=4]="Undefined"})(E||(E={}))}),define(Re[256],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=void 0;const g=function(z){const T=f=>{globalThis.removeEventListener("message",T);const k=f.data;Object.defineProperties(globalThis,{postMessage:{value(m,F){k.postMessage(m,F)}},onmessage:{get(){return k.onmessage},set(m){k.onmessage=m}}}),k.addEventListener("message",m=>{globalThis.dispatchEvent(new MessageEvent("message",{data:m.data,ports:m.ports?[...m.ports]:void 0}))}),k.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(z)};globalThis.addEventListener("message",T)}.toString();class C extends EventTarget{constructor(z,T,f){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const k=`((${g})('${T}'))`,m=new Blob([k],{type:"application/javascript"}),F=URL.createObjectURL(m),D=new MessageChannel,h=F,b={type:"_newWorker",id:h,port:D.port2,url:F,options:f};z(b,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{z({type:"_terminateWorker",id:h}),URL.revokeObjectURL(F),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set($){D.port1.onmessage=$}},onmessageerror:{get(){return D.port1.onmessageerror},set($){D.port1.onmessageerror=$}}}),D.port1.addEventListener("messageerror",$=>{const u=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(u)}),D.port1.addEventListener("message",$=>{const u=new MessageEvent("message",{data:$.data});this.dispatchEvent(u)}),D.port1.start()}}e.$Zbc=C}),define(Re[257],Fe([1,0,5,30,31,3]),function(te,e,g,C,S,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nI=e.$mI=e.OutputChannelUpdateMode=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=void 0,e.$bI="text/x-code-output",e.$cI="output",e.$dI="Log",e.$eI="text/x-code-log-output",e.$fI="log",e.$gI="log",e.$hI="workbench.panel.output",e.$iI=new S.$Ki("inOutput",!1),e.$jI=new S.$Ki("activeLogOutput",!1),e.$kI=new S.$Ki("outputView.scrollLock",!1),e.$lI=(0,z.$lh)("outputService");var T;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.$mI={OutputChannels:"workbench.contributions.outputChannels"};class f{constructor(){this.a=new Map,this.b=new g.$5c,this.onDidRegisterChannel=this.b.event,this.c=new g.$5c,this.onDidRemoveChannel=this.c.event}registerChannel(m){this.a.has(m.id)||(this.a.set(m.id,m),this.b.fire(m.id))}getChannels(){const m=[];return this.a.forEach(F=>m.push(F)),m}getChannel(m){return this.a.get(m)}removeChannel(m){this.a.delete(m),this.c.fire(m)}}C.$Pm.add(e.$mI.OutputChannels,new f),e.$nI=new S.$Ki("activeOutputChannel","")}),define(Re[109],Fe([1,0,4,3,17,24,15,257,61,27,39,129,25,10,38,5,6]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=e.$G$b=void 0;class r extends T.$Ti{get disposed(){return this.l}constructor(y,i,l,n,s){super(),this.id=y,this.name=i,this.m=l,this.n=n,this.extension=s,this.k=0,this.l=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel(p=>this.setLevel(p)))}get logLevel(){return this.getLevel()}appendLine(y){this.append(y+`
`)}append(y){this.info(y)}clear(){const y=this.k;this.m.flush(),this.n.$update(this.id,f.OutputChannelUpdateMode.Clear,y)}replace(y){const i=this.k;this.info(y),this.n.$update(this.id,f.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(y,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof y=="boolean"?y:i))}hide(){this.n.$close(this.id)}g(y,i){this.k+=h.$Ib.fromString(i).byteLength,(0,T.log)(this.m,y,i),this.visible&&(this.m.flush(),this.n.$update(this.id,f.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class c extends r{appendLine(y){this.append(y)}}let w=e.$G$b=class{constructor(y,i,l,n,s,p){this.i=i,this.j=l,this.k=n,this.l=s,this.m=p,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=y.getProxy(g.$$I.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,D.$Ol)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(y){this.h=y;for(const[i,l]of this.g)l.visible=i===this.h}createOutputChannel(y,i,l){if(y=y.trim(),!y)throw new Error("illegal argument `name`. must not be falsy");const n=typeof i=="object"&&i.log,s=(0,b.$ge)(i)?i:void 0;if((0,b.$ge)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let p;const I=this.i.environment.extensionLogLevel?.find(([A])=>z.$Dl.equals(l.identifier,A))?.[1];I&&(p=(0,T.$4i)(I));const d=n?this.o(y,p,l):this.n(y,s,l);return d.then(A=>{this.g.set(A.id,A),A.visible=A.id===this.h}),n?this.r(y,p??this.m.getLevel(),d):this.q(y,d)}async n(y,i,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,s=this.k.extUri.joinPath(n,`${this.f++}-${y.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.l.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.a.$register(y,s,i,l.identifier.value);return new r(I,y,p,this.a,l)}async o(y,i,l){const n=await this.p(l),s=y.replace(/[\\/:\*\?"<>\|]/g,""),p=this.k.extUri.joinPath(n,`${s}.log`),I=`${l.identifier.value}.${s}`,d=this.l.createLogger(p,{id:I,name:y,logLevel:i,extensionId:l.identifier.value});return new c(I,y,d,this.a,l)}p(y){let i=this.d.get(y.identifier.value);if(!i){const l=this.k.extUri.joinPath(this.i.logsLocation,y.identifier.value);this.d.set(y.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(l)}catch(n){if((0,$.$4j)(n)!==$.FileSystemProviderErrorCode.FileExists)throw n}return l})())}return i}q(y,i){let l=!1;const n=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return y},append(s){n(),i.then(p=>p.append(s))},appendLine(s){n(),i.then(p=>p.appendLine(s))},clear(){n(),i.then(s=>s.clear())},replace(s){n(),i.then(p=>p.replace(s))},show(s,p){n(),i.then(I=>I.show(s,p))},hide(){n(),i.then(s=>s.hide())},dispose(){l=!0,i.then(s=>s.dispose())}}}r(y,i,l){const n=new t.$jb,s=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},p=n.add(new u.$5c);function I(d){i=d,p.fire(d)}return l.then(d=>{n.add(d),d.logLevel!==i&&I(d.logLevel),n.add(d.onDidChangeLogLevel(A=>I(A)))}),{...this.q(y,l),get logLevel(){return i},onDidChangeLogLevel:p.event,trace(d,...A){s(),l.then(E=>E.trace(d,...A))},debug(d,...A){s(),l.then(E=>E.debug(d,...A))},info(d,...A){s(),l.then(E=>E.info(d,...A))},warn(d,...A){s(),l.then(E=>E.warn(d,...A))},error(d,...A){s(),l.then(E=>E.error(d,...A))},dispose(){n.dispose()}}}};e.$G$b=w=qe([Ve(0,S.$aL),Ve(1,m.$qL),Ve(2,k.$j$b),Ve(3,F.$Q0b),Ve(4,T.$Oi),Ve(5,T.$Ni)],w),e.$H$b=(0,C.$lh)("IExtHostOutputService")});var Te=this&&this.__classPrivateFieldGet||function(te,e,g,C){if(g==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?C:g==="a"?C.call(te):C?C.value:e.get(te)},Ye=this&&this.__classPrivateFieldSet||function(te,e,g,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g};define(Re[258],Fe([1,0,3,16]),function(te,e,g,C){"use strict";var S,z,T,f,k,m,F,D,h,b,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=void 0,e.$4l=(0,g.$lh)("remoteAgentService"),e.$5l=new($=class{constructor(){S.set(this,5),z.set(this,2e3),T.set(this,[]),f.set(this,3),k.set(this,[]),m.set(this,100),F.set(this,2),D.set(this,500),h.set(this,1500),b.set(this,void 0)}get latency(){return Te(this,b,"f")}async measure(u){let t=1/0;for(let c=0;c<Te(this,S,"f");c++){const w=await u.getRoundTripTime();if(w===void 0)return;t=Math.min(t,w/2),await(0,C.$sg)(Te(this,z,"f"))}Te(this,k,"f").push(t),Te(this,k,"f").length>Te(this,m,"f")&&Te(this,k,"f").shift();let r;return Te(this,T,"f").length<Te(this,f,"f")?Te(this,T,"f").push(t):r=Te(this,T,"f").reduce((c,w)=>c+w,0)/Te(this,T,"f").length,Ye(this,b,{initial:r,current:t,average:Te(this,k,"f").reduce((c,w)=>c+w,0)/Te(this,k,"f").length,high:(()=>typeof r>"u"?!1:t>Te(this,h,"f")||t>Te(this,D,"f")&&t>r*Te(this,F,"f"))()},"f"),Te(this,b,"f")}},S=new WeakMap,z=new WeakMap,T=new WeakMap,f=new WeakMap,k=new WeakMap,m=new WeakMap,F=new WeakMap,D=new WeakMap,h=new WeakMap,b=new WeakMap,$)}),define(Re[259],Fe([1,0,42,14,19,21,20,2,3,185,53,208,258]),function(te,e,g,C,S,z,T,f,k,m,F,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NI=e.$MI=void 0,e.$MI=(0,k.$lh)("pathService");let b=e.$NI=class Tn{constructor(u,t,r,c){this.d=u,this.e=t,this.f=r,this.g=c,this.a=(async()=>(await this.e.getEnvironment())?.os||z.OS)(),this.b=(async()=>{const w=await this.e.getEnvironment();return this.c=w?.userHome??u})()}hasValidBasename(u,t,r){return typeof t=="string"||typeof t>"u"?this.a.then(c=>this.h(u,c,t)):this.h(u,t,r)}h(u,t,r){return u.scheme===C.Schemas.file||u.scheme===C.Schemas.vscodeRemote?(0,g.$Fe)(r??(0,T.$3f)(u),t===1):!0}get defaultUriScheme(){return Tn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(u,t){if(u.remoteAuthority)return C.Schemas.vscodeRemote;const r=(0,m.$JI)(t.getWorkspace());if(r)return r;const c=t.getWorkspace().folders[0];if(c)return c.uri.scheme;const w=t.getWorkspace().configuration;return w?w.scheme:C.Schemas.file}userHome(u){return u?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(u=>u===1?S.$7b:S.$8b)}async fileURI(u){let t="";if(await this.a===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const c=u.indexOf("/",2);c===-1?(t=u.substring(2),u="/"):(t=u.substring(2,c),u=u.substring(c)||"/")}return f.URI.from({scheme:C.Schemas.file,authority:t,path:u,query:"",fragment:""})}};e.$NI=b=qe([Ve(1,h.$4l),Ve(2,D.$oI),Ve(3,F.$uh)],b)}),define(Re[110],Fe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$qH=e.$pH=void 0;class g{constructor(T,f){this.line=T,this.character=f}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,f){return new g(0,0)}with(T){return new g(0,0)}}e.$pH=g;class C{constructor(T,f,k,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(T,f),this.end=new g(k,m)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new C(0,0,0,0)}with(T){return new C(0,0,0,0)}}e.$qH=C;var S;(function(z){z[z.Information=1]="Information",z[z.Warning=2]="Warning"})(S||(e.TextSearchCompleteMessageType=S={}))}),define(Re[47],Fe([1,0,18,37,23,42,13,3,19,9,110,16]),function(te,e,g,C,S,z,T,f,k,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.SearchErrorCode=e.$EH=e.$DH=e.SearchSortOrder=e.ViewMode=e.$CH=e.$BH=e.$AH=e.$zH=e.SearchCompletionExitCode=e.$yH=e.$xH=e.$wH=e.QueryType=e.SearchProviderType=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.$rH="workbench.view.search",e.$sH="workbench.panel.search",e.$tH="workbench.view.search",e.$uH="search.exclude";const h="\u27EA ",b=" characters skipped \u27EB",$=(h.length+b.length+5)*2;e.$vH=(0,f.$lh)("searchService");var u;(function(_){_[_.file=0]="file",_[_.text=1]="text"})(u||(e.SearchProviderType=u={}));var t;(function(_){_[_.File=1]="File",_[_.Text=2]="Text"})(t||(e.QueryType=t={}));function r(_){return!!_.preview}e.$wH=r;function c(_){return!!_.resource}e.$xH=c;function w(_){return!!_.message}e.$yH=w;var v;(function(_){_[_.Normal=0]="Normal",_[_.NewSearchStarted=1]="NewSearchStarted"})(v||(e.SearchCompletionExitCode=v={}));class y{constructor(Y){this.resource=Y,this.results=[]}}e.$zH=y;class i{constructor(Y,ce,ke,Ce){this.ranges=ce,this.webviewIndex=Ce;const me=Array.isArray(ce)?ce:[ce];if(ke&&ke.matchLines===1&&l(me)){Y=(0,T.$_d)(Y,ke.matchLines);let R="",Q=0,he=0;const De=Math.floor(ke.charsPerLine/5),ye=[];for(const $e of me){const Se=Math.max($e.startColumn-De,0),ae=$e.startColumn+ke.charsPerLine;if(Se>he+De+$){const le=h+(Se-he)+b;R+=le+Y.slice(Se,ae),Q+=Se-(he+le.length)}else R+=Y.slice(he,ae);ye.push(new s(0,$e.startColumn-Q,$e.endColumn-Q)),he=ae}this.preview={text:R,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const R=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:Y,matches:(0,g.$Ff)(ce,Q=>new n(Q.startLineNumber-R,Q.startColumn,Q.endLineNumber-R,Q.endColumn))}}}}e.$AH=i;function l(_){const Y=_[0].startLineNumber;for(const ce of _)if(ce.startLineNumber!==Y||ce.endLineNumber!==Y)return!1;return!0}class n{constructor(Y,ce,ke,Ce){this.startLineNumber=Y,this.startColumn=ce,this.endLineNumber=ke,this.endColumn=Ce}}e.$BH=n;class s extends n{constructor(Y,ce,ke){super(Y,ce,Y,ke)}}e.$CH=s;var p;(function(_){_.List="list",_.Tree="tree"})(p||(e.ViewMode=p={}));var I;(function(_){_.Default="default",_.FileNames="fileNames",_.Type="type",_.Modified="modified",_.CountDescending="countDescending",_.CountAscending="countAscending"})(I||(e.SearchSortOrder=I={}));function d(_,Y=!0){const ce=_&&_.files&&_.files.exclude,ke=Y&&_&&_.search&&_.search.exclude;if(!ce&&!ke)return;if(!ce||!ke)return ce||ke;let Ce=Object.create(null);return Ce=S.$Gm(Ce,S.$Dm(ce)),Ce=S.$Gm(Ce,S.$Dm(ke),!0),Ce}e.$DH=d;function A(_,Y){return _.excludePattern&&C.$_i(_.excludePattern,Y)?!1:_.includePattern||_.usingSearchPaths?_.includePattern&&C.$_i(_.includePattern,Y)?!0:_.usingSearchPaths?!!_.folderQueries&&_.folderQueries.some(ce=>{const ke=ce.folder.fsPath;if(z.$He(Y,ke)){const Ce=k.$ac(ke,Y);return!ce.includePattern||!!C.$_i(ce.includePattern,Ce)}else return!1}):!1:!0}e.$EH=A;var E;(function(_){_[_.unknownEncoding=1]="unknownEncoding",_[_.regexParseError=2]="regexParseError",_[_.globParseError=3]="globParseError",_[_.invalidLiteral=4]="invalidLiteral",_[_.rgProcessError=5]="rgProcessError",_[_.other=6]="other",_[_.canceled=7]="canceled"})(E||(e.SearchErrorCode=E={}));class a extends Error{constructor(Y,ce){super(Y),this.code=ce}}e.$FH=a;function o(_){const Y=_.message;if((0,m.$1)(_))return new a(Y,E.canceled);try{const ce=JSON.parse(Y);return new a(ce.message,ce.code)}catch{return new a(Y,E.other)}}e.$GH=o;function L(_){const Y={message:_.message,code:_.code};return new Error(JSON.stringify(Y))}e.$HH=L;function B(_){return _.type==="error"?!0:_.type==="success"}e.$IH=B;function G(_){return _.type==="success"}e.$JH=G;function q(_){return!!_.path}e.$KH=q;function W(_,Y){const ce=_.searchPath?_.searchPath:_.relativePath;return(0,T.$9d)(ce,Y)}e.$LH=W;class N{constructor(Y){this.path=Y,this.results=[]}addMatch(Y){this.results.push(Y)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$MH=N;function H(_,Y){const ce={..._||{},...Y||{}};return Object.keys(ce).filter(ke=>{const Ce=ce[ke];return typeof Ce=="boolean"&&Ce})}e.$NH=H;class j{constructor(Y,ce){this.c=null,this.a={...Y.excludePattern||{},...ce.excludePattern||{}},this.b=C.$aj(this.a);let ke=Y.includePattern;ce.includePattern&&(ke?ke={...ke,...ce.includePattern}:ke=ce.includePattern),ke&&(this.c=C.$aj(ke))}matchesExcludesSync(Y,ce,ke){return!!(this.b&&this.b(Y,ce,ke))}includedInQuerySync(Y,ce,ke){return!(this.b&&this.b(Y,ce,ke)||this.c&&!this.c(Y,ce,ke))}includedInQuery(Y,ce,ke){const Ce=this.b(Y,ce,ke),me=()=>this.c?!!this.c(Y,ce,ke):!0;return(0,D.$eg)(Ce)?Ce.then(R=>R?!1:me()):me()}hasSiblingExcludeClauses(){return O(this.a)}}e.$OH=j;function O(_){for(const Y in _)if(typeof _[Y]!="boolean")return!0;return!1}function ue(_){if(!_)return;let Y;return ce=>(Y||(Y=(_()||Promise.resolve([])).then(ke=>ke?Pe(ke):{})),Y.then(ke=>!!ke[ce]))}e.$PH=ue;function pe(_){if(!_)return;let Y;return ce=>{if(!Y){const ke=_();Y=ke?Pe(ke):{}}return!!Y[ce]}}e.$QH=pe;function Pe(_){const Y={};for(const ce of _)Y[ce]=!0;return Y}}),define(Re[33],Fe([1,0,18,16,22,5,6,48,14,117,20,13,10,2,156,3,15,173,53,39,27,17,8,7,55,47,4]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t,r,c,w,v,y,i,l,n,s,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$40b=e.$30b=void 0;function I(G,q,W){return new F.$Uf(N=>a(N,W)).isEqual(G,q)}function d(G,q,W){return I(G.uri,q.uri,W)?0:(0,D.$Cd)(G.uri.toString(),q.uri.toString())}function A(G,q,W){return G.index!==q.index?G.index<q.index?-1:1:I(G.uri,q.uri,W)?(0,D.$Cd)(G.name,q.name):(0,D.$Cd)(G.uri.toString(),q.uri.toString())}function E(G,q,W,N){const H=G.slice(0).sort((O,ue)=>W(O,ue,N)),j=q.slice(0).sort((O,ue)=>W(O,ue,N));return(0,g.$gf)(H,j,(O,ue)=>W(O,ue,N))}function a(G,q){const W=q.getCapabilities(G.scheme);return!(W&&W&1024)}class o extends c.$Eh{static toExtHostWorkspace(q,W,N,H){if(!q)return{workspace:null,added:[],removed:[]};const{id:j,name:O,folders:ue,configuration:pe,transient:Pe,isUntitled:_}=q,Y=[],ce=W;W?ue.forEach((R,Q)=>{const he=b.URI.revive(R.uri),De=o.o(N||W,he,H);De?(De.name=R.name,De.index=R.index,Y.push(De)):Y.push({uri:he,name:R.name,index:Q})}):Y.push(...ue.map(({uri:R,name:Q,index:he})=>({uri:b.URI.revive(R),name:Q,index:he}))),Y.sort((R,Q)=>R.index<Q.index?-1:1);const ke=new o(j,O,Y,!!Pe,pe?b.URI.revive(pe):null,!!_,R=>a(R,H)),{added:Ce,removed:me}=E(ce?ce.workspaceFolders:[],ke.workspaceFolders,d,H);return{workspace:ke,added:Ce,removed:me}}static o(q,W,N){for(let H=0;H<q.folders.length;H++){const j=q.workspaceFolders[H];if(I(j.uri,W,N))return j}}constructor(q,W,N,H,j,O,ue){super(q,N.map(pe=>new c.$Fh(pe)),H,j,ue),this.t=W,this.u=O,this.q=[],this.s=f.$rh.forUris(ue),N.forEach(pe=>{this.q.push(pe),this.s.set(pe.uri,pe)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,W){return W&&this.s.get(q)&&(q=(0,F.$5f)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let L=e.$30b=class{constructor(q,W,N,H,j){this.c=new z.$5c,this.onDidChangeWorkspace=this.c.event,this.g=new z.$5c,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new z.$7c,this.B=new Map,this.h=H,this.s=N,this.t=j,this.j=new m.$rl,this.k=new C.$qg,this.o=q.getProxy(p.$$I.MainThreadWorkspace),this.q=q.getProxy(p.$$I.MainThreadMessageService);const O=W.workspace;this.l=O?new o(O.id,O.name,[],!!O.transient,O.configuration?b.URI.revive(O.configuration):null,!!O.isUntitled,ue=>a(ue,N)):void 0}$initializeWorkspace(q,W){this.v=W,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:k.Schemas.untitled,path:(0,F.$3f)((0,F.$5f)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,W,N,...H){const j=[];if(Array.isArray(H)&&H.forEach(_=>{b.URI.isUri(_.uri)&&!j.some(Y=>I(Y.uri,_.uri,this.s))&&j.push({uri:_.uri,name:_.name||(0,F.$2f)(_.uri)})}),this.n||[W,N].some(_=>typeof _!="number"||_<0)||N===0&&j.length===0)return!1;const O=this.x?this.x.workspaceFolders:[];if(W+N>O.length)return!1;const ue=O.slice(0);ue.splice(W,N,...j.map(_=>({uri:_.uri,name:_.name||(0,F.$2f)(_.uri),index:void 0})));for(let _=0;_<ue.length;_++){const Y=ue[_];if(ue.some((ce,ke)=>ke!==_&&I(Y.uri,ce.uri,this.s)))return!1}ue.forEach((_,Y)=>_.index=Y);const{added:pe,removed:Pe}=E(O,ue,A,this.s);if(pe.length===0&&Pe.length===0)return!1;if(this.o){const _=q.displayName||q.name;this.o.$updateWorkspaceFolders(_,W,N,j).then(void 0,Y=>{this.n=void 0;const ce={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(r.Severity.Error,(0,$.localize)(0,null,_,Y.toString()),ce,[])})}return this.y(ue),!0}getWorkspaceFolder(q,W){if(this.x)return this.x.getWorkspaceFolder(q,W)}async getWorkspaceFolder2(q,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,W)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,W){let N,H="";if(typeof q=="string"?(N=b.URI.file(q),H=q):typeof q<"u"&&(N=q,H=q.fsPath),!N)return H;const j=this.getWorkspaceFolder(N,!0);if(!j)return H;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let O=(0,F.$8f)(j.uri,N);return W&&j.name&&(O=`${j.name}/${O}`),O}y(q){this.x&&(this.n=o.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:W,added:N,removed:H}=o.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:H}))}findFiles(q,W,N,H,j=S.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${H.value}, entryPoint: findFiles`);let O;if(W===null?O=!1:W&&(typeof W=="string"?O=W:O=W.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:ue,folder:pe}=B(i.GlobPattern.from(q));return this.o.$startFileSearch((0,h.$ze)(ue),(0,h.$ze)(pe),(0,h.$ze)(O),(0,h.$ze)(N),j).then(Pe=>Array.isArray(Pe)?Pe.map(_=>b.URI.revive(_)):[])}async findTextInFiles(q,W,N,H,j=S.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${H.value}, entryPoint: findTextInFiles`);const O=this.j.getNext(),ue=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:pe,folder:Pe}=B(i.GlobPattern.from(W.include)),_=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,Y={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:ue,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:pe,excludePattern:_},ce=!1;if(this.u[O]=ke=>{if(ce)return;const Ce=b.URI.revive(ke.resource);ke.results.forEach(me=>{(0,s.$wH)(me)?N({uri:Ce,preview:{text:me.preview.text,matches:(0,g.$Ff)(me.preview.matches,R=>new l.$cJ(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn))},ranges:(0,g.$Ff)(me.ranges,R=>new l.$cJ(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn))}):N({uri:Ce,text:me.text,lineNumber:me.lineNumber})})},j.isCancellationRequested)return{};try{const ke=await this.o.$startTextSearch(q,(0,h.$ze)(Pe),Y,O,j);return delete this.u[O],ke||{}}catch(ke){throw delete this.u[O],ke}}$handleTextSearchResult(q,W){this.u[W]?.(q)}async save(q){const W=await this.o.$save(q,{saveAs:!1});return b.URI.revive(W)}async saveAs(q){const W=await this.o.$save(q,{saveAs:!0});return b.URI.revive(W)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,W){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,W);const N=this.t.transformOutgoingScheme(q),H=this.z++;return this.o.$registerEditSessionIdentityProvider(H,N),(0,T.$ib)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(H)})}async $getEditSessionIdentifier(q,W){this.h.info("Getting edit session identifier for workspaceFolder",q);const N=await this.resolveWorkspaceFolder(b.URI.revive(q));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const H=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!H),!H)return;const j=await H.provideEditSessionIdentity(N,W);if(this.h.info("Provider returned edit session identifier: ",j),!!j)return j}async $provideEditSessionIdentityMatch(q,W,N,H){this.h.info("Getting edit session identifier for workspaceFolder",q);const j=await this.resolveWorkspaceFolder(b.URI.revive(q));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const O=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!O),!O)return;const ue=await O.provideEditSessionIdentityMatch?.(W,N,H);if(this.h.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}getOnWillCreateEditSessionIdentityEvent(q){return(W,N,H)=>{const j=function(ue){W.call(N,ue)};return j.extension=q,this.A.event(j,void 0,H)}}async $onWillCreateEditSessionIdentity(q,W,N){const H=await this.resolveWorkspaceFolder(b.URI.revive(q));if(H===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:H},W,async(j,O)=>{const ue=Date.now();await Promise.resolve(j),Date.now()-ue>N&&this.h.warn("SLOW edit session create-participant",O.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(q,W){if(this.B.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.B.set(q,W);const N=this.t.transformOutgoingScheme(q),H=this.z++;return this.o.$registerCanonicalUriProvider(H,N),(0,T.$ib)(()=>{this.B.delete(q),this.o.$unregisterCanonicalUriProvider(H)})}async provideCanonicalUri(q,W,N){const H=this.B.get(q.scheme);if(!H)return;const j=await H.provideCanonicalUri?.(b.URI.revive(q),W,N);if(j)return j}async $provideCanonicalUri(q,W,N){return this.provideCanonicalUri(b.URI.revive(q),{targetScheme:W},N)}};e.$30b=L=qe([Ve(0,y.$aL),Ve(1,v.$qL),Ve(2,w.$Q0b),Ve(3,t.$Ni),Ve(4,n.$10b)],L),e.$40b=(0,u.$lh)("IExtHostWorkspace");function B(G){let q,W;return G&&(typeof G=="string"?q=G:(q=G.pattern,W=b.URI.revive(G.baseUri))),{includePattern:q,folder:W}}}),define(Re[34],Fe([1,0,23,5,33,4,7,176,96,10,16,3,17,15,2]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$70b=e.$60b=e.$50b=void 0;function u(l,n){if(n){const s=n.split(".");let p=l;for(let I=0;p&&I<s.length;I++)p=p[s[I]];return p}}function t(l){return l instanceof $.URI}function r(l){return l&&l.uri instanceof $.URI&&l.languageId&&typeof l.languageId=="string"}function c(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function w(l){return l&&l.uri instanceof $.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function v(l){if(t(l))return{resource:l};if(r(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(c(l))return{overrideIdentifier:l.languageId};if(w(l))return{resource:l.uri};if(l===null)return{resource:null}}let y=e.$50b=class{constructor(n,s,p){this.a=n.getProxy(z.$$I.MainThreadConfiguration),this.c=s,this.b=p,this.d=new F.$qg,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new i(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,s){this.getConfigProvider().then(p=>p.$acceptConfigurationChanged(n,s))}};e.$50b=y=qe([Ve(0,h.$aL),Ve(1,S.$40b),Ve(2,b.$Ni)],y);class i{constructor(n,s,p,I){this.a=new C.$5c,this.b=n,this.f=I,this.c=s,this.e=f.$bn.parse(p),this.d=this.k(p.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,s){const p={data:this.e.toData(),workspace:this.c.workspace};this.e=f.$bn.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(s,p))}getConfiguration(n,s,p){const I=v(s)||{},d=this.g(n?u(this.e.getValue(void 0,I,this.c.workspace),n):this.e.getValue(void 0,I,this.c.workspace));n&&this.h(n,I,p?.identifier);function A(a){if(a==null)return null;if(typeof a=="boolean")return a?2:5;switch(a){case T.ConfigurationTarget.Global:return 2;case T.ConfigurationTarget.Workspace:return 5;case T.ConfigurationTarget.WorkspaceFolder:return 6}}const E={has(a){return typeof u(d,a)<"u"},get:(a,o)=>{this.h(n?`${n}.${a}`:a,I,p?.identifier);let L=u(d,a);if(typeof L>"u")L=o;else{let B;const G=(q,W)=>{if((0,m.$ie)(q)){let N;const H=()=>{B=B||(0,g.$Dm)(d),N=N||u(B,W)};return new Proxy(q,{get:(j,O)=>{if(typeof O=="string"&&O.toLowerCase()==="tojson")return H(),()=>N;if(B)return N=N||u(B,W),N[O];const ue=j[O];return typeof O=="string"?G(ue,`${W}.${O}`):ue},set:(j,O,ue)=>(H(),N&&(N[O]=ue),!0),deleteProperty:(j,O)=>(H(),N&&delete N[O],!0),defineProperty:(j,O,ue)=>(H(),N&&Object.defineProperty(N,O,ue),!0)})}return Array.isArray(q)?(0,g.$Dm)(q):q};L=G(L,a)}return L},update:(a,o,L,B)=>{a=n?`${n}.${a}`:a;const G=A(L);return o!==void 0?this.b.$updateConfigurationOption(G,a,o,I,B):this.b.$removeConfigurationOption(G,a,I,B)},inspect:a=>{a=n?`${n}.${a}`:a;const o=this.e.inspect(a,I,this.c.workspace);if(o)return{key:a,defaultValue:(0,g.$Dm)(o.policy?.value??o.default?.value),globalValue:(0,g.$Dm)(o.user?.value??o.application?.value),workspaceValue:(0,g.$Dm)(o.workspace?.value),workspaceFolderValue:(0,g.$Dm)(o.workspaceFolder?.value),defaultLanguageValue:(0,g.$Dm)(o.default?.override),globalLanguageValue:(0,g.$Dm)(o.user?.override??o.application?.override),workspaceLanguageValue:(0,g.$Dm)(o.workspace?.override),workspaceFolderLanguageValue:(0,g.$Dm)(o.workspaceFolder?.override),languageIds:(0,g.$Dm)(o.overrideIdentifiers)}}};return typeof d=="object"&&(0,g.$Gm)(E,d,!1),Object.freeze(E)}g(n){const s=p=>(0,m.$ie)(p)?new Proxy(p,{get:(I,d)=>s(I[d]),set:(I,d,A)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(I,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(I,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:I=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):p;return s(n)}h(n,s,p){const I=k.$5m.test(n)?4:this.d.get(n),d=p?`[${p.value}] `:"";if(I===4){typeof s?.resource>"u"&&this.f.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(I===3){s?.resource&&this.f.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,s){const p=new f.$dn(n,s,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(I,d)=>p.affectsConfiguration(I,v(d))})}k(n){return n.reduce((s,p)=>(s.set(p[0],p[1]),s),new Map)}}e.$60b=i,e.$70b=(0,D.$lh)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(te,e,g,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Te=this&&this.__classPrivateFieldGet||function(te,e,g,C){if(g==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?C:g==="a"?C.call(te):C?C.value:e.get(te)};define(Re[111],Fe([1,0,2,16,5,4,7,33,59,34,22,62,17,27,3,14,21,15,81,213,9]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t,r,c,w,v){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$5$b=e.$4$b=e.$3$b=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(q){function W(H){if(H!=null)return H}q.from=W;function N(H){if(H!=null)return H}q.to=N})(i||(i={}));var l;(function(q){function W(H){if(H!=null)return H}q.from=W;function N(H){if(H!=null)return H}q.to=N})(l||(l={}));var n;(function(q){function W(H){if(H!=null)return H}q.from=W;function N(H){if(H!=null)return H}q.to=N})(n||(n={}));var s;(function(q){function W(j){if(j){const O=j;return O&&!!O.process}else return!1}q.is=W;function N(j){if(j==null)return;const O={process:j.process,args:j.args};return j.options&&(O.options=n.from(j.options)),O}q.from=N;function H(j){if(j!=null)return new T.$VJ(j.process,j.args,j.options)}q.to=H})(s||(s={}));var p;(function(q){function W(H){if(H!=null)return H}q.from=W;function N(H){if(H!=null)return H}q.to=N})(p||(p={}));var I;(function(q){function W(j){if(j){const O=j;return O&&(!!O.commandLine||!!O.command)}else return!1}q.is=W;function N(j){if(j==null)return;const O={};return j.commandLine!==void 0?O.commandLine=j.commandLine:(O.command=j.command,O.args=j.args),j.options&&(O.options=p.from(j.options)),O}q.from=N;function H(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new T.$WJ(j.commandLine,j.options):new T.$WJ(j.command,j.args?j.args:[],j.options)}q.to=H})(I||(I={}));var d;(function(q){function W(j){if(j){const O=j;return O&&O.customExecution==="customExecution"}else return!1}q.is=W;function N(j){return{customExecution:"customExecution"}}q.from=N;function H(j,O){return O.get(j)}q.to=H})(d||(e.CustomExecutionDTO=d={}));var A;(function(q){function W(N,H){let j;return N.scope!==void 0&&typeof N.scope!="number"?j=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===T.TaskScope.Workspace&&H&&H.workspaceFile?j=H.workspaceFile:j=w.$tF),{id:N._id,workspaceFolder:j}}q.from=W})(A||(e.TaskHandleDTO=A={}));var E;(function(q){function W(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}q.from=W})(E||(E={}));var a;(function(q){function W(j,O){if(j==null)return[];const ue=[];for(const pe of j){const Pe=N(pe,O);Pe&&ue.push(Pe)}return ue}q.fromMany=W;function N(j,O){if(j==null)return;let ue;j.execution instanceof T.$VJ?ue=s.from(j.execution):j.execution instanceof T.$WJ?ue=I.from(j.execution):j.execution&&j.execution instanceof T.$XJ&&(ue=d.from(j.execution));const pe=i.from(j.definition);let Pe;return j.scope?typeof j.scope=="number"?Pe=j.scope:Pe=j.scope.uri:Pe=T.TaskScope.Workspace,!pe||!Pe?void 0:{_id:j._id,definition:pe,name:j.name,source:{extensionId:O.identifier.value,label:j.source,scope:Pe},execution:ue,isBackground:j.isBackground,group:E.from(j.group),presentationOptions:l.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}q.from=N;async function H(j,O,ue){if(j==null)return;let pe;s.is(j.execution)?pe=s.to(j.execution):I.is(j.execution)?pe=I.to(j.execution):d.is(j.execution)&&(pe=d.to(j._id,ue));const Pe=i.to(j.definition);let _;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?_=j.source.scope:_=await O.resolveWorkspaceFolder(g.URI.revive(j.source.scope)):_=T.TaskScope.Workspace),!Pe||!_)return;const Y=new T.$YJ(Pe,_,j.name,j.source.label,pe,j.problemMatchers);return j.isBackground!==void 0&&(Y.isBackground=j.isBackground),j.group!==void 0&&(Y.group=T.$UJ.from(j.group._id),Y.group&&j.group.isDefault&&(Y.group=new T.$UJ(Y.group.id,Y.group.label),j.group.isDefault===!0&&(Y.group.isDefault=j.group.isDefault))),j.presentationOptions&&(Y.presentationOptions=l.to(j.presentationOptions)),j._id&&(Y._id=j._id),j.detail&&(Y.detail=j.detail),Y}q.to=H})(a||(e.TaskDTO=a={}));var o;(function(q){function W(H){return H}q.from=W;function N(H){if(H)return Object.assign(Object.create(null),H)}q.to=N})(o||(o={}));class L{constructor(W,N,H){this._id=N,this.a=H,y.set(this,void 0),Ye(this,y,W,"f")}get task(){return this.a}terminate(){Te(this,y,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}y=new WeakMap;let B=e.$3$b=class{constructor(W,N,H,j,O,ue,pe,Pe){this.q=new S.$5c,this.r=new S.$5c,this.s=new S.$5c,this.t=new S.$5c,this.a=W.getProxy(z.$$I.MainThreadTask),this.b=H,this.c=j,this.d=O,this.e=ue,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=pe,this.g=Pe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,N,H){if(!H)return new T.$aJ(()=>{});const j=this.w();return this.j.set(j,{type:N,provider:H,extension:W}),this.a.$registerTaskProvider(j,N),new T.$aJ(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(W,N){this.a.$registerTaskSystem(W,N)}fetchTasks(W){return this.a.$fetchTasks(o.from(W)).then(async N=>{const H=[];for(const j of N){const O=await a.to(j,this.b,this.m);O&&H.push(O)}return H})}get taskExecutions(){const W=[];return this.k.forEach(N=>W.push(N)),W}terminateTask(W){if(!(W instanceof L))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,N,H){const j=this.m.get(W.id);j&&(this.o.set(W.id,j),this.e.attachPtyToTerminal(N,await j.callback(H))),this.p=W.id,this.q.fire({execution:await this.y(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){const N=await this.y(W);this.l.delete(W.id),this.k.delete(W.id),this.A(W),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const N=await this.y(W.id);this.s.fire({execution:N,processId:W.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(W){const N=await this.y(W.id);this.t.fire({execution:N,exitCode:W.exitCode})}$provideTasks(W,N){const H=this.j.get(W);if(!H)return Promise.reject(new Error("no handler found"));const j=[],O=(0,C.$kg)(()=>H.provider.provideTasks(F.CancellationToken.None)).then(ue=>this.u(N,j,H,ue));return new Promise(ue=>{O.then(pe=>{Promise.all(j).then(()=>{ue(pe)})})})}async $resolveTask(W,N){const H=this.j.get(W);if(!H)return Promise.reject(new Error("no handler found"));if(N.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${H.type}].`);const j=await a.to(N,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const O=await H.provider.resolveTask(j,F.CancellationToken.None);if(!O)return;this.z(O,H);const ue=a.from(O,H.extension);if(!ue)throw new Error("Unexpected: Task cannot be resolved.");if(O.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(ue.execution)&&await this.x(ue,O,!0),await this.v(ue)}w(){return this.h++}async x(W,N,H){const j=await this.a.$createTaskId(W);!H&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,N.execution)),this.m.set(j,N.execution)}async y(W,N){if(typeof W=="string"){const O=this.l.get(W);if(!O)throw new v.$_("Unexpected: The specified task is missing an execution");return O}const H=this.l.get(W.id);if(H)return H;const j=new Promise((O,ue)=>{function pe(Pe,_,Y){Y?O(new L(Pe,_.id,Y)):ue("Unexpected: Task does not exist.")}N?pe(this,W,N):a.to(W.task,this.b,this.m).then(Pe=>pe(this,W,Pe))});return this.l.set(W.id,j),j.then(O=>(this.k.set(W.id,O),O),O=>Promise.reject(O))}z(W,N){W._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}A(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const H=this.n.values();let j=H.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=H.next()}};e.$3$b=B=qe([Ve(0,h.$aL),Ve(1,b.$qL),Ve(2,f.$40b),Ve(3,k.$lL),Ve(4,m.$70b),Ve(5,D.$m$b),Ve(6,r.$Ni),Ve(7,c.$T0b)],B);let G=e.$4$b=class extends B{constructor(W,N,H,j,O,ue,pe,Pe){super(W,N,H,j,O,ue,pe,Pe),this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(W,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const H=a.from(N,W);if(H===void 0)throw new Error("Task is not valid");if(d.is(H.execution))await this.x(H,N,!1);else throw new v.$0;const j=await this.y(await this.a.$getTaskExecution(H),N);return this.a.$executeTask(H).catch(O=>{throw new Error(O)}),j}u(W,N,H,j){const O=[];if(j)for(const ue of j){this.z(ue,H),(!ue.definition||!W[ue.definition.type])&&this.f.warn(`The task [${ue.source}, ${ue.name}] uses an undefined task type. The task will be ignored in the future.`);const pe=a.from(ue,H.extension);pe&&d.is(pe.execution)?(O.push(pe),N.push(this.x(pe,ue,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:O,extension:H.extension}}async v(W){if(d.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,N,H){}};e.$4$b=G=qe([Ve(0,h.$aL),Ve(1,b.$qL),Ve(2,f.$40b),Ve(3,k.$lL),Ve(4,m.$70b),Ve(5,D.$m$b),Ve(6,r.$Ni),Ve(7,c.$T0b)],G),e.$5$b=(0,$.$lh)("IExtHostTask")}),define(Re[260],Fe([1,0,19,22,41,37,20,58,47]),function(te,e,g,C,S,z,T,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c_b=void 0;class m{constructor(h,b,$){this.k=h,this.l=b,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=h.filePattern,this.b=h.includePattern&&z.$aj(h.includePattern),this.c=h.maxResults||void 0,this.d=h.exists,this.h=new Set,this.j=h.excludePattern&&z.$aj(h.excludePattern)}cancel(){this.g=!0,this.h.forEach(h=>h.cancel()),this.h=new Set}search(h){const b=this.k.folderQueries||[];return new Promise(($,u)=>{const t=r=>{this.f++,h(r)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const c=r.toString(),w=g.$cc(c);this.j&&this.j(c,w)||this.v(t,{base:r,basename:w})}),Promise.all(b.map(r=>this.p(r,t))).then(r=>{$({limitHit:this.e,stats:r[0]||void 0})},r=>{u(new Error((0,S.$9h)(r)))})})}async p(h,b){const $=new C.$bd,u=this.q(h),t=this.r(),r=new k.$OH(this.k,h),c=!r.hasSiblingExcludeClauses();let w;try{this.h.add($),w=f.$1c.create();const v=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},u,$.token),y=w.elapsed(),i=f.$1c.create();return this.g&&!this.e||(v&&v.forEach(l=>{const n=g.$8b.relative(h.folder.path,l.path);if(c){const s=g.$cc(l.path);this.v(b,{base:h.folder,relativePath:n,basename:s});return}this.s(t,h.folder,n,b)}),this.g&&!this.e)?null:(this.u(t,r,b),{providerTime:y,postProcessTime:i.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(h){const b=(0,k.$NH)(this.k.includePattern,h.includePattern),$=(0,k.$NH)(this.k.excludePattern,h.excludePattern);return{folder:h.folder,excludes:$,includes:b,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}s({pathToEntries:h},b,$,u){if($===this.a){const r=g.$cc(this.a);this.v(u,{base:b,relativePath:this.a,basename:r})}function t(r){const c=g.$cc(r),w=g.$bc(r);let v=h[w];v||(v=h[w]=[],t(w)),v.push({base:b,relativePath:r,basename:c})}t($)}u({rootEntries:h,pathToEntries:b},$,u){const t=this,r=this.a;function c(w){const v=(0,k.$QH)(()=>w.map(y=>y.basename));for(let y=0,i=w.length;y<i;y++){const l=w[y],{relativePath:n,basename:s}=l;if($.matchesExcludesSync(n,s,r!==s?v:void 0))continue;const p=b[n];if(p)c(p);else{if(n===r)continue;t.v(u,l)}if(t.e)break}}c(h)}v(h,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||h(b))}}class F{constructor(){this.b=new Map}fileSearch(h,b,$,u){const t=this.c(h.cacheKey),r=new m(h,b,t&&t.token);let c=0;const w=v=>{c+=v.length,$(v.map(y=>this.d(y)))};return this.e(r,F.a,w,u).then(v=>({limitHit:v.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:v.stats}}))}clearCache(h){this.c(h)?.cancel()}c(h){if(h)return this.b.has(h)||this.b.set(h,new C.$bd),this.b.get(h)}d(h){return h.relativePath?{resource:T.$6f(h.base,h.relativePath)}:{resource:h.base}}e(h,b,$,u){u.onCancellationRequested(()=>{h.cancel()});const t=c=>{c&&(r.push(c),b>0&&r.length>=b&&($(r),r=[]))};let r=[];return h.search(t).then(c=>(r.length&&$(r),c),c=>(r.length&&$(r),Promise.reject(c)))}}e.$c_b=F,F.a=512}),define(Re[261],Fe([1,0,18,64,37,90,28,14,19,20,13,10,2,275,165,43,15,53,102,259,47]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t,r,c,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PI=e.$OI=void 0;let y=e.$OI=class{constructor(a,o,L,B,G){this.a=a,this.b=o,this.c=L,this.d=B,this.e=G}text(a,o,L={}){a=this.f(a,L);const B=this.a.getValue(),G=o&&o.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(o?.map(r.$Gh),L),type:2,contentPattern:a,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:B.search.usePCRE2||G||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(a,o){const L=this.a.getValue();a.isRegExp&&(a.pattern=a.pattern.replace(/\r?\n/g,"\\n"));const B={...a,wordSeparators:L.editor.wordSeparators};return this.j(a,o)&&(B.isCaseSensitive=!0),this.k(a)&&(B.isMultiline=!0),o.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=o.notebookSearchConfig.includeMarkupInput),o.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=o.notebookSearchConfig.includeMarkupPreview),o.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=o.notebookSearchConfig.includeCodeInput),o.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=o.notebookSearchConfig.includeOutput),B}file(a,o={}){return{...this.h(a,o),type:1,filePattern:o.filePattern?o.filePattern.trim():o.filePattern,exists:o.exists,sortByScore:o.sortByScore,cacheKey:o.cacheKey}}g(a,o){return a?(a=Array.isArray(a)?a.map(p):p(a),o?this.parseSearchPaths(a):{pattern:l(...Array.isArray(a)?a:[a])}):{}}h(a=[],o={}){const L=this.g(o.includePattern,o.expandPatterns),B=this.g(o.excludePattern,o.expandPatterns),G=a.length>1,q=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(H=>this.q(H,o,B)):a.map(H=>this.r(H,o,B,G))).filter(H=>!!H),W={_reason:o._reason,folderQueries:q,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:o.extraFileResources,excludePattern:B.pattern,includePattern:L.pattern,onlyOpenEditors:o.onlyOpenEditors,maxResults:o.maxResults};if(o.onlyOpenEditors){const H=g.$jf(g.$vf(this.c.groups.map(ue=>ue.editors.map(pe=>pe.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(H));const j=H.filter(ue=>(0,v.$EH)(W,ue.fsPath)),O=this.i(j);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(O)),{...W,...O}}const N=o.extraFileResources&&o.extraFileResources.filter(H=>(0,v.$EH)(W,H.fsPath));return W.extraFileResources=N&&N.length?N:void 0,W}i(a){const o=[],L=new T.$ji,B={};let G=!1;return a.forEach(q=>{if(q.scheme===f.Schemas.walkThrough)return;if((0,m.$0f)(q)){const N=this.b.getWorkspaceFolder(q)?.uri??q.with({path:k.$bc(q.fsPath)});let H=L.get(N);H||(G=!0,H={folder:N,includePattern:{}},o.push(H),L.set(N,H));const j=k.$ac(N.fsPath,q.fsPath);(0,D.$re)(H.includePattern)[j.replace(/\\/g,"/")]=!0}else q.fsPath&&(G=!0,B[q.fsPath]=!0)}),{folderQueries:o,includePattern:B,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(a,o){if(o.isSmartCase){if(a.isRegExp){if(F.$0d(a.pattern,!0))return!0}else if(F.$0d(a.pattern))return!0}return!!a.isCaseSensitive}k(a){return a.isMultiline||a.isRegExp&&(0,b.$FB)(a.pattern)||a.pattern.indexOf(`
`)>=0?!0:!!a.isMultiline}parseSearchPaths(a){const o=O=>k.$0b(O)||/^\.\.?([\/\\]|$)/.test(O),B=(Array.isArray(a)?a:n(a)).map(O=>{const ue=this.e.resolvedUserHome;return ue?(0,z.$Qz)(O,ue.scheme===f.Schemas.file?ue.fsPath:ue.path):O}),G=C.$I(B,O=>o(O)?"searchPaths":"exprSegments"),q=(G.exprSegments||[]).map(O=>F.$qd(O,"/")).map(O=>F.$qd(O,"\\")).map(O=>(O[0]==="."&&(O="*"+O),s(O))),W={},N=this.m(G.searchPaths||[]);N&&N.length&&(W.searchPaths=N);const H=g.$vf(q),j=l(...H);return j&&(W.pattern=j),W}l(a,o){return o.disregardExcludeSettings?void 0:(0,v.$DH)(a,!o.disregardSearchExcludeSettings)}m(a){if(!a||!a.length)return[];const o=a.flatMap(B=>{let{pathPortion:G,globPortion:q}=i(B);return q&&(q=I(q)),this.n(G).flatMap(N=>this.o(N,q))}),L=new Map;return o.forEach(B=>{const G=B.searchPath.toString(),q=L.get(G);q?B.pattern&&(q.pattern=q.pattern||{},q.pattern[B.pattern]=!0):L.set(G,{searchPath:B.searchPath,pattern:B.pattern?l(B.pattern):void 0})}),Array.from(L.values())}n(a){if(k.$0b(a)){const o=this.b.getWorkspace().folders;return o[0]&&o[0].uri.scheme!==f.Schemas.file?[{searchPath:o[0].uri.with({path:a})}]:[{searchPath:h.URI.file(k.$9b(a))}]}if(this.b.getWorkbenchState()===2){const o=this.b.getWorkspace().folders[0].uri;if(a=p(a),a.startsWith("../")||a===".."){const B=k.$8b.resolve(o.path,a);return[{searchPath:o.with({path:B})}]}const L=I(a);return[{searchPath:o,pattern:L}]}else{if(a==="./"||a===".\\")return[];{const o=a.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(G=>{const q=o.match(new RegExp(`^${F.$ld(G.name)}(?:/(.*)|$)`));return q?{match:q,folder:G}:null}).filter(D.$oe);if(B.length)return B.map(G=>{const q=G.match[1];return{searchPath:G.folder.uri,pattern:q&&I(q)}});{const G=a.match(/\.[\/\\](.+)[\/\\]?/),q=G?G[1]:a,W=$.localize(0,null,q);throw new Error(W)}}}}o(a,o){const L=a.pattern&&o?`${a.pattern}/${o}`:a.pattern||o,B=[{searchPath:a.searchPath,pattern:L}];return L&&!L.endsWith("**")&&B.push({searchPath:a.searchPath,pattern:L+"/**"}),B}q(a,o,L){const B=this.r((0,r.$Gh)(a.searchPath),o,L,!1);return B?{...B,includePattern:a.pattern}:null}r(a,o,L,B){let G;const q=h.URI.isUri(a)?a:a.uri;if(L.searchPaths){const O=L.searchPaths.filter(ue=>(0,m.$Yf)(ue.searchPath,q))[0];if(O&&!O.pattern)return null;O&&(G=O.pattern)}const W=this.a.getValue({resource:q}),H={...this.l(W,o)||{},...G||{}},j=h.URI.isUri(a)?(0,m.$3f)(a):a.name;return{folder:q,folderName:B?j:void 0,excludePattern:Object.keys(H).length>0?H:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof o.disregardIgnoreFiles=="boolean"?o.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof o.disregardGlobalIgnoreFiles=="boolean"?o.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof o.disregardParentIgnoreFiles=="boolean"?o.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof o.ignoreSymlinks=="boolean"?o.ignoreSymlinks:!W.search.followSymlinks}}};e.$OI=y=qe([Ve(0,u.$Rh),Ve(1,r.$uh),Ve(2,c.$qC),Ve(3,t.$Ni),Ve(4,w.$MI)],y);function i(E){const a=E.match(/[\*\{\}\(\)\[\]\?]/);if(a){const o=a.index,L=E.substr(0,o).match(/[/|\\][^/\\]*$/);if(L){let B=E.substr(0,L.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:E.substr((L.index||0)+1)}}}return{pathPortion:E}}function l(...E){return E.length?E.reduce((a,o)=>(a[o]=!0,a),Object.create(null)):void 0}function n(E){return S.$$i(E,",").map(a=>a.trim()).filter(a=>!!a.length)}function s(E){return[`**/${E}/**`,`**/${E}`].map(o=>o.replace(/\*\*\/\*\*/g,"**"))}function p(E){return E.replace(/\\/g,"/")}function I(E){return p(E).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(E){return E.replace(/([?*[\]])/g,"[$1]")}function A(E,a){E=g.$of(E,B=>B.toString());const o=[],L=a.getWorkspace();return E&&E.forEach(B=>{let G;if(a.getWorkbenchState()===2)G=(0,m.$8f)(L.folders[0].uri,B),G&&G!=="."&&(G="./"+G);else{const q=a.getWorkspaceFolder(B);if(q){const W=q.name;if(L.folders.filter(H=>H.name===W).length===1){const H=(0,m.$8f)(q.uri,B);H===""?G=`./${q.name}`:G=`./${q.name}/${H}`}else G=B.fsPath}}G&&o.push(d(G))}),o}e.$PI=A}),define(Re[262],Fe([1,0,20,2,22,9,3,261,47,53]),function(te,e,g,C,S,z,T,f,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sib=e.$rib=void 0;const F=7e3;function D(u,t){const r=t.activationEvents;if(!r)return Promise.resolve(void 0);const c=[],w=[];for(const s of r)if(/^workspaceContains:/.test(s)){const p=s.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||u.forceUsingSearch?w.push(p):c.push(p)}if(c.length===0&&w.length===0)return Promise.resolve(void 0);let v;const y=new Promise((s,p)=>{v=s}),i=s=>v({activationEvent:s}),l=Promise.all(c.map(s=>h(u,s,i))).then(()=>{}),n=b(u,t.identifier,w,i);return Promise.all([l,n]).then(()=>{v(void 0)}),y}e.$rib=D;async function h(u,t,r){for(const c of u.folders)if(await u.exists(g.$6f(C.URI.revive(c),t))){r(`workspaceContains:${t}`);return}}async function b(u,t,r,c){if(r.length===0)return Promise.resolve(void 0);const w=new S.$bd,v=u.checkExists(u.folders,r,w.token),y=setTimeout(async()=>{w.cancel(),u.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},F);let i=!1;try{i=await v}catch(l){z.$1(l)||z.$X(l)}w.dispose(),clearTimeout(y),i&&c(`workspaceContains:${r.join(",")}`)}function $(u,t,r,c){const w=u.get(T.$kh),v=u.get(k.$vH),i=w.createInstance(f.$OI).file(t.map(l=>(0,m.$Gh)(C.URI.revive(l))),{_reason:"checkExists",includePattern:r,exists:!0});return v.fileSearch(i,c).then(l=>!!l.limitHit,l=>z.$1(l)?!1:Promise.reject(l))}e.$sib=$});var Ye=this&&this.__classPrivateFieldSet||function(te,e,g,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,g):S?S.value=g:e.set(te,g),g},Te=this&&this.__classPrivateFieldGet||function(te,e,g,C){if(g==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?C:g==="a"?C.call(te):C?C.value:e.get(te)};define(Re[35],Fe([1,0,148,19,87,20,16,6,48,2,15,4,34,209,85,33,26,106,9,24,25,187,7,97,3,27,86,17,73,75,62,5,262,84,189,14,82,58,21,83]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t,r,c,w,v,y,i,l,n,s,p,I,d,A,E,a,o,L,B,G,q,W,N,H){"use strict";var j,O,ue;Object.defineProperty(e,"__esModule",{value:!0}),e.$B$b=e.$A$b=e.$z$b=e.$y$b=e.$x$b=void 0,e.$x$b=(0,n.$lh)("IHostUtils");let pe=e.$y$b=class Ln extends f.$kb{constructor(R,Q,he,De,ye,$e,Se,ae,le,ne,ee,P){super(),this.R=P,this.a=this.B(new a.$5c),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=Q,this.g=he,this.f=Se,this.j=De,this.k=ye,this.l=$e,this.m=le,this.p=ne,this.s=ee,this.t=this.g.getProxy(D.$$I.MainThreadWorkspace),this.u=this.g.getProxy(D.$$I.MainThreadTelemetry),this.v=this.g.getProxy(D.$$I.MainThreadExtensionService),this.w=new T.$qg,this.y=new T.$qg,this.z=new T.$qg,this.C=new T.$qg,this.D=new Ce(this.f.activationEvents),this.G=new r.$pZb(this.D,this.f.allExtensions);const K=new w.$El(this.f.myExtensions);this.F=new r.$pZb(this.D,ce(this.G,K)),this.H=new $.$e$b(this.g,this.l),this.I=new L.$q$b(this.g),this.J=ae,this.h=R.createChild(new d.$jh([$.$f$b,this.H],[L.$r$b,this.I])),this.L=this.B(new b.$d$b(this.F,this.G,{onExtensionActivationError:(V,J,re)=>{this.v.$onExtensionActivationError(V,c.$Z(J),re)},actualActivateExtension:async(V,J)=>{if(r.$pZb.isHostExtension(V,this.F,this.G))return await this.v.$activateExtension(V,J),new b.$c$b;const re=this.F.getExtensionDescription(V);return this.$(re,J)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),S.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(R){c.$X(R)}}async S(){this.J.onWillDeactivateAll();let R=[];try{R=this.F.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this.Z(ye))}catch{}await Promise.all(R)}terminate(R,Q=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${R}`),this.l.flush(),this.p.dispose(),this.L.dispose(),c.setUnexpectedErrorHandler(De=>{this.l.error(De)}),this.g.dispose();const he=this.S();Promise.race([(0,T.$sg)(5e3),he]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${Q}`):this.l.info(`Extension host exiting with code ${Q}`),this.l.flush(),this.l.dispose(),this.c.exit(Q)})}isActivated(R){return this.z.isOpen()?this.L.isActivated(R):!1}async getExtension(R){const Q=await this.v.$getExtension(R);return Q&&{...Q,identifier:new w.$Dl(Q.identifier.value),extensionLocation:m.URI.revive(Q.extensionLocation)}}U(R,Q){return this.L.activateByEvent(R,Q)}W(R,Q){return this.L.activateById(R,Q)}activateByIdWithErrors(R,Q){return this.W(R,Q).then(()=>{const he=this.L.getActivatedExtension(R);if(he.activationFailed)return Promise.reject(he.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(R=>this.F)}getExtensionExports(R){if(this.z.isOpen())return this.L.getActivatedExtension(R).exports;try{return this.L.getActivatedExtension(R).exports}catch{return null}}async X(R){if(R.scheme!==G.Schemas.file)return R;const Q=await this.c.realpath(R.fsPath);return m.URI.file(Q)}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(R=>new ke(R))),this.M}async Y(R){const Q=k.$rh.forUris(he=>z.$Wf.ignorePathCasing(he));return await Promise.all(R.map(async he=>{if(this.qb(he)){const De=await this.X(he.extensionLocation);Q.set(De,he)}})),Q}Z(R){let Q=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(R))return Q;const he=this.L.getActivatedExtension(R);if(!he)return Q;try{typeof he.module.deactivate=="function"&&(Q=Promise.resolve(he.module.deactivate()).then(void 0,De=>(this.l.error(De),Promise.resolve(void 0))))}catch(De){this.l.error(`An error occurred when deactivating the extension '${R.value}':`),this.l.error(De)}try{(0,f.$fb)(he.subscriptions)}catch(De){this.l.error(`An error occurred when deactivating the subscriptions for extension '${R.value}':`),this.l.error(De)}return Q}async $(R,Q){return this.f.remote.isRemote?this.v.$onWillActivateExtension(R.identifier):await this.v.$onWillActivateExtension(R.identifier),this.bb(R,Q).then(he=>{const De=he.activationTimes;return this.v.$onDidActivateExtension(R.identifier,De.codeLoadingTime,De.activateCallTime,De.activateResolvedTime,Q),this.ab(R,Q,"success",De),he},he=>{throw this.ab(R,Q,"failure"),he})}ab(R,Q,he,De){const ye=_(R,Q);this.u.$publicLog2("extensionActivationTimes",{...ye,...De||{},outcome:he})}bb(R,Q){const he=_(R,Q);this.u.$publicLog2("activatePlugin",he);const De=this.qb(R);if(!De)return Promise.resolve(new b.$b$b(b.$$0b.NONE));this.l.info(`ExtensionService#_doActivateExtension ${R.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${R.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this.l.flush();const ye=new b.$_0b(Q.startup);return Promise.all([this.rb(R,(0,z.$6f)(R.extensionLocation,De),ye),this.cb(R)]).then($e=>(S.mark(`code/extHost/willActivateExtension/${R.identifier.value}`),Ln.db(this.l,R.identifier,$e[0],$e[1],ye))).then($e=>(S.mark(`code/extHost/didActivateExtension/${R.identifier.value}`),$e))}cb(R){const Q=new y.$h$b(R,this.H),he=new y.$g$b(R.identifier.value,!1,this.H),De=new B.$s$b(R,this.I),ye=R.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,$e=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${R.identifier.value}`),Promise.all([Q.whenReady,he.whenReady,this.J.whenReady]).then(()=>{const Se=this;let ae,le;const ne=(0,t.$0E)(R,"ipc")?this.f.messagePorts?.get(w.$Dl.toKey(R.identifier)):void 0;return Object.freeze({globalState:Q,workspaceState:he,secrets:De,subscriptions:[],get extensionUri(){return R.extensionLocation},get extensionPath(){return R.extensionLocation.fsPath},asAbsolutePath(ee){return C.$$b(R.extensionLocation.fsPath,ee)},get storagePath(){return Se.J.workspaceValue(R)?.fsPath},get globalStoragePath(){return Se.J.globalValue(R).fsPath},get logPath(){return C.$$b(Se.f.logsLocation.fsPath,R.identifier.value)},get logUri(){return m.URI.joinPath(Se.f.logsLocation,R.identifier.value)},get storageUri(){return Se.J.workspaceValue(R)},get globalStorageUri(){return Se.J.globalValue(R)},get extensionMode(){return ye},get extension(){return ae===void 0&&(ae=new Y(Se,R.identifier,R,$e,!1)),ae},get extensionRuntime(){return(0,t.$$E)(R,"extensionRuntime"),Se.extensionRuntime},get environmentVariableCollection(){return Se.p.getEnvironmentVariableCollection(R)},get messagePassingProtocol(){if(!le){if(!ne)return;const ee=a.Event.buffer(a.Event.fromDOMEventEmitter(ne,"message",P=>P.data));ne.start(),le={onDidReceiveMessage:ee,postMessage:ne.postMessage.bind(ne)}}return le}})})}static db(R,Q,he,De,ye){return he=he||{activate:void 0,deactivate:void 0},this.eb(R,Q,he,De,ye).then($e=>new b.$a$b(!1,null,ye.build(),he,$e,De.subscriptions))}static eb(R,Q,he,De,ye){if(typeof he.activate=="function")try{ye.activateCallStart(),R.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const $e=typeof global=="object"?global:self,Se=he.activate.apply($e,[De]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(Se).then(ae=>(ye.activateResolveStop(),ae))}catch($e){return Promise.reject($e)}else return Promise.resolve(he)}fb(R,Q){this.W(R.identifier,{startup:!1,extensionId:R.identifier,activationEvent:Q}).then(void 0,he=>{this.l.error(he)})}gb(R,Q=0){const De=Date.now();(0,N.$A)(()=>{for(let ye=Q;ye<R.length;ye+=1){const $e=R[ye];for(const Se of $e.activationEvents??[])if(Se==="onStartupFinished")if(Date.now()-De>50){this.gb(R,ye);break}else this.fb($e,Se)}})}hb(){this.v.$setPerformanceMarks(S.getMarks()),this.k.getConfigProvider().then(R=>{const Q=R.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),he=this.F.getAllExtensionDescriptions();if(Q)this.gb(he);else for(const De of he)if(De.activationEvents)for(const ye of De.activationEvents)ye==="onStartupFinished"&&this.fb(De,ye)})}ib(){const R=this.U("*",!0).then(void 0,$e=>{this.l.error($e)});this.B(this.j.onDidChangeWorkspace($e=>this.jb($e.added)));const Q=this.j.workspace?this.j.workspace.folders:[],he=this.jb(Q),De=this.lb(),ye=Promise.all([De,R,he]).then(()=>{});return Promise.race([ye,(0,T.$sg)(1e4)]).then(()=>{this.hb()}),ye}jb(R){return R.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(Q=>this.kb(R,Q))).then(()=>{})}async kb(R,Q){if(this.isActivated(Q.identifier))return;const he=!this.f.remote.isRemote&&!!this.f.remote.authority,De={logService:this.l,folders:R.map($e=>$e.uri),forceUsingSearch:he,exists:$e=>this.c.exists($e.fsPath),checkExists:($e,Se,ae)=>this.t.$checkExists($e,Se,ae)},ye=await(0,o.$rib)(De,Q);if(ye)return this.W(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:ye.activationEvent}).then(void 0,$e=>this.l.error($e))}async lb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(R){throw console.error(R),R}}async mb(){const{extensionDevelopmentLocationURI:R,extensionTestsLocationURI:Q}=this.f.environment;if(!R||!Q)throw new Error(g.localize(0,null));const he=await this.rb(null,Q,new b.$_0b(!1));if(!he||typeof he.run!="function")throw new Error(g.localize(1,null,Q.toString()));return new Promise((De,ye)=>{const $e=(le,ne)=>{le?ye(le):De(typeof ne=="number"&&ne>0?1:0)},Se=(0,z.$Tf)(Q),ae=he.run(Se,$e);ae&&ae.then&&ae.then(()=>{De(0)}).catch(le=>{ye(le instanceof Error&&le.stack?le.stack:String(le))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,T.$sg)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(R,Q){return this.N[R]=Q,(0,f.$ib)(()=>{delete this.N[R]})}async getRemoteExecServer(R){const{resolver:Q}=await this.ob(R);return Q?.resolveExecServer?.(R,{resolveAttempt:0})}async ob(R){const Q=R.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const he=R.substr(0,Q);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${he}`,!1),{authorityPrefix:he,resolver:this.N[he]}}async $resolveAuthority(R,Q){const he=W.$1c.create(!1),De=()=>`[resolveAuthority(${(0,l.$wk)(R)},${Q})][${he.elapsed()}ms] `,ye=re=>this.l.info(`${De()}${re}`),$e=(re,de=void 0)=>this.l.error(`${De()}${re}`,de),Se=re=>{if(re instanceof i.$gJ)return{type:"error",error:{code:re._code,message:re._message,detail:re._detail}};throw re},ae=R.split(/@|%40/g).reverse();ye(`activating remote resolvers ${ae.join(" -> ")}`);let le;try{le=await Promise.all(ae.map(async re=>{ye("activating resolver...");const{resolver:de,authorityPrefix:ie}=await this.ob(re);if(!de)throw $e("no resolver"),new i.$gJ(`No remote extension installed to resolve ${ie}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:de,authorityPrefix:ie,remoteAuthority:re}}))}catch(re){return Se(re)}const ne=new T.$Bg;ne.cancelAndSet(()=>ye("waiting..."),1e3);let ee,P;for(const[re,{authorityPrefix:de,resolver:ie,remoteAuthority:ve}]of le.entries())try{if(re===le.length-1)ye("invoking final resolve()..."),S.mark(`code/extHost/willResolveAuthority/${de}`),ee=await ie.resolve(ve,{resolveAttempt:Q,execServer:P}),S.mark(`code/extHost/didResolveAuthorityOK/${de}`),ye("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(ie));else{if(ye(`invoking resolveExecServer() for ${ve}`),S.mark(`code/extHost/willResolveExecServer/${de}`),P=await ie.resolveExecServer?.(ve,{resolveAttempt:Q,execServer:P}),!P)throw new i.$gJ(`Exec server was not available for ${ve}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);S.mark(`code/extHost/didResolveExecServerOK/${de}`)}}catch(Ee){return S.mark(`code/extHost/didResolveAuthorityError/${de}`),$e("returned an error",Ee),ne.dispose(),Se(Ee)}ne.dispose();const K={environmentTunnels:ee.environmentTunnels,features:ee.tunnelFeatures},V={extensionHostEnv:ee.extensionHostEnv,isTrusted:ee.isTrusted,authenticationSession:ee.authenticationSessionForInitializingExtensions?{id:ee.authenticationSessionForInitializingExtensions.id,providerId:ee.authenticationSessionForInitializingExtensions.providerId}:void 0};ye(`returned ${i.$fJ.isManagedResolvedAuthority(ee)?"managed authority":`${ee.host}:${ee.port}`}`);let J;if(i.$fJ.isManagedResolvedAuthority(ee)){const re=Q;this.R.setFactory(re,ee.makeConnection),J={authority:R,connectTo:new l.$tk(re),connectionToken:ee.connectionToken}}else J={authority:R,connectTo:new l.$uk(ee.host,ee.port),connectionToken:ee.connectionToken};return{type:"ok",value:{authority:J,options:V,tunnelInformation:K}}}async $getCanonicalURI(R,Q){this.l.info(`$getCanonicalURI invoked for authority (${(0,l.$wk)(R)})`);const{resolver:he}=await this.ob(R);if(!he)return null;const De=m.URI.revive(Q);if(typeof he.getCanonicalURI>"u")return De;const ye=await(0,T.$kg)(()=>he.getCanonicalURI(De));return ye||De}$startExtensionHost(R){R.toAdd.forEach(De=>De.extensionLocation=m.URI.revive(De.extensionLocation));const{globalRegistry:Q,myExtensions:he}=Pe(this.D,this.G,this.F,R);return this.G.set(Q.getAllExtensionDescriptions()),this.F.set(he),this.nb()}$activateByEvent(R,Q){return Q===1?this.U(R,!1):this.z.wait().then(he=>this.U(R,!1))}async $activate(R,Q){return await this.z.wait(),this.F.getExtensionDescription(R)?(await this.W(R,Q),!0):!1}async $deltaExtensions(R){R.toAdd.forEach($e=>$e.extensionLocation=m.URI.revive($e.extensionLocation));const{globalRegistry:Q,myExtensions:he}=Pe(this.D,this.G,this.F,R),De=await this.Y(he);return(await this.getExtensionPathIndex()).setSearchTree(De),this.G.set(Q.getAllExtensionDescriptions()),this.F.set(he),Promise.resolve(void 0)}async $test_latency(R){return R}async $test_up(R){return R.byteLength}async $test_down(R){const Q=v.$Ib.alloc(R),he=Math.random()%256;for(let De=0;De<R;De++)Q.writeUInt8(he,De);return Q}async $updateRemoteConnectionData(R){this.Q=R,this.a.fire()}};e.$y$b=pe=qe([Ve(0,n.$kh),Ve(1,e.$x$b),Ve(2,I.$aL),Ve(3,u.$40b),Ve(4,h.$70b),Ve(5,F.$Ni),Ve(6,s.$qL),Ve(7,p.$k$b),Ve(8,A.$job),Ve(9,E.$m$b),Ve(10,q.$u$b),Ve(11,H.$v$b)],pe);function Pe(me,R,Q,he){me.addActivationEvents(he.addActivationEvents);const De=new r.$pZb(me,R.getAllExtensionDescriptions());De.deltaExtensions(he.toAdd,he.toRemove);const ye=new w.$El(Q.getAllExtensionDescriptions().map(Se=>Se.identifier));for(const Se of he.myToRemove)ye.delete(Se);for(const Se of he.myToAdd)ye.add(Se);const $e=ce(De,ye);return{globalRegistry:De,myExtensions:$e}}function _(me,R){return{id:me.identifier.value,name:me.name,extensionVersion:me.version,publisherDisplayName:me.publisher,activationEvents:me.activationEvents?me.activationEvents.join(","):null,isBuiltin:me.isBuiltin,reason:R.activationEvent,reasonId:R.extensionId.value}}e.$z$b=(0,n.$lh)("IExtHostExtensionService");class Y{constructor(R,Q,he,De,ye){j.set(this,void 0),O.set(this,void 0),ue.set(this,void 0),Ye(this,j,R,"f"),Ye(this,O,Q,"f"),Ye(this,ue,he.identifier,"f"),this.id=he.identifier.value,this.extensionUri=he.extensionLocation,this.extensionPath=C.$9b((0,z.$Tf)(he.extensionLocation)),this.packageJSON=he,this.extensionKind=De,this.isFromDifferentExtensionHost=ye}get isActive(){return Te(this,j,"f").isActivated(Te(this,ue,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Te(this,j,"f").getExtensionExports(Te(this,ue,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Te(this,j,"f").activateByIdWithErrors(Te(this,ue,"f"),{startup:!1,extensionId:Te(this,O,"f"),activationEvent:"api"}),this.exports}}e.$A$b=Y,j=new WeakMap,O=new WeakMap,ue=new WeakMap;function ce(me,R){return me.getAllExtensionDescriptions().filter(Q=>R.has(Q.identifier))}class ke{constructor(R){this.a=R}setSearchTree(R){this.a=R}findSubstr(R){return this.a.findSubstr(R)}forEach(R){return this.a.forEach(R)}}e.$B$b=ke;class Ce{constructor(R){this.a=new w.$Fl,this.addActivationEvents(R)}readActivationEvents(R){return this.a.get(R.identifier)}addActivationEvents(R){for(const Q of Object.keys(R))this.a.set(Q,R[Q])}}}),define(Re[263],Fe([1,0,87,2,4,34,26,24,17,27,3,35,51,15,13]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T_b=void 0;let u=e.$T_b=class{constructor(y,i,l,n,s,p,I){this.c=y,this.d=i,this.e=l,this.f=n,this.g=s,this.h=p,this.i=I,this.a=new Map,this.b=[]}async install(){this.j(),g.mark("code/extHost/willWaitForConfig");const y=await this.f.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new r(this.c,i,this.d,y,this.i)),this.register(this.e.createInstance(c,i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(w,i,this.h.environment.appUriScheme))}register(y){if("nodeModuleName"in y)if(Array.isArray(y.nodeModuleName))for(const i of y.nodeModuleName)this.a.set(i,y);else this.a.set(y.nodeModuleName,y);typeof y.alternativeModuleName=="function"&&this.b.push(i=>y.alternativeModuleName(i))}};e.$T_b=u=qe([Ve(2,F.$kh),Ve(3,z.$70b),Ve(4,D.$z$b),Ve(5,m.$qL),Ve(6,b.$Ni)],u);let t=class fn{constructor(y){if(y.environment.appRoot&&fn.a.size){const i=(0,$.$ld)(this.c(y.environment.appRoot.fsPath)),l="[a-z0-9_.-]",n=`@${l}+\\/${l}+|${l}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${s}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(y){if(!this.b)return;const i=this.b.exec(this.c(y));if(!i)return;const[,l,n,s]=i,p=fn.a.get(n);if(p!==void 0)return console.warn(`${n} as been renamed to ${p}, please update your imports`),l+p+s}c(y){return y.replace(/\\/g,"/")}};t.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=qe([Ve(0,m.$qL)],t);class r{constructor(y,i,l,n,s){this.c=y,this.d=i,this.e=l,this.f=n,this.g=s,this.nodeModuleName="vscode",this.a=new f.$Fl}load(y,i){const l=this.d.findSubstr(i);if(l){let n=this.a.get(l.identifier);return n||(n=this.c(l,this.e,this.f),this.a.set(l.identifier,n)),n}if(!this.b){let n="";this.d.forEach((s,p)=>n+=`	${p} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${n}`),this.b=this.c(T.$5E,this.e,this.f)}return this.b}}let c=class{constructor(y,i,l){this.d=y,this.nodeModuleName="keytar",this.a=i.getProxy(S.$$I.MainThreadTelemetry);const{environment:n}=l,s=i.getProxy(S.$$I.MainThreadKeytar);if(n.appRoot){let p=n.appRoot.fsPath;h.$5b==="win32"&&(p=p.replace(/\\/g,"/")),p[p.length-1]==="/"&&(p=p.substr(0,p.length-1)),this.b=new Set,this.b.add(`${p}/node_modules.asar/keytar`),this.b.add(`${p}/node_modules/keytar`)}this.c={getPassword:(p,I)=>s.$getPassword(p,I),setPassword:(p,I,d)=>s.$setPassword(p,I,d),deletePassword:(p,I)=>s.$deletePassword(p,I),findPassword:p=>s.$findPassword(p),findCredentials(p){return s.$findCredentials(p)}}}load(y,i){const l=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:l?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(y){const i=y.length;if(i<=7||!this.b)return;const l=i-7;if((y.charAt(l)==="/"||y.charAt(l)==="\\")&&y.endsWith("keytar")&&(y=y.replace(/\\/g,"/"),this.b.has(y)))return"keytar"}};c=qe([Ve(1,k.$aL),Ve(2,m.$qL)],c);let w=class{constructor(y,i,l){this.e=y,this.f=i,this.nodeModuleName=["open","opn"],this.d=l.getProxy(S.$$I.MainThreadTelemetry);const n=l.getProxy(S.$$I.MainThreadWindow);this.c=(s,p)=>{const I=C.URI.parse(s);return p?this.g(s,p):I.scheme==="http"||I.scheme==="https"?n.$openUri(I,s,{allowTunneling:!0}):I.scheme==="mailto"||I.scheme===this.f?n.$openUri(I,s,{}):this.g(s,p)}}load(y,i,l){const n=this.e.findSubstr(i);return n&&(this.a=n.identifier.value,this.h()),this.b=l(y),this.c}g(y,i){return this.i(),this.b(y,i)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};w=qe([Ve(2,k.$aL)],w)}),define(Re[112],Fe([1,0,66,6,19,51,3,59,60,35,7,33,199,34]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9$b=e.$8$b=void 0,e.$8$b=(0,T.$lh)("IExtHostVariableResolverProvider");class $ extends h.$cM{constructor(r,c,w,v,y,i,l){function n(){if(w){const s=w.activeEditor();if(s)return s.document.uri;const p=v.tabGroups.all.find(I=>I.isActive)?.activeTab;if(p!==void 0){if(p.input instanceof F.$UK||p.input instanceof F.$ZK)return p.input.modified;if(p.input instanceof F.$TK||p.input instanceof F.$YK||p.input instanceof F.$WK)return p.input.uri}}}super({getFolderUri:s=>{const p=i.folders.filter(I=>I.name===s);if(p&&p.length>0)return p[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(s,p)=>y.getConfiguration(void 0,s).get(p),getAppRoot:()=>z.cwd(),getExecPath:()=>z.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=n();if(s)return S.$9b(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const s=n();if(s){const p=c.getWorkspaceFolder(s);if(p)return S.$9b(p.uri.fsPath)}}},getSelectedText:()=>{if(w){const s=w.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(w){const s=w.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>r.getExtension(s)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(z.env))}}let u=e.$9$b=class extends C.$kb{constructor(r,c,w,v,y){super(),this.b=r,this.c=c,this.g=w,this.h=v,this.i=y,this.a=new g.$S(async()=>{const i=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async s=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.i,i,n,this.j())})}getResolver(){return this.a.value}j(){}};e.$9$b=u=qe([Ve(0,m.$z$b),Ve(1,D.$40b),Ve(2,f.$lL),Ve(3,b.$70b),Ve(4,k.$6$b)],u)}),define(Re[113],Fe([1,0,16,5,10,2,3,4,60,35,17,7,33,192,194,34,112]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b_b=e.$a_b=e.$_$b=e.$$$b=e.$0$b=void 0,e.$0$b=(0,T.$lh)("IExtHostDebugService");let r=e.$$$b=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,s,p,I,d,A){this.F=s,this.G=p,this.H=I,this.I=d,this.J=A,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new C.$5c,this.n=new C.$5c,this.o=new C.$5c,this.u=new C.$5c,this.k=n.getProxy(f.$$I.MainThreadDebugService),this.z=new C.$5c({onWillAddFirstListener:()=>{this.V()}}),this.B=new C.$5c,this.v=new w(this.k),this.w=new Map,this.y=!1,this.G.getExtensionRegistry().then(E=>{E.onDidChange(a=>{this.K(E)}),this.K(E)})}asDebugSourceUri(n,s){const p=n;if(typeof p.sourceReference=="number"&&p.sourceReference>0){let I=`debug:${encodeURIComponent(p.path||"")}`,d="?";return s&&(I+=`${d}session=${encodeURIComponent(s.id)}`,d="&"),I+=`${d}ref=${p.sourceReference}`,z.URI.parse(I)}else{if(p.path)return z.URI.file(p.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}K(n){const s=[];for(const p of n.getAllExtensionDescriptions())if(p.contributes){const I=p.contributes.debuggers;if(I&&I.length>0)for(const d of I)(0,$.$HE)(d)&&s.push(d.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.V();const n=[];return this.w.forEach(s=>n.push(s)),n}addBreakpoints(n){this.V();const s=n.filter(d=>{const A=d.id;return this.w.has(A)?!1:(this.w.set(A,d),!0)});this.W(s,[],[]);const p=[],I=new Map;for(const d of s)if(d instanceof D.$aK){let A=I.get(d.location.uri.toString());A||(A={type:"sourceMulti",uri:d.location.uri,lines:[]},I.set(d.location.uri.toString(),A),p.push(A)),A.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof D.$bK&&p.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(p)}removeBreakpoints(n){this.V();const s=n.filter(A=>this.w.delete(A.id));this.W([],s,[]);const p=s.filter(A=>A instanceof D.$aK).map(A=>A.id),I=s.filter(A=>A instanceof D.$bK).map(A=>A.id),d=s.filter(A=>A instanceof D.$cK).map(A=>A.id);return this.k.$unregisterBreakpoints(p,I,d)}startDebugging(n,s,p){return this.k.$startDebugging(n?n.uri:void 0,s,{parentSessionID:p.parentSession?p.parentSession.id:void 0,lifecycleManagedByParent:p.lifecycleManagedByParent,repl:p.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:p.noDebug,compact:p.compact,suppressSaveBeforeStart:p.suppressSaveBeforeStart,suppressDebugStatusbar:p.suppressDebugStatusbar??p.debugUI?.simple,suppressDebugToolbar:p.suppressDebugToolbar??p.debugUI?.simple,suppressDebugView:p.suppressDebugView??p.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,s,p){if(!s)return new D.$aJ(()=>{});const I=this.d++;return this.f.push({type:n,handle:I,provider:s}),this.k.$registerDebugConfigurationProvider(n,p,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,I),new D.$aJ(()=>{this.f=this.f.filter(d=>d.provider!==s),this.k.$unregisterDebugConfigurationProvider(I)})}registerDebugAdapterDescriptorFactory(n,s,p){if(!p)return new D.$aJ(()=>{});if(!this.R(n,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.O(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const I=this.g++;return this.h.push({type:s,handle:I,factory:p}),this.k.$registerDebugAdapterDescriptorFactory(s,I),new D.$aJ(()=>{this.h=this.h.filter(d=>d.factory!==p),this.k.$unregisterDebugAdapterDescriptorFactory(I)})}registerDebugAdapterTrackerFactory(n,s){if(!s)return new D.$aJ(()=>{});const p=this.i++;return this.j.push({type:n,handle:p,factory:s}),new D.$aJ(()=>{this.j=this.j.filter(I=>I.factory!==s)})}async $runInTerminal(n,s){return Promise.resolve(void 0)}async $substituteVariables(n,s){let p;const I=await this.Y(n);return I&&(p={uri:I.uri,name:I.name,index:I.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.J.getResolver()).resolveAnyAsync(p,s)}L(n,s){if(n.type==="implementation")return new y(n.implementation)}M(){}async $startDASession(n,s){const p=this,I=await this.X(s);return this.T(this.O(I.type),I).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}' (extension might have failed to activate)`);const A=this.N(d),E=this.L(A,I);if(!E)throw new Error(`Couldn't create a debug adapter for type '${I.type}'.`);const a=E;return this.C.set(n,a),this.S(I).then(o=>(o&&this.D.set(n,o),a.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const B=L,G={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this.E||(this.E=this.M());try{if(this.E){const q=await this.E.sign(B.arguments.value);G.body={signature:q},a.sendResponse(G)}else throw new Error("no signer")}catch(q){G.success=!1,G.message=q.message,a.sendResponse(G)}}else o&&o.onDidSendMessage&&o.onDidSendMessage(L),L=(0,$.$ME)(L,!0),p.k.$acceptDAMessage(n,L)}),a.onError(L=>{o&&o.onError&&o.onError(L),this.k.$acceptDAError(n,L.name,L.message,L.stack)}),a.onExit(L=>{o&&o.onExit&&o.onExit((0,S.$ye)(L),void 0),this.k.$acceptDAExit(n,(0,S.$ye)(L),void 0)}),o&&o.onWillStartSession&&o.onWillStartSession(),a.startSession()))})}$sendDAMessage(n,s){s=(0,$.$LE)(s,!1);const p=this.D.get(n);p&&p.onWillReceiveMessage&&p.onWillReceiveMessage(s),this.C.get(n)?.sendMessage(s)}$stopDASession(n){const s=this.D.get(n);this.D.delete(n),s&&s.onWillStopSession&&s.onWillStopSession();const p=this.C.get(n);return this.C.delete(n),p?p.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const s=[],p=[],I=[];if(n.added)for(const d of n.added){const A=d.id;if(A&&!this.w.has(A)){let E;if(d.type==="function")E=new D.$bK(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")E=new D.$cK(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const a=z.URI.revive(d.uri);E=new D.$aK(new D.$mJ(a,new D.$bJ(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,D.$$J)(E,A),this.w.set(A,E),s.push(E)}}if(n.removed)for(const d of n.removed){const A=this.w.get(d);A&&(this.w.delete(d),p.push(A))}if(n.changed){for(const d of n.changed)if(d.id){const A=this.w.get(d.id);if(A){if(A instanceof D.$bK&&d.type==="function"){const E=A;E.enabled=d.enabled,E.condition=d.condition,E.hitCondition=d.hitCondition,E.logMessage=d.logMessage,E.functionName=d.functionName}else if(A instanceof D.$aK&&d.type==="source"){const E=A;E.enabled=d.enabled,E.condition=d.condition,E.hitCondition=d.hitCondition,E.logMessage=d.logMessage,E.location=new D.$mJ(z.URI.revive(d.uri),new D.$bJ(d.line,d.character))}I.push(A)}}}this.W(s,p,I)}async $acceptStackFrameFocus(n){let s;const p=n.sessionId?await this.X(n.sessionId):void 0;if(!p)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?s=new D.$iK(p,n.threadId):s=new D.$hK(p,n.threadId,n.frameId),this.A=s,this.B.fire(this.A)}$provideDebugConfigurations(n,s,p){return(0,g.$kg)(async()=>{const I=this.Q(n);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.Y(s);return I.provideDebugConfigurations(d,p)}).then(I=>{if(!I)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return I})}$resolveDebugConfiguration(n,s,p,I){return(0,g.$kg)(async()=>{const d=this.Q(n);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.Y(s);return d.resolveDebugConfiguration(A,p,I)})}$resolveDebugConfigurationWithSubstitutedVariables(n,s,p,I){return(0,g.$kg)(async()=>{const d=this.Q(n);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.Y(s);return d.resolveDebugConfigurationWithSubstitutedVariables(A,p,I)})}async $provideDebugAdapter(n,s){const p=this.P(n);if(!p)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const I=await this.X(s);return this.T(p,I).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}'`);return this.N(d)})}async $acceptDebugSessionStarted(n){const s=await this.X(n);this.m.fire(s)}async $acceptDebugSessionTerminated(n){const s=await this.X(n);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.X(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,s){(await this.X(n))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(n,s){const I={session:await this.X(n),event:s.event,body:s.body};this.u.fire(I)}N(n){if(n instanceof D.$dK)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof D.$eK)return{type:"server",port:n.port,host:n.host};if(n instanceof D.$fK)return{type:"pipeServer",path:n.path};if(n instanceof D.$gK)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}O(n){const s=this.h.filter(p=>p.type===n);if(s.length>0)return s[0].factory}P(n){const s=this.h.filter(p=>p.handle===n);if(s.length>0)return s[0].factory}Q(n){const s=this.f.filter(p=>p.handle===n);if(s.length>0)return s[0].provider}R(n,s){if(n.contributes){const p=n.contributes.debuggers;if(p&&p.length>0){for(const I of p)if(I.label&&I.type&&I.type===s)return!0}}return!1}S(n){const p=n.configuration.type,I=this.j.filter(d=>d.type===p||d.type==="*").map(d=>(0,g.$kg)(()=>d.factory.createDebugAdapterTracker(n)).then(A=>A,A=>null));return Promise.race([Promise.all(I).then(d=>{const A=d.filter(E=>!!E);if(A.length>0)return new v(A)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async T(n,s){const p=s.configuration.debugServer;if(typeof p=="number")return Promise.resolve(new D.$eK(p));if(n){const d=await this.G.getExtensionRegistry();return(0,g.$kg)(()=>n.createDebugAdapterDescriptor(s,this.U(s,d))).then(A=>{if(A)return A})}const I=await this.G.getExtensionRegistry();return Promise.resolve(this.U(s,I))}U(n,s){}V(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}W(n,s,p){(n.length>0||s.length>0||p.length>0)&&this.z.fire(Object.freeze({added:n,removed:s,changed:p}))}async X(n){if(n)if(typeof n=="string"){const s=this.l.get(n);if(s)return s}else{let s=this.l.get(n.id);if(!s){const p=await this.Y(n.folderUri),I=n.parent?this.l.get(n.parent):void 0;s=new c(this.k,n.id,n.type,n.name,p,n.configuration,I),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}Y(n){if(n){const s=z.URI.revive(n);return this.F.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$$$b=r=qe([Ve(0,F.$aL),Ve(1,h.$40b),Ve(2,m.$z$b),Ve(3,u.$70b),Ve(4,k.$6$b),Ve(5,t.$8$b)],r);class c{constructor(n,s,p,I,d,A,E){this.d=n,this.f=s,this.g=p,this.h=I,this.i=d,this.j=A,this.k=E}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,s){return this.d.$customDebugAdapterRequest(this.f,n,s)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$_$b=c;class w{constructor(n){this.value=Object.freeze({append(s){n.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$a_b=w;class v{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(s=>s.onError?s.onError(n):void 0)}onExit(n,s){this.d.forEach(p=>p.onExit?p.onExit(n,s):void 0)}}class y extends b.$$9{constructor(n){super(),this.h=n,n.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=e.$b_b=class extends r{constructor(n,s,p,I,d,A){super(n,s,p,I,d,A)}};e.$b_b=i=qe([Ve(0,F.$aL),Ve(1,h.$40b),Ve(2,m.$z$b),Ve(3,u.$70b),Ve(4,k.$6$b),Ve(5,t.$8$b)],i)}),define(Re[264],Fe([1,0,9,87,2,4,255,15,72,73,27,170,17,55,35,57]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=e.$U_b=void 0;class t{static async installEarlyHandler(w){const v=w.get(f.$Ni),i=w.get(h.$aL).getProxy(z.$$I.MainThreadErrors);g.setUnexpectedErrorHandler(l=>{v.error(l);const n=g.$Z(l);i.$onUnexpectedError(n)})}static async installFullHandler(w){const v=w.get(f.$Ni),y=w.get(h.$aL),i=w.get($.$z$b),l=w.get(u.$uL),n=y.getProxy(z.$$I.MainThreadExtensionService),s=y.getProxy(z.$$I.MainThreadErrors),p=await i.getExtensionPathIndex(),I=new WeakMap;function d(a,o){if(I.has(a))return I.get(a).stack;let L="",B,G;for(const W of o)L+=`
	at ${W.toString()}`,G=W.getFileName(),!B&&G&&(B=p.findSubstr(S.URI.file(G)));const q=`${a.name||"Error"}: ${a.message||""}${L}`;return I.set(a,{extensionIdentifier:B?.identifier,stack:q}),q}const A=Symbol("prepareStackTrace wrapped");let E=d;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return E},set(a){if(a===d||a[A]){E=a;return}E=function(o,L){return d(o,L),a.call(Error,o,L)},Object.assign(E,{[A]:!0})}}),g.setUnexpectedErrorHandler(a=>{v.error(a);const o=g.$Z(a),L=I.get(a);if(!L?.extensionIdentifier){s.$onUnexpectedError(o);return}n.$onExtensionRuntimeError(L.extensionIdentifier,o);const B=l.onExtensionError(L.extensionIdentifier,a);v.trace("forwarded error to extension?",B,L)})}}e.$U_b=t,Error.stackTraceLimit=100;class r{constructor(w,v,y,i,l){this.a=y,this.b=new T.$xZb(w,null,i),v=r.e(v,this.b);const n=new m.$jh(...(0,k.$9q)());n.set(F.$qL,{_serviceBrand:void 0,...v,messagePorts:l}),n.set(h.$aL,new h.$bL(this.b)),n.set(b.$10b,new b.$20b(i)),n.set($.$x$b,y);const s=new D.$Qp(n,!0);s.invokeFunction(t.installEarlyHandler),this.d=s.invokeFunction(p=>p.get(f.$Ni)),C.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",v),this.c=s.invokeFunction(p=>p.get($.$z$b)),this.c.initialize(),s.invokeFunction(t.installFullHandler)}async asBrowserUri(w){const v=this.b.getProxy(z.$$I.MainThreadExtensionService);return S.URI.revive(await v.$asBrowserUri(w))}terminate(w){this.c.terminate(w)}static e(w,v){w.allExtensions.forEach(i=>{i.extensionLocation=S.URI.revive(v.transformIncomingURIs(i.extensionLocation))}),w.environment.appRoot=S.URI.revive(v.transformIncomingURIs(w.environment.appRoot));const y=w.environment.extensionDevelopmentLocationURI;return y&&(w.environment.extensionDevelopmentLocationURI=y.map(i=>S.URI.revive(v.transformIncomingURIs(i)))),w.environment.extensionTestsLocationURI=S.URI.revive(v.transformIncomingURIs(w.environment.extensionTestsLocationURI)),w.environment.globalStorageHome=S.URI.revive(v.transformIncomingURIs(w.environment.globalStorageHome)),w.environment.workspaceStorageHome=S.URI.revive(v.transformIncomingURIs(w.environment.workspaceStorageHome)),w.environment.extensionTelemetryLogResource=S.URI.revive(v.transformIncomingURIs(w.environment.extensionTelemetryLogResource)),w.nlsBaseUrl=S.URI.revive(v.transformIncomingURIs(w.nlsBaseUrl)),w.logsLocation=S.URI.revive(v.transformIncomingURIs(w.logsLocation)),w.workspace=v.transformIncomingURIs(w.workspace),w}}e.$V_b=r}),define(Re[265],Fe([1,0,18,16,22,41,14,19,20,2,47]),function(te,e,g,C,S,z,T,f,k,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g_b=e.$f_b=e.$e_b=e.$d_b=void 0;class D{constructor(c,w,v,y){this.d=c,this.e=w,this.f=v,this.g=y,this.a=null,this.b=!1,this.c=0}search(c,w){const v=this.d.folderQueries||[],y=new S.$bd;return w.onCancellationRequested(()=>y.cancel()),new Promise((i,l)=>{this.a=new b(c);let n=!1;const s=(p,I)=>{if(!n&&!this.b){const d=this.h(p);u(p)&&typeof this.d.maxResults=="number"&&this.c+d>this.d.maxResults&&(this.b=!0,n=!0,y.cancel(),p=this.j(p,this.d.maxResults-this.c));const A=this.h(p);this.c+=A,(A>0||!u(p))&&this.a.add(p,I)}};Promise.all(v.map((p,I)=>this.k(p,d=>s(d,I),y.token))).then(p=>{y.dispose(),this.a.flush();const I=p.some(d=>!!d&&!!d.limitHit);i({limitHit:this.b||I,messages:(0,g.$vf)(p.map(d=>d?.message?Array.isArray(d.message)?d.message:[d.message]:[])),stats:{type:this.g}})},p=>{y.dispose();const I=(0,z.$9h)(p);l(new Error(I))})})}h(c){return u(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,w){const v=Array.isArray(c.ranges)?c.ranges:[c.ranges],y=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:v.slice(0,w),preview:{matches:y.slice(0,w),text:c.preview.text},uri:c.uri}}async k(c,w,v){const y=new F.$OH(this.d,c),i=[],l={report:p=>{if(!this.l(p))return;const I=c.folder.scheme===T.Schemas.file?(0,F.$PH)(()=>this.f.readdir(k.$5f(p.uri))):void 0,d=k.$8f(c.folder,p.uri);if(d){const A=y.includedInQuery(d,f.$cc(d),I);(0,C.$eg)(A)?i.push(A.then(E=>{E&&w(p)})):A&&w(p)}}},n=this.n(c),s=await this.e.provideTextSearchResults(h(this.d.contentPattern),n,l,v);return i.length&&await Promise.all(i),s}l(c){if(u(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const w=(0,F.$NH)(this.d.includePattern,c.includePattern),v=(0,F.$NH)(this.d.excludePattern,c.excludePattern),y={folder:m.URI.from(c.folder),excludes:v,includes:w,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return y.usePCRE2=this.d.usePCRE2,y}}e.$d_b=D;function h(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class b{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,w=>this.g(w))}add(c,w){this.d&&(this.b!==w||!k.$Yf(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=w,this.d={resource:c.uri,results:[]}),this.d.results.push($(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$e_b=b;function $(r){return u(r)?{preview:{matches:(0,g.$Ff)(r.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:r.preview.text},ranges:(0,g.$Ff)(r.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function u(r){return!!r.preview}e.$f_b=u;class t{constructor(c,w){this.g=c,this.h=w,this.c=0,this.d=[],this.e=0}addItem(c,w){c&&this.j(c,w)}addItems(c,w){c&&this.k(c,w)}j(c,w){this.d.push(c),this.e+=w,this.l()}k(c,w){this.d=this.d.concat(c),this.e+=w,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$g_b=t,t.a=4e3,t.b=50}),define(Re[114],Fe([1,0,6,4,3,260,17,55,15,2,265]),function(te,e,g,C,S,z,T,f,k,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=e.$i_b=e.$h_b=void 0,e.$h_b=(0,S.$lh)("IExtHostSearch");let D=e.$i_b=class{constructor(u,t,r){this.k=u,this.l=t,this.n=r,this.c=this.k.getProxy(C.$$I.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new z.$c_b}o(u){return this.l.transformOutgoingScheme(u)}registerTextSearchProvider(u,t){if(this.g.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this.g.add(u);const r=this.d++;return this.e.set(r,t),this.c.$registerTextSearchProvider(r,this.o(u)),(0,g.$ib)(()=>{this.g.delete(u),this.e.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(u,t){if(this.i.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this.i.add(u);const r=this.d++;return this.h.set(r,t),this.c.$registerFileSearchProvider(r,this.o(u)),(0,g.$ib)(()=>{this.i.delete(u),this.h.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(u,t,r,c){const w=h(r),v=this.h.get(u);if(v)return this.j.fileSearch(w,v,y=>{this.c.$handleFileMatch(u,t,y.map(i=>i.resource))},c);throw new Error("unknown provider: "+u)}$clearCache(u){return this.j.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,t,r,c){const w=this.e.get(u);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const v=h(r);return this.q(v,w).search(i=>this.c.$handleTextMatch(u,t,i),c)}$enableExtensionHostSearch(){}q(u,t){return new F.$d_b(u,t,{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}};e.$i_b=D=qe([Ve(0,T.$aL),Ve(1,f.$10b),Ve(2,k.$Ni)],D);function h($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(b),extraFileResources:$.extraFileResources&&$.extraFileResources.map(u=>m.URI.revive(u))}}e.$j_b=h;function b($){return{...$,folder:m.URI.revive($.folder)}}}),define(Re[266],Fe([1,0,22,9,5,29,2,135,276,124,133,38,4,80,219,218,32,220,34,222,223,224,202,225,59,35,226,227,232,233,235,109,206,241,242,245,85,62,247,207,8,7,52,250,63,108,33,24,197,231,50,107,111,113,114,15,55,17,27,236,195,75,81,215,248,86,61,253,251,252,216,39,246,249,84,60,57,237,110,238,14,95,205,188,229,6,26,193,82,184,239,240,217,228,204,243,230,83,244]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t,r,c,w,v,y,i,l,n,s,p,I,d,A,E,a,o,L,B,G,q,W,N,H,j,O,ue,pe,Pe,_,Y,ce,ke,Ce,me,R,Q,he,De,ye,$e,Se,ae,le,ne,ee,P,K,V,J,re,de,ie,ve,Ee,Be,We,_e,He,Qe,it,ct,et,rt,Oe,st,x,X,ge,je,Ne,Ze,tt,$t,wt,Lt,Gt,Wt,yt,Ut,Mt,Nt,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P_b=void 0;function Vt(at){const ft=at.get(ae.$qL),jt=at.get(Be.$Q0b),Rt=at.get(re.$j$b),St=at.get(s.$z$b),ut=at.get(Y.$40b),Ct=at.get(it.$uL),Tt=at.get(c.$70b),Ae=at.get($e.$10b),we=at.get(Se.$aL),be=at.get(q.$f$b),Z=at.get(J.$k$b),Le=at.get(ye.$Oi),Ue=at.get(ye.$Ni),Ge=at.get(ee.$job),Ke=at.get(P.$T0b),xe=at.get(_.$X$b),Et=at.get(He.$r$b),It=at.get(Qe.$6$b),Pt=at.get(Nt.$v$b);we.set(h.$_I.ExtHostFileSystemInfo,jt),we.set(h.$_I.ExtHostLogLevelServiceShape,Le),we.set(h.$_I.ExtHostWorkspace,ut),we.set(h.$_I.ExtHostConfiguration,Tt),we.set(h.$_I.ExtHostExtensionService,St),we.set(h.$_I.ExtHostStorage,be),we.set(h.$_I.ExtHostTunnelService,Ge),we.set(h.$_I.ExtHostWindow,xe),we.set(h.$_I.ExtHostSecretState,Et),we.set(h.$_I.ExtHostTelemetry,Ct),we.set(h.$_I.ExtHostEditorTabs,It),we.set(h.$_I.ExtHostManagedSockets,Pt);const mt=we.set(h.$_I.ExtHostDecorations,at.get(R.$2$b)),pt=we.set(h.$_I.ExtHostDocumentsAndEditors,at.get(n.$lL)),dt=we.set(h.$_I.ExtHostCommands,at.get(t.$wL)),vt=we.set(h.$_I.ExtHostTerminalService,at.get(W.$m$b)),bt=we.set(h.$_I.ExtHostDebugService,at.get(he.$0$b)),Zt=we.set(h.$_I.ExtHostSearch,at.get(De.$h_b)),Bt=we.set(h.$_I.ExtHostTask,at.get(Q.$5$b)),ni=we.set(h.$_I.ExtHostOutputService,at.get(a.$H$b)),ai=we.set(h.$_I.ExtHostLocalization,at.get(tt.$u$b)),yi=we.set(h.$_I.ExtHostUrls,new pe.$Q$b(we)),At=we.set(h.$_I.ExtHostDocuments,new l.$O0b(we,pt)),ci=we.set(h.$_I.ExtHostDocumentContentProviders,new y.$90b(we,pt,Ue)),fi=we.set(h.$_I.ExtHostDocumentSaveParticipant,new i.$00b(Ue,At,we.getProxy(h.$$I.MainThreadBulkEdits))),kt=we.set(h.$_I.ExtHostNotebook,new le.$n_b(we,dt,pt,At,Rt)),Ei=we.set(h.$_I.ExtHostNotebookDocuments,new X.$F_b(kt)),Ti=we.set(h.$_I.ExtHostNotebookEditors,new x.$E_b(Ue,kt)),gi=we.set(h.$_I.ExtHostNotebookKernels,new ct.$B_b(we,ft,kt,dt,Ue)),Li=we.set(h.$_I.ExtHostNotebookRenderers,new rt.$D_b(we,kt)),Mi=we.set(h.$_I.ExtHostNotebookDocumentSaveParticipant,new yt.$L_b(Ue,kt,we.getProxy(h.$$I.MainThreadBulkEdits))),zt=we.set(h.$_I.ExtHostEditors,new N.$O$b(we,pt)),Qt=we.set(h.$_I.ExtHostTreeViews,new H.$P$b(we.getProxy(h.$$I.MainThreadTreeViews),dt,Ue)),zi=we.set(h.$_I.ExtHostEditorInsets,new ke.$Y$b(we.getProxy(h.$$I.MainThreadEditorInsets),zt,ft.remote)),ui=we.set(h.$_I.ExtHostDiagnostics,new w.$S0b(we,Ue,jt,pt)),li=we.set(h.$_I.ExtHostLanguages,new A.$E$b(we,At,dt.converter,Ae)),lt=we.set(h.$_I.ExtHostLanguageFeatures,new d.$W0b(we,Ae,At,dt,ui,Ue,Ke,Ct)),an=we.set(h.$_I.ExtHostFileSystem,new p.$C$b(we,lt)),qt=we.set(h.$_I.ExtHostFileSystemEventService,new I.$D$b(we,Ue,pt)),ri=we.set(h.$_I.ExtHostQuickOpen,(0,L.$J$b)(we,ut,dt)),Di=we.set(h.$_I.ExtHostSCM,new B.$L$b(we,dt,At,Ue)),Ni=we.set(h.$_I.ExtHostQuickDiff,new Lt.$I_b(we,Ae)),Oi=we.set(h.$_I.ExtHostShare,new Kt.$O_b(we,Ae)),Ui=we.set(h.$_I.ExtHostComments,(0,r.$Z0b)(we,dt,At)),ki=we.set(h.$_I.ExtHostProgress,new o.$I$b(we.getProxy(h.$$I.MainThreadProgress))),ji=we.set(h.$_I.ExtHosLabelService,new Ce.$Z$b(we)),Si=we.set(h.$_I.ExtHostTheming,new ne.$o_b(we)),si=we.set(h.$_I.ExtHostAuthentication,new K.$p_b(we)),Bi=we.set(h.$_I.ExtHostTimeline,new V.$r_b(we,dt)),mi=we.set(h.$_I.ExtHostWebviews,new Pe.$T$b(we,ft.remote,ut,Ue,Ke)),$i=we.set(h.$_I.ExtHostWebviewPanels,new ve.$t_b(we,mi,ut)),Wi=we.set(h.$_I.ExtHostCustomEditors,new ie.$u_b(we,At,Z,mi,$i)),Ki=we.set(h.$_I.ExtHostWebviewViews,new de.$s_b(we,mi)),oi=we.set(h.$_I.ExtHostTesting,new We.$w_b(we,dt,pt)),Vi=we.set(h.$_I.ExtHostUriOpeners,new _e.$A_b(we)),qi=we.set(h.$_I.ExtHostProfileContentHandlers,new wt.$H_b(we));we.set(h.$_I.ExtHostInteractive,new ge.$G_b(we,kt,pt,dt,Ue));const Ji=we.set(h.$_I.ExtHostInlineChat,new Wt.$K_b(we,dt,At,Ue)),ei=we.set(h.$_I.ExtHostChat,new Gt.$J_b(we,Ue)),Hi=we.set(h.$_I.ExtHostSemanticSimilarity,new Ut.$M_b(we)),Gi=we.set(h.$_I.ExtHostIssueReporter,new Mt.$N_b(we)),Ii=we.set(h.$_I.ExtHostStatusBar,new G.$N$b(we,dt.converter)),Qi=Object.values(h.$_I);we.assertRegistered(Qi);const cn=new Ee.$v_b(we,pt),un=new u.$Y0b(we),hi=new E.$F$b(we,Ue),pi=new v.$80b(we);return $.$X0b.register(dt),function(ze,Xt,Ci){const gt=function(){let se=!ze.isUnderDevelopment;function fe(){se||(Ue.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Me(nt){if(Array.isArray(nt))nt.forEach(Me);else if(typeof nt=="string")fe();else{const Dt=nt;typeof Dt.scheme>"u"&&fe(),typeof Dt.exclusive=="boolean"&&(0,Ne.$$E)(ze,"documentFiltersExclusive")}return nt}}(),Yi={getSession(se,fe,Me){return si.getSession(ze,se,fe,Me)},getSessions(se,fe){return(0,Ne.$$E)(ze,"authGetSessions"),si.getSessions(ze,se,fe)},async hasSession(se,fe){return(0,Ne.$$E)(ze,"authSession"),!!await si.getSession(ze,se,fe,{silent:!0})},get onDidChangeSessions(){return si.onDidChangeSessions},registerAuthenticationProvider(se,fe,Me,nt){return si.registerAuthenticationProvider(se,fe,Me,nt)}},Zi={registerCommand(se,fe,Me){return dt.registerCommand(!0,se,fe,Me,void 0,ze)},registerTextEditorCommand(se,fe,Me){return dt.registerCommand(!0,se,(...nt)=>{const Dt=zt.getActiveTextEditor();if(!Dt){Ue.warn("Cannot execute "+se+" because there is no active text editor.");return}return Dt.edit(Ft=>{fe.apply(Me,[Dt,Ft,...nt])}).then(Ft=>{Ft||Ue.warn("Edits from command "+se+" were not applied.")},Ft=>{Ue.warn("An error occurred while running command "+se,Ft)})},void 0,void 0,ze)},registerDiffInformationCommand:(se,fe,Me)=>((0,Ne.$$E)(ze,"diffCommand"),dt.registerCommand(!0,se,async(...nt)=>{const Dt=pt.activeEditor(!0);if(!Dt){Ue.warn("Cannot execute "+se+" because there is no active text editor.");return}const Ft=await zt.getDiffInformation(Dt.id);fe.apply(Me,[Ft,...nt])},void 0,void 0,ze)),executeCommand(se,...fe){return dt.executeCommand(se,...fe)},getCommands(se=!1){return dt.getCommands(se)}},Pi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return un.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ne.$$E)(ze,"envShellEvent"),vt.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.$$E)(ze,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.$$E)(ze,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,it.$tL)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(se,fe){return it.$sL.validateSender(se),Ct.instantiateLogger(ze,se,fe)},openExternal(se,fe){return xe.openUri(se,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===ft.environment.appUriScheme)return yi.createAppUri(se);try{return await xe.asExternalUri(se,{allowTunneling:!!ft.remote.authority})}catch(fe){if((0,st.$vY)(se,Oe.Schemas.http)||(0,st.$vY)(se,Oe.Schemas.https))return se;throw fe}},get remoteName(){return(0,me.$yk)(ft.remote.authority)},get remoteAuthority(){return(0,Ne.$$E)(ze,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return Ue.getLevel()},get onDidChangeLogLevel(){return Ue.onDidChangeLogLevel},registerIssueUriRequestHandler(se){return(0,Ne.$$E)(ze,"handleIssueUri"),Gi.registerIssueUriRequestHandler(ze,se)},get appQuality(){return(0,Ne.$$E)(ze,"resolvers"),ft.quality},get appCommit(){return(0,Ne.$$E)(ze,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Pi);const ln={createTestController(se,fe,Me){return oi.createTestController(ze,se,fe,Me)},createTestObserver(){return(0,Ne.$$E)(ze,"testObserver"),oi.createTestObserver()},runTests(se){return(0,Ne.$$E)(ze,"testObserver"),oi.runTests(se)},get onDidChangeTestResults(){return(0,Ne.$$E)(ze,"testObserver"),oi.onResultsChanged},get testResults(){return(0,Ne.$$E)(ze,"testObserver"),oi.results}},di=ft.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,Xi={getExtension(se,fe){(0,Ne.$0E)(ze,"extensionsAny")||(fe=!1);const Me=Xt.mine.getExtensionDescription(se);if(Me)return new s.$A$b(St,ze.identifier,Me,di,!1);if(fe){const nt=Xt.all.getExtensionDescription(se);if(nt)return new s.$A$b(St,ze.identifier,nt,di,!0)}},get all(){const se=[];for(const fe of Xt.mine.getAllExtensionDescriptions())se.push(new s.$A$b(St,ze.identifier,fe,di,!1));return se},get allAcrossExtensionHosts(){(0,Ne.$$E)(ze,"extensionsAny");const se=new ce.$El(Xt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),fe=[];for(const Me of Xt.all.getAllExtensionDescriptions()){const nt=!se.has(Me.identifier);fe.push(new s.$A$b(St,ze.identifier,Me,di,nt))}return fe},get onDidChange(){return(0,Ne.$0E)(ze,"extensionsAny")?S.Event.any(Xt.mine.onDidChange,Xt.all.onDidChange):Xt.mine.onDidChange}},_t={createDiagnosticCollection(se){return ui.createDiagnosticCollection(ze.identifier,se)},get onDidChangeDiagnostics(){return ui.onDidChangeDiagnostics},getDiagnostics:se=>ui.getDiagnostics(se),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(se,fe){return li.changeLanguage(se.uri,fe)},match(se,fe){const Me=At.getDocumentData(fe.uri)?.notebook;return(0,F.$xE)(j.LanguageSelector.from(se),fe.uri,fe.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(se,fe,Me){return lt.registerCodeActionProvider(ze,gt(se),fe,Me)},registerDocumentPasteEditProvider(se,fe,Me){return(0,Ne.$$E)(ze,"documentPaste"),lt.registerDocumentPasteEditProvider(ze,gt(se),fe,Me)},registerCodeLensProvider(se,fe){return lt.registerCodeLensProvider(ze,gt(se),fe)},registerDefinitionProvider(se,fe){return lt.registerDefinitionProvider(ze,gt(se),fe)},registerDeclarationProvider(se,fe){return lt.registerDeclarationProvider(ze,gt(se),fe)},registerImplementationProvider(se,fe){return lt.registerImplementationProvider(ze,gt(se),fe)},registerTypeDefinitionProvider(se,fe){return lt.registerTypeDefinitionProvider(ze,gt(se),fe)},registerHoverProvider(se,fe){return lt.registerHoverProvider(ze,gt(se),fe,ze.identifier)},registerEvaluatableExpressionProvider(se,fe){return lt.registerEvaluatableExpressionProvider(ze,gt(se),fe,ze.identifier)},registerInlineValuesProvider(se,fe){return lt.registerInlineValuesProvider(ze,gt(se),fe,ze.identifier)},registerDocumentHighlightProvider(se,fe){return lt.registerDocumentHighlightProvider(ze,gt(se),fe)},registerLinkedEditingRangeProvider(se,fe){return lt.registerLinkedEditingRangeProvider(ze,gt(se),fe)},registerReferenceProvider(se,fe){return lt.registerReferenceProvider(ze,gt(se),fe)},registerRenameProvider(se,fe){return lt.registerRenameProvider(ze,gt(se),fe)},registerDocumentSymbolProvider(se,fe,Me){return lt.registerDocumentSymbolProvider(ze,gt(se),fe,Me)},registerWorkspaceSymbolProvider(se){return lt.registerWorkspaceSymbolProvider(ze,se)},registerDocumentFormattingEditProvider(se,fe){return lt.registerDocumentFormattingEditProvider(ze,gt(se),fe)},registerDocumentRangeFormattingEditProvider(se,fe){return lt.registerDocumentRangeFormattingEditProvider(ze,gt(se),fe)},registerOnTypeFormattingEditProvider(se,fe,Me,...nt){return lt.registerOnTypeFormattingEditProvider(ze,gt(se),fe,[Me].concat(nt))},registerDocumentSemanticTokensProvider(se,fe,Me){return lt.registerDocumentSemanticTokensProvider(ze,gt(se),fe,Me)},registerDocumentRangeSemanticTokensProvider(se,fe,Me){return lt.registerDocumentRangeSemanticTokensProvider(ze,gt(se),fe,Me)},registerSignatureHelpProvider(se,fe,Me,...nt){return typeof Me=="object"?lt.registerSignatureHelpProvider(ze,gt(se),fe,Me):lt.registerSignatureHelpProvider(ze,gt(se),fe,typeof Me>"u"?[]:[Me,...nt])},registerCompletionItemProvider(se,fe,...Me){return lt.registerCompletionItemProvider(ze,gt(se),fe,Me)},registerInlineCompletionItemProvider(se,fe){return fe.handleDidShowCompletionItem&&(0,Ne.$$E)(ze,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Ne.$$E)(ze,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(ze,gt(se),fe)},registerDocumentLinkProvider(se,fe){return lt.registerDocumentLinkProvider(ze,gt(se),fe)},registerColorProvider(se,fe){return lt.registerColorProvider(ze,gt(se),fe)},registerFoldingRangeProvider(se,fe){return lt.registerFoldingRangeProvider(ze,gt(se),fe)},registerSelectionRangeProvider(se,fe){return lt.registerSelectionRangeProvider(ze,se,fe)},registerCallHierarchyProvider(se,fe){return lt.registerCallHierarchyProvider(ze,se,fe)},registerTypeHierarchyProvider(se,fe){return lt.registerTypeHierarchyProvider(ze,se,fe)},setLanguageConfiguration:(se,fe)=>lt.setLanguageConfiguration(ze,se,fe),getTokenInformationAtPosition(se,fe){return(0,Ne.$$E)(ze,"tokenInformation"),li.tokenAtPosition(se,fe)},registerInlayHintsProvider(se,fe){return lt.registerInlayHintsProvider(ze,se,fe)},createLanguageStatusItem(se,fe){return li.createLanguageStatusItem(ze,se,fe)},registerDocumentDropEditProvider(se,fe,Me){return lt.registerDocumentOnDropEditProvider(ze,se,fe,(0,Ne.$0E)(ze,"dropMetadata")?Me:void 0)}},bi={get activeTextEditor(){return zt.getActiveTextEditor()},get visibleTextEditors(){return zt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(se,fe,Me){const nt=await(T.URI.isUri(se)?Promise.resolve(_i.openTextDocument(se)):Promise.resolve(se));return zt.showTextDocument(nt,fe,Me)},createTextEditorDecorationType(se){return zt.createTextEditorDecorationType(ze,se)},onDidChangeActiveTextEditor(se,fe,Me){return zt.onDidChangeActiveTextEditor(se,fe,Me)},onDidChangeVisibleTextEditors(se,fe,Me){return zt.onDidChangeVisibleTextEditors(se,fe,Me)},onDidChangeTextEditorSelection(se,fe,Me){return zt.onDidChangeTextEditorSelection(se,fe,Me)},onDidChangeTextEditorOptions(se,fe,Me){return zt.onDidChangeTextEditorOptions(se,fe,Me)},onDidChangeTextEditorVisibleRanges(se,fe,Me){return zt.onDidChangeTextEditorVisibleRanges(se,fe,Me)},onDidChangeTextEditorViewColumn(se,fe,Me){return zt.onDidChangeTextEditorViewColumn(se,fe,Me)},onDidCloseTerminal(se,fe,Me){return vt.onDidCloseTerminal(se,fe,Me)},onDidOpenTerminal(se,fe,Me){return vt.onDidOpenTerminal(se,fe,Me)},onDidChangeActiveTerminal(se,fe,Me){return vt.onDidChangeActiveTerminal(se,fe,Me)},onDidChangeTerminalDimensions(se,fe,Me){return(0,Ne.$$E)(ze,"terminalDimensions"),vt.onDidChangeTerminalDimensions(se,fe,Me)},onDidChangeTerminalState(se,fe,Me){return vt.onDidChangeTerminalState(se,fe,Me)},onDidWriteTerminalData(se,fe,Me){return(0,Ne.$$E)(ze,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(se,fe,Me)},get state(){return xe.getState(ze)},onDidChangeWindowState(se,fe,Me){return xe.onDidChangeWindowState(se,fe,Me)},showInformationMessage(se,...fe){return hi.showMessage(ze,z.default.Info,se,fe[0],fe.slice(1))},showWarningMessage(se,...fe){return hi.showMessage(ze,z.default.Warning,se,fe[0],fe.slice(1))},showErrorMessage(se,...fe){return hi.showMessage(ze,z.default.Error,se,fe[0],fe.slice(1))},showQuickPick(se,fe,Me){return ri.showQuickPick(ze,se,fe,Me)},showWorkspaceFolderPick(se){return ri.showWorkspaceFolderPick(se)},showInputBox(se,fe){return ri.showInput(se,fe)},showOpenDialog(se){return pi.showOpenDialog(ze,se)},showSaveDialog(se){return pi.showSaveDialog(se)},createStatusBarItem(se,fe,Me){let nt,Dt,Ft;return typeof se=="string"?(nt=se,Dt=fe,Ft=Me):(Dt=se,Ft=fe),Ii.createStatusBarEntry(ze,nt,Dt,Ft)},setStatusBarMessage(se,fe){return Ii.setStatusBarMessage(se,fe)},withScmProgress(se){return Ke.report("window.withScmProgress",ze,"Use 'withProgress' instead."),ki.withProgress(ze,{location:O.ProgressLocation.SourceControl},(fe,Me)=>se({report(nt){}}))},withProgress(se,fe){return ki.withProgress(ze,se,fe)},createOutputChannel(se,fe){return ni.createOutputChannel(se,fe,ze)},createWebviewPanel(se,fe,Me,nt){return $i.createWebviewPanel(ze,se,fe,Me,nt)},createWebviewTextEditorInset(se,fe,Me,nt){return(0,Ne.$$E)(ze,"editorInsets"),zi.createWebviewEditorInset(se,fe,Me,nt,ze)},createTerminal(se,fe,Me){return typeof se=="object"?"pty"in se?vt.createExtensionTerminal(se):vt.createTerminalFromOptions(se):vt.createTerminal(se,fe,Me)},registerTerminalLinkProvider(se){return vt.registerLinkProvider(se)},registerTerminalProfileProvider(se,fe){return vt.registerProfileProvider(ze,se,fe)},registerTerminalQuickFixProvider(se,fe){return(0,Ne.$$E)(ze,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(se,ze.identifier.value,fe)},registerTreeDataProvider(se,fe){return Qt.registerTreeDataProvider(se,fe,ze)},createTreeView(se,fe){return Qt.createTreeView(se,fe,ze)},registerWebviewPanelSerializer:(se,fe)=>$i.registerWebviewPanelSerializer(ze,se,fe),registerCustomEditorProvider:(se,fe,Me={})=>Wi.registerCustomEditorProvider(ze,se,fe,Me),registerFileDecorationProvider(se){return mt.registerFileDecorationProvider(se,ze)},registerUriHandler(se){return yi.registerUriHandler(ze,se)},createQuickPick(){return ri.createQuickPick(ze)},createInputBox(){return ri.createInputBox(ze)},get activeColorTheme(){return Si.activeColorTheme},onDidChangeActiveColorTheme(se,fe,Me){return Si.onDidChangeActiveColorTheme(se,fe,Me)},registerWebviewViewProvider(se,fe,Me){return Ki.registerWebviewViewProvider(ze,se,fe,Me?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,fe,Me){return kt.onDidChangeActiveNotebookEditor(se,fe,Me)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,fe,Me){return Ti.onDidChangeNotebookEditorSelection(se,fe,Me)},onDidChangeNotebookEditorVisibleRanges(se,fe,Me){return Ti.onDidChangeNotebookEditorVisibleRanges(se,fe,Me)},showNotebookDocument(se,fe){return kt.showNotebookDocument(se,fe)},registerExternalUriOpener(se,fe,Me){return(0,Ne.$$E)(ze,"externalUriOpener"),Vi.registerExternalUriOpener(ze.identifier,se,fe,Me)},registerProfileContentHandler(se,fe){return(0,Ne.$$E)(ze,"profileContentHandlers"),qi.registrProfileContentHandler(ze,se,fe)},registerQuickDiffProvider(se,fe,Me,nt){return(0,Ne.$$E)(ze,"quickDiffProvider"),Ni.registerQuickDiffProvider(gt(se),fe,Me,nt)},get tabGroups(){return It.tabGroups},registerShareProvider(se,fe){return(0,Ne.$$E)(ze,"shareProvider"),Oi.registerShareProvider(gt(se),fe)}},_i={get rootPath(){return Ke.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ut.getPath()},set rootPath(se){throw C.$6()},getWorkspaceFolder(se){return ut.getWorkspaceFolder(se)},get workspaceFolders(){return ut.getWorkspaceFolders()},get name(){return ut.name},set name(se){throw C.$6()},get workspaceFile(){return ut.workspaceFile},set workspaceFile(se){throw C.$6()},updateWorkspaceFolders:(se,fe,...Me)=>ut.updateWorkspaceFolders(ze,se,fe||0,...Me),onDidChangeWorkspaceFolders:function(se,fe,Me){return ut.onDidChangeWorkspace(se,fe,Me)},asRelativePath:(se,fe)=>ut.getRelativePath(se,fe),findFiles:(se,fe,Me,nt)=>ut.findFiles(se,fe,Me,ze.identifier,nt),findTextInFiles:(se,fe,Me,nt)=>{(0,Ne.$$E)(ze,"findTextInFiles");let Dt,Ft;return typeof fe=="object"?(Dt=fe,Ft=Me):(Dt={},Ft=fe,nt=Me),ut.findTextInFiles(se,Dt||{},Ft,ze.identifier,nt)},save:se=>((0,Ne.$$E)(ze,"saveEditor"),ut.save(se)),saveAs:se=>((0,Ne.$$E)(ze,"saveEditor"),ut.saveAs(se)),saveAll:se=>ut.saveAll(se),applyEdit(se,fe){return cn.applyWorkspaceEdit(se,ze,fe)},createFileSystemWatcher:(se,fe,Me,nt)=>qt.createFileSystemWatcher(ut,ze,se,fe,Me,nt),get textDocuments(){return At.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw C.$6()},openTextDocument(se){let fe;const Me=se;if(typeof se=="string")fe=Promise.resolve(T.URI.file(se));else if(T.URI.isUri(se))fe=Promise.resolve(se);else if(!Me||typeof Me=="object")fe=At.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(nt=>At.ensureDocumentData(nt).then(Dt=>Dt.document))},onDidOpenTextDocument:(se,fe,Me)=>At.onDidAddDocument(se,fe,Me),onDidCloseTextDocument:(se,fe,Me)=>At.onDidRemoveDocument(se,fe,Me),onDidChangeTextDocument:(se,fe,Me)=>At.onDidChangeDocument(se,fe,Me),onDidSaveTextDocument:(se,fe,Me)=>At.onDidSaveDocument(se,fe,Me),onWillSaveTextDocument:(se,fe,Me)=>fi.getOnWillSaveTextDocumentEvent(ze)(se,fe,Me),get notebookDocuments(){return kt.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,fe){let Me;if(T.URI.isUri(se))Me=se,await kt.openNotebookDocument(se);else if(typeof se=="string")Me=T.URI.revive(await kt.createNotebookDocument({viewType:se,content:fe}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(se,fe,Me){return Ei.onDidSaveNotebookDocument(se,fe,Me)},onDidChangeNotebookDocument(se,fe,Me){return Ei.onDidChangeNotebookDocument(se,fe,Me)},onWillSaveNotebookDocument(se,fe,Me){return Mi.getOnWillSaveNotebookDocumentEvent(ze)(se,fe,Me)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(se,fe,Me,nt){return kt.registerNotebookSerializer(ze,se,fe,Me,(0,Ne.$0E)(ze,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(se,fe,Me)=>Ci.onDidChangeConfiguration(se,fe,Me),getConfiguration(se,fe){return fe=arguments.length===1?void 0:fe,Ci.getConfiguration(se,fe,ze)},registerTextDocumentContentProvider(se,fe){return ci.registerTextDocumentContentProvider(se,fe)},registerTaskProvider:(se,fe)=>(Ke.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Bt.registerTaskProvider(ze,se,fe)),registerFileSystemProvider(se,fe,Me){return(0,je.$hb)(an.registerFileSystemProvider(ze,se,fe,Me),Rt.addFileSystemProvider(se,fe,Me))},get fs(){return Rt.value},registerFileSearchProvider:(se,fe)=>((0,Ne.$$E)(ze,"fileSearchProvider"),Zt.registerFileSearchProvider(se,fe)),registerTextSearchProvider:(se,fe)=>((0,Ne.$$E)(ze,"textSearchProvider"),Zt.registerTextSearchProvider(se,fe)),registerRemoteAuthorityResolver:(se,fe)=>((0,Ne.$$E)(ze,"resolvers"),St.registerRemoteAuthorityResolver(se,fe)),registerResourceLabelFormatter:se=>((0,Ne.$$E)(ze,"resolvers"),ji.$registerResourceLabelFormatter(se)),getRemoteExecServer:se=>((0,Ne.$$E)(ze,"resolvers"),St.getRemoteExecServer(se)),onDidCreateFiles:(se,fe,Me)=>qt.onDidCreateFile(se,fe,Me),onDidDeleteFiles:(se,fe,Me)=>qt.onDidDeleteFile(se,fe,Me),onDidRenameFiles:(se,fe,Me)=>qt.onDidRenameFile(se,fe,Me),onWillCreateFiles:(se,fe,Me)=>qt.getOnWillCreateFileEvent(ze)(se,fe,Me),onWillDeleteFiles:(se,fe,Me)=>qt.getOnWillDeleteFileEvent(ze)(se,fe,Me),onWillRenameFiles:(se,fe,Me)=>qt.getOnWillRenameFileEvent(ze)(se,fe,Me),openTunnel:se=>((0,Ne.$$E)(ze,"tunnels"),Ge.openTunnel(ze,se).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Ne.$$E)(ze,"tunnels"),Ge.getTunnels()},onDidChangeTunnels:(se,fe,Me)=>((0,Ne.$$E)(ze,"tunnels"),Ge.onDidChangeTunnels(se,fe,Me)),registerPortAttributesProvider:(se,fe)=>((0,Ne.$$E)(ze,"portsAttributes"),Ge.registerPortsAttributesProvider(se,fe)),registerTimelineProvider:(se,fe)=>((0,Ne.$$E)(ze,"timeline"),Bi.registerTimelineProvider(se,fe,ze.identifier,dt.converter)),get isTrusted(){return ut.trusted},requestWorkspaceTrust:se=>((0,Ne.$$E)(ze,"workspaceTrust"),ut.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,fe,Me)=>ut.onDidGrantWorkspaceTrust(se,fe,Me),registerEditSessionIdentityProvider:(se,fe)=>((0,Ne.$$E)(ze,"editSessionIdentityProvider"),ut.registerEditSessionIdentityProvider(se,fe)),onWillCreateEditSessionIdentity:(se,fe,Me)=>((0,Ne.$$E)(ze,"editSessionIdentityProvider"),ut.getOnWillCreateEditSessionIdentityEvent(ze)(se,fe,Me)),registerCanonicalUriProvider:(se,fe)=>((0,Ne.$$E)(ze,"canonicalUriProvider"),ut.registerCanonicalUriProvider(se,fe)),getCanonicalUri:(se,fe,Me)=>((0,Ne.$$E)(ze,"canonicalUriProvider"),ut.provideCanonicalUri(se,fe,Me))},Jt={get inputBox(){return Ke.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Di.getLastInputBox(ze)},createSourceControl(se,fe,Me){return Di.createSourceControl(ze,se,fe,Me)}},vi={createCommentController(se,fe){return Ui.createCommentController(ze,se,fe)}},xi={get activeDebugSession(){return bt.activeDebugSession},get activeDebugConsole(){return bt.activeDebugConsole},get breakpoints(){return bt.breakpoints},get stackFrameFocus(){return bt.stackFrameFocus},onDidStartDebugSession(se,fe,Me){return bt.onDidStartDebugSession(se,fe,Me)},onDidTerminateDebugSession(se,fe,Me){return bt.onDidTerminateDebugSession(se,fe,Me)},onDidChangeActiveDebugSession(se,fe,Me){return bt.onDidChangeActiveDebugSession(se,fe,Me)},onDidReceiveDebugSessionCustomEvent(se,fe,Me){return bt.onDidReceiveDebugSessionCustomEvent(se,fe,Me)},onDidChangeBreakpoints(se,fe,Me){return bt.onDidChangeBreakpoints(se,fe,Me)},onDidChangeStackFrameFocus(se,fe,Me){return(0,Ne.$$E)(ze,"debugFocus"),bt.onDidChangeStackFrameFocus(se,fe,Me)},registerDebugConfigurationProvider(se,fe,Me){return bt.registerDebugConfigurationProvider(se,fe,Me||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,fe){return bt.registerDebugAdapterDescriptorFactory(ze,se,fe)},registerDebugAdapterTrackerFactory(se,fe){return bt.registerDebugAdapterTrackerFactory(se,fe)},startDebugging(se,fe,Me){return!Me||typeof Me=="object"&&"configuration"in Me?bt.startDebugging(se,fe,{parentSession:Me}):bt.startDebugging(se,fe,Me||{})},stopDebugging(se){return bt.stopDebugging(se)},addBreakpoints(se){return bt.addBreakpoints(se)},removeBreakpoints(se){return bt.removeBreakpoints(se)},asDebugSourceUri(se,fe){return bt.asDebugSourceUri(se,fe)}},en={registerTaskProvider:(se,fe)=>Bt.registerTaskProvider(ze,se,fe),fetchTasks:se=>Bt.fetchTasks(se),executeTask:se=>Bt.executeTask(ze,se),get taskExecutions(){return Bt.taskExecutions},onDidStartTask:(se,fe,Me)=>Bt.onDidStartTask(se,fe,Me),onDidEndTask:(se,fe,Me)=>Bt.onDidEndTask(se,fe,Me),onDidStartTaskProcess:(se,fe,Me)=>Bt.onDidStartTaskProcess(se,fe,Me),onDidEndTaskProcess:(se,fe,Me)=>Bt.onDidEndTaskProcess(se,fe,Me)},tn={createNotebookController(se,fe,Me,nt,Dt){return gi.createNotebookController(ze,se,fe,Me,nt,(0,Ne.$0E)(ze,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(se,fe)=>kt.registerNotebookCellStatusBarItemProvider(ze,se,fe),createRendererMessaging(se){return Li.createRendererMessaging(ze,se)},createNotebookControllerDetectionTask(se){return(0,Ne.$$E)(ze,"notebookKernelSource"),gi.createNotebookControllerDetectionTask(ze,se)},registerKernelSourceActionProvider(se,fe){return(0,Ne.$$E)(ze,"notebookKernelSource"),gi.registerKernelSourceActionProvider(ze,se,fe)},onDidChangeNotebookCellExecutionState(se,fe,Me){return(0,Ne.$$E)(ze,"notebookCellExecutionState"),gi.onDidChangeNotebookCellExecutionState(se,fe,Me)}},nn={t(...se){if(typeof se[0]=="string"){const fe=se.shift(),Me=!se||typeof se[0]!="object"?se:se[0];return ai.getMessage(ze.identifier.value,{message:fe,args:Me})}return ai.getMessage(ze.identifier.value,se[0])},get bundle(){return ai.getBundle(ze.identifier.value)},get uri(){return ai.getBundleUri(ze.identifier.value)}},hn={_version:1,registerInteractiveEditorSessionProvider(se){return(0,Ne.$$E)(ze,"interactive"),Ji.registerProvider(ze,se)},registerInteractiveSessionProvider(se,fe){return(0,Ne.$$E)(ze,"interactive"),ei.registerChatProvider(ze,se,fe)},addInteractiveRequest(se){return(0,Ne.$$E)(ze,"interactive"),ei.addChatRequest(se)},sendInteractiveRequestToProvider(se,fe){return(0,Ne.$$E)(ze,"interactive"),ei.sendInteractiveRequestToProvider(se,fe)},get onDidPerformUserAction(){return(0,Ne.$$E)(ze,"interactiveUserActions"),ei.onDidPerformUserAction},transferChatSession(se,fe){return(0,Ne.$$E)(ze,"interactive"),ei.transferChatSession(se,fe)}},rn={registerSlashCommandProvider(se,fe){return(0,Ne.$$E)(ze,"interactiveSlashCommands"),ei.registerSlashCommandProvider(ze,se,fe)}},sn={registerSemanticSimilarityProvider(se){return(0,Ne.$$E)(ze,"semanticSimilarity"),Hi.registerSemanticSimilarityProvider(ze,se)}};return{version:ft.version,ai:sn,authentication:Yi,commands:Zi,comments:vi,debug:xi,env:Pi,extensions:Xi,interactive:hn,interactiveSlashCommands:rn,l10n:nn,languages:_t,notebooks:tn,scm:Jt,tasks:en,tests:ln,window:bi,workspace:_i,Breakpoint:O.$_J,TerminalOutputAnchor:O.TerminalOutputAnchor,CallHierarchyIncomingCall:O.$yJ,CallHierarchyItem:O.$xJ,CallHierarchyOutgoingCall:O.$zJ,CancellationError:C.$2,CancellationTokenSource:g.$bd,CandidatePortSource:h.CandidatePortSource,CodeAction:O.$tJ,CodeActionKind:O.$uJ,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.$AJ,Color:O.$NJ,ColorInformation:O.$OJ,ColorPresentation:O.$PJ,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentState:O.CommentState,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CommentThreadState:O.CommentThreadState,CompletionItem:O.$HJ,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.$IJ,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.$XJ,DebugAdapterExecutable:O.$dK,DebugAdapterInlineImplementation:O.$gK,DebugAdapterNamedPipeServer:O.$fK,DebugAdapterServer:O.$eK,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.$oJ,DiagnosticRelatedInformation:O.$nJ,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.$aJ,DocumentHighlight:O.$qJ,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.$MJ,DocumentSymbol:O.$sJ,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.$jK,InlineValueText:O.$kK,InlineValueVariableLookup:O.$lK,InlineValueEvaluatableExpression:O.$mK,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,EventEmitter:S.$5c,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.$wK,FileDecoration2:O.$wK,FileSystemError:O.$oK,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:O.$pK,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.$bK,InlineCompletionItem:O.$JJ,InlineCompletionList:O.$KJ,Hover:O.$pJ,IndentAction:m.IndentAction,Location:O.$mJ,MarkdownString:O.$BJ,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:O.$CJ,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.$bJ,ProcessExecution:O.$VJ,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.$vK,Range:O.$cJ,RelativePattern:O.$0J,Selection:O.$dJ,SelectionRange:O.$wJ,SemanticTokens:O.$sK,SemanticTokensBuilder:O.$rK,SemanticTokensEdit:O.$tK,SemanticTokensEdits:O.$uK,SemanticTokensLegend:O.$qK,ShellExecution:O.$WJ,ShellQuoting:O.ShellQuoting,SignatureHelp:O.$EJ,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.$DJ,SnippetString:O.$lJ,SourceBreakpoint:O.$aK,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.$rJ,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.$YJ,TaskGroup:O.$UJ,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.$QJ,TerminalQuickFixCommand:O.$SJ,TerminalQuickFixOpener:O.$RJ,TerminalLocation:O.TerminalLocation,TerminalProfile:O.$TJ,TerminalExitReason:O.TerminalExitReason,TerminalQuickFixType:O.TerminalQuickFixType,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.$hJ,SnippetTextEdit:O.$jJ,TextEditorCursorStyle:f.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,TextDocumentChangeReason:O.TextDocumentChangeReason,ThemeColor:O.$9J,ThemeIcon:O.$8J,TreeItem:O.$ZJ,TreeItemCheckboxState:O.TreeItemCheckboxState,TreeItemCollapsibleState:O.TreeItemCollapsibleState,TypeHierarchyItem:O.$SK,UIKind:b.UIKind,Uri:T.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.$kJ,DocumentDropEdit:O.$6J,DocumentPasteEdit:O.$7J,InlayHint:O.$GJ,InlayHintLabelPart:O.$FJ,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.$gJ,ResolvedAuthority:O.$eJ,ManagedResolvedAuthority:O.$fJ,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.$GK,NotebookRange:O.$yK,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.$zK,NotebookData:O.$AK,NotebookRendererScript:O.$EK,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.$CK,NotebookCellOutputItem:O.$BK,NotebookCellStatusBarItem:O.$DK,NotebookControllerAffinity:O.NotebookControllerAffinity,NotebookControllerAffinity2:O.NotebookControllerAffinity2,NotebookEdit:O.$iJ,NotebookKernelSourceAction:O.$FK,PortAttributes:O.$IK,LinkedEditingRanges:O.$HK,TestResultState:O.TestResultState,TestRunRequest:O.$JK,TestRunRequest2:O.$KK,TestMessage:O.$LK,TestTag:O.$MK,TestRunProfileKind:O.TestRunProfileKind,TextSearchCompleteMessageType:et.TextSearchCompleteMessageType,DataTransfer:O.$5J,DataTransferItem:O.$1J,CoveredCount:O.$NK,FileCoverage:O.$OK,StatementCoverage:O.$PK,BranchCoverage:O.$QK,FunctionCoverage:O.$RK,WorkspaceTrustState:O.WorkspaceTrustState,LanguageStatusSeverity:O.LanguageStatusSeverity,QuickPickItemKind:O.QuickPickItemKind,InputBoxValidationSeverity:O.InputBoxValidationSeverity,TabInputText:O.$TK,TabInputTextDiff:O.$UK,TabInputTextMerge:O.$VK,TabInputCustom:O.$WK,TabInputNotebook:O.$YK,TabInputNotebookDiff:O.$ZK,TabInputWebview:O.$XK,TabInputTerminal:O.$1K,TabInputInteractiveWindow:O.$2K,TelemetryTrustedValue:ue.$Xn,LogLevel:ye.LogLevel,EditSessionIdentityMatch:$t.EditSessionIdentityMatch,InteractiveSessionVoteDirection:O.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:O.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:O.InteractiveEditorResponseFeedbackKind,StackFrameFocus:O.$hK,ThreadFocus:O.$iK,NotebookCodeActionKind:O.$vJ}}}e.$P_b=Vt}),define(Re[267],Fe([1,0,72,109,33,107,34,32,59,62,111,113,114,85,75,81,108,61,39,84,57,60,234,15,112,82,83]),function(te,e,g,C,S,z,T,f,k,m,F,D,h,b,$,u,t,r,c,w,v,y,i,l,n,s,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.$8q)(s.$u$b,s.$t$b,1),(0,g.$8q)(l.$Oi,i.$Q_b,1),(0,g.$8q)(u.$T0b,u.$U0b,1),(0,g.$8q)(f.$wL,f.$vL,0),(0,g.$8q)(T.$70b,T.$50b,0),(0,g.$8q)(r.$j$b,r.$i$b,0),(0,g.$8q)(D.$0$b,D.$b_b,0),(0,g.$8q)(z.$2$b,z.$1$b,0),(0,g.$8q)(k.$lL,k.$kL,0),(0,g.$8q)(p.$v$b,p.$w$b,0),(0,g.$8q)(c.$Q0b,c.$P0b,0),(0,g.$8q)(C.$H$b,C.$G$b,1),(0,g.$8q)(h.$h_b,h.$i_b,0),(0,g.$8q)(b.$f$b,b.$e$b,0),(0,g.$8q)(F.$5$b,F.$4$b,0),(0,g.$8q)(m.$m$b,m.$p$b,0),(0,g.$8q)($.$job,$.$kob,0),(0,g.$8q)(t.$X$b,t.$W$b,0),(0,g.$8q)(S.$40b,S.$30b,0),(0,g.$8q)(w.$r$b,w.$q$b,0),(0,g.$8q)(v.$uL,v.$rL,0),(0,g.$8q)(y.$6$b,y.$7$b,0),(0,g.$8q)(n.$8$b,n.$9$b,0)}),define(Re[268],Fe([1,0,266,35,2,263,7,16,254]),function(te,e,g,C,S,z,T,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=void 0;class m extends z.$T_b{j(){}getModule(b,$){for(const u of this.b){const t=u(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class F extends C.$y$b{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Webworker}async pb(){this.h.createInstance(k.$Xbc);const b=this.h.invokeFunction(g.$P_b);this.r=this.h.createInstance(m,b,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.vb()}qb(b){return b.browser}async rb(b,$,u){$=$.with({path:D($.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const r=S.URI.revive(await this.v.$asBrowserUri($)),c=await fetch(r.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const w=await c.text(),v=`${$.toString(!0)}#vscode-extension`,y=`${w}
//# sourceURL=${v}`;let i;try{i=new Function("module","exports","require",y)}catch(p){throw console.error(t?`Loading code for extension ${t} failed: ${p.message}`:`Loading code failed: ${p.message}`),console.error(`${$.toString(!0)}${typeof p.line=="number"?` line ${p.line}`:""}${typeof p.column=="number"?` column ${p.column}`:""}`),console.error(p),p}b&&await this.s.initializeLocalizedMessages(b);const l={},n={exports:l},s=p=>{const I=this.r.getModule(p,$);if(I===void 0)throw new Error(`Cannot load module '${p}'`);return I};try{return u.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),i(n,l,s),n.exports!==l?n.exports:l}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),u.codeLoadingStop()}}async $setRemoteEnvironment(b){}async vb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+b;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,f.$sg)(10)}}e.$Ybc=F;function D(h,b){return h.endsWith(b)?h:h+b}}),define(Re[269],Fe([1,0,71,72,15,35,186,86,268]),function(te,e,g,C,S,z,T,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$8q)(S.$Ni,new g.$ih(T.$S_b,[!0],!0)),(0,C.$8q)(z.$z$b,k.$Ybc,0),(0,C.$8q)(f.$k$b,f.$l$b,0)}),define(Re[277],Fe([1,0,25,5,80,264,256,19,87,14,2,267,269]),function(te,e,g,C,S,z,T,f,k,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(i){return/^(file|vscode-remote):/i.test(i)}const $=fetch.bind(self);function u(i){self.fetch=async function(l,n){return l instanceof Request||b(String(l))&&(l=(await i(F.URI.parse(String(l)))).toString(!0)),$(l,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,n,s,p,I){(async()=>(b(n.toString())&&(n=(await i(F.URI.parse(n.toString()))).toString(!0)),super.open(l,n,s??!0,p,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(l,n){if(/^file:/i.test(l.toString()))l=m.$1e.uriToBrowserUri(F.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const p=`(${function(E){function a(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const o=fetch.bind(self);self.fetch=function(B,G){return B instanceof Request?o(B,G):o(a(B),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,G,q,W,N){return super.open(B,a(G),q??!0,W,N)}};const L=importScripts.bind(self);self.importScripts=(...B)=>{L(...B.map(a))},L(E)}.toString()}('${l}'))`;n=n||{},n.name=n.name||f.$cc(l.toString());const I=new Blob([p],{type:"application/javascript"}),d=URL.createObjectURL(I);return new i(d,n)}}else self.Worker=class extends T.$Zbc{constructor(i,l){super(h,i,{name:f.$cc(i.toString()),...l})}};const t=new class{constructor(){this.pid=void 0}exit(i){D()}async exists(i){return!0}async realpath(i){return i}};class r{constructor(){const l=new MessageChannel,n=new C.$5c;let s=!1;h(l.port2,[l.port2]),l.port1.onmessage=p=>{const{data:I}=p;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const d=g.$Ib.wrap(new Uint8Array(I,0,I.byteLength));if((0,S.$Ml)(d,2)){s=!0,w("received terminate message from renderer");return}n.fire(d)},this.protocol={onMessage:n.event,send:p=>{if(!s){const I=p.buffer.buffer.slice(p.buffer.byteOffset,p.buffer.byteOffset+p.buffer.byteLength);l.port1.postMessage(I,[I])}}}}}function c(i){return new Promise(l=>{const n=i.onMessage(s=>{n.dispose();const p=JSON.parse(s.toString());i.send((0,S.$Ll)(0)),l({protocol:i,initData:p})});i.send((0,S.$Ll)(1))})}let w=i=>D();function v(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function y(){k.mark("code/extHost/willConnectToRenderer");const i=new r;return{onmessage(l){v(l)&&c(i.protocol).then(n=>{k.mark("code/extHost/didWaitForInitData");const s=new z.$V_b(n.protocol,n.initData,t,null,l.data);u(p=>s.asBrowserUri(p)),w=p=>s.terminate(p)})}}}e.create=y})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/660393deaaa6d1996740ff4880f1bad43768c814/core/vs/workbench/api/worker/extensionHostWorker.js.map
